
var EBConduitHelper_CT2958529 =
{
    CommonID: 'Common',

    GetId: function(bIsCommon) {
        var strId = (bIsCommon) ? this.CommonID : EBGlobalConsts_CT2958529.ToolbarCTID;
        return strId;
    },

    stroreKey: function(strKey, strValue, bIsCommon) {
        var strCTID = this.GetId(bIsCommon);

        try {
            var objHelper = oToolbar_CT2958529.keysStorage.manager;

            objHelper.storeKey(strCTID, strKey, strValue);
        }
        catch (e) {
            EBLogging_CT2958529.LogToConsole(e);
        }
    },

    retrieveKey: function(strKey, bIsCommon) {
        var strCTID = this.GetId(bIsCommon);

        try {
            var objHelper = oToolbar_CT2958529.keysStorage.manager;

            var strValue = objHelper.retrieveKey(strCTID, strKey);
            return strValue;
        }
        catch (e) {
            EBLogging_CT2958529.LogToConsole(e);
        }
    },

    deleteKey: function(strKey, bIsCommon) {
        var strCTID = this.GetId(bIsCommon);

        try {
            var objHelper = oToolbar_CT2958529.keysStorage.manager;

            objHelper.deleteKey(strCTID, strKey);
        }
        catch (e) {
            EBLogging_CT2958529.LogToConsole(e);
        }
    },

    update404redirectUrl: function(strUrl, bIsRemove, bIaAll) {
        if (strUrl) {
            try {
                strUrl = EBActionManager_CT2958529.ConvertAliasesUrl(strUrl);

                var objHelper = oToolbar_CT2958529.fix404.manager;

                if (bIsRemove)
                    if (bIaAll)
                    objHelper.unregisterAllWindows404redirectUrl(strUrl, EBGlobalConsts_CT2958529.ToolbarCTID);
                else
                    objHelper.unregisterSingleWindow404redirectUrl(strUrl, EBGlobalConsts_CT2958529.ToolbarCTID);
                else
                    if (bIaAll)
                    objHelper.registerAllWindows404redirectUrl(strUrl, EBGlobalConsts_CT2958529.ToolbarCTID);
                else
                    objHelper.registerSingleWindow404redirectUrl(strUrl, EBGlobalConsts_CT2958529.ToolbarCTID);
            }
            catch (e) {
                EBLogging_CT2958529.LogToConsole(e);
            }
        }
    }
}

        


var DualPackageFunctions_CT2958529 =
{
    hideShowEngineAfterRestartPref: ".HideEngineAfterRestart",

    engineOwnerCTID: function() {
        return EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EngineOwner);
    },

    engineOwnerGuid: function() {
        return EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EngineOwnerGuid);
    },

    engineOwnerToolbarId: function() {
        return EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EngineOwnerToolbarId);
    },

    getEngineOwnerToolbar: function() {
        return document.getElementById(this.engineOwnerToolbarId());
    },

    getEngineXulElement: function() {
        return document.getElementById(EBGlobalConsts_CT2958529.ConduitEngineName);
    },

    isEngineOnToolbar: function() {
        if (this.isEngineStandAlone()) return false;

        var ownerToolbarId = this.engineOwnerToolbarId();
        var xulOwnerToolbar = document.getElementById(ownerToolbarId);
        if (!xulOwnerToolbar) return false;

        return xulOwnerToolbar.getAttribute("collapsed") != "true";
        //var strDisplay = document.defaultView.getComputedStyle(xulOwnerToolbar, null).getPropertyValue("display");
        //return strDisplay != "none";
    },

    isEngineStandAlone: function() {
        return this.engineOwnerCTID() == EBGlobalConsts_CT2958529.EngineCTID;
    },

    //for toolbar
    isToolbarInDualPackage: function() {
        var ownerCTID = this.engineOwnerCTID();
        return EBGlobalConsts_CT2958529.ToolbarCTID == ownerCTID;
    },

    isEngineInDualPackage: function() {
        if (EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EngineOwner) == EBGlobalConsts_CT2958529.EngineCTID) return false;
        if (!EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EngineOwner)) return false;
        if (!EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.EngineOwnerGuid)) return false;
        else return true;
    },

    validateEngineOwner: function(strToolbarCtid) {
        if (EBGlobalConsts_CT2958529.IsEngine) {
            if ((!this.engineOwnerCTID() || this.engineOwnerCTID() == EBGlobalConsts_CT2958529.EngineCTID) &&
                    EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.OriginalEngineOwner) &&
                    EBGlobalConsts_CT2958529.ToolbarCTID != EBGlobalConsts_CT2958529.EngineCTID)
                this.setOriginalEngineOwner(EBGlobalConsts_CT2958529.ToolbarCTID, EBGlobalConsts_CT2958529.ToolbarId, EBGlobalConsts_CT2958529.GUID);
            return;
        }

        if (!this.engineOwnerCTID() && (EBGlobalConsts_CT2958529.MyStuffEnabled || EBGlobalConsts_CT2958529.IsEngine) && !this.isToolbarCantBeEngineOwner(strToolbarCtid)) {
            DualPackageFunctions_CT2958529.setEngineOwner(EBGlobalConsts_CT2958529.ToolbarCTID, EBGlobalConsts_CT2958529.ToolbarId, EBGlobalConsts_CT2958529.GUID);
        }
        else if (!EBGlobalConsts_CT2958529.IsEngine && (this.engineOwnerCTID() && this.engineOwnerCTID() != EBGlobalConsts_CT2958529.ToolbarCTID) || !EBGlobalConsts_CT2958529.MyStuffEnabled) {
            EBInitializeToolbarManager_CT2958529.AddMeToInstalledToolbarsList(EBPreferenceConsts_CT2958529.CantToolbarBeEngineOwner, EBGlobalConsts_CT2958529.ToolbarCTID);
        }
    },

    isToolbarCantBeEngineOwner: function(strToolbarCtid) {
        if (!EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.CantToolbarBeEngineOwner))
            return false;
        return EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.CantToolbarBeEngineOwner).indexOf(strToolbarCtid) == -1 ? false : true;
    },

    isEngineVisible: function() {
        return (window["EBPreferenceForLocalStorage_" + EBGlobalConsts_CT2958529.EngineCTID]) ? window["EBPreferenceForLocalStorage_" + EBGlobalConsts_CT2958529.EngineCTID].IsEngineShown : false;
    },

    hideShowEngineAfterRestart: function(isTohide) {
        EBPreferenceService_CT2958529.SetPref(EBGlobalConsts_CT2958529.EngineCTID + this.hideShowEngineAfterRestartPref, isTohide);
    },

    isEngineHidingAfterRestart: function() {
        return EBPreferenceService_CT2958529.GetPref(EBGlobalConsts_CT2958529.EngineCTID + this.hideShowEngineAfterRestartPref);
    },

    getSubjectIncludeMainWindowId: function() {
        if (!window.conduitId)
            window.conduitId = Math.random();

        var objSubject = new Object();
        objSubject.wrappedJSObject = objSubject;
        objSubject.windowId = window.conduitId;
        return objSubject;
    },

    getMainWindowId: function() {
        if (!window.conduitId)
            window.conduitId = Math.random();
        return window.conduitId;
    },

    setEngineOwner: function(strEngineOwner, strEngineOwnerToolbarId, strEngineOwnerGuid) {
        EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EngineOwner, strEngineOwner);
        EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EngineOwnerToolbarId, strEngineOwnerToolbarId);
        EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EngineOwnerGuid, strEngineOwnerGuid);

        if (!EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.OriginalEngineOwner) || !EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.OriginalEngineOwner))
            this.setOriginalEngineOwner(strEngineOwner, strEngineOwnerToolbarId, strEngineOwnerGuid);
    },

    setOriginalEngineOwner: function(strEngineOwner, strEngineOwnerToolbarId, strEngineOwnerGuid) {
        EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.OriginalEngineOwner, strEngineOwner);
        EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.OriginalEngineOwnerToolbarId, strEngineOwnerToolbarId);
        EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.OriginalEngineOwnerGuid, strEngineOwnerGuid);
    },

    originalEngineOwner: function() {
        var objOriginalEngineOwner = new Object();
        objOriginalEngineOwner.CTID = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.OriginalEngineOwner);
        objOriginalEngineOwner.ToolbarId = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.OriginalEngineOwnerToolbarId);
        objOriginalEngineOwner.Guid = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.OriginalEngineOwnerGuid);
        return objOriginalEngineOwner;
    }
};
// new encryption class
// the old class adds some illigal chars when used on small strings
var EBEncryption_CT2958529 =
{
    keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
    hexStr: "0123456789ABCDEF",

    encodeHex: function(input) {
        var output = "";
        var chr1 = "";
        var enc1, enc2 = "";
        var i = 0;

        do {
            chr1 = input.charCodeAt(i++);
            enc1 = chr1 >> 4;
            enc2 = chr1 & 15;
            output = output + this.hexStr.charAt(enc1) + this.hexStr.charAt(enc2);
        } while (i < input.length);
        return output;
    },

    decodeHex: function(input) {
        var output = "";
        var chr1, chr2 = "";
        var enc1 = "";
        var i = 0;

        // remove all characters that are not A-F, a-F, or 0-9
        input = input.replace(/[^A-Fa-f0-9]/g, "");
        input = input.toUpperCase();

        do {
            chr1 = this.hexStr.indexOf(input.charAt(i++));
            chr2 = this.hexStr.indexOf(input.charAt(i++));
            enc1 = chr2 | (chr1 << 4);
            output = output + String.fromCharCode(enc1);
        } while (i < input.length);
        return output;
    },

    encode64: function(input) {
        var output = "";
        var chr1, chr2, chr3 = "";
        var enc1, enc2, enc3, enc4 = "";
        var i = 0;

        do {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
            this.keyStr.charAt(enc1) +
            this.keyStr.charAt(enc2) +
            this.keyStr.charAt(enc3) +
            this.keyStr.charAt(enc4);
            chr1 = chr2 = chr3 = "";
            enc1 = enc2 = enc3 = enc4 = "";
        } while (i < input.length);

        return output;
    },

    decode64: function(input) {
        var output = "";
        var chr1, chr2, chr3 = "";
        var enc1, enc2, enc3, enc4 = "";
        var i = 0;

        // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        do {
            enc1 = this.keyStr.indexOf(input.charAt(i++));
            enc2 = this.keyStr.indexOf(input.charAt(i++));
            enc3 = this.keyStr.indexOf(input.charAt(i++));
            enc4 = this.keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

            chr1 = chr2 = chr3 = "";
            enc1 = enc2 = enc3 = enc4 = "";

        } while (i < input.length);

        return output;
    },

    // public method for url encoding
    encodeUTF8: function(string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    },

    // public method for url decoding
    decodeUTF8: function(utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while (i < utftext.length) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    },

    encode: function(input) {
        return this.encodeHex(this.encodeUTF8(input));
    },

    decode: function(input) {
        return this.decodeUTF8(this.decodeHex(input));
    }

};

function parseBool(str) {
    if (!str) return false;

    return str.toLowerCase() == "true";
};

function dumpAllProp(obj) {
    if(!obj) return;

    for (var i in obj) {
        try {
            EBLog(i + " = " + obj[i]);
        } catch (e) { }
    }
};

function dumpAllPropToFile(obj, filename) {
     if (!obj) return;

    var strText = "";
    for (var i in obj) strText += i + " = " + obj[i] + "\r\n";

    var oFile = EBIOManager_CT2958529.CreateToolbarFile(filename+".txt");
    EBFileIO_CT2958529.write(oFile, strText, null, "UTF-8");
};


if (typeof (stringFormat) == "undefined") {
    window.stringFormat = function(strText) {
        if (arguments.length <= 1) return strText;
        var replaceString = "";
        for (var i = 0; i < arguments.length - 1; i++) {
            replaceString = "{" + i.toString() + "}";
            strText = strText.replace(replaceString, arguments[i + 1]);
        }

        return strText;
    };
}

if (typeof (stringEquals) == "undefined") {
    window.stringEquals = function(str1, str2, bIgnoreCase) {
        if (!str1 && !str2)
            return true;
        else if (!str1 || !str2)
            return false;
        else {
            if (bIgnoreCase)
                return str1.toLowerCase() == str2.toLowerCase();
            else
                return str1 == str2;
        }
    };
};

if (typeof (ebCheckForMiddleClick) == "undefined") {
    function ebCheckForMiddleClick(event, command) {
        var node = event.target;
        if (node.getAttribute("disabled") == "true") return; // Do nothing
        // If the middle-click was on part of a menu, close the menu.
        // (Menus close automatically with left-click but not with middle-click.)

        if (event.button == 1) {
            command(event);
            closeMenus(node);
        }
    }
}

function getTopMostChevronStaticManager_CT2958529() {
    var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
    return (win) ? win.EBChevronStaticManager_CT2958529 : null;
};


//global array collection object
function EBArrayCollection_CT2958529()
{
	this.Arr = null;
	
	this.Init = function()
	{
		this.Arr = new Array();
	};
	
	this.AppendElement = function(objElement)
	{
		this.Arr[this.Arr.length] = objElement;
	};
	
	this.InsertElement = function(iIndex,objElement)
	{
		this.Arr.splice(iIndex,0,objElement);
	};
	
	this.RemoveElement = function(iIndex)
	{
		this.Arr.splice(iIndex,1);	
	};
	
	this.GetItem = function(iIndex)
	{
		var oItem = null;
		if(this.Arr[iIndex])
		{
			oItem = this.Arr[iIndex];
		}
		return oItem;	
	};

	this.Clear = function()
	{
		this.Init();	
	};
	
	this.Init();
}

var EBGlobalManager_CT2958529 =
{
    NSISound: Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound),
    _recentWindow: null,

    htmlDecode: function(encodedString) {
        return encodedString.replace(/&#([0-9]+);/g, function(a, b) { return String.fromCharCode(b); });
    },

    //support for firefox hidden window, 
    // be carefull, this window will be dropped in the future.
    HiddenWindow: function() {
        var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService)
         .hiddenDOMWindow;
        return hiddenWindow;
    },

    GetAllTabs: function() {
        var win = this.GetMostRecentBrowserWindow(true);
        var objTab = null;
        var arrTabs = new Array();

        for (var i = 0; i < win.gBrowser.browsers.length; i++)
            arrTabs.push(win.gBrowser.getBrowserAtIndex(i));

        return arrTabs;
    },

    // Return true / false attribute from element as real boolean type.
    GetBooleanAttribute: function(xulElement, strAttribute, bDefault) {
        var strAttributeValue = xulElement.getAttribute(strAttribute);
        return this.StringToBoolean(strAttributeValue, bDefault);
    },

    StringToBoolean: function(strBoolean, bDefault) {
        bDefault = (typeof bDefault == 'undefined') ? false : bDefault;

        if (!strBoolean)
            return bDefault;

        switch (strBoolean.toLowerCase()) {
            case 'true': return true; break;
            case 'false': return false; break;
            default: return bReturn;
        }
    },

    IsLastWindowInstance: function() {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');

        return !objEnumerator.hasMoreElements();
    },

    IsLanguageRtl: function(strLanguage) {
        if (!strLanguage || typeof (strLanguage) == "undefined")
            return false;

        strLanguage = strLanguage.toLowerCase();
        if (strLanguage.indexOf('he') != -1 || strLanguage.indexOf('ar') != -1) {
            return true;
        }

        return false;

    },

    GetUserAgentDirection: function() {
        var oWindow = this.GetMostRecentBrowserWindow(true);
        var xulMainWindow = oWindow.document.getElementById('main-window');
        var curDirection = oWindow.document.defaultView.getComputedStyle(xulMainWindow, null).getPropertyValue("direction");

        return curDirection;
    },

    IsUserAgentRtl: function() {
        var dir = this.GetUserAgentDirection();
        if (dir == 'rtl')
            return true;
        else
            return false;
    },

    IsReverseDialogs: function() {
        var prefName = EBPreferenceConsts_CT2958529.DialogsAlignMode;
        var direction = EBToolbarPreferenceManager_CT2958529.GetPref(prefName, true);
        if (!this.IsUserAgentRtl() && direction == "RTL") {
            return "rtl";
        }
        else if (this.IsUserAgentRtl() && direction == "LTR") {
            return "ltr";
        }
        else {
            return false;
        }
    },

    IsToolbarRTL: function() {
        //return EBGlobalConsts_CT2958529.IsToolbarReversed == EBUILogic_Toolbar_CT2958529.Consts.RTL;
        if(isFloatingMode_CT2958529 && !isAIOMode_CT2958529) 
            return EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().EBGlobalManager_CT2958529.IsToolbarRTL();
   
        var xulToolbar = (EBGlobalConsts_CT2958529.IsEngine && !isFloatingMode_CT2958529) || (!isAIOMode_CT2958529 && !EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.isToolbarInDualPackage() && !DualPackageFunctions_CT2958529.isEngineOnToolbar())  ?
                            document.getElementById("conduitEngineContainer") :
                            EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
        var compStyle = document.defaultView.getComputedStyle(xulToolbar, null);
        return compStyle.getPropertyValue("direction") == EBUILogic_Toolbar_CT2958529.Consts.RTL;
    },

    IsLocaleRTL: function() {
        var prefName = EBPreferenceConsts_CT2958529.DialogsAlignMode;
        if (EBToolbarPreferenceManager_CT2958529.GetPref(prefName, true) == "RTL") {
            return true;
        }
        else {
            return false;
        }
    },

    //returns real toolbar's direction based on drown toolbar
    GetToolbarDir: function() {
        var oToolbar = document.getElementById('browsersearch');
        var curDirection = document.defaultView.getComputedStyle(oToolbar, null).getPropertyValue("direction");
        return curDirection;
    },

    DateTimeStringToInt: function(strDateTime) {
        var iDateTime = 0;

        if (strDateTime)
            iDateTime = Date.parse(strDateTime);

        return iDateTime;
    },

    Initialize: function() {
        if (this.NSISound) {
            this.NSISound.init();
        }
    },

    ToStripHTML: function(strText) {
        strText = EBXML_CT2958529.FromLegalXml(strText);

        var FLAG_SKIP = 0;
        var FLAG_WRITE = 1;

        var iFlagState = FLAG_WRITE;
        var strClean = '';
        var chr = '';
        for (var i = 0; i < strText.length; i++) {
            chr = strText[i];
            if (chr == '<') {
                iFlagState = FLAG_SKIP;
            }
            else if (chr == '>') {
                iFlagState = FLAG_WRITE;
            }
            else if (iFlagState == FLAG_WRITE) {
                strClean += chr;
            }
        }

        return strClean;


    },

    IsFunctionNotLink: function(strURL) {
        if (strURL.indexOf("EBOpenPopHtml") != -1)
            return true;

        return false;
    },

    IsLegalCTID: function(strCTID) {
        var oRegTemplate = /^CT\d+$/i;
        return oRegTemplate.test(strCTID);
    },

    IsDomainExists: function(strDomain) {
        var arrDomains = EBGlobalConsts_CT2958529.Domains;
        for (var i = 0; i < arrDomains.length; i++) {
            if (arrDomains[i] == strDomain.toLowerCase()) {
                return true;
            }
        }

        return false;
    },

    IsCharWhitespace: function(ch) {
        return /^\s$/.test(ch);
    },

    IsCharPunctuation: function(ch) {
        return /[`~!@#$%^&\*()-+={}\[\]|\\:;\"<>,\.\?\/]/.test(ch);
    },

    IsValidEMail: function(strEMail) {
        return /^([0-9a-zA-Z]([-.\w_])*@([0-9a-zA-Z][-\w]*[0-9a-zA-Z]\.)+[a-zA-Z]{2,9})$/.test(strEMail);
    },

    GetParametersFromStringFunctionName: function(strUrl, strFunctionName) {
        strUrl = unescape(strUrl);
        strUrl = strUrl.substr(strUrl.indexOf(strFunctionName));
        strUrl = strUrl.replace(/"/g, '');
        strUrl = strUrl.replace(/'/g, "");
        var iStart = strUrl.indexOf('(') + 1;
        var iEnd = strUrl.indexOf(')');
        var strParams = strUrl.substring(iStart, iEnd);
        var arrParams = strParams.split(',');

        return arrParams;
    },

    IsWordCharacter: function(ch) {
        if (ch == null || (typeof ch != "string" || ch.length != 1)) {
            return false;
        }
        var code = ch.charCodeAt(0);
        return code >= 48 && code <= 57 || (code >= 65 && code <= 90 || (code >= 97 && code <= 122 || (code >= 138 && code <= 142 || (code >= 154 && code <= 159 || code >= 192 && code <= 255))))
    },

    BeginsWith: function(str, pref) {
        return str.substring(0, pref.length).toUpperCase() == pref.toUpperCase();
    },

    EndsWith: function(str, pref) {
        var iIndex = str.length - pref.length;
        return str.substring(iIndex).toLowerCase() == pref.toLowerCase();
    },

    TotalTrim: function(str) {
        str = str.replace(/\s/g, '');
        return str;
    },

    TrimToOne: function(str) {
        // Return empty if nothing was passed in
        if (!str) return "";

        str = this.Trim(str);

        // Replace any multiple whitespace characters with a single space
        str = str.replace(/\s+/g, ' ');

        // Return the altered string
        return str;
    },

    Trim: function(str) {
        if (!str || !str.replace)
            return null;

        str = str.replace(/^\s+/, '');
        str = str.replace(/\s+$/, '');

        return str;
    },

    IsPathExists: function(strPath) {
        var bExists = false;

        try {
            var oFile = Components.classes["@mozilla.org/file/local;1"]
									.createInstance(Components.interfaces.nsILocalFile);
            oFile.initWithPath(strPath);

            bExists = oFile.exists();
        }
        catch (ex) {
            bExists = false;
        }

        return bExists;
    },

    GetEnvironmentArg: function(strAlias) {
        var oEnvironment = Components.classes["@mozilla.org/process/environment;1"]
									.getService(Components.interfaces.nsIEnvironment);
        var strArg = oEnvironment.get(strAlias);

        return strArg;
    },

    PlaySound: function(strAudioFilePath) {
        var objURI = null;
        var objIOService = Components.classes["@mozilla.org/network/io-service;1"].createInstance(Components.interfaces.nsIIOService);
        var objFile = EBFileIO_CT2958529.open(strAudioFilePath);

        if (objFile)
            objURI = objIOService.newFileURI(objFile);
        else
            objURI = objIOService.newURI(strAudioFilePath, null, null);

        this.NSISound.play(objURI);
    },

    ToLegalFileName: function(strText) {
        strText = strText.replace(/\.|\\|\/|\:|\*|\?|\&amp\;|\&|\"|\<|\>|\|/g, '_');

        if (strText.length > 160)
            strText = EB_MD5Hash_CT2958529.MD5(strText);

        return strText;
    },

    Alert: function(objWindow, strTitle, strMsg) {
        var objPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
							.getService(Components.interfaces.nsIPromptService);

        objPromptService.alert(objWindow, strTitle, strMsg);
    },

    Confirm: function(objWindow, strTitle, strMsg) {
        var objPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
							.getService(Components.interfaces.nsIPromptService);

        return objPromptService.confirm(objWindow, strTitle, strMsg);
    },

    //var chkboxResponse = {value: false};
    ConfirmCheck: function(objWindow, strTitle, strMsg, strCheckboxText, chkboxResponse) {
        var objPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
							.getService(Components.interfaces.nsIPromptService);

        return objPromptService.confirmCheck(objWindow, strTitle, strMsg, strCheckboxText, chkboxResponse);
    },

    OpenDefaultMailClient: function() {
        var objShell = getShellService();
        try {
            if (objShell) {
                var iAppToOpen = Components.interfaces.nsIShellService.APPLICATION_MAIL;

                if (objShell.openApplication)
                    objShell.openApplication(iAppToOpen);
                else if (objShell.openPreferredApplication)
                    objShell.openPreferredApplication(iAppToOpen);
            }
        }
        catch (e) {
            if (this.IsWindowsPlatform()) {
                var strPath = EBRegistryManager_CT2958529.GetRegistryEntry(EBRegistryManager_CT2958529.HKEY_CLASSES_ROOT, 'mailto\\shell\\open\\command', '');
                if (!strPath) return;

                var bSuccess = EBWindows_CT2958529.WindowsShellDirectExecute(strPath, null, true);
                if (!bSuccess) {
                    var iStart = strPath.indexOf('"');
                    var iEnd = strPath.indexOf('"', iStart + 1);
                    var strAppPath = strPath.substring(iStart + 1, iEnd);
                    bSuccess = EBWindows_CT2958529.WindowsShellDirectExecute(strAppPath, null, true);
                }
            }
        }
    },

    GetEndOfLine: function() {
        return '\r\n';
    },

    IsFirefox3: function() {
        var objXULApp = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
        var platformVersion = objXULApp.platformVersion;
        var strGeckoVer = "1.9.0.0"; //FF3 gecko version
        var iCompare = this.compareVersions(platformVersion, strGeckoVer);
        return (iCompare >= 0)
    },

    IsFirefox35: function() {
        var objXULApp = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
        var platformVersion = objXULApp.platformVersion;
        var strGeckoVer = "1.9.1.0"; //FF3.5 gecko version
        var iCompare = this.compareVersions(platformVersion, strGeckoVer);
        return (iCompare >= 0)
    },

    IsFirefox36: function() {
        var objXULApp = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
        var platformVersion = objXULApp.platformVersion;
        var strGeckoVer = "1.9.2.0"; //FF3.6 gecko version
        var iCompare = this.compareVersions(platformVersion, strGeckoVer);
        return (iCompare >= 0)
    },
    
    IsFirefox4: function() {
        var objXULApp = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
        var platformVersion = objXULApp.platformVersion;
        var strGeckoVer = "1.9.3.0"; //FF4.0 gecko version
        var iCompare = this.compareVersions(platformVersion, strGeckoVer);
        return (iCompare >= 0);
    },
    
    GetBrowserName: function() {
        var strBrowserName = '';

        if ("@mozilla.org/windows-registry-key;1" in Components.classes) //1.5
        {
            var objXULApp = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
            strBrowserName = objXULApp.name;
        }
        else //1.0.x
        {
            strBrowserName = navigator.vendor;
        }

        return strBrowserName;
    },

    GetBrowserVersion: function() {
        var strBrowserVersion = '';
        var objXULApp = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
        strBrowserVersion = objXULApp.version;

        return strBrowserVersion;
    },

    GetBrowserNameAndVersion: function() {
        return this.GetBrowserName() + "_" + this.GetBrowserVersion();
    },

    IsFirefoxBrowser: function() {
        var strBrowserName = this.GetBrowserName();
        return strBrowserName.toLowerCase() == 'firefox';
    },

    IsNewestBrowserAPI: function() {
        return this.GetBrowserVersion() >= '1.5' || !this.IsFirefoxBrowser();
    },

    _GetMostRecentBrowserWindow: function() {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        //get the last browser window active(this is actually it parent
        return objWindowsManager.getMostRecentWindow('navigator:browser');
    },

    GetMostRecentBrowserWindow: function(forceRealBrowserWindow) {
        if (forceRealBrowserWindow)
            return this._GetMostRecentBrowserWindow();

        if (!this._recentWindow) {
            if (typeof gBrowser != "undefined" || window.isAIOMode_CT2958529)
                this._recentWindow = window;
            else if (window.opener && (window.opener.gBrowser || window.opener.isAIOMode_CT2958529))
                this._recentWindow = window.opener;
            else
                this._recentWindow = this._GetMostRecentBrowserWindow();
        }

        return this._recentWindow;
    },

    GetAllWindows: function() {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
					.getService(Components.interfaces.nsIWindowMediator);

        var windowType = (isAIOMode_CT2958529) ? "EBChevronToolbarType_CT2958529" : "navigator:browser";
        var objEnumerator = objWindowsManager.getEnumerator(windowType);
        var arrWindows = new Array();
        var win = null;
        while (objEnumerator.hasMoreElements()) {
            win = objEnumerator.getNext();
            if (!isAIOMode_CT2958529 || win.AIOModeCTID_CT2958529 == AIOModeCTID_CT2958529)
                arrWindows.push(win);
        }

        return arrWindows;
    },

    GetXULWindowByTypeAndName: function(strWindowType, strWindowName) {
        var oWindowsManager = Components.classes["@mozilla.org/appshell/window-mediator;1"]
						.getService(Components.interfaces.nsIWindowMediator);

        var oEnumerator = oWindowsManager.getEnumerator(strWindowType);

        while (oEnumerator.hasMoreElements()) {
            var oWindow = oEnumerator.getNext();

            if (oWindow.name == strWindowName) {
                return oWindow;
            }
            else if (oWindow.name == (strWindowName + EBGlobalConsts_CT2958529.ToolbarCTID)){
              return oWindow;
            }
        }

        return null;
    },

    GetXULWindowsByType: function(strWindowType) {
        var arr = new Array();
        var oWindowsManager = Components.classes["@mozilla.org/appshell/window-mediator;1"]
						.getService(Components.interfaces.nsIWindowMediator);

        var oEnumerator = oWindowsManager.getEnumerator(strWindowType);

        while (oEnumerator.hasMoreElements()) {
            var oWindow = oEnumerator.getNext();
            arr.push(oWindow);
        }

        return arr;
    },

    GetWebPageJavascriptObject: function(oContentWindow) {
        var oJavascript = null;

        try {
            if (oContentWindow)
                oJavascript = oContentWindow.wrappedJSObject ? oContentWindow.wrappedJSObject : oContentWindow;
        }
        catch (ex) { }

        return oJavascript;
    },

    IsWindowsPlatform: function() {
        var strPlatform = navigator.platform.toLowerCase();
        return strPlatform.indexOf('win') != -1 ? true : false;
    },

    IsLinuxPlatform: function() {
        var strPlatform = navigator.platform.toLowerCase();
        return strPlatform.indexOf('linux') != -1 ? true : false;
    },

    IsMacintoshPlatform: function() {
        var strPlatform = navigator.platform.toLowerCase();
        return strPlatform.indexOf('mac') != -1 ? true : false;
    },

    GetOS: function() {
        try {
            var strUserAgent = navigator.userAgent;
            var iStart = strUserAgent.indexOf('(');
            var iEnd = strUserAgent.indexOf(')');
            var strPlatformData = strUserAgent.substring(iStart, iEnd);
            var arrData = strPlatformData.split(';');
            return EBGlobalManager_CT2958529.Trim(arrData[2]);
        }
        catch (e) {
            return '';
        }
    },

    GetOSVersion: function() {
        var strOS = this.GetOS();
        if (!strOS) return "";

        var arr = strOS.split(" ");
        return arr[arr.length - 1];
    },

    IsInArray: function(arr, strText) {
        for (var i = 0; i < arr.length; i++) {
            if (arr[i] == strText) {
                return i;
            }
        }

        return -1;
    },

    //get the index of a dom element referring to it's parent
    GetDOMElementIndex: function(objDOMElement) {
        var objDOMParentElement = objDOMElement.parentNode;
        if (objDOMParentElement) {
            for (var i = 0; i < objDOMParentElement.childNodes.length; i++) {
                if (objDOMParentElement.childNodes[i] == objDOMElement) {
                    return i;
                }
            }
        }

        return -1;
    },

    GenerateRandomNumber: function() {
        var iNum = Math.ceil(Math.random() * 10000000000000);

        return iNum;
    },

    IsElementInScreenCoordinates: function(objElement) {
        var iElementX = objElement.boxObject.screenX;
        var iElementY = objElement.boxObject.screenY;
        var iElementWidth = objElement.boxObject.width;
        var iElementHeight = objElement.boxObject.height;


        //get the global screen coordinates
        var iScreenX = EBGlobalVariables_CT2958529.ScreenCoordinateX;
        var iScreenY = EBGlobalVariables_CT2958529.ScreenCoordinateY;

        if (iScreenX >= iElementX &&
			iScreenX <= (iElementX + iElementWidth) &&
			iScreenY >= iElementY &&
			iScreenY <= (iElementY + iElementHeight)) {
            return true;
        }
        else {
            return false;
        }
    },

    SendFeedback: function(which) {
        var strURL = '';
        var oWindow = this.GetMostRecentBrowserWindow()
        var strAdditional = '';

        switch (which) {
            case "weather":
                strAdditional = EBGlobalConsts_CT2958529.FeedbackURL.Weather + EBGlobalManager_CT2958529.GetBrowserName();
                strURL = oWindow.EBActionManager_CT2958529.GetWebServerURL(strAdditional);
                strURL = EBUrl_CT2958529.LegalizeLinkUrl(strURL);
                oWindow.EBWeb_CT2958529.LoadURL(strURL);
                break;
            case "emailNotifier":
                strAdditional = EBGlobalConsts_CT2958529.FeedbackURL.EmailNotifier + EBGlobalManager_CT2958529.GetBrowserName();
                strURL = oWindow.EBActionManager_CT2958529.GetWebServerURL(strAdditional);
                strURL = EBUrl_CT2958529.LegalizeLinkUrl(strURL);
                EBWeb_CT2958529.LoadURLInNewWindow(strURL);
                break;
            case "radio":
                strAdditional = EBGlobalConsts_CT2958529.FeedbackURL.Radio + EBGlobalManager_CT2958529.GetBrowserName();
                strURL = oWindow.EBActionManager_CT2958529.GetWebServerURL(strAdditional);
                strURL = EBUrl_CT2958529.LegalizeLinkUrl(strURL);
                EBWeb_CT2958529.LoadURLInNewWindow(strURL);
                break;
        }
    },

    GetGadgetInfoFromLink: function(strURL, oEvent, strParentId) {
        var objData = new Object();
        objData.url = strURL.substring(strURL.indexOf("(") + 1, strURL.indexOf(","));
        objData.url = objData.url.replace(/\\'/g, "");
        objData.url = objData.url.replace(/"/g, '');
        objData.url = objData.url.replace(/'/g, "");

        objData.title = oEvent.target.label;
        objData.titleIcon = oEvent.target.image;
        objData.width = parseInt(strURL.substring(strURL.indexOf(",") + 1, strURL.lastIndexOf(",")));
        objData.height = parseInt(strURL.substring(strURL.lastIndexOf(",") + 1, strURL.indexOf(")")));

        if (strParentId) {
            var xulButton = document.getElementById(strParentId);

            if (xulButton) {
                objData.screenX = xulButton.boxObject.screenX;
                objData.screenY = xulButton.boxObject.screenY + xulButton.boxObject.height;
            }
        }
        else {
            objData.screenX = oEvent.target.boxObject.screenX;
            objData.screenY = oEvent.target.boxObject.screenY + oEvent.target.boxObject.height;
        }

        return objData;
    },

    copyToClipboard: function(strText) {
        var gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
	            .getService(Components.interfaces.nsIClipboardHelper);
        gClipboardHelper.copyString(strText);
    },

    compareVersions: function(strVer1, strVer2) {
        var oVersionCompare = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
                                        .createInstance(Components.interfaces.nsIVersionComparator);
        return oVersionCompare.compare(strVer1, strVer2);
    },

    //first level clone only (clones simple values, object remeins unloned, but referenced)
    cloneObject: function(obj) {
        if (typeof (obj) != "object") return obj;
        if (obj == null) return obj;

        var newObj = new Object();

        for (var i in obj)
            newObj[i] = obj[i];

        return newObj;
    },

    GetSystemLocale: function() {
        var strLocale = "en-US";
        try {
            var strLocale = Components.classes["@mozilla.org/intl/nslocaleservice;1"]
                                                .getService(Components.interfaces.nsILocaleService)
                                                .getLocaleComponentForUserAgent()
                                                .getCategory("NSILOCALE_CTYPE");
        }
        catch (ex) {
            EBLog(ex);
        }

        return strLocale;
    },

    OpenDialog: function(url, name, features, argsArray, isToNotClose, callback) {
        var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
        var dialogWin = null;
        if (!isFloatingMode_CT2958529 || isAIOMode_CT2958529){
            dialogWin = win.openDialog(url, name, features, argsArray);
            win.EBGadgetManager_CT2958529.BringToFront();
            if(callback) callback(dialogWin);
        }
        else {
            if (isToNotClose) ChevronStaticManager.disableCloseAllWindows = true;

            win.setTimeout(function() {
                dialogWin = win.openDialog(url, name, features, argsArray);
                if(callback) callback(dialogWin);
            }, 1);
            if (name.indexOf('chevronToolbar') == -1 && !isToNotClose) {
                ChevronStaticManager.CloseAllWindows();
                win.setTimeout(function() { win.EBGadgetManager_CT2958529.BringToFront(); }, 1);
            }
        }
    },

    GetAllFrames: function(objDoc) {
        var arrFrames = objDoc.getElementsByTagName('frame');
        var arrIFrames = objDoc.getElementsByTagName('iframe');
        var arr = new Array();
        var i;
        for (i = 0; i < arrFrames.length; i++)
            arr.push(arrFrames[i]);

        for (i = 0; i < arrIFrames.length; i++)
            arr.push(arrIFrames[i]);

        return arr;
    },

    DispatchEvent: function(win, topic, data) {
        var doc = win.document;
        var event = doc.createEvent("MessageEvent");
        event.initMessageEvent(topic, true, false, data, "*", "", win);
        doc.dispatchEvent(event);
    },

    UninstallExtension: function(guid) {
        //FF 4.0+
        if (EBGlobalManager_CT2958529.IsFirefox4()) {
            Components.utils.import("resource://gre/modules/AddonManager.jsm");  
            AddonManager.getAddonByID(guid, function(addon) {  
            addon.uninstall();});
        }
        //FF 3 - 3.6.*
        else {
            var objExtManager = Components.classes["@mozilla.org/extensions/manager;1"]
                .getService(Components.interfaces.nsIExtensionManager);
            objExtManager.uninstallItem(guid);
        }
        
    }
};

var EBGlobalVariables_CT2958529 =
{
    ScreenCoordinateX: 0,
    ScreenCoordinateY: 0
};

var EBGlobalConsts_CT2958529 =
{
    ServiceMapUrl: "http://servicemap.conduit-services.com/Toolbar/?ownerId=EB_ORIGINAL_CTID",
    IsEngine: false,
    ABBaseCTID: '',
    ABTestingCTID: '',
    ABTestingName: '',   
    ToolbarId: 'browsersearch',
    OptionsButtonId: 'conduitToolbarOptions_CT2958529',
    ComponentsContainerId: "componentsContainer_browsersearch",
    EngineContainerId: "conduitEngineContainer",
    MyStuffSplitterId: "MyStuffContainerSplitter_CT2958529",
    MyStuffSeperator: "MyStuffContainerSeparator_CT2958529",
    ToolbarAddStuffButtonId: "conduitToolbarAddStuffBtn_CT2958529",
    EngineAddStuffButtonId: "conduitEngineAddStuffBtn",
    ConduitEngineName: "conduitengine",
    ToolbarName: 'browsersearch',
    ToolbarCTID: 'CT2958529',
    EngineCTID: 'ConduitEngine',
    SuggestHistoryFolderName: 'EBSuggestHistory',
    GUID: '{23b86643-7612-41f7-a516-f86a071d225d}',
    EngineGUID: "engine@conduit.com",
    ToolbarVersion: '0.0.0.0',
    Version: '3.3.2.1',
    ShowUninstallPage: true,
    WebServerUrl: 'http://browsersearchToolbar.OurToolbar.com/',
    ServerUrl: 'http://users.conduit.com',
    ChromeContentPath: 'chrome://browsersearch/content/',
    ChromeSkinPath: 'chrome://browsersearch/skin/',
    Delimiter: '||',
    DefaultCharset: 'UTF-8',
    Domains: ['info', 'biz', 'name', 'pro', 'museum', 'coop', 'aero', 'edu', 'gov', 'com', 'net', 'tv', 'fm', 'us', 'cc', 'jobs', 'ws', 'ad', 'ae', 'af', 'ao', 'aq', 'ar', 'at', 'au', 'bb', 'be', 'bg', 'br', 'ca', 'ch', 'ck', 'cl', 'cn', 'co', 'cs', 'cy', 'de', 'dk', 'dz', 'ec', 'eg', 'es', 'fi', 'fj', 'fr', 'gb', 'gl', 'gov', 'gr', 'hk', 'hr', 'hu', 'id', 'ie', 'il', 'in', 'iq', 'is', 'it', 'jm', 'jp', 'lb', 'lu', 'lv', 'ly', 'ma', 'mc', 'mil', 'mk', 'mo', 'mr', 'mn', 'mt', 'mu', 'mx', 'my', 'nc', 'net', 'nf', 'nl', 'no', 'np', 'nz', 'org', 'pa', 'pe', 'pg', 'ph', 'pk', 'pl', 'pt', 'ro', 'sa', 'sb', 'se', 'sg', 'su', 'td', 'th', 'to', 'tw', 'uk', 'us', 'va', 'vg', 'za', 'zm'],
    HTTP_PREFIX: 'http://',
    FTP_PREFIX: 'ftp://',
    BookmarkletPrefix: 'javascript:',
    NetworkError: 'EB_NETWORK_ERROR',
    DegreeSymbol: '\u00BA',
    RegistryShellExecutePath: 'SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\',
    ToolbarHorizontalDialogGap: 10,
    ToolbarVerticalDialogGap: 40,
    MultiCommunity: false,
    Grouping: false,
    ToolbarLanguage: 'EN',
    IsToolbarReversed: false,
    FixPageNotFoundErrorsEnabled: false,
    FixPageNotFoundErrorsChecked: true,
    AlertEnabled: true,
    FixPageNotFoundDefaultUrl: 'http://hosting.conduit.com/notfound/?ctid=EB_TOOLBAR_ID&actid=EB_TOOLBAR_ID&octid=EB_ORIGINAL_CTID',
    EnableSearchFromAddress: true,
    TrusteUrl: 'http://truste.conduit.com/EB_ORIGINAL_CTID',
    LanguagePackUrl: "http://translation.users.conduit.com/Translation.ashx",
    DefaultWebServerURL: "http://hosting.conduit.com/",
    MyStuffServiceUrl: "http://mystuff.conduit-services.com/MyStuffService.ashx?ComponentId=EB_MY_STUFF_INSTANCE_GUID&lut=EB_MY_STUFF_LUT",
    MyStuffSearchUrl: "http://search.conduit.com/Results.aspx?q=SEARCH_TERM&ctid=EB_TOOLBAR_ID&octid=EB_ORIGINAL_CTID&SearchType=ToolbarComponents",
    MyStuffEnabled: true,
    IsAMO: false,
    IsSelectFromGroupingByLocale: false,
    FFExtensionFileName: "xpi",
    SettingsGETServerUrl: "http://settings.toolbar.conduit-services.com/?ctid=EB_TOOLBAR_ID&octid=EB_ORIGINAL_CTID",
    SearchServerUrl: "search.conduit.com",
    LastBrowserComponentId: null,
    WindowId: "ebWindowId_CT2958529",
    AllowSilentInstallation: 'false',
    ForceUninstallEngineOnToolbarUninstall: true,
    AddToEngineUninstall: false,
    EngineCookieDomain: "",
    SearchProvider: "BING",
    SocialDomains: "apps.conduit.com;social.conduit.com",
    
    Attributes:
	{
	    XULLabel: 'EB_XUL_LABEL',
	    XULImage: 'EB_XUL_IMAGE',
	    XULElementIndex: 'EB_XUL_ELEMENT_INDEX',
	    XULTooltip: 'EB_XUL_TOOLTIP'
	},

    Aliases:
	{
	    MainFrameURL: /EB_MAIN_FRAME_URL/g,
	    ToolbarID: /EB_TOOLBAR_ID/g, //ctid
	    UserID: /EB_USER_ID/g,
	    SearchTerm: /EB_SEARCH_TERM/g,
	    ToolbarVersion: /EB_TOOLBAR_VERSION/g,
	    ToolbarOriginalID: /EB_ORIGINAL_CTID/g,
	    MainFrameTitle: /EB_MAIN_FRAME_TITLE/g,
	    ToolbarSubDomain: /EB_TOOLBAR_SUB_DOMAIN/g,
	    DownloadPage: /EB_DOWNLOAD_PAGE/g,
	    ToolbarName: /EB_TOOLBAR_NAME/g
	}
};

var EBForceRefreshFlags_CT2958529 =
{
    ALL: 0,
    SETTINGS: 1,
    CHAT: 2,
    RADIO: 4,
    GROUPING: 8,
    COMMUNITIES: 16,
    MY_STUFF: 32
};

//object represent collection holding hash and index array
//example use - the toolbar components
function EBArrayHashObject_CT2958529()
{
	this.IndexerArray	= null;
	this.HashArray		= null;
	
	this.Init = function()
	{
		this.IndexerArray	= new Array();
		this.HashArray		= new Array();
	};
	
	this.Add = function(strKeyID,objValue)
	{
		//check if already exists
		if(!this.Contains(strKeyID))
		{
			strKeyID = this.LegalizeHashKey(strKeyID);
			
			//add to the indexers array to the last place
			this.IndexerArray[this.IndexerArray.length] = objValue;
			
			//add to the hash array per component id
			this.HashArray[strKeyID]					= objValue;
		}
	};

	this.Insert = function(iIndex, strKeyID, objValue) {
	    if (!this.Contains(strKeyID)) {
	        strKeyID = this.LegalizeHashKey(strKeyID);

	        //add to the indexers array to the iIndex place
	        this.IndexerArray.splice(iIndex, 0, objValue);

	        //add to the hash array per component id
	        this.HashArray[strKeyID] = objValue;
	    }
	};;
	
	this.Remove = function(iIndex,strKeyID)
	{
		if(this.Contains(strKeyID))
		{
			strKeyID = this.LegalizeHashKey(strKeyID);
			
			//remove from indexer array
			this.IndexerArray.splice(iIndex,1);
			
			//remove from hash
			delete this.HashArray[strKeyID];
		}
		
	};
	
	this.GetByIndex = function(iIndex)
	{
		var objValue = this.IndexerArray[iIndex];
		return objValue;
	};
	
	this.GetByID = function(strKeyID)
	{
		strKeyID = this.LegalizeHashKey(strKeyID);
		
		var objValue = this.HashArray[strKeyID];
		return objValue;
	};
	
	this.GetIndexByObjectValue = function(oValue)
	{
		for(var i=0;i<this.IndexerArray.length;i++)
		{
			if(this.GetByIndex(i) == oValue)
			{
				return i;
			}
		}
		
		return -1;
	};
	
	this.Contains = function(strKeyID)
	{
		var objValue = this.GetByID(strKeyID);
		return objValue ? true : false;
	};
	
	this.Count = function()
	{
		return this.IndexerArray.length;
	};
	
	this.LegalizeHashKey = function(strKeyID)
	{
		strKeyID = strKeyID.toString();
		strKeyID = strKeyID.toUpperCase();
		
		return strKeyID;	
	};
	
	this.Clear = function()
	{
		this.Init();
	};
	
	this.Init();
};


//this object is not real hash, it's used for little amount of data, but can delete from the hash.
function EBArrayHashObject2_CT2958529() {
    this.arr = null;

    this.Init = function() {
        this.arr = new Array();
    };

    this.Add = function(strKeyID, objValue) {
        strKeyID = this.LegalizeHashKey(strKeyID);

        //remove if already exists
        this.Remove(strKeyID);

        this.arr.push({ "key": strKeyID, "value": objValue });
    };

    this.Remove = function(strKeyID) {
        strKeyID = this.LegalizeHashKey(strKeyID);
        var elem = null;

        var temp = this._getObjAndIndex(strKeyID);
        if (!temp) return;

        this.arr.splice(temp.index, 1);
    };

    this.GetByIndex = function(iIndex) {
        return this.arr[iIndex].value;
    };

    this.GetByID = function(strKeyID) {
        strKeyID = this.LegalizeHashKey(strKeyID);
        var temp = this._getObjAndIndex(strKeyID);
        if (!temp) throw ("element not found in hash");
        return temp.obj.value;
    };

    this.Contains = function(strKeyID) {
        strKeyID = this.LegalizeHashKey(strKeyID);
        return this._getObjAndIndex(strKeyID) != null;
    };

    this.Count = function() {
        return this.arr.length;
    };

    this.LegalizeHashKey = function(strKeyID) {
        try {
            strKeyID = strKeyID.toString();
            strKeyID = strKeyID.toUpperCase();
        }
        catch (ex) {
            Logging.LogToConsole(ex);
        }

        return strKeyID;
    };

    this._getObjAndIndex = function(strKeyID) {
        strKeyID = this.LegalizeHashKey(strKeyID);
        for (var i = 0; i < this.arr.length; i++) {
            elem = this.arr[i];
            if (elem.key == strKeyID) {
                return { "obj": elem, "index": i };
            }
        }
        return null;
    };

    this.Clear = function() {
        this.Init();
    };

    this.Init();
};

//used only in engine uninstall dialog.
function EBSortHash_CT2958529() {
    var originalKeysArray;
    var sortedKeysArray;
    var originalValuesArray;

    this.Init = function() {
        originalKeysArray = new Array();
        sortedKeysArray = new Array();
        originalValuesArray = new Array();
    };

    this.Add = function(key, value) {
        originalKeysArray.push(key);
        sortedKeysArray.push(key);
        originalValuesArray.push(value);
    };

    this.Sort = function() {
        sortedKeysArray.sort();
    };

    this.getSortedKeysArray = function() {
        this.Sort();
        return sortedKeysArray;
    };

    this.getSortedValuesArray = function() {
        this.Sort();
        var sortedValuesArray = new Array();
        for (var i = 0; i < sortedKeysArray.length; i++)
            for (var j = 0; j < originalKeysArray.length; j++)
            if (sortedKeysArray[i] == originalKeysArray[j]) {
            sortedValuesArray.push(originalValuesArray[j])
            break;
        }
        return sortedValuesArray;
    };

    this.Init();
};
if (typeof JSON == "undefined") {
    //FF3.5
    if (EBGlobalManager_CT2958529.IsFirefox35()) {
        //do nothing
    }
    //FF3
    else if (EBGlobalManager_CT2958529.IsFirefox3()) {
        var myJson = Components.classes["@mozilla.org/dom/json;1"].createInstance(Components.interfaces.nsIJSON);
        JSON = {};
        JSON.stringify = function(obj) { return myJson.encode(obj); };
        JSON.parse = function(str) { return myJson.decode(str); };
    }
}
var EBLinkManager_CT2958529 =
{
    //all calls for link loads from any place should be done with this function!
    LoadLinkURL: function(event) {
        //check validation of the url
        if (!event.customData.url || event.customData.url.toLowerCase() == EBGlobalConsts_CT2958529.HTTP_PREFIX || EBGlobalManager_CT2958529.TotalTrim(event.customData.url) == "")
            return;
        //convert aliases in the link
        event.customData.url = EBActionManager_CT2958529.ConvertAliasesUrl(event.customData.url);
        event.customData.url = EBUrl_CT2958529.LegalizeLinkUrl(event.customData.url);
        //check if the click is from middle button to open in a new tab
        if (event && event.button == 1) {
            event.customData.urlTarget = "TAB";
        }

        //check if this link is function to open popHTML window.
        if (EBGlobalManager_CT2958529.IsFunctionNotLink(event.customData.url)) {

            var oGadgetData = EBGlobalManager_CT2958529.GetGadgetInfoFromLink(event.customData.url, event, event.customData.parentId);
            var popHtmlData = new oToolbar_CT2958529.toolbarDataParsing.dataObjects.PopHtml();
            popHtmlData.event = event;
            popHtmlData.popHtmlUrl = oGadgetData.url;
            popHtmlData.width = oGadgetData.width;
            popHtmlData.height = oGadgetData.height;
            popHtmlData.parentElement = event.target;
            popHtmlData.openPositionType = popHtmlData.openPositionTypes.alignment;
            popHtmlData.openPositionData.vertical = popHtmlData.openPositionTypes.verticalAlignmentBottom;
            popHtmlData.event.customData.isUser = (event.customData.isUser) ? true : false;
            popHtmlData.componentId = event.customData.strAncestorId;
            popHtmlData.elementId = event.customData.compId;
            popHtmlData.compType = event.customData.compType;
            popHtmlData.source = event.customData.source;
            popHtmlData.gadgetType = EBGadgetManager_CT2958529.GADGET_TYPE_REGULAR;
            popHtmlData.titleIconUrl = oGadgetData.titleIcon;
            popHtmlData.title = oGadgetData.title;

            EBGadgetManager_CT2958529.OpenGadget(popHtmlData);
        }
        //check for post
        else if (event.customData.postParams || event.customData.uploadStream)
            this.LoadURLPostData(event.customData.url, event.customData.postParams, event.customData.urlTarget, event.customData.uploadStream);

        else {
            switch (event.customData.urlTarget) {
                case "TAB":
                case "NEW":
                    EBWeb_CT2958529.LoadURLInNewTab(event.customData.url, event.customData.isStayInCurrantPage);
                    break;
                case "BLANK":
                    EBWeb_CT2958529.LoadURLInNewWindow(event.customData.url);
                    break;
                default:
                    EBWeb_CT2958529.LoadURL(event.customData.url);
                    break;
            }
        }
    },

    LoadURLPostData: function(strPostURL, postParams, urlTarget, uploadStream) {
        var objMimeStream;
        var win = null;
        if (!uploadStream)
            objMimeStream = EBWeb_CT2958529.SetupMimeStream(postParams);
        else
            objMimeStream = uploadStream;

        if (urlTarget == "TAB") {
            //first load a blank tab
            EBWeb_CT2958529.LoadURLInNewTab('');
        }
        else if (urlTarget == "NEW") {
            //first load a blank window
            //EBWeb_CT2958529.LoadURLInNewWindow('');
            EBWeb_CT2958529.LoadURLInNewTab('');
        }
        else if (urlTarget == "BLANK") {
            //first load a blank window
            EBWeb_CT2958529.LoadURLInNewWindow(strPostURL, objMimeStream);
            return;
        }

        //login to the url using the mimeStream

        var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        if (isFloatingMode_CT2958529) {
            win.getBrowser().webNavigation.loadURI(strPostURL,
											win.Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
											null,
											objMimeStream,
											null);




            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }
        else
            getBrowser().webNavigation.loadURI(strPostURL,
											Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
											null,
											objMimeStream,
											null);
    }
};

var EBLogging_CT2958529 =
{
    LogToConsole: function(ex, addInfo) {
        if (!EBPreferenceService_CT2958529.GetPref("conduit.debugMode")) return;

        if (ex && typeof ex.fileName != "undefined") {
            var strMsg = addInfo + " " + ex + "\nStack:\n " + ex.stack;
            this.ExtendedLogToConsole(strMsg, ex.fileName, null, ex.lineNumber, null, null, ex.name);
        }
        else
            this.ExtendedLogToConsole(ex, null, null, null, null, null, null);
    },

    ExtendedLogToConsole: function(aMessage, aSourceName, aSourceLine, aLineNumber, aColumnNumber, aFlags, aCategory) {
        var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);
        var scriptError = Components.classes["@mozilla.org/scripterror;1"]
                              .createInstance(Components.interfaces.nsIScriptError);
        scriptError.init(aMessage, aSourceName, aSourceLine, aLineNumber,
                   aColumnNumber, aFlags, aCategory);

        consoleService.logMessage(scriptError);
    }
};

function EBLog(ex, addInfo) {
    EBLogging_CT2958529.LogToConsole(ex, addInfo);
};

/*
 * A JavaScript implementation of the RSA Data Security, Inc. this.MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Copyright (C) Paul Johnston 1999 - 2000.
 * Updated by Greg Holt 2000 - 2001.
 * See http://pajhome.org.uk/site/legal.html for details.
 */

/*
 * Convert a 32-bit number to a hex string with ls-byte first
 */
var EB_MD5Hash_CT2958529 =
{
    hex_chr : "0123456789abcdef",
    
    rhex : function(num)
    {
      str = "";
      for(j = 0; j <= 3; j++)
        str += this.hex_chr.charAt((num >> (j * 8 + 4)) & 0x0F) +
               this.hex_chr.charAt((num >> (j * 8)) & 0x0F);
      return str;
    },

    /*
     * Convert a string to a sequence of 16-word blocks, stored as an array.
     * Append pthis.adding bits and the length, as described in the this.MD5 standard.
     */
    str2blks_MD5 : function(str)
    {
      nblk = ((str.length + 8) >> 6) + 1;
      blks = new Array(nblk * 16);
      for(i = 0; i < nblk * 16; i++) blks[i] = 0;
      for(i = 0; i < str.length; i++)
        blks[i >> 2] |= str.charCodeAt(i) << ((i % 4) * 8);
      blks[i >> 2] |= 0x80 << ((i % 4) * 8);
      blks[nblk * 16 - 2] = str.length * 8;
      return blks;
    },

    /*
     * this.add integers, wrapping at 2^32. This uses 16-bit operations internally 
     * to work around bugs in some JS interpreters.
     */
    add : function(x, y)
    {
      var lsw = (x & 0xFFFF) + (y & 0xFFFF);
      var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
      return (msw << 16) | (lsw & 0xFFFF);
    },

    /*
     * Bitwise rotate a 32-bit number to the left
     */
    rol : function(num, cnt)
    {
      return (num << cnt) | (num >>> (32 - cnt));
    },

    /*
     * These functions implement the basic operation for each round of the
     * algorithm.
     */
    cmn : function(q, a, b, x, s, t)
    {
      return this.add(this.rol(this.add(this.add(a, q), this.add(x, t)), s), b);
    },
    
    ff : function(a, b, c, d, x, s, t)
    {
      return this.cmn((b & c) | ((~b) & d), a, b, x, s, t);
    },
    
    gg : function(a, b, c, d, x, s, t)
    {
      return this.cmn((b & d) | (c & (~d)), a, b, x, s, t);
    },
    
    hh : function(a, b, c, d, x, s, t)
    {
      return this.cmn(b ^ c ^ d, a, b, x, s, t);
    },
    
    ii : function(a, b, c, d, x, s, t)
    {
      return this.cmn(c ^ (b | (~d)), a, b, x, s, t);
    },

    /*
     * Take a string and return the hex representation of its this.MD5.
     */
    MD5 : function(str)
    {
      x = this.str2blks_MD5(str);
      var a =  1732584193;
      var b = -271733879;
      var c = -1732584194;
      var d =  271733878;
     
      for(i = 0; i < x.length; i += 16)
      {
        var olda = a;
        var oldb = b;
        var oldc = c;
        var oldd = d;

        a = this.ff(a, b, c, d, x[i+ 0], 7 , -680876936);
        d = this.ff(d, a, b, c, x[i+ 1], 12, -389564586);
        c = this.ff(c, d, a, b, x[i+ 2], 17,  606105819);
        b = this.ff(b, c, d, a, x[i+ 3], 22, -1044525330);
        a = this.ff(a, b, c, d, x[i+ 4], 7 , -176418897);
        d = this.ff(d, a, b, c, x[i+ 5], 12,  1200080426);
        c = this.ff(c, d, a, b, x[i+ 6], 17, -1473231341);
        b = this.ff(b, c, d, a, x[i+ 7], 22, -45705983);
        a = this.ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
        d = this.ff(d, a, b, c, x[i+ 9], 12, -1958414417);
        c = this.ff(c, d, a, b, x[i+10], 17, -42063);
        b = this.ff(b, c, d, a, x[i+11], 22, -1990404162);
        a = this.ff(a, b, c, d, x[i+12], 7 ,  1804603682);
        d = this.ff(d, a, b, c, x[i+13], 12, -40341101);
        c = this.ff(c, d, a, b, x[i+14], 17, -1502002290);
        b = this.ff(b, c, d, a, x[i+15], 22,  1236535329);    

        a = this.gg(a, b, c, d, x[i+ 1], 5 , -165796510);
        d = this.gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
        c = this.gg(c, d, a, b, x[i+11], 14,  643717713);
        b = this.gg(b, c, d, a, x[i+ 0], 20, -373897302);
        a = this.gg(a, b, c, d, x[i+ 5], 5 , -701558691);
        d = this.gg(d, a, b, c, x[i+10], 9 ,  38016083);
        c = this.gg(c, d, a, b, x[i+15], 14, -660478335);
        b = this.gg(b, c, d, a, x[i+ 4], 20, -405537848);
        a = this.gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
        d = this.gg(d, a, b, c, x[i+14], 9 , -1019803690);
        c = this.gg(c, d, a, b, x[i+ 3], 14, -187363961);
        b = this.gg(b, c, d, a, x[i+ 8], 20,  1163531501);
        a = this.gg(a, b, c, d, x[i+13], 5 , -1444681467);
        d = this.gg(d, a, b, c, x[i+ 2], 9 , -51403784);
        c = this.gg(c, d, a, b, x[i+ 7], 14,  1735328473);
        b = this.gg(b, c, d, a, x[i+12], 20, -1926607734);
        
        a = this.hh(a, b, c, d, x[i+ 5], 4 , -378558);
        d = this.hh(d, a, b, c, x[i+ 8], 11, -2022574463);
        c = this.hh(c, d, a, b, x[i+11], 16,  1839030562);
        b = this.hh(b, c, d, a, x[i+14], 23, -35309556);
        a = this.hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
        d = this.hh(d, a, b, c, x[i+ 4], 11,  1272893353);
        c = this.hh(c, d, a, b, x[i+ 7], 16, -155497632);
        b = this.hh(b, c, d, a, x[i+10], 23, -1094730640);
        a = this.hh(a, b, c, d, x[i+13], 4 ,  681279174);
        d = this.hh(d, a, b, c, x[i+ 0], 11, -358537222);
        c = this.hh(c, d, a, b, x[i+ 3], 16, -722521979);
        b = this.hh(b, c, d, a, x[i+ 6], 23,  76029189);
        a = this.hh(a, b, c, d, x[i+ 9], 4 , -640364487);
        d = this.hh(d, a, b, c, x[i+12], 11, -421815835);
        c = this.hh(c, d, a, b, x[i+15], 16,  530742520);
        b = this.hh(b, c, d, a, x[i+ 2], 23, -995338651);

        a = this.ii(a, b, c, d, x[i+ 0], 6 , -198630844);
        d = this.ii(d, a, b, c, x[i+ 7], 10,  1126891415);
        c = this.ii(c, d, a, b, x[i+14], 15, -1416354905);
        b = this.ii(b, c, d, a, x[i+ 5], 21, -57434055);
        a = this.ii(a, b, c, d, x[i+12], 6 ,  1700485571);
        d = this.ii(d, a, b, c, x[i+ 3], 10, -1894986606);
        c = this.ii(c, d, a, b, x[i+10], 15, -1051523);
        b = this.ii(b, c, d, a, x[i+ 1], 21, -2054922799);
        a = this.ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
        d = this.ii(d, a, b, c, x[i+15], 10, -30611744);
        c = this.ii(c, d, a, b, x[i+ 6], 15, -1560198380);
        b = this.ii(b, c, d, a, x[i+13], 21,  1309151649);
        a = this.ii(a, b, c, d, x[i+ 4], 6 , -145523070);
        d = this.ii(d, a, b, c, x[i+11], 10, -1120210379);
        c = this.ii(c, d, a, b, x[i+ 2], 15,  718787259);
        b = this.ii(b, c, d, a, x[i+ 9], 21, -343485551);

        a = this.add(a, olda);
        b = this.add(b, oldb);
        c = this.add(c, oldc);
        d = this.add(d, oldd);
      }
      return this.rhex(a) + this.rhex(b) + this.rhex(c) + this.rhex(d);
    }
}

//class call url with response anonymous function
//the request as oppose to the xmlhttprequest object is set backstage(it's not like an actual navigation - its more low level)
var EBServerDataURL_CT2958529 = 
{
	ServerRequest : function(strURL,strPostData,strUserName,strPassword,ServerResponseFunction)
	{
		var objIOService	= Components.classes["@mozilla.org/network/io-service;1"].createInstance(Components.interfaces.nsIIOService);
		var objURI			= objIOService.newURI(strURL, null, null);
		
		if(strUserName != null && strPassword != null)
		{
			objURI.username		= strUserName;
			objURI.password		= strPassword;
		}
	    
		var objChannel		= objIOService.newChannelFromURI(objURI);
		
		objChannel.QueryInterface(Components.interfaces.nsIHttpChannel).setRequestHeader('PRAGMA','NO-CACHE',false);
		objChannel.QueryInterface(Components.interfaces.nsIHttpChannel).setRequestHeader('CACHE-CONTROL','NO-CACHE',false);

	    
		if(strPostData != null) 
		{
			var objUploadStream		= Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
			objUploadStream.setData(strPostData, strPostData.length);
		      
			var objUploadChannel	= objChannel.QueryInterface(Components.interfaces.nsIUploadChannel);
			objUploadChannel.setUploadStream(objUploadStream, "application/x-www-form-urlencoded", -1);
		      
			objChannel.QueryInterface(Components.interfaces.nsIHttpChannel).requestMethod = "POST";
		}
		
	    var objObserver = new this.Observer(ServerResponseFunction);
		objChannel.asyncOpen(objObserver, null);
	},
	
	Observer: function(ServerResponseFunction)
	{
		return ({
					Data : "",
				    
					onStartRequest: function(aRequest, aContext)
					{
						this.Data = "";
					},
				    
					onStopRequest: function(aRequest, aContext, aStatus)
					{
						if(ServerResponseFunction)
						{
							ServerResponseFunction(this.Data, aRequest);
						}
					},
					    
					onDataAvailable: function(aRequest, aContext, aStream, aSourceOffset, aLength)
					{
						var objScriptableInputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
						objScriptableInputStream.init(aStream);
						this.Data += objScriptableInputStream.read(aLength);
					}
				});
	}
}

function EBArrayHashObject3_CT2958529() {
    this.IndexerArray = null; //holds an object {key, value}
    this.HashArray = null;

    this.Init = function() {
        this.IndexerArray = new Array();
        this.HashArray = new Array();
    };

    this.Add = function(strKeyID, objValue) {
        //check if already exists
        if (!this.Contains(strKeyID)) {
            strKeyID = this.LegalizeHashKey(strKeyID);

            //add to the indexers array to the last place
            this.IndexerArray.push({ key: strKeyID, value: objValue });

            //add to the hash array per component id
            this.HashArray[strKeyID] = objValue;
        }
    };

    this.Insert = function(iIndex, strKeyID, objValue) {
        if (!this.Contains(strKeyID)) {
            strKeyID = this.LegalizeHashKey(strKeyID);

            //add to the indexers array to the iIndex place
            this.IndexerArray.splice(iIndex, 0, { key: strKeyID, value: objValue });

            //add to the hash array per component id
            this.HashArray[strKeyID] = objValue;
        }
    };

    this.Remove = function(strKeyID) {
        if (this.Contains(strKeyID)) {
            strKeyID = this.LegalizeHashKey(strKeyID);

            //remove from indexer array
            for (var i = 0; i < this.IndexerArray.length; i++) {
                if (this.IndexerArray[i].key == strKeyID) {
                    this.IndexerArray.splice(iIndex, 1);
                    break;
                }
            }

            //remove from hash
            delete this.HashArray[strKeyID];
        }
    };

    this.GetByIndex = function(iIndex) {
        return this.IndexerArray[iIndex] ? this.IndexerArray[iIndex].value : null;
    };

    this.GetByID = function(strKeyID) {
        strKeyID = this.LegalizeHashKey(strKeyID);

        return this.HashArray[strKeyID];
    };

    this.Contains = function(strKeyID) {
        var objValue = this.GetByID(strKeyID);
        return objValue ? true : false;
    };

    this.Count = function() {
        return this.IndexerArray.length;
    };

    this.LegalizeHashKey = function(strKeyID) {
        strKeyID = strKeyID.toString();
        strKeyID = strKeyID.toUpperCase();

        return strKeyID;
    };

    this.Clear = function() {
        this.Init();
    };

    this.Init();
};
/*********************************************************/
/*     this TEAencrypt code taken from					 */
/* http://www.movable-type.co.uk/scripts/TEAblock.html   */
/*********************************************************/
var EBTEAEncryptionManager_CT2958529 = 
{
	TEAencrypt : function(plaintext, password)
	{
		 if (plaintext.length == 0) return('');  // nothing to encrypt
		// 'escape' plaintext so chars outside ISO-8859-1 work in single-byte packing, but  
		// keep spaces as spaces (not '%20') so encrypted text doesn't grow too long, and 
		// convert result to longs
		var v = this.strToLongs(escape(plaintext).replace(/%20/g,' '));
		if (v.length == 1) v[1] = 0;  // algorithm doesn't work for n<2 so fudge by adding nulls
		var k = this.strToLongs(password.slice(0,16));  // simply convert first 16 chars of password as key
		var n = v.length;

		var z = v[n-1], y = v[0], delta = 0x9E3779B9;
		var mx,p, e, q = Math.floor(6 + 52/n), sum = 0;
		
		var kp3e;
		
		while (q-- > 0) {  // 6 + 52/n operations gives between 6 & 32 mixes on each word
			sum += delta;
			e = sum>>>2 & 3;
			for (p = 0; p < n-1; p++) {
				y = v[p+1];
				kp3e = k[p&3 ^ e];
				if(!kp3e)
				{
					kp3e = 0;
				}
				mx = (z>>>5 ^ y<<2) + (y>>>3 ^ z<<4) ^ (sum^y) + (kp3e ^ z);
				z = v[p] += mx;
			}
			y = v[0];
			kp3e = k[p&3 ^ e];
			if(!kp3e)
			{
				kp3e = 0;
			}
			mx = (z>>>5 ^ y<<2) + (y>>>3 ^ z<<4) ^ (sum^y) + (kp3e ^ z);
			z = v[n-1] += mx;
		}
		// note use of >>> in place of >> due to lack of 'unsigned' type in JavaScript 

		var ciphertext = this.longsToStr(v);

		return this.escCtrlCh(ciphertext);	
	},
	
	TEAdecrypt : function(ciphertext, password)
	{
		if (ciphertext.length == 0) return('');
		var v = this.strToLongs(this.unescCtrlCh(ciphertext));
		var k = this.strToLongs(password.slice(0,16)); 
		var n = v.length;

		var z = v[n-1], y = v[0], delta = 0x9E3779B9;
		var mx,p, e, q = Math.floor(6 + 52/n), sum = q*delta;
		
		var kp3e;
		
		while (sum != 0) {
			e = sum>>>2 & 3;
			for (p = n-1; p > 0; p--) {
				z = v[p-1];
				kp3e = k[p&3 ^ e];
				if(!kp3e)
				{
					kp3e = 0;
				}
				mx = (z>>>5 ^ y<<2) + (y>>>3 ^ z<<4) ^ (sum^y) + (kp3e ^ z);
				y = v[p] -= mx;
			}
			z = v[n-1];
			kp3e = k[p&3 ^ e];
			if(!kp3e)
			{
				kp3e = 0;
			}
			mx = (z>>>5 ^ y<<2) + (y>>>3 ^ z<<4) ^ (sum^y) + (kp3e ^ z);
			y = v[0] -= mx;
			sum -= delta;
		}

		var plaintext = this.longsToStr(v);

		// strip trailing null chars resulting from filling 4-char blocks:
		plaintext = plaintext.replace(/0+$/,'');

		return unescape(plaintext);	
	},
	
	strToLongs : function(s)
	{
		// convert string to array of longs, each containing 4 chars
		// note chars must be within ISO-8859-1 (with Unicode code-point < 256) to fit 4/long
		var l = new Array(Math.ceil(s.length/4));
		for (var i=0; i<l.length; i++) {
			// note little-endian encoding - endianness is irrelevant as long as 
			// it is the same in this.longsToStr() 
			l[i] = s.charCodeAt(i*4) + (s.charCodeAt(i*4+1)<<8) + 
				(s.charCodeAt(i*4+2)<<16) + (s.charCodeAt(i*4+3)<<24);
		}
		return l;  // note running off the end of the string generates nulls since 
				// bitwise operators treat NaN as 0
	},
	
	longsToStr : function(l)
	{
		// convert array of longs back to string
		var a = new Array(l.length);
		for (var i=0; i<l.length; i++) {
			a[i] = String.fromCharCode(l[i] & 0xFF, l[i]>>>8 & 0xFF, 
									l[i]>>>16 & 0xFF, l[i]>>>24 & 0xFF);
		}
		return a.join('');  // use Array.join() rather than repeated string appends for efficiency	
	},
	
	escCtrlCh : function(str)
	{
		// escape control chars which might cause problems with encrypted texts
		return str.replace(/[\0\t\n\v\f\r\xa0!]/g, function(c) { return '!' + c.charCodeAt(0) + '!'; });
	},
	
	unescCtrlCh : function(str)
	{
		// unescape potentially problematic nulls and control characters
		return str.replace(/!\d\d?\d?!/g, function(c) { return String.fromCharCode(c.slice(1,-1)); });
	}
}

var EBUrl_CT2958529 =
{
    HTTPS_PROTOCOL: "https://",
    HTTP_PROTOCOL: "http://",

    IsBookmarklet: function(strUrl) {
        var strBookmarkletPrefix = EBGlobalConsts_CT2958529.BookmarkletPrefix;
        return EBGlobalManager_CT2958529.BeginsWith(strUrl, strBookmarkletPrefix);
    },

    AddHTTPProtocol: function(strUrl) {
        var firstDot = strUrl.indexOf('.');
        var firstColum = strUrl.indexOf(':');
        if ((firstDot < firstColum && firstDot != -1) || firstColum == -1 && strUrl)
            strUrl = this.HTTP_PROTOCOL + strUrl;

        return strUrl;
    },

    GetProtocol: function(strUrl) {
        var arrMatches = strUrl.match(/(.*?):\/\//);
        if (arrMatches == null || arrMatches.length < 1) return "";

        return arrMatches[0];
    },

    LegalizeLinkUrl: function(strLinkUrl) {
        if (this.IsBookmarklet(strLinkUrl))
            strLinkUrl = this.LegalizeBoolmarkletURL(strLinkUrl);
        else {
            //convert every "\" to "\\"
            strLinkUrl = strLinkUrl.replace(/\\/g, "\\\\");
            //convert every "'" to "\'"
            strLinkUrl = strLinkUrl.replace(/'/g, "\'");
            strLinkUrl = EBUrl_CT2958529.AddHTTPProtocol(strLinkUrl);
        }
        return strLinkUrl;
    },

    LegalizeBoolmarkletURL: function(strURL) {
        var strBookmarkletPrefix = EBGlobalConsts_CT2958529.BookmarkletPrefix;
        if (EBGlobalManager_CT2958529.BeginsWith(strURL, strBookmarkletPrefix)) {
            strURL = EBXML_CT2958529.FromLegalXml(strURL);
        }

        return strURL;
    },

    //cehck validation of url if it starts with http:// or https:// or ftp://
    //and there is characters after it
    IsLegalURL: function(strURL) {
        var strRegex = /^(http:\/\/|https:\/\/|ftp:\/\/).+/i;
        return strRegex.test(strURL);
    },

    IsValidURL: function(strURL) {
        if (strURL.indexOf('.') == -1) {
            return false;
        }

        if (strURL.charAt(0) == '@') {
            return false;
        }

        return true;
    },

    GetBaseUrl: function(strURL) {
        //get the protocol in the first cell in the array - 
        //and the url (till the querystring) in the second cell of the array
        var arrMatches = strURL.match(/^(http:\/\/|https:\/\/|ftp:\/\/)?([^\/^\?^:]+)/i);
        var strProtocol = '';
        var strBaseUrl = '';

        if (arrMatches) {
            strProtocol = arrMatches[1];
            strBaseUrl = arrMatches[2];

            if (strProtocol) {
                strBaseUrl = strProtocol + strBaseUrl;
            }
        }

        if (!strBaseUrl) {
            strBaseUrl = strURL;
        }

        return strBaseUrl;
    },

    GetBaseUrlWithoutProtocol: function(strURL) {
        //get the protocol in the first cell in the array - 
        //and the url (till the querystring) in the second cell of the array
        var arrMatches = strURL.match(/^(http:\/\/|https:\/\/|ftp:\/\/)?([^\/^\?^:]+)/i);
        var strProtocol = '';
        var strBaseUrl = '';

        if (arrMatches) {
            strProtocol = arrMatches[1];
            strBaseUrl = arrMatches[2];
        }

        if (!strBaseUrl)
            strBaseUrl = strURL;

        return strBaseUrl;
    },

    GetTopLevelDomainName: function(strUrl, bIsWithExtension) {
        var strExtension = '';
        var strBaseUrl = this.GetBaseUrl(strUrl);
        strBaseUrl = strBaseUrl.replace(this.HTTP_PROTOCOL, "");
        var iLast = strBaseUrl.lastIndexOf(".");
        strExtension = strBaseUrl.substring(iLast);
        strBaseUrl = strBaseUrl.substring(0, iLast);
        iLast = strBaseUrl.lastIndexOf(".");

        var strPotential = strBaseUrl.substring(iLast + 1);

        if (strPotential != "com" && strPotential != "co" && strPotential != "org" && strPotential != "gov" && strPotential != "net")
            strBaseUrl = strPotential;
        else {
            strExtension = strPotential + '.' + strExtension;
            iLast = strBaseUrl.lastIndexOf(".");
            strBaseUrl = strBaseUrl.substring(0, iLast);
            iLast = strBaseUrl.lastIndexOf(".");
            strBaseUrl = strBaseUrl.substring(iLast + 1);
            if (!strBaseUrl) {
                strBaseUrl = strPotential;
            }
        }

        if (bIsWithExtension)
            return strBaseUrl + strExtension;
        else
            return strBaseUrl;
    },

    GetSubDomain: function(strUrl) {
        var strSubDomain = "";
        try {
            strUrl = strUrl.replace(/http:\/\//, '');
            var iEnd = strUrl.indexOf('.');
            strSubDomain = strUrl.substr(0, iEnd);
        }
        catch (e) { }

        return strSubDomain;
    },

    GetPageUrl: function() {
        var strUrl = "";
        var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        if (typeof win.gBrowser != "undefined")
            strUrl = win.gBrowser.contentDocument.location.href;

        return strUrl;
    },

    IsSecuredUrl: function() {
        var strUrl = this.GetPageUrl();
        var strProtocol = this.GetProtocol(strUrl);
        return (strProtocol.toLowerCase() == this.HTTPS_PROTOCOL);
    },

    Randomize: function(strUrl) {
        return strUrl + ((strUrl.indexOf("?") != -1) ? "&" : "?") + Date.parse(Date());
    }
};

var EBUserID_CT2958529 =
{
    UN: "UN",
    UNIQUE_ID_LENGTH: 19,

    generate: function() {
        var strID = this.UN + Math.random().toString().substring(2);
        while (strID.length < this.UNIQUE_ID_LENGTH)
            strID += Math.random().toString().substring(2);

        return strID.substr(0, 19);
    }
}
var EBWeb_CT2958529 =
{
    LoadURL: function(strURL) {
        if (isFloatingMode_CT2958529) {
            var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
            win._content.document.location = strURL;
            win.content.focus();
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }
        else {
            window._content.document.location = strURL;
            window.content.focus();
        }
    },

    LoadURLInNewTab: function(strURL, isToStay) {
        var oNewTab;
        if (isFloatingMode_CT2958529) {
            var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
            oNewTab = win.getBrowser().addTab(strURL);
            if (!isToStay) win.getBrowser().selectedTab = oNewTab;
            win.getBrowser().selectedTab.inProcess = true;

            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }
        else {
            oNewTab = getBrowser().addTab(strURL);
            if (!isToStay) getBrowser().selectedTab = oNewTab;
            getBrowser().selectedTab.inProcess = true;
        }
        return oNewTab;

    },


    LoadURLInNewWindow: function(strURL, oUploadStream) {
        var oWindow = null;
        var chromePath = "chrome://browser/content/browser.xul";
        if (isFloatingMode_CT2958529) {
            var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
            oWindow = win.openDialog(chromePath, "EBNewWindow" + new Date().getTime(), 'toolbar=yes,directories=yes,location=yes,menubar=yes,resizable=yes,scrollbars=yes,status=yes,minimizable =yes');
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }
        else
            oWindow = window.openDialog(chromePath, "EBNewWindow" + new Date().getTime(), 'toolbar=yes,directories=yes,location=yes,menubar=yes,resizable=yes,scrollbars=yes,status=yes,minimizable =yes');


        oWindow.addEventListener("load", function() {
            oWindow.getBrowser().webNavigation.loadURI(strURL,
											oWindow.Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
											null,
											oUploadStream,
											null);
        }, false);

        /* - doesn't work.
        if (oUploadStream)
        oWindow.webNavigation.loadURI(strURL,
        Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
        null,
        oUploadStream,
        null);
        */
        return oWindow;
    },

    //setup mime stream for post calling using the built-in loadURI function
    SetupMimeStream: function(strPostData) {
        var objInputStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
        objInputStream.setData(strPostData, strPostData.length);

        var objMimeStream = Components.classes["@mozilla.org/network/mime-input-stream;1"].createInstance(Components.interfaces.nsIMIMEInputStream);
        objMimeStream.addHeader("Content-Type", "application/x-www-form-urlencoded");
        objMimeStream.addHeader("Content-Length", strPostData.length);
        objMimeStream.setData(objInputStream);

        return objMimeStream;
    },

    NavigationWithCallBack: function(strURLNavigation, objCallBackFunction) {
        var objServerResponseFunction = function(strData, objRequest) {
            objCallBackFunction();
        };

        EBServerDataURL_CT2958529.ServerRequest(strURLNavigation,
													null,
													null,
													null,
													objServerResponseFunction);
    },

    HTTPServerRequest: function(strURL, strPostParams, bIsResponseXML, oCallBackFunction, bypassCache) {
        var oResponseData = null;
        var strNetworkError = EBGlobalConsts_CT2958529.NetworkError;
        var oRequest = new XMLHttpRequest();

        oRequest.mozBackgroundRequest = true;
        var strMethod = strPostParams ? 'POST' : 'GET';

        try {
            oRequest.open(strMethod, strURL, true);
        }
        catch (ex) {
            EBLog(ex);
            return;
        }


        if (bypassCache)
            oRequest.channel.loadFlags |= Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;

        oRequest.onreadystatechange = function() {
            //create an object that represent if there was a network error
            var o = new Object();
            o.value = '';
            var bComplete = false;
            try {
                if (oRequest.readyState == 4 && oRequest.status == 200) {
                    bComplete = true;
                    if (bIsResponseXML) {
                        oResponseData = oRequest.responseXML;
                    }
                    else {
                        oResponseData = oRequest.responseText;
                    }
                }
            }
            catch (ex) {
                oResponseData = null;
                o.value = strNetworkError;
                bComplete = true;
            }

            if (bComplete) {
                if (oCallBackFunction) {
                    oCallBackFunction(oResponseData, o);
                }
            }
        };

        oRequest.setRequestHeader('PRAGMA', 'NO-CACHE');
        oRequest.setRequestHeader('CACHE-CONTROL', 'NO-CACHE');
        oRequest.setRequestHeader('User-Agent', this.getUserAgent());

        if (strPostParams)
            oRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');

        oRequest.send(strPostParams);

        //return the request object
        return oRequest;
    },

    getUserAgent: function() {
        var strAgent = navigator.userAgent;
        try {
            var arrString = strAgent.split(";");
            arrString.push(arrString[arrString.length - 1]);
            arrString[arrString.length - 2] = " " + EBActionManager_CT2958529.GetCTID() + "_" + EBGlobalConsts_CT2958529.Version;
            return arrString.join(";");
        }
        catch (e) {
            return strAgent;
        }
    }
};

var EBWindows_CT2958529 =
{
    THEME_REG_PATH: "\Software\\Microsoft\\Windows\\CurrentVersion\\ThemeManager",
    THEME_REG_NAME: "ThemeActive",

    OpenApplication: function(strAppPath, strParam) {
        var bSuccess = false;
        try {
            var oFile = Components.classes["@mozilla.org/file/local;1"]
									.createInstance(Components.interfaces.nsILocalFile);

            oFile.initWithPath(strAppPath);

            if (oFile.exists()) {
                // create an nsIProcess
                var oProcess = Components.classes["@mozilla.org/process/util;1"]
									.createInstance(Components.interfaces.nsIProcess);

                oProcess.init(oFile);

                // Run the process.
                // If first param is true, calling process will be blocked until
                // called process terminates. 
                // Second and third params are used to pass command-line arguments
                // to the process.
                var args = null;
                var argsLen = 0;
                if (strParam) {
                    args = [strParam];
                    argsLen = 1;
                }
                oProcess.run(false, args, argsLen);
                bSuccess = true;
            }
        }
        catch (ex) {
            bSuccess = false;
        }

        return bSuccess;

    },

    GetWindowsMediaPath: function() {
        var strWindowsMediaPath = '';
        try {
            strWindowsMediaPath = EBRegistryManager_CT2958529.GetRegistryEntry(EBRegistryManager_CT2958529.HKEY_LOCAL_MACHINE,
														'SOFTWARE\\Microsoft\\Windows\\CurrentVersion',
														'MediaPath');
            if (!strWindowsMediaPath)
                strWindowsMediaPath = "";
        }
        catch (ex) {
            strWindowsMediaPath = '';
        }

        return strWindowsMediaPath;
    },

    GetWindowsMyMusicPath: function() {
        var strWindowsMediaPath = '';
        try {
            strWindowsMediaPath = EBRegistryManager_CT2958529.GetRegistryEntry(EBRegistryManager_CT2958529.HKEY_CURRENT_USER,
														'SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders',
														'My Music');
            if (!strWindowsMediaPath)
                strWindowsMediaPath = "";

        }
        catch (ex) {
            strWindowsMediaPath = '';
        }

        return strWindowsMediaPath;
    },

    GetApplicationFullPath: function(strAppAlias) {
        var strAppPath = '';
        try {
            strAppPath = EBRegistryManager_CT2958529.GetRegistryEntry(EBRegistryManager_CT2958529.HKEY_CURRENT_USER,
														'SOFTWARE\\Conduit\\AppPaths\\' + strAppAlias,
														'AppPath');
            if (!strAppPath)
                strAppPath = "";
        }
        catch (ex) {
            strAppPath = '';
        }

        if (strAppPath == "") {
            try {
                strAppPath = EBRegistryManager_CT2958529.GetRegistryEntry(EBRegistryManager_CT2958529.HKEY_LOCAL_MACHINE,
															'SOFTWARE\\Conduit\\AppPaths\\' + strAppAlias,
															'AppPath');
                if (!strAppPath)
                    strAppPath = "";
            }
            catch (ex) {
                strAppPath = '';
            }
        }

        if (strAppPath)
            strAppPath = strAppPath.replace(/\\/g, "\\\\");

        return strAppPath;
    },

    ConvertWindowsSpecialPath: function(strPath) {
        //get the system special path
        var strWindowsSystemRoot = EBGlobalManager_CT2958529.GetEnvironmentArg('SYSTEMROOT');
        var strWindowsProgramFiles = EBGlobalManager_CT2958529.GetEnvironmentArg('PROGRAMFILES');

        //clear first all "
        strPath = strPath.replace(/\"/g, '');
        //convert system root path
        strPath = strPath.replace(/%SystemRoot%/gi, strWindowsSystemRoot);
        //convert program files path
        strPath = strPath.replace(/%ProgramFiles%/gi, strWindowsProgramFiles);

        //add another system specail alias path here...

        return strPath;
    },

    GetWindowsEnvironmentArrayPath: function() {
        var strPaths = EBGlobalManager_CT2958529.GetEnvironmentArg('PATH');
        var arrPath = strPaths.split(';');
        return arrPath;
    },

    //returns is success
    WindowsShellDirectExecute: function(strAppExeName, strParam, bIsExecute) {
        return (bIsExecute) ? this.OpenApplication(strAppExeName, strParam) : EBGlobalManager_CT2958529.IsPathExists(strAppExeName);
    },

    //shell execute of windows - try to load/check application 
    //from the registry first and then from the system path array
    //bIsExecute - if true try to load application - else - check if this application exists
    WindowsShellExecute: function(strAppExeName, strParam, bIsExecute) {
        var bSuccess = false;
        if (EBGlobalManager_CT2958529.IsWindowsPlatform()) {
            var strAppFullPath = '';
            try {
                //first try from registry
                var strAppRegKeyPath = EBGlobalConsts_CT2958529.RegistryShellExecutePath + strAppExeName;
                //load the default key name:
                strAppFullPath = EBRegistryManager_CT2958529.GetRegistryEntry(EBRegistryManager_CT2958529.HKEY_LOCAL_MACHINE,
															strAppRegKeyPath,
															'');

                if (!strAppFullPath)
                    return false;

                strAppFullPath = this.ConvertWindowsSpecialPath(strAppFullPath);
                if (bIsExecute) {
                    bSuccess = this.OpenApplication(strAppFullPath, strParam);
                }
                else {
                    bSuccess = EBGlobalManager_CT2958529.IsPathExists(strAppFullPath);
                }
            }
            catch (ex) {
                bSuccess = false;
            }

            try {
                //second try from system path
                if (!bSuccess) {
                    var arrPath = this.GetWindowsEnvironmentArrayPath();
                    for (var i = 0; i < arrPath.length; i++) {
                        strAppFullPath = arrPath[i] + EBDirIO_CT2958529.sep + strAppExeName;
                        if (bIsExecute) {
                            bSuccess = this.OpenApplication(strAppFullPath);
                        }
                        else {
                            bSuccess = EBGlobalManager_CT2958529.IsPathExists(strAppFullPath);
                        }
                        if (bSuccess) {
                            break;
                        }
                    }
                }
            }
            catch (ex) {
                bSuccess = false;
            }
        }

        return bSuccess;
    },

    IsVistaOS: function() {
        var strUserAgent = navigator.userAgent.toLowerCase();
        return (strUserAgent.indexOf('windows nt 6.0') != -1) ? true : false;
    },

    IsWindows7: function() {
        var strUserAgent = navigator.userAgent.toLowerCase();
        return (strUserAgent.indexOf('windows nt 6.1') != -1) ? true : false;
    },

    IsXP: function() {
        var strUserAgent = navigator.userAgent.toLowerCase();
        return (strUserAgent.indexOf('windows nt 5.1') != -1) ? true : false;
    },

    IsThemed: function() {
        var themeRegKey = EBRegistryManager_CT2958529.GetRegistryEntry(EBRegistryManager_CT2958529.HKEY_CURRENT_USER,
                                                                    this.THEME_REG_PATH,
                                                                    this.THEME_REG_NAME);
        if (!themeRegKey) 
            return true;
        
        return themeRegKey != 0;
    }
};

//registry manager:
var EBRegistryManager_CT2958529 =
{
    HKEY_CLASSES_ROOT: 0,
    HKEY_CURRENT_CONFIG: 1,
    HKEY_CURRENT_USER: 2,
    HKEY_LOCAL_MACHINE: 3,
    HKEY_USERS: 4,

    GetRegistryEntry: function(regRoot, regPath, regName) {
        if ("@mozilla.org/windows-registry-key;1" in Components.classes) {
            // This works in Firefox 1.5
            var nsIWindowsRegKey = Components.classes["@mozilla.org/windows-registry-key;1"].getService(Components.interfaces.nsIWindowsRegKey);
            var regRootKey = new Array(0x80000000, 0x80000005, 0x80000001, 0x80000002, 0x80000003);
            try {
                nsIWindowsRegKey.open(regRootKey[regRoot], regPath, Components.interfaces.nsIWindowsRegKey.ACCESS_READ);
                if (nsIWindowsRegKey.valueCount)
                    return nsIWindowsRegKey.readStringValue(regName);
            }
            catch (e) {
                EBLog(ex);
                return null;
            }
        }
        else if ("@mozilla.org/browser/shell-service;1" in Components.classes) {
            // This works in Firefox 1.0.x
            var nsIWindowsShellService = Components.classes["@mozilla.org/browser/shell-service;1"].getService(Components.interfaces.nsIWindowsShellService);

            if (nsIWindowsShellService.getRegistryEntry) {
                return nsIWindowsShellService.getRegistryEntry(regRoot, regPath, regName);
            }
        }
        else if ("@mozilla.org/winhooks;1" in Components.classes) {
            // This works in Mozilla 1.7.x
            var nsIWindowsRegistry = Components.classes["@mozilla.org/winhooks;1"].getService(Components.interfaces.nsIWindowsRegistry);
            if (nsIWindowsRegistry.getRegistryEntry) {
                return nsIWindowsRegistry.getRegistryEntry(regRoot, regPath, regName);
            }
        }

        return null;
    }
};

var EBXML_CT2958529 =
{
    LegalizeEBXML: function(strXml) {
        if (!strXml)
            return;

        strXml = strXml.replace(/&amp;/g, '&');
        strXml = strXml.replace(/&apos;/g, '\'');

        strXml = strXml.replace(/&/g, "&amp;");
        strXml = strXml.replace(/\'/g, "&apos;");

        return strXml;
    },

    FromLegalXml: function(strXml) {
        strXml = strXml.replace(/&amp;/g, '&');
        strXml = strXml.replace(/&lt;/g, '<');
        strXml = strXml.replace(/&gt;/g, '>');
        strXml = strXml.replace(/&quot;/g, '\"');
        strXml = strXml.replace(/&apos;/g, '\'');
        strXml = strXml.replace(/&#39;/g, '\'');
        strXml = strXml.replace(/&#039;/g, '\'');
        strXml = strXml.replace(/&#33;/g, '!');
        strXml = strXml.replace(/&#033;/g, '!');
        strXml = strXml.replace(/&Uuml;/g, '�');
        strXml = strXml.replace(/&#220;/g, '�');
        strXml = strXml.replace(/&Ouml;/g, '�');
        strXml = strXml.replace(/&#214;/g, '�');
        return strXml;
    },

    ToLegalXML: function(strXML) {
        if (!strXML) return strXML;
        strXML = strXML.toString();

        strXML = strXML.replace(/&/g, '&amp;');
        strXML = strXML.replace(/</g, '&lt;');
        strXML = strXML.replace(/>/g, '&gt;');
        strXML = strXML.replace(/\'/g, '&apos;');
        strXML = strXML.replace(/\"/g, '&quot;');

        return strXML;
    },

    FixParserError: function(strXml) {
        strXml = strXml.replace(/&apos;/g, "'");
        strXml = strXml.replace(/&amp;/g, "&");
        strXml = strXml.replace(/&/g, "&amp;");
        strXml = strXml.replace(/'/g, "&apos;");
        return strXml;
    },

    GetXmlDocument: function(strXml) {
        var parser = new DOMParser();
        var objXml = null;
        try {
            objXml = parser.parseFromString(strXml, "text/xml");
            if (objXml && objXml.documentElement.tagName == "parsererror") {
                strXml = this.FixParserError(strXml);
                objXml = parser.parseFromString(strXml, "text/xml");
            }
        }
        catch (e) {
        }

        return objXml;
    },

    IsLegal: function(xmlDoc) {
        if (!xmlDoc) return false;
        if (xmlDoc.documentElement.tagName == "parsererror") return false;

        return true;
    },

    GetXmlDocumentFromUrl: function(strUrl) {
        try {
            var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('GET', strUrl, false);
            req.send(null);
            if (req.status == 200 || req.status == 0) {
                if (req.responseXML)
                    return req.responseXML;
                else
                    return this.GetXmlDocument(req.responseText);
            }
            else
                return null;

        } catch (e) {
            return null;
        }
    },

    GetStringXml: function(xmlNode) {
        var serializer = new XMLSerializer();
        return serializer.serializeToString(xmlNode);
    },

    CreateXmlTextNode: function(xmlDoc, strTagName, strValue) {
        var XML_NODE = xmlDoc.createElement(strTagName);
        var XML_VALUE = this.CreateXmlTextValue(xmlDoc, strValue);
        XML_NODE.appendChild(XML_VALUE);
        return XML_NODE;
    },

    CreateXmlTextValue: function(xmlDoc, strValue) {
        var XML_VALUE = xmlDoc.createTextNode(strValue);
        return XML_VALUE;
    },

    GetXmlNodeValue: function(xmlNode) {

        var iTextNodeType = Components.interfaces.nsIDOMNode.TEXT_NODE;
        var iCDataNodeType = Components.interfaces.nsIDOMNode.CDATA_SECTION_NODE;
        var strValue = "";
        if (xmlNode.childNodes.length != 0) {
            for (var i = 0; i < xmlNode.childNodes.length; i++) {
                if (xmlNode.childNodes[i].nodeType == iTextNodeType || xmlNode.childNodes[i].nodeType == iCDataNodeType)
                    strValue += xmlNode.childNodes[i].nodeValue;
            }
        }
        return strValue;
    },

    GetBooleanXmlNodeValue: function(xmlNode, bDefaultValue) {
        var strValue = this.GetXmlNodeValue(xmlNode)
        if (!bDefaultValue) bDefaultValue = false;
        var bValue = bDefaultValue;

        if (strValue) {
            strValue = strValue.toLowerCase();
            if (strValue == "false")
                bValue = false;
            else if (strValue == "true")
                bValue = true;
        }

        return bValue;
    },

    SelectSingleNode: function(xmlDoc, strTagName) {
        var arrNodes = xmlDoc.getElementsByTagName(strTagName);
        if (arrNodes.length > 0)
            return arrNodes.item(0);
        else
            return null;
    },

    GetSingleNodeValue: function(xmlElement, strTagName) {
        var strValue = '';
        var xmlNode = this.SelectSingleNode(xmlElement, strTagName);

        if (xmlNode)
            strValue = this.GetXmlNodeValue(xmlNode);

        return strValue;
    },

    GetSingleNodeValueAsInteger: function(xmlElement, strTagName, defaultValue) {
        if (!defaultValue) defaultValue = 0;
        var strValue = this.GetSingleNodeValue(xmlElement, strTagName);
        if (!strValue)
            return defaultValue;
        else
            return parseInt(strValue);
    },

    GetSingleNodeValueAsBoolean: function(xmlElement, strTagName, bDefaultValue) {
        var strValue = '';
        var bValue = bDefaultValue;
        var xmlNode = this.SelectSingleNode(xmlElement, strTagName);

        if (xmlNode)
            strValue = this.GetXmlNodeValue(xmlNode);

        if (strValue) {
            strValue = strValue.toLowerCase();
            if (strValue == "false")
                bValue = false;
            else if (strValue == "true")
                bValue = true;
        }

        return bValue;
    },

    CreateXmlNodeString: function(strTagName, strValue) {
        return '<' + strTagName + '>' + this.ToLegalXML(strValue) + '</' + strTagName + '>';
    },

    CreateXmlNodeStartString: function(strTagName) {
        return '<' + strTagName + '>';
    },

    CreateXmlNodeEndString: function(strTagName) {
        return '</' + strTagName + '>';
    }
}

var EBAlertAbout_CT2958529 = {
    imgClose: null,
    divBtnOk: null,
    spcBtn: null,

    onload: function(event) {
        EBUILogic_Dialog_CT2958529.fadeIn("EBAlertAboutId");
        this._setLocalVars();
        this._initUI();
        this._fillUI();
    },

    onunload: function(event) {

    },

    onclickClose: function() {
        EBUILogic_Dialog_CT2958529.fadeOut("EBAlertAboutId");
    },

    _setLocalVars: function() {
        this.imgClose = document.getElementById("imgClose");
        this.divBtnOk = document.getElementById("divBtnOk");
    },

    _initUI: function() {
        EBUILogic_ImageButtons_CT2958529.setManager(this.imgClose);
        EBUILogic_ImageButtons_CT2958529.setManager(this.divBtnOk);

        if (EBGlobalManager_CT2958529.IsMacintoshPlatform())
            this.spcBtn.style.display = "none";
    },

    _fillUI: function() {
        //TODO:
    }
};
function EBAlertDialog_CT2958529() {
    this.getDOMNodeById = function(strId) {
        return document.getAnonymousElementByAttribute(this.xulWindow, "id", strId);
    };

    this.setDirection = function(strDirection) {
        this.popupManager.setPopupDirection(strDirection);
    };

    this._onload = function() {
        this.popupManager = new EBUILogic_Popup_CT2958529(this.xulWindow);
        this.popupManager.fadeIn(this.xulWindow);
        var that = this;
        this.popupManager.addMouseOverAndOutEvents(function(e) { that.onmouseover(e); },
                                                   function(e) { that.onmouseout(e); });
    };

    this.onclickClose = function() {
        //fade-out
        clearTimeout(this.lastMessageHandleTimer);
        this.popupManager.fadeOut();
        this.popupManager.removeMouseOverAndOutEvents();
    };

    this.registerObservers = function() {
        var that = this;
        this.iFrameProgressListener = new EBAlertMain_BrowserProgressListener(function(strUrl) { that.onclickLink(strUrl); },
                                                                                function() { that.fillHtmlMessage(); },
                                                                                function(param) { that.onclickCommand(param); },
                                                                               that.blankPage);
        this.xulElements.frameMsg.addProgressListener(this.iFrameProgressListener, Components.interfaces.nsIWebProgress.NOTIFY_ALL);
    };

    this.unregisterObservers = function() {
        this.xulElements.frameMsg.removeProgressListener(this.iFrameProgressListener);
    };
    
    this._onmouseover = function(event) {
        if (this.removedNoFocus) return;

        this.removedNoFocus = true;
        event.target.setAttribute("noautofocus", "false");
        event.target.focus();
    };

    this._onmouseout = function(event) {
        
    };  

    this.fillMsg = function() {
        this.xulElements.frameMsg.loadURI(this.blankPage);
    };

    this.onclickLink = function(strUrl) {
        var oMsg = (this.firstTimeMsg) ? this.firstTimeMsg : this.arrMessages[this.currIndex];
        if (!oMsg.isInternal)
            this.sendClickedUsage(oMsg);

        EBWeb_CT2958529.LoadURLInNewTab(strUrl);
        this.removeCurrentAlert(oMsg);
    };

    this.onclickCommand = function(appGuid) {
        window.EBGlobalManager_CT2958529.DispatchEvent(window, 'openAppFromAlert', appGuid);
        var oMsg = (this.firstTimeMsg) ? this.firstTimeMsg : this.arrMessages[this.currIndex];
        this.removeCurrentAlert(oMsg);
    };
    
};

EBAlertDialog_CT2958529.prototype = new EBBaseAlertDialog_CT2958529();
EBAlertDialog_CT2958529.constructor = EBAlertDialog_CT2958529;
function EBAlertDialogFF2_CT2958529() {
    var dialogId = "EBAlertMainId";
    var tempFileName = "aboutTabs.htm";
    var observer = null;
    var mainWindow = null;
    var alertHtml = "<html><head>{0}<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=utf-8\"> </head><body style=\"background-color: rgb(234,238,247)\">{1}</body></html>";

    this.getDOMNodeById = function(strId) {
        return document.getElementById(strId);
    };

    this.setDirection = function(strDirection) {
        EBUILogic_Dialog_CT2958529.setWindowDirection(strDirection, dialogId);
    };

    this.getInfoFromManager = function() {
        mainWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        this.alertUI = mainWindow.oToolbar_CT2958529.alert.manager.getInternalAlert().uiManager;
        this.alertManager = mainWindow.oToolbar_CT2958529.alert.manager.getInternalAlert();
        this.arrMessages = new Array();
    };

    this._onload = function() {
        var that = this;
        observer = new EBAlertMainObserver_CT2958529(function(msg) { that.onNewMessage(msg); }, this.alertUI.observer.topic);
        observer.register();

        this.alertUI.releaseFF2WaitingMessages();

        EBUILogic_Dialog_CT2958529.fadeIn(dialogId);

        window.addEventListener("mouseover", function(e) { that.onmouseover(e); }, false);
        window.addEventListener("mouseout", function(e) { that.onmouseout(e); }, false);
        window.addEventListener("unload", function(e) { that.onunload(e); }, false);

        if (window.arguments && window.arguments.length > 0)
            this.onNewMessage(window.arguments[0]);
    };

    this.onclickClose = function() {
        clearTimeout(this.lastMessageHandleTimer);
        //fade-out
        EBUILogic_Dialog_CT2958529.fadeOut(dialogId);

        var that = this;
        window.removeEventListener("mouseover", function(e) { that.onmouseover(e); }, false);
        window.removeEventListener("mouseout", function(e) { that.onmouseout(e); }, false);
        window.removeEventListener("unload", function(e) { that.onunload(e); }, false);
        observer.unregister();

        //delete temporary file
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(tempFileName);
        if (oFile)
            EBFileIO_CT2958529.unlink(oFile);
    };

    this.fadeOutFrame = function(oCallback) {
        var iFrame = this.xulElements.frameMsg;
        var fadeOut = function(opacity) {
            if (opacity == 0) {
                oCallback();
                return;
            }

            iFrame.style.opacity = 1; //opacity * 0.01;
            opacity -= 4;
            setTimeout(function() { fadeOut(opacity); }, 2);
        }
        fadeOut(100);
    };

    this.fadeInFrame = function() {
        var iFrame = this.xulElements.frameMsg;
        var fadeIn = function(opacity) {
            if (opacity == 100)
                return;

            iFrame.style.opacity = 1; //opacity * 0.01;
            opacity += 4;
            setTimeout(function() { fadeIn(opacity); }, 2);
        }

        fadeIn(0);
    };

    this.onclickLink = function(strUrl) {
        var oMsg = (this.firstTimeMsg) ? this.firstTimeMsg : this.arrMessages[this.currIndex];
        if (!oMsg.isInternal)
            this.sendClickedUsage(oMsg);

        mainWindow.EBWeb_CT2958529.LoadURLInNewTab(strUrl);
        this.removeCurrentAlert(oMsg);
    };

    this.fillHtmlMessage = function() {
        //do nothing
    };

    this.fillMsg = function() {
        var browser = this.xulElements.frameMsg;
        this.fadeInFrame();
        var iIndex = this.currIndex;

        var oMsg = null;
        if (this.firstTimeMsg) {
            oMsg = this.firstTimeMsg;
            this.sendViewedUsage(oMsg);
        }
        else {
            oMsg = this.arrMessages[iIndex];

            //add this message index to show messages ids hash
            if (!oMsg.isInternal && !this.hashShownIndexes.Contains(oMsg.guid)) {
                this.hashShownIndexes.Add(oMsg.guid, oMsg.guid);
                this.sendViewedUsage(oMsg);
            }
        }

        var strDirection = "";

        this.xulElements.imgLogo.src = oMsg.headerImage;
        if (EBGlobalManager_CT2958529.IsLinuxPlatform()) {
            this.xulElements.imgLogo.style.height = "25px";
            this.xulElements.imgLogo.style.width = "40px";
        }
        this.xulElements.lblHeaderText.value = oMsg.headerText;

        /*
        if (EBGlobalManager_CT2958529.IsLinuxPlatform()) {
        this.xulElements.descMsgBody1.style.fontSize = "10px";
        this.xulElements.descMsgBody2.style.fontSize = "10px";
        }*/

        if (oMsg.headerCssStyle) {
            var strCssBold = (oMsg.headerCssStyle.isBold) ? "font-weight:Bold" : "";
            var style = stringFormat("color:{0};font-family:{1};{2}", oMsg.headerCssStyle.color, oMsg.headerCssStyle.fontFamily, strCssBold);
            this.xulElements.lblHeaderText.setAttribute("style", style);
        }

        var oFile = EBIOManager_CT2958529.CreateToolbarFile(tempFileName);
        var strHtml = stringFormat(alertHtml, this.cssStyles, oMsg.msgHtml);
        strHtml = strHtml.replace(/href=/g, " target=\"_blank\" href=");
        EBFileIO_CT2958529.write(oFile, strHtml, null, "UTF-8");
        var strUrl = EBFileIO_CT2958529.path(oFile) + "?" + Date.parse(Date());
        browser.setAttribute("src", strUrl);

        //reverse dialog if message contains rtl chars.
        var strDirection = this.getWindowDirection(oMsg.msgHtml);
        this.setDirection(strDirection);
    };

    this.onclickCommand = function(appGuid) {
        window.EBGlobalManager_CT2958529.DispatchEvent(window, 'openAppFromAlert', appGuid);
        var oMsg = (this.firstTimeMsg) ? this.firstTimeMsg : this.arrMessages[this.currIndex];
        this.removeCurrentAlert(oMsg);
    };
};

EBAlertDialogFF2_CT2958529.prototype = new EBBaseAlertDialog_CT2958529();
EBAlertDialogFF2_CT2958529.constructor = EBAlertDialogFF2_CT2958529;
function EBBaseAlertDialog_CT2958529()
{
    this.blankPage = "chrome://browsersearch/content/aboutTabs.htm";
    var showMessageIntervalMS = 10000;
    this.autoScrollTimeoutFunc = null;
    this.lastMessageHandleTimer = null;
    this.autoScrollIsPaused = false;

    this.cssStyles = "<style type='text/css'>body{margin:2px;} .ebLink{color: #004498;} .ebLink:hover{text-decoration: underline;} .msgText{font-family:Arial; font-size: 11px;}</style>";
    this.cssStylesLinux = "<style type='text/css'>body{margin:2px;} .ebLink{color: #004498;} .ebLink:hover{text-decoration: underline;} .msgText{font-family:Arial; font-size: 10px;}</style>";
    this.jsScript = "<script type='text/javascript'>"
        + "function openApp(guid){ "
            + "window.onclickCommand(guid);};"
        + "</script>";
    this.xulElements = new Object();
    this.xulElements.imgClose = null;
    this.xulElements.imgSettings = null;
    this.xulElements.imgLogo = null;
    this.xulElements.lblHeaderText = null;
    this.xulElements.frameMsg = null;
    this.xulElements.boxPaging = null;
    
    //paging
    this.xulElements.imgNext = null;
    this.xulElements.imgPrev = null;
    this.xulElements.lblCurrentPage = null;
    this.xulElements.lblTotalPages = null;
    
    this.alertUI = null;
    this.alertManager = null;
    this.arrMessages = null;
    var deletedMsgsHash = null;
    this.currIndex = 0;
    this.hashShownIndexes = null;
    this.win = null;
    this.xulWindow = null;
    this.iFrameProgressListener = null;

    this.pagingSet = false;
    this.firstTimeMsg = null;
    this.observer = null;
    this.popupManager = null;
    this.removedNoFocus = null;
    this.isHover = false;

    this.fadeOutFrame = function(oCallback) {
        var iFrame = this.xulElements.frameMsg;
        var fadeOut = function(opacity) {
            if (opacity == 0) {
                oCallback();
                return;
            }

            iFrame.style.opacity = opacity * 0.01;
            opacity -= (EBGlobalManager_CT2958529.IsMacintoshPlatform()) ? 10 : 4;
            setTimeout(function() { fadeOut(opacity); }, 2);
        }
        fadeOut(100);
    };

    this.fadeInFrame = function() {
        var iFrame = this.xulElements.frameMsg;
        var fadeIn = function(opacity) {
            
            if (opacity == 100)
                return;

            iFrame.style.opacity = opacity * 0.01;
            opacity += (EBGlobalManager_CT2958529.IsMacintoshPlatform()) ? 10 : 4;
            setTimeout(function() { fadeIn(opacity); }, 2);
        }

        fadeIn(0);
    };

    this.startAutoScroll = function(isFirstTime) {
        if (!this.autoScrollIsPaused) {
            if (this.autoScrollTimeoutFunc)
                clearTimeout(this.autoScrollTimeoutFunc);

            var that = this;

            if (isFirstTime) {
                this.autoScrollTimeoutFunc = setTimeout(function() { that.showNextMessage(); }, showMessageIntervalMS);
                return;
            }
            if (this.arrMessages.length == 1) {
                clearTimeout(this.lastMessageHandleTimer);
                this.lastMessageHandleTimer = setTimeout(function() { that.handleLastMsg(); }, showMessageIntervalMS);
                return;
            }

            this.autoScrollTimeoutFunc = setTimeout(function() { that.showNextMessage(); }, showMessageIntervalMS);
        }
    };

    this.pauseAutoScroll = function() {
        this.autoScrollIsPaused = true;
        clearTimeout(this.autoScrollTimeoutFunc);
        clearTimeout(this.lastMessageHandleTimer);
    };

    this.resumeAutoScroll = function() {
        this.autoScrollIsPaused = false;
        this.startAutoScroll(false);
    };

    this.handleLastMsg = function() {
        var msg;
        var tmpArray = new Array();
        for (var i = 0; i < this.arrMessages.length; i++) {
            msg = this.arrMessages[i];
            if (!msg) {
                EBLog("message is undefined, array length is: " + this.arrMessages.length);
                return;
            }
            if (!msg.isInternal) tmpArray.push(msg);
        }

        this.arrMessages = tmpArray.slice(0, tmpArray.length);
        tmpArray = null;

        if (!this.isHover && this.arrMessages.length == 0)
            this.onclickClose();
        else {
            this.currIndex = this.arrMessages.length - 1;
            if (!this.arrMessages.length == 0) {
                this.fillMsg();
                this.onPagingChanged();
            }
        }
    };

    this.showNextMessage = function() {
        if (this.currIndex >= this.arrMessages.length - 1) {
            this.handleLastMsg();
            return;
        }

        if (!this.autoScrollIsPaused) {
            this.onclickNext(false);
            this.startAutoScroll(false);
        }
    };
    
    //this function is invoked by observer on new message
    this.onNewMessage = function(msg) {
        this.arrMessages.push(msg);
        if (!msg || this.arrMessages.length < 0) return;
        this.setPaging(false);
        if (this.arrMessages.length > 1) {
            if (!this.pagingSet)
                this.setPaging(!this.pagingSet);
            else {
                this.xulElements.lblTotalPages.value = this.arrMessages.length;
                this.onPagingChanged();
            }
        }
        else 
            this.startAutoScroll(true);
    };

    this.getInfoFromManager = function() {
        this.alertUI = oToolbar_CT2958529.alert.manager.getInternalAlert().uiManager;
        this.alertManager = oToolbar_CT2958529.alert.manager.getInternalAlert();
        this.arrMessages = new Array();
    };

    this.setLocalVars = function() {
        this.xulElements.imgClose = this.getDOMNodeById("imgClose");
        this.xulElements.imgSettings = this.getDOMNodeById("imgSettings");

        this.xulElements.imgLogo = this.getDOMNodeById("imgLogo");
        this.xulElements.lblHeaderText = this.getDOMNodeById("lblHeaderText");
        this.xulElements.frameMsg = this.getDOMNodeById("frameMsg");

        this.xulElements.boxPaging = this.getDOMNodeById("boxPaging");
        this.hashShownIndexes = new EBArrayHashObject_CT2958529();
    };

    this.initUI = function() {
        EBUILogic_ImageButtons_CT2958529.setManager(this.xulElements.imgClose);
        EBUILogic_ImageButtons_CT2958529.setManager(this.xulElements.imgSettings);

        var that = this;
        this.xulElements.imgClose.onclick = function(event) { that.onclickClose(window); };
        this.xulElements.imgSettings.onclick = function(event) { that.onclickSettings(window); };

        //return focus
        var alertUI = this.alertUI;
        setTimeout(function() { alertUI.returnFocus(); }, 10);
    };

    this.setPaging = function(withStartAutoScroll) {
        this.currIndex = 0;
        this.xulElements.imgNext = this.getDOMNodeById("imgNext");
        this.xulElements.imgPrev = this.getDOMNodeById("imgPrev");

        EBUILogic_ImageButtons_CT2958529.setManager(this.xulElements.imgNext);
        EBUILogic_ImageButtons_CT2958529.setManager(this.xulElements.imgPrev);

        var that = this;
        this.xulElements.imgPrev.onclick = function(event) { if (!event.target.manager.isDisabled) that.onclickPrev(); };
        this.xulElements.imgNext.onclick = function(event) { if (!event.target.manager.isDisabled) that.onclickNext(true); };

        this.xulElements.lblCurrentPage = this.getDOMNodeById("lblCurrentPage");
        this.xulElements.lblTotalPages = this.getDOMNodeById("lblTotalPages");

        this.xulElements.lblTotalPages.value = this.arrMessages.length;

        this.onPagingChanged();

        this.pagingSet = true;

        if (withStartAutoScroll)
            this.startAutoScroll(true);
    };

    this.fillUI = function() {
        if (this.arrMessages.length > 1 && !this.firstTimeMsg)
            this.setPaging(true);
        else
            this.xulElements.boxPaging.style.display = "none";

        this.fillMsg();
    };

    this.onPagingChanged = function() {
        if (this.arrMessages.length >= 2)
            this.xulElements.boxPaging.style.display = "";
        else
            this.xulElements.boxPaging.style.display = "none";

        if (this.currIndex == 0)
            this.xulElements.imgPrev.manager.disable();
        else
            this.xulElements.imgPrev.manager.enable();

        if (this.currIndex == this.arrMessages.length - 1)
            this.xulElements.imgNext.manager.disable();
        else
            this.xulElements.imgNext.manager.enable();

        this.xulElements.lblCurrentPage.value = this.currIndex + 1;
        this.xulElements.lblTotalPages.value = this.arrMessages.length;
    };

    this.getWindowDirection = function(strText) {
        return EBToolbarDesignManager_CT2958529.IsLTRLanguage(strText) ? "ltr" : "rtl";
    };

    this.fillHtmlMessage = function() {
        this.fadeInFrame();
        var iIndex = this.currIndex;

        var oMsg = null;
        if (this.firstTimeMsg) {
            oMsg = this.firstTimeMsg;
            this.sendViewedUsage(oMsg);
        }
        else {
            oMsg = this.arrMessages[iIndex];

            //add this message index to show messages ids hash
            if (!oMsg.isInternal && !this.hashShownIndexes.Contains(oMsg.guid)) {
                this.hashShownIndexes.Add(oMsg.guid, oMsg.guid);
                this.sendViewedUsage(oMsg);
            }
        }

        var strDirection = "";
        this.xulElements.imgLogo.src = oMsg.headerImage;
        this.xulElements.lblHeaderText.value = oMsg.headerText;

        /*
        if (EBGlobalManager_CT2958529.IsLinuxPlatform()) {
        this.xulElements.descMsgBody1.style.fontSize = "10px";
        this.xulElements.descMsgBody2.style.fontSize = "10px";
        }*/

        if (oMsg.headerCssStyle) {
            var strCssBold = (oMsg.headerCssStyle.isBold) ? "font-weight:Bold" : "";
            var style = stringFormat("color:{0};font-family:{1};{2}", oMsg.headerCssStyle.color, oMsg.headerCssStyle.fontFamily, strCssBold);
            this.xulElements.lblHeaderText.setAttribute("style", style);
        }

        var doc = this.xulElements.frameMsg.contentDocument;
        var cssStyles = (EBGlobalManager_CT2958529.IsLinuxPlatform()) ? this.cssStylesLinux : this.cssStyles;
        doc.write(this.jsScript+oMsg.msgHtml);
        doc.getElementsByTagName("head")[0].innerHTML = cssStyles;

        //reverse dialog if message contains rtl chars.
        var strDirection = this.getWindowDirection(oMsg.msgHtml);
        this.setDirection(strDirection);
    };

    this.sendClickedUsage = function(oMsg) {
        if (oMsg.sendUsage)
            this.alertManager.usageManager.msgClicked(oMsg.guid, oMsg.feedId);
    };

    this.sendViewedUsage = function(oMsg) {
        if (oMsg.sendUsage)
            this.alertManager.usageManager.msgViewed(oMsg.guid, oMsg.feedId);
    };

    this.sendFwdUsage = function(oMsg) {
        if (oMsg.sendUsage)
            this.alertManager.usageManager.msgForwarded(oMsg.guid, oMsg.feedId);
    };

    this.sendBckUsage = function(oMsg) {
        if (oMsg.sendUsage)
            this.alertManager.usageManager.msgBackwarded(oMsg.guid, oMsg.feedId);
    };
    
    // **** functions to implement in child class ****
    this.getDOMNodeById = function(strId) { };
    this._onload = function() { };
    this.setDirection = function(strDir) { };
    this.onclickClose = function() { };
    this._onmouseover = function(event) { };
    this._onmouseout = function(event) { };
    this.fillMsg = function() { };
    this.onclickLink = function(strUrl) { };
    this.onclickCommand = function(params) { };
    this.registerObservers = function() { };
    this.unregisterObservers = function() { };
    //************************************************

    this.onload = function(xulAlertDialog) {
        this.xulWindow = xulAlertDialog;
        this.getInfoFromManager();
        this.setLocalVars();
        this.registerObservers();
        this._onload();
        this.initUI();
        this.fillUI();

        this.alertUI.setAnimatedIcon();
    };

    this.onunload = function(event) {
        this.alertManager.removeShownMessages(this.hashShownIndexes.IndexerArray, this.alertManager.isFirstMsgShown());
        this.alertUI.setNormalIcon();
        this.unregisterObservers();
        this.pagingSet = false;
    };

    this.onmouseover = function(event) {
        this.isHover = true;
        this.pauseAutoScroll();
        this._onmouseover(event);
    };

    this.onmouseout = function(event) {
        this.isHover = false;
        this.resumeAutoScroll();
        this._onmouseout(event);
    };  
    
    this.onclickSettings = function(win) {
        this.alertUI.openSettingsDialog(win);
    };
    
    this.onclickPrev = function() {
        //to avoid going to negative index on multiple clicking
        if (this.currIndex == 0) {
            this.xulElements.imgPrev.manager.disable();
            return;
        }

        this.currIndex--;
        this.sendBckUsage(this.arrMessages[this.currIndex]);
        var that = this;
        var callback = function() {
            that.fillMsg();
            that.onPagingChanged(false);
        };

        this.fadeOutFrame(callback);
    };

    this.onclickNext = function(isUserClick) {
        //to avoid going out of boundes index on multiple clicking
        if (this.currIndex == this.arrMessages.length - 1) {
            this.xulElements.imgNext.manager.disable();
            return;
        }

        this.currIndex++;
        if (isUserClick)
            this.sendFwdUsage(this.arrMessages[this.currIndex]);
        var that = this;
        var callback = function() {
            that.fillMsg();
            that.onPagingChanged(false);
        };

        this.fadeOutFrame(callback);
    };

    this.removeCurrentAlert = function(oMsg) {
        this.arrMessages.splice(this.currIndex, 1);
        if (this.currIndex + 1 > this.arrMessages.length)
            this.currIndex--;

        if (this.arrMessages.length != 0) {
            this.fillMsg();
            this.onPagingChanged();
        }
        else {
            this.onclickClose();
        }
    };
};
function EBAlertMain_BrowserProgressListener(onNavigationCallback, onBrowserReadyCallback, onCommandCallback) {
    var blankPage = "aboutTabs.htm";
    var isBlankPage = function(strUrl) {
        return (strUrl.indexOf(blankPage) != -1) ? true : false;
    };

    this.onStateChange = function(aProgress, aRequest, aFlag, aStatus) {
        var strUrl = aRequest.name;
        if (strUrl.indexOf("wyciwyg") == 0) return;

        //clicked on link
        if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_START) {
            if (!isBlankPage(strUrl) && (aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT)) {
                aRequest.cancel(0);
                onNavigationCallback(strUrl);
            }
            else {
                var win = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(aProgress.DOMWindow);
                win.onclickCommand = function(appId) {
                    onCommandCallback(appId);
                };
            }
        }

        //browser is ready
        if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP && isBlankPage(strUrl)
                && (aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT)) {
            setTimeout(function() { onBrowserReadyCallback(); }, 200);
        }
    };
};

EBAlertMain_BrowserProgressListener.prototype = new EBBaseBrowserProgressListener_CT2958529();
EBAlertMain_BrowserProgressListener.constructor = EBAlertMain_BrowserProgressListener;
function EBAlertMainObserver_CT2958529(objCallback, strTopic) {
    this.Topic = strTopic;

    this.observe = function(aSubject, aTopic, aData) {
        try {
            objCallback(aSubject.wrappedJSObject.message);
        }
        catch (e) {
            EBLogging_CT2958529.LogToConsole(e, "AlertMainObserver");
        }
    }
}

EBAlertMainObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();
var EBAlertManager_CT2958529 =
{
    MainToolbarID: 'FF_TB_CT2958529',
    ExternalToolbarID: 'FF_TB_EXT',
    _alertManager: null,

    UpdateAlertMultiple: function(arrAlertChannelIds) {
        this._alertManager.replaceChannelIds(this.MainToolbarID, arrAlertChannelIds);
    },

    UpdateAlertSingle: function(strAlertChannelId) {
        var arr = new Array();
        arr.push(strAlertChannelId);
        this.UpdateAlertMultiple(arr);
    },

    RunAlert: function() {
        try {
            if (!this._alertManager) {
                var chosenManager = EBFManager_CT2958529.getService();
                if (chosenManager)
                    this._alertManager = chosenManager.alert.manager;
                else
                    this._alertManager = oToolbar_CT2958529.alert.manager;
            }
            this._alertManager.register(this.MainToolbarID);

            //tray icon handler
            EBAlertTray_CT2958529.onload();
        } catch (e) { EBLog(e); }
    },

    OpenSettingsDialog: function(win) {
        this._alertManager.openSettingsDialog(this.MainToolbarID, win);
    },

    Uninstall: function() {
        if (!this._alertManager)
            this.RunAlert();

        this._alertManager.unregister(this.MainToolbarID);
    },

    AddExternalAlert: function(alertId) {
        var errorCode = EBWebPageApiConsts_CT2958529.Errors.SUCCESS;
        this._alertManager.addExternalAlertChannel(alertId);

        return errorCode;
    },

    Refresh: function(isForceRefresh) {
        this._alertManager.refresh(isForceRefresh);
    },

    AlertEnabled: function(value) {
        //get
        if (typeof value == "undefined")
            return this._alertManager.alertEnabled();
        //set
        else
            this._alertManager.alertEnabled(value);
    },

    AddMyStuffAlert: function(alertId, providerName) {
        var errorCode = EBWebPageApiConsts_CT2958529.Errors.SUCCESS;
        this._alertManager.addMyStuffAlertChannel(alertId, providerName);

        return errorCode;
    },
    
     onChevronClose: function() {
        this._alertManager.onChevronClose();
    }
};

var EBAlertPreview_CT2958529 = {
    imgClose: null,
    imgLogo: null,
    lblFeedTitle: null,
    divFeedItemsContainer: null,

    win: null,

    feed: null,

    onload: function(event) {
        EBUILogic_Dialog_CT2958529.fadeIn("EBAlertPreviewId");
        this._setLocalUIVars();
        this._setLocalVars();

        if (!this.feed.feedItems || this.feed.feedItems.length == 0) return;

        this._initUI();
        this._fillUI();
    },

    onunload: function(event) {

    },

    onclickClose: function() {
        EBUILogic_Dialog_CT2958529.fadeOut("EBAlertPreviewId");
    },

    _setLocalUIVars: function() {
        this.imgClose = document.getElementById("imgClose");
        this.imgLogo = document.getElementById("imgLogo");
        this.lblFeedTitle = document.getElementById("lblFeedTitle");
        this.divFeedItemsContainer = document.getElementById("divFeedItemsContainer");
    },

    _setLocalVars: function() {
        this.feed = window.arguments[0];
        this.win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
    },

    _initUI: function() {
        EBUILogic_ImageButtons_CT2958529.setManager(this.imgClose);
    },

    _fillUI: function() {
        this.imgLogo.src = this.feed.feedItems[0].headerImage;
        this.lblFeedTitle.value = this.feed.feedItems[0].feedTitle;
        var strLabelDir = (EBToolbarDesignManager_CT2958529.IsLTRLanguage(this.feed.feedItems[0].feedTitle)) ?
            "ltr" : "rtl";
        this.lblFeedTitle.style.direction = strLabelDir;
        this._fillFeedItems();
    },

    _fillFeedItems: function() {
        var feedItem;
        for (var i = 0; i < this.feed.feedItems.length; i++) {
            feedItem = this.feed.feedItems[i];
            this._appendFeedItem(feedItem);
        }
    },

    _appendFeedItem: function(feedItem) {
        var strDir = this._getDirection(feedItem);
        var xulVBox = EBXULFactory_CT2958529.CreateVBox("", "", "");
        xulVBox.setAttribute("style", "display:Block; width:275px; direction:" + strDir);
        xulVBox.setAttribute("class", "alertMessageBodyVBox");

        var title = document.createElement("label");
        title.setAttribute("value", feedItem.title);
        if (feedItem.link) {
            title.setAttribute("class", "alertMessageTitleLink");
            title.onclick = function(e) {
                EBAlertPreview_CT2958529.win.EBWeb_CT2958529.LoadURLInNewWindow(feedItem.link);
            }
        }
        else
            title.setAttribute("class", "alertMessageTitleLabel");

        var htmlDesc = document.createElementNS("http://www.w3.org/1999/xhtml", "html:div");
        htmlDesc.setAttribute("class", "alertMessageBodyDesc");

        var xulDotHBox = document.createElementNS("http://www.w3.org/1999/xhtml", "html:div");
        xulDotHBox.setAttribute("class", "dotted");
        xulDotHBox.setAttribute("style", "width:250px; height:15px;");

        xulVBox.appendChild(title);
        xulVBox.appendChild(htmlDesc);
        xulVBox.appendChild(xulDotHBox);
        this.divFeedItemsContainer.appendChild(xulVBox);

        var strDesc = EBXML_CT2958529.LegalizeEBXML(feedItem.description);
        htmlDesc.innerHTML = strDesc.replace(/\n/g, "<html:br />");
    },

    _getDirection: function(feedItem) {
        var rtl = "rtl";
        var ltr = "ltr";

        if (!EBToolbarDesignManager_CT2958529.IsLTRLanguage(feedItem.title))
            return rtl;

        if (!EBToolbarDesignManager_CT2958529.IsLTRLanguage(feedItem.description))
            return rtl;

        return ltr;
    }
};
var EBAlertSettings_CT2958529 = {
    imgClose: null,
    divBtnOk: null,
    divBtnCancel: null,

    imgFeedback: null,
    imgFaq: null,
    imgPrivacy: null,
    imgAbout: null,

    chkEnabled: null,
    chkTray: null,
    spcButtns: null,

    divFeedsContainer: null,

    alertManager: null,
    alertUI: null,
    win: null,

    hashFeeds: null,

    onload: function(event) {
        EBUILogic_Dialog_CT2958529.fadeIn("EBAlertSettingsId");
        this._getCore();
        this._setLocalUIVars();
        this._setLocalVars();
        this._initUI();
        this._fillUI();
    },

    onunload: function(event) {

    },

    onclickClose: function() {
        EBUILogic_Dialog_CT2958529.fadeOut("EBAlertSettingsId");
    },

    onclickOk: function() {
        this._saveChanges();
        EBUILogic_Dialog_CT2958529.fadeOut("EBAlertSettingsId");
    },

    onclickFeedback: function() {
        var strLink = this.alertUI.getFeedBackLink();
        this.win.EBWeb_CT2958529.LoadURLInNewWindow(strLink);
    },

    onclickFaq: function() {
        var strLink = this.alertUI.getFaqLink();
        this.win.EBWeb_CT2958529.LoadURLInNewWindow(strLink);
    },

    onclickPrivacy: function() {
        var strLink = this.alertUI.getPrivacyLink();
        this.win.EBWeb_CT2958529.LoadURLInNewWindow(strLink);
    },

    onclickAbout: function() {
        this.alertUI.openAboutDialog();
    },

    _getCore: function() {
        this.win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        this.alertUI = this.win.oToolbar_CT2958529.alert.manager.getInternalAlert().uiManager;
        this.alertManager = this.win.oToolbar_CT2958529.alert.manager.getInternalAlert();
    },

    _setLocalUIVars: function() {
        this.imgClose = document.getElementById("imgClose");
        this.divBtnOk = document.getElementById("divBtnOk");
        this.divBtnCancel = document.getElementById("divBtnCancel");

        this.imgFeedback = document.getElementById("imgFeedback");
        this.imgFaq = document.getElementById("imgFaq");
        this.imgPrivacy = document.getElementById("imgPrivacy");
        this.imgAbout = document.getElementById("imgAbout");

        this.chkEnabled = document.getElementById("chkEnabled");
        this.chkTray = document.getElementById("chkTray");
        this.spcButtns = document.getElementById("spcButtns");

        this.divFeedsContainer = document.getElementById("divFeeds");
    },

    _setLocalVars: function() {
        this.hashFeeds = this.alertManager.getFeedsHash();
    },

    _initUI: function() {
        EBUILogic_ImageButtons_CT2958529.setManager(this.imgClose);
        EBUILogic_ImageButtons_CT2958529.setManager(this.imgFeedback);
        EBUILogic_ImageButtons_CT2958529.setManager(this.imgFaq);
        EBUILogic_ImageButtons_CT2958529.setManager(this.imgPrivacy);
        EBUILogic_ImageButtons_CT2958529.setManager(this.imgAbout);
        EBUILogic_ImageButtons_CT2958529.setManager(this.divBtnOk);
        EBUILogic_ImageButtons_CT2958529.setManager(this.divBtnCancel);

        if (EBGlobalManager_CT2958529.IsMacintoshPlatform())
            this.spcButtns.style.display = "none";

        this.chkEnabled.checked = this.alertManager.alertEnabled();
        this.chkTray.checked = this.alertManager.showTray();
    },

    _fillUI: function() {
        this._fillFeeds();
    },

    _fillFeeds: function() {
        var feed = null;
        for (var i = 0; i < this.hashFeeds.Count(); i++) {
            feed = this.hashFeeds.GetByIndex(i);
            this._appendFeed(feed);
        }
    },

    _appendFeed: function(feed) {
        //do not show feeds without titles
        if (!feed.title) feed.title = "Notification";

        var xulHBox = EBXULFactory_CT2958529.CreateHBox("", "", "");
        var xulCheckbox = document.createElement("checkbox");
        xulCheckbox.setAttribute("id", feed.id);
        xulCheckbox.setAttribute("name", "feed");
        xulCheckbox.setAttribute("label", feed.title);

        //in linux, if applying this class, the checkbox becomes uncheckable.
        if (!EBGlobalManager_CT2958529.IsLinuxPlatform())
            xulCheckbox.setAttribute("class", "extendedCheckbox");

        var isChecked = (feed.isEnabled == 1) ? true : false;
        xulCheckbox.setAttribute("checked", isChecked);
        xulCheckbox.setAttribute("style", "width:260px");

     /*   var xulLabel = EBXULFactory_CT2958529.CreateLabel("View", "");
        xulLabel.setAttribute("class", "viewLink");
        if (!feed.feedItems)
            xulLabel.setAttribute("disabled", "true");
        else
            xulLabel.onclick = function(e) {
                EBAlertSettings_CT2958529.alertUI.openPreviewDialog(feed, window);
            };
              xulHBox.appendChild(xulLabel);
            */

        xulHBox.appendChild(xulCheckbox);
        this.divFeedsContainer.appendChild(xulHBox);
    },

    _saveChanges: function() {
        //handle feed changes
        var arrCheckBox = document.getElementsByTagName("checkbox");
        var arrChangedFeeds = new Array();
        var feed = null;
        var checkBox = null;
        for (var i = 0; i < arrCheckBox.length; i++) {
            checkBox = arrCheckBox[i];
            if (checkBox.getAttribute("name") == "feed") {
                feed = this.hashFeeds.GetByID(checkBox.id);
                if (feed.isEnabled != checkBox.checked) {
                    feed.isEnabled = !feed.isEnabled;
                    arrChangedFeeds.push(feed);
                }
            }
        }

        if (arrChangedFeeds.length != 0)
            this.alertManager.updateFeedsFromSettings(arrChangedFeeds);

        //handle other checkboxes changes
        if (this.chkEnabled.checked != this.alertManager.alertEnabled())
            this.alertManager.alertEnabled(this.chkEnabled.checked);

        if (this.chkTray.checked != this.alertManager.showTray())
            this.alertManager.showTray(this.chkTray.checked);
    }
};
var EBAlertTray_CT2958529 =
{
    iconId: "icon_CT2958529_Alert",
    ringIconUrl: "chrome://browsersearch/skin/alert/TrayIconAnimated.gif",
    alertIconUrl: "chrome://browsersearch/skin/alert/TrayIcon.ico",

    onload: function() {
        var oManager = oToolbar_CT2958529.alert.manager.getInternalAlert();
        if (oManager)
            oToolbar_CT2958529.alert.manager.getInternalAlert().onWindowLoad(document);
    },

    onclick: function(event) {
        //  if (event.button == 2)
        //      oToolbar_CT2958529.alert.manager.getInternalAlert().uiManager.openAlertDialog();
    },

    onRefresh: function() {
        oToolbar_CT2958529.alert.manager.refresh(false);
    },

    onSettings: function() {
        oToolbar_CT2958529.alert.manager.getInternalAlert().uiManager.openSettingsDialog(window);
    },

    onAbout: function() {
        oToolbar_CT2958529.alert.manager.getInternalAlert().uiManager.openAboutDialog();
    },

    onDisable: function() {
        var bIsEnabled = oToolbar_CT2958529.alert.manager.getInternalAlert().alertEnabled();
        oToolbar_CT2958529.alert.manager.getInternalAlert().alertEnabled(!bIsEnabled);
    },

    setIconRing: function(win) {
        var xulImage = win.document.getElementById(this.iconId);
        xulImage.src = this.ringIconUrl;
    },

    setIconNormal: function(win) {
        var xulImage = win.document.getElementById(this.iconId);
        xulImage.src = this.alertIconUrl;
    },

    onPopupShowing: function(xulPopup) {
        var bIsEnabled = oToolbar_CT2958529.alert.manager.getInternalAlert().alertEnabled();
        var strLabel = (bIsEnabled) ? "Disable Notifications" : "Enable Notifications";
        document.getElementById("alertMnuEnableDisable_CT2958529").label = strLabel;
        document.getElementById("alertMnuRefresh_CT2958529").disabled = !bIsEnabled;
    }
};
function EBBrowserCompApi_CT2958529(argsObj) {
    if (!argsObj) return;
    
    var INJECT_SCRIPT_CALLBACK_FUNCTION_NAME = "EBCallBackMessageReceived";
    var alertTimeoutSec = 10;
    var currentApi = "2.3";

    this.width = null;
    this.height = null;
    this.lastError = "";
    this.noResponse = "undefined";
    var defaultTarget = null;
    var TEXT_FILE_EXT = ".txt";
    
    this.Init = function() {
        this.width = argsObj.width;
        this.height = argsObj.height;
    };

    this.getWidth = function() {
        return this.width;
    };

    this.getHeight = function() {
        return this.height;
    };

    this.storeKey = function(strKey, strValue) {
        var objPreferencePath = EBBrowserComponentApiManager_CT2958529.GetFullPreferencePath(this.url, strKey);
        var strFullPreferencePath = objPreferencePath.fullDomain;
        var originalValue = strValue;
        strValue = (strValue) ? EBEncryption_CT2958529.encode(strValue) : "";
        EBToolbarPreferenceManager_CT2958529.SetPref(strFullPreferencePath, strValue);

        //broadcast change
        var aSubject = new Object();
        aSubject.wrappedJSObject = aSubject;
        aSubject.key = strKey;
        aSubject.value = originalValue;
        aSubject.virtualPath = objPreferencePath.virtualPath;

        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
            EBObserversManager_CT2958529.ToolbarEventsTopic,
            EBObserversManager_CT2958529.ToolbarEventsData.EBKeyChanged);
    };

    this.retrieveKey = function(strKey) {
        var objPreferencePath = EBBrowserComponentApiManager_CT2958529.GetFullPreferencePath(this.url, strKey);
        var strFullPreferencePath = objPreferencePath.fullDomain;
        var strValue = EBToolbarPreferenceManager_CT2958529.GetPref(strFullPreferencePath);
        if (strValue) strValue = EBEncryption_CT2958529.decode(strValue);
        return strValue;
    };

    this.deleteKey = function(strKey) {
        var objPreferencePath = EBBrowserComponentApiManager_CT2958529.GetFullPreferencePath(this.url, strKey);
        var strFullPreferencePath = objPreferencePath.fullDomain;
        EBToolbarPreferenceManager_CT2958529.SetPref(strFullPreferencePath, null);
    };

    this.storeGlobalKey = function(strKey, strValue) {
        EBBrowserComponentApiManager_CT2958529.storeGlobalKey(strKey, strValue);
        
        //broadcast change
        var aSubject = new Object();
        aSubject.wrappedJSObject = aSubject;
        aSubject.key = strKey;
        aSubject.value = strValue;
        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
            EBObserversManager_CT2958529.ToolbarEventsTopic,
            EBObserversManager_CT2958529.ToolbarEventsData.EBGlobalKeyChanged);
    };

    this.retrieveGlobalKey = function(strKey) {
        return EBBrowserComponentApiManager_CT2958529.retrieveGlobalKey(strKey);
    };

    this.deleteGlobalKey = function(strKey) {
        var objPreferencePath = EBBrowserComponentApiManager_CT2958529.GetFullPreferencePath(null, strKey);
        var strFullPreferencePath = objPreferencePath.fullDomain;
        EBToolbarPreferenceManager_CT2958529.SetPref(strFullPreferencePath, null);
    };
    
    this.selfNavigate = function(strUrl, newWidth) {
        if (newWidth) this.changeWidth(newWidth);
        argsObj.xulBrowser.loadURI(strUrl + "#_self");
    };

    this.changeWidth = function(newWidth) {
        argsObj.xulBrowser.width = newWidth;
        this.width = newWidth;
        _reloadBrowser();
    };

    this.changeHeight = function(newHeight) {
        var toolbarHeight = EBUILogic_Toolbar_CT2958529.getHeight();
        //validate size
        if (newHeight < 20)
            newHeight = 20;
        else if (newHeight > toolbarHeight)
            newHeight = toolbarHeight;

        argsObj.xulBrowser.height = newHeight;
        this.height = newHeight;
        argsObj.objManager.onHeightChanged(newHeight);
    };

    this.changeSize = function(newWidth, newHeight) {
        this.changeWidth(newWidth);
        this.changeHeight(newHeight);
    };

    this.handleHeight = function() {
        //does nothing, only to indicate if this version supports changing html component height.
    };

    this.refreshToolbar = function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var isToCloseWindow = argsObj.isFloatingMode && !argsObj.isAIOMode;
        var func = function() {
            if (isToCloseWindow) {
                var chevronStaticManager = getTopMostChevronStaticManager_CT2958529();
                if (chevronStaticManager)
                    chevronStaticManager.CloseAllWindows();
            }
            oWindow.EBSpecialCommands_CT2958529.REFRESH_TOOLBAR_VIEW(false);
        };
        oWindow.setTimeout(func, 1);
    };

    this.openGadget = function(strUrl, width, height, bIsResizable) {
        if (typeof bIsResizable == "undefined") bIsResizable = true;

        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var popHtmlData = new oWindow.oToolbar_CT2958529.toolbarDataParsing.dataObjects.PopHtml();
        popHtmlData.popHtmlUrl = strUrl;
        popHtmlData.parentElement = argsObj.parentElement;
        popHtmlData.openPositionType = popHtmlData.openPositionTypes.alignment;
        popHtmlData.openPositionData.vertical = popHtmlData.openPositionTypes.verticalAlignmentBottom;
        popHtmlData.width = width;
        popHtmlData.height = height;
        popHtmlData.resizable = bIsResizable;
        popHtmlData.isUser = argsObj.isAllowUntrustedFunctions;
        popHtmlData.componentId = argsObj.compId;
        popHtmlData.elementId = argsObj.elementId;
        popHtmlData.compType = argsObj.compType;
        popHtmlData.source = this.source;
        popHtmlData.gadgetType = EBGadgetManager_CT2958529.GADGET_TYPE_REGULAR;
        popHtmlData.minimizable = false;
        popHtmlData.isFloatingMode = false;
        popHtmlData.isAIOMode = false;

        //handle api permissions
        popHtmlData.apiPermissions = argsObj.apiPermissions.clone();

        //fix height in order to support backward compatibility with older toolbars
        popHtmlData.height += EBGadgetManager_CT2958529.titleHeight;

        if (!popHtmlData.resizable)
            popHtmlData.height += EBGadgetManager_CT2958529.resizerHeight;

        oWindow.EBGadgetManager_CT2958529.OpenGadget(popHtmlData);
    };

    this.openGadget2 = function(strUrl, width, height, features) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var popHtmlData = new oWindow.oToolbar_CT2958529.toolbarDataParsing.dataObjects.PopHtml();
        popHtmlData.popHtmlUrl = strUrl;
        popHtmlData.parentElement = argsObj.parentElement;
        popHtmlData.width = width;
        popHtmlData.height = height;
        popHtmlData.isUser = argsObj.isAllowUntrustedFunctions;
        popHtmlData.componentId = argsObj.compId;
        popHtmlData.elementId = argsObj.elementId;
        popHtmlData.compType = argsObj.compType;
        popHtmlData.source = this.source;
        popHtmlData.gadgetType = EBGadgetManager_CT2958529.GADGET_TYPE_REGULAR;
        popHtmlData.initFeatures(features);
        popHtmlData.minimizable = false;
        popHtmlData.isFloatingMode = false;
        popHtmlData.isAIOMode = false;

        //handle api permissions
        popHtmlData.apiPermissions = argsObj.apiPermissions.clone();

        //fix height in order to support backward compatibility with older toolbars
        if (!popHtmlData.titlebar)
            popHtmlData.height += EBGadgetManager_CT2958529.titleHeight;

        if (!popHtmlData.resizable)
            popHtmlData.height += EBGadgetManager_CT2958529.resizerHeight;

        oWindow.EBGadgetManager_CT2958529.OpenGadget(popHtmlData);
    };

    this.openGadget3 = function(strUrl, width, height, features) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var popHtmlData = new oWindow.oToolbar_CT2958529.toolbarDataParsing.dataObjects.PopHtml();
        popHtmlData.popHtmlUrl = strUrl;
        popHtmlData.parentElement = argsObj.parentElement;
        popHtmlData.width = width;
        popHtmlData.height = height;
        popHtmlData.isUser = argsObj.isAllowUntrustedFunctions;
        popHtmlData.componentId = argsObj.compId;
        popHtmlData.elementId = argsObj.elementId;
        popHtmlData.compType = argsObj.compType;
        popHtmlData.source = this.source;
        popHtmlData.gadgetType = EBGadgetManager_CT2958529.GADGET_TYPE_REGULAR;
        popHtmlData.minimizable = false;
        popHtmlData.isFloatingMode = false;
        popHtmlData.isAIOMode = false;

        popHtmlData.initFeatures(features);

        //handle api permissions
        popHtmlData.apiPermissions = argsObj.apiPermissions.clone();

        oWindow.EBGadgetManager_CT2958529.OpenGadget(popHtmlData);
    };

    this.navigateInMainFrame = function(strUrl) {
        if (argsObj.objManager && argsObj.objManager._isUserClick()) {
            var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
            var event = { "customData": { "url": strUrl, "urlTarget": "SELF"} };
            oWindow.EBLinkManager_CT2958529.LoadLinkURL(event);
        }
    };

    this.getMainFrameUrl = function() {
        if (argsObj.apiPermissions.getMainFrameUrl == false || (argsObj.apiPermissions.getMainFrameUrl == null && !argsObj.isAllowUntrustedFunctions)) {
            this.lastError = 1;
            return "";
        }

        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        return oWindow.EBUrl_CT2958529.GetPageUrl();
    };

    this.getMainFrameTitle = function() {
        if (argsObj.apiPermissions.getMainFrameTitle == false || (argsObj.apiPermissions.getMainFrameTitle == null && !argsObj.isAllowUntrustedFunctions)) {
            this.lastError = 1;
            return "";
        }

        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        return oWindow.EBActionManager_CT2958529.GetPageTitle();
    };

    this.getSearchTerm = function() {
        if (argsObj.apiPermissions.getSearchTerm == false || (argsObj.apiPermissions.getSearchTerm == null && !argsObj.isAllowUntrustedFunctions)) {
            this.lastError = 1;
            return "";
        }

        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var searchComp = oWindow.EBComponentsManager_CT2958529.GetSearchBoxComponent();
        return (searchComp) ? searchComp.xulMenuList.value : "";
    };

    this.getVersion = function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        return oWindow.EBGlobalConsts_CT2958529.Version;
    };

    this.getDownloadPageUrl = function(strCompId) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        return oWindow.EBGlobalConsts_CT2958529.IsEngine ? null : oWindow.oToolbarManager_CT2958529.data.generalToolbarInfo.webServerUrl;
    };

    this.getToolbarName = function(strCompId) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        return oWindow.EBGlobalConsts_CT2958529.ToolbarName;
    };

    this.getToolbarId = function(strCompId) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        if(EBGlobalConsts_CT2958529.IsEngine)
            return (DualPackageFunctions_CT2958529.engineOwnerCTID() == EBGlobalConsts_CT2958529.EngineCTID) ? "undefined" : DualPackageFunctions_CT2958529.engineOwnerCTID();
        else        
            return oWindow.EBGlobalConsts_CT2958529.ToolbarCTID;
    };

    this.refreshComponentById = function(strCompId) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        return oWindow.EBToolbarManager_CT2958529.refreshComponentByIdAllWindows(strCompId);
    };

    this.getApiVersion = function() {
        return currentApi;
    };

    this.getInfo = function() {
        var objInfo = {
            "componentId": this.componentId,
            "appId": argsObj.elementId //guid for mystuff
        };
	var host = EBGlobalConsts_CT2958529.IsEngine? "Engine" : "Toolbar";
        objInfo.context = {
            "host": host,
            "embedLocation": this.embeddedLocation
        };
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        objInfo.general = {
            "toolbarName": oWindow.EBActionManager_CT2958529.GetToolbarName(),
            "OS": EBGlobalManager_CT2958529.GetOS(),
            "OSVersion": EBGlobalManager_CT2958529.GetOSVersion(),
            "browser": "Firefox",
            "browserVersion": EBGlobalManager_CT2958529.GetBrowserVersion(),
            "toolbarVersion": EBGlobalConsts_CT2958529.Version
        };

        objInfo.size = {
            "width": this.getWidth(),
            "height": this.getHeight()
        };

        return JSON.stringify(objInfo);
    };

    this.__defineGetter__("source", function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        return oWindow.EBUsageGadget_CT2958529.SourceBC;
    });

    this.__defineGetter__("embeddedLocation", function() {
        return "Embedded App";
    });

    this.__defineGetter__("componentId", function() {
        return argsObj.compId;
    });

    this.sendInstantAlertByHtml2 = function(strTitle, logoUrl, strHtml, alertLengthSeconds) {
        if (!this.apiPermissions.instantAlert) {
            this.lastError = 1;
            return "";
        }

        var mostRecentWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var alertManager = mostRecentWindow.oToolbar_CT2958529.alert.manager;
        var alertItem = new mostRecentWindow.oToolbar_CT2958529.alert.simpleAlertItem(strTitle, null, logoUrl, strHtml, false, Math.random(), true, Math.random(), alertTimeoutSec, alertLengthSeconds);

        alertManager.sendInternalAlert(alertItem);
    };

    this.registerForMessaging = function(key) {
        argsObj.callbackRegisterKey(key);
    };

    this.__defineGetter__("apiPermissions", function() {
        return EBComponentsManager_CT2958529.GetComponentByCompID(argsObj.compId).ComponentItem.apiPermissions;
    });

    this.injectScript = function(strScript) {
        if (!argsObj.apiPermissions.jsInjection) {
            this.lastError = 1;
            return "";
        }

        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        var mainBrowserJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(oWindow.gBrowser.selectedTab.linkedBrowser.contentWindow);
        if (mainBrowserJS.document.location.href.toString().indexOf("https://") == 0) return "";
        var htmlComponentJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(argsObj.xulBrowser.contentWindow);

        var guid = this.getToolbarId(argsObj.compId) + "_" + argsObj.compId;
        if (strScript.indexOf(INJECT_SCRIPT_CALLBACK_FUNCTION_NAME) != -1) {
            var newFunctionName = INJECT_SCRIPT_CALLBACK_FUNCTION_NAME + guid;
            strScript = strScript.replace(INJECT_SCRIPT_CALLBACK_FUNCTION_NAME, newFunctionName, "g");

            if (!mainBrowserJS[newFunctionName]) {
                mainBrowserJS[newFunctionName] = function(data) {
                    if (htmlComponentJS.EBCallBackMessageReceived)
                        htmlComponentJS.EBCallBackMessageReceived(data);
                };
            }
        }

        var oScript = mainBrowserJS.document.createElement("script");
        oScript.setAttribute("type", "text/javascript");
        oScript.appendChild(mainBrowserJS.document.createTextNode(strScript));
        mainBrowserJS.document.getElementsByTagName("head")[0].appendChild(oScript);
    };


    this.crossDomainHttpRequest = function(callbackKey, method, url, postParams, userName, password, strHeaders, win) {
        if (!argsObj.apiPermissions.crossDomainAjax) {
            this.lastError = 1;
            return "";
        }

        var req = new XMLHttpRequest();
        req.open(method, url, true, userName, password);

        req.onreadystatechange = function() {
            if (req.readyState == 4)
                win.AjaxResponse(callbackKey, req.responseText, req.status);
        };

        if (method.toLowerCase() == "post")
            req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');


        if (strHeaders) {
            try {
                var arrHeaders = JSON.parse(strHeaders);
            }
            catch (exp) {
                EBLog('JSON.parse: ' + exp);
            }
            if (arrHeaders) {
                if (arrHeaders.length) {
                    for (var i = 0; i < arrHeaders.length; i++)
                        req.setRequestHeader(arrHeaders[i][0], arrHeaders[i][1]);
                }
            }
        }

        req.send(postParams);
    };

    this.__defineGetter__("apiPermissions", function() {
        return EBComponentsManager_CT2958529.GetComponentByCompID(argsObj.compId).ComponentItem.apiPermissions;
    });

    this.sendMessage = function(nickname, strValue) {
        if (!nickname || !strValue) return;

        //broadcast message
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        var aSubject = EBObserversManager_CT2958529.GetSubject(oWindow.gBrowser[EBGlobalConsts_CT2958529.WindowId]);
        aSubject.nickname = nickname;
        aSubject.value = strValue;
        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
            EBObserversManager_CT2958529.ToolbarEventsTopic,
            EBObserversManager_CT2958529.ToolbarEventsData.EBMessageReceived);
    };

    this.isAppView = function() {
        if (argsObj.visibleState) {
            if (argsObj.visibleState == "ALWAYS_OPEN")
                return false;
        }

        return EBActionManager_CT2958529.IsAppView();
    };

    this.isAppInstalled = function(strAppGuid) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        var item = null;
        if (EBGlobalConsts_CT2958529.IsEngine)
            item = oWindow.oToolbarManager_CT2958529.data.getItemByGuid(strAppGuid);
        else {
            var itemsHash = oWindow.oToolbarManager_CT2958529.data.publisherItemsHash;
            for (var i = 0; i < itemsHash.Count(); i++) {
                testItem = itemsHash.GetByIndex(i);
                if (testItem.componentGuid == strAppGuid) {
                    item = testItem;
                    break;
                }
            }
            if (!item) {
                var engineManager = oWindow.oToolbar_CT2958529.toolbar.getEngineManager();
                if (engineManager && engineManager.data)
                    item = engineManager.data.getItemByGuid(strAppGuid);
            }
        }
        return item ? true : false;
    };

    this.setLinksTarget = function(target) {
        target = target.toLowerCase();
        if (target == "_self" || target == "_tab" || target == "_new" || target == "_main")
            defaultTarget = "#" + target;
    };

    this.navigateInFrame = function(url, targetFrame) {
        var doc = argsObj.xulBrowser.contentDocument;
        var theFrame = doc.getElementById(targetFrame);

        if (!theFrame) return;
        theFrame.contentDocument.location.href = url;
    };

    this.saveFile = function(strFileName, strFileContent) {
        if (strFileContent.toString().length > 5500000)
            return false;

        var appDirPath = EBBrowserComponentApiManager_CT2958529.getLocalFilesDir(this.componentId);
        var objFilesLimits = EBBrowserComponentApiManager_CT2958529.getFilesNumberAndSizes(appDirPath);
        var legalFileName = EBBrowserComponentApiManager_CT2958529.getLegalizeFileName(strFileName);
        var obgFile = EBBrowserComponentApiManager_CT2958529.isFileExist(appDirPath, legalFileName);

        var isFileAlreadyExist = obgFile == -1 ? false : true;
        var currFileSize = parseInt(obgFile);
        
        if ((!isFileAlreadyExist && objFilesLimits.filesNumber >= 256) ||
        (!isFileAlreadyExist && parseInt(objFilesLimits.filesSize) + parseInt(strFileContent.toString().length) > 20 * 1000 * 1000) ||
        (isFileAlreadyExist && (parseInt(objFilesLimits.filesSize) + parseInt(strFileContent.toString().length) - currFileSize > 20 * 1000 * 1000)))
        return false;
        
        try {
            var oDir = EBDirIO_CT2958529.open(appDirPath);
            if (!oDir.exists())
                EBDirIO_CT2958529.create(oDir);

            var strFullFileName = legalFileName + TEXT_FILE_EXT;
            var oFile = EBFileIO_CT2958529.open(oDir.path + EBDirIO_CT2958529.sep + strFullFileName);
            EBFileIO_CT2958529.create(oFile); //override the file every time
            EBFileIO_CT2958529.write(oFile, strFileContent, null, "UTF-8");
            if (oFile.fileSizeOfLink <= 5000000) {
                EBBrowserComponentApiManager_CT2958529.addFileToLocalFilesDBFile(appDirPath, legalFileName, oFile.fileSizeOfLink);
                return true;
            }
            else {
                EBFileIO_CT2958529.unlink(oFile);
                return false;
            }
        } catch (e) { return false; }
    };

    this.loadFile = function(strFileName) {
        var legalFileName = EBBrowserComponentApiManager_CT2958529.getLegalizeFileName(strFileName);
        try {
            var oDir = EBDirIO_CT2958529.open(EBBrowserComponentApiManager_CT2958529.getLocalFilesDir(this.componentId));
            if (!oDir.exists()) return null;

            var strFullFileName = legalFileName + TEXT_FILE_EXT;
            var oFile = EBFileIO_CT2958529.open(oDir.path + EBDirIO_CT2958529.sep + strFullFileName);
            if (!oFile) return null;

            var strFileContent = EBFileIO_CT2958529.read(oFile, "UTF-8");
            return strFileContent;
        }
        catch (e) { return null; }
    };

    this.deleteFile = function(strFileName) {
        var legalFileName = EBBrowserComponentApiManager_CT2958529.getLegalizeFileName(strFileName);
        try {
            var appDirPath = EBBrowserComponentApiManager_CT2958529.getLocalFilesDir(this.componentId);
            var oDir = EBDirIO_CT2958529.open(appDirPath);
            if (!oDir.exists()) return false;

            var strFullFileName = legalFileName + TEXT_FILE_EXT;
            var oFile = EBFileIO_CT2958529.open(oDir.path + EBDirIO_CT2958529.sep + strFullFileName);
            if (!oFile) return false;

            EBBrowserComponentApiManager_CT2958529.removeFileToLocalFilesDBFile(appDirPath, legalFileName);
            return EBFileIO_CT2958529.unlink(oFile);
        }
        catch (e) { return false; }
    };

    this.__defineGetter__("defaultTarget", function() {
        return defaultTarget;
    });
 
    this.__defineGetter__("url", function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        return oWindow.EBActionManager_CT2958529.ConvertAliasesUrl(argsObj.xulBrowser.currentURI.spec);
    });

    var _reloadBrowser = function() {
        argsObj.xulBrowser.parentNode.width = argsObj.xulBrowser.width;
        setTimeout(function() { EBChevronStaticManager_CT2958529.onchange(false); }, 10);
    };

    if (argsObj)
        this.Init();
};


function EBBrowserCompObserver_CT2958529(that, callbackNavComplete, callbackDocComplete, callbackSearchTermChange, callbackTabSwitch, callbackGlobalKeyChanged, callbackRadioStateChanged, callbackToolbarHide, callbackToolbarShow, strWindowId, callbackKeyChanged, callbackMessageExchange) {
    this.Topic = EBObserversManager_CT2958529.ToolbarEventsTopic;
    
    //get related window id
    this.windowId = strWindowId;

    this.observe = function(aSubject, aTopic, aData) {
        try {
            //to this window only
            if (!aSubject || !this.windowId || this.windowId == aSubject.wrappedJSObject.windowId) {
                switch (aData) {
                    case EBObserversManager_CT2958529.ToolbarEventsData.NavigateComplete:
                        callbackNavComplete.call(that, aSubject.wrappedJSObject.url);
                        break;
                    case EBObserversManager_CT2958529.ToolbarEventsData.DocumentComplete:
                        callbackDocComplete.call(that, aSubject.wrappedJSObject.url);
                        break;
                    case EBObserversManager_CT2958529.ToolbarEventsData.SearchTermChanged:
                        callbackSearchTermChange.call(that);
                        break;
                    //for switch tab event           
                    case EBObserversManager_CT2958529.ToolbarEventsData.TabChange:
                        callbackTabSwitch.call(that, aSubject.wrappedJSObject.url);
                        break;
                    //radio events      
                    case EBObserversManager_CT2958529.ToolbarEventsData.RadioStateChanged:
                        callbackRadioStateChanged.call(that, aSubject.wrappedJSObject.state);
                        break;
                    //message transfer    
                    case EBObserversManager_CT2958529.ToolbarEventsData.EBMessageReceived:
                        callbackMessageExchange.call(that, aSubject.wrappedJSObject.nickname,
                                            aSubject.wrappedJSObject.value);
                        break;
                    default: break;
                }
            }
         
            //to all windows
            switch (aData) {
                case EBObserversManager_CT2958529.ToolbarEventsData.EBGlobalKeyChanged:
                    callbackGlobalKeyChanged.call(that, aSubject.wrappedJSObject.key,
                                            aSubject.wrappedJSObject.value);
                    break;
                case EBObserversManager_CT2958529.ToolbarEventsData.EBKeyChanged:
                    callbackKeyChanged.call(that, aSubject.wrappedJSObject.virtualPath,
                                                aSubject.wrappedJSObject.key,
                                                aSubject.wrappedJSObject.value);
                    break;
                case EBObserversManager_CT2958529.ToolbarEventsData.ToolbarHide:
                    callbackToolbarHide.call(that);
                    break;
                case EBObserversManager_CT2958529.ToolbarEventsData.ToolbarShow:
                    callbackToolbarShow.call(that);
                    break;
                default: break;
            }
        }   
        catch (e) {
            EBLog(e, "BrowserCompObserver");
        }
    }
}

EBBrowserCompObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();

function EBBrowserCompProgressListener_CT2958529() {
    this.xulBrowser = null;
    this.isAllowUntrustedFunctions = true;
    this.width = "";
    this.height = "";
    this.lastClickTimestamp = 0;
    this.observer = null;
    this.elementId = "";
    this.componentId = "";
    this.isGadget = false;
    this.initialUrl = "";
    this.compType = "";
    this.onloadFireOnceArr = null;
    this.autoFit = null;
    this.firstClick = 0;
    this.lastClick = 0;
    this.timer = null;
    this.lastClickEvent = null;
    this.isDocumentCompletedOnce = false;
    this.apiPermissions = null;

    var mAppRegisteredEventList = null;
    var that = this;
    
    this.browserCompApi = null;

    this.onStateChange = function(aProgress, aRequest, aFlag, aStatus) {
        var strUrl = aRequest.name;
        var bIsMainBC = (aProgress.DOMWindow == this.xulBrowser.contentWindow);

        //attach API on earlier state
        if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_START && strUrl != "about:document-onload-blocker") {
            if (aProgress.DOMWindow)
                var win = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(aProgress.DOMWindow);

            if (win) {
                try {
                    win.BCAPIObject = this.browserCompApi;
                }
                catch (e) { EBLog(e); }
            }
        }

        if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT) {
            if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_START) {
                var oUploadStream = null;
                var requestMethod = "get";
                try {
                    requestMethod = aRequest.QueryInterface(Components.interfaces.nsIHttpChannel).requestMethod.toLowerCase();
                }
                catch (ex) { }

                if (requestMethod == "post")
                    oUploadStream = aRequest.QueryInterface(Components.interfaces.nsIUploadChannel).uploadStream;

                this._onBeforeNavigate(strUrl, oUploadStream, aRequest, aProgress.DOMWindow, !bIsMainBC);
            }

            //doc complete
            if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
                var bIsSuccess = true;
                try {
                    var httpChannel = aRequest.QueryInterface(Components.interfaces.nsIHttpChannel);
                    var responseStatus = httpChannel.responseStatus;
                    if (responseStatus != EBBrowserComponentConsts_CT2958529.ErrorRequestOK) {
                        bIsSuccess = false;
                    }
                }
                catch (ex) { }

                this._onDocumentComplete(bIsSuccess, bIsMainBC);

                if (!bIsSuccess || aStatus == EBBrowserComponentConsts_CT2958529.ErorrUpdateServerNotFound)
                    this.onError();
                //all OK
                else {
                    this._handleTooltips(aProgress.DOMWindow);
                }
            }

            if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP) { }
            if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_START) { }

            return 0;
        }
    };

    this.onError = function() {
        var oBrowserComp = EBComponentsManager_CT2958529.GetComponentByCompID(this.componentId);
        if (!oBrowserComp) return;
        if (!EBActionManager_CT2958529.IsAppView())
            oBrowserComp.onConnectionStateOff();
    };

    this.addOnloadFireOnceCallback = function(callback) {
        if (this.isDocumentCompletedOnce)
            callback();
        else {
            if (!this.onloadFireOnceArr)
                this.onloadFireOnceArr = new Array();
            this.onloadFireOnceArr.push(callback);
        }
    };

    this.onclick = function(event) {
        this.lastClickEvent = event;
        this._logUserActionTimeStamp(event);

        var comp = EBComponentsManager_CT2958529.GetComponentByCompID(this.componentId);
        var interval = comp.ComponentItem.usageIntervalSec * 1000;

        var self = this;
        var setTiming = function() {
            var length = (self.lastClick - self.firstClick) / 1000;
            EBUsageBrowserComponent_CT2958529.OnClick(self.componentId, self.lastClickEvent, self.compType, length);
            self.firstClick = 0;
            self.lastClick = 0;
        };

        if (this.firstClick == 0 && this.lastClick == 0) {
            this.firstClick = Date.parse(Date());
            this.lastClick = Date.parse(Date());
            this.timer = setTimeout(setTiming, interval);
        }
        else {
            this.lastClick = Date.parse(Date());
            clearTimeout(this.timer);
            this.timer = setTimeout(setTiming, interval);
        }
    };

    this.onkeypress = function(event) {
        this._logUserActionTimeStamp(event);
    };
    this.isUrlHasTarget = function(url) {
        if (url.indexOf("#_self") != -1 || url.indexOf("#_new") != -1 || url.indexOf("#_new") != -1 || url.indexOf("#_tab") != -1 || url.indexOf("#_blank") != -1 || url.indexOf("#_main") != -1)
            return true;
        return false;
    }

    //handle navigation with parameters
    this._onBeforeNavigate = function(strUrl, oUploadStream, aRequest, DOMWindow, isIframe) {
        if (this._checkDontCatchNextNavigation()) return;

        var originalUrl = strUrl;
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        strUrl = oWindow.EBActionManager_CT2958529.ConvertAliasesUrl(strUrl, false, !this.isAllowUntrustedFunctions);
        var isAsyncStop = (oUploadStream) ? false : true;
        var strLowerCaseUrl = strUrl.toLowerCase();

        if (this.browserCompApi.defaultTarget && !this.isUrlHasTarget(strLowerCaseUrl) && strLowerCaseUrl != "about:blank")
            strLowerCaseUrl += this.browserCompApi.defaultTarget;

        if (strLowerCaseUrl.indexOf("#_self") != -1)
            this._selfNavigate(strUrl, oUploadStream);
        else if (strLowerCaseUrl.indexOf("#_new") != -1) {
            this._browserStop(isAsyncStop, aRequest, isIframe);
            if (!this._isUserClick()) return;
            strUrl = strUrl.replace(/#_new/, "");
            oWindow.EBWeb_CT2958529.LoadURLInNewWindow(strUrl, oUploadStream);
        }
        else if (strLowerCaseUrl.indexOf("#_tab") != -1) {
            this._browserStop(isAsyncStop, aRequest, isIframe);
            if (!this._isUserClick()) return;
            strUrl = strUrl.replace(/#_tab/, "");
            var event = { "customData": { "url": strUrl, "urlTarget": "TAB", "uploadStream": oUploadStream} };
            oWindow.EBLinkManager_CT2958529.LoadLinkURL(event);
        }
        else if (strLowerCaseUrl.indexOf("#_blank") != -1) {
            this._browserStop(isAsyncStop, aRequest, isIframe);
            if (!this._isUserClick()) return;
            var event = { "customData": { "url": "about:blank", "uploadStream": oUploadStream} };
            oWindow.EBLinkManager_CT2958529.LoadLinkURL(event);
        }
        else if (strLowerCaseUrl.indexOf("#_main") != -1) {
            this._browserStop(isAsyncStop, aRequest, isIframe);
            if (!this._isUserClick()) return;
            strUrl = strUrl.replace(/#_main/, "");
            var event = { "customData": { "url": strUrl, "urlTarget": "SELF", "uploadStream": oUploadStream} };
            oWindow.EBLinkManager_CT2958529.LoadLinkURL(event);
        }
        else if (!this.isGadget && this._isUserClick() && !isIframe) {
            this._browserStop(isAsyncStop, aRequest, isIframe);
            var event = { "customData": { "url": strUrl, "uploadStream": oUploadStream} };
            oWindow.EBLinkManager_CT2958529.LoadLinkURL(event);
        }
        //regular self navigate, stop the browser and reload after aliases replaced
        //do it only if aliases present
        else if (originalUrl != strUrl && originalUrl != this.initialUrl && originalUrl != "about:blank") {
            this._selfNavigate(strUrl, oUploadStream, DOMWindow, isIframe);
        }
    };

    this._selfNavigate = function(strUrl, oUploadStream, DOMWindow, isIframe) {
        this._setDontCatchNextNavigation();
        strUrl = strUrl.replace(/#_self/, "");
        if (isIframe) {
            DOMWindow.location.href = strUrl;
        }
        else {
            if (!oUploadStream)
                this.xulBrowser.loadURI(strUrl);
            else
                this.xulBrowser.webNavigation.loadURI(strUrl, Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE, null, oUploadStream, null);
        }
    };

    this._setDontCatchNextNavigation = function() {
        this.xulBrowser.ebDontCatchNextNavigation = true;
    };

    this._checkDontCatchNextNavigation = function() {
        var val = this.xulBrowser.ebDontCatchNextNavigation;
        this.xulBrowser.ebDontCatchNextNavigation = false;
        return (typeof (val) == "undefined") ? false : val;
    };

    this._isTicker = function() {
        return this.initialUrl.indexOf("Components/RssTicker/") != -1 || this.initialUrl.indexOf("http://ticker.") != -1;
    };

    this._onDocumentComplete = function(bIsSuccess, bIsMainBC) {
        this.isDocumentCompletedOnce = true;
        //update radio state
        EBRadioManager_CT2958529.updateHtmlComponentState();

        //fire attached onload callback, used to ensure that mystuff added component is visible
        if (this.onloadFireOnceArr && this.onloadFireOnceArr.length != 0) {
            var callback = null;
            for (var i = 0; i < this.onloadFireOnceArr.length; i++) {
                callback = this.onloadFireOnceArr[i];
                callback();
            }

            this.onloadFireOnceArr = null;
        }

        var isTicker = this._isTicker();
        if (this.xulBrowser.ebStopped && isTicker) {
            this.xulBrowser.ebStopped = false;
            return;
        }

        EBUILogic_Browser_CT2958529.setBrowserStyle(this.xulBrowser, isTicker, this.autoFit, this.height);

    };

    this.onHeightChanged = function(newHeight) {
        this.height = newHeight;
        var isTicker = this._isTicker();
        EBUILogic_Browser_CT2958529.setBrowserStyle(this.xulBrowser, isTicker, this.autoFit, this.height);
    };

    this._attachTooltipHandler = function(htmlElement) {
        var showTooltip = function(htmlElement) {
            htmlElement.mouseOn = true;
            var checkIfToShow = function() {
                if (!htmlElement.mouseOn) return;

                var oTooltip = document.getElementById("eb_HTMLTooltip_CT2958529");
                if (!oTooltip) return;
                oTooltip.label = htmlElement.getAttribute("title");
                if (oTooltip.openPopup)
                    oTooltip.openPopup(htmlElement, "after_end", -1, -1, true, null);
                else {
                    //oTooltip.showPopup(null, event.screenX, event.screenY, "tooltip", null, null);
                }
            };

            setTimeout(checkIfToShow, 700);
        };

        var hideTooltip = function(htmlElement) {
            var oTooltip = document.getElementById("eb_HTMLTooltip_CT2958529");
            if (!oTooltip) return;
            oTooltip.hidePopup();
            htmlElement.mouseOn = false;
        };

        htmlElement.addEventListener("mouseover", function() { showTooltip(htmlElement); }, false);
        htmlElement.addEventListener("mouseout", function() { hideTooltip(htmlElement); }, false);
    };

    this._handleTooltips = function(DOMWindow) {
        var objJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(DOMWindow);
        var arrElements = objJavascript.document.getElementsByTagName("*");
        if (!arrElements || arrElements.length == 0) return;

        for (var i = 0; i < arrElements.length; i++) {
            if (arrElements[i].getAttribute("title"))
                this._attachTooltipHandler(arrElements[i]);
        }
    };

    this._attachBCApi = function(DOMWindow) {
        var objJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(DOMWindow);
        if (objJavascript.BCAPI) {
            objJavascript.BCAPI = this.browserCompApi;
        }
    };

    this._browserStop = function(isAsync, aRequest, isIframe) {
        this.xulBrowser.ebStopped = true;
        if (isAsync) {
            var xulBrowser = this.xulBrowser;
            var fStop = function() {
                if (isIframe)
                    aRequest.cancel(0);
                else
                    xulBrowser.webNavigation.stop(Components.interfaces.nsIWebNavigation.STOP_ALL);
            };
            setTimeout(fStop, 0);
        }
        else {
            if (isIframe)
                aRequest.cancel(0);
            else
                this.xulBrowser.webNavigation.stop(Components.interfaces.nsIWebNavigation.STOP_ALL);
        }
    };

    this._logUserActionTimeStamp = function(event) {
        this.lastClickTimestamp = Date.parse(Date());
    };

    this._isUserClick = function() {
        if (!this.lastClickTimestamp || Date.parse(Date()) - this.lastClickTimestamp > 1000)
            return false;
        else {
            this.lastClickTimestamp = 0;
            return true;
        }
    };

    //main browser events handlers
    this.mainNavComplete = function(strUrl) {
        var oJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
        strUrl = (this.apiPermissions.getMainFrameUrl == false || (this.apiPermissions.getMainFrameUrl == null && !this.isAllowUntrustedFunctions)) ?
                        "" : strUrl;
        if (oJavascript && oJavascript.EBNavigateComplete)
            oJavascript.setTimeout(function() { oJavascript.EBNavigateComplete(strUrl); }, EBBrowserComponentConsts_CT2958529.ApiFuncTimeout);
    };

    this.mainDocComplete = function(strUrl) {
        var oJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
        strUrl = (this.apiPermissions.getMainFrameUrl == false || (this.apiPermissions.getMainFrameUrl == null && !this.isAllowUntrustedFunctions)) ?
                        "" : strUrl;
        if (oJavascript && oJavascript.EBDocumentComplete)
            oJavascript.setTimeout(function() { oJavascript.EBDocumentComplete(strUrl); }, EBBrowserComponentConsts_CT2958529.ApiFuncTimeout);
    };

    this.SearchTermChange = function() {
        var oJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
        if (oJavascript && oJavascript.EBSearchTermChanged)
            oJavascript.setTimeout(oJavascript.EBSearchTermChanged, EBBrowserComponentConsts_CT2958529.ApiFuncTimeout);
    };
    
    // switch tab event
    this.TabChange = function(strUrl) {
        var oJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
        strUrl = (this.apiPermissions.getMainFrameUrl == false || (this.apiPermissions.getMainFrameUrl == null && !this.isAllowUntrustedFunctions)) ?
                        "" : strUrl;
        if (oJavascript && oJavascript.EBTabChange)
            oJavascript.setTimeout(function() { oJavascript.EBTabChange(strUrl); }, EBBrowserComponentConsts_CT2958529.ApiFuncTimeout);
    };

    //global back end storage changed
    this.globalKeyChanged = function(key, value) {
        var oJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
        if (oJavascript && oJavascript.EBGlobalKeyChanged)
            oJavascript.setTimeout(function() { oJavascript.EBGlobalKeyChanged(key, value); }, EBBrowserComponentConsts_CT2958529.ApiFuncTimeout);
    };

    //key back end storage changed
    this.keyChanged = function(virtualPath, key, value) {
        if (!this.xulBrowser.currentURI) return;
        var myVirtualPath = EBBrowserComponentApiManager_CT2958529.GetFullPreferencePath(this.xulBrowser.currentURI.spec, key).virtualPath;
        if (virtualPath == myVirtualPath) {
            var oJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
            if (oJavascript && oJavascript.EBKeyChanged)
                oJavascript.setTimeout(function() { oJavascript.EBKeyChanged(key, value); }, EBBrowserComponentConsts_CT2958529.ApiFuncTimeout);
        }
    };

    this.messageTransfer = function(nickname, strMsg) {
        if (!mAppRegisteredEventList || mAppRegisteredEventList.Count() == 0) return;

        if (mAppRegisteredEventList.Contains(nickname)) {
            var oJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
            if (oJavascript && oJavascript.EBMessageReceived)
                oJavascript.setTimeout(function() { oJavascript.EBMessageReceived(nickname, strMsg); },
                    EBBrowserComponentConsts_CT2958529.ApiFuncTimeout);
        }
    };

    //global back end storage changed
    this.radioStateChanged = function(radioState) {
        var oJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
        if (oJavascript && oJavascript.EBRadioPlayerStateChange)
            oJavascript.setTimeout(function() { oJavascript.EBRadioPlayerStateChange(radioState); },
                EBBrowserComponentConsts_CT2958529.ApiFuncTimeout);
    };

    //global back end storage changed
    this.tabRestored = function(restoredTabUrl, selectedTabUrl) {
        var oJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
        if (oJavascript && oJavascript.EBTabRestored) {
            oJavascript.setTimeout(function() { oJavascript.EBTabRestored(restoredTabUrl, selectedTabUrl); },
                EBBrowserComponentConsts_CT2958529.ApiFuncTimeout);
        }
    };

    this.toolbarHide = function() {
        if (!EBGlobalConsts_CT2958529.IsEngine) return;
        var browserComp = EBComponentsManager_CT2958529.GetComponentByCompID(this.componentId);
        if (!browserComp) return;

        browserComp.onToolbarHide();
    };

    this.toolbarShow = function() {
        if (!EBGlobalConsts_CT2958529.IsEngine) return;
        var browserComp = EBComponentsManager_CT2958529.GetComponentByCompID(this.componentId);
        if (!browserComp) return;

        browserComp.onToolbarShow();
    };

    this.init = function(xulBrowser, isAllowUntrustedFunctions, width, height, componentId, elementId, compType, autoFit, visibleState) {
        try {
            this._setMembers(xulBrowser, isAllowUntrustedFunctions, width, height, componentId, elementId, compType, autoFit, visibleState);
            this._initBrowserCompApi();
            this._initListeners();
            this._initObserver();
            //save initial url
            this.initialUrl = xulBrowser.getAttribute("src");
            xulBrowser.contentWindow.name = componentId;
            this.attachBCAPI();
        }
        catch (e) {
            EBLog(e); 
        }
    };

    this._setMembers = function(xulBrowser, isAllowUntrustedFunctions, width, height, componentId, elementId, compType, autoFit, visibleState) {
        this.xulBrowser = xulBrowser;
        this.isAllowUntrustedFunctions = isAllowUntrustedFunctions;
        this.width = width;
        this.height = height;
        this.componentId = componentId;
        this.elementId = elementId;
        this.compType = compType;
        this.autoFit = autoFit;
        this.visibleState = visibleState;
    };

    this.attachBCAPI = function(contentWindow) {
        if (!contentWindow)
            contentWindow = this.xulBrowser.contentWindow;

        try {
            var arrFrames = EBGlobalManager_CT2958529.GetAllFrames(contentWindow.document);
            for (var i = 0; i < arrFrames.length; i++)
                this.attachBCAPI(arrFrames[i].contentWindow);
        }
        catch (ex) { EBLog(ex); }

        this._attachBCApi(contentWindow);
    };

    this._initBrowserCompApi = function() {
        var that = this;
        var argsObj = new Object();
        argsObj.width = this.width;
        argsObj.height = this.height;
        argsObj.xulBrowser = this.xulBrowser;
        argsObj.parentElement = this.xulBrowser;
        argsObj.objManager = this;
        argsObj.compId = this.componentId;
        argsObj.elementId = this.elementId;
        argsObj.compType = this.compType;
        argsObj.isAllowUntrustedFunctions = this.isAllowUntrustedFunctions;
        argsObj.callbackRegisterKey = function(key) { that.registerKey(key); };
        argsObj.apiPermissions = EBComponentsManager_CT2958529.GetComponentByCompID(argsObj.compId).ComponentItem.apiPermissions;
        argsObj.visibleState = this.visibleState;

        this.browserCompApi = new EBBrowserCompApi_CT2958529(argsObj);
        this.apiPermissions = argsObj.apiPermissions;
    };

    this.registerKey = function(key) {
        if (!mAppRegisteredEventList)
            mAppRegisteredEventList = new EBArrayHashObject_CT2958529();

        mAppRegisteredEventList.Add(key, true);
    };

    this._initListeners = function() {
        this.xulBrowser.addProgressListener(this);
        this.xulBrowser.manager = this;
        this.xulBrowser.addEventListener('click', function(event) { this.manager.onclick(event); }, true);
        this.xulBrowser.addEventListener('keypress', function(event) { this.manager.onkeypress(event); }, true);
    };

    this._initObserver = function() {
        //register observer
        if (this.observer) return;


        if (typeof gBrowser != "undefined") {
            var self = this;
            gBrowser.addEventListener("SSTabRestored", function(aEvent) {
                var restoredTabUrl = aEvent.originalTarget.linkedBrowser.contentWindow.document.location.href;
                var selectedTabUrl = gBrowser.selectedTab.linkedBrowser.contentWindow.document.location.href;
                self.tabRestored(restoredTabUrl, selectedTabUrl);
            }, false);
        }

        this.observer = new EBBrowserCompObserver_CT2958529(this,
                                                        this.mainNavComplete,
                                                        this.mainDocComplete,
                                                        this.SearchTermChange,
                                                        this.TabChange,
                                                        this.globalKeyChanged,
                                                        this.radioStateChanged,
                                                        this.toolbarHide,
                                                        this.toolbarShow,
                                                        EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true).gBrowser[EBGlobalConsts_CT2958529.WindowId],
                                                        this.keyChanged,
                                                        this.messageTransfer);
        this.observer.register();
    };

    this.unload = function() {
        try {
            if (this.firstClick && this.lastClick) {
                var length = (this.lastClick - this.firstClick) / 1000;
                EBUsageBrowserComponent_CT2958529.OnClick(this.componentId, this.lastClickEvent, this.compType, length);
            }
            this.xulBrowser.removeProgressListener(this);
            this.xulBrowser.removeEventListener('click', function(event) { this.manager.onclick(event); }, true);
            this.xulBrowser.removeEventListener('keypress', function(event) { this.manager.onkeypress(event); }, true);
            this.xulBrowser.manager = null;
            if (this.observer)
                this.observer.unregister();
        }
        catch (e) {
            EBLog(e, "BrowserComp unload");
        }
    };
   
};

EBBrowserCompProgressListener_CT2958529.prototype = new EBBaseBrowserProgressListener_CT2958529();
EBBrowserCompProgressListener_CT2958529.constructor = EBBrowserCompProgressListener_CT2958529;

var EBBrowserComponentConsts_CT2958529 =
{
    Caption: 'Browser Component',

    Images:
	{
	    MiniBrowser: 'chrome://browsersearch/skin/minibrowser.png'
	},

    RegistrySubBranch: 'BackEndStorage.',
    EncryptPass: 'EBEMailNotifierAcc',
    
    ApiFuncTimeout: 1500,

    ErrorRequestOK: '200',
    ErrorNotFound: '404',
    ErrorBadGateway: '502',
    ErorrUpdateServerNotFound: '2152398878',
    
    conduitDir: "conduit",
    localStorageDir: "localStorage",
    appsFilesDir: "appsFiles"
};

var EBBrowserComponentApiManager_CT2958529 =
{
    GetFullPreferencePath: function(strFullUrl, strKey) {
        var objResults = new Object();
        var strFullDomain = "";
        if (strFullUrl) {
            var iEnd = strFullUrl.lastIndexOf("/");
            strFullDomain = strFullUrl.substring(0, iEnd);
            strFullDomain = strFullDomain.replace(/\./g, '_');
            strFullDomain += ".";
        }

        strFullDomain = EBBrowserComponentConsts_CT2958529.RegistrySubBranch + strFullDomain + strKey;

        objResults.fullDomain = strFullDomain.toLowerCase();
        var iEnd = strFullDomain.lastIndexOf("/");
        objResults.virtualPath = strFullDomain.substring(0, iEnd);

        return objResults;
    },

    storeGlobalKey: function(strKey, strValue) {
        var objPreferencePath = this.GetFullPreferencePath(null, strKey);
        var strFullPreferencePath = objPreferencePath.fullDomain;
        var originalValue = strValue;
        strValue = (strValue) ? EBEncryption_CT2958529.encode(strValue) : "";
        EBToolbarPreferenceManager_CT2958529.SetPref(strFullPreferencePath, strValue);
    },

    retrieveGlobalKey: function(strKey) {
        var objPreferencePath = EBBrowserComponentApiManager_CT2958529.GetFullPreferencePath(null, strKey);
        var strFullPreferencePath = objPreferencePath.fullDomain;
        var strValue = EBToolbarPreferenceManager_CT2958529.GetPref(strFullPreferencePath);
        if (strValue) strValue = EBEncryption_CT2958529.decode(strValue);
        return strValue;
    },

    getLocalFilesDir: function(componentId) {
        var plugDir = EBIOManager_CT2958529.GetPrefsDir();
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        //if from marketplace: conduit/localStorage/appsFiles/appguid   else: conduit/localStorage/CTID/compId
        var strComponentPath = plugDir.path + EBDirIO_CT2958529.sep + EBBrowserComponentConsts_CT2958529.conduitDir + EBDirIO_CT2958529.sep + EBBrowserComponentConsts_CT2958529.localStorageDir + EBDirIO_CT2958529.sep;
        var componentObj = oWindow.EBComponentsManager_CT2958529.GetComponentByCompID(componentId);
        strComponentPath += componentObj.componentGuid ?
                            EBBrowserComponentConsts_CT2958529.appsFilesDir + EBDirIO_CT2958529.sep + componentObj.componentGuid :
                            oWindow.EBGlobalConsts_CT2958529.ToolbarCTID + EBDirIO_CT2958529.sep + componentId;
        return strComponentPath;
    },

    addFileToLocalFilesDBFile: function(filePath, fileLegalName, fileContentSize) {
        var arrList = this.readListFileToArray(filePath);
        if (!arrList)
            arrList = new Array();
        for (var i = 0; i < arrList.length; i++) {
            if (arrList[i].indexOf(fileLegalName + ":") != -1) {
                arrList.splice(i, 1);
                break;
            }
        }
        arrList.push(fileLegalName + ":" + fileContentSize);
        this.writeListFileToArray(filePath, arrList);
    },

    removeFileToLocalFilesDBFile: function(filePath, fileLegalName) {
        try {
            var arrList = this.readListFileToArray(filePath);
            if (!arrList || arrList.length == 0) return;
            for (var i = 0; i < arrList.length; i++) {
                if (arrList[i].indexOf(fileLegalName + ":") != -1) {
                    arrList.splice(i, 1);
                    this.writeListFileToArray(filePath, arrList);
                    break;
                }
            }
        } catch (e) { EBLog(e); }
    },

    getFilesNumberAndSizes: function(filePath) {
        try {
            var ans = new Object();
            var arrList = this.readListFileToArray(filePath);
            if (!arrList) {
                ans.filesNumber = 0;
                ans.filesSize = 0;
            }
            else {
                ans.filesNumber = arrList.length;
                var contentsSize = 0;
                for (var i = 0; i < arrList.length; i++) {
                    var arrSplits = arrList[i].split(":");
                    var currentFileSize = arrSplits[1];
                    if (parseInt(currentFileSize))
                        contentsSize += parseInt(currentFileSize);
                }
                ans.filesSize = contentsSize;
            }
            return ans;
        } catch (e) { EBLog(e); }
    },

    isFileExist: function(filePath, localFileName) {
        try {
            var ans = new Object();
            var arrList = this.readListFileToArray(filePath);
            for (var i = 0; i < arrList.length; i++) {
                var arrSplits = arrList[i].split(":");
                var currentFileSize = arrSplits[0];
                if (currentFileSize == localFileName) {
                    return arrSplits[1];
                }
            }
            return -1;
        } catch (e) { EBLog(e); }
    },

    readListFileToArray: function(filePath) {
        try {
            var oFile = EBFileIO_CT2958529.open(filePath + EBDirIO_CT2958529.sep + "filesMenu.json");
            if (!oFile.exists()) {
                EBFileIO_CT2958529.create(oFile);
                return null;
            }


            var strListJson = EBFileIO_CT2958529.read(oFile, "UTF-8");

            if (!strListJson) return null;
            var arrList = null;

            arrList = JSON.parse(strListJson);
        }
        catch (ex) {
            EBLog('readListFileToArray ' + ex);
        }
        return arrList;
    },

    writeListFileToArray: function(filePath, arrList) {
        var oFile = EBFileIO_CT2958529.open(filePath + EBDirIO_CT2958529.sep + "filesMenu.json");
        if (!oFile)
            EBFileIO_CT2958529.create(oFile);
        var strJson = (!arrList || arrList.length == 0) ? "" : "[\"" + arrList.join("\",\"") + "\"]";
        EBFileIO_CT2958529.write(oFile, strJson, null, "UTF-8");
    },

    getLegalizeFileName: function(strName) {
        if (!strName)
            return "";
        strName = strName.replace(/&amp;/g, '_');
        strName = strName.replace(/&apos;/g, '_');
        strName = strName.replace(/\.|\\|\/|\:|\!|\*|\?|\&amp\;|\&|\"|\<|\>|\|/g, "_");
        return strName;
    }
};

function EBBrowserNetworkStateObserver_CT2958529(callbackOnline, callbackNetworkStateChanged) {
    EBBaseObserver_CT2958529.call(this);
    this.Topic = oToolbar_CT2958529.networkConnectivity.topic;

    this.observe = function(aSubject, aTopic, aData) {
        try {
            switch (aData) {
                case oToolbar_CT2958529.networkConnectivity.data.online:
                    callbackOnline();
                    break;
                case oToolbar_CT2958529.networkConnectivity.data.offline:
                    break;
                case oToolbar_CT2958529.networkConnectivity.data.networkStateChanged:
                    callbackNetworkStateChanged();
                    break;
                default: break;
            }
        }
        catch (e) {
            EBLog(e, "EBBrowserNetworkStateObserver");
        }
    }
}

EBBrowserNetworkStateObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();
EBBrowserNetworkStateObserver_CT2958529.constructor = EBBrowserNetworkStateObserver_CT2958529;
function nsIWebProgressListener_CT2958529() {
    this.QueryInterface = function(aIID) {
        if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
       aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
       aIID.equals(Components.interfaces.nsISupports))
            return this;
        throw Components.results.NS_NOINTERFACE;
    };

    this.onStateChange = function(aProgress, aRequest, aFlag, aStatus) { return 0; };
    this.onLocationChange = function(aProgress, aRequest, aURI) { return 0; };
    this.onProgressChange = function(aProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) { return 0; };
    this.onStatusChange = function(aProgress, aRequest, aStatus, aMessage) { return 0; };
    this.onSecurityChange = function(aProgress, aRequest, aState) { return 0; };
    this.onLinkIconAvailable = function() { return 0; };
};
function EBBaseComponentsBuilder_CT2958529(oToolbarData) {
    if (!oToolbarData) return;
    this.XULPostToolbarItem = null;

    this.clearUnwantedXulElements = function(toolbarContainer, componentsContainer) {
        if (!toolbarContainer || !componentsContainer) return;
        while (toolbarContainer.firstChild.id != componentsContainer.id) {
            if (toolbarContainer.firstChild.tagName == EBToolbarBuilderConsts_CT2958529.ToolbarSeparator)
                toolbarContainer.removeChild(toolbarContainer.firstChild);
        }
    };

    this.clearComponents = function(hashComponents, toolbarContainer) {
        if (!hashComponents || hashComponents.Count() == 0) return;

        var component = null;
        for (var i = 0; i < hashComponents.Count(); i++) {
            component = hashComponents.GetByIndex(i);
            component.RemoveFromToolbar(toolbarContainer);
        }

        hashComponents.Clear();
    };

    this.clearContainer = function(toolbarContainer) {
        //empty xulElement that not part of any components (like last element in rtl toolbars)
        while (toolbarContainer.firstChild)
            toolbarContainer.removeChild(toolbarContainer.firstChild);
    };

    this.buildComponents = function(itemsHash, componentsHash, toolbarContainer, index) {
        if (!itemsHash || itemsHash.Count() == 0 || !toolbarContainer) return 0;
        var item = null;
        var counter = 0;
        var component = null;

        if (index < 0) index = 0;
        for (var i = 0; i < itemsHash.Count(); i++) {
            item = itemsHash.GetByIndex(i);
            if (item.isShow()) {
                component = EBToolbarFactoryComponent_CT2958529.GetInstance(item);
                if (component && !componentsHash.Contains(item.UniqueCompID) && component.Init()) {
                    counter++;
                    if (counter > index) {
                        try {
                            componentsHash.Add(item.UniqueCompID, component);
                            component.AddToToolbar(toolbarContainer);

                        }
                        catch (ex) {
                            EBLog(ex, EBToolbarBuilderConsts_CT2958529.BuildCompsError);
                        }
                    }
                }
                if (componentsHash.Contains(item.UniqueCompID))
                    componentsHash.GetByID(item.UniqueCompID).SetComponentCollapsed(false);
            }
            else {
                if (componentsHash.Contains(item.UniqueCompID)) {
                    component = componentsHash.GetByID(item.UniqueCompID);
                    component.RemoveFromToolbar(toolbarContainer);
                    componentsHash.Remove(item.UniqueCompID);
                    counter--;
                }
            }
        }
        return counter;
    };

    this.destroy = function() {
        this.clearComponents(EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash, EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer);
        this.clearContainer(EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer);
    };
};

function EBEngineComponentsBuilder_CT2958529(oToolbarData) {
    EBBaseComponentsBuilder_CT2958529.call(this, oToolbarData);
    var itemPackToEnd = "itemPackToEnd";

    this.build = function(index) {
        this.clearComponents(EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash, EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer);
        this.clearContainer(EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer);
        this.buildComponents(oToolbarData.myStuffItemsHash, EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash, EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer, index);
        if (EBGlobalManager_CT2958529.IsToolbarRTL()) {
            this.XULPostToolbarItem = EBXULFactory_CT2958529.CreateToolbarItem();
            this.XULPostToolbarItem.setAttribute("id", itemPackToEnd);
            this.XULPostToolbarItem.setAttribute("pack", "end");
            this.XULPostToolbarItem.setAttribute("flex", "1");
            EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer.appendChild(this.XULPostToolbarItem);
        }
    };

    this.addDetectedComponent = function(oItem) {
        var oComponent = EBToolbarFactoryComponent_CT2958529.GetInstance(oItem);
        //unknown component
        if (!oComponent) return;
        try {
            if (oComponent.Init()) {
                var itemPackToEndObj = removePackItem(false);
                EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.Add(oComponent.ComponentItem.UniqueCompID, oComponent);
                oComponent.AddToToolbar(EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer);
                EBToolbarManager_CT2958529.myStuffManager.setDetectedComponent(oComponent);
                returnPackItemToEnd(itemPackToEndObj);
            }
        }
        catch (ex) {
            EBLog(ex);
        }
    };

    /*
    this.addOneComponent = function(compId) {
        var isFound = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.Contains(compId);
        var itemPackToEndObj = removePackItem(isFound);
        this.buildComponents(oToolbarData.myStuffItemsHash, EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash, EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer, 0);
        returnPackItemToEnd(itemPackToEndObj);
    };*/

    var insertComponentAtStart = function(component) {
        EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.Insert(0, component.ComponentItem.UniqueCompID, component);
        component.AddToToolbar(EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer, true);
    };

    this.addOneComponent = function(compId) {
        var component = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.GetByID(compId);
        if (component) return;

        var item = oToolbarData.getItem(compId);
        var component = EBToolbarFactoryComponent_CT2958529.GetInstance(item);
        if (component && component.Init())
            insertComponentAtStart(component);
    };

    var removePackItem = function(isFound) {
        var itemPackToEndObj = null;
        if (!isFound && EBGlobalManager_CT2958529.IsToolbarRTL()) {
            var itemPack = document.getElementById(itemPackToEnd);
            if (!itemPack) return null;
            itemPackToEndObj = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer.removeChild(itemPack);
        }
        return itemPackToEndObj;
    };

    var returnPackItemToEnd = function(isFound, itemPackToEndObj) {
        if (!isFound && EBGlobalManager_CT2958529.IsToolbarRTL() && itemPackToEndObj)
            EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer.appendChild(itemPackToEndObj);
    };
};

EBEngineComponentsBuilder_CT2958529.prototype = new EBBaseComponentsBuilder_CT2958529();
EBEngineComponentsBuilder_CT2958529.constructor = EBEngineComponentsBuilder_CT2958529;



function EBToolbarComponentsBuilder_CT2958529(oToolbarData) {
    EBBaseComponentsBuilder_CT2958529.call(this, oToolbarData);
    
    this.build = function(index) {
        this.clearUnwantedXulElements(EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance, EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer);
        //clear old components
        var dto = EBToolbarManager_CT2958529.dataToolbarObject;
        this.clearComponents(dto.ComponentsHash, dto.ComponentsContainer);
        this.clearContainer(dto.ComponentsContainer);

        var publisherItemsHash = oToolbarData.publisherItemsHash;
        var thirdPartyItemsHash = oToolbarData.thirdPartyItemsHash;
        var userItemsHash = oToolbarData.userItemsHash;

        index -= this.buildComponents(publisherItemsHash, dto.ComponentsHash, dto.ComponentsContainer, index);
        index -= this.buildComponents(thirdPartyItemsHash, dto.ComponentsHash, dto.ComponentsContainer, index);
        this.buildComponents(userItemsHash, dto.ComponentsHash, dto.ComponentsContainer, index);

        //add empty flexable component to the end of the toolbar for resizer to work.
        if (EBGlobalManager_CT2958529.IsToolbarRTL()) {
            this.XULPostToolbarItem = EBXULFactory_CT2958529.CreateToolbarItem();
            this.XULPostToolbarItem.setAttribute("pack", "end");
            this.XULPostToolbarItem.setAttribute("flex", "1");
            dto.ComponentsContainer.appendChild(this.XULPostToolbarItem);
        }
    };

//     this.checkForUntrustedApps = function() {
//         if (EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.approveUntrustedApps)) return false;
//         var publisherItemsHash = oToolbarData.publisherItemsHash;
//         var item = null;
//         for (var i = 0; i < publisherItemsHash.Count(); i++) {
//             item = publisherItemsHash.GetByIndex(i);
//             if (item.isUntrusted && item.isShow()) return true;
//         }
//         return false;
//     };
// 
//     this.hideUntrustedApps = function() {
//         var publisherItemsHash = oToolbarData.publisherItemsHash;
//         var item = null;
//         for (var i = 0; i < publisherItemsHash.Count(); i++) {
//             item = publisherItemsHash.GetByIndex(i);
//             if (item.isUntrusted && item.isShow()) 
//                 item.setShowState(false);
//         }
//     };
    
};

EBToolbarComponentsBuilder_CT2958529.prototype = new EBBaseComponentsBuilder_CT2958529();
EBToolbarComponentsBuilder_CT2958529.constructor = EBToolbarComponentsBuilder_CT2958529;



var EBToolbarBuilderConsts_CT2958529 =
{
    ToolbarSeparator: "toolbarseparator",
    BuildCompsError: "failed to add component to toolbar",
    marketPlaceButton: "marketPlaceButton"
};

function EBBaseToolbarData_CT2958529()
{
    //toolbar containers
    this.ToolbarInstance = document.getElementById(EBGlobalConsts_CT2958529.ToolbarId); //whole toolbar
    this.ComponentsContainer = document.getElementById(EBGlobalConsts_CT2958529.ComponentsContainerId);
    this.ComponentsHash = new EBArrayHashObject3_CT2958529();
    
    this.componentContextMenu = null;

    //TODO: remove from here in next versions.
    this.IsHighlighting = false;
};

function EBEngineData_CT2958529() {
    EBBaseToolbarData_CT2958529.call(this);

    this.EngineContainer = document.getElementById(EBGlobalConsts_CT2958529.EngineContainerId);
    this.AddStuffButton = document.getElementById(EBGlobalConsts_CT2958529.EngineAddStuffButtonId);
    this.engineContextMenu = null;
};

EBEngineData_CT2958529.prototype = new EBBaseToolbarData_CT2958529();
EBEngineData_CT2958529.constructor = EBEngineData_CT2958529;


function EBKnownComponents_CT2958529() {
    var hashKnownComponents = new EBArrayHashObject_CT2958529();
    hashKnownComponents.Add("GENERAL_TOOLBAR_INFO", true);
    hashKnownComponents.Add("USER_SETTINGS", true);
    
    hashKnownComponents.Add("DYNAMIC_MENU", true);
    hashKnownComponents.Add("LINK_BUTTONITEM", true);
    hashKnownComponents.Add("SPECIAL_COMMAND_ITEM", true);
    hashKnownComponents.Add("BUTTON", true);
    hashKnownComponents.Add("BROWSER_COMPONENT", true);
    hashKnownComponents.Add("SEARCH", true);
    hashKnownComponents.Add("HIGHLIGHTER", true);
    hashKnownComponents.Add("RSS_FEED_ITEM", true);
    hashKnownComponents.Add("SEPERATORITEM", true);
    hashKnownComponents.Add("PRIVACY_COMPONENT", true);
    hashKnownComponents.Add("EXTERNAL_COMPONENT", true);
    hashKnownComponents.Add("EMAIL_NOTIFIER", true);
    hashKnownComponents.Add("MULTI_RSS", true);
    hashKnownComponents.Add("WEATHER", true);
    hashKnownComponents.Add("LABEL", true);
    hashKnownComponents.Add("RADIO_PLAYER", true);
    hashKnownComponents.Add("MULTI_COMMUNITY", true);
    hashKnownComponents.Add("EMAIL_NOTIFIER_NEW", true);
    hashKnownComponents.Add("TOGGLE_COMPONENT", true);
    hashKnownComponents.Add("CHAT", true);
    hashKnownComponents.Add("TWITTER", true);
    hashKnownComponents.Add("FACEBOOK_COMP", true);
    hashKnownComponents.Add("ALERT_COMP", true);
    hashKnownComponents.Add("ALERT_SETTING_COMP", true);
    hashKnownComponents.Add("TOOLBAR_APP", true);

    this.isKnownComponent = function(tagName) {
        return tagName && hashKnownComponents.Contains(tagName);
    };
};
function EBToolbarData_CT2958529() {
    EBBaseToolbarData_CT2958529.call(this);

    this.MyStuffSplitter = document.getElementById(EBGlobalConsts_CT2958529.MyStuffSplitterId);
    this.MyStuffSeperator = document.getElementById(EBGlobalConsts_CT2958529.MyStuffSeperator);
    this.ToolbarAddStuffButton = document.getElementById(EBGlobalConsts_CT2958529.ToolbarAddStuffButtonId);
    this.OptionsButton = document.getElementById(EBGlobalConsts_CT2958529.OptionsButtonId);
};

EBToolbarData_CT2958529.prototype = new EBBaseToolbarData_CT2958529();
EBToolbarData_CT2958529.constructor = EBToolbarData_CT2958529;

var EBMainMenuPatch_CT2958529 =
{
    MAIN_MENU_ATTR: "EB_MAIN_MENU_COMPONENT",
    MULTICOMMUNITY_ATTR: "EB_MULTICOMMUNITY_COMPONENT",

    onToolbarBuilt: function() {
        setTimeout(function() { EBMainMenuPatch_CT2958529.checkForTwoMenus(); }, 1000);
    },

    isEquals: function(xulMenuButton1, xulMenuButton2) {
        if (xulMenuButton1.image != xulMenuButton2.image) return false;
        if (xulMenuButton1.label != xulMenuButton2.label) return false;
        if (xulMenuButton1.getAttribute("type") != xulMenuButton2.getAttribute("type")) return false;
        if (xulMenuButton1.firstChild && xulMenuButton2.firstChild &&
            xulMenuButton1.firstChild.childNodes.length != xulMenuButton2.firstChild.childNodes.length) return false;

        return true;
    },

    getDeltaTime: function(strDate) {
        if (!strDate) return "";

        var iNow = Date.parse(Date());
        try {
            var iDate = Date.parse(strDate);
            return ((iNow - iDate) / 1000) + " sec";
        }
        catch (ex) {
            return "";
        }
    },

    getLastShownItemIdAndTagName: function() {
        var itemsHash = oToolbarManager_CT2958529.data.publisherItemsHash;
        if (!itemsHash) return null;
        var item = null;
        for (var i = itemsHash.Count() - 1; i >= 0; i++) {
            item = itemsHash.GetByIndex(i);
            if (item.isShow())
                return { "id": item.UniqueCompID, "tagName": (item.objData && item.objData.xmlNode) ? item.objData.xmlNode.tagName : "" };
        }

        return null;
    },

    sendClientLog: function(mainMenu1, mainMenu2) {
        var objToolbarInfo = new oToolbar_CT2958529.clientLog.toolbarInfo(
                    EBGlobalConsts_CT2958529.Version,
                    EBGlobalConsts_CT2958529.ToolbarCTID,
                    EBActionManager_CT2958529.GetCTID(),
                    EBGlobalManager_CT2958529.GetOS(),
                    EBGlobalManager_CT2958529.GetBrowserNameAndVersion());
        var msg = "Found two main menus in Firefox";
        var comp1Id = (mainMenu1.id) ? mainMenu1.id.replace(EBComponentsConsts_CT2958529.ToolbarButtonIDPrefix, "").replace(EBGlobalConsts_CT2958529.ToolbarCTID, "") : "";
        var comp2Id = (mainMenu2.id) ? mainMenu2.id.replace(EBComponentsConsts_CT2958529.ToolbarButtonIDPrefix, "").replace(EBGlobalConsts_CT2958529.ToolbarCTID, "") : "";
        var data = EBXML_CT2958529.CreateXmlNodeStartString("ERR_DESCRIPTION");
        data += EBXML_CT2958529.CreateXmlNodeString("FirstMenuID", comp1Id);
        data += EBXML_CT2958529.CreateXmlNodeString("SecondMenuID", comp2Id);
        data += EBXML_CT2958529.CreateXmlNodeString("SecondMenuHasMainMenuAttr", mainMenu2.hasAttribute(this.MAIN_MENU_ATTR));
        data += EBXML_CT2958529.CreateXmlNodeString("SettingsLastCheckTimeDelta",
                                    this.getDeltaTime(EBToolbarPreferenceManager_CT2958529.GetPref("SettingsLastCheckTime")));
        data += EBXML_CT2958529.CreateXmlNodeString("LastLoginDelta",
                                    this.getDeltaTime(EBToolbarPreferenceManager_CT2958529.GetPref("LastLogin_3.3.2.1")));
        data += EBXML_CT2958529.CreateXmlNodeString("LPLastCheckTimeDelta",
                                    this.getDeltaTime(EBToolbarPreferenceManager_CT2958529.GetPref("LanguagePackLastCheckTime")));
        data += EBXML_CT2958529.CreateXmlNodeString("InstalledDate",
                                    EBToolbarPreferenceManager_CT2958529.GetPref("InstalledDate"));

        var lastShownItemData = this.getLastShownItemIdAndTagName();
        if (lastShownItemData) {
            data += EBXML_CT2958529.CreateXmlNodeStartString("LastShownItem");
            data += EBXML_CT2958529.CreateXmlNodeString("id", lastShownItemData.id);
            data += EBXML_CT2958529.CreateXmlNodeString("tagName", lastShownItemData.tagName);
            data += EBXML_CT2958529.CreateXmlNodeEndString("LastShownItem");
        }

        data += EBXML_CT2958529.CreateXmlNodeEndString("ERR_DESCRIPTION");

        var objEvent = new oToolbar_CT2958529.clientLog.event(50, "ERROR", msg, data);
        oToolbar_CT2958529.clientLog.manager.send(objToolbarInfo, objEvent);
        EBLog("Found two main menus");
    },

    removeSecondMenu: function(mainMenu2) {
        var xulPublisherContainer = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer;
        xulPublisherContainer.removeChild(mainMenu2.parentNode);
    },

    onTwoMenusFound: function(mainMenu1, mainMenu2) {
        this.sendClientLog(mainMenu1, mainMenu2);
        this.removeSecondMenu(mainMenu2);
    },

    checkForTwoMenus: function() {
        try {
            if (isFloatingMode_CT2958529 || EBGlobalConsts_CT2958529.IsEngine) return;
            var xulPublisherContainer = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer;
            var xulItems = xulPublisherContainer.childNodes;
            if (!xulItems || xulItems.length == 0) return;
            var xulItem = null;
            var xulToolbarButton = null;
            var arrMenus = new Array();
            var i;

            for (i = 0; i < xulItems.length; i++) {
                xulItem = xulItems[i];
                if (xulItem.tagName == "toolbaritem" && xulItem.firstChild && xulItem.firstChild.tagName == "toolbarbutton") {
                    xulToolbarButton = xulItem.firstChild;
                    if (xulToolbarButton.getAttribute("type"))
                        arrMenus.push(xulToolbarButton);
                }
            }

            if (arrMenus.length < 2) return;

            var xulFirstMainMenu = null;
            if (arrMenus[0].hasAttribute(this.MULTICOMMUNITY_ATTR)) {
                xulFirstMainMenu = arrMenus[1];
                arrMenus.splice(0, 2);
            }
            else {
                xulFirstMainMenu = arrMenus[0];
                arrMenus.splice(0, 1);
            }

            if (arrMenus.length == 0) return;

            for (i = 0; i < arrMenus.length; i++) {
                if (this.isEquals(xulFirstMainMenu, arrMenus[i])) {
                    this.onTwoMenusFound(xulFirstMainMenu, arrMenus[i])
                    return;
                }
            }
        }
        catch (ex) {
            EBLog(ex);
        }
    }
};

function BaseToolbarManager_CT2958529() {
    this.componentsBuilder = null;
    this.toolbarDataObserver = null;
    this.toolbarComponentsEventsManager = null;
    this.dataToolbarObject = null;
    this.chevronManager = null;
    this.stripSizeManager = null;
    this.init_eventListeners = false;
    this.correntIndex =  0;
    this.contextMenuManager = null;

    this.setUILogic = function() { };
    this.buildToolbar = function(dataObj) { };
    this.onload = function(dataObj) { };
    this.showToolbar = function() { };
    this.hideToolbar = function() { };
    this.onunload = function(bCheckIfShown) { };
    this.onMyStuffChange = function() { };

    this.getToolbarDefaultsData = function() {
        var oToolbarData = new oToolbar_CT2958529.toolbar.toolbarDefaultsData();
        oToolbarData.settingsUrl = EBGlobalConsts_CT2958529.ServerUrl;
        oToolbarData.settingsGETServerUrl = EBGlobalConsts_CT2958529.SettingsGETServerUrl;
        oToolbarData.loginUrl = EBGlobalConsts_CT2958529.ServerUrl;
        oToolbarData.thirdPartyUrl = EBGlobalConsts_CT2958529.ServerUrl;
        oToolbarData.languagePackUrl = EBGlobalConsts_CT2958529.LanguagePackUrl;
        oToolbarData.webServerUrl = EBGlobalConsts_CT2958529.WebServerUrl;
        oToolbarData.myStuffUrl = EBGlobalConsts_CT2958529.MyStuffServiceUrl;
        oToolbarData.myStuffSearchUrl = EBGlobalConsts_CT2958529.MyStuffSearchUrl;
        oToolbarData.myStuffEnabled = EBGlobalConsts_CT2958529.MyStuffEnabled;
        oToolbarData.isMC = EBGlobalConsts_CT2958529.MultiCommunity;
        oToolbarData.isGrouping = EBGlobalConsts_CT2958529.Grouping;
        oToolbarData.version = EBGlobalConsts_CT2958529.Version;
        oToolbarData.chromeName = EBGlobalConsts_CT2958529.ToolbarId;
        oToolbarData.fix404Enabled = EBGlobalConsts_CT2958529.FixPageNotFoundErrorsEnabled;
        oToolbarData.fix404Checked = EBGlobalConsts_CT2958529.FixPageNotFoundErrorsChecked;
        oToolbarData.sendValidationData = true;
        oToolbarData.alertSource = EBAlertManager_CT2958529.MainToolbarID;
        oToolbarData.knownComponents = new EBKnownComponents_CT2958529();
        oToolbarData.searchInNewTab = true;
        oToolbarData.searchServerUrl = EBGlobalConsts_CT2958529.SearchServerUrl;
        oToolbarData.name = EBGlobalConsts_CT2958529.ToolbarName;
        oToolbarData.serviceMapUrl = EBGlobalConsts_CT2958529.ServiceMapUrl;
        oToolbarData.engineCookieDomain = EBGlobalConsts_CT2958529.EngineCookieDomain;
        oToolbarData.ABBaseCTID = EBGlobalConsts_CT2958529.ABBaseCTID;
        oToolbarData.ABTestingCTID = EBGlobalConsts_CT2958529.ABTestingCTID;
        oToolbarData.isFromUpdate = !EBInitializeToolbarManager_CT2958529.IsFirstRun();
        oToolbarData.isSupportOpenAppFromAlert = true;
        oToolbarData.socialDomains = EBGlobalConsts_CT2958529.SocialDomains;
        return oToolbarData;
    };

    this.setToolbarHeight = function(container) {
        var toolbarHeight = 0;
        var floatingWindowHeight = 0;
        if (EBGlobalManager_CT2958529.IsWindowsPlatform()) {
            toolbarHeight = (EBWindows_CT2958529.IsXP()) ? 29 : 28;
            floatingWindowHeight = 30;
        }
        else if (EBGlobalManager_CT2958529.IsMacintoshPlatform()) {
            toolbarHeight = 30;
            floatingWindowHeight = 22;
        }
        else if (EBGlobalManager_CT2958529.IsLinuxPlatform()) {
            toolbarHeight = 34;
            floatingWindowHeight = 30;
        }

        if (!isFloatingMode_CT2958529)
            this.dataToolbarObject.ToolbarInstance.setAttribute("height", toolbarHeight + "px");

        EBChevronConsts_CT2958529.floatingWindowHight = floatingWindowHeight;
    };

    this.addEventListeners = function(isFloatingMode_CT2958529) {
        if (this.init_eventListeners) return;

        this.init_eventListeners = true;

        if (!isFloatingMode_CT2958529) {
            //add to main window progressive listener
            window.getBrowser().addProgressListener(EBMainBrowserListener_CT2958529);
            window.getBrowser().addEventListener("load", EBMainBrowserLoad_CT2958529, true);

            //add to main window progress listener in XPCOM
            //TODO: figure out how to listen to new window open in xpcom, and attach the progress listener from there
            oToolbar_CT2958529.webProgress.manager.addProgressListener(getBrowser());
            var that = this;
            gBrowser.tabContainer.addEventListener("TabSelect", function(event) { that.onTabChange(event); }, false);
        }

        var that = this;
        window.addEventListener("focus", EBWindowFocus_CT2958529, true);
        window.addEventListener("blur", EBWindowBlur_CT2958529, true);
        window.addEventListener("resize", EBWindowResize_CT2958529, false);
        window.addEventListener("mousemove", EBWindowMouseMove_CT2958529, false);
        window.addEventListener("mouseup", EBWindowMouseUp_CT2958529, false);
        window.addEventListener("unload", EBWindowUnLoad_CT2958529, false);

        document.addEventListener("openAppFromAlert", function(e) { that.openGadgetFromAlert(e.data); }, false);
        document.addEventListener("toolbar-dualPackgeChange", function(e) { that.onChangeDualPackgeState(e); }, false);
        document.addEventListener("appsContainerChangeSize", EBWindowResize_CT2958529, false);
        document.addEventListener("resizeContainer", function(e) { EBChevronStaticManager_CT2958529.forceChange(true); }, false);
        var xulDialogsBrowser = document.getElementById("dialogXulBrowser_" + EBGlobalConsts_CT2958529.ToolbarCTID);
        xulDialogsBrowser.addEventListener("load", function(event) { oToolbarManager_CT2958529.dialogsManager.onDialogShow(event, window); }, true);
    };

    this.onTabChange = function(event) {
        var aSubject = EBObserversManager_CT2958529.GetSubject(gBrowser.ebWindowId_CT2958529);
        aSubject.url = gBrowser.getBrowserForTab(event.target).currentURI.spec;
        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
                                                          EBObserversManager_CT2958529.ToolbarEventsTopic,
                                                        EBObserversManager_CT2958529.ToolbarEventsData.TabChange);
        EBToggleComponentManager_CT2958529.TabChange(gBrowser.getBrowserForTab(event.target).contentWindow);
    };

    this.onunload = function(bCheckIfShown) {
        if (bCheckIfShown && !EBActionManager_CT2958529.IsToolbarShown()) return;
        EBActionManager_CT2958529.CloseToolbarDialogs();
        if (this.toolbarDataObserver)
            this.toolbarDataObserver.unregister();
        this.toolbarDataObserver = null;

        if (EBGlobalConsts_CT2958529.IsEngine)
            this._onunload();

        if (this.componentsBuilder)
            this.componentsBuilder.destroy();
        this.componentsBuilder = null;

        this.toolbarComponentsEventsManager = null;

        if (this.stripSizeManager) this.stripSizeManager.OnUnload();
        this.stripSizeManager = null;

        this.dataToolbarObject = null;
        this.contextMenuManager = null;

        if (bCheckIfShown)
            EBSearchFromAddressBar_CT2958529.onunload();

        if (oToolbarManager_CT2958529)
            oToolbarManager_CT2958529.unregister();
        oToolbarManager_CT2958529 = null;
    };

    this.onSettingsChange = function() {
        if (EBActionManager_CT2958529.IsToolbarShown()) this.buildToolbar();
    };

    this.onBeforeRefreshAllWindows = function() {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var oWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            oWindow = arrWindows[i];
            if (oWindow.EBToolbarManager_CT2958529)
                oWindow.EBToolbarManager_CT2958529.onBeforeRefresh();
        }
    };

    this.refreshComponentByIdAllWindows = function(strCompId) {
        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompId);
        if (!oComponent)
            return false;

        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var oWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            oWindow = arrWindows[i];
            if (oWindow.EBToolbarManager_CT2958529) {
                //refreshComponentById will return false if should be refreshed only one instance of the toolbar,
                //meaning that component will handle the broadcast to other instances.
                if (!oWindow.EBToolbarManager_CT2958529.refreshComponentById(strCompId))
                    break;
            }
        }
        return true;
    };

    this.refreshComponentById = function(strCompId) {
        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompId);
        if (oComponent)
            return oComponent.RefreshComponent();

        return true;
    };

    this.onBeforeRefresh = function() {
        if (this.toolbarComponentsEventsManager)
            this.toolbarComponentsEventsManager.onBeforeRefresh();
    };

    this.onShrinkUnshrinkAllWindows = function() {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var oWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            oWindow = arrWindows[i];
            if (oWindow.EBToolbarManager_CT2958529)
                oWindow.EBToolbarManager_CT2958529.onShrinkUnshrink();
        }
    };

    this.onShrinkUnshrink = function() {
        if (EBActionManager_CT2958529.ToolbarShrink())
            EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance.setAttribute("mode", "icons");
        else
            EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance.setAttribute("mode", "full");

        this.toolbarComponentsEventsManager.onShrinkUnshrink();

        //get the toggle command element to change it's caption
        var objShrinkUnshrinkToggleElements = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance.getElementsByAttribute(EBPreferenceConsts_CT2958529.ToolbarShrink, EBPreferenceConsts_CT2958529.ToolbarShrink);
        if (objShrinkUnshrinkToggleElements[0])
            EBDynamicMenuManager_CT2958529.ReDrawToggleCommandElement(objShrinkUnshrinkToggleElements[0]);

        EBChevronStaticManager_CT2958529.onchange(false);
    };

    this.broadcastRebuild = function(strData) {
        var aSubject = new Object();
        aSubject.wrappedJSObject = aSubject;
        aSubject.originalCTID = EBGlobalConsts_CT2958529.ToolbarCTID;
        aSubject.actingCTID = EBActionManager_CT2958529.GetCTID();

        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
                                        oToolbar_CT2958529.toolbarDataParsing.observerTopic,
                                        strData);
    };

    this.onTabsRestore = function(aEvent) {
        EBWebPageApiManager_CT2958529.registerApi(aEvent.originalTarget.linkedBrowser.contentWindow);
    };

    this.componentContextMenuChanged = function(forDefault) {
        if (this.contextMenuManager)
            this.contextMenuManager.updateComponentContextMenu(forDefault);
    };

    this.openGadgetFromAlert = function(guid) {
        var appsList = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash;
        for (var i = 0; i < appsList.Count(); i++) {
            var app = appsList.GetByIndex(i);
            if (app.ComponentItem.componentGuid == guid && app.openAppByDemand && !window.isOpenAppByDemandActivated) {
                window.isOpenAppByDemandActivated = true;
                app.openAppByDemand();
                setTimeout(function() { window.isOpenAppByDemandActivated = false; }, 100);
                return;
            }
        }
    };

    this.onDialogsReady = function() {
        EBInitParams_CT2958529.initFromDialogsReady();
    };
};

function EngineManager_CT2958529() {
    BaseToolbarManager_CT2958529.call(this);
    var unhideToolbar = false;
    this.myStuffManager = null;
    this.detectedItem = null;
    var mBuildingToolbar = false;
    this.mWindowsCounter = 0;
    var bFirstTime = false;

    var showEngineOnToolbarShowing = true;

    this.onload = function(dataObj) {
        var self = this;
        var iTimeout = (DualPackageFunctions_CT2958529.engineOwnerCTID()) ? 20 : 1500;
        setTimeout(function() { self._onLoad(dataObj); }, iTimeout);
    };

    this._onLoad = function(dataObj) {
        DualPackageFunctions_CT2958529.validateEngineOwner(EBGlobalConsts_CT2958529.EngineCTID);
        EBInitParams_CT2958529.initFirstData();
        this.dataToolbarObject = new EBEngineData_CT2958529();
        //toolbar data observer
        this.toolbarDataObserver = new EBToolbarDataObserver_CT2958529();
        this.toolbarDataObserver.register();

        if (!EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EngineOwner))
            DualPackageFunctions_CT2958529.setEngineOwner(EBGlobalConsts_CT2958529.ToolbarCTID, EBGlobalConsts_CT2958529.ToolbarId, EBGlobalConsts_CT2958529.GUID);
        if (!EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.IsEngineShown)) {
            EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsEngineShown, true);
            EBPreferenceForLocalStorage_CT2958529.IsEngineShown = true;
        }

        oToolbarManager_CT2958529 = oToolbar_CT2958529.toolbar.getManager(EBGlobalConsts_CT2958529.ToolbarCTID, EBActionManager_CT2958529.GetCTID(), EBGlobalConsts_CT2958529.IsEngine);
        oToolbarManager_CT2958529.register(this.getToolbarDefaultsData(), EBActionManager_CT2958529.IsToolbarShown());
        this.contextMenuManager = new EBEngineContextMenuManager_CT2958529();

        this.componentsBuilder = new EBEngineComponentsBuilder_CT2958529(oToolbarManager_CT2958529.data);
        this.toolbarComponentsEventsManager = new EBToolbarComponentsEvents_CT2958529();

        if (oToolbarManager_CT2958529.isReady()) {
            this.buildToolbar(dataObj);
            if (dataObj && dataObj.detectedItem) this.addDetectedComponent(dataObj.detectedItem);
        }
    };

    this.onLanguagePackChange = function() {
        EBInitParams_CT2958529.initFromLP();

        //add here global toolbar change
        this.toolbarComponentsEventsManager.onLanguagePackChange();
    };

    this.onclickAdd = function(event) {
        var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        var toolbarManager = win["EBToolbarManager_" + DualPackageFunctions_CT2958529.engineOwnerCTID()];
        if (toolbarManager && DualPackageFunctions_CT2958529.isEngineOnToolbar()) return toolbarManager.onclickAdd(event);

        var SEARCH_TERM_ALIAS = "SEARCH_TERM";
        var strUrl = oToolbarManager_CT2958529.getMyStuffSearchUrl();
        strUrl = EBActionManager_CT2958529.ConvertAliasesUrl(strUrl);
        strUrl = strUrl.replace(SEARCH_TERM_ALIAS, "");
        EBWeb_CT2958529.LoadURLInNewTab(strUrl);

        //usage
        EBUsageMyStuff_CT2958529.AddStuffToolbarClick();
    };

    this.onunload = function(bCheckIfShown) {
        if (bCheckIfShown && !EBActionManager_CT2958529.IsToolbarShown()) return;

        EBActionManager_CT2958529.CloseToolbarDialogs();

        if (this.toolbarDataObserver)
            this.toolbarDataObserver.unregister();
        this.toolbarDataObserver = null;

        if (this.mToolbarShowStateObserver)
            this.mToolbarShowStateObserver.unregister();
        this.mToolbarShowStateObserver = null;

        if (this.mToolbarSkinLoadingObserver)
            this.mToolbarSkinLoadingObserver.unregister();
        this.mToolbarSkinLoadingObserver = null;

        if (this.componentsBuilder)
            this.componentsBuilder.destroy();
        this.componentsBuilder = null;

        this.toolbarComponentsEventsManager = null;

        if (this.stripSizeManager) this.stripSizeManager.OnUnload();
        this.stripSizeManager = null;

        if (this.chevronManager) this.chevronManager.OnUnload();
        this.chevronManager = null;


        //this.dataToolbarObject = null;
        this.contextMenuManager = null;

        if (oToolbarManager_CT2958529)
            oToolbarManager_CT2958529.unregister();

        //oToolbarManager_CT2958529 = null;
    };

    this.buildToolbar = function(dataObj) {
        if (mBuildingToolbar) return;
        mBuildingToolbar = true;

        var index = this.correntIndex;
        var event = null;
        if (dataObj) {
            index = this.correntIndex = dataObj.FirstIndex;
            event = dataObj.event;
        }

        EBUILogic_Toolbar_CT2958529.checkDirection();


        if (!this.myStuffManager)
            this.myStuffManager = new EBMyStuffManager_CT2958529();
        //create chevron managers
        if (!this.chevronManager)
            this.chevronManager = isFloatingMode_CT2958529 ? new EBSecondChevronManager_CT2958529(this.dataToolbarObject.ComponentsContainer,
                                                                    this.dataToolbarObject.ComponentsHash,
                                                                    index) :
                                                          new EBFirstChevronManager_CT2958529(this.dataToolbarObject.ComponentsContainer,
                                                                    this.dataToolbarObject.ComponentsHash,
                                                                    index);

        if (!this.stripSizeManager)
            this.stripSizeManager = EBStripeSizeManagersFactory_CT2958529.getManager(this.dataToolbarObject.ComponentsContainer,
                                                                                    this.dataToolbarObject.ComponentsHash,
                                                                                    DualPackageFunctions_CT2958529.isEngineOnToolbar());

        //Clear Toggle Components
        //TODO: toggle component manager, should not be static, add is as child of component
        EBToggleComponentManager_CT2958529.Clear();
        this.setUILogic();
        this.componentsBuilder.build(index);

        if (isFloatingMode_CT2958529) {
            var container = this.dataToolbarObject.ToolbarInstance;
            container.addEventListener("mouseover", function(event) { window.isMouseIsOnMe = true; }, false);
            container.addEventListener("mouseout", function(event) { window.isMouseIsOnMe = false; }, false);
        }

        //add event listeners only after toolbar build, because events could be dipatched to unexisting components 
        //like chevron which uses search component
        this.addEventListeners(isFloatingMode_CT2958529);
        EBChevronStaticManager_CT2958529.onchange(true);
        EBGadgetsMinimizeManager_CT2958529.onToolbarRebuilt();
        if (!EBGlobalManager_CT2958529.IsToolbarRTL()) EBChevronStaticManager_CT2958529.onWindowResize();
        this.contextMenuManager.onload();
        EBInitParams_CT2958529.initFromSettings();
        EBInitializeToolbarManager_CT2958529.Initialize();
        this.stripSizeManager.postLoad();
        mBuildingToolbar = false;
        oToolbarManager_CT2958529.postBuilt();

    };

    this.setUILogic = function() {
        //skin object
        oToolbarSkin_CT2958529 = oToolbarManager_CT2958529.data.skin;

        if (DualPackageFunctions_CT2958529.isEngineInDualPackage() && isFloatingMode_CT2958529) {
            var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
            var toolbarManager = win["oToolbarManager_" + DualPackageFunctions_CT2958529.engineOwnerCTID()];
            if (toolbarManager) {
                oToolbarSkin = toolbarManager.data.skin;
                EBToolbarCssFunctions_CT2958529.checkToLoadWindowsXPThemeCSSStyleSheet(oToolbarSkin);
                EBUILogic_Toolbar_CT2958529.setToolbarSkin(oToolbarSkin);
            }
        }

        if (isFloatingMode_CT2958529) return;

        if (DualPackageFunctions_CT2958529.isEngineInDualPackage())//dual package and engine wasn't uninstalled
            this.registerToolbarShowState();

        //engine stand alone, show the engine's xul:toolbar
        if (!DualPackageFunctions_CT2958529.isEngineOnToolbar()) {
            this.dataToolbarObject.ToolbarInstance.setAttribute("collapsed", !EBActionManager_CT2958529.IsToolbarShown());
            //move engine's container to it's own xul:toolbar
            if (this.dataToolbarObject.EngineContainer.parentNode.id != this.dataToolbarObject.ToolbarInstance)
                this.dataToolbarObject.ToolbarInstance.appendChild(this.dataToolbarObject.EngineContainer);
        }

        //engine on toolbar
        else {
            if (EBActionManager_CT2958529.IsToolbarShown()) {
                this.engineOnToolbar(false);
            }
            //hide engine's xul:toolbar
            this.dataToolbarObject.ToolbarInstance.setAttribute("collapsed", true);
            var ownerDataToolbarObject = this.ownerDataToolbarObject();
            if (ownerDataToolbarObject) {
                var xulHosterToolbar = ownerDataToolbarObject.ToolbarInstance;
                var engineManager = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().oToolbar_CT2958529.toolbar.getEngineManager(null, true);

                /* if (!EBActionManager_CT2958529.IsToolbarShown()) {
                if (engineManager && engineManager.data.myStuffDataHash.Count() == 0) {
                this.unHideEngine();
                }
                else return;
                }*/
                //move engine's container to toolbar
                if (EBActionManager_CT2958529.IsToolbarShown()) {
                    if (this.dataToolbarObject.EngineContainer.parentNode.id != xulHosterToolbar.id)
                        xulHosterToolbar.appendChild(this.dataToolbarObject.EngineContainer);
                }
            }
        }

        this.updateAddStuffBtn();
        this.setToolbarHeight(this.dataToolbarObject.ComponentsContainer);

        if (DualPackageFunctions_CT2958529.engineOwnerCTID() == EBGlobalConsts_CT2958529.EngineCTID && DualPackageFunctions_CT2958529.isEngineHidingAfterRestart()) {
            DualPackageFunctions_CT2958529.hideShowEngineAfterRestart(false);
            this.hideToolbar(false);
        }
        //the owner was disabled
        else if (!bFirstTime && DualPackageFunctions_CT2958529.engineOwnerCTID() != EBGlobalConsts_CT2958529.EngineCTID && !DualPackageFunctions_CT2958529.getEngineOwnerToolbar()) {
            //if engine is kept and has no apps - hide the engine
            var engineManager = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().oToolbar_CT2958529.toolbar.getEngineManager(null, true);
            if (engineManager && engineManager.data.myStuffDataHash.Count() == 0) {
                this.hideToolbar(true);
                bFirstTime = true;
            }
        }
    };

    this.onMyStuffChange = function() {
        if (!this.componentsBuilder) return;
        this.buildToolbar();
    };

    this.engineContextMenuChanged = function(forDefault) {
        if (this.contextMenuManager)
            this.contextMenuManager.updateHostContextMenu(forDefault);
    };

    this.addDetectedComponent = function(oItem) {
        if (DualPackageFunctions_CT2958529.isEngineOnToolbar()) {
            document.getElementById("MyStuffContainerSplitter_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "";
            document.getElementById("MyStuffContainerSeparator_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "none";
        }
        
        if (!oItem) oItem = oToolbarManager_CT2958529.detectedComponentItem;

        if (!EBActionManager_CT2958529.IsToolbarShown())
            this.unHideEngine();

        this.componentsBuilder.addDetectedComponent(oItem);
        this.contextMenuManager.onload();
        EBChevronStaticManager_CT2958529.onchange(true);
        this.detectedItem = oItem;
    };

    this.unHideEngine = function() {
        unhideToolbar = true;
        DualPackageFunctions_CT2958529.hideShowEngineAfterRestart(false);
        this.showToolbar();
    };

    this.addOneComponent = function(oItem, isOpenPopup ) {
        //if engine is hidden, show it.
        var self = this;
        if (!EBActionManager_CT2958529.IsToolbarShown())
            this.unHideEngine();

        this.componentsBuilder.addOneComponent(oItem.UniqueCompID);
        if (DualPackageFunctions_CT2958529.isEngineOnToolbar()) {
            document.getElementById("MyStuffContainerSplitter_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "";
            document.getElementById("MyStuffContainerSeparator_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "none";
            var comp = EBComponentsManager_CT2958529.GetComponentByCompID(oItem.UniqueCompID);
            var self = this;
            var resizeEngineContainer = function() {
                EBChevronStaticManager_CT2958529.resizeEngineToContent(true);
                self.checkForUntrustedApp(comp, isOpenPopup);

            };
            comp.Onload(resizeEngineContainer);
        }
        else {
            this.checkForUntrustedApp(EBComponentsManager_CT2958529.GetComponentByCompID(oItem.UniqueCompID), isOpenPopup);
        }

        this.contextMenuManager.onload();
    };

    this.checkForUntrustedApp = function(app, isOpenPopup) {
        if (!app.ComponentItem.isUntrusted) {
            if (isOpenPopup || DualPackageFunctions_CT2958529.isEngineOnToolbar()) {
                this.myStuffManager.openAddingAppDialog(app, false);
            }
        }
        else {

            this.myStuffManager.openAddingAppDialog(app, true);
        }
    };

    this.onHideComponent = function() {
        this.componentsBuilder.addOneComponent(false);
        this.contextMenuManager.onload();
        EBChevronStaticManager_CT2958529.onchange(true);

        if (this.dataToolbarObject.ComponentsHash.Count() == 0)
            oToolbarManager_CT2958529._loadMyStuffComponents(true);
    };

    this.removeDetectedComponent = function() {
        //rebuild the toolbar from items hash
        if (!this.componentsBuilder) return;
        this.componentsBuilder.build(0);
        this.contextMenuManager.onload();
        this.detectedItem = null;
    };

    this.onComponentDeleted = function(event) {
        try {
            var data = JSON.parse(event.data);
        }
        catch (exp) {
            EBLog('JSON.parse: ' + exp);
            return;
        }
        var strCompId = data.compId;

        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompId);
        if (!oComponent) return;

        oComponent.OnDelete();
    };

    this.updateAddStuffBtn = function(container) {
        if (isFloatingMode_CT2958529) return;
        var xulButton = this.dataToolbarObject.AddStuffButton;
        if (!xulButton) return;

        var strHint = oToolbarManager_CT2958529.getLPKey("CELP_STR_ID_ENGINE_ADD_APPS_BUTTON_TOOLTIP");
        xulButton.setAttribute("tooltiptext", strHint);
        EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(xulButton);
    };

    this.ownerDataToolbarObject = function() {
        if (DualPackageFunctions_CT2958529.engineOwnerCTID().indexOf(EBGlobalConsts_CT2958529.EngineGUID) != -1)
            return;

        var toolbarWin = window["EBToolbarManager_" + DualPackageFunctions_CT2958529.engineOwnerCTID()];
        if (!toolbarWin) return null;
        return toolbarWin.dataToolbarObject;
    };

    this.registerToolbarShowState = function() {
        var self = this;
        if (this.mToolbarShowStateObserver) return;
        var mainWindowId = DualPackageFunctions_CT2958529.getMainWindowId();
        this.mToolbarShowStateObserver = new EBToolbarShowStateObserver_CT2958529(function() { self.onToolbarHidding(); }, function() { self.onToolbarShowing(); }, mainWindowId);
        this.mToolbarShowStateObserver.register();
        this.mToolbarSkinLoadingObserver = new EBToolbarChevronSkinObserver_CT2958529(function() { self.onToolbarShowing_SkinLoaded(); }, function() { self.onToolbarShowing_SkinUnLoaded(); });
        this.mToolbarSkinLoadingObserver.register();
    };

    this.onToolbarHidding = function() {
        var toolbarDataObj = this.ownerDataToolbarObject();
        if (!toolbarDataObj) return;
        //display engine

        if (this.dataToolbarObject.ComponentsHash.Count() > 0) {
            this.dataToolbarObject.ToolbarInstance.setAttribute("collapsed", false);
            this.dataToolbarObject.ToolbarInstance.appendChild(this.dataToolbarObject.EngineContainer);
            var oToolbox = document.getElementById("navigator-toolbox");
            oToolbox.appendChild(this.dataToolbarObject.ToolbarInstance);
        }
        else
            this.hideToolbar(true);

        EBChevronStaticManager_CT2958529.onchange(false);
        this.engineOffToolbar();

    };

    this.onToolbarShowing = function() {
        //if (!EBActionManager_CT2958529.IsToolbarShown()) return;
        //hide engine strip
        if (!showEngineOnToolbarShowing)
            return;

        this.dataToolbarObject.ToolbarInstance.setAttribute("collapsed", true);
        if (this.dataToolbarObject.ComponentsHash.Count() == 0) {
            //this.dataToolbarObject.EngineContainer.setAttribute("collapsed", false);
            this.showToolbar();
        }
        var xulToolbar = DualPackageFunctions_CT2958529.getEngineOwnerToolbar();
        xulToolbar.appendChild(this.dataToolbarObject.EngineContainer);
        EBChevronStaticManager_CT2958529.onchange(false);
        this.engineOnToolbar(true);
    };

    this.onToolbarShowing_SkinUnLoaded = function() {
        this.chevronManager.setEngineChevronSkinToDefualt();
    };

    this.onToolbarShowing_SkinLoaded = function() {
        this.chevronManager.CreateChevronElement();
    };

    //SHOW ENGINE
    this.showToolbar = function() {
        EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsEngineShown, true);
        EBPreferenceForLocalStorage_CT2958529.IsEngineShown = true;
        showEngineOnToolbarShowing = true;
        if (unhideToolbar || !DualPackageFunctions_CT2958529.isEngineOnToolbar()) {
            this.dataToolbarObject.ToolbarInstance.setAttribute("collapsed", false);
            if (this.dataToolbarObject.EngineContainer.getAttribute("collapsed"))
                this.dataToolbarObject.EngineContainer.setAttribute("collapsed", false);

            unhideToolbar = false;
        }
        else
            this.dataToolbarObject.EngineContainer.setAttribute("collapsed", false);
        oToolbarManager_CT2958529.onEngineShown();
        //    this.onload();
        this.engineOnToolbar(true);
        this.stripSizeManager.postLoad();

    };

    //HIDE ENGINE
    this.hideToolbar = function(force) {
        //dual package - both shown - deleting all apps from engine
        if (!force && DualPackageFunctions_CT2958529.isEngineInDualPackage() && DualPackageFunctions_CT2958529.isEngineOnToolbar())
            return;

        if (this.dataToolbarObject.ComponentsHash.Count() == 0 && !DualPackageFunctions_CT2958529.isEngineVisible())
            showEngineOnToolbarShowing = false;

        this.dataToolbarObject.ToolbarInstance.setAttribute("collapsed", true)
        this.dataToolbarObject.EngineContainer.setAttribute("collapsed", true);

        if (DualPackageFunctions_CT2958529.isEngineInDualPackage() && DualPackageFunctions_CT2958529.getEngineOwnerToolbar())
            this.engineOffToolbar();
        oToolbarManager_CT2958529.onEngineHiden();
        var optionsDialog = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName(EBToolbarOptionsDialogConsts_CT2958529.DialogType, EBToolbarOptionsDialogConsts_CT2958529.DialogName);
        if (optionsDialog) optionsDialog.close();
        EBGlobalManager_CT2958529.DispatchEvent(window, "appsContainerChangeSize", null);
        EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsEngineShown, false);
        EBPreferenceForLocalStorage_CT2958529.IsEngineShown = false;
    };

    this.engineOnToolbar = function(rebuildStipeManager, forceShow) {
        if (!DualPackageFunctions_CT2958529.getEngineOwnerToolbar() || !DualPackageFunctions_CT2958529.isEngineInDualPackage() || !DualPackageFunctions_CT2958529.isEngineOnToolbar())
            return;
        if (DualPackageFunctions_CT2958529.isEngineVisible()) {
            var that = this;
            setTimeout(function() {
            if (that.dataToolbarObject.ComponentsHash.Count() != 0) {
                    document.getElementById("MyStuffContainerSplitter_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "";
                    document.getElementById("MyStuffContainerSeparator_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "none";
                }
                else if (that.dataToolbarObject.ComponentsHash.Count() == 0 || forceShow) {
                    document.getElementById("MyStuffContainerSplitter_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "none";
                    document.getElementById("MyStuffContainerSeparator_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "";
                }
            }, 10);
        }
        document.getElementById("conduitToolbarAddStuffBtn_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "none";

        //handle stripe manager
        if (rebuildStipeManager) {
            this.stripSizeManager.OnUnload();
            this.stripSizeManager = new EBDualPackageStripeSizeManager_CT2958529(this.dataToolbarObject.ComponentsContainer, this.dataToolbarObject.ComponentsHash);
            this.stripSizeManager.postLoad();
        }

        EBGlobalManager_CT2958529.DispatchEvent(window, "toolbar-dualPackgeChange", "true");
    };

    this.engineOffToolbar = function() {
        if (!DualPackageFunctions_CT2958529.getEngineOwnerToolbar() || !DualPackageFunctions_CT2958529.isEngineInDualPackage())
            return;
   
        document.getElementById("MyStuffContainerSplitter_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "none";
        document.getElementById("MyStuffContainerSeparator_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "none";
        document.getElementById("conduitToolbarAddStuffBtn_" + DualPackageFunctions_CT2958529.engineOwnerCTID()).style.display = "none";

        this.stripSizeManager.OnUnload();
        this.stripSizeManager = new EBToolbarStripeSizeManager_CT2958529(this.dataToolbarObject.ComponentsContainer, this.dataToolbarObject.ComponentsHash);
        this.stripSizeManager.postLoad();
        EBGlobalManager_CT2958529.DispatchEvent(window, "toolbar-dualPackgeChange", "false");
    };
};

EngineManager_CT2958529.prototype = new BaseToolbarManager_CT2958529();
EngineManager_CT2958529.constructor = EngineManager_CT2958529;

var EBManagersFactory_CT2958529 =
{
    getInstance: function (isEngine) {
        return (isEngine) ? new EngineManager_CT2958529() : new ToolbarManager_CT2958529();
    }
};
function ToolbarManager_CT2958529() {
    BaseToolbarManager_CT2958529.call(this);
    var mBuildingToolbar = false;
    var mIsSettingsReady = false;
    var mOpeningApprovalDialog = false;


    this.onload = function(dataObj) {
        DualPackageFunctions_CT2958529.validateEngineOwner(EBActionManager_CT2958529.GetCTIDForServices());
        if (!isFloatingMode_CT2958529)
            EBInitParams_CT2958529.initFirstData();

        this.dataToolbarObject = new EBToolbarData_CT2958529();

        //toolbar data observer
        this.toolbarDataObserver = new EBToolbarDataObserver_CT2958529();
        this.toolbarDataObserver.register();

        //regular
        if (!(dataObj && dataObj.url && dataObj.interval)) {
            oToolbarManager_CT2958529 = oToolbar_CT2958529.toolbar.getManager(EBGlobalConsts_CT2958529.ToolbarCTID, EBActionManager_CT2958529.GetCTID(), EBGlobalConsts_CT2958529.IsEngine);
        }
        //AIO
        else {
            EBGlobalConsts_CT2958529.IsEngine = false;
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CTID, dataObj.ctid);
            oToolbarManager_CT2958529 = oToolbar_CT2958529.toolbar.getAIOManager(EBGlobalConsts_CT2958529.ToolbarCTID, dataObj.ctid, dataObj.url, dataObj.interval);
        }

        var defaultsData = this.getToolbarDefaultsData()
        // for AB testing (check if testing toolbar is already was installed)
        if (EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.testingCtid) &&
                EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.testingCtid) != defaultsData.ABTestingCTID) {
            oToolbarManager_CT2958529.cleanDataForSwitchTesatingToolbars(defaultsData.ABTestingCTID);
            var EngineOwnerCtid = defaultsData.ABBaseCTID ? defaultsData.ABBaseCTID : "CT2958529";
            if (DualPackageFunctions_CT2958529.engineOwnerCTID() == EngineOwnerCtid)
                DualPackageFunctions_CT2958529.setEngineOwner(EngineOwnerCtid, EBGlobalConsts_CT2958529.ToolbarId, EBGlobalConsts_CT2958529.GUID);
        }
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.testingCtid, defaultsData.ABTestingCTID);

        oToolbarManager_CT2958529.register(this.getToolbarDefaultsData(), EBActionManager_CT2958529.IsToolbarShown());
        if (!isAIOMode_CT2958529)
            this.contextMenuManager = new EBToolbarContextMenuManager_CT2958529();
        this.componentsBuilder = new EBToolbarComponentsBuilder_CT2958529(oToolbarManager_CT2958529.data);
        this.toolbarComponentsEventsManager = new EBToolbarComponentsEvents_CT2958529();

        if (oToolbarManager_CT2958529.isReady())
            this.buildToolbar(dataObj);
    };

    this.setUILogic = function() {
        //skin object
        oToolbarSkin_CT2958529 = oToolbarManager_CT2958529.data.skin;

        if (!isFloatingMode_CT2958529 && EBGlobalConsts_CT2958529.MyStuffEnabled) {
            if (!DualPackageFunctions_CT2958529.isToolbarInDualPackage()) {
                if (oToolbarSkin_CT2958529.myStuffImageUrl)
                    this.dataToolbarObject.ToolbarAddStuffButton.firstChild.setAttribute("image", oToolbarSkin_CT2958529.myStuffImageUrl);
                this.dataToolbarObject.ToolbarAddStuffButton.style.display = "";
                this.dataToolbarObject.ToolbarAddStuffButton.firstChild.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_ADD_STUFF_TOOLTIP"));
            }
        }

        if (oToolbarManager_CT2958529.data.generalToolbarInfo.myStuffEnabled)
            this.addStuffBtnOnToolbar();
        else
            this.addStuffBtnOffToolbar();

        //only toolbar sets the skin
        EBToolbarCssFunctions_CT2958529.checkToLoadWindowsXPThemeCSSStyleSheet(oToolbarSkin_CT2958529);
        EBUILogic_Toolbar_CT2958529.setToolbarSkin(oToolbarSkin_CT2958529);

        this.setToolbarHeight(this.dataToolbarObject.ComponentsContainer);
        if (!isFloatingMode_CT2958529)
            this.dataToolbarObject.OptionsButton.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_OPEN_OPTIONS"));
    };

    /*********************************************ONLY FOR TOOLBARS THAT AREN'T IN DUAL PACKAGE*******************************/
    this.addStuffBtnOnToolbar = function() {
        if (DualPackageFunctions_CT2958529.isToolbarInDualPackage() || isFloatingMode_CT2958529)
            return;

        document.getElementById("MyStuffContainerSeparator_" + EBGlobalConsts_CT2958529.ToolbarCTID).style.display = "";
        if (oToolbarSkin_CT2958529.myStuffImageUrl && this.dataToolbarObject.ToolbarAddStuffButton)
            this.dataToolbarObject.ToolbarAddStuffButton.firstChild.setAttribute("image", oToolbarSkin_CT2958529.myStuffImageUrl);
        else
            document.getElementById("conduitToolbarAddStuffBtn_" + EBGlobalConsts_CT2958529.ToolbarCTID).style.display = "";
    };

    this.addStuffBtnOffToolbar = function() {
        if (DualPackageFunctions_CT2958529.isToolbarInDualPackage() || isFloatingMode_CT2958529)
            return;

        document.getElementById("MyStuffContainerSeparator_" + EBGlobalConsts_CT2958529.ToolbarCTID).style.display = "none";
        if (oToolbarSkin_CT2958529.myStuffImageUrl && this.dataToolbarObject.ToolbarAddStuffButton)
            this.dataToolbarObject.ToolbarAddStuffButton.firstChild.style.display = "none";
        else
            document.getElementById("conduitToolbarAddStuffBtn_" + EBGlobalConsts_CT2958529.ToolbarCTID).style.display = "none";
    };
    /*************************************************************************************************************************/

    this.onThirdPartyChange = function() { };
    
    this.switchCommunity = function() {
        this.onunload(false);
        this.onload();
        EBWebPageApiManager_CT2958529.reregisterApi();
        EBChevronStaticManager_CT2958529.onWindowResize(null);
    };

    this.buildToolbar = function(dataObj) {
        mIsSettingsReady = true;
        if (mBuildingToolbar) return;
        mBuildingToolbar = true;

        var index = this.correntIndex;
        var isMyStuff = false;
        var event = null;
        if (dataObj) {
            index = this.correntIndex = dataObj.FirstIndex;
            event = dataObj.event;
        }
        EBUILogic_Toolbar_CT2958529.checkDirection();


        //create chevron managers
        if (!this.chevronManager)
            this.chevronManager = isFloatingMode_CT2958529 ? new EBSecondChevronManager_CT2958529(this.dataToolbarObject.ComponentsContainer,
                                                                    this.dataToolbarObject.ComponentsHash,
                                                                    index) :
                                                          new EBFirstChevronManager_CT2958529(this.dataToolbarObject.ComponentsContainer,
                                                                    this.dataToolbarObject.ComponentsHash,
                                                                    index);

        if (!this.stripSizeManager)
            this.stripSizeManager = EBStripeSizeManagersFactory_CT2958529.getManager(this.dataToolbarObject.ComponentsContainer,
                                                                                    this.dataToolbarObject.ComponentsHash,
                                                                                    DualPackageFunctions_CT2958529.isToolbarInDualPackage() && DualPackageFunctions_CT2958529.isEngineVisible());
        if (!isFloatingMode_CT2958529 && DualPackageFunctions_CT2958529.isToolbarInDualPackage() && DualPackageFunctions_CT2958529.isEngineVisible()) {
            var that = this;
            document.addEventListener("toolbar-dualPackgeChange", function(e) { that.onChangeDualPackgeState(e); }, false);
        }

        //Clear Toggle Components
        //TODO: toggle component manager, should not be static, add is as child of component
        EBToggleComponentManager_CT2958529.Clear();
        this.setUILogic();


        this.componentsBuilder.build(index);

        //add event listeners only after toolbar build, because events could be dipatched to unexisting components 
        //like chevron which uses search component
        this.addEventListeners(isFloatingMode_CT2958529);

        EBChevronStaticManager_CT2958529.onchange(true);

        EBMainMenuPatch_CT2958529.onToolbarBuilt();
        EBGadgetsMinimizeManager_CT2958529.onToolbarRebuilt();
        if (!EBGlobalManager_CT2958529.IsToolbarRTL()) EBChevronStaticManager_CT2958529.onWindowResize();


        if (!isFloatingMode_CT2958529)
            EBInitParams_CT2958529.initFromSettings();

        EBSearchFromAddressBar_CT2958529.onload();
        EBInitializeToolbarManager_CT2958529.Initialize();

        if (isFloatingMode_CT2958529) {
            var container = this.dataToolbarObject.ToolbarInstance;
            container.addEventListener("mouseover", function(event) { window.isMouseIsOnMe = true; }, false);
            container.addEventListener("mouseout", function(event) { window.isMouseIsOnMe = false; }, false);
        }

        if (!isAIOMode_CT2958529)
            this.contextMenuManager.onload();

        this.stripSizeManager.postLoad();
        mBuildingToolbar = false;
        oToolbarManager_CT2958529.postBuilt();
//         if (oToolbarManager_CT2958529.dialogsManager.isDialogsReady() && !mOpeningApprovalDialog)
//             this.openUntrustedApprovalDialog();
    };

//     this.openUntrustedApprovalDialog = function() {
//         if (!isFloatingMode_CT2958529 && EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.FirstTime) && this.componentsBuilder.checkForUntrustedApps()) {
//             mOpeningApprovalDialog = true;
//             setTimeout(function() {
// 
//                 var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
//                 var ToolbarUTAppUpdateDialogId = "ToolbarUntrustedAppsApprovalDialog";
//                 var dialogData = oToolbarManager_CT2958529.dialogsManager.getDialogDataManager(ToolbarUTAppUpdateDialogId);
//                 if (!dialogData) {
//                     EBLog("error - dialogs were supposed to be here already");
//                     return;
//                 }
//                 var toolbar = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
//                 var fallbackCoordinates = { "isRTL": EBActionManager_CT2958529.IsToolbarRTL(), "x": EBActionManager_CT2958529.IsToolbarRTL() ? toolbar.boxObject.screenX + toolbar.boxObject.width : toolbar.boxObject.screenX, "y": toolbar.boxObject.screenY + toolbar.boxObject.height };
//                 var oMainMenu = EBComponentsManager_CT2958529.GetMainMenuComponent();
//                 var strDialogOpenType = (EBGlobalConsts_CT2958529.IsAMO) ? "dependent," : "modal,";
//                 var strParams = stringFormat("{0}resizable=no,titlebar=yes,", strDialogOpenType);
// 
//                 dialogData.showDialogWinBaseWithPosition(oWindow, 0, 0, false, oToolbarManager_CT2958529, strParams, oMainMenu, oWindow.EBChevronStaticManager_CT2958529, fallbackCoordinates);
//                 oWindow.windowOpen = true;
//             }, 100);
//         }
//     };

    this.onunload = function(bCheckIfShown) {
        if (bCheckIfShown && !EBActionManager_CT2958529.IsToolbarShown()) return;
        //if DUP - engine is kept and has no apps - hide the engine
        if (DualPackageFunctions_CT2958529.isToolbarInDualPackage() && DualPackageFunctions_CT2958529.isEngineInDualPackage()) {
            var engineManager = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().oToolbar_CT2958529.toolbar.getEngineManager(null, true);
            if (engineManager && engineManager.data.myStuffDataHash.Count() == 0) {
                DualPackageFunctions_CT2958529.hideShowEngineAfterRestart(true);
            }
            else if (engineManager && engineManager.data.myStuffDataHash.Count() > 0 && DualPackageFunctions_CT2958529.isEngineHidingAfterRestart()) {
                DualPackageFunctions_CT2958529.hideShowEngineAfterRestart(false);
            }
        }


        EBActionManager_CT2958529.CloseToolbarDialogs();
        if (this.toolbarDataObserver)
            this.toolbarDataObserver.unregister();
        this.toolbarDataObserver = null;

        if (this.componentsBuilder)
            this.componentsBuilder.destroy();
        this.componentsBuilder = null;

        this.toolbarComponentsEventsManager = null;

        if (this.chevronManager) this.chevronManager.OnUnload();
        this.chevronManager = null;

        this.dataToolbarObject = null;
        this.contextMenuManager = null;

        if (bCheckIfShown)
            EBSearchFromAddressBar_CT2958529.onunload();

        if (oToolbarManager_CT2958529)
            oToolbarManager_CT2958529.unregister();
        oToolbarManager_CT2958529 = null;
    };

    this.onLanguagePackChange = function() {
        if (!isFloatingMode_CT2958529)
            EBInitParams_CT2958529.initFromLP();

        //add here global toolbar change
        this.toolbarComponentsEventsManager.onLanguagePackChange();
    };

    this.showToolbar = function() {
        //this.onload();
    };

    this.hideToolbar = function() {
        this.dataToolbarObject.ToolbarInstance.setAttribute("collapsed", true);
        var optionsDialog = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName(EBToolbarOptionsDialogConsts_CT2958529.DialogType, EBToolbarOptionsDialogConsts_CT2958529.DialogName);
        if (optionsDialog) optionsDialog.close();
    };

    this.onUserAddedComponentsChanged = function() {
        this.buildToolbar();
    };

    this.onclickAdd = function(event) {
        var SEARCH_TERM_ALIAS = "SEARCH_TERM";
        var strUrl = oToolbarManager_CT2958529.getMyStuffSearchUrl();
        strUrl = EBActionManager_CT2958529.ConvertAliasesUrl(strUrl);
        strUrl = strUrl.replace(SEARCH_TERM_ALIAS, "");
        EBWeb_CT2958529.LoadURLInNewTab(strUrl);

        //usage
        EBUsageMyStuff_CT2958529.AddStuffToolbarClick();
    };

    this.toolbarContextMenuChanged = function(forDefault) {
        if (this.contextMenuManager && !isAIOMode_CT2958529)
            this.contextMenuManager.updateHostContextMenu(forDefault);
    };

    this.appsContextMenuChanged = function(forDefault, type) {
        var appsContextMenu = "";
        switch (type) {
            case oToolbarManager_CT2958529.metaDataConsts.appTypes.getAppsContextMenu:
                appsContextMenu = oToolbarManager_CT2958529.metaDataConsts.appTypes.getAppsContextMenu;
                break;
            case oToolbarManager_CT2958529.metaDataConsts.appTypes.postAppsContextMenu:
                appsContextMenu = oToolbarManager_CT2958529.metaDataConsts.appTypes.postAppsContextMenu;
                break;
            case oToolbarManager_CT2958529.metaDataConsts.appTypes.unsharedAppsContextMenu:
                appsContextMenu = oToolbarManager_CT2958529.metaDataConsts.appTypes.unsharedAppsContextMenu;
                break;
            default: break;
        }

        if (this.contextMenuManager && !isAIOMode_CT2958529)
            this.contextMenuManager.updateComponentContextMenu(forDefault, appsContextMenu);
    };

    this.showErrorMessage = function(event) {
        if (isAIOMode_CT2958529) {
            var param = window.arguments[0][0];
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            if (ChevronStaticManager.AIOWindows.Contains(param.ctid)) {
                var WinObj = ChevronStaticManager.AIOWindows.GetByID(param.ctid);
                param.parentComp.showErrorMessage(window, param.bgWin);
            }
        }
    };

    this.onChangeDualPackgeState = function(event) {
        var isInDualPackge = parseBool(event.data);
        this.stripSizeManager.OnUnload();
        this.stripSizeManager = (isInDualPackge&& DualPackageFunctions_CT2958529.isToolbarInDualPackage()) ? new EBDualPackageStripeSizeManager_CT2958529(this.dataToolbarObject.ComponentsContainer, this.dataToolbarObject.ComponentsHash) :
                                                 new EBToolbarStripeSizeManager_CT2958529(this.dataToolbarObject.ComponentsContainer, this.dataToolbarObject.ComponentsHash);
        this.stripSizeManager.postLoad();
    };

    this.hideUntrustedApps = function() {
//         this.componentsBuilder.hideUntrustedApps();
//         this.buildToolbar();
    };


    this.onDialogsReady = function() {
        EBInitParams_CT2958529.initFromDialogsReady();
        if (mIsSettingsReady && !mOpeningApprovalDialog)
            this.openUntrustedApprovalDialog();

    };

    this.__defineGetter__("mOpeningApprovalDialog", function() {
        return mOpeningApprovalDialog;
    });

    this.__defineSetter__("mOpeningApprovalDialog", function(val) {
        mOpeningApprovalDialog = val;
    });
};

ToolbarManager_CT2958529.prototype = new BaseToolbarManager_CT2958529();
ToolbarManager_CT2958529.constructor = ToolbarManager_CT2958529;
function EBToolbarDataObserver_CT2958529() {
    this.Topic = oToolbar_CT2958529.toolbarDataParsing.observerTopic;

    this.observe = function(aSubject, aTopic, aData) {
        aSubject = aSubject.wrappedJSObject;
        if (aSubject.originalCTID.toUpperCase() != EBGlobalConsts_CT2958529.ToolbarCTID.toUpperCase() ||
             aSubject.actingCTID.toUpperCase() != EBActionManager_CT2958529.GetCTID().toUpperCase())
            return;

        switch (aData) {
            case oToolbar_CT2958529.toolbarDataParsing.observerData.settings:
                EBToolbarManager_CT2958529.onSettingsChange();
                break;

            case oToolbar_CT2958529.toolbarDataParsing.observerData.userAddComponents:
                EBToolbarManager_CT2958529.onUserAddedComponentsChanged();
                break;

            case oToolbar_CT2958529.toolbarDataParsing.observerData.thirdParty:
                EBToolbarManager_CT2958529.onThirdPartyChange();
                break;

            case oToolbar_CT2958529.toolbarDataParsing.observerData.myStuff:
                EBToolbarManager_CT2958529.onMyStuffChange();
                break;

            case oToolbar_CT2958529.toolbarDataParsing.observerData.languagePack:
                EBToolbarManager_CT2958529.onLanguagePackChange();
                break;

            case oToolbar_CT2958529.toolbarDataParsing.observerData.dialogsReady:
                EBToolbarManager_CT2958529.onDialogsReady();
                break;

            case oToolbar_CT2958529.toolbarDataParsing.observerData.switchCommunity:
                EBToolbarManager_CT2958529.switchCommunity();
                break;

            case oToolbar_CT2958529.toolbarDataParsing.observerData.componentContextMenuChanged:
                EBToolbarManager_CT2958529.componentContextMenuChanged(false);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.engineContextMenuChanged:
                EBToolbarManager_CT2958529.engineContextMenuChanged(false);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.componentContextMenuChangedForDefault:
                EBToolbarManager_CT2958529.componentContextMenuChanged(true);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.engineContextMenuChangedForDefault:
                EBToolbarManager_CT2958529.engineContextMenuChanged(true);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.toolbarContextMenuChanged:
                EBToolbarManager_CT2958529.toolbarContextMenuChanged(false);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.postAppsContextMenuChanged:
                EBToolbarManager_CT2958529.appsContextMenuChanged(false, oToolbarManager_CT2958529.metaDataConsts.appTypes.postAppsContextMenu);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.getAppsContextMenuChanged:
                EBToolbarManager_CT2958529.appsContextMenuChanged(false, oToolbarManager_CT2958529.metaDataConsts.appTypes.getAppsContextMenu);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.unsharedAppsContextMenuChanged:
                EBToolbarManager_CT2958529.appsContextMenuChanged(false, oToolbarManager_CT2958529.metaDataConsts.appTypes.unsharedAppsContextMenu);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.toolbarContextMenuChangedForDefault:
                EBToolbarManager_CT2958529.toolbarContextMenuChanged(true);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.postAppsContextMenuChangedForDefault:
                EBToolbarManager_CT2958529.appsContextMenuChanged(true, oToolbarManager_CT2958529.metaDataConsts.appTypes.postAppsContextMenu);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.getAppsContextMenuChangedForDefault:
                EBToolbarManager_CT2958529.appsContextMenuChanged(true, oToolbarManager_CT2958529.metaDataConsts.appTypes.getAppsContextMenu);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.unsharedAppsContextMenuChangedForDefault:
                EBToolbarManager_CT2958529.appsContextMenuChanged(true, oToolbarManager_CT2958529.metaDataConsts.appTypes.unsharedAppsContextMenu);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.hideEngine:
                EBToolbarManager_CT2958529.hideToolbar();
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.showEngine:
                EBToolbarManager_CT2958529.showToolbar();
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.newApp:
                EBToolbarManager_CT2958529.addOneComponent(aSubject.wrappedJSObject.oItem, aSubject.wrappedJSObject.isPopup);
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.hideApp:
                EBToolbarManager_CT2958529.onHideComponent();
                break;
            case oToolbar_CT2958529.toolbarDataParsing.observerData.ErrInAIOsettings:
                EBToolbarManager_CT2958529.showErrorMessage();
                break;
            default: break;
        }
    };
};

EBToolbarDataObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();

function EBToolbarShowStateObserver_CT2958529(callbackToolbarHide, callbackToolbarShow, conduitWinId) {
  //  EBBaseObserver_CT2958529.call(this);
    this.Topic = EBObserversManager_CT2958529.DualPackageTopic;
    this.windowId = conduitWinId;

    this.observe = function(aSubject, aTopic, aData) {
        try {
            if (!aSubject || !this.windowId || this.windowId == aSubject.wrappedJSObject.windowId) {
                switch (aData) {
                    case EBObserversManager_CT2958529.DualPackageData.ToolbarHide:
                        if (!callbackToolbarHide) break;
                        callbackToolbarHide();
                        break;
                    case EBObserversManager_CT2958529.DualPackageData.ToolbarShow:
                        if (!callbackToolbarShow) break;
                        callbackToolbarShow();
                        break;
                    default: break;
                }
            }
        }
        catch (e) {
            EBLog(e, "EBToolbarShowStateObserver");
        }
    }
}

EBToolbarShowStateObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();
//EBToolbarShowStateObserver_CT2958529.constructor = EBToolbarShowStateObserver_CT2958529();
function EBToolbarComponentsEvents_CT2958529() {
    var onBeforeRefresh = function(componentsHash) {
        if (!componentsHash || componentsHash.Count() == 0) return;
        
        for (var i = 0; i < componentsHash.Count(); i++)
            componentsHash.GetByIndex(i).OnBeforeRefresh();
    };

    var onLanguagePackChange = function(componentsHash) {
        if (!componentsHash || componentsHash.Count() == 0) return;

        for (var i = 0; i < componentsHash.Count(); i++)
            componentsHash.GetByIndex(i).OnLanguagePackChange();
    };

    var onShrinkUnshrink = function(componentsHash) {
        if (!componentsHash || componentsHash.Count() == 0) return;

        for (var i = 0; i < componentsHash.Count(); i++)
            componentsHash.GetByIndex(i).SetToolbarButtonClass();
    };

    this.onBeforeRefresh = function() {
        if (EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash)
            onBeforeRefresh(EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash);
    };

    this.onLanguagePackChange = function() {
        if (EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash)
            onLanguagePackChange(EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash);
    };

    this.onShrinkUnshrink = function() {
        if (EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash)
            onShrinkUnshrink(EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash);
    };
};
var EBToolbarFactoryComponent_CT2958529 =
{
    GetInstance: function(oToolbarItem) {
        if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.dynamicMenu)
            return new EBDynamicMenuComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.button)
            return new EBButtonComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.browserComponent)
            return  EBGlobalConsts_CT2958529.IsEngine ? new EBEngineBrowserComponent_CT2958529(oToolbarItem) : new EBToolbarBrowserComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.searchBox)
            return new EBSearchBoxComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.highlighter)
            return new EBHighlighterComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.separator)
            return new EBSeparatorComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.feed)
            return new EBFeedComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.privacy)
            return new EBPrivacyComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.externalComponent)
            return new EBExternalComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.emailNotifier)
            return new EBEMailNotifierComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.multiFeed)
            return new EBMultiFeedComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.weather)
            return new EBWeatherComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.label)
            return new EBLabelComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.radio)
            return new EBRadioComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.multicommunity)
            return new EBMultiCommunityComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.toggleComponent)
            return new EBToggleComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.chat)
            return new EBChatComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.myStuffWithOptions)
            return new EBMyStuffWithOptionsComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.myStuff)
            return new EBMyStuffComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.twitter)
            return new EBTwitterComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.facebook)
            return new EBFacebookComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.alertSetting)
            return new EBAlertSettingComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.allInOne)
            return new EBAlInOneComponent_CT2958529(oToolbarItem);
        else if (oToolbarItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.logo)
            return new EBLogoComponent_CT2958529(oToolbarItem);
        return null;
        
    }
};

var EBToolbarManager_CT2958529 = null;

function EBChatObserver_CT2958529(objCallback, that) {
    this.Topic = "EBChat";
    this.thatCallback = that;
    this.callback = objCallback;

	this.observe = function(aSubject, aTopic, strCTID) {
	    try {
	        if (strCTID == EBActionManager_CT2958529.GetCTID()) {
	            this.callback.call(this.thatCallback, aSubject);
	        }
	    }
	    catch (err) { }
	};
}

EBChatObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();
var EBChatStaticManager_CT2958529 =
{
    OnToolbarRefresh: function(bInvalidateCache) {
        var oChat = EBComponentsManager_CT2958529.GetChatComponent();
        if (!oChat) return;

        oChat.onToolbarRefresh(bInvalidateCache);
    },

    ForceRefresh: function() {
        var oChat = EBComponentsManager_CT2958529.GetChatComponent();
        if (!oChat) return;

        oChat.reInit(true);
    }
}
function ChatMenuUIManager_CT2958529(chatComponent) {
    this.chatManager = null;
    this.xulMenuPopup = null;
    this.componentId = "";
    this.compType = "";
    this.buttonId = "";
    this.iconUrl = "";
    this.defaultRoom = null;

    this.init = function(objChatManager, xulButton, strCompId, strCompType, objDefaultRoom) {
        this.chatManager = objChatManager;
        this.componentId = strCompId;
        this.buttonId = xulButton.getAttribute("id");
        this.iconUrl = xulButton.getAttribute("image");
        this.defaultRoom = objDefaultRoom;

        this._correctDefaultRoomData(xulButton);
        this._createMainButtonCommand(xulButton);
        this._createDynamicMenuPopup(xulButton);
    };

    //used for toolbar <---> chevron
    this.updateMenuPopup = function(xulMenuPopup) {
        this.xulMenuPopup = xulMenuPopup;
    };

    //populate menu on menu showing event, get the latest data from the core
    this.onMenuShowing = function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBGadgetsMinimizeManager_CT2958529.preventGadgetsPreview = true;
        var objRoomsData = this.chatManager.getRoomsInfo();
        var objProvidersRoomsData = this.chatManager.getProvidersRoomsInfo();
        this._buildMenuItems(objRoomsData, objProvidersRoomsData);
        EBUsageChat_CT2958529.OnOpenMenu();
    };

    //remove all items from the menu
    this.onMenuHiding = function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBGadgetsMinimizeManager_CT2958529.preventGadgetsPreview = false;
        this._removeMenuItems();
        //usage
        var compId = this.componentId;
        var compType = this.compType;
        var oTimed = function() {
            EBUsageChat_CT2958529.OnCloseMenu(compId, compId, compType);
        };

        setTimeout(oTimed, 200);
    };

    //add label and/or image to the default room if not exists
    this._correctDefaultRoomData = function(xulButton) {
        if (!this.defaultRoom.name)
            this.defaultRoom.name = xulButton.getAttribute("label");

        if (!this.defaultRoom.iconUrl)
            this.defaultRoom.iconUrl = xulButton.getAttribute("image");
    };

    this._createMainButtonCommand = function(xulButton) {
        //add open default chat room to button, after initing the menu, because the function is in menu object
        var objCommand = this.getCommand(this.defaultRoom, EBUsageChat_CT2958529.SourceButton);
        xulButton.addEventListener("command", objCommand, false);
    };

    this._createDynamicMenuPopup = function(xulButton) {
        //set the event to the popupmenu for usage
        var strOnPopupShowing = "this.manager.onMenuShowing()";
        var strOnPopupHiding = "this.manager.onMenuHiding()";
        this.xulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", strOnPopupShowing, strOnPopupHiding);
        this.xulMenuPopup.manager = this;
        
        xulButton.appendChild(this.xulMenuPopup);
    };

    this._buildMenuItems = function(objRoomsData, objProvidersRoomsData) {
        if (objRoomsData && (objRoomsData.publisherRooms || objRoomsData.publicRooms)) {
            //add publisher rooms
            this._buildRoomsMenuItems(objRoomsData.publisherRooms, objProvidersRoomsData);

            //add separator between publisher rooms and public rooms
            if (objRoomsData.publisherRooms && objRoomsData.publicRooms)
                this.xulMenuPopup.appendChild(EBXULFactory_CT2958529.CreateMenuSeparator());

            //add public rooms
            this._buildRoomsMenuItems(objRoomsData.publicRooms, objProvidersRoomsData);
        }
        //create one default room
        else
            this._buildDefaultRoomMenuItem();
    };

    this._buildRoomsMenuItems = function(hashRooms, objProvidersRoomsData) {
        var oRoomData = null;
        var iParticipantsCount;
        var oProvider = null;
        var objProviderRoomData = null;

        if (hashRooms) {
            for (var i = 0; i < hashRooms.Count(); i++) {
                oRoomData = hashRooms.GetByIndex(i);
                iParticipantsCount = null;
                if (oRoomData.providerRoomInfo && objProvidersRoomsData) {
                    oProvider = objProvidersRoomsData.GetByID(oRoomData.providerRoomInfo.providerType);
                    if (oProvider) {
                        objProviderRoomData = oProvider.roomsDataHash.GetByID(oRoomData.providerRoomInfo.roomId);
                        if (objProviderRoomData)
                            iParticipantsCount = objProviderRoomData.participants;
                    }
                }

                this.xulMenuPopup.appendChild(this._buildMenuItem(oRoomData, iParticipantsCount));
            }
        }
    };

    this._buildDefaultRoomMenuItem = function() {
        this.xulMenuPopup.appendChild(this._buildMenuItem(this.defaultRoom, null));
    };

    this._buildMenuItem = function(oRoomData, iParticipantsCount) {
        var strLabel = oRoomData.name;
        var strParticipants = this._getMenuItemParticipantsCaption(iParticipantsCount);
        var strImage = oRoomData.iconUrl;
        var strTooltip = oRoomData.name;
        var objCommand = this.getCommand(oRoomData, EBUsageChat_CT2958529.SourceMenu);
        var strName = "";
        var arrData = null;

        var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strLabel, strImage, strTooltip, objCommand, strName, arrData);
        xulMenuItem.setAttribute("acceltext", strParticipants);
        if (EBGadgetsMinimizeManager_CT2958529.hasMinimizedGadget(this.componentId, oRoomData.id)) {

            var position = (EBGlobalManager_CT2958529.IsToolbarRTL()) ? EBCanvas_CT2958529.positionFlags.topRight : EBCanvas_CT2958529.positionFlags.topLeft;
            var icon = (EBGlobalManager_CT2958529.IsToolbarRTL()) ? EBGadgetsMinimizeManager_CT2958529.menuItemNotificationIconRTL : EBGadgetsMinimizeManager_CT2958529.menuItemNotificationIcon;
            EBImageHandler_CT2958529.SetStar(xulMenuItem, icon, position);
        }

        return xulMenuItem;
    };

    //create command to open chat gadget from chat room data
    this.getCommand = function(oRoomData, strSource) {
        var strUrl = EBActionManager_CT2958529.ConvertAliasesUrl(oRoomData.url);
        var popHtmlData = new oToolbar_CT2958529.toolbarDataParsing.dataObjects.PopHtml();
        popHtmlData.popHtmlUrl = this._convertAliasesUrl(strUrl);
        popHtmlData.parentElement = chatComponent.XULElement;
        popHtmlData.openPositionType = popHtmlData.openPositionTypes.alignment;
        popHtmlData.openPositionData.vertical = popHtmlData.openPositionTypes.verticalAlignmentBottom;
        popHtmlData.width = 700;
        popHtmlData.height = 560;
        popHtmlData.minimizable = true;
        popHtmlData.resizable = true;
        popHtmlData.isUser = false;
        popHtmlData.componentId = this.componentId;
        popHtmlData.elementId = this.componentId;
        popHtmlData.compType = this.compType;
        popHtmlData.source = strSource;
        popHtmlData.gadgetType = EBGadgetManager_CT2958529.GADGET_TYPE_CHAT;
        popHtmlData.chatRoomId = oRoomData.id;
        popHtmlData.titleIconUrl = this.iconUrl;
        var strButtonId = this.buttonId;
        var commandFunc = function(event) {
            popHtmlData.parentElement = document.getElementById(strButtonId);
            EBGadgetManager_CT2958529.OpenGadget(popHtmlData);
            event.cancelBubble = true;
        };

        return commandFunc;
    };

    this._convertAliasesUrl = function(strUrl) {
        strUrl = EBActionManager_CT2958529.ConvertAliasesUrl(strUrl);
        return strUrl;
    };

    this._getMenuItemParticipantsCaption = function(iParticipantsCount) {
        if (iParticipantsCount != null && iParticipantsCount != -1)
            return "[" + iParticipantsCount + "]";
        else
            return "";
    };
    
    this._removeMenuItems = function() {
        while (this.xulMenuPopup.childNodes.length > 0)
            this.xulMenuPopup.removeChild(this.xulMenuPopup.firstChild);
    };
};
function EngineComponentContextMenuHelper_CT2958529(e) {
    var menuPopup = e.target;
    var compId = EBToolbarManager_CT2958529.contextMenuManager.contextMenuCompId;
    menuPopup.contextComponentId = compId;

    //set the context component ID to all the items recursive
    var handleMenuItem = function(xulMenuItem) {
        xulMenuItem.contextComponentId = compId;
        var strCommand = xulMenuItem.getAttribute("eb-command");
        switch (strCommand) {
            //move left               
            case EBSpecialCommands_CT2958529.CE_MOVE_LEFT_COMPONENT_CMD:
                if (!isFloatingMode_CT2958529 && ((EBComponentsManager_CT2958529.IsFirstComponent(compId) && !EBGlobalManager_CT2958529.IsToolbarRTL())
                || (EBComponentsManager_CT2958529.IsLastComponent(compId) && EBGlobalManager_CT2958529.IsToolbarRTL())))
                    xulMenuItem.setAttribute("disabled", true);
                else
                    xulMenuItem.setAttribute("disabled", false);
                break;
            //move right               
            case EBSpecialCommands_CT2958529.CE_MOVE_RIGHT_COMPONENT_CMD:
                if ((EBComponentsManager_CT2958529.IsLastComponent(compId) && !EBGlobalManager_CT2958529.IsToolbarRTL())
                || (EBComponentsManager_CT2958529.IsFirstComponent(compId) && EBGlobalManager_CT2958529.IsToolbarRTL()))
                    xulMenuItem.setAttribute("disabled", true);
                else
                    xulMenuItem.setAttribute("disabled", false);
                break;
            //more from this publisher
            case EBSpecialCommands_CT2958529.CE_MORE_FROM_THIS_PUBLISHER_CMD:
            case EBSpecialCommands_CT2958529.CM_MORE_FROM_THIS_PUBLISHER_CMD:
                var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(compId);
                if (!oComponent) return;

                //disable this menu-item in case that no url available
                if (!oComponent.ComponentItem.publisherInfo.moreFromThisPublisherUrl)
                    xulMenuItem.setAttribute("disabled", true);
                else
                    xulMenuItem.setAttribute("disabled", false);

                if (!xulMenuItem.hasAttribute("savedLabel"))
                    xulMenuItem.setAttribute("savedLabel", xulMenuItem.getAttribute("label"));

                var strCaption = xulMenuItem.getAttribute("savedLabel");
                
                if (oComponent.ComponentItem && oComponent.ComponentItem.publisherInfo && oComponent.ComponentItem.publisherInfo.publisherName)
                    strCaption = strCaption.replace(/EB_PUBLISHER_NAME/g, oComponent.ComponentItem.publisherInfo.publisherName);
                else
                    strCaption = oToolbarManager_CT2958529.getLPKey("CELP_STR_ID_ENGINE_CONTEXT_MENU_COMP_MORE_PUBLISHER_CAPTION");

                xulMenuItem.setAttribute("label", strCaption);
                break;
            case EBSpecialCommands_CT2958529.CE_SHARE_COMPONENT_CMD:
                var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(compId);
                if (!oComponent) return;

                //disable this menuitem if no info available
                if (!oComponent.ComponentItem.compPageUrl)
                    xulMenuItem.setAttribute("disabled", true);
                else
                    xulMenuItem.setAttribute("disabled", false);

                //save component info to use later in DynamicMenuComponent oncommand
                xulMenuItem.ebComponent = oComponent;
                break;
            default: break;
        }
    };

    var setContextCompIdToMenu = function(xulMenu) {
        var xulMenuItem = null;
        for (var i = 0; i < xulMenu.childNodes.length; i++) {
            xulMenuItem = xulMenu.childNodes[i];

            if (xulMenuItem.tagName.toLowerCase() == "menuitem")
                handleMenuItem(xulMenuItem);
            else {
                setContextCompIdToMenu(xulMenuItem);
            }
        }
    };



    
    setContextCompIdToMenu(menuPopup);
};
function ToolbarComponentContextMenuHelper_CT2958529(e) {
    var menuPopup = e.target;
    var compId = EBToolbarManager_CT2958529.contextMenuManager.contextMenuCompId;
    menuPopup.contextComponentId = compId;
    
    //set the context component ID to all the items recursive
    var handleMenuItem = function(xulMenuItem) {
        xulMenuItem.contextComponentId = compId;
        xulMenuItem.ebComponent = EBComponentsManager_CT2958529.GetComponentByCompID(compId);
        var strCommand = xulMenuItem.getAttribute("eb-command");
        switch (strCommand) {
            //options       
            case EBSpecialCommands_CT2958529.OPTIONS:
                if (!isFloatingMode_CT2958529)
                    xulMenuItem.setAttribute("disabled", true);
                else
                    xulMenuItem.setAttribute("disabled", false);
                break;
            //refresh toolbar          
            case EBSpecialCommands_CT2958529.REFRESH_TOOLBAR_VIEW:
                if (!isFloatingMode_CT2958529)
                    xulMenuItem.setAttribute("disabled", true);
                else
                    xulMenuItem.setAttribute("disabled", false);
                break;
            //more from this publisher       
            case EBSpecialCommands_CT2958529.CM_MORE_FROM_THIS_PUBLISHER_CMD:
                var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(compId);
                if (!oComponent) return;
                //disable this menu-item in case that no url available
                if (!oComponent.ComponentItem.publisherInfo.moreFromThisPublisherUrl)
                    xulMenuItem.setAttribute("disabled", true);
                else
                    xulMenuItem.setAttribute("disabled", false);

                if (!xulMenuItem.hasAttribute("savedLabel"))
                    xulMenuItem.setAttribute("savedLabel", xulMenuItem.getAttribute("label"));

                var strCaption = xulMenuItem.getAttribute("savedLabel");
                if (oComponent.ComponentItem.publisherInfo.publisherName)
                    strCaption = strCaption.replace(/EB_PUBLISHER_NAME/g, oComponent.ComponentItem.publisherInfo.publisherName);
                else
                    strCaption = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_TOOLBAR_NEW_CONTEXT_MENU_MORE_FROM_PUBLISHER");

                xulMenuItem.setAttribute("label", strCaption);
                break;
            default: break;
        }
    };

    var setContextCompIdToMenu = function(xulMenu) {
        var xulMenuItem = null;
        for (var i = 0; i < xulMenu.childNodes.length; i++) {
            xulMenuItem = xulMenu.childNodes[i];
            
            if (xulMenuItem.tagName.toLowerCase() == "menuitem")
                handleMenuItem(xulMenuItem);
            else
                setContextCompIdToMenu(xulMenuItem);
        }
    };

    setContextCompIdToMenu(menuPopup);
};
function EngineContextMenuHelper_CT2958529(e) {};
function ToolbarContextMenuHelper_CT2958529(e) {
    var menuPopup = e.target;

    //set the context component ID to all the items recursive
    var handleMenuItem = function(xulMenuItem) {
        xulMenuItem.isToolbar = true;
        var strCommand = xulMenuItem.getAttribute("eb-command");
        switch (strCommand) {
            //options     
            case EBSpecialCommands_CT2958529.OPTIONS:
                if (!isFloatingMode_CT2958529)
                    xulMenuItem.setAttribute("disabled", true);
                else
                    xulMenuItem.setAttribute("disabled", false);
                break;
            //refresh toolbar     
            case EBSpecialCommands_CT2958529.REFRESH_TOOLBAR_VIEW:
                if (!isFloatingMode_CT2958529)
                    xulMenuItem.setAttribute("disabled", true);
                else
                    xulMenuItem.setAttribute("disabled", false);
                break;
            default: break;
        }
    };

    var setContextCompIdToMenu = function(xulMenu) {
        var xulMenuItem = null;
        for (var i = 0; i < xulMenu.childNodes.length; i++) {
            xulMenuItem = xulMenu.childNodes[i];
            if (xulMenuItem.tagName.toLowerCase() == "menuitem")
                handleMenuItem(xulMenuItem);
        }
    };

    setContextCompIdToMenu(menuPopup);
};
function EBBaseContextMenuManager_CT2958529()
{
    this.mHostContextMenuId = null;
    this.mComponentContextMenuId = null;

    this.setUsagesClass = function(dynamicMenuComponent, id) { };

    this.addContextPopup = function(dynamicMenuComponent, id, onPopupShowingCallback) {
        var menuPopup = dynamicMenuComponent.XULElement.firstChild;
        var strMainPopupSetID = EBComponentsConsts_CT2958529.MainPopupSetID;
        var objMainPopupSet = document.getElementById(strMainPopupSetID);
        var oldMenuPopup = document.getElementById(id);

        this.setUsagesClass(dynamicMenuComponent, id);

        //remove the old one if exists
        var eventName = (EBGlobalManager_CT2958529.IsFirefox36()) ? "popupshowing" : "popupshown";
        if (oldMenuPopup && objMainPopupSet) {
            oldMenuPopup.removeEventListener(eventName, onPopupShowingCallback, false);
            objMainPopupSet.removeChild(oldMenuPopup)
        }

        menuPopup.setAttribute("id", id);

        menuPopup.addEventListener(eventName, function(e) { onPopupShowingCallback(e); e.cancelBubble = true; }, false);
        objMainPopupSet.appendChild(menuPopup);
        menuPopup.style.direction = (EBGlobalManager_CT2958529.IsToolbarRTL()) ? "rtl" : "ltr";
    };

    this.addContextMenuToComponents = function() { };

    this.addContextMenuToHost = function() { };

    this.updateHostContextMenu = function() { };
    this.updateComponentContextMenu = function(forDefault) { };

    this.onload = function() { };

    this.addContextEventListener = function() {
        EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer.addEventListener("contextmenu", function(event) {
            var compId = event.target.getAttribute("eb-comp-id");
            if (compId)
                EBToolbarManager_CT2958529.contextMenuManager.contextMenuCompId = compId;
        }, false);
    };

    this.onRebuild = function() {
        this.addContextMenuToComponents();
    };
};

function EBEngineContextMenuManager_CT2958529() {
    EBBaseContextMenuManager_CT2958529.call(this);

    this.mComponentContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBComponentContextMenuId;
    this.mHostContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBEngineContextMenuId;

    this.updateComponentContextMenu = function(forDefault) {
        var oItem = oToolbarManager_CT2958529.data.componentContextMenuItem;
        if (!oItem) return;

        var _componentContextMenuComp = new EBDynamicMenuComponent_CT2958529(oItem);
        if (!_componentContextMenuComp.Init()) {
            EBLog("app context menu init failed");
            if (!forDefault) oToolbarManager_CT2958529.loadDefaultAppContextMenu();
            return;
        }
        var onPopupshowingCallback = function(e) {
            var clickedElement = e.explicitOriginalTarget;
            var compId = clickedElement.getAttribute("EB_COMP_ID");
        };
        this.addContextPopup(_componentContextMenuComp, this.mComponentContextMenuId, EngineComponentContextMenuHelper_CT2958529);
    };

    this.updateHostContextMenu = function(forDefault) {
        var oItem = oToolbarManager_CT2958529.data.engineContextMenuItem;
        if (!oItem) return;

        var _engineContextMenuComp = new EBDynamicMenuComponent_CT2958529(oItem);
        if (!_engineContextMenuComp.Init()) {
            EBLog("engine context menu init failed");
            if (!forDefault) oToolbarManager_CT2958529.loadDefaultEngineContextMenu();
            return;
        }

        var onPopupshowingCallback = function(e) {
            var oToolbar = e.explicitOriginalTarget;
        };
        this.addContextPopup(_engineContextMenuComp, this.mHostContextMenuId, EngineContextMenuHelper_CT2958529);
    };

    this.addContextMenuToComponents = function() {
        var componentHash = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash;
        if (!componentHash || componentHash.Count() == 0) return;

        for (var i = 0; i < componentHash.Count(); i++)
            componentHash.GetByIndex(i).AddContextMenu(this.mComponentContextMenuId);
    };

    this.addContextMenuToHost = function() {
        var oToolbar = EBToolbarManager_CT2958529.dataToolbarObject.EngineContainer;
        if (oToolbar)
            oToolbar.setAttribute("context", this.mHostContextMenuId);
        else {
            var oChevron = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
            oChevron.setAttribute("context", this.mHostContextMenuId);
        }
    };

    this.setUsagesClass = function(dynamicMenuComponent, id) {
        if (id == this.mHostContextMenuId)
            dynamicMenuComponent.changeUsagesclass(EBUsageEngineContextMenu_CT2958529);
        if (id == this.mComponentContextMenuId)
            dynamicMenuComponent.changeUsagesclass(EBUsageComponentContextMenu_CT2958529);
    };

    this.onload = function() {
        this.updateComponentContextMenu();
        this.updateHostContextMenu();

        this.addContextMenuToComponents();
        this.addContextMenuToHost();

        this.addContextEventListener();
    };
};
EBEngineContextMenuManager_CT2958529.prototype = new EBBaseContextMenuManager_CT2958529();
EBEngineContextMenuManager_CT2958529.constructor = EBEngineContextMenuManager_CT2958529;

function EBToolbarContextMenuManager_CT2958529() {
    EBBaseContextMenuManager_CT2958529.call(this);

    this.mComponentContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBComponentContextMenuId;
    this.mHostContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBToolbarContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID;
    var mIsAddContextMenuToComponents = false;

    var isMataDataServiceOn = false;
    var listOfUpdatesComponentContextMenuForDefault = new Array();
    var listOfUpdatesComponentContextMenuForType = new Array();

    var isFirstTime = true;
    this.firstCompInit = true;

    this.updateComponentContextMenu = function(forDefault, type) {
        var that = this;

        this.addContextPopUp = function(itemName, strComponentContextMenuId, appType) {
            var oItem = oToolbarManager_CT2958529.data[itemName];
            if (!oItem) return;

            var _componentContextMenuComp = new EBDynamicMenuComponent_CT2958529(oItem);
            if (!_componentContextMenuComp.Init()) {
                EBLog("app context menu init failed");
                if (!forDefault) oToolbarManager_CT2958529.loadDefaultAppContextMenu(appType);
                return;
            }
            var onPopupshowingCallback = function(e) {
                var clickedElement = e.explicitOriginalTarget;
                var compId = clickedElement.getAttribute("EB_COMP_ID");
            };

            that.addContextPopup(_componentContextMenuComp, strComponentContextMenuId, ToolbarComponentContextMenuHelper_CT2958529);
        };


        var itemName = "";
        var helper = "";
        var strComponentContextMenuId = "";

        switch (type) {
            case oToolbarManager_CT2958529.metaDataConsts.appTypes.getAppsContextMenu:
                itemName = oToolbarManager_CT2958529.metaDataConsts.itemsTypes.getAppsContextMenuItem;
                strComponentContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBToolbarComponentContextMenuId.EBGetComponentContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID;
                break;
            case oToolbarManager_CT2958529.metaDataConsts.appTypes.postAppsContextMenu:
                itemName = oToolbarManager_CT2958529.metaDataConsts.itemsTypes.postAppsContextMenuItem;
                strComponentContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBToolbarComponentContextMenuId.EBPostComponentContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID;
                break;
            case oToolbarManager_CT2958529.metaDataConsts.appTypes.unsharedAppsContextMenu:
                itemName = oToolbarManager_CT2958529.metaDataConsts.itemsTypes.unsharedAppsContextMenuItem;
                strComponentContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBToolbarComponentContextMenuId.EBOtherComponentContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID;
                break;
            default: break;
        }
        if (typeof (type) != "undefined")
            this.addContextPopUp(itemName, strComponentContextMenuId, type);
        else {
            this.addContextPopUp(oToolbarManager_CT2958529.metaDataConsts.itemsTypes.getAppsContextMenuItem, oToolbarManager_CT2958529.metaDataConsts.EBToolbarComponentContextMenuId.EBGetComponentContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID, oToolbarManager_CT2958529.metaDataConsts.appTypes.getAppsContextMenu);
            this.addContextPopUp(oToolbarManager_CT2958529.metaDataConsts.itemsTypes.postAppsContextMenuItem, oToolbarManager_CT2958529.metaDataConsts.EBToolbarComponentContextMenuId.EBPostComponentContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID, oToolbarManager_CT2958529.metaDataConsts.appTypes.postAppsContextMenu);
            this.addContextPopUp(oToolbarManager_CT2958529.metaDataConsts.itemsTypes.unsharedAppsContextMenuItem, oToolbarManager_CT2958529.metaDataConsts.EBToolbarComponentContextMenuId.EBOtherComponentContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID, oToolbarManager_CT2958529.metaDataConsts.appTypes.unsharedAppsContextMenu);
        }

    };

    this.updateHostContextMenu = function(forDefault) {
        var oItem = oToolbarManager_CT2958529.data.toolbarContextMenuItem;
        if (!oItem) return;

        var _toolbarContextMenuComp = new EBDynamicMenuComponent_CT2958529(oItem);

        if (!_toolbarContextMenuComp.Init()) {
            EBLog("toolbar context menu init failed");
            if (!forDefault) oToolbarManager_CT2958529.loadDefaultToolbarContextMenu();
            return;
        }

        var onPopupshowingCallback = function(e) {
            var oToolbar = e.explicitOriginalTarget;
        };

        this.addContextPopup(_toolbarContextMenuComp, this.mHostContextMenuId, ToolbarContextMenuHelper_CT2958529);
    };

    this.addContextMenuToComponents = function(appsMetaDataUpdatedIds) {
        var componentHash = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash;
        if (!componentHash || componentHash.Count() == 0) return;
        var strComponentContextMenuId = "";

        for (var i = 0; i < componentHash.Count(); i++) {
            var strComponentContextMenuId = "";
            switch (componentHash.GetByIndex(i).ComponentItem.appMetaDataType) {
                case oToolbarManager_CT2958529.metaDataConsts.appTypes.getAppsContextMenu:
                    strComponentContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBToolbarComponentContextMenuId.EBGetComponentContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID;
                    break;
                case oToolbarManager_CT2958529.metaDataConsts.appTypes.postAppsContextMenu:
                    strComponentContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBToolbarComponentContextMenuId.EBPostComponentContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID;
                    break;
                default: strComponentContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBToolbarComponentContextMenuId.EBOtherComponentContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID;
                    break;
            }
            componentHash.GetByIndex(i).AddContextMenu(strComponentContextMenuId);
        }
    };

    this.setUsagesClass = function(dynamicMenuComponent, id) {
        if (id == this.mHostContextMenuId)
            dynamicMenuComponent.changeUsagesclass(EBUsageToolbarContextMenu_CT2958529);
        else
            dynamicMenuComponent.changeUsagesclass(EBUsageComponentContextMenu_CT2958529);
    };
    
    this.addContextMenuToHost = function() {
        EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer.setAttribute("context", this.mHostContextMenuId);
        if (EBGlobalConsts_CT2958529.MyStuffEnabled && EBToolbarManager_CT2958529.dataToolbarObject.ToolbarAddStuffButton && EBToolbarManager_CT2958529.dataToolbarObject.ToolbarAddStuffButton.style.display == "")
            EBToolbarManager_CT2958529.dataToolbarObject.ToolbarAddStuffButton.firstChild.setAttribute("context", this.mHostContextMenuId);
    };


    this.onload = function() {
        this.updateComponentContextMenu();
        this.updateHostContextMenu();
        this.addContextMenuToComponents();
        this.addContextMenuToHost();

        this.addContextEventListener();
    };
};

EBToolbarContextMenuManager_CT2958529.prototype = new EBBaseContextMenuManager_CT2958529();
EBToolbarContextMenuManager_CT2958529.constructor = EBToolbarContextMenuManager_CT2958529;

var EBDefaultsManager_CT2958529 = {
    defaultsFolder: "chrome://browsersearch/skin/defaults/",

    manifestFileName: "manifest.xml",

    settingsFilePath: "",
    imagesHash: null,

    isInit: false,
    isImagesInit: false,
    isSettingsInit: false,

    checkIcon: function(xulElement) {
        //lazy init
        if (!this.isInit) this.init();
        if (!this.isImagesInit) return;

        var strImageUrl = "";
        if (xulElement.tagName == "image")
            strImageUrl = xulElement.getAttribute("src");
        else
            strImageUrl = xulElement.getAttribute("image");
        //if no icon defined, nothing to check
        if (!strImageUrl) return;

        //find if icon is in defaults, if not, return
        var strFullLocalPath = this.checkFileAndGetFullPath(strImageUrl);
        if (!strFullLocalPath) return;

        xulElement.setAttribute("image", strFullLocalPath);
    },

    getImageUrl: function(strImageUrl) {
        //lazy init
        if (!this.isInit) this.init();
        if (!this.isImagesInit) return strImageUrl;

        var strFullLocalPath = this.checkFileAndGetFullPath(strImageUrl);

        if (strFullLocalPath)
            return strFullLocalPath;
        else
            return strImageUrl;
    },

    checkFileAndGetFullPath: function(strIconUrl) {
        if (!this.imagesHash || this.imagesHash.Count() == 0 || !this.imagesHash.Contains(strIconUrl)) return "";

        var strLocalPath = this.imagesHash.GetByID(strIconUrl);
        if (strLocalPath)
            return this.defaultsFolder + strLocalPath.replace(/\\/g, "/");
        else
            return "";
    },

    getAndCopySettingsFile: function() {
        //lazy init
        if (!this.isInit) this.init();
        if (!this.isSettingsInit) return null;
        var xmlSettings = EBXML_CT2958529.GetXmlDocumentFromUrl(this.defaultsFolder + this.settingsFilePath);
        var oFile = null;

        if (xmlSettings)
            oFile = this.copySettingsFile(xmlSettings);

        return oFile;
    },

    //copy the settings file from defaults and delete it in defaults
    copySettingsFile: function(xmlSettings) {
        try {
            var strSettings = EBXML_CT2958529.GetStringXml(xmlSettings);
            var oDestFile = EBIOManager_CT2958529.CreateToolbarFile(EBServerCommunicationConsts_CT2958529.SETTINGS_FILE_NAME);
            EBFileIO_CT2958529.write(oDestFile, strSettings, null, EBGlobalConsts_CT2958529.DefaultCharset);
            return oDestFile;
        }
        catch (e) {
            return null;
        }
    },

    getManifestXml: function() {
        var xmlManifest = EBXML_CT2958529.GetXmlDocumentFromUrl(this.defaultsFolder + this.manifestFileName);
        return xmlManifest;
    },

    init: function() {
        this.isInit = true;

        var xmlDoc = this.getManifestXml();
        if (!xmlDoc) {
            return;
        }

        var xmlSettings = EBXML_CT2958529.SelectSingleNode(xmlDoc, "settings");
        var xmlImages = EBXML_CT2958529.SelectSingleNode(xmlDoc, "images");
        this.initSettings(xmlSettings);
        this.initImages(xmlImages);
    },

    initSettings: function(xmlSettings) {
        if (!xmlSettings) {
            return;
        }

        this.settingsFilePath = EBXML_CT2958529.GetSingleNodeValue(xmlSettings, "local_file_path");
        this.isSettingsInit = true;
    },

    initImages: function(xmlImages) {
        this.imagesHash = new EBArrayHashObject_CT2958529();
        if (!xmlImages || xmlImages.childNodes.length == 0) return;

        var arrImages = xmlImages.getElementsByTagName("image");
        var oImageData = null;

        for (var i = 0; i < arrImages.length; i++) {
            oImageData = new Defaults_ImageData_CT2958529(arrImages[i]);
            this.imagesHash.Add(oImageData.originalPath, oImageData.localPath);
        }

        this.isImagesInit = true;
    }
}

function Defaults_ImageData_CT2958529(xmlImage) {
    this.originalPath;
    this.localPath;

    this.init = function(xmlImage) {
        this.originalPath = EBXML_CT2958529.GetSingleNodeValue(xmlImage, "original_path");
        this.localPath = EBXML_CT2958529.GetSingleNodeValue(xmlImage, "local_file_path");
    };

    this.init(xmlImage);
}
/////////////////////////////////////////////////
/////////////////////////////////////////////////
//
// Basic JavaScript File and Directory IO module
// By: MonkeeSage, v0.1
//
/////////////////////////////////////////////////
/////////////////////////////////////////////////

	/////////////////////////////////////////////////
	// Basic file IO object based on Mozilla source 
	// code post at forums.mozillazine.org
	/////////////////////////////////////////////////

	// Example use:
	// var fileIn = FileIO.open('/test.txt');
	// if (fileIn.exists()) {
	// 	var fileOut = FileIO.open('/copy of test.txt');
	// 	var str = FileIO.read(fileIn);
	// 	var rv = FileIO.write(fileOut, str);
	// 	al('File write: ' + rv);
	// 	rv = FileIO.write(fileOut, str, 'a');
	// 	al('File append: ' + rv);
	// 	rv = FileIO.unlink(fileOut);
	// 	al('File unlink: ' + rv);
	// }

var EBFileIO_CT2958529 =
{

    localfileCID: '@mozilla.org/file/local;1',
    localfileIID: Components.interfaces.nsILocalFile,

    finstreamCID: '@mozilla.org/network/file-input-stream;1',
    finstreamIID: Components.interfaces.nsIFileInputStream,

    foutstreamCID: '@mozilla.org/network/file-output-stream;1',
    foutstreamIID: Components.interfaces.nsIFileOutputStream,

    sinstreamCID: '@mozilla.org/scriptableinputstream;1',
    sinstreamIID: Components.interfaces.nsIScriptableInputStream,

    suniconvCID: '@mozilla.org/intl/scriptableunicodeconverter',
    suniconvIID: Components.interfaces.nsIScriptableUnicodeConverter,

    open: function(path) {
        try {
            var file = Components.classes[this.localfileCID]
							.createInstance(this.localfileIID);
			
			file.initWithPath(path);
            return file;
        }
        catch (e) {
            return false;
        }
    },

    read: function(file, charset) {
        try {
            var data = new String();
            var fiStream = Components.classes[this.finstreamCID]
								.createInstance(this.finstreamIID);
            var siStream = Components.classes[this.sinstreamCID]
								.createInstance(this.sinstreamIID);
            fiStream.init(file, 1, 0, false);
            siStream.init(fiStream);
            data += siStream.read(-1);
            siStream.close();
            fiStream.close();
            if (charset) {
                data = this.toUnicode(charset, data);
            }
            return data;
        }
        catch (e) {
            return false;
        }
    },

    write: function(file, data, mode, charset) {
        try {
            var foStream = Components.classes[this.foutstreamCID]
								.createInstance(this.foutstreamIID);
            if (charset) {
                data = this.fromUnicode(charset, data);
            }
            var flags = 0x02 | 0x08 | 0x20; // wronly | create | truncate
            if (mode == 'a') {
                flags = 0x02 | 0x10; // wronly | append
            }
            foStream.init(file, flags, 0664, 0);
            foStream.write(data, data.length);
            // foStream.flush();
            foStream.close();
            return true;
        }
        catch (e) {
            return false;
        }
    },

    create: function(file) {
        try {
            file.create(0x00, 0664);
            return true;
        }
        catch (e) {
            return false;
        }
    },

    unlink: function(file) {
        try {
            file.remove(false);
            return true;
        }
        catch (e) {
            return false;
        }
    },

    path: function(file) {
        try {
            return 'file:///' + file.path.replace(/\\/g, '\/')
						.replace(/^\s*\/?/, '').replace(/\ /g, '%20');
        }
        catch (e) {
            return false;
        }
    },

    toUnicode: function(charset, data) {
        try {
            var uniConv = Components.classes[this.suniconvCID]
								.createInstance(this.suniconvIID);
            uniConv.charset = charset;
            data = uniConv.ConvertToUnicode(data);
        }
        catch (e) {
            // foobar!
        }
        return data;
    },

    fromUnicode: function(charset, data) {
        try {
            var uniConv = Components.classes[this.suniconvCID]
								.createInstance(this.suniconvIID);
            uniConv.charset = charset;
            data = uniConv.ConvertFromUnicode(data);
            // data += uniConv.Finish();
        }
        catch (e) {
            // foobar!
        }
        return data;
    }
};


/////////////////////////////////////////////////
// Basic Directory IO object based on JSLib 
// source code found at jslib.mozdev.org
/////////////////////////////////////////////////

// Example use:
// var dir = DirIO.open('/test');
// if (dir.exists()) {
// 	al(DirIO.path(dir));
// 	var arr = DirIO.read(dir, true), i;
// 	if (arr) {
// 		for (i = 0; i < arr.length; ++i) {
// 			al(arr[i].path);
// 		}
// 	}
// }
// else {
// 	var rv = DirIO.create(dir);
// 	al('Directory create: ' + rv);
// }

// ---------------------------------------------
// ----------------- Nota Bene -----------------
// ---------------------------------------------
// Some possible types for get are:
// 	'ProfD'				= profile
// 	'DefProfRt'			= user (e.g., /root/.mozilla)
// 	'UChrm'				= %profile%/chrome
// 	'DefRt'				= installation
// 	'PrfDef'			= %installation%/defaults/pref
// 	'ProfDefNoLoc'		= %installation%/defaults/profile
// 	'APlugns'			= %installation%/plugins
// 	'AChrom'			= %installation%/chrome
// 	'ComsD'				= %installation%/components
// 	'CurProcD'			= installation (usually)
// 	'Home'				= OS root (e.g., /root)
// 	'TmpD'				= OS tmp (e.g., /tmp)

var EBDirIO_CT2958529 =
{

    sep: '/',

    dirservCID: '@mozilla.org/file/directory_service;1',

    propsIID: Components.interfaces.nsIProperties,

    fileIID: Components.interfaces.nsIFile,

    Get: function(type) {
        try {
            var dir = Components.classes[this.dirservCID]
							.createInstance(this.propsIID)
							.get(type, this.fileIID);
            return dir;
        }
        catch (e) {
            return false;
        }
    },

    open: function(path) {
        return EBFileIO_CT2958529.open(path);
    },

    create: function(dir) {
        try {
            dir.create(0x01, 0755);
            //make sure we can read and write to and from the directory
            if (!dir.isReadable() || !dir.isWritable()) {
                dir.permissions = 0755;
            }
            return true;
        }
        catch (e) {
            return false;
        }
    },

    read: function(dir, recursive) {
        var list = new Array();
        try {
            if (dir.isDirectory()) {
                if (recursive == null) {
                    recursive = false;
                }
                var files = dir.directoryEntries;
                list = this._read(files, recursive);
            }
        }
        catch (e) {
            // foobar!
        }
        return list;
    },

    _read: function(dirEntry, recursive) {
        var list = new Array();
        try {
            while (dirEntry.hasMoreElements()) {
                list.push(dirEntry.getNext()
								.QueryInterface(EBFileIO_CT2958529.localfileIID));
            }
            if (recursive) {
                var list2 = new Array();
                for (var i = 0; i < list.length; ++i) {
                    if (list[i].isDirectory()) {
                        files = list[i].directoryEntries;
                        list2 = this._read(files, recursive);
                    }
                }
                for (i = 0; i < list2.length; ++i) {
                    list.push(list2[i]);
                }
            }
        }
        catch (e) {
            // foobar!
        }
        return list;
    },

    unlink: function(dir, recursive) {
        try {
            if (recursive == null) {
                recursive = false;
            }
            dir.remove(recursive);
            return true;
        }
        catch (e) {
            return false;
        }
    },

    path: function(dir) {
        return EBFileIO_CT2958529.path(dir);
    },

    split: function(str, join) {
        var arr = str.split(/\/|\\/), i;
        str = new String();
        for (i = 0; i < arr.length; ++i) {
            str += arr[i] + ((i != arr.length - 1) ?
									join : '');
        }
        return str;
    },

    join: function(str, split) {
        var arr = str.split(split), i;
        str = new String();
        for (i = 0; i < arr.length; ++i) {
            str += arr[i] + ((i != arr.length - 1) ?
									this.sep : '');
        }
        return str;
    }
};

if(navigator.platform.toLowerCase().indexOf('win') > -1)
{
	EBDirIO_CT2958529.sep = '\\';
}



var EBIOManager_CT2958529 =
{
    extensions: 'extensions',
    
    GetPrefsDir: function() {
        return EBDirIO_CT2958529.Get('ProfD');
    },

    GetSearchPluginsDir: function() {
        return EBDirIO_CT2958529.Get("SrchPlugns");
    },
    
    GetSynchronicExtentionPath: function(id) {
        var extPath = this.GetPrefsDir();
        extPath.append(this.extensions);
        extPath.append(id);
        return extPath;
    }, 

    GetExtentionPath: function(id, callback) {
        var strExtPath = "";
        try {
           if (EBGlobalManager_CT2958529.IsFirefox4()) {
            var self = this;
            Components.utils.import("resource://gre/modules/AddonManager.jsm");
            AddonManager.getAddonByID(id, function(addon) {
             callback(addon.getResourceURI().spec);
            });
        } 
          
            var ext = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager)
                    .getInstallLocation(id)
                    .getItemLocation(id);
            strExtPath = ext.path;
            }
        catch (ex) {
            strExtPath = "";
        }

        finally {
            callback(strExtPath);
        }
    },

    CreateDir: function(strDirName) {
        var ebDirPath = this.GetPrefsDir().path + EBDirIO_CT2958529.sep + strDirName;
        var ebDir = EBDirIO_CT2958529.open(ebDirPath);
        if (!ebDir.exists()) {
            EBDirIO_CT2958529.create(ebDir);
        }
        return ebDir;
    },

    CreateToolbarFile: function(strFileName) {
        var ebFile = null;
        try {
            var ebDir = this.CreateDir(EBGlobalConsts_CT2958529.ToolbarCTID);
            ebFile = EBFileIO_CT2958529.open(ebDir.path + EBDirIO_CT2958529.sep + strFileName);
            if (!ebFile.exists()) {
                EBFileIO_CT2958529.create(ebFile);
            }
        }
        catch (err) {
            ebFile = null;
        }
        finally {
            return ebFile;
        }
    },

    DeleteToolbarFile: function(strFileName) {
        var ebFile = null;
        try {
            var ebDir = this.CreateDir(EBGlobalConsts_CT2958529.ToolbarCTID);
            ebFile = EBFileIO_CT2958529.open(ebDir.path + EBDirIO_CT2958529.sep + strFileName);
            if (!ebFile.exists()) {
                EBFileIO_CT2958529.unlink(ebFile, true);
            }
        }
        catch (err) {
            ebFile = null;
        }
        finally {
            return ebFile;
        }
    },

    CreateSuggestFile: function(strFileName) {
        var ebFile = null;
        try {
            var ebDir = this.CreateDir(EBGlobalConsts_CT2958529.SuggestHistoryFolderName);
            ebFile = EBFileIO_CT2958529.open(ebDir.path + EBDirIO_CT2958529.sep + strFileName);
            if (!ebFile.exists()) {
                EBFileIO_CT2958529.create(ebFile);
            }
        }
        catch (err) {
            ebFile = null;
        }
        finally {
            return ebFile;
        }
    },

    DeleteToolbarDirectory: function() {
        var bRetVal = false;
        try {
            var objEBDir = this.CreateDir(EBGlobalConsts_CT2958529.ToolbarCTID);
            EBDirIO_CT2958529.unlink(objEBDir, true);
            bRetVal = true;
        }
        catch (err) {
            bRetVal = false;
        }

        return bRetVal;
    },

    DeleteSuggestDirectory: function() {
        var bRetVal = false;
        try {
            var objEBDir = this.CreateDir(EBGlobalConsts_CT2958529.SuggestHistoryFolderName);
            EBDirIO_CT2958529.unlink(objEBDir, true);
            bRetVal = true;
        }
        catch (err) {
            bRetVal = false;
        }

        return bRetVal;
    },

    IsToolbarFileExists: function(strFileName) {
        var bRetVal = false;
        try {
            var ebDir = this.CreateDir(EBGlobalConsts_CT2958529.ToolbarCTID);
            var ebFile = EBFileIO_CT2958529.open(ebDir.path + EBDirIO_CT2958529.sep + strFileName);
            bRetVal = ebFile.exists();
        }
        catch (err) {
            bRetVal = false;
        }

        return bRetVal;
    }
};
var EBPreferenceConsts_CT2958529 =
{
    SearchBoxWidth: 'SearchBoxWidth',
    SearchEngine: 'SearchEngine',
    SearchBackToDefault: 'SearchBackToDefaultEngine',
    LoginCallDate: 'LastLogin',
    UserID: 'UserID',
    LoginCache: 'LoginCache',
    SettingsLastUpdateTime: 'SettingsLastUpdate',
    SettingsInvalidateCache: 'SettingsInvalidateCache',
    LanguagePackLastCheckTime: 'LanguagePackLastCheckTime',
    LanguagePackReloadIntervalMM: 'LanguagePackReloadIntervalMM',
    LanguagePackServiceUrl: 'LanguagePackServiceUrl',
    ServerURL: 'Server',
    CTID: 'CTID',
    ToolbarName: 'ToolbarName',
    PreviouseCTID: 'PreviouseCTID',
    PreviouseToolbarName: 'PreviouseToolbarName',
    ToolbarType: 'Type',
    MyWebServerURL: 'MyWebServerURL',
    ToolbarShrink: 'SHRINK_TOOLBAR',
    EMailNotifierPollDate: 'EMailNotifierPollDate',
    EMailNotifierSound: 'EMailNotifierSound',
    EMailNotifierCheckInterval: 'EMailNotifierCheckInterval',
    EMailNotifierLabelLength: 'EMailNotifierLabelLength',
    FeedPollDatePrefix: 'FeedPollDate',
    FeedTTLPrefix: "FeedTTL",
    ExternalComponentPrefix: 'ExternalComponentPollDate',
    ExternalComponentCacheMode: 'ExternalComponentCacheMode',
    Uninstall: 'Uninstall',
    Initialize: 'Initialize',
    InitializeCommonPrefs: 'InitializeCommonPrefs',
    WeatherPollDate: 'WeatherPollDate',
    WeatherUnit: 'WeatherUnit',
    WeatherNetwork: 'WeatherNetwork',
    WeatherNextIFeelLuckyCheck: 'WeatherNextIFeelLuckyCheck',
    ThirdPartyComponentsLastCheck: 'ThirdPartyComponentsLastCheck',
    ThirdPartyComponentsLastUpdate: 'ThirdPartyComponentsLastUpdate',
    ThirdPartyComponentsInterval: 'ThirdPartyComponentsInterval',
    Locale: 'Locale',
    FirstTime: 'FirstTime',
    FirstTimeFF3: 'FirstTimeFF3',
    InstalledDate: 'InstalledDate',
    DialogsAlignMode: 'DialogsAlignMode',
    ToolbarAlignMode: 'ToolbarAlignMode',
    EnableSearchHistory: 'EnableSearchHistory',
    EnableSearchSuggest: 'EnableSearchSuggest',
    EnableUsage: 'EnableUsage',
    EnableClickToSearchBox: 'EnableClickToSearchBox',

    IsMulticommunity: 'IsMulticommunity',
    IsGrouping: 'IsGrouping',
    GroupingLastCheckTime: 'GroupingLastCheckTime',
    GroupingInvalidateCache: 'GroupingInvalidateCache',
    GroupingLastCheckResponse: 'GroupingLastResponse',
    GroupingLastServerUpdateTime: 'GroupingLastServerUpdateTime',
    GroupingLastErrorCode: 'GroupingLastErrorCode',
    GroupingServerCheckInterval: 'GroupingServerCheckInterval',
    CommunitiesChangesLastCheckTime: 'CommunitiesChangesLastCheckTime',
    CommunityChanged: 'CommunityChanged',
    GroupingServiceUrl: 'GroupingServiceUrl',

    VusualLastUpdateTime: 'VusualLastUpdateTime',
    CTPBaseServerUrl: 'CTPBaseServerUrl',
    MCDetectTooltipShow: 'MCDetectTooltipShow',
    MCDetectTooltipWidth: 'MCDetectTooltipWidth',
    MCDetectTooltipHeight: 'MCDetectTooltipHeight',
    MCDetectTooltipUrl: 'MCDetectTooltipUrl',
    DownloadDomainsListLastCheckTime: 'DownloadDomainsListLastCheckTime',
    DownloadDomainsListLastServerUpdateTime: 'DownloadDomainsListLastServerUpdateTime',
    DownloadDomainsCheckInterval: 'DownloadDomainsCheckInterval',
    ToggleComponentState: 'ToggleComponentState',
    AboutPrivacyUrl: 'AboutPrivacyUrl',
    SuggestWindowWidth: 'SuggestWindowWidth',
    SuggestWindowHeight: 'SuggestWindowHeight',
    AllowNonPrivacy: 'AllowNonPrivacy',
    FixPageNotFoundErrors: 'FixPageNotFoundErrors',
    FixPageNotFoundUrl: 'FixPageNotFoundUrl',
    UsageServerURL: 'UsageServerURL',
    IsOpenThankYouPage: 'IsOpenThankYouPage',
    IsOpenUninstallPage: 'IsOpenUninstallPage',
    SearchFromAddressBarUrl: 'SearchFromAddressBarUrl',
    TrusteLinkUrl: 'TrusteLinkUrl',
    BrowserCompStateIsOpen: 'BrowserCompStateIsOpen_',
    IsAppView: 'IsAppView',
    isRevertToBase: "isRevertToBase",
    isUntrustedAppsallowed :"isUntrustedAppsallowed",


    //Secondary Search
    SearchTimeAverage: 'SearchTimeAverage',
    SearchesCount: 'SearchesCount',

    SearchFromAddressBarIsInit: 'SearchFromAddressBarIsInit',

    PublisherContainerWidth: "PublisherContainerWidth",

    ValidationData_Search: "ValidationData_Search",
    ValidationData_Toolbar: "ValidationData_Toolbar",
    FirstServerDate: "FirstServerDate",
    CurrentServerDate: "CurrentServerDate",
    SearchInNewTabUserEnabled: "SearchInNewTabUserEnabled",
    SavedHomepage: "SavedHomepage",
    IsToolbarSelectedFromGrouping: "IsToolbarSelectedFromGrouping",

    //Common
    MyGadgetsIsVisible: 'MyGadgetsIsVisible',
    ToolbarsList: 'ToolbarsList',
    //list for toolbars with search from address bar
    ToolbarsList2: 'ToolbarsList2',
    ToolbarsList3: 'ToolbarsList3',
    MiniIPageGadgetPosition: 'MiniIPageGadgetPosition',
    MiniIPageGadgetSize: 'MiniIPageGadgetSize',
    MyGadgetsIsHighlight: 'MyGadgetsIsHighlight',
    MyGadgetsShowDetectDialog: 'MyGadgetsShowDetectDialog',
    SearchFromAddressBarSavedUrl: 'SearchFromAddressBarSavedUrl',
    FeedDeleteDontAskAgain: "FeedDeleteDontAskAgain",
    AppDetectionDialogShown: "AppDetectionDialogShown",

    IsEngineStandAlone: "IsEngineStandAlone",

    EngineOwner: "EngineOwner",
    EngineOwnerGuid: "EngineOwnerGuid",
    EngineOwnerToolbarId: "EngineOwnerToolbarId",

    OriginalEngineOwner: "OriginalEngineOwner",
    OriginalEngineOwnerToolbarId: "OriginalEngineOwnerToolbarId",
    OriginalEngineOwnerGuid: "OriginalEngineOwnerGuid",

    InstallationType: "InstallationType",
    InstallationId: "InstallationId",
    EngineDependOnToolbar: "EngineDependOnToolbar",
    KeepEngineInstalled: "KeepEngineInstalled",
    CantToolbarBeEngineOwner: "CantToolbarBeEngineOwner",
    testingCtid: "testingCtid",
    HasUserGlobalKeys: "HasUserGlobalKeys",
    approveUntrustedApps: "approveUntrustedApps",
    appApproved: "appApproved",
    IsEngineShown: "IsEngineShown",
    EngineHiddenByUser: "EngineHiddenByUser" 
};



//interface to write/read from the prefrence file(about:config) - 
//the registry of firefox
var EBPreferenceService_CT2958529 =
{
    PREFERENCE_SERVICE: Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch),

    GetPref: function(strName, defaultValue) {
        var strRetVal;
        try {
            switch (this.PREFERENCE_SERVICE.getPrefType(strName)) {
                case this.PREFERENCE_SERVICE.PREF_BOOL:
                    strRetVal = this.PREFERENCE_SERVICE.getBoolPref(strName);
                    break;
                case this.PREFERENCE_SERVICE.PREF_INT:
                    strRetVal = this.PREFERENCE_SERVICE.getIntPref(strName);
                    break;
                case this.PREFERENCE_SERVICE.PREF_STRING:
                    strRetVal = this.PREFERENCE_SERVICE.getCharPref(strName);
                    break;
                default:
                    strRetVal = (typeof defaultValue != "undefined") ? defaultValue : null;
                    break;
            }
            return strRetVal;
        }
        catch (e) {
            return null;
        }
    },

    SetPref: function(strName, strValue) {
        if (strValue == null) {
            this.SetPref(strName, "");
            this.PREFERENCE_SERVICE.clearUserPref(strName);
            return true;
        }
        try {
            switch (typeof strValue) {
                case 'boolean':
                    this.PREFERENCE_SERVICE.setBoolPref(strName, strValue);
                    break;
                case 'number':
                    this.PREFERENCE_SERVICE.setIntPref(strName, strValue);
                    break;
                case 'string':
                    this.PREFERENCE_SERVICE.setCharPref(strName, strValue);
                    break;
                default:
                    try {
                        var str = strValue.toString();
                        this.PREFERENCE_SERVICE.setCharPref(strName, str);
                    } catch (e) {
                        return false;
                    }
                    break;
            }
        }
        catch (ex) {
            EBLog(ex, "SetPref");
        }
        return true;
    },

    HasUserValue: function(strName) {
        return this.PREFERENCE_SERVICE.prefHasUserValue(strName);
    },

    DeleteBranch: function(strBranchName) {
        this.PREFERENCE_SERVICE.deleteBranch(strBranchName);
    },

    ClearUserValue: function(strName) {
        try {
            this.PREFERENCE_SERVICE.clearUserPref(strName);
        }
        catch (e) { EBLog(ex, "ClearUserValue"); }
    },

    //saves current prefs state to file (Firefox does it when it's unloads)
    SaveAll: function() {
        var prefService = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefService);
        prefService.savePrefFile(null);
    }
};

var EBToolbarPreferenceManager_CT2958529 = 
{
	GetPrefixPrefName : function(isMC)
	{
		var strPrefixPrefName = EBGlobalConsts_CT2958529.ToolbarCTID + '.';
		if(isMC == true && !EBMCManager_CT2958529.IsSelectedOriginalCommunity())
		{
			strPrefixPrefName += this.AddMCPrefix();
		}
		return strPrefixPrefName;
	},
	
	AddMCPrefix : function()
	{
		return EBMCManager_CT2958529.GetSelectedCTID() + ".";
	},
	
	GetPref : function(strName, isMC, defaultValue) 
	{
		var strPrefixPrefName = this.GetPrefixPrefName(isMC);
		
		var strFullPrefName = strPrefixPrefName + strName;

		return EBPreferenceService_CT2958529.GetPref(strFullPrefName, defaultValue);
	},

	SetPref : function(strName, strValue, isMC) 
	{
		var strPrefixPrefName = this.GetPrefixPrefName(isMC);

		var strFullPrefName = strPrefixPrefName + strName;
		EBPreferenceService_CT2958529.SetPref(strFullPrefName,strValue);
	},
	
	HasUserValue : function(strName,isMC)
	{
		var strPrefixPrefName = this.GetPrefixPrefName(isMC);
		
		var strFullPrefName = strPrefixPrefName + strName;
		return 	EBPreferenceService_CT2958529.HasUserValue(strFullPrefName);
	},
	
	Clear : function(strName, isMC) {
        var strPrefixPrefName = this.GetPrefixPrefName(isMC);
        var strFullPrefName = strPrefixPrefName + strName;
        EBPreferenceService_CT2958529.ClearUserValue(strFullPrefName);
    },
	
	ClearAll : function()
	{
		EBPreferenceService_CT2958529.DeleteBranch(EBGlobalConsts_CT2958529.ToolbarCTID);
	}
};

var EBCommunityPreferenceManager_CT2958529 =
{
    GetPrefixPrefName: function(strCTID) {
        var strPrefixPrefName = EBGlobalConsts_CT2958529.ToolbarCTID + ".";
        if (strCTID != EBGlobalConsts_CT2958529.ToolbarCTID)
            strPrefixPrefName += strCTID + ".";

        return strPrefixPrefName;
    },

    GetPref: function(strName, strCTID) {
        var strPrefixPrefName = this.GetPrefixPrefName(strCTID);

        var strFullPrefName = strPrefixPrefName + strName;

		return EBPreferenceService_CT2958529.GetPref(strFullPrefName);
	},

	SetPref : function(strName,strValue,strCTID) 
	{
		var strPrefixPrefName = this.GetPrefixPrefName(strCTID);

		var strFullPrefName = strPrefixPrefName + strName;
		EBPreferenceService_CT2958529.SetPref(strFullPrefName,strValue);
	},
	
	HasUserValue : function(strName,strCTID)
	{
		var strPrefixPrefName = this.GetPrefixPrefName(strCTID);
		
		var strFullPrefName = strPrefixPrefName + strName;
		return 	EBPreferenceService_CT2958529.HasUserValue(strFullPrefName);
	},
	
	ClearAll : function()
	{
		EBPreferenceService_CT2958529.DeleteBranch(EBGlobalConsts_CT2958529.ToolbarCTID);
	}
};

var EBGlobalPreferenceManager_CT2958529 =
{
    GetPrefixPrefName: function() {
        var strPrefixPrefName = 'CommunityToolbar.';
        return strPrefixPrefName;
    },

    GetPref: function(strName) {
        var strPrefixPrefName = this.GetPrefixPrefName();

        var strFullPrefName = strPrefixPrefName + strName;

        return EBPreferenceService_CT2958529.GetPref(strFullPrefName);
    },

    SetPref: function(strName, strValue) {
        var strPrefixPrefName = this.GetPrefixPrefName();

        var strFullPrefName = strPrefixPrefName + strName;
        EBPreferenceService_CT2958529.SetPref(strFullPrefName, strValue);
    },

    HasUserValue: function(strName) {
        var strPrefixPrefName = this.GetPrefixPrefName();

        var strFullPrefName = strPrefixPrefName + strName;
        return EBPreferenceService_CT2958529.HasUserValue(strFullPrefName);
    },


    ClearAll: function() {
        EBPreferenceService_CT2958529.DeleteBranch(this.GetPrefixPrefName());
    }

};

var EBPreferenceForLocalStorage_CT2958529 =
{
    IsEngineShown: true,
    EngineHiddenByUser: true
};
var EBAboutDialogManager_CT2958529 =
{
    PrivacyUrl: 'http://www.conduit.com/privacy/ConduitPrivacy.aspx',
    mainWindow: null,

    Privacy_Onclick: function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var strPrivacy = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.AboutPrivacyUrl, true);

        if (!strPrivacy)
            strPrivacy = this.PrivacyUrl;

        oWindow.EBWeb_CT2958529.LoadURLInNewTab(strPrivacy);
        window.close();
    },

    OnLoadAboutDialog: function() {
        this.mainWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        var strVersion = EBGlobalConsts_CT2958529.Version;
        var strUserID = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.UserID);
        var strCTID = EBActionManager_CT2958529.GetCTIDForServices();
        document.getElementById("ebAboutDialog").title = "test";
        window.document.title = this.mainWindow.EBActionManager_CT2958529.GetToolbarName() + " Community Toolbar";
        document.getElementById('lblVersion').setAttribute('value', strVersion);
        document.getElementById('lblUID').setAttribute('value', strUserID);
        document.getElementById('lblCTID').setAttribute('value', strCTID);

        if (!this.mainWindow.oToolbarManager_CT2958529.data.generalToolbarInfo.displayTrusteSeal)
            document.getElementById('imgTruste').style.display = 'none';
    },

    onClickCTID: function(obj) {
        obj.style.backgroundColor = 'rgb(51,153,255)';
        obj.style.color = 'white';
        EBGlobalManager_CT2958529.copyToClipboard(obj.value);
    },

    onBlurCTID: function(obj, e) {
        if (e.target.id == 'lblCTID') return;
        obj.style.backgroundColor = '';
        obj.style.color = '';
    },

    onClickTruste: function(event) {
        var trusteUrl = this.mainWindow.EBActionManager_CT2958529.GetTrusteLinkUrl();
        event.customData = { "url": trusteUrl, "urlTarget": "BLANK" };
        this.mainWindow.EBLinkManager_CT2958529.LoadLinkURL(event);
    }
};


var EBAboutDialogManagerCE_CT2958529 =
{
    PrivacyUrl: 'http://www.conduit.com/privacy/ConduitPrivacy.aspx',
    mainWindow: null,

    EULA_Onclick: function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var strEula = this.mainWindow.oToolbarManager_CT2958529.data.settings.enginePages.eula;

        if (strEula) {
            oWindow.EBWeb_CT2958529.LoadURLInNewTab(strEula);
            window.close();
        }
    },

    OnLoadAboutDialog: function() {
        this.mainWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        var strVersion = EBGlobalConsts_CT2958529.Version;
        var strUserID = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.UserID);
        document.getElementById('lblVersion').setAttribute('value', strVersion);
        document.getElementById('lblUID').setAttribute('value', strUserID);
        //no translation in this version
        //document.getElementById("lblConduit").setAttribute("value", this.mainWindow.oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_GLOBAL_EULA"));
    },

    onClickTruste: function(event) {
        var trusteUrl = this.mainWindow.oToolbarManager_CT2958529.data.settings.truste.link;
        event.customData = { "url": trusteUrl, "urlTarget": "BLANK" };
        this.mainWindow.EBLinkManager_CT2958529.LoadLinkURL(event);
    }
};


/********************************************/
/*		Copyright 2006 Conduit Ltd.			*/
/*           All Rights Reserved.           */
/********************************************/

//global functions related to the toolbar
var EBActionManager_CT2958529 =
{
    //get toolbar age in days for usage
    GetToolbarAgeInDays: function() {
        var stringToTimestamp = function(strServerDate) {
            if (!strServerDate) return null;
            var arrDate = strServerDate.split("-");
            if (arrDate.length != 3) return null;

            var oDate = new Date();
            oDate.setDate(arrDate[0]);
            oDate.setMonth(parseInt(arrDate[1]) - 1);
            oDate.setFullYear(arrDate[2]);
            var iTimestamp = Date.parse(oDate.toDateString());
            return isNaN(iTimestamp) ? null : iTimestamp;
        };

        var strCreatedDate = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.FirstServerDate);
        var iCreatedDate = stringToTimestamp(strCreatedDate);
        if (!iCreatedDate) return -1;

        var strCurrentDate = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.CurrentServerDate);
        var iCurrentDate = stringToTimestamp(strCurrentDate);
        if (!iCurrentDate) return -1;

        var iMilliseconds = iCurrentDate - iCreatedDate;
        var iDays = parseInt(iMilliseconds / (1000 * 60 * 60 * 24));
        return (isNaN(iDays)) ? -1 : iDays;
    },

    //reset this setting when switching toolbars.
    ResetToolbarInfo: function() {
        EBEMailNotifierManager_CT2958529.Reset();
    },

    //0 - shrink mode ,1 - unshrink mode
    ToolbarShrink: function(isShrinked) {
        var iPrefState;
        //get
        if (typeof value == "undefined") {
            iPrefState = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.ToolbarShrink);
            return iPrefState == 0 ? true : false;
        }
        //set
        else {
            iPrefState = (value) ? 0 : 1;
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.ToolbarShrink, iPrefState);
        }
    },

    GetTrusteLinkUrl: function() {
        var strPrefValue = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.TrusteLinkUrl);
        return (strPrefValue) ? strPrefValue : EBGlobalConsts_CT2958529.TrusteUrl;
    },

    ConvertAliasesUrl: function(strUrl, isFor404Url, bDontReplaceUntrusted) {
        if (typeof isFor404Url == "undefined") isFor404Url = false;
        if (typeof bDontReplaceUntrusted == "undefined") bDontReplaceUntrusted = false;

        var strCurrentUrl = EBUrl_CT2958529.GetPageUrl();
        var strToolbarCTID;

        if (EBGlobalConsts_CT2958529.IsEngine)
            strToolbarCTID = (DualPackageFunctions_CT2958529.engineOwnerCTID() == EBGlobalConsts_CT2958529.EngineCTID) ? "undefined" : DualPackageFunctions_CT2958529.engineOwnerCTID();
        else
            strToolbarCTID = this.GetCTID();

        var strUserID = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.UserID);
        var strToolbarVersion = EBGlobalConsts_CT2958529.Version;
        var strOriginalCTID = EBGlobalConsts_CT2958529.IsEngine ? strToolbarCTID : EBActionManager_CT2958529.GetOriginalCTIDForServices();
        var strPageTitle = this.GetPageTitle();
        var strSubDomain = EBGlobalConsts_CT2958529.IsEngine ? "undefined" : EBUrl_CT2958529.GetSubDomain(this.GetWebServerURL(""));
        var strDownloadPage = EBGlobalConsts_CT2958529.IsEngine ? "undefined" : oToolbarManager_CT2958529.data.generalToolbarInfo.webServerUrl;
        var strToolbarName = EBGlobalConsts_CT2958529.IsEngine ? "undefined" : EBGlobalConsts_CT2958529.ToolbarName;

        if (strUserID == null) strUserID = "";

        //replace the aliases
        if (!isFor404Url && !bDontReplaceUntrusted)
            strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.MainFrameURL, encodeURIComponent(strCurrentUrl));
        else if (!isFor404Url && bDontReplaceUntrusted)
            strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.MainFrameURL, "");

        if (!bDontReplaceUntrusted) {
            strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.UserID, strUserID);
            var oSearchBoxComp = EBComponentsManager_CT2958529.GetSearchBoxComponent();
            if (oSearchBoxComp)
                strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.SearchTerm, oSearchBoxComp.xulMenuList.value);
            else
                strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.SearchTerm, "undefined");

            strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.MainFrameTitle, encodeURIComponent(strPageTitle));
        }
        else {
            strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.UserID, "");
            strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.SearchTerm, "");
            strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.MainFrameTitle, "");
        }

        strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.ToolbarID, strToolbarCTID);
        strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.ToolbarVersion, strToolbarVersion);
        strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.ToolbarOriginalID, strOriginalCTID);
        strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.ToolbarSubDomain, strSubDomain);
        strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.DownloadPage, strDownloadPage);
        strUrl = strUrl.replace(EBGlobalConsts_CT2958529.Aliases.ToolbarName, strToolbarName);


        //replace aliases with global keys
        if (strUrl.indexOf("@@@") != -1) {
            strUrl = strUrl.replace(/@@@(.*?)@@@/g, function(full, val) {
                var objPreferencePath = EBBrowserComponentApiManager_CT2958529.GetFullPreferencePath(null, val);
                var strFullPreferencePath = objPreferencePath.fullDomain;
                if (EBToolbarPreferenceManager_CT2958529.HasUserValue(strFullPreferencePath)) {
                    var value = EBToolbarPreferenceManager_CT2958529.GetPref(strFullPreferencePath);
                    return (value) ? EBEncryption_CT2958529.decode(strValue) : "";
                }
                else
                    return "";
            });
        }
        return strUrl;
    },

    GetPageTitle: function() {
        var strTitle = "";
        var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        if (typeof win.gBrowser != "undefined")
            strTitle = win.gBrowser.contentDocument.title;

        return strTitle;
    },

    SetToolbarSearchTerm: function(strSearchTerm) {
        var oSearchComponent = EBComponentsManager_CT2958529.GetSearchBoxComponent();

        if (oSearchComponent) {
            var bIsChanged = oSearchComponent.setSearchTerm(strSearchTerm);

            if (bIsChanged) {
                this.SearchTermChanged();
            }
        }
    },

    IsToolbarRTL: function() {
        var xulToolbarElement = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
        var strToolbarDirection = document.defaultView.getComputedStyle(xulToolbarElement, null).getPropertyValue("direction");
        return strToolbarDirection == 'rtl' ? true : false;
    },

    IsToolbarGeneric: function() {
        var strToolbarType = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.ToolbarType);
        //return strToolbarType == 'generic' ? true : false;
        return false;

    },

    IsToolbarMC: function() {
        var bIsInRegistry = EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.IsMulticommunity);
        if (bIsInRegistry)
            return EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.IsMulticommunity);
        else {
            var bValue = EBGlobalConsts_CT2958529.MultiCommunity;
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsMulticommunity, bValue);
            return bValue;
        }
    },

    IsToolbarGrouping: function() {
        var bIsInRegistry = EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.IsGrouping);
        if (bIsInRegistry) {
            return EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.IsGrouping);
        }
        else {
            var bValue = EBGlobalConsts_CT2958529.Grouping;
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsGrouping, bValue);
            return bValue;
        }
    },

    IsToolbarShown: function() {
        if (EBGlobalConsts_CT2958529.IsEngine)
            return EBPreferenceForLocalStorage_CT2958529.IsEngineShown;

        //toolbox is not visible
        var oToolbox = document.getElementById("navigator-toolbox");
        var vis = document.defaultView.getComputedStyle(oToolbox, null).getPropertyValue("display");
        if (vis == "none") return false;

        var oToolbar = document.getElementById(EBGlobalConsts_CT2958529.ToolbarId);

        var bRetVal = false;
        if (oToolbar) {
            var strCollapsed = oToolbar.getAttribute('collapsed');
            //check that the toolbar is not hidden
            if (!strCollapsed || strCollapsed.toLowerCase() != 'true') {
                bRetVal = true;
            }
        }
        return bRetVal;
    },

    GetToolbarChevron: function() {
        var strChevronID = EBToolbarManager_CT2958529.chevronManager.GetToolbarChveronID();
        var oChevron = document.getElementById(strChevronID);
        return oChevron;
    },

    GetToolbarChevronParent: function(strCompId) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        return oWindow.EBToolbarManager_CT2958529.chevronManager.ChevronXULElement;
    },

    GetWebServerURL: function(strAddition) {
        var strGeneralInfoWebServerURL = oToolbarManager_CT2958529.data.generalToolbarInfo.webServerUrl;

        if (strGeneralInfoWebServerURL) {
            return strGeneralInfoWebServerURL + strAddition;
        }
        else {
            if (strAddition.charAt(strAddition.length - 1) == '/') {
                strAddition += '?';
            }
            else {
                strAddition += '&';
            }
            return EBGlobalConsts_CT2958529.DefaultWebServerURL + strAddition + 'ToolbarId=CT2958529';
        }
    },

    //get ctid from the prefs and if there isn't so from the hard-coded(means it's the original toolbar)
    GetCTID: function() {
        if (window.isAIOMode_CT2958529)
            return window.AIOModeCTID_CT2958529;
        else {
            var strCTID = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.CTID);
            strCTID = (!EBGlobalConsts_CT2958529.IsEngine && strCTID) ? strCTID : EBGlobalConsts_CT2958529.ToolbarCTID;
            return strCTID;
        }
    },

    GetCTIDForServices: function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var testingCTID = oWindow.EBToolbarManager_CT2958529.getToolbarDefaultsData().ABTestingCTID;
        if (!EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.isRevertToBase) && testingCTID)
            return testingCTID;
        return this.GetCTID();
    },

    GetOriginalCTIDForServices: function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var testingCTID = oWindow.EBToolbarManager_CT2958529.getToolbarDefaultsData().ABTestingCTID;
        if (!EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.isRevertToBase) && testingCTID)
            return testingCTID;
        return EBGlobalConsts_CT2958529.ToolbarCTID;
    },



    GetTestingCTID: function() {
        var testingCTID = EBToolbarManager_CT2958529.getToolbarDefaultsData().ABTestingCTID;
        if (EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.isRevertToBase) && testingCTID)
            return testingCTID;
        return null;
    },

    GetToolbarName: function() {
        var strName = EBGlobalConsts_CT2958529.IsEngine ? oToolbarManager_CT2958529.data.settings.engineName :
					oToolbarManager_CT2958529.data.generalToolbarInfo.toolbarName;
        strName = (strName) ? strName : EBGlobalConsts_CT2958529.ToolbarName;

        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var testingCTID = oWindow.EBToolbarManager_CT2958529.getToolbarDefaultsData().ABTestingCTID;
        if (!EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.isRevertToBase) && testingCTID)
            strName = oWindow.EBGlobalConsts_CT2958529.ToolbarName;
        return strName;
    },

    DocumentComplete: function() {
        //check for highlighting when the page is loaded!
        if (EBToolbarManager_CT2958529.dataToolbarObject.IsHighlighting) {
            EBHighlighterManager_CT2958529.Highlight();
        }
    },

    SearchTermChanged: function() {
        var XULSearchBoxMenuList = EBComponentsManager_CT2958529.GetSearchBoxMenuList();

        if (XULSearchBoxMenuList) {
            var strSearchTerm = XULSearchBoxMenuList.value;

            //set the finder highlight buttons
            EBHighlighterManager_CT2958529.SetHighlightButtons(XULSearchBoxMenuList);


            EBSearchBoxManager_CT2958529.IsSetSearchBGText = false;

            EBObserversManager_CT2958529.NotifyCustomObserver(EBObserversManager_CT2958529.GetSubject(EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true).gBrowser.ebWindowId_CT2958529),
                                                            EBObserversManager_CT2958529.ToolbarEventsTopic,
                                                            EBObserversManager_CT2958529.ToolbarEventsData.SearchTermChanged);
        }
    },

    GetEBToolbarsCTID: function() {
        var arrCTID = new Array();
        var objToolbarbox = document.getElementById('navigator-toolbox');

        var objToolbars = objToolbarbox.getElementsByTagName('toolbar');
        var objToolbar = null;
        var strCTIDAttributeName = 'ebtoolbarctid';
        var strCTIDAttributeValue = '';
        var strOriginalCTID = '';
        var strCurrentCTID = '';
        var obj = null;

        for (var i = 0; i < objToolbars.length; i++) {
            objToolbar = objToolbars[i];
            strCTIDAttributeValue = objToolbar.getAttribute(strCTIDAttributeName);
            if (strCTIDAttributeValue) {
                strOriginalCTID = strCTIDAttributeValue;
                strCurrentCTID = this.GetOtherToolbarCurrentCTID(strOriginalCTID);
                obj = new Object();
                obj.originalCTID = strOriginalCTID;
                obj.currentCTID = strCurrentCTID;
                arrCTID.push(obj);
            }
        }

        return arrCTID;
    },

    GetOtherToolbarCurrentCTID: function(strOriginalCTID) {
        var strPref = strOriginalCTID + "." + EBPreferenceConsts_CT2958529.CTID;
        var currentCTID = EBPreferenceService_CT2958529.GetPref(strPref);
        return currentCTID;
    },

    GetToolbarDialogOpeningCoordinates: function(oElement, iDialogWidth) {
        var oElementBoxObject = oElement.boxObject;
        var iElementScreenX = oElementBoxObject.screenX;

        //get the y position from the toolbar
        var oToolbar = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
        var oToolbarBoxObject = oToolbar.boxObject;
        var iToolbarScreenY = oToolbarBoxObject.screenY;
        var iToolbarHeight = oToolbarBoxObject.height;

        var iX = iElementScreenX;
        var iY = iToolbarScreenY + iToolbarHeight;
        //in mac the y is different:
        if (EBGlobalManager_CT2958529.IsMacintoshPlatform()) {
            iY = iToolbarScreenY;
        }

        //validate the x coordinate according to the screen:
        var oCoordinates = EBScreen_CT2958529.getCorrectedCoordinatesForWindow(iX, iY, iDialogWidth, 100, oElement);
        return { X: oCoordinates.x, Y: oCoordinates.y };
    },

    GetItemDialogOpeningCoordintates: function(oElement, iDialogWidth, iDialogHeight) {
        var oElementBoxObject = oElement.boxObject;
        var iElementScreenX = oElementBoxObject.screenX;
        var iElementScreenY = oElementBoxObject.screenY;
        var iX;
        if (EBGlobalManager_CT2958529.IsToolbarRTL()) {
            iX = iElementScreenX - iDialogWidth;
        }
        else {
            iX = iElementScreenX + oElementBoxObject.width;
        }
        var iY = iElementScreenY;


        var iHorizontalGap = EBGlobalConsts_CT2958529.ToolbarHorizontalDialogGap;
        var iVerticalGap = EBGlobalConsts_CT2958529.ToolbarVerticalDialogGap;

        if (iX + iDialogWidth > screen.width) {
            iX = iElementScreenX - iDialogWidth;
        }
        else if (iX < 0) {
            if (EBGlobalManager_CT2958529.IsToolbarRTL()) {
                iX = iElementScreenX + oElementBoxObject.width;
            }
            else {
                iX = iHorizontalGap;
            }
        }

        if (iY + iDialogHeight > screen.height) {
            iY = screen.height - iDialogHeight - iVerticalGap;
        }

        return { X: iX, Y: iY };
    },

    //close all the special dialogs of the toolbar (weather-feed-multifeed)
    CloseToolbarDialogs: function() {
        var oWeatherDialog = EBWeatherDialogManager_CT2958529.GetDialog();
        if (oWeatherDialog)
            oWeatherDialog.close();
    },


    IsBiggerVersion: function(strNew, strMax) {
        return EBGlobalManager_CT2958529.compareVersions(strNew, strMax) > 0;
    },

    OpenEULA: function(strTarget, strUrl) {
        if (!strUrl)
            strUrl = EBGlobalConsts_CT2958529.IsEngine ? oToolbarManager_CT2958529.data.settings.enginePages.eula : EBGlobalConsts_CT2958529.WebServerUrl + "EULA";
        else {
            strUrl = EBUrl_CT2958529.AddHTTPProtocol(strUrl);
            strUrl += "/EULA";
        }

        this._openUrlWindow(strTarget, strUrl);
    },

    OpenPrivacyPolicy: function(strTarget, strUrl) {
        if (!strUrl)
            strUrl = EBGlobalConsts_CT2958529.IsEngine ? oToolbarManager_CT2958529.data.settings.enginePages.privacy : EBGlobalConsts_CT2958529.WebServerUrl + "Privacy";
        else {
            strUrl = EBUrl_CT2958529.AddHTTPProtocol(strUrl);
            strUrl += "/Privacy";
        }

        this._openUrlWindow(strTarget, strUrl);
    },

    OpenLearnMore: function(strTarget, strUrl) {
        if (!strUrl)
            strUrl = EBGlobalConsts_CT2958529.WebServerUrl + "LearnMore";
        else {
            strUrl = EBUrl_CT2958529.AddHTTPProtocol(strUrl);
            strUrl += "/Tooltips/LearnMore";
        }

        this._openUrlWindow(strTarget, strUrl);
    },

    OpenContentPolicy: function(strTarget, strUrl) {
        if (!strUrl)
            strUrl = EBGlobalConsts_CT2958529.WebServerUrl + "content-policy";
        else {
            strUrl = EBUrl_CT2958529.AddHTTPProtocol(strUrl);
            strUrl += "/Tooltips/content-policy";
        }
        this._openUrlWindow(strTarget, strUrl);
    },

    OpenIPhoneLink: function(strTarget, strUrl) {
        if (!strUrl) {
            strUrl = "";
        }
        else {
            strUrl = EBUrl_CT2958529.AddHTTPProtocol(strUrl);
            strUrl += "/Privacy";
        }
        strUrl = strUrl.replace(/EB_BROWSER_TYPE/g, "FF");
        strUrl = strUrl.replace(/EB_ORIGINAL_CTID/g, "CT2958529");
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        oWindow.open(strUrl, "SPECIAL_WINDOW", "toolbar=0,scrollbars=1,resizable=1,status=1");
    },

    _openUrlWindow: function(strTarget, strUrl) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        if (strTarget != "DIALOG") {
            var event = { "customData": { "url": strUrl, "urlTarget": strTarget} };
            oWindow.EBLinkManager_CT2958529.LoadLinkURL(event);
        }
        else {
            var strPos = ",outerHeight =" + screen.availHeight + ",outerWidth =" + screen.availWidth;
            oWindow.openDialog(strUrl, "SPECIAL_WINDOW", "toolbar=0,scrollbars=1,resizable=1,status=1" + strPos);
        }
    },

    SetToolbarVisible: function() {
        document.getElementById(EBGlobalConsts_CT2958529.ToolbarId).collapsed = false;
        document.persist(EBGlobalConsts_CT2958529.ToolbarId, "collapsed");
    },

    IsAppView: function() {
        return EBGlobalConsts_CT2958529.IsEngine && EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.IsAppView, false, true) && !window.isAIOMode_CT2958529;
    }
};

function EBBaseBrowserProgressListener_CT2958529() {
    this.QueryInterface = function(aIID) {
        if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
            aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
            aIID.equals(Components.interfaces.nsISupports))
            return this;
        throw Components.results.NS_NOINTERFACE;
    };

    this.onLocationChange = function(aProgress, aRequest, aURI) { return 0; };
    this.onProgressChange = function() { return 0; };
    this.onStatusChange = function(aProgress, aRequest, aStatus, aMessage) { };
    this.onSecurityChange = function(aProgress, aRequest, aState) { };
    this.onLinkIconAvailable = function() { return 0; };
    this.onStateChange = function(aProgress, aRequest, aFlag, aStatus) {
        if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT) {
            var strUrl = aRequest.name;
            //navigate complete
            if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_START) { }
            //document complete
            if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP) { }
        }
    };
};
function EBBaseObserver_CT2958529() {
    this.Topic = "";
    var NSIObserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces["nsIObserverService"]);

    this.register = function() {
        NSIObserverService.addObserver(this, this.Topic, false);
    };

    this.unregister = function() {
        try {
            NSIObserverService.removeObserver(this, this.Topic);
        }
        catch (e) {
            EBLog("error removing observer with topic: " + this.Topic);
        }
    };

    this.observe = function(aSubject, aTopic, aData) {
        //Implement in inherited class
    };
};
/*************************** Special command consts ******************************/
var EBSpecialCommands_CT2958529 =
{
    CE_MOVE_LEFT_COMPONENT_CMD: "CE_MOVE_LEFT_COMPONENT",
    CE_MOVE_RIGHT_COMPONENT_CMD: "CE_MOVE_RIGHT_COMPONENT",
    CE_MORE_FROM_THIS_PUBLISHER_CMD: "CE_MORE_FROM_THIS_PUBLISHER",
    CM_MORE_FROM_THIS_PUBLISHER_CMD: "CM_MORE_FROM_THIS_PUBLISHER",
    CE_SHARE_COMPONENT_CMD: "CE_SHARE_COMPONENT", //not real command, set to share menu item
    DO_UPGRADE_CMD: "DO_UPGRADE",


    //consts:
    PRIVACY_PAGE: "Privacy/",

    HELP_PAGE: "Help/",

    TELL_A_FRIEND_PAGE: "",

    TELLAFRIEND: function() {
        var strTellAFriendMailTo = "";

        if (oToolbarManager_CT2958529.data.generalToolbarInfo.tellAfriendCmd == "") {
            //build the default tell_a_friend!

            //check if there is webServerUrl from the xml general info
            var strDownloadToolbarUrl = EBActionManager_CT2958529.GetWebServerURL(this.TELL_A_FRIEND_PAGE);
            var strToolbarName = EBGlobalConsts_CT2958529.ToolbarName;

            var strSubject = "Try " + strToolbarName + " toolbar";
            var strBody = "Hi,%0D%0A%0D%0AI recently installed the ";
            strBody += strToolbarName;
            strBody += " toolbar and thought you might also find it interesting.%0D%0AIt has lots of useful features and seems to be well-liked ";
            strBody += "by a large number of users (including my self).%0D%0A%0D%0A";
            strBody += "To find out more about this toolbar and download it, go to: %0D%0A";
            strBody += strDownloadToolbarUrl;
            strBody += "%0D%0A%0D%0A";

            strTellAFriendMailTo = "mailto:?subject=" + strSubject + "&body=" + strBody;
        }
        else {
            strTellAFriendMailTo = oToolbarManager_CT2958529.data.generalToolbarInfo.tellAfriendCmd;
        }

        var event = { "customData": { "url": strTellAFriendMailTo} };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    },

    HELP: function(event) {
        //get the correct web server url
        var strAdditional = this.HELP_PAGE + "?version=" + EBGlobalConsts_CT2958529.Version;
        var strURL = EBGlobalConsts_CT2958529.IsEngine_ ? oToolbarManager_CT2958529.data.settings.enginePages.help : EBActionManager_CT2958529.GetWebServerURL(strAdditional);
        event.customData = { "url": strURL };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    },

    PRIVACY: function(event) {
        //get the correct web server url
        var strAdditional = this.PRIVACY_PAGE + "?version=" + EBGlobalConsts_CT2958529.Version;
        var strURL = EBGlobalConsts_CT2958529.IsEngine_ ? oToolbarManager_CT2958529.data.settings.enginePages.privacy : EBActionManager_CT2958529.GetWebServerURL(strAdditional);
        event.customData = { "url": strURL };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    },

    HOMEPAGE: function(event) {
        var strToolbarHomePage = EBGlobalConsts_CT2958529.IsEngine_ ? oToolbarManager_CT2958529.data.settings.enginePages.home : EBComponentsManager_CT2958529.GetMainMenuComponent().ComponentItem.link;
        event.customData = { "url": strToolbarHomePage };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    },

    CONTACTUS: function(event) {
        var strMailTo = oToolbarManager_CT2958529.data.generalToolbarInfo.writeToUsCmd;
        if (strMailTo != "") {
            event.customData = { "url": strMailTo };
            EBLinkManager_CT2958529.LoadLinkURL(event);
        }
    },

    ABOUT: function() {
        var strAboutDialogType = 'EBAboutDialog_CT2958529';
        var strAboutDialogName = 'EBAboutDialogName_CT2958529';
        var oAboutDialog = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName(strAboutDialogType, strAboutDialogName);

        //check if the about window is open to set it to focus
        if (oAboutDialog) {
            oAboutDialog.focus();
        }
        else {
            var fileName = EBGlobalConsts_CT2958529.IsEngine ? 'aboutCE.xul' : 'about.xul';
            var strAboutChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + fileName;

            EBGlobalManager_CT2958529.OpenDialog(strAboutChromePath,
								                strAboutDialogName,
								                'chrome,modal,centerscreen,chrome,resizable=no');
        }
    },

    CLEAN_CACHE: function() {
        var title = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PRIVACY_COMP_TITLE');
        var message = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_POPUP_BLOCKER_CLEAR_CASHE_APPROVAL_MSGBOX");
        if (EBGlobalManager_CT2958529.Confirm(window, title, message)) {
            var cacheService = Components.classes["@mozilla.org/network/cache-service;1"].
		    								getService(Components.interfaces.nsICacheService);

            cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
            cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
        }
        if (isFloatingMode_CT2958529) {
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }
    },

    CLEAN_HISTORY: function() {
        var title = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PRIVACY_COMP_TITLE');
        var message = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_POPUP_BLOCKER_CLEAR_HISTORY_APPROVAL_MSGBOX");
        if (EBGlobalManager_CT2958529.Confirm(window, title, message)) {
            var historyManager = Components.classes["@mozilla.org/browser/global-history;2"].
		    								getService(Components.interfaces.nsIBrowserHistory);

            historyManager.removeAllPages();
        }
        if (isFloatingMode_CT2958529) {
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }
    },

    CLEAR_COOKIES: function() {
        var title = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PRIVACY_COMP_TITLE');
        var message = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_POPUP_BLOCKER_CLEAR_COOKIES_APPROVAL_MSGBOX");
        if (EBGlobalManager_CT2958529.Confirm(window, title, message)) {
            var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].
		    							getService(Components.interfaces.nsICookieManager);

            cookieManager.removeAll();
        }

        if (isFloatingMode_CT2958529) {
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }
    },

    OnToolbarRefresh: function(isForceRefresh) {
        //clear toggle components list
        EBToggleComponentManager_CT2958529.OnToolbarRefresh();

        EBToolbarManager_CT2958529.onBeforeRefreshAllWindows();

        //Get new settings from server
        oToolbarManager_CT2958529.refresh(isForceRefresh);
    },

    REFRESH_TOOLBAR_VIEW: function(isForceRefresh) {
        if (typeof (isForceRefresh) == "undefined") isForceRefresh = false;
        var win = (isFloatingMode_CT2958529) ? EBGlobalManager_CT2958529.GetMostRecentBrowserWindow() : window;
        var isFloatingMode = isFloatingMode_CT2958529;
        var refreshCallback = function() {
            win.EBMCManager_CT2958529.OnToolbarRefreshGrouping(false);
            win.EBMCManager_CT2958529.OnToolbarRefreshMulticommunitiesChanges(false);
            win.EBRadioManager_CT2958529.OnToolbarRefresh(false);
            win.EBChatStaticManager_CT2958529.OnToolbarRefresh(false);
            //refresh alert
            if (!isFloatingMode) EBAlertManager_CT2958529.Refresh(false);
            win.EBSpecialCommands_CT2958529.OnToolbarRefresh(isForceRefresh);
        };
        if (isFloatingMode && !isAIOMode_CT2958529) {
            win.setTimeout(refreshCallback, 1);
            getTopMostChevronStaticManager_CT2958529().CloseAllWindows();
        }
        else
            refreshCallback();
    },

    ForceRefreshWithFlags: function(flags) {
        if (!flags || flags & EBForceRefreshFlags_CT2958529.SETTINGS) {
            EBChatStaticManager_CT2958529.OnToolbarRefresh(flags & EBForceRefreshFlags_CT2958529.CHAT || !flags);
            //force refresh is allowed only for chat in this release
            EBMCManager_CT2958529.OnToolbarRefreshGrouping(false); //flags & EBForceRefreshFlags_CT2958529.GROUPING || !flags
            EBMCManager_CT2958529.OnToolbarRefreshMulticommunitiesChanges(false); //flags & EBForceRefreshFlags_CT2958529.COMMUNITIES || !flags
            EBRadioManager_CT2958529.OnToolbarRefresh(false); //flags & EBForceRefreshFlags_CT2958529.RADIO || !flags
            this.OnToolbarRefresh(true);
        }
        //if the toolbar is not refreshed, refresh here specific components
        else {
            //force refresh is allowed only for chat in this release
            if (flags & EBForceRefreshFlags_CT2958529.CHAT)
                EBChatStaticManager_CT2958529.ForceRefresh();
            /*
            if (flags & EBForceRefreshFlags_CT2958529.RADIO)
            EBRadioManager_CT2958529.ForceRefresh();

            if (flags & EBForceRefreshFlags_CT2958529.GROUPING)
            EBMCManager_CT2958529.ForceRefreshGrouping();

            if (flags & EBForceRefreshFlags_CT2958529.COMMUNITIES)
            EBMCManager_CT2958529.ForceRefreshMulticommunitiesChanges();

            if (flags & EBForceRefreshFlags_CT2958529.MY_STUFF) {
            EBMyGadgetsIO_CT2958529.InvalidateCache(true);
            //notify mystuff observer;
            }*/
        }
    },

    DELETE_SEARCH_HISTORY: function(bIsEnable, cleanOnly) {
        EBSearchBoxManager_CT2958529.ClearSearchHistoryFile();
        var aSubject = new Object();
        aSubject.wrappedJSObject = aSubject;
        aSubject.originalCTID = EBGlobalConsts_CT2958529.ToolbarCTID;
        aSubject.isEnabled = bIsEnable;
        aSubject.cleanOnly = cleanOnly;
        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
                                                            EBSearchBoxConsts_CT2958529.observerTopic,
                                                            EBSearchBoxConsts_CT2958529.observerData.changeSearchHistoryState);
    },

    UNINSTALL: function() {
        var strUninstallMsg = EBGlobalConsts_CT2958529.ToolbarName + " toolbar will be uninstalled after you restart Firefox.";
        var isUninstall = false;
        var strGUID = EBGlobalConsts_CT2958529.GUID;

        try {
            EBGlobalManager_CT2958529.UninstallExtension(strGUID);
            EBGlobalManager_CT2958529.Alert(window, strUninstallMsg, 'Uninstallation');

        } catch (err) { }
    },

    SHRINK_TOOLBAR: function() {
        var oTimeout = function() {
            EBActionManager_CT2958529.ToolbarShrink(true);
            EBToolbarManager_CT2958529.onShrinkUnshrinkAllWindows();
            EBRadioManager_CT2958529.OnShrink(true);
        };
        setTimeout(oTimeout, 1);
    },

    UNSHRINK_TOOLBAR: function() {
        var oTimeout = function() {
            EBActionManager_CT2958529.ToolbarShrink(false);
            EBRadioManager_CT2958529.OnExpand(true);
            EBToolbarManager_CT2958529.onShrinkUnshrinkAllWindows();
        };
        setTimeout(oTimeout, 1);
    },

    EMAIL_NOTIFIER_OPTIONS: function() {
        EBEMailNotifierDialogsManager_CT2958529.OpenSettingsDialog(window, false, "");
    },

    EMAIL_NOTIFIER_CHECK_NOW: function() {
        if (isFloatingMode_CT2958529) {
            var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
            oWindow.EBEMailNotifierToolbarManager_CT2958529.OnCommandCheckForNewEMailsButton();
            getTopMostChevronStaticManager_CT2958529().CloseAllWindows();
        }
        else
            EBEMailNotifierToolbarManager_CT2958529.OnCommandCheckForNewEMailsButton();
    },

    OPTIONS: function() {
        if (isFloatingMode_CT2958529) {
            var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
            setTimeout(function() {
                var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
                ChevronStaticManager.uncheckChevronButton();
                ChevronStaticManager.CloseAllWindows();
                win.EBToolbarOptionsStaticDialogManager_CT2958529.OpenDialog(win, null);
            }, 1);
        }
        else
            EBToolbarOptionsStaticDialogManager_CT2958529.OpenDialog(window, null);
    },

    CALC: function() {
        EBWindows_CT2958529.WindowsShellExecute('calc.exe', null, true);
    },

    WINWORD: function() {
        EBWindows_CT2958529.WindowsShellExecute('winword.exe', null, true);
    },

    NOTEPAD: function() {
        EBWindows_CT2958529.WindowsShellExecute('notepad.exe', null, true);
    },

    EXCEL: function() {
        EBWindows_CT2958529.WindowsShellExecute('excel.exe', null, true);
    },

    PAINT: function() {
        EBWindows_CT2958529.WindowsShellExecute('mspaint.exe', null, true);
    },

    NETMEETING: function() {
        EBWindows_CT2958529.WindowsShellExecute('conf.exe', null, true);
    },

    OUTLOOK: function() {
        EBWindows_CT2958529.WindowsShellExecute('outlook.exe', null, true);
    },

    DIALER: function() {
        EBWindows_CT2958529.WindowsShellExecute('dialer.exe', null, true);
    },

    MSCONFIG: function() {
        EBWindows_CT2958529.WindowsShellExecute('msconfig.exe', null, true);
    },

    FRONTPAGE: function() {
        EBWindows_CT2958529.WindowsShellExecute('frontpg.exe', null, true);
    },

    HELPCENTER: function() {
        EBWindows_CT2958529.WindowsShellExecute('helpctr.exe', null, true);
    },

    HYPERTERMINAL: function() {
        EBWindows_CT2958529.WindowsShellExecute('hypertrm.exe', null, true);
    },

    MSMOVIEMAKER: function() {
        EBWindows_CT2958529.WindowsShellExecute('moviemk.exe', null, true);
    },

    FILETRANSFERWIZARD: function() {
        EBWindows_CT2958529.WindowsShellExecute('migwiz.exe', null, true);
    },

    MSACCESS: function() {
        EBWindows_CT2958529.WindowsShellExecute('msaccess.exe', null, true);
    },

    MSDEV: function() {
        EBWindows_CT2958529.WindowsShellExecute('msdev.exe', null, true);
    },

    OUTLOOKEXPRESS: function() {
        EBWindows_CT2958529.WindowsShellExecute('msimn.exe', null, true);
    },

    MSINFO32: function() {
        EBWindows_CT2958529.WindowsShellExecute('msinfo32.exe', null, true);
    },

    MSNMESSENGER: function() {
        EBWindows_CT2958529.WindowsShellExecute('msnmsgr.exe', null, true);
    },

    WINZIP: function() {
        EBWindows_CT2958529.WindowsShellExecute('winzip.exe', null, true);
    },

    WORDPAD: function() {
        EBWindows_CT2958529.WindowsShellExecute('wordpad.exe', null, true);
    },

    WMPLAYER: function() {
        EBWindows_CT2958529.WindowsShellExecute('wmplayer.exe', null, true);
    },

    IIS: function() {
        EBWindows_CT2958529.WindowsShellExecute('inetmgr.exe', null, true);
    },

    PHOTOSHOP: function() {
        EBWindows_CT2958529.WindowsShellExecute('photoshop.exe', null, true);
    },

    POWERPOINT: function() {
        EBWindows_CT2958529.WindowsShellExecute('powerpnt.exe', null, true);
    },

    QUICKTIMEPLAYER: function() {
        EBWindows_CT2958529.WindowsShellExecute('quicktimeplayer.exe', null, true);
    },

    REGISTRYEDITOR: function() {
        EBWindows_CT2958529.WindowsShellExecute('regedit.exe', null, true);
    },

    CE_MOVE_LEFT_COMPONENT: function(event) {
        var strCompoId = event.target.contextComponentId;
        var iOffset = (EBGlobalManager_CT2958529.IsToolbarRTL()) ? 1 : -1;
        var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
        if (isFloatingMode_CT2958529)
            ChevronStaticManager.CloseAllWindows();
        else
            ChevronStaticManager.CloseAllAIOWindows();

        oToolbarManager_CT2958529.moveMyStuffComponent(strCompoId, iOffset);

    },

    CE_MOVE_RIGHT_COMPONENT: function(event) {
        var strCompoId = event.target.contextComponentId;
        var iOffset = (EBGlobalManager_CT2958529.IsToolbarRTL()) ? -1 : 1;
        var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
        if (isFloatingMode_CT2958529)
            ChevronStaticManager.CloseAllWindows();
        else
            ChevronStaticManager.CloseAllAIOWindows();

        oToolbarManager_CT2958529.moveMyStuffComponent(strCompoId, iOffset);

    },

    CE_HIDE_COMPONENT: function(event) {
        var strCompoId = event.target.contextComponentId;
        var objComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompoId);
        if (!objComponent) return;
        if (isFloatingMode_CT2958529) {
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }
        EBGadgetManager_CT2958529.closeGadgetsForComponent(strCompoId);
        objComponent.ComponentItem.setShowState(false);
        oToolbarManager_CT2958529._loadMyStuffComponents(true);
    },

    CE_REFRESH_COMPONENT: function(event) {
        EBSpecialCommands_CT2958529.REFRESH_TOOLBAR_VIEW(false);
        //oToolbarManager_CT2958529._refreshMyStuff(true);
        if (isFloatingMode_CT2958529) {
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }
    },

    CE_ALERT_OPTIONS: function(event) {
        //TODO
    },

    CE_MORE_FROM_THIS_PUBLISHER: function(event) {
        var strCompoId = event.target.contextComponentId;
        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompoId);
        if (!oComponent) return;

        var strUrl = oComponent.ComponentItem.publisherInfo.moreFromThisPublisherUrl;
        if (!strUrl) return;

        EBWeb_CT2958529.LoadURL(strUrl);
    },

    CM_MORE_FROM_THIS_PUBLISHER: function(event) {
        var strCompoId = event.target.contextComponentId;
        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompoId);
        if (!oComponent) return;

        var strUrl = oComponent.ComponentItem.publisherInfo.moreFromThisPublisherUrl;
        if (!strUrl) return;

        EBWeb_CT2958529.LoadURL(strUrl);
    },

    DO_UPGRADE: function() {
        var strUpgradeUrl = EBGlobalConsts_CT2958529.IsEngine ? oToolbarManager_CT2958529.data.settings.latestVersion.moduleUrl : oToolbarManager_CT2958529.data.generalToolbarInfo.webServerUrl;
        if (!strUpgradeUrl) return;

        EBWeb_CT2958529.LoadURL(strUpgradeUrl + EBGlobalConsts_CT2958529.FFExtensionFileName);
    },

    ActivateSpecialCommand: function(event, strCommandId) {
        strCommandId = strCommandId.toUpperCase();

        switch (strCommandId) {
            case "TELLAFRIEND":
                this.TELLAFRIEND();
                break;
            case "HELP":
                this.HELP(event);
                break;
            case "PRIVACY":
                this.PRIVACY(event);
                break;
            case "HOMEPAGE":
                this.HOMEPAGE(event);
                break;
            case "ABOUT":
                this.ABOUT();
                break;
            case "CONTACTUS":
                this.CONTACTUS();
                break;
            case "CLEAN_CACHE":
                this.CLEAN_CACHE();
                break;
            case "CLEAN_HISTORY":
                this.CLEAN_HISTORY();
                break;
            case "CLEAR_COOKIES":
                this.CLEAR_COOKIES();
                break;
            case "REFRESH_TOOLBAR_VIEW":
                this.REFRESH_TOOLBAR_VIEW();
                break;
            case "DELETE_SEARCH_HISTORY":
                this.DELETE_SEARCH_HISTORY();
                break;
            case "UNINSTALL":
                this.UNINSTALL();
                break;
            case "SHRINK_TOOLBAR":
                this.SHRINK_TOOLBAR();
                break;
            case "UNSHRINK_TOOLBAR":
                this.UNSHRINK_TOOLBAR();
                break;
            case "EMAIL_NOTIFIER_CHECK_NOW":
                this.EMAIL_NOTIFIER_CHECK_NOW();
                objUsage = null;
                break;
            case "EMAIL_NOTIFIER_OPTIONS":
                this.EMAIL_NOTIFIER_OPTIONS();
                objUsage = null;
                break;
            case "OPTIONS":
                this.OPTIONS();
                break;
            case 'CALC':
                this.CALC();
                break;
            case 'WINWORD':
                this.WINWORD();
                break;
            case 'NOTEPAD':
                this.NOTEPAD();
                break;
            case 'EXCEL':
                this.EXCEL();
                break;
            case 'PAINT':
                this.PAINT();
                break;
            case 'NETMEETING':
                this.NETMEETING();
                break;
            case 'OUTLOOK':
                this.OUTLOOK();
                break;
            case 'DIALER':
                this.DIALER();
                break;
            case 'MSCONFIG':
                this.MSCONFIG();
                break;
            case 'FRONTPAGE':
                this.FRONTPAGE();
                break;
            case 'HELPCENTER':
                this.HELPCENTER();
                break;
            case 'HYPERTERMINAL':
                this.HYPERTERMINAL();
                break;
            case 'MSMOVIEMAKER':
                this.MSMOVIEMAKER();
                break;
            case 'FILETRANSFERWIZARD':
                this.FILETRANSFERWIZARD();
                break;
            case 'MSACCESS':
                this.MSACCESS();
                break;
            case 'MSDEV':
                this.MSDEV();
                break;
            case 'OUTLOOKEXPRESS':
                this.OUTLOOKEXPRESS();
                break;
            case 'MSINFO32':
                this.MSINFO32();
                break;
            case 'MSNMESSENGER':
                this.MSNMESSENGER();
                break;
            case 'WINZIP':
                this.WINZIP();
                break;
            case 'WORDPAD':
                this.WORDPAD();
                break;
            case 'WMPLAYER':
                this.WMPLAYER();
                break;
            case 'IIS':
                this.IIS();
                break;
            case 'PHOTOSHOP':
                this.PHOTOSHOP();
                break;
            case 'POWERPOINT':
                this.POWERPOINT();
                break;
            case 'QUICKTIMEPLAYER':
                this.QUICKTIMEPLAYER();
                break;
            case 'REGISTRYEDITOR':
                this.REGISTRYEDITOR();
                break;
            //Conduit Engine                                                                       
            case "CE_SHARE_COMPONENT":
                this.CE_SHARE_COMPONENT(event);
                break;
            case "CE_MOVE_LEFT_COMPONENT":
                this.CE_MOVE_LEFT_COMPONENT(event);
                break;
            case "CE_MOVE_RIGHT_COMPONENT":
                this.CE_MOVE_RIGHT_COMPONENT(event);
                break;
            case "CE_HIDE_COMPONENT":
                this.CE_HIDE_COMPONENT(event);
                break;
            case "CE_REFRESH_COMPONENT":
                this.CE_REFRESH_COMPONENT(event);
                break;
            case "CE_ALERT_OPTIONS":
                this.CE_ALERT_OPTIONS(event);
                break;
            case "CE_MORE_FROM_THIS_PUBLISHER":
                this.CE_MORE_FROM_THIS_PUBLISHER(event);
                break;
            case "CM_MORE_FROM_THIS_PUBLISHER":
                this.CM_MORE_FROM_THIS_PUBLISHER(event);
                break;
            case "DO_UPGRADE":
                this.DO_UPGRADE(event);
                break;
        }
    },

    IsSupportedCommand: function(strCommandId) {
        strCommandId = strCommandId.toUpperCase();

        switch (strCommandId) {
            case "TELLAFRIEND":
                return true;
                break;
            case "HELP":
                return true;
                break;
            case "PRIVACY":
                return true;
                break;
            case "HOMEPAGE":
                return true;
                break;
            case "ABOUT":
                return true;
                break;
            case "CONTACTUS":
                return true;
                break;
            case "CLEAN_CACHE":
                return true;
                break;
            case "CLEAN_HISTORY":
                return true;
                break;
            case "CLEAR_COOKIES":
                return true;
                break;
            case "REFRESH_TOOLBAR_VIEW":
                return true;
                break;
            case "DELETE_SEARCH_HISTORY":
                return true;
                break;
            case "UNINSTALL":
                return true;
                break;
            case "SHRINK_TOOLBAR":
                return true;
                break;
            case "UNSHRINK_TOOLBAR":
                return true;
                break;
            case "EMAIL_NOTIFIER_CHECK_NOW":
                return true;
                break;
            case "EMAIL_NOTIFIER_OPTIONS":
                return true;
                break;
            case "OPTIONS":
                return true;
                break;
            //Conduit Engine commands                                                                          
            case "CE_SHARE_COMPONENT": return true; break;
            case "CE_MOVE_LEFT_COMPONENT": return true; break;
            case "CE_MOVE_RIGHT_COMPONENT": return true; break;
            case "CE_HIDE_COMPONENT": return true; break;
            case "CE_REFRESH_COMPONENT": return true; break;
            case "CE_ALERT_OPTIONS": return true; break;
            case "CE_MORE_FROM_THIS_PUBLISHER": return true; break;
            case "CM_MORE_FROM_THIS_PUBLISHER": return true; break;
            case "DO_UPGRADE": return true; break;

            //3rd party commands                                                                      
            case "CALC":
                //in every third component application i check if this is 
                //windows OS and if there is this application under window!
                if (EBWindows_CT2958529.WindowsShellExecute('calc.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "WINWORD":
                if (EBWindows_CT2958529.WindowsShellExecute('winword.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "NOTEPAD":
                if (EBWindows_CT2958529.WindowsShellExecute('notepad.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "EXCEL":
                if (EBWindows_CT2958529.WindowsShellExecute('excel.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "PAINT":
                if (EBWindows_CT2958529.WindowsShellExecute('mspaint.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "NETMEETING":
                if (EBWindows_CT2958529.WindowsShellExecute('conf.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "OUTLOOK":
                if (EBWindows_CT2958529.WindowsShellExecute('outlook.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "DIALER":
                if (EBWindows_CT2958529.WindowsShellExecute('dialer.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "MSCONFIG":
                if (EBWindows_CT2958529.WindowsShellExecute('msconfig.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "FRONTPAGE":
                if (EBWindows_CT2958529.WindowsShellExecute('frontpg.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "HELPCENTER":
                if (EBWindows_CT2958529.WindowsShellExecute('helpctr.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "HYPERTERMINAL":
                if (EBWindows_CT2958529.WindowsShellExecute('hypertrm.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "MSMOVIEMAKER":
                if (EBWindows_CT2958529.WindowsShellExecute('moviemk.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "FILETRANSFERWIZARD":
                if (EBWindows_CT2958529.WindowsShellExecute('migwiz.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "MSACCESS":
                if (EBWindows_CT2958529.WindowsShellExecute('msaccess.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "MSDEV":
                if (EBWindows_CT2958529.WindowsShellExecute('msdev.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "OUTLOOKEXPRESS":
                if (EBWindows_CT2958529.WindowsShellExecute('msimn.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "MSINFO32":
                if (EBWindows_CT2958529.WindowsShellExecute('msinfo32.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "MSNMESSENGER":
                if (EBWindows_CT2958529.WindowsShellExecute('msnmsgr.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "WINZIP":
                if (EBWindows_CT2958529.WindowsShellExecute('winzip.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "WORDPAD":
                if (EBWindows_CT2958529.WindowsShellExecute('wordpad.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "WMPLAYER":
                if (EBWindows_CT2958529.WindowsShellExecute('wmplayer.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "IIS":
                if (EBWindows_CT2958529.WindowsShellExecute('inetmgr.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "PHOTOSHOP":
                if (EBWindows_CT2958529.WindowsShellExecute('photoshop.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "POWERPOINT":
                if (EBWindows_CT2958529.WindowsShellExecute('powerpnt.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "QUICKTIMEPLAYER":
                if (EBWindows_CT2958529.WindowsShellExecute('quicktimeplayer.exe', null, false))
                    return true;
                else
                    return false;
                break;
            case "REGISTRYEDITOR":
                if (EBWindows_CT2958529.WindowsShellExecute('regedit.exe', null, false))
                    return true;
                else
                    return false;
                break;
        }

        return false;
    }
}


var EBComponentsConsts_CT2958529 =
{
    TRUE: 'TRUE',
    FALSE: 'FALSE',
    TooltipPrefix: 'EBTooltip_',
    ToolbarButtonIDPrefix: 'EBToolbarButton_',
    MainPopupSetID: 'EBMainPopupSet_CT2958529',
    DontChangeTerm: 'EB_DONT_CHANGE_TERM',
    EMailNotifierNewID: 'EBEmailNotifierNewBrowserHelperObject',

    Editable:
	{
	    FULL: 'FULL',
	    NONE: 'NONE'
	},

    //components type to distinguish between The different type of components
    //components coming from the original settings request,components coming from the third party components request, etc..
    ComponentsType:
	{
	    Settings: 'Settings',
	    ThirdParty: 'ThirdParty',
	    UserAdded: 'UserAdded',
	    UserFavorites: 'UserFavorites'
	},

    Caption:
	{
	    Loading: 'Loading...',
	    New: 'new',
	    EmailFailed: 'Failed',
	    Unread: 'unread'
	}
};


var EBComponentsManager_CT2958529 =
{
    ValidateComponentID: function(strCompID) {
        var strValidateCompID = strCompID;
        if (!strValidateCompID)
            strValidateCompID = EBGlobalManager_CT2958529.GenerateRandomNumber();

        return strValidateCompID;
    },

    IsEditableComponent: function(objToolbarComponent) {
        var strPermission = objToolbarComponent.ComponentItem.Permission;
        return (strPermission.toUpperCase() != EBComponentsConsts_CT2958529.Editable.NONE)
    },

    GetComponentByCompID: function(strCompID) {
        try {
            var oComponent = null;
            if (EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.Contains(strCompID))
                oComponent = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.GetByID(strCompID);

            return oComponent;
        }
        catch (e) { EBLog(e); }
    },

    GetMainMenuComponent: function() {
        var strMainMenuCompID = oToolbarManager_CT2958529.data.componentsIds.MainMenu;
        var oMainMenuComponent = this.GetComponentByCompID(strMainMenuCompID);
        return oMainMenuComponent;
    },

    GetSearchBoxComponent: function() {
        var strSearchBoxCompID = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var objSearchBoxComponent = this.GetComponentByCompID(strSearchBoxCompID);
        return objSearchBoxComponent;
    },

    GetEMailNotifierComponent: function() {
        var strEMailNotifierCompID = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var objEMailNotifierComponent = this.GetComponentByCompID(strEMailNotifierCompID);
        return objEMailNotifierComponent;
    },

    GetEMailNotifierToolbarButton: function() {
        var oXULToolbarButton = null;
        var oEMailNotifierComponent = this.GetEMailNotifierComponent();
        if (oEMailNotifierComponent)
            oXULToolbarButton = oEMailNotifierComponent.XULElement;

        return oXULToolbarButton;
    },

    GetWeatherComponent: function() {
        var strWeatherCompID = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var oWeatherComponent = this.GetComponentByCompID(strWeatherCompID);
        return oWeatherComponent;
    },

    GetRadioComponent: function() {
        var strRadioCompID = EBGlobalConsts_CT2958529.IsEngine ? ToolbarManager_CT2958529.data.componentsIds.Radio : oToolbarManager_CT2958529.data.componentsIds.Radio;
        var oRadioComponent = this.GetComponentByCompID(strRadioCompID);
        return oRadioComponent;
    },

    GetMainMenuToolbarButton: function() {
        var oToolbarButton = null;
        var oMainMenuComponent = this.GetMainMenuComponent();
        if (oMainMenuComponent)
            oToolbarButton = oMainMenuComponent.XULElement;
        return oToolbarButton;
    },

    GetMainMenuToolbarLogo: function() {
        var strLogo = '';
        var oMainToolbarButton = this.GetMainMenuToolbarButton();
        if (oMainToolbarButton)
            strLogo = oMainToolbarButton.getAttribute('image');
        return strLogo;
    },

    //TODO: should be removed
    GetWeatherComponentButton: function() {
        var oWeatherComponent = this.GetWeatherComponent();
        var oXULButton = null;
        if (oWeatherComponent)
            oXULButton = oWeatherComponent.XULElement;

        return oXULButton;
    },

    GetWeatherComponentChevronElement: function() {
        var oWeatherComponent = this.GetWeatherComponent();
        var oXULChevronElement = null;
        if (oWeatherComponent)
            oXULChevronElement = oWeatherComponent.XULChevronElement;

        return oXULChevronElement;
    },

    //TODO: should be removed
    GetSearchBoxMenuList: function() {
        var XULSearchMenuList = null;
        var objSearchBoxComponent = this.GetSearchBoxComponent();

        if (objSearchBoxComponent)
            XULSearchMenuList = objSearchBoxComponent.xulMenuList;

        return XULSearchMenuList;
    },

    GetAllDynamicMenuComponents: function() {
        if (!EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash)
            return null;

        var arrComp = new Array();
        var oComp = null;

        for (var i = 0; i < EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.Count(); i++) {
            oComp = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.GetByIndex(i);

            if (oComp instanceof EBDynamicMenuComponent_CT2958529 && oComp.ComponentItem.isShow())
                arrComp.push(oComp);
        }

        return arrComp;
    },

    GetChatComponent: function() {
        if (!EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash) return null;

        var oComp = null;
        var strChatCompID = oToolbarManager_CT2958529.data.componentsIds.Chat;
        oComp = this.GetComponentByCompID(strChatCompID);

        if (oComp && !oComp.ComponentItem.isShow)
            return null;
        else
            return oComp;
    },

    GetFacebookComponent: function() {
        var strFacebookCompID = oToolbarManager_CT2958529.data.componentsIds.Facebook;
        var objFacebookComponent = this.GetComponentByCompID(strFacebookCompID);
        //dumpAllProp(objFacebookComponent);
        return objFacebookComponent;
    },

    //the toolbarbutton id is for the tooltip attach for this button
    //to the tooltip-shrink effect
    GetToolbarButtonID: function(strCompID) {
        var strToolbarButtonIDPrefix = EBComponentsConsts_CT2958529.ToolbarButtonIDPrefix;
        var strToolbarButtonID = strToolbarButtonIDPrefix + strCompID + EBGlobalConsts_CT2958529.ToolbarCTID;
        return strToolbarButtonID;
    },

    GetTooltipID: function(strCompID) {
        var strTooltipPrefix = EBComponentsConsts_CT2958529.TooltipPrefix;
        var strTooltipID = strTooltipPrefix + strCompID + EBGlobalConsts_CT2958529.ToolbarCTID;
        return strTooltipID;
    },

    AddTooltip: function(strCompID, objXULToolbarButton) {
        var strMainPopupSetID = EBComponentsConsts_CT2958529.MainPopupSetID;
        var objMainPopupSet = document.getElementById(strMainPopupSetID);

        var strTooltipID = this.GetTooltipID(strCompID);
        var strOrient = 'vertical';

        //patch to 1.0.* - send the toolbarbutton id to retrieve the label and tooltip instead of
        //the toolbarbutton object itself as a param to the onpopupshowing event
        //set addEventListener also fails to work in 1.0.*
        var strToolbarButtonID = objXULToolbarButton.getAttribute('id');
        var objXULTooltip = EBXULFactory_CT2958529.CreateTooltip(strTooltipID, strOrient, "");
        objXULTooltip.addEventListener("popupshowing", function(event) {
            return EBToolbarDesignManager_CT2958529.OnTooltipPopupShowing(event, strToolbarButtonID);
            event.stopPropagation();
        }, false);

        objMainPopupSet.appendChild(objXULTooltip);
    },

    ExecuteApplication: function(exeAlias, params, notFoundLink, event) {
        var strExeFile = EBWindows_CT2958529.GetApplicationFullPath(exeAlias);
        var bIsExists = EBWindows_CT2958529.WindowsShellDirectExecute(strExeFile, null, false);
        if (bIsExists)
            EBWindows_CT2958529.WindowsShellDirectExecute(strExeFile, params, true);
        else {
            event.customData = { "url": notFoundLink, "urlTarget": "NEW" };
            EBLinkManager_CT2958529.LoadLinkURL(event);
        }
    },

    IsFirstComponent: function(strCompId) {
        if (!EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash ||
            EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.Count() == 0) return false;

        var firstComp = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.GetByIndex(0);
        if (!firstComp) return false;
        if (firstComp.isTemporary) {
            var secondComp = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.GetByIndex(1);
            if (secondComp && secondComp.ComponentItem.UniqueCompID == strCompId) return true;
        }
        return firstComp.ComponentItem.UniqueCompID == strCompId;
    },

    IsLastComponent: function(strCompId) {
        if (!EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash ||
            EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.Count() == 0) return false;

        var count = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.Count();
        var lastComp = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.GetByIndex(count - 1);
        if (!lastComp) return false;

        return lastComp.ComponentItem.UniqueCompID == strCompId;
    }
};

var EBToolbarDesignConsts_CT2958529 =
{
    SubMenuRTLClass: 'eb-submenu-rtl_CT2958529',
    SubMenuLTRClass: 'eb-submenu-ltr_CT2958529',
    
    SubMenuRTLClassFF3: 'eb-submenu-rtlFF3_CT2958529',
    SubMenuLTRClassFF3: 'eb-submenu-ltrFF3_CT2958529',
    
    ToolbarButtonHideTextClass: 'eb-toolbarbutton-hidetext_CT2958529',
    ToolbarButtonShowTextClass: 'eb-toolbarbutton-showtext_CT2958529',
    ToolbarButtonShowTextClassRTL: 'eb-toolbarbutton-showtextRTL_CT2958529',
    
    ToolbarButtonMenuButtonClassMAC: 'eb-toolbarbutton-menubuttonMAC_CT2958529',
    ToolbarButtonMenuButtonClassWIN: 'eb-toolbarbutton-menubuttonWIN_CT2958529',
    ToolbarButtonMenuButtonClassLINUX: 'eb-toolbarbutton-menubuttonLINUX_CT2958529',
    TOOLBAR_BUTTON_APP_VIEW: "ebToolbarButton24View_CT2958529",
    TOOLBAR_IS_RTL: "ebRTL_CT2958529",
    ToolbarButtonMenuClass: 'eb-toolbarbutton-menu_CT2958529', //TODO - check if needed to be changed in 24
    EngineButtonChevronClass: 'eb-toolbarbutton-chevron_'+EBGlobalConsts_CT2958529.EngineCTID, //TODO - check if needed to be changed in 24
    ToolbarMenuButtonOnlyIconClass: 'eb-toolbarbutton-menu-onlyicon_CT2958529',
    ToolbarButtonOnlyIconClass: 'eb-toolbarbutton-onlyicon_CT2958529',
    
    ToolbarMaxImageHeightStyle: 'max-height:25px;'
};

var EBToolbarDesignManager_CT2958529 =
{
    //set toolbarbuttons class - according to their type
    //or shrink unshrink state of toolbar
    SetToolbarButtonClass: function(strCompID, XULToolbarButton) {
        if (!XULToolbarButton || EBActionManager_CT2958529.IsAppView()) return;

        var arrClassAttribute = new Array();

        var strLabel = XULToolbarButton.getAttribute('label');
        var strImage = XULToolbarButton.getAttribute('image');
        var strType = XULToolbarButton.getAttribute('type');

        if (strType == 'menu-button') {
            if (EBGlobalManager_CT2958529.IsWindowsPlatform())
                arrClassAttribute[arrClassAttribute.length] = EBToolbarDesignConsts_CT2958529.ToolbarButtonMenuButtonClassWIN;
            else if (EBGlobalManager_CT2958529.IsMacintoshPlatform())
                arrClassAttribute[arrClassAttribute.length] = EBToolbarDesignConsts_CT2958529.ToolbarButtonMenuButtonClassMAC;
            else
                arrClassAttribute[arrClassAttribute.length] = EBToolbarDesignConsts_CT2958529.ToolbarButtonMenuButtonClassLINUX;
        }

        //check if this button is regular button with image only
        //to set to it the special css class that reduce the gap 
        //between the image edge to the toolbar 
        //it also check that this style will be set to only icon in toolbarbutton type=menubutton
        //to reduce that bug
        if (!strLabel && strImage) {
            if (strType == 'menu')
                arrClassAttribute[arrClassAttribute.length] = EBToolbarDesignConsts_CT2958529.ToolbarMenuButtonOnlyIconClass;
            else
                arrClassAttribute[arrClassAttribute.length] = EBToolbarDesignConsts_CT2958529.ToolbarButtonOnlyIconClass;
        }


        var strClassHideText = EBToolbarDesignConsts_CT2958529.ToolbarButtonHideTextClass;
        var strClassShowText = EBToolbarDesignConsts_CT2958529.ToolbarButtonShowTextClass;
        var objComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompID);
        var btnText = '';

        if (objComponent)
            btnText = objComponent.ComponentItem.DisplayText;

        if (!this.IsLTRLanguage(btnText))
            strClassShowText = EBToolbarDesignConsts_CT2958529.ToolbarButtonShowTextClassRTL;

        if (EBActionManager_CT2958529.ToolbarShrink()) {
            EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance.setAttribute("mode", "icons");
        }
        else {
            if (strLabel) {
                arrClassAttribute[arrClassAttribute.length] = strClassShowText;

                if (strType == 'menu')//if there is label then set this class(padding the text class)
                    arrClassAttribute[arrClassAttribute.length] = EBToolbarDesignConsts_CT2958529.ToolbarButtonMenuClass;
            }
            this.SetTooltipUnShrink(XULToolbarButton);
        }

        var strClass = arrClassAttribute.join(' ');
        XULToolbarButton.setAttribute('class', strClass);
    },

    SetToolbarButtonGlobalStyle: function(objToolbarButton) {
        if (EBActionManager_CT2958529.IsAppView()) return;
        //i set the style of the button using the getAnonymousNodes of that button
        //this method return the core elements (low-level elements) of this xul element
        //and this way we can set the style only to them - and not to their dom childs!
        //if this regular button we need to set the xul:label Anonymous Node
        //if this toolbarbutton is from type menu-button we set the xul:toolbarbutton core element
        var strStyle = oToolbarSkin_CT2958529.getStyleString();
        if (objToolbarButton.tagName == 'label')
            objToolbarButton.setAttribute('style', strStyle);
        else {
            var objAnonymousNodes = document.getAnonymousNodes(objToolbarButton);
            var objNode = null;

            if (objAnonymousNodes) {
                for (var i = 0; i < objAnonymousNodes.length; i++) {
                    objNode = objAnonymousNodes[i];
                    if (objNode.tagName == 'xul:toolbarbutton' ||
					    objNode.tagName == 'xul:label') {
                        objNode.setAttribute('style', strStyle);
                    }
                }
            }
        }
    },

    IdealTextColor: function(bg) {
        var nThreshold = 105;
        var bgR = parseInt(bg.slice(1, 3), 16);
        var bgG = parseInt(bg.slice(3, 5), 16);
        var bgB = parseInt(bg.slice(5, 7), 16);
        var bgDelta = parseInt((bgR * 0.299) + (bgG * 0.587) + (bgB * 0.114));
        var foreColor = (255 - bgDelta < nThreshold) ? '#000000' : '#FFFFFF';
        return foreColor;
    },

    SetToolbarSearchBoxBGColor: function(objSearchBox, strBGColor) {
        if (strBGColor && strBGColor.toUpperCase() != '#FFFFFF') {
            objSearchBox.inputField.setAttribute('style', 'background-color:' + strBGColor + ';');
            objSearchBox.setAttribute('style', 'background-color:' + strBGColor + ';');
            var textColor = this.IdealTextColor(strBGColor);
            if (textColor != "#000000") {
                var oldStyle = objSearchBox.inputField.getAttribute("style");
                objSearchBox.inputField.setAttribute("style", oldStyle + "color:" + textColor + ";");
            }
        }
    },

    SetTooltipShrink: function(strCompID, XULToolbarButton) {
        if (this.IsSpecialTooltip(XULToolbarButton)) {
            return;
        }

        //check if this toolbar need tooltip shrink
        var strLabel = XULToolbarButton.getAttribute('label');
        if (!strLabel) {
            return;
        }

        var strTooltipID = EBComponentsManager_CT2958529.GetTooltipID(strCompID);

        XULToolbarButton.setAttribute('tooltip', strTooltipID);
        XULToolbarButton.removeAttribute('tooltiptext');
    },

    SetTooltipUnShrink: function(XULToolbarButton) {
        if (this.IsSpecialTooltip(XULToolbarButton)) return;

        XULToolbarButton.removeAttribute('tooltip');
        var strOriginalTooltip = XULToolbarButton.getAttribute(EBGlobalConsts_CT2958529.Attributes.XULTooltip);

        if (strOriginalTooltip)
            XULToolbarButton.setAttribute('tooltiptext', strOriginalTooltip);
    },

    //function that checks if the toolbarbutton element is set to 
    //special tooltip to not set to it the shrink-unshrink tooltip - like the weather forecast tooltip
    IsSpecialTooltip: function(oXULToolbarButton) {
        var strTooltipID = oXULToolbarButton.getAttribute('tooltip');

        if (strTooltipID == EBWeatherGUIConsts_CT2958529.ForecastTooltipID) return true;

        return false;
    },

    OnTooltipPopupShowing: function(event, strToolbarButtonID) {

        if (event.eventPhase == 2) {
            var XULTooltip = event.target;
            var XULToolbarButton = document.getElementById(strToolbarButtonID);

            //check to see if the mouse is hover the toolbarbutton
            //to prevent this tooltip shown on this toolbar buttons childs
            if (!EBGlobalManager_CT2958529.IsElementInScreenCoordinates(XULToolbarButton))
                return false;

            while (XULTooltip.childNodes.length > 0)
                XULTooltip.removeChild(XULTooltip.firstChild);

            var strOriginalTooltip = XULToolbarButton.getAttribute(EBGlobalConsts_CT2958529.Attributes.XULTooltip);
            var strLabel = XULToolbarButton.getAttribute('label');

            var XULLabelButtonLabel = null;
            var XULLabelButtonTooltip = null;

            if (strLabel)
                XULLabelButtonLabel = EBXULFactory_CT2958529.CreateLabel(strLabel, '');

            if (strOriginalTooltip)
                XULLabelButtonTooltip = EBXULFactory_CT2958529.CreateLabel(strOriginalTooltip, '');

            if (XULLabelButtonLabel)
                XULTooltip.appendChild(XULLabelButtonLabel);

            if (XULLabelButtonTooltip)
                XULTooltip.appendChild(XULLabelButtonTooltip);

            return true;
        }

        return false;
    },

    IsLTRLanguage: function(strText) {
        if (!strText) return true;

        var ch = '';
        for (var i = 0; i < strText.length; i++) {
            ch = strText.charCodeAt(i)
            if (ch >= 1488 && ch <= 1514)
                return false;
        }

        return true;
    },

    GetToolbarWidth: function() {
        return parseInt(document.defaultView.getComputedStyle(EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer, null).getPropertyValue("width"));
    },

    verticalAlign: function(obj) {
        var objParent = obj.parentNode;
        var objHeight = obj.boxObject.height;
        var parentHeight = parseInt(document.defaultView.getComputedStyle(objParent, null).getPropertyValue("height"));
        var iMargin = (parentHeight - objHeight) / 2;
        objParent.style.paddingTop = iMargin + "px";
    }
};

//this class is ment for action on the firefox browser itself
//like the context-menu etc...

var EBFirefoxBrowserManager_CT2958529 =
{
    OnLoadWindow: function() {
        //set the context menu 
        this.SetContextMenuPopupShowingListener();
    },

    //set event listener to popupshowing so we coulde catch
    //the change for the check uncheck of the toolbar from the toolbars
    //context menu of the browser itself
    SetContextMenuPopupShowingListener: function() {
        var oToolbarsContextMenu = document.getElementById('toolbar-context-menu');
        var oToolbarsMenu = document.getElementById('viewToolbarsMenu');
        if (oToolbarsContextMenu)
            oToolbarsContextMenu.addEventListener('popupshowing',
								    	EBFirefoxBrowserManager_CT2958529.OnPopupShowingToolbarContextMenu,
								    	false);
        if (oToolbarsMenu)
            oToolbarsMenu.addEventListener('popupshowing',
					    				EBFirefoxBrowserManager_CT2958529.OnPopupShowingToolbarContextMenu,
						    			false);
    },

    OnPopupShowingToolbarContextMenu: function(event) {
        var oToolbarsContextMenu = event.target;

        //set the listener for the command on this toolbar context menu item:

        //get the toolbar name for comparison
        var strToolbarLabel = "browsersearch Community Toolbar";

        var oMenuItem = null;
        //loop all the elments in the context menu till there 
        //is a match with the toolbar name and set to this menu item
        //element the listener for the oncommand



        for (var i = 0; i < oToolbarsContextMenu.childNodes.length; i++) {
            oMenuItem = oToolbarsContextMenu.childNodes[i];

            if (oMenuItem.getAttribute('label').indexOf(strToolbarLabel) != -1) {
                oMenuItem.addEventListener('command', EBFirefoxBrowserManager_CT2958529.OnCommandToolbarContextMenuItem, false);

                if (EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.isEngineInDualPackage())
                    oMenuItem.setAttribute("checked", EBPreferenceForLocalStorage_CT2958529.IsEngineShown);
                break;
            }
        }
    },

    OnCommandToolbarContextMenuItem: function(event) {
        var oMenuItem = event.target;
        var strChecked = oMenuItem.getAttribute('checked');

        if (strChecked)
            strChecked = strChecked.toLowerCase();

        //show
        if (strChecked == 'true') {
            EBObserversManager_CT2958529.NotifyCustomObserver(null, EBObserversManager_CT2958529.ToolbarEventsTopic,
                                                                EBObserversManager_CT2958529.ToolbarEventsData.ToolbarShow);
            if (DualPackageFunctions_CT2958529.isToolbarInDualPackage() && DualPackageFunctions_CT2958529.engineOwnerCTID() == EBGlobalConsts_CT2958529.ToolbarCTID && (DualPackageFunctions_CT2958529.isEngineVisible() || !(window["EBPreferenceForLocalStorage_" + EBGlobalConsts_CT2958529.EngineCTID] && window["EBPreferenceForLocalStorage_" + EBGlobalConsts_CT2958529.EngineCTID].EngineHiddenByUser))) {
                EBObserversManager_CT2958529.NotifyCustomObserver(DualPackageFunctions_CT2958529.getSubjectIncludeMainWindowId(), EBObserversManager_CT2958529.DualPackageTopic,
                                                                EBObserversManager_CT2958529.DualPackageData.ToolbarShow);


            }

            var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
            var win = null;
            //engine
            if (EBGlobalConsts_CT2958529.IsEngine) {
                EBToolbarManager_CT2958529.showToolbar();
                EBToolbarManager_CT2958529.onMyStuffChange();
            }
            //toolbar
            else {
                for (var i = 0; i < arrWindows.length; i++) {
                    win = arrWindows[i];
                    if (win.EBToolbarManager_CT2958529) {
                        win.EBLoadToolbar_CT2958529();
                        win.EBWebPageApiManager_CT2958529.reregisterApi();
                    }
                }
            }
        }
        //hide
        else {
            if (EBGlobalConsts_CT2958529.IsEngine) {
                EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EngineHiddenByUser, true);
                EBPreferenceForLocalStorage_CT2958529.EngineHiddenByUser = true;
            }
            else if (DualPackageFunctions_CT2958529.isEngineVisible()) {
                EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EngineHiddenByUser, false);
                window["EBPreferenceForLocalStorage_" + EBGlobalConsts_CT2958529.EngineCTID].EngineHiddenByUser = false;
            }

            if (DualPackageFunctions_CT2958529.isToolbarInDualPackage() && DualPackageFunctions_CT2958529.engineOwnerCTID() == EBGlobalConsts_CT2958529.ToolbarCTID && DualPackageFunctions_CT2958529.isEngineVisible()) {
                EBObserversManager_CT2958529.NotifyCustomObserver(DualPackageFunctions_CT2958529.getSubjectIncludeMainWindowId(), EBObserversManager_CT2958529.DualPackageTopic,
                                                                EBObserversManager_CT2958529.DualPackageData.ToolbarHide);


            }

            EBObserversManager_CT2958529.NotifyCustomObserver(null, EBObserversManager_CT2958529.ToolbarEventsTopic,
                                                                EBObserversManager_CT2958529.ToolbarEventsData.ToolbarHide);

            if (!DualPackageFunctions_CT2958529.engineOwnerCTID() && DualPackageFunctions_CT2958529.isEngineStandAlone()) {
                DualPackageFunctions_CT2958529.setEngineOwner(EBGlobalConsts_CT2958529.ToolbarCTID, EBGlobalConsts_CT2958529.ToolbarId, EBGlobalConsts_CT2958529.GUID);
            }

            var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
            var win = null;
            //engine
            if (EBGlobalConsts_CT2958529.IsEngine) {
                EBToolbarManager_CT2958529.hideToolbar(true);
            }
            //toolbar
            else {
                for (var i = 0; i < arrWindows.length; i++) {
                    win = arrWindows[i];
                    if (win.EBToolbarManager_CT2958529) {
                        EBUnloadToolbar_CT2958529(false);
                        EBWebPageApiManager_CT2958529.unregisterApi();
                    }
                }
            }

            //close all gadgets
            var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
            oWindow.EBGadgetsMinimizeManager_CT2958529.closeAllGadgetWindows();
        }
    },

    GetSubjectForDualPackage: function() {
        var objSubject = new Object();
        objSubject.wrappedJSObject = objSubject;

        var engineOwnerCTID = DualPackageFunctions_CT2958529.engineOwnerCTID();
        if (!engineOwnerCTID)
            return null;

        var engineOwnerGlobalManager = window["EBGlobalManager_" + engineOwnerCTID];
        if (!engineOwnerGlobalManager)
            return null;

        var mainWindowId = engineOwnerGlobalManager.GetMostRecentBrowserWindow(true).gBrowser["ebWindowId_" + engineOwnerCTID];
        objSubject.windowId = mainWindowId;
        return objSubject;
    }
};

var EBHighlighterConsts_CT2958529 =
{
    DisplayText: 'Highlighter',
    HighlightButtonsContainerID: 'EBHighlighterButtonsContainer_CT2958529',

    Images:
	{
	    HighlighterChevron: 'chrome://browsersearch/skin/highlighter_chevron.png',
	    HighlighterSearchTerm: 'chrome://browsersearch/skin/highlighterSearchTerm.png'
	},

    Attributes:
	{
	    HighlightButtonName: 'EB_HIGHLIGHT_BUTTON_ATT_NAME',
	    HighlightButtonValue: 'EB_HIGHLIGHT_BUTTON_ATT_VALUE',
	    IsInChevron: 'EB_HIGHLIGHTER_IS_IN_CHEVRON'
	}
};

var EBHighlighterManager_CT2958529 =
{
    FindRange: Components.classes['@mozilla.org/embedcomp/rangefind;1'].
					createInstance().QueryInterface(Components.interfaces.nsIFind),

    COLORS: ['Yellow', 'Cyan', 'Fuchsia', 'Chartreuse', 'Dodgerblue'],
    SPAN_ID: 'EBSpanHighlighter',
    ARR_TERMS: null,

    OnCommandHighlighter: function(event) {
        EBToolbarManager_CT2958529.dataToolbarObject.IsHighlighting = !EBToolbarManager_CT2958529.dataToolbarObject.IsHighlighting;

        //get the object from the toolbar 
        var objXULHighlighterToolbarButton = EBSearchBoxManager_CT2958529.GetHighlighterButtonOnToolbar();


        if (EBToolbarManager_CT2958529.dataToolbarObject.IsHighlighting) {
            objXULHighlighterToolbarButton.setAttribute("checked", true);
            this.Highlight();
        }
        else {
            objXULHighlighterToolbarButton.setAttribute("checked", false);
            this.UnHighlight();
        }

        //Usage
        EBUsageHighlighter_CT2958529.OnClick(EBToolbarManager_CT2958529.dataToolbarObject.IsHighlighting);
    },

    GetSearchTerm: function() {
        var strSearchQuery = EBComponentsManager_CT2958529.GetSearchBoxComponent().xulMenuList.value;
        return strSearchQuery;
    },

    Highlight: function() {
        //get the value from the menulist textbox
        this.ARR_TERMS = null;
        this.ARR_TERMS = this.GetTermsToHighlight();

        var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        for (var i = 0; i < this.ARR_TERMS.length; i++) {
            this.HighlightWindow(win, this.ARR_TERMS[i], this.COLORS[i % this.COLORS.length]);
        }
    },

    UnHighlight: function() {
        var arrTabs = EBGlobalManager_CT2958529.GetAllTabs();
        for (var i = 0; i < arrTabs.length; i++)
            this.ClearHighlight(arrTabs[i].contentWindow);
    },

    TabChange: function(aProgress) {
        if (EBToolbarManager_CT2958529.dataToolbarObject.IsHighlighting)
            this.Highlight();
        else
            this.UnHighlight();
    },

    GetTermsToHighlight: function() {
        var strSearchQuery = this.GetSearchTerm();
        var tokens = [];
        tokens = this.TokenizeSearchQuery(strSearchQuery);
        tokens = this.RemoveOperators(tokens);
        tokens = this.NormalizeSpacing(tokens);
        return this.RemoveAdjacentDuplicates(tokens);
    },

    TokenizeSearchQuery: function(input) {
        var tokens = [];
        var state = 0;
        for (var i = 0; i < input.length; ++i) {
            var ch = input[i];
            if (state == 0) {
                if (ch == '"') {
                    tokens.push(["", true]);
                    state = 2
                }
                else if (!EBGlobalManager_CT2958529.IsCharWhitespace(ch) && !EBGlobalManager_CT2958529.IsCharPunctuation(ch)) {
                    tokens.push([ch, false]);
                    state = 1;
                }
            }
            else if (state == 1) {
                if (EBGlobalManager_CT2958529.IsCharWhitespace(ch) || EBGlobalManager_CT2958529.IsCharPunctuation(ch)) {
                    state = 0;
                }
                else {
                    tokens[tokens.length - 1][0] += ch;
                }
            }
            else if (state == 2) {
                if (ch == '"') {
                    state = 0;
                }
                else {
                    tokens[tokens.length - 1][0] += ch;
                }
            }
        }
        return tokens;
    },

    RemoveOperators: function(tokens) {
        var results = [];
        for (var i = 0; i < tokens.length; ++i) {
            var token = tokens[i][0];
            if (tokens[i][1]) {
                if (token.length > 0) {
                    results.push(token);
                }
                continue;
            }
            if (token.toUpperCase() == "OR") {
                continue;
            }
            if (token[0] == "-") {
                continue;
            }
            if (token == "*" || (token == "/" || (token == "^" || token == "%"))) {
                continue;
            }
            if (/\d+\.\.\.\d+/.test(token)) {
                continue;
            }
            if (token[0] == "~") {
                token = token.substring(1);
            }
            token = token.replace(/-+/g, " ");
            results.push(token);
        }
        return results;
    },

    NormalizeSpacing: function(tokens) {
        var results = [];
        for (var i = 0; i < tokens.length; ++i) {
            var token = tokens[i];
            token = token.replace(/^\s+/, "");
            token = token.replace(/\s+$/, "");
            token = token.replace(/\s+/g, " ");
            if (token.length > 0) {
                results.push(token);
            }
        }
        return results;
    },

    RemoveAdjacentDuplicates: function(list) {
        if (list.length == 0) {
            return list;
        }
        var last = 0;
        for (var i = 1; i < list.length; ++i) {
            if (list[i] != list[last]) {
                list[++last] = list[i];
            }
        }
        list.length = last + 1;
        return list;
    },

    IsNodeInputNodeOrChildOf: function(node) {
        if (node.nodeName.toUpperCase() == "INPUT")
            return true;
        if (node.parentNode != null)
            return this.IsNodeInputNodeOrChildOf(node.parentNode);
        return false;
    },

    HighlightWindow: function(win, text, color) {
        if (!win)
            win = window._content;

        if (win.frames != null) {
            for (var i = 0; i < win.frames.length; i++) {
                this.HighlightWindow(win.frames[i], text, color);
            }
        }

        var doc = win.document;
        if (doc != null) {
            var body = doc.body;
            if (body != null) {
                var docRange = doc.createRange();
                docRange.selectNode(body);
                var startRange = docRange.cloneRange();
                startRange.collapse(true);
                var stopRange = docRange.cloneRange();
                stopRange.collapse(false);


                this.FindRange.caseSensitive = false;
                this.FindRange.findBackwards = false;
                var result = this.FindRange.Find(text, docRange, startRange, stopRange);
                while (null != result) {
                    if (result.endContainer != null && (result.startContainer != null && (result.endContainer.nodeType == Node.TEXT_NODE && (result.startContainer.nodeType == Node.TEXT_NODE && (!this.IsNodeInputNodeOrChildOf(result.startContainer) && !this.IsNodeInputNodeOrChildOf(result.endContainer)))))) {
                        var startChar = null;
                        if (result.startOffset > 0) {
                            startChar = result.startContainer.nodeValue.charAt(result.startOffset - 1)
                        }
                        var endChar = result.endContainer.nodeValue.charAt(result.endOffset);
                        if (!EBGlobalManager_CT2958529.IsWordCharacter(startChar) && !EBGlobalManager_CT2958529.IsWordCharacter(endChar)) {
                            var spanNode = this.SetHighlight(result, color, this.SPAN_ID);
                            startRange.selectNode(spanNode);
                        }
                        else {
                            startRange = result
                        }
                    }
                    else {
                        startRange = result
                    }

                    startRange.collapse(false);
                    result = this.FindRange.Find(text, docRange, startRange, stopRange)
                }

            }
        }

    },

    SetHighlight: function(range, color, id) {
        var startContainer = range.startContainer;
        var spanNode = startContainer.ownerDocument.createElement("span");
        spanNode.style.backgroundColor = color;
        spanNode.style.color = "black";
        spanNode.id = id;
        var docfrag = range.extractContents();
        spanNode.appendChild(docfrag);
        range.insertNode(spanNode);
        return spanNode;
    },

    ClearHighlight: function(win) {
        if (!this.ARR_TERMS)
            return;

        if (!win)
            win = window._content;

        var i = 0; // Avoid multiple redeclaration warnings

        for (i = 0; win.frames && i < win.frames.length; i++) {
            this.ClearHighlight(win.frames[i]);
        }

        var doc = win.document;
        if (!doc) { return; }
        var body = doc.body;
        if (!body) { return; }

        var count = body.childNodes.length;

        for (i = 0; i < this.ARR_TERMS.length; i++) {
            var term = this.ARR_TERMS[i];

            var searchRange = doc.createRange();
            searchRange.setStart(body, 0);
            searchRange.setEnd(body, count);

            var startPt = doc.createRange();
            startPt.setStart(body, 0);
            startPt.setEnd(body, 0);

            var endPt = doc.createRange();
            endPt.setStart(body, count);
            endPt.setEnd(body, count);

            var retRange = null;
            while ((retRange = this.FindRange.Find(term, searchRange, startPt, endPt))) {
                var startContainer = retRange.startContainer;
                var elem = null;
                try { elem = startContainer.parentNode; } catch (e) { }
                if (elem) {
                    // Avoid multiple redeclaration warnings
                    var docfrag = null;
                    var child = null;
                    var next = null;
                    var parent = null;

                    if (elem.getAttribute("id") == this.SPAN_ID) {
                        docfrag = doc.createDocumentFragment();
                        next = elem.nextSibling;
                        parent = elem.parentNode;

                        while ((child = elem.firstChild)) {
                            docfrag.appendChild(child);
                        }

                        startPt = doc.createRange();
                        startPt.setStartAfter(elem);

                        parent.removeChild(elem);
                        parent.insertBefore(docfrag, next);
                    }
                    else {
                        try {
                            while ((elem = elem.parentNode)) {
                                if (elem.getAttribute("id") == this.SPAN_ID) {
                                    docfrag = doc.createDocumentFragment();
                                    next = elem.nextSibling;
                                    parent = elem.parentNode;

                                    while ((child = elem.firstChild)) {
                                        docfrag.appendChild(child);
                                    }

                                    startPt = doc.createRange();
                                    startPt.setStartAfter(elem);

                                    parent.removeChild(elem);
                                    parent.insertBefore(docfrag, next);
                                    break;
                                }
                            }
                        } catch (e) { }
                        startPt = doc.createRange();
                        startPt.setStart(retRange.endContainer, retRange.endOffset);
                    }
                }
                else {
                    startPt = doc.createRange();
                    startPt.setStart(retRange.endContainer, retRange.endOffset);
                }

                startPt.collapse(true);
            }
        }
    },

    OnCommandSearchTerm: function(event) {
        var strTerm = event.target.getAttribute("label");
        //if shift key is pressed the search going backwards
        this.FindSingleTerm(strTerm, !event.shiftKey);

        EBUsageHighlighter_CT2958529.OnClickWord();
    },

    FindSingleTerm: function(text, forward) {
        var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        var objFind = win.getBrowser().webBrowserFind;

        objFind.searchString = text;
        objFind.matchCase = false;
        objFind.wrapFind = true;
        objFind.findBackwards = !forward;

        var result = objFind.findNext();
    },

    SetHighlightButtons: function() {
        var XULHighlighter = EBSearchBoxManager_CT2958529.GetHighlighterButtonOnToolbar();

        //check if the highlighter exists on the toolbar and if not return
        if (!XULHighlighter) return;

        //set the highlighter state
        if (EBGlobalManager_CT2958529.TotalTrim(this.GetSearchTerm())) {

            XULHighlighter.setAttribute('disabled', 'false');
            XULHighlighter.setAttribute('image', oToolbarSkin_CT2958529.highlighterActiveImageUrl);
        }
        else {
            XULHighlighter.setAttribute('disabled', 'true');
            XULHighlighter.setAttribute('image', oToolbarSkin_CT2958529.highlighterInactiveImageUrl);
        }
    }
};

var EBInitializeToolbarManager_CT2958529 =
{

    GetSetupFinishURL: function() {
        return EBGlobalConsts_CT2958529.IsEngine ? oToolbarManager_CT2958529.data.settings.enginePages.welcome : EBActionManager_CT2958529.GetWebServerURL('SetUpFinish/');
    },

    GetInitializePrefName: function() {
        var strInitializePrefName = EBPreferenceConsts_CT2958529.Initialize;
        return strInitializePrefName;
    },

    IsFirstRun: function() {
        var strInitializePrefName = this.GetInitializePrefName();
        //if there isn't any value in this pref it's first time load
        return !EBToolbarPreferenceManager_CT2958529.HasUserValue(strInitializePrefName);

    },

    IsFirstRunForCommonPrefs: function() {
        var strInitializePrefName = EBPreferenceConsts_CT2958529.InitializeCommonPrefs;
        //if there isn't any value in this pref it's first time load
        return !EBToolbarPreferenceManager_CT2958529.HasUserValue(strInitializePrefName);
    },

    SetInitializePref: function() {
        var strInitializePrefName = this.GetInitializePrefName();
        EBToolbarPreferenceManager_CT2958529.SetPref(strInitializePrefName, true);
    },

    SetInitializeCommonPrefsPref: function() {
        var strInitializePrefName = EBPreferenceConsts_CT2958529.InitializeCommonPrefs;
        EBToolbarPreferenceManager_CT2958529.SetPref(strInitializePrefName, true);
    },

    Initialize: function() {
        //check if there is any value in this pref and if not this is the first initialization
        if (this.IsFirstRun()) {
            //set the init pref
            this.SetInitializePref();

            if (this.IsOpenSetupFinishPage())
                this.LoadSetupFinishPage();
        }

        if (this.IsFirstRunForCommonPrefs()) {
            //set the init pref
            this.SetInitializeCommonPrefsPref();

            this.AddMeToInstalledToolbarsList(EBPreferenceConsts_CT2958529.ToolbarsList);
        }
    },

    LoadSetupFinishPage: function() {
        //open the setup finish page in new process, because otherwise FF 2.* closes the new tab
        var strSetupFinish = EBInitializeToolbarManager_CT2958529.GetSetupFinishURL();
        setTimeout(function() {
            var event = { "customData": { "url": strSetupFinish, "urlTarget": "TAB"} };
            EBLinkManager_CT2958529.LoadLinkURL(event);
        }, 500);
    },

    IsOpenSetupFinishPage: function() {
        if (EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.IsOpenThankYouPage))
            return EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.IsOpenThankYouPage)
        else
            return !EBGlobalConsts_CT2958529.IsEngine;
    },

    AddMeToInstalledToolbarsList: function(strPrefName) {
        var strToolbarsList = EBGlobalPreferenceManager_CT2958529.GetPref(strPrefName);

        if (!strToolbarsList)
            strToolbarsList = EBGlobalConsts_CT2958529.ToolbarCTID;
        else {
            var arrToolbars = strToolbarsList.split(',');
            var bFound = false;

            for (var i = 0; i < arrToolbars.length; i++)
                if (arrToolbars[i] == EBGlobalConsts_CT2958529.ToolbarCTID)
                bFound = true;

            if (!bFound)
                arrToolbars.push(EBGlobalConsts_CT2958529.ToolbarCTID);

            strToolbarsList = arrToolbars.join(',');
        }

        EBGlobalPreferenceManager_CT2958529.SetPref(strPrefName, strToolbarsList);
    }
}




function EBLoadToolbar_CT2958529(dataObj) {
    EBToolbarManager_CT2958529 = EBManagersFactory_CT2958529.getInstance(EBGlobalConsts_CT2958529.IsEngine && !isAIOMode_CT2958529);

    EBToolbarCssFunctions_CT2958529.init();
    
    if (!isFloatingMode_CT2958529) {
        if (!EBActionManager_CT2958529.IsToolbarShown() && !EBGlobalConsts_CT2958529.IsEngine) return;
        //set identifier to this window
        if (!gBrowser[EBGlobalConsts_CT2958529.WindowId])
            gBrowser[EBGlobalConsts_CT2958529.WindowId] = Math.random().toString();
        setTimeout(function() { EBAlertManager_CT2958529.RunAlert(); }, 100);
        setTimeout(function() {
          gBrowser.addEventListener("SSTabRestored", function(aEvent) { EBToolbarManager_CT2958529.onTabsRestore(aEvent); }, false);
        }, 130);
    }

    var iTimeout = (EBGlobalConsts_CT2958529.IsEngine) ? 400 : 120;
    
    setTimeout(function() { EBToolbarManager_CT2958529.onload(dataObj); }, iTimeout);
};

//progressive listener of the main browser (actually the all toolbar)
var EBMainBrowserListener_CT2958529 =
{
    prevUrl: '',

    QueryInterface: function(aIID) {
        if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
            aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
            aIID.equals(Components.interfaces.nsISupports))
            return this;
        throw Components.results.NS_NOINTERFACE;
    },

    onStateChange: function(aProgress, aRequest, aFlag, aStatus) {
        var strURL = (aRequest) ? aRequest.name : '';
        //navigate start event
        if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW) {
            if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_START) {
                var aSubject = EBObserversManager_CT2958529.GetSubject(gBrowser[EBGlobalConsts_CT2958529.WindowId]);
                aSubject.url = strURL;
                //broadcast this event only for main document, not iframes.
                if (aProgress.DOMWindow == gBrowser.selectedTab.linkedBrowser.contentWindow) {
                    EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
                                                            EBObserversManager_CT2958529.ToolbarEventsTopic,
                                                            EBObserversManager_CT2958529.ToolbarEventsData.NavigateComplete);
                    if (EBActionManager_CT2958529.IsToolbarMC() && EBActionManager_CT2958529.IsToolbarShown())
                        EBMCManager_CT2958529.OnBeforeNavigate(strURL);
                }
            }


        }
        if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST) {
            //resource download complete event
            if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
                EBGlobalConsts_CT2958529.IsEngine ? WebApiManager_CT2958529.registerApi(aProgress.DOMWindow) : EBWebPageApiManager_CT2958529.registerApi(aProgress.DOMWindow);
            }
        }
        return 0;
    },
    // This fires when the location bar changes i.e load event is confirmed
    // or when the user switches tabs
    onLocationChange: function(aProgress, aRequest, aURI) {
        var strURL = (aURI) ? aURI.spec : "";

        EBHighlighterManager_CT2958529.TabChange(aProgress);

        //check suggests keywords
        EBSuggestsManager_CT2958529.CheckSuggests();

        //check the toolbar api
        if (!aProgress.isLoadingDocument)
            EBGlobalConsts_CT2958529.IsEngine ? WebApiManager_CT2958529.registerApi(aProgress.DOMWindow) : EBWebPageApiManager_CT2958529.registerApi(aProgress.DOMWindow);

        if (EBActionManager_CT2958529.IsToolbarMC() && strURL && this.prevUrl != strURL) {
            this.prevUrl = strURL;
            EBMCManager_CT2958529.LocationChange(strURL);
        }

        return 0;
    },

    // For definitions of the remaining functions see XulPlanet.com
    onSecurityChange: function(aProgress, aRequest, aState) {
        //check the toolbar api
        if (!aProgress.isLoadingDocument)
            EBGlobalConsts_CT2958529.IsEngine ? WebApiManager_CT2958529.registerApi(aProgress.DOMWindow) : EBWebPageApiManager_CT2958529.registerApi(aProgress.DOMWindow);
        return 0;
    },
    onProgressChange: function() { return 0; },
    onStatusChange: function(aProgress, request, status, message) {
        //check the toolbar api
        if (aProgress && !aProgress.isLoadingDocument)
            EBGlobalConsts_CT2958529.IsEngine ? WebApiManager_CT2958529.registerApi(aProgress.DOMWindow) : EBWebPageApiManager_CT2958529.registerApi(aProgress.DOMWindow);
        return 0;
    },
    onLinkIconAvailable: function() { return 0; }
};

function EBMainBrowserLoad_CT2958529(event) {
    if (event.originalTarget instanceof HTMLDocument) {
        var win = event.originalTarget.defaultView;
        var strURL = win.document.location.href.toString();
        //main only
        if (!win.frameElement) {
            var aSubject = EBObserversManager_CT2958529.GetSubject(gBrowser[EBGlobalConsts_CT2958529.WindowId]);
            aSubject.url = strURL;
            EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
                                                           	 EBObserversManager_CT2958529.ToolbarEventsTopic,
                                                           	 EBObserversManager_CT2958529.ToolbarEventsData.DocumentComplete);
        }
        //iframe only
        else {}

        EBActionManager_CT2958529.DocumentComplete();
        if (EBActionManager_CT2958529.IsToolbarMC())
            EBMCManager_CT2958529.DocumentComplete();
        //notify the secondary search manager
        EBSecondarySearchManager_CT2958529.onDocCompleted(strURL);

        //notify toggle components
        EBToggleComponentManager_CT2958529.DocumentComplete(win);
        
        EBGlobalConsts_CT2958529.IsEngine ? WebApiManager_CT2958529.registerApi(win) : EBWebPageApiManager_CT2958529.registerApi(win);
    }
}

var EBObserversManager_CT2958529 =
{
    NSIObserverService: Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces["nsIObserverService"]),
    ArrObservers: null,
    Delimiter: '!EBObserverDelim!',
    ToolbarEventsTopic: 'Topic_ConduitToolbar_CT2958529',
    DualPackageTopic: "Topic_ConduitToolbar",
    ToolbarEventsData:
	{
	    NavigateComplete: 'NavigateComplete',
	    DocumentComplete: 'DocumentComplete',
	    SearchTermChanged: 'SearchTermChanged',
	    TabChange: 'TabChange',
	    EBGlobalKeyChanged: 'GlobalStorageChange',
	    EBKeyChanged: 'StorageChange',
	    EBMessageReceived: 'MessageReceived',
	    RadioStateChanged: 'RadioStateChanged',
	    ToolbarHide: "ToolbarHide",
	    ToolbarShow: "ToolbarShow"
	},

    DualPackageData:
	{
	    ToolbarHide: "ToolbarHide",
	    ToolbarShow: "ToolbarShow",
	    EngineHide: "EngineHide",
	    EngineShow: "EngineShow"
	},

    Register: function() {
        //ff 4
        if (EBGlobalManager_CT2958529.IsFirefox4()) {
            if (!isFloatingMode_CT2958529)
                UninstallListenerFF4_CT2958529.register();
        }
        //ff 3.6
        else {
            //add installation observer
            if (!isFloatingMode_CT2958529)
                EBInstallationObserver_CT2958529.register();
        }
        //all toolbar activity observer
        EBToolbarObserver_CT2958529.register();

    },

    UnRegister: function() {
        //ff 4
        if (EBGlobalManager_CT2958529.IsFirefox4()) {
            if (!isFloatingMode_CT2958529)
                UninstallListenerFF4_CT2958529.unregister();
        }
        //ff 3.6
        else {
            //remove installation observer
            if (!isFloatingMode_CT2958529)
                EBInstallationObserver_CT2958529.unregister();
        }
        //remove custom observers
        try {
            if (this.ArrObservers && this.ArrObservers.length > 0)
                for (var i = 0; i < this.ArrObservers.length; i++)
                    this.ArrObservers[i].unregister();
        }
        catch (e) {
            EBLogging_CT2958529.LogToConsole(e);
        }
        this.ArrObservers = null;
    },

    RegisterCustomObserver: function(objObserver) {
        //lazy init
        if (!this.ArrObservers)
            this.ArrObservers = new Array();

        //save observer to unregister it later on windows unload
        this.ArrObservers.push(objObserver);

        this.NSIObserverService.addObserver(objObserver, objObserver.Topic, false);
    },

    NotifyCustomObserver: function(aSubject, strTopic, oData) {
        this.NSIObserverService.notifyObservers(aSubject, strTopic, oData);
    },

    EncodeData: function() {
        if (arguments.length == 0)
            return;

        var arrData = new Array();
        for (var i = 0; i < arguments.length; arrData.push(arguments[i]), i++);

        var strData = arrData.join(this.Delimiter);

        return strData;
    },

    DecodeData: function(strData) {
        return strData.split(this.Delimiter);
    },

    GetSubject: function(strWindowId) {
        var objSubject = new Object();
        objSubject.wrappedJSObject = objSubject;
        objSubject.windowId = strWindowId;
        return objSubject;
    }
}




//observe the installation process of the extensions
//trigger when:
//install extension
//uninstall extension
//enable extension
//disable extension
//upgrade extension
//cancel extension

var EBInstallationObserver_CT2958529 =
{
    ACTION_REQUESTED_TOPIC: "em-action-requested",
    ITEM_INSTALLED: "item-installed",
    ITEM_UPGRADED: "item-upgraded",
    ITEM_UNINSTALLED: "item-uninstalled",
    ITEM_ENABLED: "item-enabled",
    ITEM_DISABLED: "item-disabled",
    ITEM_CANCEL: "item-cancel-action",


    register: function() {
        //ff4
        if (EBGlobalManager_CT2958529.IsFirefox4()) {
            UninstallListenerFF4_CT2958529.register();
        }
        // ff 3.6
        else
            EBObserversManager_CT2958529.NSIObserverService.addObserver(this, this.ACTION_REQUESTED_TOPIC, false);
    },

    unregister: function() {
        EBObserversManager_CT2958529.NSIObserverService.removeObserver(this, this.ACTION_REQUESTED_TOPIC);
    },

    observe: function(aSubject, aTopic, aData) {
        try {
            if (aData == this.ITEM_UNINSTALLED) {
                var objExtensionItem = aSubject.QueryInterface(Components.interfaces.nsIUpdateItem);

                if (objExtensionItem.id == EBGlobalConsts_CT2958529.GUID) {
                    EBLogging_CT2958529.LogToConsole("Initiate uninstall sequence: CT2958529");
                    EBUninstallManager_CT2958529.PostUninstallToolbar();
                }
            }
            else if (aData == this.ITEM_CANCEL) {
                var objExtensionItem = aSubject.QueryInterface(Components.interfaces.nsIUpdateItem);
                if (objExtensionItem.id == EBGlobalConsts_CT2958529.GUID) {
                    EBLogging_CT2958529.LogToConsole("Uninstall sequence canceled");
                    EBUninstallManager_CT2958529.CancelUninstall();
                }
            }
        }
        catch (err) {
            EBLogging_CT2958529.LogToConsole(err, "Uninstall Error");
        }
    }
};

var EBToolbarObserver_CT2958529 = 
{
	
	Topic   : 'Topic_ConduitToolbar_CT2958529',
	
	Action  :
	{
	    RefreshToolbar : 'RefreshToolbar'
	},
	
	observe: function(aSubject, aTopic, aData)
	{	
	    switch(aData)
	    {
	        case this.Action.RefreshToolbar:
	            //Add here functions to invoke on toolbar refresh
	            break;
	    }
	},
	
	register : function()
	{
	    EBObserversManager_CT2958529.RegisterCustomObserver(this);
	},
	
	unregister : function()
	{
	    EBObserversManager_CT2958529.NSIObserverService.removeObserver(this, this.Topic);
	}
};
var EBSearchFromAddressBar_CT2958529 =
{
    addressBarEngineURL: 'http://search.conduit.com/ResultsExt.aspx?ctid=CT2958529&SearchSource=2&q=',
    addressBarUrlPrefName: 'keyword.URL',
    addressBarEnabledPrefName: 'keyword.enabled',
    addressBarSelectedCtid: 'keywordURLSelectedCTID',

    firstTime: function(strUrl, bIsSet) {
        //save old one, if not saved before
        this.backup();

        strUrl = this.convertSettingsUrl(strUrl);
        //save the new url
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.SearchFromAddressBarUrl, strUrl);

        //set new url
        if (bIsSet) {
            this.setAddressBarSearchUrl(strUrl);
            this.setSelectedCtid();
            this.setEnabledAddressBarSearch();

        }

        EBInitializeToolbarManager_CT2958529.AddMeToInstalledToolbarsList(EBPreferenceConsts_CT2958529.ToolbarsList2);
    },

    setAddressBarSearchUrl: function(strUrl) {
        EBPreferenceService_CT2958529.SetPref(this.addressBarUrlPrefName, strUrl);
    },

    setSelectedCtid: function() {
        EBGlobalPreferenceManager_CT2958529.SetPref(this.addressBarSelectedCtid, EBGlobalConsts_CT2958529.ToolbarCTID);
    },

    removeSelectedCtid: function() {
        EBGlobalPreferenceManager_CT2958529.SetPref(this.addressBarSelectedCtid, null);
    },

    setEnabledAddressBarSearch: function() {
        var bIsEnabled = EBPreferenceService_CT2958529.GetPref(this.addressBarEnabledPrefName);

        if (!bIsEnabled)
            EBPreferenceService_CT2958529.SetPref(this.addressBarEnabledPrefName, true);
    },

    getUrl: function() {
        var strUrl = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.SearchFromAddressBarUrl);
        if (!strUrl)
            strUrl = this.convertSettingsUrl(this.addressBarEngineURL);

        return strUrl;
    },

    changeState: function(bIsEnabled) {
        if (bIsEnabled) {
            var strUrl = this.getUrl();
            this.setAddressBarSearchUrl(strUrl);
            this.setSelectedCtid();
        }
        else {
            this.setToDefaultSearch();
            this.removeSelectedCtid();
        }
    },

    //backup only once per all toolbars installations
    backup: function() {
        var strSearchFromAddressOldUrl = EBPreferenceService_CT2958529.GetPref(this.addressBarUrlPrefName);

        //save the original value if not saved before
        if (!EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.SearchFromAddressBarSavedUrl)) {
            EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.SearchFromAddressBarSavedUrl, strSearchFromAddressOldUrl);
        }
    },

    //restore to original, executed by the last toolbar uninstall
    restoreOriginal: function() {
        var strSavedUrl = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.SearchFromAddressBarSavedUrl);
        if (strSavedUrl) {
            this.setAddressBarSearchUrl(strSavedUrl);
        }
    },

    setToDefaultSearch: function() {
        this.restoreOriginal();
    },

    restorePrevious: function() {
        var strCTIDs = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.ToolbarsList2);
        var arrCTIDs = strCTIDs.split(",");
        var strCTID = arrCTIDs.pop();
        var strPrefName = strCTID + "." + EBPreferenceConsts_CT2958529.SearchFromAddressBarUrl;
        var strUrl = EBPreferenceService_CT2958529.GetPref(strPrefName);
        this.setAddressBarSearchUrl(strUrl);
    },

    restoreOnUninstall: function() {
        var strPrefName = EBPreferenceConsts_CT2958529.ToolbarsList2;
        EBUninstallManager_CT2958529.RemoveMeFromInstalledToolbarsList(strPrefName);

        if (EBUninstallManager_CT2958529.IsLastToolbar(strPrefName)) {
            this.restoreOriginal();
        }
        else if (this.isEnabled()) {
            this.restorePrevious();
        }
    },

    isEnabled: function() {
        return EBGlobalPreferenceManager_CT2958529.GetPref(this.addressBarSelectedCtid) == EBGlobalConsts_CT2958529.ToolbarCTID;
    },

    updateFromSettings: function(strUrl) {
        strUrl = this.convertSettingsUrl(strUrl);

        //save the new url
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.SearchFromAddressBarUrl, strUrl);
    },

    convertSettingsUrl: function(strUrl) {
        strUrl = strUrl.replace(/MYSEARCHTERM/g, '');
        strUrl = strUrl.replace(/EB_CTID/g, EBActionManager_CT2958529.GetCTID());

        //fix server issue, the parameter q= must be at the end of the string
        if (strUrl.indexOf("q=&") != -1) {
            strUrl = strUrl.replace(/q=&/, "") + "&q=";
        }
        return strUrl;
    },

    isThisToolbarRegisteredWithDefault: function() {
        var strUrl = EBPreferenceService_CT2958529.GetPref(this.addressBarUrlPrefName);
        return strUrl == this.convertSettingsUrl(this.addressBarEngineURL);
    },

    onload: function() {
        var selectedCtid = EBGlobalPreferenceManager_CT2958529.GetPref(this.addressBarSelectedCtid);
        if (!selectedCtid) return;

        if (this.isToolbarLive(selectedCtid)) {
            this.setAddressBarSearchUrl(this.getToolbarSearchFromAddressBarUrl(selectedCtid));
            return;
        }

        var nextToolbarSerchUrl = this.getNextLiveToolbarSearchUrl(EBPreferenceConsts_CT2958529.ToolbarsList2);

        if (nextToolbarSerchUrl)
            this.setAddressBarSearchUrl(nextToolbarSerchUrl);
        else
            this.setAddressBarSearchUrl(EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.SearchFromAddressBarSavedUrl));
    },

    onunload: function() {
        this.restoreOriginal();
    },

    getToolbarSearchFromAddressBarUrl: function(ctid) {
        var prefName = ctid + "." + EBPreferenceConsts_CT2958529.SearchFromAddressBarUrl;
        return EBPreferenceService_CT2958529.GetPref(prefName);
    },

    isToolbarLive: function(ctid) {
        var activeToolbarsList = EBActionManager_CT2958529.GetEBToolbarsCTID();
        var searchFromAddressBarUrl;
        for (var i = 0; i < activeToolbarsList.length; i++) {
            if (activeToolbarsList[i].originalCTID == ctid)
                return true;
        }

        return false;
    },

    //get the first live toolbar
    getNextLiveToolbarSearchUrl: function(toolbarListPref) {
        var toolbarList = EBPreferenceService_CT2958529.GetPref(toolbarListPref);
        if (!toolbarList) return null;
        // split the list to array
        var arrToolbars = toolbarList.split(',');
        var searchFromAddressBarUrl;
        for (var i = 0; i < arrToolbars.length; i++) {
            searchFromAddressBarUrl = this.getToolbarSearchFromAddressBarUrl(arrToolbars[i]);
            // if this live toolbar
            if (this.isToolbarLive(arrToolbars[i]))
                return searchFromAddressBarUrl;
        }
        //didn't find any live toolbar
        return null;
    }
};
var EBSecondarySearchManager_CT2958529 =
{
    TimeoutSecondary: null,
    IsSearchExecuted: false,
    SearchUrl: '',
    EngineId: '',

    //public
    onSearchStarted: function(objSecondarySearch, evnt, strPostParams, strSearchTerm, strSearchUrl) {
        if (objSecondarySearch == null)
            return;

        this.SearchStartTime = Date.parse(Date());
        clearTimeout(this.TimeoutSecondary);

        this.IsSearchExecuted = true;
        this.SearchUrl = strSearchUrl;
        this.EngineId = objSecondarySearch.engineId;

        var oCheckIfLoaded = function() {
            if (EBSecondarySearchManager_CT2958529.IsSearchExecuted) {
                var strSearchUrl = objSecondarySearch.prefix.replace(objSecondarySearch.searchTermToReplace, strSearchTerm);
                strSearchUrl = EBActionManager_CT2958529.ConvertAliasesUrl(strSearchUrl);
                EBSecondarySearchManager_CT2958529.SearchUrl = "";
                EBSecondarySearchManager_CT2958529.IsSearchExecuted = false;
                evnt.customData = { "url": strSearchUrl, "postParams": strPostParams };
                EBLinkManager_CT2958529.LoadLinkURL(evnt);
            }
        };

        this.TimeoutSecondary = setTimeout(oCheckIfLoaded, this.getSecondarySearchTimeout(objSecondarySearch.engineId, objSecondarySearch.interval));
    },

    //public
    onDocCompleted: function(strUrl) {
        clearTimeout(this.TimeoutSecondary);
        if (strUrl == this.SearchUrl && this.IsSearchExecuted) {
            var iSearchTime = Date.parse(Date()) - this.SearchStartTime;
            this.setNewData(this.EngineId, iSearchTime);
        }
        else {
            this.IsSearchExecuted = false;
            this.SearchUrl = '';
        }
    },

    //private
    searchesCount: function(strEngineId, iCount) {
        var prefSearchesCount = EBPreferenceConsts_CT2958529.SearchesCount + '.' + strEngineId;

        //get
        if (typeof iCount == 'undefined') {
            var iCnt = EBToolbarPreferenceManager_CT2958529.GetPref(prefSearchesCount);
            if (!iCnt) iCnt = 0;
            return iCnt;
        }
        //set
        else
            EBToolbarPreferenceManager_CT2958529.SetPref(prefSearchesCount, iCount);
    },

    //private
    searchesAverage: function(strEngineId, iAvg) {
        var prefSearchTimeAverage = EBPreferenceConsts_CT2958529.SearchTimeAverage + '.' + strEngineId;

        //get
        if (typeof iAvg == 'undefined') {
            var iAverage = EBToolbarPreferenceManager_CT2958529.GetPref(prefSearchTimeAverage);
            if (!iAverage) iAverage = 0;
            return iAverage;
        }
        //set
        else
            EBToolbarPreferenceManager_CT2958529.SetPref(prefSearchTimeAverage, iAvg);
    },

    //private
    setNewData: function(strEngineId, iSearchTime) {
        //get data from prefs
        var iCount = this.searchesCount(strEngineId);
        var iAvg = this.searchesAverage(strEngineId);

        //calculate new average
        iAvg = (iAvg * iCount + iSearchTime) / (iCount + 1)

        //set new data to prefs
        this.searchesCount(strEngineId, iCount + 1);
        this.searchesAverage(strEngineId, iAvg);
    },

    //private
    getSecondarySearchTimeout: function(strEngineId, iMinTimeout) {
        var iAvg = this.searchesAverage(strEngineId);
        if (iAvg == 0)
            return iMinTimeout * 2;
        else if (iAvg < iMinTimeout)
            return iMinTimeout;
        else
            return (1 + iMinTimeout / iAvg) * iAvg;
    }
}
var EBSelectToSearchBox_CT2958529 =
{
    getTextFromClick: function(parent, offset, target) {
        if (parent.parentNode != target || parent.nodeType != Node.TEXT_NODE) return;

        var container = parent.parentNode;
        if (container) {
            var foundNode = false;
            for (var i = container.firstChild; i != null; i = i.nextSibling) {
                if (i == parent) {
                    foundNode = true;
                    break;
                }
            }
            if (!foundNode) return;
        }

        var range = parent.ownerDocument.createRange();
        range.selectNode(parent);
        var str = range.toString();

        if (offset < 0 || offset >= str.length) return;

        var start = offset;

        while (str.charAt(start) != " " && start > 0) {
            start--;
        }

        var end = offset + 1;

        while (str.charAt(end) != " " && end < str.length) {
            end++;
        }

        var text = str.substring(start, end);
        return text;
    },

    getSelectionText: function(event) {
        var str = "";
        if (!event.rangeParent) return true;

        if (getBrowser().contentWindow.getSelection())
            str = getBrowser().contentWindow.getSelection().toString();

        var node = document.commandDispatcher.focusedElement;
        try {
            if (node &&
			    'selectionStart' in node &&
			    node.selectionStart != node.selectionEnd &&
			    node.type != "password" &&
			    node.nodeName != "html:input") {
                var offsetStart = Math.min(node.selectionStart, node.selectionEnd);
                var offsetEnd = Math.max(node.selectionStart, node.selectionEnd);
                str = node.value.substr(offsetStart, offsetEnd - offsetStart);
            }
            else if (node && node.nodeName == "html:input")
                str = EBComponentsConsts_CT2958529.DontChangeTerm;
        }
        catch (ex) { }

        return str;
    },

    onmouseup: function(event) {
        if (event.button != 0 || !this.isEnabled()) return;


        //check if there was selection made
        var text = this.getSelectionText(event);

        if (text == null) text = "";

        if (text != EBComponentsConsts_CT2958529.DontChangeTerm &&
		    (text != "" || !EBSearchBoxConsts_CT2958529.IsUserInput)) {
            text = EBGlobalManager_CT2958529.Trim(text);
            if (text != null) {
                //take the text part up to enter
                try {
                    text = text.substr(0, 255);
                    text = text.replace(/\r\n/g, "");
                    text = text.replace(/\n/g, "");
                }
                catch (ex) {
                    EBLog(ex, "select to search box");
                }

                EBActionManager_CT2958529.SetToolbarSearchTerm(text);
                EBSearchBoxConsts_CT2958529.IsUserInput = false;
            }
        }
    },

    isEnabled: function() {
        var publisherIsEnabled = (oToolbarManager_CT2958529 && oToolbarManager_CT2958529.data && oToolbarManager_CT2958529.data.generalToolbarInfo) ?
                                     oToolbarManager_CT2958529.data.generalToolbarInfo.selectToSearchBoxEnabled : true;
        var isEnabled = EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.EnableClickToSearchBox) ?
            EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EnableClickToSearchBox) : publisherIsEnabled;

        return isEnabled;
    }
};
function EBSuggestObject_CT2958529(strDomain,strSearchParam,strOutputCharset)
{
	this.domain			= strDomain;
	this.searchParam	= strSearchParam;	
	this.outputCharset	= strOutputCharset;
}


var EBSuggestsManager_CT2958529 =
{
    CheckSuggests: function() {
        var oSearch = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        if (!oSearch) return;

        var arrToolbarSuggests = oSearch.searchSuggests;

        if (arrToolbarSuggests) {
            for (var i = 0; i < arrToolbarSuggests.length; i++) {
                this.SetSuggest(arrToolbarSuggests[i]);
            }
        }
    },

    SetSuggest: function(ebSuggestObj) {
        var strKeyword = this.GetKeyword(ebSuggestObj)

        if (strKeyword)
            EBActionManager_CT2958529.SetToolbarSearchTerm(strKeyword);
    },

    GetKeyword: function(ebSuggestObj) {
        var strKeyword = "";

        var DELIMITER_PARAMS = '&';

        var strDomain = ebSuggestObj.domain;
        var strSearchParam = ebSuggestObj.searchParam;
        var strOutputCharset = ebSuggestObj.outputCharset;

        //get the current url
        var strCurrentUrl = EBUrl_CT2958529.GetPageUrl();

        //check the current url with the suggest element
        if (strCurrentUrl.indexOf(strDomain) != -1) {
            //get the index of the search param
            var iIndexOfParam = strCurrentUrl.indexOf(strSearchParam);
            if (iIndexOfParam != -1) {
                //get the url string from the search param till the end
                var strUrlFromParam = strCurrentUrl.substring(iIndexOfParam + strSearchParam.length);

                //check if this is the keyword by getting the next delimiter params(usually '&')
                var iIndexOfNextParam = strUrlFromParam.indexOf(DELIMITER_PARAMS);
                if (iIndexOfNextParam != -1)
                    strKeyword = strUrlFromParam.substring(0, iIndexOfNextParam);
                else
                    strKeyword = strUrlFromParam;
            }
        }

        strKeyword = this.ConvertKeyword(strKeyword, strOutputCharset);

        return strKeyword;
    },

    ConvertKeyword: function(strKeyword, strCharset) {
        if (strKeyword == "")
            return "";

        //convert the url spacing before!!! the main conversion itself.
        strKeyword = strKeyword.replace(/\+/g, ' ');

        //convert the search keyword back from the url keyword to normal one
        strKeyword = unescape(strKeyword);
        strKeyword = EBFileIO_CT2958529.toUnicode(strCharset, strKeyword);

        //remove the site:<domain> from the keyword in case of site search
        if (strKeyword.indexOf("site:") != -1 && strKeyword.indexOf("site: ") == -1) {
            try {
                var iStart = strKeyword.indexOf("site2:");
                var iBlank = strKeyword.indexOf(" ", iStart);
                strKeyword = strKeyword.substr(iBlank + 1);
            }
            catch (ex)
			{ }
        }
        return strKeyword;
    }


}
var EBToggleComponentConsts_CT2958529 =
{
    MODE_TEMPORARY: 'TEMPORARY',
    MODE_PERMANENT: 'PERMANENT'
};

var EBToggleComponentManager_CT2958529 =
{
    //Lazy initiation of the toggle components hash table
    ArrToggleComponents: null,
    isInitializedTabsRestore: false,

    OnToolbarRefresh: function() {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            if (objWindow.EBToggleComponentManager_CT2958529.OnToolbarRefresh) {
                try {
                    objWindow.EBToggleComponentManager_CT2958529.Clear();
                }
                catch (ex) { }
            }
        }
    },

    Clear: function() {
        this.ArrToggleComponents = null;
    },

    Init: function() {
        if (!this.ArrToggleComponents)
            this.ArrToggleComponents = new EBArrayHashObject_CT2958529();

        //no need to handle tabs restore when toolbar is chevron
        if (isFloatingMode_CT2958529) return;

        //handle tabs restore
        if (!this.isInitializedTabsRestore) {
            this.isInitializedTabsRestore = true;

            function _handleRestoreTabs(aEvent) {
                if (aEvent.originalTarget.linkedBrowser.contentWindow)
                    EBToggleComponentManager_CT2958529.DocumentComplete(aEvent.originalTarget.linkedBrowser.contentWindow);
            };

            gBrowser.addEventListener("SSTabRestored", _handleRestoreTabs, false);
        }
    },

    InitComponent: function(obj) {
        this.Init();

        this.ArrToggleComponents.Add(obj.ComponentItem.UniqueCompID, obj);

        var bIsPressed = this.GetIsPressedStateFromPreferences(obj.ComponentItem.UniqueCompID);

        if (bIsPressed)
            obj.ToggleOn();
    },

    //Firefox Events
    DocumentComplete: function(DOMWindow) {
        if (!this.ArrToggleComponents)
            return;

        var objJSWrapped = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(DOMWindow);
        var objComponent;
        for (var i = 0; i < this.ArrToggleComponents.Count(); i++) {
            objComponent = this.ArrToggleComponents.GetByIndex(i);
            if ((DOMWindow.document == gBrowser.contentDocument) || objComponent.ComponentItem.handleIframes) {
                if (objComponent.IsChecked) {
                    //if mode permanent update without checking
                    if (objComponent.ComponentItem.mode == EBToggleComponentConsts_CT2958529.MODE_PERMANENT) {
                        if (!this.IsToSkip(DOMWindow))
                            this.AddScript(objComponent, EBActionManager_CT2958529.ConvertAliasesUrl(objComponent.ComponentItem.scriptUrl), null, objJSWrapped);
                    }
                    //if mode temporary, check if selected on current window
                    else if (EBGlobalManager_CT2958529.GetBooleanAttribute(gBrowser.selectedBrowser, "a" + objComponent.ComponentItem.UniqueCompID, false)) {
                        if (!this.IsToSkip(DOMWindow))
                            this.AddScript(objComponent, EBActionManager_CT2958529.ConvertAliasesUrl(objComponent.ComponentItem.scriptUrl), null, objJSWrapped);
                    }
                }
            }
        }
    },

    TabChange: function(DOMWindow) {
        if (!this.ArrToggleComponents)
            return;

        var objJSWrapped = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(DOMWindow);
        var objComponent;

        for (var i = 0; i < this.ArrToggleComponents.Count(); i++) {
            objComponent = this.ArrToggleComponents.GetByIndex(i);

            if (objComponent.ComponentItem.mode == EBToggleComponentConsts_CT2958529.MODE_TEMPORARY) {
                if (objComponent.IsChecked && !EBGlobalManager_CT2958529.GetBooleanAttribute(gBrowser.selectedBrowser, "a" + objComponent.ComponentItem.UniqueCompID, false))
                    objComponent.ToggleOff();
                else if (!objComponent.IsChecked && EBGlobalManager_CT2958529.GetBooleanAttribute(gBrowser.selectedBrowser, "a" + objComponent.ComponentItem.UniqueCompID, false))
                    objComponent.ToggleOn();
            }
        }
    },

    OnClick: function(event, UniqueCompID, compType) {
        objToggleComponent = this.ArrToggleComponents.GetByID(UniqueCompID);

        //usage
        if (objToggleComponent.IsChecked)
            EBUsageToggleComponent_CT2958529.OnClickOff(UniqueCompID, compType);
        else
            EBUsageToggleComponent_CT2958529.OnClickOn(UniqueCompID, compType);

        if (objToggleComponent.ComponentItem.mode == EBToggleComponentConsts_CT2958529.MODE_PERMANENT) {
            this.SetIsPressedStateFromPreferences(UniqueCompID, !objToggleComponent.IsChecked);
            this.BroadcastOnClick(UniqueCompID, objToggleComponent.IsChecked);
        }
        else
            this.OnClickOnCurrentTab(objToggleComponent);
    },

    BroadcastOnClick: function(compId, bIsChecked) {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        for (var i = 0; i < arrWindows.length; i++) {
            var objWindow = arrWindows[i];
            if (objWindow.EBToggleComponentManager_CT2958529.OnClickOff &&
			    objWindow.EBToggleComponentManager_CT2958529.OnClickOn) {
                try {
                    if (bIsChecked)
                        objWindow.EBToggleComponentManager_CT2958529.OnClickOff(compId);
                    else
                        objWindow.EBToggleComponentManager_CT2958529.OnClickOn(compId);
                }
                catch (ex) { }
            }
        }

        //if chevron, change for self
        if (isFloatingMode_CT2958529 && !isAIOMode_CT2958529) {
            if (bIsChecked)
                EBToggleComponentManager_CT2958529.OnClickOff(compId);
            else
                EBToggleComponentManager_CT2958529.OnClickOn(compId);
        }
    },

    //for mode temporary toggle components
    OnClickOnCurrentTab: function(objComponent) {
        var objSJWrapped = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(gBrowser.selectedBrowser.contentWindow);

        if (objComponent.IsChecked) {
            gBrowser.selectedBrowser.removeAttribute("a" + objComponent.ComponentItem.UniqueCompID)
            this.OnClickOff(objComponent.ComponentItem.UniqueCompID, objSJWrapped)
        }
        else {
            gBrowser.selectedBrowser.setAttribute("a" + objComponent.ComponentItem.UniqueCompID, true)
            this.OnClickOn(objComponent.ComponentItem.UniqueCompID, objSJWrapped)
        }
    },

    OnClickOff: function(compId, objJSWrapped) {
        objComponent = this.ArrToggleComponents.GetByID(compId);
        objComponent.ToggleOff();
        this.ScriptOff(objComponent, objComponent.ComponentItem.scriptOff, EBActionManager_CT2958529.ConvertAliasesUrl(objComponent.ComponentItem.scriptUrl), objJSWrapped);
    },

    OnClickOn: function(compId, objJSWrapped) {
        objComponent = this.ArrToggleComponents.GetByID(compId);
        objComponent.ToggleOn();
        this.AddScript(objComponent, EBActionManager_CT2958529.ConvertAliasesUrl(objComponent.ComponentItem.scriptUrl), objComponent.ComponentItem.scriptOn, objJSWrapped);
    },


    AddScript: function(objComponent, strScriptSrc, strFunction, objJSWrapped) {
        //do not inject script into https sites.
        if (EBUrl_CT2958529.IsSecuredUrl()) return;

        var objScript;
        //fired from document complete or temporary toggle component
        if (objJSWrapped) {
            if (!this.IsScriptExists(objJSWrapped, strScriptSrc)) {
                objScript = this.GetScriptObjectFromUrl(objJSWrapped, strScriptSrc);
                this.AppendScriptIntoDocument(objJSWrapped, objScript, strScriptSrc);
            }
            else if (strFunction && strFunction in objJSWrapped)
                objJSWrapped[strFunction].apply();
        }
        else {
            var arrTabs = EBGlobalManager_CT2958529.GetAllTabs();
            var arrJSObjects;

            for (var i = 0; i < arrTabs.length; i++) {
                arrJSObjects = this.getAllBrowserObjects(arrTabs[i].contentWindow);
                var size = objComponent.ComponentItem.handleIframes ? arrJSObjects.length : 1;
                for (var j = 0; j < size; j++) {
                    objJSWrapped = arrJSObjects[j];
                    objScript = this.GetScriptObjectFromUrl(objJSWrapped, strScriptSrc);
                    if (this.IsScriptExists(objJSWrapped, strScriptSrc) && strFunction in objJSWrapped)
                        objJSWrapped[strFunction].apply();
                    else
                        this.AppendScriptIntoDocument(objJSWrapped, objScript, strScriptSrc);
                }
            }
            //get all open tabs and inject the script
            //check if script exists, only execute function
        }
    },

    ScriptOff: function(objComponent, strFunction, strScriptSrc, objJSWrapped) {
        //do not inject script into https sites.
        if (EBUrl_CT2958529.IsSecuredUrl()) return;

        if (objJSWrapped) {
            if (this.IsScriptExists(objJSWrapped, strScriptSrc) && strFunction in objJSWrapped)
                objJSWrapped[strFunction].apply();
        }
        else {
            var arrTabs = EBGlobalManager_CT2958529.GetAllTabs();

            for (var i = 0; i < arrTabs.length; i++) {
                arrJSObjects = this.getAllBrowserObjects(arrTabs[i].contentWindow);
                var size = objComponent.ComponentItem.handleIframes ? arrJSObjects.length : 1;
                for (var j = 0; j < size; j++) {
                    objJSWrapped = arrJSObjects[j];
                    objScript = this.GetScriptObjectFromUrl(objJSWrapped, strScriptSrc);
                    if (this.IsScriptExists(objJSWrapped, strScriptSrc) && strFunction in objJSWrapped)
                        objJSWrapped[strFunction].apply();
                }
            }
        }
    },

    AppendScriptIntoDocument: function(objJSWrapped, objScript, strScriptSrc) {
        var objDoc = objJSWrapped.document;
        var objHead = objDoc.getElementsByTagName("head")[0];
        if (!objHead) return;
        objHead.appendChild(objScript);
    },

    GetScriptObjectFromUrl: function(objJSWrapped, strScriptSrc) {

        var objScript = objJSWrapped.document.createElement('script');
        objScript.setAttribute('src', strScriptSrc);
        objScript.setAttribute('type', 'text/javascript');

        return objScript;
    },

    IsScriptExists: function(objJSWarpped, strScriptSrc) {
        var objHead = objJSWarpped.document.getElementsByTagName('head')[0];
        if (!objHead) return false;

        var arrScripts = objHead.getElementsByTagName('script');

        if (arrScripts.length == 0)
            return false;

        var objScript = null;
        var strSrc = '';

        for (var i = 0; i < arrScripts.length; i++) {
            objScript = arrScripts[i];
            strSrc = objScript.getAttribute('src');

            if (strSrc == strScriptSrc)
                return true;
        }

        return false;
    },

    GetIsPressedStateFromPreferences: function(uniqueCompId) {
        var prefName = EBPreferenceConsts_CT2958529.ToggleComponentState + uniqueCompId;
        var bIsPressedState = EBToolbarPreferenceManager_CT2958529.GetPref(prefName, true);

        return bIsPressedState;
    },

    SetIsPressedStateFromPreferences: function(uniqueCompId, bState) {
        var prefName = EBPreferenceConsts_CT2958529.ToggleComponentState + uniqueCompId;
        var bIsPressedState = EBToolbarPreferenceManager_CT2958529.SetPref(prefName, bState, true);
    },

    HasIsPressedStateFromPreferences: function(uniqueCompId, bState) {
        var prefName = EBPreferenceConsts_CT2958529.ToggleComponentState + uniqueCompId;
        return EBToolbarPreferenceManager_CT2958529.HasUserValue(prefName);
    },

    IsToSkip: function(DomWindow) {
        var href = DomWindow.location.href;
        if (href == "about:blank")
            return true;
        else
            return false;
    },

    getAllBrowserObjects: function(DOMWindow) {
        var arrJSObjects = new Array();
        var mainJSObject = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(DOMWindow);
        arrJSObjects.push(mainJSObject);

        var arrFrames = mainJSObject.document.getElementsByTagName("frame");
        var i;
        if (arrFrames.length > 0) {
            for (i = 0; i < arrFrames.length; i++)
                arrJSObjects.push(arrFrames[i].contentWindow);
        }

        arrFrames = mainJSObject.document.getElementsByTagName("iframe");
        if (arrFrames.length > 0) {
            for (i = 0; i < arrFrames.length; i++)
                arrJSObjects.push(arrFrames[i].contentWindow);
        }

        return arrJSObjects;
    }
};

function EBUnloadToolbar_CT2958529(bCheckToolbarVisible)
{
    if (!isFloatingMode_CT2958529) window.getBrowser().removeProgressListener(EBMainBrowserListener_CT2958529);
    EBToolbarManager_CT2958529.onunload(bCheckToolbarVisible);
};

//User components functions
var EBUserComponentsManager_CT2958529 =
{
    filename: 'UserAdditionalComponents.xml',

    //returns XML of User Additional Components
    GetXMLFromURL: function(strURL) {
        var oCallBackFunction = function(strXML, o) {
            strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
            var xmlComponent = EBXML_CT2958529.GetXmlDocument(strXML);
            if (!xmlComponent) return false;

            EBUserComponentsManager_CT2958529.AddComponentToFile(xmlComponent.documentElement);
        };

        EBWeb_CT2958529.HTTPServerRequest(strURL, null, false, oCallBackFunction);
    },

    LoadFromFile: function() {
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(this.filename);
        var strXMLUserComponents = EBFileIO_CT2958529.read(oFile, EBGlobalConsts_CT2958529.DefaultCharset);

        //no file exists
        if (!strXMLUserComponents) return null;

        return EBXML_CT2958529.GetXmlDocument(strXMLUserComponents).documentElement;
    },

    SaveComponentsToFile: function(xmlComponents) {
        var strComponents = EBXML_CT2958529.GetStringXml(xmlComponents);
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(this.filename);
        EBFileIO_CT2958529.write(oFile, strComponents, "", EBGlobalConsts_CT2958529.DefaultCharset);
    },

    AddComponentToFile: function(xmlComponent) {
        var xmlUserComponents = this.LoadFromFile();
        var strXMLComponent = EBXML_CT2958529.GetStringXml(xmlComponent);
        var strXMLUserComponents = '';
        if (!xmlUserComponents) {
            strXMLUserComponents = "<USER_ADDITIONAL_COMPONENTS/>";
            xmlUserComponents = EBXML_CT2958529.GetXmlDocument(strXMLUserComponents);
            xmlUserComponents = xmlUserComponents.documentElement;
        }
        else {
            var componentId = this.GetComponentId(xmlComponent);
            if (this.isExists(xmlUserComponents, componentId))
                return false;
        }
        xmlUserComponents.appendChild(xmlComponent);
        strXMLUserComponents = EBXML_CT2958529.GetStringXml(xmlUserComponents);

        var oFile = EBIOManager_CT2958529.CreateToolbarFile(this.filename);
        EBFileIO_CT2958529.write(oFile, strXMLUserComponents, "", EBGlobalConsts_CT2958529.DefaultCharset);
        oToolbarManager_CT2958529.reloadUserComponents(true);
        return true;
    },

    RemoveFromFile: function(arrDeletedIds) {
        try {
            var strDeletedIds = '-' + arrDeletedIds.join('-') + '-';

            var xmlUserComponents = this.LoadFromFile();
            var compId = '';

            for (var i = xmlUserComponents.childNodes.length - 1; i >= 0; i--) {
                compId = this.GetComponentId(xmlUserComponents.childNodes[i]);

                if (strDeletedIds.indexOf('-' + compId + '-') != -1)
                    xmlUserComponents.removeChild(xmlUserComponents.childNodes[i]);
            }

            this.SaveComponentsToFile(xmlUserComponents);
        }
        catch (e) { }
    },

    GetComponentNodeByComponentID: function(xmlComponents, compID) {
        var arrElements = xmlComponents.getElementsByTagName('UNIQUE_COMP_ID');
        for (var i = 0; i < arrElements.length; i++) {
            if (EBXML_CT2958529.GetXmlNodeValue(arrElements.item(i)) == compID) {
                return arrElements.item(i).parentNode;
            }
        }
    },

    RepositionComponents: function(arrPosition) {
        var xmlComponents = this.LoadFromFile()

        if (xmlComponents.childNodes.length == 0) return;

        var strXMLUserComponents = "<USER_ADDITIONAL_COMPONENTS/>";
        var xmlUserComponents = EBXML_CT2958529.GetXmlDocument(strXMLUserComponents);
        var newXmlComponents = xmlUserComponents.documentElement;
        var xmlComponent = null;
        for (var i = 0; i < arrPosition.length; i++) {
            xmlComponent = this.GetComponentNodeByComponentID(xmlComponents, arrPosition[i])
            newXmlComponents.appendChild(xmlComponent);
        }

        this.SaveComponentsToFile(newXmlComponents);
        oToolbarManager_CT2958529.reloadUserComponents(false);
    },

    GetComponentId: function(xmlComponent) {
        var arrNodes = null;

        try {
            arrNodes = xmlComponent.parentNode.getElementsByTagName('UNIQUE_COMP_ID');
        }
        catch (e) {
            arrNodes = xmlComponent.getElementsByTagName('UNIQUE_COMP_ID');
        }

        if (arrNodes.length > 0)
            return EBXML_CT2958529.GetXmlNodeValue(arrNodes.item(0))

        return null;
    },

    isExists: function(xmlUserComponents, componentId) {
        var compId = '';
        for (var i = 0; i < xmlUserComponents.childNodes.length; i++) {
            compId = this.GetComponentId(xmlUserComponents.childNodes[i]);
            if (compId == componentId)
                return true;
        }
        return false;
    }
}


var EBValidationManager_CT2958529 =
{
    validate: function(prefName) {
        var value = (EBToolbarPreferenceManager_CT2958529.HasUserValue(prefName)) ?
        EBToolbarPreferenceManager_CT2958529.GetPref(prefName) : -1;

        value++;
        if (value > 2) value = 2;
        EBToolbarPreferenceManager_CT2958529.SetPref(prefName, value);
    }
};
function EBWindowLoad_CT2958529(event, dataObj) {
    if (EBGlobalConsts_CT2958529.IsEngine) {
        if (EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.IsEngineShown))
            EBPreferenceForLocalStorage_CT2958529.IsEngineShown = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.IsEngineShown);

        if (EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.EngineHiddenByUser))
            EBPreferenceForLocalStorage_CT2958529.EngineHiddenByUser = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EngineHiddenByUser);
    }
    oToolbar_CT2958529 = (isFloatingMode_CT2958529) ? EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true).oToolbar_CT2958529 : EBFManager_CT2958529.getService();
	//Initialize the global object(currently for the sound xpcom class)
	EBGlobalManager_CT2958529.Initialize();
	//register all observers
	EBObserversManager_CT2958529.Register();
	EBFirefoxBrowserManager_CT2958529.OnLoadWindow();
	if (dataObj) dataObj.event = event;
	

	
	EBLoadToolbar_CT2958529(dataObj);
};

function EBWindowUnLoad_CT2958529(event) {
    if (EBGlobalConsts_CT2958529.IsEngine) {
        if (EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.IsEngineShown))
            EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsEngineShown, EBPreferenceForLocalStorage_CT2958529.IsEngineShown);
        
        if (EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.EngineHiddenByUser))
            EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EngineHiddenByUser, EBPreferenceForLocalStorage_CT2958529.EngineHiddenByUser);
    }

    if (!isFloatingMode_CT2958529) window.EBChevronStaticManager_CT2958529.CloseAllWindows();
    //remove all observers:
    EBObserversManager_CT2958529.UnRegister();

	//check if closing in uninstalltion to clear all toolbar private data
	//in the unload process - this prevents a bug if the user opened a 
	//window after he does uninstall without closing all Firefox instances first -
	//so we sure delete all data when he close the last window
	if(EBUninstallManager_CT2958529.IsToClearToolbarData())
	{
	    //Restore search from address url to previous
	    EBSearchFromAddressBar_CT2958529.restoreOnUninstall();
	    
	    EBUninstallManager_CT2958529.ClearToolbarData();

	    if (EBUninstallManager_CT2958529.IsLastToolbar(EBPreferenceConsts_CT2958529.ToolbarsList))
		    EBUninstallManager_CT2958529.ClearCommonData();
		
		//Clear Alert Info
		EBAlertManager_CT2958529.Uninstall();

		//set toolbar visible, for next time installation
		EBActionManager_CT2958529.SetToolbarVisible();
		
		//close all remain open windows to fully complete the uninstallation
		EBUninstallManager_CT2958529.CloseAllWindows();
		var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
		ChevronStaticManager.CloseAllWindows();
	}

	EBUnloadToolbar_CT2958529(true);
};

function EBWindowClose_CT2958529(event) {

};

function EBWindowMouseUp_CT2958529(event) {
    if (!EBToolbarManager_CT2958529.dataToolbarObject) return;
    
    EBGadgetManager_CT2958529.onclickOnGadget("dummyId");
    if (!isFloatingMode_CT2958529) EBSelectToSearchBox_CT2958529.onmouseup(event);
};

function EBWindowMouseMove_CT2958529(event)
{
	//set the globals variable state the client coordinates
	EBGlobalVariables_CT2958529.ScreenCoordinateX = event.screenX;
	EBGlobalVariables_CT2958529.ScreenCoordinateY = event.screenY;
};

//global event of the window to set focus
// - start to be able catch the onfocus on the searchbox menulist
//which does not have an auto onblur event
function EBWindowFocus_CT2958529(event) {
    if (!EBToolbarManager_CT2958529.dataToolbarObject) return;
    
    EBGadgetManager_CT2958529.onclickOnGadget("dummyId");
    
    if (event.eventPhase == 2)
        EBChevronStaticManager_CT2958529.onWindowResize(event);
        
	if(event && event.target)
	{
		var XULSearchBoxMenuList = EBComponentsManager_CT2958529.GetSearchBoxMenuList();
		if(XULSearchBoxMenuList && event.target == XULSearchBoxMenuList)
			EBSearchBoxManager_CT2958529.OnSearchBoxFocus(event);
	}	
};

//global event of the window to set blur(un-focus)
// - start to be able catch the onblur on the searchbox menulist
//which does not have an auto onblur event
function EBWindowBlur_CT2958529(event) {
    if (!EBToolbarManager_CT2958529.dataToolbarObject) return;
	
	if(event && event.target)
	{
		var XULSearchBoxMenuList = EBComponentsManager_CT2958529.GetSearchBoxMenuList();
		if (XULSearchBoxMenuList && event.target == XULSearchBoxMenuList)
		    EBSearchBoxManager_CT2958529.OnSearchBoxBlur(event);
	}
};

function EBWindowResize_CT2958529(event) {
    if (!EBToolbarManager_CT2958529.dataToolbarObject) return;
    if (event.eventPhase != 2) return;

    EBChevronStaticManager_CT2958529.onWindowResize(event);
};

function EBFloatingWindowBlur_CT2958529(event) {
    window.isFocused = false;
    var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
    setTimeout(function() {
        if (!ChevronStaticManager.focusFromBC) ChevronStaticManager.CloseAllWindows();
        else { ChevronStaticManager.focusFromBC = false; }
    }, 10);

    return;
};


function EBFloatingWindowFocus_CT2958529(event) {
    var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
    if (!ChevronStaticManager) return;
    window.isFocused = true;
    ChevronStaticManager.disableCloseAllWindows = true;
    ChevronStaticManager.CloseCorrectWindows();
    setTimeout(function() { ChevronStaticManager.disableCloseAllWindows = false; }, 100);
};

function EBFloatingWindowClick_CT2958529(event) {
    var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
    ChevronStaticManager.isClickOnWindow = true;
    setTimeout(function() { ChevronStaticManager.isClickOnWindow = false }, 50);    
};

function EBAOLAccount_CT2958529(strEmail, strPassword) {
    this.MailAccount = null;
    this.cancelLogin = false;
    var self = this;

    //Constructor
    this.InitAccount = function(strEMail, strPassword) {
        //initialize the email account object
        this.MailAccount = new EBEMailAccount_CT2958529(EBEmailAccountsConsts_CT2958529.AOL.MailURL, strEMail, strPassword);
    }

    this._login = function(event, objExtractNewMessages) {
        var strMailURL = this.MailAccount.MailURL;
        var that = this;
        var objCallBackFunction = function() {
            var objLogin = function(strHtml) {
                var strPostData = that._GetPostData.call(that, strHtml);
                if (objExtractNewMessages)
                    EBServerDataURL_CT2958529.ServerRequest(strMailURL, strPostData, null, null, objExtractNewMessages);
                else {
                    var bIsInNewTab = event.button == 1;
                    event.customData = { "url": strMailURL, "urlTarget": bIsInNewTab ? "TAB" : "SELF", postParams: strPostData };
                    EBLinkManager_CT2958529.LoadLinkURL(event);
                }
            };
            EBServerDataURL_CT2958529.ServerRequest(EBEmailAccountsConsts_CT2958529.AOL.MailURL, null, null, null, objLogin);
        };

        //logout before navigating to the account
        this.DeleteSessionCookies();
        EBWeb_CT2958529.NavigationWithCallBack(EBEmailAccountsConsts_CT2958529.AOL.MailLogoutURL, objCallBackFunction);
    };

    this.Login = function(event) {
        var oNewTab = EBWeb_CT2958529.LoadURLInNewTab("chrome://browsersearch/content/wait.xul");

        var strMailURL = this.MailAccount.MailURL;
        var bIsInNewTab = event.button == 1;
        var goToAccount = function() {
            if (!self.cancelLogin)
                oNewTab.linkedBrowser.contentDocument.location.href = strMailURL;
            //remove self from logging in accounts
            EBEMailNotifierManager_CT2958529.loginAccounts.Remove(strEmail);
        };

        this.GetNewMessagesCount(goToAccount);
    };

    this.Logout = function(event) {
        var strLogoutURL = EBEmailAccountsConsts_CT2958529.AOL.MailLogoutURL;
        var strLoginURL = EBEmailAccountsConsts_CT2958529.AOL.MailURL;

        var objCallBackFunction = function() {
            if (!this.cancelLogin) {
                event.customData = { "url": strLogoutURL };
                EBLinkManager_CT2958529.LoadLinkURL(event);
            }
        };

        EBWeb_CT2958529.NavigationWithCallBack(strLogoutURL, objCallBackFunction);
    };


    this.DeleteSessionCookies = function() {
        var oCookieManager = Components.classes["@mozilla.org/cookieService;1"].
                  getService(Components.interfaces.nsICookieManager);

        //TODO if needed
    };

    this.IsLoggedIn = function(objCallBackFunction) {
        //check if there an open window on yahoo mail and check to retrive the 
        //new messages from this window using it html document
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            var objTabBrowser = objWindow.document.getElementById('content');
            var objTab = null;
            for (var i = 0; i < objTabBrowser.browsers.length; i++) {
                objTab = objTabBrowser.browsers[i];
                var objTabDocument = objTab.contentWindow.document;

                var strLocationURL = objTabDocument.location.href;

                if (strLocationURL.toLowerCase().indexOf(EBEmailAccountsConsts_CT2958529.AOL.CheckLoginInURL) != -1) {
                    iNewMessages = EBEmailAccountsConsts_CT2958529.LOGIN_ANOTHER_ACCOUNT;
                    objCallBackFunction(iNewMessages);
                    return true;
                }
            }
        }
        return false;
    };

    this.GetNewMessagesCount = function(objCallBackFunction, bIsFromCheck) {
        var strMailURL = this.MailAccount.MailURL;
        var strEMail = this.MailAccount.EMail;
        var iNewMessages = null;

        if (this.IsLoggedIn(objCallBackFunction)) return;

        var objCheckFunction = function(objDoc) {
            var arrBody = objDoc.getElementsByTagName("body");
            if (arrBody && arrBody.length != 0) {
                var strHtml = arrBody[0].innerHTML;
                var arrMatches = strHtml.match(/onClickMailCount\"\>(\d*)/);
                if (arrMatches && arrMatches.length >= 2 && !isNaN(parseInt(arrMatches[1]))) {
                    var iCount = parseInt(arrMatches[1]);
                    return iCount;
                }
            }

            return null;
        };

        var strLogoutUrl = EBEmailAccountsConsts_CT2958529.AOL.MailLogoutURL;
        var strLoginUrl = EBEmailAccountsConsts_CT2958529.AOL.MailURL;
        var strUserName = this.MailAccount.UserName;
        var strPass = this.MailAccount.Password;
        var strUserNameFieldID = "lgnId1";
        var strPassFieldID = "pwdId1";
        var strSubmitID = "aolsubmit";
        var strFormName = "AOLLoginForm";

        if (bIsFromCheck) {
            var strBrowserID = EBComponentsConsts_CT2958529.EMailNotifierNewID;

            EBEmailNotifierManager_CT2958529.xulBrowser = EBXULFactory_CT2958529.CreateBrowser(strBrowserID, '', 0, 0);
            document.getElementById('mainBox').appendChild(EBEmailNotifierManager_CT2958529.xulBrowser);
        }
        var loginToAOL = function() {
            var objData = new EBEMailNotifierManagerData_CT2958529();
            objData.callbackNewMessages = objCallBackFunction;
            objData.inboxCheckFunction = objCheckFunction;
            objData.logoutUrl = strLogoutUrl;
            objData.loginUrl = strLoginUrl;
            objData.username = strUserName;
            objData.password = strPass;
            objData.inputIDs.username = strUserNameFieldID;
            objData.inputIDs.password = strPassFieldID;
            objData.inputIDs.submit = strSubmitID;
            objData.formName = strFormName;
            objData.checkFrames = false;

            EBEmailNotifierManager_CT2958529.CheckForEmails(objData);
        };
        this._login(null, loginToAOL);
    };

    this._GetPostData = function(strHtml) {
        var arrMatches = strHtml.match(/name=\"usrd\" value=\"(\d+)/);
        var strUsrd = (arrMatches) ? arrMatches[1] : "";
        var strPostData = "loginId=" + this.MailAccount.UserName + "&password=" + this.MailAccount.Password;
        strPostData += "&siteId=";
        strPostData += "&sitedomain=sns.webmail.aol.com";
        //strPostData += "&sitedomain=";
        strPostData += "&lang=en";
        strPostData += "&locale=us";
        strPostData += "&authLev=0";
        strPostData += "&siteState=";
        strPostData += "&isSiteStateEncoded=false";
        strPostData += "&mcState=initialized";
        strPostData += "&uitype=std";
        strPostData += "&use_aam=0";
        strPostData += "&_sns_fg_color_=";
        strPostData += "&_sns_err_color_=";
        strPostData += "&_sns_link_color_=";
        strPostData += "&_sns_width_";
        strPostData += "&_sns_height_";
        strPostData += "&_sns_bg_color_";
        strPostData += "&offerId=mail-second-en-us";
        strPostData += "&seamless=novl";
        strPostData += "&regPromoCode=";
        strPostData += "&idType=SN";
        strPostData += "&xchk=false";
        strPostData += "&doSSL=";
        strPostData += "&redirType=";
        strPostData += "&rememberMe=";
        strPostData += "&usrd=" + strUsrd;
        return strPostData;
    };

    this.InitAccount(strEmail, strPassword);
};

/********************* GMail Account ****************************/
function EBGmailAccount_CT2958529(strEMail, strPassword) {
    this.MailAccount = null;
    this.cancelLogin = false;
    var self = this;

    //Constructor
    this.InitAccount = function(strEMail, strPassword) {
        //initialize the email account object
        this.MailAccount = new EBEMailAccount_CT2958529(EBEmailAccountsConsts_CT2958529.GMail.MailURL, strEMail, strPassword);
    }

    this.Login = function(event) {
        var oNewTab = EBWeb_CT2958529.LoadURLInNewTab("chrome://browsersearch/content/wait.xul");

        var strMailURL = "http://gmail.com";
        var bIsInNewTab = event.button == 1;
        var goToAccount = function() {
            if (!self.cancelLogin)
                oNewTab.linkedBrowser.contentDocument.location.href = strMailURL;
            //remove self from logging in accounts
            EBEMailNotifierManager_CT2958529.loginAccounts.Remove(strEMail);
        };
        if (isFloatingMode_CT2958529) {
            var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
            var emailAccount = win.EBEMailNotifierManager_CT2958529.GetAccountObjectByType(EBEmailAccountsTypes_CT2958529.GMail, strEMail, strPassword);
            emailAccount._preLogin(goToAccount);
            emailAccount = null;
        }
        else
            this._preLogin(goToAccount);
    };

    this.Logout = function(event) {
        var strLogoutURL = EBEmailAccountsConsts_CT2958529.GMail.MailLogoutURL;
        var strLoginURL = EBEmailAccountsConsts_CT2958529.GMail.MailURLnoAuth;
        event.customData = { "url": strLogoutURL };
        EBLinkManager_CT2958529.LoadLinkURL(event);
        event.customData = { "url": strLoginURL };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    };


    this._GetGmailPostData = function() {
        var strPostData = "ltmpl=wsad&ltmplcache=2&continue=https%3A%2F%2Fmail.google.com%2Fmail%2F%3F&service=mail&rm=false&ltmpl=wsad&Email=" +
        	            encodeURIComponent(this.MailAccount.UserName) + "&Passwd=" + encodeURIComponent(this.MailAccount.Password) + "&null=Sign+in";
        
        return strPostData;
    };

    this.GetNewMessagesCount = function(objCallBackFunction) {
        //define the response function coming from the server
        //after retrieving the string data
        var objServerResponseFunction = function(strData, objRequest) {
            var iNewMessagesCount = EBEmailAccountsConsts_CT2958529.LOGIN_FAILED;
            //parse the data of the xml
            var XMLDoc = EBXML_CT2958529.GetXmlDocument(strData);

            var objXMLRoot = XMLDoc.documentElement;
            var objXMLChildNode = null;
            if (objXMLRoot.tagName == "feed") {
                for (var i = 0; i < objXMLRoot.childNodes.length; i++) {
                    objXMLChildNode = objXMLRoot.childNodes[i];
                    if (objXMLChildNode.tagName == 'fullcount') {
                        iNewMessagesCount = EBXML_CT2958529.GetXmlNodeValue(objXMLChildNode);
                        break;
                    }
                }
            }
            objCallBackFunction(iNewMessagesCount);
        };

        //call a dummy request first to nullify the gmail feed session
        EBServerDataURL_CT2958529.ServerRequest(EBEmailAccountsConsts_CT2958529.GMail.FeedURL,
										'',
										'dummy',
										'dummy',
										null);

        EBServerDataURL_CT2958529.ServerRequest(EBEmailAccountsConsts_CT2958529.GMail.FeedURL,
										'',
										this.MailAccount.UserName,
										this.MailAccount.Password,
										objServerResponseFunction);

    };

    this._preLogin = function(objCallBackFunction, bIsFromCheck) {
        var strMailURL = this.MailAccount.MailURL;
        var strEMail = this.MailAccount.EMail;
        var iNewMessages = null;

        //if (this.IsLoggedIn(objCallBackFunction)) return;

        var objCheckFunction = function(objDoc) {
            return (objDoc.location.href.indexOf("://www.google.com/accounts/ManageAccount") != -1) ? 1 : null;
        };

        var strLogoutUrl = EBEmailAccountsConsts_CT2958529.GMail.MailLogoutURL;
        var strLoginUrl = EBEmailAccountsConsts_CT2958529.GMail.MailURL;
        var strUserName = this.MailAccount.UserName;
        var strPass = this.MailAccount.Password;
        var strUserNameFieldID = "Email";
        var strPassFieldID = "Passwd";
        var strSubmitID = "Passwd";
        var strFormName = null;
        var strFrameName = null;
        if (bIsFromCheck) {
            var strBrowserID = EBComponentsConsts_CT2958529.EMailNotifierNewID;

            EBEmailNotifierManager_CT2958529.xulBrowser = EBXULFactory_CT2958529.CreateBrowser(strBrowserID, '', 0, 0);
            document.getElementById('mainBox').appendChild(EBEmailNotifierManager_CT2958529.xulBrowser);
        }

        var login = function() {
            var objData = new EBEMailNotifierManagerData_CT2958529();
            objData.callbackNewMessages = objCallBackFunction;
            objData.inboxCheckFunction = objCheckFunction;
            objData.logoutUrl = strLogoutUrl;
            objData.loginUrl = strLoginUrl;
            objData.username = strUserName;
            objData.password = strPass;
            objData.inputIDs.username = strUserNameFieldID;
            objData.inputIDs.password = strPassFieldID;
            objData.inputIDs.submit = strSubmitID;

            EBEmailNotifierManager_CT2958529.CheckForEmails(objData);
        };

        EBWeb_CT2958529.NavigationWithCallBack(EBEmailAccountsConsts_CT2958529.GMail.MailLogoutURL, login);
    };


    //call the constructor when the object is raised
    this.InitAccount(strEMail, strPassword);
};

/********************* Hotmail Account ****************************/
function EBHotmailAccount_CT2958529(strEMail, strPassword) {
    this.MailAccount = null;
    this.cancelLogin = false;
    var self = this;

    //Constructor
    this.InitAccount = function(strEMail, strPassword) {
        //initialize the email account object
        this.MailAccount = new EBEMailAccount_CT2958529('', strEMail, strPassword);
    };

    this.Login = function(event) {
        var strPostData = this._GetHotmailPostData();
        var oEvent = event;
        var bIsInNewTab = oEvent.button == 1;
        var objCallBackFunction = function(strFormAction, strPPFTHiddenValue) {
            if (strFormAction && strPPFTHiddenValue && !self.cancelLogin) {
                strPostData += strPPFTHiddenValue;
                oEvent.customData = { "url": strFormAction, "urlTarget": bIsInNewTab ? "TAB" : "SELF", postParams: strPostData };
                EBLinkManager_CT2958529.LoadLinkURL(oEvent);
            }
            //remove self from logging in accounts
            EBEMailNotifierManager_CT2958529.loginAccounts.Remove(strEMail);
        };

        var objLogoutWithCallBackFunction = function() {
            EBHotmailAccountManager_CT2958529.GetLoginInformation(objCallBackFunction);
        };

        this.DeleteSessionCookies();
        EBWeb_CT2958529.NavigationWithCallBack(EBEmailAccountsConsts_CT2958529.Hotmail.MailLogoutURL, objLogoutWithCallBackFunction);
    };

    this.Logout = function(event) {
        var strLogoutURL = EBEmailAccountsConsts_CT2958529.Hotmail.MailLogoutURL;
        var strLoginURL = EBEmailAccountsConsts_CT2958529.Hotmail.MailURL;
        event.customData = { "url": strLogoutURL };
        EBLinkManager_CT2958529.LoadLinkURL(event);
        event.customData = { "url": strLoginURL };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    };

    this._GetHotmailPostData = function() {
        var strPostData = 'PPSX=Pas&PwdPad=IfYouAreReadingThisYouHaveTooMuchFreeTime&login=' + encodeURIComponent(this.MailAccount.EMail) + '&passwd=' + encodeURIComponent(this.MailAccount.Password) + '&PPFT=';
        return strPostData;
    };

    this.DeleteSessionCookies = function() {
        var oCookieManager = Components.classes["@mozilla.org/cookieService;1"].
                  getService(Components.interfaces.nsICookieManager);

        oCookieManager.remove('.msn.com', 'MSPAuth', '/', false);
        oCookieManager.remove('.msn.com', 'MSPProf', '/', false);
        oCookieManager.remove('.msn.com', 'MailToken', '/', false);
        oCookieManager.remove('.msn.com', 'PIM', '/', false);
        oCookieManager.remove('.msn.com', 'MUID', '/', false);
        oCookieManager.remove('.msn.com', 'ANON', '/', false);
        oCookieManager.remove('.msn.com', 'NAP', '/', false);

        oCookieManager.remove('.login.live.com', 'PPAuth', '/', false);
        oCookieManager.remove('.login.live.com', 'RPSTAuthTime', '/', false);
        oCookieManager.remove('.login.live.com', 'MSPVis', '/', false);
        oCookieManager.remove('.login.live.com', 'MSPSoftVis', '/', false);
        oCookieManager.remove('.login.live.com', 'MSPCID', '/', false);
        oCookieManager.remove('.login.live.com', 'MSPPre', '/', false);
        oCookieManager.remove('login.live.com', 'MSPRequ', '/', false);

        oCookieManager.remove('.live.com', 'PPLState', '/', false);
        oCookieManager.remove('.live.com', 'RPSTAuth', '/', false);
        oCookieManager.remove('.live.com', 'MSPAuth', '/', false);
        oCookieManager.remove('.live.com', 'MSPProf', '/', false);
        oCookieManager.remove('.live.com', 'MSPSecAuth', '/', false);
        oCookieManager.remove('.live.com', 'MUID', '/', false);

        oCookieManager.remove('by117w.bay117.mail.live.com', 'mt', '/', false);
        oCookieManager.remove('by123w.bay123.mail.live.com', 'mt', '/', false);

        oCookieManager.remove('.hotmail.msn.com', 'HMSC0899', '/', false);
        oCookieManager.remove('.hotmail.msn.com', 'HMSatchmo', '/', false);
        oCookieManager.remove('.hotmail.msn.com', 'HMP1', '/', false);

        oCookieManager.remove('.passport.com', 'MSPBack', '/', false);
        oCookieManager.remove('.passport.com', 'PPWLRedir', '/', false);
        oCookieManager.remove('.passport.com', 'PPStateXfer', '/', false);

        oCookieManager.remove('login.passport.com', 'MSPRequ', '/', false);

        oCookieManager.remove('.mail.live.com', 'KSC1108', '/', false);
        oCookieManager.remove('.mail.live.com', 'bic', '/', false);
        oCookieManager.remove('.mail.live.com', 'KVC', '/', false);


    };

    this.IsLogIn = function(strLocation) {
        strLocation = strLocation.toLowerCase();
        var arrLoginURL = EBEmailAccountsConsts_CT2958529.Hotmail.CheckLoginInURL;
        for (var i = 0; i < arrLoginURL.length; i++) {
            if (strLocation.indexOf(arrLoginURL[i]) != -1) {
                return true;
            }
        }

        return false;
    };

    this.IsLoggedIn = function() {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            var objTabBrowser = objWindow.document.getElementById('content');
            var objTab = null;
            for (var i = 0; i < objTabBrowser.browsers.length; i++) {
                objTab = objTabBrowser.browsers[i];
                var objTabDocument = objTab.contentWindow.document;
                var objTabBody = objTabDocument.body;
                var strLocationURL = objTabDocument.location.href;

                //check if the user is logged in to Hotmail account
                //to prevent the check new messages (which log you out 
                //from your current account!)
                if (this.IsLogIn(strLocationURL)) {
                    //in hotmail i can't always check his new messages
                    //because of the different pages so i always return login anouther 
                    //user to make him disconnect
                    return true;
                }
            }
        }

        return false;
    };

    this.GetNewMessagesCount = function(objCallBackNewMessagesFunction, bIsFromCheck) {
        var iNewMessages = null;

        //var strPostData = this._GetHotmailPostData();
        var strEMail = this.MailAccount.EMail.toLowerCase();

        //check if there an open window on hotmail mail and check to retrive the 
        if (this.IsLoggedIn()) {
            iNewMessages = EBEmailAccountsConsts_CT2958529.LOGIN_ANOTHER_ACCOUNT;
            objCallBackNewMessagesFunction(iNewMessages);
            return;
        }

        iNewMessages = EBEmailAccountsConsts_CT2958529.LOGIN_FAILED;
        //*******************************************************************************
        var objCheckFunction = function(objDoc, objWin, isMainFrame) {

            //   if (!isMainFrame) return;
            function EB_IsNewLookPage() {
                var oIsNewLookPage = objDoc.getElementById("DontShowMessageAtLoginCheckbox");
                if (oIsNewLookPage != null) {
                    return true;
                }
                return false;
            }

            function EB_HandleNewLookPage() {
                var oTakeMeToInbox = objDoc.getElementById("TakeMeToInbox");
                if (oTakeMeToInbox != null) {
                    oTakeMeToInbox.click();
                }
                return -1;
            }

            function EB_IsUIFrameExist() {
                var oUIFrame = objDoc.getElementById("UIFrame");
                if (!oUIFrame)
                    return false;
                return true;
            }

            function EB_HandleYouSpokePage() {
                var oUIFrame = objDoc.getElementById("UIFrame");
                if (!oUIFrame)
                    return false;

                try {
                    var oTitle = objWin.frames[0].document.title;
                    if (oTitle) {
                        return false;
                    }
                }
                catch (e) {
                    if (!e.message)
                        return false;

                    var oStrError = e.message.toLowerCase();
                    if (oStrError.indexOf("access is denied") != -1) {
                        var oStrSrc = oUIFrame.src;
                        objDoc.location.href = oStrSrc;
                        return true;
                    }
                }
                return false;
            }

            function EB_GetNumNewMessagesFromIFrame() {
                var oUIFrame = objDoc.getElementById("UIFrame");
                if (!oUIFrame)
                    return null;

                var oDocument = objWin.frames[0].document;
                return EB_GetNumNewMessagesFromDocument(oDocument);
            }

            function EB_GetNumNewMessagesFromDocument(oDocument) {
                try {

                    var numNode = oDocument.getElementById("h_inboxCount");
                    if (numNode) {
                        var strNumNode = numNode.innerHTML;
                        return parseInt(strNumNode.match(/\d+/g));
                    }

                    var oUL = oDocument.getElementById("folderList");
                    if (oUL) {
                        var oLI = oUL.firstChild;
                        if (oLI) {
                            var iInbox = oLI.getAttribute("count");
                            if (iInbox) {
                                var iNumNewMessages = parseInt(iInbox);
                                return iNumNewMessages;
                            }
                        }
                    }
                }
                catch (e) {
                }
                return null;
            };

            //***************

            var oExist = EB_IsUIFrameExist();
            if (oExist) {
                var oRet = EB_HandleYouSpokePage();
                if (oRet == true)
                    return null;


                iNumNewMessages = EB_GetNumNewMessagesFromIFrame();
                return iNumNewMessages;
            }

            var bIsNewLookPage = EB_IsNewLookPage();
            if (bIsNewLookPage == true) {
                return EB_HandleNewLookPage();
            }

            iNumNewMessages = EB_GetNumNewMessagesFromDocument(objDoc);
            return iNumNewMessages;
        };

        var objLoginFunction = function(objWindow, userName, password, isMainPage, isDocument) {
            if (!isMainPage || !isDocument) return -1;
            var bIsIncorrectDetails = EB_IsIncorrectDetails(objWindow);
            if (bIsIncorrectDetails == true)
                return -50; // Incorrect userName Or Password.

            try {
                var oUserName = objWindow.document.getElementById("i0116");
                oUserName.value = userName;

                var oPassword = objWindow.document.getElementById("i0118");
                oPassword.value = password;

                var CheckBox = objWindow.document.getElementById("i0136");
                CheckBox.checked = false; //	Save my e-mail address and password

                CheckBox = objWindow.document.getElementById("i0137");
                CheckBox.checked = false; //	Save my e-mail address

                CheckBox = objWindow.document.getElementById("i0138");
                CheckBox.checked = true; //	Always ask for my e-mail address and password

                objWindow.document.forms[0].submit();
            }
            catch (e) {
                return 0;
            }
            return 1;
        }

        function EB_IsIncorrectDetails(objWindow) {
            var oIncorrectDetails = objWindow.document.getElementById("i0518");
            if (oIncorrectDetails != null) {
                return true;
            }
            return false;
        }
        //*******************************************************************************


        var strLogooutUrl = EBEmailAccountsConsts_CT2958529.Hotmail.MailLogoutURL;
        var strLoginUrl = 'http://login.live.com/login.srf?id=2';
        var strUserName = this.MailAccount.EMail;
        var strPass = this.MailAccount.Password;
        var strUserNameFieldID = 'i0116';
        var strPassFieldID = 'i0118';
        var strSubmitID = 'i0011';
        var strFrameName = '';

        if (bIsFromCheck) {
            var strBrowserID = EBComponentsConsts_CT2958529.EMailNotifierNewID;

            EBEmailNotifierManager_CT2958529.xulBrowser = EBXULFactory_CT2958529.CreateBrowser(strBrowserID, '', 0, 0);
            document.getElementById('mainBox').appendChild(EBEmailNotifierManager_CT2958529.xulBrowser);
        }

        var objData = new EBEMailNotifierManagerData_CT2958529();
        objData.callbackNewMessages = objCallBackNewMessagesFunction;
        objData.inboxCheckFunction = objCheckFunction;
        objData.logoutUrl = strLogooutUrl;
        objData.loginUrl = strLoginUrl;
        objData.username = strUserName;
        objData.password = strPass;
        objData.inputIDs.username = strUserNameFieldID;
        objData.inputIDs.password = strPassFieldID;
        objData.inputIDs.submit = strSubmitID;
        objData.inboxDomain = "mail.live";
        objData.checkFrames = true;
        objData.loginFunction = objLoginFunction;
        objData.reloadPage = EBEmailAccountsConsts_CT2958529.Hotmail.ReloadPage;

        EBEmailNotifierManager_CT2958529.CheckForEmails(objData);

        var objCallBackFunction = function(strFormAction, strPPFTHiddenValue) {
            if (strFormAction && strPPFTHiddenValue) {
                strPostData += strPPFTHiddenValue;


                var objServerResponseFunction = function(strData, aRequest) {
                    var strInboxURL = '';

                    //first check within the javascript location.replace
                    var arrMatches = strData.match(/location.replace\([\"|\']*([^\"|^\']+)[\"|\']*\).*/i);
                    if (arrMatches) {
                        strInboxURL = arrMatches[1];
                    }
                    else {
                        //second check in the meta tag
                        arrMatches = strData.match(/URL=[\"|\']*([^\"|^\'|^\>]+)[\"|\']*.*/i);
                        if (arrMatches) {
                            strInboxURL = arrMatches[1];
                        }
                    }
                    if (strInboxURL) {
                        var objServerResponseFunctionInner = function(strDataInner, aRequestInner) {
                            var strSource = strDataInner;

                            //check for hotmail beta:
                            var strLocationReplaceURL = '';
                            var arrMatches = strSource.match(/location.replace\([\"|\']*([^\"|^\']+)[\"|\']*\).*/i);
                            if (arrMatches) {
                                strLocationReplaceURL = arrMatches[1];
                            }

                            if (strLocationReplaceURL)//hotmail beta
                            {
                                EBHotmailBetaAccountManager_CT2958529.CheckNewMessages(strLocationReplaceURL, objCallBackNewMessagesFunction);
                            }
                            else //regular hotmail
                            {
                                iNewMessages = EBEmailAccountsConsts_CT2958529.LOGIN_FAILED;
                                //parse the source using indexOf and not regular expression cause there
                                //is too many matching templates to the new messages templates
                                var strFontClassK = strSource.substring(strSource.indexOf('<font class="K">'));

                                var strNewMessages = strFontClassK.substring(strFontClassK.indexOf('(') + 1, strFontClassK.indexOf(')'));

                                if (strNewMessages && isFinite(strNewMessages)) {
                                    iNewMessages = strNewMessages;
                                }
                                //sometimes the landing page is Today and not Mail
                                else {
                                    strFontClassK = strSource.substring(strSource.lastIndexOf('<font class="K">'))
                                    strNewMessages = strFontClassK.substring(strFontClassK.indexOf('(') + 1, strFontClassK.indexOf(')'));
                                    if (strNewMessages && isFinite(strNewMessages)) {
                                        iNewMessages = strNewMessages;
                                    }
                                }

                                objCallBackNewMessagesFunction(iNewMessages);
                            }
                        };

                        EBServerDataURL_CT2958529.ServerRequest(strInboxURL,
											null,
											null,
											null,
											objServerResponseFunctionInner);
                    }
                    else {
                        objCallBackNewMessagesFunction(iNewMessages);
                    }
                }

                EBServerDataURL_CT2958529.ServerRequest(strFormAction,
												strPostData,
												null,
												null,
												objServerResponseFunction);

            }
            else {
                objCallBackNewMessagesFunction(iNewMessages);
            }
        };

        var objLogoutWithCallBackFunction = function() {
            EBHotmailAccountManager_CT2958529.GetLoginInformation(objCallBackFunction);
        };

        //this.DeleteSessionCookies();
        //EBWeb_CT2958529.NavigationWithCallBack(EBEmailAccountsConsts_CT2958529.Hotmail.MailLogoutURL,objLogoutWithCallBackFunction);
    };
    this.InitAccount(strEMail, strPassword);
};

var EBHotmailAccountManager_CT2958529 =
{
    GetLoginInformation: function(objCallBackFunction) {
        var objServerResponseFunction = function(strDataInner, aRequestInner) {

            var strFormAction = '';
            var strPPFTHiddenValue = '';

            var arrMatches = strDataInner.match(/\<form\s+.*action=[\"|\']*([^\"|^\']+)[\"|\']*.*\>/i);
            if (arrMatches) {
                strFormAction = arrMatches[1];
            }
            arrMatches = strDataInner.match(/\<input\s+.*name=[\"|\']*PPFT[\"|\']*\s+.*value=[\"|\']*([^\"|^\']+)[\"|\']*.*\>/i);
            if (arrMatches) {
                strPPFTHiddenValue = arrMatches[1];
            }

            objCallBackFunction(strFormAction, strPPFTHiddenValue);
        };

        EBServerDataURL_CT2958529.ServerRequest(EBEmailAccountsConsts_CT2958529.Hotmail.URL,
												null,
												null,
												null,
												objServerResponseFunction);
    }
}


var EBHotmailBetaAccountManager_CT2958529 =
{
    CheckNewMessages: function(strLocationReplaceURL, objCallBackNewMessagesFunction) {
        var oServerResponseFunction = function(strData, oRequest) {
            var strMainFrameSrc = '';
            //find the main frame src from the html frameset code:
            var arrMatches = strData.match(/frame\s+.*name=[\"|\']*main[\"|\']*\s+.*src=[\"|\']*([^\"|^\']+)[\"|\']*\s+/i);

            if (arrMatches) {
                strMainFrameSrc = arrMatches[1];
            }
            else {
                var iNewMessages = 0;
                arrMatches = ''
                arrMatches = strData.match(/Inbox \(([^\"|^\']+)\)/);
                if (arrMatches) {
                    iNewMessages = parseInt(arrMatches[1]);
                }
                objCallBackNewMessagesFunction(iNewMessages);
                return;
            }
            var strHotmailURLPath = strLocationReplaceURL.substring(0, strLocationReplaceURL.lastIndexOf('/') + 1);
            if (strMainFrameSrc) {
                var strFullApplicationMailURL = strHotmailURLPath + strMainFrameSrc;
                EBHotmailBetaAccountManager_CT2958529.ParseApplicationMailFrame(strHotmailURLPath, strFullApplicationMailURL, objCallBackNewMessagesFunction);
            }
            else {
                objCallBackNewMessagesFunction(EBEmailAccountsConsts_CT2958529.LOGIN_FAILED);
            }
        };

        EBServerDataURL_CT2958529.ServerRequest(strLocationReplaceURL,
								null,
								null,
								null,
								oServerResponseFunction);
    },

    ParseApplicationMailFrame: function(strHotmailURLPath, strApplicationMailURL, objCallBackNewMessagesFunction) {
        var arrMatches = null;
        var oServerResponseFunctionFirst = function(strData, oRequest) {
            var strSessionHash = '';
            //looking for sessionidhash in the js code example: 
            //"sessionidhash" : "yBUJQZ0rvmjNav9NBYv3iA%3d%3d",;
            arrMatches = strData.match(/[\"|\']*sessionidhash[\"|\']*\s*\:\s*[\"|\']([^\"|^\']+)[\"|\']/i);

            if (arrMatches) {
                strSessionHash = arrMatches[1];
            }

            var strCheckInboxURL = '';
            if (strSessionHash) {
                strCheckInboxURL = EBHotmailBetaAccountManager_CT2958529.GetFullCheckInboxURL(strHotmailURLPath, strSessionHash);
            }

            if (strCheckInboxURL) {
                var oServerResponseFunctionSecond = function(strData2, oRequest2) {
                    var iNewMessages = 0;

                    arrMatches = strData2.match(/[\"|\']i_inbox[\"|\']\D+(\d+)/i);

                    if (arrMatches) {
                        iNewMessages = parseInt(arrMatches[1]);
                    }
                    objCallBackNewMessagesFunction(iNewMessages);
                };
                var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
                var oCookieManager = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);
                var strMailToken = ''
                uri.spec = '.msn.com';
                var strCookies = oCookieManager.getCookieString(uri, null);
                arrMyCookie = strCookies.match(/MailToken=([^\"|^\']+);/)
                if (arrMyCookie) {
                    strMailToken = arrMyCookie[1];
                }

                EBServerDataURL_CT2958529.ServerRequest(strCheckInboxURL,
											'cn=Microsoft.Msn.Hotmail.MailBox&mn=Bootstrap&d={25,null,null,null,null,null,true,false,null}&v=1&mt=' + strMailToken,
											null,
											null,
											oServerResponseFunctionSecond);

            }
            else {
                objCallBackNewMessagesFunction(EBEmailAccountsConsts_CT2958529.LOGIN_FAILED);
            }
        };


        EBServerDataURL_CT2958529.ServerRequest(strApplicationMailURL,
											null,
											null,
											null,
											oServerResponseFunctionFirst);
    },

    GetFullCheckInboxURL: function(strHotmailURLPath, strSessionHash) {
        var strURL = strHotmailURLPath + 'mail.fpp?cnmn=Microsoft.Msn.Hotmail.MailBox.Bootstrap&ptid=0&a=' + strSessionHash;

        return strURL;
    }
};
/********************* Pop3 Account ****************************/
function EBPop3Account_CT2958529(strUserName, strPassword, strServerURL, iPort) {
    this.MailAccount = null;
    this.Server = strServerURL;
    this.Port = iPort;
    this.id = Math.random();

    //legalize port
    if (!this.Port) {
        this.Port = EBEmailAccountsConsts_CT2958529.Pop3.DefaultPort
    }

    //Constructor
    this.InitAccount = function(strEMail, strPassword) {
        //initialize the email account object
        this.MailAccount = new EBEMailAccount_CT2958529(this.Server, strUserName, strPassword);
    };

    this.Login = function(event) {
        EBGlobalManager_CT2958529.OpenDefaultMailClient();
    };

    this.Logout = function(event) { };

    this.GetNewMessagesCount = function(objCallBackNewMessagesFunction) {
        var pop3 = new EBPop3_CT2958529(this.MailAccount.MailURL,
                                        this.MailAccount.EMail,
									    this.MailAccount.Password,
									    this.Port,
									    objCallBackNewMessagesFunction);
    };


    this.InitAccount(strUserName, strPassword);
};

function EBPop3_CT2958529(strServerURL, strUserName, strPassword, iPort, objCallBackFunction) {
    this.InputStream = null;
    this.OutputStream = null;
    this.EndOfLine = null;
    this.NewMessages = null;
    var self = this;
    
    var Listener = function(strServerURL, strUserName) {
        this.onStartRequest = function(request, context) {
            self.NewMessages = EBEmailAccountsConsts_CT2958529.LOGIN_FAILED;
            Pop3Commands.State = EBEmailAccountsConsts_CT2958529.Pop3.StateStart;
        };
        
        this.onStopRequest = function(request, context, status) {
            self.Finish(strServerURL, strUserName);
        };

        this.onDataAvailable = function(request, context, inputStream, offset, count) {
            var strData = self.InputStream.read(count);
            Pop3Commands.Execute(strData);
        };
    };

    this.Start = function() {
        if (EBPop3AccountManager_CT2958529.isInProgress(strServerURL, strUserName))
            return;
        
        EBPop3AccountManager_CT2958529.startCheck(strServerURL, strUserName);

        //the EndOfLine char according to operation system
        this.EndOfLine = EBGlobalManager_CT2958529.GetEndOfLine();

        var objTransportSocket = Components.classes["@mozilla.org/network/socket-transport-service;1"]
									.getService(Components.interfaces.nsISocketTransportService);

        var objTransport = objTransportSocket.createTransport(null, 0, strServerURL, iPort, null);

        //initialize output stream:
        this.OutputStream = objTransport.openOutputStream(0, 0, 0);

        var objStream = objTransport.openInputStream(0, 0, 0);

        //initialize input stream:
        this.InputStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
								.createInstance(Components.interfaces.nsIScriptableInputStream);

        this.InputStream.init(objStream);

        var objPump = Components.classes["@mozilla.org/network/input-stream-pump;1"]
						.createInstance(Components.interfaces.nsIInputStreamPump);

        objPump.init(objStream, -1, -1, 0, 0, false);
        objPump.asyncRead(new Listener(strServerURL, strUserName), null);
    };

    this.Finish = function() {
        this.InputStream.close();
        this.OutputStream.close();
        EBPop3AccountManager_CT2958529.endCheck(strServerURL, strUserName);
        objCallBackFunction(this.NewMessages);
    };

    var Pop3Commands =
	{
	    State: null,

	    CMD: '',

	    Execute: function(strData) {
	        //check the data
	        if (EBGlobalManager_CT2958529.BeginsWith(strData, EBEmailAccountsConsts_CT2958529.Pop3.CommandOKPrefix)) {
	            if (this.State == EBEmailAccountsConsts_CT2958529.Pop3.StateStatus) {
	                this.ParseStatus(strData);
	            }
	            this.State++;
	            switch (this.State) {
	                case EBEmailAccountsConsts_CT2958529.Pop3.StateUserName:
	                    this.UserName();
	                    break;
	                case EBEmailAccountsConsts_CT2958529.Pop3.StatePassword:
	                    this.Password();
	                    break;
	                case EBEmailAccountsConsts_CT2958529.Pop3.StateStatus:
	                    this.Status();
	                    break;
	                case EBEmailAccountsConsts_CT2958529.Pop3.StateQuit:
	                    this.Quit();
	                    break;
	            }
	        }
	        else if (EBGlobalManager_CT2958529.BeginsWith(strData, EBEmailAccountsConsts_CT2958529.Pop3.CommandERRPrefix)) {
	            this.Quit();
	        }
	    },

	    UserName: function() {
	        this.CMD = 'USER ' + strUserName + self.EndOfLine;
	        this.RequestData();
	    },
	    Password: function() {
	        this.CMD = 'PASS ' + strPassword + self.EndOfLine;
	        this.RequestData();
	    },
	    Status: function() {
	        this.CMD = 'STAT' + self.EndOfLine;
	        this.RequestData();
	    },
	    Quit: function() {
	        this.CMD = 'QUIT' + self.EndOfLine;
	        this.RequestData();
	    },

	    RequestData: function() {
	        self.OutputStream.write(this.CMD, this.CMD.length);
	    },

	    ParseStatus: function(strData) {
	        //parse the status string from the server to see how much messages there is:
	        var arrMessages = strData.split(' ');

	        var iNewMessages = 0;
	        if (arrMessages[1])
	            iNewMessages = arrMessages[1];

	        self.NewMessages = iNewMessages;
	    }
	};

	this.Start();
};

var EBPop3AccountManager_CT2958529 =
{
    accountsChecking: new Object(),
    getAccountCheckingKey: function(strServerURL, strUserName) {
        return strServerURL + strUserName;
    },

    isInProgress: function(strServerURL, strUserName) {
        var strKey = this.getAccountCheckingKey(strServerURL, strUserName);
        return this.accountsChecking[strKey];
    },

    startCheck: function(strServerURL, strUserName) {
        var strKey = this.getAccountCheckingKey(strServerURL, strUserName);
        this.accountsChecking[strKey] = true;
    },

    endCheck: function(strServerURL, strUserName) {
        var strKey = this.getAccountCheckingKey(strServerURL, strUserName);
        this.accountsChecking[strKey] = false;
    }
};
function EBRRAccount_CT2958529(strEmail, strPassword) {
    var _pop3Account = null;
    this.MailAccount = null;
    this.cancelLogin = false;
    var self = this;

    //Constructor
    this.InitAccount = function(strEMail, strPassword) {
        //initialize the email account object
        this.MailAccount = new EBEMailAccount_CT2958529(EBEmailAccountsConsts_CT2958529.RR.MailURL, strEMail, strPassword);
    }

    this.Login = function(event) {
        //get the post data of the account
        var strPostData = this._GetPostData();
        var strMailURL = this.MailAccount.MailURL;
        var oEvent = event;
        var bIsInNewTab = oEvent.button == 1;

        var objCallBackFunction = function() {
            this.cancelLogin = false;
            if (!self.cancelLogin){
                oEvent.customData = { "url": strMailURL, "urlTarget": bIsInNewTab ? "TAB" : "SELF", postParams: strPostData };
                EBLinkManager_CT2958529.LoadLinkURL(oEvent);
            }
            //remove self from logging in accounts
            EBEMailNotifierManager_CT2958529.loginAccounts.Remove(strEmail);
        };

        //logout before navigating to the account
        this.DeleteSessionCookies();
        EBWeb_CT2958529.NavigationWithCallBack(EBEmailAccountsConsts_CT2958529.RR.MailLogoutURL, objCallBackFunction);
    };

    this.Logout = function(event) {
        var strLogoutURL = EBEmailAccountsConsts_CT2958529.RR.MailLogoutURL;
        var strLoginURL = EBEmailAccountsConsts_CT2958529.RR.MailURL;
        event.customData = { "url": strLogoutURL };
        EBLinkManager_CT2958529.LoadLinkURL(event);
        event.customData = { "url": strLoginURL };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    };

    this.DeleteSessionCookies = function() {
        var oCookieManager = Components.classes["@mozilla.org/cookieService;1"].
                  getService(Components.interfaces.nsICookieManager);

        //TODO if needed
    };

    this.GetNewMessagesCount = function(objCallBackFunction) {
        if (!_pop3Account) {
            var strUrl = EBEmailAccountsConsts_CT2958529.RR.POP3ServerUrlPattern;
            var strLocal = this._getDomainFromEmail(strEmail);
            strUrl = stringFormat(strUrl, strLocal);
            _pop3Account = new EBPop3Account_CT2958529(strEmail, strPassword, strUrl, 110);
        }
        _pop3Account.GetNewMessagesCount(objCallBackFunction);
    };

    this._GetPostData = function() {
        var strPostData = "account=" + strEmail + "&password=" + this.MailAccount.Password + "&client=html&variant=standard&domain=webmail.roadrunner.com&login=1&locale=en-US";
        return strPostData;
    };

    this._getDomainFromEmail = function(strEmail) {
        var arr = strEmail.match(/@(.*)/);
        if (arr && arr.length >= 2)
            return arr[1];
        else
            return "";
    };

    this.InitAccount(strEmail, strPassword);
};
function EBUnivisionAccount_CT2958529(strEmail, strPassword) {
    this.MailAccount = null;
    this.cancelLogin = false;
    var self = this;

    //Constructor
    this.InitAccount = function(strEMail, strPassword) {
        //initialize the email account object
        this.MailAccount = new EBEMailAccount_CT2958529(EBEmailAccountsConsts_CT2958529.Univision.MailURL, strEMail, strPassword);
    }

    this._login = function(event, objExtractNewMessages) {
        var strMailURL = this.MailAccount.MailURL;
        var that = this;
        var objCallBackFunction = function() {
            var objLogin = function(strHtml) {
                var strPostData = that._GetPostData.call(that, strHtml);
                if (objExtractNewMessages)
                    EBServerDataURL_CT2958529.ServerRequest(strMailURL, strPostData, null, null, objExtractNewMessages);
                else {
                    var bIsInNewTab = event.button == 1;
                    event.customData = { "url": strMailURL, "urlTarget": bIsInNewTab ? "TAB" : "SELF", postParams: strPostData };
                    EBLinkManager_CT2958529.LoadLinkURL(event);
                }
            };
            EBServerDataURL_CT2958529.ServerRequest(EBEmailAccountsConsts_CT2958529.Univision.MailURL, null, null, null, objLogin);
        };

        //logout before navigating to the account
        this.DeleteSessionCookies();
        EBWeb_CT2958529.NavigationWithCallBack(EBEmailAccountsConsts_CT2958529.Univision.MailLogoutURL, objCallBackFunction);
    };

    this.Login = function(event) {
        var oNewTab = EBWeb_CT2958529.LoadURLInNewTab("chrome://browsersearch/content/wait.xul");
        var bIsInNewTab = event.button == 1;
        var goToAccount = function() {
        if (!self.cancelLogin)
                oNewTab.linkedBrowser.contentDocument.location.href = EBEmailAccountsConsts_CT2958529.Univision.URL;
            //remove self from logging in accounts
            EBEMailNotifierManager_CT2958529.loginAccounts.Remove(strEmail);
        };

        this.GetNewMessagesCount(goToAccount);
    };

    this.Logout = function(event) {
        var strLogoutURL = EBEmailAccountsConsts_CT2958529.Univision.MailLogoutURL;
        var strLoginURL = EBEmailAccountsConsts_CT2958529.Univision.URL;

        var objCallBackFunction = function() {
            event.customData = { "url": strLogoutURL };
            EBLinkManager_CT2958529.LoadLinkURL(event);
        };

        EBWeb_CT2958529.NavigationWithCallBack(strLogoutURL, objCallBackFunction);
    };


    this.DeleteSessionCookies = function() {
        var oCookieManager = Components.classes["@mozilla.org/cookieService;1"].
                  getService(Components.interfaces.nsICookieManager);

        //TODO if needed
    };

    this.IsLoggedIn = function(objCallBackFunction) {
        //check if there an open window on yahoo mail and check to retrive the 
        //new messages from this window using it html document
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            var objTabBrowser = objWindow.document.getElementById('content');
            var objTab = null;
            for (var i = 0; i < objTabBrowser.browsers.length; i++) {
                objTab = objTabBrowser.browsers[i];
                var objTabDocument = objTab.contentWindow.document;

                var strLocationURL = objTabDocument.location.href;

                if (strLocationURL.toLowerCase().indexOf(EBEmailAccountsConsts_CT2958529.Univision.CheckLoginInURL) != -1) {
                    iNewMessages = EBEmailAccountsConsts_CT2958529.LOGIN_ANOTHER_ACCOUNT;
                    objCallBackFunction(iNewMessages);
                    return true;
                }
            }
        }
        return false;
    };

    this.GetNewMessagesCount = function(objCallBackFunction, bIsFromCheck) {
        var strMailURL = this.MailAccount.MailURL;
        var strEMail = this.MailAccount.EMail;
        var iNewMessages = null;

        if (this.IsLoggedIn(objCallBackFunction)) return;

        var objCheckFunction = function(objDoc, objWindow, isMainFrame, isDocument) {
            if (!isMainFrame || !isDocument) return null;

            function GetNumberFromText(text) {
                try {
                    var iLength = text.length;
                    var bFoundNumber = false;
                    var strNumber = "";
                    for (var i = 0; i < iLength; i++) {
                        var c = text.charAt(i);
                        if (c >= "0" && c <= "9") {
                            bFoundNumber = true;
                            strNumber += c;
                        }
                        else if (bFoundNumber == true) {
                            break;
                        }
                    }
                    if (bFoundNumber) {
                        var iNumber = parseInt(strNumber);
                        EBEmailAccountsConsts_CT2958529.Univision.URL = EB_GetInboxUrl();
                        return iNumber;
                    }
                    return -1;
                }
                catch (e) {
                    return -3;
                }


                function EB_GetInboxUrl() {
                    try {
                        var oInboxLink = objDoc.getElementById("tum_top_link_inbox");
                        if (!oInboxLink || oInboxLink == "undefined") {
                            return objDoc.location.href;
                        }
                        return oInboxLink.href;
                    }
                    catch (e) {
                        return "";
                    }
                    return "";
                }



            }
            try {
                var oNewInboxMessagesDiv = objDoc.getElementById("tum_top_link_span_inbox");
                if (!oNewInboxMessagesDiv || oNewInboxMessagesDiv == "undefined") {
                    return null;
                }

                var oNewMessagesDiv = objDoc.getElementById("new_messages_span");
                if (!oNewMessagesDiv || oNewMessagesDiv == "undefined") {
                    return 0;
                }

                var iNumMessages = GetNumberFromText(oNewMessagesDiv.innerHTML);
                return iNumMessages;

            }
            catch (e) {
                return null;
            }
            return null;
        };

        //********************************************************************
        var objLoginFunction = function(objWindow, userName, password, isMainPage, isDocument) {
            if (!isMainPage || !isDocument) return -1;

            function EB_IsInPortalPage() {
                if (objWindow.document.location.href == "http://www.univision.com/portal.jhtml") {
                    return true;
                }
                return false;
            }

            function EB_IsInPortalPageWithUser() {
                var oHeaderInfoDiv = objWindow.document.getElementById("header-user-info");
                if (oHeaderInfoDiv && oHeaderInfoDiv != "undefined") {
                    return true;
                }

                var oHeaderInfoNoUserDiv = objWindow.document.getElementById("header-no-user");
                if (oHeaderInfoNoUserDiv && oHeaderInfoNoUserDiv != "undefined") {
                    return false;
                }

                return false;

            }
            function EB_HandlePortalPageWithNoUser() {
                objWindow.document.location.href = "http://www.univision.com/membershipservices/login.jhtml?partnerSystem=103818&locale=En";
                return 0;
            }

            function EB_DoLogout() {
                objWindow.document.location.href = "http://www.univision.com/membershipservices/logoutmipagina.jhtml";
                return 0;

            }

            function EB_HandlePortalPage(userName) {
                if (!EB_IsInPortalPageWithUser()) {
                    return EB_HandlePortalPageWithNoUser();
                }

                var oHeaderUserNameDiv = objWindow.document.getElementById("header-user-name");
                if (!oHeaderUserNameDiv || oHeaderUserNameDiv == "undefined") {
                    return -2;
                }

                var oA = oHeaderUserNameDiv.firstChild;
                if (!oA || oA == undefined) {
                    return -3;
                }

                var oFixedInnerText = oA.innerHTML.toLowerCase();
                var oFixedUserName = EB_getFixedUserName(userName).toLowerCase();
                if (oFixedInnerText != oFixedUserName) {
                    return EB_DoLogout();
                }

                objWindow.document.location.href = oHeaderUserNameDiv.firstChild.href;
                return 0;
            }

            function EB_getFixedUserName(userName) {
                var oSplit = userName.split("@");
                if (!oSplit || oSplit.length < 1)
                    return userName;

                return oSplit[0];
            }

            function EB_IsIncorrectDetails() {
                var oIncorrectDetails = objWindow.document.getElementById("mc");
                if (oIncorrectDetails != null) {
                    if (oIncorrectDetails.firstChild) {
                        var text = oIncorrectDetails.firstChild.innerText;
                        if (text == "The e-mail address you entered does not exist in our system.") {
                            return true;
                        }

                        if (text == "The password you entered is not correct. Did you forget your password, or are you not sure you are entering a valid password?") {
                            return true;
                        }
                    }
                }
                return false;
            }

            function EB_GetLoginForm() {
                var elementCollection = objWindow.document.getElementsByTagName("FORM");
                var names;
                for (var i = 0; i < elementCollection.length; i++) {
                    var varAttribute = elementCollection[i].getAttribute("name");
                    if (varAttribute && (varAttribute == "MainForm"))
                        return elementCollection[i];
                }
                return null;
            }
            //**************

            if (EB_IsInPortalPage())
                return EB_HandlePortalPage(userName);

            var formElement = EB_GetLoginForm();
            if (formElement == null) {
                return 0;
            }


            var bIsIncorrectDetails = EB_IsIncorrectDetails();
            if (bIsIncorrectDetails == true)
                return -50; // Incorrect userName Or Password.

            try {
                var bUserNameOK = false;
                var bPasswordOK = false;
                var elementCollection = formElement.getElementsByTagName("INPUT");
                var bFirstRadioChecked = false;
                var oButtonSubmit = null;
                for (var i = 0; i < elementCollection.length; i++) {
                    var varName = elementCollection[i].getAttribute("name");

                    if (varName != null && varName != "undefined") {
                        if (varName == "email") {
                            elementCollection[i].value = userName;
                            bUserNameOK = true;
                        }
                        else if (varName == "password") {
                            elementCollection[i].value = password;
                            bPasswordOK = true;
                        }
                        else if (varName == "persistent") {
                            elementCollection[i].checked = false;
                        }
                        else if (varName == "submit") {
                            oButtonSubmit = elementCollection[i];
                        }
                    }
                }
                if (!bUserNameOK || !bPasswordOK)
                    return -10;

                if (oButtonSubmit) {
                    oButtonSubmit.click();
                }
                return 1;
            }
            catch (e) {
                return 0;
            }
            return 1;
        };

        //***********************************************************************************

        var strLogoutUrl = EBEmailAccountsConsts_CT2958529.Univision.MailLogoutURL;
        var strLoginUrl = EBEmailAccountsConsts_CT2958529.Univision.MailURL;
        var strUserName = this.MailAccount.EMail;
        var strPass = this.MailAccount.Password;
        var strUserNameFieldID = "username";
        var strPassFieldID = "password";
        var strSubmitID = "loginButton";
        var strFormName = "login";
        var strFrameName = null;
        if (bIsFromCheck) {
            var strBrowserID = EBComponentsConsts_CT2958529.EMailNotifierNewID;

            EBEmailNotifierManager_CT2958529.xulBrowser = EBXULFactory_CT2958529.CreateBrowser(strBrowserID, '', 0, 0);
            document.getElementById('mainBox').appendChild(EBEmailNotifierManager_CT2958529.xulBrowser);
        }

        var loginToUnivision = function() {
            var objData = new EBEMailNotifierManagerData_CT2958529();
            objData.callbackNewMessages = objCallBackFunction;
            objData.inboxCheckFunction = objCheckFunction;
            objData.logoutUrl = strLogoutUrl;
            objData.loginUrl = strLoginUrl;
            objData.username = strUserName;
            objData.password = strPass;
            objData.inputIDs.username = strUserNameFieldID;
            objData.inputIDs.password = strPassFieldID;
            objData.inputIDs.submit = strSubmitID;
            objData.formName = strFormName;
            objData.loginFunction = objLoginFunction;
            objData.inboxDomain = "mipagina.univision.com";
            objData.checkFrames = false;

            EBEmailNotifierManager_CT2958529.CheckForEmails(objData);
        };

        this._login(null, loginToUnivision);
    };

    this._GetPostData = function() {
        var strPostData = "email=" + strEmail;
        strPostData += "&password=" + strPassword;
        strPostData += "&loginErrorURL=/membershipservices/login.jhtml?partnerSystem=103818";
        strPostData += "&loginSuccessURL=/membershipservices/login.jhtml?partnerSystem=103818";
        strPostData += "&partnerSystem=103818";
        return strPostData;
    };

    this.InitAccount(strEmail, strPassword);
};

/********************* Yahoo Account ****************************/
function EBYahooAccount_CT2958529(strEMail, strPassword) {
    this.MailAccount = null;
    this.cancelLogin = false;
    var self = this;

    //Constructor
    this.InitAccount = function(strEMail, strPassword) {
        //initialize the email account object
        this.MailAccount = new EBEMailAccount_CT2958529(EBEmailAccountsConsts_CT2958529.Yahoo.MailURL, strEMail, strPassword);
    }

    this.Login = function(event) {
        //in yahoo you have to logout first before login
        //so i login after i log out using NavigationWithCallBack function

        //get the post data of the account
        var strPostData = this._GetYahooPostData();
        var strMailURL = this.MailAccount.MailURL;
        var oEvent = event;
        var bIsInNewTab = oEvent.button == 1;

        var objCallBackFunction = function() {
            if (!self.cancelLogin) {
                oEvent.customData = { "url": strMailURL, "urlTarget": bIsInNewTab ? "TAB" : "SELF", postParams: strPostData };
                EBLinkManager_CT2958529.LoadLinkURL(oEvent);
            }
            //remove self from logging in accounts
            EBEMailNotifierManager_CT2958529.loginAccounts.Remove(strEMail);
        };

        //logout before navigating to the account
        this.DeleteSessionCookies();
        EBWeb_CT2958529.NavigationWithCallBack(EBEmailAccountsConsts_CT2958529.Yahoo.MailLogoutURL, objCallBackFunction);
    };

    this.Logout = function(event) {
        var strLogoutURL = EBEmailAccountsConsts_CT2958529.Yahoo.MailLogoutURL;
        var strLoginURL = EBEmailAccountsConsts_CT2958529.Yahoo.MailURL;
        event.customData = { "url": strLogoutURL };
        EBLinkManager_CT2958529.LoadLinkURL(event);
        event.customData = { "url": strLoginURL };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    };

    this.DeleteSessionCookies = function() {
        var oCookieManager = Components.classes["@mozilla.org/cookieService;1"].
                  getService(Components.interfaces.nsICookieManager);

        oCookieManager.remove('.yahoo.com', 'YGCV', '/', false);
        oCookieManager.remove('.mail.yahoo.com', 'YM.Gen', '/', false);
    };

    this.GetNewMessagesCount = function(objCallBackFunction) {
        var strPostData = this._GetYahooPostData();
        var strMailURL = this.MailAccount.MailURL;
        var strEMail = this.MailAccount.EMail;

        var iNewMessages = null;

        //check if there an open window on yahoo mail and check to retrive the 
        //new messages from this window using it html document
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            var objTabBrowser = objWindow.document.getElementById('content');
            var objTab = null;
            for (var i = 0; i < objTabBrowser.browsers.length; i++) {
                objTab = objTabBrowser.browsers[i];
                var objTabDocument = objTab.contentWindow.document;
                var strLocationURL = objTabDocument.location.href;

                if (strLocationURL.toLowerCase().indexOf(EBEmailAccountsConsts_CT2958529.Yahoo.CheckLoginInURL) != -1) {

                    iNewMessages = EBEmailAccountsConsts_CT2958529.LOGIN_ANOTHER_ACCOUNT;

                    objCallBackFunction(iNewMessages);
                    return;
                }
            }
        }

        //if there isn't any page open in this account - i check it in the regular way
        //perform logout and then login to the account
        var objServerResponseFunction = function(strData, objRequest) {
            iNewMessages = EBEmailAccountsConsts_CT2958529.LOGIN_FAILED;
            //check classic first, if failed, check beta
            //find the new messages using regular expression on the page
            var arrResults = strData.match(/\<a\s+.*\>\s*Inbox\s*\D*\(\s*(\d+)\s*\)\s*\D*\<\/a\>/i);
            if (arrResults && arrResults.length > 1) {
                var strInbox = arrResults[1];
                var iInbox = parseInt(strInbox);
                if (!isNaN(iInbox))
                    iNewMessages = iInbox;

                objCallBackFunction(iNewMessages);
            }
            else
                EBYahooBetaAccountManager_CT2958529.CheckFromWebService(strData, objCallBackFunction);
        };

        var objLogoutWithCallBackFunction = function() {
            EBServerDataURL_CT2958529.ServerRequest(strMailURL,
										strPostData,
										null,
										null,
										objServerResponseFunction);
        };


        this.DeleteSessionCookies();
        EBWeb_CT2958529.NavigationWithCallBack(EBEmailAccountsConsts_CT2958529.Yahoo.MailLogoutURL, objLogoutWithCallBackFunction);
    };

    this._GetYahooPostData = function() {
        var strPostData = '.tries=1&.intl=us&.v=0&hasMsgr=0&.chkP=Y&.done=http://mail.yahoo.com&.persistent=Y&login=' + this.MailAccount.UserName + '&passwd=' + this.MailAccount.Password;
        return strPostData;
    };

    this.InitAccount(strEMail, strPassword);

};

var EBYahooBetaAccountManager_CT2958529 =
{
    CheckFromWebService: function(strSource, objCallBackFunction) {
        var iNewMessages = EBEmailAccountsConsts_CT2958529.LOGIN_FAILED;
        var xmlSoap = this.GetSoapXML(strSource);
        var xmlNode = null;
        for (var i = 0; i < xmlSoap.childNodes.length; i++) {
            xmlNode = xmlSoap.childNodes[i];
            if (EBXML_CT2958529.GetStringXml(xmlNode).toLowerCase().indexOf(name = "inbox") != -1) {
                break;
            }
        }

        var strInbox = xmlNode.getAttribute("unread");
        if (strInbox) {
            var iInbox = parseInt(strInbox);
            if (!isNaN(iInbox))
                iNewMessages = iInbox;
        }

        objCallBackFunction(iNewMessages);
    },

    GetSoapXML: function(strSource) {
        var iStart = strSource.indexOf("<ListFoldersResponse>");
        var iEnd = strSource.indexOf("</ListFoldersResponse>");
        var strXml = strSource.substring(iStart, iEnd + 22);
        var xmlDoc = EBXML_CT2958529.GetXmlDocument(strXml);
        return xmlDoc.documentElement;
    }
};
//consts Class:
var EBEmailAccountsConsts_CT2958529 =
{
    LOGIN_FAILED: -1,
    LOGIN_ANOTHER_ACCOUNT: -2,

    CheckURL: 'http://www.conduit.com',

    DomainCaptionDelimiter: '/',

    GMail:
	{
	    MailURL: 'https://www.google.com/accounts/ServiceLoginAuth',
	    MailURLnoAuth: 'https://www.google.com/accounts/ServiceLogin',
	    MailLogoutURL: 'https://mail.google.com/mail/?logout&hl=en',
	    EMailDomain: ['@gmail.com', '@googlemail.com'],
	    EMailDomainCaption: ['.com'],
	    FeedURL: 'https://gmail.google.com/gmail/feed/atom',
	    AccountName: 'Gmail'
	},

    Yahoo:
	{
	    MailURL: 'http://login.yahoo.com/config/login',
	    MailLogoutURL: 'http://login.yahoo.com/config/login?logout=1',
	    EMailDomain: ['@yahoo.com', '@yahoo.co.uk', '@yahoo.com.au', '@yahoo.ca'],
	    EMailDomainCaption: ['.com', '.co.uk', '.com.au', '.ca'],
	    AccountName: 'Yahoo',
	    CheckLoginInURL: '.mail.yahoo.'
	},

    Hotmail:
	{
	    MailURL: 'http://www.hotmail.com/',
	    MailLogoutURL: 'http://login.live.com/logout.srf',
	    EMailDomain: ['@hotmail.com', '@hotmail.co.uk', '@msn.com', '@msn.co.uk'],
	    EMailDomainCaption: ['.com', '.co.uk'],
	    AccountName: 'Hotmail',
	    URL: 'http://login.live.com/login.srf?id=2',
	    CheckLoginInURL: ['.hotmail.msn.', '.mail.live.'],
	    ReloadPage : "http://sn122w.snt122.mail.live.com/default.aspx"
	},

    Pop3:
	{
	    AccountName: 'POP3',
	    StateStart: 0,
	    StateUserName: 1,
	    StatePassword: 2,
	    StateStatus: 3,
	    StateQuit: 4,
	    DefaultPort: 110,
	    CommandOKPrefix: '+OK',
	    CommandERRPrefix: '-ERR'
	},

    RR:
	{
	    MailURL: 'https://webmail.roadrunner.com',
	    MailLogoutURL: 'http://webmail.roadrunner.com/do/logout?l=en-US&v=standard',
	    EMailDomain: ['@rr.com'],
	    EMailDomainCaption: ['.com'],
	    AccountName: 'RR',
	    URL: 'https://webmail.roadrunner.com',
	    CheckLoginInURL: ['webmail.roadrunner.'],
	    POP3ServerUrlPattern: 'pop-server.{0}'
	},

	AOL:
	{
	    MailURL: 'http://webmail.aol.com',
	    MailLogoutURL: 'http://my.screenname.aol.com/_cqr/logout/mcLogout.psp',
	    EMailDomain: ['@aol.com'],
	    EMailDomainCaption: ['aol.com'],
	    AccountName: 'AOL',
	    URL: 'https://my.screenname.aol.com/_cqr/login/login.psp',
	    CheckLoginInURL: ['webmail.aol.']
	},

	Univision:
	{
	    MailURL: 'http://www.univision.com/membershipservices/login.jhtml?partnerSystem=103818&locale=En',
	    MailLogoutURL: 'http://www.univision.com/membershipservices/logoutmipagina.jhtml',
	    EMailDomain: ['@univision.com','@univision.rd.ibm.outblaze.com' ],
	    EMailDomainCaption: ['univision.com'],
	    AccountName: 'Univision',
	    URL: 'http://playr-univision.rd.ibm.outblaze.com/mail/mail/listing/INBOX',
	    CheckLoginInURL: ['micorreo.univision.com']
	}
};

var EBEmailAccountsTypes_CT2958529 =
{
    GMail: 1,
    Yahoo: 2,
    Hotmail: 3,
    Pop3: 4,
    RR: 5,
    AOL: 6,
    Univision: 7
};


//the base class of the email notifier hierarchy
function EBEMailAccount_CT2958529(strMailURL, strEMail, strPassword) {
    this.EMail = strEMail;
    this.Password = strPassword;
    this.MailURL = strMailURL;

    this.UserName = '';

    this.Init = function() {
        this.UserName = EBEMailNotifierManager_CT2958529.GetUserNameByEMail(this.EMail);
    }

    this.Init();
};

function EBEMailNotifierManagerData_CT2958529() {
    this.callbackNewMessages = null;
    this.inboxCheckFunction = null;
    this.loginFunction = null;
    this.logoutUrl = "";
    this.loginUrl = "";
    this.username = "";
    this.password = "";
    this.inputIDs = {
        "username": null,
        "password": null,
        "submit": null
    };
    this.formName = "";
    this.frameName = "";
    this.checkFrames = true;
    this.inboxDomain = "";
};
var EmailWebListener_CT2958529 =
{
    QueryInterface: function(aIID) {
        if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
       aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
       aIID.equals(Components.interfaces.nsISupports))
            return this;
        throw Components.results.NS_NOINTERFACE;
    },

    onStateChange: function(aProgress, aRequest, aFlag, aStatus) {
        //get the url
        var strUrl = aRequest.name;
        
        if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP)
            EBEmailNotifierManager_CT2958529.DocumentComplete(aProgress, aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT);
        
        return 0;
    },

    onLocationChange: function(aProgress, aRequest, aURI) {
        // This fires when the location bar changes i.e load event is confirmed
        // or when the user switches tabs
        return 0;
    },

    // For definitions of the remaining functions see XulPlanet.com
    onProgressChange: function() { return 0; },
    onStatusChange: function() { return 0; },
    onSecurityChange: function() { return 0; },
    onLinkIconAvailable: function() { return 0; }
};
var EBEMailNotifierConsts_CT2958529 =
{
    EMailNotifierDirectory: 'emailnotifier',

    EMailNotifierAccountsFileName: 'acc',

    EncryptionPass: 'EBEMailNotifierAcc',

    DefaultIntervalMinutes: 5,

    Images:
	{
	    V_Image: 'chrome://browsersearch/skin/v.png',
	    X_Image: 'chrome://browsersearch/skin/x.png',
	    BlankImage: 'chrome://browsersearch/skin/blank.png',
	    EMailImage: 'chrome://browsersearch/skin/email.png',
	    EMailNewImage: 'chrome://browsersearch/skin/emailnew.png',
	    EMailNewSmallImage: 'chrome://browsersearch/skin/emailnewsmall.png',
	    StarImage: 'chrome://browsersearch/skin/star.png',
	    WarningImage: 'chrome://browsersearch/skin/warning.png'
	},

    XML:
	{
	    ACCOUNTS: 'ACCOUNTS',
	    ACCOUNT: 'ACCOUNT',
	    NAME: 'NAME',
	    EMAIL: 'EMAIL',
	    PASSWORD: 'PASSWORD',
	    SERVER: 'SERVER',
	    PORT: 'PORT',
	    TYPE: 'TYPE',
	    AUTO_LOGIN: 'AUTO_LOGIN',
	    STARED: 'STARED',
	    NEW_MESSAGES: 'NEW_MESSAGES'
	},

    Attributes:
	{
	    MAIL_ACCOUNT: 'EB_ATTRIBUTE_MAIL_ACCOUNT',
	    MAIL_ACCOUNT_VALUE: 'EB_ATTRIBUTE_MAIL_ACCOUNT_VALUE',
	    CHECK_NEW_EMAIL_INTERVAL: 'EB_ATTRIBUTE_CHECK_NEW_EMAIL_INTERVAL',
	    SOUND: 'EB_ATTRIBUTE_SOUND',
	    STARED_ICON_URL: 'EB_ATTRIBUTE_STARED_ICON_URL',
	    STARED_TOOLTIP: 'EB_ATTRIBUTE_STARED_TOOLTIP',
	    DEFAULT_TOOLTIP: 'EB_ATTRIBUTE_DEFAULT_TOOLTIP',
	    DEFAULT_CAPTION: 'EB_ATTRIBUTE_DEFAULT_CAPTION',
	    EMAIL: 'EB_ATTRIBUTE_EMAIL',
	    PASSWORD: 'EB_ATTRIBUTE_PASSWORD',
	    ACCOUNT_TYPE: 'EB_ATTRIBUTE_ACCOUNT_TYPE',
	    AUTO_LOGIN: 'EB_ATTRIBUTE_AUTO_LOGIN',
	    POP3_SERVER: 'EB_ATTRIBUTE_POP3_SERVER',
	    POP3_PORT: 'EB_ATTRIBUTE_POP3_PORT',
	    TOTAL_NEW_MESSAGES: 'EB_ATTRIBUTE_TOTAL_NEW_MESSAGES'
	},

    Sound:
	{
	    DefaultWavChromePath: 'chrome://browsersearch/skin/enSound.wav',

	    NONE: 'NONE',
	    DEFAULT: 'DEFAULT'
	}
};
var EBEMailNotifierDialogsConsts_CT2958529 = 
{	
	WindowTypeAttributeName		: 'EBEMailNotifierDialogs_CT2958529',
	
	XULDialogsDirectoryName		: 'EMailNotifierDialogs',
	
	SettingsDialog				:	 
	{
		FileName					: 'enSettings.xul',
		Name						: 'EBEmailNotifierXULSettingsDialogName_CT2958529',
		SupportSubjectCaption		: 'E-mail Notifier Feedback [Firefox]',
		TreeCellPasswordAttribute	: 'TreeCellPasswordAttribute',
		TreeCellTypeAttribute		: 'TreeCellTypeAttribute',
		TreeCellAutoLoginAttribute	: 'TreeCellAutoLoginAttribute',
		TreeCellServerAttribute		: 'TreeCellServerAttribute'
	},
	
	AddEditDialog				:
	{
		FileName					: 'enAddEdit.xul',
		Name						: 'EBEmailNotifierXULAddEditDialogName_CT2958529',
		ModeAdd						: 'ADD',
		ModeEdit					: 'EDIT'
	},
	
	ConfirmDialog				: 
	{
		FileName					: 'enConfirm.xul',	
		Name						: 'EBEmailNotifierXULConfirmDialogName_CT2958529',
		MismatchErrorTitle			: 'Check e-mail password',
		MismatchErrorContent		: 'Incorrect password!\nPlease enter the password that you have defined in this account'
	},
	
	TestAccountDialog			:
	{
		FileName					: 'enTestAccount.xul',
		ID							: 'EBEmailNotifierXULTestAccountDialogID',
		Name						: 'EBEmailNotifierXULTestAccountDialogName_CT2958529',
		AccountNameAlias			: '{{ACCOUNT_NAME}}'
	}
}

//the default values of the dialogs captions
//if there is xml it will change for the languages support!
var EBEMailNotifierDialogsCaption_CT2958529 = 
{
	SettingsDialog		:
	{
		Yes						: 'Yes',
		No						: 'No'
	},
	
	
	AddEditDialog		:
	{
		EmailAddress						: 'E-mail Address:',
		Pop3EMailAddress					: 'User Name:',
		AutoLogin							: 'Auto Login (will not ask for password when logging into my account)',
		Pop3AutoLogin						: 'Open Default Mail Client',
		ErrorTitleAlertMsg					: 'Invalid E-mail address',
		ErrorMsgIncorrectEMailAddress		: 'The E-mail address you have entered appears to be incorrect',
		ErrorMsgEmailAlreadyExist			: 'You have already defined an account with that E-mail address',
		ErrorMsgPOP3AlreadyExist			: 'You have already defined that account',
		ErrorMsgEmailAddressNotSupported	: 'The E-mail address is not supported. We currently support Hotmail (.com/.co.uk), Gmail, and Yahoo(.com/.co.uk/.com.au/.ca).',
		ErrorMsgEmailTypeIncorrect			: 'The E-mail address and the account type do not match.'
		
	},
	
	TestAccountDialog	:
	{
		TasksSuccessFinishMsg		: 'Mail account tested successfully',
		TasksFailureFinishMsg		: 'Failed testing mail account',
		TasksSuccess				: 'Completed',
		TasksFailure				: 'Failed',
		TaskSuccessDone             : 'Done',
		ButtonOK					: 'OK',
		TestWarningMsg1				: 'Please logout of all your ' + EBEMailNotifierDialogsConsts_CT2958529.TestAccountDialog.AccountNameAlias + ' accounts before testing your account settings.'
	}
	
}



var EBEMailNotifierDialogsManager_CT2958529 = 
{
	GetDialogWindow : function(strWindowName)
	{
		var strWindowType = EBEMailNotifierDialogsConsts_CT2958529.WindowTypeAttributeName;
        return EBGlobalManager_CT2958529.GetXULWindowByTypeAndName(strWindowType,strWindowName);
	},
	
		
	OpenSettingsDialog : function(objParentWindow, isFromToolbarOptions, strCompType)
	{
		//check if one of the email notifier windows is open to make the focus on it
		var objSettingsWindow		= this.GetDialogWindow(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.Name);
		var objAddEditWindow		= this.GetDialogWindow(EBEMailNotifierDialogsConsts_CT2958529.AddEditDialog.Name);
		var objTestAccountWindow	= this.GetDialogWindow(EBEMailNotifierDialogsConsts_CT2958529.TestAccountDialog.Name);
		var objConfirmWindow		= this.GetDialogWindow(EBEMailNotifierDialogsConsts_CT2958529.ConfirmDialog.Name);
		
		
		//check if the dialogs already open in a different browser to set 
		//focus on them - the order is important! of course (from the last dialog shown to the first)
		if(objTestAccountWindow)
			objTestAccountWindow.focus();
		else if(objConfirmWindow)
			objConfirmWindow.focus();
		else if(objAddEditWindow)
			objAddEditWindow.focus();
		else if(objSettingsWindow)
			objSettingsWindow.focus();
		else
		{
			var strXULSettingsDialogChromePath	= EBGlobalConsts_CT2958529.ChromeContentPath + EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.FileName;
			
			//adding the EBEMailNotifierDialogsXULEvents as a window argument 
			//and retrieving it from the code inside the xul window using window.arguments[iIndex]
			EBGlobalManager_CT2958529.OpenDialog(strXULSettingsDialogChromePath,
											EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.Name,
											'modal,centerscreen,chrome,resizable=no',
											isFromToolbarOptions, strCompType);
		}
	},
	
	OpenAddEditDialog : function(oSettingsWindow,strMode,objAccountData)
	{
		if(oSettingsWindow)
		{
			var strXULAddEditDialogChromePath	= EBGlobalConsts_CT2958529.ChromeContentPath + EBEMailNotifierDialogsConsts_CT2958529.AddEditDialog.FileName;
			
			oSettingsWindow.openDialog(strXULAddEditDialogChromePath,
										EBEMailNotifierDialogsConsts_CT2958529.AddEditDialog.Name,
										'modal,centerscreen,chrome,resizable=no',
										strMode,
										objAccountData);
		}
		
	},
	
	OpenConfirmDialog : function(oAddEditWindow,oAccountData)
	{
		if(oAddEditWindow)
		{
			var strXULConfirmDialogChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + EBEMailNotifierDialogsConsts_CT2958529.ConfirmDialog.FileName;
			
			oAddEditWindow.openDialog(strXULConfirmDialogChromePath,
										EBEMailNotifierDialogsConsts_CT2958529.ConfirmDialog.Name,
										'modal,centerscreen,chrome,resizable=no',
										oAccountData,
										oAddEditWindow.document);
		}
		
	},
	
	OpenTestAccountDialog : function(oAddEditWindow)
	{
		if(oAddEditWindow)
		{	
			var strXULTestAccountDialogChromePath	= EBGlobalConsts_CT2958529.ChromeContentPath + EBEMailNotifierDialogsConsts_CT2958529.TestAccountDialog.FileName;
			
			oAddEditWindow.openDialog(strXULTestAccountDialogChromePath,
										EBEMailNotifierDialogsConsts_CT2958529.TestAccountDialog.Name,
										'modal,centerscreen,chrome,resizable=no',
										oAddEditWindow.document);
		}

	}
};

var EBEMailNotifierDialogsXULEvents_CT2958529 =
{
    OnLoadSettingsDialog: function(event) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var dialogsDirection = objWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "EBEmailNotifierXULSettingsDialogID");

        EmailNotifierLanguagePack_CT2958529.SettingsDialog();

        //set the global accounts object
        window.m_oDialogsMailAccountsCollection = new EBArrayCollection_CT2958529();

        //loads the accounts from the file and set the xul tree according it
        //take them from the browser window(this window is the window of the xul dialog so the 
        //EBEMailNotifierToolbarManager_CT2958529.MailAccountsCollection is not define in this scope!!
        var oBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var objMailAccountsCollection = oBrowserWindow.EBEMailNotifierToolbarManager_CT2958529.MailAccountsCollection;

        if (objMailAccountsCollection) {
            var arrAccounts = objMailAccountsCollection.Arr;

            var objAccountData = null;

            for (var i = 0; i < arrAccounts.length; i++) {
                objAccountData = arrAccounts[i];

                this.AddMailAccountTreeItem(objAccountData, false);
            }
        }


        //check if it's open from toolbar options to disable the toolbar option button:
        var isFromToolbarOptions = null;

        try {
            isFromToolbarOptions = window.arguments[0];
        }
        catch (ex) {
            isFromToolbarOptions = false;
        }

        if (isFromToolbarOptions || (window.opener && window.opener.isAIOMode_CT2958529))
            document.getElementById('btnToolbarOptions').disabled = true;

        //set the check event to the sound checkbox
        var objCheckBoxPlaySound = document.getElementById('checkPlaySound');
        //add event to the checkbox
        objCheckBoxPlaySound.addEventListener("CheckboxStateChange",
										EBEMailNotifierDialogsXULEvents_CT2958529.OnCheckBoxSettingsPlaySoundChange,
										false);


        //set the check interval according to the save value from pref
        this.SetCheckIntervalSelection();
        //set the sound xul elements according to the saved sound (in the prefs)
        this.SetSoundSelection();
    },

    OnCheckBoxSettingsPlaySoundChange: function(event) {
        var objCheckBoxPlaySound = document.getElementById('checkPlaySound');
        var objRadioGroupSound = document.getElementById('radioGroupSound');

        var bCheck = objCheckBoxPlaySound.checked;


        var objButtonSoundChooseFile = document.getElementById('btnSoundChooseFile');
        var objButtonSoundPlay = document.getElementById('btnSoundPlay');
        var objTextBoxSoundFilePath = document.getElementById('txtSoundFilePath');

        objRadioGroupSound.disabled = !bCheck;
        objButtonSoundChooseFile.disabled = !bCheck;
        objButtonSoundPlay.disabled = !bCheck;
        objTextBoxSoundFilePath.disabled = !bCheck;

    },

    OnCommandSettingsChooseSoundFile: function(event) {
        var objRadioGroupSound = document.getElementById('radioGroupSound');
        var objRadioSoundChoose = document.getElementById('radSoundChoose');

        var objTextBoxSoundFilePath = document.getElementById('txtSoundFilePath');

        var nsIFilePicker = Components.interfaces.nsIFilePicker;
        var objFilePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        objFilePicker.init(window, "Select a File", nsIFilePicker.modeOpen);
        objFilePicker.appendFilter("Wav Files (*.wav)", "*.wav");

        //set the display dir path to what he chose
        //and if he doesn't so to the windows xp media path as the default path:
        var strDisplayDir = objTextBoxSoundFilePath.value;
        if (!strDisplayDir) {
            strDisplayDir = EBWindows_CT2958529.GetWindowsMediaPath();
        }
        var objDisplayDir = EBDirIO_CT2958529.open(strDisplayDir);
        if (objDisplayDir) {
            objFilePicker.displayDirectory = objDisplayDir;
        }

        var iResult = objFilePicker.show();
        if (iResult == nsIFilePicker.returnOK) {
            objRadioGroupSound.selectedItem = objRadioSoundChoose;
            var strPath = objFilePicker.file.path;

            objTextBoxSoundFilePath.value = strPath;
        }
    },

    OnCommandSettingsPlaySoundFile: function(event) {
        var objRadioGroupSound = document.getElementById('radioGroupSound');
        var objRadioSoundChoose = document.getElementById('radSoundChoose');
        var objRadioSoundDefault = document.getElementById('radSoundUseDefault');

        var strFilePath = '';
        if (objRadioGroupSound.selectedItem == objRadioSoundChoose) {
            strFilePath = document.getElementById('txtSoundFilePath').value;
        }
        else if (objRadioGroupSound.selectedItem == objRadioSoundDefault) {
            strFilePath = EBEMailNotifierConsts_CT2958529.Sound.DefaultWavChromePath;
        }

        if (strFilePath) {
            EBGlobalManager_CT2958529.PlaySound(strFilePath);
        }
    },



    OnUnLoadSettingsDialog: function(event) {
        window.m_oDialogsMailAccountsCollection = null;

        //usage
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        objWindow.EBUsageEmailNotifier_CT2958529.OnMenuClose(window.arguments[0]);
    },

    OnCommandSettingsOKButton: function() {
        try {
            this.SaveCheckIntervalSelection();
            this.SaveSoundSelection();
            var oBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
            oBrowserWindow.EBEMailNotifierToolbarManager_CT2958529.OnCommandSettingsOKButton(window.m_oDialogsMailAccountsCollection);
        }
        catch (ex) { }
    },

    SetCheckIntervalSelection: function() {
        //get value from pref
        var iMinutesFromPref = EBEMailNotifierToolbarManager_CT2958529.GetCheckIntervalPref();
        if (!iMinutesFromPref || !isFinite(iMinutesFromPref)) {
            // set default to 5 minutes
            iMinutesFromPref = 5;
        }

        var oComboInterval = document.getElementById('cmbCheckInterval');
        var oPopupMenu = oComboInterval.firstChild;

        var oMenuItem = null;
        for (var i = 0; i < oPopupMenu.childNodes.length; i++) {
            oMenuItem = oPopupMenu.childNodes[i];
            if (oMenuItem.getAttribute('label') == iMinutesFromPref) {
                oComboInterval.selectedItem = oMenuItem;
                break;
            }
        }
    },

    SetSoundSelection: function() {
        var objCheckBoxPlaySound = document.getElementById('checkPlaySound');

        var objRadioGroupSound = document.getElementById('radioGroupSound');
        var objRadioSoundChoose = document.getElementById('radSoundChoose');
        var objRadioSoundDefault = document.getElementById('radSoundUseDefault');
        var objTextBoxSoundFilePath = document.getElementById('txtSoundFilePath');

        var strSound = EBEMailNotifierToolbarManager_CT2958529.GetSoundPref();

        if (strSound != EBEMailNotifierConsts_CT2958529.Sound.NONE) {
            objCheckBoxPlaySound.checked = true;
            if (!strSound || strSound == EBEMailNotifierConsts_CT2958529.Sound.DEFAULT) {
                objRadioGroupSound.selectedItem = objRadioSoundDefault;
            }
            else {
                objTextBoxSoundFilePath.value = strSound;
                objRadioGroupSound.selectedItem = objRadioSoundChoose;
            }
        }
        else {
            objCheckBoxPlaySound.checked = false;
        }


    },

    SaveCheckIntervalSelection: function() {
        var oComboInterval = document.getElementById('cmbCheckInterval');

        var oSelectedMenuItem = oComboInterval.selectedItem;
        var iMinutesValue = oSelectedMenuItem.getAttribute('label');

        EBEMailNotifierToolbarManager_CT2958529.SaveCheckIntervalPref(iMinutesValue);
    },

    //save the sound 
    SaveSoundSelection: function() {

        var objCheckBoxPlaySound = document.getElementById('checkPlaySound');

        var objRadioGroupSound = document.getElementById('radioGroupSound');
        var objRadioSoundChoose = document.getElementById('radSoundChoose');
        var objRadioSoundDefault = document.getElementById('radSoundUseDefault');
        var objTextBoxSoundFilePath = document.getElementById('txtSoundFilePath');

        var strSound = '';

        if (objCheckBoxPlaySound.checked) {
            var strTxtFilePathValue = objTextBoxSoundFilePath.value;
            if (objRadioGroupSound.selectedItem == objRadioSoundDefault || !strTxtFilePathValue) {
                strSound = EBEMailNotifierConsts_CT2958529.Sound.DEFAULT;
            }
            else if (objRadioGroupSound.selectedItem == objRadioSoundChoose) {
                strSound = strTxtFilePathValue;
            }
        }
        else {
            strSound = EBEMailNotifierConsts_CT2958529.Sound.NONE;
        }


        EBEMailNotifierToolbarManager_CT2958529.SaveSoundPref(strSound);
    },



    AccountDataObjectToTreeRow: function(objSettingsDocument, objAccountData) {
        var strAccountName = objAccountData.AccountName;
        var strEMailAddress = objAccountData.EMailAddress;
        var strPassword = objAccountData.Password;
        var iAccountType = objAccountData.AccountType;
        var isAutoLogin = objAccountData.AutoLogin;
        var strPop3Server = objAccountData.Pop3Server;

        var objTreeRow = objSettingsDocument.createElement('treerow');

        var objTreeCellAccountName = objSettingsDocument.createElement('treecell');
        objTreeCellAccountName.setAttribute('label', strAccountName);

        var objTreeCellEMailAddress = objSettingsDocument.createElement('treecell');
        objTreeCellEMailAddress.setAttribute('label', strEMailAddress);
        //save the password in the email treecell as an attribute
        objTreeCellEMailAddress.setAttribute(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.TreeCellPasswordAttribute, strPassword);
        //save the pop3 server url as an attribute
        objTreeCellEMailAddress.setAttribute(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.TreeCellServerAttribute, strPop3Server);


        var strAccountType = EBEMailNotifierManager_CT2958529.GetAccountNameByType(iAccountType);
        var objTreeCellAccountType = objSettingsDocument.createElement('treecell');
        objTreeCellAccountType.setAttribute('label', strAccountType);
        //save the actual type in an attribute for retrieving it.
        objTreeCellAccountType.setAttribute(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.TreeCellTypeAttribute, iAccountType);


        var strAutoLogin = isAutoLogin ? EBEMailNotifierDialogsCaption_CT2958529.SettingsDialog.Yes : EBEMailNotifierDialogsCaption_CT2958529.SettingsDialog.No;
        var objTreeCellAutoLogin = objSettingsDocument.createElement('treecell');
        objTreeCellAutoLogin.setAttribute('label', strAutoLogin);
        //save the actual auto login value in an attribute for retrieving it.
        objTreeCellAutoLogin.setAttribute(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.TreeCellAutoLoginAttribute, isAutoLogin);

        //build the dom elements
        objTreeRow.appendChild(objTreeCellAccountName);
        objTreeRow.appendChild(objTreeCellEMailAddress);
        objTreeRow.appendChild(objTreeCellAccountType);
        objTreeRow.appendChild(objTreeCellAutoLogin);

        return objTreeRow;
    },

    OnSelectSettingsMailAccountsTree: function(event) {
        this.SetSettingsEditDeleteButtonsDisabled(false);
    },

    OnDoubleClickSettingsMailAccountsTree: function(event) {
        //this is how you illustrate double click on a tree row element:
        var objTreeMailAccounts = document.getElementById('treeMailAccounts');
        var iIndex = objTreeMailAccounts.treeBoxObject.getRowAt(event.clientX, event.clientY);

        if (iIndex > -1) {
            var objAccountDataToEdit = window.m_oDialogsMailAccountsCollection.GetItem(iIndex);

            EBEMailNotifierDialogsManager_CT2958529.OpenAddEditDialog(window, EBEMailNotifierDialogsConsts_CT2958529.AddEditDialog.ModeEdit,
																	objAccountDataToEdit);
        }
    },

    SetSettingsEditDeleteButtonsDisabled: function(isDisabled) {
        var objEditButton = document.getElementById('btnEdit');
        var objEditDelete = document.getElementById('btnDelete');
        objEditButton.disabled = isDisabled;
        objEditDelete.disabled = isDisabled;
    },

    OnCommandSettingsToolbarOptionsButton: function(event) {
        //get this with the most recent browser window cause this function 
        //is not in the email notifier scope
        var oRecentBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        //Usage
        oRecentBrowserWindow.EBUsageEmailNotifier_CT2958529.OnClickToolbarOptions();

        //Open dialog
        oRecentBrowserWindow.EBToolbarOptionsStaticDialogManager_CT2958529.OpenDialog(window, true);
    },

    OnCommandSettingsAddButton: function(event) {
        EBEMailNotifierDialogsManager_CT2958529.OpenAddEditDialog(window, EBEMailNotifierDialogsConsts_CT2958529.AddEditDialog.ModeAdd, null);
    },

    OnCommandSettingsEditButton: function(event) {
        var objTreeMailAccounts = document.getElementById('treeMailAccounts');
        var iIndex = objTreeMailAccounts.currentIndex;
        var objAccountDataToEdit = window.m_oDialogsMailAccountsCollection.GetItem(iIndex);

        EBEMailNotifierDialogsManager_CT2958529.OpenAddEditDialog(window, EBEMailNotifierDialogsConsts_CT2958529.AddEditDialog.ModeEdit,
																	objAccountDataToEdit);
    },

    OnCommandSettingsDeleteButton: function(event) {
        var objTreeMailAccounts = document.getElementById('treeMailAccounts');
        var objTreeItemToDelete = this.GetSelectedTreeItem(objTreeMailAccounts);

        if (objTreeItemToDelete) {
            var iDeleteItemIndex = objTreeMailAccounts.currentIndex;
            var objTreeChildrenParent = objTreeItemToDelete.parentNode;
            objTreeChildrenParent.removeChild(objTreeItemToDelete);

            //delete it from the data object:
            window.m_oDialogsMailAccountsCollection.RemoveElement(iDeleteItemIndex);

            var iIndexToSelect = -1;

            if (iDeleteItemIndex > 0)//check to select the previous element:
            {
                iIndexToSelect = iDeleteItemIndex - 1;
            }
            else if (objTreeChildrenParent.childNodes.length > 0)//check to select the next element
            {
                iIndexToSelect = iDeleteItemIndex;
            }

            if (iIndexToSelect != -1)//select the treeItem
            {
                var objPrevElementTreeItem = objTreeChildrenParent.childNodes[iIndexToSelect];
                this.SelectTreeItem(objPrevElementTreeItem);
            }
            else //if there isn't any elements left i disable the add-edit buttons
            {
                this.SetSettingsEditDeleteButtonsDisabled(true);
            }



        }
    },

    GetSelectedTreeItem: function(objTree) {
        var objTreeItem = null;
        var iIndex = objTree.currentIndex;
        if (iIndex != -1) {
            objTreeItem = objTree.contentView.getItemAtIndex(iIndex);
        }
        return objTreeItem;
    },

    OnLoadAddEditDialog: function(event) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var dialogsDirection = objWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "EBEmailNotifierXULAddEditDialogID");

        EmailNotifierLanguagePack_CT2958529.AddEditDialog();
        var objEMailTextBox = document.getElementById('txtEMail');

        var objRadioGroupEMails = document.getElementById('radioGroupEMails');
        var objRadioHotmail = document.getElementById('radHotmail');
        var objRadioYahoo = document.getElementById('radYahoo');
        var objRadioGmail = document.getElementById('radGMail');
        var objRadioRR = document.getElementById('radRR');
        var objRadioAOL = document.getElementById('radAOL');
        var objRadioUnivision = document.getElementById('radUnivision');
        var objRadioPop3 = document.getElementById('radPop3');

        if (MODE == EBEMailNotifierDialogsConsts_CT2958529.AddEditDialog.ModeEdit) {
            var objPasswordTextBox = document.getElementById('txtPassword');
            var objAccountNameTextBox = document.getElementById('txtAccountName');
            var objTextBoxPop3MailServer = document.getElementById('txtPop3MailServer');
            var objTextBoxPop3Port = document.getElementById('txtPop3Port');

            var objAutoLoginCheckBox = document.getElementById('checkAutoLogin');
            var objButtonTestAccount = document.getElementById('btnTestAccount');
            var objButtonOK = document.getElementById('btnOK');

            //set the values
            objEMailTextBox.value = m_oAccountData.EMailAddress;
            objPasswordTextBox.value = m_oAccountData.Password;
            objAccountNameTextBox.value = m_oAccountData.AccountName;

            //check account type
            if (m_oAccountData.AccountType == EBEmailAccountsTypes_CT2958529.GMail)
                objRadioGroupEMails.selectedItem = objRadioGmail;
            else if (m_oAccountData.AccountType == EBEmailAccountsTypes_CT2958529.Yahoo)
                objRadioGroupEMails.selectedItem = objRadioYahoo;
            else if (m_oAccountData.AccountType == EBEmailAccountsTypes_CT2958529.Hotmail)
                objRadioGroupEMails.selectedItem = objRadioHotmail;
            else if (m_oAccountData.AccountType == EBEmailAccountsTypes_CT2958529.RR)
                objRadioGroupEMails.selectedItem = objRadioRR;
            else if (m_oAccountData.AccountType == EBEmailAccountsTypes_CT2958529.AOL)
                objRadioGroupEMails.selectedItem = objRadioAOL;
            else if (m_oAccountData.AccountType == EBEmailAccountsTypes_CT2958529.Univision)
                objRadioGroupEMails.selectedItem = objRadioUnivision;
            else if (m_oAccountData.AccountType == EBEmailAccountsTypes_CT2958529.Pop3) {
                objRadioGroupEMails.selectedItem = objRadioPop3;
                objTextBoxPop3MailServer.value = m_oAccountData.Pop3Server;

                var iPort = EBEmailAccountsConsts_CT2958529.Pop3.DefaultPort;
                var iPortFromObject = m_oAccountData.Pop3Port;
                if (iPortFromObject) {
                    iPort = iPortFromObject;
                }
                objTextBoxPop3Port.value = iPort;
            }

            objAutoLoginCheckBox.checked = m_oAccountData.AutoLogin;

            objEMailTextBox.select();

            objButtonTestAccount.disabled = false;
            objButtonOK.disabled = false;


            //if it's edit mode we are set the checkbox an oncheckcahnged event 
            //for the confirm dialog
            var oCheckBoxAutoLogin = document.getElementById('checkAutoLogin');
            oCheckBoxAutoLogin.addEventListener("CheckboxStateChange",
										EBEMailNotifierDialogsXULEvents_CT2958529.OnCheckBoxStateChangeAutoLogin,
										false);

        }
        else {
            objRadioGroupEMails.selectedItem = objRadioHotmail;
        }
        objEMailTextBox.focus();
    },

    OnCheckBoxStateChangeAutoLogin: function(event) {
        var oCheckBox = event.target;
        if (oCheckBox.checked) {
            EBEMailNotifierDialogsManager_CT2958529.OpenConfirmDialog(window, m_oAccountData);
        }
    },


    OnAcceptConfirmDialog: function(event) {
        try {

            var oTextBoxPassword = document.getElementById('txtPassword');
            var strPassword = oTextBoxPassword.value;
            var strAccountDataPassword = m_oAccountData.Password;

            if (strPassword != strAccountDataPassword) {
                var strTitle = EBEMailNotifierDialogsConsts_CT2958529.ConfirmDialog.MismatchErrorTitle;
                var strMsg = EBEMailNotifierDialogsConsts_CT2958529.ConfirmDialog.MismatchErrorContent;
                EBGlobalManager_CT2958529.Alert(window, strTitle, strMsg);
                m_bIsCloseAcceptDialog = false;
            }
            else {
                m_bIsCloseAcceptDialog = true;
            }
        }
        catch (ex) {
            //if there is any error we want to close the dialog
            m_bIsCloseAcceptDialog = true;
        }

        return m_bIsCloseAcceptDialog;

    },

    OnLoadConfirmDialog: function(event) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var dialogsDirection = objWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "EBEmailNotifierXULConfirmAccountDialogID");

        EmailNotifierLanguagePack_CT2958529.ConfirmDialog();
    },

    OnUnloadConfirmDialog: function(event) {
        //in the onload document we set the addedit dialog autologin checkbox
        //according to the matching of the password if the user didn't
        //click on the accept button
        if (!m_bIsCloseAcceptDialog) {
            var oCheckBoxAutoLogin = m_oAddEditDocument.getElementById('checkAutoLogin');
            oCheckBoxAutoLogin.checked = false;
        }
    },

    OnInputAddEditEmailTextBox: function(event) {
        var objTextBoxEmail = event.target;
        var strEmail = objTextBoxEmail.value;
        var objTextBoxAccountName = document.getElementById('txtAccountName');

        var objRadioGroupEMails = document.getElementById('radioGroupEMails');
        var objRadioHotmail = document.getElementById('radHotmail');
        var objRadioYahoo = document.getElementById('radYahoo');
        var objRadioGmail = document.getElementById('radGMail');
        var objRadioAOL = document.getElementById('radAOL');
        var objRadioRR = document.getElementById('radRR');
        var objRadioUnivision = document.getElementById('radUnivision');
        objTextBoxAccountName.value = strEmail;

        var isGMailDmain = EBEMailNotifierManager_CT2958529.IsEMailDomain(EBEmailAccountsConsts_CT2958529.GMail, strEmail);
        var isYahooDomain = EBEMailNotifierManager_CT2958529.IsEMailDomain(EBEmailAccountsConsts_CT2958529.Yahoo, strEmail);
        var isHotmailDomain = EBEMailNotifierManager_CT2958529.IsEMailDomain(EBEmailAccountsConsts_CT2958529.Hotmail, strEmail);
        var isAOLDomain = EBEMailNotifierManager_CT2958529.IsEMailDomain(EBEmailAccountsConsts_CT2958529.AOL, strEmail);
        var isUnivisionDomain = EBEMailNotifierManager_CT2958529.IsEMailDomain(EBEmailAccountsConsts_CT2958529.Univision, strEmail);
        var isRRDomain = EBEMailNotifierManager_CT2958529.IsRRDomain(strEmail);

        if (isRRDomain)
            objRadioGroupEMails.selectedItem = objRadioRR;
        else if (isGMailDmain)
            objRadioGroupEMails.selectedItem = objRadioGmail;
        else if (isYahooDomain)
            objRadioGroupEMails.selectedItem = objRadioYahoo;
        else if (isHotmailDomain)
            objRadioGroupEMails.selectedItem = objRadioHotmail;
        else if (isAOLDomain)
            objRadioGroupEMails.selectedItem = objRadioAOL;
        else if (isUnivisionDomain)
            objRadioGroupEMails.selectedItem = objRadioUnivision;


        this.SetTestAccountOKButtonsState();
    },

    OnInputAddEditPasswordTextBox: function(event) {
        this.SetTestAccountOKButtonsState();
    },

    OnInputAddEditAccountNameTextBox: function(event) {
        this.SetTestAccountOKButtonsState();
    },

    OnInputAddEditPop3MailServerTextBox: function(event) {
        this.SetTestAccountOKButtonsState();
    },

    IsAddEditPop3Mode: function() {
        var objRadioGroupEMails = document.getElementById('radioGroupEMails');
        var objRadioPop3 = document.getElementById('radPop3');

        return objRadioGroupEMails.selectedItem == objRadioPop3;
    },

    OnSelectAddEditRadioGroupEMails: function(event) {

        var objRadioGroupEMails = document.getElementById('radioGroupEMails');
        var objRadioHotmail = document.getElementById('radHotmail');
        var objRadioYahoo = document.getElementById('radYahoo');
        var objRadioGmail = document.getElementById('radGMail');
        var objRadioRR = document.getElementById('radRR');
        var objRadioAOL = document.getElementById('radAOL');
        var objRadioUnivision = document.getElementById('radUnivision');
        var objRadioPOP3 = document.getElementById('radPop3');

        var objLabelSupportedDomains = document.getElementById('lblSupportedDomains');

        //set the caption domains:
        var strCaptionDomains = '';

        if (objRadioGroupEMails.selectedItem == objRadioHotmail)
            strCaptionDomains = EBEMailNotifierManager_CT2958529.GetHotmailDomainCaption();
        else if (objRadioGroupEMails.selectedItem == objRadioYahoo)
            strCaptionDomains = EBEMailNotifierManager_CT2958529.GetYahooDomainCaption();
        else if (objRadioGroupEMails.selectedItem == objRadioGmail)
            strCaptionDomains = EBEMailNotifierManager_CT2958529.GetGMailDomainCaption();
        else if (objRadioGroupEMails.selectedItem == objRadioRR)
            strCaptionDomains = EBEMailNotifierManager_CT2958529.GetRRDomainCaption();
        else if (objRadioGroupEMails.selectedItem == objRadioAOL)
            strCaptionDomains = EBEMailNotifierManager_CT2958529.GetAOLDomainCaption();
        else if (objRadioGroupEMails.selectedItem == objRadioUnivision)
            strCaptionDomains = EBEMailNotifierManager_CT2958529.GetUnivisionDomainCaption();
        else if (objRadioGroupEMails.selectedItem == objRadioPOP3)
            strCaptionDomains = '';

        objLabelSupportedDomains.setAttribute('value', strCaptionDomains);

        var objRowPop3MailServer = document.getElementById('rowPop3MailServer');
        var objCheckBoxAutoLogin = document.getElementById('checkAutoLogin');
        var objLabelEMail = document.getElementById('lblEMail');

        var oTextBoxPop3MailServerURL = document.getElementById('txtPop3MailServer');
        if (this.IsAddEditPop3Mode()) {
            objLabelEMail.setAttribute('value', EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.Pop3EMailAddress);
            objRowPop3MailServer.style.visibility = '';
            objCheckBoxAutoLogin.setAttribute('accesskey', 'O');
            objCheckBoxAutoLogin.setAttribute('label', EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.Pop3AutoLogin);
            oTextBoxPop3MailServerURL.focus();
        }
        else {
            objLabelEMail.setAttribute('value', EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.EmailAddress);
            objRowPop3MailServer.style.visibility = 'hidden';
            objCheckBoxAutoLogin.setAttribute('accesskey', 'A');
            objCheckBoxAutoLogin.setAttribute('label', EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.AutoLogin);
        }

        //when selection check the state of the buttons:
        this.SetTestAccountOKButtonsState();
    },

    SetTestAccountOKButtonsState: function() {
        var objButtonTestAccount = document.getElementById('btnTestAccount');
        var objButtonOK = document.getElementById('btnOK');

        var objTextBoxEmail = document.getElementById('txtEMail');
        var objTextBoxPassword = document.getElementById('txtPassword');
        var objTextBoxAccountName = document.getElementById('txtAccountName');
        var objTextBoxPop3MailServer = document.getElementById('txtPop3MailServer');

        //get the values from the text boxes
        var strEMail = objTextBoxEmail.value;
        var strPassword = objTextBoxPassword.value;
        var strAccountName = objTextBoxAccountName.value;

        var strPop3MailServer = objTextBoxPop3MailServer.value;

        if (EBGlobalManager_CT2958529.TotalTrim(strEMail) != '' &&
			strPassword != '' &&
			EBGlobalManager_CT2958529.TotalTrim(strAccountName) != '') {
            objButtonTestAccount.disabled = false;
            objButtonOK.disabled = false;
        }
        else {
            objButtonTestAccount.disabled = true;
            objButtonOK.disabled = true;
        }

        if (this.IsAddEditPop3Mode()) {
            if (EBGlobalManager_CT2958529.TotalTrim(strPop3MailServer) != '') {
                objButtonTestAccount.disabled = false;
                objButtonOK.disabled = false;
            }
            else {
                objButtonTestAccount.disabled = true;
                objButtonOK.disabled = true;
            }
        }


    },

    OnCommandAddEditTestAccountButton: function(event) {
        if (this.IsValidEMailAddress()) {
            EBEMailNotifierDialogsManager_CT2958529.OpenTestAccountDialog(window);
        }
    },

    IsValidEMailAddress: function() {
        var objTextBoxEmail = document.getElementById('txtEMail');
        var strEMail = objTextBoxEmail.value;


        //if it's pop3 there isn't any check
        if (this.IsAddEditPop3Mode()) {
            var strUserName = strEMail;
            var strMailServerURL = document.getElementById('txtPop3MailServer').value;
            if (this.IsPop3AccountExists(strUserName, strMailServerURL)) {
                EBGlobalManager_CT2958529.Alert(window, EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorTitleAlertMsg,
							EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorMsgPOP3AlreadyExist);
                objTextBoxEmail.select();
                return false;
            }
            else {
                return true;
            }
        }


        //check incorrect email
        if (!EBGlobalManager_CT2958529.IsValidEMail(strEMail)) {
            EBGlobalManager_CT2958529.Alert(window, EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorTitleAlertMsg,
								EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorMsgIncorrectEMailAddress);
            objTextBoxEmail.select();
            return false;
        }

        //check supported email
        if (!EBEMailNotifierManager_CT2958529.IsSupportedEMailAccounts(strEMail)) {
            EBGlobalManager_CT2958529.Alert(window, EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorTitleAlertMsg,
								EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorMsgEmailAddressNotSupported);
            objTextBoxEmail.select();
            return false;
        }

        //check for existing email(using the data object account)
        if (this.IsEMailExists(strEMail)) {
            EBGlobalManager_CT2958529.Alert(window, EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorTitleAlertMsg,
								EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorMsgEmailAlreadyExist);
            objTextBoxEmail.select();
            return false;
        }

        //check if the radio button suit to the account:

        //check the desirable type
        var iAcceptableAccountType = EBEMailNotifierManager_CT2958529.GetAccountTypeByEMail(strEMail);
        //check actual radio selection
        var iActualAccountType = 0;
        var objRadioGroupEMails = document.getElementById('radioGroupEMails');
        var objRadioHotmail = document.getElementById('radHotmail');
        var objRadioYahoo = document.getElementById('radYahoo');
        var objRadioGmail = document.getElementById('radGMail');
        var objRadioRR = document.getElementById('radRR');
        var objRadioAOL = document.getElementById('radAOL');
        var objRadioUnivision = document.getElementById('radUnivision');


        if (objRadioGroupEMails.selectedItem == objRadioHotmail)
            iActualAccountType = EBEmailAccountsTypes_CT2958529.Hotmail;
        else if (objRadioGroupEMails.selectedItem == objRadioYahoo)
            iActualAccountType = EBEmailAccountsTypes_CT2958529.Yahoo;
        else if (objRadioGroupEMails.selectedItem == objRadioGmail)
            iActualAccountType = EBEmailAccountsTypes_CT2958529.GMail;
        else if (objRadioGroupEMails.selectedItem == objRadioRR)
            iActualAccountType = EBEmailAccountsTypes_CT2958529.RR;
        else if (objRadioGroupEMails.selectedItem == objRadioAOL)
            iActualAccountType = EBEmailAccountsTypes_CT2958529.AOL;
        else if (objRadioGroupEMails.selectedItem == objRadioUnivision)
            iActualAccountType = EBEmailAccountsTypes_CT2958529.Univision;

        if (iAcceptableAccountType != iActualAccountType) {
            EBGlobalManager_CT2958529.Alert(window, EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorTitleAlertMsg,
								EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorMsgEmailTypeIncorrect);
            objRadioGroupEMails.focus();
            return false;
        }

        return true;
    },

    IsEMailExists: function(strEMail) {
        //get the dialogs mail account collection:
        var oMailAccountsColl = this.GetDialogsMailAccountCollection();
        if (oMailAccountsColl) {
            var arrAccounts = oMailAccountsColl.Arr;
            var objAccountData = null;
            for (var i = 0; i < arrAccounts.length; i++) {
                objAccountData = arrAccounts[i];
                if (m_oAccountData != objAccountData && objAccountData.EMailAddress.toLowerCase() == strEMail.toLowerCase())
                    return true;
            }
        }

        return false;
    },

    IsPop3AccountExists: function(strUserName, strMailServerURL) {
        var oMailAccountsColl = this.GetDialogsMailAccountCollection();
        if (oMailAccountsColl) {
            var arrAccounts = oMailAccountsColl.Arr;
            var objAccountData = null;
            for (var i = 0; i < arrAccounts.length; i++) {
                objAccountData = arrAccounts[i];
                if (m_oAccountData != objAccountData &&
				objAccountData.EMailAddress == strUserName &&
				objAccountData.Pop3Server.toLowerCase() == strMailServerURL.toLowerCase()) {
                    return true;
                }
            }
        }

        return false;

    },

    GetIndexByAccountDataObject: function(objCurrentAccountData) {
        var oMailAccountsColl = this.GetDialogsMailAccountCollection();
        if (oMailAccountsColl) {
            var arrAccounts = oMailAccountsColl.Arr;
            var objAccountData = null;
            for (var i = 0; i < arrAccounts.length; i++) {
                objAccountData = arrAccounts[i];
                if (objAccountData == objCurrentAccountData) {
                    return i;
                }
            }
        }

        return -1;
    },

    OnCommandAddEditOKButton: function(event) {
        try {
            var objTextBoxEmail = document.getElementById('txtEMail');
            var strEMailAddress = objTextBoxEmail.value;

            if (!this.IsValidEMailAddress()) {
                return false;
            }

            var strPassword = document.getElementById('txtPassword').value;
            var strAccountName = document.getElementById('txtAccountName').value;

            var strPop3ServerURL = null;
            var strPop3Port = null;
            if (this.IsAddEditPop3Mode()) {
                strPop3ServerURL = document.getElementById('txtPop3MailServer').value;
                strPop3Port = document.getElementById('txtPop3Port').value;
            }

            var objRadioGroupEMails = document.getElementById('radioGroupEMails');
            var objRadioHotmail = document.getElementById('radHotmail');
            var objRadioYahoo = document.getElementById('radYahoo');
            var objRadioGmail = document.getElementById('radGMail');
            var objRadioAOL = document.getElementById('radAOL');
            var objRadioRR = document.getElementById('radRR');
            var objRadioUnivision = document.getElementById('radUnivision');
            var objRadioPop3 = document.getElementById('radPop3');

            var iAccountType;
            if (objRadioGroupEMails.selectedItem == objRadioGmail) {
                iAccountType = EBEmailAccountsTypes_CT2958529.GMail;
            }
            else if (objRadioGroupEMails.selectedItem == objRadioYahoo) {
                iAccountType = EBEmailAccountsTypes_CT2958529.Yahoo;
            }
            else if (objRadioGroupEMails.selectedItem == objRadioHotmail) {
                iAccountType = EBEmailAccountsTypes_CT2958529.Hotmail;
            }
            else if (objRadioGroupEMails.selectedItem == objRadioRR) {
                iAccountType = EBEmailAccountsTypes_CT2958529.RR;
            }
            else if (objRadioGroupEMails.selectedItem == objRadioAOL) {
                iAccountType = EBEmailAccountsTypes_CT2958529.AOL;
            }
            else if (objRadioGroupEMails.selectedItem == objRadioUnivision) {
                iAccountType = EBEmailAccountsTypes_CT2958529.Univision;
            }
            else if (objRadioGroupEMails.selectedItem == objRadioPop3) {
                iAccountType = EBEmailAccountsTypes_CT2958529.Pop3;
            }

            var isAutoLogin = document.getElementById('checkAutoLogin').checked;

            if (MODE == EBEMailNotifierDialogsConsts_CT2958529.AddEditDialog.ModeAdd) {
                var objAccountDataToAdd = new EBEMailAccountDataObject_CT2958529(strAccountName,
															strEMailAddress,
															strPassword,
															iAccountType,
															isAutoLogin,
															null,
															null,
															strPop3ServerURL,
															strPop3Port);

                this.AddMailAccountTreeItem(objAccountDataToAdd, true);
            }
            else {
                this.EditMailAccountTreeItem(strAccountName, strEMailAddress, strPassword, iAccountType, isAutoLogin, strPop3ServerURL, strPop3Port, m_oAccountData);
            }
        }
        catch (ex) { }

        return true;

    },

    OnLoadTestAccountDialog: function(event) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var dialogsDirection = objWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "EBEmailNotifierXULTestAccountDialogID");

        //set focus to the ok button
        document.getElementById('btnOKCancel').focus();
        EmailNotifierLanguagePack_CT2958529.TestAccountDialog();
        //open the test from the browser window to prevent bug
        //when the user close the test before the end of the process
        if (objWindow) {
            objWindow.EmailNotifierLanguagePack_CT2958529.TestAccountDialogSub();
            TestAccountDialogCheck_CT2958529.Start(document, m_oAddEditDialogDocument);
        }
    },

    OnUnloadTestAccountDialog: function(event) {
        //open the test from the browser window to prevent bug
        //when the user close the test before the end of the process
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        if (objWindow) {
            objWindow.TestAccountDialogCheck_CT2958529.NullifyMemebers();
        }
    },

    //get the dialog account collection which define in the settings dialog!
    GetDialogsMailAccountCollection: function() {
        var objSettingsWindow = EBEMailNotifierDialogsManager_CT2958529.GetDialogWindow(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.Name);

        return objSettingsWindow.m_oDialogsMailAccountsCollection;
    },

    AddMailAccountTreeItem: function(objAccountData, isSelectItem) {
        var objSettingsWindow = EBEMailNotifierDialogsManager_CT2958529.GetDialogWindow(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.Name);

        if (!objSettingsWindow) {
            return;
        }

        var objSettingsDocument = objSettingsWindow.document;

        var objTreeChildrenMailAccounts = objSettingsDocument.getElementById('treeChildrenMailAccounts');

        var objTreeItem = objSettingsDocument.createElement('treeitem');

        var objTreeRow = this.AccountDataObjectToTreeRow(objSettingsDocument, objAccountData);

        objTreeItem.appendChild(objTreeRow);

        objTreeChildrenMailAccounts.appendChild(objTreeItem);


        if (isSelectItem) {
            this.SelectTreeItem(objTreeItem);
        }


        //add the data to the dialog collection
        objSettingsWindow.m_oDialogsMailAccountsCollection.AppendElement(objAccountData);

    },

    EditMailAccountTreeItem: function(strAccountName, strEMailAddress, strPassword, iAccountType, isAutoLogin, strPop3ServerURL, strPop3Port, objAccountData) {
        var objSettingsWindow = EBEMailNotifierDialogsManager_CT2958529.GetDialogWindow(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.Name);

        if (!objSettingsWindow) return;

        var objSettingsDocument = objSettingsWindow.document;

        var iIndexToEdit = this.GetIndexByAccountDataObject(objAccountData);

        if (iIndexToEdit == -1) return;

        var objTreeChildren = objSettingsDocument.getElementById('treeChildrenMailAccounts');

        var objTreeRowCollection = objTreeChildren.getElementsByTagName('treerow');

        var objTreeRowToEdit = objTreeRowCollection.item(iIndexToEdit);

        var objTreeCellAccountName = objTreeRowToEdit.childNodes[0];
        var objTreeCellEMailAddress = objTreeRowToEdit.childNodes[1];
        var objTreeCellAccountType = objTreeRowToEdit.childNodes[2];
        var objTreeCellAutoLogin = objTreeRowToEdit.childNodes[3];

        objTreeCellAccountName.setAttribute('label', strAccountName);

        objTreeCellEMailAddress.setAttribute('label', strEMailAddress);
        objTreeCellEMailAddress.setAttribute(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.TreeCellPasswordAttribute, strPassword);
        objTreeCellEMailAddress.setAttribute(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.TreeCellServerAttribute, strPop3ServerURL);

        var strAccountType = EBEMailNotifierManager_CT2958529.GetAccountNameByType(iAccountType);
        objTreeCellAccountType.setAttribute('label', strAccountType);
        objTreeCellAccountType.setAttribute(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.TreeCellTypeAttribute, iAccountType);

        var strIsAutoLogin = isAutoLogin ? EBEMailNotifierDialogsCaption_CT2958529.SettingsDialog.Yes : EBEMailNotifierDialogsCaption_CT2958529.SettingsDialog.No;
        objTreeCellAutoLogin.setAttribute('label', strIsAutoLogin);
        objTreeCellAutoLogin.setAttribute(EBEMailNotifierDialogsConsts_CT2958529.SettingsDialog.TreeCellAutoLoginAttribute, isAutoLogin);

        //set the data object
        objAccountData.AccountName = strAccountName;
        objAccountData.EMailAddress = strEMailAddress;
        objAccountData.Password = strPassword;
        objAccountData.AccountType = iAccountType;
        objAccountData.AutoLogin = isAutoLogin;
        objAccountData.Pop3Server = strPop3ServerURL;
        objAccountData.Pop3Port = strPop3Port;

    },

    SelectTreeItem: function(objTreeItem) {
        var objTree = objTreeItem.parentNode.parentNode;
        var iIndex = objTree.contentView.getIndexOfItem(objTreeItem);
        objTree.view.selection.select(iIndex);
        objTree.focus();
    },

    Test: function(doc) {

    },

    OnClickHelp: function(event) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        //usage
        objWindow.EBUsageEmailNotifier_CT2958529.OnClickFeedback();

        //send feedback
        var emailNotifierComp = objWindow.EBComponentsManager_CT2958529.GetEMailNotifierComponent();
        if (emailNotifierComp && emailNotifierComp.ComponentItem.helpUrl)
            objWindow.EBWeb_CT2958529.LoadURLInNewWindow(emailNotifierComp.ComponentItem.helpUrl, null);
    }
};

var TestAccountDialogCheck_CT2958529 =
{
    EMailAccountType: null,

    EMail: '',

    Password: '',

    Pop3ServerURL: '',

    Pop3Port: 0,

    TestDialogDocument: null,

    AddEditDialogDocument: null,

    IsTestAccountDialogExists: function() {
        var objTestAccountWindow = EBEMailNotifierDialogsManager_CT2958529.GetDialogWindow(EBEMailNotifierDialogsConsts_CT2958529.TestAccountDialog.Name);
        return objTestAccountWindow ? true : false;
    },

    Start: function(oTestDialogDocument, oAddEditDialogDocument) {
        this.TestDialogDocument = oTestDialogDocument;
        this.AddEditDialogDocument = oAddEditDialogDocument;

        var objTextBoxEmail = this.AddEditDialogDocument.getElementById('txtEMail');
        var objTextBoxPassword = this.AddEditDialogDocument.getElementById('txtPassword');
        var objTextBoxPop3MailServer = this.AddEditDialogDocument.getElementById('txtPop3MailServer');
        var objTextBoxPop3Port = this.AddEditDialogDocument.getElementById('txtPop3Port');

        var objRadioGroupEMails = this.AddEditDialogDocument.getElementById('radioGroupEMails');
        var objRadioHotmail = this.AddEditDialogDocument.getElementById('radHotmail');
        var objRadioYahoo = this.AddEditDialogDocument.getElementById('radYahoo');
        var objRadioGmail = this.AddEditDialogDocument.getElementById('radGMail');
        var objRadioAOL = this.AddEditDialogDocument.getElementById('radAOL');
        var objRadioRR = this.AddEditDialogDocument.getElementById('radRR');
        var objRadioUnivision = this.AddEditDialogDocument.getElementById('radUnivision');
        var objRadioPop3 = this.AddEditDialogDocument.getElementById('radPop3');

        var iEMailAccountType = null;
        if (objRadioGroupEMails.selectedItem == objRadioGmail) {
            iEMailAccountType = EBEmailAccountsTypes_CT2958529.GMail;
        }
        else if (objRadioGroupEMails.selectedItem == objRadioYahoo) {
            iEMailAccountType = EBEmailAccountsTypes_CT2958529.Yahoo;
        }
        else if (objRadioGroupEMails.selectedItem == objRadioHotmail) {
            iEMailAccountType = EBEmailAccountsTypes_CT2958529.Hotmail;
        }
        else if (objRadioGroupEMails.selectedItem == objRadioRR) {
            iEMailAccountType = EBEmailAccountsTypes_CT2958529.RR;
        }
        else if (objRadioGroupEMails.selectedItem == objRadioAOL) {
            iEMailAccountType = EBEmailAccountsTypes_CT2958529.AOL;
        }
        else if (objRadioGroupEMails.selectedItem == objRadioUnivision) {
            iEMailAccountType = EBEmailAccountsTypes_CT2958529.Univision;
        }
        else if (objRadioGroupEMails.selectedItem == objRadioPop3) {
            iEMailAccountType = EBEmailAccountsTypes_CT2958529.Pop3;
        }

        //get the values from the text boxes
        var strEMail = objTextBoxEmail.value;
        var strPassword = objTextBoxPassword.value;
        var strPop3MailServerURL = objTextBoxPop3MailServer.value;
        var strPop3Port = objTextBoxPop3Port.value;

        //set the class members for later use
        this.EMailAccountType = iEMailAccountType;
        this.EMail = strEMail;
        this.Password = strPassword;
        this.Pop3ServerURL = strPop3MailServerURL;
        this.Pop3Port = strPop3Port;

        this.StepOneCheckInternetConnection(oTestDialogDocument);
    },

    StepOneCheckInternetConnection: function(oTestDialogDocument) {
        //check internet connection:
        var strCheckURL = EBEmailAccountsConsts_CT2958529.CheckURL;

        var oCallBackFunction = function(oData, o) {
            if (o.value == EBGlobalConsts_CT2958529.NetworkError) {
                TestAccountDialogCheck_CT2958529.ConnectionFailed();
            }
            else {
                TestAccountDialogCheck_CT2958529.ConnectionSuccess(oTestDialogDocument);
            }
        };

        EBWeb_CT2958529.HTTPServerRequest(strCheckURL, null, false, oCallBackFunction);
    },

    StepTwoLoginToMailServer: function() {
        var objMailAccount = EBEMailNotifierManager_CT2958529.GetAccountObjectByType(this.EMailAccountType,
																			this.EMail,
																			this.Password,
																			this.Pop3ServerURL,
																			this.Pop3Port);

        var objResponseFunction = function(iNewMessages) {
            TestAccountDialogCheck_CT2958529.ResponseLoginMailServer(iNewMessages);
        };

        objMailAccount.GetNewMessagesCount(objResponseFunction, true);
    },

    ConnectionSuccess: function(oTestDialogDocument) {
        //check if the user close the window in the middle of the check
        if (!this.IsTestAccountDialogExists()) return;

        //set the check connection tree cell to success
        this.SetTreeCellIndicatorSuccess('tcEstablishConnection');

        //make time effect for the check function
        var objIntervalFunction = function() {
            //TestAccountDialogCheck_CT2958529.SetTreeCellIndicatorSuccess('tcFindMailServer');	
            TestAccountDialogCheck_CT2958529.StepTwoLoginToMailServer();
        };

        setTimeout(objIntervalFunction, 500);
    },

    ResponseLoginMailServer: function(iNewMessages) {
        //check if the user close the window in the middle of the check
        //Fix it later, enable the check
        //if(!BEMailNotifierDialogsManager_CT2958529.IsTestAccountDialogExists())return;

        if (iNewMessages == EBEmailAccountsConsts_CT2958529.LOGIN_FAILED) {
            this.SetTreeCellIndicatorFailed('tcLoginMsg');
            this.TestFailed();
        }
        else if (iNewMessages == EBEmailAccountsConsts_CT2958529.LOGIN_ANOTHER_ACCOUNT)
            this.TestWarning();
        else {
            this.SetTreeCellIndicatorSuccess('tcLoginMsg');
            this.TestSuccess();
        }
    },

    ConnectionFailed: function() {
        //check if the user close the window in the middle of the check
        if (!this.IsTestAccountDialogExists()) return;


        this.SetTreeCellIndicatorFailed('tcEstablishConnection');
        this.SetTreeCellIndicatorFailed('tcFindMailServer');
        this.SetTreeCellIndicatorFailed('tcLoginMsg');
        this.TestFailed();
    },

    SetTreeCellIndicatorSuccess: function(strTreeCellID) {
        var objTreeCellIndicator = this.TestDialogDocument.getElementById(strTreeCellID);
        var objTreeCellValue = this.TestDialogDocument.getElementById(strTreeCellID + 'Value');

        objTreeCellIndicator.setAttribute('src', EBEMailNotifierConsts_CT2958529.Images.V_Image);

        objTreeCellValue.setAttribute('label', EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TasksSuccess);

        return objTreeCellIndicator;
    },

    SetTreeCellIndicatorFailed: function(strTreeCellID) {
        var objTreeCellIndicator = this.TestDialogDocument.getElementById(strTreeCellID);
        var objTreeCellValue = this.TestDialogDocument.getElementById(strTreeCellID + 'Value');

        objTreeCellIndicator.setAttribute('src', EBEMailNotifierConsts_CT2958529.Images.X_Image);

        objTreeCellValue.setAttribute('label', EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TasksFailure);

        return objTreeCellIndicator;
    },

    TestSuccess: function() {
        var objTreeCellFinish = this.SetTreeCellIndicatorSuccess('tcFinishMsg');
        objTreeCellFinish.setAttribute('label', ' ' + EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TasksSuccessFinishMsg);

        var objTreeCellFinishDone = this.TestDialogDocument.getElementById('tcFinishMsgDone');
        objTreeCellFinishDone.setAttribute('properties', 'success');
        objTreeCellFinishDone.setAttribute('label', EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TaskSuccessDone);
        objTreeCellFinishDone.setAttribute('src', EBEMailNotifierConsts_CT2958529.Images.V_Image);

        this.Finish();
    },

    TestFailed: function() {
        var objTreeCellFinish = this.SetTreeCellIndicatorFailed('tcFinishMsg');
        objTreeCellFinish.setAttribute('label', ' ' + EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TasksFailureFinishMsg);
        objTreeCellFinish.setAttribute('properties', 'failed');

        this.Finish();
    },

    TestWarning: function() {
        var objTreeCellEstablish = this.TestDialogDocument.getElementById('tcEstablishConnection');
        var objTreeCellEstablishValue = this.TestDialogDocument.getElementById('tcEstablishConnectionValue');
        var objTreeCellLogin = this.TestDialogDocument.getElementById('tcLoginMsg');
        var objTreeCellLoginValue = this.TestDialogDocument.getElementById('tcLoginMsgValue');

        //the string of the warning message devide into 2 strings because
        //of spacing problem
        //convert the warning string according to the account type
        var strWarning1 = EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TestWarningMsg1;
        var strAccountName = EBEMailNotifierManager_CT2958529.GetAccountNameByType(this.EMailAccountType);
        strWarning1 = strWarning1.replace(EBEMailNotifierDialogsConsts_CT2958529.TestAccountDialog.AccountNameAlias, strAccountName);

        this.TestDialogDocument.getElementById('treeChildren').style.display = "none";
        this.TestDialogDocument.getElementById('txtWarning').innerHTML = strWarning1;
        this.TestDialogDocument.getElementById('errorLogoutDiv').style.display = "";
        this.TestDialogDocument.getElementById('imgWarning').setAttribute('src', EBEMailNotifierConsts_CT2958529.Images.WarningImage);

        this.Finish();

    },

    Finish: function() {
        var objButtonOKCancel = this.TestDialogDocument.getElementById('btnOKCancel');
        objButtonOKCancel.setAttribute('label', EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.ButtonOK);
    },

    NullifyMemebers: function() {
        this.EMailAccountType = null;
        this.EMail = '';
        this.Password = '';
        this.TestDialogDocument = null;
        this.AddEditDialogDocument = null;
    }
};

var EmailNotifierLanguagePack_CT2958529 =
{
    SettingsDialog: function() {
        var ID = 'EBEmailNotifierXULSettingsDialogID';
        var acceptButton = document.getElementById(ID).getButton('accept');
        var cancelButton = document.getElementById(ID).getButton('cancel');
        var emailNotifierSettings = document.getElementById('emailNotifierSettings');
        var getAlertsOfNewEmails = document.getElementById('getAlertsOfNewEmails');
        var emailNotifierChecksTheseAccounts = document.getElementById('emailNotifierChecksTheseAccounts');
        var tcAccountName = document.getElementById('tcAccountName');
        var tcAccountAddress = document.getElementById('tcAccountAddress');
        var tcAccountType = document.getElementById('tcAccountType');
        var tcAccountAutoLogin = document.getElementById('tcAccountAutoLogin');
        var checkForNewEmailsEvery = document.getElementById('checkForNewEmailsEvery');
        var checkPlaySound = document.getElementById('checkPlaySound');
        var radSoundUseDefault = document.getElementById('radSoundUseDefault');
        var radSoundChoose = document.getElementById('radSoundChoose');
        var btnSoundChooseFile = document.getElementById('btnSoundChooseFile');
        var btnSoundPlay = document.getElementById('btnSoundPlay');
        var aSupportLink = document.getElementById('aSupportLink');
        var btnToolbarOptions = document.getElementById('btnToolbarOptions');
        var btnAdd = document.getElementById('btnAdd');
        var btnEdit = document.getElementById('btnEdit');
        var btnDelete = document.getElementById('btnDelete');

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);

        EBEMailNotifierDialogsCaption_CT2958529.SettingsDialog.Yes = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_YES');
        EBEMailNotifierDialogsCaption_CT2958529.SettingsDialog.No = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_NO');

        acceptButton.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK');
        cancelButton.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL');
        window.title = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_TITLE');
        emailNotifierSettings.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_INNER_TITLE');
        getAlertsOfNewEmails.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_INNER_DESCRIPTION');
        emailNotifierChecksTheseAccounts.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_LIST_TITLE');
        tcAccountName.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_LIST_CUL_NAME'));
        tcAccountAddress.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_LIST_CUL_ADDRESS'));
        tcAccountType.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_LIST_CUL_TYPE'));
        tcAccountAutoLogin.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_LIST_CUL_AUTOLOGIN'));
        checkForNewEmailsEvery.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_CHECK_EVERY_TEXT');
        checkPlaySound.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_PLAY_SOUND_TEXT');
        checkPlaySound.setAttribute('accesskey', radSoundUseDefault.getAttribute('label').charAt(0));
        radSoundUseDefault.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_DEFAULT_SOUND_TEXT');
        radSoundUseDefault.setAttribute('accesskey', radSoundUseDefault.getAttribute('label').charAt(0));
        radSoundChoose.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_DIFFERENT_SOUND_TEXT');
        radSoundChoose.setAttribute('accesskey', radSoundChoose.getAttribute('label').charAt(0));
        btnSoundChooseFile.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_BROWSE');
        btnSoundChooseFile.setAttribute('accesskey', btnSoundChooseFile.getAttribute('label').charAt(0));
        btnSoundPlay.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_BUTT_PLAY_TEXT');
        btnSoundPlay.setAttribute('accesskey', btnSoundPlay.getAttribute('label').charAt(0));
        aSupportLink.innerHTML = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_HELP');
        btnToolbarOptions.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_BUTT_TBOPTIONS_TEXT');
        btnToolbarOptions.setAttribute('accesskey', btnToolbarOptions.getAttribute('label').charAt(0));
        btnAdd.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_BUTT_ADD_TEXT'));
        btnAdd.setAttribute('accesskey', btnAdd.getAttribute('label').charAt(0));
        btnEdit.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_BUTT_EDIT_TEXT');
        btnEdit.setAttribute('accesskey', btnEdit.getAttribute('label').charAt(0));
        btnDelete.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_SETTINGS_DLG_BUTT_DELETE_TEXT');
        btnDelete.setAttribute('accesskey', btnDelete.getAttribute('label').charAt(0));
    },

    TestAccountDialogSub: function() {
        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);

        EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TasksFailureFinishMsg = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_FAILED_TESTING');
        EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TasksSuccessFinishMsg = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_COMPLETED_SUCC_TEXT');
        EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TaskSuccessDone = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_DONE_TESTING');
        EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TasksSuccess = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_COMPLETED');
        EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TasksFailure = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_FAILED');
        EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.ButtonOK = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK');
        EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TestWarningMsg1 = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_PLEASE_LOGOUT_TEXT');
        // * EBEMailNotifierDialogsCaption_CT2958529.TestAccountDialog.TestWarningMsg2 = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_FAILED_TESTING');
    },

    TestAccountDialog: function() {
        var ID = 'EBEmailNotifierXULTestAccountDialogID';

        var acceptButton = document.getElementById(ID).getButton('accept');
        var EmailAccountTest = document.getElementById('EmailAccountTest');
        var tcEstablishConnection = document.getElementById('tcEstablishConnection');
        var tcLoginMsg = document.getElementById('tcLoginMsg');
        var tcFinishMsg = document.getElementById('tcFinishMsg');
        var tcTasks = document.getElementById('tcTasks');
        var tcStatus = document.getElementById('tcStatus');

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);

        window.title = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_TITLE');
        acceptButton.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL');
        EmailAccountTest.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_INNER_TITLE');
        tcEstablishConnection.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_ESTABLISH'));
        tcLoginMsg.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_LOGINTO'));
        tcFinishMsg.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL'));
        tcTasks.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_CUL_TASKS'));
        tcStatus.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_CUL_STATUS'));

    },

    ConfirmDialog: function() {
        var ID = 'EBEmailNotifierXULConfirmAccountDialogID';

        var acceptButton = document.getElementById(ID).getButton('accept');
        var cancelButton = document.getElementById(ID).getButton('cancel');
        var Description = document.getElementById('Description');
        var Password = document.getElementById('Password');

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);

        EBEMailNotifierDialogsConsts_CT2958529.ConfirmDialog.MismatchErrorTitle = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ALERT_MSG_WRONG_PASSWORD_TITLE');
        EBEMailNotifierDialogsConsts_CT2958529.ConfirmDialog.MismatchErrorContent = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ALERT_MSG_WRONG_PASSWORD');

        window.title = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_PASSWORD_DLG_TITLE');
        acceptButton.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK');
        cancelButton.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL');
        Description.setAttribute('innerHTML', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_PASSWORD_DLG_DESC'));
        Password.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_PASSWORD_DLG_PASSWORD');
    },

    AddEditDialog: function() {
        var ID = 'EBEmailNotifierXULAddEditDialogID';

        var acceptButton = document.getElementById(ID).getButton('accept');
        var cancelButton = document.getElementById(ID).getButton('cancel');
        var EmailAccountDetails = document.getElementById('EmailAccountDetails');
        var AccountType = document.getElementById('AccountType');
        var SupportedDomains = document.getElementById('SupportedDomains');
        var lblEMail = document.getElementById('lblEMail');
        var Password = document.getElementById('Password');
        var NameYourAccount = document.getElementById('NameYourAccount');
        var IncomingMailServer = document.getElementById('IncomingMailServer');
        var Port = document.getElementById('Port');
        var btnTestAccount = document.getElementById('btnTestAccount');

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);
        EBEMailNotifierDialogsCaption_CT2958529.SettingsDialog.Yes = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_YES');
        EBEMailNotifierDialogsCaption_CT2958529.SettingsDialog.No = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_NO');

        EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.AutoLogin = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_AUTO_LOGIN_TEXT');
        EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.Pop3AutoLogin = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_OPEN_DEFAULT_CLIENT_TEXT');
        // * EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorTitleAlertMsg = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_TITLE');
        EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorMsgIncorrectEMailAddress = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ALERT_MESSAGE_INCCORECT_ADDRESS');
        EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorMsgEmailAlreadyExist = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ALERT_MESSAGE_ACCOUNT_ALREADY_EXISTS');
        EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorMsgPOP3AlreadyExist = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ALERT_MESSAGE_ACCOUNT_ALREADY_EXISTS');
        EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorMsgEmailAddressNotSupported = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ALERT_MESSAGE_EMAIL_NOT_SUPPORTED');
        EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.ErrorMsgEmailTypeIncorrect = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ALERT_MESSAGE_INCCORECT_ADDRESS');

        acceptButton.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK');
        cancelButton.label = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL');
        window.title = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_TITLE');
        EmailAccountDetails.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_INNER_TITLE');
        AccountType.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_TYPE_TEXT');
        SupportedDomains.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_SUPPORTED_DOMAINS_TEXT');

        EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.EmailAddress = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_EMAIL_ADDRESS_TEXT');
        EBEMailNotifierDialogsCaption_CT2958529.AddEditDialog.Pop3EMailAddress = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_USER_NAME_TEXT');
        Password.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_PASSWORD_TEXT');
        NameYourAccount.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_NAME_ACCOUNT_TEXT');
        IncomingMailServer.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_INCOMMING_SERVER_TEXT');
        Port.value = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_PORT_TEXT');
        btnTestAccount.setAttribute('label', objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_EMAIL_NOTIFIER_ADD_DLG_BUTT_TEST_MAIL_TEXT'));
        btnTestAccount.setAttribute('accesskey', btnTestAccount.getAttribute('label').charAt(0));
    }
};

var EBEMailNotifierManager_CT2958529 =
{
    loginAccounts: new EBArrayHashObject2_CT2958529(),

    Reset: function() {
        EBEMailNotifierConsts_CT2958529.Images.EMailImage = 'chrome://browsersearch/skin/email.png';
    },

    GetAccountObjectByType: function(iAccountType, strEMail, strPassword, strPop3ServerURL, iPop3Port) {
        var objMailAccount = null;
        if (iAccountType == EBEmailAccountsTypes_CT2958529.GMail) {
            objMailAccount = new EBGmailAccount_CT2958529(strEMail, strPassword);
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.Yahoo) {
            objMailAccount = new EBYahooAccount_CT2958529(strEMail, strPassword);
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.Hotmail) {
            objMailAccount = new EBHotmailAccount_CT2958529(strEMail, strPassword);
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.RR) {
            objMailAccount = new EBRRAccount_CT2958529(strEMail, strPassword);
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.AOL) {
            objMailAccount = new EBAOLAccount_CT2958529(strEMail, strPassword);
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.Univision) {
            objMailAccount = new EBUnivisionAccount_CT2958529(strEMail, strPassword);
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.Pop3) {
            objMailAccount = new EBPop3Account_CT2958529(strEMail,
												strPassword,
												strPop3ServerURL,
												iPop3Port);
        }

        return objMailAccount;
    },

    GetAccountNameByType: function(iAccountType) {
        var strAccountName = '';
        if (iAccountType == EBEmailAccountsTypes_CT2958529.GMail) {
            strAccountName = EBEmailAccountsConsts_CT2958529.GMail.AccountName;
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.Yahoo) {
            strAccountName = EBEmailAccountsConsts_CT2958529.Yahoo.AccountName;
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.Hotmail) {
            strAccountName = EBEmailAccountsConsts_CT2958529.Hotmail.AccountName;
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.RR) {
            strAccountName = EBEmailAccountsConsts_CT2958529.RR.AccountName;
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.AOL) {
            strAccountName = EBEmailAccountsConsts_CT2958529.AOL.AccountName;
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.Univision) {
            strAccountName = EBEmailAccountsConsts_CT2958529.Univision.AccountName;
        }
        else if (iAccountType == EBEmailAccountsTypes_CT2958529.Pop3) {
            strAccountName = EBEmailAccountsConsts_CT2958529.Pop3.AccountName;
        }

        return strAccountName;
    },

    GetAccountTypeByEMail: function(strEMail) {
        var iAccountType = 0;
        if (this.IsSupportedEMailGMail(strEMail)) {
            iAccountType = EBEmailAccountsTypes_CT2958529.GMail;
        }
        else if (this.IsSupportedEMailYahoo(strEMail)) {
            iAccountType = EBEmailAccountsTypes_CT2958529.Yahoo;
        }
        else if (this.IsSupportedEMailHotmail(strEMail)) {
            iAccountType = EBEmailAccountsTypes_CT2958529.Hotmail;
        }
        else if (this.IsSupportedEMailRR(strEMail)) {
            iAccountType = EBEmailAccountsTypes_CT2958529.RR;
        }
        else if (this.IsSupportedEMailAOL(strEMail)) {
            iAccountType = EBEmailAccountsTypes_CT2958529.AOL;
        }
        else if (this.IsSupportedEMailUnivision(strEMail)) {
            iAccountType = EBEmailAccountsTypes_CT2958529.Univision;
        }

        return iAccountType;
    },


    GetUserNameByEMail: function(strFullEMail) {
        var strUserName = strFullEMail;
        var iIndexOfAT = strFullEMail.indexOf('@');
        if (iIndexOfAT != -1) {
            strUserName = strFullEMail.substring(0, iIndexOfAT);
        }

        return strUserName;
    },

    IsEMailDomain: function(AccountConstClass, strEMail) {
        var arrDomains = AccountConstClass.EMailDomain;
        for (var i = 0; i < arrDomains.length; i++) {
            if (strEMail.toLowerCase().indexOf(arrDomains[i]) != -1)
                return true;
        }

        return false;
    },

    IsRRDomain: function(strEMail) {
        if (!strEMail || strEMail.indexOf("@") == -1) return false;

        var arr = strEMail.split("@");
        var domain = arr[1];
        var topLevelDomain = EBUrl_CT2958529.GetTopLevelDomainName(domain, true);
        return (topLevelDomain.toLowerCase() == "rr.com" || topLevelDomain.toLowerCase() == "roadrunner.com");
    },

    IsSupportedEMail: function(strEMail, arrDomains) {
        var isSupported = false;
        for (var i = 0; i < arrDomains.length; i++) {
            isSupported = EBGlobalManager_CT2958529.EndsWith(strEMail, arrDomains[i]);
            if (isSupported) break;
        }
        return isSupported;
    },

    IsSupportedEMailGMail: function(strEMail) {
        var arrDomains = EBEmailAccountsConsts_CT2958529.GMail.EMailDomain;
        return this.IsSupportedEMail(strEMail, arrDomains);
    },

    IsSupportedEMailYahoo: function(strEMail) {
        var arrDomains = EBEmailAccountsConsts_CT2958529.Yahoo.EMailDomain;
        return this.IsSupportedEMail(strEMail, arrDomains);
    },

    IsSupportedEMailHotmail: function(strEMail) {
        var arrDomains = EBEmailAccountsConsts_CT2958529.Hotmail.EMailDomain;
        return this.IsSupportedEMail(strEMail, arrDomains);
    },

    IsSupportedEMailAOL: function(strEMail) {
        var arrDomains = EBEmailAccountsConsts_CT2958529.AOL.EMailDomain;
        return this.IsSupportedEMail(strEMail, arrDomains);
    },

    IsSupportedEMailRR: function(strEMail) {
        return this.IsRRDomain(strEMail);
    },

    IsSupportedEMailUnivision: function(strEMail) {
        var arrDomains = EBEmailAccountsConsts_CT2958529.Univision.EMailDomain;
        return this.IsSupportedEMail(strEMail, arrDomains);
    },

    IsSupportedEMailAccounts: function(strEMail) {
        return this.IsSupportedEMailGMail(strEMail)
				||
				this.IsSupportedEMailYahoo(strEMail)
				||
				this.IsSupportedEMailHotmail(strEMail)
				||
				this.IsSupportedEMailRR(strEMail)
				||
				this.IsSupportedEMailAOL(strEMail)
				||
                this.IsSupportedEMailUnivision(strEMail);
    },

    GetEMailDomainCaption: function(arrCaptionDomains) {
        var strDelimiter = EBEmailAccountsConsts_CT2958529.DomainCaptionDelimiter;
        var strDomainCaptions = '';
        for (var i = 0; i < arrCaptionDomains.length; i++) {
            if ((i + 1) == arrCaptionDomains.length) {
                strDelimiter = '';
            }
            strDomainCaptions += arrCaptionDomains[i] + strDelimiter;
        }

        return strDomainCaptions;
    },

    GetGMailDomainCaption: function() {
        var arrCaptionDomains = EBEmailAccountsConsts_CT2958529.GMail.EMailDomainCaption;
        return this.GetEMailDomainCaption(arrCaptionDomains);
    },

    GetYahooDomainCaption: function(strEMail) {
        var arrCaptionDomains = EBEmailAccountsConsts_CT2958529.Yahoo.EMailDomainCaption;
        return this.GetEMailDomainCaption(arrCaptionDomains);
    },

    GetHotmailDomainCaption: function(strEMail) {
        var arrCaptionDomains = EBEmailAccountsConsts_CT2958529.Hotmail.EMailDomainCaption;
        return this.GetEMailDomainCaption(arrCaptionDomains);
    },

    GetRRDomainCaption: function(strEMail) {
        var arrCaptionDomains = EBEmailAccountsConsts_CT2958529.RR.EMailDomainCaption;
        return this.GetEMailDomainCaption(arrCaptionDomains);
    },

    GetAOLDomainCaption: function(strEMail) {
        var arrCaptionDomains = EBEmailAccountsConsts_CT2958529.AOL.EMailDomainCaption;
        return this.GetEMailDomainCaption(arrCaptionDomains);
    },

    GetUnivisionDomainCaption: function(strEMail) {
        var arrCaptionDomains = EBEmailAccountsConsts_CT2958529.Univision.EMailDomainCaption;
        return this.GetEMailDomainCaption(arrCaptionDomains);
    }
};

//the object that the dialogs is used to handle the numbers of emails accounts
//that the user defined. the file of the emails is writing from this object.
//and the loading of the menu item to the toolbar component email notifier is using 
//the file to read all that accounts
function EBEMailAccountDataObject_CT2958529(strAccountName,
								strEMailAddress,
								strPassword,
								iAccountType,
								isAutoLogin,
								isStared,
								iNewMessages,
								strPop3Server,
								iPop3Port) {
    this.AccountName = strAccountName;
    this.EMailAddress = strEMailAddress;
    this.Password = strPassword;
    this.AccountType = iAccountType;
    this.AutoLogin = isAutoLogin;

    this.Stared = false;
    this.NewMessages = 0;
    this.Pop3Server = '';
    this.Pop3Port = 0;
    this.isPop3 = (strPop3Server || iAccountType == EBEmailAccountsTypes_CT2958529.RR) ? true : false;

    if (isStared) {
        this.Stared = isStared;
    }
    if (iNewMessages) {
        this.NewMessages = iNewMessages;
    }
    if (strPop3Server) {
        this.Pop3Server = strPop3Server;
    }
    if (iPop3Port) {
        this.Pop3Port = iPop3Port;
    }
};



var EBEmailNotifierManager_CT2958529 =
{
    xulBrowser: null,
    IsLogout: false,
    IsLoggedIn: false,
    IsListenerSet: false,
    Done: false,
    reload: false,

    secWarn:
    {
        secWarnEnt: null,
        secWarnExt: null,
        secWarnMixed: null
    },

    AccountInfo: null,

    OnDone: function(iInbox) {
        this.reload = false;
        try {
            this.xulBrowser.removeProgressListener(EmailWebListener_CT2958529);
        }
        catch (ex) { }

        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        this.xulBrowser.loadURIWithFlags('about:blank', Components.interfaces.nsIWebNavigation.LOAD_FLAGS_BYPASS_HISTORY, null, null);
        this.IsListenerSet = false;
        this.Done = true;
        this.AccountInfo.callbackNewMessages(iInbox);
        EBPreferenceService_CT2958529.SetPref("security.warn_entering_secure", this.secWarn.secWarnEnt);
        EBPreferenceService_CT2958529.SetPref("security.warn_leaving_secure", this.secWarn.secWarnExt);
        EBPreferenceService_CT2958529.SetPref("security.warn_viewing_mixed", this.secWarn.secWarnMixed);
    },

    CheckError: function(strUserName, strLoginUrl) {
        if (strUserName == EBEmailNotifierManager_CT2958529.AccountInfo.username
            &&
            strLoginUrl == EBEmailNotifierManager_CT2958529.AccountInfo.loginUrl
            &&
           !EBEmailNotifierManager_CT2958529.Done) {
            this.OnDone(EBEmailAccountsConsts_CT2958529.LOGIN_FAILED);
        }
    },

    UpdateAccountInfo: function(objData) {
        this.AccountInfo = objData;
        this.secWarn.secWarnEnt = EBPreferenceService_CT2958529.GetPref("security.warn_entering_secure");
        this.secWarn.secWarnExt = EBPreferenceService_CT2958529.GetPref("security.warn_leaving_secure");
        this.secWarn.secWarnMixed = EBPreferenceService_CT2958529.GetPref("security.warn_viewing_mixed");
    },

    ClearAccountInfo: function() {
        this.AccountInfo = null;
    },

    CheckForEmails: function(objData) {
        this.IsLoggedIn = false;
        this.Done = false;
        this.UpdateAccountInfo(objData);
        EBPreferenceService_CT2958529.SetPref("security.warn_entering_secure", false);
        EBPreferenceService_CT2958529.SetPref("security.warn_leaving_secure", false);
        EBPreferenceService_CT2958529.SetPref("security.warn_viewing_mixed", false);

        EBWeb_CT2958529.NavigationWithCallBack(objData.logoutUrl, EBEmailNotifierManager_CT2958529.GoToLoginPage);
        this.IsLogout = false;

        var checkForError = function() {
            EBEmailNotifierManager_CT2958529.CheckError(objData.username, objData.loginUrl);
        };

        setTimeout(checkForError, 50000);
        EBEmailNotifierManager_CT2958529.xulBrowser.docShell.allowImages = false;
    },

    GoToLoginPage: function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        EBEmailNotifierManager_CT2958529.xulBrowser.loadURIWithFlags(EBEmailNotifierManager_CT2958529.AccountInfo.loginUrl, oWindow.nsIWebNavigation.LOAD_FLAGS_BYPASS_HISTORY, null, null);
        if (!EBEmailNotifierManager_CT2958529.IsListenerSet) {
            EBEmailNotifierManager_CT2958529.xulBrowser.addProgressListener(EmailWebListener_CT2958529);
            EBEmailNotifierManager_CT2958529.IsListenerSet = true;
        }
    },

    Login: function(objWindow, isDocument) {
        if (this.IsLoggedIn) return;

        var objDocument = objWindow.document;
        var isMainFrame = objWindow.document.location.href == this.xulBrowser.currentURI.spec;
        if (EBEmailNotifierManager_CT2958529.AccountInfo.loginFunction) {
            var oldValSignon = EBPreferenceService_CT2958529.GetPref("signon.rememberSignons");
            EBPreferenceService_CT2958529.SetPref("signon.rememberSignons", false);

            var result = EBEmailNotifierManager_CT2958529.AccountInfo.loginFunction(objWindow, this.AccountInfo.username, this.AccountInfo.password, isMainFrame, isDocument);
            EBPreferenceService_CT2958529.SetPref("signon.rememberSignons", oldValSignon);
        }
        else {
            var oName = objDocument.getElementById(this.AccountInfo.inputIDs.username);
            var oPass = objDocument.getElementById(this.AccountInfo.inputIDs.password);
            var oSubmit = objDocument.getElementById(this.AccountInfo.inputIDs.submit);
            if (oName && oPass && oSubmit) {
                oName.value = this.AccountInfo.username;
                oPass.value = this.AccountInfo.password;
                var oldValSignon = EBPreferenceService_CT2958529.GetPref("signon.rememberSignons");
                EBPreferenceService_CT2958529.SetPref("signon.rememberSignons", false);
                if (this.AccountInfo.formName)
                    oSubmit.click();
                else
                    objDocument.forms[0].submit();

                EBPreferenceService_CT2958529.SetPref("signon.rememberSignons", oldValSignon);
                this.IsLoggedIn = true;
            }
        }
    },

    FindInbox: function(objWindow, isDocument) {
        var isMainFrame = objWindow.document.location.href == this.xulBrowser.currentURI.spec;
        if (this.AccountInfo.reloadPage && this.xulBrowser.currentURI.spec == this.AccountInfo.reloadPage && !this.reload) {
            this.xulBrowser.reload();
            this.reload = true;
        }
        //if continue button is found, click it and return
        if (this.CheckIntermidiatePage(objWindow.document, isDocument)) return;
        var iInbox = null;
        try {
            if (EBEmailNotifierManager_CT2958529.AccountInfo.checkFrames) {
                var arrFrames = EBGlobalManager_CT2958529.GetAllFrames(objWindow.document);

                var oFrame;
                if (arrFrames.length > 0) {
                    for (var i = 0; i < arrFrames.length; i++) {
                        oFrame = arrFrames[i];
                        if (this.AccountInfo.frameName && oFrame.name == this.AccountInfo.frameName || !this.AccountInfo.frameName) {
                            iInbox = this.AccountInfo.inboxCheckFunction(oFrame.contentWindow.document, objWindow, false, isDocument);
                            if (iInbox != null)
                                break;
                        }
                    }
                }
            }

        }
        catch (e) {
            EBLog(e);
        }
        if (iInbox == null && !this.AccountInfo.frameName)
            iInbox = this.AccountInfo.inboxCheckFunction(objWindow.document, objWindow, isMainFrame, isDocument);

        if (iInbox != null)
            this.OnDone(iInbox);

    },

    CheckIntermidiatePage: function(objDocument, isDocument) {
        var btnContinue = objDocument.getElementById("TakeMeToInbox");
        if (btnContinue && isDocument) {
            btnContinue.click();
            return true;
        }

        return false;
    },

    DocumentComplete: function(aProgress, isDocument) {
        var objWindow = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(aProgress.DOMWindow);

        if (this.IsLogout) {
            this.IsLogout = false;
            this.GoToLoginPage(objWindow.document);
        }
        else if (EBEmailNotifierManager_CT2958529.AccountInfo.inboxDomain &&
            objWindow.document.location.href.indexOf(EBEmailNotifierManager_CT2958529.AccountInfo.inboxDomain) != -1) {
            this.IsLoggedIn = true;
            this.FindInbox(objWindow, isDocument);
        }
        else if (!this.IsLoggedIn) {
            this.Login(objWindow, isDocument);
        }
        else {
            this.FindInbox(objWindow, isDocument);
        }
    }
};

function EBEmailAccount_CT2958529(userName) {
    this.userName = userName;
    this.iInbox = 0;
};

var EBEMailNotifierToolbarManager_CT2958529 =
{
    MailAccountsCollection: null,

    TimeoutID: null,

    //var to check if the button is stared on the onhidden popup
    //so just if it is stared i nullify the stars and write to the file
    ButtonStared: false,

    Sound: null,

    OnLoadToolbarEMailNotifier: function() {
        //set the mail collection from the file
        this.MailAccountsCollection = this.AccountsFileToAccountsCollection();

        //set the on hidden popup event (to clear the stars when it closed!)
        this.RemoveToolbarMailAccounts();
        this.BuildToolbarMailAccounts();
        this.CheckToolbarMenuItemsMailAccounts(false);
    },

    OnUnloadToolbarEMailNotifier: function() {
        var oEmailNotifierToolbarButton = EBComponentsManager_CT2958529.GetEMailNotifierToolbarButton();
        if (oEmailNotifierToolbarButton) {
            this.RemoveToolbarMailAccounts();
            this.ClearMailAccountsTimeoutID();
        }
    },

    OnCommandSettingsOKButton: function(oMailAccountsCollection) {
        this.RemoveToolbarMailAccounts();

        //get the accounts from the dialog accounts collection
        this.MailAccountsCollection = oMailAccountsCollection;

        //write the changes to the file
        this.AccountsCollectionToAccountsFile(this.MailAccountsCollection);

        //send the changes to the rest of the open browsers
        this.BroadcastChangesToAllBrowsers();

        this.BuildToolbarMailAccounts();

        this.CheckToolbarMenuItemsMailAccounts(true);
    },

    OnMenuPopupHidden: function(event) {
        //check if the button is already not stared so no need to nullify it!
        if (!this.ButtonStared) return;

        //clear all the stars 
        var arrAccounts = this.MailAccountsCollection.Arr;
        var i;
        for (i = 0; i < arrAccounts.length; i++)
            arrAccounts[i].Stared = false;

        //update the button and all the menu item
        //button image update
        this.SetToolbarButtonImageTooltip(false);
        //menu items image update
        var objMenuItemsMailAccounts = this.GetMenuItemsMailAccounts();
        var objMenuItem = null;
        var strCurrentImage = '';
        for (i = 0; i < objMenuItemsMailAccounts.length; i++) {
            objMenuItem = objMenuItemsMailAccounts.item(i);
            strCurrentImage = objMenuItem.getAttribute('image');
            if (strCurrentImage == EBEMailNotifierConsts_CT2958529.Images.StarImage)
                objMenuItem.setAttribute('image', EBEMailNotifierConsts_CT2958529.Images.BlankImage);
        }

        //write the file
        this.AccountsCollectionToAccountsFile(this.MailAccountsCollection);
        this.BroadcastChangesToAllBrowsers();
    },

    GetMenuItemsMailAccounts: function() {
        var objXULMenuPopup = this.GetXULToolbarMenuPopup();

        var objMenuItemsMailAccounts = objXULMenuPopup.getElementsByAttribute(EBEMailNotifierConsts_CT2958529.Attributes.MAIL_ACCOUNT, EBEMailNotifierConsts_CT2958529.Attributes.MAIL_ACCOUNT_VALUE);

        return objMenuItemsMailAccounts;
    },

    GetMenuItemAccountIndex: function(objMenuItemMailAccount) {
        var objMenuItemsMailAccounts = this.GetMenuItemsMailAccounts();

        for (var i = 0; i < objMenuItemsMailAccounts.length; i++) {
            if (objMenuItemsMailAccounts.item(i) == objMenuItemMailAccount) {
                return i;
            }
        }

        return -1;
    },

    BuildToolbarMailAccounts: function() {
        var arrAccounts = this.MailAccountsCollection.Arr;
        var objAccountData;

        if (!arrAccounts || arrAccounts.length == 0) {
            //set the default caption of the button 
            this.SetToolbarButtonDefaulCaption();
            this.SetToolbarButtonImageTooltip(false);

            //remove the separator if there is no accounts
            this.ShowHideSeparatorCheckMenuItems(true);
        }
        else {
            //set button defalt caption with elements ([0 new])
            this.SetToolbarButtonCaption(0);

            this.SetToolbarButtonImageTooltip(this.IsButtonToStared());

            //add the separator and the check menu items
            this.ShowHideSeparatorCheckMenuItems(false);

            for (var i = 0; i < arrAccounts.length; i++) {
                objAccountData = arrAccounts[i];
                this.BuildToolbarMenuItemMailAccount(objAccountData);
            }


        }
    },

    //check if one of the accounts are stared to star 
    //the main button
    IsButtonToStared: function() {
        var arrAccounts = this.MailAccountsCollection.Arr;
        for (var i = 0; i < arrAccounts.length; i++) {
            if (arrAccounts[i].Stared) {
                return true;
            }
        }

        return false;
    },

    BuildToolbarMenuItemMailAccount: function(objAccountData) {
        var objXULMenuPopup = this.GetXULToolbarMenuPopup();

        var strLabel = '';
        var strImage = '';
        var strAccelText = '';
        var objCommand = function(event) {
            EBEMailNotifierToolbarManager_CT2958529.OnCommandMenuItemMailAccount(event);
            event.cancelBubble = true;
        };
        var arrData = new Array();

        objAccountData.NewMessages = parseInt(objAccountData.NewMessages);

        strLabel = this.GetMailAccountFullCaption(objAccountData);
        strImage = this.GetMailAccountImage(objAccountData);
        strAccelText = this.GetMailAccountAccelText(objAccountData);

        //build the attributes 
        //special attribute to distinguish between mail account menu item and othe menu items(check,settings)
        arrData[EBEMailNotifierConsts_CT2958529.Attributes.MAIL_ACCOUNT] = EBEMailNotifierConsts_CT2958529.Attributes.MAIL_ACCOUNT_VALUE;
        arrData[EBEMailNotifierConsts_CT2958529.Attributes.EMAIL] = objAccountData.EMailAddress;
        arrData[EBEMailNotifierConsts_CT2958529.Attributes.PASSWORD] = objAccountData.Password;
        arrData[EBEMailNotifierConsts_CT2958529.Attributes.ACCOUNT_TYPE] = objAccountData.AccountType;
        arrData[EBEMailNotifierConsts_CT2958529.Attributes.AUTO_LOGIN] = objAccountData.AutoLogin;
        arrData[EBEMailNotifierConsts_CT2958529.Attributes.POP3_SERVER] = objAccountData.Pop3Server;
        arrData[EBEMailNotifierConsts_CT2958529.Attributes.POP3_PORT] = objAccountData.Pop3Port;

        var objXULMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strLabel, strImage, objAccountData.EMailAddress, objCommand, "", arrData);
        objXULMenuItem.setAttribute("acceltext", strAccelText);

        var objXULSeparatorItem = this.GetXULToolbarSeparatorItem();
        objXULMenuPopup.insertBefore(objXULMenuItem, objXULSeparatorItem);

        //update the main button caption
        if (objAccountData.NewMessages != EBEmailAccountsConsts_CT2958529.LOGIN_FAILED)
            this.UpdateButtonNewMessages(objAccountData.NewMessages);
    },

    ClearMailAccountsTimeoutID: function() {
        if (this.TimeoutID)
            clearTimeout(this.TimeoutID);

        this.TimeoutID = null;
    },

    RemoveToolbarMailAccounts: function() {
        var objMenuItemsMailAccounts = this.GetMenuItemsMailAccounts();
        while (objMenuItemsMailAccounts.length > 0) {
            this.RemoveToolbarMailAccount(objMenuItemsMailAccounts.item(objMenuItemsMailAccounts.length - 1));

            //get the objMenuItemsMailAccounts due to a bug in Firefox 1.0.7
            //probably the getElementsByAttribute not related to the dom in 1.0.7
            objMenuItemsMailAccounts = this.GetMenuItemsMailAccounts();
        }
    },

    RemoveToolbarMailAccount: function(objMenuItemMailAccount) {
        //remove the menu item
        var objXULMenuPopup = this.GetXULToolbarMenuPopup();
        objXULMenuPopup.removeChild(objMenuItemMailAccount);
    },

    OnCommandCheckForNewEMailsButton: function() {
        //re-check all accounts
        this.CheckToolbarMenuItemsMailAccounts(true);

        //usage
        EBUsageEmailNotifier_CT2958529.OnCheckForNewEmails();
    },

    CheckToolbarMenuItemsMailAccounts: function(isForceCheck) {
        if (isForceCheck || this.IsPollDateElapsed()) {
            this.CheckMailAccountsFromServers();
        }

        //make the interval call
        this.SetTimeoutAccountsCheck();
    },

    //check if need to make a master check(check from server) or not(check from file)
    IsPollDateElapsed: function() {
        var strPollDate = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EMailNotifierPollDate);
        if (strPollDate == null || strPollDate == "") {
            return true;
        }

        var objCurrentDate = new Date();
        var objPollDate = new Date(strPollDate);

        var iCheckIntervalTime = this.GetCheckAccountIntervalTime();

        var iDateDiff = objCurrentDate - objPollDate;

        return iDateDiff > iCheckIntervalTime;
    },

    SetPollDatePreference: function() {
        var objCurrentDate = new Date();
        var strDateValue = objCurrentDate.toString();
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EMailNotifierPollDate, strDateValue);
    },

    //this call actually check the accounts using the account objects(using GetNewMessages function)
    //and the rest of the open browsers update themselves from the file each interval time
    CheckMailAccountsFromServers: function() {
        //set the time of the check
        this.SetPollDatePreference();

        this.SetCurrentSound();

        var objMenuItemsMailAccounts = this.GetMenuItemsMailAccounts();
        var objMenuItemMailAccount = null;
        var objAccountData = null;

        var iLastIndex = this.MailAccountsCollection.Arr.length - 1;

        //start the check from the last child(menu item mail account) and in the end of each check 
        //the current child call the prev child email check till the first and vice-verse
        objMenuItemMailAccount = objMenuItemsMailAccounts.item(iLastIndex);
        objAccountData = this.MailAccountsCollection.GetItem(iLastIndex);

        if (objMenuItemMailAccount && objAccountData) {
            var objIntervalFunction = function() {
                EBEMailNotifierToolbarManager_CT2958529.CheckToolbarMenuItemMailAccount(objMenuItemMailAccount, objAccountData);
            }
            setTimeout(objIntervalFunction, 100);
        }
    },

    CheckToolbarMenuItemMailAccount: function(objXULMenuItem, objAccountData) {
        var strLoginEMail = objAccountData.EMailAddress;
        var strLoginPassword = objAccountData.Password;
        var strPop3MailServerURL = objAccountData.Pop3Server;
        var iPop3Port = objAccountData.Pop3Port;

        var objMailAccount = EBEMailNotifierManager_CT2958529.GetAccountObjectByType(objAccountData.AccountType,
																			strLoginEMail,
																			strLoginPassword,
																			strPop3MailServerURL,
																			iPop3Port);

        if (objMailAccount) {
            var objCallBackFunction = function(iNewMessages) {
                EBEMailNotifierToolbarManager_CT2958529.CheckToolbarMenuItemMailAccountCallBack(objXULMenuItem, objAccountData, iNewMessages);
            };

            objMailAccount.GetNewMessagesCount(objCallBackFunction);
        }
    },

    IsMenuItemMailAccountChild: function(objMenuItemMailAccountChild) {
        var objMenuItemsMailAccounts = this.GetMenuItemsMailAccounts();
        for (var i = 0; i < objMenuItemsMailAccounts.length; i++) {
            if (objMenuItemsMailAccounts.item(i) == objMenuItemMailAccountChild) {
                return true;
            }
        }
        return false;
    },

    CheckToolbarMenuItemMailAccountCallBack: function(objXULMenuItem, objAccountData, iNewMessages) {
        //check to see if the callback menuitem is still part of the 
        //email notifier dom elements - and if not terminate it
        //the check is perform due to too much reqeusts (the close dialogs,refresh toolbar)
        //so the timeouts can get out of mix - that is why i check it!
        if (!this.IsMenuItemMailAccountChild(objXULMenuItem)) {
            return;
        }

        //the changes coming back from the thread are only occur to the
        //data objects - the changes to the GUI (menu items) occur
        //in end of each cycle (and then broadcast to all browsers!

        iNewMessages = parseInt(iNewMessages);
        objAccountData.NewMessages = parseInt(objAccountData.NewMessages);

        var isStared = false;

        //flag determine if to perform new messages for this menuitem

        if (iNewMessages <= 0) {
            isStared = false;
        }
        else if (iNewMessages > objAccountData.NewMessages) {
            isStared = true;

        }
        else {
            //if this element was stared i don't change it
            if (objAccountData.Stared) {
                isStared = true;
            }
        }

        //update the object data:
        var iOldMessages = objAccountData.NewMessages;

        //if there is another login the data new messages is stay put
        if (iNewMessages != EBEmailAccountsConsts_CT2958529.LOGIN_ANOTHER_ACCOUNT) {
            objAccountData.NewMessages = iNewMessages;
        }
        objAccountData.Stared = isStared;


        this.UpdateToolbarMenuItemMailAccount(objXULMenuItem, objAccountData, iOldMessages);


        //check the previous account in the list (the check is one by one!)
        this.CheckPreviousAccount(objXULMenuItem);

    },

    UpdateToolbarMenuItemMailAccount: function(objXULMenuItem, objAccountData, iOldMessages) {
        //set label and stared for this menu item:
        var isStared = objAccountData.Stared;
        var iNewMessages = objAccountData.NewMessages;

        var strLabel = this.GetMailAccountFullCaption(objAccountData);
        var strImage = this.GetMailAccountImage(objAccountData);
        var strAccelText = this.GetMailAccountAccelText(objAccountData);


        objXULMenuItem.setAttribute("label", strLabel);
        objXULMenuItem.setAttribute("image", strImage);
        EBUILogic_Functions_CT2958529.setAcceltext(objXULMenuItem, strAccelText);

        var isChanged = false;

        //update the button caption:
        if (iNewMessages != EBEmailAccountsConsts_CT2958529.LOGIN_ANOTHER_ACCOUNT) {
            if (iNewMessages != iOldMessages) {
                isChanged = true;
                //check if it's failed to set the message to zero (for the subtract from the main button the old messages)
                if (iNewMessages == EBEmailAccountsConsts_CT2958529.LOGIN_FAILED) {
                    iNewMessages = 0;
                }
                else if (iOldMessages == EBEmailAccountsConsts_CT2958529.LOGIN_FAILED) {
                    iOldMessages = 0;
                }

                var iDiffMessages = iNewMessages - iOldMessages;
                this.UpdateButtonNewMessages(iDiffMessages);
            }
        }


        if (isStared) {
            //update image and tooltip
            this.SetToolbarButtonImageTooltip(true);

            //play music only if it's stared (new email)
            //and it's not the state like before 
            //only when the user got new email the first time
            if (isChanged) {
                //check if to play the sound
                this.CheckNewEMailPlaySound();
            }
        }

        if (isChanged) {
            //write the changes to the accounts file:
            this.AccountsCollectionToAccountsFile(this.MailAccountsCollection);
            //broadcast to all elements
            this.BroadcastChangesToAllBrowsers();
        }

    },

    CheckPreviousAccount: function(objXULMenuItem) {
        var objMenuItemsMailAccounts = this.GetMenuItemsMailAccounts();
        var objMenuItemMailAccount = null;
        var objAccountData = null;

        var iIndex = this.GetMenuItemAccountIndex(objXULMenuItem);
        var iAccountsLength = this.MailAccountsCollection.Arr.length;

        var iPreviousIndex = iIndex - 1;

        if (iPreviousIndex >= 0) {
            objMenuItemMailAccount = objMenuItemsMailAccounts.item(iPreviousIndex);
            objAccountData = this.MailAccountsCollection.GetItem(iPreviousIndex);

            this.CheckToolbarMenuItemMailAccount(objMenuItemMailAccount, objAccountData);
        }
        else {
            //check if there is new message to update the button
            //if there is no new messages we also need to update the button to be
            //not stared in case it was stared before and now there is no msg and need
            //to be stared off
            var bIsToStared = this.IsThereIsNewMessages();
            this.SetToolbarButtonImageTooltip(bIsToStared);

        }
    },

    //check from all the accounts if there is one that there is new message
    IsThereIsNewMessages: function() {
        var oCollection = this.MailAccountsCollection;
        if (oCollection) {
            var arrAccounts = oCollection.Arr;
            var oAccount = null;
            for (var i = 0; i < arrAccounts.length; i++) {
                oAccount = oCollection.GetItem(i);
                if (oAccount.Stared) {
                    return true;
                }
            }
        }

        return false;
    },

    //set the changes from the file to all open browsers
    BroadcastChangesToAllBrowsers: function() {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        for (var i = 0; i < arrWindows.length; i++) {
            var objWindow = arrWindows[i];
            if (objWindow != window) {
                if (objWindow.EBEMailNotifierToolbarManager_CT2958529.RebuildMailAccountsFromFile) {
                    //try-catch to avoid other browsers when they email notifier
                    //is hidden so the xul elements not loaded and it can cause an exception
                    try {
                        objWindow.EBEMailNotifierToolbarManager_CT2958529.RebuildMailAccountsFromFile();
                    }
                    catch (ex) { }
                }
            }
        }
    },

    RebuildMailAccountsFromFile: function() {
        this.MailAccountsCollection = this.AccountsFileToAccountsCollection();
        this.RemoveToolbarMailAccounts();
        this.BuildToolbarMailAccounts();
    },

    SetTimeoutAccountsCheck: function() {
        var iIntervalTime = this.GetCheckAccountIntervalTime();

        var objIntervalFunction = function() {
            EBEMailNotifierToolbarManager_CT2958529.CheckToolbarMenuItemsMailAccounts(false);
        };

        this.ClearMailAccountsTimeoutID();

        this.TimeoutID = setTimeout(objIntervalFunction, iIntervalTime);
    },

    GetCheckAccountIntervalTime: function() {
        var iMinutes = EBEMailNotifierConsts_CT2958529.DefaultIntervalMinutes;
        //check from the prefs and if there isn't take the default from the button settings definition
        var oEmailNotifierToolbarButton = EBComponentsManager_CT2958529.GetEMailNotifierToolbarButton();
        if (oEmailNotifierToolbarButton) {
            iMinutes = oEmailNotifierToolbarButton.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.CHECK_NEW_EMAIL_INTERVAL);
            var iMinutesFromPref = this.GetCheckIntervalPref();
            if (iMinutesFromPref && isFinite(iMinutesFromPref)) {
                iMinutes = iMinutesFromPref;
            }
        }
        return iMinutes * 60 * 1000;
    },

    OnCommandMenuItemMailAccount: function(event) {
        var objXULMenuItem = event.target;

        var strEMail = objXULMenuItem.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.EMAIL);
        var strPassword = objXULMenuItem.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.PASSWORD);
        var iAccountType = objXULMenuItem.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.ACCOUNT_TYPE);
        var isAutoLogin = objXULMenuItem.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.AUTO_LOGIN);
        isAutoLogin = isAutoLogin == 'true' ? true : false;
        var strPop3Server = objXULMenuItem.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.POP3_SERVER);
        var strPop3Port = objXULMenuItem.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.POP3_PORT);
        var win = (isFloatingMode_CT2958529) ? EBGlobalManager_CT2958529.GetMostRecentBrowserWindow() : window;
        var objMailAccount = win.EBEMailNotifierManager_CT2958529.GetAccountObjectByType(iAccountType,
																			strEMail,
																			strPassword,
																			strPop3Server,
																			strPop3Port);

        var accounts = EBEMailNotifierManager_CT2958529.loginAccounts;
        //this account is already in login process
        if (accounts.Contains(strEMail))
            return;
        //cancel login for all other accounts
        else {
            var account = null;
            for (var i = 0; i < accounts.Count(); i++) {
                account = accounts.GetByIndex(i);
                account.cancelLogin = true;
            }
            accounts.Add(strEMail, objMailAccount);
        }
        if (objMailAccount) {
            if (isAutoLogin)
                objMailAccount.Login(event);
            else
                objMailAccount.Logout(event);
        }

        if (isFloatingMode_CT2958529 && !isAIOMode_CT2958529) window.close();
        //request usage
        EBUsageEmailNotifier_CT2958529.OnAccountOpen();
    },

    GetXULToolbarMenuPopup: function() {
        var oEmailNotifierComponent = EBComponentsManager_CT2958529.GetEMailNotifierComponent();
        return oEmailNotifierComponent.dynamicMenuComponent.XULMenuPopup;
    },

    OnMenuPopupShowing: function(event) {
        if (event.eventPhase == 2) {
            var iNumOfAccunts = 0;

            if (this.MailAccountsCollection && this.MailAccountsCollection.Arr) {
                iNumOfAccunts = this.MailAccountsCollection.Arr.length;
            }
        }
    },

    ShowHideSeparatorCheckMenuItems: function(isHide) {
        var objXULToolbarSeparatorItem = this.GetXULToolbarSeparatorItem();
        var objXULToolbarCheckMenuItem = this.GetXULToolbarCheckForNewEMailMenuItem();

        if (isHide) {
            objXULToolbarSeparatorItem.setAttribute('style', 'display:none;');
            objXULToolbarCheckMenuItem.setAttribute('style', 'display:none;');
        }
        else {
            objXULToolbarSeparatorItem.removeAttribute('style');
            objXULToolbarCheckMenuItem.removeAttribute('style');
        }
    },

    //the separator that separates between the accounts and the configuration
    GetXULToolbarSeparatorItem: function() {
        var objXULMenuPopup = this.GetXULToolbarMenuPopup();
        return objXULMenuPopup.childNodes[objXULMenuPopup.childNodes.length - 3];
    },

    GetXULToolbarCheckForNewEMailMenuItem: function() {
        var objXULMenuPopup = this.GetXULToolbarMenuPopup();
        return objXULMenuPopup.childNodes[objXULMenuPopup.childNodes.length - 2];
    },

    UpdateButtonNewMessages: function(iNewMessages) {
        var iCurrentTotalNewMessages = this.GetToolbarButtonTotalNewMessages();
        iCurrentTotalNewMessages += parseInt(iNewMessages);

        if (iCurrentTotalNewMessages < 0) {
            iCurrentTotalNewMessages = 0;
        }
        this.SetToolbarButtonCaption(iCurrentTotalNewMessages);


    },

    SetToolbarButtonCaption: function(iNewMessages) {
        var oEmailNotifier = EBComponentsManager_CT2958529.GetEMailNotifierComponent();
        if (oEmailNotifier) {
            var strCaption = '[' + iNewMessages + ']';
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EMailNotifierLabelLength, strCaption.length + 2);
            oEmailNotifier.UpdateUI(strCaption);
            var oEmailNotifierToolbarButton = EBComponentsManager_CT2958529.GetEMailNotifierToolbarButton();
            oEmailNotifierToolbarButton.setAttribute(EBEMailNotifierConsts_CT2958529.Attributes.TOTAL_NEW_MESSAGES, iNewMessages);
        }
    },

    GetToolbarButtonTotalNewMessages: function() {
        var iTotalNewMessages = 0;
        var oEmailNotifierToolbarButton = EBComponentsManager_CT2958529.GetEMailNotifierToolbarButton();
        if (oEmailNotifierToolbarButton) {
            var strTotalNewMessages = oEmailNotifierToolbarButton.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.TOTAL_NEW_MESSAGES);
            iTotalNewMessages = parseInt(strTotalNewMessages);
        }

        return iTotalNewMessages;
    },

    SetToolbarButtonDefaulCaption: function() {
        var oEmailNotifierToolbarButton = EBComponentsManager_CT2958529.GetEMailNotifierToolbarButton();
        var oEmailNotifier = EBComponentsManager_CT2958529.GetEMailNotifierComponent();
        if (oEmailNotifier) {
            var strDefaultCaption = oEmailNotifierToolbarButton.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.DEFAULT_CAPTION);
            oEmailNotifier.UpdateUI(strDefaultCaption);
        }
    },


    SetToolbarButtonImageTooltip: function(isStared) {
        var oEmailNotifierToolbarButton = EBComponentsManager_CT2958529.GetEMailNotifierToolbarButton();
        if (oEmailNotifierToolbarButton) {
            var strImage = EBEMailNotifierConsts_CT2958529.Images.EMailImage;
            var strTooltip = oEmailNotifierToolbarButton.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.DEFAULT_TOOLTIP);

            this.ButtonStared = isStared;
            if (isStared) {
                strTooltip = oEmailNotifierToolbarButton.getAttribute(EBEMailNotifierConsts_CT2958529.Attributes.STARED_TOOLTIP);
            }
            EBImageHandler_CT2958529.UpdateStar(oEmailNotifierToolbarButton, isStared);

            //ask if has attribute not to ruin the  tooltip shrink 
            if (oEmailNotifierToolbarButton.hasAttribute('tooltiptext')) {
                oEmailNotifierToolbarButton.setAttribute('tooltiptext', strTooltip);
            }
        }
    },

    GetMailAccountFullCaption: function(objAccountData) {
        return objAccountData.AccountName;
    },

    GetMailAccountAccelText: function(objAccountData) {
        var iNewMessages = objAccountData.NewMessages;
        var strCaption = "";
        var text = (objAccountData.isPop3) ?
                oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_GLOBAL_TOTAL") :
                oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_GLOBAL_UNREAD");

        if (iNewMessages >= 0)
            strCaption = ' [' + iNewMessages + ' ' + text + '] ';
        else if (iNewMessages == EBEmailAccountsConsts_CT2958529.LOGIN_FAILED)
            strCaption = this.GetMailAccountFailedCaption();
        return strCaption;

    },

    GetMailAccountFailedCaption: function() {
        return ' [' + oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_EMAIL_NOTIFIER_TEST_DLG_FAILED") + ']';
    },

    GetMailAccountImage: function(objAccountData) {
        var strImage = '';
        if (objAccountData.Stared) {
            strImage = EBEMailNotifierConsts_CT2958529.Images.StarImage;
        }
        else if (objAccountData.NewMessages == EBEmailAccountsConsts_CT2958529.LOGIN_FAILED) {
            strImage = EBEMailNotifierConsts_CT2958529.Images.X_Image;
        }
        else {
            strImage = EBEMailNotifierConsts_CT2958529.Images.BlankImage;
        }

        return strImage;
    },

    CreateEMailNotifierToolbarFile: function(strPath) {
        var strEMailNotifierPath = EBEMailNotifierConsts_CT2958529.EMailNotifierDirectory + EBDirIO_CT2958529.sep + strPath;
        var objFile = EBIOManager_CT2958529.CreateToolbarFile(strEMailNotifierPath);
        return objFile;
    },

    GetToolbarAccountsXMLFile: function() {
        var objAccountsFile = this.CreateEMailNotifierToolbarFile(EBEMailNotifierConsts_CT2958529.EMailNotifierAccountsFileName);
        return objAccountsFile;
    },

    CheckNewEMailPlaySound: function() {
        if (this.Sound &&
			this.Sound != EBEMailNotifierConsts_CT2958529.Sound.NONE) {
            var strSoundFilePath = '';
            if (this.Sound == EBEMailNotifierConsts_CT2958529.Sound.DEFAULT) {
                strSoundFilePath = EBEMailNotifierConsts_CT2958529.Sound.DefaultWavChromePath;
            }
            else {
                strSoundFilePath = this.Sound;
            }
            EBGlobalManager_CT2958529.PlaySound(strSoundFilePath);
        }
    },

    SetCurrentSound: function() {
        this.Sound = this.GetSoundPref();
    },

    GetSoundPrefName: function() {
        var strPrefName = EBPreferenceConsts_CT2958529.EMailNotifierSound;
        return strPrefName;
    },

    SaveSoundPref: function(strSound) {
        var strSoundPrefName = this.GetSoundPrefName();
        EBToolbarPreferenceManager_CT2958529.SetPref(strSoundPrefName, strSound);
    },

    GetSoundPref: function() {
        var strSoundPrefName = this.GetSoundPrefName();

        var strSound = '';
        if (!EBToolbarPreferenceManager_CT2958529.HasUserValue(strSoundPrefName)) {
            strSound = EBEMailNotifierConsts_CT2958529.Sound.NONE;
        }
        else {
            strSound = EBToolbarPreferenceManager_CT2958529.GetPref(strSoundPrefName);
        }

        return strSound;
    },

    GetCheckIntervalPrefName: function() {
        var strPrefName = EBPreferenceConsts_CT2958529.EMailNotifierCheckInterval;
        return strPrefName;
    },

    SaveCheckIntervalPref: function(iMinutesValue) {
        var strCheckIntervalPrefName = this.GetCheckIntervalPrefName();
        EBToolbarPreferenceManager_CT2958529.SetPref(strCheckIntervalPrefName, iMinutesValue);
    },

    GetCheckIntervalPref: function() {
        var strCheckIntervalPrefName = this.GetCheckIntervalPrefName();
        var iMinutesValue = EBToolbarPreferenceManager_CT2958529.GetPref(strCheckIntervalPrefName);

        return iMinutesValue;
    },


    AccountsFileToAccountsCollection: function() {
        var objAccountsCollection = new EBArrayCollection_CT2958529();

        var strContent = this.LoadAccountsFile();

        if (!strContent)
            return objAccountsCollection;

        var XMLDoc = EBXML_CT2958529.GetXmlDocument(strContent);
        var XMLRoot = XMLDoc.documentElement;

        var objAccountData = null;

        if (XMLRoot.tagName == EBEMailNotifierConsts_CT2958529.XML.ACCOUNTS) {
            var objXMLAccounts = XMLRoot.getElementsByTagName(EBEMailNotifierConsts_CT2958529.XML.ACCOUNT);
            var objXMLAccount = null;
            var objXMLNode = null;

            var strName = '';
            var strEMail = '';
            var strPassword = '';
            var strServer = '';
            var iPort = 0;
            var iType = -1;
            var isAutoLogin = true;
            var isStared = false;
            var iNewMessages = 0;
            var isPop3 = false;

            for (var i = 0; i < objXMLAccounts.length; i++) {
                objXMLAccount = objXMLAccounts.item(i);
                for (var j = 0; j < objXMLAccount.childNodes.length; j++) {
                    objXMLNode = objXMLAccount.childNodes[j];
                    if (objXMLNode.tagName == EBEMailNotifierConsts_CT2958529.XML.NAME) {
                        strName = EBXML_CT2958529.GetXmlNodeValue(objXMLNode);
                    }
                    else if (objXMLNode.tagName == EBEMailNotifierConsts_CT2958529.XML.EMAIL) {
                        strEMail = EBXML_CT2958529.GetXmlNodeValue(objXMLNode);
                    }
                    else if (objXMLNode.tagName == EBEMailNotifierConsts_CT2958529.XML.PASSWORD) {
                        strPassword = EBXML_CT2958529.GetXmlNodeValue(objXMLNode);
                    }
                    else if (objXMLNode.tagName == EBEMailNotifierConsts_CT2958529.XML.SERVER) {
                        strServer = EBXML_CT2958529.GetXmlNodeValue(objXMLNode);
                    }
                    else if (objXMLNode.tagName == EBEMailNotifierConsts_CT2958529.XML.PORT) {
                        iPort = EBXML_CT2958529.GetXmlNodeValue(objXMLNode);
                    }
                    else if (objXMLNode.tagName == EBEMailNotifierConsts_CT2958529.XML.TYPE) {
                        iType = EBXML_CT2958529.GetXmlNodeValue(objXMLNode);
                    }
                    else if (objXMLNode.tagName == EBEMailNotifierConsts_CT2958529.XML.AUTO_LOGIN) {
                        var strIsLogin = EBXML_CT2958529.GetXmlNodeValue(objXMLNode);
                        isAutoLogin = strIsLogin == 'true' ? true : false;
                    }
                    else if (objXMLNode.tagName == EBEMailNotifierConsts_CT2958529.XML.STARED) {
                        var strIsStared = EBXML_CT2958529.GetXmlNodeValue(objXMLNode);
                        isStared = strIsStared == 'true' ? true : false;
                    }
                    else if (objXMLNode.tagName == EBEMailNotifierConsts_CT2958529.XML.NEW_MESSAGES) {
                        iNewMessages = EBXML_CT2958529.GetXmlNodeValue(objXMLNode);
                    }

                }

                objAccountData = new EBEMailAccountDataObject_CT2958529(strName,
															strEMail,
															strPassword,
															iType,
															isAutoLogin,
															isStared,
															iNewMessages,
															strServer,
															iPort,
															isPop3);

                objAccountsCollection.AppendElement(objAccountData);
            }
        }

        return objAccountsCollection;
    },

    AccountsCollectionToAccountsFile: function(objAccountsCollection) {
        var strRootXML = '<' + EBEMailNotifierConsts_CT2958529.XML.ACCOUNTS + '></' + EBEMailNotifierConsts_CT2958529.XML.ACCOUNTS + '>'
        var XMLDoc = EBXML_CT2958529.GetXmlDocument(strRootXML);

        var XMLRoot = XMLDoc.documentElement;

        var XMLNodeAccount = null;
        var XMLNodeName = null;
        var XMLNodeEMail = null;
        var XMLNodePassword = null;
        var XMLNodeServer = null;
        var XMLNodePort = null;
        var XMLNodeType = null;
        var XMLNodeAutoLogin = null;
        var XMLNodeStared = null;
        var XMLNodeNewMessages = null;

        var arrAccounts = objAccountsCollection.Arr;

        for (var i = 0; i < arrAccounts.length; i++) {
            XMLNodeAccount = XMLDoc.createElement(EBEMailNotifierConsts_CT2958529.XML.ACCOUNT);

            XMLNodeName = EBXML_CT2958529.CreateXmlTextNode(XMLDoc,
																	EBEMailNotifierConsts_CT2958529.XML.NAME,
																	arrAccounts[i].AccountName);
            XMLNodeEMail = EBXML_CT2958529.CreateXmlTextNode(XMLDoc,
																	EBEMailNotifierConsts_CT2958529.XML.EMAIL,
																	arrAccounts[i].EMailAddress);
            XMLNodePassword = EBXML_CT2958529.CreateXmlTextNode(XMLDoc,
																	EBEMailNotifierConsts_CT2958529.XML.PASSWORD,
																	arrAccounts[i].Password);
            XMLNodeServer = EBXML_CT2958529.CreateXmlTextNode(XMLDoc,
																	EBEMailNotifierConsts_CT2958529.XML.SERVER,
																	arrAccounts[i].Pop3Server);
            XMLNodePort = EBXML_CT2958529.CreateXmlTextNode(XMLDoc,
																	EBEMailNotifierConsts_CT2958529.XML.PORT,
																	arrAccounts[i].Pop3Port);
            XMLNodeType = EBXML_CT2958529.CreateXmlTextNode(XMLDoc,
																	EBEMailNotifierConsts_CT2958529.XML.TYPE,
																	arrAccounts[i].AccountType);
            XMLNodeAutoLogin = EBXML_CT2958529.CreateXmlTextNode(XMLDoc,
																	EBEMailNotifierConsts_CT2958529.XML.AUTO_LOGIN,
																	arrAccounts[i].AutoLogin);
            XMLNodeStared = EBXML_CT2958529.CreateXmlTextNode(XMLDoc,
																	EBEMailNotifierConsts_CT2958529.XML.STARED,
																	arrAccounts[i].Stared);
            XMLNodeNewMessages = EBXML_CT2958529.CreateXmlTextNode(XMLDoc,
																	EBEMailNotifierConsts_CT2958529.XML.NEW_MESSAGES,
																	arrAccounts[i].NewMessages);
            XMLNodeAccount.appendChild(XMLNodeName);
            XMLNodeAccount.appendChild(XMLNodeEMail);
            XMLNodeAccount.appendChild(XMLNodePassword);
            XMLNodeAccount.appendChild(XMLNodeServer);
            XMLNodeAccount.appendChild(XMLNodePort);
            XMLNodeAccount.appendChild(XMLNodeType);
            XMLNodeAccount.appendChild(XMLNodeAutoLogin);
            XMLNodeAccount.appendChild(XMLNodeStared);
            XMLNodeAccount.appendChild(XMLNodeNewMessages);

            XMLRoot.appendChild(XMLNodeAccount);
        }

        var strXML = EBXML_CT2958529.GetStringXml(XMLDoc);

        this.SaveAccountsFile(strXML);
    },

    SaveAccountsFile: function(strXMLContent) {
        var objAccountsFile = this.GetToolbarAccountsXMLFile();

        //encrypt the data
        var strEncryptContent = EBTEAEncryptionManager_CT2958529.TEAencrypt(strXMLContent, EBEMailNotifierConsts_CT2958529.EncryptionPass);

        //write the data to the accounts xml file
        EBFileIO_CT2958529.write(objAccountsFile, strEncryptContent, "", EBGlobalConsts_CT2958529.DefaultCharset);
    },

    LoadAccountsFile: function() {
        var strXMLContent = '';
        var objAccountsFile = this.GetToolbarAccountsXMLFile();
        var strEncryptContent = EBFileIO_CT2958529.read(objAccountsFile, EBGlobalConsts_CT2958529.DefaultCharset);

        //check if this data is encrypted first(for older version of the toolabar - before we encrypted the data).
        if (strEncryptContent) {
            //try to load it to an xml first
            if (strEncryptContent.indexOf(EBEMailNotifierConsts_CT2958529.XML.ACCOUNTS) != -1) {
                var XMLDoc = EBXML_CT2958529.GetXmlDocument(strEncryptContent);
                var XMLRoot = XMLDoc.documentElement;
                if (XMLRoot.tagName != "parsererror" && XMLRoot.tagName == EBEMailNotifierConsts_CT2958529.XML.ACCOUNTS)
                    strXMLContent = strEncryptContent;
            }

            if (!strXMLContent)
                strXMLContent = EBTEAEncryptionManager_CT2958529.TEAdecrypt(strEncryptContent, EBEMailNotifierConsts_CT2958529.EncryptionPass);
        }

        return strXMLContent;
    }
};/*************************** facebook commands  ******************************/
var EBFacebookCommands_CT2958529 =
{
    settingsDialogPath: "chrome://browsersearch/content/fbSettings.xul",

    FB_LOGIN: function(event) {
        var facebookComp = EBComponentsManager_CT2958529.GetFacebookComponent();
        var settingObj = oToolbar_CT2958529.facebook.manager.facebookSettings;
        var urlStr = settingObj.gadget.facebookLoginUrl;
        urlStr = urlStr.replace(/EB_FB_API_KEY/g, oToolbar_CT2958529.facebook.consts.FB_APP_API_KEY);
        urlStr = urlStr.replace(/EB_FB_CANCEL_URL/g, oToolbar_CT2958529.facebook.manager.facebookSettings.gadget.facebookFailureUrl);

        var perms = oToolbar_CT2958529.facebook.manager.facebookSettings.gadget.facebookGetInboxPermission + "," + oToolbar_CT2958529.facebook.manager.facebookSettings.gadget.facebookSetStatusPermission;
        urlStr = urlStr.replace(/EB_FB_PERMISSIONS_ARRAY/g, perms);
        var successUrl = oToolbar_CT2958529.facebook.manager.facebookSettings.gadget.facebookSuccessUrl;
        urlStr = urlStr.replace(/EB_FB_SUCCESS_URL/g, successUrl.substr(0, successUrl.indexOf("?xxRESULTTOKENxx")));
        facebookComp.openFacebookGadgetWindow(urlStr, oToolbar_CT2958529.facebook.consts.gadgetType.login, settingObj.gadget.facebookLoginHeight, settingObj.gadget.facebookLoginWidth);
    },

    FB_INBOX: function(event) {
        var facebookItem = EBComponentsManager_CT2958529.GetFacebookComponent().ComponentItem;
        EBUsageFacebook_CT2958529.OnItemClick(facebookItem.UniqueCompID, facebookItem.UniqueCompID, facebookItem.CompType);


        var urlStr = oToolbar_CT2958529.facebook.manager.facebookSettings.links.facebookInboxUrl;
        urlStr = urlStr.replace(/EB_FB_API_KEY/g, oToolbar_CT2958529.facebook.consts.FB_APP_API_KEY);
        urlStr = urlStr.replace(/EB_FB_SESSION_KEY/g, oToolbar_CT2958529.facebook.manager.sessionKey);
        event.customData = { "url": urlStr, "urlTarget": "SELF" };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    },

    FB_FRIENDS: function(event) {
        var facebookItem = EBComponentsManager_CT2958529.GetFacebookComponent().ComponentItem;
        EBUsageFacebook_CT2958529.OnItemClick(facebookItem.UniqueCompID, facebookItem.UniqueCompID, facebookItem.CompType);
        var urlStr = oToolbar_CT2958529.facebook.manager.facebookSettings.requests.facebookRequestsUrl;
        urlStr = urlStr.replace(/EB_FB_REQ_TYPE/g, oToolbar_CT2958529.facebook.manager.facebookSettings.requests.facebookReqFriend);
        urlStr = urlStr.replace(/EB_FB_API_KEY/g, oToolbar_CT2958529.facebook.consts.FB_APP_API_KEY);
        urlStr = urlStr.replace(/EB_FB_SESSION_KEY/g, oToolbar_CT2958529.facebook.manager.sessionKey);
        event.customData = { "url": urlStr, "urlTarget": "SELF" };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    },

    FB_GROUPS: function(event) {
        var facebookItem = EBComponentsManager_CT2958529.GetFacebookComponent().ComponentItem;
        EBUsageFacebook_CT2958529.OnItemClick(facebookItem.UniqueCompID, facebookItem.UniqueCompID, facebookItem.CompType);
        var urlStr = oToolbar_CT2958529.facebook.manager.facebookSettings.requests.facebookRequestsUrl;
        urlStr = urlStr.replace(/EB_FB_REQ_TYPE/g, oToolbar_CT2958529.facebook.manager.facebookSettings.requests.facebookReqGroup);
        urlStr = urlStr.replace(/EB_FB_API_KEY/g, oToolbar_CT2958529.facebook.consts.FB_APP_API_KEY);
        urlStr = urlStr.replace(/EB_FB_SESSION_KEY/g, oToolbar_CT2958529.facebook.manager.sessionKey);
        event.customData = { "url": urlStr, "urlTarget": "SELF" };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    },

    FB_EVENTS: function(event) {
        var facebookItem = EBComponentsManager_CT2958529.GetFacebookComponent().ComponentItem;
        EBUsageFacebook_CT2958529.OnItemClick(facebookItem.UniqueCompID, facebookItem.UniqueCompID, facebookItem.CompType);
        var urlStr = oToolbar_CT2958529.facebook.manager.facebookSettings.requests.facebookRequestsUrl;
        urlStr = urlStr.replace(/EB_FB_REQ_TYPE/g, oToolbar_CT2958529.facebook.manager.facebookSettings.requests.facebookReqEvent);
        urlStr = urlStr.replace(/EB_FB_API_KEY/g, oToolbar_CT2958529.facebook.consts.FB_APP_API_KEY);
        urlStr = urlStr.replace(/EB_FB_SESSION_KEY/g, oToolbar_CT2958529.facebook.manager.sessionKey);
        event.customData = { "url": urlStr, "urlTarget": "SELF" };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    },

    FB_SHARE: function(event) {
        var settingObj = oToolbar_CT2958529.facebook.manager.facebookSettings;
        var facebookItem = EBComponentsManager_CT2958529.GetFacebookComponent().ComponentItem;
        EBUsageFacebook_CT2958529.OnItemClick(facebookItem.UniqueCompID, facebookItem.UniqueCompID, facebookItem.CompType);

        var urlStr = settingObj.gadget.facebookSharerUrl;
        urlStr = urlStr.replace(/EB_MAIN_FRAME_URL/g, encodeURIComponent(EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().EBUrl_CT2958529.GetPageUrl()).replace("'", "\\'", 'g'));


        var facebookComp = EBComponentsManager_CT2958529.GetFacebookComponent();
        facebookComp.openFacebookGadgetWindow(urlStr, oToolbar_CT2958529.facebook.consts.gadgetType.share, settingObj.gadget.facebookSharerHeight, settingObj.gadget.facebookSharerWidth);
    },

    FB_UPDATE_STATUS: function(event) {
        var settingObj = oToolbar_CT2958529.facebook.manager.facebookSettings;
        var facebookItem = EBComponentsManager_CT2958529.GetFacebookComponent().ComponentItem;
        EBUsageFacebook_CT2958529.OnItemClick(facebookItem.UniqueCompID, facebookItem.UniqueCompID, facebookItem.CompType);
        var callbackForGetPermissions = function(permissions) {
            if (permissions == "1")
                oToolbar_CT2958529.facebook.manager.getUserDataForUpdateStatus(function(strJson, type) { EBComponentsManager_CT2958529.GetFacebookComponent().callbackForGetDataForUpdateStatus(strJson, type); });
            else {
                var facebookComp = EBComponentsManager_CT2958529.GetFacebookComponent();
                var successUrl = oToolbar_CT2958529.facebook.manager.facebookSettings.gadget.facebookPermissionUrl;
                successUrl = successUrl.replace(/EB_FB_SUCCESS_URL/g, oToolbar_CT2958529.facebook.manager.facebookSettings.gadget.facebookSuccessUrl);
                successUrl = successUrl.replace(/EB_FB_API_KEY/g, oToolbar_CT2958529.facebook.consts.FB_APP_API_KEY);
                successUrl = successUrl.replace(/EB_FB_PERMISSION/g, oToolbar_CT2958529.facebook.manager.facebookSettings.gadget.facebookSetStatusPermission);


                var urlStr = settingObj.gadget.facebookLoginUrl;
                urlStr = urlStr.replace(/EB_FB_API_KEY/g, "");
                urlStr = urlStr.replace(/EB_FB_CANCEL_URL/g, oToolbar_CT2958529.facebook.manager.facebookSettings.gadget.facebookFailureUrl);
                urlStr = urlStr.replace(/EB_FB_SUCCESS_URL/g, encodeURIComponent(successUrl).replace("'", "\\'", 'g'));

                facebookComp.openFacebookGadgetWindow(urlStr, oToolbar_CT2958529.facebook.consts.gadgetType.getUpdateStatusPermission, settingObj.gadget.facebookLoginHeight, settingObj.gadget.facebookLoginWidth);
            }
        };

        oToolbar_CT2958529.facebook.manager.checkUpdateStatusPermission(callbackForGetPermissions);
    },

    FB_LOGOUT: function(event) {
        var title = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_FACEBOOK_LOGOUT_DIALOG_TITLE");
        var message = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_FACEBOOK_LOGOUT_DIALOG_TEXT");
        if (EBGlobalManager_CT2958529.Confirm(window, title, message)) {
            var facebookItem = EBComponentsManager_CT2958529.GetFacebookComponent().ComponentItem;
            EBUsageFacebook_CT2958529.OnItemClick(facebookItem.UniqueCompID, facebookItem.UniqueCompID, facebookItem.CompType);
            oToolbar_CT2958529.facebook.manager.logout();
            if (isFloatingMode_CT2958529) {
                var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
                ChevronStaticManager.CloseAllWindows();
            }
        }
    },

    FB_SETTINGS: function(event) {
        var facebookItem = EBComponentsManager_CT2958529.GetFacebookComponent().ComponentItem;
        EBUsageFacebook_CT2958529.OnItemClick(facebookItem.UniqueCompID, facebookItem.UniqueCompID, facebookItem.CompType);
        oToolbar_CT2958529.facebook.manager.alertsManager.openSettingsDialog(window, EBFacebookCommands_CT2958529.settingsDialogPath);

        if (isFloatingMode_CT2958529) {
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }
    },

    ActivateSpecialCommand: function(event, strCommandId) {
        switch (strCommandId.toUpperCase()) {
            case "FB_LOGIN":
                this.FB_LOGIN(event);
                break;
            case "FB_INBOX":
                this.FB_INBOX(event);
                break;
            case "FB_FRIENDS":
                this.FB_FRIENDS(event);
                break;
            case "FB_GROUPS":
                this.FB_GROUPS(event);
                break;
            case "FB_EVENTS":
                this.FB_EVENTS(event);
                break;
            case "FB_SHARE":
                this.FB_SHARE(event);
                break;
            case "FB_UPDATE_STATUS":
                this.FB_UPDATE_STATUS(event);
                break;
            case "FB_LOGOUT":
                this.FB_LOGOUT(event);
                break;
            case "FB_SETTINGS":
                this.FB_SETTINGS(event);
                break;
        }
    },

    IsSupportedCommand: function(strCommandId) {
        switch (strCommandId.toUpperCase()) {
            case "FB_LOGIN":
                return true;
                break;
            case "FB_INBOX":
                return true;
                break;
            case "FB_FRIENDS":
                return true;
                break;
            case "FB_GROUPS":
                return true;
                break;
            case "FB_EVENTS":
                return true;
                break;
            case "FB_SHARE":
                return true;
                break;
            case "FB_UPDATE_STATUS":
                return true;
                break;
            case "FB_LOGOUT":
                return true;
                break;
            case "FB_SETTINGS":
                return true;
                break;
            default: return false;
        }
    }
};

function EBFacebookGadgetDialog_CT2958529(oWindow, popHtmlData) {
    var facebookManager = oWindow.oToolbar_CT2958529.facebook.manager;
    var facebookDataFormSetting = oWindow.oToolbar_CT2958529.facebook.manager.facebookSettings;
    var facebookConsts = oWindow.oToolbar_CT2958529.facebook.consts;
    var facebookItem = oWindow.EBComponentsManager_CT2958529.GetFacebookComponent().ComponentItem;
    var firstTime = true;
    var firstTimeExtPerms = true;
    var _state = "first.login";
    
    var successUrlLength = facebookDataFormSetting.gadget.facebookSuccessUrl.indexOf("?xxRESULTTOKENxx");
    var failureUrlLength = facebookDataFormSetting.gadget.facebookFailureUrl.length;
    var permissionUrlLength = facebookDataFormSetting.gadget.facebookPermissionUrl.indexOf("?");
    var facebookPath = facebookConsts.FB_URL;
    var sendUsage = false;
    this.onDocumentComplete = function(xulBrowser) {

        var pathWIthoutParms = xulBrowser.currentURI.prePath + xulBrowser.currentURI.path.substring(0, 27);
        var usageStatus = facebookConsts.gadgetClosingType.cancel;
        var currentFullPath = xulBrowser.currentURI.prePath + xulBrowser.currentURI.path;

        if (currentFullPath.indexOf("login_attempt=") != -1 && firstTime) {
            window.resizeBy(0, 100);
            firstTime = false;
        }
        if (currentFullPath.indexOf("login_attempt=") == -1 && (xulBrowser.currentURI.prePath.indexOf("login") != -1 || currentFullPath.substring(0, 56).indexOf("http://www.facebook.com/connect/prompt_permissions.php?") != -1) && firstTimeExtPerms) {
            firstTimeExtPerms = false;
            window.resizeTo(facebookDataFormSetting.gadget.facebookPermissionWidth, facebookDataFormSetting.gadget.facebookPermissionHeight);

        }
        if (xulBrowser.currentURI.prePath == facebookPath) {
            if (currentFullPath.substring(0, successUrlLength) == facebookDataFormSetting.gadget.facebookSuccessUrl.substring(0, successUrlLength) || currentFullPath.substring(0, failureUrlLength) == facebookDataFormSetting.gadget.facebookFailureUrl.substring(0, failureUrlLength)) {
                switch (_state) {
                    case ("first.login"):
                        if (currentFullPath.substring(0, successUrlLength) == facebookDataFormSetting.gadget.facebookSuccessUrl.substring(0, successUrlLength)) {
                            var resArray = xulBrowser.currentURI.path.split('&');
                            var reslut;
                            for (var i = 0; i < resArray.length; i++) {
                                reslut = resArray[i];
                                if (reslut.indexOf("session=") != -1) {
                                    try {
                                        var facebookLoginJsonObj = JSON.parse(decodeURIComponent(reslut.substring(reslut.indexOf("session=") + 8)));
                                    } catch (exp) {
                                        EBLog('JSON.parse: ' + exp);
                                        break;
                                    }
                                    facebookManager.cleanData();
                                    facebookManager.updateData(facebookLoginJsonObj);
                                    facebookManager.getUser();
                                    break;
                                }
                            }
                            usageStatus = facebookConsts.gadgetClosingType.success;
                            window.close();
                        }
                        else
                            window.close();
                        break;
                    case ("readMailbox.permission"):

                        if (currentFullPath.substring(0, successUrlLength) == facebookDataFormSetting.gadget.facebookSuccessUrl.substring(0, successUrlLength) && xulBrowser.currentURI.path.substring(28, xulBrowser.currentURI.path.length)) {

                            var resArray = xulBrowser.currentURI.path.split('&');
                            var reslut;
                            for (var i = 0; i < resArray.length; i++) {
                                reslut = resArray[i];
                                if (reslut.indexOf("session=") != -1) {
                                    try {
                                        var facebookLoginJsonObj = JSON.parse(decodeURIComponent(reslut.substring(reslut.indexOf("session=") + 8)));
                                    } catch (exp) {
                                        EBLog('JSON.parse: ' + exp);
                                        break;
                                    }
                                    facebookManager.cleanData();
                                    facebookManager.updateData(facebookLoginJsonObj);
                                    facebookManager.getUser();
                                    break;
                                }
                            }
                            usageStatus = facebookConsts.gadgetClosingType.success;
                        }
                        window.close();
                        break;
                    case ("statusUpdate.permission"):
                        if (currentFullPath.substring(0, successUrlLength) == facebookDataFormSetting.gadget.facebookSuccessUrl.substring(0, successUrlLength) && xulBrowser.currentURI.path.substring(28, xulBrowser.currentURI.path.length)) {
                            facebookManager.getUserDataForUpdateStatus(function(strJson, type) { oWindow.EBComponentsManager_CT2958529.GetFacebookComponent().callbackForGetDataForUpdateStatus(strJson, type); });
                            usageStatus = facebookConsts.gadgetClosingType.success;
                        }
                        window.close();
                        break;
                }
            }
            else {
                if (currentFullPath.indexOf("nochrome=true") == -1 && currentFullPath.indexOf("xxRESULTTOKENxx") != -1 && _state == "readMailbox.permission" && !sendUsage) {
                    oWindow.EBUsageFacebook_CT2958529.OnReadMailboxPermGadgetOpen(popHtmlData.elementId, popHtmlData.componentId, popHtmlData.compType);
                    sendUsage = true;
                    popHtmlData.facebookGagetType = facebookConsts.gadgetType.getReadMailboxPermission;
                }
                else

                    if (currentFullPath.substring(0, permissionUrlLength) == facebookDataFormSetting.gadget.facebookPermissionUrl.substring(0, permissionUrlLength) && xulBrowser.currentURI.path.indexOf(facebookmanager.facebookSettings.gadget.facebookSetStatusPermission) != -1) {
                    window.resizeTo(facebookDataFormSetting.gadget.facebookUpdateStatusWidth, facebookDataFormSetting.gadget.facebookUpdateStatusHeight);
                    _state = "statusUpdate.permission";
                }
                _state = "readMailbox.permission";
            }
            window.ebCloseStatus = usageStatus;
        }
    }
};


function EBFacebookSettingsDialog_CT2958529() {
    var dialogId = "EBFacebookSettingsId";

    var lblAlertSettings = null;
    //var btnFaq = null;
    //var btnPrivacy = null;
    var lblChoose1 = null;
    var lblChoose2 = null;

    var btnAccept = null;
    var btnCancel = null;
    
    var chkEnabled = null;
    var chkFriendReq = null;
    var chkInbox = null;
    var chkGroups = null;
    var chkEvents = null;
    var chkNewsFeeds = null;

    var boxCheckboxesWrapper = null;

    var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
    var fbAlertManager = win.oToolbar_CT2958529.facebook.manager.alertsManager;
    
    this.enableDisableCheckboxes = function(bEnabled) {
        var arrChk = boxCheckboxesWrapper.getElementsByTagName("checkbox");
        for (var i = 0; i < arrChk.length; i++)
            arrChk[i].disabled = !bEnabled;
    };

    this.setLocalUIVars = function() {
        lblAlertSettings = document.getElementById("lblAlertSettings"); ;
        //btnFaq = document.getElementById("btnFaq"); ;
        //btnPrivacy = document.getElementById("btnPrivacy"); ;
        lblChoose1 = document.getElementById("lblChoose1"); ;
        lblChoose2 = document.getElementById("lblChoose2"); ;
        chkEnabled = document.getElementById("chkEnabled");
        boxCheckboxesWrapper = document.getElementById("boxCheckboxesWrapper");
        chkFriendReq = document.getElementById("chkFriendReq");
        chkInbox = document.getElementById("chkInbox");
        chkGroups = document.getElementById("chkGroups");
        chkEvents = document.getElementById("chkEvents");
        chkNewsFeeds = document.getElementById("chkNewsFeeds");

        btnAccept = document.getElementById(dialogId).getButton("accept");
        btnCancel = document.getElementById(dialogId).getButton("cancel");
    };

    this.initUI = function() {
        chkEnabled.checked = fbAlertManager.enabled;
        this.enableDisableCheckboxes(chkEnabled.checked);
        
        chkFriendReq.checked = fbAlertManager.friendReqEnabled;
        chkInbox.checked = fbAlertManager.inboxEnabled;
        chkGroups.checked = fbAlertManager.groupsEnabled;
        chkEvents.checked = fbAlertManager.eventsEnabled;
        chkNewsFeeds.checked = fbAlertManager.newsFeedsEnabled;
    };

    this.saveChanges = function() {
        fbAlertManager.enabled = chkEnabled.checked;
        fbAlertManager.friendReqEnabled = chkFriendReq.checked;
        fbAlertManager.inboxEnabled = chkInbox.checked;
        fbAlertManager.groupsEnabled = chkGroups.checked;
        fbAlertManager.eventsEnabled = chkEvents.checked;
        fbAlertManager.newsFeedsEnabled = chkNewsFeeds.checked;
    };

    this.onload = function() {
        this.setLocalUIVars();
        this.initUI();
        EBUILogic_Dialog_CT2958529.fadeIn(dialogId);
        this.applyLanguagePack();
    };

    this.onunload = function() { };

    this.onclickClose = function() {
        EBUILogic_Dialog_CT2958529.fadeOut(dialogId);
    };

    this.onclickAlertEnabled = function() {
        this.enableDisableCheckboxes(!chkEnabled.checked);
    };

    this.onclickOk = function() {
        this.saveChanges();
        EBUILogic_Dialog_CT2958529.fadeOut(dialogId);
    };
    /*
    this.onclickFaq = function() {
        var strLink = win.EBActionManager_CT2958529.GetWebServerURL("FAQ");
        win.EBWeb_CT2958529.LoadURLInNewWindow(strLink);
    };

    this.onclickPrivacy = function() {
        var strLink = win.EBActionManager_CT2958529.GetWebServerURL("Privacy");
        win.EBWeb_CT2958529.LoadURLInNewWindow(strLink);
    };*/

    this.applyLanguagePack = function() {
        var dialogsDirection = win.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, dialogId);

        window.document.title = win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_SETTINGS_DLG_TITLE');
        lblAlertSettings.value = win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_NOTIFICATION_SETTING_TITLE');
        lblChoose1.value = win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_SETTINGS_DLG_SUBTITLE_NOTIFICATION_FIRST');
        lblChoose2.value = win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_SETTINGS_DLG_SUBTITLE_SECOND');
        chkEnabled.setAttribute("label", win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_SETTINGS_NOTIFICATION_CHOOSE_FROM_OPTIONS'));
        chkFriendReq.setAttribute("label", win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_SETTINGS_ALERT_FRIEND_REQUEST'));
        chkInbox.setAttribute("label", win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_SETTINGS_ALERT_INBOX'));
        chkGroups.setAttribute("label", win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_SETTINGS_ALERT_GROUP'));
        chkEvents.setAttribute("label", win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_SETTINGS_ALERT_EVENTS'));
        chkNewsFeeds.setAttribute("label", win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_SETTINGS_ALERT_NEWS_FEED'));
        btnAccept.setAttribute("label", win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK'));
        btnCancel.setAttribute("label", win.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL'));
    };
};
var EBFeedXMLConsts_CT2958529 =
{
    FEED: 'FEED',
    DATA: 'DATA',
    TITLE: 'TITLE',
    LINK: 'LINK',
    STARED: 'STARED',
    LANGUAGE: 'LANGUAGE',
    ITEMS: 'ITEMS',
    ITEM: 'ITEM',
    TOOLTIP: 'TOOLTIP',
    STATUS: 'STATUS',
    VISITED: 'VISITED',
    HISTORY: 'HISTORY',
    TRUE: 'TRUE',
    FALSE: 'FALSE',
    READ: 'READ',
    UNREAD: 'UNREAD',

    RSS_FEED_ITEM: 'RSS_FEED_ITEM',
    PERMISSIONS: 'PERMISSIONS',
    USER_ATTRIBUTES: 'USER_ATTRIBUTES',
    UNIQUE_COMP_ID: 'UNIQUE_COMP_ID',
    DISPLAY_TEXT: 'DISPLAY_TEXT',
    DISPLAY_ICON: 'DISPLAY_ICON',
    INTERVAL: 'INTERVAL',
    LIVE_MODE: 'LIVE_MODE',
    PODCAST: 'PODCAST',
    ICON_NORMAL_URL: 'ICON_NORMAL_URL',
    IMAGE_STYLE: 'IMAGE_STYLE',

    UserAttributesValue: '<PERMISSION>FULL</PERMISSION><SHOW_IN_CHEVRON>True</SHOW_IN_CHEVRON>',
    PermissionsValue: '<EDIT>True</EDIT><MOVE>True</MOVE><DELETE>True</DELETE>'
};

function EBHistoryData_CT2958529(oHistoryItemDataArrayHash)
{
	this.ArrayHash = oHistoryItemDataArrayHash;
	
	this.XMLSerialize = function()
	{
		var strXMLHistory		= EBFeedXMLConsts_CT2958529.HISTORY;
		
		var strXML = '';
		strXML += '<' + strXMLHistory + '>';
		
		var oHistoryItemData = null;
		var iCount = this.ArrayHash.Count();	
		for(var i=0;i<iCount;i++)
		{
			oHistoryItemData = this.ArrayHash.GetByIndex(i);
			strXML += oHistoryItemData.XMLSerialize();
		}
		
		strXML += '</' + strXMLHistory + '>';
		return strXML;
	};
};

function EBHistoryItemData_CT2958529(strLink)
{
	this.Link = strLink;
	
	this.XMLSerialize = function()
	{
		var strXML = '';
		var strXMLLink		= EBFeedXMLConsts_CT2958529.LINK;
		strXML +=	'<' + strXMLLink+ '>' +  EBXML_CT2958529.ToLegalXML(this.Link) + '</' + strXMLLink+ '>';
		return strXML;
	};
};

function EBFeedData_CT2958529(oFeedDataData,oFeedItemArrayHashData)
{
	this.Data		= oFeedDataData;
	this.Items		= oFeedItemArrayHashData;

	this.XMLSerialize = function() {
	    var strXMLFeed = EBFeedXMLConsts_CT2958529.FEED;
	    var strXML = '';
	    strXML += '<' + strXMLFeed + '>';
	    strXML += this.Data.XMLSerialize();
	    strXML += this.Items.XMLSerialize();
	    strXML += '</' + strXMLFeed + '>';

	    return strXML;
	};
};

function EBFeedDataData_CT2958529(strTitle,strLink,bIsStared,strLanguage)
{
	this.Title		= strTitle;
	this.Link		= strLink;
	this.Stared		= bIsStared;
	this.Language	= strLanguage;
	
	this.XMLSerialize = function()
	{
		var strXMLData		= EBFeedXMLConsts_CT2958529.DATA;
		var strXMLTitle		= EBFeedXMLConsts_CT2958529.TITLE;
		var strXMLLink		= EBFeedXMLConsts_CT2958529.LINK;
		var strXMLStared	= EBFeedXMLConsts_CT2958529.STARED;
		var strXMLLanguage	= EBFeedXMLConsts_CT2958529.LANGUAGE;
		
		var strXML = '';
		strXML +=	 '<' + strXMLData + '>';
		strXML +=		'<' + strXMLTitle + '>' + EBXML_CT2958529.ToLegalXML(this.Title) + '</' + strXMLTitle + '>';
		strXML +=		'<' + strXMLLink + '>' + EBXML_CT2958529.ToLegalXML(this.Link) + '</' + strXMLLink + '>';
		strXML +=		'<' + strXMLLanguage + '>' + EBXML_CT2958529.ToLegalXML(this.Language) + '</' + strXMLLanguage + '>';
		
		var strStared = this.Stared ? 
									EBFeedXMLConsts_CT2958529.TRUE 
									: 
									EBFeedXMLConsts_CT2958529.FALSE;
		
		strXML +=		'<' + strXMLStared + '>' + strStared + '</' + strXMLStared + '>';
		strXML +=	'</' + strXMLData + '>';
		
		return strXML;
	};
};

function EBFeedItemArrayHashData_CT2958529()
{
	this.ArrayHash = new EBArrayHashObject_CT2958529();
	
	this.XMLSerialize = function()
	{
		var strXMLItems		= EBFeedXMLConsts_CT2958529.ITEMS;
		
		var strXML = '';
		strXML += '<' + strXMLItems + '>';
		
		var oFeedItemData = null;
		var iCount = this.ArrayHash.Count();	
		for(var i=0;i<iCount;i++)
		{
			oFeedItemData = this.ArrayHash.GetByIndex(i);
			strXML += oFeedItemData.XMLSerialize();
		}
		
		strXML += '</' + strXMLItems + '>';
		return strXML;
	};
};

function EBFeedItemData_CT2958529(strTitle,strLink,strTooltip,strStatus,bVisited)
{
	this.Title		= strTitle;
	this.Link		= strLink;
	this.Tooltip	= strTooltip;
	this.Status		= strStatus;
	this.Visited	= bVisited;
	
	this.XMLSerialize = function()
	{
		var strXMLItem		= EBFeedXMLConsts_CT2958529.ITEM;
		var strXMLTitle		= EBFeedXMLConsts_CT2958529.TITLE;
		var strXMLLink		= EBFeedXMLConsts_CT2958529.LINK;
		var strXMLTooltip	= EBFeedXMLConsts_CT2958529.TOOLTIP;
		var strXMLStatus	= EBFeedXMLConsts_CT2958529.STATUS;
		var strXMLVisited	= EBFeedXMLConsts_CT2958529.VISITED;
		
		var strXML = '';
		strXML +=	 '<' + strXMLItem + '>';
		strXML +=		'<' + strXMLTitle + '>' + EBXML_CT2958529.ToLegalXML(this.Title)+ '</' + strXMLTitle + '>';
		strXML +=		'<' + strXMLLink + '>' + EBXML_CT2958529.ToLegalXML(this.Link) + '</' + strXMLLink + '>';
		strXML +=		'<' + strXMLTooltip + '>' + this.Tooltip + '</' + strXMLTooltip + '>';
		strXML +=		'<' + strXMLStatus + '>' + this.Status + '</' + strXMLStatus + '>';
		
		var strVisited = this.Visited ? 
								EBFeedXMLConsts_CT2958529.TRUE 
								: 
								EBFeedXMLConsts_CT2958529.FALSE;
		
		strXML +=		'<' + strXMLVisited + '>' + strVisited + '</' + strXMLVisited + '>';
		strXML +=	'</' + strXMLItem + '>';
		
		return strXML;
	};
};

var EBFeedDataFactory_CT2958529 =
{
    XMLToHistoryData: function(XMLDoc) {
        var oHistoryData = null;
        var oHistoryItemDataArrayHash = null;
        var oHistoryItemData = null;

        var strXMLHistory = EBFeedXMLConsts_CT2958529.HISTORY;

        var XMLRoot = XMLDoc.documentElement;
        var XMLChildNode = null;

        if (XMLRoot.tagName == strXMLHistory) {
            oHistoryItemDataArrayHash = new EBArrayHashObject_CT2958529();
            for (var i = 0; i < XMLRoot.childNodes.length; i++) {
                XMLChildNode = XMLRoot.childNodes[i];
                oHistoryItemData = this.XMLToHistoryItemData(XMLChildNode);

                if (oHistoryItemData) {
                    oHistoryItemDataArrayHash.Add(oHistoryItemData.Link, oHistoryItemData);
                }
            }
            oHistoryData = new EBHistoryData_CT2958529(oHistoryItemDataArrayHash);
        }

        return oHistoryData;
    },

    XMLToHistoryItemData: function(XMLNode) {
        var oHistoryItemData = null;

        var strXMLLink = EBFeedXMLConsts_CT2958529.LINK;

        //get the correct root node (depends in this is the xml document or a regular dom node)
        var XMLRoot = XMLNode.ownerDocument ? XMLNode : XMLNode.documentElement;
        var XMLChildNode = null;
        var strLink = '';
        if (XMLRoot.tagName == strXMLLink) {
            strLink = EBXML_CT2958529.GetXmlNodeValue(XMLRoot);
            if (strLink) {
                oHistoryItemData = new EBHistoryItemData_CT2958529(strLink);
            }
        }

        return oHistoryItemData;
    },

    XMLToFeedData: function(XMLDoc) {
        var oFeedData = null;
        var oFeedDataData = null;
        var oFeedItemArrayHashData = null;

        var strXMLFeed = EBFeedXMLConsts_CT2958529.FEED;
        var strXMLData = EBFeedXMLConsts_CT2958529.DATA;
        var strXMLItems = EBFeedXMLConsts_CT2958529.ITEMS;

        var XMLRoot = XMLDoc.documentElement;
        var XMLChildNode = null;

        if (XMLRoot.tagName == strXMLFeed) {
            for (var i = 0; i < XMLRoot.childNodes.length; i++) {
                XMLChildNode = XMLRoot.childNodes[i];
                if (XMLChildNode.tagName == strXMLData) {
                    oFeedDataData = this.XMLToFeedDataData(XMLChildNode);
                }
                else if (XMLChildNode.tagName == strXMLItems) {
                    oFeedItemArrayHashData = this.XMLToFeedItemArrayHashData(XMLChildNode);
                }
            }

            if (oFeedDataData && oFeedItemArrayHashData) {
                oFeedData = new EBFeedData_CT2958529(oFeedDataData, oFeedItemArrayHashData);
            }

        }

        return oFeedData;

    },

    XMLToFeedDataData: function(XMLNode) {
        var oFeedDataData = null;

        var strXMLData = EBFeedXMLConsts_CT2958529.DATA;
        var strXMLTitle = EBFeedXMLConsts_CT2958529.TITLE;
        var strXMLLink = EBFeedXMLConsts_CT2958529.LINK;
        var strXMLStared = EBFeedXMLConsts_CT2958529.STARED;
        var strXMLLanguage = EBFeedXMLConsts_CT2958529.LANGUAGE;

        //get the correct root node (depends in this is the xml document or a regular dom node)
        var XMLRoot = XMLNode.ownerDocument ? XMLNode : XMLNode.documentElement;
        var XMLChildNode = null;

        if (XMLRoot.tagName == strXMLData) {
            var strTitle = '';
            var strLink = '';
            var strStared = '';
            var strLanguage = '';
            var bIsStared = false;

            for (var i = 0; i < XMLRoot.childNodes.length; i++) {
                XMLChildNode = XMLRoot.childNodes[i];
                if (XMLChildNode.tagName == strXMLTitle) {
                    strTitle = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
                }
                else if (XMLChildNode.tagName == strXMLLink) {
                    strLink = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
                }
                else if (XMLChildNode.tagName == strXMLLanguage) {
                    strLanguage = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
                }
                else if (XMLChildNode.tagName == strXMLStared) {
                    strStared = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);

                    bIsStared = strStared == EBFeedXMLConsts_CT2958529.TRUE
												?
												true
												:
												false;
                }
            }

            oFeedDataData = new EBFeedDataData_CT2958529(strTitle, strLink, bIsStared, strLanguage);
        }

        return oFeedDataData;
    },

    XMLToFeedItemArrayHashData: function(XMLNode) {
        var oFeedItemArrayHashData = null;


        var strXMLItems = EBFeedXMLConsts_CT2958529.ITEMS;

        //get the correct root node (depends in this is the xml document or a regular dom node)
        var XMLRoot = XMLNode.ownerDocument ? XMLNode : XMLNode.documentElement;
        var XMLChildNode = null;

        if (XMLRoot.tagName == strXMLItems) {
            var oFeedItemData = null;

            oFeedItemArrayHashData = new EBFeedItemArrayHashData_CT2958529();
            for (var i = 0; i < XMLRoot.childNodes.length; i++) {
                XMLChildNode = XMLRoot.childNodes[i];
                oFeedItemData = this.XMLToFeedItemData(XMLChildNode);
                if (oFeedItemData) {
                    oFeedItemArrayHashData.ArrayHash.Add(oFeedItemData.Link, oFeedItemData);
                }
            }

        }

        return oFeedItemArrayHashData;
    },

    XMLToFeedItemData: function(XMLNode) {
        var oFeedItemData = null;

        var strXMLItem = EBFeedXMLConsts_CT2958529.ITEM;
        var strXMLTitle = EBFeedXMLConsts_CT2958529.TITLE;
        var strXMLLink = EBFeedXMLConsts_CT2958529.LINK;
        var strXMLTooltip = EBFeedXMLConsts_CT2958529.TOOLTIP;
        var strXMLStatus = EBFeedXMLConsts_CT2958529.STATUS;
        var strXMLVisited = EBFeedXMLConsts_CT2958529.VISITED;

        //get the correct root node (depends in this is the xml document or a regular dom node)
        var XMLRoot = XMLNode.ownerDocument ? XMLNode : XMLNode.documentElement;
        var XMLChildNode = null;

        if (XMLRoot.tagName == strXMLItem) {
            var strTitle = '';
            var strLink = '';
            var strTooltip = '';
            var strStatus = '';
            var strVisited = '';
            var bVisited = false;

            for (var i = 0; i < XMLRoot.childNodes.length; i++) {
                XMLChildNode = XMLRoot.childNodes[i];
                if (XMLChildNode.tagName == strXMLTitle) {
                    strTitle = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
                }
                else if (XMLChildNode.tagName == strXMLLink) {
                    strLink = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
                }
                else if (XMLChildNode.tagName == strXMLTooltip) {
                    strTooltip = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
                }
                else if (XMLChildNode.tagName == strXMLStatus) {
                    strStatus = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
                }
                else if (XMLChildNode.tagName == strXMLVisited) {
                    strVisited = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);

                    bVisited = strVisited == EBFeedXMLConsts_CT2958529.TRUE
												?
												true
												:
												false;
                }
            }

            if (strLink) {
                oFeedItemData = new EBFeedItemData_CT2958529(strTitle, strLink, strTooltip, strStatus, bVisited);
            }
        }

        return oFeedItemData;
    }
};
var EBFeedDialogConsts_CT2958529 = 
{
	Attributes : 
	{
		Link	: 'EBAttributeFeedLink',
		Index   : 'EBIndex'
	},
	
	Images :
	{
		EnvRead		: 'chrome://browsersearch/skin/feed_env_read.png',
		EnvUnread	: 'chrome://browsersearch/skin/feed_env_unread.png'
	},
	
	Style : 
	{									
		BoxFeedItemFixedStyle			: 'margin-left:5px;margin-right:5px;height:20px;width:220px;min-width:220px;',
		BoxFeedItemDefaultStyle			: 'border:1px solid transparent;',
		BoxFeedItemHoverStyle			: 'background-color:#C6D3EF;border:1px solid #316AC5;cursor:pointer;',
		BoxFeedItemDownStyle			: 'padding-top:2px;padding-left:2px;',
		ImageFeedItemDownStyle			: 'padding-top:1px;padding-left:1px;',
		LabelFeedItemFixedStyle			: 'font-size:11px;margin-left:1px;width:210px;min-width:210px;',
		LabelFeedItemHoverStyle			: 'cursor:pointer;',
		LabelTextUnVisitedStyleColor	: 'color:black;',
		LabelTextVisitedStyleColor		: 'color:#800080;',
		BoxLabelAlign					: 'center'
	}
}

function EBFeedDialogManager_CT2958529(xulMenuPopup, oFeedComponent) {
    this.xulMenuPopup = xulMenuPopup;
    //prevent opening engine context menu on feed dialog
    if (xulMenuPopup) {
        xulMenuPopup.addEventListener("click", function(event) {
            if (event.button == 2) {
                event.preventDefault();
                return false;
            }
        }, false);

        xulMenuPopup.addEventListener("dblclick", function(event) {
            if (event.button == 2) {
                event.preventDefault();
                return false;
            }
        }, false);
    }
    
    this.m_oFeedComponent = oFeedComponent;

    this.contextItem = null;
    this.xulContext = null;
    this.xulStack = null;
    this.xulContextWidth = null;
    this.xulContextHeight = null;

    this.imgComments = null;
    this.commentsFlexBox = null;
    this.imgRefresh = null;
    this.imgDelete = null;
    this.imgRead = null;
    this.imgUnread = null;
    this.lblTitle = null;

    this.usgDeleteItem = null;
    this.usgOpenItem = null;
    this.usgRefresh = null;
    this.usgDeleteAll = null;
    this.usgClose = null;
    this.usgOpen = null;

    this.initUsageObjects = function() {
        this.usgDeleteItem = EBUsageRss_CT2958529.DeleteItem;
        this.usgOpenItem = EBUsageRss_CT2958529.OpenItemLink;
        this.usgRefresh = EBUsageRss_CT2958529.Refresh;
        this.usgDeleteAll = EBUsageRss_CT2958529.DeleteAll;
        this.usgClose = EBUsageRss_CT2958529.OnRssClose;
        this.usgOpen = EBUsageRss_CT2958529.OnRssOpen;
    };

    this.init = function() {
        this.contextItem = null;
        this.xulContext = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "boxContext");
        this.xulStack = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "mainStack");
        this.xulContextWidth = 0;
        this.xulContextHeight = 0;

        this.imgComments = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "imageComments");
        this.commentsFlexBox = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "boxCommentsFlex");
        this.imgRefresh = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "imageRefresh");
        this.imgDelete = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "imageDelete");
        this.imgRead = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "imageRead");
        this.imgUnread = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "imageUnread");
        this.lblTitle = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "lblTitle");

        //init usage objects
        this.initUsageObjects();

        this.CheckForDialogRTL();
        this.ApplyLanguagePack();
        this._initUI();
        this._handleCommentsLink();

        //send usage if not multifeed dialog
        if (!this.m_oFeedComponent.IsMultiFeed || 
            (typeof this.m_oFeedComponent.IsSingle != "undefined" && this.m_oFeedComponent.IsSingle))
            this.usgOpen();

        this.LoadDialogData();
    };

    this.reload = function(newFeedComponent) {
        newFeedComponent.ContainerScrollTop = 0;
        this.m_oFeedComponent = newFeedComponent;
        this.LoadDialogData();
    };

    this._initUI = function() {
        //init image buttons
        if (this.imgComments)
            EBUILogic_ImageButtons_CT2958529.setManager(this.imgComments);

        if (this.imgRefresh)
            EBUILogic_ImageButtons_CT2958529.setManager(this.imgRefresh);

        if (this.imgDelete)
            EBUILogic_ImageButtons_CT2958529.setManager(this.imgDelete);

        if (this.imgRead)
            EBUILogic_ImageButtons_CT2958529.setManager(this.imgRead);

        if (this.imgUnread)
            EBUILogic_ImageButtons_CT2958529.setManager(this.imgUnread);

        //init onclick actions
        var manager = this;
        if (this.imgRefresh)
            this.imgRefresh.onclick = function(e) {
                if (e.button == 2) {
                    e.preventDefault();
                    return false;
                }
                if (!this.manager.isDisabled) manager.OnClickRefresh(e);
            };

        if (this.imgDelete)
            this.imgDelete.onclick = function(e) {
                if (e.button == 2) {
                    e.preventDefault();
                    return false;
                }

                if (!this.manager.isDisabled) manager.OnClickDeleteAll(e);
            };

        if (this.imgRead)
            this.imgRead.onclick = function(e) {
                if (e.button == 2) {
                    e.preventDefault();
                    return false;
                }
                if (!this.manager.isDisabled) manager.OnClickMarkRead(e);
            };

        if (this.imgUnread)
            this.imgUnread.onclick = function(e) {
                if (e.button == 2) {
                    e.preventDefault();
                    return false;
                }
                if (!this.manager.isDisabled) manager.OnClickMarkUnRead(e);
            };

        if (this.lblTitle)
            this.lblTitle.onclick = function(e) {
                if (e.button == 2) {
                    e.preventDefault();
                    return false;
                }
                manager.OnClickLabelTitle(e);
            };

        //hide context delete message button if live mode
        var xulDeleteItem = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextDelete");
        if (this.m_oFeedComponent.IsLiveMode)
            xulDeleteItem.style.display = "none";

        this.xulContext.style.display = "none";
    };

    this._handleCommentsLink = function() {
        var strCommentsLink = this.m_oFeedComponent.ComponentItem.Comments;
        var manager = this;

        //show comments link button
        if (this.imgComments) {
            if (strCommentsLink) {
                this.imgComments.style.display = "";
                this.commentsFlexBox.style.display = "";
                this.imgComments.onclick = function(e) { manager.OnClickComments(e, strCommentsLink); };
            }
            //hide comment link button
            else {
                this.imgComments.style.display = "none";
                this.commentsFlexBox.style.display = "none";
            }
        }
    };

    this.CheckForDialogRTL = function() {
        var isUserAgentRtl = EBGlobalManager_CT2958529.IsUserAgentRtl();
        var isFeedRtl = EBGlobalManager_CT2958529.IsLanguageRtl(this.m_oFeedComponent.FeedData.Data.Language);
        var direction = (isFeedRtl) ? 'rtl' : 'ltr';

        //adjust text direction and alignment
        EBFeedDialogConsts_CT2958529.Style.BoxFeedItemFixedStyle += 'direction: ' + direction + ';text-align:left;';

        var boxMain = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "boxMain");

        //adjust background
        if (isFeedRtl)
            this.xulMenuPopup.style.textAlign = "right";
        //else
        //    boxMain.className = "eb-feed";
    };

    this.LoadDialogData = function() {
        this.LoadHeaderData();
        if (!this.m_oFeedComponent.IsLiveMode)
            this.LoadFeedItemsData();
        else
            this.LoadLiveFeedItemsData();
    };

    this.LoadHeaderData = function() {
        var strFeedTitle = this.m_oFeedComponent.FeedData.Data.Title;
        strFeedTitle = EBXML_CT2958529.FromLegalXml(strFeedTitle);
        this.lblTitle.setAttribute('value', strFeedTitle);
    };

    this.OnClickComments = function(event, strCommentsLink) {
        this.NavigateToURL(event, strCommentsLink);
    };

    this.OnClickLabelTitle = function(event) {
        var strFeedLink = this.m_oFeedComponent.FeedData.Data.Link;
        this.NavigateToURL(event, strFeedLink);
    };

    this.NullifyFeedItemsContainer = function() {
        var oContainer = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", 'rowsItems');

        while (oContainer.childNodes.length > 0)
            oContainer.removeChild(oContainer.firstChild);
    };

    this.LoadFeedItemsData = function() {
        this.NullifyFeedItemsContainer();

        this.m_oFeedComponent.NumOfNew = 0;

        var oHistoryItemDataArrayHash = this.m_oFeedComponent.HistoryData.ArrayHash;

        var oFeedItemDataArrayHash = this.m_oFeedComponent.FeedData.Items.ArrayHash;
        var oFeedItemData = null;
        var strHashKey = '';
        var iCount = oFeedItemDataArrayHash.Count();
        for (var i = 0; i < iCount; i++) {
            oFeedItemData = oFeedItemDataArrayHash.GetByIndex(i);
            strHashKey = oFeedItemData.Link;

            //only if it's not in the history loads it
            if (!oHistoryItemDataArrayHash.Contains(strHashKey)) {
                if (oFeedItemData.Status == EBFeedXMLConsts_CT2958529.UNREAD)
                    this.m_oFeedComponent.NumOfNew++;

                this.LoadFeedItemData(oFeedItemData, i);
            }
        }

        this.updateActionButtons();

        //set the scroll top
        document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", 'divContainer').scrollTop = this.m_oFeedComponent.ContainerScrollTop;
    };

    this.updateActionButtons = function() {
        var iCount = this.m_oFeedComponent.FeedData.Items.ArrayHash.Count();
        //Enable/Disbale action buttons
        if (this.m_oFeedComponent.NumOfNew == 0 && this.imgRead)
            this.imgRead.manager.disable();

        if (iCount == 0) {
            if (this.imgDelete) this.imgDelete.manager.disable();
            if (this.imgRead) this.imgRead.manager.disable();
            if (this.imgUnread) this.imgUnread.manager.disable();

        }
        else if (iCount == this.m_oFeedComponent.NumOfNew) {
            if (this.imgDelete) this.imgDelete.manager.enable();
            if (this.imgRead) this.imgRead.manager.enable();
            if (this.imgUnread) this.imgUnread.manager.disable();

        }
        else {
            if (this.imgDelete) this.imgDelete.manager.enable();
            if (this.imgRead) this.imgRead.manager.enable();
            if (this.imgUnread) this.imgUnread.manager.enable();
        }
    };

    this.LoadLiveFeedItemsData = function() {
        this.NullifyFeedItemsContainer();

        this.m_oFeedComponent.NumOfNew = 0;
        var oFeedItemDataArrayHash = this.m_oFeedComponent.FeedData.Items.ArrayHash;
        var oFeedItemData = null;
        var strHashKey = '';
        var iCount = oFeedItemDataArrayHash.Count();
        for (var i = 0; i < iCount; i++) {
            oFeedItemData = oFeedItemDataArrayHash.GetByIndex(i);
            this.LoadFeedItemData(oFeedItemData, i);
        }

        //Hide Buttons
        document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "eb-feed-icons").style.display = 'none';
        //set the scroll top
        document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", 'divContainer').scrollTop = this.m_oFeedComponent.ContainerScrollTop;
    };

    this.LoadFeedItemData = function(oFeedItemData, iIndex) {
        var strTitle = oFeedItemData.Title;
        var strLink = oFeedItemData.Link;
        var strTooltip = oFeedItemData.Tooltip;
        var strStatus = oFeedItemData.Status;
        var bVisited = oFeedItemData.Visited;
        var manager = this;

        var oEnvImage = document.createElement('image');
        var strImage = '';

        if (strStatus == EBFeedXMLConsts_CT2958529.READ)
            strImage = EBFeedDialogConsts_CT2958529.Images.EnvRead;
        else
            strImage = EBFeedDialogConsts_CT2958529.Images.EnvUnread;

        var strLabelTextStyleColor = '';
        if (bVisited)
            strLabelTextStyleColor = EBFeedDialogConsts_CT2958529.Style.LabelTextVisitedStyleColor;
        else
            strLabelTextStyleColor = EBFeedDialogConsts_CT2958529.Style.LabelTextUnVisitedStyleColor;

        oEnvImage.setAttribute('src', strImage);
        oEnvImage.setAttribute('width', '24');
        oEnvImage.setAttribute('height', '16');

        var oBoxLabel = document.createElement('box');
        oBoxLabel.setAttribute('align', EBFeedDialogConsts_CT2958529.Style.BoxLabelAlign);
        oBoxLabel.setAttribute('style', EBFeedDialogConsts_CT2958529.Style.BoxFeedItemFixedStyle + EBFeedDialogConsts_CT2958529.Style.BoxFeedItemDefaultStyle);
        oBoxLabel.onmouseover = function(e) { manager.OnMouseOverBoxFeedItem(e, this); };
        oBoxLabel.onmouseout = function(e) { manager.OnMouseOutBoxFeedItem(e, this); };
        oBoxLabel.onmousedown = function(e) { manager.OnMouseDownBoxFeedItem(e, this); };
        oBoxLabel.onmouseup = function(e) { manager.OnMouseUpBoxFeedItem(e, this); };
        oBoxLabel.onclick = function(e) { manager.OnClickBoxFeedItem(e, this); };
        //add link special attribute
        oBoxLabel.setAttribute(EBFeedDialogConsts_CT2958529.Attributes.Link, strLink);
        //add index special attribute
        oBoxLabel.setAttribute(EBFeedDialogConsts_CT2958529.Attributes.Index, iIndex);
        
        var oLabel = document.createElement('label');
        strTitle = EBXML_CT2958529.FromLegalXml(strTitle);
        oLabel.setAttribute('value', EBGlobalManager_CT2958529.htmlDecode(strTitle));
        oLabel.setAttribute('name', 'feedTitle');

        if (EBGlobalManager_CT2958529.IsFirefox3())
            oLabel.setAttribute('tooltiptext', strTooltip);

        oLabel.setAttribute('style', EBFeedDialogConsts_CT2958529.Style.LabelFeedItemFixedStyle + strLabelTextStyleColor);
        oLabel.onmouseover = function(e) { manager.OnMouseOverLabelFeedItem(e, this, strLabelTextStyleColor); };
        oLabel.onmouseout = function(e) { manager.OnMouseOutLabelFeedItem(e, this, strLabelTextStyleColor); };
        oBoxLabel.appendChild(oLabel);

        //create the hbox container:
        var oRow = document.createElement('hbox');
        oRow.setAttribute('align', 'center');
        oRow.setAttribute('height', '20');

        //add the elements to the hbox
        oRow.appendChild(oEnvImage);
        oRow.appendChild(oBoxLabel);

        //add to the main container
        var oRowsItems = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", 'rowsItems');
        oRowsItems.appendChild(oRow);

        if (this.m_oFeedComponent.IsLiveMode)
            oEnvImage.style.visibility = 'hidden';
    };

    this.OnCommandDeleteMessage = function(event) {
        //find the element associated with the popup menu:
        var oElement = this.contextItem;
        var oBoxLabel = null;
        var oRow = null;

        if (oElement.tagName == 'label')
            oBoxLabel = oElement.parentNode;
        else
            oBoxLabel = oElement;

        var strLink = oBoxLabel.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Link);

        var oFeedItemDataArrayHash = this.m_oFeedComponent.FeedData.Items.ArrayHash;
        //check to update num of new
        var oFeedItemData = oFeedItemDataArrayHash.GetByID(strLink);
        if (oFeedItemData) {
            if (oFeedItemData.Status == EBFeedXMLConsts_CT2958529.UNREAD)
                this.m_oFeedComponent.NumOfNew--;

            var iIndex = oFeedItemDataArrayHash.GetIndexByObjectValue(oFeedItemData);

            //remove it from feed data
            oFeedItemDataArrayHash.Remove(iIndex, strLink);

            //add it to the history data:
            var oHistoryItemDataArrayHash = this.m_oFeedComponent.HistoryData.ArrayHash;
            var oHistoryItemData = new EBHistoryItemData_CT2958529(strLink);
            oHistoryItemDataArrayHash.Add(oHistoryItemData.Link, oHistoryItemData);

            //remove the element from the main rows
            oRow = oBoxLabel.parentNode;
            var oContainer = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", 'rowsItems');
            oContainer.removeChild(oRow);

            //update multi feed menu
            this.UpdateMultiFeedMenu();

            //save the data to the files
            this.SaveDataAndUpdate();
        }

        var strAncestorId = this.m_oFeedComponent.MultiFeedCompID;
        var strCompId = this.m_oFeedComponent.ComponentItem.UniqueCompID;
        var strCompType = this.m_oFeedComponent.ComponentItem.CompType;
        this.usgDeleteItem(strAncestorId, strCompId, strCompType);
        this.updateActionButtons();
    };

    this.sendMenuItemClickUsage = function(strLink, iIndex, oBoxLabel, bIsNewTab, bIsNewWindow) {
        var strAncestorId = this.m_oFeedComponent.MultiFeedCompID;
        var strCompId = this.m_oFeedComponent.ComponentItem.UniqueCompID;
        var iCount = this.m_oFeedComponent.FeedData.Items.ArrayHash.Count();
        var strCompType = this.m_oFeedComponent.ComponentItem.CompType;
        //for twitter
        var twitterUserId = (this.m_oFeedComponent.ComponentItem.userId) ? this.m_oFeedComponent.ComponentItem.userId : "";
        var userScreenName = (this.m_oFeedComponent.ComponentItem.screenName) ? this.m_oFeedComponent.ComponentItem.screenName : "";

        this.usgOpenItem(strAncestorId, strCompId, this.m_oFeedComponent.ComponentItem.FeedURL, strLink, bIsNewWindow, bIsNewTab, iIndex, iCount, strCompType, twitterUserId, userScreenName);
    };

    this.OnCommandShowInNewWindow = function(event, bIsTab) {
        //find the element associated with the popup menu:
        var oElement = this.contextItem;
        var oBoxLabel = null;
        var oRow = null;

        if (oElement.tagName == 'label')
            oBoxLabel = oElement.parentNode;
        else
            oBoxLabel = oElement;

        var strLink = oBoxLabel.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Link);
        var iIndex = oBoxLabel.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Index);
        var oFeedItemDataArrayHash = this.m_oFeedComponent.FeedData.Items.ArrayHash;
        var oFeedItemData = oFeedItemDataArrayHash.GetByID(strLink);

        //set not stared:
        this.setNotStarred();

        //update read status and number of unread
        if (oFeedItemData.Status == EBFeedXMLConsts_CT2958529.UNREAD) {
            //update the num of new
            if (!this.m_oFeedComponent.IsLiveMode)
                this.m_oFeedComponent.NumOfNew--;

            oFeedItemData.Status = EBFeedXMLConsts_CT2958529.READ;
        }

        oFeedItemData.Visited = true;

        this.SaveDataAndUpdate();

        //usage
        this.sendMenuItemClickUsage(strLink, iIndex, oBoxLabel, bIsTab, !bIsTab);

        strLink = EBXML_CT2958529.FromLegalXml(strLink);

        if (bIsTab)
            EBWeb_CT2958529.LoadURLInNewTab(oFeedItemData.Link);
        else
            oWindow = EBWeb_CT2958529.LoadURLInNewWindow(oFeedItemData.Link);

        EBFeedUIManager_CT2958529.closeFeed(this.xulMenuPopup);
        var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
        ChevronStaticManager.CloseAllWindows();
    };

    this.SetFeedItemsImages = function(strStatus) {
        var strImage = '';

        if (strStatus == EBFeedXMLConsts_CT2958529.READ)
            strImage = EBFeedDialogConsts_CT2958529.Images.EnvRead;
        else
            strImage = EBFeedDialogConsts_CT2958529.Images.EnvUnread;

        var oContainer = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", 'rowsItems');
        var oImages = oContainer.getElementsByTagName('image');
        var oImage = null;

        for (var i = 0; i < oImages.length; i++) {
            oImage = oImages[i];
            oImage.setAttribute('src', strImage);
        }
    };

    this.OnClickBoxFeedItem = function(event, oElement) {
        //right click
        if (event.button == 2) {
            this.openContextBox(event);
            event.preventDefault();
        }

        //left or middle click
        else if (event.button != 2) {
            //get the special attribute to recieve this item from the hash
            var strLinkHashKey = oElement.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Link);
            var iIndex = oElement.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Index);
            var oFeedItemData = this.m_oFeedComponent.FeedData.Items.ArrayHash.GetByID(strLinkHashKey);

            if (oFeedItemData) {
                //set not stared:
                this.setNotStarred();

                if (oFeedItemData.Status == EBFeedXMLConsts_CT2958529.UNREAD) {
                    //update the num of new
                    if (!this.m_oFeedComponent.IsLiveMode)
                        this.m_oFeedComponent.NumOfNew--;

                    oFeedItemData.Status = EBFeedXMLConsts_CT2958529.READ;
                }

                oFeedItemData.Visited = true;

                this.SaveDataAndUpdate();

                //send usage
                this.sendMenuItemClickUsage(strLinkHashKey, iIndex, event.target, event.button == 1, false);

                this.NavigateToURL(event, oFeedItemData.Link);
            }
        }
    };

    this.openContextBox = function(event) {
        this.xulContext.style.display = "";

        var xulOpenInNewTab = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextNewTab"); //this.xulContext.childNodes[1].firstChild;
        var xulOpenInNewWindow = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextNewWindow"); //this.xulContext.childNodes[1].childNodes[1];
        var xulDeleteItem = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextDelete"); //this.xulContext.childNodes[1].childNodes[2];
        var manager = this;

        //set manually the item associated with the context
        this.contextItem = event.currentTarget;

        //FF 3+
        if (EBGlobalManager_CT2958529.IsFirefox3()) {
            var mouseX = event.layerX;
            var mouseY = event.layerY;

            var iScroll = parseInt(document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", 'divContainer').scrollTop);
            mouseY -= iScroll;

            //lazy calculation of xulContext width
            if (!this.xulContextWidth) this.xulContextWidth = this.xulContext.boxObject.width;
            if (!this.xulContextHeight) this.xulContextHeight = this.xulContext.boxObject.height;

            if (mouseX + this.xulContextWidth > this.xulStack.boxObject.width)
                mouseX = this.xulStack.boxObject.width - this.xulContextWidth - 10;

            if (mouseY + this.xulContextHeight > this.xulStack.boxObject.height)
                mouseY = this.xulStack.boxObject.height - this.xulContextHeight;

            this.xulContext.setAttribute("top", mouseY);
            this.xulContext.setAttribute("left", mouseX);
        }
        //FF 2-
        else {
            var xulRows = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "rowsItems");
            xulRows.insertBefore(this.xulContext, event.currentTarget.parentNode.nextSibling);
        }
    };

    this.NavigateToURL = function(event, strURL) {
        strURL = EBXML_CT2958529.FromLegalXml(strURL);
        event.customData = { "url": strURL, "urlTarget": "SELF" };
        EBLinkManager_CT2958529.LoadLinkURL(event);

        //close feed popup / meltifeed menupopup
        EBFeedUIManager_CT2958529.closeFeed(this.xulMenuPopup);
    };

    this.OnMouseOverLabelFeedItem = function(event, oElement, strLabelTextStyleColor) {
        var strStyle = EBFeedDialogConsts_CT2958529.Style.LabelFeedItemFixedStyle + strLabelTextStyleColor
						+
					EBFeedDialogConsts_CT2958529.Style.LabelFeedItemHoverStyle;
        oElement.setAttribute('style', strStyle);
    };

    this.OnMouseOutLabelFeedItem = function(event, oElement, strLabelTextStyleColor) {
        var strStyle = EBFeedDialogConsts_CT2958529.Style.LabelFeedItemFixedStyle + strLabelTextStyleColor;
        oElement.setAttribute('style', strStyle);
    };

    this.OnMouseOverBoxFeedItem = function(event, oElement) {
        var strStyle = EBFeedDialogConsts_CT2958529.Style.BoxFeedItemFixedStyle
						+
					EBFeedDialogConsts_CT2958529.Style.BoxFeedItemHoverStyle;
        oElement.setAttribute('style', strStyle);

        if (this.contextItem && this.contextItem.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Index)
            != oElement.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Index))
            this.xulContext.style.display = "none";
    };

    this.OnMouseOutBoxFeedItem = function(event, oElement) {
        var strStyle = EBFeedDialogConsts_CT2958529.Style.BoxFeedItemFixedStyle
						+
					EBFeedDialogConsts_CT2958529.Style.BoxFeedItemDefaultStyle;

        //clear the image style
        if (!this.m_oFeedComponent.IsLiveMode)
            oElement.parentNode.firstChild.setAttribute('style', '');

        oElement.setAttribute('style', strStyle);
    };

    this.OnMouseDownBoxFeedItem = function(event, oElement) {
        if (event.button == 0) {
            var strStyle = EBFeedDialogConsts_CT2958529.Style.BoxFeedItemFixedStyle
							+
						EBFeedDialogConsts_CT2958529.Style.BoxFeedItemHoverStyle
							+
						EBFeedDialogConsts_CT2958529.Style.BoxFeedItemDownStyle;

            //set the image to be click style as well
            if (!this.m_oFeedComponent.IsLiveMode) {
                oElement.parentNode.firstChild.setAttribute('style', EBFeedDialogConsts_CT2958529.Style.ImageFeedItemDownStyle);
            }
            oElement.setAttribute('style', strStyle);
        }
    };

    this.OnMouseUpBoxFeedItem = function(event, oElement) {
        if (event.button == 0) {
            var strStyle = EBFeedDialogConsts_CT2958529.Style.BoxFeedItemFixedStyle
							+
						EBFeedDialogConsts_CT2958529.Style.BoxFeedItemHoverStyle;

            //clear the image style
            oElement.parentNode.firstChild.setAttribute('style', '');
            oElement.setAttribute('style', strStyle);
        }
    };

    this.OnClickRefresh = function(event) {
        EBFeedPreferencesManager_CT2958529.NullifyFeedPollDate(this.m_oFeedComponent);
        EBFeedManager_CT2958529.CheckServerRequest(this.m_oFeedComponent);

        //usage
        var strAncestorId = this.m_oFeedComponent.MultiFeedCompID;
        var strCompId = this.m_oFeedComponent.ComponentItem.UniqueCompID;
        var strCompType = this.m_oFeedComponent.ComponentItem.CompType;
        this.usgRefresh(strAncestorId, strCompId, strCompType);
    };

    this.OnAcceptConfirmDialog = function(event) {
        oInput.value = true;
    };

    this.OnClickDeleteAll = function(event) {
        //usage
        var strAncestorId = this.m_oFeedComponent.MultiFeedCompID;
        var strCompId = this.m_oFeedComponent.ComponentItem.UniqueCompID;
        var strCompType = this.m_oFeedComponent.ComponentItem.CompType;
        this.usgDeleteAll(strAncestorId, strCompId, strCompType);

        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale);
        var strTitle = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_DELETE_ALL_ITEMS_TITLE');
        var strText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_DELETE_ALL_ITEMS_MESSAGE');
        var strCheckboxText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_DONT_ASK_AGAIN');
        var checkboxValue = { "value": false };
        var isDelete = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.FeedDeleteDontAskAgain);
        var bClearFeed = true;

        if (!isDelete) {
            bClearFeed = false;
            EBFeedUIManager_CT2958529.closeFeed(this.xulMenuPopup);
            isDelete = EBGlobalManager_CT2958529.ConfirmCheck(window, strTitle, strText, strCheckboxText, checkboxValue);
        }

        if (isDelete) {
            this._DeleteAll(event, bClearFeed);
            if (checkboxValue.value)
                EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.FeedDeleteDontAskAgain, true);
        }
    };

    this._DeleteAll = function(event, bClearFeed) {
        //add all items in structured data to the history data:								
        var oHistoryItemDataArrayHash = this.m_oFeedComponent.HistoryData.ArrayHash;
        var oHistoryItemData = null;

        var oFeedItemDataArrayHash = this.m_oFeedComponent.FeedData.Items.ArrayHash;
        var oFeedItemData = null;
        var iCount = oFeedItemDataArrayHash.Count();
        var strLink = '';
        for (var i = 0; i < iCount; i++) {
            oFeedItemData = oFeedItemDataArrayHash.GetByIndex(i);
            strLink = oFeedItemData.Link;
            if (!oHistoryItemDataArrayHash.Contains(strLink)) {
                oHistoryItemData = new EBHistoryItemData_CT2958529(strLink);
                oHistoryItemDataArrayHash.Add(oHistoryItemData.Link, oHistoryItemData);
            }
        }
        //clear the feed items hash array
        oFeedItemDataArrayHash.Clear();
        this.setNotStarred();
        this.m_oFeedComponent.NumOfNew = 0;

        this.SaveDataAndUpdate();
        if (bClearFeed)
            this.reload(this.m_oFeedComponent);
    };

    this.OnClickMarkRead = function(event) {
        //set all images read
        this.SetFeedItemsImages(EBFeedXMLConsts_CT2958529.READ);

        //set data
        var oHistoryItemDataArrayHash = this.m_oFeedComponent.HistoryData.ArrayHash;
        var oFeedItemDataArrayHash = this.m_oFeedComponent.FeedData.Items.ArrayHash;
        var oFeedItemData = null;
        var iCount = oFeedItemDataArrayHash.Count();
        for (var i = 0; i < iCount; i++) {
            oFeedItemData = oFeedItemDataArrayHash.GetByIndex(i);
            if (!oHistoryItemDataArrayHash.Contains(oFeedItemData.Link))
                oFeedItemData.Status = EBFeedXMLConsts_CT2958529.READ;
        }

        this.m_oFeedComponent.NumOfNew = 0;
        this.setNotStarred();

        if (this.imgRead)
            this.imgRead.manager.disable();
            
        if (this.imgUnread)
            this.imgUnread.manager.enable();

        //usage
        var strAncestorId = this.m_oFeedComponent.MultiFeedCompID;
        var strCompId = this.m_oFeedComponent.ComponentItem.UniqueCompID;
        var strCompType = this.m_oFeedComponent.ComponentItem.CompType;
        EBUsageRss_CT2958529.MarkAllRead(strAncestorId, strCompId, strCompType);

        this.SaveDataAndUpdate();
    };

    this.OnClickMarkUnRead = function(event) {
        //set all images unread
        this.SetFeedItemsImages(EBFeedXMLConsts_CT2958529.UNREAD);

        //set data
        this.m_oFeedComponent.NumOfNew = 0;
        var oHistoryItemDataArrayHash = this.m_oFeedComponent.HistoryData.ArrayHash;
        var oFeedItemDataArrayHash = this.m_oFeedComponent.FeedData.Items.ArrayHash;
        var oFeedItemData = null;
        var iCount = oFeedItemDataArrayHash.Count();
        for (var i = 0; i < iCount; i++) {
            oFeedItemData = oFeedItemDataArrayHash.GetByIndex(i);
            if (!oHistoryItemDataArrayHash.Contains(oFeedItemData.Link)) {
                this.m_oFeedComponent.NumOfNew++;
                oFeedItemData.Status = EBFeedXMLConsts_CT2958529.UNREAD;
            }
        }

        if (this.imgUnread)
            this.imgUnread.manager.disable();

        if (this.imgRead)
            this.imgRead.manager.enable();

        //usage
        var strAncestorId = this.m_oFeedComponent.MultiFeedCompID;
        var strCompId = this.m_oFeedComponent.ComponentItem.UniqueCompID;
        var strCompType = this.m_oFeedComponent.ComponentItem.CompType;
        EBUsageRss_CT2958529.MarkAllUnRead(strAncestorId, strCompId, strCompType);

        this.SaveDataAndUpdate();
    };

    this.OnUnLoadDialog = function(event) {
        try {
            this.xulContext.style.display = "none";

            if (this.xulContext.parentNode.id != this.xulStack.id)
                this.xulStack.appendChild(this.xulContext);

            //save the scroll top
            this.m_oFeedComponent.ContainerScrollTop = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", 'divContainer').scrollTop;

            //set the starred to false
            this.setNotStarred();

            //empty container
            this.NullifyFeedItemsContainer();

            //save the data to the files
            this.SaveDataAndUpdate();

            //usage
            var strAncestorId = this.m_oFeedComponent.MultiFeedCompID;
            var strCompId = this.m_oFeedComponent.ComponentItem.UniqueCompID;
            var strFeedUrl = this.m_oFeedComponent.ComponentItem.FeedURL
            var strCompType = this.m_oFeedComponent.ComponentItem.CompType;
            this.usgClose(strAncestorId, strCompId, strFeedUrl, strCompType);
        }
        catch (ex) {
            EBLog(ex, "Rss.OnUnLoadDialog");
        }
    };

    this.setNotStarred = function() {
        this.m_oFeedComponent.FeedData.Data.Stared = false;
        //update multi rss menu
        if (this.m_oFeedComponent.IsMultiFeed && !this.m_oFeedComponent.IsLiveMode)
            EBFeedUIManager_CT2958529.removeStarOnMultiRssMenu(this.xulMenuPopup, this.m_oFeedComponent.MultiFeedCompID);
    };

    this.SaveDataAndUpdate = function() {
        if (!this.m_oFeedComponent.IsLiveMode) {
            EBFeedManager_CT2958529.SaveFeedDataStructured(this.m_oFeedComponent);
            EBFeedManager_CT2958529.SaveFeedDataHistory(this.m_oFeedComponent);
        }
        EBFeedManager_CT2958529.notifyUpdate(this.m_oFeedComponent);
    };

    this.UpdateMultiFeedMenu = function() {
        if (this.m_oFeedComponent.IsMultiFeed)
            EBFeedUIManager_CT2958529.updateMultiFeedMenu(this.m_oFeedComponent.MultiFeedCompID,
                                                        this.xulMenuPopup.parentNode.parentNode,
                                                        this.m_oFeedComponent.MultiFeedChildIndex);
    };

    this.ApplyLanguagePack = function() {
        var xulOpenInNewTab = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextNewTab");
        var xulOpenInNewWindow = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextNewWindow");
        var xulDeleteItem = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextDelete");

        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale);

        if (this.imgComments)
            this.imgComments.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_ADD_YOUR_COMMET_TO_BOX'));
        
        if (this.imgRefresh)
            this.imgRefresh.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_REFRESH_TOOLTIP'));
        
        if (this.imgDelete)
            this.imgDelete.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_DELETE_ALL_ITEMS_TOOLTIP'));
        
        if (this.imgRead)
            this.imgRead.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_MARK_ALL_AS_READ_TOOLTIP'));
        
        if (this.imgUnread)
            this.imgUnread.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_MARK_ALL_AS_UNREAD_TOOLTIP'));

        xulOpenInNewTab.value = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_OPEN_IN_NEW_TAB');
        xulOpenInNewWindow.value = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_OPEN_IN_NEW_WINDOW');
        xulDeleteItem.value = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_DELETE_MESSAGE');
    };

    if(this.xulMenuPopup && this.m_oFeedComponent) this.init();
};
var EBFeedIOConsts_CT2958529 = 
{
	FolderName					: 'feed',
	StructuredFileNameSuffix	: '_structured.xml',
	HistoryFileNameSuffix		: '_history.xml',
	LiveFileNameSuffix			: '_live_structured.xml'
}


var EBFeedIOManager_CT2958529 =
{
    GetLegalFeedFileNamePrefix: function(strURL) {
        var strFileNamePrefix = EBGlobalManager_CT2958529.ToLegalFileName(strURL);
        return strFileNamePrefix;
    },

    GetFeedFullPath: function(strFullFileName) {
        var strFeedFolder = EBFeedIOConsts_CT2958529.FolderName;

        var strFeedFullPath = strFeedFolder + EBDirIO_CT2958529.sep + strFullFileName;

        return strFeedFullPath;
    },

    GetFeedFile: function(strFileName) {
        var strFeedFullPath = this.GetFeedFullPath(strFileName);
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(strFeedFullPath);

        return oFile;
    },

    WriteFeedFile: function(strFileName, strContent) {
        var bSuccess = false;
        var oFile = this.GetFeedFile(strFileName);
        if (oFile) {
            bSuccess = EBFileIO_CT2958529.write(oFile, strContent, "", EBGlobalConsts_CT2958529.DefaultCharset);
        }
        return bSuccess;
    },

    ReadFeedFile: function(strFileName) {
        var strContent = '';
        var oFile = this.GetFeedFile(strFileName);
        if (oFile) {
            strContent = EBFileIO_CT2958529.read(oFile, EBGlobalConsts_CT2958529.DefaultCharset);
        }

        return strContent;
    },

    GetFullStructuredFileName: function(strURL) {
        var strFileNamePrefix = this.GetLegalFeedFileNamePrefix(strURL);
        var strStructuredFileName = strFileNamePrefix + EBFeedIOConsts_CT2958529.StructuredFileNameSuffix;
        return strStructuredFileName;
    },

    GetFullHistoryFileName: function(strURL) {
        var strFileNamePrefix = this.GetLegalFeedFileNamePrefix(strURL);
        var strHistoryFileName = strFileNamePrefix + EBFeedIOConsts_CT2958529.HistoryFileNameSuffix;
        return strHistoryFileName;
    },

    GetFullLiveFileName: function(strURL) {
        var strFileNamePrefix = this.GetLegalFeedFileNamePrefix(strURL);
        var strLiveFileName = strFileNamePrefix + EBFeedIOConsts_CT2958529.LiveFileNameSuffix;
        return strLiveFileName;
    },

    WriteStructured: function(strURL, strContent) {
        var strStructuredFileName = this.GetFullStructuredFileName(strURL);
        this.WriteFeedFile(strStructuredFileName, strContent);
    },

    WriteHistory: function(strURL, strContent) {
        var strHistoryFileName = this.GetFullHistoryFileName(strURL);
        this.WriteFeedFile(strHistoryFileName, strContent);
    },

    WriteLive: function(strURL, strContent) {
        var strLiveFileName = this.GetFullLiveFileName(strURL);
        this.WriteFeedFile(strLiveFileName, strContent);
    },

    ReadStructured: function(strURL) {
        var strStructuredFileName = this.GetFullStructuredFileName(strURL);
        var strContent = this.ReadFeedFile(strStructuredFileName);
        return strContent;
    },

    ReadHistory: function(strURL) {
        var strHistoryFileName = this.GetFullHistoryFileName(strURL);
        var strContent = this.ReadFeedFile(strHistoryFileName);
        return strContent;
    },

    ReadLive: function(strURL) {
        var strLiveFileName = this.GetFullLiveFileName(strURL);
        var strContent = this.ReadFeedFile(strLiveFileName);
        return strContent;
    },

    DeleteFeedFiles: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;
        var strUrl = oFeedComponent.ComponentItem.FeedURL;
        try {
            var filename = "";
            var file = null;

            if (oFeedComponent.IsLiveMode) {
                filename = this.GetFullLiveFileName(strUrl);
                file = this.GetFeedFile(filename);
                if (file && file.exists()) EBFileIO_CT2958529.unlink(file);
            }
            else {
                filename = this.GetFullStructuredFileName(strUrl);
                file = this.GetFeedFile(filename);
                if (file && file.exists()) EBFileIO_CT2958529.unlink(file);

                filename = this.GetFullHistoryFileName(strUrl);
                file = this.GetFeedFile(filename);
                if (file && file.exists()) EBFileIO_CT2958529.unlink(file);
            }
        }
        catch (ex) {
            EBLog(ex, "error deleting feed files");
        }
    }
};


var EBFeedPreferencesManager_CT2958529 = 
{
    GetFeedPollDateFullPrefName: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;
        var strPrefName = EBPreferenceConsts_CT2958529.FeedPollDatePrefix + oFeedComponent.ComponentItem.UniqueCompID;
        return strPrefName;
    },

    GetFeedTTLFullPrefName: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;
        var strPrefName = EBPreferenceConsts_CT2958529.FeedTTLPrefix + oFeedComponent.ComponentItem.UniqueCompID;
        return strPrefName;
    },

    GetFeedPollDate: function(oFeedComponent) {
        var strPrefName = this.GetFeedPollDateFullPrefName(oFeedComponent);
        var strPrefValue = EBToolbarPreferenceManager_CT2958529.GetPref(strPrefName);
        return strPrefValue;
    },

    SetFeedPollDate: function(oFeedComponent) {
        var strPrefName = this.GetFeedPollDateFullPrefName(oFeedComponent);
        var oDate = new Date();
        var strPrefValue = oDate.toString();
        EBToolbarPreferenceManager_CT2958529.SetPref(strPrefName, strPrefValue);
    },

    NullifyFeedPollDate: function(oFeedComponent) {
        var strPrefName = this.GetFeedPollDateFullPrefName(oFeedComponent);
        EBToolbarPreferenceManager_CT2958529.SetPref(strPrefName, null);
    },

    NullifyFeedPrefs: function(oFeedComponent) {
        this.NullifyFeedPollDate(oFeedComponent);

        /*
        var strPrefName = this.GetFeedTTLFullPrefName(oFeedComponent);
        EBToolbarPreferenceManager_CT2958529.ClearUserPref(strPrefName);

        //nullify last count
        strPrefName = EBFeedConsts_CT2958529.PrefFeedCountPrefix + oFeedComponent.UniqueCompID;
        EBToolbarPreferenceManager_CT2958529.ClearUserPref(strPrefName);
        */
    },

	FeedTTL: function(oFeedComponent, iTTL) {
	    var strPrefName = this.GetFeedTTLFullPrefName(oFeedComponent);
	    //get
	    if (typeof iTTL == "undefined")
	        return EBToolbarPreferenceManager_CT2958529.GetPref(strPrefName);
	    //set
	    else {
	        var bIsChanged = (EBToolbarPreferenceManager_CT2958529.HasUserValue(strPrefName)) ?
                EBToolbarPreferenceManager_CT2958529.GetPref(strPrefName) != iTTL : true;
	        EBToolbarPreferenceManager_CT2958529.SetPref(strPrefName, iTTL);
	        return bIsChanged;
	    }
	}
}


var EBFeedConsts_CT2958529 = 
{
	DefaultInterval				: 60,
	MaxStructuredItems			: 50,
	MaxHistoryItems				: 200,
	NoTitleCaption				: '(no title)',
	NoItemsCaption				: 'No Items',
	Timeout						: 30000,
	PrefFeedCountPrefix         : 'FeedLastCount',
	
	Observer:
	{
	    Topic_FeedObserver: 'EBFeedObserverTopic_CT2958529',
	    Data_FeedReload: 'EBFeed_FeedReload'
	}
}

var EBFeedManager_CT2958529 =
{
    SetFeedsCount: function(strId, iCount) {
        var strPrefName = EBFeedConsts_CT2958529.PrefFeedCountPrefix + strId;
        EBToolbarPreferenceManager_CT2958529.SetPref(strPrefName, iCount, true);
    },

    GetFeedsCount: function(strId) {
        var strPrefName = EBFeedConsts_CT2958529.PrefFeedCountPrefix + strId;
        var iCount = EBToolbarPreferenceManager_CT2958529.GetPref(strPrefName, true);

        if (iCount == null)
            iCount = 0;

        return iCount;
    },

    LoadFeedStructured: function(oFeedComponent, strXML) {
        var oFeedData = null;
        if (strXML) {
            var XMLDoc = EBXML_CT2958529.GetXmlDocument(strXML);
            oFeedData = EBFeedDataFactory_CT2958529.XMLToFeedData(XMLDoc);
        }

        //bug fix for previous releases, if no title, nullify last poll time, to get new and write it with title
        if (!oFeedData) //if it's not succeed load blank feed data
            oFeedData = this.CreateBlankFeedData();

        oFeedComponent.FeedData = oFeedData;
    },

    //the load functions load the data into the object! (as oppose to return the object);
    LoadEditableFeedStructured: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;

        var strURL = oFeedComponent.ComponentItem.FeedURL;
        var strXML = EBFeedIOManager_CT2958529.ReadStructured(strURL);
        this.LoadFeedStructured(oFeedComponent, strXML);
    },

    LoadLiveFeedStructured: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;

        var strURL = oFeedComponent.ComponentItem.FeedURL;
        var strXML = EBFeedIOManager_CT2958529.ReadLive(strURL);
        this.LoadFeedStructured(oFeedComponent, strXML);
    },

    LoadFeedHistory: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;

        var strURL = oFeedComponent.ComponentItem.FeedURL;
        var oHistoryData = null;
        var strXML = EBFeedIOManager_CT2958529.ReadHistory(strURL);
        if (strXML) {
            var XMLDoc = EBXML_CT2958529.GetXmlDocument(strXML);
            oHistoryData = EBFeedDataFactory_CT2958529.XMLToHistoryData(XMLDoc);
        }

        if (!oHistoryData) {
            oHistoryData = this.CreateBlankHistoryData();
        }

        oFeedComponent.HistoryData = oHistoryData;
    },

    CreateBlankFeedData: function() {
        var oFeedDataData = new EBFeedDataData_CT2958529('', '', false, '');
        var oFeedItemArrayHashData = new EBFeedItemArrayHashData_CT2958529();
        var oFeedData = new EBFeedData_CT2958529(oFeedDataData, oFeedItemArrayHashData);
        return oFeedData;
    },

    CreateBlankHistoryData: function() {
        var oHistoryItemDataArrayHash = new EBArrayHashObject_CT2958529();
        var oHistoryData = new EBHistoryData_CT2958529(oHistoryItemDataArrayHash);
        return oHistoryData;
    },

    SaveStructured: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;

        var oFeedData = oFeedComponent.FeedData;
        var strURL = oFeedComponent.ComponentItem.FeedURL;
        var strXML = oFeedData.XMLSerialize();
        EBFeedIOManager_CT2958529.WriteStructured(strURL, strXML);
    },

    SaveHistory: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;

        var oHistoryData = oFeedComponent.HistoryData;
        var strURL = oFeedComponent.ComponentItem.FeedURL;
        var strXML = oHistoryData.XMLSerialize();
        EBFeedIOManager_CT2958529.WriteHistory(strURL, strXML);
    },

    SaveLive: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;

        var oFeedData = oFeedComponent.FeedData;
        var strURL = oFeedComponent.ComponentItem.FeedURL;
        var strXML = oFeedData.XMLSerialize();
        EBFeedIOManager_CT2958529.WriteLive(strURL, strXML);
    },

    OnLoadFeedItem: function(oFeedComponent) {
        this.LoadComponentData(oFeedComponent);
        this.CheckServerRequest(oFeedComponent);
    },

    OnUnloadFeedItem: function(oFeedComponent) {
        this.ClearTimeoutID(oFeedComponent);
    },

    ClearTimeoutID: function(oFeedComponent) {
        if (oFeedComponent.TimeoutID) {
            clearTimeout(oFeedComponent.TimeoutID);
        }
    },

    CheckServerRequest: function(oFeedComponent) {
        if (this.IsTimeElapsed(oFeedComponent)) {
            //save poll date to now
            EBFeedPreferencesManager_CT2958529.SetFeedPollDate(oFeedComponent);
            this.ServerRequest(oFeedComponent);
        }
        else
            this.UpdateFeedData(oFeedComponent);

        this.SetTimeoutCheck(oFeedComponent);
    },

    SetTimeoutCheck: function(oFeedComponent) {
        var oFunction = function() {
            EBFeedManager_CT2958529.CheckServerRequest(oFeedComponent);
        };
        var iIntervalMinutes = this.GetFeedInterval(oFeedComponent);
        var iMillisecondInterval = iIntervalMinutes * 60 * 1000;

        oFeedComponent.TimeoutID = setTimeout(oFunction, iMillisecondInterval);
    },

    ResetTimeoutCheck: function(oFeedComponent) {
        if (oFeedComponent.TimeoutID)
            clearTimeout(oFeedComponent.TimeoutID);

        this.SetTimeoutCheck(oFeedComponent);
    },

    LoadComponentData: function(oFeedComponent) {
        if (oFeedComponent.IsLiveMode) {
            this.LoadLiveFeedStructured(oFeedComponent);
        }
        else {
            this.LoadEditableFeedStructured(oFeedComponent);
            this.LoadFeedHistory(oFeedComponent);
        }
    },

    ServerRequest: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;

        var strURL = oFeedComponent.ComponentItem.FeedURL;
        //set the flag of the loading from server:
        oFeedComponent.LoadingFromServer = true;
        var oCallBackFunction = function(strXML, o) {
            //check if window is still exists
            if (typeof EBFeedManager_CT2958529 != "undefined")
                EBFeedManager_CT2958529.ServerResponse(oFeedComponent, strXML, o);
        };

        var oRequest = EBWeb_CT2958529.HTTPServerRequest(strURL, null, false, oCallBackFunction);
        this.CheckServerTimeout(oFeedComponent, oRequest);
    },

    CheckServerTimeout: function(oFeedComponent, oRequest) {
        var oThreadFunction = function() {
            if (oFeedComponent.LoadingFromServer) {
                oRequest.abort();
                if (oFeedComponent.isCustom)
                    oFeedComponent.Invoke(false);
                else
                    EBFeedManager_CT2958529.ServerResponse(oFeedComponent, '', null);
            }
        };
        setTimeout(oThreadFunction, EBFeedConsts_CT2958529.Timeout);
    },

    ServerResponse: function(oFeedComponent, strXML, o) {
        //the request is back so set the flag that it's not loading nomore:
        oFeedComponent.LoadingFromServer = false;

        if (oFeedComponent.isCustom)
            this.ParsePodcastFeed(oFeedComponent, strXML);
        else {
            if (oFeedComponent.IsLiveMode)
                this.ParseLiveFeed(oFeedComponent, strXML);
            else
                this.ParseEditableFeed(oFeedComponent, strXML);
        }
    },

    ParseEditableFeed: function(oFeedComponent, strXML) {
        if (!oFeedComponent.ComponentItem) return;

        var XMLDoc = null;

        if (strXML)
            XMLDoc = EBXML_CT2958529.GetXmlDocument(strXML);

        var bIsNewItemsFromServer = false;

        var oFeedParser = new EBFeedParser_CT2958529(XMLDoc, EBFeedConsts_CT2958529.MaxStructuredItems, oFeedComponent.ComponentItem.Podcast);
        //save the TTL
        if (oFeedParser.TTL) {
            var bIsChanged = EBFeedPreferencesManager_CT2958529.FeedTTL(oFeedComponent, oFeedParser.TTL);
            if (bIsChanged)
                this.ResetTimeoutCheck(oFeedComponent);
        }

        var oFeedElementArrayHash = oFeedParser.ArrayHash;
        var oHistoryItemDataArrayHash = oFeedComponent.HistoryData.ArrayHash;
        var oFeedItemDataArrayHash = oFeedComponent.FeedData.Items.ArrayHash;

        //update feeddata data from server
        var strFeedTitle = oFeedParser.Title;
        var strFeedLink = oFeedParser.Link;
        oFeedComponent.FeedData.Data.Language = oFeedParser.Language;

        if (strFeedTitle)
            oFeedComponent.FeedData.Data.Title = strFeedTitle;
        else //if there isn't title take the title from the settings
            oFeedComponent.FeedData.Data.Title = oFeedComponent.ComponentItem.Title;

        if (strFeedLink)
            oFeedComponent.FeedData.Data.Link = strFeedLink;
        else //if there isn't link from the feed take the feed URL
            oFeedComponent.FeedData.Data.Link = oFeedComponent.ComponentItem.FeedURL;

        //compare between the items from the server to the items in the history and the structured
        if (oFeedElementArrayHash.Count() > 0) {
            var strTitle = '';
            var strLink = '';
            var strTooltip = '';
            var strStatus = '';
            var bVisited = false;

            //run on the items from the server
            var iCount = oFeedElementArrayHash.Count();
            var oFeedElement = null;
            var bIsItemInStructured = false;
            var bIsItemInHistory = false;
            var strHashKey = '';

            var oFeedItemData = null;
            //go backwards in the server items to add the newset items in the feed to the top of the structured ArrayHash
            for (var i = iCount - 1; i >= 0; i--) {
                oFeedElement = oFeedElementArrayHash.GetByIndex(i);
                strHashKey = oFeedElement.Link;

                //check structured
                bIsItemInStructured = oFeedItemDataArrayHash.Contains(strHashKey);
                //check history
                bIsItemInHistory = oHistoryItemDataArrayHash.Contains(strHashKey);

                //check to add this item to the structured if it's not in structured or in history
                if (!bIsItemInStructured && !bIsItemInHistory) {
                    bIsNewItemsFromServer = true;
                    //insert the new item to the structured hasharray
                    strTitle = this.GetTitle(oFeedElement.Title);
                    strLink = oFeedElement.Link;
                    strTooltip = this.GetTooltipCaption(oFeedElement.Date);
                    strStatus = EBFeedXMLConsts_CT2958529.UNREAD;

                    oFeedItemData = new EBFeedItemData_CT2958529(strTitle,
													strLink,
													strTooltip,
													strStatus,
													bVisited);

                    //insert to the top
                    oFeedItemDataArrayHash.Insert(0, oFeedItemData.Link, oFeedItemData);
                }
            }
        }

        //check to save the data
        if (bIsNewItemsFromServer) {
            oFeedComponent.FeedData.Data.Stared = true;
            this.SaveFeedDataStructured(oFeedComponent);

            //check if there is dialog open with this component to refill it with the new data
            this.CheckToRefillDialog(oFeedComponent);
        }

        this.UpdateFeedData(oFeedComponent);
    },

    ParsePodcastFeed: function(oFeedComponent, strXML) {
        if (!oFeedComponent.ComponentItem) return;

        var XMLDoc = null;

        if (strXML)
            XMLDoc = EBXML_CT2958529.GetXmlDocument(strXML);

        var bIsNewItemsFromServer = false;

        var oFeedParser = new EBFeedParser_CT2958529(XMLDoc, EBFeedConsts_CT2958529.MaxStructuredItems, oFeedComponent.ComponentItem.Podcast);
        //save the TTL
        if (oFeedParser.TTL) {
            var bIsChanged = EBFeedPreferencesManager_CT2958529.FeedTTL(oFeedComponent, oFeedParser.TTL);
            if (bIsChanged)
                this.ResetTimeoutCheck(oFeedComponent);
        }

        var oFeedElementArrayHash = oFeedParser.ArrayHash;
        var oFeedItemDataArrayHash = oFeedComponent.FeedData.Items.ArrayHash;
        oFeedItemDataArrayHash.Clear();

        //update feeddata data from server
        var strFeedTitle = oFeedParser.Title;
        var strFeedLink = oFeedParser.Link;
        oFeedComponent.FeedData.Data.Language = oFeedParser.Language;

        if (strFeedTitle)
            oFeedComponent.FeedData.Data.Title = strFeedTitle;
        else //if there isn't title take the title from the settings
            oFeedComponent.FeedData.Data.Title = oFeedComponent.ComponentItem.Title;

        if (strFeedLink)
            oFeedComponent.FeedData.Data.Link = strFeedLink;
        else //if there isn't link from the feed take the feed URL
            oFeedComponent.FeedData.Data.Link = oFeedComponent.ComponentItem.FeedURL;

        //compare between the items from the server to the items in the history and the structured
        if (oFeedElementArrayHash.Count() > 0) {
            var strTitle = '';
            var strLink = '';
            var strTooltip = '';
            var strStatus = '';
            var bVisited = false;

            //run on the items from the server
            var iCount = oFeedElementArrayHash.Count();
            var oFeedElement = null;
            var bIsItemInStructured = false;
            var bIsItemInHistory = false;
            var strHashKey = '';

            var oFeedItemData = null;
            //go backwards in the server items to add the newset items in the feed to the top of the structured ArrayHash
            for (var i = 0; i < iCount; i++) {
                oFeedElement = oFeedElementArrayHash.GetByIndex(i);
                strHashKey = oFeedElement.Link;
                strTitle = this.GetTitle(oFeedElement.Title);
                strLink = oFeedElement.Link;
                strTooltip = this.GetTooltipCaption(oFeedElement.Date);
                strStatus = EBFeedXMLConsts_CT2958529.UNREAD;
                oFeedItemData = new EBFeedItemData_CT2958529(strTitle,
												strLink,
												strTooltip,
												strStatus,
												bVisited);

                //insert to the top
                oFeedItemDataArrayHash.Add(oFeedItemData.Link, oFeedItemData);
            }
        }

        oFeedComponent.FeedData.Data.Stared = true;
        this.SaveFeedDataStructured(oFeedComponent);
        this.UpdateFeedData(oFeedComponent);
    },

    ParseLiveFeed: function(oFeedComponent, strXML) {
        if (!oFeedComponent.ComponentItem) return;

        var XMLDoc = null;

        if (strXML)
            XMLDoc = EBXML_CT2958529.GetXmlDocument(strXML);

        var oFeedParser = new EBFeedParser_CT2958529(XMLDoc, EBFeedConsts_CT2958529.MaxStructuredItems);
        //save the TTL
        if (oFeedParser.TTL) {
            var bIsChanged = EBFeedPreferencesManager_CT2958529.FeedTTL(oFeedComponent, oFeedParser.TTL);
            if (bIsChanged)
                this.ResetTimeoutCheck(oFeedComponent);
        }

        var oFeedElementArrayHash = oFeedParser.ArrayHash;
        var oFeedItemDataArrayHash = oFeedComponent.FeedData.Items.ArrayHash;
        var strFeedTitle = oFeedParser.Title;
        oFeedComponent.FeedData.Data.Language = oFeedParser.Language;

        if (strFeedTitle)
            oFeedComponent.FeedData.Data.Title = strFeedTitle;
        else //if there isn't title take the title from the settings
            oFeedComponent.FeedData.Data.Title = oFeedComponent.ComponentItem.Title;

        //check first if there is something new from the server:
        var bIsNewItems = false;
        var iCount = oFeedElementArrayHash.Count();
        var oFeedElement = null;
        var i;
        for (i = 0; i < iCount; i++) {
            oFeedElement = oFeedElementArrayHash.GetByIndex(i);
            strHashKey = oFeedElement.Link;

            //check if exists:
            if (!oFeedItemDataArrayHash.Contains(strHashKey)) {
                bIsNewItems = true;
                break;
            }
        }

        //if there is new items - clear all the existing ones and add what comes from the server
        if (bIsNewItems) {
            //clear all the items in the feed item data array hash:
            oFeedItemDataArrayHash.Clear();

            var strTitle = '';
            var strLink = '';
            var strTooltip = '';
            var strStatus = '';
            var bVisited = false;

            var oFeedItemData = null;
            for (i = 0; i < iCount; i++) {
                oFeedElement = oFeedElementArrayHash.GetByIndex(i);
                //in the live mode there isn't any need for tooltip and status 
                //but i keep them in case this live mode will become regular mode and becasue 
                //the live and editable mode save in the same data structure type
                strTitle = this.GetTitle(oFeedElement.Title);
                strLink = oFeedElement.Link;
                strTooltip = this.GetTooltipCaption(oFeedElement.Date);
                strStatus = EBFeedXMLConsts_CT2958529.UNREAD;

                oFeedItemData = new EBFeedItemData_CT2958529(strTitle,
												strLink,
												strTooltip,
												strStatus,
												bVisited);

                //insert to the top
                oFeedItemDataArrayHash.Add(oFeedItemData.Link, oFeedItemData);
            }

            //save the data and broadcast
            oFeedComponent.FeedData.Data.Stared = true;
            this.SaveFeedDataStructured(oFeedComponent);
        }

        this.notifyUpdate(oFeedComponent);
    },

    CheckToRefillDialog: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;

        //if there is opened feed popup, update it
        try {
            var popup = EBFeedUIManager_CT2958529.currentFeedPopup;
            if (!popup || !popup.manager || !popup.manager.reload ||
            popup.manager.m_oFeedComponent.ComponentItem.UniqueCompID != oFeedComponent.ComponentItem.UniqueCompID) return;

            EBFeedUIManager_CT2958529.currentFeedPopup.manager.reload(oFeedComponent);
        }
        catch (ex) {
            EBLog(ex);
        }
    },

    SaveFeedDataStructured: function(oFeedComponent) {
        this.ValidateMaxStructuredItems(oFeedComponent.FeedData);
        if (oFeedComponent.IsLiveMode)
            this.SaveLive(oFeedComponent);
        else
            this.SaveStructured(oFeedComponent);
    },

    ValidateMaxStructuredItems: function(oFeedData) {
        var oFeedItemDataArrayHash = oFeedData.Items.ArrayHash;
        var oFeedItemData = null;
        var iCount = oFeedItemDataArrayHash.Count();
        var iLastIndex = 0;
        while (iCount > EBFeedConsts_CT2958529.MaxStructuredItems) {
            //remove the last element
            iLastIndex = iCount - 1;
            oFeedItemData = oFeedItemDataArrayHash.GetByIndex(iLastIndex);
            if (oFeedItemData) {
                oFeedItemDataArrayHash.Remove(iLastIndex, oFeedItemData.Link);
                iCount = oFeedItemDataArrayHash.Count();
            }
            else
            //if there isn't item in that index for some reason break the loop!
                break;
        }

    },

    SaveFeedDataHistory: function(oFeedComponent) {
        this.ValidateMaxHistoryItems(oFeedComponent.HistoryData);
        this.SaveHistory(oFeedComponent);
    },

    ValidateMaxHistoryItems: function(oHistoryData) {
        var oHistoryItemDataArrayHash = oHistoryData.ArrayHash;

        var oHistoryItemData = null;
        var iCount = oHistoryItemDataArrayHash.Count();
        var iLastIndex = 0;
        while (iCount > EBFeedConsts_CT2958529.MaxHistoryItems) {
            //remove the last element
            iLastIndex = iCount - 1;
            oHistoryItemData = oHistoryItemDataArrayHash.GetByIndex(iLastIndex);
            if (oHistoryItemData) {
                oHistoryItemDataArrayHash.Remove(iLastIndex, oHistoryItemData.Link);
                iCount = oHistoryItemDataArrayHash.Count();
            }
            else
            //if there isn't item in that index for some reason break the loop!
                break;
        }
    },

    //update the NumOfNew of the feed component and then set the button label to the current new messages
    UpdateFeedData: function(oFeedComponent) {
        if (!oFeedComponent.FeedData) return;
        
        if (!oFeedComponent.IsLiveMode) {
            var iNumOfNew = 0;
            var oFeedItemDataArrayHash = oFeedComponent.FeedData.Items.ArrayHash;
            var oHistoryItemDataArrayHash = oFeedComponent.HistoryData.ArrayHash;

            //go through all the items - check that they are not in history 
            //and they are not read to increase the counter
            var oFeedItemData = null;
            var iCount = oFeedItemDataArrayHash.Count();

            for (var i = 0; i < iCount; i++) {
                oFeedItemData = oFeedItemDataArrayHash.GetByIndex(i);
                //check that the item is not in the history and it's unread
                if (!oHistoryItemDataArrayHash.Contains(oFeedItemData.Link) &&
                    oFeedItemData.Status == EBFeedXMLConsts_CT2958529.UNREAD)
                    iNumOfNew++;
            }

            //update the object data
            oFeedComponent.NumOfNew = iNumOfNew;
        }

        if (oFeedComponent.isCustom)
            oFeedComponent.Invoke(true);
        else
            this.notifyUpdate(oFeedComponent);
    },

    notifyUpdate: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;

        var subject = new Object();
        subject.feedComponent = oFeedComponent;
        subject.uniqueCompID = (oFeedComponent.IsMultiFeed) ? oFeedComponent.MultiFeedCompID : oFeedComponent.ComponentItem.UniqueCompID;
        subject.wrappedJSObject = subject;

        EBObserversManager_CT2958529.NotifyCustomObserver(subject,
                                                            EBFeedConsts_CT2958529.Observer.Topic_FeedObserver,
                                                            EBFeedConsts_CT2958529.Observer.Data_FeedReload);

    },

    //check if the time has passed to check again from the server
    IsTimeElapsed: function(oFeedComponent) {
        var bRetVal = true;

        var strPollDatePrefValue = EBFeedPreferencesManager_CT2958529.GetFeedPollDate(oFeedComponent);
        //check if that it's not empty
        if (strPollDatePrefValue) {
            //check difference between times:
            var iIntervalMinutes = this.GetFeedInterval(oFeedComponent);
            var oDateCurrent = new Date();
            var oDatePollDate = new Date(strPollDatePrefValue);

            var iCheckIntervalTime = 1000 * 60 * iIntervalMinutes;

            var iDateDiff = oDateCurrent - oDatePollDate;

            bRetVal = iDateDiff > iCheckIntervalTime;

        }
        return bRetVal;
    },

    GetFeedInterval: function(oFeedComponent) {
        if (!oFeedComponent.ComponentItem) return;

        var iInterval = oFeedComponent.ComponentItem.Interval;
        if (!iInterval || !isFinite(iInterval)) {
            iInterval = EBFeedConsts_CT2958529.DefaultInterval;
        }
        var iTTL = EBFeedPreferencesManager_CT2958529.FeedTTL(oFeedComponent);
        if (!iTTL) iTTL = 0;
        iInterval = Math.max(iInterval, iTTL);
        return iInterval;
    },

    GetTitle: function(strTitle) {
        if (!strTitle) {
            strTitle = EBFeedConsts_CT2958529.NoTitleCaption;
        }
        else {
            strTitle = strTitle.replace(/\n/g, '');
            strTitle = strTitle.replace(/\r/g, '');
            strTitle = EBGlobalManager_CT2958529.TrimToOne(strTitle);
            strTitle = EBGlobalManager_CT2958529.ToStripHTML(strTitle);
        }

        return strTitle;
    },

    GetTooltipCaption: function(strDate) {
        var strTooltip = 'Posted ' + strDate;
        return strTooltip;
    },

    ConstructRSSFeedXML: function(uniqueCompId, url, interval, isPodcast, isLiveMode) {
        var strXML = EBXML_CT2958529.CreateXmlNodeStartString(EBFeedXMLConsts_CT2958529.RSS_FEED_ITEM);
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.LINK, url);
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.PERMISSIONS, EBFeedXMLConsts_CT2958529.PermissionsValue);
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.USER_ATTRIBUTES, EBFeedXMLConsts_CT2958529.UserAttributesValue);
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.UNIQUE_COMP_ID, uniqueCompId);
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.DISPLAY_TEXT, '');
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.DISPLAY_ICON, '');
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.TITLE, '');
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.INTERVAL, interval);
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.ICON_NORMAL_URL, '');
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.IMAGE_STYLE, '');
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.LIVE_MODE, isLiveMode);
        strXML += EBXML_CT2958529.CreateXmlNodeString(EBFeedXMLConsts_CT2958529.PODCAST, isPodcast);
        strXML += EBXML_CT2958529.CreateXmlNodeEndString(EBFeedXMLConsts_CT2958529.RSS_FEED_ITEM);

        return EBXML_CT2958529.GetXmlDocument(strXML).documentElement;
    },

    DeleteFeedData: function(oFeedComponent) {
        try {
            EBFeedIOManager_CT2958529.DeleteFeedFiles(oFeedComponent);
            EBFeedPreferencesManager_CT2958529.NullifyFeedPrefs(oFeedComponent);
        }
        catch (ex) {
            EBLog(ex);
        }
    }
};
var FeedParserConsts_CT2958529 =
{
	TYPE : 
	{
		RSS		: 'RSS',
		ATOM	: 'ATOM' 	
	},

	RSS : 
	{
		CHANNEL		: 'channel',
		ITEM		: 'item',
		TITLE		: 'title',
		LINK		: 'link',
		GUID		: 'guid',
		PUBDATE		: 'pubdate',
		DCDATE		: 'dc:date',
		ISPERMALINK : 'isPermaLink',
		TRUE		: 'true',
		FALSE		: 'false',
		ENCLOSURE	: 'enclosure',
		URL			: 'url',
		LANGUAGE	: 'language',
		TTL: 'ttl'
	},
	
	ATOM : 
	{
		ENTRY		: 'entry',
		TITLE		: 'title',
		LINK		: 'link',
		HREF		: 'href',
		MODIFIED	: 'modified',
		TYPE		: 'type',
		TEXTHTML	: 'text/html',
		UPDATED     : 'updated',
		REL         : 'rel',
		ALTERNATE   : 'alternate'
	}
}

function EBFeedElement_CT2958529(strTitle,strLink,strDate)
{
	this.Title	= strTitle;
	this.Link	= strLink;
	this.Date	= strDate;
}

function EBFeedParser_CT2958529(XMLDoc,iMaxElements,isPodcast)
{
	this.Type			= '';
	
	this.Title			= '';
	this.Link			= '';
	this.ArrayHash		= new EBArrayHashObject_CT2958529();
	this.MaxElements	= iMaxElements;
	this.Language = '';
	this.TTL = 0;

	this.Init = function(XMLDoc)
	{
		if(XMLDoc)
		{
			var XMLRoot = XMLDoc.documentElement;
			if(XMLRoot.tagName != 'parsererror')
			{
				this.BuildFeed(XMLRoot);
			}
		}
	};
	
	this.BuildFeed = function(XMLRoot)
	{
		var XMLFeedItems = this.GetFeedItems(XMLRoot);
		this.SetFeedLanguage(XMLRoot);
		this.SetFeedTTL(XMLRoot);
		
		if(XMLFeedItems)
		{
			if(this.Type == FeedParserConsts_CT2958529.TYPE.RSS)
			{
				this.SetRSSFeedTitleLink(XMLRoot);
				this.BuildRSSFeedItems(XMLFeedItems);
			}
			else if(this.Type == FeedParserConsts_CT2958529.TYPE.ATOM)
			{
				this.SetATOMFeedTitleLink(XMLRoot);
				this.BuildATOMFeedItems(XMLFeedItems);
			}
		}
	};

	this.SetFeedLanguage = function(XMLRoot) {
	    var lang = XMLRoot.getElementsByTagName(FeedParserConsts_CT2958529.RSS.LANGUAGE);
	    if (lang.length > 0) {
	        this.Language = EBXML_CT2958529.GetXmlNodeValue(lang.item(0));
	    }
	};

	this.SetFeedTTL = function(XMLRoot) {
	    this.TTL = EBXML_CT2958529.GetSingleNodeValueAsInteger(XMLRoot, FeedParserConsts_CT2958529.RSS.TTL, 0);
	};

	this.BuildRSSFeedItems = function(XMLFeedItems) {
	    var strTitle = '';
	    var strLink = '';
	    var strDate = '';

	    var strURLFromLinkNode = '';
	    var strURLFromEnclosureNode = '';
	    var oAttributes = null;
	    var oAttURL = '';
	    var strURLFromGUIDPermaLinkNode = '';

	    var strTagName = '';

	    var XMLFeedItem = null;
	    var XMLChildNode = null;
	    for (var i = 0; i < XMLFeedItems.length; i++) {
	        XMLFeedItem = XMLFeedItems.item(i);
	        for (var j = 0; j < XMLFeedItem.childNodes.length; j++) {
	            XMLChildNode = XMLFeedItem.childNodes[j];
	            strTagName = XMLChildNode.tagName;
	            if (typeof (strTagName) == 'string') {
	                strTagName = strTagName.toLowerCase();
	            }

	            if (strTagName == FeedParserConsts_CT2958529.RSS.TITLE) {
	                strTitle = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
	            }
	            else if (strTagName == FeedParserConsts_CT2958529.RSS.ENCLOSURE) {
	                oAttributes = XMLChildNode.attributes;
	                oAttURL = oAttributes.getNamedItem(FeedParserConsts_CT2958529.RSS.URL);
	                strURLFromEnclosureNode = oAttURL.nodeValue;
	            }
	            else if (strTagName == FeedParserConsts_CT2958529.RSS.LINK) {
	                strURLFromLinkNode = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
	            }
	            else if (strTagName == FeedParserConsts_CT2958529.RSS.GUID) {
	                strURLFromGUIDPermaLinkNode = this.GetRSSLinkFromXMLGUIDNode(XMLChildNode);
	            }
	            else if (strTagName == FeedParserConsts_CT2958529.RSS.PUBDATE) {
	                strDate = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
	            }
	            else if (strTagName == FeedParserConsts_CT2958529.RSS.DCDATE) {
	                strDate = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
	            }
	        }

	        if (isPodcast) {
	            strLink = strURLFromEnclosureNode ? strURLFromEnclosureNode : strURLFromLinkNode;
	        }
	        else {
	            strLink = strURLFromLinkNode ? strURLFromLinkNode : strURLFromGUIDPermaLinkNode;
	        }

	        if (strLink) {
	            this.AddFeedElement(strTitle, strLink, strDate);
	        }

	        if (this.IsMaxElements()) {
	            break;
	        }
	    }
	};

	this.BuildATOMFeedItems = function(XMLFeedItems) {
	    var strTitle = '';
	    var strLink = '';
	    var strDate = '';

	    var strURLFromLinkNodeTextHTML = '';
	    var strURLFromLinkNode = '';

	    var strTagName = '';
	    var XMLFeedItem = null;
	    var xpathResult = null;
	    for (var i = 0; i < XMLFeedItems.length; i++) {
	        XMLFeedItem = XMLFeedItems.item(i);
	        strTitle = EBXML_CT2958529.GetSingleNodeValue(XMLFeedItem, FeedParserConsts_CT2958529.ATOM.TITLE);
	        strDate = EBXML_CT2958529.GetSingleNodeValue(XMLFeedItem, FeedParserConsts_CT2958529.ATOM.UPDATED);
	        strLink = this.GetAtomLink(XMLFeedItem);

	        if (strLink && strTitle)
	            this.AddFeedElement(strTitle, strLink, strDate);

	        if (this.IsMaxElements())
	            break;
	    }
	};

	this.GetAtomLink = function(xmlElement) {
	    var arrLink = xmlElement.getElementsByTagName(FeedParserConsts_CT2958529.ATOM.LINK);
	    var xmlLink = "";
	    
	    //only one link tag, return it.
	    if (arrLink.length == 1) return arrLink[0].getAttribute(FeedParserConsts_CT2958529.ATOM.HREF);
	    
	    for (var i = 0; i < arrLink.length; i++) {
	        xmlLink = arrLink.item(i);
	        if (xmlLink.getAttribute(FeedParserConsts_CT2958529.ATOM.TYPE) == FeedParserConsts_CT2958529.ATOM.TEXTHTML &&
	            xmlLink.getAttribute(FeedParserConsts_CT2958529.ATOM.REL) == FeedParserConsts_CT2958529.ATOM.ALTERNATE)
	            return xmlLink.getAttribute(FeedParserConsts_CT2958529.ATOM.HREF);
	    }

	    return "";
	};
	
	this.AddFeedElement = function(strTitle,strLink,strDate)
	{
		var oFeedElement = new EBFeedElement_CT2958529(strTitle,strLink,strDate);
		this.ArrayHash.Add(oFeedElement.Link,oFeedElement);
	};
	
	this.IsMaxElements = function()
	{
		var bRetVal = false;
		
		if(this.MaxElements && this.ArrayHash.Count() >= this.MaxElements)
		{
			bRetVal = true;
		}		
		
		return bRetVal;
	};
	
	this.GetFeedItems = function(XMLRoot)
	{
		var XMLFeedItems = null;
		//check rss
		XMLFeedItems = XMLRoot.getElementsByTagName(FeedParserConsts_CT2958529.RSS.ITEM);
		if(XMLFeedItems.length > 0)
		{
			this.Type	= FeedParserConsts_CT2958529.TYPE.RSS;
			return XMLFeedItems;
		}
		
		//check atom
		XMLFeedItems = XMLRoot.getElementsByTagName(FeedParserConsts_CT2958529.ATOM.ENTRY);
		if(XMLFeedItems.length > 0)
		{
			this.Type	= FeedParserConsts_CT2958529.TYPE.ATOM;
			return XMLFeedItems;
		}
		
		return null;
		
	};

	this.SetRSSFeedTitleLink = function(XMLRoot) {
	    var strFeedTitle = '';
	    var strFeedLink = '';
	    var XMLChildNode = null;
	    var XMLChannelNode = null;
	    var strTagName = '';
	    var i;
	    for (i = 0; i < XMLRoot.childNodes.length; i++) {
	        XMLChildNode = XMLRoot.childNodes[i];
	        strTagName = XMLChildNode.tagName;
	        
	        if (typeof (strTagName) == 'string')
	            strTagName = strTagName.toLowerCase();

	        if (strTagName == FeedParserConsts_CT2958529.RSS.CHANNEL) {
	            XMLChannelNode = XMLChildNode;
	            break;
	        }
	    }

	    if (XMLChannelNode) {
	        for (i = 0; i < XMLChannelNode.childNodes.length; i++) {
	            XMLChildNode = XMLChannelNode.childNodes[i];
	            strTagName = XMLChildNode.tagName;
	            if (typeof (strTagName) == 'string')
	                strTagName = strTagName.toLowerCase();

	            if (strTagName == FeedParserConsts_CT2958529.RSS.TITLE)
	                strFeedTitle = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
	            else if (strTagName == FeedParserConsts_CT2958529.RSS.LINK)
	                strFeedLink = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);

	            if (strFeedTitle && strFeedLink)
	                break;
	        }
	    }
	    
	    this.Title = strFeedTitle;
	    this.Link = strFeedLink;
	};
	
	this.SetATOMFeedTitleLink = function(XMLRoot)
	{
		var strFeedTitle	= '';
		var strFeedLink		= '';
		var XMLChildNode	= null;
		var strTagName		= '';
		
		for(var i=0;i<XMLRoot.childNodes.length;i++)
		{
			XMLChildNode = XMLRoot.childNodes[i];
			strTagName	 = XMLChildNode.tagName;
			if(typeof(strTagName) == 'string')
			{
				strTagName = strTagName.toLowerCase();
			}
			
			if(strTagName == FeedParserConsts_CT2958529.ATOM.TITLE)
			{
				strFeedTitle = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
			}
			else if(strTagName == FeedParserConsts_CT2958529.ATOM.LINK)
			{
				strFeedLink = this.GetATOMLinkFromXMLLinkNodeTextHTML(XMLChildNode);
				if(!strFeedLink)
				{
					strFeedLink =  this.GetATOMLinkFromXMLLink(XMLChildNode);
				}
			}
			
			if(strFeedTitle && strFeedLink)
			{
				break;
			}
		}
		
		this.Title		= strFeedTitle;
		this.Link		= strFeedLink;
	};

	this.GetATOMLinkFromXMLLinkNodeTextHTML = function(XMLLinkNode) {
	    var strLink = '';

	    var oAttributes = null;
	    var oAttType = null;
	    var oAttHref = null;

	    oAttributes = XMLLinkNode.attributes;
	    oAttHref = oAttributes.getNamedItem(FeedParserConsts_CT2958529.ATOM.HREF);
	    oAttType = oAttributes.getNamedItem(FeedParserConsts_CT2958529.ATOM.TYPE);
	    if (oAttHref && oAttType && oAttType.nodeValue.toLowerCase() == FeedParserConsts_CT2958529.ATOM.TEXTHTML)
	        strLink = oAttHref.nodeValue;

	    if(strLink)
	        strLink = EBUrl_CT2958529.AddHTTPProtocol(strLink);
	    
	    return strLink;
	};
	
	this.GetATOMLinkFromXMLLink = function(XMLLinkNode)
	{
		var strLink = '';
	
		var oAttributes		= null;
		var oAttHref		= null;
		
		oAttributes = XMLLinkNode.attributes;
		oAttHref	= oAttributes.getNamedItem(FeedParserConsts_CT2958529.ATOM.HREF);
		
		if(oAttHref)
			strLink = oAttHref.nodeValue;
		
		if(strLink)
		    strLink = EBUrl_CT2958529.AddHTTPProtocol(strLink);
		
		return strLink;
	};	
	
	this.GetRSSLinkFromXMLGUIDNode = function(XMLGUIDNode)
	{
		var strLink = '';
		var oAttributes		= null;
		var oAttIsPermaLink	= null;
		
		oAttributes		= XMLGUIDNode.attributes;
		oAttIsPermaLink	= oAttributes.getNamedItem(FeedParserConsts_CT2958529.RSS.ISPERMALINK);
	
		if(!oAttIsPermaLink || oAttIsPermaLink.nodeValue.toLowerCase() == FeedParserConsts_CT2958529.RSS.TRUE)
		{
			strLink = EBXML_CT2958529.GetXmlNodeValue(XMLGUIDNode);
		}
		
		return strLink;
	};
	
	this.Init(XMLDoc);
}

var EBFeedUIManager_CT2958529 =
{
    currentFeedPopup: null,
    currentMultiFeedPopup: null,
    currentMultiFeedPopupCompId: null,

    onFeedShowing: function(e, strCompID, iMultiIndex) {
        if (e.eventPhase != 2) return false;

        this.currentFeedPopup = e.target;
        var oFeedComponent = (iMultiIndex == -1) ?
		    EBComponentsManager_CT2958529.GetComponentByCompID(strCompID) :
		    EBComponentsManager_CT2958529.GetComponentByCompID(strCompID).FeedComponents[iMultiIndex];

        //close other feed dialog, it can remain opened in sertain conditions
        this._closeOtherFeedPopups(e.target);

        if (oFeedComponent)
            e.target.init(oFeedComponent); //event.target = feed menupopup

        return true;
    },

    onFeedsMenuShowing: function(e, strCompID, bIsTwitter) {
        if (!e.target.hasAttribute("eb-main-feed-popup")) return true;
        if (e.eventPhase != 2) return false;

        e.target.onclick = function(e) {
            if (e.button != 2) return;
            e.preventDefault();
            return false;
        };
        e.target.ondblclick = function(e) {
            if (e.button != 2) return;
            e.preventDefault();
            return false;
        };

        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompID);
        oComponent.createFeedsMenu(e.target);

        this.currentMultiFeedPopup = e.target;
        this.currentMultiFeedPopupCompId = strCompID;

        //usage
        if (bIsTwitter)
            EBUsageTwitter_CT2958529.OnOpenMultiRss();
        else
            EBUsageRss_CT2958529.OnOpenMultiRss();

        return true;
    },

    onFeedsMenuShown: function(e, strCompID) {
        if (!e.target.hasAttribute("eb-main-feed-popup")) return true;
        if (e.eventPhase != 2) return false;

        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompID);
        oComponent.updateStarsOnFeedsMenu(e.target);
    },

    onFeedMenuHiding: function(e, strCompID, bIsTwitter) {
        if (!e.target.hasAttribute("eb-main-feed-popup")) return true;
        if (e.eventPhase != 2) return false;

        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompID);
        oComponent.emptyFeedsMenu(e.target);

        this.currentMultiFeedPopup = null;
        this.currentMultiFeedPopupCompId = null;

        if (bIsTwitter)
            EBUsageTwitter_CT2958529.OnCloseMultiRss(strCompID, oComponent.ComponentItem.CompType);
        else
            EBUsageRss_CT2958529.OnCloseMultiRss(strCompID, oComponent.ComponentItem.CompType);

        return true;
    },

    _closeOtherFeedPopups: function(currentPopup) {
        var arrPopups = document.getElementsByTagName("menupopup");
        var xulPopup = null;

        for (var i = 0; i < arrPopups.length; i++) {
            xulPopup = arrPopups[i];
            if ((xulPopup.className.indexOf("ebFeedDialogPopup") != -1 || xulPopup.className.indexOf("ebTwitterDialogPopup") != -1) &&
                xulPopup.id != currentPopup.id &&
                xulPopup.closeMe)

                xulPopup.closeMe(false);
        }
    },

    //this funcion will close feed popup and multi feed menu if opened
    closeFeed: function(xulPopup) {
        if (!xulPopup.closeMe) return;

        xulPopup.closeMe(true);
        var xulParent = xulPopup.parentNode.parentNode;
        //close multi feed menupopup (multi rss)
        if (xulParent.tagName == "menupopup") {
            xulParent.hidePopup();
            //hide chevron (if in chevron)
            if (xulParent.parentNode && xulParent.parentNode.parentNode && xulParent.parentNode.parentNode.hidePopup)
                xulParent.parentNode.parentNode.hidePopup();
        }
    },

    updateMultiFeedMenu: function(multiFeedId, menupopup, feedIndex) {
        if (!menupopup) return;

        var oFeedComponent = EBComponentsManager_CT2958529.GetComponentByCompID(multiFeedId);
        oFeedComponent.updateFeedCountInMenu(menupopup, feedIndex);
    },

    removeStarOnMultiRssMenu: function(xulFeedPopup, strCompID) {
        var xulMenu = xulFeedPopup.parentNode;
        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strCompID);
        oComponent.removeStarOnMenu(xulMenu, xulMenu.parentNode);
    },

    //update the count in multifeed menu popup if open for specific multifeed
    updateMultifeedCountInMenu: function(uniqueCompId, iFeedIndex) {
        if (!this.currentFeedPopup || this.currentMultiFeedPopupCompId != uniqueCompId) return;

        this.updateMultiFeedMenu(uniqueCompId, this.currentMultiFeedPopup, iFeedIndex);
    },

    Context_OnCommandShowInNewWindow: function(event, bIsTab) {
        this.currentFeedPopup.manager.xulContext.style.display = "none";
        this.currentFeedPopup.manager.OnCommandShowInNewWindow(event, bIsTab);
    },

    Context_OnCommandDeleteMessage: function(event) {
        this.currentFeedPopup.manager.xulContext.style.display = "none";
        this.currentFeedPopup.manager.OnCommandDeleteMessage(event);
    }
};
var EBIniFile_CT2958529 =
{
    filename: 'setup.ini',
    globalKeysFilename: 'globalkeys.ini',


    getFile: function(strFileName) {
        if (strFileName != this.filename && strFileName != this.globalKeysFilename) return null;
        var extPath = EBIOManager_CT2958529.GetSynchronicExtentionPath(EBGlobalConsts_CT2958529.GUID);
        extPath.append(strFileName);
        if (extPath.exists()) {
            return extPath;
        }
        else
            return null;
    },

    getParamsFromFile: function(strFileName) {
        var oFile = EBIniFile_CT2958529.getFile(strFileName);
        if (!oFile) return null;

        var strText = EBFileIO_CT2958529.read(oFile, EBGlobalConsts_CT2958529.DefaultCharset);
        var arrLines = strText.split('\n');
        var oParams = new ToolbarParams_CT2958529();

        switch (strFileName) {
            case this.filename:
                for (var i = 0; i < arrLines.length; i++)
                    this.fillParam(arrLines[i], oParams);
                return oParams;
                break;
            case this.globalKeysFilename:
                var arrKeys = new Array(2);
                arrKeys[0] = new Array();
                arrKeys[1] = new Array();
                for (var i = 0; i < arrLines.length; i++)
                    this.fillParamAsArray(arrLines[i], arrKeys);
                return arrKeys;
                break;
            default: return oParams;
        }
    },

    fillParam: function(strLine, oParams) {
        if (!strLine || strLine.indexOf("=") == -1) return;
        var paramName = "";
        var paramValue = "";
        try {
            paramName = strLine.split('=')[0];
            paramValue = (strLine.match(/=(.*)/))[1];
        } catch (e) { return; }

        switch (paramName) {
            case '_SET_DEFAULT_SEARCH_':
                oParams.FFSearchIsDefault = EBGlobalManager_CT2958529.StringToBoolean(paramValue);
                oParams.FFSearchIsChecked = EBGlobalManager_CT2958529.StringToBoolean(paramValue);
                break;
            case '_DEFAULT_SEARCH_DISPLAY_NAME_': oParams.FFSearchCaption = paramValue; break;
            case '_DEFAULT_SEARCH_URL_':
                oParams.FFSearchUrl = paramValue;
                oParams.FFAddressBarSearchUrl = paramValue;
                break;
            case '_START_PAGE_': oParams.HomepageIsSet = EBGlobalManager_CT2958529.StringToBoolean(paramValue); break;
            case '_SETUP_FIX_404_CHK_BOX_VAL_': oParams.Fix404IsChecked = EBGlobalManager_CT2958529.StringToBoolean(paramValue); break;
            case '_CT_ID_': oParams.SelectedCTID = paramValue; break;
            case '_OPEN_THANKYOU_PAGE_': oParams.IsOpenThankYouPage = EBGlobalManager_CT2958529.StringToBoolean(paramValue); break;
            case '_OPEN_UNINSTALL_PAGE_': oParams.IsOpenUninstallPage = EBGlobalManager_CT2958529.StringToBoolean(paramValue); break;
            case '_OPEN_WELCOME_DIALOG_': oParams.IsOpenWelcomeDialog = EBGlobalManager_CT2958529.StringToBoolean(paramValue); break;
            case 'true': oParams.SearchFromAddress = EBGlobalManager_CT2958529.StringToBoolean(paramValue); break;
            case '_INSTALL_TYPE_': oParams.InstallationType = paramValue; break;
            case '_INSTALL_ID_': oParams.InstallationId = paramValue; break;
            default: break;
        }
    },

    fillParamAsArray: function(strLine, arrKeys) {
        if (!strLine || strLine.indexOf("=") == -1) return;
        var paramName = "";
        var paramValue = "";
        try {
            paramName = strLine.split('=')[0];
            paramValue = (strLine.match(/=(.*)/))[1];
        } catch (e) { return; }

        if (paramName && paramValue) {
            arrKeys[0].push(paramName);
            arrKeys[1].push(paramValue);
        }
    }
};
function ToolbarParams_CT2958529() {
    this.FFSearchIsChecked = true; //boolean
    this.FFSearchIsDefault = null; //boolean
    this.FFSearchCaption = '';
    this.FFSearchUrl = '';
    this.FFAddressBarSearchUrl = '';
    this.HomepageIsSet = null; //boolean
    this.Fix404IsChecked = null; //boolean
    this.SelectedCTID = '';
    this.IsOpenThankYouPage = true; //boolean
    this.IsOpenUninstallPage = null; //boolean
    this.IsOpenWelcomeDialog = EBGlobalConsts_CT2958529.IsEngine ? true : null; //boolean
    this.SearchFromAddress = null; //boolean
    this.InstallationType = "";
    this.InstallationId = "";
}

var EBInitParams_CT2958529 =
{
    engineName: 'browsersearch Customized Web Search',
    srcFileName: 'conduit.src',
    xmlFileName: 'conduit.xml',
    imgFileName: 'conduit.gif',
    engineURL: 'http://search.conduit.com/ResultsExt.aspx?ctid=CT2958529&SearchSource=3&q={searchTerms}',
    homepageUrl: 'http://search.conduit.com/?ctid=CT2958529&SearchSource=13',
    homepageText: '',
    prefHomePage: 'browser.startup.homepage',
    homepageIsChecked: false,
    FFSearchIsDefault: true,
    WelcomeDialogMode: "full",
    unknownIntegration: "UnknownIntegration",

    settingsReady: false,
    languagePackReady: false,
    isDialogsReady: false,
    initDone: false,
    oParams: null,

    isAllInitDone: function() {
        var isInit = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.FirstTime);
        var isInitSearchFromAddressBar = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.SearchFromAddressBarIsInit);
        var isFF3FirstTime = this.isFF3FirstTime();

        if (isInit && isFF3FirstTime && isInitSearchFromAddressBar)
            return true;
        else
            return false;
    },

    initFirstData: function() {
        try {
            //the name of the pref key is globalKeys, because it's started form global keys task, now we also using this function,
            //to read setup.ini in order to save the installation params before we send first login.
            if (EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.HasUserGlobalKeys)) return;

            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.HasUserGlobalKeys, true);

            //init global keys
            var arrkeys = EBIniFile_CT2958529.getParamsFromFile(EBIniFile_CT2958529.globalKeysFilename);
            //have globalkeys.ini file
            if (arrkeys) {
                for (var i = 0; i < arrkeys[0].length; i++)
                    EBBrowserComponentApiManager_CT2958529.storeGlobalKey(arrkeys[0][i], arrkeys[1][i]);
            }
            
            //read setup.ini
            this.oParams = EBIniFile_CT2958529.getParamsFromFile(EBIniFile_CT2958529.filename);
            
            //save installation params to prefs, in order to send in login
            if(this.oParams) {
                if (this.oParams.InstallationType)
                    EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.InstallationType, this.oParams.InstallationType);
                else
                    EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.InstallationType, EBInitParams_CT2958529.unknownIntegration);

                if (this.oParams.InstallationId)
                    EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.InstallationId, this.oParams.InstallationId);
            }
            
        } catch (e) { EBLog('initFirstData error: ' + e); }
    },

    initFromSettings: function() {
        var engineDependOnToolbarkey = EBPreferenceConsts_CT2958529.EngineDependOnToolbar + "." + EBGlobalConsts_CT2958529.GUID;
        if (EBGlobalConsts_CT2958529.MyStuffEnabled && EBGlobalConsts_CT2958529.AddToEngineUninstall && !EBGlobalConsts_CT2958529.IsEngine && !EBGlobalPreferenceManager_CT2958529.GetPref(engineDependOnToolbarkey))
            EBGlobalPreferenceManager_CT2958529.SetPref(engineDependOnToolbarkey, EBGlobalConsts_CT2958529.ToolbarCTID);

        if (this.isAllInitDone()) return;

        this.settingsReady = true;

        
        //have setup.ini file
        if (this.oParams) {
            //only publisher that AllowSilentInstallation is enabled can disable the welcome dialog.
            this.oParams.IsOpenWelcomeDialog = (EBGlobalConsts_CT2958529.AllowSilentInstallation) ? this.oParams.IsOpenWelcomeDialog : true;

            var isToOpen = EBGlobalConsts_CT2958529.IsEngine ? false : this.oParams.IsOpenThankYouPage;

            this.setIsOpenThankYouPage(isToOpen);
            //if show welcome dialog is set to false there is no need to wait for Language pack
            if (!this.oParams.IsOpenWelcomeDialog) {
                this._init();
                return;
            }
        }
        if (this.languagePackReady && this.isDialogsReady)
            this._init();
        else {
            var that = this;
            setTimeout(function() {
                if ( oToolbarManager_CT2958529.dialogsManager.isDialogsReady()) that._init();
            }, 15000);
        }
    },

    initFromLP: function() {
        if (this.isAllInitDone()) return;
        this.languagePackReady = true;

        if (this.settingsReady && this.isDialogsReady) this._init();
    },

    initFromDialogsReady: function() {
        if (this.isAllInitDone()) return;
        this.isDialogsReady = true;

        if (this.settingsReady && this.languagePackReady) this._init();
    },

    _init: function() {
        if (this.initDone) return;
        this.initDone = true;

        var isInit = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.FirstTime);
        var isInitSearchFromAddressBar = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.SearchFromAddressBarIsInit);

        var isFF3FirstTime = this.isFF3FirstTime();

        if (isInit && isFF3FirstTime && isInitSearchFromAddressBar)
            return;

        //set not to init again search from address bar
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.SearchFromAddressBarIsInit, true);

        if (!this.oParams)
            this.oParams = new ToolbarParams_CT2958529();

        var bIsRebuildSearchEngine = (isInit) ? false : true;
        this.addDefaultsToParams(this.oParams, bIsRebuildSearchEngine);

        //set installed date to prefs
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.InstalledDate, Date());
        //init all
        if (bIsRebuildSearchEngine) {
            this.applyParams(this.oParams, this.oParams.IsOpenWelcomeDialog);
            if (this.oParams.IsOpenWelcomeDialog) {
                var welcomeDialogObj;
                if (EBGlobalConsts_CT2958529.IsEngine && !DualPackageFunctions_CT2958529.isEngineInDualPackage() || !EBGlobalConsts_CT2958529.IsEngine) {
                    welcomeDialogObj = EBGlobalConsts_CT2958529.IsEngine ? EBWelcomeDialogCE_CT2958529 : EBWelcomeDialog_CT2958529;
                    welcomeDialogObj.OpenWelcomeDialog(this.oParams);
                }
                else
                    if (EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.isEngineInDualPackage()) {
                    EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.FirstTime, true);
                    //first time login
                    oToolbarManager_CT2958529.isFinishClicked = true;
                }
            }
            else {
                //set not to init again
                EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.FirstTime, true);
                //first time login
                oToolbarManager_CT2958529.isFinishClicked = true;
                if (this.oParams.SelectedCTID == EBGlobalConsts_CT2958529.ToolbarCTID) {
                    if (!EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.CTID))
                        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CTID, EBGlobalConsts_CT2958529.ToolbarCTID);
                    EBToolbarManager_CT2958529.broadcastRebuild(oToolbar_CT2958529.toolbarDataParsing.observerData.settings);
                }
                else
                    oToolbar_CT2958529.toolbar.switchToCommunity(EBGlobalConsts_CT2958529.ToolbarCTID,
                                                    EBGlobalConsts_CT2958529.ToolbarCTID,
                                                    this.oParams.SelectedCTID);
            }
        }
        //init only the search from address bar
        else if (!isInitSearchFromAddressBar)
            EBSearchFromAddressBar_CT2958529.firstTime(this.oParams.FFAddressBarSearchUrl, oParams.SearchFromAddress);
    },

    addDefaultsToParams: function(oParams, bIsRebuildSearchEngine) {
        var bIsRebuildEngineXml = false;
        if (oParams.FFSearchIsDefault == null)
            oParams.FFSearchIsDefault = this.FFSearchIsDefault;

        if (!oParams.FFSearchCaption)
            oParams.FFSearchCaption = this.engineName;
        else
            bIsRebuildEngineXml = true;

        if (!oParams.FFSearchUrl) {
            oParams.FFSearchUrl = this.engineURL;
            oParams.FFAddressBarSearchUrl = EBSearchFromAddressBar_CT2958529.addressBarEngineURL;
        }
        else
            bIsRebuildEngineXml = true;

        if (oParams.HomepageIsSet == null)
            oParams.HomepageIsSet = this.homepageIsChecked;
        if (oParams.Fix404IsChecked == null)
            oParams.Fix404IsChecked = EBGlobalConsts_CT2958529.FixPageNotFoundErrorsChecked;
        if (!oParams.SelectedCTID)
            oParams.SelectedCTID = EBGlobalConsts_CT2958529.ToolbarCTID;
        if (oParams.IsOpenUninstallPage == null)
            oParams.IsOpenUninstallPage = EBGlobalConsts_CT2958529.ShowUninstallPage;
        if (oParams.SearchFromAddress == null)
            oParams.SearchFromAddress = oParams.FFSearchIsDefault;
        if (oParams.IsOpenWelcomeDialog == null)
            oParams.IsOpenWelcomeDialog = (EBInitParams_CT2958529.WelcomeDialogMode == "none") ? false : true;


        if (bIsRebuildEngineXml && bIsRebuildEngineXml)
            this.rebuildEngineXml(oParams.FFSearchCaption, oParams.FFSearchUrl);
    },

    rebuildEngineXml: function(strCaption, strSearchUrl) {
        EBIOManager_CT2958529.GetExtentionPath(EBGlobalConsts_CT2958529.GUID, function(extPath) {
            try {
                var oFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
                oFile.initWithPath(extPath);
                oFile.appendRelativePath('searchplugin');
                oFile.appendRelativePath('conduit.xml');
                if (!oFile) return;

                var strSearchXml = EBFileIO_CT2958529.read(oFile);
                var xmlSearch = EBXML_CT2958529.GetXmlDocument(strSearchXml);
                var xmlShortName = EBXML_CT2958529.SelectSingleNode(xmlSearch, "ShortName");
                var xmlDescription = EBXML_CT2958529.SelectSingleNode(xmlSearch, "Description");
                var xmlUrl = EBXML_CT2958529.SelectSingleNode(xmlSearch, "Url");
                var xmlSeachForm = EBXML_CT2958529.SelectSingleNode(xmlSearch, "SearchForm");

                xmlShortName.firstChild.nodeValue = strCaption;
                xmlDescription.firstChild.nodeValue = strCaption;
                xmlSeachForm.firstChild.nodeValue = strSearchUrl;
                xmlUrl.setAttribute("template", strSearchUrl);

                strSearchXml = EBXML_CT2958529.GetStringXml(xmlSearch);
                EBFileIO_CT2958529.write(oFile, strSearchXml, null, EBGlobalConsts_CT2958529.DefaultCharset);
            }
            catch (ex) {
            }
        });
    },

    applyParams: function(oParams, bIsUserInput) {
        var isToOpen = EBGlobalConsts_CT2958529.IsEngine ? false : this.oParams.IsOpenThankYouPage;
        this.setIsOpenThankYouPage(isToOpen);
        this.setIsOpenUninstallPage(oParams.IsOpenUninstallPage);

        if (!bIsUserInput) {
            this.SetEngine(oParams.FFSearchIsChecked, oParams.FFSearchIsDefault, oParams);
            if (oParams.HomepageIsSet) this.SetHomepage();
            this.setFix404(oParams.Fix404IsChecked);
            EBSearchFromAddressBar_CT2958529.firstTime(oParams.FFAddressBarSearchUrl, oParams.SearchFromAddress);
        }
    },

    isFF3FirstTime: function() {
        if (!EBGlobalManager_CT2958529.IsFirefox3() || EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.FirstTimeFF3))
            return true;

        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.FirstTimeFF3, true);

        var sep = EBDirIO_CT2958529.sep;

        var plugDir = EBIOManager_CT2958529.GetSearchPluginsDir();
        var plug2Dir = this.getProfileSearchPluginsFolder();
        var that = this;
        EBIOManager_CT2958529.GetExtentionPath(EBGlobalConsts_CT2958529.GUID, function(extPath) {
            var engineSrc = EBFileIO_CT2958529.open(plugDir.path);
            engineSrc.appendRelativePath(that.xmlFileName);
            var engine2Src = EBFileIO_CT2958529.open(plug2Dir);
            engine2Src.appendRelativePath(that.xmlFileName);

            try {
                if (engineSrc.exists() || engine2Src.exists())
                    return true;
                else
                    return false;
            }
            catch (e) {
                return true;
            }
        });
    },

    copyFile: function(fileObj, destdir, filename) {
        // get a component for the directory to copy to
        var aDir = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
        if (!aDir) return false;

        // next, assign URLs to the file components
        aDir.initWithPath(destdir);
        aDir.appendRelativePath(filename);
        try {
            aDir.remove(false);
        }
        catch (ex) { }
        aDir.initWithPath(destdir);

        // finally, copy the file, without renaming it
        try {
            if (aDir.isWritable()) {
                fileObj.copyTo(aDir, null);
            }
            else
                return false;
        }
        catch (ex) {
            EBLog(ex);
        }
        return true;
    },

    CreatePluginsFolder: function(strPath) {
        var oDir = EBDirIO_CT2958529.open(strPath);
        if (!oDir.exists())
            EBDirIO_CT2958529.create(oDir);
    },

    getProfileSearchPluginsFolder: function() {
        var plugDir = EBIOManager_CT2958529.GetPrefsDir();
        var strDestPath = plugDir.path + EBDirIO_CT2958529.sep + "searchplugins";
        return strDestPath;
    },

    removeHiddenSearch: function() {
        try {
            var prefDir = EBIOManager_CT2958529.GetPrefsDir();

            //remove from .sqlite file
            var searchSqlite = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            searchSqlite.initWithPath(prefDir.path);
            searchSqlite.appendRelativePath("search.sqlite");
            if (searchSqlite.exists()) {
                var storageService = Components.classes["@mozilla.org/storage/service;1"]
                                    .getService(Components.interfaces.mozIStorageService);
                var dbConn = storageService.openDatabase(searchSqlite);
                dbConn.executeSimpleSQL("UPDATE engine_data SET name='order' WHERE (engineid='[profile]/conduit.xml' OR engineid='[pp]/conduit.xml') AND name='hidden'");
                dbConn.close();
            }

            //remove from json file.
            var searchJson = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            searchJson.initWithPath(prefDir.path);
            searchJson.appendRelativePath("search.json");
            if (searchJson.exists()) {
                var strSearchJson = EBFileIO_CT2958529.read(searchJson, "UTF-8");
                if (!strSearchJson) return;
                var objSearchEngines = null;
                try {
                    objSearchEngines = JSON.parse(strSearchJson);
                } catch (e) { return; }
                var engines = null;
                var conduitEngine = null;
                for (var i in objSearchEngines.directories) {
                    engines = objSearchEngines.directories[i].engines;
                    for (var j = 0; j < engines.length; j++) {
                        if (engines[j].filePath.indexOf("conduit.xml") != -1) {
                            conduitEngine = engines[j];
                            break;
                        }
                    }

                    if (conduitEngine) break;
                }

                if (!conduitEngine) return;

                delete conduitEngine.hidden;
                strSearchJson = JSON.stringify(objSearchEngines);
                EBFileIO_CT2958529.write(searchJson, searchJson, null, "UTF-8");
            }
        }
        catch (ex) {
            EBLog(ex);
        }
    },

    SetEngine: function(isAddEngine, isDefaultEngine, oParams) {
        if (!isAddEngine) return;
        var that = this;
        var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        if (win.document == null) { return }

        var searchbar = win.document.getElementById("searchbar");
        var sep = EBDirIO_CT2958529.sep;

        var strDestPath = this.getProfileSearchPluginsFolder();
        this.CreatePluginsFolder(strDestPath);
        EBIOManager_CT2958529.GetExtentionPath(EBGlobalConsts_CT2958529.GUID, function(extPath) {
            if (!extPath) return;
            var oExtPath = extPath;
            var engineSrc = EBFileIO_CT2958529.open(extPath + sep + "searchplugin");
            var engineGif = EBFileIO_CT2958529.open(extPath + sep + "searchplugin");
            var bIsSuccess = false;
            // for FF 4
            if (!engineSrc) {
                    extPath = (decodeURIComponent(extPath)).replace("file:///", "");//.substr(0, extPath.length - 3);
                    extPath = extPath.replace(/[/]/gi, '\\') + "searchplugin";
                    engineSrc = EBFileIO_CT2958529.open(extPath);
                    engineSrc.append(that.xmlFileName);
                    bIsSuccess = that.copyFile(engineSrc, strDestPath, that.xmlFileName);
                    that.removeHiddenSearch();
            }
            else {
                try {
                    // for FF 1.5.* copy plugin.src and plugin.ico file
                    if (searchbar != null && searchbar.attributes["searchengine"] != null) {
                        engineSrc.appendRelativePath(that.srcFileName);
                        engineGif.appendRelativePath(that.imgFileName);
                        bIsSuccess = that.copyFile(engineSrc, strDestPath, that.srcFileName)
                        bIsSuccess = that.copyFile(engineGif, strDestPath, that.imgFileName)
                    }
                    // for FF 2.0 copy plugin.xml file
                    else {
                        engineSrc.appendRelativePath(that.xmlFileName);
                        engineGif.appendRelativePath(that.imgFileName);
                        bIsSuccess = that.copyFile(engineSrc, strDestPath, that.xmlFileName);
                        that.removeHiddenSearch();
                    }
                }
                catch (ex) {
                    EBLog(ex);
                }
            }

            if (!isDefaultEngine)
                return;
           
            if (searchbar != null) {	//for FF prior to 2.0 - in FF 4 beta null
                try {
                    if (searchbar.attributes["searchengine"] != null) {
                        searchbar.setAttribute("searchengine", "engine://" + escape(engineSrc.path));
                        searchbar.setAttribute("src", "file:///" + escape(engineGif.path));
                        bIsSuccess = true;
                    }
                }
                catch (ex) {
                    EBLog(ex);
                }
            }

            //set to be default
            if (bIsSuccess) {
                EBPreferenceService_CT2958529.SetPref("browser.search.defaultthis.engineName", oParams.FFSearchCaption);
                EBPreferenceService_CT2958529.SetPref("browser.search.defaulturl", oParams.FFSearchUrl);
                EBPreferenceService_CT2958529.SetPref("browser.search.selectedEngine", oParams.FFSearchCaption)
            }
        });
    },

    setFix404: function(bValue) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.FixPageNotFoundErrors, bValue);
    },

    setUsage: function(bValue) {
        oToolbarManager_CT2958529.usage.enabled = bValue;
    },

    setIsOpenThankYouPage: function(bValue) {
        if (EBGlobalConsts_CT2958529.AllowSilentInstallation)
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsOpenThankYouPage, bValue);
        else
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsOpenThankYouPage, true);
    },

    setIsOpenUninstallPage: function(bValue) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsOpenUninstallPage, bValue);
    },

    SetHomepage: function() {
        //save last home page.
        if (!EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.SavedHomepage)) {
            var strHomepage = EBPreferenceService_CT2958529.GetPref(this.prefHomePage);
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.SavedHomepage, strHomepage);
        }

        var strHomePage = this.homepageUrl;
        EBPreferenceService_CT2958529.SetPref(this.prefHomePage, strHomePage);
    },

    ResetHomepage: function() {
        var strHomePage = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.SavedHomepage);
        EBPreferenceService_CT2958529.SetPref(this.prefHomePage, strHomePage);
    }
};

var EBWelcomeDialog_CT2958529 =
{
    toolbarFirstTimeDialog: "ToolbarFirstTimeDialog",
    iphoneUpdateLink: "",
    btnFinish: null,
    lblBtnAbort: null,
    dscPersonalComponentsTitle: null,
    dscDialogTitleWelcomeOnly: null,
    dscDialogTextWelcomeOnly: null,
    chkEmail: null,
    chkWeather: null,
    chkRadio: null,
    chkFacebook: null,
    dscDialogTitle: null,
    dscDialogText: null,
    boxFullDialogTitle: null,
    imgLowerDivider: null,
    chkWebSearch: null,
    chkHomePage: null,
    chkEnableAlerts: null,
    dscEnableAlerts: null,
    dscSettingsTitle: null,
    chkEnable404: null,
    txtBottom: null,
    aEula: null,
    txtAnd: null,
    aPrivacy: null,
    boxPersonalComponents: null,
    boxSearchAndHomepage: null,
    boxWelcomeOnly: null,
    htmlTruste: null,
    dscIPhoneLink: null,
    boxIphoneAppLink: null,

    _txtUninstallTitle: "",
    _txtUninstallBody: "",
    _isSingleComponent: false,
    _isPersonalComponents: true,
    params: null,

    dialog: null,
    oWindow: null,
    bDisplayTruste: false,

    OpenWelcomeDialog: function(oParams) {
        var strDialogOpenType = (EBGlobalConsts_CT2958529.IsAMO) ? "dependent," : "modal,";
        var strParams = stringFormat("{0}resizable=no,titlebar=no,", strDialogOpenType);

        var oMainMenu = EBComponentsManager_CT2958529.GetMainMenuComponent();
        var xulMainManuBox, x, y;

        if (oMainMenu && oMainMenu.XULElement) {
            if (!EBActionManager_CT2958529.IsToolbarRTL()) {
                //find open position
                xulMainManuBox = oMainMenu.XULElement.boxObject;
                x = xulMainManuBox.screenX + (xulMainManuBox.width / 2);
                y = xulMainManuBox.screenY + xulMainManuBox.height;
            }
            else {
                //find open position
                xulMainManuBox = oMainMenu.XULElement.boxObject;
                x = xulMainManuBox.screenX + (xulMainManuBox.width / 2) - 500;
                y = xulMainManuBox.screenY + xulMainManuBox.height;
            }
        }


        if (EBGlobalManager_CT2958529.IsFirefox4())
            strParams += "width=1px,height=1px";
        var data = {
            isAMO: EBGlobalConsts_CT2958529.IsAMO,
            FixPageNotFoundErrorsEnabled: EBGlobalConsts_CT2958529.FixPageNotFoundErrorsEnabled,
            AlertEnabled: EBGlobalConsts_CT2958529.AlertEnabled,
            FixPageNotFoundErrorsChecked: EBGlobalConsts_CT2958529.FixPageNotFoundErrorsChecked,
            oParams: oParams,
            isWindowsPlatform: EBGlobalManager_CT2958529.IsWindowsPlatform(),
            WelcomeDialogMode: EBInitParams_CT2958529.WelcomeDialogMode,
            IsToolbarInDualPackage: DualPackageFunctions_CT2958529.isToolbarInDualPackage(),
            toolbarName: EBGlobalConsts_CT2958529.ToolbarName,
            iPhoneLink: EBWelcomeDialog_CT2958529.iphoneUpdateLink,
            isDisplayTrusteLink: oToolbarManager_CT2958529.data.generalToolbarInfo.displayTrusteSeal,
            homepageCaption: EBInitParams_CT2958529.homepageText,
            downloadPage: EBGlobalConsts_CT2958529.WebServerUrl,
            searchProvider: EBGlobalConsts_CT2958529.SearchProvider
        };

        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        var toolbar = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
        var fallbackCoordinates = { "isRTL": EBActionManager_CT2958529.IsToolbarRTL(), "x": EBActionManager_CT2958529.IsToolbarRTL() ? toolbar.boxObject.screenX + toolbar.boxObject.width : toolbar.boxObject.screenX, "y": toolbar.boxObject.screenY + toolbar.boxObject.height };
        var dialogName = this.toolbarFirstTimeDialog;
        var dialogData = oToolbarManager_CT2958529.dialogsManager.getDialogDataManager(dialogName, data);
        dialogData.showDialogWinBaseWithPosition(oWindow, x, y, null, oToolbarManager_CT2958529, strParams, oMainMenu, oWindow.EBChevronStaticManager_CT2958529, fallbackCoordinates);
    },

    onload: function(event) {
        this._setLocalUIVars(event);
        this._initUI();

        if (!this.iphoneUpdateLink || this.oWindow.EBGlobalManager_CT2958529.IsLinuxPlatform())
            this.boxIphoneAppLink.style.display = "none";

        if (EBInitParams_CT2958529.WelcomeDialogMode == "full")
            this._fillUIForFullDialog();
        else
            this._fillUIForWelcomeOnlyDialog();
        this._applyLP();
    },

    onunload: function() {

    },

    onclickUninstall: function() {
        if (EBGlobalManager_CT2958529.Confirm(window, this._txtUninstallTitle, this._txtUninstallBody)) {
            if (DualPackageFunctions_CT2958529.isToolbarInDualPackage())
                EBGlobalManager_CT2958529.UninstallExtension(EBGlobalConsts_CT2958529.EngineGUID);
            EBGlobalManager_CT2958529.UninstallExtension(EBGlobalConsts_CT2958529.GUID);
            window.close();
        }
    },

    onclickFinish: function() {
        if (this._isPersonalComponents) {
            if (this.chkEmail.style.display != "none") {
                var emailNotifierItem = this.oWindow.oToolbarManager_CT2958529.data.getEmailNotifierItem();
                emailNotifierItem.setShowState(this.chkEmail.checked);
            }

            if (this.chkWeather.style.display != "none") {
                var weatherItem = this.oWindow.oToolbarManager_CT2958529.data.getWeatherItem();
                weatherItem.setShowState(this.chkWeather.checked);
            }

            if (this.chkRadio.style.display != "none") {
                var radioItem = this.oWindow.oToolbarManager_CT2958529.data.getRadioItem();
                radioItem.setShowState(this.chkRadio.checked);
            }

            if (this.chkFacebook.style.display != "none") {
                var facebookItem = this.oWindow.oToolbarManager_CT2958529.data.getFacebookItem();
                facebookItem.setShowState(this.chkFacebook.checked);
            }
        }

        if (this.chkHomePage.checked)
            EBInitParams_CT2958529.SetHomepage();

        if (this.chkWebSearch.checked)
            EBInitParams_CT2958529.SetEngine(true, true, this.params);

        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.FixPageNotFoundErrors, this.chkEnable404.checked);
        this.oWindow.oToolbarManager_CT2958529.fix404Checked(this.chkEnable404.checked);
        this.oWindow.oToolbar_CT2958529.alert.manager.alertEnabled(this.chkEnableAlerts.checked); // -  until the key will  be translated


        EBSearchFromAddressBar_CT2958529.firstTime(this.params.FFAddressBarSearchUrl, this.chkWebSearch.checked);

        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.FirstTime, true);
        if (this.params.SelectedCTID == EBGlobalConsts_CT2958529.ToolbarCTID) {
            if (!EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.CTID))
                EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CTID, EBGlobalConsts_CT2958529.ToolbarCTID);
            this.oWindow.EBToolbarManager_CT2958529.broadcastRebuild(this.oWindow.oToolbar_CT2958529.toolbarDataParsing.observerData.settings);
        }
        else
            this.oWindow.oToolbar_CT2958529.toolbar.switchToCommunity(EBGlobalConsts_CT2958529.ToolbarCTID,
                                                    EBGlobalConsts_CT2958529.ToolbarCTID,
                                                    this.params.SelectedCTID);

        var oManager = this.oWindow.oToolbarManager_CT2958529;
        window.close();
    },

    onClickTruste: function() {
        var strTrusteUrl = this.oWindow.EBActionManager_CT2958529.GetTrusteLinkUrl();
        EBActionManager_CT2958529._openUrlWindow("DIALOG", strTrusteUrl);
    },

    _setLocalUIVars: function(event) {
        this.btnFinish = document.getElementById("btnFinish");
        this.lblBtnAbort = document.getElementById("lblBtnAbort");
        this.dscPersonalComponentsTitle = document.getElementById("dscPersonalComponentsTitle");
        this.dscDialogTitleWelcomeOnly = document.getElementById("dscDialogTitleWelcomeOnly");
        this.dscDialogTextWelcomeOnly = document.getElementById("dscDialogTextWelcomeOnly");
        this.chkEmail = document.getElementById("chkEmail");
        this.chkWeather = document.getElementById("chkWeather");
        this.chkRadio = document.getElementById("chkRadio");
        this.chkFacebook = document.getElementById("chkFacebook");
        this.dscDialogTitle = document.getElementById("dscDialogTitle");
        this.dscDialogText = document.getElementById("dscDialogText");
        this.boxFullDialogTitle = document.getElementById("boxFullDialogTitle");
        this.dscSettingsTitle = document.getElementById("dscSettingsTitle");
        this.chkWebSearch = document.getElementById("chkWebSearch");
        this.chkHomePage = document.getElementById("chkHomePage");
        this.chkEnableAlerts = document.getElementById("chkEnableAlerts");
        this.dscEnableAlerts = document.getElementById("dscEnableAlerts");
        this.chkEnable404 = document.getElementById("chkEnable404");
        this.txtBottom = document.getElementById("txtBottom");
        this.aEula = document.getElementById("aEula");
        this.txtAnd = document.getElementById("txtAnd");
        this.aPrivacy = document.getElementById("aPrivacy");
        this.boxPersonalComponents = document.getElementById("boxPersonalComponents");
        this.boxSearchAndHomepage = document.getElementById("boxSearchAndHomepage");
        this.boxWelcomeOnly = document.getElementById("boxWelcomeOnly");
        this.htmlTruste = document.getElementById("htmlTruste");
        this.dscIPhoneLink = document.getElementById("dscIPhoneLink");
        this.boxIphoneAppLink = document.getElementById("boxIphoneAppLink");
        this.imgLowerDivider = document.getElementById("imgLowerDivider");


        this.dialog = event.target;
        this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        if (window.arguments && window.arguments[0] && window.arguments[0][0])
            this.params = window.arguments[0][0];
        /*
        else
        this.params = new ToolbarParams_CT2958529();*/
    },

    _initUI: function() {
        if (!this.bDisplayTruste)
            this.htmlTruste.style.display = "none";
    },

    _fillUIForWelcomeOnlyDialog: function() {
        this.boxWelcomeOnly.style.display = "";
        this.imgLowerDivider.style.display = "none";
        this.boxFullDialogTitle.style.display = "none";
        this.boxPersonalComponents.style.display = "none";
        this.dscPersonalComponentsTitle.style.display = "none";
        this.boxSearchAndHomepage.style.display = "none";
        this._isPersonalComponents = false;

        this.chkHomePage.checked = this.params.HomepageIsSet;
        this.chkWebSearch.checked = this.params.FFSearchIsDefault;
        this.chkEnable404.checked = EBGlobalConsts_CT2958529.FixPageNotFoundErrorsChecked;
        this.chkEnableAlerts.checked = EBGlobalConsts_CT2958529.AlertEnabled;
    },

    _fillUIForFullDialog: function() {
        this.boxWelcomeOnly.style.display = "none";

        var oEmailNotifier = this.oWindow.oToolbarManager_CT2958529.data.getEmailNotifierItem();
        var oWeather = this.oWindow.oToolbarManager_CT2958529.data.getWeatherItem();
        var oRadio = this.oWindow.oToolbarManager_CT2958529.data.getRadioItem();
        var oFacebook = this.oWindow.oToolbarManager_CT2958529.data.getFacebookItem();

        var bShowEmailNotifier = (oEmailNotifier) ? oEmailNotifier.isShowInPersonalComponentsDialog() : false;
        var bShowWeather = (oWeather) ? oWeather.isShowInPersonalComponentsDialog() : false;
        var bShowRadio = EBGlobalManager_CT2958529.IsWindowsPlatform() &&
                            (oRadio) ? oRadio.isShowInPersonalComponentsDialog() : false;
        var bShowFacebook = (oFacebook) ? oFacebook.isShowInPersonalComponentsDialog() : false;
        if (!bShowEmailNotifier && !bShowWeather && !bShowRadio && !bShowFacebook) {
            this.boxPersonalComponents.style.display = "none";
            this._isPersonalComponents = false;
        }
        else if (bShowEmailNotifier + bShowWeather + bShowRadio + bShowFacebook == 1)
            this._isSingleComponent = true;

        if (EBGlobalConsts_CT2958529.IsAMO) {
            this.chkHomePage.checked = false;
            this.chkWebSearch.checked = false;
            this.chkEnable404.checked = false;
            this.chkEnableAlerts.checked = false;
        }
        else {

            this.chkHomePage.checked = this.params.HomepageIsSet;
            this.chkWebSearch.checked = this.params.FFSearchIsDefault;
            this.chkEnable404.checked = EBGlobalConsts_CT2958529.FixPageNotFoundErrorsChecked;
            this.chkEnableAlerts.checked = EBGlobalConsts_CT2958529.AlertEnabled;
        }
        if (!EBGlobalConsts_CT2958529.FixPageNotFoundErrorsEnabled)
            this.chkEnable404.style.display = "none";


        var oComponent = null;
        var strImage = "";

        if (this._isPersonalComponents) {
            if (!bShowEmailNotifier)
                this.chkEmail.style.display = "none";
            else
                this.chkEmail.checked = !EBGlobalConsts_CT2958529.IsAMO;

            if (!bShowWeather)
                this.chkWeather.style.display = "none";
            else
                this.chkWeather.checked = !EBGlobalConsts_CT2958529.IsAMO;

            if (!bShowRadio)
                this.chkRadio.style.display = "none";
            else
                this.chkRadio.checked = !EBGlobalConsts_CT2958529.IsAMO;

            if (!bShowFacebook)
                this.chkFacebook.style.display = "none";
            else
                this.chkFacebook.checked = !EBGlobalConsts_CT2958529.IsAMO;
        }
    },

    _applyLP: function() {
        //TODO: handle with if dual package and regular.

        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);
        this.btnFinish.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_FINISH_FF');
        this.lblBtnAbort.value = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_ABORT_INSTALLATION_FF');
        this.dscSettingsTitle.firstChild.nodeValue = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_SETTINGS_TITLE_FF2');

        if (this._isPersonalComponents) {
            var strTitle = (this._isSingleComponent) ? this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_INTRO_SINGLE') :
                this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_INTRO');
            this.dscPersonalComponentsTitle.firstChild.nodeValue = strTitle;
            this.chkEmail.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_EMAIL');
            this.chkWeather.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_WEATHER');
            this.chkRadio.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_RADIO');
            this.chkFacebook.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_FACEBOOK');
        }

        this.dscDialogTitle.firstChild.nodeValue = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_SETTINGS_TITLE_DUALPACKAGE_FF').replace(/\[EB_TOOLBAR_NAME\]/g, EBGlobalConsts_CT2958529.ToolbarName);
        this.dscDialogTitleWelcomeOnly.firstChild.nodeValue = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_WELCOME_ONLY_TITLE_FF').replace(/\{\{EB_TOOLBAR_NAME\}\}/g, EBGlobalConsts_CT2958529.ToolbarName);
        if (DualPackageFunctions_CT2958529.isToolbarInDualPackage()) {
            this.dscDialogText.firstChild.nodeValue = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_SETTINGS_TEXT_DUAL_PACKAGE_FF');
            this.dscDialogTextWelcomeOnly.firstChild.nodeValue = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_SETTINGS_TEXT_DUAL_PACKAGE_FF');
        }
        this.chkWebSearch.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_SET_SEARCH_FF').replace(/\{\{EB_TOOLBAR_NAME\}\}/g, EBGlobalConsts_CT2958529.ToolbarName);
        this.chkEnable404.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_SHOW_AN_ALTERNATE_SEARCH_PAGE_WHEN_WEB_PAGES_ARE_NOT_FOUND').replace(/\{\{EB_TOOLBAR_NAME\}\}/g, EBGlobalConsts_CT2958529.ToolbarName);

        this.chkEnableAlerts.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_ENABLE_NOTIFICATION_FF');
        this.dscEnableAlerts.firstChild.nodeValue = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_ENABLE_NOTIFICATION_COMMENT_FF');

        if (EBInitParams_CT2958529.homepageText)
            this.chkHomePage.label = EBInitParams_CT2958529.homepageText;
        else
            this.chkHomePage.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_SET_HOMEPAGE_FF').replace(/\{\{EB_TOOLBAR_NAME\}\}/g, EBGlobalConsts_CT2958529.ToolbarName);

        this.txtBottom.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_BOTTOM_FF');
        this.aEula.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_EULA');
        this.txtAnd.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_AND');
        this.aPrivacy.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_PRIVACY_POLICY');
        this.dscIPhoneLink.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_DLG_IPHONE_UPDATES_LINK_TEXT').replace(/\{\{EB_TOOLBAR_NAME\}\}/g, EBGlobalConsts_CT2958529.ToolbarName); ;

        this._txtUninstallTitle = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_ABORT_INSTALLATION_FF');
        this._txtUninstallBody = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_CONFIRM_UNINSTALL_BODY_FF').replace(/\\n/g, "\n");
    }
};

var EBWelcomeDialogCE_CT2958529 =
{
    engineFirstTimeDialog: "EngineFirstTimeDialog",
    btnFinish: null,
    lblBtnAbort: null,
    dscTitle: null,
    dscSettingsTitle: null,
    componentAlertEnable: null,
    chkWebSearch: null,
    chkHomePage: null,
    txtBottom: null,
    aEula: null,
    txtAnd: null,
    aPrivacy: null,
    htmlTruste: null,

    _txtUninstallTitle: "",
    _txtUninstallBody: "",
    _isSingleComponent: false,
    _isPersonalComponents: true,
    params: null,

    dialog: null,
    oWindow: null,
    bDisplayTruste: true,

    OpenWelcomeDialog: function(oParams) {
        var win = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName("EBWelcome_CT2958529", "Welcome");
        if (win) return;
        
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var app = oWindow.EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash.GetByIndex(0);

        var toolbar = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
        var strPos, xulMainManuBox, x, y;

        if (toolbar) {
            if (!EBActionManager_CT2958529.IsToolbarRTL()) {
                //find open position
                x = app ? parseInt(app.XULElement.boxObject.screenX) + (parseInt(app.XULElement.boxObject.width) / 2) : toolbar.boxObject.screenX;
                y = toolbar.boxObject.screenY + toolbar.boxObject.height;
            }
            else {
                //find open position
                x = (app ? parseInt(app.XULElement.boxObject.screenX) + (parseInt(app.XULElement.boxObject.width) / 2) : toolbar.boxObject.screenX + toolbar.boxObject.width) - 410;
                y = toolbar.boxObject.screenY + toolbar.boxObject.height;
            }
        }

        var fallbackCoordinates = { "isRTL": EBActionManager_CT2958529.IsToolbarRTL(), "x": EBActionManager_CT2958529.IsToolbarRTL() ? toolbar.boxObject.screenX + toolbar.boxObject.width : toolbar.boxObject.screenX, "y": toolbar.boxObject.screenY + toolbar.boxObject.height };
        var dialogName = this.engineFirstTimeDialog;
        var dialogData = oToolbarManager_CT2958529.dialogsManager.getDialogDataManager(dialogName);
        dialogData.showDialogWinBaseWithPosition(oWindow, x, y, null, oToolbarManager_CT2958529, 'modal,chrome,dependent,resizable=no,titlebar=yes', app, oWindow.EBChevronStaticManager_CT2958529, fallbackCoordinates); //oWindow, x,y, isRtl, isChevronShown, toolbarManager
    },

    onload: function(event) {
        this._setLocalUIVars(event);
        this._initUI();
        this._applyLP();
    },

    onunload: function() {
        var isCompAlert = parseBool(this.componentAlertEnable.getAttribute("checked"));
        this.oWindow.oToolbarManager_CT2958529.isComponentAlertEnabled = isCompAlert;
        this.oWindow.oToolbarManager_CT2958529.createChannelsArrayForAlertManager();
    },

    onclickUninstall: function() {
        if (EBGlobalManager_CT2958529.Confirm(window, this._txtUninstallTitle, this._txtUninstallBody)) {
            EBGlobalManager_CT2958529.UninstallExtension(EBGlobalConsts_CT2958529.GUID);
            window.close();
        }
    },

    onclickFinish: function() {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.FirstTime, true);
        if (!EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.CTID))
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CTID, EBGlobalConsts_CT2958529.ToolbarCTID);
        this.oWindow.EBToolbarManager_CT2958529.broadcastRebuild(this.oWindow.oToolbar_CT2958529.toolbarDataParsing.observerData.settings);


        var oManager = this.oWindow.oToolbarManager_CT2958529;
        var asyncReqLogin = function() {
            oManager.isFinishClicked = true;
        }
        this.oWindow.setTimeout(asyncReqLogin, 200);
        window.close();
    },

    onclickEULA: function() {
        this.oWindow.EBActionManager_CT2958529.OpenEULA("DIALOG");
    },

    onclickPrivacy: function() {
        this.oWindow.EBActionManager_CT2958529.OpenPrivacyPolicy("DIALOG");
    },

    onClickTruste: function() {
        var strTrusteUrl = this.oWindow.oToolbarManager_CT2958529.data.settings.truste.link;
        EBActionManager_CT2958529._openUrlWindow("DIALOG", strTrusteUrl);
    },

    _setLocalUIVars: function(event) {
        this.btnFinish = document.getElementById("btnFinish");
        this.lblBtnAbort = document.getElementById("lblBtnAbort");
        this.dscTitle = document.getElementById("dscTitle");
        this.dscSettingsTitle = document.getElementById("boxMainTextTitle");
        this.boxMainTextTitle2 = document.getElementById("boxMainTextTitle2");
        this.componentAlertEnable = document.getElementById("componentAlertEnable");
        this.chkWebSearch = document.getElementById("chkWebSearch");
        this.chkHomePage = document.getElementById("chkHomePage");
        this.txtBottom = document.getElementById("txtBottom");
        this.aEula = document.getElementById("aEula");
        this.txtAnd = document.getElementById("txtAnd");
        this.aPrivacy = document.getElementById("aPrivacy");
        this.htmlTruste = document.getElementById("htmlTruste");

        this.dialog = event.target;
        this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        this.params = window.arguments[0];
    },

    _initUI: function() {
        if (!this.bDisplayTruste)
            this.htmlTruste.style.display = "none";
    },


    _applyLP: function() {
        this.dscSettingsTitle.firstChild.nodeValue = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_FIRST_TIME_DIALOG_SUCCESS_HEADLINE');
        this.boxMainTextTitle2.firstChild.nodeValue = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_FIRST_TIME_DIALOG_SUCCESS_TEXT');
        this.componentAlertEnable.setAttribute("label", this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_FIRST_TIME_DIALOG_SUCCESS_ALERT_CHECKBOX_FF'));

        this.btnFinish.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_FINISH_FF');
        this.lblBtnAbort.value = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_ABORT_INSTALLATION_FF');

        this.txtBottom.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_BOTTOM_FF');
        this.aEula.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_EULA');
        this.txtAnd.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_AND');
        this.aPrivacy.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_PRIVACY_POLICY');

        this._txtUninstallTitle = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_PERSONAL_COMP_DLG_ABORT_INSTALLATION_FF');
        this._txtUninstallBody = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_FIRST_TIME_DIALOG_CONFIRM_UNINSTALL_BODY_FF').replace(/\\n/g, "\n");
    }
};

var EBFManager_CT2958529 =
{
    CONDUIT_TOOLBARCT2958529ATTR_NAME: "ebtoolbarctid",
    VERSION_ATTR_NAME: "ebVersion",

    getService: function() {
        var arrConduitToolbars = this.getConduitToolbars();
        var xulToolbar = this.getMaxVersionToolbar(arrConduitToolbars);
        if (!xulToolbar) return null;
        var strMaxVersionCTID = xulToolbar.getAttribute(this.CONDUIT_TOOLBARCT2958529ATTR_NAME);
        var oToolbar = this._getService(strMaxVersionCTID);
        return oToolbar;
    },

    getConduitToolbars: function() {
        var arrConduitToolbars = new Array();
        var objToolbarbox = document.getElementById('navigator-toolbox');
        var arrAllToolbars = objToolbarbox.getElementsByTagName('toolbar');
        for (var i = 0; i < arrAllToolbars.length; i++) {
            if (arrAllToolbars[i].getAttribute(this.CONDUIT_TOOLBARCT2958529ATTR_NAME))
                arrConduitToolbars.push(arrAllToolbars[i]);
        }

        return arrConduitToolbars;
    },

    getMaxVersionToolbar: function(arrConduitToolbars) {
        if (arrConduitToolbars.length == 0) return;
        if (arrConduitToolbars.length == 1)
            return arrConduitToolbars[0];

        var xulMaxVersionToolbar = arrConduitToolbars[0];
        var strMaxVersion = xulMaxVersionToolbar.getAttribute(this.VERSION_ATTR_NAME);
        var strVersion;
        for (var i = 1; i < arrConduitToolbars.length; i++) {
            strVersion = arrConduitToolbars[i].getAttribute(this.VERSION_ATTR_NAME);
            if (strVersion && EBGlobalManager_CT2958529.compareVersions(strVersion, strMaxVersion) > 0) {
                strMaxVersion = strVersion;
                xulMaxVersionToolbar = arrConduitToolbars[i];
            }
        }

        return xulMaxVersionToolbar;
    },

    _getService: function(strCTID) {
        try {
            return Components.classes["@conduit.com/toolbar;1=" + strCTID].
            getService(Components.interfaces["nsIConduitToolbar_" + strCTID]).wrappedJSObject;
        }
        catch (e) {
            EBLogging_CT2958529.LogToConsole(e);
        }
    }
};
function EBGadgetApi_CT2958529(argsObj) {
    EBBrowserCompApi_CT2958529.call(this, argsObj);
    
    this.getWidth = function() {
        return EBGadgetDialog_CT2958529.popHtmlData.width;
    };

    this.getHeight = function() {
        return EBGadgetDialog_CT2958529.popHtmlData.height;
    };

    this.changeWidth = function(newWidth) {
        EBGadgetDialog_CT2958529.ChangeSize(newWidth, null, false);
    };

    this.changeHeight = function(newHeight) {
        var popHtmlData = EBGadgetDialog_CT2958529.popHtmlData;
        //fix height in order to support backward compatibility with older toolbars
        if (!popHtmlData.title)
            newHeight += EBGadgetManager_CT2958529.titleHeight;

        if (!popHtmlData.resizable)
            newHeight += EBGadgetManager_CT2958529.resizerHeight;
        
        EBGadgetDialog_CT2958529.ChangeSize(null, newHeight, false);
    };

    this.changeHeight2 = function(newHeight) {
        EBGadgetDialog_CT2958529.ChangeSize(null, newHeight, false);
    };
    
    this.closeWindow = function() {
        window.close();
    };

    this.changeSize = function(newWidth, newHeight) {
        var popHtmlData = EBGadgetDialog_CT2958529.popHtmlData;
        //fix height in order to support backward compatibility with older toolbars
        if (!popHtmlData.title)
            newHeight += EBGadgetManager_CT2958529.titleHeight;

        if (!popHtmlData.resizable)
            newHeight += EBGadgetManager_CT2958529.resizerHeight;
        
        EBGadgetDialog_CT2958529.ChangeSize(newWidth, newHeight, false);
    };

    this.changeSize2 = function(newWidth, newHeight) {
        EBGadgetDialog_CT2958529.ChangeSize(newWidth, newHeight, false);
    };
    
    /////////////////////////////////////////////new api////////////////////////////////////////////////////////
    this.__defineGetter__("apiPermissions", function() {
        return EBGadgetDialog_CT2958529.popHtmlData.apiPermissions;
    });
    
    this.__defineGetter__("embeddedLocation", function() {
        return "Gadget";
    });

    this.__defineGetter__("componentId", function() {
        return EBGadgetDialog_CT2958529.popHtmlData.componentId;
    });

    this.__defineGetter__("source", function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        return oWindow.EBUsageGadget_CT2958529.Other;
    });
};

EBGadgetApi_CT2958529.prototype = new EBBrowserCompApi_CT2958529();
EBGadgetApi_CT2958529.constructor = EBGadgetApi_CT2958529;


var EBGadgetDialog_CT2958529 =
{
    mTitleHeight: 25,
    mResizerHeight: 15,

    popHtmlData: null,
    _oWindow: null,

    _oTitleBar: null,
    _oBoxTitle: null,
    _lblTitle: null,
    _oImgClose: null,
    _oImgTitle: null,
    _oMainBox: null,
    _oDivError: null,
    _oDialog: null,
    _oResizer: null,
    _divMinimize: null,
    _imgMinimize: null,
    _openTimeStamp: 0,
    _xulMinimizeToParent: null,
    _usageSentForClickInside: false,

    BrowserParentId: 'mainBox',
    _gadgetProgressListener: null,
    xulBrowser: null,
    _facebookGadgetDialog: null,
    screenShotImageData: null,
    isMinimized: false,
    currLocation: { "x": 0, "y": 0 },

    OnLoad: function(event) {
        this.SetParameters();
        this.SetLocalVariables();
        this.ApplyParametersLogic();

        //calculate open duration
        this._openTimeStamp = Date.parse(Date());
        //add this gadget to hash if close on external click enabled
        if (this.popHtmlData.closeOnExternalClick) {
            this._oWindow.EBGadgetManager_CT2958529.arrCloseOnExternalClickGadgets.Add(window.ebGadgetId, window);
        }
        _heightDelta = 2;
        if (this.popHtmlData.titlebar) _heightDelta += this.mTitleHeight;
        if (this.popHtmlData.resizable) _heightDelta += this.mResizerHeight;
        _minWidth = (this.popHtmlData.closeButton || this.popHtmlData.resizable) ? 33 : 0;

        if (this.popHtmlData.minimizable)
            _minWidth += 33;

        window.totalWidth = this.popHtmlData.width + _widthDelta;
        window.totalHeight = this.popHtmlData.height + _heightDelta;

        if (!EBGlobalManager_CT2958529.IsMacintoshPlatform()) {
            window.max = (window.totalHeight > window.totalWidth) ? window.totalHeight : window.totalWidth;
            window.step = max / 12;
            var oResize = function() {
                EBGadgetDialog_CT2958529.ResizeWindow(2, 2, 1);
            };

            setTimeout(oResize, 1);
        }
        else {
            var funcTimeout = function() {
                window.resizeTo(window.totalWidth, window.totalHeight);
                EBGadgetDialog_CT2958529.CreateBrowser();
            };

            setTimeout(funcTimeout, 1)
        }
        //calculate open duration
        this._openTimeStamp = Date.parse(Date());

        //usage
        if (_gadgetType == EBUsageGadget_CT2958529.GadgetTypes.Chat)
            this._oWindow.EBUsageChat_CT2958529.OnOpen(this.popHtmlData.componentId, this.popHtmlData.elementId, this.popHtmlData.popHtmlUrl, this.popHtmlData.source, this.popHtmlData.chatRoomId, this.popHtmlData.compType);
        else {
            if (this.popHtmlData.gadgetType == EBGadgetManager_CT2958529.GADGET_TYPE_FACEBOOK) {
                var facebookConsts = this._oWindow.oToolbar_CT2958529.facebook.consts;
                switch (this.popHtmlData.facebookGagetType) {
                    case facebookConsts.gadgetType.login:
                        this._oWindow.EBUsageFacebook_CT2958529.OnLoginGadgetOpen(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType);
                        break;
                    case facebookConsts.gadgetType.getUpdateStatusPermission:
                        this._oWindow.EBUsageFacebook_CT2958529.OnSetStatusPermGadgetOpen(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType);
                        break;
                    case facebookConsts.gadgetType.updateStatusWithoutAfterGetPermission:
                        this._oWindow.EBUsageFacebook_CT2958529.OnSetStatusGadgetOpen(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType);
                        break;
                    case facebookConsts.gadgetType.updateStatusAfterGetPermission:
                        this._oWindow.EBUsageFacebook_CT2958529.OnSetStatusGadgetShow(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType);
                        break;
                    case facebookConsts.gadgetType.share:
                        this._oWindow.EBUsageFacebook_CT2958529.OnShareGadgetOpen(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType);
                        break;
                }
            }

            else
                this._oWindow.EBUsageGadget_CT2958529.OnOpen(this.popHtmlData.componentId, this.popHtmlData.elementId, this.popHtmlData.popHtmlUrl, this.popHtmlData.source, _gadgetType, this.popHtmlData.compType);
        }

        //add this gadget to hash if close on external click enabled
        if (this.popHtmlData.closeOnExternalClick)
            this._oWindow.EBGadgetManager_CT2958529.arrCloseOnExternalClickGadgets.Add(window.ebGadgetId, window);
    },

    OnUnLoad: function(event) {
        //unload gadget manager (progress listener and api)
        if (this._gadgetProgressListener)
            this._gadgetProgressListener.unload();

        //remove this browser xul object from the hash array.
        if (this._oWindow && this._oWindow.EBGadgetManager_CT2958529) {
            var index = this._oWindow.EBGadgetManager_CT2958529.arrPopupHTMLWindows.GetIndexByObjectValue(this.xulBrowser);
            this._oWindow.EBGadgetManager_CT2958529.arrPopupHTMLWindows.Remove(index, this.popHtmlData.popHtmlUrl);
        }

        //calculate open duration
        var iOpenDuration = (Date.parse(Date()) - this._openTimeStamp) / 1000;

        //usage, if this dialog is closed because of main window closed, "this._oWindow.EBUsageGadget_CT2958529" will be null.
        if (this._oWindow && this._oWindow.EBUsageGadget_CT2958529) {
            if (_gadgetType == EBUsageGadget_CT2958529.GadgetTypes.Chat)
                this._oWindow.EBUsageChat_CT2958529.Close(this.popHtmlData.componentId, this.popHtmlData.elementId, this.popHtmlData.popHtmlUrl, this.popHtmlData.chatRoomId, iOpenDuration, this.popHtmlData.compType);
            else {
                if (this.popHtmlData.gadgetType == EBGadgetManager_CT2958529.GADGET_TYPE_FACEBOOK) {
                    var facebookConsts = this._oWindow.oToolbar_CT2958529.facebook.consts;

                    switch (this.popHtmlData.facebookGagetType) {
                        case facebookConsts.gadgetType.login:
                            this._oWindow.EBUsageFacebook_CT2958529.OnLoginGadgetClose(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType, window.ebCloseStatus);
                            break;
                        case facebookConsts.gadgetType.getUpdateStatusPermission:
                            this._oWindow.EBUsageFacebook_CT2958529.OnSetStatusPermGadgetClose(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType, window.ebCloseStatus);
                            break;
                        case (facebookConsts.gadgetType.updateStatusWithoutAfterGetPermission):
                        case (facebookConsts.gadgetType.updateStatusAfterGetPermission):
                            this.SendSetStatusCloseUsage();
                            break;
                        case facebookConsts.gadgetType.share:
                            this._oWindow.EBUsageFacebook_CT2958529.OnShareGadgetClose(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType);
                            break;
                        case facebookConsts.gadgetType.getReadMailboxPermission:
                            this._oWindow.EBUsageFacebook_CT2958529.OnReadMailboxPermGadgetClose(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType, window.ebCloseStatus);
                            break;
                    }
                }
                else
                    this._oWindow.EBUsageGadget_CT2958529.Close(this.popHtmlData.componentId, this.popHtmlData.elementId, this.popHtmlData.popHtmlUrl, this.popHtmlData.source, _gadgetType, iOpenDuration, this.popHtmlData.compType);
            }

        }

        //remove this gadget to hash if close on external click enabled
        if (this.popHtmlData.closeOnExternalClick)
            this._oWindow.EBGadgetManager_CT2958529.arrCloseOnExternalClickGadgets.Remove(window.ebGadgetId);


        if (_gadgetType == EBUsageGadget_CT2958529.GadgetTypes.Chat)
            this._oWindow.EBGadgetsMinimizeManager_CT2958529.removeMinimizedGadget(this.popHtmlData.chatRoomId, this.popHtmlData.componentId);

    },

    SendSetStatusCloseUsage: function() {
        if (window.ebCloseStatus == this._oWindow.oToolbar_CT2958529.facebook.consts.gadgetClosingType.clear)
            this._oWindow.EBUsageFacebook_CT2958529.OnSetStatusGadgetClear(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType);
        else
            this._oWindow.EBUsageFacebook_CT2958529.OnSetStatusGadgetClose(this.popHtmlData.elementId, this.popHtmlData.componentId, this.popHtmlData.compType, window.ebCloseStatus);
    },

    OnDocumentComplete: function(bIsSuccess, bIsMainBC) {
        if (bIsMainBC) {
            if (this.xulBrowser.contentTitle && (_syncTitle || !this.popHtmlData.title))
                this.popHtmlData.title = this.xulBrowser.contentTitle;

            //remove the loading animation from the window and expand the browser xul object
            this._oDialog.className = _cssDialogLoaded;
            if (!bIsSuccess)
                this._onError();
            else {
                this.SetTitle();
                this._showResizer();
                this._oDivError.style.display = 'none';
                this._setColorForResizerAndTitle(this.GetBrowserBackgroundColor(this.xulBrowser));
            }
            this.xulBrowser.focus();
        }

        if (this.popHtmlData.gadgetType == EBGadgetManager_CT2958529.GADGET_TYPE_FACEBOOK) {
            if (!this._facebookGadgetDialog) this._facebookGadgetDialog = new EBFacebookGadgetDialog_CT2958529(this._oWindow, this.popHtmlData);
            this._facebookGadgetDialog.onDocumentComplete(this.xulBrowser);
        }

        //override the window.close function
        var innerJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
        innerJS.window.close = function() {
            window.close();
        };


        var facebookConsts = this._oWindow.oToolbar_CT2958529.facebook.consts;
        if (this.popHtmlData.facebookGagetType == facebookConsts.gadgetType.updateStatusWithoutAfterGetPermission || this.popHtmlData.facebookGagetType == facebookConsts.gadgetType.updateStatusAfterGetPermission) {
            var innerJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(this.xulBrowser.contentWindow);
            var win = this._oWindow;
            var that = this;
            innerJS.window.facebookSetStatus = function(state, status) {

                if (state == "post") {
                    window.ebCloseStatus = facebookConsts.gadgetClosingType.success;
                    win.oToolbar_CT2958529.facebook.manager.setStatus(status);
                }
                else if (state == "cancel")
                    window.ebCloseStatus = facebookConsts.gadgetClosingType.cancel;

                if (state != "clear")
                    window.close();
                else {
                    win.oToolbar_CT2958529.facebook.manager.setStatus("");
                    win.EBUsageFacebook_CT2958529.OnSetStatusGadgetClear(that.popHtmlData.elementId, that.popHtmlData.componentId, that.popHtmlData.compType);
                }
            };
        }
    },

    OnClick: function(event, strUrl) {
        if (this._usageSentForClickInside) return;

        if (this.popHtmlData.gadgetType == EBGadgetManager_CT2958529.GADGET_TYPE_CHAT)
            this._oWindow.EBUsageChat_CT2958529.OnClickInside(this.popHtmlData.componentId, this.popHtmlData.elementId, event, strUrl, this.popHtmlData.chatRoomId, this.popHtmlData.compType);
        else if (this.popHtmlData.gadgetType == EBGadgetManager_CT2958529.GADGET_TYPE_REGULAR)
            this._oWindow.EBUsageGadget_CT2958529.OnClickInside(this.popHtmlData.componentId, this.popHtmlData.elementId, event, this.popHtmlData.source, _gadgetType, strUrl, this.popHtmlData.compType);

        this._usageSentForClickInside = true;
    },

    _onError: function() {
        //translate error message
        var locale = this._oWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);
        var strErrorText = this._oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GADGETS_ERROR_ERROR_TEXT_CLOSE_WINDOW');
        strErrorText = strErrorText.replace("\n", "<html:br/>", "g");
        strErrorText = strErrorText.replace(/\@(.*?)\@/, function(full, val) {
            return "<html:a href=\"javascript:window.close();\"><html:font color=\"blue\">" + val + "</html:font></html:a>";
        });
        this._oDivError.innerHTML = strErrorText;
        this._oDivError.style.display = '';
        this._oDivError.style.width = this.popHtmlData.width + 'px';
        this._oDivError.style.heigh = this.popHtmlData.height + 'px';

        /*
        if (this._oResizer && this.popHtmlData.resizable)
        this._oResizer.style.display = 'none';
        */
        this.xulBrowser.style.display = 'none';
    },

    _setColorForResizerAndTitle: function(strColor) {
        //set resizer background color to be as document background color
        this._oResizer.style.backgroundColor = strColor;
    },

    _showResizer: function() {
        if (this._oResizer && this.popHtmlData.resizable) {
            this._oResizer.style.display = '';
            /*
            var curDirection = document.defaultView.getComputedStyle(this._oDialog, null).getPropertyValue("direction");
            if(curDirection == 'rtl')
            this.SetResizerRtl();
            */
        }
    },

    /* - disabled in this release
    //todo - create RTL css and change to it also on RTL platforms
    SetResizerRtl : function()
    {
    var xulResizer = document.getElementById('xulResizer');
    xulResizer.dir = 'bottomleft';
        
    var oImage = new Image();
    oImage.src = "chrome://browsersearch/skin/resizeRTL.gif";
    xulResizer.appendChild(oImage);
    },
    */

    GetBrowserBackgroundColor: function(xulCurrentBrowser) {
        try {
            var strColor = xulCurrentBrowser.contentDocument.defaultView.getComputedStyle(xulCurrentBrowser.contentDocument.getElementsByTagName('body')[0], null).getPropertyValue("background-color");
            if (strColor == 'transparent')
                strColor = 'white';
            return strColor;
        }
        catch (ex) {
            return 'white';
            EBLogging_CT2958529.LogToConsole(ex);
        }
    },

    SetParameters: function() {
        this._oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        this.popHtmlData = window.arguments[0][0];
        this.popHtmlData.popHtmlUrl = this._oWindow.EBActionManager_CT2958529.ConvertAliasesUrl(this.popHtmlData.popHtmlUrl);
    },

    SetLocalVariables: function() {
        this._oTitleBar = document.getElementById('titleBar');
        this._oBoxTitle = document.getElementById("boxTitle");
        this._lblTitle = document.getElementById('lblTitle');
        this._oImgClose = document.getElementById('imgClose');
        this._oImgEdit = document.getElementById('imgEdit');
        this._oImgTitle = document.getElementById('imgTitle');
        this._oMainBox = document.getElementById('mainBox');
        this._oResizer = document.getElementById('boxResize');
        this._divMinimize = document.getElementById('divMinimize');
        this._imgMinimize = document.getElementById('imgMinimize');
        this._oDivError = document.getElementById('dscErrorLoading');
        this._oDialog = document.getElementById('EBPopupHTMLWindow');
    },

    ApplyParametersLogic: function() {
        this._showResizer();

        if (!this.popHtmlData.titlebar)
            this._oBoxTitle.style.display = "none";
        else if (!this.popHtmlData.closeButton)
            this._oImgClose.style.display = "none";

        if (!this.popHtmlData.minimizable || EBGlobalManager_CT2958529.IsLinuxPlatform())
            this._imgMinimize.style.display = "none";
    },



    SetBrowserLogics: function() {
        if (!this.popHtmlData.scrollV && !this.popHtmlData.scrollH)
            this.xulBrowser.setAttribute("autoscroll", false);
        else {
            if (this.popHtmlData.scrollV)
                this.xulBrowser.style.overflowY = "auto";
            if (this.popHtmlData.scrollH)
                this.xulBrowser.style.overflowX = "auto";
        }
    },

    ResizeWindow: function(newWidth, newHeight, i) {
        newWidth = parseInt(newWidth); newHeight = parseInt(newHeight);
        i = parseInt(i);

        // final resize
        if (i >= max) {
            window.resizeTo(parseInt(this.popHtmlData.width) + _widthDelta, parseInt(this.popHtmlData.height) + _heightDelta);
            this.CreateBrowser();
            return;
        }

        i += Math.floor(step);
        if (i <= this.popHtmlData.height) { newHeight = i; }
        if (i <= this.popHtmlData.width) { newWidth = i; }
        window.resizeTo(newWidth, newHeight);

        var oResize = function() {
            EBGadgetDialog_CT2958529.ResizeWindow(newWidth, newHeight, i);
        };

        setTimeout(oResize, 1);
    },

    SetTitleFromDocument: function() {
        if (EBGadgetDialog_CT2958529.xulBrowser.contentTitle)
            EBGadgetDialog_CT2958529.popHtmlData.title = EBGadgetDialog_CT2958529.xulBrowser.contentTitle;

        EBGadgetDialog_CT2958529.SetTitle();
        EBGadgetDialog_CT2958529.SetIcon();

        if (!EBGadgetDialog_CT2958529.popHtmlData.titlebar) {
            EBGadgetDialog_CT2958529._oBoxTitle.style.backgroundColor = EBGadgetDialog_CT2958529.GetBrowserBackgroundColor(EBGadgetDialog_CT2958529.xulBrowser);
        }
    },

    SetTitle: function() {
        var strTitle = EBXML_CT2958529.LegalizeEBXML(this.popHtmlData.title);
        if (this.popHtmlData.title)
            this._lblTitle.innerHTML = strTitle;
        window.title = strTitle;
    },

    SetIcon: function() {
        var imageUrl = "";
        if (this.popHtmlData.titleIconUrl)
            imageUrl = this.popHtmlData.titleIconUrl;
        EBGadgetDialog_CT2958529._oImgTitle.src = imageUrl;
    },

    IsCloseVisible: function() {
        var iBoxTitleWidth = this._oDialog.boxObject.width;
        var iCloseTopRight = this._oImgClose.boxObject.x + this._oImgClose.boxObject.width;
        return iCloseTopRight + _addCloseSpace <= iBoxTitleWidth;
    },

    CreateBrowser: function() {
        this.xulBrowser = EBXULFactory_CT2958529.CreateBrowser(this.popHtmlData.popHtmlUrl, this.popHtmlData.popHtmlUrl, this.popHtmlData.width, this.popHtmlData.height);
        this.xulBrowser.setAttribute('flex', '1');
        this.xulBrowser.setAttribute('type', 'content-primary');
        var oBrowser = this._oWindow.EBGadgetManager_CT2958529.arrPopupHTMLWindows.GetByID(this.popHtmlData.popHtmlUrl);

        //add this browser XUL object to hash table of objects
        if (!oBrowser)
            this._oWindow.EBGadgetManager_CT2958529.arrPopupHTMLWindows.Add(this.popHtmlData.popHtmlUrl, this.xulBrowser);

        EBGadgetDialog_CT2958529._oMainBox.appendChild(this.xulBrowser);
        this._setListeners();
        this.OnFocus();
        this.SetBrowserLogics();
    },

    _setListeners: function() {
        this._gadgetProgressListener = new EBGadgetProgressListener_CT2958529();
        this._gadgetProgressListener.init(this.xulBrowser, this._isAllowUntrustedFunctions(), this.popHtmlData.width, this.popHtmlData.height, this.popHtmlData.componentId, this.popHtmlData.elementId, this.popHtmlData.compType);
        this._gadgetProgressListener.initGadgetData(this.popHtmlData.source, this.popHtmlData.gadgetType, EBGadgetDialog_CT2958529.OnDocumentComplete, EBGadgetDialog_CT2958529.OnClick, this);
        this.xulBrowser.addEventListener("DOMTitleChanged", EBGadgetDialog_CT2958529.SetTitleFromDocument, false);
        //this.xulBrowser.addEventListener("blur", EBGadgetDialog_CT2958529.OnBrowserBlur, true);
        this.xulBrowser.addEventListener("mousemove", EBGadgetDialog_CT2958529.OnMouseMove, true);
    },

    _isAllowUntrustedFunctions: function() {
        //if user component, always allow.
        if (this.popHtmlData.isUser) return true;
        var allowNonPrivacyFunctions = this._oWindow.EBGlobalConsts_CT2958529.IsEngine ? this._oWindow.oToolbarManager_CT2958529.data.settings.truste.allowNonPrivacyFunction :
							 this._oWindow.oToolbarManager_CT2958529.data.generalToolbarInfo.allowNonPrivacyFunctions
        return allowNonPrivacyFunctions;
    },

    ChangeSize: function(newWidth, newHeight, isFromManualResize) {
        if (isFromManualResize) {
            newWidth = parseInt(document.defaultView.getComputedStyle(this.xulBrowser, null).getPropertyValue("width"));
            newHeight = parseInt(document.defaultView.getComputedStyle(this.xulBrowser, null).getPropertyValue("height"));
        }
        else {
            if (!newHeight)
                newHeight = parseInt(document.defaultView.getComputedStyle(this.xulBrowser, null).getPropertyValue("height")) + 2;

            if (!newWidth)
                newWidth = parseInt(document.defaultView.getComputedStyle(this.xulBrowser, null).getPropertyValue("width"));
        }

        this.popHtmlData.width = parseInt(newWidth);
        this.popHtmlData.height = parseInt(newHeight);

        var bAdjustSize = false;
        if (this._oDialog.boxObject.width < _minWidth + _widthDelta) {
            bAdjustSize = true;
            this.popHtmlData.width = _minWidth;
        }

        if (this._oDialog.boxObject.height < _minHeight + _heightDelta) {
            bAdjustSize = true;
            this.popHtmlData.height = _minHeight;
        }

        //don't resize if the window is already manually resized
        if (!isFromManualResize || bAdjustSize)
            window.resizeTo(this.popHtmlData.width + _widthDelta, this.popHtmlData.height + _heightDelta);

        //save new size
        var strGadgetName = (this.popHtmlData.gadgetType == EBGadgetManager_CT2958529.GADGET_TYPE_CHAT) ? EBGadgetManager_CT2958529.CHAT_DIALOG_NAME : this.popHtmlData.popHtmlUrl;
        if (this.popHtmlData.saveSize)
            this._oWindow.EBGadgetManager_CT2958529.GadgetSize(strGadgetName, this.popHtmlData.width, this.popHtmlData.height);

        this.SetTitle();
    },

    ///////////////////////////////////////////////////////////
    //Title bar events
    OnMouseDownMinimize: function(event) {
        event.target.src = _imgMinimize_dn;
    },

    OnMouseUpMinimize: function(event) {
        event.target.src = _imgMinimize;
        EBGadgetDialog_CT2958529.minimize();
    },

    OnMouseDownClose: function(event) {
        event.target.src = _imgClose_dn;
    },

    OnMouseUpClose: function(event) {
        event.target.src = _imgClose;
        window.ebCloseStatus = "Close";
        window.close();
    },

    OnMove: function(event) {
        var strGadgetName = (this.popHtmlData.gadgetType == EBGadgetManager_CT2958529.GADGET_TYPE_CHAT) ? EBGadgetManager_CT2958529.CHAT_DIALOG_NAME : this.popHtmlData.popHtmlUrl;
        if (EBGadgetDialog_CT2958529.popHtmlData.saveLocation)
            this._oWindow.EBGadgetManager_CT2958529.GadgetCoordinates(strGadgetName, this._oDialog.boxObject.screenX, this._oDialog.boxObject.screenY);
    },

    //Title bar events end
    ///////////////////////////////////////////////////////////

    //set the close button position
    onResize: function(event) {
        EBGadgetDialog_CT2958529.setCloseImgBtnPosition(event);
    },

    setCloseImgBtnPosition: function(event) {
        if (this.ignoreResize) {
            this.ignoreResize = false;
            return;
        }
        var titleBoxWidth = this._oDialog.boxObject.width;
        if (this._oImgClose.boxObject.width + this._oImgClose.boxObject.x + 6 > titleBoxWidth) {
            this._oImgTitle.style.display = "none";
            this.ignoreResize = true;
        }
        else
            this._oImgTitle.style.display = "";
    },

    OnResizeEnd: function(event) {
        this.ChangeSize(null, null, true);
    },

    OnFocus: function(event) {
        var oBrowser = this._oMainBox.firstChild;

        if (oBrowser)
            this._oWindow.EBGadgetManager_CT2958529.selectedPopWindowId = oBrowser.id;
    },

    //track mouse move from the dialog, because browser tracking stops when mouse over dialog.
    OnMouseMove: function(event) {
        EBGadgetDialog_CT2958529._oWindow.EBGlobalVariables_CT2958529.ScreenCoordinateX = event.screenX;
        EBGadgetDialog_CT2958529._oWindow.EBGlobalVariables_CT2958529.ScreenCoordinateY = event.screenY;
    },

    onclickInside: function(event) {
        EBGadgetDialog_CT2958529._oWindow.EBGadgetManager_CT2958529.onclickOnGadget(window.ebGadgetId);
    },

    OnBrowserBlur: function(event) {
        if (!EBGadgetDialog_CT2958529.popHtmlData.closeOnExternalClick) return;

        if (document.activeElement.tagName == "browser") {
            var oWin = EBGadgetDialog_CT2958529._oWindow;
            var bringToFrontOtherGadgets = function() {
                oWin.EBGadgetManager_CT2958529.BringToFront();
            };
            oWin.setTimeout(bringToFrontOtherGadgets, 50);
            window.close();
        }
    },

    ChatRoomChange: function(objPopHtmlData) {
        this.popHtmlData = objPopHtmlData;
        this._gadgetProgressListener._selfNavigate(objPopHtmlData.popHtmlUrl, null);
        window.focus();

        //send usage
        this._oWindow.EBUsageButton_CT2958529.OnItemClick(this.popHtmlData.componentId, this.popHtmlData.elementId, this.popHtmlData.compType);
    },

    //Minimize
    ///////////////////////////////////////////////////////////
    minimize: function() {
        var stepInc = 46;
        var timeout = 14;
        var elementId = (_gadgetType == EBUsageGadget_CT2958529.GadgetTypes.Chat) ? this.popHtmlData.chatRoomId : this.popHtmlData.elementId;

        this._xulMinimizeToParent = this._oWindow.EBGadgetsMinimizeManager_CT2958529.addMinimizedGadget(elementId, window, this.popHtmlData.componentId);

        if (!this._xulMinimizeToParent) {
            EBLog("Error on minimize");
            return;
        }

        this.isMinimized = true;
        this.currLocation.x = this._oDialog.boxObject.screenX;
        this.currLocation.y = this._oDialog.boxObject.screenY;

        var parentBoxObject = EBGlobalConsts_CT2958529.IsEngine && EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(false).isAIOMode_CT2958529 ?
                                EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(false).arguments[0][0].parentComp.XULElement.boxObject :
                                this._xulMinimizeToParent.boxObject;

        //handle the case of open gadget and then the toolbar has been refreshed
        if (parentBoxObject.screenX == 0 && !EBGlobalConsts_CT2958529.IsEngine && EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(false).arguments[0]) {
            var parentId = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(false).arguments[0][0].parentComp.XULElement.id;
            var componentHash = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true).EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash;
            for (var i = 0; i < componentHash.Count(); i++)
                if (parentId.indexOf(componentHash.GetByIndex(i).ComponentItem.UniqueCompID) != -1) {
                parentBoxObject = componentHash.GetByIndex(i).XULElement.boxObject;
            }
        }

        var moveX = parentBoxObject.screenX - this.currLocation.x;
        var moveY = parentBoxObject.screenY - this.currLocation.y;

        var width = parseInt(EBGadgetDialog_CT2958529.popHtmlData.width) + _widthDelta;
        var height = parseInt(EBGadgetDialog_CT2958529.popHtmlData.height) + _heightDelta;


        var minStep = Math.max(Math.max(Math.abs(moveX), Math.abs(moveY)), Math.max(width, height));
        minStep /= stepInc;
        var moveXStep = moveX / minStep;
        var moveYStep = moveY / minStep;
        var widthStep = width / minStep;
        var heightStep = height / minStep;
        var timer = null;
        
        var onScreenShotReady = function(strImageData) {
            //save screen-shot
            EBGadgetDialog_CT2958529.screenShotImageData = strImageData;

            //do minimize
            var minimizeWindow = function() {
                if (minStep <= 0) {
                    window.moveTo(-10000, -1000);
                    clearInterval(timer);
                    return;
                }

                minStep--;
                window.moveBy(moveXStep, moveYStep);
                window.resizeBy(-1 * widthStep, -1 * heightStep);
            };

            timer = setInterval(minimizeWindow, timeout);
        };

        EBCanvas_CT2958529.getImageBase64DataFromGadget(window, onScreenShotReady);
    },

    restore: function() {
        //bug fix 9073 - TODO: change the solution and find why EBGadgetDialog_CT2958529.popHtmlData.height eqauls 0 somethines
        if (!this.isMinimized) return;
        this.isMinimized = false;
        var defaultGadgetSize = 300;
        var stepInc = 23;
        var timeout = 7;

        var elementId = (_gadgetType == EBUsageGadget_CT2958529.GadgetTypes.Chat) ? this.popHtmlData.chatRoomId : this.popHtmlData.elementId;
        var parentBoxObject = EBGlobalConsts_CT2958529.IsEngine && EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(false).isAIOMode_CT2958529 ?
                                EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(false).arguments[0][0].parentComp.XULElement.boxObject :
                                this._xulMinimizeToParent.boxObject;

        var moveX = this.currLocation.x - parentBoxObject.screenX;
        var moveY = this.currLocation.y - parentBoxObject.screenY;

        var width = parseInt(EBGadgetDialog_CT2958529.popHtmlData.width);
        var height = parseInt(EBGadgetDialog_CT2958529.popHtmlData.height);
        if (width == 0 || height == 0) {
            width = defaultGadgetSize;
            height = defaultGadgetSize;
        }

        var actualGadgetWidth = width + 2;
        var actualGadgetHeight = height + 2;
        if (this.popHtmlData.titlebar) actualGadgetHeight += this.mTitleHeight;
        if (this.popHtmlData.resizable) actualGadgetHeight += this.mResizerHeight;

        var minStep = Math.max(Math.max(Math.abs(moveX), Math.abs(moveY)), Math.max(width, height));
        minStep /= stepInc;

        var moveXStep = moveX / minStep;
        var moveYStep = moveY / minStep;
        var widthStep = actualGadgetWidth / minStep;
        var heightStep = actualGadgetHeight / minStep;
        var timer = null;

        var self = this;
        window.moveTo(parentBoxObject.screenX, parentBoxObject.screenY);

        var onScreenShotReady = function(strImageData) {
            //save screen-shot
            EBGadgetDialog_CT2958529.screenShotImageData = strImageData;

            //do minimize
            var that = self;
            var minimizeWindow = function() {
                if (minStep <= 0) {
                    window.moveTo(that.currLocation.x, that.currLocation.y);
                    window.resizeTo(actualGadgetWidth, actualGadgetHeight);
                    clearInterval(timer);
                    that._oWindow.EBGadgetsMinimizeManager_CT2958529.removeMinimizedGadget(elementId, that.popHtmlData.componentId);
                    window.focus();
                    return;
                }

                minStep--;
                window.moveBy(moveXStep, moveYStep);
                window.resizeBy(widthStep, heightStep);
            };

            timer = setInterval(minimizeWindow, timeout);
        };

        EBCanvas_CT2958529.getImageBase64DataFromGadget(window, onScreenShotReady);
    }
};

//inherits from nsIWebProgressListener
function EBGadgetProgressListener_CT2958529() {
    this.isClickedInGadget = false;
    this.source = "";
    this.gadgetType = "";
    this.callbackDocumentComplete = null;
    this.callbackOnClick = null;
    this.callbackThis = null;

    this._onDocumentComplete = function(bIsSuccess, bIsMainBC) {
        if (this.callbackDocumentComplete)
                this.callbackDocumentComplete.call(this.callbackThis, bIsSuccess, bIsMainBC);
    };

    this._initBrowserCompApi = function() {
        var that = this;
        var argsObj = new Object();
        argsObj.xulBrowser = this.xulBrowser;
        argsObj.parentElement = this.xulBrowser;
        argsObj.objManager = this;
        argsObj.isAllowUntrustedFunctions = this.isAllowUntrustedFunctions;
        argsObj.callbackRegisterKey = function(key) { that.registerKey(key); };

        argsObj.compId = EBGadgetDialog_CT2958529.popHtmlData.componentId;
        argsObj.elementId = EBGadgetDialog_CT2958529.popHtmlData.elementId;
        argsObj.compType = EBGadgetDialog_CT2958529.popHtmlData.compType;
        argsObj.apiPermissions = EBGadgetDialog_CT2958529.popHtmlData.apiPermissions;

        this.browserCompApi = new EBGadgetApi_CT2958529(argsObj);
    };

    this.onError = function() {
        //DON'T REMOVE IT 
        //this function overrides the base HTML comp function. 
    };

    this.onclick = function(event) {
        this._logUserActionTimeStamp(event);

        //send usage
        if (this.callbackOnClick)
            this.callbackOnClick.call(this.callbackThis, event, this.xulBrowser.currentURI.spec);
    };
    
    this.isFloating = function() {
        return EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().isFloatingMode_CT2958529;
    };
    
    this.initGadgetData = function(strSource, strGadgetType, callbackDocumentComplete, callbackOnClick, that) {
        this.source = strSource;
        this.gadgetType = strGadgetType;
        this.isGadget = true;
        this.callbackDocumentComplete = callbackDocumentComplete;
        this.callbackThis = that;
        this.callbackOnClick = callbackOnClick;
    };
};

EBGadgetProgressListener_CT2958529.prototype = new EBBrowserCompProgressListener_CT2958529();

var EBGadgetManager_CT2958529 =
{
    BrowserName: 'popupHTMLWindow',
    PopupHTMLWindowId: 'EBPopupHTMLWindow',
    arrPopupHTMLWindows: new EBArrayHashObject_CT2958529(),
    arrCloseOnExternalClickGadgets: new EBArrayHashObject2_CT2958529(),
    strChromePath: 'chrome://browsersearch/content/popup.xul',
    strChromePathChat: 'chrome://browsersearch/content/popup_chat.xul',
    selectedPopWindowId: null,
    lastCloseOnExternalClickGadgetClosedUrlAndTime: null,

    GADGET_TYPE_REGULAR: 1,
    GADGET_TYPE_CHAT: 4,
    GADGET_TYPE_FACEBOOK: 5,

    CHAT_DIALOG_NAME: 'ChatGadgetWindowNameCT2958529',

    titleHeight: 25,
    resizerHeight: 15,

    closeGadgetsForComponent: function(componentId) {
        //remove all minimized gadgets
        EBGadgetsMinimizeManager_CT2958529.removeMinimizedGadgetOnComponentRemove(componentId);

        //remove all visible gadgets
        var xulBrowser = null;
        var xulGadgetWindows = EBGlobalManager_CT2958529.GetXULWindowsByType("EBPopupDialog_CT2958529");
        if (!xulGadgetWindows || xulGadgetWindows.length == 0) return;
        var xulGadgetWindow = null;
        for (var i = 0; i < xulGadgetWindows.length; i++) {
            xulGadgetWindow = xulGadgetWindows[i];
            if (xulGadgetWindow.EBGadgetDialog_CT2958529.popHtmlData.componentId == componentId)
                xulGadgetWindow.close();
        }
    },

    _getScreenY: function(xulElem) {
        if (EBGlobalManager_CT2958529.IsFirefox36() || xulElem.tagName.toLowerCase() != "menuitem")
            return xulElem.boxObject.screenY;

        var menuButton = xulElem.parentNode.parentNode;
        return menuButton.boxObject.screenY + xulElem.boxObject.screenY - 90;

    },

    _getScreenX: function(xulElem) {
        if (EBGlobalManager_CT2958529.IsFirefox36() || xulElem.tagName.toLowerCase() != "menuitem")
            return xulElem.boxObject.screenX;

        var menuButton = xulElem.parentNode.parentNode;
        return menuButton.boxObject.screenX;
    },

    OpenGadget: function(objPopHtmlDataOriginal) {
        //clone the data object to ensure that changes that will be made in gadget will not reflect
        //next time that the same gadget will be opened
        var objPopHtmlData = EBGlobalManager_CT2958529.cloneObject(objPopHtmlDataOriginal);
        //check if already opened
        var strDialogName = ((objPopHtmlData.gadgetType != this.GADGET_TYPE_CHAT) ?
            objPopHtmlData.popHtmlUrl : this.CHAT_DIALOG_NAME) + EBGlobalConsts_CT2958529.ToolbarCTID;
  
        var oDialog = this.GetGadgetWindow(strDialogName);
        if (oDialog) {
            //regular gadget
            if (objPopHtmlData.gadgetType != this.GADGET_TYPE_CHAT) {
                oDialog.EBGadgetDialog_CT2958529.restore();
                oDialog.focus()
            }

            //chat gadget, reload with new url
            else {
                oDialog.EBGadgetDialog_CT2958529.restore();
                oDialog.EBGadgetDialog_CT2958529.ChatRoomChange(objPopHtmlData);
            }

            return;
        }

        var features = "";
        var position = "";
        var bHaveSavedLocation = false;

        //get saved size, if exists
        if (objPopHtmlData.saveSize) {
            var size = this.GadgetSize(objPopHtmlData.popHtmlUrl);
            if (size) {
                objPopHtmlData.width = size.width;
                objPopHtmlData.height = size.height;
            }
        }

        var x, y;
        //get saved location, if exists
        if (objPopHtmlData.saveLocation) {
            var coordinates = this.GadgetCoordinates(objPopHtmlData.popHtmlUrl);
            if (coordinates) {
                x = coordinates.x;
                y = coordinates.y;
                bHaveSavedLocation = true;
            }
        }

        if (!bHaveSavedLocation) {
            switch (objPopHtmlData.openPositionType) {
                case objPopHtmlData.openPositionTypes.click:
                    x = EBGlobalVariables_CT2958529.ScreenCoordinateX;
                    y = EBGlobalVariables_CT2958529.ScreenCoordinateY;
                    break;
                case objPopHtmlData.openPositionTypes.center:
                    x = screen.availWidth / 2 - (objPopHtmlData.width / 2);
                    y = screen.availHeight / 2 - (objPopHtmlData.height / 2);
                    break;
                case objPopHtmlData.openPositionTypes.alignment:
                    if (objPopHtmlData.openPositionData.vertical == objPopHtmlData.openPositionTypes.verticalAlignmentTop)
                        y = this._getScreenY(objPopHtmlData.parentElement) - objPopHtmlData.height - 38;
                    else
                        y = this._getScreenY(objPopHtmlData.parentElement) + objPopHtmlData.parentElement.boxObject.height;

                    if (objPopHtmlData.openPositionData.horizontal == objPopHtmlData.openPositionTypes.horizontalAlignmentRight)
                        x = this._getScreenX(objPopHtmlData.parentElement) + objPopHtmlData.parentElement.boxObject.width - objPopHtmlData.width - 2;
                    else
                        x = this._getScreenX(objPopHtmlData.parentElement);

                    break;
                case objPopHtmlData.openPositionTypes.offset:
                    x = this._getScreenX(objPopHtmlData.parentElement) + objPopHtmlData.openPositionData.offsetX;
                    y = this._getScreenY(objPopHtmlData.parentElement) + objPopHtmlData.openPositionData.offsetY;
                    break;
            }
        }

        var actualGadgetWidth = objPopHtmlData.width + 2;
        var actualGadgetHeight = objPopHtmlData.height + 2;
        if (objPopHtmlData.titlebar) actualGadgetHeight += this.titleHeight;
        if (objPopHtmlData.resizable) actualGadgetHeight += this.resizerHeight;
        var objCoordinates = EBScreen_CT2958529.getCorrectedCoordinatesForWindow(x, y, actualGadgetWidth, actualGadgetHeight, objPopHtmlData.parentElement);
        x = (objCoordinates.x == 0) ? 1 : objCoordinates.x;
        y = (objCoordinates.y == 0) ? 1 : objCoordinates.y;

        if (objCoordinates.resizedWidth)
            objPopHtmlData.width = objCoordinates.width;

        if (objCoordinates.resizedHeight)
            objPopHtmlData.height = objCoordinates.height;

        position = "left=" + x + ",top=" + y;

        //regular gadget
        features = "dependent,";
        if (EBGlobalManager_CT2958529.IsMacintoshPlatform() && !EBGlobalManager_CT2958529.IsFirefox36())
            features += "titlebar = no,"
        else
            features += "titlebar = yes,"
        features += "chrome,resizable=yes,width=1,height=1," + position;

        var strChromePath = this.GetGadgetChromePath(objPopHtmlData.gadgetType);

        var openTimeStamp = Date.parse(Date());
        //add this gadget to hash if close on external click enabled
        if (objPopHtmlData.closeOnExternalClick) {
            if (this.lastCloseOnExternalClickGadgetClosedUrlAndTime && objPopHtmlData.popHtmlUrl == this.lastCloseOnExternalClickGadgetClosedUrlAndTime.url &&
                            openTimeStamp == this.lastCloseOnExternalClickGadgetClosedUrlAndTime.date) {
                this.lastCloseOnExternalClickGadgetClosedUrlAndTime = null;
                return;
            }
        }

        EBGlobalManager_CT2958529.OpenDialog(strChromePath, strDialogName, features, [objPopHtmlData]);
    },

    GetGadgetWindow: function(strURL) {
        var oDialog = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName("EBPopupDialog_CT2958529", strURL)
        return oDialog;
    },

    RefreshContent: function(oDialog) {
        try {
            var oBrowser = oDialog.document.getElementsByTagName('browser')[0];
            oBrowser.setAttribute('EBStopped', true);
            oBrowser.reload();
        }
        catch (e) {
            EBLogging_CT2958529.LogToConsole(e);
        }
    },

    GetGadgetChromePath: function(GadgetType) {
        GadgetType = parseInt(GadgetType);
        if (!GadgetType) GadgetType = this.GADGET_TYPE_REGULAR;
        var strPath = '';
        switch (GadgetType) {
            case this.GADGET_TYPE_REGULAR: strPath = this.strChromePath; break;
            case this.GADGET_TYPE_FACEBOOK: strPath = this.strChromePath; break;
            case this.GADGET_TYPE_CHAT: strPath = this.strChromePathChat; break;
        }

        return strPath;
    },

    IsGadget: function(xulBrowser) {
        if (xulBrowser.parentNode.getAttribute('id') == EBGadgetDialog_CT2958529.BrowserParentId)
            return true;
        else
            return false;
    },

    BringToFront: function() {
        //enough to focus on one popup window, in order to bring all others to front
        window.focus();
        var i;

        if (this.arrPopupHTMLWindows != null && this.arrPopupHTMLWindows.Count() != 0) {
            var xulBrowser = null;
            var xulWindow = null;
            for (i = 0; i < this.arrPopupHTMLWindows.Count(); i++) {
                xulBrowser = this.arrPopupHTMLWindows.GetByIndex(i);
                try {
                    xulWindow = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName("EBPopupDialog_CT2958529", xulBrowser.id);
                    if (!xulWindow)
                        xulWindow = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName("EBPopupDialog_CT2958529", this.CHAT_DIALOG_NAME);
                    if (xulWindow) xulWindow.focus();
                    break;
                }
                catch (ex) {
                    EBLog(ex);
                }
            }
        }
        //no open pop-up windows in this toolbar, check if there are in other toolbars
        else {
            var cmndName = '';
            var thatGlobalManager;
            var thatGadgetManager;
            var arrCTID = EBActionManager_CT2958529.GetEBToolbarsCTID();
            for (i = 0; i < arrCTID.length; i++) {
                thatGlobalManager = window["EBGlobalManager_" + arrCTID[i].originalCTID];
                thatGadgetManager = window["EBGadgetManager_" + arrCTID[i].originalCTID];
                if (thatGlobalManager && thatGadgetManager) {
                    oDialog = thatGlobalManager.GetXULWindowByTypeAndName("EBPopupDialog_" + arrCTID[i].originalCTID, thatGadgetManager.selectedPopWindowId);
                    if (oDialog) {
                        oDialog.focus();
                        break;
                    }
                }
            }
        }
    },

    GadgetCoordinates: function(strUrl, posX, posY) {
        var strPref = EBPreferenceConsts_CT2958529.MiniIPageGadgetPosition + '.' + strUrl;
        var strPos;
        //get
        if (typeof posX == 'undefined' && typeof posY == 'undefined') {
            strPos = EBGlobalPreferenceManager_CT2958529.GetPref(strPref);
            if (strPos) {
                var arrPos = strPos.split('x');
                return { x: parseInt(arrPos[0]), y: parseInt(arrPos[1]) };
            }
            else
                return null;
        }
        //set
        else {
            strPos = posX + 'x' + posY;
            EBGlobalPreferenceManager_CT2958529.SetPref(strPref, strPos);
        }
    },

    GadgetSize: function(strUrl, width, height) {
        var strPref = EBPreferenceConsts_CT2958529.MiniIPageGadgetSize + '.' + strUrl;
        var strSize;
        //get
        if (typeof width == 'undefined' && typeof height == 'undefined') {
            strSize = EBGlobalPreferenceManager_CT2958529.GetPref(strPref);
            if (strSize) {
                var arrSize = strSize.split('x');
                if (isNaN(parseInt(arrSize[0])) || isNaN(parseInt(arrSize[1])))
                    return null;
                else
                    return { width: parseInt(arrSize[0]), height: parseInt(arrSize[1]) };
            }
            else
                return null;
        }
        //set
        else {
            strSize = width + 'x' + height;
            EBGlobalPreferenceManager_CT2958529.SetPref(strPref, strSize);
        }
    },

    onclickOnGadget: function(clickedGadgetId) {
        if (this.arrCloseOnExternalClickGadgets.Count() == 0) return;

        var iCount = this.arrCloseOnExternalClickGadgets.Count();
        var gadgetWin = null;
        for (var i = iCount - 1; i >= 0; i--) {
            gadgetWin = this.arrCloseOnExternalClickGadgets.GetByIndex(i);
            if (gadgetWin.ebGadgetId != clickedGadgetId) {
                this.arrCloseOnExternalClickGadgets.Remove(gadgetWin.ebGadgetId);
                this.lastCloseOnExternalClickGadgetClosedUrlAndTime = { "url": gadgetWin.arguments[0][0].popHtmlUrl, "date": Date.parse(Date()) };
                gadgetWin.close();
                setTimeout(function() {
                    EBGadgetManager_CT2958529.BringToFront();
                }, 1);
            }
        }
    }
};

var EBGadgetsMinimizeManager_CT2958529 =
{
    pnlMinimizedGadget: null,
    hashMinimizedGadgets: new EBArrayHashObject2_CT2958529(), //key = componentId, value = hash of minimized gadgets (key = id, value = win)

    gadgetPreviewImageInfo: { "width": 150, "height": 157, "panelWidthDeltaPx": 9, "panelHeightDeltaPx": 30, "thumbWidth": 150, "thumbHeight": 157 },
    buttonNotificationIcon: "chrome://browsersearch/skin/small_arrow.png",
    menuItemNotificationIcon: "chrome://browsersearch/skin/small_arrow.png",
    buttonNotificationIconRTL: "chrome://browsersearch/skin/small_arrowRTL.png",
    menuItemNotificationIconRTL: "chrome://browsersearch/skin/small_arrowRTL.png",
    contextCompId: null,
    contextComponent: null,

    isMouseOverComponent: false,
    isMouseOverPanel: false,
    preventGadgetsPreview: false,
    isPanelOpened: false,
    popupManager: null,
    closeTimer: null,
    openTimer: null,
    mTimeMouseOverComponent: 600,

    _getWindowScope: function() {
        return (isAIOMode_CT2958529) ? window : EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
    },

    _getMinimizedGadgetsHash: function() {
        var oWindow = this._getWindowScope();
        return oWindow.EBGadgetsMinimizeManager_CT2958529.hashMinimizedGadgets;
    },

    _clearMinimizedGadgetsHash: function() {
        var oWindow = this._getWindowScope();
        oWindow.EBGadgetsMinimizeManager_CT2958529.hashMinimizedGadgets = new EBArrayHashObject2_CT2958529();
    },

    _getMinimizedGadgetsContextCompId: function() {
        var oWindow = this._getWindowScope();
        return oWindow.EBGadgetsMinimizeManager_CT2958529.componentId;
    },

    _clearPanel: function() {
        var oWindow = this._getWindowScope();
        oWindow.EBGadgetsMinimizeManager_CT2958529._init();

        EBUILogic_Functions_CT2958529.emptyContainer(this.pnlMinimizedGadget);
    },

    showPreviewPanel: function(e, componentId) {
        var xulContextElementBoxObject = e.target.boxObject;
        this.contextCompId = componentId;
        var oWindow = this._getWindowScope();

        if (EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(false).isAIOMode_CT2958529) {
            var parentId = e.target.id;
            var componentHash = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(false).EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash;
            for (var i = 0; i < componentHash.Count(); i++)
                if (parentId.indexOf(componentHash.GetByIndex(i).ComponentItem.UniqueCompID) != -1)
                xulContextElementBoxObject = componentHash.GetByIndex(i).XULElement.boxObject;
        }
        oWindow.EBGadgetsMinimizeManager_CT2958529.showPanel(xulContextElementBoxObject.screenX,
                                                xulContextElementBoxObject.screenY + xulContextElementBoxObject.height);
    },

    onPanelShowing: function(e) {
        var oWindow = this._getWindowScope();
        oWindow.EBGadgetsMinimizeManager_CT2958529.isPanelOpened = true;
        oWindow.EBGadgetsMinimizeManager_CT2958529.fillPreviewPanelWithGadgetsScreenShots(e);
    },

    onPanelHiding: function(e) {
        var oWindow = this._getWindowScope();
        oWindow.EBGadgetsMinimizeManager_CT2958529.isPanelOpened = false;
    },

    addThumb: function(gadgetWin) {
        var gadgetThumb = document.createElement("minimizedGadgetThumb_CT2958529");
        gadgetThumb.setAttribute("width", this.gadgetPreviewImageInfo.thumbWidth + "px");
        gadgetThumb.setAttribute("height", this.gadgetPreviewImageInfo.thumbHeight + "px");
        gadgetThumb.gadgetWin = gadgetWin;
        var isClosed = false;

        var oWindow = EBGadgetsMinimizeManager_CT2958529._getWindowScope();
        gadgetThumb.onImageClick = function() {
            if (isClosed) return;
            isClosed = false;

            gadgetWin.EBGadgetDialog_CT2958529.restore();
            oWindow.EBGadgetsMinimizeManager_CT2958529.closePanel();
        };

        gadgetThumb.onCloseClick = function() {
            isClosed = true;
            //for chat - fix if default room id is 0
            if (gadgetWin.EBGadgetDialog_CT2958529.popHtmlData.gadgetType == EBGadgetManager_CT2958529.GADGET_TYPE_CHAT && gadgetWin.EBGadgetDialog_CT2958529.popHtmlData.chatRoomId == 0) {
                gadgetWin.close();
                oWindow.EBGadgetsMinimizeManager_CT2958529.closePanel();
                return;
            }

            var isLast = (gadgetWin.EBGadgetDialog_CT2958529.popHtmlData.gadgetType == EBGadgetManager_CT2958529.GADGET_TYPE_CHAT) ?
                            oWindow.EBGadgetsMinimizeManager_CT2958529.removeMinimizedGadget(gadgetWin.EBGadgetDialog_CT2958529.popHtmlData.chatRoomId,
                                                                    gadgetWin.EBGadgetDialog_CT2958529.popHtmlData.componentId) :
                            oWindow.EBGadgetsMinimizeManager_CT2958529.removeMinimizedGadget(gadgetWin.EBGadgetDialog_CT2958529.popHtmlData.elementId,
                                                                    gadgetWin.EBGadgetDialog_CT2958529.popHtmlData.componentId);
            if (!isLast)
                gadgetThumb.parentNode.removeChild(gadgetThumb);

            gadgetWin.close();
            if (isLast)
                oWindow.EBGadgetsMinimizeManager_CT2958529.closePanel();
        };

        return gadgetThumb;
    },

    fillPreviewPanelWithGadgetsScreenShots: function(e) {
        var componentId = EBGadgetsMinimizeManager_CT2958529._getMinimizedGadgetsContextCompId();
        var pnl = e.target;
        var thumbsContainer = document.getElementById("boxGadgetsThumbs_CT2958529");
        EBUILogic_Functions_CT2958529.emptyContainer(thumbsContainer);
        var oWindow = this._getWindowScope();
        if (!oWindow.EBGadgetsMinimizeManager_CT2958529._getMinimizedGadgetsHash().Contains(componentId)) return false;
        var hashMinimizedGadgets = oWindow.EBGadgetsMinimizeManager_CT2958529._getMinimizedGadgetsHash().GetByID(componentId);

        var imageWrapper = null;
        var xulImage = null;
        var gadgetWin = null;
        var maxPossibleGadgets = parseInt(screen.availWidth / (this.gadgetPreviewImageInfo.panelWidthDeltaPx * 2 + this.gadgetPreviewImageInfo.width));
        var maxGadgets = Math.min(hashMinimizedGadgets.Count(), maxPossibleGadgets);

        for (var i = 0; i < maxGadgets; i++) {
            gadgetWin = hashMinimizedGadgets.GetByIndex(i);
            thumbsContainer.appendChild(oWindow.EBGadgetsMinimizeManager_CT2958529.addThumb(gadgetWin));
        }
    },

    addMinimizedGadget: function(elementId, win, componentId) {
        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(componentId);
        if (!oComponent) return false;

        var gadgetsHash = (this._getMinimizedGadgetsHash().Contains(componentId)) ? this.hashMinimizedGadgets.GetByID(componentId) : null;
        if (!gadgetsHash) {
            gadgetsHash = new EBArrayHashObject2_CT2958529();
            gadgetsHash.componentId = componentId;
            this._getMinimizedGadgetsHash().Add(componentId, gadgetsHash);
        }

        gadgetsHash.Add(elementId, win);
        if (gadgetsHash.Count() == 1)
            oComponent.InitMinimizedGadgets();

        //oComponent.AddMinimizedGadget(win.EBGadgetDialog_CT2958529.popHtmlData.elementId);

        var xulElement = null;
        var oWindow = this._getWindowScope();
        if (isAIOMode_CT2958529)
            xulElement = AIOParentComponent.GetToolbarItemContainer();
        else {
            if (!oComponent.IsCollapsed()) {
                xulElement = oComponent.GetToolbarItemContainer();
            }
            else {
                var compItem = oComponent.ComponentItem;
                if (!compItem)
                    xulElement = oComponent.GetToolbarItemContainer();
                else {
                    var parentOfChevronGadget = EBChevronStaticManager_CT2958529.IsChevronAlive() ? EBActionManager_CT2958529.GetToolbarChevron() : EBActionManager_CT2958529.GetToolbarChevronParent(componentId);
                    xulElement = parentOfChevronGadget;
                }
            }
        }

        oWindow.focus();

        return xulElement;
    },

    removeMinimizedGadgetOnComponentRemove: function(componentId) {
        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(componentId);
        if (!oComponent) return;
        var gadgetsHash = (this._getMinimizedGadgetsHash().Contains(componentId)) ? this.hashMinimizedGadgets.GetByID(componentId) : null;
        if (!gadgetsHash) return;
        var gadgetWin = null;
        for (var i = 0; i < gadgetsHash.Count(); i++) {
            gadgetWin = gadgetsHash.GetByIndex(i);
            gadgetWin.close();
        }

        oComponent.DisposeMinimizedGadgets();
    },

    //returns true if the gadget removed was the last one for that comopnent
    removeMinimizedGadget: function(elementId, componentId) {
        var oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(componentId);
        if (!oComponent) return false;
        var gadgetsHash = (this._getMinimizedGadgetsHash().Contains(componentId)) ? this.hashMinimizedGadgets.GetByID(componentId) : null;
        if (!gadgetsHash) return false;

        if (!gadgetsHash.Contains(elementId)) return false;
        var gadgetWin = gadgetsHash.GetByID(elementId);
        gadgetsHash.Remove(elementId);
        if (gadgetsHash.Count() == 0) {
            oComponent.DisposeMinimizedGadgets(); //remove events handler and image if any
            return true;
        }
        return false;
        //oComponent.RemoveMinimizedGadget(gadgetWin.EBGadgetDialog_CT2958529.popHtmlData.elementId);
    },

    closeAllGadgets: function(gadgetsHash) {
        var gadgetWin = null;
        for (var i = 0; i < gadgetsHash.Count(); i++) {
            gadgetWin = gadgetsHash.GetByIndex(i);
            gadgetWin.close();
        }
    },

    closeAllGadgetWindows: function() {
        var oWindow = this._getWindowScope();
        var winArr = oWindow.EBGlobalManager_CT2958529.GetXULWindowsByType("EBPopupDialog_CT2958529");
        for (var i = 0; i < winArr.length; i++)
            winArr[i].close();

        oWindow.EBGadgetsMinimizeManager_CT2958529._clearMinimizedGadgetsHash();
    },

    onToolbarRebuilt: function() {
        //in case of show-hide any app - if tool;bar has dynamic menu it will be true
        //important - will not show preview
        if (EBGadgetsMinimizeManager_CT2958529.preventGadgetsPreview)
            EBGadgetsMinimizeManager_CT2958529.preventGadgetsPreview = false;

        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        if (this._getMinimizedGadgetsHash().Count() == 0) return;

        var gadgetsHash = null;
        var oComponent = null;
        var gadgetWin = null;
        var arrCompsToDelete = new Array();
        var hashMinimizedGadgets = this._getMinimizedGadgetsHash();
        for (var i = 0; i < hashMinimizedGadgets.Count(); i++) {
            gadgetsHash = hashMinimizedGadgets.GetByIndex(i);
            oComponent = EBComponentsManager_CT2958529.GetComponentByCompID(gadgetsHash.componentId);
            //no component exists for minimized gadgets, close them all.
            if (!oComponent) {
                if (!isFloatingMode_CT2958529) {
                    this.closeAllGadgets(gadgetsHash);
                    arrCompsToDelete.push(gadgetsHash.componentId);
                }
            }
            else {
                if (gadgetsHash.Count() != 0)
                    oComponent.InitMinimizedGadgets();
            }
        }

        //remove gadgets hash for non existing components
        for (var i = 0; i < arrCompsToDelete.length; i++)
            hashMinimizedGadgets.Remove(arrCompsToDelete[i]);
    },

    hasMinimizedGadget: function(componentId, elementId) {
        var hashMinimizedGadgets = this._getMinimizedGadgetsHash();
        if (!hashMinimizedGadgets.Contains(componentId)) return false;
        var hashGadgets = hashMinimizedGadgets.GetByID(componentId);
        if (hashGadgets.Count() == 0) return false;

        return hashGadgets.Contains(elementId);
    },

    onClick: function(e, componentId) {
        var oWindow = this._getWindowScope();
        clearTimeout(oWindow.EBGadgetsMinimizeManager_CT2958529.openTimer);
        oWindow.EBGadgetsMinimizeManager_CT2958529.closePanel();
    },

    onMouseOverComponent: function(e, componentId) {
        var oWindow = this._getWindowScope();
        clearTimeout(oWindow.EBGadgetsMinimizeManager_CT2958529.closeTimer);
        //mouse over other toolbaritem
        if (oWindow.EBGadgetsMinimizeManager_CT2958529.contextCompId && oWindow.EBGadgetsMinimizeManager_CT2958529.contextCompId != componentId
                && oWindow.EBGadgetsMinimizeManager_CT2958529.isPanelOpened)
            oWindow.EBGadgetsMinimizeManager_CT2958529.closePanel();

        oWindow.EBGadgetsMinimizeManager_CT2958529.componentId = componentId;
        if (e.target.tagName != "toolbarbutton") return;

        oWindow.EBGadgetsMinimizeManager_CT2958529.isMouseOverComponent = true;

        oWindow.EBGadgetsMinimizeManager_CT2958529.openTimer = setTimeout(function() {
            if (!oWindow.EBGadgetsMinimizeManager_CT2958529._getMinimizedGadgetsHash().Contains(componentId)) return;
            var hashMinimizedGadgets = oWindow.EBGadgetsMinimizeManager_CT2958529._getMinimizedGadgetsHash().GetByID(componentId);
            if (hashMinimizedGadgets.Count() == 0) return;

            if (!oWindow.EBGadgetsMinimizeManager_CT2958529.isMouseOverComponent || oWindow.EBGadgetsMinimizeManager_CT2958529.preventGadgetsPreview) return;
            oWindow.EBGadgetsMinimizeManager_CT2958529.showPreviewPanel(e, componentId);
        }, this.mTimeMouseOverComponent);
    },

    onMouseOutComponent: function(e, componentId) {
        var oWindow = this._getWindowScope();
        oWindow.EBGadgetsMinimizeManager_CT2958529.isMouseOverComponent = false;
        oWindow.EBGadgetsMinimizeManager_CT2958529.closeTimer = setTimeout(function() {
            if (oWindow.EBGadgetsMinimizeManager_CT2958529.isMouseOverComponent || oWindow.EBGadgetsMinimizeManager_CT2958529.isMouseOverPanel) return;
            if (oWindow.EBGadgetsMinimizeManager_CT2958529.isPanelOpened)
                oWindow.EBGadgetsMinimizeManager_CT2958529.closePanel();
        }, this.mTimeMouseOverComponent + 400);
    },

    onMouseOutPanel: function(e) {
        var oWindow = this._getWindowScope();
        oWindow.EBGadgetsMinimizeManager_CT2958529.isMouseOverPanel = false;
        oWindow.EBGadgetsMinimizeManager_CT2958529.closeTimer = oWindow.setTimeout(function() {
            if (oWindow.EBGadgetsMinimizeManager_CT2958529.isMouseOverComponent || oWindow.EBGadgetsMinimizeManager_CT2958529.isMouseOverPanel) return;
            oWindow.EBGadgetsMinimizeManager_CT2958529.closePanel();
        }, this.mTimeMouseOverComponent + 400);
    },

    onMouseOverPanel: function(e) {
        var oWindow = this._getWindowScope();
        clearTimeout(oWindow.EBGadgetsMinimizeManager_CT2958529.closeTimer);
        oWindow.EBGadgetsMinimizeManager_CT2958529.isMouseOverPanel = true;
        oWindow.EBGadgetsMinimizeManager_CT2958529.isMouseOverComponent = false;
    },

    closePanel: function() {
        var oWindow = this._getWindowScope();
        if (!oWindow.EBGadgetsMinimizeManager_CT2958529.isPanelOpened) return;
        oWindow.EBGadgetsMinimizeManager_CT2958529.isPanelOpened = false;

        oWindow.EBGadgetsMinimizeManager_CT2958529.popupManager.fadeOut();
    },

    showPanel: function(x, y) {
        var oWindow = this._getWindowScope();
        if (oWindow.EBGadgetsMinimizeManager_CT2958529.isPanelOpened) return;

        oWindow.EBGadgetsMinimizeManager_CT2958529.isPanelOpened = true;
        oWindow.EBGadgetsMinimizeManager_CT2958529.pnlMinimizedGadget = document.getElementById("pnlMinimizedGadgets_CT2958529");
        oWindow.EBGadgetsMinimizeManager_CT2958529.popupManager = new EBUILogic_Popup_CT2958529(oWindow.EBGadgetsMinimizeManager_CT2958529.pnlMinimizedGadget);

        oWindow.EBGadgetsMinimizeManager_CT2958529.pnlMinimizedGadget.openPopupAtScreen(x, y);
        oWindow.EBGadgetsMinimizeManager_CT2958529.popupManager.fadeIn();
    }
};
var EBMCTrusteDialog_CT2958529 =
{
    dialogFilename: "truste.xul",
    dialogName: "EBTrusteDialogName",
    dialogId: "EBTrusteDialogId",

    downloadUrl: "",
    mainWindow: null,
    usageSource: "",

    //************** toolbar scope **************
    open: function(strDownloadUrl, strUsageSource) {
        EBGlobalManager_CT2958529.OpenDialog(EBGlobalConsts_CT2958529.ChromeContentPath + this.dialogFilename,
							this.dialogName,
							'modal,centerscreen,chrome,resizable=no',
							[strDownloadUrl, strUsageSource]);
    },


    //************** dialog scope **************
    onload: function(event) {
        this.downloadUrl = window.arguments[0][0];
        this.usageSource = window.arguments[0][1];
        this.mainWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        this._applyLP();
    },

    onunload: function(event) {

    },

    onaccept: function() {
        var strUsageSource = this.usageSource;
        var strUrl = this.downloadUrl;
        var oWin = this.mainWindow;

        var funcGetAndChangeCommunity = function() {
            oWin.EBMCManager_CT2958529.GetAndChangeCommunity(strUrl, strUsageSource);
        };

        oWin.setTimeout(funcGetAndChangeCommunity, 1000);
    },

    oncancel: function() {

    },

    onclickEULA: function() {
        EBActionManager_CT2958529.OpenEULA("BLANK", this.downloadUrl);
    },

    _applyLP: function() {
        var dialogsDirection = this.mainWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, this.dialogId);

        var locale = this.mainWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);
        window.title = this.mainWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_ADD_COMMUNITY_DLG_TITLE');

        document.getElementById("dscText1").firstChild.nodeValue = this.mainWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_ADD_COMMUNITY_DLG_EXPLAIN1');
        document.getElementById("dscText2").firstChild.nodeValue = this.mainWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_ADD_COMMUNITY_DLG_EXPLAIN2');
        document.getElementById("lblEula").value = this.mainWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_ADD_COMMUNITY_DLG_LEARN_MORE');
        document.getElementById("btnAccept").setAttribute("label", this.mainWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK'));
        document.getElementById("btnCancel").setAttribute("label", this.mainWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL'));
    }
}
var EBGroupingManager_CT2958529 =
{
    LOCALE_PREF_NAME: "general.useragent.locale",
    groupingReceived: false,

    canInitToolbar: function() {
        if (!EBGlobalConsts_CT2958529.IsSelectFromGroupingByLocale) return true;
        //this will be relevant when upgrade is done, if the new toolbar set to select from grouping
        if (EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.FirstTime)) return true;

        return EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.IsToolbarSelectedFromGrouping);
    },

    initFirstTime: function() {
        EBMCServerComm_CT2958529.GetGroupInfoFromServer(true);
        var that = this;
        setTimeout(function() { that.checkGroupingReceived.call(that); }, 5000);
    },

    onErrorGetting: function() {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsToolbarSelectedFromGrouping, true);
        if (!EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.CTID))
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CTID, EBGlobalConsts_CT2958529.ToolbarCTID);
        //TODO: set client error log
        EBToolbarManager_CT2958529.onload();
    },

    onGroupingResponse: function(objGroupingCommunities) {
        //grouping already selected or no need to select
        if (this.canInitToolbar()) return;

        this.groupingReceived = true;
        EBGroupingManager_CT2958529.selectToolbarFromGroupingByLocale(objGroupingCommunities);
    },

    checkGroupingReceived: function() {
        if (!this.groupingReceived)
            this.onErrorGetting();
    },

    selectToolbarFromGroupingByLocale: function(objGroupingCommunities) {
        if (!objGroupingCommunities || objGroupingCommunities.IsEmpty())
            this.onErrorGetting();

        var systemLocale = EBPreferenceService_CT2958529.GetPref(this.LOCALE_PREF_NAME);
        if (!systemLocale)
            this.onErrorGetting();

        var perfectMatchCTID = "";
        var nearMatchCTID = EBGlobalConsts_CT2958529.ToolbarCTID;

        try {
            if (!stringEquals(systemLocale, EBGlobalConsts_CT2958529.ToolbarLanguage, true)) {
                var communities = objGroupingCommunities.CommunityList();
                var community = null;

                for (var i = 0; i < communities.Count(); i++) {
                    community = communities.GetByIndex(i);
                    if (community.Locale && stringEquals(community.Locale, systemLocale, true)) {
                        perfectMatchCTID = community.CTID;
                        break;
                    }

                    if (community.Locale && stringEquals(community.Locale.substr(0, 2), systemLocale.substr(0, 2), true))
                        nearMatchCTID = community.CTID;
                }
            }

            var selectedCTID = (perfectMatchCTID) ? perfectMatchCTID : nearMatchCTID;
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CTID, selectedCTID);
        }
        catch (e) {
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CTID, EBGlobalConsts_CT2958529.ToolbarCTID);
            EBLog(e);
        }

        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.IsToolbarSelectedFromGrouping, true);
        EBToolbarManager_CT2958529.onload();
    }
};
var EBMCButtonManager_CT2958529 =
{
    Consts:
    {
        CandidateIcon: 'chrome://browsersearch/skin/mc_add_candidate.png',
        TimeoutFuncRef: null,
        TooltipID: 'EBMulticommunityTooltipID_CT2958529'
    },

    IsTooltipShown: false,
    DontShowTooltip: false,


    OnClickMainButton: function() {
        this.ClearTimeout();
        EBUsageMyConduit_CT2958529.OnOpenDropDownMenu();

        //star
        this.RemoveMainButtonStar();

        var menuButton = EBMCMenu_CT2958529.xulMenuObj;
        var strImage = EBImageHandler_CT2958529.GetImageUrl(menuButton);

        if (strImage == oToolbarSkin_CT2958529.groupInactiveImageUrl) {
            this.ClearTimeout();
            EBImageHandler_CT2958529.SetNewImage(menuButton, oToolbarSkin_CT2958529.groupInactiveImageUrl);
        }
        else if (strImage == this.Consts.CandidateIcon)
            this.CandidateDetected();
        else
            this.CommunitiesDetectedStop();
    },

    CommunitiesDetected: function() {
        this.ClearTimeout();
        var menuButton = EBMCMenu_CT2958529.xulMenuObj;
        EBImageHandler_CT2958529.SetNewImage(menuButton, oToolbarSkin_CT2958529.groupFlashingIconUrl);
        this.Consts.TimeoutFuncRef = setTimeout(function() { EBMCButtonManager_CT2958529.CommunitiesDetectedStop() }, 12000);
        EBUsageMyConduit_CT2958529.ToolbarDetected();
    },

    CommunitiesDetectedStop: function() {
        var menuButton = EBMCMenu_CT2958529.xulMenuObj;
        EBImageHandler_CT2958529.SetNewImage(menuButton, oToolbarSkin_CT2958529.groupActiveImageUrl);
    },

    CandidateDetected: function() {

        var menuButton = EBMCMenu_CT2958529.xulMenuObj;
        EBImageHandler_CT2958529.SetNewImage(menuButton, this.Consts.CandidateIcon);
    },

    CommunitiesNotDetected: function() {
        this.ClearTimeout();
        var menuButton = EBMCMenu_CT2958529.xulMenuObj;

        if (!menuButton) return;

        EBImageHandler_CT2958529.SetNewImage(menuButton, oToolbarSkin_CT2958529.groupInactiveImageUrl);

        var strBaseUrl = null;

        EBMCMenu_CT2958529.CommunitiesNotDetected(strBaseUrl);
    },

    ClearTimeout: function() {
        try {
            clearTimeout(this.Consts.TimeoutFuncRef);
        }
        catch (ex) { }
    },

    SetMainButtonStar: function() {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            if (objWindow.EBMCButtonManager_CT2958529._SetMainButtonStar) {
                objWindow.EBMCButtonManager_CT2958529._SetMainButtonStar();
            }
        }
    },

    RemoveMainButtonStar: function() {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            if (objWindow.EBMCButtonManager_CT2958529._RemoveMainButtonStar) {
                objWindow.EBMCButtonManager_CT2958529._RemoveMainButtonStar();
            }
        }
    },

    _SetMainButtonStar: function() {
        var menuButton = EBMCMenu_CT2958529.xulMenuObj;
        EBImageHandler_CT2958529.SetStar(menuButton);
    },


    _RemoveMainButtonStar: function() {
        var menuButton = EBMCMenu_CT2958529.xulMenuObj;
        EBImageHandler_CT2958529.RemoveStar(menuButton);
    },

    // +++++++++++++++++++++++ POPUP ++++++++++++++++++++++++++
    ShowPopup: function(arrA) {
        if (this.IsTooltipShown || this.DontShowTooltip) {
            this.DontShowTooltip = false;
            return;
        }

        var bShow = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipShow);
        bShow = (bShow == null) ? true : bShow;
        if (!bShow) {
            return;
        }

        var menuButton = EBMCMenu_CT2958529.xulMenuObj;
        var x = menuButton.boxObject.screenX;
        var y = menuButton.boxObject.screenY + menuButton.boxObject.height;
        var strUrls = '';
        for (var i = 0; i < arrA.length; i++) {
            strUrls += arrA[i].url;
            if (i < arrA.length - 1) {
                strUrls += ' ';
            }
        }
        var width = (EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipWidth)) ? EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipWidth) : EBMCDialog_CT2958529.Consts.BrowserWidth;
        var height = (EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipHeight)) ? EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipHeight) : EBMCDialog_CT2958529.Consts.BrowserHeight;

        //open dialog with timeout, if not, it will self close before even shown, 
        //because of the onblur=window.close of the dialog
        var iTimeout = parseInt(Math.random() * 100) + 1;
        setTimeout(function() { EBMCDialog_CT2958529.OpenDetectedDialog(strUrls, x, y, parseInt(width), parseInt(height)); }, iTimeout);

        window.addEventListener("click", EBMCDialog_CT2958529.OnExternalClick, false);
    }
    // +++++++++++++++++++++++ POPUP ++++++++++++++++++++++++++
};

function EBCommunitiesList_CT2958529(objUserCommunities,objGroupingCommunities,objRecentCommunities)
{
    //Original Info, with duplicates
    this.UserCommunities        = objUserCommunities;
    this.GroupingCommunities    = objGroupingCommunities;
    this.RecentCommunities      = objRecentCommunities;
    
    //Info without duplication
    this.User                   = null;
    this.Grouping               = null;
    this.Recent                 = null;
    
    //Info without duplication for options dialog (without recent)
    this.GroupingDialog         = null;
    this.UserDialog             = null;
    
    
    //Hash for all communities
    this.AllCommunities = null;

    this.Init = function() {
        var oCommunity = null;
        this.AllCommunities = new EBArrayHashObject_CT2958529();
        var i;

        //Init Recent List
        if (this.RecentCommunities && !this.RecentCommunities.IsEmpty()) {
            this.Recent = new EBRecentCommunityList_CT2958529(null, this.RecentCommunities.FullFilePath)
            for (i = 0; i < this.RecentCommunities.Count(); i++) {
                oCommunity = this.RecentCommunities.GetByIndex(i);
                if (!this.AllCommunities.Contains(oCommunity.CTID) && oCommunity.Status == 0) {
                    this.AllCommunities.Add(oCommunity.CTID, oCommunity);
                    this.Recent.Add(oCommunity);
                }
            }
        }

        //Init Grouping List
        if (this.GroupingCommunities && !this.GroupingCommunities.IsEmpty()) {
            this.Grouping = new EBMCCommunityList_CT2958529(null, this.GroupingCommunities.FullFilePath)

            for (i = 0; i < this.GroupingCommunities.Count(); i++) {
                oCommunity = this.GroupingCommunities.GetByIndex(i);
                if (!this.AllCommunities.Contains(oCommunity.CTID) && oCommunity.Status == 0) {
                    this.AllCommunities.Add(oCommunity.CTID, oCommunity);
                    this.Grouping.Add(oCommunity);
                }
            }
        }

        //Init User List
        if (this.UserCommunities && !this.UserCommunities.IsEmpty()) {
            this.User = new EBMCCommunityList_CT2958529(null, this.UserCommunities.FullFilePath)

            for (i = 0; i < this.UserCommunities.Count(); i++) {
                oCommunity = this.UserCommunities.GetByIndex(i);
                if (!this.AllCommunities.Contains(oCommunity.CTID) && oCommunity.Status == 0) {
                    this.AllCommunities.Add(oCommunity.CTID, oCommunity);
                    this.User.Add(oCommunity);
                }
            }
        }

        //Add Original toolbar object to AllCommunities object
        var strOriginalToolbarXml = '<COMMUNITY>';
        strOriginalToolbarXml += '<CTID>' + EBGlobalConsts_CT2958529.ToolbarCTID + '</CTID>';
        strOriginalToolbarXml += '<NAME>' + EBGlobalConsts_CT2958529.ToolbarName + '</NAME>';
        strOriginalToolbarXml += '<DESCRIPTION></DESCRIPTION>';
        strOriginalToolbarXml += '<TAGS></TAGS>';
        strOriginalToolbarXml += '<INSTALLATION_URL>' + EBGlobalConsts_CT2958529.WebServerUrl.replace(/http:\/\//, '') + '</INSTALLATION_URL>';
        strOriginalToolbarXml += '</COMMUNITY>';

        var xmlOriginalToolbar = EBXML_CT2958529.GetXmlDocument(strOriginalToolbarXml);
        xmlOriginalToolbar = xmlOriginalToolbar.documentElement;

        var oToolbar = new EBMCCommunityList_CT2958529(xmlOriginalToolbar, '');
        this.AllCommunities.Add(oToolbar.CTID, oToolbar);
    };

    this.InitForDialog = function() {
        var oCommunity = null;
        var DialogAllCommunities = new EBArrayHashObject_CT2958529();
        var i;
        
        //Init Grouping List
        if (this.GroupingCommunities && !this.GroupingCommunities.IsEmpty()) {
            this.GroupingDialog = new EBMCCommunityList_CT2958529(null, this.GroupingCommunities.FullFilePath)

            for (i = 0; i < this.GroupingCommunities.Count(); i++) {
                oCommunity = this.GroupingCommunities.GetByIndex(i);
                if (!DialogAllCommunities.Contains(oCommunity.CTID) &&
                    oCommunity.Status != 2) {
                    DialogAllCommunities.Add(oCommunity.CTID, oCommunity);
                    this.GroupingDialog.Add(oCommunity);
                }
            }
        }

        //Init User List
        if (this.UserCommunities && !this.UserCommunities.IsEmpty()) {
            this.UserDialog = new EBMCCommunityList_CT2958529(null, this.UserCommunities.FullFilePath)

            for (i = 0; i < this.UserCommunities.Count(); i++) {
                oCommunity = this.UserCommunities.GetByIndex(i);
                if (!DialogAllCommunities.Contains(oCommunity.CTID)) {
                    DialogAllCommunities.Add(oCommunity.CTID, oCommunity);
                    this.UserDialog.Add(oCommunity);
                }
            }
        }

        //Init Recent List
        if (this.RecentCommunities && !this.RecentCommunities.IsEmpty()) {
            if (!this.UserDialog) {
                this.UserDialog = new EBMCCommunityList_CT2958529(null, this.UserCommunities.FullFilePath)
            }

            for (i = 0; i < this.RecentCommunities.Count(); i++) {
                oCommunity = this.RecentCommunities.GetByIndex(i);
                if (!DialogAllCommunities.Contains(oCommunity.CTID)) {
                    DialogAllCommunities.Add(oCommunity.CTID, oCommunity);
                    this.UserDialog.Add(oCommunity);
                }
            }
        }

    };

    this.CommunitySelected = function(strCTID) {
        //if original toolbar selected, don't insert it to any list
        if (strCTID == EBGlobalConsts_CT2958529.ToolbarCTID) return;

        var oCommunity = null;
        //if this community from grouping, add it to user and recent list
        if (this.Grouping && this.Grouping.Contains(strCTID)) {
            oCommunity = this.Grouping.GetByID(strCTID);
            this.RecentCommunities.Add(oCommunity);
            if (!this.UserCommunities) {
                var strFullFilePath = EBMCConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBMCConsts_CT2958529.CommunitiesFileName;
                this.UserCommunities = new EBMCCommunityList_CT2958529(null, strFullFilePath);
            }
            this.UserCommunities.Add(oCommunity);
            this.UserCommunities.SaveToFile();
            this.RecentCommunities.SaveToFile();

        }
        //else, add it to recent list only
        else {
            oCommunity = this.AllCommunities.GetByID(strCTID);
            this.RecentCommunities.Add(oCommunity);
            this.RecentCommunities.SaveToFile();
        }
    };

    this.IsExists = function(strUrl) {
        var oCommunity = this.GetCommunityByInstallationUrl(strUrl);

        return (oCommunity) ? true : false;
    };

    this.GetCommunityByCTID = function(strCTID) {
        return this.AllCommunities.GetByID(strCTID);
    };

    this.GetCTIDByInstallationUrl = function(strUrl) {
        var oCommunity = this.GetCommunityByInstallationUrl(strUrl);

        return (oCommunity) ? oCommunity.CTID : null;
    };

    this.GetCommunityByInstallationUrl = function(strUrl) {
        var strCommunityName = EBMCManager_CT2958529.GetCommunityNameFromInstallationUrl(strUrl)
        var strName = '';
        var oCommunity = null;

        for (var i = 0; i < this.AllCommunities.Count(); i++) {
            oCommunity = this.AllCommunities.GetByIndex(i);
            strName = EBMCManager_CT2958529.GetCommunityNameFromInstallationUrl(oCommunity.InstallationUrl)
            if (strCommunityName.toLowerCase() == strName.toLowerCase()) {
                return oCommunity;
            }
        }

        return null;
    };

    this.GetAllCTIDCommaSeparatedString = function() {
        var strCTIDs = '';
        var oCommunity = null
        var arrLen = this.AllCommunities.Count();
        for (var i = 0; i < arrLen; i++) {
            oCommunity = this.AllCommunities.GetByIndex(i);
            strCTIDs += oCommunity.CTID;
            if (i < arrLen - 1) {
                strCTIDs += ',';
            }
        }

        return strCTIDs;
    };

    this.UpdateGrouping = function(oGrouping) {
        this.GroupingCommunities = oGrouping;
        this.Init();
    };

    this.UpdateCurrentGrouping = function(oCommunities) {
        var oCommunity = null;
        var oExistingCommunity = null;

        for (var i = 0; i < oCommunities.Count(); i++) {
            oCommunity = oCommunities.GetByIndex(i);
            if (!this.UserCommunities.Contains(oCommunity.CTID) && oCommunity.CTID != EBGlobalConsts_CT2958529.ToolbarCTID) {
                this.UserCommunities.Add(oCommunity);
            }
        }
        this.UserCommunities.SaveToFile();
        this.Init();
    };

    this.Count = function() {
        return this.AllCommunities.Count();
    };
    
    //Init and fill communities
    this.Init();
};
//Radio Media Class
function EBMCCommunity_CT2958529(XMLNode)
{
	this.CTID               = '';
	this.Name               = '';
	this.Description        = '';
	this.Tags               = '';
	this.InstallationUrl    = '';
	this.Status = 0;
	this.Locale = "";

	this.Init = function(XMLNode) {
	    var XMLNodeChild = null;

	    for (var i = 0; i < XMLNode.childNodes.length; i++) {
	        XMLNodeChild = XMLNode.childNodes[i];

	        if (XMLNodeChild.tagName == EBMCConsts_CT2958529.xmlTags.CTID)
	            this.CTID = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	        else if (XMLNodeChild.tagName == EBMCConsts_CT2958529.xmlTags.Name)
	            this.Name = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	        else if (XMLNodeChild.tagName == EBMCConsts_CT2958529.xmlTags.Description)
	            this.Description = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	        else if (XMLNodeChild.tagName == EBMCConsts_CT2958529.xmlTags.Tags)
	            this.Tags = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	        else if (XMLNodeChild.tagName == EBMCConsts_CT2958529.xmlTags.InstallUrl)
	            this.InstallationUrl = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	        else if (XMLNodeChild.tagName == EBMCConsts_CT2958529.xmlTags.Locale)
	            this.Locale = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	    }
	    this.Status = this.GetCommunityStatus(this.CTID);
	};
		
	this.GetCommunityStatus = function(strCTID)
    {
        var strStatusBranch = EBMCConsts_CT2958529.CommunitiesStatusBranch;
        var strPrefName     = strStatusBranch + '.' + strCTID;
        var iStatus         = EBToolbarPreferenceManager_CT2958529.GetPref(strPrefName);
        if(!iStatus)
            iStatus = 0;

        return iStatus;
    };
    
	this.Update = function(CTID,Name,Description,Tags,InstallationUrl)
	{
		this.CTID			    = CTID;
		this.Name			    = Name;
		this.Description	    = Description;
		this.Tags			    = Tags;
		this.InstallationUrl    = InstallationUrl;
	};
	
	this.toXML = function()
	{
		return EBXML_CT2958529.GetXmlDocument(this.toXMLString);
	};
	
	this.toXMLString = function()
	{
        var strXML =  EBXML_CT2958529.CreateXmlNodeStartString(EBMCConsts_CT2958529.xmlTags.Community);
		    strXML += EBXML_CT2958529.CreateXmlNodeString(EBMCConsts_CT2958529.xmlTags.CTID,         this.CTID);
		    strXML += EBXML_CT2958529.CreateXmlNodeString(EBMCConsts_CT2958529.xmlTags.Name,         this.Name);
		    strXML += EBXML_CT2958529.CreateXmlNodeString(EBMCConsts_CT2958529.xmlTags.Description,  this.Description);
		    strXML += EBXML_CT2958529.CreateXmlNodeString(EBMCConsts_CT2958529.xmlTags.Tags,         this.Tags);
		    strXML += EBXML_CT2958529.CreateXmlNodeString(EBMCConsts_CT2958529.xmlTags.InstallUrl, this.InstallationUrl);
		    strXML += EBXML_CT2958529.CreateXmlNodeString(EBMCConsts_CT2958529.xmlTags.Locale, this.Locale);
		    strXML += EBXML_CT2958529.CreateXmlNodeEndString(EBMCConsts_CT2958529.xmlTags.Community);
		
		return strXML;
	};
	
	this.SetStatus = function(iStatus)
	{
	    this.Status = iStatus;
	    var strStatusBranch = EBMCConsts_CT2958529.CommunitiesStatusBranch;
        var strPrefName     = strStatusBranch + '.' + this.CTID;
        EBToolbarPreferenceManager_CT2958529.SetPref(strPrefName,iStatus);
	};


	this.toListItem = function(bIsGrouping, doc) {
	    if (this.Status == 2) return null;
	    
	    var strDisplayText = this.Name;
	    var strDisplayIcon = EBMCDialog_CT2958529.Consts.DialogIcon;
	    var strCheckBoxID = this.CTID;

	    var objListItem = doc.createElement("listitem");
	    var objCheckBox = doc.createElement("listcell");
	    var objTextImage = doc.createElement("listcell");

	    objListItem.setAttribute('allowevents', 'true');
	    objListItem.setAttribute('style', 'height:20px');
	    objListItem.setAttribute('EB_GROUPING', bIsGrouping);
	    objListItem.setAttribute('id', strCheckBoxID);

	    objCheckBox.setAttribute('type', 'checkbox');
	    objCheckBox.addEventListener("click", function(event) { EBMCDialog_CT2958529.ListItem_OnClickCheckBox(event); }, false);

	    objTextImage.setAttribute('image', strDisplayIcon);
	    objTextImage.setAttribute('label', strDisplayText);
	    objTextImage.setAttribute('class', 'listcell-iconic');
	    objTextImage.addEventListener("mouseover", function(event) { EBMCDialog_CT2958529.ListItem_MouseOver(this); }, false);
	    objTextImage.addEventListener("mouseout", function(event) { EBMCDialog_CT2958529.ListItem_MouseOut(this); }, false);



	    var isChecked = (this.Status == 0) ? true : false
	    objCheckBox.setAttribute('checked', isChecked.toString());

	    objListItem.appendChild(objCheckBox);
	    objListItem.appendChild(objTextImage);
	    return objListItem;
	};
};
function EBMCCommunityList_CT2958529(XMLNode,strFullFilePath)
{
	this.CommunitiesHash = new EBArrayHashObject_CT2958529();
	
	this.Caption	    = '';
	this.IconUrl	    = '';
	this.Hint		    = '';
	this.FullFilePath = '';
	
	this.InitList = function(XMLNode)
	{
		var oCommunity	= null;
		this.isList		= true;
		
		var XMLNodeChild = null;
		for(var i=0;i<XMLNode.childNodes.length;i++)
		{
			XMLNodeChild = XMLNode.childNodes[i];
			if(XMLNodeChild.tagName == 'COMMUNITY')
			{
				oCommunity = new EBMCCommunityList_CT2958529(XMLNodeChild);
				this.CommunitiesHash.Add(oCommunity.CTID, oCommunity);
			}
			else if(XMLNodeChild.tagName == 'COMMUNITIES')
			{
				oCommunity = new EBMCCommunityList_CT2958529(XMLNodeChild)
				this.CommunitiesHash.Add("CommunityList"+i,oCommunity);
			}
			else if(XMLNodeChild.tagName == 'CAPTION')
				this.Caption = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
			else if(XMLNodeChild.tagName == 'ICON_URL')
				this.IconUrl = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
			else if(XMLNodeChild.tagName == 'HINT')
				this.Hint = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
			
		}
		oCommunity = null;
	};
	
	this.toXML = function()
	{
		var strXml = this.toString();
		var xmlDoc = EBXML_CT2958529.GetXmlDocument(strXml);
		return xmlDoc;
	};
	
	this.toString = function()
	{
		var oCommunity	= '';
		var strXML	    = '<COMMUNITIES>';
		
		for(var i=0;i<this.CommunitiesHash.Count();i++)
		{
			oCommunity = this.CommunitiesHash.GetByIndex(i);
			strXML += oCommunity.toXMLString();
		}
		
		strXML += '</COMMUNITIES>';
		strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
		return strXML;
	};
    
	this.SaveToFile = function()
	{
	    var strXml = this.toString();
	    var oFile = EBIOManager_CT2958529.CreateToolbarFile(this.FullFilePath);
	    EBFileIO_CT2958529.write(oFile,strXml,'',EBGlobalConsts_CT2958529.DefaultCharset);
	};
	
	this.Add = function(oCommunity)
	{
	    if(!this.Contains(oCommunity.CTID))
	        this.CommunitiesHash.Add(oCommunity.CTID,oCommunity);
	};
	
	this.AddFirst = function(oCommunity)
	{
	    if(!this.Contains(oCommunity.CTID))
            this.CommunitiesHash.Insert(0,oCommunity.CTID,oCommunity);
	};
	
	this.GetByIndex = function(iIndex)
	{
	    return this.CommunitiesHash.GetByIndex(iIndex);
	};
	
	this.Count = function()
	{
	    return this.CommunitiesHash.Count();
	};
	
	this.Remove = function(oCommunity)
	{
		if(this.Contains(oCommunity.CTID))
		{
			var index = this.GetIndexByCommunity(oCommunity)
			this.CommunitiesHash.Remove(index,oCommunity.CTID);
		}	
	};
	
	this.GetIndexByCommunity = function(oCommunity)
	{
	    var iCommunity = null;
	    
	    for(var i=0;this.CommunitiesHash.Count();i++)
	    {
	        iCommunity = this.CommunitiesHash.GetByIndex(i);
	        if(iCommunity.CTID == oCommunity.CTID)
	        {
	            return i;
	        }
	    }
	    
	    return -1;
	};
	
	this.CommunityList = function()
	{
		return this.CommunitiesHash;
	};
	
	this.GetCommunityListFromArray = function(arrCommunity)
	{
		var arr = new EBArrayHashObject_CT2958529();
		var oCommunity = null;
		
		for(var i=0;i<arrCommunity.Count();i++)
		{
			oCommunity = arrCommunity.GetByIndex(i);
			if(oCommunity.isList)
			{
				arr.Add('CommunityList'+i,oCommunity.arrCommunity);
			}
		}
		return arr;
	};
	
	this.IsEmpty = function()
	{
	    return (this.CommunitiesHash.Count() == 0) ? true : false;
	};
	
	this._Contains = function(CTID,arrCommunity)
	{
		if(arrCommunity.Contains(CTID)) return true;
		else
		{
			
			var arrCommunityList = this.GetCommunityListFromArray(arrCommunity);
			for(var i=0;i<arrCommunityList.Count();i++)
			{
				if(this._Contains(CTID,arrCommunityList.GetByIndex(i)))
					return true;
			}
		}
		return false;
	};
	
	this.Contains = function(CTID)
	{
		if(this.CommunitiesHash.Count() == 0) return false;
		
		return this._Contains(CTID,this.CommunitiesHash);
	};
	
	this._GetByID = function(CTID,arrCommunity)
	{
		var oCommunity = arrCommunity.GetByID(CTID);
		if(oCommunity) return oCommunity;
		else
		{
			var arrCommunityList = this.GetCommunityListFromArray(arrCommunity);
			for(var i=0;i<arrCommunityList.Count();i++)
			{
				oCommunity = this._GetByID(CTID,arrCommunityList.GetByIndex(i));
				if(oCommunity)
					return oCommunity;
			}
			return null;
		}
		return null;
	};
	
	this.GetByID = function(CTID)
	{
		return this._GetByID(CTID,this.CommunitiesHash);
	};
	
	// startup point
	if(XMLNode && XMLNode.tagName == 'COMMUNITY') 
		this.Init(XMLNode);
	else if(XMLNode)
		this.InitList(XMLNode,strFullFilePath);
	
	this.FullFilePath   = strFullFilePath;
};

EBMCCommunityList_CT2958529.prototype = new EBMCCommunity_CT2958529;
var EBMCConsts_CT2958529 = 
{
    BaseGroupingServiceUrl: "http://grouping.services.conduit.com/",
    CommunityServiceServerUrl		        : 'CommunityRequest.ctp?type=GetCommunity&CommunityPage=',
	GroupServiceServerUrl			        : 'GroupingRequest.ctp?type=GetGroup&ctid=CTxxxx&lut=',
	CommunitiesCheckServerUrl		        : 'GroupingRequest.ctp?type=ToolbarsInfo',
	DownloadDomainsServerUrl                : 'Domains/DomainsManager.asmx/GetDomains?LastUpdateTime=',
	InvalidateCacheParam                    : '&ic=true',
	CommunitySearchUrl			            : 'http://search.conduit.com/?ctid=EB_TOOLBAR_ID&octid=EB_ORIGINAL_CTID&is=1&iss=1&q=',
	FolderName						        : 'communities',
	CommunitiesFileName				        : 'Communities.xml',
	GroupFileName					        : 'CommunitiesGroup.xml',
	RecentFileName					        : 'RecentCommunities.xml',
	DownloadDomainsFileName                 : 'DownloadDomains.xml',
	ExcludedDomainsFileName                 : 'ExcludedDomains.xml',
	CommunitiesXMLRootTag			        : '<COMMUNITIES/>',
	GroupNotModified				        : 'NOT_MODIFIED',
	Modified                                : 'MODIFIED',
	GroupingServerCheckInterval		        : 1440, //minutes
	GroupingServerOnErrorInterval	        : 720, //minutes
	DeletedGroupingBranch                   : 'DeletedGroupingToolbars',
	DownloadDomainsServerCheckInterval      : 168, //hours (7 days)
	DownloadDomainsErrorServerCheckInterval : 3, //hours (3 hours)
	ERROR_REPLY                             : 'ERROR_REPLY',
	UrlParameter_CTIDs                      : '&ctids=',
	CommunitiesStatusBranch                 : 'CommunitiesStatus',
	
	xmlTags :
	{
		CTID						: 'CTID',
		Name						: 'NAME',
		Description					: 'DESCRIPTION',
		Tags						: 'TAGS',
		InstallUrl					: 'INSTALLATION_URL',
		GroupingXMLRootTagName		: 'GROUPING',
		LastUpdateTime				: 'LAST_UPDATE_TIME',
		VisualLastUpdateTime        : 'VISUAL_LAST_UPDATE_TIME',
		AlertChannelId              : 'ALERT_CHANNEL_ID',
		Communities					: 'COMMUNITIES',
		DownloadDomains             : 'DOMAINS',
		DownloadDomain              : 'DOMAIN',
		ExcludedDomains             : 'EXCLUDED_DOMAINS',
	    Interval                    : 'INTERVAL_IN_HOURS',
	    Flags                       : 'FLAGS',
	    Community                   : 'COMMUNITY',
	    Locale: "LOCALE"
	},
	
	CommunityFileType :
	{
	    User        : 'user',
	    Grouping    : 'grouping',
	    Recent      : 'recent'
	}
};


var EBMCDetect_CT2958529 =
{

    ArrDomainsList: null,
    ArrExcludedDomainsList: null,
    strSuffix1: "/exe",
    strSuffix2: "/xpi",

    Init: function(arrDomainsList, arrExcludedDomainsList) {
        //update download domains
        if (arrDomainsList)
            this.ArrDomainsList = arrDomainsList;
        else
            this.ArrDomainsList = new Array("qatoolbar.com", "ourtoolbar.com", "communitytoolbars.com", "forumtoolbar.com",
						    "myblogtoolbar.com", "mycitytoolbar.com", "mycollegetoolbar.com", "myfamilytoolbar.com",
						    "myforumtoolbar.com", "mylibrarytoolbar.com", "myradiotoolbar.com", "mystoretoolbar.com",
						    "mytowntoolbar.com", "myuniversitytoolbar.com", "ourchurchtoolbar.com", "myxangatoolbar.com",
						    "media-toolbar.com", "loyaltytoolbar.com", "myteamtoolbar.com", "greattoolbars.com",
						    "ourorganizationtoolbar.com", "ourbusinesstoolbar.com");

        //update excluded domains						    
        if (arrExcludedDomainsList)
            this.ArrExcludedDomainsList = arrExcludedDomainsList;
        else
            this.ArrExcludedDomainsList = new Array("search.conduit.com", "search15.conduit.com", "search16.conduit.com",
	                                            "accounts.conduit.com", "translation.conduit.com")

    },

    UpdateDomainsList: function(arrDownloadDomainsList, arrExcludedDomainsList) {
        if (arrDownloadDomainsList)
            this.ArrDomainsList = arrDownloadDomainsList;

        if (arrExcludedDomainsList)
            this.ArrExcludedDomainsList = arrExcludedDomainsList;
    },

    IsExcludedDomain: function(strTLD) {
        if (!this.ArrDomainsList)
            this.Init(null, null)

        if (strTLD.toLowerCase() == "conduit" ||
		    strTLD.toLowerCase() == "google" ||
		    strTLD.toLowerCase() == "yahoo" ||
		    strTLD.toLowerCase() == "search" ||
		    strTLD.toLowerCase() == "msn"
          ) {
            return true;
        }

        for (var i = 0; i < this.ArrDomainsList.length; i++) {
            if (this.ArrDomainsList[i].indexOf(strTLD.toLowerCase()) != -1) {
                return true;
            }
        }

        return false;

    },

    IsDownloadLink: function(strHref) {
        if (!this.ArrDomainsList)
            this.Init(null, null)

        //patch for toolbar directory
        if (strHref == "http://www.ourtoolbar.com") return false;

        var strBaseUrl = EBUrl_CT2958529.GetBaseUrlWithoutProtocol(strHref);
        for (var i = 0; i < this.ArrDomainsList.length; i++) {
            if (strBaseUrl.toLowerCase().indexOf(this.ArrDomainsList[i]) != -1) {
                return true;
            }
        }
        return false;
    },

    IsExists: function(arr, elem) {
        for (var i = 0; i < arr.length; i++) {
            if (arr[i].url == elem) {
                return true;
            }
        }
        return false;
    },

    Detect: function(win) {
        var bIsExists = null;
        var arrFoundA = new Array();

        var arrMeta = win.document.getElementsByTagName("meta");

        // <meta> tag search
        var nameAttr = '';
        var contantAttr = '';
        var i;

        for (i = 0; i < arrMeta.length; i++) {
            nameAttr = arrMeta[i].getAttribute('name');
            if (nameAttr && nameAttr.toLowerCase() == 'toolbar') {
                contantAttr = arrMeta[i].getAttribute('content');
                if (contantAttr && this.IsDownloadLink(contantAttr)) {
                    contantAttr = this.ClearFoundUrl(contantAttr);
                    bIsExists = EBMCManager_CT2958529.IsCommunityExists(contantAttr);
                    if (bIsExists && EBMCManager_CT2958529.GetCTIDFromExistingCommunitiesByInstallUrl(contantAttr) != EBActionManager_CT2958529.GetCTID()
						||
						!bIsExists) {
                        arrFoundA.push(new EBMCFoundObject_CT2958529(contantAttr, bIsExists));
                    }
                }
            }
        }

        //if toolbar meta tags exist on page, don't check for links
        if (arrFoundA.length > 0) {
            return arrFoundA;
        }

        //check for links, in case of none meta tags
        var arrA = win.document.getElementsByTagName("a");
        if (arrA.length == 0 && arrMeta.length == 0) {
            return null;
        }


        var strHref = "";
        // <a> tag search
        for (i = 0; i < arrA.length; i++) {
            strHref = arrA[i].getAttribute("href");
            if (strHref && this.IsDownloadLink(strHref)) {
                strHref = this.ClearFoundUrl(strHref);
                if (!this.IsExists(arrFoundA, strHref)) {
                    bIsExists = EBMCManager_CT2958529.IsCommunityExists(strHref);
                    if (bIsExists && EBMCManager_CT2958529.GetCTIDFromExistingCommunitiesByInstallUrl(strHref) != EBActionManager_CT2958529.GetCTID()
						||
						!bIsExists) {
                        arrFoundA.push(new EBMCFoundObject_CT2958529(strHref, bIsExists));
                    }
                }
            }
        }

        if (arrFoundA.length == 0)
            arrFoundA = null;
        
        return arrFoundA;
    },

    IsFinalDownloadLink: function(strUrl) {
        if (strUrl.indexOf(this.strSuffix1) == strUrl.length - 4
			||
			strUrl.indexOf(this.strSuffix2) == strUrl.length - 4) {
            return true;
        }

        return false;
    },

    CheckUrl: function(strUrl) {
        var arrFound = new Array();
        if (this.IsDownloadLink(strUrl) && this.IsFinalDownloadLink(strUrl)) {
            strUrl = this.ClearFoundUrl(strUrl);
            arrFound.push(strUrl);
        }
        return arrFound;
    },

    ClearFoundUrl: function(strHref) {
        strHref = strHref.replace(/http:\/\//, '');
        var iIndex = strHref.indexOf("/");

        if (iIndex != -1)
            strHref = strHref.slice(0, iIndex);

        return EBGlobalManager_CT2958529.Trim(strHref);
    },

    IsDontCheckThisUrl: function(strUrl) {
        if (!this.ArrExcludedDomainsList)
            this.Init(null, null);

        var strDomain = EBUrl_CT2958529.GetBaseUrlWithoutProtocol(strUrl);

        for (var i = 0; i < this.ArrExcludedDomainsList.length; i++)
            if (strDomain.indexOf(this.ArrExcludedDomainsList[i]) != -1)
            return true;

        return false;
    }
}

function EBMCFoundObject_CT2958529(strUrl,bIsExists)
{
	this.url		= strUrl;
	this.IsExists	= bIsExists;
}
var EBMCDialog_CT2958529 =
{
    Consts:
	{
	    DialogFilename: 'multicommunity.xul',
	    DownloadDialogFilename: 'multicommunity_download.xul',
	    DetectedDialogFilename: 'multicommunity_detected.xul',
	    DialogName: 'EBMulticommunityDetectedDialogName',
	    DetectedDialogName: 'EBMulticommunityDetectedDialogNameDetected',
	    DialogType: 'EBMulticommunityDialog_CT2958529',
	    DialogIcon: 'chrome://browsersearch/skin/mc_community_dialog.png',
	    DialogIcon_over: 'chrome://browsersearch/skin/mc_community_dialog_over.png',
	    DownloadDialogName: 'EBMulticommunityDownloadDialogName',
	    Delete_AreYouSure: 'Are you sure you want to remove ',
	    BrowserWidth: 295,
	    BrowserHeight: 83,
	    BrowserID: 'MC_DETECTED_BROWSER_ID'
	},

    xulBrowser: null,
    DetectedSelectedIndex: 0,
    DetectedArrUrls: null,
    DetectedUrl: 'http://@EB_INSTALL_LINK@/Rank/Tooltip/?version=1',
    WindowCloseTimeout: null,
    WindowCloseTimeoutMillisec: 10000,
    DetectedDialogWidthDelta: 2,
    DetectedDialogHeightDelta: 51,
    DetectDialog: null,

    oDownBtn: null,
    oUpBtn: null,
    oDeleteBtn: null,
    oAcceptBtn: null,
    oCancelBtn: null,
    oListBox: null,

    dialogChanged: false,

    OpenDialog: function(objWindow) {
        //check if the dialog exsits to focus on it
        var oDialog = this.GetDialog();
        if (oDialog) {
            oDialog.focus();
        }
        else {
            var strChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + this.Consts.DialogFilename;

            objWindow.openDialog(strChromePath,
							this.Consts.DialogName,
							'modal,centerscreen,chrome,resizable=no');
        }
    },

    OpenDownloadDialog: function(strUrl) {
        var strChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + this.Consts.DownloadDialogFilename;
        window.openDialog(strChromePath,
							this.Consts.DownloadDialogName,
							'modal,centerscreen,chrome,resizable=no',
							strUrl);
        EBUsageMyConduit_CT2958529.PopupShown();
    },

    OpenDetectedDialog: function(strUrls, dialogScreenX, dialogScreenY, width, height) {
        EBMCButtonManager_CT2958529.IsTooltipShown = true;

        //check if another toolbar is already showed the detection dialog
        var arrToolbars = EBActionManager_CT2958529.GetEBToolbarsCTID();
        var thatButtonManager;
        for (var i = 0; i < arrToolbars.length; i++) {
            if (arrToolbars[i].originalCTID != EBGlobalConsts_CT2958529.ToolbarCTID) {
                thatButtonManager = window["EBMCButtonManager_" + arrToolbars[i].originalCTID];
                if (thatButtonManager && thatButtonManager.IsTooltipShown) {
                    EBMCButtonManager_CT2958529.IsTooltipShown = false;
                    return;
                }
            }
        }

        var dialogWidth = width + this.DetectedDialogWidthDelta;
        var dialogHeight = height + this.DetectedDialogHeightDelta;

        var strChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + this.Consts.DetectedDialogFilename;
        this.DetectDialog = window.openDialog(strChromePath,
	                                            this.Consts.DetectedDialogName,
	                                            'chrome,dependent,resizable=no,titlebar=yes,screenX=' + dialogScreenX + ',screenY=' + dialogScreenY + ',width=' + dialogWidth + ',height=' + 1,
	                                            strUrls, width, height);
    },

    GetDialog: function() {
        var strOptionsDialogType = this.Consts.DialogType;
        var strOptionsDialogName = this.Consts.DialogName;

        var oOptionsDialog = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName(strOptionsDialogType, strOptionsDialogName);

        return oOptionsDialog;
    },
    // +++++++ Detected Dialog start +++++++++++++++++++++++++++++++
    OnExternalClick: function(event) {
        if (EBMCDialog_CT2958529.DetectDialog) {
            EBMCDialog_CT2958529.DetectDialog.close();


            window.removeEventListener("click",
							        EBMCDialog_CT2958529.OnExternalClick,
							        false);
        }
    },

    Detected_OnLoad: function(event) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        document.getElementById('descriptionOnError').style.display = 'none';

        //translate
        EBMCLanguagePack_CT2958529.Detected_OnLoad(objWindow);

        var strTooltipUrl = (objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipUrl)) ? objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipUrl) : this.DetectedUrl;
        this.DetectedArrUrls = strURLs.split(' ');
        this.DetectedSelectedIndex = 0;

        if (this.DetectedArrUrls.length > 1)
            this.Detected_ShowArrows(event);
        else {
            this._DisableNextButton();
            this._DisablePrevButton();
        }
        var strUrl = strTooltipUrl.replace(/@EB_INSTALL_LINK@/, this.DetectedArrUrls[0]);
        var browserId = this.Consts.BrowserID;

        //create and add browser
        this.xulBrowser = EBXULFactory_CT2958529.CreateBrowser(browserId, strUrl, browserWidth, browserHeight);
        var mainBox = document.getElementById('mainBrowserBox');
        mainBox.appendChild(this.xulBrowser);

        //init progress listener and observers
        this._setListeners();

        this._UpdateImagePositions();
        this.SlideWindow(2);
    },

    _setListeners: function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        EBGadgetDialog_CT2958529.popHtmlData = { "componentId": "",
            "elementId": "",
            "compType": "",
            "apiPermissions": {}
        };
        this._gadgetProgressListener = new EBGadgetProgressListener_CT2958529();
        this._gadgetProgressListener.init(this.xulBrowser,
                                            true,
                                            browserWidth,
                                            browserHeight,
                                            oWindow.oToolbarManager_CT2958529.data.componentsIds.MultiCommunity,
                                            oWindow.oToolbarManager_CT2958529.data.componentsIds.MultiCommunity);

        this._gadgetProgressListener.initGadgetData("", "", EBMCDialog_CT2958529.Detected_OnDocumentComplete, null, this);
    },

    SlideWindow: function(height) {
        var iHeight = parseInt(height);
        var newHeight = iHeight + 10;
        if (iHeight >= browserHeight + EBMCDialog_CT2958529.DetectedDialogHeightDelta) {
            window.resizeTo(browserWidth + EBMCDialog_CT2958529.DetectedDialogWidthDelta, browserHeight + EBMCDialog_CT2958529.DetectedDialogHeightDelta);
        }
        else {
            window.resizeTo(browserWidth + EBMCDialog_CT2958529.DetectedDialogWidthDelta, iHeight);
            setTimeout(function() { EBMCDialog_CT2958529.SlideWindow(newHeight); }, 25);
        }
    },

    Detected_OnUnLoad: function(event) {
        var isChecked = document.getElementById('chkDontShowAgain').checked;

        //unload browser manager
        if (this._gadgetProgressListener)
            this._gadgetProgressListener.unload();

        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipShow, !isChecked);
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        objWindow.EBMCButtonManager_CT2958529.IsTooltipShown = false;

        //firefox bug is when you close one xul window, the others are moved
        //to back in z-order, so we focus() on the last focused PopHtmlWindow
        //and it gets all such window to front. (only on window platform)
        if (EBGlobalManager_CT2958529.IsWindowsPlatform())
            objWindow.setTimeout(function() { objWindow.EBGadgetManager_CT2958529.BringToFront(); }, 1);

        objWindow.EBMCDialog_CT2958529.DetectDialog = null;
    },

    Detected_OnBlur: function(event) {

    },

    Detected_OnLearnMoreClick: function() {
        var strUrl = EBMCDialog_CT2958529.DetectedArrUrls[EBMCDialog_CT2958529.DetectedSelectedIndex];
        EBActionManager_CT2958529.OpenLearnMore("TAB", strUrl);
    },

    Detected_OnClick: function(event) {
        if (this.WindowCloseTimeout)
            clearTimeout(this.WindowCloseTimeout);
    },

    Detected_OnDocumentComplete: function(bIsSuccess) {
        if (!bIsSuccess)
            this.Detected_OnErrorDocument();
    },

    Detected_OnErrorDocument: function() {
        var imgAddTo = document.getElementById('imgAddTo');
        var oDescriptionOnError = document.getElementById('descriptionOnError');

        this.xulBrowser.style.display = 'none';
        oDescriptionOnError.style.display = '';
        var descHeight = browserHeight - 8;
        var descWidth = browserWidth;
        oDescriptionOnError.width = descWidth;
        oDescriptionOnError.height = descHeight;
        this._DisableAddTo(imgAddTo);
    },

    Detected_ShowArrows: function() {
        this._DisablePrevButton();
    },

    _UpdateImagePositions: function() {
        var imgPrev = document.getElementById('imgPrev');
        var imgNext = document.getElementById('imgNext');
        var imgClose = document.getElementById('imgClose');
        var imgAddTo = document.getElementById('imgAddTo');
        imgPrev.setAttribute('left', parseInt(browserWidth) / 2 - 21)
        imgNext.setAttribute('left', parseInt(browserWidth) / 2 + 11)
        imgClose.setAttribute('left', parseInt(browserWidth) - 14)
        imgAddTo.setAttribute('left', parseInt(browserWidth) - 100)
    },

    _DisableAddTo: function(objImage) {
        objImage.src = 'chrome://browsersearch/skin/mc_tooltip_addTo_over.gif';
        objImage.onmouseover = null;
        objImage.onmouseout = null;
        objImage.onmouseup = null;
        objImage.onmousedown = null;
        objImage.setAttribute('onclick', '');
        objImage.onclick = null;
    },

    _DisableNextButton: function() {
        var objImage = document.getElementById('imgNext');
        objImage.src = 'chrome://browsersearch/skin/mc_tooltip_next_dis.gif';
        objImage.onmouseover = null;
        objImage.onmouseout = null;
        objImage.onmouseup = null;
        objImage.onmousedown = null;
        objImage.setAttribute('onclick', '');
        objImage.onclick = null;
    },

    _EnableNextButton: function() {
        var objImage = document.getElementById('imgNext');
        objImage.src = 'chrome://browsersearch/skin/mc_tooltip_next.gif';
        objImage.setAttribute('onclick', 'EBMCDialog_CT2958529.Detected_OnNextClick(event);');
        objImage.onmousedown = function() { this.src = 'chrome://browsersearch/skin/mc_tooltip_next_dn.gif'; };
        objImage.onmouseup = function() { this.src = 'chrome://browsersearch/skin/mc_tooltip_next.gif'; };
        objImage.onmouseover = function() { this.src = 'chrome://browsersearch/skin/mc_tooltip_next_over.gif'; };
        objImage.onmouseout = function() { this.src = 'chrome://browsersearch/skin/mc_tooltip_next.gif'; };
    },

    _DisablePrevButton: function() {
        var objImage = document.getElementById('imgPrev');
        objImage.src = 'chrome://browsersearch/skin/mc_tooltip_prev_dis.gif';
        objImage.onmouseover = null;
        objImage.onmouseout = null;
        objImage.onmouseup = null;
        objImage.onmousedown = null;
        objImage.setAttribute('onclick', '');
        objImage.onclick = null;
    },

    _EnablePrevButton: function() {
        var objImage = document.getElementById('imgPrev');
        objImage.src = 'chrome://browsersearch/skin/mc_tooltip_prev.gif';
        objImage.setAttribute('onclick', 'EBMCDialog_CT2958529.Detected_OnPrevClick(event);');
        objImage.onmousedown = function() { this.src = 'chrome://browsersearch/skin/mc_tooltip_prev_dn.gif'; };
        objImage.onmouseup = function() { this.src = 'chrome://browsersearch/skin/mc_tooltip_prev.gif'; };
        objImage.onmouseover = function() { this.src = 'chrome://browsersearch/skin/mc_tooltip_prev_over.gif'; };
        objImage.onmouseout = function() { this.src = 'chrome://browsersearch/skin/mc_tooltip_prev.gif'; };
    },

    Detected_OnPrevClick: function(event) {
        this.CheckIfBrowserVisible();
        //disable window close on user action;
        if (EBMCDialog_CT2958529.WindowCloseTimeout)
            clearTimeout(EBMCDialog_CT2958529.WindowCloseTimeout);

        var oPrev = event.target;
        var oNext = document.getElementById('imgNext');

        //if next button is disabled, enable it
        if (EBMCDialog_CT2958529.DetectedSelectedIndex == EBMCDialog_CT2958529.DetectedArrUrls.length - 1) {
            EBMCDialog_CT2958529._EnableNextButton();
        }

        EBMCDialog_CT2958529.DetectedSelectedIndex--;

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var strTooltipUrl = (objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipUrl)) ? objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipUrl) : this.DetectedUrl;
        var strUrl = strTooltipUrl.replace(/@EB_INSTALL_LINK@/, EBMCDialog_CT2958529.DetectedArrUrls[EBMCDialog_CT2958529.DetectedSelectedIndex]);
        EBMCDialog_CT2958529.xulBrowser.setAttribute('src', strUrl);

        if (EBMCDialog_CT2958529.DetectedSelectedIndex == 0) {
            EBMCDialog_CT2958529._DisablePrevButton();
        }
    },

    Detected_OnNextClick: function(event) {
        this.CheckIfBrowserVisible();
        //disable window close on user action;
        if (EBMCDialog_CT2958529.WindowCloseTimeout)
            clearTimeout(EBMCDialog_CT2958529.WindowCloseTimeout);

        var oNext = event.target;
        var oPrev = document.getElementById('imgPrev');

        //if prev button is disabled, enable it
        if (EBMCDialog_CT2958529.DetectedSelectedIndex == 0) {
            EBMCDialog_CT2958529._EnablePrevButton();
        }

        EBMCDialog_CT2958529.DetectedSelectedIndex++;

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var strTooltipUrl = (objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipUrl)) ? objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipUrl) : this.DetectedUrl;
        var strUrl = strTooltipUrl.replace(/@EB_INSTALL_LINK@/, EBMCDialog_CT2958529.DetectedArrUrls[EBMCDialog_CT2958529.DetectedSelectedIndex]);
        EBMCDialog_CT2958529.xulBrowser.setAttribute('src', strUrl);

        if (EBMCDialog_CT2958529.DetectedSelectedIndex == EBMCDialog_CT2958529.DetectedArrUrls.length - 1) {
            EBMCDialog_CT2958529._DisableNextButton();
        }
    },

    CheckIfBrowserVisible: function() {
        var oDescriptionOnError = document.getElementById('descriptionOnError');
        if (this.xulBrowser.style.display == 'none') {
            this.xulBrowser.style.display = '';
            oDescriptionOnError.style.display = 'none'
        }
    },

    Detected_AddToOnClick: function(event) {
        window.close();
        var strUrl = EBMCDialog_CT2958529.DetectedArrUrls[EBMCDialog_CT2958529.DetectedSelectedIndex];
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        if (objWindow.EBMCManager_CT2958529.IsCommunityExists(strUrl)) {
            //switch only
            var oCommunity = objWindow.EBMCManager_CT2958529.GetCommunityFromExistingCommunitiesByInstallUrl(strUrl);

            var oTimeout = function() {
                objWindow.EBMCManager_CT2958529.ChangeToCommunity(oCommunity.CTID, oCommunity.Name, true, null, objWindow.EBUsageMyConduit_CT2958529.SourceTooltip, false);
            };
            objWindow.setTimeout(oTimeout, 100);
        }
        else {
            //add community and switch
            objWindow.EBMCTrusteDialog_CT2958529.open(strUrl, EBUsageMyConduit_CT2958529.SourceTooltip);
        }
    },

    // +++++++ Detected Dialog end +++++++++++++++++++++++++++++++

    // +++++++ Download Dialog start +++++++++++++++++++++++++++++++
    Download_OnLoad: function() {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var dialogsDirection = objWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "ebMulticommunityDownloadDialog");

        var iMode = 0;
        var strCommunityName = '';
        var lnkLearnMore = document.getElementById('lnkLearnMore');

        //There are 3 modes to the dialog
        //Regular(0) : Add to, Install
        //(1)        : Switch to, Reinstall
        //(2)        : Switch to, Install
        if (objWindow.EBMCManager_CT2958529.IsCommunityExists(strURL)) {
            if (objWindow.EBMCManager_CT2958529.IsDownloadUrlIsOriginalCommunity(strURL)) {
                iMode = 1;
                strCommunityName = " " + objWindow.EBActionManager_CT2958529.GetToolbarName();
            }
            else {
                iMode = 2;
                strCommunityName = " " + objWindow.EBMCManager_CT2958529.GetCommunityNameFromInstallationUrl(strURL);
            }

            lnkLearnMore.style.display = 'none';
        }
        else
            lnkLearnMore.style.display = '';

        EBMCLanguagePack_CT2958529.DownloadDialog_OnLoad(objWindow, iMode, strCommunityName);
    },

    Download_OnDialogAccept: function() {
        var oRadio = document.getElementById("radio_add");
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        if (oRadio.selected) {
            if (objWindow.EBMCManager_CT2958529.IsCommunityExists(strURL)) {
                var oCommunity = objWindow.EBMCManager_CT2958529.GetCommunityFromExistingCommunitiesByInstallUrl(strURL);

                var oTimeout = function() {
                    objWindow.EBMCManager_CT2958529.ChangeToCommunity(oCommunity.CTID, oCommunity.Name, false, null, objWindow.EBUsageMyConduit_CT2958529.SourceMessageBox, false);
                };
                objWindow.setTimeout(oTimeout, 100);
            }
            else
                objWindow.EBMCTrusteDialog_CT2958529.open(strURL, EBUsageMyConduit_CT2958529.SourceMessageBox);

            objWindow.EBMCManager_CT2958529.NavigationStop();
        }

        objWindow.setTimeout(function() { objWindow.ToolbarDetected = false; }, 500);
    },

    Download_OnDialogCancel: function() {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        objWindow.EBMCManager_CT2958529.NavigationStop();
    },

    Download_OnLearnMoreClick: function() {
        EBActionManager_CT2958529.OpenLearnMore("BLANK", strURL);
    },

    // +++++++ Download Dialog end +++++++++++++++++++++++++++++++++


    // +++++++ Manage toolbars dialog ++++++++++++++++++++++++++++++

    StatusHash: null,
    ShowHideTexts: '',

    OnLoad: function() {
        this.StatusHash = new EBArrayHashObject_CT2958529();

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var dialogsDirection = objWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "ebMulticommunityDialog");

        //this.oDownBtn	    = document.getElementById("btnMoveDown");
        //this.oUpBtn	    = document.getElementById("btnMoveUp");
        this.oDeleteBtn = document.getElementById("btnDelete");
        this.oHideBtn = document.getElementById("btnHide");
        this.oAcceptBtn = document.getElementById("ebMulticommunityDialog").getButton("accept");
        this.oCancelBtn = document.getElementById("ebMulticommunityDialog").getButton("cancel");
        this.oListBox = document.getElementById("listCommunities");
        this.oDescription = document.getElementById("dscTitle");

        this.ShowHideTexts = EBMCLanguagePack_CT2958529.Dialog_OnLoad(objWindow, this);

        var objCommunities = objWindow.EBMCManager_CT2958529.AllCommunities;
        objCommunities.InitForDialog();

        var max = 0;
        var listItem = null;
        var oCommunity = null;

        if (objCommunities.GroupingDialog && !objCommunities.GroupingDialog.IsEmpty()) {
            max = this.CreateListItems(objCommunities.GroupingDialog, true, max);
        }

        if (objCommunities.UserDialog && !objCommunities.UserDialog.IsEmpty()) {
            max = this.CreateListItems(objCommunities.UserDialog, false, max);
        }

        //resize the listbox according to the biggest item.
        if (max != 0) {
            max += 40;
            strSize = max + 'px';
            this.oListBox.width = strSize;
        }
    },

    CreateListItems: function(oCommunities, bIsGrouping, iMax) {
        var strSize = '';
        var iSize = 0;
        var max = iMax;

        for (var i = 0; i < oCommunities.Count(); i++) {
            oCommunity = oCommunities.GetByIndex(i);
            listItem = oCommunity.toListItem(bIsGrouping, document);
            this.oListBox.appendChild(listItem);

            strSize = document.defaultView.getComputedStyle(listItem, null).getPropertyValue("width");
            strSize = strSize.replace(/px/, "");
            iSize = parseInt(strSize);

            if (!isNaN(iSize) && iSize > max) {
                max = iSize;
            }
        }

        return max;
    },

    // ---- List Items Functions -------------------------------------------

    //check / uncheck
    ListItem_OnClickCheckBox: function(e) {
        var obj = e.target;
        var bIsChecked = EBGlobalManager_CT2958529.GetBooleanAttribute(obj, 'checked', false);
        bIsChecked = !bIsChecked;
        var strCTID = obj.parentNode.getAttribute('id');
        this.CheckUncheckItem(obj, strCTID, bIsChecked);
        this.DialogChanged();
    },

    ListItem_MouseOver: function(obj) {
        obj.setAttribute('image', this.Consts.DialogIcon_over)
    },

    ListItem_MouseOut: function(obj) {
        obj.setAttribute('image', this.Consts.DialogIcon)
    },

    ListCommunities_OnSelect: function(event) {
        this.oDeleteBtn.disabled = false;
        this.oHideBtn.disabled = false;

        var oSelected = this.oListBox.selectedItem;

        var bIsChecked = EBGlobalManager_CT2958529.GetBooleanAttribute(oSelected.firstChild, 'checked', false);

        if (bIsChecked) {
            this.oHideBtn.setAttribute('label', this.ShowHideTexts.hide);
        }
        else {
            this.oHideBtn.setAttribute('label', this.ShowHideTexts.show);
        }


        //		if(iSelectedIndex == 0)
        //		{
        //			this.DisableUpBtn();
        //		}
        //		else
        //		{
        //			this.EnableUpBtn();
        //		}
        //		if(iSelectedIndex == this.oListBox.childNodes.length - 2)
        //		{
        //			this.DisableDownBtn()
        //		}
        //		else
        //		{
        //			this.EnableDownBtn();
        //		}

    },

    //	DisableUpBtn : function()
    //	{
    //		this.oUpBtn.disabled = true;
    //	},
    //	
    //	DisableDownBtn : function()
    //	{
    //		this.oDownBtn.disabled = true;
    //	},
    //	
    //	EnableUpBtn : function()
    //	{
    //		this.oUpBtn.disabled = false;
    //	},
    //	
    //	EnableDownBtn : function()
    //	{
    //		this.oDownBtn.disabled = false;
    //	},

    //-------------------------------

    DialogChanged: function() {
        if (!this.dialogChanged) {
            this.dialogChanged = true;
            this.oAcceptBtn.disabled = false;
        }
    },

    CheckUncheckItem: function(obj, strCTID, bIsChecked) {
        obj.setAttribute('checked', bIsChecked);
        var objStatus = this.StatusHash.GetByID(strCTID);
        //update
        if (objStatus) {
            objStatus.Status = (bIsChecked) ? 0 : 1;
        }
        //add new
        else {
            objStatus = new Object();
            objStatus.Status = (bIsChecked) ? 0 : 1;
            this.StatusHash.Add(strCTID, objStatus);
        }

        if (bIsChecked) {
            EBMCDialog_CT2958529.oHideBtn.setAttribute('label', this.ShowHideTexts.hide);
        }
        else {
            EBMCDialog_CT2958529.oHideBtn.setAttribute('label', this.ShowHideTexts.show);
        }

        this.DialogChanged();
    },

    OnHideButtonClicked: function() {
        var oSelected = this.oListBox.selectedItem;
        var bIsChecked = EBGlobalManager_CT2958529.GetBooleanAttribute(oSelected.firstChild, 'checked', false);

        bIsChecked = !bIsChecked;
        this.CheckUncheckItem(oSelected.firstChild, oSelected.getAttribute('id'), bIsChecked);

        this.DialogChanged();
    },

    OnDeleteButtonClicked: function() {
        var strName = "";
        var oSelectedItem = this.oListBox.selectedItem;
        try {
            strName = oSelectedItem.childNodes[1].getAttribute("label");
        }
        catch (ex) { }

        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var locale = oWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);
        var strTitle = oWindow.oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MULTI_COMMUNITY_DELETE_WARNING_DLG_CAPTION", locale);
        var strText = oWindow.oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MULTI_COMMUNITY_DELETE_WARNING_DLG_TEXT", locale);
        strText = strText.replace(/\[TOOLBAR NAME\]/, strName);
        if (!EBGlobalManager_CT2958529.Confirm(window, strTitle, strText)) return;

        var iSelectedIndex = this.oListBox.selectedIndex;
        var strCTID = oSelectedItem.getAttribute('id');
        var objStatus = new Object();
        objStatus.Status = 2;

        this.StatusHash.Add(strCTID, objStatus);

        this.oListBox.removeItemAt(iSelectedIndex);

        if (iSelectedIndex == this.oListBox.childNodes.length - 1) {
            iSelectedIndex--;
        }

        if (iSelectedIndex != -1) {
            var oItem = this.oListBox.getItemAtIndex(iSelectedIndex);
            if (oItem) {
                this.oListBox.selectItem(oItem);
            }
        }

        this.DialogChanged();
    },


    //	OnMoveUpButtonClicked : function()
    //	{
    //		var oSelectedItem = this.oListBox.selectedItem;
    //		var oUpper = this.oListBox.childNodes[this.oListBox.selectedIndex];
    //		this.oListBox.insertBefore(oSelectedItem,oUpper);
    //		this.AfterMoveProcedures(oSelectedItem);
    //	},
    //	
    //	OnMoveDownButtonClicked : function()
    //	{
    //		var oSelectedItem = this.oListBox.selectedItem;
    //		var oLower = this.oListBox.childNodes[this.oListBox.selectedIndex+2];
    //		this.oListBox.insertBefore(oLower,oSelectedItem);
    //		this.AfterMoveProcedures(oSelectedItem);
    //	},
    //	
    //	AfterMoveProcedures : function(oSelectedItem)
    //	{
    //		this.oListBox.selectItem(oSelectedItem);
    //		this.oListBox.ensureElementIsVisible(oSelectedItem);
    //		this.ListCommunities_OnSelect();
    //		this.DialogChanged();
    //	},


    // ---- List Items Functions End -------------------------------------------


    UpdateGroupingChanges: function() {
        if (this.DeletedGroupingArray.length > 0) {
            for (var i = 0; i < this.DeletedGroupingArray.length; i++) {
                EBMCIO_CT2958529.SetGroupingDeleted(this.DeletedGroupingArray[i]);
            }
        }
    },

    //Returns object with changes
    SyncCommunitiesStatus: function(oCommunities, bIsDelete, oReturn) {
        var oCommunity = null;
        var objStatus = null;

        for (var strCTID in this.StatusHash.HashArray) {
            objStatus = this.StatusHash.GetByID(strCTID);
            if (objStatus) {
                oCommunity = oCommunities.GetByID(strCTID);
                if (oCommunity) {
                    oCommunity.SetStatus(objStatus.Status)

                    switch (objStatus.Status) {
                        case 0: if (oReturn) oReturn.ShownCTIDs.push(oCommunity.CTID); break;
                        case 1: if (oReturn) oReturn.HiddenCTIDs.push(oCommunity.CTID); break;
                        case 2: if (oReturn) oReturn.DeletedCTIDs.push(oCommunity.CTID);
                            if (bIsDelete) oCommunities.Remove(oCommunity); break;
                    }
                }
            }
        }

        return oReturn;
    },

    OnDialogAccept: function() {
        var iStatus = 0;
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var objCommunities = objWindow.EBMCManager_CT2958529.AllCommunities;

        var oReturn = new Object();
        oReturn.HiddenCTIDs = new Array();
        oReturn.DeletedCTIDs = new Array();
        oReturn.ShownCTIDs = new Array();

        if (objCommunities.UserCommunities && !objCommunities.UserCommunities.IsEmpty()) {
            this.SyncCommunitiesStatus(objCommunities.UserCommunities, true, oReturn);
            objCommunities.UserCommunities.SaveToFile();
        }

        if (objCommunities.GroupingCommunities && !objCommunities.GroupingCommunities.IsEmpty())
            this.SyncCommunitiesStatus(objCommunities.GroupingCommunities, false, oReturn);

        if (objCommunities.RecentCommunities && !objCommunities.RecentCommunities.IsEmpty()) {
            this.SyncCommunitiesStatus(objCommunities.RecentCommunities, true, null);
            objCommunities.RecentCommunities.SaveToFile();
        }

        objCommunities.Init();

        EBMCManager_CT2958529.BroadcastChanges(objCommunities);

        objWindow.EBUsageMyConduit_CT2958529.OpenEditdialog(objWindow.EBMCManager_CT2958529.AllCommunities.Count(),
		                                            objWindow.EBUsageMyConduit_CT2958529.ExitCodeOK,
		                                            oReturn.DeletedCTIDs,
		                                            oReturn.HiddenCTIDs,
		                                            oReturn.ShownCTIDs);
    },

    OnDialogCancel: function() {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        objWindow.EBUsageMyConduit_CT2958529.OpenEditdialog(objWindow.EBMCManager_CT2958529.AllCommunities.Count(),
		                                            objWindow.EBUsageMyConduit_CT2958529.ExitCodeCancel,
		                                            null,
		                                            null,
		                                            null);
    }
}
var EBMCIO_CT2958529 =
{
    InitGrouping: function(bIsEmpty) {
        EBMCServerComm_CT2958529.InitGrouping(bIsEmpty);
    },

    AddCommunityToFile: function(objCommunity) {
        //add to user file
        var oCommunities = this.LoadCommunities('user');
        oCommunities.AddFirst(objCommunity);
        oCommunities.SaveToFile();

        //add also to recent
        oCommunities = this.LoadCommunities('recent');
        oCommunities.Add(objCommunity);
        oCommunities.SaveToFile();
    },

    LoadCommunities: function(strWhich) {
        var strFullPath = EBMCConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep;

        if (strWhich == EBMCConsts_CT2958529.CommunityFileType.User)
            strFullPath += EBMCConsts_CT2958529.CommunitiesFileName;
        else if (strWhich == EBMCConsts_CT2958529.CommunityFileType.Grouping)
            strFullPath += EBMCConsts_CT2958529.GroupFileName;
        else if (strWhich == EBMCConsts_CT2958529.CommunityFileType.Recent)
            strFullPath += EBMCConsts_CT2958529.RecentFileName

        var oFile = EBIOManager_CT2958529.CreateToolbarFile(strFullPath);
        var strXMLFile = EBFileIO_CT2958529.read(oFile, EBGlobalConsts_CT2958529.DefaultCharset);

        var xmlCommunities = null;
        var objCommunities = null;

        if (strXMLFile) {
            xmlCommunities = EBXML_CT2958529.GetXmlDocument(strXMLFile);
            xmlCommunities = xmlCommunities.documentElement;
        }

        if (strWhich == EBMCConsts_CT2958529.CommunityFileType.Recent)
            objCommunities = new EBRecentCommunityList_CT2958529(xmlCommunities, strFullPath);
        else
            objCommunities = new EBMCCommunityList_CT2958529(xmlCommunities, strFullPath);

        return objCommunities;
    },

    RemoveDeletedGroupingCommunities: function(xmlCommunities) {
        var strCTID = '';
        var strPrefName = '';
        var bIsDeleted = false;
        for (var i = xmlCommunities.childNodes.length - 1; i >= 0; i--) {
            strCTID = this.GetCTIDFromCommunityXML(xmlCommunities.childNodes[i]);
            strPrefName = EBMCConsts_CT2958529.DeletedGroupingBranch + '.' + strCTID;
            bIsDeleted = EBToolbarPreferenceManager_CT2958529.GetPref(strPrefName);
            if (bIsDeleted) {
                xmlCommunities.removeChild(xmlCommunities.childNodes[i]);
            }
        }
    },

    ChangeToCommunity: function(strUrl, strSource) {
        EBMCServerComm_CT2958529.GetCommunityInfoFromServer(strUrl, strSource);
    },

    GetNodeByCTID: function(xmlDoc, ctid) {
        var currCTID = "";
        var xmlCommunity = null;
        var xmlNode = null;

        for (var i = 0; i < xmlDoc.childNodes.length; i++) {
            xmlCommunity = xmlDoc.childNodes[i];
            for (var j = 0; xmlCommunity.childNodes.length; j++) {
                xmlNode = xmlCommunity.childNodes[j];
                if (xmlNode.tagName == EBMCConsts_CT2958529.xmlTags.CTID) {
                    currCTID = EBXML_CT2958529.GetXmlNodeValue(xmlNode);
                    if (currCTID == ctid) {
                        return xmlCommunity;
                    }
                    else {
                        break;
                    }
                }
            }
        }
        return null;
    },

    GetValueFromCommunityXmlByTagName: function(xmlDoc, tagName) {
        for (var i = 0; i < xmlDoc.childNodes.length; i++) {
            if (xmlDoc.childNodes[i].tagName == tagName) {
                return EBXML_CT2958529.GetXmlNodeValue(xmlDoc.childNodes[i]);
            }
        }
    },

    GetCTIDFromCommunityXML: function(xmlDoc) {
        return this.GetValueFromCommunityXmlByTagName(xmlDoc, EBMCConsts_CT2958529.xmlTags.CTID);
    },

    GetNameFromCommunityXML: function(xmlDoc) {
        return this.GetValueFromCommunityXmlByTagName(xmlDoc, EBMCConsts_CT2958529.xmlTags.Name);
    },

    GetInstallUrlFromCommunityXML: function(xmlDoc) {
        return this.GetValueFromCommunityXmlByTagName(xmlDoc, EBMCConsts_CT2958529.xmlTags.InstallUrl);
    },

    GetObjectFromCommunityXML: function(xmlDoc) {
        var obj = new Object();
        obj.ctid = "";
        obj.name = "";
        obj.InstallUrl = "";
        obj.description = "";
        obj.tags = "";

        for (var i = 0; i < xmlDoc.childNodes.length; i++) {
            if (xmlDoc.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.CTID)
                obj.ctid = EBXML_CT2958529.GetXmlNodeValue(xmlDoc.childNodes[i]);
            else if (xmlDoc.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.Name)
                obj.name = EBXML_CT2958529.GetXmlNodeValue(xmlDoc.childNodes[i]);
            else if (xmlDoc.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.InstallUrl)
                obj.installUrl = EBXML_CT2958529.GetXmlNodeValue(xmlDoc.childNodes[i]);
            else if (xmlDoc.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.Tags)
                obj.tags = EBXML_CT2958529.GetXmlNodeValue(xmlDoc.childNodes[i]);
            else if (xmlDoc.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.Description)
                obj.description = EBXML_CT2958529.GetXmlNodeValue(xmlDoc.childNodes[i]);
        }
        return obj;
    },

    SetGroupingDeleted: function(strCTID) {
        var strPrefName = EBMCConsts_CT2958529.DeletedGroupingBranch + '.' + strCTID;
        EBToolbarPreferenceManager_CT2958529.SetPref(strPrefName, true);
    },

    //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //get grouping functions for current toolbar

    InitCurrentGrouping: function() {
        EBMCServerComm_CT2958529.InitCurrentGrouping();
    },

    SaveDomainsToFile: function(xmlDomains, strFileName) {
        var strXml = EBXML_CT2958529.GetStringXml(xmlDomains);
        var strFile = EBMCConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + strFileName;
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(strFile);
        EBFileIO_CT2958529.write(oFile, strXml, '', EBGlobalConsts_CT2958529.DefaultCharset);
    },

    SaveDownloadDomainsToFile: function(xmlDownloadDomains) {
        this.SaveDomainsToFile(xmlDownloadDomains, EBMCConsts_CT2958529.DownloadDomainsFileName);
    },

    SaveExcludedDomainsToFile: function(xmlExludedDomains) {
        this.SaveDomainsToFile(xmlExludedDomains, EBMCConsts_CT2958529.ExcludedDomainsFileName);
    },

    LoadDomainsFromFile: function(strFileName) {
        var strFile = EBMCConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + strFileName;
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(strFile);
        var strXmlDomains = EBFileIO_CT2958529.read(oFile, EBGlobalConsts_CT2958529.DefaultCharset);

        var xmlDomains = null;
        if (strXmlDomains) {
            xmlDomains = EBXML_CT2958529.GetXmlDocument(strXmlDomains);
            xmlDomains = xmlDomains.documentElement;
        }
        else {
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.DownloadDomainsListLastCheckTime, '');
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.DownloadDomainsListLastServerUpdateTime, null);
        }
        return xmlDomains;
    },

    GetDomainArrayFromXml: function(xmlDomains) {
        if (!xmlDomains)
            return null;

        var xmlNode = null;
        var strDomain;
        var arrDownloadDomains = new Array();

        for (var i = 0; i < xmlDomains.childNodes.length; i++) {
            xmlNode = xmlDomains.childNodes[i];
            strDomain = EBXML_CT2958529.GetXmlNodeValue(xmlNode);
            if (strDomain)
                arrDownloadDomains.push(strDomain.toLowerCase());
        }

        return arrDownloadDomains;
    },

    LoadDownloadDomainsAsArray: function() {
        var xmlDomains = this.LoadDomainsFromFile(EBMCConsts_CT2958529.DownloadDomainsFileName);
        return this.GetDomainArrayFromXml(xmlDomains);
    },

    LoadExcludedDomainsAsArray: function() {
        var xmlDomains = this.LoadDomainsFromFile(EBMCConsts_CT2958529.ExcludedDomainsFileName);
        return this.GetDomainArrayFromXml(xmlDomains);
    },

    //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    // Download domains functions END

    NullifyTimesGrouping: function() {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckTime, "0", true);
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastServerUpdateTime, "0", true);
    },

    InvalidateCacheGrouping: function(bInvalidateCache) {
        var bValue = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingInvalidateCache, true);

        if (typeof bInvalidateCache != "undefined")
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingInvalidateCache, bInvalidateCache, true);

        return bValue;
    },

    NullifyTimesCommunitiesChanges: function() {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CommunitiesChangesLastCheckTime, "0");
    }
}
var EBMCManager_CT2958529 =
{
    UserCommunities: null,
    GroupingCommunities: null,
    RecentCommunities: null,
    AllCommunities: null,
    arrDetectedDomains: null,
    IsActive: false,
    MaxRecent: 10,

    Exception_CommunityNotExists: 'Exception_CommunityNotExists',

    Consts:
	{
	    State: null
	},

    OnLoad: function() {
        this.arrDetectedDomains = new EBArrayHashObject_CT2958529;

        //initialize detect manager, fill it with known domains
        if (!EBActionManager_CT2958529.IsToolbarGrouping()
			||
			EBActionManager_CT2958529.IsToolbarMC()) {
            var arrDownloadDomains = EBMCIO_CT2958529.LoadDownloadDomainsAsArray();
            var arrExcludedDomains = EBMCIO_CT2958529.LoadExcludedDomainsAsArray();

            EBMCDetect_CT2958529.Init(arrDownloadDomains, arrExcludedDomains);
            EBMCServerComm_CT2958529.InitMC();
        }

        this.RecentCommunities = EBMCIO_CT2958529.LoadCommunities(EBMCConsts_CT2958529.CommunityFileType.Recent);

        if (EBActionManager_CT2958529.IsToolbarMC())
            this.UserCommunities = EBMCIO_CT2958529.LoadCommunities(EBMCConsts_CT2958529.CommunityFileType.User);

        if (EBActionManager_CT2958529.IsToolbarGrouping()) {
            this.GroupingCommunities = EBMCIO_CT2958529.LoadCommunities(EBMCConsts_CT2958529.CommunityFileType.Grouping);
            EBMCIO_CT2958529.InitGrouping(this.GroupingCommunities.IsEmpty());
        }

        //get grouping info for currently selected toolbar
        EBMCIO_CT2958529.InitCurrentGrouping();

        this.AllCommunities = new EBCommunitiesList_CT2958529(this.UserCommunities,
		                                                        this.GroupingCommunities,
		                                                        this.RecentCommunities);

        EBMCMenu_CT2958529.OnLoad(this.AllCommunities);

        //star
        EBMCServerComm_CT2958529.GetCommunitiesChangesInfoFromServer();
    },

    GetCount: function() {
        return this.AllCommunities.Count();
    },

    OnClickSearch: function(event, strCompId, strSearchTerm) {
        var strLink = EBMCConsts_CT2958529.CommunitySearchUrl;
        if (strSearchTerm)
            strLink += strSearchTerm;

        event.customData = { "url": strLink, "urlTarget": "SELF" };
        EBLinkManager_CT2958529.LoadLinkURL(event);
    },

    OnClickOpenDialog: function(win) {
        EBMCDialog_CT2958529.OpenDialog(win);
    },

    OnToolbarRefreshGrouping: function(bInvalidateCache) {
        EBMCIO_CT2958529.NullifyTimesGrouping();
        EBMCIO_CT2958529.InvalidateCacheGrouping(bInvalidateCache);
    },

    ForceRefreshGrouping: function() {
        this.OnToolbarRefresh(true);
        EBMCServerComm_CT2958529.GetCurrentGroupInfoFromServer();
    },

    OnToolbarRefreshMulticommunitiesChanges: function(bInvalidateCache) {
        EBMCIO_CT2958529.NullifyTimesCommunitiesChanges();
    },

    ForceRefreshMulticommunitiesChanges: function() {
        this.OnToolbarRefreshMulticommunitiesChanges(true);
        EBMCServerComm_CT2958529.GetCommunitiesChangesInfoFromServer();
    },

    LocationChange: function(strUrl) {
        if (!EBActionManager_CT2958529.IsToolbarShown()) {
            return;
        }

        if (EBMCDetect_CT2958529.IsDontCheckThisUrl(window._content.document.location.toString())) {
            EBMCButtonManager_CT2958529.CommunitiesNotDetected();
            return;
        }

        //check the url before document complete.
        var arrA = EBMCDetect_CT2958529.CheckUrl(strUrl);
        if (arrA.length != 0) {
            EBMCMenu_CT2958529.UpdateMenu(arrA);
            EBMCButtonManager_CT2958529.CommunitiesDetected();
        }

        EBMCButtonManager_CT2958529.CommunitiesNotDetected();
        this.DocumentComplete();
    },

    DocumentComplete: function() {
        if (!EBActionManager_CT2958529.IsToolbarMC() ||
			!EBActionManager_CT2958529.IsToolbarShown())
            return;

        if (EBMCDetect_CT2958529.IsDontCheckThisUrl(window._content.document.location.toString())) {
            EBMCButtonManager_CT2958529.CommunitiesNotDetected();
            return;
        }

        var cWin = getBrowser().contentWindow;
        var win = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(cWin);
        var arrA = EBMCDetect_CT2958529.Detect(win);
        if (arrA != null) {
            EBMCMenu_CT2958529.UpdateMenu(arrA);
            EBMCButtonManager_CT2958529.CommunitiesDetected();
            //var strUrl = window._content.document.location;

            if (!this.arrDetectedDomains.Contains(arrA[0].url)) {
                this.arrDetectedDomains.Add(arrA[0].url, true);
                EBMCButtonManager_CT2958529.ShowPopup(arrA);
            }
        }
        else
            EBMCButtonManager_CT2958529.CommunitiesNotDetected();
    },

    //Source parameter is for usage
    GetAndChangeCommunity: function(strUrl, strSource) {
        EBMCIO_CT2958529.ChangeToCommunity(strUrl, strSource);
    },

    ChangeToCommunityFromApi: function(strCTID) {
        if (strCTID == EBGlobalConsts_CT2958529.ToolbarCTID) {
            this.ChangeToOriginal(EBUsageMyConduit_CT2958529.SourceApi);
            return;
        }

        objCommunity = this.GetCommunityFromExistingCommunitiesByCTID(strCTID);
        if (!objCommunity) return;

        this.ChangeToCommunity(strCTID, objCommunity.Name, false, objCommunity, EBUsageMyConduit_CT2958529.SourceApi, false);
    },

    ChangeToCommunity: function(strCTID, strName, isFromMenu, objCommunity, strSource, bIsNew) {
        EBWebPageApiManager_CT2958529.unregisterApi();
        
        if (strCTID == EBActionManager_CT2958529.GetCTID()) return;

        //Send usage
        if (bIsNew) {
            EBUsageMyConduit_CT2958529.AddNewCommunity(this.AllCommunities.Count() + 1, EBActionManager_CT2958529.GetCTID(), strCTID, strSource);
            EBMCIO_CT2958529.AddCommunityToFile(objCommunity);
        }
        else
            EBUsageMyConduit_CT2958529.SwitchCommunity(this.AllCommunities.Count(), EBActionManager_CT2958529.GetCTID(), strCTID, strSource);

        EBCommunityPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CommunityChanged, false, strCTID)

        if (!objCommunity) {
            objCommunity = this.GetCommunityFromExistingCommunitiesByCTID(strCTID);
            //if user previosly deleted this toolbar, and now he added it's again,
            //must set not deleted in registry
            objCommunity.SetStatus(0);
        }

        if (isFromMenu)
            this.AllCommunities.CommunitySelected(strCTID);
        //if user previosly deleted this toolbar, and now he added it's again,
        //must set not deleted in registry
        else
            objCommunity.SetStatus(0);

        oToolbar_CT2958529.toolbar.switchToCommunity(EBGlobalConsts_CT2958529.ToolbarCTID,
                                                    EBActionManager_CT2958529.GetCTID(),
                                                    objCommunity.CTID);
    },

    RefreshAllToolbars: function(strCTID, objCommunity) {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        var i = 0;
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            if (objWindow.EBServerCommunicationManager_CT2958529.OnLoadToolbar
				&&
				objWindow.EBMCManager_CT2958529.DocumentComplete) {
                //only one toolbar will write new community to file
                if (i == 0)
                    objWindow.EBServerCommunicationManager_CT2958529.OnLoadToolbar(strCTID, objCommunity);
                else
                    objWindow.EBServerCommunicationManager_CT2958529.OnLoadToolbar(strCTID);

                objWindow.setTimeout(function() { objWindow.EBMCManager_CT2958529.DocumentComplete(); }, 1000);
            }
            i++;
        }
    },

    //stars logic
    UpdateMenuForStarLogic: function() {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            if (objWindow.EBMCMenu_CT2958529.UpdateMenuForStarLogic) {
                objWindow.EBMCMenu_CT2958529.UpdateMenuForStarLogic();
            }
        }
    },

    UpdateDetectDomainsList: function(arrDownloadDomains, arrExcludedDomains) {
        try {
            var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						    .getService(Components.interfaces.nsIWindowMediator);

            var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
            while (objEnumerator.hasMoreElements()) {
                var objWindow = objEnumerator.getNext();
                if (objWindow.EBMCDetect_CT2958529.UpdateDomainsList)
                    EBMCDetect_CT2958529.UpdateDomainsList(arrDownloadDomains, arrExcludedDomains);
            }
        }
        catch (ex)
		{ }
    },

    GetCommunityNameFromInstallationUrl: function(strUrl) {
        if (!strUrl) return null;
        var iDotIndex = strUrl.indexOf(".");
        if (iDotIndex != -1)
            return strUrl.slice(0, iDotIndex);

        return strUrl;
    },

    IsOriginalToolbar: function(strUrl) {
        var strWebServerUrl = EBGlobalConsts_CT2958529.WebServerUrl;
        strWebServerUrl = strWebServerUrl.toLowerCase();
        strUrl = strUrl.toLowerCase();
        if (strWebServerUrl.indexOf(strUrl) != -1)
            return true;
        else
            return false;
    },

    IsCommunityExists: function(strUrl) {
        if (this.AllCommunities)
            return this.AllCommunities.IsExists(strUrl);
        else
            return false;
    },

    GetCTIDFromExistingCommunitiesByInstallUrl: function(strUrl) {
        return this.AllCommunities.GetCTIDByInstallationUrl(strUrl);
    },

    GetCommunityFromExistingCommunitiesByInstallUrl: function(strUrl) {
        return this.AllCommunities.GetCommunityByInstallationUrl(strUrl);
    },

    GetCommunityFromExistingCommunitiesByCTID: function(strCTID) {
        return this.AllCommunities.GetCommunityByCTID(strCTID);
    },

    ChangeToOriginal: function(strSource) {
        strCTID = EBGlobalConsts_CT2958529.ToolbarCTID;
        this.ChangeToCommunity(strCTID, null, true, null, strSource, false);
    },

    GetSelectedCTID: function() {
        return EBActionManager_CT2958529.GetCTID();
    },

    IsSelectedOriginalCommunity: function() {
        return (this.GetSelectedCTID() == "CT2958529")
    },

    GetCommunitySettingsPath: function() {
        return EBMCConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + this.GetSelectedCTID() + EBDirIO_CT2958529.sep;
    },

    BroadcastChanges: function(objCommunities) {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            if (objWindow.EBMCManager_CT2958529.UpdateCommunities) {
                objWindow.EBMCManager_CT2958529.UpdateCommunities(objCommunities);
            }
        }
    },

    UpdateCommunities: function(objCommunities) {
        this.AllCommunities = objCommunities;
        EBMCMenu_CT2958529.OnLoad(this.AllCommunities);
    },

    //Detect toolbar download
    OnBeforeNavigate: function(strUrl) {
        var arrA = EBMCDetect_CT2958529.CheckUrl(strUrl);

        if (arrA.length != 0 && !window.ToolbarDetected) {
            window.ToolbarDetected = true;
            this.ToolbarDownloadDetected(arrA[0]);
        }
    },

    IsDownloadUrlIsOriginalCommunity: function(strUrl) {
        var strToolbarName = this.GetCommunityNameFromInstallationUrl(strUrl);
        var iStart = EBGlobalConsts_CT2958529.WebServerUrl.indexOf('.');
        if (iStart != -1) {
            var strOToolbarName = EBGlobalConsts_CT2958529.WebServerUrl.substr(0, iStart);
            strOToolbarName = strOToolbarName.replace(/http:\/\//, '');
            if (strToolbarName == strOToolbarName ||
	            strToolbarName == EBGlobalConsts_CT2958529.ToolbarCTID ||
	            strToolbarName == EBGlobalConsts_CT2958529.ToolbarId) {
                return true;
            }
            else {
                return false;
            }
        }

        return false;
    },

    ToolbarDownloadDetected: function(strUrl) {
        //if downloading toolbar is the original toolbar and currently shown, don't popup selector dialog
        if (this.IsSelectedOriginalCommunity() && this.IsDownloadUrlIsOriginalCommunity(strUrl))
            return;

        EBMCDialog_CT2958529.OpenDownloadDialog(strUrl);
    },

    NavigationStop: function() {
        var objTimeout = function() {
            window.ToolbarDetected = false;
        };
        setTimeout(objTimeout, 500);

        var oWebNav = getBrowser().webNavigation;
        var fStop = function() {
            oWebNav.stop(Components.interfaces.nsIWebNavigation.STOP_ALL);
        }
        setTimeout(fStop, 1);
    },

    BroadcastGrouping: function(objGrouping) {
        this.AllCommunities.UpdateGrouping(objGrouping);
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            if (objWindow.EBMCManager_CT2958529.UpdateCommunities) {
                objWindow.EBMCManager_CT2958529.UpdateCommunities(this.AllCommunities);
            }
        }
    },

    BroadcastCurrentGrouping: function(objGrouping) {
        this.AllCommunities.UpdateCurrentGrouping(objGrouping);

        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator('navigator:browser');
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            if (objWindow.EBMCManager_CT2958529.UpdateCommunities) {
                objWindow.EBMCManager_CT2958529.UpdateCommunities(this.AllCommunities);
            }
        }
    }
}

// +++++++++++ Multicommunity Language Pack +++++++++++++++++

var EBMCLanguagePack_CT2958529 =
{
	OnLoad : function()
	{
		var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale,true);
		
		EBMCMenu_CT2958529.MenuItemInitText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_MENU_COMMUNITY_TOOLBAR_DETECTED');
		EBMCMenu_CT2958529.ConduitNetworkText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_MENU_NETWORK');
		EBMCMenu_CT2958529.OptionsText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_MENU_OPTIONS');
		EBMCMenu_CT2958529.DetectedTooltipText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_MENU_COMMUNITY_TOOLBAR_DETECTED');
		EBMCMenu_CT2958529.SwitchTo = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_MENU_COMMUNITY_SWITCH_TO_DETECTED_TOOLBAR');
		EBMCMenu_CT2958529.SearchForText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_CANDIDATE_SEARCH_FOR');
	},
	
	Dialog_OnLoad : function(objWindow,objDialog)
	{
		var locale = objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale,true);
		var objShowHide = new Object();
		    objShowHide.show = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_SHOW_COMPONENT_BUTTON');
		    objShowHide.hide = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_HIDE_COMPONENT_BUTTON');
		
		//objDialog.oDownBtn.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_OPTIONS_DLG_MOVE_DOWN_BUTT'));
		//objDialog.oUpBtn.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_OPTIONS_DLG_MOVE_UP_BUTT'));
		objDialog.oDeleteBtn.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_OPTIONS_DLG_REMOVE_BUTT'));
		objDialog.oHideBtn.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_HIDE_COMPONENT_BUTTON'));
		objDialog.oAcceptBtn.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK'));
		objDialog.oCancelBtn.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL'));
		objDialog.oDescription.innerHTML = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_OPTIONS_DLG_STATIC')
		window.title = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_OPTIONS_DLG_CAPTION');
		return objShowHide;
	},
	
	DownloadDialog_OnLoad : function(objWindow,iMode,strCommunityName)
	{
		var locale		= objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale,true);
		var descText	= document.getElementById("descText");
		var radio_add	= document.getElementById("radio_add");
		var radio_new	= document.getElementById("radio_new");
		var accept		= document.getElementById("ebMulticommunityDownloadDialog").getButton("accept");
		var cancel		= document.getElementById("ebMulticommunityDownloadDialog").getButton("cancel");
		var lblLearnMore= document.getElementById("lnkLearnMore");
		
		
		window.title = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_COMMUNITY_ADD_WARNING_DLG_CAPTION');
		
		accept.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK'));
		cancel.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL'));
		
        switch(iMode)
        {
            case 0:
                    radio_add.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_COMMUNITY_ADD_WARNING_DLG_ADD'));
		            radio_new.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_ADD_COMMUNITY_WARNING_INSTALL'));
		            break;
		    case 1:
		            radio_add.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_MENU_COMMUNITY_SWITCH_TO_DETECTED_TOOLBAR') + strCommunityName);
		            radio_new.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_ADD_COMMUNITY_WARNING_REINSTALL').replace(/{TOOLBAR_NAME}/,strCommunityName));
		            break;
		    case 2:
		            radio_add.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_MENU_COMMUNITY_SWITCH_TO_DETECTED_TOOLBAR') + strCommunityName);
		            radio_new.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_CHANNEL_ADD_COMMUNITY_WARNING_INSTALL'));
		            break;
		}

		descText.innerHTML = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MULTI_COMMUNITY_ADD_WARNING_DLG_TXT').replace(/\n/g,'');
		lblLearnMore.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_LEARN_MORE'));
	},
	
	Detected_OnLoad : function(objWindow)
	{
	    var locale		= objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale,true);
	    var chkDontShow = document.getElementById('chkDontShowAgain');
	    chkDontShow.setAttribute('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_DO_NOT_SHOW_AGAIN'));
	}
}

// +++++++++++ Multicommunity Language Pack +++++++++++++++++

var EBMCMenu_CT2958529 =
{
    xulMenuObj: null,
    MenuItemNewCommunityNameAtt: 'communityNew',
    MenuItemCommunityNameAtt: 'community',
    MenuItemGroupingNameAtt: 'community_group',
    MenuItemRecentNameAtt: 'recent',
    MenuItemSeparatorNameAtt: 'separator',
    MenuItemDetectedPrefix: 'DetectedCommunity_CT2958529',

    MenuItemInitText: 'Community Toolbar Detected',
    ConduitNetworkText: 'Search the Conduit Network',
    SearchForText: 'Search the Conduit Network for',
    SwitchTo: 'Switch To - ',
    OptionsText: 'Edit',
    DetectedTooltipText: 'Communiy Toolbar Detected',

    MenuItemInitIcon: 'chrome://browsersearch/skin/mc_add_inactive.png',
    MenuItemCommunity: 'chrome://browsersearch/skin/mc_community.png',
    MenuItemCommunitySelected: 'chrome://browsersearch/skin/mc_community_selected.png',
    MenuItemCommunity50: 'chrome://browsersearch/skin/mc_community_50.png',
    MaxNewDetectedInMenu: 5,

    EmptyPrevCommunities: function(xulMenuPopup) {
        while (xulMenuPopup.firstChild.getAttribute('name') == this.MenuItemNewCommunityNameAtt) {
            xulMenuPopup.removeChild(xulMenuPopup.firstChild);
        }
    },

    EmptyExistingCommunities: function(xulMenuPopup) {
        var attrName = "";
        for (var i = xulMenuPopup.childNodes.length - 1; i > 4; i--) {
            attrName = xulMenuPopup.childNodes[i].getAttribute('name');

            if ((attrName == this.MenuItemCommunityNameAtt ||
				attrName == this.MenuItemSeparatorNameAtt + "2") && xulMenuPopup.childNodes[i].hasAttribute("EB_CHANGE_TO")) {
                xulMenuPopup.removeChild(xulMenuPopup.childNodes[i]);
                if (attrName == this.MenuItemSeparatorNameAtt + "2")
                    return;
            }
        }
    },

    EmptyExistingGroup: function(xulMenuPopup) {
        var attrName = "";
        for (var i = xulMenuPopup.childNodes.length - 1; i >= 0; i--) {
            attrName = xulMenuPopup.childNodes[i].getAttribute('name');

            if (attrName == this.MenuItemGroupingNameAtt
				||
				attrName == this.MenuItemSeparatorNameAtt + "1") {
                xulMenuPopup.removeChild(xulMenuPopup.childNodes[i]);
                if (attrName == this.MenuItemSeparatorNameAtt + "1") {
                    return;
                }
            }
        }

    },

    EmptyExistingRecent: function(xulMenuPopup) {
        var attrName = "";
        for (var i = xulMenuPopup.childNodes.length - 1; i >= 0; i--) {
            attrName = xulMenuPopup.childNodes[i].getAttribute('name');

            if (attrName == this.MenuItemRecentNameAtt
				||
				attrName == this.MenuItemSeparatorNameAtt + "3") {
                xulMenuPopup.removeChild(xulMenuPopup.childNodes[i]);
                if (attrName == this.MenuItemSeparatorNameAtt + "3") {
                    return;
                }
            }
        }
    },

    CreateNewCommunityXulMenuItem: function(objDetected) {
        var strCaption = objDetected.url;
        var objCommunity = null;
        if (objDetected.IsExists) {
            objCommunity = EBMCManager_CT2958529.GetCommunityFromExistingCommunitiesByInstallUrl(objDetected.url);
            strCaption = this.SwitchTo + " " + objCommunity.Name;
        }

        var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strCaption, oToolbarSkin_CT2958529.groupActiveImageUrl, "", "", "", null);
        xulMenuItem.setAttribute('id', this.MenuItemDetectedPrefix + objDetected.url);
        xulMenuItem.setAttribute('name', this.MenuItemNewCommunityNameAtt);

        xulMenuItem.addEventListener("command", function(e) {
            if (objDetected.IsExists && objCommunity)
                EBMCManager_CT2958529.ChangeToCommunity(objCommunity.CTID, objCommunity.Name, true, null, EBUsageMyConduit_CT2958529.SourceMenu, false);
            else {
                EBMCMenu_CT2958529.RemoveMeFromDetector(xulMenuItem);
                setTimeout(function() { EBMCTrusteDialog_CT2958529.open(objDetected.url, EBUsageMyConduit_CT2958529.SourceMenu); }, 1);
            }

            e.cancelBubble = true;
        }, false);

        return xulMenuItem;
    },

    RemoveMeFromDetector: function(obj) {
        var xulMenu = this.xulMenuObj.childNodes[0];
        xulMenu.removeChild(obj);
        //if this was the last detected community, create "no communities detected node",
        //and change to not detected icon.
        var firstNode = xulMenu.childNodes[0];
        if (firstNode.getAttribute("name") == this.MenuItemSeparatorNameAtt + "0") {
            EBMCButtonManager_CT2958529.CommunitiesNotDetected();
        }
    },

    UpdateDetectedCommunities: function(xulMenuPopup, arrDetected) {
        var xulMenuItem = null;
        var obj = null;
        var numOfDetected = (arrDetected.length > this.MaxNewDetectedInMenu) ? this.MaxNewDetectedInMenu : arrDetected.length;
        for (var i = 0; i < numOfDetected; i++) {
            xulMenuItem = this.CreateNewCommunityXulMenuItem(arrDetected[i]);
            xulMenuPopup.insertBefore(xulMenuItem, xulMenuPopup.firstChild);
        }
    },

    UpdateMenu: function(arrDetected) {
        var xulMenu = this.xulMenuObj.childNodes[0];
        this.EmptyPrevCommunities(xulMenu);
        this.UpdateDetectedCommunities(xulMenu, arrDetected);
    },

    UpdateMenuForStarLogic: function() {
        if (!this.xulMenuObj) return;
        
        var xulMenuPopup = this.xulMenuObj.firstChild;

        if (!xulMenuPopup) return;

        var xulMenu = null;
        var strCTID = "";
        for (var i = 0; i < xulMenuPopup.childNodes.length; i++) {
            xulMenu = xulMenuPopup.childNodes[i];
            strCTID = xulMenu.getAttribute('EB_CTID');
            if (strCTID && EBCommunityPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.CommunityChanged, strCTID)) {
                this.ChangeIconToStar(xulMenu);
            }
        }
    },

    ChangeIconToStar: function(xulMenu) {
        if (xulMenu.getAttribute('EBchecked').toLowerCase() == "true") {
            return;
        }
        else {
            xulMenu.setAttribute(EBImageHandler_CT2958529.Consts.IsToStarAttribute, 'true');
        }
    },

    CommunitiesNotDetected: function(strDomain) {
        var xulMenuPopup = this.xulMenuObj.childNodes[0];
        this.EmptyPrevCommunities(xulMenuPopup);
        var strName = this.MenuItemInitText;
        var strIcon = this.MenuItemInitIcon;
        var strHint = this.MenuItemInitHint;
        var objCommand = null;
        var strDisabled = "true";

        if (strDomain) {
            strName = this.SearchForText + " \"" + strDomain + "\"";
            objCommand = function(event) {
                EBMCManager_CT2958529.OnClickSearch(event, null, strDomain);
                event.cancelBubble = true;
            };
            strDisabled = "false";
        }

        var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strName, strIcon, strHint, objCommand, "", null);
        xulMenuItem.setAttribute('id', this.MenuItemDetectedPrefix);
        xulMenuItem.setAttribute('name', this.MenuItemNewCommunityNameAtt);
        xulMenuItem.setAttribute('disabled', strDisabled);

        xulMenuPopup.insertBefore(xulMenuItem, xulMenuPopup.firstChild)
    },

    BuildSection: function(xulMenu, ObjCommunities, nameAttr, seperatorNameAttr, bIsReversedOrder) {
        if (ObjCommunities && !ObjCommunities.IsEmpty()) {
            var objFirst = null
            var j = ObjCommunities.Count();
            var xulMenuItem, oCommunity;

            for (var i = 0; i < ObjCommunities.Count(); i++) {
                if (bIsReversedOrder) j--;
                else j = i;

                oCommunity = ObjCommunities.GetByIndex(j);
                if (oCommunity.Status == 0) {
                    xulMenuItem = this.CreateNewCommunityMenuItem(oCommunity, nameAttr);
                    xulMenu.appendChild(xulMenuItem);
                    if (!objFirst) objFirst = xulMenuItem;
                }
            }

            if (objFirst) {
                var xulMenuSeparator = EBXULFactory_CT2958529.CreateMenuSeparator();
                xulMenuSeparator.setAttribute('name', seperatorNameAttr);
                xulMenu.appendChild(xulMenuSeparator);
                xulMenu.insertBefore(xulMenuSeparator, objFirst);
            }
        }
    },

    OnLoad: function(objCommunities) {
        var oCommunity = null;
        var xulMenu = this.xulMenuObj.childNodes[0];

        this.EmptyExistingCommunities(xulMenu);
        this.EmptyExistingGroup(xulMenu);
        this.EmptyExistingRecent(xulMenu);

        //Build Recent menu section
        if (objCommunities.Recent && !objCommunities.Recent.IsEmpty()) {
            this.BuildSection(xulMenu, objCommunities.Recent, this.MenuItemRecentNameAtt, this.MenuItemSeparatorNameAtt + "3", true);
        }

        //Build Grouping menu section
        if (objCommunities.Grouping && !objCommunities.Grouping.IsEmpty()) {
            this.BuildSection(xulMenu, objCommunities.Grouping, this.MenuItemGroupingNameAtt, this.MenuItemSeparatorNameAtt + "1", false);
        }

        //Build User menu section
        if (objCommunities.User && !objCommunities.User.IsEmpty()) {
            this.BuildSection(xulMenu, objCommunities.User, this.MenuItemCommunityNameAtt, this.MenuItemSeparatorNameAtt + "2", false);
        }
    },

    UpdateGrouping: function(xmlGroup) {
        var xulMenuItem = null;
        var xulMenu = this.xulMenuObj.childNodes[0];
        this.EmptyExistingGroup(xulMenu);
        var xulMenuItemInsertBefore = this.FindInsertBeforeMenuItem(xulMenu);

        var xulMenuSeparator = EBXULFactory_CT2958529.CreateMenuSeparator();
        xulMenuSeparator.setAttribute('name', this.MenuItemSeparatorNameAtt + "1");
        xulMenuSeparator.style.display = 'none';

        if (xulMenuItemInsertBefore) {
            xulMenu.insertBefore(xulMenuSeparator, xulMenuItemInsertBefore);
        }
        else {
            xulMenu.appendChild(xulMenuSeparator);
        }
        for (var i = 0; i < xmlGroup.childNodes.length; i++) {
            xulMenuItem = this.CreateNewCommunityMenuItemFromXML(xmlGroup.childNodes[i], this.MenuItemGroupingNameAtt);
            if (xulMenuItemInsertBefore) {
                xulMenu.insertBefore(xulMenuItem, xulMenuItemInsertBefore);
            }
            else {
                xulMenu.appendChild(xulMenuItem);
            }
        }
    },

    FindInsertBeforeMenuItem: function(xulMenu) {
        var nameAtt = "";
        var commandAtt = "";
        for (var i = 0; i < xulMenu.childNodes.length; i++) {
            if (xulMenu.childNodes[i].hasAttribute("EB_CHANGE_TO")) {
                if (i < xulMenu.childNodes.length - 1)
                    return xulMenu.childNodes[i + 1];
                else
                    return null;
            }
        }
    },

    CreateNewCommunityMenuItem: function(oCommunity, nameAtt) {
        var strCaption = oCommunity.Name;
        var strCTID = oCommunity.CTID;
        var strHint = oCommunity.InstallationUrl
        var objCommand = function(event) { EBMCManager_CT2958529.ChangeToCommunity(strCTID, strCaption, true, null, EBUsageMyConduit_CT2958529.SourceMenu, false); };
        var strIcon = this.MenuItemCommunity;

        if (EBMCManager_CT2958529.GetSelectedCTID() == strCTID)
            strIcon = this.MenuItemCommunitySelected;

        var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strCaption, this.MenuItemCommunity, strHint, objCommand, "", null);
        xulMenuItem.setAttribute('id', this.MenuItemDetectedPrefix + strCaption);
        xulMenuItem.setAttribute('name', nameAtt);
        xulMenuItem.setAttribute('EB_CTID', strCTID);

        if (EBMCManager_CT2958529.GetSelectedCTID() == strCTID)
            this.SetMenuSelected(xulMenuItem);

        return xulMenuItem;
    },

    SetMenuSelected: function(xulMenuItem) {
        xulMenuItem.setAttribute('EBchecked', 'true');
        xulMenuItem.setAttribute("class", "menuitem-iconic");
        xulMenuItem.setAttribute("image", this.MenuItemCommunitySelected);
        xulMenuItem.setAttribute("style", EBToolbarDesignConsts_CT2958529.ToolbarMaxImageHeightStyle + ';font-weight:bold');
    },

    SetMenuNotSelected: function(xulMenuItem) {
        xulMenuItem.setAttribute('EBchecked', 'false');
        xulMenuItem.setAttribute("class", "menuitem-iconic");
        xulMenuItem.setAttribute("image", this.MenuItemCommunity);
        xulMenuItem.setAttribute("style", EBToolbarDesignConsts_CT2958529.ToolbarMaxImageHeightStyle);
    },

    OnCommunitySelect: function(strId) {
        var xulMenu = this.xulMenuObj.childNodes[0];
        var xulMenuItem = null;
        for (var i = 0; i < xulMenu.childNodes.length; i++) {
            xulMenuItem = xulMenu.childNodes[i];
            if (xulMenuItem.getAttribute('name') == this.MenuItemCommunityNameAtt) {
                if (xulMenuItem.getAttribute('id') == strId) {
                    this.SetMenuSelected(xulMenuItem);
                }
                else {
                    this.SetMenuNotSelected(xulMenuItem);
                }
            }
        }
    },

    OnNewCommunitySelect: function(xulSelected) {
        var xulMenu = this.xulMenuObj.childNodes[0];
        var xulMenuItem, xulMenuItemInsertBefore = null;

        var isAppend = false;
        var foundFirst = true;
        for (var i = 0; i < xulMenu.childNodes.length; i++) {
            xulMenuItem = xulMenu.childNodes[i];
            if (xulMenuItem.getAttribute('name') == this.MenuItemCommunityNameAtt) {
                if (foundFirst) {
                    if (i == xulMenu.childNodes.length - 1) {
                        isAppend = true;
                    }
                    else {
                        xulMenuItemInsertBefore = xulMenu.childNodes[i + 1];
                    }
                    foundFirst = false;
                }

                this.SetMenuNotSelected(xulMenuItem);
            }
        }
        xulSelected.setAttribute('name', this.MenuItemCommunityNameAtt);
        if (isAppend) {
            xulMenu.appendChild(xulSelected);
        }
        else {
            xulMenu.insertBefore(xulSelected, xulMenuItemInsertBefore);
        }
        this.SetMenuSelected(xulSelected);
    }
};

//Radio Recent Media List Class
function EBRecentCommunityList_CT2958529(XMLDoc,strFullFilePath)
{
	this.Add = function(oCommunity)
	{
		if(this.Contains(oCommunity))
            this.Remove(oCommunity);

		if(this.CommunitiesHash.Count() == EBMCManager_CT2958529.MaxRecent)
		{
			var oCommunityToRemove = this.CommunitiesHash.GetByIndex(0);
			this.CommunitiesHash.Remove(0,oCommunityToRemove.CTID);
		}
		this.CommunitiesHash.Add(oCommunity.CTID,oCommunity);
	};

	this.Contains = function(oCommunity)
	{
		return this.CommunitiesHash.Contains(oCommunity.CTID);
	};

	this.Remove = function(oCommunity)
	{
		if(this.Contains(oCommunity))
		{
			var index = this.GetIndexByCommunity(oCommunity)
			this.CommunitiesHash.Remove(index,oCommunity.CTID);
		}	
	};
	
	this.GetIndexByCommunity = function(oCommunity)
	{
	    var iCommunity = null;
	    
	    for(var i=0;this.CommunitiesHash.Count();i++)
	    {
	        iCommunity = this.CommunitiesHash.GetByIndex(i);
	        if(iCommunity.CTID == oCommunity.CTID)
	        {
	            return i;
	        }
	    }
	    
	    return -1;
	};
	
	if(XMLDoc && XMLDoc.childNodes.length != 0)
	{
		this.CommunitiesHash = new EBArrayHashObject_CT2958529();
		this.InitList(XMLDoc);
	}
	else
	{
	    this.CommunitiesHash = new EBArrayHashObject_CT2958529();
	}
	
	this.FullFilePath   = strFullFilePath;

}

EBRecentCommunityList_CT2958529.prototype = new EBMCCommunityList_CT2958529;
var EBMCServerComm_CT2958529 =
{
    timeoutFunc: null,
    timeoutFuncCurrent: null,
    //****************************************************************************
    //                                  Grouping
    //****************************************************************************
    InitGrouping: function(bIsEmpty) {
        //Set grouping check interval.
        var iGroupingInterval = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingServerCheckInterval);
        if (iGroupingInterval != null && iGroupingInterval) {
            EBMCConsts_CT2958529.GroupingServerCheckInterval = iGroupingInterval;
            if (EBMCConsts_CT2958529.GroupingServerOnErrorInterval >= iGroupingInterval) {
                EBMCConsts_CT2958529.GroupingServerOnErrorInterval = parseInt(iGroupingInterval / 2);
            }
        }

        var timeOut;

        if (bIsEmpty) {
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckTime, '0');
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastServerUpdateTime, '0');
        }

        var IsResponded;
        if (this.IsRequestGrouping()) {
            this.GetGroupInfoFromServer();
            IsResponded = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckResponse);
            IsResponded = (IsResponded == null) ? false : IsResponded;

            if (!IsResponded)
                timeOut = this.GetDifference(!IsResponded, true);
            else
                timeOut = EBMCConsts_CT2958529.GroupingServerCheckInterval * 60 * 1000;
        }
        else {
            IsResponded = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckResponse);
            IsResponded = (IsResponded == null) ? false : IsResponded;

            timeOut = this.GetDifference(!IsResponded, true);
        }

        this.timeoutFunc = setTimeout(function() { EBMCServerComm_CT2958529.InitGrouping(false); }, timeOut);
    },

    GetDifference: function(isError, isNextCheckTime, bIsCurrent) {
        var now = Date();
        var lastCheckTime = "";
        var milliDif = 0;

        if (!bIsCurrent) bIsCurrent = false;

        if (isError) {
            lastCheckTime = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckTime, bIsCurrent);
            if (isNextCheckTime)
                milliDif = EBMCConsts_CT2958529.GroupingServerOnErrorInterval * 60 * 1000 - (Date.parse(now) - Date.parse(lastCheckTime));
            else {
                if (lastCheckTime)
                    milliDif = Date.parse(now) - Date.parse(lastCheckTime);
                else
                    milliDif = EBMCConsts_CT2958529.GroupingServerCheckInterval * 60 * 1000;
            }
        }
        else {
            lastCheckTime = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckTime, bIsCurrent);
            if (isNextCheckTime)
                milliDif = EBMCConsts_CT2958529.GroupingServerCheckInterval * 60 * 1000 - (Date.parse(now) - Date.parse(lastCheckTime));
            else
                milliDif = Date.parse(now) - Date.parse(lastCheckTime);
        }

        return milliDif;
    },

    IsRequestGrouping: function(bIsCurrent) {
        if (!bIsCurrent) bIsCurrent = false;

        var now = Date();
        var timeOut = 0;
        var lastCheckTime = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckTime, bIsCurrent);
        var IsResponded = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckResponse, bIsCurrent);
        var lastErrorCode = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastErrorCode, bIsCurrent);

        if (!lastCheckTime || lastCheckTime == "0") {
            return true;
        }

        if (!IsResponded) {
            timeOut = EBMCConsts_CT2958529.GroupingServerOnErrorInterval * 60 * 1000;
            var timePased = this.GetDifference(true, false, bIsCurrent);
            if (timePased >= timeOut)
                return true;
        }
        else {
            var milliDif = this.GetDifference(false, false, bIsCurrent);
            timeOut = EBMCConsts_CT2958529.GroupingServerCheckInterval * 60 * 1000;
            if (milliDif >= timeOut)
                return true;
        }

        // all ok, no need to check
        return false;
    },

    GetGroupInfoFromServer: function(bIsFromSelectFromGroupingByLocale) {
        var oCallBackFunction = function(strXML, o) {
            strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
            var xmlGroup = EBXML_CT2958529.GetXmlDocument(strXML);
            if (!xmlGroup) {
                EBMCServerComm_CT2958529.GroupingErrorResponse(o);
                return false;
            }
            EBMCServerComm_CT2958529.GroupInfoResponse(xmlGroup.documentElement, bIsFromSelectFromGroupingByLocale);
        };
        //set last request time 
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckTime, Date());
        //nullify last response
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckResponse, false);

        var strUrl = this.getGroupingServiceUrl() + EBMCConsts_CT2958529.GroupServiceServerUrl;
        strUrl = strUrl.replace(/CTxxxx/, EBActionManager_CT2958529.GetCTIDForServices());
        var lut = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastServerUpdateTime);

        if (lut == null)
            lut = 0;

        strUrl += lut;
        EBWeb_CT2958529.HTTPServerRequest(strUrl, null, false, oCallBackFunction);
    },

    GroupInfoResponse: function(xmlDoc, bIsFromSelectFromGroupingByLocale) {
        var strNodeValue = EBXML_CT2958529.GetXmlNodeValue(xmlDoc);
        if (strNodeValue == EBMCConsts_CT2958529.ERROR_REPLY) {
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastErrorCode, "ERROR_REPLY");
            return false;
        }

        var lastUpdateTime = "";
        var xmlCommunities = null;
        //update last grouping response time
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckResponse, true);

        //clear last error code
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastErrorCode, "");
        for (var i = 0; i < xmlDoc.childNodes.length; i++) {
            if (xmlDoc.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.LastUpdateTime) {
                lastUpdateTime = EBXML_CT2958529.GetXmlNodeValue(xmlDoc.childNodes[i]);

                if (lastUpdateTime == EBMCConsts_CT2958529.GroupNotModified)
                    return;
            }
            else if (xmlDoc.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.Communities) {
                xmlCommunities = xmlDoc.childNodes[i];
            }
        }
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastServerUpdateTime, lastUpdateTime);

        if (xmlCommunities.childNodes.length == 0)
            return false;

        var strFullPath = EBMCConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBMCConsts_CT2958529.GroupFileName;
        var oGrouping = new EBMCCommunityList_CT2958529(xmlCommunities, strFullPath);

        oGrouping.SaveToFile();

        if (bIsFromSelectFromGroupingByLocale)
            EBGroupingManager_CT2958529.onGroupingResponse(oGrouping);
        else
            EBMCManager_CT2958529.BroadcastGrouping(oGrouping);
    },

    GroupingErrorResponse: function(objError) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastErrorCode, objError.value);
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastResponseTime, Date());
        clearTimeout(this.timeoutFunc);
        this.timeoutFunc = setTimeout(function() { EBMCServerComm_CT2958529.InitGrouping(); }, EBMCConsts_CT2958529.GroupingServerOnErrorInterval * 60 * 1000);
    },

    //****************************************************************************
    //                                  Community Info
    //****************************************************************************

    GetCommunityInfoFromServer: function(strCommunityUrl, strSource) {
        var oCallBackFunction = function(strXML, o) {
            strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
            var xmlCommunity = EBXML_CT2958529.GetXmlDocument(strXML);

            if (!xmlCommunity)
                return false;

            EBMCServerComm_CT2958529.CommunityInfoResponse(xmlCommunity.documentElement, strSource);
        };

        var strUrl = this.getGroupingServiceUrl() + EBMCConsts_CT2958529.CommunityServiceServerUrl + strCommunityUrl;
        EBWeb_CT2958529.HTTPServerRequest(strUrl, null, false, oCallBackFunction);
    },

    CommunityInfoResponse: function(xmlDoc, strSource) {
        var strNodeValue = EBXML_CT2958529.GetXmlNodeValue(xmlDoc);
        if (strNodeValue == EBMCConsts_CT2958529.ERROR_REPLY)
            return false;

        var objCommunity = new EBMCCommunityList_CT2958529(xmlDoc)
        EBMCManager_CT2958529.ChangeToCommunity(objCommunity.CTID, objCommunity.Name, false, objCommunity, strSource, true);
    },

    //****************************************************************************
    //                                  Communities Changes
    //****************************************************************************

    IsRequestCommunitiesChanges: function() {
        var lastCheckTime = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.CommunitiesChangesLastCheckTime);
        if (lastCheckTime) {
            var milliDif = Date.parse(Date()) - Date.parse(lastCheckTime);
            if (milliDif < 1000 * 60)
                return false;
        }

        return true;
    },

    CreateCommunitiesChangesRequestParametersString: function() {
        var strParams = EBMCConsts_CT2958529.UrlParameter_CTIDs + EBMCManager_CT2958529.AllCommunities.GetAllCTIDCommaSeparatedString();
        return strParams;
    },

    GetCommunitiesChangesInfoFromServer: function() {
        if (!this.IsRequestCommunitiesChanges()) {
            EBMCManager_CT2958529.UpdateMenuForStarLogic();
            return;
        }

        var oCallBackFunction = function(strXML, o) {
            strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
            var xmlMCChanges = EBXML_CT2958529.GetXmlDocument(strXML);

            if (!xmlMCChanges)
                return false;

            EBMCServerComm_CT2958529.CommunitiesChangesInfoResponse(xmlMCChanges.documentElement);
        };

        //set last request time 
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CommunitiesChangesLastCheckTime, Date());

        var strUrl = this.getGroupingServiceUrl() + EBMCConsts_CT2958529.CommunitiesCheckServerUrl;
        var strParams = this.CreateCommunitiesChangesRequestParametersString();

        if (strParams) {
            strUrl += strParams;
            EBWeb_CT2958529.HTTPServerRequest(strUrl, null, false, oCallBackFunction);
        }
    },

    CommunitiesChangesInfoResponse: function(xmlDoc) {
        var strNodeValue = EBXML_CT2958529.GetXmlNodeValue(xmlDoc);
        if (strNodeValue == EBMCConsts_CT2958529.ERROR_REPLY)
            return false;
        var GetCommunityInfo = function(xmlCommunity) {
            var objCommunity = new Object();
            var strUpdated = "";

            for (var i = 0; i < xmlCommunity.childNodes.length; i++) {
                if (xmlCommunity.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.CTID)
                    objCommunity.ctid = EBXML_CT2958529.GetXmlNodeValue(xmlCommunity.childNodes[i]);
                else if (xmlCommunity.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.VisualLastUpdateTime)
                    objCommunity.lut = EBXML_CT2958529.GetXmlNodeValue(xmlCommunity.childNodes[i]);
                else if (xmlCommunity.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.AlertChannelId)
                    objCommunity.alertChannelId = EBXML_CT2958529.GetXmlNodeValue(xmlCommunity.childNodes[i]);
            }

            return objCommunity;
        };

        var bIsAnyChanges = false;
        var bIsAnyChangesFromLastTime = false;
        var objCommunity = null;
        var xmlCommunity = null;
        var strPrefLUT = "";
        var strPrefUpdated = "";
        var bLastState = null;
        var strLastVisualLUT = "";
        var arrChannelsId = new Array();
        //get the GROUPING node
        xmlDoc = EBXML_CT2958529.SelectSingleNode(xmlDoc, EBMCConsts_CT2958529.xmlTags.Communities);
        for (var i = 0; i < xmlDoc.childNodes.length; i++) {
            objCommunity = GetCommunityInfo(xmlDoc.childNodes[i]);
            if (objCommunity.alertChannelId)
                arrChannelsId.push(objCommunity.alertChannelId);
            strLastVisualLUT = EBCommunityPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.VusualLastUpdateTime, objCommunity.ctid);
            if (objCommunity.lut != strLastVisualLUT) {
                bIsAnyChanges = true;
                bLastState = EBCommunityPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.CommunityChanged, objCommunity.ctid);

                if (!bLastState)
                    bIsAnyChangesFromLastTime = true;

                EBCommunityPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.CommunityChanged, true, objCommunity.ctid);
            }
        }

        if (bIsAnyChanges)
            EBMCManager_CT2958529.UpdateMenuForStarLogic();

        if (bIsAnyChangesFromLastTime)
            EBMCButtonManager_CT2958529.SetMainButtonStar();
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBAlertManager_CT2958529.UpdateAlertMultiple(arrChannelsId);
    },

    //****************************************************************************
    //                         Current Toolbar Grouping
    //****************************************************************************

    InitCurrentGrouping: function() {
        //do not request grouping for original toolbar, it has it's own mechanism.
        if (EBMCManager_CT2958529.IsSelectedOriginalCommunity())
            return;

        var iGroupingInterval = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingServerCheckInterval);

        if (iGroupingInterval != null && iGroupingInterval) {
            EBMCConsts_CT2958529.GroupingServerCheckInterval = iGroupingInterval;

            if (EBMCConsts_CT2958529.GroupingServerOnErrorInterval >= iGroupingInterval)
                EBMCConsts_CT2958529.GroupingServerOnErrorInterval = parseInt(iGroupingInterval / 2);
        }

        var timeOut, IsResponded;

        if (this.IsRequestGrouping(true)) {
            this.GetCurrentGroupInfoFromServer();
            IsResponded = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckResponse, true);
            IsResponded = (IsResponded == null) ? false : IsResponded;
            if (!IsResponded)
                timeOut = this.GetDifference(!IsResponded, false, true);
            else
                timeOut = EBMCConsts_CT2958529.GroupingServerCheckInterval * 60 * 1000;

        }
        else {
            IsResponded = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckResponse, true);
            IsResponded = (IsResponded == null) ? false : IsResponded;
            timeOut = this.GetDifference(!IsResponded, true, true);
        }

        this.timeoutFuncCurrent = setTimeout(function() { EBMCServerComm_CT2958529.InitCurrentGrouping(false); }, timeOut);
    },

    GetCurrentGroupInfoFromServer: function() {
        var oCallBackFunction = function(strXML, o) {
            strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
            var xmlGroup = EBXML_CT2958529.GetXmlDocument(strXML);
            if (!xmlGroup) {
                EBMCServerComm_CT2958529.CurrentGroupingErrorResponse(o);
                return false;
            }

            EBMCServerComm_CT2958529.CurrentGroupInfoResponse(xmlGroup.documentElement);
        };

        //set last request time 
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckTime, Date(), true);
        //nullify last response
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckResponse, false, true);

        var strUrl = this.getGroupingServiceUrl() + EBMCConsts_CT2958529.GroupServiceServerUrl;
        strUrl = strUrl.replace(/CTxxxx/, EBActionManager_CT2958529.GetOriginalCTIDForServices());
        var lut = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingLastServerUpdateTime, true);

        if (lut == null) lut = 0;
        strUrl += lut;

        //get value and set false, in order to invalidate cache maximum one time.
        if (EBMCIO_CT2958529.InvalidateCacheGrouping(false))
            strUrl += EBMCConsts_CT2958529.InvalidateCacheParam;

        EBWeb_CT2958529.HTTPServerRequest(strUrl, null, false, oCallBackFunction);
    },

    CurrentGroupingErrorResponse: function(o)
    { },

    CurrentGroupInfoResponse: function(xmlDoc) {
        var strNodeValue = EBXML_CT2958529.GetXmlNodeValue(xmlDoc);
        if (strNodeValue == "ERROR_REPLY") {
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastErrorCode, "ERROR_REPLY", true);
            return false;
        }

        var lastUpdateTime = "";
        var xmlCommunities = null;
        //update last grouping response time
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastCheckResponse, true, true);

        //clear last error code
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastErrorCode, "", true);
        for (var i = 0; i < xmlDoc.childNodes.length; i++) {
            if (xmlDoc.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.LastUpdateTime) {
                lastUpdateTime = EBXML_CT2958529.GetXmlNodeValue(xmlDoc.childNodes[i]);

                if (lastUpdateTime == EBMCConsts_CT2958529.GroupNotModified) {
                    return;
                }
            }
            else if (xmlDoc.childNodes[i].tagName == EBMCConsts_CT2958529.xmlTags.Communities) {
                xmlCommunities = xmlDoc.childNodes[i];
            }
        }

        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.GroupingLastServerUpdateTime, lastUpdateTime, true);
        if (xmlCommunities.childNodes.length == 0) {
            return false;
        }

        var strFullPath = ''; //EBMCConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBMCConsts_CT2958529.GroupFileName;
        var oGrouping = new EBMCCommunityList_CT2958529(xmlCommunities, strFullPath);

        EBMCManager_CT2958529.BroadcastCurrentGrouping(oGrouping);
    },

    //****************************************************************************
    //                              Download and Excluded Domains
    //****************************************************************************

    GetDownloadDomainsCheckInterval: function() {
        var iInterval = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.DownloadDomainsCheckInterval);
        if (!iInterval)
            iInterval = EBMCConsts_CT2958529.DownloadDomainsServerCheckInterval;

        return iInterval;
    },

    IsRequestDownloadDomains: function() {
        var now = Date();
        var lastCheckTime = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.DownloadDomainsListLastCheckTime);
        var lastServerUpdateTime = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.DownloadDomainsListLastServerUpdateTime);
        var milliDif = Date.parse(now) - Date.parse(lastCheckTime);

        //if never checked
        if (!lastCheckTime)
            return true;

        //if no server last update timestamp present, but checked before (in case of an error)
        //check only if error interval is passed
        if (!lastServerUpdateTime && milliDif >= EBMCConsts_CT2958529.DownloadDomainsErrorServerCheckInterval * 60 * 60 * 1000)
            return true;

        //normal interval passed
        if (milliDif >= this.GetDownloadDomainsCheckInterval() * 60 * 60 * 1000)
            return true;

        //all ok, no need to check.
        return false;
    },

    //Download Domains request (if needed)
    InitMC: function() {
        //no need to check
        if (!this.IsRequestDownloadDomains())
            return;

        //get last server update time
        var strLUT = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.DownloadDomainsListLastServerUpdateTime);
        if (!strLUT)
            strLUT = 0;

        //set last request time 
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.DownloadDomainsListLastCheckTime, Date());

        //build the request url
        var strUrl = this.getGroupingServiceUrl() + EBMCConsts_CT2958529.DownloadDomainsServerUrl;

        //response function
        var oCallBackFunction = function(strXML, o) {
            strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
            var xmlDomains = EBXML_CT2958529.GetXmlDocument(strXML);
            if (!xmlDomains)
                return false;

            EBMCServerComm_CT2958529.DownloadDomainsResponse(xmlDomains.documentElement);
        };

        //Execute call
        EBWeb_CT2958529.HTTPServerRequest(strUrl, null, false, oCallBackFunction);
    },

    DownloadDomainsResponse: function(xmlRoot) {
        var xmlDomains = null;
        var xmlExcludedDomains = null;
        var xmlLastUpdateTime = null;
        var xmlInterval = null;
        var xmlFlags = null;
        var xmlNode = null;

        var xmlTags = EBMCConsts_CT2958529.xmlTags;

        //Extract Domains and LastUpdateTime nodes
        for (var i = 0; i < xmlRoot.childNodes.length; i++) {
            xmlNode = xmlRoot.childNodes[i];
            if (xmlNode.tagName == xmlTags.DownloadDomains)
                xmlDomains = xmlNode;
            else if (xmlNode.tagName == xmlTags.ExcludedDomains)
                xmlExcludedDomains = xmlNode;
            else if (xmlNode.tagName == xmlTags.LastUpdateTime)
                xmlLastUpdateTime = xmlNode;
            else if (xmlNode.tagName == xmlTags.Interval)
                xmlInterval = xmlNode;
            else if (xmlNode.tagName == xmlTags.Flags)
                xmlFlags = xmlNode;
        }

        try {
            //update check interval, set new interval into preferences
            var iInterval = EBXML_CT2958529.GetXmlNodeValue(xmlInterval);
            if (iInterval)
                EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.DownloadDomainsCheckInterval, iInterval);

            //check if NOT_MODIFIED response
            var strFlags = EBXML_CT2958529.GetXmlNodeValue(xmlFlags);
            if (strFlags == EBMCConsts_CT2958529.GroupNotModified)
                return;

            //Save the last update time
            var strServerLastUpdateTime = EBXML_CT2958529.GetXmlNodeValue(xmlLastUpdateTime);
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.DownloadDomainsListLastServerUpdateTime, strServerLastUpdateTime);

            //Save the domains in file
            EBMCIO_CT2958529.SaveDownloadDomainsToFile(xmlDomains);
            EBMCIO_CT2958529.SaveExcludedDomainsToFile(xmlExcludedDomains);

            var arrDownloadDomains = EBMCIO_CT2958529.GetDomainArrayFromXml(xmlDomains);
            var arrExcludedDomains = EBMCIO_CT2958529.GetDomainArrayFromXml(xmlExcludedDomains);

            //Update the list via manager
            EBMCManager_CT2958529.UpdateDetectDomainsList(arrDownloadDomains, arrExcludedDomains);
        }
        catch (ex) { }
    },

    getGroupingServiceUrl: function() {
        var strUrl = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.GroupingServiceUrl);
        if (!strUrl)
            strUrl = EBMCConsts_CT2958529.BaseGroupingServiceUrl;

        return strUrl;
    }
};
function AppDetectionTooltipDialog() {
    BaseDialogManager_CT2958529.call(this);

    this.xulElements = { "descDetectionText": null, "chkStopDetection": null };
    this.mainWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

    this._onload = function(e) {
        this.applyLP();
    };

    this._onunload = function(e) {
        //save apps detection checkbox
        this.mainWindow.oToolbarManager_CT2958529.isDetectionEnabled = !parseBool(this.xulElements.chkStopDetection.getAttribute("checked"));
        //set pref key not to show this tooltip again
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.AppDetectionDialogShown, true);
    };

    this.onclickOK = function() {
        window.close();
    };

    this.applyLP = function() {
        this.xulElements.descDetectionText.firstChild.nodeValue = this.mainWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_DETECTION_DIALOG_MESSAGE_TEXT');
        this.xulElements.chkStopDetection.setAttribute("label", this.mainWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_DETECTION_DIALOG_CHECKBOX_TEXT'));
    };
};

AppDetectionTooltipDialog.prototype = new BaseDialogManager_CT2958529();
AppDetectionTooltipDialog.constructor = AppDetectionTooltipDialog;
var EBMyStuffErrorDialog_CT2958529 =
{
    dialogPath: "chrome://browsersearch/content/myStuffError.xul",
    dialogName: "EBMyStuffErrorDialogName_CT2958529",
    dialogId: "ebMyStuffError",
    divMsg: null,
    oWindow: null,
    btnOk: null,
    btnUpgrade: null,

    openDialog: function(flags) {

        window.openDialog(this.dialogPath, this.dialogName,
						'chrome,modal,centerscreen,resizable=no',
						flags);
    },

    onload: function(event) {
        this.divMsg = document.getElementById("divMsg");
        this.btnOk = document.getElementById(this.dialogId).getButton("accept");
        this.btnUpgrade = document.getElementById("btnUpgrade");

        this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var flags = window.arguments[0];
        this.applyLanguagePack();
        this.initUI(flags);
    },

    initUI: function(flags) {
        var responsFlags = this.oWindow.oToolbar_CT2958529.toolbarDataParsing.myStuff.responseFlags;
        var tooltipHtmlText = "";
        var tooltipTitle = "";

        switch (flags) {
            case responsFlags.DELETED:
            case responsFlags.COMPONENT_NOT_FOUND:
                tooltipHtmlText = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_COMP_NOT_EXISTS');
                tooltipTitle = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TITLE_UNVAVAILABLE');
                break;
            case responsFlags.CONNECTION_ERROR:
                tooltipHtmlText = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TEMP_UNAVAILABLE');
                tooltipTitle = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TITLE_TEMP_UNAVAILABLE');
                break;
            case responsFlags.ERROR:
                tooltipHtmlText = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TECH_ERROR');
                var contactCustomerSupportCaption = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MYSTUFF_ERROR_TOOLTIP_CUSTOMER_SUPPORT_LINK_TEXT');
                var customerSupportLink = "<html:a onclick=\"EBMyStuffErrorDialog_CT2958529.onclickCustomerSupport(event)\" href=\"#\" class=\"EBMyStuffTooltipA_CT2958529\"> " + contactCustomerSupportCaption + "</html:a>";
                tooltipHtmlText += customerSupportLink;
                tooltipTitle = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TITLE_UNVAVAILABLE');
                break;
            case responsFlags.SERVER_UNREACHABLE:
                tooltipHtmlText = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TEMP_UNAVAILABLE');
                tooltipTitle = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TITLE_TEMP_UNAVAILABLE');
                break;
            case responsFlags.INVALID_XML:
                tooltipHtmlText = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TEMP_UNAVAILABLE');
                tooltipTitle = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TITLE_TEMP_UNAVAILABLE');
                break;
            case responsFlags.UNSUPPORTED:
                //TODO: check if this toolbar is up to date.
                tooltipTitle = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TITLE_UPGRADE');
                if (this.oWindow.oToolbarManager_CT2958529.isLatestVersion())
                    tooltipHtmlText = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_COMP_NOT_EXISTS');
                else {
                    tooltipHtmlText = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_UPGRADE_TOOLBAR_FULL_MSG');
                    this.btnUpgrade.style.display = "";
                    this.btnOk.label = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL');
                }
                break;
            case responsFlags.BAD_INPUT:
                tooltipHtmlText = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_COMP_NOT_EXISTS');
                tooltipTitle = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_MYSTUFF_ERROR_TOOLTIP_TITLE_UNVAVAILABLE');
                break;
            default:
                break;
        }

        this.divMsg.innerHTML = tooltipHtmlText;
        window.document.title = tooltipTitle;
    },

    onclickCustomerSupport: function(event) {
        var strUrl = EBGlobalConsts_CT2958529.IsEngine ? this.oWindow.oToolbarManager_CT2958529.data.settings.enginePages.support : this.oWindow.EBActionManager_CT2958529.GetWebServerURL("support");
        this.oWindow.EBWeb_CT2958529.LoadURLInNewTab(strUrl);
        window.close();
    },

    onclickUpgrade: function(event) {
        var strUrl = EBGlobalConsts_CT2958529.IsEngine ? this.oWindow.oToolbarManager_CT2958529.data.settings.enginePages.upgrade : this.oWindow.EBActionManager_CT2958529.GetWebServerURL("upgrade");
        this.oWindow.EBWeb_CT2958529.LoadURLInNewTab(strUrl);
        window.close();
    },

    applyLanguagePack: function() {
        var dialogsDirection = this.oWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, this.dialogId);

        this.btnOk.label = this.oWindow.oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_GLOBAL_OK");
        this.btnUpgrade.label = this.oWindow.oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_ERROR_TOOLTIP_UPGRADE_TOOLBAR_LINK_TEXT");
    }
};

function EBMyStuffManager_CT2958529() {
    var self = this;
    var SEARCH_TERM_ALIAS = "SEARCH_TERM";
    var tooltip = null;
    var tooltipManager = null;
    var BLINK_TIMES = 5;
    var AddedComponentSucessDialogId = "AddedAppDialog";
    var UTAppAddedDialogId = "UntrustedAddedAppDialog";
    var AppDitectionDialogId = "DetectedAppDialog";
    
    

    
    this.onclickAdd = function(event) {
        var strUrl = oToolbarManager_CT2958529.getMyStuffSearchUrl();
        strUrl = EBActionManager_CT2958529.ConvertAliasesUrl(strUrl);
        strUrl = strUrl.replace(SEARCH_TERM_ALIAS, "");
        EBWeb_CT2958529.LoadURL(strUrl);

        //usage
        EBUsageMyStuff_CT2958529.AddStuffEngineClick();
    };

    this.onclickOptions = function(event) {
        EBToolbarOptionsStaticDialogManager_CT2958529.OpenDialog(window, false, true);
        
        //usage
        EBUsageMyStuff_CT2958529.OptionsClick();
    };

    this.onTooltipHidden = function(event) { };

    this.onApiAddStuffResponse = function(event) {
        try {
            var data = JSON.parse(event.data);
        } catch (exp) {
            EBLog('JSON.parse: ' + exp);
            return;
        }
        var flags = data.flags;
        var isSuccess = data.isSuccess;

        if (!isSuccess && flags != oToolbar_CT2958529.toolbarDataParsing.myStuff.responseFlags.EXISTS)
            EBMyStuffErrorDialog_CT2958529.openDialog(flags)
        else {
            if (!EBActionManager_CT2958529.IsToolbarShown())
                EBToolbarManager_CT2958529.showToolbar();
        }
    };

    this.setDetectedComponent = function(oComponent) {
        oComponent.SetDetected();
        this.openDetectionDialog(oComponent);
    };

    this.openDetectionDialog = function(app) {
        if (!EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.FirstTime) || EBGlobalManager_CT2958529.IsLinuxPlatform() || !app || isFloatingMode_CT2958529) return;
        setTimeout(function() {
            var dialogName = AppDitectionDialogId;
            var dialogData = oToolbarManager_CT2958529.dialogsManager.getDialogDataManager(dialogName);
            dialogData.showDialog(window, app, EBToolbarManager_CT2958529.chevronManager.isChevronShown(), oToolbarManager_CT2958529);
        }, 1);
    };

    this.openAddingAppDialog = function(app, isUntrusted) {
        
        if (isUntrusted && !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.appApproved + "." + app.ComponentItem.UniqueCompID)) {
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.appApproved + "." + app.ComponentItem.UniqueCompID, !isUntrusted);
            EBPreferenceService_CT2958529.SaveAll();
        }
        if (!EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.FirstTime) || EBGlobalManager_CT2958529.IsLinuxPlatform() || !app) return;

        setTimeout(function() {
            if (window.isToShowAddAppPanel || DualPackageFunctions_CT2958529.isEngineOnToolbar() && window.isWindowAddApp) {
                window.isToShowAddAppPanel = false;
                window.isWindowAddApp = false;

                if (isUntrusted && !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.approveUntrustedApps)) {
                    var dialogName = UTAppAddedDialogId;
                    var dialogData = oToolbarManager_CT2958529.dialogsManager.getDialogDataManager(dialogName);
                    var strDialogOpenType = (EBGlobalConsts_CT2958529.IsAMO) ? "dependent," : "modal,";
                    var strParams = stringFormat("{0}resizable=no,titlebar=yes,", strDialogOpenType);
                    dialogData.showDialogWinBaseWithPosition(window, 0, 0, EBToolbarManager_CT2958529.chevronManager.isChevronShown(), oToolbarManager_CT2958529, strParams, app, EBChevronStaticManager_CT2958529);
                }
                else {
                    var dialogName = AddedComponentSucessDialogId;
                    var dialogData = oToolbarManager_CT2958529.dialogsManager.getDialogDataManager(dialogName);
                    dialogData.showDialog(window, app, EBToolbarManager_CT2958529.chevronManager.isChevronShown(), oToolbarManager_CT2958529);
                }
            }
        }, 1);
    };
    
    var init = function() {
        document.addEventListener("conduit-engine-onApiAddStuffResponse", function(e) { self.onApiAddStuffResponse(e); }, false);
        document.addEventListener("conduit-engine-onComponentDeleted", function(e) { EBToolbarManager_CT2958529.onComponentDeleted(e); }, false);
        document.addEventListener("conduit-engine-addDetectedComponent", function(e) { EBToolbarManager_CT2958529.addDetectedComponent(); }, false);
        document.addEventListener("conduit-engine-saveDetectedComponent", function(e) {
            EBChevronStaticManager_CT2958529.onchange(true);
            EBToolbarManager_CT2958529.contextMenuManager.onload();
        }, false);
        document.addEventListener("conduit-engine-removeDetectedComponent", function(e) { EBToolbarManager_CT2958529.removeDetectedComponent(); }, false);
    };

    init();
};

function EBBaseSectionManager_CT2958529() {
    this.xulElements = new Object();
    this.xulElements.showHideButton = null;
    this.xulElements.deleteButton = null;
    this.xulElements.btnUp = null;
    this.xulElements.btnDown = null;
    this.xulElements.listComponents = null;
    this.xulElements.listcolsComponents = null;

    var upArrow = "chrome://global/skin/arrow/arrow-up.gif";
    var upArrowDis = "chrome://global/skin/arrow/arrow-up-dis.gif";
    var downArrow = "chrome://global/skin/arrow/arrow-dn.gif";
    var downArrowDis = "chrome://global/skin/arrow/arrow-dn-dis.gif";

    this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
    this.disabled = false;
    
    this.onload = function(event) { };
    this.onunload = function(event) { };
    this.ondialogAccept = function(event) { };
    this.applyLanguagePack = function() { };
    this.changed = false;

    //common list functions
    this.btnCaptionHide = "";
    this.btnCaptionShow = "";

    this.onClickCheckBox = function(e) {
        //implement in inherited class
    };

    this.onDelete = function(e) {
        var iSelectedIndex = this.xulElements.listComponents.selectedIndex;
        //select other node

        var offset = (this.xulElements.listComponents.getRowCount() == iSelectedIndex + 1) ?
                                -1 : 1;

        if (this.xulElements.listComponents.getRowCount() > 1) {
            this.xulElements.listComponents.moveByOffset(offset, true, false);
            this.xulElements.listComponents.ensureElementIsVisible(this.xulElements.listComponents.selectedItem);
            this.listbox_onSelect();
        }
        else
            this.disableAllButtons();

        this.xulElements.listComponents.removeItemAt(iSelectedIndex);
    };

    this.getComponentXulItem = function(item, isDeletable) {
        var strDisplayText = item.DisplayText;
        var strDisplayIcon = item.DisplayIcon;
        var strCompID = item.UniqueCompID;

        var objListItem = document.createElement("listitem");
        var objCheckBox = document.createElement("listcell");
        var objTextImage = document.createElement("listcell");

        objListItem.setAttribute('allowevents', 'true');
        objListItem.setAttribute('style', 'height:20px');

        objCheckBox.setAttribute('isDeletable', isDeletable);
        objCheckBox.setAttribute('type', 'checkbox');
        objCheckBox.onclick = this.onClickCheckBox;
        objCheckBox.setAttribute('checked', item.isShow().toString());
        objCheckBox.setAttribute('id', strCompID);

        objTextImage.setAttribute('image', strDisplayIcon);
        objTextImage.setAttribute('label', strDisplayText);
        objTextImage.setAttribute('class', 'listcell-iconic');

        objListItem.appendChild(objCheckBox);
        objListItem.appendChild(objTextImage);
        return objListItem;
    };

    this.addComponents = function(itemsHash) {
        if (!itemsHash || itemsHash.Count() == 0) {
            this.disableAllButtons();
            return;
        }
        
        var item = null;
        var xulElement = null
        var isDeletable = false;
        for (var i = 0; i < itemsHash.Count(); i++) {
            item = itemsHash.GetByIndex(i);
            if (item.Permission == this.oWindow.oToolbar_CT2958529.toolbarDataParsing.Editable.FULL) {
                //add to user components positions array
                if (item.CompType == this.oWindow.oToolbar_CT2958529.toolbarDataParsing.ComponentType.UserAdded ||
                        item.CompType == this.oWindow.oToolbar_CT2958529.toolbarDataParsing.ComponentType.MyStuff)
                    isDeletable = true;
                else
                    isDeletable = false;

                xulElement = this.getComponentXulItem(item, isDeletable);
                this.xulElements.listComponents.appendChild(xulElement);
            }
        }
    };

    this.setShowHideBtnLabel = function(checked) {
        this.xulElements.showHideButton.label = (checked) ? this.btnCaptionHide : this.btnCaptionShow;
    };
    
    this.enableDisableDeleteBtn = function(isDeletable)
    {
        if(!this.xulElements.deleteButton) return;
        
        this.xulElements.deleteButton.disabled = !isDeletable;
    };

    this.enableDisableHideShowBtn = function(isDeletable) {
        if (!this.xulElements.showHideButton) return;
        
        this.xulElements.showHideButton.disabled = !isDeletable;
    };
    
    this.enableDisableMoveBtns = function() {
        var manager = this;

        var upBtn = function(isEnabled) {
            var image = (isEnabled) ? upArrow : upArrowDis;
            manager.xulElements.btnUp.disabled = !isEnabled;
            manager.xulElements.btnUp.image = image;
        };

        var dnBtn = function(isEnabled) {
            var image = (isEnabled) ? downArrow : downArrowDis;
            manager.xulElements.btnDown.disabled = !isEnabled;
            manager.xulElements.btnDown.image = image;
        };
        //no moving buttons
        if (!this.xulElements.btnDown || !this.xulElements.btnUp) return;

        if (!this.xulElements.listComponents.selectedItem) {
            upBtn(false);
            dnBtn(false);
            return;
        }

        var checkbox = this.xulElements.listComponents.selectedItem.firstChild;
        var isDeletable = parseBool(checkbox.getAttribute("isDeletable"));

        //item is not deletable
        if (!isDeletable) {
            upBtn(false);
            dnBtn(false);
            return;
        }

        var iSelectedIndex = this.xulElements.listComponents.selectedIndex;
        //check previus item
        if (iSelectedIndex == 0)
            upBtn(false);
        else {
            if (!parseBool(this.xulElements.listComponents.getItemAtIndex(iSelectedIndex - 1).firstChild.getAttribute("isDeletable")))
                upBtn(false);
            else
                upBtn(true);
        }

        //check next item
        if (iSelectedIndex + 1 == this.xulElements.listComponents.getRowCount())
            dnBtn(false);
        else {
            if (!parseBool(this.xulElements.listComponents.getItemAtIndex(iSelectedIndex + 1).firstChild.getAttribute("isDeletable")))
                dnBtn(false);
            else
                dnBtn(true);
        }
    };

    this.onMoveUp = function(e) {
        var oSelected = this.xulElements.listComponents.selectedItem;
        var oUpper = this.xulElements.listComponents.getItemAtIndex(this.xulElements.listComponents.selectedIndex-1);
        this.xulElements.listComponents.insertBefore(oSelected, oUpper);
        this.xulElements.listComponents.selectItem(oSelected);
        this.enableDisableMoveBtns();
    };

    this.onMoveDown = function(e) {
        var oSelected = this.xulElements.listComponents.selectedItem;
        var oLower = this.xulElements.listComponents.getItemAtIndex(this.xulElements.listComponents.selectedIndex + 1);
        this.xulElements.listComponents.insertBefore(oLower, oSelected);
        this.xulElements.listComponents.selectItem(oSelected);
        this.enableDisableMoveBtns();
    };

    this.listbox_onSelect = function(e) {
        if (!this.xulElements.listComponents.selectedItem) return;
        var checkbox = this.xulElements.listComponents.selectedItem.firstChild;
        var isChecked = parseBool(checkbox.getAttribute("checked"));
        this.setShowHideBtnLabel(isChecked);
        var isDeletable = parseBool(checkbox.getAttribute("isDeletable"));
        this.enableDisableDeleteBtn(isDeletable);
        this.enableDisableHideShowBtn(isDeletable);
        this.enableDisableMoveBtns(isDeletable);
    };

    this.listbox_onKeyPress = function(e) {
        //delete
        if (e.keyCode == 46 && !this.xulElements.deleteButton.disabled)
            this.onDelete();

        //space
        else if (e.charCode == e.DOM_VK_SPACE) {
            var event = new Object();
            event.target = this.xulElements.listComponents.selectedItem.firstChild;
            this.onClickCheckBox(event);
        }
    };

    this.disableAllButtons = function(e) {
        this.xulElements.deleteButton.disabled = true;
        this.xulElements.showHideButton.disabled = true;
        this.enableDisableMoveBtns();
    };

    this.onShowHide = function(e) {
        var selectedItem = this.xulElements.listComponents.selectedItem;
        var isChecked = parseBool(selectedItem.firstChild.getAttribute("checked"));
        selectedItem.firstChild.setAttribute("checked", (!isChecked).toString());
        this.setShowHideBtnLabel(!isChecked);
    };

    this.onCommandAlertSettings = function(event) {
        this.oWindow.EBAlertManager_CT2958529.OpenSettingsDialog(window);
    };
};
function EBToolbarOptions_CE_MyStuffComponents_CT2958529(isFromMyStuff) {
    this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
    this.isEngineShown = false;
    this.xulElements = new Object();
    this.xulElements.lblMyStuffComponents = document.getElementById("lblMyStuffComponents");
    this.xulElements.dscMyStuffComponents = document.getElementById("dscMyStuffComponents");
    this.xulElements.listComponents = document.getElementById("listMyStuffComponents");
    this.xulElements.listcolsComponents = document.getElementById("listcolsMyStuffComponents");
    this.xulElements.showHideButton = document.getElementById("showHideButtonMyStuff");
    this.xulElements.deleteButton = document.getElementById("deleteButtonMyStuff");
    this.xulElements.btnUp = document.getElementById("btnUpMyStuff");
    this.xulElements.btnDown = document.getElementById("btnDownMyStuff");
    this.xulElements.componentAlertEnable = document.getElementById("componentAlertEnable");
    this.xulElements.detectEnable = document.getElementById("detectEnable");
    this.xulElements.chkUsage = document.getElementById("chkUsage");
    this.xulElements.chkUntrusted = document.getElementById("chkUntrusted");
    this.xulElements.dscAlertSettings = document.getElementById("dscAlertSettings");
    this.xulElements.btnAlertSettings = document.getElementById("btnAlertSettings");

    this.changed = false;

    var disabled = false;
    var manager = this;
    this.onClickCheckBox = function(e) {
        var isChecked = parseBool(e.target.getAttribute("checked"));
        manager.setShowHideBtnLabel(!isChecked);
        e.target.setAttribute("checked", (!isChecked).toString());
    };

    this.onload = function() {
        this.isEngineShown = this.oWindow.EBActionManager_CT2958529.IsToolbarShown();
        this.xulElements.componentAlertEnable.setAttribute("disabled", !this.isEngineShown);
        this.xulElements.detectEnable.setAttribute("disabled", !this.isEngineShown);
        this.xulElements.chkUsage.setAttribute("disabled", !this.isEngineShown);
        if (this.isEngineShown) {
            this.xulElements.componentAlertEnable.setAttribute("checked", this.oWindow.oToolbarManager_CT2958529.isComponentAlertEnabled);
            this.xulElements.detectEnable.setAttribute("checked", this.oWindow.oToolbarManager_CT2958529.isDetectionEnabled);
            this.xulElements.chkUsage.setAttribute("checked", this.oWindow.oToolbarManager_CT2958529.usage.enabled);
            this.xulElements.chkUntrusted.setAttribute("checked", !this.oWindow.EBToolbarPreferenceManager_CT2958529.GetPref(this.oWindow.EBPreferenceConsts_CT2958529.approveUntrustedApps));
        }
        var myStuffItemsHash = this.oWindow.oToolbarManager_CT2958529.data.myStuffItemsHash;
        this.addComponents(myStuffItemsHash);

        if (!myStuffItemsHash || myStuffItemsHash.Count() <= 1)
            this.disableAllButtons();
    };

    this.onunload = function() { };

    this.isMyStuffPositionChanged = function(positionsHash) {
        var myStuffItemsHash = this.oWindow.oToolbarManager_CT2958529.data.myStuffItemsHash;
        if (positionsHash.Count() != myStuffItemsHash.Count()) return true;

        for (var i = 0; i < positionsHash.Count(); i++) {
            if (positionsHash.GetByIndex(i) != myStuffItemsHash.GetByIndex(i).UniqueCompID)
                return true;
        }

        return false;
    };

    this.acceptUserComponents = function() {
        var checkBox = null;
        var item = null;
        var positionsHash = new EBArrayHashObject_CT2958529();
        for (var i = 0; i < this.xulElements.listComponents.getRowCount(); i++) {
            checkBox = this.xulElements.listComponents.getItemAtIndex(i).firstChild;
            item = this.oWindow.oToolbarManager_CT2958529.data.myStuffItemsHash.GetByID(checkBox.id);
            positionsHash.Add(checkBox.id, checkBox.id);
            if (item.isShow() != parseBool(checkBox.getAttribute("checked"))) {
                this.changed = true;
                item.setShowState(!item.isShow());
            }
        }
        if (this.isMyStuffPositionChanged(positionsHash)) {
            this.oWindow.oToolbarManager_CT2958529.updateMyStuffComponents(positionsHash);
            this.oWindow.oToolbarManager_CT2958529.createChannelsArrayForAlertManager();
            this.changed = true;
        }
    };

    this.ondialogAccept = function() {
        if (disabled) return;
        var isUsagesEnabled = parseBool(this.xulElements.chkUsage.getAttribute("checked"));

        var isUntrustedEnabled = parseBool(this.xulElements.chkUntrusted.getAttribute("checked"));
        this.oWindow.EBToolbarPreferenceManager_CT2958529.SetPref(this.oWindow.EBPreferenceConsts_CT2958529.approveUntrustedApps, !isUntrustedEnabled);
        this.oWindow.EBPreferenceService_CT2958529.SaveAll();
        if (this.isEngineShown && (this.oWindow.oToolbarManager_CT2958529.usage.enabled != isUsagesEnabled))
            this.oWindow.oToolbarManager_CT2958529.usage.enabled = isUsagesEnabled;
        this.acceptUserComponents();
        var isCompAlertsEnabled = parseBool(this.xulElements.componentAlertEnable.getAttribute("checked"));
        var isDetectionEnabled = parseBool(this.xulElements.detectEnable.getAttribute("checked"));

        if (this.oWindow.oToolbarManager_CT2958529.isComponentAlertEnabled != isCompAlertsEnabled) {
            if (this.isEngineShown) this.oWindow.oToolbarManager_CT2958529.isComponentAlertEnabled = isCompAlertsEnabled;
            this.changed = true;
        }

        if (this.isEngineShown && (this.oWindow.oToolbarManager_CT2958529.isDetectionEnabled != isDetectionEnabled))
            this.oWindow.oToolbarManager_CT2958529.isDetectionEnabled = isDetectionEnabled;

    };

    this.applyLanguagePack = function() {
        this.xulElements.lblMyStuffComponents.value = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_OPTIONS_DLG_COMPONENTS_HEADING');
        this.xulElements.dscMyStuffComponents.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_OPTIONS_DLG_COMPONENTS_INTRO').replace(/\\n/g, "<html:br />");
        this.xulElements.deleteButton.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_DELETE_COMPONENT_BUTTON'));
        this.btnCaptionHide = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_HIDE_COMPONENT_BUTTON');
        this.btnCaptionShow = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_SHOW_COMPONENT_BUTTON');

        this.xulElements.detectEnable.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_OPTIONS_DLG_SETTINGS_ENABLE_DETECTION'));
        this.xulElements.componentAlertEnable.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_OPTIONS_DLG_SETTINGS_ENABLE_COMPONENTS_ALERTS'));
        this.xulElements.chkUsage.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_ENGINE_OPTIONS_DLG_SETTINGS_ADDITIONAL_USAGE'));
        this.xulElements.dscAlertSettings.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CELP_STR_ID_OPTIONS_DLG_NOTIFICATION_SETTINGS_DESCRIPTION');
        this.xulElements.btnAlertSettings.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_NOTIFICATION_SETTINGS_BUTTON'));

        this.xulElements.listComponents.selectedIndex = 0;
    };
    
    this.onCommandAlertSettings = function(event) {
        this.oWindow.EBAlertManager_CT2958529.OpenSettingsDialog(window);
    };
};

EBToolbarOptions_CE_MyStuffComponents_CT2958529.prototype = new EBBaseSectionManager_CT2958529();

var EBToolbarOptionsPreferenceConsts_CT2958529 =
{
    PrefPrefix: 'components'
}

var EBToolbarOptionsDialogConsts_CT2958529 =
{
    FileNameTB: 'options.xul',
    FileNameCE: 'optionsCE.xul',
    DialogName: 'optionsDialogName_CT2958529',
    DialogType: 'EBOptionsDialog_CT2958529',
    EditableCheckBoxPrefixID: 'checkBoxEditableComponent',
    EditableCheckBoxAttributeCompID: 'EB_EDITABLE_CHECK_BOX_COMP_ID',
    PersonalComponentsTabIndex: 0,
    PredefinedComponentsTabIndex: 1,
    ThirdPartyComponentsTabIndex: 2,
    AreYouSureConfirm: 'Are you sure?'
}
function EBToolbarOptionsDialogManager_CT2958529() {
    var dialogId = "ebOptionsDialog";
    this.xulElements = new Object();
    this.xulElements.okBtn = document.getElementById(dialogId).getButton("accept");
    this.xulElements.cancelBtn = document.getElementById(dialogId).getButton("cancel");

    var isFromEmailNotifier = (window.arguments) ? window.arguments[0] : false;
    var isFromMyStuff = (window.arguments) ? window.arguments[1] : false;
    
    this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
    this.managers = new Array();
    if (!this.oWindow.EBGlobalConsts_CT2958529.IsEngine) {
        this.personalComponentsDialogManager = new EBToolbarOptions_PersonalComponents_CT2958529(isFromEmailNotifier);
        this.managers.push(this.personalComponentsDialogManager);

        this.settingsDialogManager = new EBToolbarOptions_Settings_CT2958529();
        this.managers.push(this.settingsDialogManager);

        this.predefinedComponentsDialogManager = new EBToolbarOptions_PredefinedComponents_CT2958529();
        this.managers.push(this.predefinedComponentsDialogManager);

        this.thirdPartyComponentsDialogManager = new EBToolbarOptions_ThirdPartyComponents_CT2958529();
        this.managers.push(this.thirdPartyComponentsDialogManager);
    }
    else {
        this.MyStuffComponentsDialogManager = new EBToolbarOptions_CE_MyStuffComponents_CT2958529(true);
        this.managers.push(this.MyStuffComponentsDialogManager);
    }

    this.onload = function(event) {
        //for toolbar only
        if (!this.oWindow.EBGlobalConsts_CT2958529.IsEngine)
            this.handleVisibility();

        for (var i = 0; i < this.managers.length; this.managers[i].onload(), i++);

        this.applyLanguagePack();
    };

    this.onunload = function(event) {
        for (var i = 0; i < this.managers.length; this.managers[i].onunload(), i++);
    };

    var bSelectedTab = false;
    var enableDisableTab = function(tabManager, isEnabled) {
        if (!isEnabled) {
            tabManager.disabled = true;
            tabManager.xulElements.tabPanel.style.visibility = "hidden";
            tabManager.xulElements.tab.style.display = "none";
        }
        else if (!bSelectedTab) {
            tabManager.xulElements.tab.click();
            bSelectedTab = true;
        }
    };

    this.handleVisibility = function() {
            var tabsVisibilityState = this.oWindow.oToolbarManager_CT2958529.data.generalToolbarInfo.tabsVisibilityState;

            enableDisableTab(this.personalComponentsDialogManager, tabsVisibilityState.personalComp);
            enableDisableTab(this.predefinedComponentsDialogManager, tabsVisibilityState.predefined);
            enableDisableTab(this.thirdPartyComponentsDialogManager, tabsVisibilityState.thirdParty);
            enableDisableTab(this.settingsDialogManager, true);

            //show alert settings button on settings dialog in case that personal comps dialog is not visible
            if (!tabsVisibilityState.personalComp)
                this.settingsDialogManager.xulElements.btnAlertSettings.style.display = "";

    };

    this.broadcastChange = function() {
        if (this.oWindow.EBGlobalConsts_CT2958529.IsEngine) {
            var self = this;
            this.oWindow.setTimeout(function() {
                self.oWindow.oToolbarManager_CT2958529._loadMyStuffComponents(true);
            }, 1);
        }
        else
            this.oWindow.EBToolbarManager_CT2958529.broadcastRebuild(this.oWindow.oToolbar_CT2958529.toolbarDataParsing.observerData.settings);
    };

    this.ondialogAccept = function() {
        var i;
        for (i = 0; i < this.managers.length; this.managers[i].ondialogAccept(), i++);
        var isChanged = false;

        for (i = 0; i < this.managers.length; isChanged |= this.managers[i].changed, i++);

        if (isChanged)
            this.broadcastChange();
    };

    this.applyLanguagePack = function() {
        var dialogsDirection = this.oWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "ebOptionsDialog");

        this.xulElements.okBtn.label = this.oWindow.oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_GLOBAL_OK");
        this.xulElements.cancelBtn.label = this.oWindow.oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_GLOBAL_CANCEL");
        if(this.oWindow.EBGlobalConsts_CT2958529.IsEngine)
		window.document.title = this.oWindow.oToolbarManager_CT2958529.getLPKey("CELP_STR_ID_ENGINE_OPTIONS_DLG_TITLE");

        for (var i = 0; i < this.managers.length; this.managers[i].applyLanguagePack(), i++);
    };
};
var EBToolbarOptionsStaticDialogManager_CT2958529 = {
    OpenDialog: function(objParentWindow, isFromEMailNotifier, isFromMyStuff) {
        //check if the dialog exsits to focus on it
        var oOptionsDialog = this.GetDialog();
        if (oOptionsDialog)
            oOptionsDialog.focus();
        else {
            var strChromePath = EBGlobalConsts_CT2958529.IsEngine ? EBToolbarOptionsDialogConsts_CT2958529.FileNameCE : EBToolbarOptionsDialogConsts_CT2958529.FileNameTB;
            strChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + strChromePath;
            objParentWindow.openDialog(strChromePath,
                                        EBToolbarOptionsDialogConsts_CT2958529.DialogName,
                                        'modal,centerscreen,chrome,resizable=no',
                                        isFromEMailNotifier, isFromMyStuff);
        }
    },

    GetDialog: function() {
        var strOptionsDialogType = EBToolbarOptionsDialogConsts_CT2958529.DialogType;
        var strOptionsDialogName = EBToolbarOptionsDialogConsts_CT2958529.DialogName;

        var oOptionsDialog = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName(strOptionsDialogType, strOptionsDialogName);

        return oOptionsDialog;
    }
};
/// <reference path="BaseSectionManager.js" />
function EBToolbarOptions_PersonalComponents_CT2958529(isFromEmailNotifier) {
    
    this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
    
    this.xulElements = new Object();
    this.xulElements.tab = document.getElementById("tabPersonalComponents");
    this.xulElements.tabPanel = document.getElementById("tpPersonalComponents");
    this.xulElements.lblPersonalComponents = document.getElementById("lblPersonalComponents");
    this.xulElements.dscPersonalComponents = document.getElementById("dscPersonalComponents");
    this.xulElements.rowEmail = document.getElementById("rowEmail");
    this.xulElements.checkEMailNotifier = document.getElementById("checkEMailNotifier");
    this.xulElements.dscEmailNotifier = document.getElementById("dscEmailNotifier");
    this.xulElements.btnEMailNotifier = document.getElementById("btnEMailNotifier");
    this.xulElements.rowPrivacy = document.getElementById("rowPrivacy");
    this.xulElements.checkPrivacy = document.getElementById("checkPrivacy");
    this.xulElements.dscPrivacy = document.getElementById("dscPrivacy");
    this.xulElements.rowWeather = document.getElementById("rowWeather");
    this.xulElements.checkWeather = document.getElementById("checkWeather");
    this.xulElements.dscWeather = document.getElementById("dscWeather");
    this.xulElements.rowRadio = document.getElementById("rowRadio");
    this.xulElements.checkRadio = document.getElementById("checkRadio");
    this.xulElements.dscRadio = document.getElementById("dscRadio");
    this.xulElements.rowFacebook = document.getElementById("rowFacebook");
    this.xulElements.checkFacebook = document.getElementById("checkFacebook");
    this.xulElements.dscFacebook = document.getElementById("dscFacebook");
    this.xulElements.btnFacebook = document.getElementById("btnFacebook");
    this.xulElements.rowAlertSettings = document.getElementById("rowAlertSettings");
    this.xulElements.btnAlertSettings = document.getElementById("btnAlertSettings");
    this.xulElements.dscAlertSettings = document.getElementById("dscAlertSettings");

    var oEMailNotifierItem = this.oWindow.oToolbarManager_CT2958529.data.getEmailNotifierItem();
    var oPrivacyItem = this.oWindow.oToolbarManager_CT2958529.data.getPrivacyItem();
    var oWeatherItem = this.oWindow.oToolbarManager_CT2958529.data.getWeatherItem();
    var oRadioItem = this.oWindow.oToolbarManager_CT2958529.data.getRadioItem();
    var oFacebookItem = this.oWindow.oToolbarManager_CT2958529.data.getFacebookItem();
    var that = this;
    var emailNotifierCheckedEvent = function() {
        that.xulElements.btnEMailNotifier.setAttribute("disabled", !that.xulElements.checkEMailNotifier.checked);
    };

    var facebookCheckedEvent = function() {
        that.xulElements.btnFacebook.disabled = !that.xulElements.checkFacebook.checked;
    };

    this.onload = function() {
        if (this.disabled) return;

        if (oEMailNotifierItem && oEMailNotifierItem.isAvailable()) {
            this.xulElements.checkEMailNotifier.checked = oEMailNotifierItem.isShow();
            this.xulElements.checkEMailNotifier.setAttribute("src", oEMailNotifierItem.DisplayIcon);

            this.xulElements.btnEMailNotifier.disabled = !oEMailNotifierItem.isShow();
            this.xulElements.checkEMailNotifier.addEventListener("click", emailNotifierCheckedEvent, false);
        }
        else
            this.xulElements.rowEmail.style.display = "none";

        if (oPrivacyItem && oPrivacyItem.isAvailable()) {
            this.xulElements.checkPrivacy.checked = oPrivacyItem.isShow();
            this.xulElements.checkPrivacy.setAttribute("src", oPrivacyItem.DisplayIcon);
        }
        else
            this.xulElements.rowPrivacy.style.display = "none";

        if (oWeatherItem && oWeatherItem.isAvailable()) {
            this.xulElements.checkWeather.checked = oWeatherItem.isShow();
            this.xulElements.checkWeather.setAttribute("src", oWeatherItem.DisplayIcon);
        }
        else
            this.xulElements.rowWeather.style.display = "none";

        if (oRadioItem && oRadioItem.isAvailable() && EBGlobalManager_CT2958529.IsWindowsPlatform()) {
            this.xulElements.checkRadio.checked = oRadioItem.isShow();
            this.xulElements.checkRadio.setAttribute("src", oRadioItem.DisplayIcon);
        }
        else
            this.xulElements.rowRadio.style.display = "none";

        if (oFacebookItem && oFacebookItem.isAvailable()) {
            this.xulElements.checkFacebook.checked = oFacebookItem.isShow();
            this.xulElements.checkFacebook.setAttribute("src", oFacebookItem.DisplayIcon);
            
            this.xulElements.btnFacebook.disabled = !oFacebookItem.isShow();
            this.xulElements.checkFacebook.addEventListener("click", facebookCheckedEvent, false);
        }
        else
            this.xulElements.rowFacebook.style.display = "none";

        //if the FB comp is the old one, show setting button
        if (oFacebookItem instanceof this.oWindow.oToolbar_CT2958529.toolbarDataParsing.toolbarItems.facebook) {
            this.xulElements.btnFacebook.style.display = "inline";
        }
    };

    this.onunload = function() {
        this.xulElements.checkEMailNotifier.removeEventListener("click", emailNotifierCheckedEvent, false);
    };

    this.ondialogAccept = function() {
        if (this.disabled) return;

        if (oEMailNotifierItem && oEMailNotifierItem.isAvailable()) {
            if (oEMailNotifierItem.isShow() != this.xulElements.checkEMailNotifier.checked) {
                oEMailNotifierItem.setShowState(this.xulElements.checkEMailNotifier.checked);
                this.changed = true;
            }
        }

        if (oPrivacyItem && oPrivacyItem.isAvailable()) {
            if (oPrivacyItem.isShow() != this.xulElements.checkPrivacy.checked) {
                oPrivacyItem.setShowState(this.xulElements.checkPrivacy.checked);
                this.changed = true;
            }
        }

        if (oWeatherItem && oWeatherItem.isAvailable()) {
            if (oWeatherItem.isShow() != this.xulElements.checkWeather.checked) {
                oWeatherItem.setShowState(this.xulElements.checkWeather.checked);
                this.changed = true;
            }
        }

        if (oRadioItem && oRadioItem.isAvailable() && EBGlobalManager_CT2958529.IsWindowsPlatform()) {
            if (oRadioItem.isShow() != this.xulElements.checkRadio.checked) {
                oRadioItem.setShowState(this.xulElements.checkRadio.checked);
                this.changed = true;
            }
        }

        if (oFacebookItem && oFacebookItem.isAvailable()) {
            if (oFacebookItem.isShow() != this.xulElements.checkFacebook.checked) {
                oFacebookItem.setShowState(this.xulElements.checkFacebook.checked);
                this.changed = true;
            }
        }
    };

    this.applyLanguagePack = function() {
        this.xulElements.tab.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PERSONAL_COMPONENTS_TAB_TITLE'));
        this.xulElements.lblPersonalComponents.value = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PERSONAL_COMPONENTS_TAB_TITLE');
        this.xulElements.dscPersonalComponents.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PERSONAL_COMPONENTS_TAB_DESCRIPTION').replace(/\n/g, "<html:br />");
        this.xulElements.checkEMailNotifier.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_EMAIL_NOTIFIER_COMP_TITLE'));
        this.xulElements.btnEMailNotifier.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_EMAIL_NOTIFIER_SETTINGS_BUTTON'));
        this.xulElements.dscEmailNotifier.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_EMAIL_NOTIFIER_COMP_DESCRIPTION');
        this.xulElements.dscPrivacy.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PRIVACY_COMP_DESCRIPTION');
        this.xulElements.dscWeather.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_WEATHER_COMP_DESCRIPTION');
        this.xulElements.dscRadio.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_RADIO_COMP_DESCRIPTION');
        this.xulElements.checkPrivacy.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PRIVACY_COMP_TITLE'));
        this.xulElements.checkWeather.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_WEATHER_COMP_TITLE'));
        this.xulElements.checkRadio.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_RADIO_COMP_TITLE'));
        this.xulElements.btnAlertSettings.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_NOTIFICATION_SETTINGS_BUTTON'));
        this.xulElements.dscAlertSettings.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_NOTIFICATION_SETTINGS_DESCRIPTION');
        this.xulElements.checkFacebook.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_FACEBOOK_COMP_TITLE'));
        this.xulElements.dscFacebook.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_FACEBOOK_COMP_NOTIFICATION_DESCRIPTION');
        this.xulElements.btnFacebook.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_FACEBOOK_SETTINGS_BUTTON'));
    };

    this.onCommandEMailNotifier = function(event) {
        this.oWindow.EBEMailNotifierDialogsManager_CT2958529.OpenSettingsDialog(window, true, "");
    };

    this.onCommandFacebook = function(event) {
        //if the facebook component is not initialized, init it, because otherwise facebook manager has no data
        var fbManager = this.oWindow.oToolbar_CT2958529.facebook.manager;
        if (!this.oWindow.EBComponentsManager_CT2958529.GetFacebookComponent()) {
            var fbItem = this.oWindow.oToolbarManager_CT2958529.data.getFacebookItem();
            if (!fbItem) return;
            fbManager.register(fbItem,
                this.oWindow.oToolbarManager_CT2958529.data.languagePack,
                this.oWindow.EBActionManager_CT2958529.GetToolbarName());
        }

        fbManager.alertsManager.openSettingsDialog(window);
    };
};

EBToolbarOptions_PersonalComponents_CT2958529.prototype = new EBBaseSectionManager_CT2958529();
function EBToolbarOptions_PredefinedComponents_CT2958529() {
    this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

    this.xulElements = new Object();
    this.xulElements.tab = document.getElementById("tabPredefinedComponents");
    this.xulElements.tabPanel = document.getElementById("tpPredefinedComponents");
    this.xulElements.lblPredefinedComponents = document.getElementById("lblPredefinedComponents");
    this.xulElements.dscPredefinedComponents = document.getElementById("dscPredefinedComponents");
    this.xulElements.listComponents = document.getElementById("listPredefinedComponents");
    this.xulElements.listcolsComponents = document.getElementById("listcolsPredefinedComponents");
    this.xulElements.showHideButton = document.getElementById("showHideButton");
    this.xulElements.deleteButton = document.getElementById("deleteButton");
    this.xulElements.btnUp = document.getElementById("btnUp");
    this.xulElements.btnDown = document.getElementById("btnDown");

    var firstUserComponentIndex = 0;
    
    var manager = this;
    this.onClickCheckBox = function(e) {
        var isChecked = parseBool(e.target.getAttribute("checked"));
        manager.setShowHideBtnLabel(!isChecked);
        e.target.setAttribute("checked", (!isChecked).toString());
    };

    this.onload = function() {
        if (this.disabled) return;

        this.addComponents(this.oWindow.oToolbarManager_CT2958529.data.publisherItemsHash);
        var userItemsHash = this.oWindow.oToolbarManager_CT2958529.data.userItemsHash;
        if (userItemsHash && userItemsHash.Count() > 0) {
            firstUserComponentIndex = this.xulElements.listComponents.getRowCount();
            this.addComponents(this.oWindow.oToolbarManager_CT2958529.data.userItemsHash);
        }
    };
    
    this.onunload = function() { };

    this.isUserPositionChanged = function(arrNewPositions) {
        var usersHash = this.oWindow.oToolbarManager_CT2958529.data.userItemsHash;
        if (arrNewPositions.length != usersHash.Count()) return true;

        for (var i = 0; i < arrNewPositions.length; i++) {
            if (arrNewPositions[i] != usersHash.GetByIndex(i).UniqueCompID)
                return true;
        }

        return false;
    };
    
    this.acceptPredefinedComponents = function() {
        var endIndex = (firstUserComponentIndex) ? firstUserComponentIndex : this.xulElements.listComponents.getRowCount();
        var checkBox = null;
        var item = null;
        for (var i = 0; i < endIndex; i++) {
            checkBox = this.xulElements.listComponents.getItemAtIndex(i).firstChild;
            item = this.oWindow.oToolbarManager_CT2958529.data.publisherItemsHash.GetByID(checkBox.id);
            if (item.isShow() != parseBool(checkBox.getAttribute("checked"))) {
                this.changed = true;
                item.setShowState(!item.isShow());
            }
        }
    };

    this.acceptUserComponents = function() {
        var checkBox = null;
        var item = null;
        var positionArr = new Array();
        for (var i = firstUserComponentIndex; i < this.xulElements.listComponents.getRowCount(); i++) {
            checkBox = this.xulElements.listComponents.getItemAtIndex(i).firstChild;
            item = this.oWindow.oToolbarManager_CT2958529.data.userItemsHash.GetByID(checkBox.id);
            positionArr.push(checkBox.id);
            if (item.isShow() != parseBool(checkBox.getAttribute("checked"))) {
                this.changed = true;
                item.setShowState(!item.isShow());
            }
        }

        if (this.isUserPositionChanged(positionArr)) {
            this.oWindow.EBUserComponentsManager_CT2958529.RepositionComponents(positionArr);
            this.changed = true;
        }
    };

    this.ondialogAccept = function() {
        if (this.disabled) return;

        this.acceptPredefinedComponents();
        if (firstUserComponentIndex != 0)
            this.acceptUserComponents();
    };

    this.enableDisableHideShowBtn = function(isDeletable) {
        //Don't remove this function
    };

    this.applyLanguagePack = function() {
        this.xulElements.tab.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PREDEFINED_COMPONENTS_TAB_TITLE'));
        this.xulElements.lblPredefinedComponents.value = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PREDEFINED_COMPONENTS_TAB_TITLE');
        this.xulElements.dscPredefinedComponents.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_PREDEFINED_COMPONENTS_TAB_DESCRIPTION').replace(/\n/g, "<html:br />");
        this.xulElements.deleteButton.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_DELETE_COMPONENT_BUTTON'));
        this.btnCaptionHide = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_HIDE_COMPONENT_BUTTON');
        this.btnCaptionShow = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_SHOW_COMPONENT_BUTTON');

        this.xulElements.listComponents.selectedIndex = 0;
    };
};

EBToolbarOptions_PredefinedComponents_CT2958529.prototype = new EBBaseSectionManager_CT2958529();
function EBToolbarOptions_Settings_CT2958529() {
    this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

    this.xulElements = new Object();
    this.xulElements.tab = document.getElementById("tabAdditionalSettings");
    this.xulElements.tabPanel = document.getElementById("tpAdditionalSettings");
    this.xulElements.lblAdditionalSettings = document.getElementById("lblAdditionalSettings");
    this.xulElements.dscAdditionalSettings = document.getElementById("dscAdditionalSettings");
    this.xulElements.checkEnableHistory = document.getElementById("checkEnableHistory");
    this.xulElements.checkEnableSuggest = document.getElementById("checkEnableSuggest");
    this.xulElements.btnClearHistory = document.getElementById("btnClearHistory");
    this.xulElements.checkEnableUsage = document.getElementById("checkEnableUsage");
    this.xulElements.checkEnableClickToSearchBox = document.getElementById("checkEnableClickToSearchBox");
    this.xulElements.checkEnableSearchBackToDefault = document.getElementById("checkEnableSearchBackToDefault");
    this.xulElements.checkDontShowMCDetectedPopup = document.getElementById("checkDontShowMCDetectedPopup");
    this.xulElements.checkFixPageNotFoundError = document.getElementById("checkFixPageNotFoundError");
    this.xulElements.checkSearchFromAddress = document.getElementById("checkSearchFromAddress");
    this.xulElements.checkSearchInNewTab = document.getElementById("checkSearchInNewTab");
    this.xulElements.btnAlertSettings = document.getElementById("btnAlertSettings2");
    
    var bHistoryValue = null;
    var bSuggestValue = null;
    var bEnableUsageValue = null;
    var bEnableClickToSearchBox = null;
    var bEnableSearchBackToDefault = null;
    var bDontShowMCPopup = null;
    var bFixPageNotFoundErrors = null;
    var bEnableSearchFromAddress = null;
    var bEnableSearchInNewTab = null;
    var newTabManager = null;

    var manager = this;
    var enebleHistoryEvent = function() {
        manager.xulElements.checkEnableSuggest.disabled = !manager.xulElements.checkEnableHistory.checked;
    };

    this.changeSearchSuggestState = function(bIsEnable) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EnableSearchSuggest, bIsEnable);

        //notify observers
        var aSubject = new Object();
        aSubject.wrappedJSObject = aSubject;
        aSubject.originalCTID = EBGlobalConsts_CT2958529.ToolbarCTID;
        aSubject.isEnabled = bIsEnable;
        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
                                                            EBSearchBoxConsts_CT2958529.observerTopic,
                                                            EBSearchBoxConsts_CT2958529.observerData.changeSearchSuggestState);
    };

    this.changeSearchHistoryState = function(bIsEnable, bIsConfirm) {
        if (bIsEnable || (!bIsConfirm || EBGlobalManager_CT2958529.Confirm(window,
                                        this.oWindow.EBActionManager_CT2958529.GetToolbarName(),
                                        this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_CONFIRM_CLEAR_HISTORY')))) {
            //clear both history and suggest files
            this.oWindow.EBSpecialCommands_CT2958529.DELETE_SEARCH_HISTORY(bIsEnable ,bIsConfirm );
            //notify observers
        }
    };


    

    this.onload = function(event) {
        if (this.disabled) return;

        bHistoryValue = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EnableSearchHistory);
        bSuggestValue = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EnableSearchSuggest);
        bEnableUsageValue = this.oWindow.oToolbarManager_CT2958529.usage.enabled;
        bEnableClickToSearchBox = this.oWindow.EBSelectToSearchBox_CT2958529.isEnabled();
        var oSearchComponent = this.oWindow.EBComponentsManager_CT2958529.GetSearchBoxComponent();
        bEnableSearchBackToDefault = (oSearchComponent) ? oSearchComponent.backToDefault() : false;
        bDontShowMCPopup = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipShow);
        bFixPageNotFoundErrors = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.FixPageNotFoundErrors);
        bEnableSearchFromAddress = EBSearchFromAddressBar_CT2958529.isEnabled();
        newTabManager = this.oWindow.oToolbar_CT2958529.searchInNewTab.getManager(EBGlobalConsts_CT2958529.ToolbarCTID);
        bEnableSearchInNewTab = (newTabManager && newTabManager.userEnabled) ? true : false;

        if (bHistoryValue == null) bHistoryValue = true;
        if (bSuggestValue == null) bSuggestValue = true;
        if (bEnableUsageValue == null) bEnableUsageValue = true;
        if (bEnableClickToSearchBox == null) bEnableClickToSearchBox = true;
        if (bEnableSearchBackToDefault == null) bEnableSearchBackToDefault = true;
        if (bDontShowMCPopup == null) bDontShowMCPopup = true;
        if (bFixPageNotFoundErrors == null) bFixPageNotFoundErrors = EBGlobalConsts_CT2958529.FixPageNotFoundErrorsChecked;

        this.xulElements.checkEnableHistory.checked = bHistoryValue;
        this.xulElements.checkEnableSuggest.checked = bSuggestValue;
        this.xulElements.checkEnableUsage.checked = bEnableUsageValue;
        this.xulElements.checkEnableClickToSearchBox.checked = bEnableClickToSearchBox;
        this.xulElements.checkEnableSearchBackToDefault.checked = bEnableSearchBackToDefault;

        if (EBActionManager_CT2958529.IsToolbarMC())
            this.xulElements.checkDontShowMCDetectedPopup.checked = bDontShowMCPopup;
        else
            this.xulElements.checkDontShowMCDetectedPopup.style.display = "none";

        this.xulElements.checkSearchFromAddress.checked = bEnableSearchFromAddress;

        if (EBGlobalConsts_CT2958529.FixPageNotFoundErrorsEnabled)
            this.xulElements.checkFixPageNotFoundError.checked = bFixPageNotFoundErrors;
        else
            this.xulElements.checkFixPageNotFoundError.style.display = "none";

        this.xulElements.checkEnableSuggest.disabled = !bHistoryValue;
        this.xulElements.checkEnableHistory.addEventListener("click", enebleHistoryEvent, false);

        if (this.oWindow.oToolbarManager_CT2958529.searchInNewTabAvailable())
            this.xulElements.checkSearchInNewTab.checked = bEnableSearchInNewTab;
        else
            this.xulElements.checkSearchInNewTab.style.display = "none";
    };

    this.onunload = function(event) {
        delete manager;
        this.xulElements.checkEnableHistory.removeEventListener("click", enebleHistoryEvent, false);
        delete enebleHistoryEvent;
    };

    this.ondialogAccept = function(event) {
        if (this.disabled) return;
        
        try {
            if (bHistoryValue != this.xulElements.checkEnableHistory.checked) {
                this.changed = true;
                EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EnableSearchHistory, !bHistoryValue);
                if (!this.xulElements.checkEnableHistory.checked) 
                    this.changeSearchSuggestState(false);
                this.changeSearchHistoryState(!bHistoryValue, false);
            }

            if (this.xulElements.checkEnableHistory.checked && bSuggestValue != this.xulElements.checkEnableSuggest.checked) {
                this.changed = true;
                this.changeSearchSuggestState(!bSuggestValue);
            }

            if (bEnableUsageValue != this.xulElements.checkEnableUsage.checked) {
                this.oWindow.oToolbarManager_CT2958529.usage.enabled = !bEnableUsageValue;
            }

            if (bEnableClickToSearchBox != this.xulElements.checkEnableClickToSearchBox.checked) {
                this.changed = true;
                EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.EnableClickToSearchBox, !bEnableClickToSearchBox);
            }

            if (bEnableSearchBackToDefault != this.xulElements.checkEnableSearchBackToDefault.checked) {
                this.changed = true;
                EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.SearchBackToDefault, !bEnableSearchBackToDefault);
            }

            if (bDontShowMCPopup != this.xulElements.checkDontShowMCDetectedPopup.checked) {
                this.changed = true;
                EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.MCDetectTooltipShow, !bDontShowMCPopup);
            }

            if (EBGlobalConsts_CT2958529.FixPageNotFoundErrorsEnabled &&
                    bFixPageNotFoundErrors != this.xulElements.checkFixPageNotFoundError.checked) {
                this.changed = true;
                EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.FixPageNotFoundErrors, !bFixPageNotFoundErrors);
                this.oWindow.oToolbarManager_CT2958529.fix404Checked(!bFixPageNotFoundErrors);
            }

            if (bEnableSearchFromAddress != this.xulElements.checkSearchFromAddress.checked)
                EBSearchFromAddressBar_CT2958529.changeState(!bEnableSearchFromAddress);

            if (bEnableSearchInNewTab != this.xulElements.checkSearchInNewTab.checked) {
                //no need to refresh toolbar
                if (newTabManager)
                    newTabManager.userEnabled = !bEnableSearchInNewTab;
            }
        }
        catch (e) {
            EBLog(e);
        }
    };

    this.applyLanguagePack = function() {
        this.xulElements.tab.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_TAB_TITLE'));
        this.xulElements.lblAdditionalSettings.value = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_TAB_TITLE');
        this.xulElements.dscAdditionalSettings.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_TAB_DESCRIPTION').replace(/\n/g, "<html:br />");
        this.xulElements.checkEnableHistory.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_ENABLE_HISTORY'));
        this.xulElements.checkEnableSuggest.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_SUGGEST'));
        this.xulElements.checkEnableUsage.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_USAGE__2'));
        this.xulElements.checkEnableClickToSearchBox.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_SHOW_SELECTED_TEXT_ON_WEBPAGE_IN_SEARCH_BOX__2'));
        this.xulElements.checkEnableSearchBackToDefault.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_BACK_TO_DEFAULT_SEARCH_ENGINE__2'));
        this.xulElements.checkDontShowMCDetectedPopup.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_SHOW_POPUP_ON_COMMUNITY_DETECTED__2'));
        this.xulElements.checkFixPageNotFoundError.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_SHOW_AN_ALTERNATE_SEARCH_PAGE_WHEN_WEB_PAGES_ARE_NOT_FOUND'));
        this.xulElements.checkSearchFromAddress.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ENABLE_SEARCH_ADDRESS_BAR'));
        this.xulElements.btnClearHistory.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_BUTTON_CLEAR_HISTORY'));
        this.xulElements.checkSearchInNewTab.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_ADDITIONAL_SEARCH_IN_NEW_TAB'));
        this.xulElements.btnAlertSettings.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_NOTIFICATION_SETTINGS_BUTTON'));
    };
};
EBToolbarOptions_Settings_CT2958529.prototype = new EBBaseSectionManager_CT2958529();

function EBToolbarOptions_ThirdPartyComponents_CT2958529() {
    this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
    
    this.xulElements = new Object();
    this.xulElements.tab = document.getElementById("tabThirdPartyComponents");
    this.xulElements.tabPanel = document.getElementById("tpThirdPartyComponents");
    this.xulElements.lblThirdPartyComponents = document.getElementById("lblThirdPartyComponents");
    this.xulElements.dscThirdPartyComponents = document.getElementById("dscThirdPartyComponents");
    this.xulElements.showHideButton = document.getElementById("btnShowHide3rdParty");
    this.xulElements.listComponents = document.getElementById("listThirdPartyComponents");
    this.xulElements.listcolComponents = document.getElementById("listcolsThirdPartyComponents");

    var manager = this;
    this.onClickCheckBox = function(e) {
        var isChecked = parseBool(e.target.getAttribute("checked"));
        manager.setShowHideBtnLabel(!isChecked);
        e.target.setAttribute("checked", (!isChecked).toString());
    };
    var disabled = false;

    this.onload = function() {
        if (this.disabled) return;

        var thirdPartyItemsHash = this.oWindow.oToolbarManager_CT2958529.data.thirdPartyItemsHash;
        if (!thirdPartyItemsHash || thirdPartyItemsHash.Count() == 0 || !EBGlobalManager_CT2958529.IsWindowsPlatform()) {
            this.disabled = true;
            this.xulElements.tabPanel.style.visibility = "hidden";
            this.xulElements.tab.style.display = "none";
            return;
        }

        this.addComponents(this.oWindow.oToolbarManager_CT2958529.data.thirdPartyItemsHash);
    };

    this.onunload = function() { };

    this.ondialogAccept = function() {
        if (this.disabled) return;

        var checkBox = null;
        var item = null;
        for (var i = 0; i < this.xulElements.listComponents.getRowCount(); i++) {
            checkBox = this.xulElements.listComponents.getItemAtIndex(i).firstChild;
            item = this.oWindow.oToolbarManager_CT2958529.data.thirdPartyItemsHash.GetByID(checkBox.id);
            if (item.isShow() != parseBool(checkBox.getAttribute("checked"))) {
                this.changed = true;
                item.setShowState(!item.isShow());
            }
        }
    };

    this.applyLanguagePack = function() {
        if (disabled) return;

        this.xulElements.tab.setAttribute('label', this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_USEFUL_COMPONENTS_TAB_TITLE'));
        this.xulElements.lblThirdPartyComponents.value = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_USEFUL_COMPONENTS_TAB_TITLE');
        this.xulElements.dscThirdPartyComponents.innerHTML = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_USEFUL_COMPONENTS_TAB_DESCRIPTION').replace(/\n/g, "<html:br />");
        this.btnCaptionHide = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_HIDE_COMPONENT_BUTTON');
        this.btnCaptionShow = this.oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_OPTIONS_DLG_SHOW_COMPONENT_BUTTON');

        this.xulElements.listComponents.selectedIndex = 0;
    };
};

EBToolbarOptions_ThirdPartyComponents_CT2958529.prototype = new EBBaseSectionManager_CT2958529();
var EBRadioConsts_CT2958529 = 
{
    xmlTags :
    {
        RADIO_STATIONS  : 'RADIO_STATIONS',
        RADIO_STATION   : 'RADIO_STATION',
        STATION_ID      : 'STATION_ID',
        STATION_NAME    : 'STATION_NAME',
        STATION_URL     : 'STATION_URL',
        TYPE            : 'TYPE',
        CONTENT_TYPE    : 'CONTENT_TYPE'
    },
    
    Registry :
	{
		PlayState				: 'RadioPlayState',
		ShowState				: 'RadioShowState',
		ErrorString				: 'RadioErrorString',
		StationName				: 'RadioStationName',
		StationURL				: 'RadioStationURL',
		StationID				: 'RadioStationID',
		Volume					: 'RadioVolume',
		MenuSelectedID			: 'RadioMenuSelectedID',
		MediaType				: 'RadioMediaType',
		LastUpdateServerTime	: 'RadioLastUpdateServer',
		LastUpdateServerIPTime  : 'RadioLastUpdateIPServer',
		LastCheckTime			: 'RadioLastCheckTime',
		CookiesImportComplete	: 'RadioCookiesImportComplete',
		Shrinked				: 'RadioShrinked',
		UseRealActiveX			: 'RadioUseRealActiveX',
		IsPodcast				: 'RadioIsPodcast',
		MediaID                 : 'RadioMediaID',
		InvalidateCache         : 'InvalidateCache'
	},
    
    MediaFileType :
    {
        User        : 'user',
        Publisher   : 'publisher',
        Recent      : 'recent',
        IP          : 'ip'
    },
    
    StationsCookie :
    {
        DomainConduit           : 'webradio.conduit.com',
        DomainSite2             : 'site2',
        DomainEffectiveBrand    : 'www.effectivebrand.com',
        Name                    : 'RadioUserDefined0'
    },
    
    DisplayText		: 'Radio Player',
	DisplayIcon		: 'chrome://browsersearch/skin/radio/RadioPlayChev.ico',
	ErrorPage		: 'RadioTroubleshooting/',
	TimerInterval	: 30*1000,
	GetRealURL		: 'RadioTroubleshooting/',
	SpecialString	: '~!!~',
	
	NowState :
	{
		PlayState		: 'stopped',
		ButtonState		: 'play',
		StationName		: '',
		StationURL		: '',
		MediaType		: '',
		IsPodcast		: false,
		MediaID         : '',
		ErrorStr		: '',
		MenuSelectedID  : '',
		Volume			: '',
		InChevron		: '',
		IsUserPause		: false,
		IsShrinked      : false
    },

    PlayerTypes:
    {
         MediaPlayer    :'Media Player',
         RealPlayer     :'Real Player'
    },
	Observer:
	{
	    RadioWMPcoreTopic  : 'RadioWMPcoreTopic_CT2958529',
	    NewStateEvent      : 'play_state_changed',
	    ErrorEvent         : 'error',
	    WaitingState       : 'waitingState',
	    onPause            : 'forceonPause',
	    ChangeMenuStation  : 'ChangeMenuStation'
	},
	
	SetStationName				: false,
	
	MaxRecentStations			: 10,
	
	IsUpdateStationFromPodcast	: true,
	
	xulSlider			        : null,
	
	UserMediaList				: null,
	PublisherMediaList			: null,
	RecentMediaList				: null,
	IPMediaList                 : null,
	RadioMenu					: null,
	RadioMainID					: 'EBRadioXUL_CT2958529',
	RadioPlayID					: 'EBRadioPlay_CT2958529',
	RadioStopID					: 'EBRadioStop_CT2958529',
	RadioVolumeID               : 'EBRadioVolume_CT2958529',
	RadioMenuButtonID			: 'EBRadioMenuButton_CT2958529',
	RadioMenuButtonChevronID	: 'EBRadioMenuButtonChevron_CT2958529',
	RadioPlayButtonChevronID	: 'EBRadioPlayButtonChevron_CT2958529',
	RadioMenuButtonContainerID	: 'EBRadioMenuButtonContainer_CT2958529',
	RadioSliderContainerID		: 'EBRadioSliderContainer_CT2958529',
	RadioShrinkID				: 'EBRadioShrink_CT2958529',
	RadioEqID					: 'EBRadioEq_CT2958529',
	RadioSliderID				: 'EBRadioSlider_CT2958529',
	
	EnableIPStations            : false,
	
	FolderName			: 'radio',
	PublisherMediaFile	: 'Predefined_Media_List.xml',
	IPMediaFile         : 'IP_Media_List.xml',
	UserMediaFile		: 'User_Media_List.xml',
	RecentMediaFile		: 'Recent_Media_List.xml',
	ServerURL			: 'http://radio.services.conduit.com/RadioRequest.ctp',
	ServerRQAdd			: '?type=user&ctid=CTxxxx&lut=',
	ServerRQAddIP       : '?type=ipstations&iplut=',
	ServerRQAddBoth     : '?type=userip&ctid=CTxxxx&lut=<LUT>&iplut=',
	ServerRQInvalidateCache: '&ic=true',
	SearchAdd			: '?type=search&query=',
	CheckInterval		: 30*60*1000, //millisec
	PodcastCheckInterval: 30, //minutes
	
	XMLResponseIP           : 'IP_STATIONS_REPLY',
	XMLResponsePublisher    : 'PUBLISHER_STATIONS_REPLY',
	XMLResponseMultiple     : 'MULTIPLE_STATIONS_REPLY',
	XMLRadioStations        : 'RADIO_STATIONS',
	XMLLUT                  : 'LAST_UPDATE_TIME',
	XMLResponseNoChange     : 'NOT_MODIFIED',
	XMLResponseErrorReply   : 'RADIO_ERROR',
	
	//Menu
	MenuIDPreffix				: 'EBRadioMenu_CT2958529',
	MenuIDRecentPreffix         : '_RECENT',
	PodcastPreffix				: 'EBRadioPodcastPreffix',
	LoadingText					: 'Loading...',
	LoadingHint					: 'Wait, Loading...',
	MenuUserStations			: 'My Stations',
	MenuUserStationsHint		: 'Stations that you defined',
	MenuAddStations             : 'Add and Edit Stations',
	MenuAddStationsHint			: 'Add and edit the stations in the radio',
	MenuMoreStations			: 'More',
	MenuLocalStations           : 'Local Stations',
	MenuRecentStations          : 'Recent',
	MenuMoreStationsHint		: 'View additional radio stations',
	MenuPodcastNoItems			: 'No items found in podcast',
	MenuPodcastTimeout			: 'Podcast currently not available',
	MaxStationsInMenu			: 20
}

var EBRadioCore_CT2958529 =
{
    isActive: false,
    wmp: null,
    real: null,
    wmp_active: false,
    real_active: false,
    useRealActiveX: false,

    GetStateForHtmlComponents: function(strState, strError) {
        if (strError) return "StateError";

        switch (strState) {
            case "ready":
            case "stopped": return "StateStop";
            case "playing": return "StatePlay";
            case "paused": return "StatePause";
            case "buffering":
            case "reconnecting":
            case "preparing new item":
            case "waiting": return "StateBuffering";
            default: return "";
        }
    },

    GetUniversalState: function(stateId, mediaType) {
        if (mediaType == EBRadioConsts_CT2958529.PlayerTypes.RealPlayer) {
            switch (stateId) {
                case 0: return "stopped"; break;
                case 1: return "waiting"; break;
                case 2: return "buffering"; break;
                case 3: return "playing"; break;
                case 4: return "paused"; break;
                case 5: return "reconnecting"; break;
            }
        }
        else if (mediaType == EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer) {
            switch (stateId) {
                case 0: return "undefined"; break;
                case 1: return "stopped"; break;
                case 2: return "paused"; break;
                case 3: return "playing"; break;
                case 6: return "buffering"; break;
                case 7: return "waiting"; break;
                case 8: return "media ended"; break;
                case 9: return "preparing new item"; break;
                case 10: return "ready"; break;
                case 11: return "reconnecting"; break;
            }
        }
    },

    BroadcastVolume: function(volume) {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioCore_CT2958529) {
                try {
                    if (objWindow.EBRadioCore_CT2958529.isActive) {
                        if (objWindow.EBRadioCore_CT2958529.wmp || objWindow.EBRadioCore_CT2958529.real) {
                            try {
                                objWindow.EBRadioCore_CT2958529.wmp.setVolume(volume);
                            }
                            catch (e) { }
                            try {
                                objWindow.EBRadioCore_CT2958529.real.SetVolume(volume)
                            }
                            catch (e) { }
                            break;
                        }
                    }
                }
                catch (ex) {
                    EBLog(ex);
                }
            }
        }
    },

    NullifyObjects: function() {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            try {
                if (objWindow.EBRadioManager_CT2958529.OnStop)
                    objWindow.EBRadioManager_CT2958529.OnStop();
            }
            catch (ex) {
                EBLog(ex);
            }
        }

        EBRadioConsts_CT2958529.NowState.PlayState = "stopped";

        if (this.real_active) {
            try {
                this.real.DoStop();
                this.real_active = false;
            }
            catch (e) { }
        }

        if (this.wmp_active) {
            try {
                this.wmp.stop();
                this.wmp_active = false;
            }
            catch (e) { }
        }

        this.wmp = null;
        this.real = null;


        this.isActive = false;
    },

    UnloadToolbar: function(isShown) {
        if (!this.isActive) {
            return;
        }
        if (!isShown) {
            this.NullifyObjects();
            return;
        }
        var found = false;
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBActionManager_CT2958529.IsToolbarShown()) {
                try {
                    if (objWindow != window) {
                        objWindow.EBRadioCore_CT2958529.real = this.real;
                        objWindow.EBRadioCore_CT2958529.real_active = this.real_active;
                        objWindow.EBRadioCore_CT2958529.wmp = this.wmp;
                        objWindow.EBRadioCore_CT2958529.wmp_active = this.wmp_active;
                        objWindow.EBRadioCore_CT2958529.isActive = true;
                        objWindow.EBRadioManager_CT2958529.HandleNewEvents(EBRadioConsts_CT2958529.Observer.NewStateEvent);
                        found = true;
                        break;
                    }
                }
                catch (ex) { }
            }
        }
        if (!found) {
            this.NullifyObjects();
        }
    },

    CreateCore: function(which) {
        this.isActive = true;
        if (which == EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer) {
            try {
                this.wmp = Components.classes["@conduit.com/radioWMPCore;1"].createInstance(Components.interfaces.IRadioWMPCore);
                this.wmp.registerTopicForObserver(EBRadioConsts_CT2958529.Observer.RadioWMPcoreTopic);
                this.wmp.setVolume(EBRadioConsts_CT2958529.NowState.Volume);
            }
            catch (ex) {
                EBRadioManager_CT2958529.StateManager('error', "Cannot find Windows Media Player, click here for troubleshoot")
                this.wmp = null;
            }
        }
        else if (which == EBRadioConsts_CT2958529.PlayerTypes.RealPlayer) {
            if (this.useRealActiveX) {
                try {
                    this.real = new window.GeckoActiveXObject('{CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA}');
                    this.real.SetWantErrors(true);
                    this.real.SetSource('');
                }
                catch (ex) {
                    EBRadioManager_CT2958529.StateManager('error', "Cannot find Real Player, click here for troubleshoot")
                    this.real = null;
                }
            }
            else {
                if (EBWindows_CT2958529.WindowsShellExecute('realplay.exe', null, false)) {
                    this.real = 'realplay.exe';
                }
                else if (EBWindows_CT2958529.WindowsShellExecute('mplayerc.exe', null, false)) {
                    this.real = 'mplayerc.exe';
                }
                else {
                    EBRadioManager_CT2958529.StateManager('error', 'Cannot find Real Player, click here to get Real Player');
                }
            }

        }

    },

    Init: function() {
        this.UpdateGUIOnLoad();
    },

    UpdateGUIOnLoad: function() {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioCore_CT2958529) {
                try {
                    if (objWindow.EBRadioCore_CT2958529.isActive) {
                        EBRadioConsts_CT2958529.NowState.PlayState = objWindow.EBRadioConsts_CT2958529.NowState.PlayState;
                        EBRadioConsts_CT2958529.NowState.ButtonState = objWindow.EBRadioConsts_CT2958529.NowState.ButtonState;
                        EBRadioConsts_CT2958529.NowState.ErrorStr = objWindow.EBRadioConsts_CT2958529.NowState.ErrorStr;
                        setTimeout(function() { EBRadioManager_CT2958529.UpdatePlayState(); }, 100);
                        break;
                    }
                }
                catch (ex) {
                    EBLog(ex);
                }
            }
        }
    },

    GetStateFromCore: function() {
        var url = '';
        var playState = '';

        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioCore_CT2958529) {
                try {
                    if (objWindow.EBRadioCore_CT2958529.isActive) {

                        url = objWindow.EBRadioCore_CT2958529.wmp.getStaionURL();
                        playState = objWindow.EBRadioCore_CT2958529.wmp.getPlayState();
                        EBRadioManager_CT2958529.StateManager(playState);
                    }
                }
                catch (ex) {
                    EBLog(ex);
                }
            }
        }
    },

    BroadcastPlay: function(stationURL, mediaType) {
        var found = false;
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioCore_CT2958529) {
                try {
                    if (objWindow.EBRadioCore_CT2958529.isActive) {
                        objWindow.EBRadioCore_CT2958529.Play(stationURL, mediaType);
                        EBRadioManager_CT2958529.HandleNewEvents(EBRadioConsts_CT2958529.Observer.NewStateEvent);
                        found = true;
                        break;
                    }
                }
                catch (ex) { EBLog(ex); }
            }
        }
        if (!found) {
            this.Play(stationURL, mediaType);
            EBRadioManager_CT2958529.HandleNewEvents(EBRadioConsts_CT2958529.Observer.NewStateEvent);
        }
    },

    BroadcastPause: function(isStop) {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioCore_CT2958529) {
                try {
                    if (objWindow.EBRadioCore_CT2958529.isActive) {
                        objWindow.EBRadioCore_CT2958529.Pause(isStop);
                    }
                }
                catch (ex) { EBLog(ex); }
            }
        }

        var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
        var chevronWin = ChevronStaticManager.floatingWindowsArray[0];
        if (chevronWin && chevronWin.EBRadioCore_CT2958529) {
            try {
                if (chevronWin.EBRadioCore_CT2958529.isActive) {
                    chevronWin.EBRadioCore_CT2958529.Pause(isStop);
                }
            }
            catch (ex) { }
        }
    },

    Pause: function(isStop) {
        if (this.wmp_active) {
            try {
                if (isStop) {
                    this.wmp.stop();
                }
                else {
                    try {
                        if (this.wmp.canPause())
                            this.wmp.pause();

                        else
                            this.wmp.stop();

                    }
                    catch (ex) {
                        EBLog(ex)
                    }
                }
            }
            catch (ex) { EBLog(ex) }
        }
        else if (this.real_active && this.useRealActiveX) {
            try {
                this.real.DoStop();
            }
            catch (ex) { }
        }


    },

    Play: function(stationURL, mediaType) {
        if (stationURL)
            stationURL = stationURL.replace(/~!!~/g, "\\\\");

        if (mediaType == EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer) {
            if (!this.wmp)
                this.CreateCore(mediaType);

            if (this.real_active && this.useRealActiveX) {
                try {
                    this.real.DoStop();
                }
                catch (ex) { }
            }
            if (this.wmp) {
                if (stationURL)
                    this.wmp.setStaionURL(stationURL);
                try { this.wmp.play(); } catch (e) { }
            }
            this.real_active = false;
            this.wmp_active = true;
        }

        else if (mediaType == EBRadioConsts_CT2958529.PlayerTypes.RealPlayer) {
            this.wmp_active = false;
            this.real_active = true;

            if (!this.real)
                this.CreateCore(mediaType);

            try {
                this.wmp.stop();
            }
            catch (ex) { }

            if (this.real) {
                if (this.useRealActiveX) {
                    this.real.SetSource(stationURL);
                    this.real.DoPlay();
                }
                else {
                    EBWindows_CT2958529.WindowsShellExecute(this.real, stationURL, true);
                    EBRadioManager_CT2958529.StateManager('real');
                }
            }
        }
    },

    isCreateActiveX: function() {
        var someoneActive;
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioCore_CT2958529) {
                try {
                    someoneActive = objWindow.EBRadioCore_CT2958529.isActive;
                    if (someoneActive) {
                        break;
                    }
                }
                catch (ex) { EBLog(ex); }
            }
        }
        return !someoneActive;
    }

}

function EBRadioCoreObserver_CT2958529(callbackForChangeState,callbackForChangeStation) {
    this.Topic = EBRadioConsts_CT2958529.Observer.RadioWMPcoreTopic;

    this.observe = function(aSubject, aTopic, aData) {
        try {
            if (aData == EBRadioConsts_CT2958529.Observer.ChangeMenuStation) {
                var station = aSubject.wrappedJSObject.station;
                callbackForChangeStation(station);
            }
            else
                callbackForChangeState(aData);
        }
        catch (e) {
            EBLog(e, "EBRadioCoreObserver");
        }
    }
}

EBRadioCoreObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();

var EBRadioDialogManager_CT2958529 =
{
    MenuDialogName: 'RadioStationsDialog',
    SearchDialogName: 'RadioSearchDialog',
    AddEditDialogName: 'RadioAddEditDialog',
    SearchDialogTitle: 'Search results for',
    CantRemovePlaying: "cannot be deleted since it's currently being played. Please switch to a different station and then delete this one",
    CantRemoveSelected: "cannot be deleted since it's selected for playing. Please switch to a different station and then delete this one",
    AddDialogLabel: 'Enter the name and stream URL of the station you want to add ',
    EditDialogLabel: 'Edit the name and stream URL of the selected station',
    NoStationsText: 'No stations found',
    ConfirmDeleteText: "",
    ConfirmDeleteTitle: "",
    MediaExistsText: 'This media \"{{MEDIA_NAME}}\" already exists in your list',
    SelectAudioFiles: 'Select Audio Files',
    oMediaList: null,
    arrMediaList: null,
    oMedia: null,
    SelectedIndex: null,


    // +++++++++++++ Generic +++++++++++++++
    FillRadioStations: function() {
        var objStationsList = document.getElementById('listStationsList');
        var oMedia = null;
        var listItem = null;

        //nullify all first

        while (objStationsList.childNodes.length > 2) {
            objStationsList.removeChild(objStationsList.lastChild);
        }

        if (!this.arrMediaList) {
            objStationsList.appendChild(this.CreateNoStationsListItem());
            return;
        }
        for (var i = 0; i < this.arrMediaList.Count(); i++) {
            oMedia = this.arrMediaList.GetByIndex(i)
            listItem = oMedia.toListItem(document);
            objStationsList.appendChild(listItem);
        }
    },

    CreateNoStationsListItem: function() {
        var listItem = document.createElement('listitem');
        var listCell = document.createElement('listcell');
        listCell.setAttribute('label', this.NoStationsText);
        listItem.appendChild(listCell);
        return listItem;
    },

    // +++++++++++++ Main Dialog +++++++++++++++
    OpenMainDialog: function(win) {
        var MenuChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + 'radio_menu.xul';
        win.openDialog(MenuChromePath,
						this.MenuDialogName,
						'chrome,modal,centerscreen,chrome,resizable=no');
        if (isFloatingMode_CT2958529) {
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            ChevronStaticManager.CloseAllWindows();
        }

    },

    MainDialog_OnDblClick: function(event) {
        var oListStationsList = document.getElementById('listStationsList');
        var iIndex = oListStationsList.selectedIndex;
        if (iIndex > -1) {
            this.oMedia = this.arrMediaList.GetByIndex(iIndex);
            this.MainDialog_OnOpenEditDialog(this.oMedia.MediaURL, this.oMedia.MediaName, this.oMedia.GetType());

        }
    },

    MainDialog_OnSelect: function(event) {
        var oListStationsList = document.getElementById('listStationsList');
        var iIndex = oListStationsList.selectedIndex;
        var oBtnSelect = document.getElementById('btnEdit');
        var oBtnDelete = document.getElementById('btnDelete');
        if (iIndex != -1) {
            oBtnDelete.setAttribute('disabled', 'false');
            if (oListStationsList.selectedCount == 1) {
                oBtnSelect.setAttribute('disabled', 'false');
                this.SelectedIndex = iIndex;
            }
            else {
                oBtnSelect.setAttribute('disabled', 'true');
            }
        }
        else {
            oBtnSelect.setAttribute('disabled', 'true');
            oBtnDelete.setAttribute('disabled', 'true');

        }
    },

    MainDialog_OnEdit: function(event) {
        this.MainDialog_OnDblClick();
    },

    MainDialog_OnDelete: function(event) {
        var oRecentBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        if (!EBGlobalManager_CT2958529.Confirm(window, oRecentBrowserWindow.EBRadioDialogManager_CT2958529.ConfirmDeleteTitle,
                oRecentBrowserWindow.EBRadioDialogManager_CT2958529.ConfirmDeleteText))
            return;

        var selectedStationURL = oRecentBrowserWindow.EBRadioConsts_CT2958529.NowState.StationURL;
        //if podcast item selected, get the podcast's URL.
        if (oRecentBrowserWindow.EBRadioConsts_CT2958529.NowState.IsPodcast) {
            try {
                var oPodcastMenu = oRecentBrowserWindow.document.getElementById(oRecentBrowserWindow.EBRadioConsts_CT2958529.NowState.MenuSelectedID).parentNode;
                var podcastMenuID = oPodcastMenu.getAttribute('id');
                podcastMenuID = podcastMenuID.replace(EBRadioConsts_CT2958529.MenuIDPreffix, '');
                selectedStationURL = this.arrMediaList.GetByID(podcastMenuID).MediaURL;
            }
            catch (ex) { }
        }

        var oListStationsList = document.getElementById('listStationsList');
        var arrSelectedItems = oListStationsList.selectedItems;
        var iIndex = 0;
        for (var i = arrSelectedItems.length - 1; i >= 0; i--) {
            iIndex = oListStationsList.getIndexOfItem(arrSelectedItems[i]);
            this.arrMediaList.Remove(iIndex, this.arrMediaList.GetByIndex(iIndex).MediaID);
            // Media List Remove
            oListStationsList.removeItemAt(iIndex);
        }
    },

    MainDialog_OnOkButton: function() {
        var xmlStations = this.oMediaList.toXML();
        var fileName = EBRadioConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBRadioConsts_CT2958529.UserMediaFile;
        EBRadioIOManager_CT2958529.SaveMediaXMLToFile(xmlStations, fileName);
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBRadioManager_CT2958529.UpdateMedia('user', xmlStations.documentElement);

        //usage
        oWindow.EBUsageRadio_CT2958529.OnCloseSettings(oWindow.EBUsageRadio_CT2958529.ExitCodeOK);
    },

    MainDialog_OnCancelButton: function() {
        //usage
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBUsageRadio_CT2958529.OnCloseSettings(oWindow.EBUsageRadio_CT2958529.ExitCodeCancel);
    },

    MainDialog_OnOpenEditDialog: function(mURL, mName, mType) {
        var AddEditChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + 'radio_addEdit.xul';
        window.openDialog(AddEditChromePath,
						this.AddEditDialogName,
						'chrome,modal,centerscreen,chrome,resizable=no',
						['edit', mURL, mName, mType]);
    },

    MainDialog_OnLoad: function(event) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        //usage
        objWindow.EBUsageRadio_CT2958529.OnOpenSettingsDialog();

        var dialogsDirection = objWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "ebRadioMenuDialog");

        if (objWindow.EBGlobalManager_CT2958529.IsLocaleRTL())
            this.MainDialog_ConvertToRTL();

        document.getElementById('ebRadioMenuDialog').getButton('cancel').focus();

        EBRadioLanguagePack_CT2958529.MenuDialog(objWindow);
        this.oMediaList = objWindow.EBRadioConsts_CT2958529.UserMediaList;

        if (objWindow.EBRadioConsts_CT2958529.RecentMediaList &&
        !objWindow.EBRadioConsts_CT2958529.RecentMediaList.isEmpty())
            document.getElementById("btnClearRecent").disabled = false;

        if (!this.oMediaList)
            return;

        this.arrMediaList = this.oMediaList.arrMedia;
        this.FillRadioStations();
    },

    MainDialog_ConvertToRTL: function() {
        var arrArrows = document.getElementsByTagName("image");
        for (var i = 0; i < arrArrows.length; i++) {
            if (arrArrows[i].getAttribute("src") == "chrome://browsersearch/skin/radio/RadioErrow.ico") {
                arrArrows[i].src = "chrome://browsersearch/skin/radio/RadioErrowRTL.ico";
            }
        }
    },

    MainDialog_OnInputSearch: function(obj) {
        var oBtnSearch = document.getElementById('btnSearch');
        var strValue = obj.value;
        if (strValue.length > 0 && EBGlobalManager_CT2958529.TotalTrim(strValue) != '') {
            oBtnSearch.setAttribute('disabled', 'false');
        }
        else {
            oBtnSearch.setAttribute('disabled', 'true');
        }
    },

    MainDialog_OnOpenSearchDialog: function(searchStr) {
        //usage
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBUsageRadio_CT2958529.OnSettingsAction(oWindow.EBUsageRadio_CT2958529.SettingsActionSearch);

        var SearchChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + 'radio_search.xul';
        window.openDialog(SearchChromePath,
						this.SearchDialogName,
						'chrome,modal,centerscreen,chrome,resizable=no', [searchStr]);
        return false;
    },

    MainDialog_OnOpenAddDialog: function() {
        //usage
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBUsageRadio_CT2958529.OnSettingsAction(oWindow.EBUsageRadio_CT2958529.SettingsActionDefine);

        var AddEditChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + 'radio_addEdit.xul';
        window.openDialog(AddEditChromePath,
						this.AddEditDialogName,
						'chrome,modal,centerscreen,chrome,resizable=no', ['add']);
    },

    MainDialog_OnEnterKey: function(event) {
        var AddEditChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + 'radio_addEdit.xul';
        window.openDialog(AddEditChromePath,
						this.AddEditDialogName,
						'chrome,modal,centerscreen,chrome,resizable=no', ['add']);
    },

    MainDialog_OnInputSearchCheckKey: function(event, strValue) {
        if (event.keyCode == 13 && strValue) {
            this.MainDialog_OnOpenSearchDialog(strValue);
        }
    },

    MainDialog_OnListBoxCheckKey: function(event) {
        if (event.keyCode == 13) {
            this.MainDialog_OnEdit();
        }

    },

    MainDialog_OnFileBrowse: function(event) {
        //usage
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBUsageRadio_CT2958529.OnSettingsAction(oWindow.EBUsageRadio_CT2958529.SettingsActionAddFiles);

        var nsIFilePicker = Components.interfaces.nsIFilePicker;
        var objFilePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        objFilePicker.init(window, this.SelectAudioFiles, nsIFilePicker.modeOpenMultiple);
        objFilePicker.appendFilter("All files (*.*)", "*.*");

        //and if he doesn't so to the windows xp media path as the default path:
        strDisplayDir = EBWindows_CT2958529.GetWindowsMyMusicPath();
        var objDisplayDir = EBDirIO_CT2958529.open(strDisplayDir);
        if (objDisplayDir) {
            objFilePicker.displayDirectory = objDisplayDir;
        }

        var iResult = objFilePicker.show();
        if (iResult == nsIFilePicker.returnOK) {
            var objFiles = objFilePicker.files;

        }
        var file = null;
        var oNewMedia = null;
        var objStationsList = document.getElementById('listStationsList');
        while (objFiles.hasMoreElements()) {
            file = objFiles.getNext().QueryInterface(Components.interfaces.nsILocalFile);
            oNewMedia = new EBRadioMedia_CT2958529();
            oNewMedia.MediaName = file.path.slice(file.path.lastIndexOf('\\') + 1);
            oNewMedia.MediaURL = file.path.replace(/\\/g, EBRadioConsts_CT2958529.SpecialString);
            oNewMedia.MediaID = oNewMedia.MediaURL;
            oNewMedia.SetType("mp");
            if (!this.arrMediaList.Contains(oNewMedia.MediaID)) {
                this.arrMediaList.Add(oNewMedia.MediaID, oNewMedia);
                objStationsList.appendChild(oNewMedia.toListItem(document));
            }
        }
    },

    MainDialog_Help: function(event) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        //send feedback
        var radioComp = objWindow.EBComponentsManager_CT2958529.GetRadioComponent();
        if (radioComp && radioComp.ComponentItem.helpUrl)
            objWindow.EBWeb_CT2958529.LoadURLInNewWindow(radioComp.ComponentItem.helpUrl, null);
    },

    MainDialog_ClearRecentStations: function(event) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var locale = oWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);
        var strTitle = oWindow.oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_RADIO_CLEAR_RECENT_STATIONS_MSG_CAPTION", locale);
        var strText = oWindow.oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_RADIO_CLEAR_RECENT_STATIONS_MSG", locale);

        if (!EBGlobalManager_CT2958529.Confirm(window, strTitle, strText)) return;

        document.getElementById("btnClearRecent").disabled = true;
        oWindow.EBRadioManager_CT2958529.ClearRecentStations();
    },

    // +++++++++++++ Search Dialog +++++++++++++++
    OnLoadSearchDialog: function(event) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var dialogsDirection = objWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "ebRadioSearchDialog");

        var oRecentBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        EBRadioLanguagePack_CT2958529.SearchDialog(oRecentBrowserWindow, argSearchString)

        EBRadioServerComm_CT2958529.SearchRadioStations(argSearchString);
    },

    OnUnLoadSearchDialog: function(event) {
        //TODO unload action.
    },

    SearchResults: function(oSearchMediaList) {
        if (!oSearchMediaList || oSearchMediaList.arrMedia.Count() == 0) {
            this.arrMediaList = null;
        }
        else {
            this.arrMediaList = oSearchMediaList.arrMedia;
        }

        this.FillRadioStations();
    },

    SearchDialog_OnOkButton: function() {
        var oListStationsList = document.getElementById('listStationsList');
        var oMediaList = opener.document.getElementById('listStationsList');
        var arrSelectedItems = oListStationsList.selectedItems;
        var iIndex = 0;
        var oMedia = null;
        var MediaID = null;

        for (var i = arrSelectedItems.length - 1; i >= 0; i--) {
            iIndex = oListStationsList.getIndexOfItem(arrSelectedItems[i]);
            oMedia = this.arrMediaList.GetByIndex(iIndex);
            MediaID = this.arrMediaList.GetByIndex(iIndex).MediaID;
            if (!opener.EBRadioDialogManager_CT2958529.arrMediaList.Contains(MediaID)) {
                opener.EBRadioDialogManager_CT2958529.arrMediaList.Add(MediaID, oMedia);
                oMediaList.appendChild(oMedia.toListItem(opener.document));
            }
        }
    },

    SearchDialog_OnDblClick: function(event) {
        this.SearchDialog_OnOkButton();
        window.close();
    },

    SearchDialog_OnSelect: function(event) {
        var oListStationsList = document.getElementById('listStationsList');
        var iIndex = oListStationsList.selectedIndex;
        var oBtnOk = document.getElementById('ebRadioSearchDialog').getButton('accept');
        if (iIndex != -1) {
            oBtnOk.setAttribute('disabled', 'false');
        }
        else {
            oBtnOk.setAttribute('disabled', 'true');
        }
    },

    // +++++++++++++ AddEdit Dialog +++++++++++++++
    OnLoadAddEditDialog: function(event) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var dialogsDirection = objWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "ebRadioAddEditDialog");

        var oRecentBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        var lblAddEditLabel = document.getElementById('lblAddEditLabel');
        EBRadioLanguagePack_CT2958529.AddEditDialog(oRecentBrowserWindow, argDialogType)

        if (argDialogType == "add") {
            lblAddEditLabel.setAttribute('value', this.AddDialogLabel);
            window.title = "Add Your Own Radio Station"

        }
        else //edit
        {
            lblAddEditLabel.setAttribute('value', this.EditDialogLabel);
            window.title = "Edit Radio Station"
            var oStationURL = document.getElementById('txtURL');
            var oStationName = document.getElementById('txtName');
            var oStationType = document.getElementById('cmbStreamType');

            oStationURL.setAttribute('value', argURL.replace(/~!!~/g, "\\"));
            oStationName.setAttribute('value', argName);
            // set stream type
            var oComboType = document.getElementById('cmbStreamType');
            var oPopupMenu = oComboType.firstChild;

            var oMenuItem = null;
            for (var i = 0; i < oPopupMenu.childNodes.length; i++) {
                oMenuItem = oPopupMenu.childNodes[i];
                if (oMenuItem.getAttribute('value') == argType.toLowerCase()) {
                    oComboType.selectedItem = oMenuItem;
                    break;
                }
            }
        }
        this.AddEditDialog_CheckInput();
    },

    OnUnLoadAddEditDialog: function(event) {
        // do nothing
    },

    AddEditDialog_OnOKButton: function() {
        var oStationURL = document.getElementById('txtURL');
        var oStationName = document.getElementById('txtName');
        var oStationType = document.getElementById('cmbStreamType');
        var oMediaList = opener.document.getElementById('listStationsList');

        var oSelectedMenuItem = oStationType.selectedItem;
        var strStreamType = oSelectedMenuItem.value

        // update Media Object		
        if (argDialogType == "edit") {
            opener.EBRadioDialogManager_CT2958529.oMedia.MediaURL = oStationURL.value.replace(/\\/g, "~!!~")
            opener.EBRadioDialogManager_CT2958529.oMedia.MediaName = oStationName.value
            if (strStreamType == "podcast") {
                opener.EBRadioDialogManager_CT2958529.oMedia.SetPodCast();
            }
            else {
                opener.EBRadioDialogManager_CT2958529.oMedia.SetType(strStreamType);
            }

            // update List
            var selectedIndex = opener.EBRadioDialogManager_CT2958529.SelectedIndex;
            var oListItem = oMediaList.getItemAtIndex(selectedIndex);
            oListItem.childNodes[0].setAttribute('label', oStationName.value);
            oListItem.childNodes[1].setAttribute('label', oStationURL.value);
        }
        else //add
        {
            var oNewMedia = new EBRadioMedia_CT2958529();
            oNewMedia.MediaName = oStationName.value;
            oNewMedia.MediaURL = oStationURL.value.replace(/\\/g, "~!!~");
            oNewMedia.MediaID = oNewMedia.MediaURL;
            if (strStreamType == "podcast") {
                oNewMedia.SetPodCast();
            }
            else {
                oNewMedia.SetType(strStreamType);
            }
            if (!opener.EBRadioDialogManager_CT2958529.arrMediaList.Contains(oNewMedia.MediaID)) {
                opener.EBRadioDialogManager_CT2958529.arrMediaList.Add(oNewMedia.MediaID, oNewMedia);
                oMediaList.appendChild(oNewMedia.toListItem(opener.document));
            }
        }
    },

    AddEditDialog_CheckInput: function(event) {

        var oStationURL = document.getElementById('txtURL').value;
        var oStationName = document.getElementById('txtName').value;
        var oStationType = document.getElementById('cmbStreamType').selectedItem.value;
        var oOkButton = document.getElementById('btnAccept');

        if (!oStationURL || !oStationName || !oStationType)
            oOkButton.setAttribute('disabled', true);
        else
            oOkButton.setAttribute('disabled', false);
    },

    // +++++++++++++ Volume Dialog +++++++++++++++++++
    xulSlider: null,
    timeoutFunc: null,
    oWindow: null,

    Volume_OpenDialog: function(VolumeChromePath, VolumeDialogName, dWidth, dHeight, screenX, screenY) {
        var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
        ChevronStaticManager.isVolumeDialogOpen = true;
        ChevronStaticManager.disableCloseAllWindows = true;
        EBGlobalManager_CT2958529.OpenDialog(VolumeChromePath, VolumeDialogName, 'chrome,dependent,titlebar=yes,resizable=no,width=' + dWidth + ',height=' + dHeight + ',screenX=' + screenX + ',screenY=' + screenY, [dWidth, dHeight], true);
    },

    Volume_OnLoad: function(event) {
        //resize window onload to get exact size.
        window.resizeTo(window.arguments[0][0], window.arguments[0][1]);

        var GetGripper = function(xulElement) {
            var arrElements = document.getAnonymousNodes(xulElement);
            var xulGripper = null;

            if (arrElements) {
                for (var i = 0; i < arrElements.length; i++) {
                    if (arrElements[i].tagName == 'xul:gripper') {
                        xulGripper = arrElements[i];
                        break;
                    }
                }
            }

            return xulGripper
        };


        this.oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        //usage
        this.oWindow.EBUsageRadio_CT2958529.OnClickVolume();

        var oElement = this.oWindow.EBRadioSkinManager_CT2958529.Slider.sliderButton;
        var thumbWidth = oElement.width;
        thumbWidth += 'px';
        var dHeight = this.oWindow.EBRadioSkinManager_CT2958529.Slider.height;
        var dWidth = this.oWindow.EBRadioSkinManager_CT2958529.Slider.width;

        var bgImage = this.oWindow.EBRadioSkinManager_CT2958529.Slider.normalUrl;
        bgImage = 'url(' + bgImage + ')';
        var thImage = this.oWindow.EBRadioSkinManager_CT2958529.Slider.sliderButton.normalUrl;
        thImage = 'url(' + thImage + ')';
        var oSlider = document.getElementById('slider');
        var oThumb = document.getElementById('thumb');
        var oDialog = document.getElementById('ebRadioVolumeDialog');
        var oHbox = document.getElementById('hbox');
        var oGripper = GetGripper(oThumb);
        var iVolume = this.oWindow.EBRadioConsts_CT2958529.NowState.Volume;
        this.xulSlider = oSlider;

        oSlider.style.backgroundImage = bgImage;
        oSlider.setAttribute('curpos', iVolume);
        oSlider.style.opacity = '0';
        this.OnLoadEffect(0);


        var oThumb_mouseover = 'this.style.backgroundImage="url(' + oElement.hoverUrl + ')"';
        var oThumb_mouseout = 'this.style.backgroundImage="url(' + oElement.normalUrl + ')"';
        var oThumb_mousedown = 'this.style.backgroundImage="url(' + oElement.pressedUrl + ')"';
        var oThumb_mouseup = 'this.style.backgroundImage="url(' + oElement.normalUrl + ')"';

        oThumb.style.backgroundImage = thImage;

        oThumb.setAttribute('ondraggesture', oThumb_mousedown);
        oThumb.setAttribute('onmouseover', oThumb_mouseover);
        oThumb.setAttribute('onmouseout', oThumb_mouseout);
        oThumb.setAttribute('onmousedown', oThumb_mousedown);
        oThumb.setAttribute('onmouseup', oThumb_mouseup);

        oThumb.style.width = thumbWidth;
        oHbox.height = dHeight;
        this.CheckVolume();
    },

    OnLoadEffect: function(opacity) {
        var fOpacity = parseFloat(opacity);
        if (fOpacity < 1) {
            fOpacity += 0.2;
            this.xulSlider.style.opacity = fOpacity;
            setTimeout(function() { EBRadioDialogManager_CT2958529.OnLoadEffect(fOpacity); }, 40);
        }
    },

    OnUnLoadEffect: function(opacity) {
        var fOpacity = parseFloat(opacity);
        if (fOpacity > 0) {
            fOpacity -= 0.2;
            this.xulSlider.style.opacity = fOpacity;
            setTimeout(function() { EBRadioDialogManager_CT2958529.OnUnLoadEffect(fOpacity); }, 40);
        }
        else {
            window.close();
        }
    },

    Volume_OnBlur: function(event) {
        var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
        ChevronStaticManager.isVolumeDialogOpen = true;
        this.OnUnLoadEffect(1);
    },

    Volume_OnUnLoad: function(event) {
        clearTimeout(this.timeoutFunc);
        this.xulSlider.style.opacity = 0;
        window.focus();
    },

    CheckVolume: function() {
        var volume = this.xulSlider.getAttribute('curpos');
        if (volume != this.oWindow.EBRadioConsts_CT2958529.NowState.Volume) {
            this.oWindow.EBRadioIOManager_CT2958529.SetVolumeToRegistry(volume);
            this.oWindow.EBRadioManager_CT2958529.BroadcastVolume(volume);
        }
        this.timeoutFunc = setTimeout(function() { EBRadioDialogManager_CT2958529.CheckVolume(); }, 100);
    }

}

var EBRadioGUIManager_CT2958529 =
{
    xulPlay: null,
    xulStop: null,
    xulEq: null,
    xulMenuButton: null,
    xulMenuButtonContainer: null,
    xulSliderBG: null,
    xulSlider: null,
    xulVolume: null,
    xulShrinkUnshrink: null,
    TooltipID: 'EBRadioTooltipID_CT2958529',
    TooltipRealID: 'EBRadioTooltipRealID_CT2958529',
    RadioTooltipAnimationID: 'EBRadioTooltipAnimationID_CT2958529',

    Tooltips:
	{
	    playing: 'Playing',
	    stopped: 'Stopped',
	    paused: 'Paused',
	    buffering: 'Buffering',
	    waiting: 'Connecting...',
	    mediaEnded: 'Media ended',
	    preparingNewItem: 'Preparing new item',
	    ready: 'Ready',
	    reconncting: 'Reconnecting',
	    shrink: 'Shrink',
	    expand: 'Expand',
	    play: 'Play',
	    stop: 'Stop',
	    pause: 'Pause',
	    volume: 'Volume',
	    undefined: 'Undefined',
	    playingReal: '[Playing in external Real player]'
	},

    Images:
	{
	    imgPlay: "chrome://browsersearch/skin/radio/RadioPlay.gif",
	    imgPlay_dn: "chrome://browsersearch/skin/radio/RadioPlay_dn.gif",
	    imgPlay_on: "chrome://browsersearch/skin/radio/RadioPlay_on.gif",
	    imgStop: "chrome://browsersearch/skin/radio/RadioStop.gif",
	    imgStop_dn: "chrome://browsersearch/skin/radio/RadioStop_dn.gif",
	    imgStop_on: "chrome://browsersearch/skin/radio/RadioStop_on.gif",
	    imgPause: "chrome://browsersearch/skin/radio/RadioPause.gif",
	    imgPause_dn: "chrome://browsersearch/skin/radio/RadioPause_dn.gif",
	    imgPause_on: "chrome://browsersearch/skin/radio/RadioPause_on.gif",
	    imgRadioEqPause: "chrome://browsersearch/skin/radio/RadioEqualizerSilent.gif",
	    bgCenter: "chrome://browsersearch/skin/radio/RadioStrip.gif",
	    imgSliderLine: "chrome://browsersearch/skin/radio/RadioSliderBG.gif",
	    imgSliderBall: "chrome://browsersearch/skin/radio/RadioSliderBall.gif",
	    imgRadioEqSilent: "chrome://browsersearch/skin/radio/RadioEqualizerSilent.gif",
	    imgRadioEqLoading: "chrome://browsersearch/skin/radio/RadioEqualizerLoading.gif",
	    imgRadioEqPlay: "chrome://browsersearch/skin/radio/RadioEqualizerPlay.gif",
	    imgRadioEqError: "chrome://browsersearch/skin/radio/RadioError.gif",
	    bgCombo: "chrome://browsersearch/skin/radio/RadioCombo.gif",
	    imgShrink: "chrome://browsersearch/skin/radio/RadioMini.gif",
	    imgShrink_dn: "chrome://browsersearch/skin/radio/RadioMini_dn.gif",
	    imgShrink_on: "chrome://browsersearch/skin/radio/RadioMini_on.gif",
	    imgExpand: "chrome://browsersearch/skin/radio/RadioMaxi.gif",
	    imgExpand_dn: "chrome://browsersearch/skin/radio/RadioMaxi_dn.gif",
	    imgExpand_on: "chrome://browsersearch/skin/radio/RadioMaxi_on.gif",
	    imgPlayChev: "chrome://browsersearch/skin/radio/RadioPlayChev.ico",
	    imgStopChev: "chrome://browsersearch/skin/radio/RadioStopChev.ico",
	    imgRadioChev: "chrome://browsersearch/skin/radio/RadioImgChev.ico",
	    imgRealLogo: "chrome://browsersearch/skin/radio/RealLogo.png",
	    imgRealLogo_hover: "chrome://browsersearch/skin/radio/RealLogo.png",
	    imgWMPLogo: "chrome://browsersearch/skin/radio/WMPLogo.png",
	    imgWMPLogo_hover: "chrome://browsersearch/skin/radio/WMPLogo.png",
	    imgPodcast: "chrome://browsersearch/skin/radio/Podcast.png",
	    imgPodcast_hover: "chrome://browsersearch/skin/radio/Podcast.png",
	    imgPlayingReal: "chrome://browsersearch/skin/radio/RadioEqualizerReal.ico",
	    imgRadioTooltip: "chrome://browsersearch/skin/radio/RadioTooltipStopped.gif",
	    imgRadioTooltipPl: "chrome://browsersearch/skin/radio/RadioTooltipPlaying.gif",
	    imgRadioTooltipSt: "chrome://browsersearch/skin/radio/RadioTooltipStopped.gif",
	    imgVolume: "chrome://browsersearch/skin/radio/RadioVolume.gif",
	    imgVolume_dn: "chrome://browsersearch/skin/radio/RadioVolume_dn.gif",
	    imgVolume_on: "chrome://browsersearch/skin/radio/RadioVolume_on.gif",
	    imgSliderBG: ""
	},

    Init: function() {
        this.xulPlay = document.getElementById(EBRadioConsts_CT2958529.RadioPlayID);
        this.xulStop = document.getElementById(EBRadioConsts_CT2958529.RadioStopID);
        this.xulMenuButton = document.getElementById(EBRadioConsts_CT2958529.RadioMenuButtonID);
        this.xulMenuButtonContainer = document.getElementById(EBRadioConsts_CT2958529.RadioMenuButtonContainerID);
        this.xulSliderBG = document.getElementById(EBRadioConsts_CT2958529.RadioSliderContainerID);
        this.xulSlider = document.getElementById(EBRadioConsts_CT2958529.RadioSliderID);
        this.xulShrink = document.getElementById(EBRadioConsts_CT2958529.RadioShrinkID);
        this.xulEq = document.getElementById(EBRadioConsts_CT2958529.RadioEqID);

        //if radio expanded
        if (this.xulMenuButton)
            this.xulMenuButton.setAttribute('tooltip', this.TooltipID);

        this.CreateTooltip();
        this.CreateRealTooltip();
    },

    SetNewState: function(strState, strError) {
        //states:	0-undefined, 1-stopped, 2-paused, 3-playing, 6-buffering, 7-waiting
        //			8-media ended, 9-preparing new media item, 10-ready, 11-reconnecting
        switch (strState) {
            case "undefined": this.SetUndefined(); break;
            case "stopped": this.SetStopped(); break;
            case "paused": this.SetPause(); break;
            case "playing": this.SetPlay(); break;
            case "buffering": this.SetBuffering(); break;
            case "waiting": this.SetWaiting(); break;
            case "media ended": this.SetMediaEnded(); break;
            case "preparing new item": this.SetPreparingNewItem; break;
            case "ready": this.SetReady(); break;
            case "reconnecting": this.Reconnecting(); break;
            case "error": this.SetError(strError); break;
            case "real": this.SetPlayingReal(); break;
        }
    },

    SetPlayingReal: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('tooltip', this.TooltipRealID);
            this.xulVolume.setAttribute('tooltip', this.TooltipRealID);
            this.xulEq.removeAttribute('tooltiptext');
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.stoppedUrl);
            this.xulEq.setAttribute('onclick', '');
            this.xulEq.setAttribute('style', '');
        }

        if (this.xulVolume)
            this.xulVolume.removeAttribute('tooltiptext');

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgRealLogo);
        this.Images.imgRadioTooltip = EBRadioSkinManager_CT2958529.Indicator.stoppedUrl;
        this.OnPause();
    },

    SetError: function(strError) {
        var strAdditional, troubleShootPage, radioComp;
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.errorUrl);
            this.xulEq.setAttribute('tooltiptext', strError);
        }
        if (EBGlobalConsts_CT2958529.IsEngine) {
            radioComp = EBComponentsManager_CT2958529.GetRadioComponent();
            troubleShootPage = (radioComp) ? radioComp.ComponentItem.troubleshootUrl : "";
        }
        if (strError && strError.match('Cannot find Windows Media Player, click here for troubleshoot')) {
            if (!EBGlobalConsts_CT2958529.IsEngine) {
                strAdditional = EBRadioConsts_CT2958529.ErrorPage;
                troubleShootPage = EBActionManager_CT2958529.GetWebServerURL(strAdditional) + '#aFirefoxPlugin';
            }
            if (this.xulEq) {
                this.xulEq.onclick = function(e) { EBWeb_CT2958529.LoadURLInNewWindow(troubleShootPage); };
                this.xulEq.setAttribute('style', 'cursor:pointer');
            }
        }
        else if (strError && strError.match('Cannot find Real Player')) {
            if (!EBGlobalConsts_CT2958529.IsEngine) {
                strAdditional = EBRadioConsts_CT2958529.GetRealURL;
                troubleShootPage = EBActionManager_CT2958529.GetWebServerURL(strAdditional);
            }
            if (troubleShootPage && this.xulEq) {
                this.xulEq.onclick = function(e) { EBWeb_CT2958529.LoadURLInNewWindow(troubleShootPage); };
                this.xulEq.setAttribute('style', 'cursor:pointer');
            }
        }
        if (this.xulVolume) {
            this.xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
            this.xulVolume.removeAttribute('tooltip');
        }

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgRadioEqError);
        this.Images.imgRadioTooltip = this.Images.imgRadioEqError;
        this.OnPause();
    },

    SetUndefined: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.errorUrl);
            this.xulEq.setAttribute('tooltiptext', this.Tooltips.undefined);
            var troubleShootPage = null;
            if (EBGlobalConsts_CT2958529.IsEngine) {
                var radioComp = EBComponentsManager_CT2958529.GetRadioComponent();
                troubleShootPage = (radioComp) ? radioComp.ComponentItem.troubleshootUrl : "";
            }
            else {
                var strAdditional = EBRadioConsts_CT2958529.ErrorPage;
                troubleShootPage = EBActionManager_CT2958529.GetWebServerURL(strAdditional);
            }
            if (troubleShootPage) {
                this.xulEq.setAttribute('onclick', 'EBWeb_CT2958529.LoadURLInNewWindow("' + troubleShootPage + '")');
                this.xulEq.setAttribute('style', 'cursor:pointer');
            }
        }

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgRadioEqError);

        if (this.xulVolume) {
            this.xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
            this.xulVolume.removeAttribute('tooltip');
        }

        this.Images.imgRadioTooltip = this.Images.imgRadioEqError;
        this.OnPause();
    },

    SetPlayChevron: function() {
        var btnPlay = document.getElementById(EBRadioConsts_CT2958529.RadioPlayButtonChevronID);
        var image = EBRadioSkinManager_CT2958529.ObjSkinDef.ChevronStopImageUrl;
        btnPlay.setAttribute('label', this.Tooltips.stop);
        btnPlay.setAttribute('image', image);
        btnPlay.setAttribute('oncommand', 'EBRadioManager_CT2958529.OnPause();event.cancelBubble = true;');
    },

    SetPauseChevron: function() {
        var btnPlay = document.getElementById(EBRadioConsts_CT2958529.RadioPlayButtonChevronID);
        var image = EBRadioSkinManager_CT2958529.ObjSkinDef.ChevronPlayImageUrl;
        btnPlay.setAttribute('label', this.Tooltips.play);
        btnPlay.setAttribute('image', image);
        btnPlay.setAttribute('oncommand', 'EBRadioManager_CT2958529.OnPlay();event.cancelBubble = true;');
    },

    SetPause: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.stoppedUrl);
            this.xulEq.setAttribute('tooltiptext', this.Tooltips.paused);
            this.xulEq.setAttribute('onclick', '');
            this.xulEq.setAttribute('style', '');
        }

        if (this.xulVolume) {
            this.xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
            this.xulVolume.removeAttribute('tooltip');
        }

        this.Images.imgRadioTooltip = this.Images.imgRadioTooltipSt;

        if (EBRadioConsts_CT2958529.NowState.InChevron)
            this.SetPauseChevron();

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgWMPLogo);
    },

    SetPlay: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.playingUrl);
            this.xulEq.setAttribute('tooltiptext', this.Tooltips.playing);
            this.xulEq.setAttribute('onclick', '');
            this.xulEq.setAttribute('style', '');
        }

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgRadioEqPlay);
        this.Images.imgRadioTooltip = this.Images.imgRadioTooltipPl;

        if (this.xulVolume) {
            this.xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
            this.xulVolume.removeAttribute('tooltip');
        }

        this.OnPlay();

        if (EBRadioConsts_CT2958529.NowState.InChevron)
            this.SetPlayChevron();
    },

    SetBuffering: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.bufferingUrl);
            this.xulEq.setAttribute('tooltiptext', this.Tooltips.buffering);
            this.xulEq.setAttribute('onclick', '');
            this.xulEq.setAttribute('style', '');
        }

        if (this.xulVolume) {
            this.xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
            this.xulVolume.removeAttribute('tooltip');
        }

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgRadioEqLoading);
        this.Images.imgRadioTooltip = this.Images.imgRadioTooltipSt;
        this.OnPlay();
    },

    SetWaiting: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.bufferingUrl);
            this.xulEq.setAttribute('tooltiptext', this.Tooltips.waiting);
            this.xulEq.setAttribute('onclick', '');
            this.xulEq.setAttribute('style', '');
        }

        if (this.xulVolume) {
            this.xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
            this.xulVolume.removeAttribute('tooltip');
        }

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgRadioEqLoading);
        this.Images.imgRadioTooltip = this.Images.imgRadioTooltipSt;
        this.OnPlay();
    },

    SetMediaEnded: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.stoppedUrl);
            this.xulEq.setAttribute('tooltiptext', this.Tooltips.mediaEnded);
            this.xulEq.setAttribute('onclick', '');
            this.xulEq.setAttribute('style', '');
        }

        if (this.xulVolume) {
            this.xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
            this.xulVolume.removeAttribute('tooltip');
        }

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgWMPLogo);
        this.Images.imgRadioTooltip = this.Images.imgRadioTooltipSt;
        this.OnPause();
    },

    SetPreparingNewItem: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.bufferingUrl);
            this.xulEq.setAttribute('tooltiptext', this.Tooltips.preparingNewItem);
            this.xulEq.setAttribute('onclick', '');
            this.xulEq.setAttribute('style', '');
        }

        if (this.xulVolume) {
            this.xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
            this.xulVolume.removeAttribute('tooltip');
        }

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgRadioEqLoading);
        this.Images.imgRadioTooltip = this.Images.imgRadioTooltipSt;
        this.OnPlay();
    },

    SetStopped: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.stoppedUrl);
            this.xulEq.setAttribute('tooltiptext', this.Tooltips.stopped);
            this.xulEq.setAttribute('onclick', '');
            this.xulEq.setAttribute('style', '');
        }

        this.Images.imgRadioTooltip = this.Images.imgRadioTooltipSt;
        this.OnPause();
        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgWMPLogo);

        /*
        if (EBRadioConsts_CT2958529.NowState.InChevron)
        this.SetStopChevron();
        */
    },

    SetReady: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.stoppedUrl);
            this.xulEq.setAttribute('tooltiptext', this.Tooltips.ready);
            this.xulEq.setAttribute('onclick', '');
            this.xulEq.setAttribute('style', '');
        }

        if (this.xulVolume) {
            this.xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
            this.xulVolume.removeAttribute('tooltip');
        }

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgWMPLogo);
        this.Images.imgRadioTooltip = this.Images.imgRadioTooltipSt;
        this.OnPause();
    },

    Reconnecting: function() {
        if (this.xulEq) {
            this.xulEq.setAttribute('src', EBRadioSkinManager_CT2958529.Indicator.bufferingUrl);
            this.xulEq.setAttribute('tooltiptext', this.Tooltips.reconnecting);
            this.xulEq.setAttribute('onclick', '');
        }

        if (this.xulVolume) {
            this.xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
            this.xulVolume.removeAttribute('tooltip');
        }

        EBRadioConsts_CT2958529.RadioMenu.SetActiveMenuItemImage(this.Images.imgRadioEqLoading);
        this.Images.imgRadioTooltip = this.Images.imgRadioTooltipSt;
        this.OnPlay();

    },

    OnPlay: function() {
        EBRadioSkinManager_CT2958529.ChangePlayToPauseButton(null, null);
    },

    OnPause: function() {
        EBRadioSkinManager_CT2958529.ChangePauseToPlayButton(null, null);
    },

    SetShrink: function() {
        if (this.xulShrink) {
            EBRadioConsts_CT2958529.NowState.IsShrinked = true;
            EBRadioSkinManager_CT2958529.SetShrink();
        }
    },

    SetExpand: function() {
        if (this.xulShrink) {
            EBRadioConsts_CT2958529.NowState.IsShrinked = false;
            EBRadioSkinManager_CT2958529.SetExpand();
        }
    },

    SetStation: function(strName, strMediaType, strMediaURL) {
        //if radio expanded
        if (this.xulMenuButton) {
            this.xulMenuButton.setAttribute('label', strName);
            this.xulMenuButton.setAttribute('MediaType', strMediaType);
            this.xulMenuButton.setAttribute('MediaURL', strMediaURL);
        }
    },

    GetRadioChevronImage: function() {
        var strImage = '';

        if (EBRadioSkinManager_CT2958529.ObjSkinDef)
            strImage = EBRadioSkinManager_CT2958529.ObjSkinDef.ChevronMenuImageUrl;
        else
            strImage = this.Images.imgRadioChev;

        return strImage;
    },

    CreateTooltip: function() {
        if (!this.xulMenuButton)
            return;

        var strMainPopupSetID = EBComponentsConsts_CT2958529.MainPopupSetID;
        var objMainPopupSet = document.getElementById(strMainPopupSetID);

        var strTooltipID = this.TooltipID;
        var strOrient = 'horisontal';

        //patch to 1.0.* - send the toolbarbutton id to retrieve the label and tooltip instead of
        //the toolbarbutton object itself as a param to the onpopupshowing event
        //set addEventListener also fails to work in 1.0.*
        var strToolbarButtonID = this.xulMenuButton.getAttribute('id');
        var strOnPopupShowing = "";
        var objXULTooltip = EBXULFactory_CT2958529.CreateTooltip(strTooltipID, strOrient, strOnPopupShowing);
        objXULTooltip.addEventListener("popupshowing",
        function(event) {
            event.stopPropagation();
            return EBRadioGUIManager_CT2958529.OnTooltipPopupShowing(false, event, strToolbarButtonID);
        }, false);
        objXULTooltip.setAttribute('noautohide', 'true');
        objMainPopupSet.appendChild(objXULTooltip);
    },

    CreateRealTooltip: function() {
        if (!this.xulMenuButton) return;

        var strMainPopupSetID = EBComponentsConsts_CT2958529.MainPopupSetID;
        var objMainPopupSet = document.getElementById(strMainPopupSetID);
        var strTooltipID = this.TooltipRealID;
        var strOrient = 'horisontal';
        //patch to 1.0.* - send the toolbarbutton id to retrieve the label and tooltip instead of
        //the toolbarbutton object itself as a param to the onpopupshowing event
        //set addEventListener also fails to work in 1.0.*
        var strToolbarButtonID = this.xulMenuButton.getAttribute('id');
        var strOnPopupShowing = "";
        var objXULTooltip = EBXULFactory_CT2958529.CreateTooltip(strTooltipID, strOrient, strOnPopupShowing);
        objXULTooltip.addEventListener("popupshowing",
        function(event) {
            event.stopPropagation();
            return EBRadioGUIManager_CT2958529.OnTooltipPopupShowing(true, event, strToolbarButtonID);
        }, false);
        objXULTooltip.setAttribute('noautohide', 'true');
        objMainPopupSet.appendChild(objXULTooltip);
    },

    OnTooltipPopupShowing: function(isReal, event, strToolbarButtonID) {
        if (event.eventPhase != 2) return false;

        var XULTooltip = event.target;
        var XULToolbarButton = document.getElementById(strToolbarButtonID);

        //check to see if the mouse is hover the toolbarbutton
        //to prevent this tooltip shown on this toolbar buttons childs
        if (!EBGlobalManager_CT2958529.IsElementInScreenCoordinates(XULToolbarButton) && !isReal)
            return false;


        while (XULTooltip.childNodes.length > 0)
            XULTooltip.removeChild(XULTooltip.firstChild);

        var mediaName = XULToolbarButton.getAttribute('label');
        var mediaType = XULToolbarButton.getAttribute('MediaType');
        var mediaURL = XULToolbarButton.getAttribute('MediaURL');
        var strImage = '';

        switch (mediaType) {
            case EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer: strImage = this.Images.imgWMPLogo; break;
            case EBRadioConsts_CT2958529.PlayerTypes.RealPlayer:
                strImage = this.Images.imgRealLogo;
                mediaName += ' ' + this.Tooltips.playingReal;
                break;
            case "Podcast": strImage = this.Images.imgPodcast; break;
        }

        var XULTooltipCont = EBXULFactory_CT2958529.CreateHBox('', '', '');
        var XULLeftCont = EBXULFactory_CT2958529.CreateHBox('', '', '');
        var XULRightCont = EBXULFactory_CT2958529.CreateVBox('', '', '');
        var XULRightTop = EBXULFactory_CT2958529.CreateHBox('', '', '');
        var XULRightBottom = EBXULFactory_CT2958529.CreateHBox('', '', '');
        var XULLeftImage = EBXULFactory_CT2958529.CreateImage(EBRadioGUIManager_CT2958529.Images.imgRadioTooltip, '', '');
        var XULMediaImage = EBXULFactory_CT2958529.CreateImage(strImage, '', '');
        var XULMediaName = EBXULFactory_CT2958529.CreateLabel(mediaName, '');

        XULLeftCont.appendChild(XULLeftImage);
        XULLeftCont.setAttribute('style', 'margin: 3px 10px 3px 10px');
        XULRightTop.appendChild(XULMediaImage);
        XULRightTop.appendChild(XULMediaName);
        XULRightTop.setAttribute('style', 'margin: 7px 3px 0px 0px');
        XULRightCont.appendChild(XULRightTop);
        XULRightCont.appendChild(XULRightBottom);

        XULTooltipCont.appendChild(XULLeftCont);
        XULTooltipCont.appendChild(XULRightCont);
        XULTooltipCont.setAttribute('style', '');
        XULTooltip.appendChild(XULTooltipCont);

        return true;
    }
};
//Radio IO Manager Class
var EBRadioIOManager_CT2958529 =
{
    SetStationToRegistry: function(name, url, mediaType, menuID, isPodcast, mediaID) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.StationName, encodeURIComponent(name));
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.StationURL, url);
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.MediaType, mediaType);
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.MenuSelectedID, menuID);
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.IsPodcast, isPodcast);
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.MediaID, mediaID);
    },

    GetUseRealActiveX: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.UseRealActiveX);
    },

    SetShrinkedToRegistry: function(state) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.Shrinked, state);
    },

    GetShrinkedFromRegistry: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.Shrinked);
    },

    SetVolumeToRegistry: function(volume) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.Volume, volume);
    },

    GetVolumeFromRegistry: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.Volume);
    },

    GetStationNameFromRegistry: function() {
        return decodeURIComponent(EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.StationName));
    },

    GetStationURLFromRegistry: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.StationURL);
    },

    GetMediaTypeFromRegistry: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.MediaType);
    },

    GetMenuSelectedIdFromRegistry: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.MenuSelectedID);
    },

    GetStationIdFromRegistry: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.MediaID);
    },

    GetIsPodcastFromRegistry: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.IsPodcast);
    },

    Init: function(oRadio) {
        if (oRadio.ComponentItem.PredefinedListInterval) {
            EBRadioConsts_CT2958529.CheckInterval = oRadio.ComponentItem.PredefinedListInterval * 60 * 1000;
        }
        if (oRadio.ComponentItem.PodcastInterval) {
            EBRadioConsts_CT2958529.PodcastCheckInterval = oRadio.ComponentItem.PodcastInterval;
        }
        if (oRadio.ComponentItem.RadioServerURL) {
            EBRadioConsts_CT2958529.ServerURL = oRadio.ComponentItem.RadioServerURL;
        }

        EBRadioServerComm_CT2958529.RequestPublisherMedia();
    },

    SaveMediaXMLToFile: function(XMLStationsNode, strRadioFullPath) {
        //var strRadioFolder = EBRadioConsts_CT2958529.FolderName;
        //var strRadioFullPath = strRadioFolder + EBDirIO_CT2958529.sep + MediaFile;
        var oFileMedia = EBIOManager_CT2958529.CreateToolbarFile(strRadioFullPath);
        var strXML = EBXML_CT2958529.GetStringXml(XMLStationsNode);
        EBFileIO_CT2958529.write(oFileMedia, strXML, "", EBGlobalConsts_CT2958529.DefaultCharset);
    },

    LoadMediaFromFile: function(which) {
        var FileName = '';
        var strRadioFolder = EBRadioConsts_CT2958529.FolderName;

        if (which == EBRadioConsts_CT2958529.MediaFileType.Publisher) {
            FileName = EBRadioConsts_CT2958529.PublisherMediaFile;
           if (EBMCManager_CT2958529 && !EBMCManager_CT2958529.IsSelectedOriginalCommunity())
                strRadioFolder = EBMCManager_CT2958529.GetCommunitySettingsPath() + strRadioFolder;
        }
        else if (which == EBRadioConsts_CT2958529.MediaFileType.User) {
            this.GetUserMediaFromCookies();
            FileName = EBRadioConsts_CT2958529.UserMediaFile;
        }
        else if (which == EBRadioConsts_CT2958529.MediaFileType.Recent)
            FileName = EBRadioConsts_CT2958529.RecentMediaFile;
        else if (which == EBRadioConsts_CT2958529.MediaFileType.IP)
            FileName = EBRadioConsts_CT2958529.IPMediaFile;
        else
            return null;

        var strRadioFullPath = strRadioFolder + EBDirIO_CT2958529.sep + FileName;

        var oFile = EBIOManager_CT2958529.CreateToolbarFile(strRadioFullPath);
        var strXMLMedia = EBFileIO_CT2958529.read(oFile, EBGlobalConsts_CT2958529.DefaultCharset);
        var XMLMedia = null;

        if (strXMLMedia)
            XMLMedia = EBXML_CT2958529.GetXmlDocument(strXMLMedia);

        //check if file is valid
        var isPublisherRadio = EBComponentsManager_CT2958529.GetRadioComponent().ComponentItem.objData.isPublisher;
        if (strXMLMedia.length == 0) {
            if (which == EBRadioConsts_CT2958529.MediaFileType.Publisher && isPublisherRadio) {
                EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastCheckTime, "0", true)
                EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerTime, "0", true);
            }
            else if (which == EBRadioConsts_CT2958529.MediaFileType.Recent)
                return new EBRadioRecentMediaList_CT2958529();
            else if (which == EBRadioConsts_CT2958529.MediaFileType.IP
			        && (!isPublisherRadio || (isPublisherRadio && EBRadioConsts_CT2958529.EnableIPStations))) {
                EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastCheckTime, "0", true)
                EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerIPTime, "0", true);
            }
            else
                return new EBRadioMediaList_CT2958529();
        }

        if (!XMLMedia) return null;

        var MediaList = null;
        if (which == EBRadioConsts_CT2958529.MediaFileType.Recent)
            MediaList = new EBRadioRecentMediaList_CT2958529(XMLMedia.documentElement);
        else
            MediaList = new EBRadioMediaList_CT2958529(XMLMedia.documentElement);

        return MediaList;

    },

    DeleteRecentStations: function() {
        var strFileName = EBRadioConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBRadioConsts_CT2958529.RecentMediaFile;
        if (!EBIOManager_CT2958529.IsToolbarFileExists(strFileName)) return;

        var oFile = EBIOManager_CT2958529.CreateToolbarFile(strFileName);
        if (oFile)
            EBFileIO_CT2958529.unlink(oFile);
    },

    GetUserMediaFromCookies: function() {
        var Imported = EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.CookiesImportComplete);
        if (Imported)
            return;

        var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
        var oCookieManager = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);
        uri.spec = EBRadioConsts_CT2958529.StationsCookie.DomainConduit;
        var strCookies = oCookieManager.getCookieString(uri, null);
        if (!strCookies || !strCookies.match(EBRadioConsts_CT2958529.StationsCookie.Name)) {
            uri.spec = EBRadioConsts_CT2958529.StationsCookie.DomainSite2;
            strCookies = oCookieManager.getCookieString(uri, null);
            if (!strCookies || !strCookies.match(EBRadioConsts_CT2958529.StationsCookie.Name)) {
                uri.spec = EBRadioConsts_CT2958529.StationsCookie.DomainEffectiveBrand;
                strCookies = oCookieManager.getCookieString(uri, null);
                if (!strCookies) {
                    return;
                }
            }
        }
        var arrCookies = strCookies.split(";");
        var i = 0;
        while (!arrCookies[i].match(EBRadioConsts_CT2958529.StationsCookie.Name) && i < arrCookies.length - 1) {
            i++;
        }
        if (!arrCookies[i].match(EBRadioConsts_CT2958529.StationsCookie.Name)) {
            EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.CookiesImportComplete, true);
            return;
        }
        var strMediaList = arrCookies[i].replace(EBRadioConsts_CT2958529.StationsCookie.Name + "=", "")
        strMediaList = decodeURIComponent(strMediaList);
        var arrMediaList = strMediaList.split("!!");
        var strXMLMedia = EBXML_CT2958529.CreateXmlNodeStartString(EBRadioConsts_CT2958529.xmlTags.RADIO_STATIONS);
        var arrMedia = null;
        for (i = 0; i < arrMediaList.length; i++) {
            arrMedia = arrMediaList[i].split("|");
            strXMLMedia += EBXML_CT2958529.CreateXmlNodeStartString(EBRadioConsts_CT2958529.xmlTags.RADIO_STATION);
            strXMLMedia += EBXML_CT2958529.CreateXmlNodeString(EBRadioConsts_CT2958529.xmlTags.STATION_ID, arrMedia[1]);
            strXMLMedia += EBXML_CT2958529.CreateXmlNodeString(EBRadioConsts_CT2958529.xmlTags.STATION_NAME, decodeURIComponent(arrMedia[2]));
            strXMLMedia += EBXML_CT2958529.CreateXmlNodeString(EBRadioConsts_CT2958529.xmlTags.STATION_URL, arrMedia[3]);
            strXMLMedia += EBXML_CT2958529.CreateXmlNodeString(EBRadioConsts_CT2958529.xmlTags.TYPE, arrMedia[4]);
            strXMLMedia += EBXML_CT2958529.CreateXmlNodeString(EBRadioConsts_CT2958529.xmlTags.CONTENT_TYPE, arrMedia[5]);
            strXMLMedia += EBXML_CT2958529.CreateXmlNodeEndString(EBRadioConsts_CT2958529.xmlTags.RADIO_STATION);
        }
        strXMLMedia += EBXML_CT2958529.CreateXmlNodeEndString(EBRadioConsts_CT2958529.xmlTags.RADIO_STATIONS);
        strXMLMedia = EBXML_CT2958529.LegalizeEBXML(strXMLMedia);
        var XMLMedia = EBXML_CT2958529.GetXmlDocument(strXMLMedia);

        var UserMediaFileName = EBRadioConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBRadioConsts_CT2958529.UserMediaFile;
        this.SaveMediaXMLToFile(XMLMedia, UserMediaFileName);

        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.CookiesImportComplete, true);
    },

    SetPlayState: function(state) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.PlayState, state);
    },

    GetPlayState: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.PlayState);
    },

    SetShowState: function(state) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.ShowState, state);
    },

    GetShowState: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.ShowState);
    },

    SetPlayingStation: function(ID, name) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.StationID, ID);
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.StationName, name);
    },

    GetPlayingStationName: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.StationName);
    },

    GetPlayingStationID: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.StationID);
    },

    SetErrorString: function(strError) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.ErrorString, strError);
    },

    GetErrorString: function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.ErrorString);
    },

    FillStationsInfo: function(xmlDoc, tagName) {
        var XMLPublisherNode = null;
        var xmlStations = null;
        var strXmlText = '';
        var strLUT = '0';
        var obj = new Object();


        XMLPublisherNode = EBXML_CT2958529.SelectSingleNode(xmlDoc, tagName);
        if (XMLPublisherNode) {
            strXmlText = EBXML_CT2958529.GetXmlNodeValue(XMLPublisherNode);
            if (strXmlText != EBRadioConsts_CT2958529.XMLResponseErrorReply) {
                obj.error = false;
                for (var i = 0; i < XMLPublisherNode.childNodes.length; i++) {
                    if (XMLPublisherNode.childNodes[i].tagName == EBRadioConsts_CT2958529.XMLRadioStations) {
                        xmlStations = XMLPublisherNode.childNodes[i];
                    }
                    else if (XMLPublisherNode.childNodes[i].tagName == EBRadioConsts_CT2958529.XMLLUT) {
                        strLUT = EBXML_CT2958529.GetXmlNodeValue(XMLPublisherNode.childNodes[i]);
                    }
                }

                if (xmlStations && xmlStations.childNodes.length == 0)
                    xmlStations = null;
            }
            else
                obj.error = true;

            if (xmlStations) {
                strXmlText = EBXML_CT2958529.GetXmlNodeValue(xmlStations);

                if (strXmlText == EBRadioConsts_CT2958529.XMLResponseNoChange)
                    xmlStations = null;
            }
        }

        obj.xmlStations = xmlStations;
        obj.lut = strLUT;

        return obj;
    },

    NullifyTimes: function() {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastCheckTime, "0", true);
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerTime, "0", true);
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerIPTime, "0", true);
    },

    InvalidateCache: function(bValue) {
        var bOldValud = EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.InvalidateCache, true);
        if (typeof bValue != "undefined")
            EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.InvalidateCache, bValue, true);

        return bOldValud;
    }
}
//Radio Manager
var EBRadioManager_CT2958529 =
{
    isAfterRefresh: false,
    isShrink: false,
    isUnshrink: false,
    observer: null,
    isLastEventError: false,

    UnloadToolbar: function(isShown) {
        EBRadioCore_CT2958529.UnloadToolbar(isShown);

        if (isShown) {
            var oRadio = EBComponentsManager_CT2958529.GetRadioComponent();
            EBRadioSkinManager_CT2958529.UnloadSkin(oRadio, 1);
        }

        if (this.observer) {
            this.observer.unregister();
            this.observer = null;
        }
    },

    RadioBuildComplete: function() {
        this.Init(true);
    },

    ApplySkin: function() {
        var oRadio = EBComponentsManager_CT2958529.GetRadioComponent();
        EBRadioSkinManager_CT2958529.LoadSkin(oRadio, 1);
    },

    CheckIfSkinLoaded: function() {
        if (!EBRadioSkinManager_CT2958529.ObjSkinDef)
            EBRadioSkinManager_CT2958529.LoadDefaultSkin();
    },

    BroadcastVolume: function(volume) {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioManager_CT2958529) {
                try {
                    objWindow.EBRadioConsts_CT2958529.NowState.Volume = volume;
                }
                catch (ex) { EBLog(ex); }
            }
        }
        EBRadioCore_CT2958529.BroadcastVolume(volume);
    },

    SetInChevron: function(xulChevronMenu) {
        var XULMenu = EBRadioConsts_CT2958529.RadioMenu.GetXULMenu();
        while (xulChevronMenu.childNodes.length > 0) {
            xulChevronMenu.removeChild(xulChevronMenu.firstChild);
        }
        xulChevronMenu.appendChild(XULMenu);
        EBRadioConsts_CT2958529.NowState.InChevron = true;
    },

    SetOutChevron: function() {
        if (!EBRadioConsts_CT2958529.RadioMenu) return;

        var XULMenu = EBRadioConsts_CT2958529.RadioMenu.GetXULMenu();
        var RadioMenuButtonID = EBRadioConsts_CT2958529.RadioMenuButtonID;
        var menuButton = document.getElementById(RadioMenuButtonID)
        if (menuButton) {
            while (menuButton.childNodes.length > 0) {
                menuButton.removeChild(menuButton.firstChild);
            }
            menuButton.appendChild(XULMenu);
        }
        EBRadioConsts_CT2958529.NowState.InChevron = false;
    },

    StateManager: function(strState, strError) {
        this.notifyHtmlComponentsObservers(strState, strError);

        if (EBRadioConsts_CT2958529.NowState.PlayState != strState) {
            if (!EBRadioConsts_CT2958529.NowState.IsUserPause) {
                if (strState == "stopped" && EBRadioConsts_CT2958529.NowState.IsPodcast) {
                    this.PlayNextPodcastItem();
                }
            }
            this.changeState(strState, strError);

            //client log - radio error
            if (strState == "error") {
                if (!this.isAfterRefresh) {
                    var objToolbarInfo = new oToolbar_CT2958529.clientLog.toolbarInfo(
                    EBGlobalConsts_CT2958529.Version,
                    EBGlobalConsts_CT2958529.ToolbarCTID,
                    EBActionManager_CT2958529.GetCTID(),
                    EBGlobalManager_CT2958529.GetOS(),
                    EBGlobalManager_CT2958529.GetBrowserNameAndVersion());
                    var msg = "";
                    var data = EBXML_CT2958529.CreateXmlNodeStartString("ERR_DESCRIPTION");
                    data += EBXML_CT2958529.CreateXmlNodeString("PLAYER_MSG", strError);
                    data += EBXML_CT2958529.CreateXmlNodeString("STATION_URL", EBRadioConsts_CT2958529.NowState.StationURL);
                    data += EBXML_CT2958529.CreateXmlNodeEndString("ERR_DESCRIPTION");

                    var objEvent = new oToolbar_CT2958529.clientLog.event(20, "ERROR", msg, data);
                    oToolbar_CT2958529.clientLog.manager.send(objToolbarInfo, objEvent);
                }
                this.broadcastIsAfterRefresh(false);
            }
        }
    },


    changeState: function(strState, strError) {
        if (window.EBRadioGUIManager_CT2958529.SetNewState) {
            try {
                window.EBRadioManager_CT2958529.isLastEventError = this.isLastEventError;
                window.EBRadioConsts_CT2958529.NowState.PlayState = strState;
                window.EBRadioConsts_CT2958529.NowState.ErrorStr = strError;
                window.EBRadioGUIManager_CT2958529.SetNewState(strState, strError);
                window.EBRadioConsts_CT2958529.NowState.IsUserPause = false;
            }
            catch (ex) { }
        }
    },


    updateHtmlComponentState: function() {
        var state = EBRadioConsts_CT2958529.NowState.PlayState;
        var error = EBRadioConsts_CT2958529.NowState.ErrorStr;
        this.notifyHtmlComponentsObservers(state, error);
    },

    notifyHtmlComponentsObservers: function(strState, strError) {
        var strState = EBRadioCore_CT2958529.GetStateForHtmlComponents(strState, strError);
        if (!strState) return;

        var aSubject = EBObserversManager_CT2958529.GetSubject(EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true).gBrowser.ebWindowId_CT2958529);
        aSubject.state = strState;
        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject, EBObserversManager_CT2958529.ToolbarEventsTopic, EBObserversManager_CT2958529.ToolbarEventsData.RadioStateChanged);
    },

    PlayNextPodcastItem: function() {
        EBRadioConsts_CT2958529.RadioMenu.PlayNextPodcastItem(EBRadioConsts_CT2958529.NowState.MenuSelectedID);
    },

    CheckIfStationLoaded: function() {
        var menuButton = document.getElementById(EBRadioConsts_CT2958529.RadioMenuButtonID)

        //if shrink mode, return
        if (!menuButton)
            return;

        var btnLabel = menuButton.getAttribute('label');

        if (btnLabel == EBRadioConsts_CT2958529.LoadingText)
            menuButton.setAttribute('label', EBRadioDialogManager_CT2958529.NoStationsText);

        if (btnLabel == EBRadioDialogManager_CT2958529.NoStationsText)
            this.FindStationToSelect();
    },

    FindStationToSelect: function(lastPodcastId) {
        var userMediaList = EBRadioConsts_CT2958529.UserMediaList;
        var otherMediaList = (EBComponentsManager_CT2958529.GetRadioComponent().ComponentItem.objData.isPublisher) ? EBRadioConsts_CT2958529.PublisherMediaList : EBRadioConsts_CT2958529.IPMediaList;
        if ((!otherMediaList || otherMediaList.arrMedia.Count() == 0) &&
			(!userMediaList || userMediaList.arrMedia.Count() == 0)) {
            EBRadioConsts_CT2958529.NowState.StationName = EBRadioDialogManager_CT2958529.NoStationsText;
            EBRadioConsts_CT2958529.NowState.StationURL = '';
            EBRadioConsts_CT2958529.NowState.MenuSelectedID = '';
            EBRadioConsts_CT2958529.NowState.IsPodcast = false;
            EBRadioConsts_CT2958529.NowState.MediaID = '';
            EBRadioGUIManager_CT2958529.SetStation(EBRadioConsts_CT2958529.NowState.StationName, EBRadioConsts_CT2958529.NowState.MediaType, EBRadioConsts_CT2958529.NowState.StationURL);
        }
        else {
            //try to find station, not podcast
            var found = false;
            var i = 0;
            var mediaList = null;
            var noPublisherMedia = false;
            var switched = false;
            if (otherMediaList.arrMedia.Count() != 0)
                mediaList = otherMediaList.arrMedia;
            else {
                mediaList = userMediaList.arrMedia;
                switched = true;
                noPublisherMedia = true;
            }
            var media = null;
            do {
                media = mediaList.GetByIndex(i);
                if (!media.isPodCast) {
                    found = true;
                }
                else {
                    if (mediaList.Count() == i + 1 && !switched) {
                        mediaList = userMediaList.arrMedia;
                        i = 0;
                        switched = true;
                    }
                    else {
                        i++;
                    }
                }
            }
            while (media.isPodCast && i < mediaList.Count())

            if (found) {
                EBRadioConsts_CT2958529.NowState.StationURL = media.MediaURL;
                EBRadioConsts_CT2958529.NowState.StationName = media.MediaName;
                EBRadioConsts_CT2958529.NowState.MediaType = media.GetTypeString();
                EBRadioConsts_CT2958529.NowState.MenuSelectedID = EBRadioConsts_CT2958529.MenuIDPreffix + media.MediaID;
                EBRadioConsts_CT2958529.NowState.IsPodcast = false;
                EBRadioConsts_CT2958529.NowState.MediaID = media.MediaID;
            }
            else {
                if (noPublisherMedia) {
                    media = userMediaList.arrMedia.GetByIndex(0);
                }
                else {
                    media = otherMediaList.arrMedia.GetByIndex(0);
                }
                var podcastMenuId = EBRadioConsts_CT2958529.MenuIDPreffix + media.MediaID;
                var oPodcastMenu = document.getElementById(podcastMenuId);
                var oFirstPodcastItem = oPodcastMenu.firstChild;
                var strMediaURL = oFirstPodcastItem.getAttribute('MediaURL');
                if (strMediaURL) {
                    EBRadioConsts_CT2958529.NowState.StationURL = strMediaURL;
                    EBRadioConsts_CT2958529.NowState.MediaType = EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer
                    EBRadioConsts_CT2958529.NowState.StationName = oFirstPodcastItem.getAttribute('MediaName');
                    EBRadioConsts_CT2958529.NowState.MenuSelectedID = oFirstPodcastItem.getAttribute('id');
                    EBRadioConsts_CT2958529.NowState.IsPodcast = true;
                    EBRadioConsts_CT2958529.NowState.MediaID = media.MediaID;
                    found = true;

                }
                else {
                    EBRadioConsts_CT2958529.NowState.StationName = EBRadioDialogManager_CT2958529.NoStationsText;
                    EBRadioConsts_CT2958529.NowState.StationURL = '';
                    EBRadioConsts_CT2958529.NowState.MenuSelectedID = '';
                    EBRadioConsts_CT2958529.NowState.IsPodcast = false;
                    EBRadioConsts_CT2958529.NowState.MediaID = '';
                    EBRadioGUIManager_CT2958529.SetStation(EBRadioConsts_CT2958529.NowState.StationName, EBRadioConsts_CT2958529.NowState.MediaType, EBRadioConsts_CT2958529.NowState.StationURL);
                    EBRadioConsts_CT2958529.SetStationName = oFirstPodcastItem.getAttribute('id');
                    setTimeout(function() { EBRadioManager_CT2958529.CheckIfStationLoaded(); }, 500);
                }
            }
        }
        if (found) {
            EBRadioIOManager_CT2958529.SetStationToRegistry(EBRadioConsts_CT2958529.NowState.StationName,
																	EBRadioConsts_CT2958529.NowState.StationURL,
																	EBRadioConsts_CT2958529.NowState.MediaType,
																	EBRadioConsts_CT2958529.NowState.MenuSelectedID,
																	EBRadioConsts_CT2958529.NowState.IsPodcast,
																	EBRadioConsts_CT2958529.NowState.MediaID);
            EBRadioGUIManager_CT2958529.SetStation(EBRadioConsts_CT2958529.NowState.StationName,
															EBRadioConsts_CT2958529.NowState.MediaType,
															EBRadioConsts_CT2958529.NowState.StationURL);
            EBRadioConsts_CT2958529.RadioMenu.OnMenuStationSelect(EBRadioConsts_CT2958529.NowState.MenuSelectedID);
        }
    },

    UpdateMenuButtonAfterShrink: function(xulMenuButton) {
        if (EBRadioConsts_CT2958529.RadioMenu) {
            var menuPopup = EBRadioConsts_CT2958529.RadioMenu.XULMenu;
            xulMenuButton.appendChild(menuPopup);
            EBRadioGUIManager_CT2958529.SetStation(EBRadioConsts_CT2958529.NowState.StationName,
												 EBRadioConsts_CT2958529.NowState.MediaType,
												 EBRadioConsts_CT2958529.NowState.StationURL);
        }
    },

    UpdateGUIOnLoad: function(forceFind) {
        EBRadioConsts_CT2958529.NowState.StationURL = EBRadioIOManager_CT2958529.GetStationURLFromRegistry();
        EBRadioConsts_CT2958529.NowState.MediaType = EBRadioIOManager_CT2958529.GetMediaTypeFromRegistry();
        EBRadioConsts_CT2958529.NowState.MenuSelectedID = EBRadioIOManager_CT2958529.GetMenuSelectedIdFromRegistry();
        EBRadioConsts_CT2958529.NowState.IsPodcast = EBRadioIOManager_CT2958529.GetIsPodcastFromRegistry();
        EBRadioConsts_CT2958529.NowState.StationName = EBRadioIOManager_CT2958529.GetStationNameFromRegistry();
        EBRadioConsts_CT2958529.NowState.MediaID = EBRadioIOManager_CT2958529.GetStationIdFromRegistry();
        var stationNotExists = false;

        if (EBRadioConsts_CT2958529.NowState.MenuSelectedID) {
            var selectedMenu = document.getElementById(EBRadioConsts_CT2958529.NowState.MenuSelectedID)
            if (!selectedMenu) {
                if (!EBRadioConsts_CT2958529.NowState.IsPodcast)
                    stationNotExists = true;
                else
                    setTimeout(function() { EBRadioManager_CT2958529.CheckIfStationLoaded(); }, 350);
            }
        }

        // no selected station or must find new one to select
        if (!EBRadioConsts_CT2958529.NowState.StationURL || forceFind || stationNotExists) {
            this.FindStationToSelect(forceFind);
        }
        else if (!EBRadioConsts_CT2958529.NowState.IsPodcast) {
            EBRadioGUIManager_CT2958529.SetStation(EBRadioConsts_CT2958529.NowState.StationName,
														EBRadioConsts_CT2958529.NowState.MediaType,
														EBRadioConsts_CT2958529.NowState.StationURL);
            EBRadioConsts_CT2958529.RadioMenu.OnMenuStationSelect(EBRadioConsts_CT2958529.NowState.MenuSelectedID);
        }
        else {
            EBRadioConsts_CT2958529.IsUpdateStationFromPodcast = true;
        }
    },

    UpdatePlayState: function() {
        EBRadioGUIManager_CT2958529.SetNewState(EBRadioConsts_CT2958529.NowState.PlayState);

        if (EBRadioConsts_CT2958529.NowState.ButtonState == "pause") {
            EBRadioGUIManager_CT2958529.OnPlay();
        }

    },

    BroadcastNewState: function(strState, strError) {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioGUIManager_CT2958529.SetNewState) {
                try {
                    objWindow.EBRadioManager_CT2958529.isLastEventError = this.isLastEventError;
                    objWindow.EBRadioConsts_CT2958529.NowState.PlayState = strState;
                    objWindow.EBRadioConsts_CT2958529.NowState.ErrorStr = strError;
                    objWindow.EBRadioGUIManager_CT2958529.SetNewState(strState, strError);
                    objWindow.EBRadioConsts_CT2958529.NowState.IsUserPause = false;
                }
                catch (ex) { }
            }
        }
        var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
        var chevronWin = ChevronStaticManager.floatingWindowsArray[0];
        if (chevronWin && objWindow.EBRadioGUIManager_CT2958529.SetNewState) {
            try {
                chevronWin.EBRadioManager_CT2958529.isLastEventError = this.isLastEventError;
                chevronWin.EBRadioConsts_CT2958529.NowState.PlayState = strState;
                chevronWin.EBRadioConsts_CT2958529.NowState.ErrorStr = strError;
                chevronWin.EBRadioGUIManager_CT2958529.SetNewState(strState, strError);
                chevronWin.EBRadioConsts_CT2958529.NowState.IsUserPause = false;
            }
            catch (ex) { }
        }
    },

    Init: function(bIsAfterRebuild) {
        setTimeout(function() { EBRadioManager_CT2958529.CheckIfStationLoaded(); }, 300);

        // real activeX core enable ?
        if (EBRadioIOManager_CT2958529.GetUseRealActiveX())
            EBRadioCore_CT2958529.useRealActiveX = true;
        // real activeX core end

        EBRadioConsts_CT2958529.NowState.Volume = EBRadioIOManager_CT2958529.GetVolumeFromRegistry();

        if (!EBRadioConsts_CT2958529.NowState.Volume)
            EBRadioConsts_CT2958529.NowState.Volume = 50;

        var oRadio = EBComponentsManager_CT2958529.GetRadioComponent();
        EBRadioConsts_CT2958529.EnableIPStations = oRadio.ComponentItem.EnableIPStations;
        EBRadioConsts_CT2958529.NowState.PlayState = 'stopped';

        EBRadioConsts_CT2958529.UserMediaList = EBRadioIOManager_CT2958529.LoadMediaFromFile(EBRadioConsts_CT2958529.MediaFileType.User);
        EBRadioConsts_CT2958529.PublisherMediaList = EBRadioIOManager_CT2958529.LoadMediaFromFile(EBRadioConsts_CT2958529.MediaFileType.Publisher);
        EBRadioConsts_CT2958529.RecentMediaList = EBRadioIOManager_CT2958529.LoadMediaFromFile(EBRadioConsts_CT2958529.MediaFileType.Recent);

        var isPublihserRadio = EBComponentsManager_CT2958529.GetRadioComponent().ComponentItem.objData.isPublisher;
        if (!isPublihserRadio
		    ||
		   (isPublihserRadio && EBRadioConsts_CT2958529.EnableIPStations)
		    ||
		   (EBActionManager_CT2958529.IsToolbarMC() || EBActionManager_CT2958529.IsToolbarGrouping())
		   ) {
            EBRadioConsts_CT2958529.IPMediaList = EBRadioIOManager_CT2958529.LoadMediaFromFile(EBRadioConsts_CT2958529.MediaFileType.IP);
        }

        EBRadioGUIManager_CT2958529.Init();

        var menuButton = document.getElementById(EBRadioConsts_CT2958529.RadioMenuButtonID)
        if (menuButton) {
            this.BuildRadioMenu(menuButton);
            this.UpdateGUIOnLoad(false);
        }

        EBRadioIOManager_CT2958529.Init(oRadio);

        setTimeout(function() { EBRadioManager_CT2958529.TimerManager(); }, EBRadioConsts_CT2958529.TimerInterval);
        this.CheckToShrink();
        EBRadioCore_CT2958529.Init();

        var self = this;
        if (!this.observer) {
            this.observer = new EBRadioCoreObserver_CT2958529(function(data) { self.HandleNewEvents(data); }, function(station) { self.ChangeMenuStation(station); });
            this.observer.register();
        }
    },

    GetActiveCore: function() {
        if (EBRadioCore_CT2958529.wmp) return EBRadioCore_CT2958529.wmp;
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioCore_CT2958529.wmp) return objWindow.EBRadioCore_CT2958529.wmp;
        }

        return null;
    },

    HandleNewEvents: function(eventType) {
        var wmp = this.GetActiveCore();
        if (eventType == EBRadioConsts_CT2958529.Observer.WaitingState)
            this.changeState("Connecting...");
        else {
            if (wmp) {
                try {

                    if (eventType == EBRadioConsts_CT2958529.Observer.NewStateEvent && !this.isLastEventError) {
                        var state = EBRadioCore_CT2958529.GetUniversalState(wmp.getPlayState(), EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer);
                        this.StateManager(state, '');
                    }
                    if (eventType == EBRadioConsts_CT2958529.Observer.ErrorEvent || this.isLastEventError) {
                        var error = wmp.getLastErrorMsg();
                        this.StateManager('error', error);

                        this.isLastEventError = true;
                    }
                }
                catch (e) {
                    EBLog(e);
                }
            }
            else //wmp core failed
                this.StateManager('error', "Cannot find Windows Media Player, click here for troubleshoot");
        }

    },


    CheckToShrink: function() {
        if (EBRadioIOManager_CT2958529.GetShrinkedFromRegistry() == 'shrinked' &&
    	    !EBRadioConsts_CT2958529.NowState.IsShrinked)
            EBRadioGUIManager_CT2958529.SetShrink();
    },

    TimerManager: function() {
        EBRadioServerComm_CT2958529.RequestPublisherMedia();
        setTimeout(function() { EBRadioManager_CT2958529.TimerManager(); }, EBRadioConsts_CT2958529.TimerInterval);
    },

    OnMenuStationSelect: function(menuItemObj, stationURL, mediaType, mediaName, isPodcast, addToRecent, isFromMoreStations) {

        EBRadioConsts_CT2958529.IsUpdateStationFromPodcast = false;
        var menuItemObjID = menuItemObj.getAttribute('id');
        //Add this station to recent list
        var mediaID = menuItemObjID.replace(EBRadioConsts_CT2958529.MenuIDPreffix, "");
        mediaID = mediaID.replace(EBRadioConsts_CT2958529.MenuIDRecentPreffix, "");
        var oMedia = null;

        var strMediaSource = EBUsageRadio_CT2958529.SourcePublisher;
        if (addToRecent) {
            if (EBRadioConsts_CT2958529.PublisherMediaList)
                oMedia = EBRadioConsts_CT2958529.PublisherMediaList.GetMediaByID(mediaID);

            if (!oMedia && EBRadioConsts_CT2958529.UserMediaList) {
                oMedia = EBRadioConsts_CT2958529.UserMediaList.GetMediaByID(mediaID);
                strMediaSource = EBUsageRadio_CT2958529.SourceUserDefined;
            }

            if (!oMedia && EBRadioConsts_CT2958529.IPMediaList) {
                oMedia = EBRadioConsts_CT2958529.IPMediaList.GetMediaByID(mediaID);
                strMediaSource = EBUsageRadio_CT2958529.SourceLocalStations;
            }
        }
        else {
            oMedia = EBRadioConsts_CT2958529.RecentMediaList.GetMediaByID(mediaID);
            strMediaSource = EBUsageRadio_CT2958529.SourceRecent;
        }

        if (oMedia) {
            EBRadioConsts_CT2958529.RecentMediaList.AddMedia(oMedia);
            var xmlStations = EBRadioConsts_CT2958529.RecentMediaList.toXML();
            var fileName = EBRadioConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBRadioConsts_CT2958529.RecentMediaFile;
            EBRadioIOManager_CT2958529.SaveMediaXMLToFile(xmlStations, fileName);

        }

        if (isFromMoreStations)
            strMediaSource = EBUsageRadio_CT2958529.SourceMore;

        //usage
        EBUsageRadio_CT2958529.OnPlay(strMediaSource, EBUsageRadio_CT2958529.ClickSourceMediaList, mediaID, stationURL, mediaName);

        //set the selected id for rebuild menu to new item in recent
        menuItemObjID = EBRadioConsts_CT2958529.MenuIDPreffix + EBRadioConsts_CT2958529.MenuIDRecentPreffix + mediaID;

        if (menuItemObjID == EBRadioConsts_CT2958529.NowState.MenuSelectedID && EBRadioConsts_CT2958529.NowState.PlayState == 'playing')
            return;
        EBRadioIOManager_CT2958529.SetStationToRegistry(mediaName, stationURL, mediaType, menuItemObjID, isPodcast, mediaID);
        var station = { "mediaName": mediaName, "stationURL": stationURL, "menuItemObjID": menuItemObjID, "isPodcast": isPodcast, "mediaType": mediaType, "RecentMediaList": EBRadioConsts_CT2958529.RecentMediaList };
        var aSubject = new Object();
        aSubject.wrappedJSObject = aSubject;
        aSubject.station = station;

        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject, EBRadioConsts_CT2958529.Observer.RadioWMPcoreTopic, EBRadioConsts_CT2958529.Observer.ChangeMenuStation);

        EBRadioCore_CT2958529.BroadcastPlay(stationURL, mediaType);
        //usage

    },

    ChangeMenuStation: function(station) {
        try {
            this.isLastEventError = false;
            EBRadioManager_CT2958529.HandleNewEvents(EBRadioConsts_CT2958529.Observer.WaitingState);
            window.EBRadioConsts_CT2958529.NowState.StationName = station.mediaName;
            window.EBRadioConsts_CT2958529.NowState.StationURL = station.stationURL;
            window.EBRadioConsts_CT2958529.NowState.MediaType = station.mediaType;
            window.EBRadioConsts_CT2958529.NowState.MenuSelectedID = station.menuItemObjID;
            window.EBRadioConsts_CT2958529.NowState.IsPodcast = station.isPodcast;
            window.EBRadioConsts_CT2958529.NowState.PlayState = "waiting";
            window.EBRadioConsts_CT2958529.NowState.ButtonState = "pause";
            window.EBRadioGUIManager_CT2958529.SetStation(station.mediaName, station.mediaType, station.stationURL);
            window.EBRadioConsts_CT2958529.RecentMediaList = window.EBRadioIOManager_CT2958529.LoadMediaFromFile(EBRadioConsts_CT2958529.MediaFileType.Recent);

            window.EBRadioGUIManager_CT2958529.OnPlay();
            window.setTimeout(function() { window.EBRadioManager_CT2958529.RebuildMenu(station.menuItemObjID, "OnMenuStationSelect"); }, 1);
        }
        catch (ex) { }
    },

    OnToolbarRefresh: function(bInvalidateCache) {
        this.broadcastIsAfterRefresh(true);
        EBRadioIOManager_CT2958529.NullifyTimes();
        EBRadioIOManager_CT2958529.InvalidateCache(bInvalidateCache);

        //reset radio IsShrinked 
        EBRadioConsts_CT2958529.NowState.IsShrinked = false;
    },

    ForceRefresh: function() {
        this.broadcastIsAfterRefresh(true);
        EBRadioIOManager_CT2958529.NullifyTimes(true);
        EBRadioServerComm_CT2958529.RequestPublisherMedia(true);
    },

    broadcastIsAfterRefresh: function(bIsAfterRefresh) {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioManager_CT2958529)
                objWindow.EBRadioManager_CT2958529.isAfterRefresh = bIsAfterRefresh;
        }
    },

    RebuildMenu: function(menuItemObjID, from) {
        var RadioMenuButtonID = EBRadioConsts_CT2958529.RadioMenuButtonID;
        var menuButton = document.getElementById(RadioMenuButtonID);
        this.BuildRadioMenu(menuButton);
        EBRadioConsts_CT2958529.RadioMenu.OnMenuStationSelect(menuItemObjID);

        if (from != "OnMenuStationSelect")
            EBRadioGUIManager_CT2958529.SetNewState(EBRadioConsts_CT2958529.NowState.PlayState);
    },

    ClearRecentStations: function() {
        EBRadioIOManager_CT2958529.DeleteRecentStations();
        this.UpdateMedia(EBRadioConsts_CT2958529.MediaFileType.Recent, null, null);
    },

    UpdateMedia: function(which, xmlMedia, xmlIPMedia) {
        //broadcast changes
        var localRecentMediaList = null;
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioManager_CT2958529.SetNewMedia) {
                try {
                    objWindow.EBRadioManager_CT2958529.SetNewMedia(which, xmlMedia, xmlIPMedia);
                }
                catch (ex) { }
            }
        }
    },

    SetNewMedia: function(which, xmlMedia, xmlIPMedia) {
        var savedSelectedStationID = null;
        //check if not first time menu
        //update local recent media list object

        if (EBRadioConsts_CT2958529.RadioMenu.activeMenuItem != null)
            savedSelectedStationID = EBRadioConsts_CT2958529.RadioMenu.activeMenuItem.getAttribute('id');

        switch (which) {
            case EBRadioConsts_CT2958529.MediaFileType.Publisher:
                if (xmlMedia)
                    EBRadioConsts_CT2958529.PublisherMediaList = new EBRadioMediaList_CT2958529(xmlMedia);

                if (xmlIPMedia)
                    EBRadioConsts_CT2958529.IPMediaList = new EBRadioMediaList_CT2958529(xmlIPMedia);

                var RadioMenuButtonID = EBRadioConsts_CT2958529.RadioMenuButtonID;
                var menuButton = document.getElementById(RadioMenuButtonID)
                this.BuildRadioMenu(menuButton);

                //if first time load or "no stations" appears on the radio button
                //find station from this stations update
                if (menuButton.getAttribute('label') == EBRadioDialogManager_CT2958529.NoStationsText) {
                    EBRadioConsts_CT2958529.NowState.MenuSelectedID = savedSelectedStationID;
                    this.UpdateGUIOnLoad(false);
                }
                else {
                    EBRadioConsts_CT2958529.RadioMenu.OnMenuStationSelect(savedSelectedStationID);
                }
                EBRadioGUIManager_CT2958529.SetNewState(EBRadioConsts_CT2958529.NowState.PlayState);
                break;
            case EBRadioConsts_CT2958529.MediaFileType.User:
                EBRadioConsts_CT2958529.UserMediaList = new EBRadioMediaList_CT2958529(xmlMedia);
                setTimeout(function() { EBRadioManager_CT2958529.RebuildMenu(savedSelectedStationID, 'SetNewMedia'); }, 1);
                break;
            case EBRadioConsts_CT2958529.MediaFileType.Recent:
                EBRadioConsts_CT2958529.RecentMediaList = new EBRadioRecentMediaList_CT2958529(xmlMedia);
                setTimeout(function() { EBRadioManager_CT2958529.RebuildMenu(savedSelectedStationID, 'SetNewMedia'); }, 1);
                break;
        }
    },

    BuildRadioMenu: function(menuButton) {
        EBRadioConsts_CT2958529.RadioMenu = new EBRadioMenu_CT2958529(EBRadioConsts_CT2958529.PublisherMediaList, EBRadioConsts_CT2958529.UserMediaList, EBRadioConsts_CT2958529.RecentMediaList, EBRadioConsts_CT2958529.IPMediaList, EBRadioSkinManager_CT2958529.ObjSkinDef);
        var XULMenu = EBRadioConsts_CT2958529.RadioMenu.GetXULMenu();
        if (menuButton) {
            while (menuButton.childNodes.length > 0)
                menuButton.removeChild(menuButton.firstChild);
            menuButton.appendChild(XULMenu);
        }
    },

    BuildPodCastMenu: function(strXMLPodcast, podcastMenuID) {
        var XMLPodcast = EBXML_CT2958529.GetXmlDocument(strXMLPodcast);
        var PodCastObj = new EBRadioPodCastMenu_CT2958529(XMLPodcast);
        var XULPodcastMenu = PodCastObj.GetXULMenu();
        document.getElementById(podcastMenuID).appendChild(XULPodcastMenu);
    },

    OnRadioMenuClick: function(obj) { },

    OnPlay: function() {
        EBRadioConsts_CT2958529.IsUpdateStationFromPodcast = false;
        if (EBRadioConsts_CT2958529.NowState.PlayState != "playing" && EBRadioConsts_CT2958529.NowState.PlayState != "error" && EBRadioConsts_CT2958529.NowState.StationURL) {
            var txtStationURL = null;
            this.isLastEventError = false;
            if (EBRadioConsts_CT2958529.NowState.PlayState != 'paused')
                txtStationURL = EBRadioConsts_CT2958529.NowState.StationURL;
            EBObserversManager_CT2958529.NotifyCustomObserver(null, EBRadioConsts_CT2958529.Observer.RadioWMPcoreTopic, EBRadioConsts_CT2958529.Observer.WaitingState);
            this.BroadcastOnPlay();
            EBRadioCore_CT2958529.BroadcastPlay(txtStationURL, EBRadioConsts_CT2958529.NowState.MediaType);

            EBRadioManager_CT2958529.HandleNewEvents(EBRadioConsts_CT2958529.Observer.NewStateEvent);
        }

        //usage
        var strMediaSource = this.GetMediaSourceByMediaId(EBRadioConsts_CT2958529.NowState.MediaID)
        var strStationId = EBRadioConsts_CT2958529.NowState.MediaID;
        EBUsageRadio_CT2958529.OnPlay(strMediaSource, EBUsageRadio_CT2958529.ClickSourcePlayBtn, strStationId, EBRadioConsts_CT2958529.NowState.StationURL, EBRadioConsts_CT2958529.NowState.StationName);

    },

    GetMediaSourceByMediaId: function(mediaID) {
        if (!mediaID)
            return '';

        var oMedia = EBRadioConsts_CT2958529.RecentMediaList.GetMediaByID(mediaID);
        if (oMedia)
            return EBUsageRadio_CT2958529.SourceRecent;

        oMedia = EBRadioConsts_CT2958529.PublisherMediaList.GetMediaByID(mediaID);
        if (oMedia)
            return EBUsageRadio_CT2958529.SourcePublisher;

        oMedia = EBRadioConsts_CT2958529.UserMediaList.GetMediaByID(mediaID);
        if (oMedia)
            return EBUsageRadio_CT2958529.SourceUserDefined;

        oMedia = EBRadioConsts_CT2958529.IPMediaList.GetMediaByID(mediaID);
        if (oMedia)
            return EBUsageRadio_CT2958529.SourceLocalStations;

        return "";
    },

    BroadcastOnPlay: function() {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioGUIManager_CT2958529.OnPlay) {
                try {
                    objWindow.EBRadioGUIManager_CT2958529.OnPlay();
                    objWindow.EBRadioConsts_CT2958529.NowState.ButtonState = "pause";
                }
                catch (ex) { }
            }
        }
    },


    OnPause: function(isStop) {
        //usage
        EBUsageRadio_CT2958529.OnStop();

        if (EBRadioConsts_CT2958529.NowState.PlayState != 'error') {
            this.isLastEventError = false;
            this.BroadcastNewState("stopped", "");
            this.BroadcastOnPause();
            EBRadioCore_CT2958529.BroadcastPause(isStop);

            // EBRadioManager_CT2958529.HandleNewEvents(EBRadioConsts_CT2958529.Observer.NewStateEvent);
        }
    },

    BroadcastOnPause: function() {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioGUIManager_CT2958529.OnPause) {
                try {
                    objWindow.EBRadioConsts_CT2958529.NowState.ButtonState = "play";
                    objWindow.EBRadioGUIManager_CT2958529.OnPause();
                    objWindow.EBRadioConsts_CT2958529.NowState.IsUserPause = true;
                }
                catch (ex) { }
            }
        }
        var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
        var chevronWin = ChevronStaticManager.floatingWindowsArray[0];
        if (chevronWin && chevronWin.EBRadioGUIManager_CT2958529.OnPause) {
            try {
                chevronWin.EBRadioConsts_CT2958529.NowState.ButtonState = "play";
                chevronWin.EBRadioGUIManager_CT2958529.OnPause();
                chevronWin.EBRadioConsts_CT2958529.NowState.IsUserPause = true;
            }
            catch (ex) { }
        }
    },

    OnShrink: function(bIsFromToolbarShrink) {
        //usage
        if (!bIsFromToolbarShrink)
            EBUsageRadio_CT2958529.OnShrink();

        if (EBRadioIOManager_CT2958529.GetShrinkedFromRegistry == 'shrinked')
            return;

        EBRadioIOManager_CT2958529.SetShrinkedToRegistry('shrinked');
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;

        if (isFloatingMode_CT2958529) {
            EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().EBRadioManager_CT2958529.isShrink = true;
            window.EBRadioGUIManager_CT2958529.SetShrink();

            for (var i = 0; i < arrWindows.length; i++) {
                objWindow = arrWindows[i];
                if (objWindow != EBGlobalManager_CT2958529.GetMostRecentBrowserWindow()) {
                    if (objWindow.EBRadioGUIManager_CT2958529.SetShrink) {
                        try {
                            objWindow.EBRadioGUIManager_CT2958529.SetShrink();
                        }
                        catch (ex) { }
                    }
                }
                else this.isShrink = true;
            }
        }
        else {

            for (var i = 0; i < arrWindows.length; i++) {
                objWindow = arrWindows[i];
                if (objWindow.EBRadioGUIManager_CT2958529.SetShrink) {
                    try {
                        objWindow.EBRadioGUIManager_CT2958529.SetShrink();
                    }
                    catch (ex) { EBLog(ex); }
                }
            }
        }
    },

    OnExpand: function(bIsFromToolbarShrink) {
        //usage
        if (!bIsFromToolbarShrink)
            EBUsageRadio_CT2958529.OnUnShrink();

        EBRadioIOManager_CT2958529.SetShrinkedToRegistry('expanded');
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        if (isFloatingMode_CT2958529) {
            EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().EBRadioManager_CT2958529.isUnshrink = true;
            window.EBRadioGUIManager_CT2958529.SetExpand();
            EBRadioManager_CT2958529.HandleNewEvents(EBRadioConsts_CT2958529.Observer.NewStateEvent);
            for (var i = 0; i < arrWindows.length; i++) {
                objWindow = arrWindows[i];
                if (objWindow != EBGlobalManager_CT2958529.GetMostRecentBrowserWindow()) {
                    try {
                        if (objWindow.EBRadioGUIManager_CT2958529.SetExpand)
                            objWindow.EBRadioGUIManager_CT2958529.SetExpand();
                        else
                            this.isUnshrink = true;

                        objWindow.EBRadioManager_CT2958529.HandleNewEvents(EBRadioConsts_CT2958529.Observer.NewStateEvent);
                    }
                    catch (ex) {
                        EBLog(ex);
                    }
                }
            }
        }
        else {
            for (var i = 0; i < arrWindows.length; i++) {
                objWindow = arrWindows[i];
                try {
                    if (objWindow.EBRadioGUIManager_CT2958529.SetExpand) {

                        objWindow.EBRadioGUIManager_CT2958529.SetExpand();

                    }
                    objWindow.EBRadioManager_CT2958529.HandleNewEvents(EBRadioConsts_CT2958529.Observer.NewStateEvent);
                }
                catch (ex) { EBLog(ex); }
            }

        }
    },

    OnErrorCreatingCore: function(which, err) {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioGUIManager_CT2958529.SetError) {
                try {
                    objWindow.EBRadioGUIManager_CT2958529.SetError(which, err);
                }
                catch (ex) { EBLog(ex); }
            }
        }
    },

    OnPodcastResponse: function(oRSSComponent, success) {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;

        if (isFloatingMode_CT2958529 && !isAIOMode_CT2958529) 
            EBRadioConsts_CT2958529.RadioMenu.BuildPodcastMenu(oRSSComponent, success);
        
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioGUIManager_CT2958529.SetExpand) {
                try {
                    objWindow.EBRadioConsts_CT2958529.RadioMenu.BuildPodcastMenu(oRSSComponent, success);
                }
                catch (ex) {
                    EBLog(ex);
                }
            }
        }
    },

    // +++++++++++++++ Add Radio Station by API  - related functions ++++++++++++++

    AddRadioStation: function(strXML) {
        var errorCode = EBWebPageApiConsts_CT2958529.Errors.SUCCESS;

        if (this.IsRadioExists()) {
            var oXML = EBXML_CT2958529.GetXmlDocument(strXML);
            var oMedia = new EBRadioMediaList_CT2958529(oXML.documentElement);
            //init and load user media list in case of radio not shown
            if (!EBRadioConsts_CT2958529.UserMediaList) {
                EBRadioConsts_CT2958529.UserMediaList = EBRadioIOManager_CT2958529.LoadMediaFromFile(EBRadioConsts_CT2958529.MediaFileType.User);
            }
            /* removed - add to recent also
            //init and load recent media list in case of radio not shown
            if(!EBRadioConsts_CT2958529.RecentMediaList)
            {
            EBRadioConsts_CT2958529.RecentMediaList	= EBRadioIOManager_CT2958529.LoadMediaFromFile('recent');
            }
            */
            if (EBRadioConsts_CT2958529.UserMediaList.Contains(oMedia.MediaID)) {
                errorCode = EBWebPageApiConsts_CT2958529.Errors.RADIO_MEDIA_EXISTS;
            }
            else {
                EBRadioConsts_CT2958529.UserMediaList.arrMedia.Add(oMedia.MediaID, oMedia);
                //EBRadioConsts_CT2958529.RecentMediaList.AddMedia(oMedia);

                //save user media list
                var xmlStations = EBRadioConsts_CT2958529.UserMediaList.toXML();
                var fileName = EBRadioConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBRadioConsts_CT2958529.UserMediaFile;
                EBRadioIOManager_CT2958529.SaveMediaXMLToFile(xmlStations, fileName);

                //save recent media list
                /*
                xmlStations = EBRadioConsts_CT2958529.RecentMediaList.toXML();
                fileName = EBRadioConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBRadioConsts_CT2958529.RecentMediaFile;
                EBRadioIOManager_CT2958529.SaveMediaXMLToFile(xmlStations,fileName);
                */

                this.ShowOrReloadRadio(oMedia);
                errorCode = EBWebPageApiConsts_CT2958529.Errors.SUCCESS;
            }
        }
        else {
            errorCode = EBWebPageApiConsts_CT2958529.Errors.NO_RADIO_COMPONENT;
        }

        return errorCode;
    },

    IsRadioExists: function() {
        return EBComponentsManager_CT2958529.GetRadioComponent() ? true : false;
    },

    IsRadioShown: function() {
        var oRadio = EBComponentsManager_CT2958529.GetRadioComponent();
        return (oRadio) ? oRadio.ComponentItem.isShow() : false;
    },

    ShowOrReloadRadio: function(oMedia) {
        if (this.IsRadioShown()) {
            this.ReloadAllMediaAndSelectLastAddedUserStation(oMedia);
        }
        else {
            this.RefreshToolbarAndShowRadio(oMedia);
        }
    },

    ReloadAllMediaAndSelectLastAddedUserStation: function(oMedia) {
        // -- Removed select station on add
        //this.SetNewSelectedStation(oMedia);

        this.Init();
    },

    //With broadcast
    RefreshToolbarAndShowRadio: function(oMedia) {
        this.SetNewSelectedStation(oMedia);
        var radioComponent = EBComponentsManager_CT2958529.GetRadioComponent();
        if (!radioComponent) return;

        radioComponent.ComponentItem.setShowState(true);
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBServerCommunicationManager_CT2958529.ParseToolbarFromFileSettings) {
                try {
                    objWindow.EBServerCommunicationManager_CT2958529.ParseToolbarFromFileSettings();
                }
                catch (ex) { }
            }
        }
    },

    SetNewSelectedStation: function(oMedia) {
        if (!oMedia.isPodCast) {
            var menuItemObjID = EBRadioConsts_CT2958529.MenuIDPreffix + oMedia.MediaID;
            EBRadioIOManager_CT2958529.SetStationToRegistry(oMedia.MediaName, oMedia.MediaURL, oMedia.MediaType, menuItemObjID, oMedia.isPodCast, oMedia.MediaID);
        }
    }
    // +++++++++++++++ Add Radio Station by API  - related functions ENDS ++++++++++++++
}

var EBRadioLanguagePack_CT2958529 =
{
    OnRadioLoad: function() {
        EBRadioDialogManager_CT2958529.SearchDialogTitle = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_SEARCH_DLG_TITLE');
        EBRadioDialogManager_CT2958529.AddDialogLabel = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_ADD_HEADER');
        EBRadioDialogManager_CT2958529.EditDialogLabel = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_EDIT_HEADER');
        EBRadioDialogManager_CT2958529.NoStationsText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_SEARCH_DLG_NO_STATIONS_FOUND');
        EBRadioDialogManager_CT2958529.ConfirmDeleteText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_REMOVE_MSG');
        EBRadioDialogManager_CT2958529.ConfirmDeleteTitle = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_REMOVE_MSG_CAPTION');
        EBRadioDialogManager_CT2958529.CantRemovePlaying = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_CANT_REMOVE_MESSAGE_CURRENT_STATION_PLAYED');
        EBRadioDialogManager_CT2958529.CantRemoveSelected = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_CANT_REMOVE_MESSAGE_CURRENT_STATION_STOPPED');
        EBRadioDialogManager_CT2958529.SelectAudioFiles = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_SELECT_AUDIO_FILES_TITLE');

        EBRadioGUIManager_CT2958529.Tooltips.playing = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_PLAY_EQUALIZER_TTIP');
        EBRadioGUIManager_CT2958529.Tooltips.stopped = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_STOP_EQUALIZER_TTIP');
        EBRadioGUIManager_CT2958529.Tooltips.buffering = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_BUFFERING_EQUALIZER_TTIP');
        EBRadioGUIManager_CT2958529.Tooltips.waiting = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CONNECTING_EQUALIZER_TTIP');
        EBRadioGUIManager_CT2958529.Tooltips.shrink = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_SHRINK_TTIP');
        EBRadioGUIManager_CT2958529.Tooltips.expand = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_UNSHRINK_TTIP');
        EBRadioGUIManager_CT2958529.Tooltips.play = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_PLAY_TTIP');
        EBRadioGUIManager_CT2958529.Tooltips.stop = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_STOP_TTIP');
        EBRadioGUIManager_CT2958529.Tooltips.volume = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_VOLUME_TTIP');

        EBRadioConsts_CT2958529.LoadingText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_LOADING');
        EBRadioConsts_CT2958529.LoadingHint = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_LOADING_TTIP');
        EBRadioConsts_CT2958529.MenuUserStations = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_MENU_USER_DEFINED_STATIONS_TITLE');
        EBRadioConsts_CT2958529.MenuUserStationsHint = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_MENU_USER_DEFINED_STATIONS_TITLE_TTIP');
        EBRadioConsts_CT2958529.MenuAddStations = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_MENU_ADD_AND_EDIT');
        EBRadioConsts_CT2958529.MenuAddStationsHint = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_SETTINGS_DLG_FIND_MORE_STATIONS_TTIP');
        EBRadioConsts_CT2958529.MenuMoreStations = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_MENU_PUBLISHER_MORE_STATIONS_TITLE');
        EBRadioConsts_CT2958529.MenuMoreStationsHint = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_MENU_PUBLISHER_MORE_STATIONS_TITLE_TTIP');
        EBRadioConsts_CT2958529.MenuPodcastNoItems = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_MENU_NOPODCAST_TITLE');
        EBRadioConsts_CT2958529.MenuPodcastTimeout = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_MENU_PODCAST_TIMEOUT_TITLE');
        EBRadioConsts_CT2958529.MenuLocalStations = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_LOCAL_STATIONS');
        EBRadioConsts_CT2958529.MenuRecentStations = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_RECENT_STATIONS');
    },

    MenuDialog: function(oWindow) {
        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);
        var ID = 'ebRadioMenuDialog';

        var acceptButton = document.getElementById(ID).getButton('accept');
        var cancelButton = document.getElementById(ID).getButton('cancel');

        var lblAddStations = document.getElementById('lblAddStations');
        var btnSearch = document.getElementById('btnSearch');
        var lblRap = document.getElementById('lblRap');
        var lblBlues = document.getElementById('lblBlues');
        var lblContry = document.getElementById('lblContry');
        var lblRock = document.getElementById('lblRock');
        var lblAlternative = document.getElementById('lblAlternative');
        var lbl80s = document.getElementById('lbl80s');
        var lblLatin = document.getElementById('lblLatin');
        var lblDance = document.getElementById('lblDance');
        var lblOldies = document.getElementById('lblOldies');
        var btnDefineYourOwn = document.getElementById('btnDefineYourOwn');
        var btnBrowseLocal = document.getElementById('btnBrowseLocal');
        var lblManageYourStations = document.getElementById('lblManageYourStations');
        var tcStationName = document.getElementById('tcStationName');
        var tcURL = document.getElementById('tcURL');
        var btnEdit = document.getElementById('btnEdit');
        var btnDelete = document.getElementById('btnDelete');
        var btnClearRecent = document.getElementById('btnClearRecent');
        var lblHelp = document.getElementById('lblHelp');

        window.title = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_MENU_ADD_AND_EDIT');
        acceptButton.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK'));
        cancelButton.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL'));
        lblAddStations.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_SETTINGS_DLG_IDC_STATIC_SEARCH_STATIONS');
        btnSearch.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_SETTINGS_DLG_IDC_BUTTON_SEARCH_DIALOG'));
        lblRap.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CATEGORY_RAP');
        lblBlues.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CATEGORY_JAZZ');
        lblContry.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CATEGORY_COUNTRY');
        lblRock.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CATEGORY_ROCK');
        lblAlternative.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CATEGORY_ALTERNATIVE');
        lbl80s.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CATEGORY_80S');
        lblLatin.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CATEGORY_LATINE');
        lblDance.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CATEGORY_CHRISTIAN');
        lblOldies.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CATEGORY_OLDIES');
        btnDefineYourOwn.setAttribute("label", oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CATEGORY_DEFINE_YOUR_OWN'));
        btnBrowseLocal.setAttribute("label", oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_YOUR_FILES'));
        lblManageYourStations.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_STATIC_MANAGE_MY_STATIONS');
        tcStationName.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_RADIO_STATIONS_LIST_NAME_CAPTION'));
        tcURL.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_RADIO_STATIONS_LIST_URL_CAPTION'));
        btnEdit.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_BUTTON_EDIT_STATION'));
        btnDelete.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_BUTTON_REMOVE_DIALOG'));
        btnClearRecent.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_CLEAR_RECENT_LIST'));
        lblHelp.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_HELP');
    },

    SearchDialog: function(oWindow, argSearchString) {
        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale);

        var ID = 'ebRadioSearchDialog';

        var acceptButton = document.getElementById(ID).getButton('accept');
        var cancelButton = document.getElementById(ID).getButton('cancel');
        var lblSelectStations = document.getElementById('lblSelectStations');
        var tcStationName = document.getElementById('tcStationName');
        var tcURL = document.getElementById('tcURL');

        window.title = oWindow.EBRadioDialogManager_CT2958529.SearchDialogTitle + ' "' + argSearchString + '"';

        acceptButton.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK'));
        cancelButton.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL'));
        lblSelectStations.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_SEARCH_DLG_HEADER');
        tcStationName.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_RADIO_STATIONS_LIST_NAME_CAPTION'));
        tcURL.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_RADIO_STATIONS_LIST_URL_CAPTION'));
    },

    AddEditDialog: function(oWindow, argDialogType) {
        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale);

        var ID = 'ebRadioAddEditDialog';

        var acceptButton = document.getElementById(ID).getButton('accept');
        var cancelButton = document.getElementById(ID).getButton('cancel');
        var lblAddEditLabel = document.getElementById('lblAddEditLabel');
        var lblStreamURL = document.getElementById('lblStreamURL');
        var lblStationName = document.getElementById('lblStationName');
        var lblStreamType = document.getElementById('lblStreamType');
        var lblegURL = document.getElementById('lblegURL');
        var lblegName = document.getElementById('lblegName');
        var cmbStreamType = document.getElementById('cmbStreamType');
        var mnuChoseStreamType = document.getElementById('mnuChoseStreamType');
        var mnuWindowsMediaPlayer = document.getElementById('mnuWindowsMediaPlayer');
        var mnuRealPlayer = document.getElementById('mnuRealPlayer');
        var mnuPodcast = document.getElementById('mnuPodcast');

        if (argDialogType == "edit") {
            window.title = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_EDIT_TITLE');
            lblAddEditLabel.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_EDIT_HEADER');
        }
        else if (argDialogType == "add") {
            window.title = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_ADD_TITLE');
            lblAddEditLabel.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_ADD_HEADER');
        }

        acceptButton.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK'));
        cancelButton.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL'));
        lblStreamURL.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_STATIC_URL');
        lblStationName.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_STATIC_NAME');
        lblStreamType.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_STATIC_TYPE');
        lblegURL.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_STATIC_URL_EG');
        lblegName.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_STATIC_NAME_EG');
        mnuChoseStreamType.setAttribute('label', '-- ' + oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_COMBO_CHOOSE_STREAM_TYPE') + ' --');
        cmbStreamType.setAttribute('label', '-- ' + oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_COMBO_CHOOSE_STREAM_TYPE') + ' --');
        mnuWindowsMediaPlayer.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_COMBO_CHOOSE_WINDOWS_MEDIA_PLAYER'));
        mnuRealPlayer.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_COMBO_CHOOSE_REAL_PLAYER'));
        mnuPodcast.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RADIO_ADD_DLG_COMBO_CHOOSE_PODCAST'));
    }
};

//Radio Media Class
function EBRadioMedia_CT2958529(XMLNode)
{
	this.STREAM				= 'stream';
	this.PODCAST			= 'XML_FEED';
	this.REAL				= 'real';
	this.MP					= 'mp',
	this.MediaID			= '';
	this.MediaURL			= '';
	this.MediaName			= '';
	this.MediaType			= '';
	this.MediaContentType	= '';
	this.isPodCast			= null;

	this.Init = function(XMLNode) {
	    var XMLNodeChild = null;
	    var mediaType = '';

	    for (var i = 0; i < XMLNode.childNodes.length; i++) {
	        XMLNodeChild = XMLNode.childNodes[i];

	        if (XMLNodeChild.tagName == 'STATION_ID') {
	            this.MediaID = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	        }
	        else if (XMLNodeChild.tagName == 'STATION_URL') {
	            this.MediaURL = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	            this.MediaURL = this.MediaURL.replace(/mms:\/\//ig, 'http://');
	        }
	        else if (XMLNodeChild.tagName == 'STATION_NAME') {
	            this.MediaName = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	            this.MediaName = this.MediaName.replace(/"/i, '\'\'');
	        }
	        else if (XMLNodeChild.tagName == 'TYPE') {
	            this.MediaType = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	            this.isPodCast = (this.MediaType.toUpperCase() == this.PODCAST) ? true : false;
	        }
	        else if (XMLNodeChild.tagName == 'CONTENT_TYPE') {
	            mediaType = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
	            if (mediaType.toLowerCase() == this.REAL) {
	                this.MediaContentType = this.REAL;
	            }
	            else {
	                this.MediaContentType = this.MP;
	            }
	        }
	    }

	    if (!this.MediaID) {
	        this.MediaID = this.MediaURL;
	    }

	    if (this.MediaType == '') {
	        this.MediaType = this.STREAM;
	        this.isPodCast = false;
	    }

	};

	this.Update = function(ID, URL, Name, Type, ContentType) {
	    this.MediaID = ID;
	    this.MediaURL = URL;
	    this.MediaName = Name;
	    this.MediaType = Type;
	    this.MediaContentType = ContentType;
	    this.isPodCast = (this.MediaType == PODCAST) ? true : false;
	    if (!this.MediaID) {
	        this.MediaID = this.MediaURL
	    }
	};

	this.toXML = function() {
	    return EBXML_CT2958529.GetXmlDocument(this.toXMLString);
	};

	this.toXMLString = function() {
	    var strXML = "<RADIO_STATION>";
	    strXML += "<STATION_ID>" + this.MediaID + "</STATION_ID>";
	    strXML += "<STATION_URL>" + this.MediaURL + "</STATION_URL>";
	    strXML += "<STATION_NAME>" + this.MediaName + "</STATION_NAME>";
	    strXML += "<TYPE>" + this.MediaType + "</TYPE>";
	    strXML += "<CONTENT_TYPE>" + this.MediaContentType + "</CONTENT_TYPE>";
	    strXML += "</RADIO_STATION>";
	    return strXML;
	};
	
	this.toListItem = function(doc)
	{
		var listItem = doc.createElement('listitem');
		var listCellName = doc.createElement('listcell');
		var listCellURL = doc.createElement('listcell');
		var imgIcon = '';
		listCellName.setAttribute('label',this.MediaName);
		
		if(this.GetTypeString() == EBRadioConsts_CT2958529.PlayerTypes.RealPlayer)
			imgIcon = EBRadioGUIManager_CT2958529.Images.imgRealLogo;
		else if(this.GetTypeString() == EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer)
			imgIcon = EBRadioGUIManager_CT2958529.Images.imgWMPLogo;
		else
			imgIcon = EBRadioGUIManager_CT2958529.Images.imgPodcast;
		
		listCellName.setAttribute('image',imgIcon);
		listCellName.setAttribute('class','listcell-iconic');
		listCellURL.setAttribute('label',this.MediaURL.replace(/~!!~/g,"\\"));
		listItem.setAttribute('id',this.MediaID);
		listItem.appendChild(listCellName);
		listItem.appendChild(listCellURL);
		return listItem;
	}
	
	this.GetType = function()
	{
		if(this.isPodCast)
			return "podcast";
		
		return this.MediaContentType;
	}

	this.GetTypeString = function() {
	    if (this.isPodCast) {
	        return "podcast";
	    }
	    else if (this.MediaContentType == this.MP) {
	        return EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer;
	    }
	    else if (this.MediaContentType == this.REAL) {
	        return EBRadioConsts_CT2958529.PlayerTypes.RealPlayer;
	    }
	};

	this.SetPodCast = function() {
	    this.isPodCast = true;
	    this.MediaType = this.PODCAST;
	};

	this.SetType = function(newType) {
	    this.isPodCast = false;
	    this.MediaType = this.STREAM;
	    this.MediaContentType = newType;
	};
	
}
//Radio Media Class
function EBRadioMediaList_CT2958529(XMLNode)
{
	// inherits from EBRadioMedia_CT2958529
	
	this.arrMedia	= new EBArrayHashObject_CT2958529();
	
	this.Caption	= "";
	this.IconUrl	= "";
	this.Hint		= "";
	
	this.InitList = function(XMLNode)
	{
		var Media		= null;
		this.isList		= true;
		
		var XMLNodeChild = null;
		for(var i=0;i<XMLNode.childNodes.length;i++)
		{
			XMLNodeChild = XMLNode.childNodes[i];
			if(XMLNodeChild.tagName == 'RADIO_STATION')
			{
				Media = new EBRadioMediaList_CT2958529(XMLNodeChild);
				this.arrMedia.Add(Media.MediaID,Media);
			}
			else if(XMLNodeChild.tagName == 'RADIO_STATIONS')
			{
				Media = new EBRadioMediaList_CT2958529(XMLNodeChild)
				this.arrMedia.Add("MediaList"+i,Media);
			}
			else if(XMLNodeChild.tagName == 'CAPTION')
			{
				this.Caption = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
			}
			else if(XMLNodeChild.tagName == 'ICON_URL')
			{
				this.IconUrl = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
			}
			else if(XMLNodeChild.tagName == 'HINT')
			{
				this.Hint = EBXML_CT2958529.GetXmlNodeValue(XMLNodeChild);
			}
		}
		Media = null;
	}
	
	this.toXML = function()
	{
		var Media	= '';
		var strXML	= '<RADIO_STATIONS>';
		
		for(var i=0;i<this.arrMedia.Count();i++)
		{
			Media = this.arrMedia.GetByIndex(i);
			strXML += Media.toXMLString();
		}
		
		strXML += '</RADIO_STATIONS>';
		strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
		return EBXML_CT2958529.GetXmlDocument(strXML);
	}
	
	this.toString = function()
	{
		var Media	= '';
		var strXML	= '<RADIO_STATIONS>';
		
		for(var i=0;i<this.arrMedia.Count();i++)
		{
			Media = this.arrMedia.GetByIndex(i);
			strXML += Media.toXMLString();
		}
		
		strXML += '</RADIO_STATIONS>';
		strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
		return strXML;
	}

	this.GetMediaArray = function()
	{
		return this.arrMedia;
	}
	
	if(XMLNode && XMLNode.tagName == 'RADIO_STATION') 
	{
		this.Init(XMLNode);
	}
	else if(XMLNode)
	{
		this.InitList(XMLNode);
	}
	
	this.GetMediaListsFromArray = function(arrMedia)
	{
		var arr = new EBArrayHashObject_CT2958529();
		var media = null;
		for(var i=0;i<arrMedia.Count();i++)
		{
			media = arrMedia.GetByIndex(i);
			if(media.isList)
			{
				arr.Add('MediaList'+i,media.arrMedia);
			}
		}
		return arr;
	};
	
	this._Contains = function(mediaID,arrMedia)
	{
		if(arrMedia.Contains(mediaID))
		{
			return true;
		}
		else
		{
			
			var arrMediaList = this.GetMediaListsFromArray(arrMedia);
			for(var i=0;i<arrMediaList.Count();i++)
			{
				if(this._Contains(mediaID,arrMediaList.GetByIndex(i)))
				{
					return true;
				}
			}
		}
		return false;
	};
	
	this.Contains = function(mediaID)
	{
		return this._Contains(mediaID,this.arrMedia);
	};
	
	this._GetByID = function(mediaID,arrMedia)
	{
		var media = arrMedia.GetByID(mediaID);
		if(media)
		{
			return media;
		}
		else
		{
			var arrMediaList = this.GetMediaListsFromArray(arrMedia);
			for(var i=0;i<arrMediaList.Count();i++)
			{
				media = this._GetByID(mediaID,arrMediaList.GetByIndex(i));
				if(media)
				{
					return media;
				}
			}
			return null;
		}
		return null;
	};
	
	this.GetMediaByID = function(mediaID)
	{
		return this._GetByID(mediaID,this.arrMedia);
	}
}

EBRadioMediaList_CT2958529.prototype = new EBRadioMedia_CT2958529;

// Radio Menu Class
function EBRadioMenu_CT2958529(PublisherMediaList,UserMediaList,RecentMediaList,IPMediaList,objSkinDef)
{
	var Media = null;
	this.XULMenu = null;
	this.activeMenuItem = null;
	
	if(!MediaList && !UserMediaList)
		return;
	
	//for usage
	var onpopupshowing = 'EBUsageRadio_CT2958529.OnOpenMenu()';
	var onpopuphiding = 'EBUsageRadio_CT2958529.OnCloseMenu()';
	
	this.XULMenu = EBXULFactory_CT2958529.CreateMenuPopup("",onpopupshowing,onpopuphiding);
	
	//set the background color
    if(objSkinDef.Menu && !EBGlobalManager_CT2958529.IsFirefox3())
    {
	    this.XULMenu.setAttribute('style','background-color:'+objSkinDef.Menu.backgroundColor);
	    //set colors of the text only after they are shown (created)
	    this.XULMenu.setAttribute('onpopupshown','EBRadioSkinManager_CT2958529.ColorizeMenuItems(this);this.onpopupshown = null;');
	}
	
	var dir = (EBGlobalManager_CT2958529.IsToolbarRTL()) ? 'rtl' : 'ltr';
	this.XULMenu.style.direction = dir;

	this.BuildMenuItem = function(Media,xulElementParent,addToRecent,isFromMoreMenu)
	{
		var strMediaType = '';
		var strIconURL	= '';
		if(Media.MediaContentType == 'mp')
		{
			strMediaType = EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer;
			strIconURL = EBRadioGUIManager_CT2958529.Images.imgWMPLogo;
		}
		else if(Media.MediaContentType == 'real')
		{
			strMediaType = EBRadioConsts_CT2958529.PlayerTypes.RealPlayer;
			strIconURL = EBRadioGUIManager_CT2958529.Images.imgRealLogo;
		}
		
		var strCaption	= Media.MediaName;
		var strHint		= Media.MediaName;
		var strCommand	= 'EBRadioManager_CT2958529.OnMenuStationSelect(this,"'+Media.MediaURL+'","'+strMediaType+'","'+Media.MediaName+'",false,'+addToRecent+','+isFromMoreMenu+');event.cancelBubble = true;';
		
		//non english name doesn't stored right in the registy, so station name
		//updated from the file directly
		if(Media.MediaURL == EBRadioConsts_CT2958529.NowState.StationURL)
		{
			EBRadioGUIManager_CT2958529.SetStation(Media.MediaName,strMediaType,Media.MediaURL);
		}
		
		var strName		= 'RadioMenu_CT2958529';
		var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strCaption,strIconURL,strHint,strCommand,strName,null);
		var strId       = EBRadioConsts_CT2958529.MenuIDPreffix;
		 
		if(!addToRecent)
		    strId += EBRadioConsts_CT2958529.MenuIDRecentPreffix;
		    
		strId += Media.MediaID;
		
		xulMenuItem.setAttribute('id',strId);
		xulMenuItem.setAttribute('MediaType',strMediaType);
		xulMenuItem.setAttribute('onmouseover','EBRadioConsts_CT2958529.RadioMenu.OnMouseOver(this)');
		xulMenuItem.setAttribute('onmouseout','EBRadioConsts_CT2958529.RadioMenu.OnMouseOut(this)');
		xulMenuItem.setAttribute('autocheck','false');
		xulElementParent.appendChild(xulMenuItem);
	};
	
	this.OnMouseOver = function(obj)
	{
		var oldImage = obj.getAttribute('image');
		var newImage = '';
		
		if(oldImage == EBRadioGUIManager_CT2958529.Images.imgWMPLogo)
		{
			newImage = EBRadioGUIManager_CT2958529.Images.imgWMPLogo_hover;
		}
		else if(oldImage == EBRadioGUIManager_CT2958529.Images.imgRealLogo)
		{
			newImage = EBRadioGUIManager_CT2958529.Images.imgRealLogo_hover;
		}
		else if(oldImage == EBRadioGUIManager_CT2958529.Images.imgPodcast)
		{
			newImage = EBRadioGUIManager_CT2958529.Images.imgPodcast_hover;
		}
		else
		{	
			newImage = oldImage;
		}
		
		obj.setAttribute('image',newImage);
		EBRadioSkinManager_CT2958529.OnMenuItemMouseOver(obj);
	};
	
	this.OnMouseOut = function(obj)
	{
		var oldImage = obj.getAttribute('image');
		var newImage = '';
		
		if(oldImage == EBRadioGUIManager_CT2958529.Images.imgWMPLogo_hover)
		{
			newImage = EBRadioGUIManager_CT2958529.Images.imgWMPLogo;
		}
		else if(oldImage == EBRadioGUIManager_CT2958529.Images.imgRealLogo_hover)
		{
			newImage = EBRadioGUIManager_CT2958529.Images.imgRealLogo;
		}
		else if(oldImage == EBRadioGUIManager_CT2958529.Images.imgPodcast_hover)
		{
			newImage = EBRadioGUIManager_CT2958529.Images.imgPodcast;
		}
		else
		{	
			newImage = oldImage;
		}
		
		obj.setAttribute('image',newImage);
		EBRadioSkinManager_CT2958529.OnMenuItemMouseOut(obj);
	};
	
	this.BuildSubPodcastMenu = function(Media,xulElementParent)
	{
		var strCaption	= Media.MediaName;
		var strIconUrl	= EBRadioGUIManager_CT2958529.Images.imgPodcast;
		var strHint		= Media.MediaName;
		
		var xulSubMenu = EBXULFactory_CT2958529.CreateMenu(strCaption,strIconUrl,strHint);
		xulSubMenu.setAttribute('MediaType','Podcast');
		xulSubMenu.setAttribute('onmouseover','EBRadioConsts_CT2958529.RadioMenu.OnMouseOver(this)');
		xulSubMenu.setAttribute('onmouseout','EBRadioConsts_CT2958529.RadioMenu.OnMouseOut(this)');
		var currentXulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("","","");
			currentXulMenuPopup.setAttribute('id',EBRadioConsts_CT2958529.MenuIDPreffix + Media.MediaID);
			if(objSkinDef.Menu && !EBGlobalManager_CT2958529.IsFirefox3())
			{
			    currentXulMenuPopup.setAttribute('style','background-color:'+objSkinDef.Menu.backgroundColor);
			}
		var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(EBRadioConsts_CT2958529.LoadingText,"",EBRadioConsts_CT2958529.LoadingHint,"","","");
		currentXulMenuPopup.appendChild(xulMenuItem);
		xulSubMenu.appendChild(currentXulMenuPopup);
		xulElementParent.appendChild(xulSubMenu);
		EBRadioServerComm_CT2958529.RequestPodcast(Media);
	};
	
	this.CreateMoreMenuItem = function(xulParent)
	{
		var strCaption = EBRadioConsts_CT2958529.MenuMoreStations;
		var strIconUrl = '';
		var strHint = EBRadioConsts_CT2958529.MenuMoreStationsHint;
		var xulSubMenu = EBXULFactory_CT2958529.CreateMenu(strCaption,strIconUrl,strHint);
		xulSubMenu.setAttribute('onclick','event.cancelBubble = true;');
		xulSubMenu.setAttribute('onmouseover','EBRadioSkinManager_CT2958529.OnMenuItemMouseOver(this)');
		xulSubMenu.setAttribute('onmouseout','EBRadioSkinManager_CT2958529.OnMenuItemMouseOut(this)');
		var xulMenuContainer = EBXULFactory_CT2958529.CreateMenuPopup("","","");
		    if(objSkinDef.Menu && !EBGlobalManager_CT2958529.IsFirefox3())
		    {
		        xulMenuContainer.setAttribute('style','background-color:'+objSkinDef.Menu.backgroundColor);
		    }
		xulSubMenu.appendChild(xulMenuContainer);
		xulParent.appendChild(xulSubMenu);
		return xulMenuContainer;
	
	};
	
	this.BuildMenuFromMediaList = function(MediaList,xulParent,maxOnPage,isPublisher,isRecent)
	{
		var oMediaList			= MediaList.GetMediaArray();
		var Media				= null;
		var count				= MediaList.arrMedia.Count();
		var shownStations		= 0;
		var createdMoreMenuItem = false;
		var createdSeparator;
		
		if(isPublisher)
			createdSeparator = false;
		else
			createdSeparator = true;
		
		for(var i=0;i<count;i++)
		{
			if(isRecent)
			{
				Media = oMediaList.GetByIndex(count-i-1);
			}
			else
			{
				Media = oMediaList.GetByIndex(i);
			}	
			
			if(maxOnPage != 0 && shownStations == maxOnPage + 1 && !createdMoreMenuItem)
			{
				xulParent = this.CreateMoreMenuItem(xulParent);
				createdMoreMenuItem = true;
			}

			shownStations++;
			if(!createdSeparator)
			{
				var lastMenuItem = this.XULMenu.childNodes[this.XULMenu.childNodes.length-1];
				if(lastMenuItem.getAttribute('label'))
				{
					var separator = EBXULFactory_CT2958529.CreateMenuSeparator()
					this.XULMenu.appendChild(separator);
				}	
				createdSeparator = true;
			}
			
			if(!Media.isList)
			{
				if(Media.isPodCast)
				{
					this.BuildSubPodcastMenu(Media,xulParent);
				}
				else
				{
					var bIsFromMore = (maxOnPage == 0 && isPublisher) ? true : false;
					this.BuildMenuItem(Media,xulParent,!isRecent, bIsFromMore);
				}
			}
			else if(Media.Caption != "")
			{
				var xulSubMenu = EBXULFactory_CT2958529.CreateMenu(Media.Caption,Media.IconUrl,Media.Hint);
				    xulSubMenu.setAttribute('onmouseover','EBRadioSkinManager_CT2958529.OnMenuItemMouseOver(this)');
		            xulSubMenu.setAttribute('onmouseout','EBRadioSkinManager_CT2958529.OnMenuItemMouseOut(this)');
				var xulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("","","");
				    if(objSkinDef.Menu && !EBGlobalManager_CT2958529.IsFirefox3())
				    {
				        xulMenuPopup.setAttribute('style','background-color:'+objSkinDef.Menu.backgroundColor);
				    }
				xulSubMenu.appendChild(xulMenuPopup);
				xulParent.appendChild(xulSubMenu);
				this.BuildMenuFromMediaList(Media,xulMenuPopup,0,false,isRecent);
			}
		}
		
		return shownStations;
	};
	
	this.CreateAddStationsMenuItem = function()
	{
		var strCaption	= EBRadioConsts_CT2958529.MenuAddStations;
		var strIconURL	= '';
		var strHint		= EBRadioConsts_CT2958529.MenuAddStationsHint;
		var strCommand	= 'EBRadioDialogManager_CT2958529.OpenMainDialog(window);event.cancelBubble = true;';
		var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strCaption,strIconURL,strHint,strCommand,'',null);
		    xulMenuItem.setAttribute('onmouseover','EBRadioSkinManager_CT2958529.OnMenuItemMouseOver(this)');
		    xulMenuItem.setAttribute('onmouseout','EBRadioSkinManager_CT2958529.OnMenuItemMouseOut(this)');
		
		this.XULMenu.appendChild(xulMenuItem);
		var separator = EBXULFactory_CT2958529.CreateMenuSeparator()
		this.XULMenu.appendChild(separator);
	};
	
	this.CreateUserMediaSubMenu = function(UserMediaList)
	{
		if(UserMediaList && UserMediaList.arrMedia.Count() == 0 || !UserMediaList)
		{
			return;
		}
		var strCaption = EBRadioConsts_CT2958529.MenuUserStations;
		var strIconUrl = '';
		
		var strHint = EBRadioConsts_CT2958529.MenuUserStationsHint;
		var xulSubMenu = EBXULFactory_CT2958529.CreateMenu(strCaption,strIconUrl,strHint);
		    xulSubMenu.setAttribute('onmouseover','EBRadioSkinManager_CT2958529.OnMenuItemMouseOver(this)');
		    xulSubMenu.setAttribute('onmouseout','EBRadioSkinManager_CT2958529.OnMenuItemMouseOut(this)');
		xulSubMenu.setAttribute('onclick','event.cancelBubble = true;');
		var xulMenuContainer = EBXULFactory_CT2958529.CreateMenuPopup("","","");
		    if(objSkinDef.Menu && !EBGlobalManager_CT2958529.IsFirefox3())
		    {
		        xulMenuContainer.setAttribute('style','background-color:'+objSkinDef.Menu.backgroundColor);
		    }
		//var shownStations = this.BuildMenuFromMediaList(UserMediaList,xulMenuContainer,0,RecentMediaList)
		var shownStations = this.BuildMenuFromMediaList(UserMediaList,xulMenuContainer,0,false,false)
		if(shownStations > 0)
		{
		    xulSubMenu.appendChild(xulMenuContainer);
		    this.XULMenu.appendChild(xulSubMenu);
		}
		
		if(IPMediaList && IPMediaList.arrMedia.Count() > 0
		    || RecentMediaList && RecentMediaList.arrMedia.Count() > 0)
		{
		    var separator = EBXULFactory_CT2958529.CreateMenuSeparator()
		    this.XULMenu.appendChild(separator);
		}
	};
	
	this.CreateIPMediaSubMenu = function(IPMediaList)
	{
	    if(IPMediaList && IPMediaList.arrMedia.Count() == 0 || !IPMediaList) return;
	    
	    var strCaption = EBRadioConsts_CT2958529.MenuLocalStations;
		var strIconUrl = '';
		
		var strHint = '';
		
		var xulSubMenu = EBXULFactory_CT2958529.CreateMenu(strCaption,strIconUrl,strHint);
		    xulSubMenu.setAttribute('onclick','event.cancelBubble = true;');
		    xulSubMenu.setAttribute('onmouseover','EBRadioSkinManager_CT2958529.OnMenuItemMouseOver(this)');
		    xulSubMenu.setAttribute('onmouseout','EBRadioSkinManager_CT2958529.OnMenuItemMouseOut(this)');
		
		var xulMenuContainer = EBXULFactory_CT2958529.CreateMenuPopup("","","");
		    if(objSkinDef.Menu && !EBGlobalManager_CT2958529.IsFirefox3())
		        xulMenuContainer.setAttribute('style','background-color:'+objSkinDef.Menu.backgroundColor);
		
		var shownStations = this.BuildMenuFromMediaList(IPMediaList,xulMenuContainer,0)
		if(shownStations > 0)
		{
		    xulSubMenu.appendChild(xulMenuContainer);
		    this.XULMenu.appendChild(xulSubMenu);
		}
		
		if(RecentMediaList && RecentMediaList.arrMedia.Count() > 0)
		{
		    var separator = EBXULFactory_CT2958529.CreateMenuSeparator()
		    this.XULMenu.appendChild(separator);
		}
	}
	
	this.CreatePublisherMenu = function(PublisherMediaList,RecentMediaList)
	{
		if(PublisherMediaList && PublisherMediaList.arrMedia.Count() == 0 || !PublisherMediaList)
		{
			return;
		}
		var recentMediaStationsCount = 0;
		if(RecentMediaList && RecentMediaList.arrMedia.Count() >=0)
		{
			recentMediaStationsCount = RecentMediaList.arrMedia.Count();
		}
		var maxPublisherStations = EBRadioConsts_CT2958529.MaxStationsInMenu - recentMediaStationsCount;
		this.BuildMenuFromMediaList(PublisherMediaList,this.XULMenu,maxPublisherStations,true)
	};
	
	this.CreateRecentStationsSubMenu = function(RecentMediaList)
	{
		if(RecentMediaList && RecentMediaList.arrMedia.Count() == 0)
		    return;

		var strCaption = EBRadioConsts_CT2958529.MenuRecentStations;
		var strIconUrl = '';

		var strHint = '';

		var xulSubMenu = EBXULFactory_CT2958529.CreateMenu(strCaption, strIconUrl, strHint);
		xulSubMenu.setAttribute('onclick', 'event.cancelBubble = true;');
		xulSubMenu.setAttribute('onmouseover', 'EBRadioSkinManager_CT2958529.OnMenuItemMouseOver(this)');
		xulSubMenu.setAttribute('onmouseout', 'EBRadioSkinManager_CT2958529.OnMenuItemMouseOut(this)');

		var xulMenuContainer = EBXULFactory_CT2958529.CreateMenuPopup("", "", "");
		if (objSkinDef.Menu && !EBGlobalManager_CT2958529.IsFirefox3())
		    xulMenuContainer.setAttribute('style', 'background-color:' + objSkinDef.Menu.backgroundColor);

		var iCount = this.BuildMenuFromMediaList(RecentMediaList, xulMenuContainer, 0, false, true)
		
		if (iCount > 0) {
		    xulSubMenu.appendChild(xulMenuContainer);
		    this.XULMenu.appendChild(xulSubMenu);
		}
    };
	
	
	this.CreateAddStationsMenuItem();
	this.CreateUserMediaSubMenu(UserMediaList);
    this.CreateIPMediaSubMenu(IPMediaList);
    this.CreateRecentStationsSubMenu(RecentMediaList)
	this.CreatePublisherMenu(PublisherMediaList,RecentMediaList);
	
	this.GetXULMenu = function()
	{
		return this.XULMenu;
	};

	this.OnMenuStationSelect = function(menuItemObjID) {
	    if (!menuItemObjID)
	        return;

	    var mediaType = '';
	    var strImage = '';

	    this.activeMenuItem = document.getElementById(menuItemObjID)
	    var RadioMenu = null;

	    if (EBRadioConsts_CT2958529.NowState.InChevron)
	        RadioMenu = document.getElementById(EBRadioConsts_CT2958529.RadioMenuButtonChevronID);
	    else
	        RadioMenu = document.getElementById(EBRadioConsts_CT2958529.RadioMenuButtonID);

	    if (!RadioMenu) return;
	    
	    var arrMenuItems = RadioMenu.getElementsByTagName('menuitem');
	    for (var i = 0; i < arrMenuItems.length; i++) {
	        mediaType = arrMenuItems[i].getAttribute('MediaType');
	        arrMenuItems[i].setAttribute('EBchecked', 'false');

	        if (mediaType == EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer) {
	            strImage = EBRadioGUIManager_CT2958529.Images.imgWMPLogo;
	            arrMenuItems[i].setAttribute("image", strImage);
	            arrMenuItems[i].setAttribute("class", "menuitem-iconic");
	            arrMenuItems[i].setAttribute("style", EBToolbarDesignConsts_CT2958529.ToolbarMaxImageHeightStyle);
	        }
	        else if (mediaType == EBRadioConsts_CT2958529.PlayerTypes.RealPlayer) {
	            strImage = EBRadioGUIManager_CT2958529.Images.imgRealLogo;
	            arrMenuItems[i].setAttribute("image", strImage);
	            arrMenuItems[i].setAttribute("class", "menuitem-iconic");
	            arrMenuItems[i].setAttribute("style", EBToolbarDesignConsts_CT2958529.ToolbarMaxImageHeightStyle);
	        }
	        else if (mediaType == "Podcast") {
	            strImage = EBRadioGUIManager_CT2958529.Images.imgPodcast;
	            arrMenuItems[i].setAttribute("image", strImage);
	            arrMenuItems[i].setAttribute("class", "menuitem-iconic");
	            arrMenuItems[i].setAttribute("style", EBToolbarDesignConsts_CT2958529.ToolbarMaxImageHeightStyle);
	        }
	        else {
	            arrMenuItems[i].setAttribute("class", "");
	            arrMenuItems[i].setAttribute("style", "");
	        }

	    }
	    try {
	        this.activeMenuItem.setAttribute('EBchecked', 'true');
	        this.activeMenuItem.setAttribute("class", "menuitem-iconic");
	        this.activeMenuItem.setAttribute("style", EBToolbarDesignConsts_CT2958529.ToolbarMaxImageHeightStyle + ';font-weight:bold');
	    }
	    catch (ex) { }
	};

	this.SetActiveMenuItemImage = function(strImage)
	{
		if(this.activeMenuItem)
		    this.activeMenuItem.setAttribute('image',strImage);
	};

	this.BuildPodcastMenu = function(oRSSComponent, success) {
	    var oFeedItemDataArrayHash = oRSSComponent.FeedData.Items.ArrayHash;
	    var xulPodcastMenu = document.getElementById(EBRadioConsts_CT2958529.MenuIDPreffix + oRSSComponent.ComponentItem.UniqueCompID);
	    var oFeedItemData = null;
	    var iCount = oFeedItemDataArrayHash.Count();
	    var xulMenuItem = null;

	    while (xulPodcastMenu.childNodes.length > 0) {
	        xulPodcastMenu.removeChild(xulPodcastMenu.firstChild);
	    }

	    if (!success) {
	        xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(EBRadioConsts_CT2958529.MenuPodcastTimeout, "", "", "", "", "");
	        xulPodcastMenu.appendChild(xulMenuItem);
	        return;
	    }

	    if (iCount == 0) {
	        xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(EBRadioConsts_CT2958529.MenuPodcastNoItems, "", "", "", "", "");
	        xulPodcastMenu.appendChild(xulMenuItem);
	        return;
	    }

	    for (var i = 0; i < iCount; i++) {
	        oFeedItemData = oFeedItemDataArrayHash.GetByIndex(i);
	        this.BuildPodcastMenuItem(oFeedItemData, xulPodcastMenu, oRSSComponent.ComponentItem.UniqueCompID + '-' + i);
	    }
	};

	this.BuildPodcastMenuItem = function(oFeedItemData, xulPodcastMenu, podcastID) {
	    var strTitle = oFeedItemData.Title;
	    var strImage = EBRadioGUIManager_CT2958529.Images.imgWMPLogo;
	    var strLink = oFeedItemData.Link;
	    var strTooltip = oFeedItemData.Tooltip;
	    var bVisited = oFeedItemData.Visited;
	    var strMediaType = EBRadioConsts_CT2958529.PlayerTypes.MediaPlayer

	    var strCommand = 'EBRadioManager_CT2958529.OnMenuStationSelect(this,"' + strLink + '","' + strMediaType + '","' + strTitle + '",true,false);event.cancelBubble = true;';
	    var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strTitle, strImage, strTooltip, strCommand, "", "");
	    xulMenuItem.setAttribute('id', EBRadioConsts_CT2958529.PodcastPreffix + podcastID);
	    xulMenuItem.setAttribute('MediaURL', strLink);
	    xulMenuItem.setAttribute('MediaName', strTitle);
	    xulMenuItem.setAttribute('MediaType', strMediaType);
	    xulMenuItem.setAttribute('onmouseover', 'EBRadioConsts_CT2958529.RadioMenu.OnMouseOver(this)');
	    xulMenuItem.setAttribute('onmouseout', 'EBRadioConsts_CT2958529.RadioMenu.OnMouseOut(this)');

	    xulPodcastMenu.appendChild(xulMenuItem);
	    //if this is the first podcast that should be selected for playing
	    if (EBRadioConsts_CT2958529.SetStationName && EBRadioConsts_CT2958529.SetStationName == EBRadioConsts_CT2958529.PodcastPreffix + podcastID) {
	        EBRadioConsts_CT2958529.SetStationName = false;
	        if (EBRadioConsts_CT2958529.IsUpdateStationFromPodcast) {
	            EBRadioIOManager_CT2958529.SetStationToRegistry(strTitle,
																strLink,
																strMediaType,
																EBRadioConsts_CT2958529.PodcastPreffix + podcastID,
																true,
																podcastID);
	            setTimeout(function() { EBRadioManager_CT2958529.UpdateGUIOnLoad("found"); }, 1000);
	        }
	    }
	    //if this podcast is selected, update GUI.

	    if (strLink == EBRadioConsts_CT2958529.NowState.StationURL) {
	        if (EBRadioConsts_CT2958529.IsUpdateStationFromPodcast) {
	            EBRadioGUIManager_CT2958529.SetStation(strTitle, strMediaType, strLink);
	            this.OnMenuStationSelect(EBRadioConsts_CT2958529.PodcastPreffix + podcastID);
	            EBRadioGUIManager_CT2958529.SetNewState(EBRadioConsts_CT2958529.NowState.PlayState);
	        }
	    }
	};
	
	this.PlayNextPodcastItem = function(menuSelectedID)
	{
		var XULPodcastContainer = document.getElementById(menuSelectedID).parentNode;
		var nodeID = '';
		for(var i=0;i<XULPodcastContainer.childNodes.length;i++)
		{
			nodeID = XULPodcastContainer.childNodes[i].getAttribute('id');
			if(nodeID == menuSelectedID)
			{
				if(i+1 == XULPodcastContainer.childNodes.length)
				{
					XULPodcastContainer.childNodes[0].click();
				}
				else
				{
					XULPodcastContainer.childNodes[i+1].click();
				}	
				return;
			}
		}
	};
}
//Radio Recent Media List Class
function EBRadioRecentMediaList_CT2958529(XMLDoc)
{
    this.arrMedia = new EBArrayHashObject_CT2958529();
    
	this.AddMedia = function(media)
	{
		if(this.Contains(media))
            this.Remove(media);

        if (this.arrMedia.Count() == EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().EBRadioConsts_CT2958529.MaxRecentStations)
		{
			var mediaToRemove = this.arrMedia.GetByIndex(0);
			this.arrMedia.Remove(0,mediaToRemove.MediaID);
		}
		
		this.arrMedia.Add(media.MediaID,media);
	};

	
	this.Contains = function(media)
	{
		return this.arrMedia.Contains(media.MediaID);
	};

	this.Remove = function(media)
	{
		if(this.Contains(media))
		{
			var index = this.GetIndexByMedia(media)
			this.arrMedia.Remove(index,media.MediaID);
		}	
	};
	
	this.GetIndexByMedia = function(media)
	{
	    var iMedia = null;
	    
	    for(var i=0;this.arrMedia.Count();i++)
	    {
	        iMedia = this.arrMedia.GetByIndex(i);
	        if(iMedia.MediaID == media.MediaID)
	        {
	            return i;
	        }
	    }
	    
	    return -1;
	};

	this.isEmpty = function() {
	    if (!this.arrMedia) return true;
	    return (this.arrMedia.Count() == 0);
	};
	
	if(XMLDoc && XMLDoc.childNodes.length != 0)
	{
		this.InitList(XMLDoc);
	}
}

EBRadioRecentMediaList_CT2958529.prototype = new EBRadioMediaList_CT2958529;
var EBRadioServerComm_CT2958529 =
{
    RequestPublisherMedia: function() {
        if (!this.IsRequestPublisherMedia())
            return;

        var oCallBackFunction = function(strXML, o) {
            strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
            EBRadioServerComm_CT2958529.ServerResponse(strXML);
        };

        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastCheckTime, Date(), true);

        var RQURL = EBRadioConsts_CT2958529.ServerURL;
        var LastUpdateServerTimeIP = EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerIPTime, true);
        var LastUpdateServerTime = EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerTime, true);

        if (!LastUpdateServerTime) LastUpdateServerTime = '0';

        if (!LastUpdateServerTimeIP) LastUpdateServerTimeIP = '0';

        var oRadioComp = EBComponentsManager_CT2958529.GetRadioComponent();
        if (!oRadioComp) return;

        if (oRadioComp.ComponentItem.objData.isPublisher) {
            if (EBRadioConsts_CT2958529.EnableIPStations) {
                RQURL += EBRadioConsts_CT2958529.ServerRQAddBoth.replace(/CTxxxx/, EBActionManager_CT2958529.GetCTIDForServices());
                RQURL = RQURL.replace(/<LUT>/, LastUpdateServerTime);
                RQURL += LastUpdateServerTimeIP;
            }
            else {
                RQURL += EBRadioConsts_CT2958529.ServerRQAdd.replace(/CTxxxx/, EBActionManager_CT2958529.GetCTIDForServices());
                RQURL += LastUpdateServerTime;
            }
        }
        else {
            RQURL += EBRadioConsts_CT2958529.ServerRQAddIP;
            RQURL += LastUpdateServerTimeIP;
        }

        var bInvalidateCache = EBRadioIOManager_CT2958529.InvalidateCache(false);
        if (bInvalidateCache)
            RQURL += EBRadioConsts_CT2958529.ServerRQInvalidateCache;

        this.ServerRequest(RQURL, oCallBackFunction);
    },

    IsRequestPublisherMedia: function() {
        var now = Date();
        var lastCheckTime = EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.LastCheckTime, true)
        if (!lastCheckTime || lastCheckTime == "0") {
            EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerTime, null, true);
            return true;
        }

        var milliDif = Date.parse(now) - Date.parse(lastCheckTime);
        if (milliDif > EBRadioConsts_CT2958529.CheckInterval)
            return true;

        var LastUpdateServerTime = EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerTime, true);
        var LastUpdateServerIPTime = EBToolbarPreferenceManager_CT2958529.GetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerIPTime, true);

        if (!LastUpdateServerTime && !LastUpdateServerIPTime)
            return true;

        // all ok, no need to check
        return false;
    },

    ServerRequest: function(strURL, oCallBackFunction) {
        EBWeb_CT2958529.HTTPServerRequest(strURL, null, false, oCallBackFunction);
    },

    ServerResponse: function(strXMLRS) {
        var XMLDoc = EBXML_CT2958529.GetXmlDocument(strXMLRS);
        var XMLStationsNode = null;
        var XMLIPStationsNode = null;
        var lut, iplut;
        var o = EBRadioIOManager_CT2958529.FillStationsInfo(XMLDoc, EBRadioConsts_CT2958529.XMLResponsePublisher);
        var o2 = EBRadioIOManager_CT2958529.FillStationsInfo(XMLDoc, EBRadioConsts_CT2958529.XMLResponseIP);

        XMLStationsNode = o.xmlStations;
        lut = o.lut;

        XMLIPStationsNode = o2.xmlStations;
        iplut = o2.lut;

        //if no stations at all, return
        if (!XMLStationsNode && !XMLIPStationsNode)
            return;

        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerTime, lut, true);
        EBToolbarPreferenceManager_CT2958529.SetPref(EBRadioConsts_CT2958529.Registry.LastUpdateServerIPTime, iplut, true)
        if (XMLStationsNode) {
            var strPublisherMediaFile = EBRadioConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBRadioConsts_CT2958529.PublisherMediaFile;

            if (!EBMCManager_CT2958529.IsSelectedOriginalCommunity())
                strPublisherMediaFile = EBMCManager_CT2958529.GetCommunitySettingsPath() + strPublisherMediaFile;

            EBRadioIOManager_CT2958529.SaveMediaXMLToFile(XMLStationsNode, strPublisherMediaFile);
        }

        if (XMLIPStationsNode) {
            var strIPMediaFile = EBRadioConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + EBRadioConsts_CT2958529.IPMediaFile;
            EBRadioIOManager_CT2958529.SaveMediaXMLToFile(XMLIPStationsNode, strIPMediaFile);
        }

        EBRadioManager_CT2958529.UpdateMedia(EBRadioConsts_CT2958529.MediaFileType.Publisher, XMLStationsNode, XMLIPStationsNode);
    },

    RequestPodcast: function(Media) {
        var xmlRSSFeed = EBFeedManager_CT2958529.ConstructRSSFeedXML(Media.MediaID, Media.MediaURL, EBRadioConsts_CT2958529.PodcastCheckInterval, true, false);
        var oRadioComp = EBComponentsManager_CT2958529.GetRadioComponent();
        var objData = oRadioComp.ComponentItem.objData;
        var oData = new oToolbar_CT2958529.toolbarDataParsing.toolbarItemData( xmlRSSFeed, objData.compType,
                                                                            objData.isPublisher, objData.chromeName, 
                                                                            objData.originalCTID, objData.actingCTID);
        var oRssItem = oToolbar_CT2958529.toolbarDataParsing.toolbarItemsFactory.GetInstance(oData);
        var oComponent = new EBFeedComponent_CT2958529(oRssItem);
        oComponent.SetCallbackFunction(EBRadioManager_CT2958529.OnPodcastResponse, EBRadioManager_CT2958529);
        oComponent.OnLoadElement();
    },

    SearchRadioStations: function(strName) {
        var oRecentBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var RQURL = oRecentBrowserWindow.EBRadioConsts_CT2958529.ServerURL + oRecentBrowserWindow.EBRadioConsts_CT2958529.SearchAdd + strName;

        var oCallBackFunction = function(strXML, o) {
            strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
            EBRadioServerComm_CT2958529.ServerResponseSearch(strXML);
        };

        this.ServerRequest(RQURL, oCallBackFunction);
    },

    ServerResponseSearch: function(strXML) {
        var xmlStations = EBXML_CT2958529.GetXmlDocument(strXML);
        var SearchMediaList = new EBRadioMediaList_CT2958529(xmlStations.documentElement.childNodes[0]);
        EBRadioDialogManager_CT2958529.SearchResults(SearchMediaList);
    }
}

//Radio build UI components
var EBRadioSkinGUIFactory_CT2958529 =
{
    CreateGUIElementsFromArray: function(arrElem, xulElement) {
        var Consts = EBRadioSkinManager_CT2958529.Consts;
        var oElement = null;

        for (var i = 0; i < arrElem.length; i++) {
            oElement = arrElem[i];
            switch (oElement.itemType) {
                case Consts.TYPE_PLAY_PAUSE:
                    if (EBRadioConsts_CT2958529.NowState.PlayState == 'playing')
                        this.CreatePauseButton(oElement.Pause, xulElement);
                    else
                        this.CreatePlayButton(oElement.Play, xulElement);
                    EBRadioSkinManager_CT2958529.PlayButton = oElement.Play;
                    EBRadioSkinManager_CT2958529.PauseButton = oElement.Pause;
                    break;
                case Consts.TYPE_STOP: this.CreateStopButton(oElement, xulElement); break;
                case Consts.TYPE_INDICATOR:
                    this.CreateIndicators(oElement, xulElement);
                    EBRadioSkinManager_CT2958529.Indicator = oElement;
                    break;
                case Consts.TYPE_MEDIA_DISPLAY: this.CreateMediaDisplay(oElement, xulElement); break;
                case Consts.TYPE_VOLUME: this.CreateVolumeButton(oElement, xulElement); break;
                case Consts.TYPE_SLIDER: EBRadioSkinManager_CT2958529.Slider = oElement; break;
                case Consts.TYPE_MINIMIZE: this.CreateMinimize(oElement, xulElement); break;
                case Consts.TYPE_MAXIMIZE: this.CreateMaximize(oElement, xulElement); break;
            }
        }

        EBRadioManager_CT2958529.RadioBuildComplete();
    },

    CreatePlayButton: function(oElement, xulElement) {
        var xulPlay = null;
        if (xulElement) {
            xulPlay = EBXULFactory_CT2958529.CreateImage(oElement.normalUrl, "", "", true);
            EBRadioGUIManager_CT2958529.xulPlay = xulPlay;
        }
        else {
            xulPlay = EBRadioGUIManager_CT2958529.xulPlay;
            xulPlay.setAttribute('src', oElement.normalUrl);
        }

        xulPlay.setAttribute('id', EBRadioConsts_CT2958529.RadioPlayID);
        xulPlay.setAttribute('onclick', 'if(event.button == 0) EBRadioManager_CT2958529.OnPlay()');
        xulPlay.setAttribute('onmouseover', 'this.src="' + oElement.hoverUrl + '"');
        xulPlay.setAttribute('onmouseout', 'this.src="' + oElement.normalUrl + '"');
        xulPlay.setAttribute('onmousedown', 'if(event.button == 0) this.src="' + oElement.pressedUrl + '"');
        xulPlay.setAttribute('onmouseup', 'if(event.button == 0) this.src="' + oElement.normalUrl + '"');
        xulPlay.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.play);
        if (xulElement) {
            xulElement.appendChild(xulPlay);
        }
    },

    CreatePauseButton: function(oElement, xulElement) {
        var xulPlay = null;
        if (xulElement)
            xulPlay = EBXULFactory_CT2958529.CreateImage(oElement.normalUrl, "", "", true);
        else {
            xulPlay = EBRadioGUIManager_CT2958529.xulPlay;
            xulPlay.setAttribute('src', oElement.normalUrl);
        }
        xulPlay.setAttribute('id', EBRadioConsts_CT2958529.RadioPlayID);
        xulPlay.setAttribute('onclick', 'if(event.button == 0) EBRadioManager_CT2958529.OnPause()');
        xulPlay.setAttribute('onmouseover', 'this.src="' + oElement.hoverUrl + '"');
        xulPlay.setAttribute('onmouseout', 'this.src="' + oElement.normalUrl + '"');
        xulPlay.setAttribute('onmousedown', 'if(event.button == 0) this.src="' + oElement.pressedUrl + '"');
        xulPlay.setAttribute('onmouseup', 'if(event.button == 0) this.src="' + oElement.normalUrl + '"');
        xulPlay.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.pause);
        if (xulElement) {
            xulElement.appendChild(xulPlay);
        }
    },

    CreateStopButton: function(oElement, xulElement) {
        var xulStop = EBXULFactory_CT2958529.CreateImage(oElement.normalUrl, "", "", true);
        EBRadioGUIManager_CT2958529.xulStop = xulStop;
        xulStop.setAttribute('id', EBRadioConsts_CT2958529.RadioStopID);
        xulStop.setAttribute('onclick', 'if(event.button == 0) EBRadioManager_CT2958529.OnPause(true)');
        xulStop.setAttribute('onmouseover', 'this.src="' + oElement.hoverUrl + '"');
        xulStop.setAttribute('onmouseout', 'this.src="' + oElement.normalUrl + '"');
        xulStop.setAttribute('onmousedown', 'if(event.button == 0) this.src="' + oElement.pressedUrl + '"');
        xulStop.setAttribute('onmouseup', 'if(event.button == 0) this.src="' + oElement.normalUrl + '"');
        xulStop.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.stop);
        xulElement.appendChild(xulStop);
    },

    CreateIndicators: function(oElement, xulElement) {
        var xulEq = EBXULFactory_CT2958529.CreateImage(oElement.stoppedUrl, "", "", true);
        EBRadioGUIManager_CT2958529.xulEq = xulEq;
        xulEq.setAttribute('id', EBRadioConsts_CT2958529.RadioEqID);
        xulElement.appendChild(xulEq);
    },

    CreateMediaDisplay: function(oElement, xulElement) {
        var iWidth = oElement.width;
        var xulComboBG_style = "-moz-box-align: center; vertical-align: center;background:url(" + oElement.normalUrl + "); height: 20px !important; max-height: 20px;width: " + iWidth + "px";

        var xulComboBG_mouseover = 'this.style.backgroundImage="url(' + oElement.hoverUrl + ')"';
        var xulComboBG_mouseout = 'this.style.backgroundImage="url(' + oElement.normalUrl + ')"';
        var xulComboBG_mousedown = 'this.style.backgroundImage="url(' + oElement.pressedUrl + ')"';
        var xulComboBG_mouseup = 'this.style.backgroundImage="url(' + oElement.hoverUrl + ')"';

        var xulComboBG = EBXULFactory_CT2958529.CreateHBox("", xulComboBG_style, "");

        xulComboBG.setAttribute('onmouseover', xulComboBG_mouseover);
        xulComboBG.setAttribute('onmouseout', xulComboBG_mouseout);
        xulComboBG.setAttribute('onmousedown', xulComboBG_mousedown);
        xulComboBG.setAttribute('onmouseup', xulComboBG_mouseup);

        var xulMenuButton = EBXULFactory_CT2958529.CreateToolbarButton(EBRadioConsts_CT2958529.RadioMenuButtonID, "menu", "", "", "", "");

        xulMenuButton.setAttribute('onclick', "if(EBGlobalManager_CT2958529.IsElementInScreenCoordinates(this) && event.button == 0) {EBRadioManager_CT2958529.OnRadioMenuClick(this);}event.cancelBubble = true;");
        xulMenuButton.setAttribute('width', iWidth + 'px');
        xulMenuButton.setAttribute('style', '-moz-appearance:none; background-color:transparent; border:0px; margin:0px; font-size: 10px; color:' + oElement.textColor);
        xulMenuButton.setAttribute('onmouseover', 'this.style.color="' + oElement.textColorHover + '"');
        xulMenuButton.setAttribute('onmouseout', 'this.style.color="' + oElement.textColor + '"');

        xulComboBG.appendChild(xulMenuButton);
        xulElement.appendChild(xulComboBG);

        EBRadioGUIManager_CT2958529.xulMenuButtonContainer = xulComboBG;
        EBRadioGUIManager_CT2958529.xulMenuButton = xulMenuButton;
        if (EBRadioConsts_CT2958529.RadioMenu)
            EBRadioManager_CT2958529.UpdateMenuButtonAfterShrink(xulMenuButton);
    },

    CreateVolumeButton: function(oElement, xulElement) {
        var xulVolume = EBXULFactory_CT2958529.CreateImage(oElement.normalUrl, "", "", true);
        EBRadioGUIManager_CT2958529.xulVolume = xulVolume;
        xulVolume.setAttribute('id', EBRadioConsts_CT2958529.RadioVolumeID);
        xulVolume.setAttribute('onclick', 'if(event.button == 0) EBRadioSkinManager_CT2958529.OnVolumeClick(this)');
        xulVolume.setAttribute('onmouseover', 'this.src="' + oElement.hoverUrl + '"');
        xulVolume.setAttribute('onmouseout', 'this.src="' + oElement.normalUrl + '"');
        xulVolume.setAttribute('onmousedown', 'if(event.button == 0) this.src="' + oElement.pressedUrl + '"');
        xulVolume.setAttribute('onmouseup', 'if(event.button == 0) this.src="' + oElement.normalUrl + '"');
        xulVolume.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.volume);
        xulElement.appendChild(xulVolume);
    },

    CreateMinimize: function(oElement, xulElement) {
        var xulShrink = EBXULFactory_CT2958529.CreateImage(oElement.normalUrl, "", "", true);
        EBRadioGUIManager_CT2958529.xulShrinkUnshrink = xulShrink;

        xulShrink.setAttribute('id', EBRadioConsts_CT2958529.RadioShrinkID);
        xulShrink.setAttribute('onclick', 'if(event.button == 0) EBRadioManager_CT2958529.OnShrink()');
        xulShrink.setAttribute('onmouseover', 'this.src="' + oElement.hoverUrl + '"');
        xulShrink.setAttribute('onmouseout', 'this.src="' + oElement.normalUrl + '"');
        xulShrink.setAttribute('onmousedown', 'if(event.button == 0) this.src="' + oElement.pressedUrl + '"');
        xulShrink.setAttribute('onmouseup', 'if(event.button == 0) this.src="' + oElement.normalUrl + '"');
        xulShrink.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.shrink);
        xulElement.appendChild(xulShrink);
    },

    CreateMaximize: function(oElement, xulElement) {
        var xulShrink = EBXULFactory_CT2958529.CreateImage(oElement.normalUrl, "", "", true);
        EBRadioGUIManager_CT2958529.xulShrinkUnshrink = xulShrink;

        xulShrink.setAttribute('id', EBRadioConsts_CT2958529.RadioShrinkID);
        xulShrink.setAttribute('onclick', 'if(event.button == 0) EBRadioManager_CT2958529.OnExpand()');
        xulShrink.setAttribute('onmouseover', 'this.src="' + oElement.hoverUrl + '"');
        xulShrink.setAttribute('onmouseout', 'this.src="' + oElement.normalUrl + '"');
        xulShrink.setAttribute('onmousedown', 'if(event.button == 0) this.src="' + oElement.pressedUrl + '"');
        xulShrink.setAttribute('onmouseup', 'if(event.button == 0) this.src="' + oElement.normalUrl + '"');
        xulShrink.setAttribute('tooltiptext', EBRadioGUIManager_CT2958529.Tooltips.expand);
        xulElement.appendChild(xulShrink);
    }
}

//++++++++++++++++++++++++++++ skins Handle +++++++++++++++++++++++++++
var EBRadioSkinManager_CT2958529 =
{
    RadioComponent: null,
    PlayButton: null,
    PauseButton: null,
    Indicator: null,
    Slider: null,
    ObjSkinDef: null,

    Consts:
	{
	    SKIN_ROOT_TAG: "DISPLAY_SETTINGS",
	    MAXIMIZED_ROOT: "MAXIMIZED",
	    MINIMIZED_ROOT: "MINIMIZED",
	    CHEVRON_ROOT: "CHEVRON",
	    OPTIONS_ROOT: "OPTIONS",
	    MENU_ROOT: "MENU",
	    ITEM: "ITEM",
	    TYPE: "TYPE",
	    IMAGE: "IMAGE",
	    URL: "URL",
	    WIDTH: "WIDTH",
	    HEIGHT: "HEIGHT",
	    TEXT_COLOR: "TEXT_COLOR",
	    TEXT_COLOR_HOVER: "TEXT_COLOR_HOVER",
	    SLIDER_BUTTON: "SLIDER_BUTTON",
	    BACKGROUND: "BACKGROUND",
	    BACKGROUND_COLOR: "BACKGROUND_COLOR",
	    NORMAL_MENUITEM_TEXT_COLOR: "NORMAL_MENUITEM_TEXT_COLOR",
	    HIGHLIGHT_MENUITEM_TEXT_COLOR: "HIGHLIGHT_MENUITEM_TEXT_COLOR",
	    HIGHLIGHT_MENUITEM_BG_COLOR: "HIGHLIGHT_MENUITEM_BG_COLOR",
	    SEPARATOR_COLOR: "SEPARATOR_COLOR",
	    TYPE_HOVER: "HOVER",
	    TYPE_NORMAL: "NORMAL",
	    TYPE_PRESSED: "PRESSED",
	    TYPE_PLAY_PAUSE: "PLAY_PAUSE",
	    TYPE_PLAY: "PLAY",
	    TYPE_PAUSE: "PAUSE",
	    TYPE_STOP: "STOP",
	    TYPE_MINIMIZE: "MINIMIZE",
	    TYPE_MAXIMIZE: "MAXIMIZE",
	    TYPE_CHEVRON: "CHEVRON",
	    TYPE_MENU: "MENU",
	    TYPE_OPTIONS: "OPTIONS",
	    TYPE_INDICATOR: "INDICATOR",
	    TYPE_PLAYING: "PLAYING",
	    TYPE_BUFFERING: "BUFFERING",
	    TYPE_ERROR: "ERROR",
	    TYPE_STOPPED: "STOPPED",
	    TYPE_MEDIA_DISPLAY: "MEDIA_DISPLAY",
	    TYPE_BG: "BG",
	    TYPE_VOLUME: "VOLUME",
	    TYPE_SLIDER: "SLIDER",
	    TYPE_BUTTON: "BUTTON",

	    VolumeDialogPath: 'chrome://browsersearch/content/radio_volume.xul',
	    strSkinPath: 'chrome://browsersearch/skin/radio/default_radio_skin.xml',
	    VolumeDialogName: 'EBRadioVolumeDialog_CT2958529',
	    SkinsSubFolder: 'Skins'
	},

    LoadDefaultSkin: function() {
        var xmlSkin = EBXML_CT2958529.GetXmlDocumentFromUrl(this.Consts.strSkinPath);
        xmlSkinRoot = xmlSkin.documentElement;
        var objSkinDef = new EBRadioSkinDefinition_CT2958529(xmlSkinRoot, '');
        this.ObjSkinDef = objSkinDef;
        this.ApplySkin(objSkinDef);

    },

    LoadSkin: function(oRadio, iSkinID) {
        this.RadioComponent = oRadio;
        this.RadioComponent.XULElement.style.marginLeft = "2px";
        this.RadioComponent.XULElement.style.marginRight = "2px";
        
        var arrSkins = this.RadioComponent.ComponentItem.Skins;
        if (!arrSkins || arrSkins.length == 0) {
            this.LoadDefaultSkin();
            return;
        }

        var objSkin = arrSkins[0];
        var objSkinDef = this.LoadRadioSkinFromFile(objSkin.Url);
        //skin exists
        if (objSkinDef && objSkinDef.Validate()) {
            this.ObjSkinDef = objSkinDef;
            this.ApplySkin(objSkinDef);
        }

        //skin doen't exist, get the skin from web
        else {
            var oCallBackFunction = function(strXML, o) {
                strXML = EBXML_CT2958529.LegalizeEBXML(strXML);
                EBRadioSkinManager_CT2958529.ServerResponseSkinXML(strXML, objSkin.Url);
            };
            EBRadioServerComm_CT2958529.ServerRequest(objSkin.Url, oCallBackFunction);
        }
    },

    UnloadSkin: function() {
        this.ClearRadioItems();
    },

    LoadRadioSkinFromFile: function(strUrl) {
        var strFileName = this.ToLegalFileName(strUrl);
        var strFullPath = EBRadioConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + this.Consts.SkinsSubFolder + EBDirIO_CT2958529.sep + strFileName;
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(strFullPath);
        var strXMLSkin = EBFileIO_CT2958529.read(oFile, EBGlobalConsts_CT2958529.DefaultCharset);
        if (!strXMLSkin) {
            return null;
        }
        var xmlSkin = EBXML_CT2958529.GetXmlDocument(strXMLSkin);
        xmlSkin = xmlSkin.documentElement;
        var objSkinDef = new EBRadioSkinDefinition_CT2958529(xmlSkin, this.ClearSkinUrl(strUrl));
        return objSkinDef;
    },

    ToLegalFileName: function(strUrl) {
        var strFileName = EBGlobalManager_CT2958529.ToLegalFileName(strUrl);
        strFileName += '.xml';
        return strFileName;
    },

    SaveSkinToFile: function(strXML, strUrl) {
        var strFileName = this.ToLegalFileName(strUrl);
        var strFullPath = EBRadioConsts_CT2958529.FolderName + EBDirIO_CT2958529.sep + this.Consts.SkinsSubFolder + EBDirIO_CT2958529.sep + strFileName;
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(strFullPath);
        EBFileIO_CT2958529.write(oFile, strXML, "", EBGlobalConsts_CT2958529.DefaultCharset);
    },

    ServerResponseSkinXML: function(strXML, strUrl) {
        try {
            var xmlSkin = EBXML_CT2958529.GetXmlDocument(strXML);
            if (xmlSkin && xmlSkin.documentElement.tagName == this.Consts.SKIN_ROOT_TAG) {
                this.SaveSkinToFile(strXML, strUrl);
                var oSkinDef = new EBRadioSkinDefinition_CT2958529(xmlSkin.documentElement, this.ClearSkinUrl(strUrl));
                if (oSkinDef && oSkinDef.Validate()) {
                    this.BroadcastNewSkin(oSkinDef);
                }
            }
        }
        catch (ex) { }
    },

    BroadcastNewSkin: function(oSkinDef) {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var objWindow = null;
        for (var i = 0; i < arrWindows.length; i++) {
            objWindow = arrWindows[i];
            if (objWindow.EBRadioSkinManager_CT2958529.ApplySkin) {
                try {
                    objWindow.EBRadioSkinManager_CT2958529.ObjSkinDef = oSkinDef;
                    objWindow.EBRadioSkinManager_CT2958529.ApplySkin(oSkinDef);
                }
                catch (ex) { EBLog(ex); }
            }
        }
    },

    ClearRadioItems: function() {
        if (!this.RadioComponent) return;

        var xulElement = this.RadioComponent.XULElement;
        for (var i = xulElement.childNodes.length - 1; i >= 0; i--) {
            xulElement.removeChild(xulElement.firstChild);
        }
    },

    SetShrink: function() {
        this.ClearRadioItems();
        EBRadioSkinGUIFactory_CT2958529.CreateGUIElementsFromArray(this.ObjSkinDef.ShrinkedView, this.RadioComponent.XULElement);
    },

    SetExpand: function() {
        this.ClearRadioItems();
        this.ApplySkin(this.ObjSkinDef);
    },

    ApplySkin: function(oSkinDef) {
        var xulChevronElement = this.RadioComponent.XULChevronElement;
        this.ClearRadioItems();
        //create new radio UI
        EBRadioSkinGUIFactory_CT2958529.CreateGUIElementsFromArray(oSkinDef.NormalView, this.RadioComponent.XULElement);

        //set the options icon
        if (oSkinDef.OptionsImageUrl && this.RadioComponent)
            this.RadioComponent.ComponentItem.DisplayIcon = oSkinDef.OptionsImageUrl;
    },

    //call function to open volume dialog
    OnVolumeClick: function(obj) {
        var DialogName = this.Consts.VolumeDialogName;
        var oDialog = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName("EBRadioVolumeDialog_CT2958529", DialogName)
        if (oDialog) return;

        var dialogWidth = parseInt(this.Slider.width);
        var dialogHeight = parseInt(this.Slider.height);
        var dialogX = obj.parentNode.boxObject.screenX + obj.parentNode.boxObject.width / 2 - dialogWidth / 2;
        var dialogY = obj.boxObject.screenY + 10;

        EBRadioDialogManager_CT2958529.Volume_OpenDialog(this.Consts.VolumeDialogPath,
	                                                    DialogName,
	                                                    dialogWidth,
	                                                    dialogHeight,
	                                                    dialogX,
	                                                    dialogY);
    },

    //change play to pause
    ChangePauseToPlayButton: function() {
        EBRadioSkinGUIFactory_CT2958529.CreatePlayButton(this.PlayButton, null);
    },

    //change play to pause button
    ChangePlayToPauseButton: function() {
        EBRadioSkinGUIFactory_CT2958529.CreatePauseButton(this.PauseButton, null);
    },

    ClearSkinUrl: function(strSkinUrl) {
        var iIndex = strSkinUrl.lastIndexOf('/');
        strSkinUrl = strSkinUrl.substr(0, iIndex + 1);
        return strSkinUrl;
    },

    GetImageUrl: function(strImageUrl, strSkinUrl) {
        var strFullImageUrl = strImageUrl;

        if (strImageUrl.indexOf('://') == -1) {
            strFullImageUrl = strSkinUrl + strFullImageUrl;
        }

        //image preloading, in order to set the image in to the cache
        var oImage = new Image();
        oImage.src = strFullImageUrl;
        oImage.onload = function() { oImage = null; }

        return strFullImageUrl;
    },

    OnMenuItemMouseOver: function(oMenuItem) {
        if (this.ObjSkinDef.Menu && !EBGlobalManager_CT2958529.IsFirefox3()) {
            oMenuItem.style.color = this.ObjSkinDef.Menu.colorHover;
            oMenuItem.style.backgroundColor = this.ObjSkinDef.Menu.backgroundColorHover;
        }
    },

    OnMenuItemMouseOut: function(oMenuItem) {
        if (this.ObjSkinDef.Menu && !EBGlobalManager_CT2958529.IsFirefox3()) {
            oMenuItem.style.color = this.ObjSkinDef.Menu.color;
            oMenuItem.style.backgroundColor = this.ObjSkinDef.Menu.backgroundColor;
        }
    },

    ColorizeMenuItems: function(obj) {
        if (!this.ObjSkinDef.Menu) return;

        var arrMenuItems = obj.getElementsByTagName('menuitem');
        var menuItem = null;
        var i;

        for (i = 0; i < arrMenuItems.length; i++) {
            menuItem = arrMenuItems[i];
            menuItem.style.color = this.ObjSkinDef.Menu.color;
        }

        arrMenuItems = obj.getElementsByTagName('menu');

        for (i = 0; i < arrMenuItems.length; i++) {
            menuItem = arrMenuItems[i];
            menuItem.style.color = this.ObjSkinDef.Menu.color;
        }

        arrMenuItems = obj.getElementsByTagName('menuseparator');

        for (i = 0; i < arrMenuItems.length; i++) {
            menuItem = arrMenuItems[i];
            menuItem.style.borderBottomColor = this.ObjSkinDef.Menu.separatorColor;
        }
    }
};
//Radio Skin objects
//Radio Skin Object - Represents Skin XML
function EBRadioSkinDefinition_CT2958529(xmlSkin,strUrl)
{
    
    this.SkinUrl        = strUrl;
    this.NormalView     = new Array();
    this.ShrinkedView   = new Array();
    
    this.ChevronMenuImageUrl        = '';
    this.ChevronPlayImageUrl        = '';
    this.ChevronPauseImageUrl       = '';
    this.ChevronStopImageUrl        = '';
    
    this.OptionsImageUrl            = '';
    
    this.Menu                       = null;
    
    var Consts = EBRadioSkinManager_CT2958529.Consts;
    var GetImage = EBRadioSkinManager_CT2958529.GetImageUrl;

    this.Validate = function() {
        if (this.NormalView.length == 0
            ||
           this.ShrinkedView.length == 0
            ||
           !this.ChevronMenuImageUrl
            ||
           !this.ChevronPlayImageUrl
            ||
           !this.ChevronStopImageUrl
            ||
           !this.OptionsImageUrl) {
            return false;
        }

        var FLAGS = 0;
        var Item = null;
        var i;

        for (i = 0; i < this.NormalView.length; i++) {
            Item = this.NormalView[i];
            //Check play & pause
            if (Item.itemType == Consts.TYPE_PLAY_PAUSE) {
                var itemPlay = Item.Play;
                var itemPause = Item.Pause;
                if (!itemPlay.normalUrl || !itemPlay.hoverUrl || !itemPlay.pressedUrl || !itemPlay.width) {
                    return false;
                }

                if (!itemPause.normalUrl || !itemPause.hoverUrl || !itemPause.pressedUrl || !itemPause.width) {
                    return false;
                }

                FLAGS++;
            }

            //Check stop
            else if (Item.itemType == Consts.TYPE_STOP) {
                if (!Item.normalUrl || !Item.hoverUrl || !Item.pressedUrl || !Item.width) {
                    return false;
                }

                FLAGS++;
            }

            //Check inicator
            else if (Item.itemType == Consts.TYPE_INDICATOR) {
                if (!Item.playingUrl || !Item.bufferingUrl || !Item.errorUrl || !Item.stoppedUrl || !Item.width) {
                    return false;
                }

                FLAGS++;
            }

            //Check media display
            else if (Item.itemType == Consts.TYPE_MEDIA_DISPLAY) {
                if (!Item.normalUrl || !Item.hoverUrl || !Item.pressedUrl || !Item.textColor || !Item.textColorHover || !Item.width) {
                    return false;
                }

                FLAGS++;
            }

            //Check volume
            else if (Item.itemType == Consts.TYPE_VOLUME) {
                if (!Item.normalUrl || !Item.hoverUrl || !Item.pressedUrl || !Item.width) {
                    return false;
                }

                FLAGS++;
            }

            //Check slider
            else if (Item.itemType == Consts.TYPE_SLIDER) {
                if (!Item.width || !Item.height || !Item.normalUrl || !Item.sliderButton.width || !Item.sliderButton.normalUrl || !Item.sliderButton.hoverUrl || !Item.sliderButton.pressedUrl) {
                    return false;
                }

                FLAGS++;
            }

            //Check minimize
            else if (Item.itemType == Consts.TYPE_MINIMIZE) {
                if (!Item.normalUrl || !Item.hoverUrl || !Item.pressedUrl || !Item.width) {
                    return false;
                }

                FLAGS++;
            }
        } //for normal view

        // +++++++++++++++ Check shrinked view +++++++++++++++
        for (i = 0; i < this.ShrinkedView.length; i++) {
            Item = this.ShrinkedView[i];
            if (Item.itemType == Consts.TYPE_MAXIMIZE) {
                if (!Item.normalUrl || !Item.hoverUrl || !Item.pressedUrl || !Item.width) {
                    return false;
                }

                FLAGS++;
            }
        } //for shrinked view

        if (!this.ChevronMenuImageUrl || !this.ChevronPlayImageUrl || this.ChevronPauseImageUrl
                ||
            !this.ChevronStopImageUrl || !this.OptionsImageUrl) {
            return false;
        }
        else {
            FLAGS++;
        }

        if (FLAGS != 9) {
            return false;
        }

        return true;

    };
    
    this.Init = function()
    {
        var xmlMode = null;
        for(var i=0;i<xmlSkin.childNodes.length;i++)
        {
            xmlMode = xmlSkin.childNodes[i];
            
            if(xmlMode.tagName == Consts.MAXIMIZED_ROOT)
            {
                this.ParseMaximized(xmlMode);
            }
            else if(xmlMode.tagName == Consts.MINIMIZED_ROOT)
            {
                this.ParseMinimized(xmlMode);
            }
            else if(xmlMode.tagName == Consts.CHEVRON_ROOT)
            {
                this.ParseChevron(xmlMode);
            }
            else if(xmlMode.tagName == Consts.OPTIONS_ROOT)
            {
                this.ParseOptions(xmlMode);
            }
            else if(xmlMode.tagName == Consts.MENU_ROOT)
            {
                this.ParseMenu(xmlMode);
            }
        }
    };
    
    this.ParseMaximized = function(xmlMaximized)
    {
        var xmlItem = null;
        var oButton = null;
        
        for(var i=0;i<xmlMaximized.childNodes.length;i++)
        {
            xmlItem = xmlMaximized.childNodes[i];
            if(xmlItem.tagName == Consts.ITEM)
            {
                oButton = new EBRadioSkinDefButton_CT2958529(xmlItem,this.SkinUrl);
                if(oButton)
                {
                    this.NormalView.push(oButton);
                }
            }
        }
    };
    
    this.ParseMinimized = function(xmlMinimized)
    {
        var xmlItem = null;
        var oButton = null;
        
        for(var i=0;i<xmlMinimized.childNodes.length;i++)
        {
            xmlItem = xmlMinimized.childNodes[i];
            if(xmlItem.tagName == Consts.ITEM)
            {
                oButton = new EBRadioSkinDefButton_CT2958529(xmlItem,this.SkinUrl);
                if(oButton)
                {
                    this.ShrinkedView.push(oButton);
                }
            }
        }
    };
        
    this.ParseChevron = function(xmlChevron)
    {
        var xmlImage        = null;
        var xmlImageNode    = null;
        var url             = '';
        var type            = '';
        
        for(var i=0;i<xmlChevron.childNodes.length;i++)
        {
            xmlImage = xmlChevron.childNodes[i];
            if(xmlImage.tagName == Consts.IMAGE)
            {
                for(var j=0;j<xmlImage.childNodes.length;j++)
                {
                    xmlImageNode = xmlImage.childNodes[j];
                    if(xmlImageNode.tagName == Consts.TYPE)
                    {
                        type = EBXML_CT2958529.GetXmlNodeValue(xmlImageNode);
                    }
                    else if(xmlImageNode.tagName == Consts.URL)
                    {
                        url = GetImage(EBXML_CT2958529.GetXmlNodeValue(xmlImageNode),this.SkinUrl);
                    }
                }
                if(type == Consts.TYPE_MENU)
                {
                    this.ChevronMenuImageUrl = url;
                }
                else if(type == Consts.TYPE_PLAY)
                {
                    this.ChevronPlayImageUrl = url;
                }
                else if(type == Consts.TYPE_STOP)
                {
                    this.ChevronStopImageUrl = url;
                }
            }
        }
    };            
         
    this.ParseOptions = function(xmlOptions)
    {
        var xmlImage        = null;
        var xmlImageNode    = null;
        var type            = '';
        var url             = '';
        
        for(var i=0;i<xmlOptions.childNodes.length;i++)
        {
            if (xmlOptions.childNodes[i].tagName && xmlOptions.childNodes[i].tagName == Consts.IMAGE)
            {
                xmlImage = xmlOptions.childNodes[i];
                for(var j=0;j<xmlImage.childNodes.length;j++)
                {
                    xmlImageNode = xmlImage.childNodes[j];
                    if(xmlImageNode.tagName == Consts.TYPE)
                    {
                        type = EBXML_CT2958529.GetXmlNodeValue(xmlImageNode);
                    }
                    else if(xmlImageNode.tagName == Consts.URL)
                    {
                        url = GetImage(EBXML_CT2958529.GetXmlNodeValue(xmlImageNode),this.SkinUrl);
                    }
                }
                if(type == Consts.TYPE_NORMAL)
                {
                    this.OptionsImageUrl = url;
                }
            }
        }
    };
    
    this.ParseMenu = function(xmlMenu)
    {
        var xmlItem = null;
        this.Menu = new Object();
        
        for(var i=0; i<xmlMenu.childNodes.length; i++)
        {
            xmlItem = xmlMenu.childNodes[i];
            if(xmlItem.tagName == Consts.NORMAL_MENUITEM_TEXT_COLOR)
            {
                this.Menu.color = EBXML_CT2958529.GetXmlNodeValue(xmlItem);
            }
            else if(xmlItem.tagName == Consts.HIGHLIGHT_MENUITEM_TEXT_COLOR)
            {
                this.Menu.colorHover = EBXML_CT2958529.GetXmlNodeValue(xmlItem);
            }
            else if(xmlItem.tagName == Consts.BACKGROUND_COLOR)
            {
                this.Menu.backgroundColor = EBXML_CT2958529.GetXmlNodeValue(xmlItem);
            }
            else if(xmlItem.tagName == Consts.HIGHLIGHT_MENUITEM_BG_COLOR)
            {
                this.Menu.backgroundColorHover = EBXML_CT2958529.GetXmlNodeValue(xmlItem);
            }
            else if(xmlItem.tagName == Consts.SEPARATOR_COLOR)
            {
                this.Menu.separatorColor = EBXML_CT2958529.GetXmlNodeValue(xmlItem);
            }
        }    
    };
    
    //Check and init the Skin XML
    if(xmlSkin.tagName == Consts.SKIN_ROOT_TAG)
    {
        this.Init();
    }
    else
    {
        return null;
    }
}


function EBRadioSkinDefButton_CT2958529(xmlItem,strUrl)
{
    this.SkinUrl        = strUrl;
    this.itemType       = '';
    this.width          = 0;
    this.height         = 0;
    this.normalUrl      = '';
    this.hoverUrl       = '';
    this.pressedUrl     = '';
    
    //media display special
    this.textColor      = '';
    this.textColorHover = '';
    
    //slider special
    this.sliderButton   = null;
    
    //indicators special
    this.playingUrl        = '';
    this.bufferingUrl   = '';
    this.errorUrl       = '';
    this.stoppedUrl       = '';
    
    this.Play           = null;
    this.Pause          = null;
    
    var Consts = EBRadioSkinManager_CT2958529.Consts; 
    var GetImage = EBRadioSkinManager_CT2958529.GetImageUrl;

    this.Init = function() {
        var type = '';
        var imageType = '';
        var imageUrl = '';
        var xmlNode = null;
        var xmlImageNode = null;
        var arrItem = new Array();
        var i,j,k;

        for (i = 0; i < xmlItem.childNodes.length; i++) {
            xmlNode = xmlItem.childNodes[i];
            if (xmlNode.tagName == Consts.TYPE) {
                this.itemType = EBXML_CT2958529.GetXmlNodeValue(xmlNode);
            }
            else if (xmlNode.tagName == Consts.WIDTH) {
                this.width = EBXML_CT2958529.GetXmlNodeValue(xmlNode);
            }
            else if (xmlNode.tagName == Consts.HEIGHT) {
                this.height = EBXML_CT2958529.GetXmlNodeValue(xmlNode);
            }
            else if (xmlNode.tagName == Consts.IMAGE) {
                for (j = 0; j < xmlNode.childNodes.length; j++) {
                    xmlImageNode = xmlNode.childNodes[j];
                    if (xmlImageNode.tagName == Consts.TYPE) {
                        imageType = EBXML_CT2958529.GetXmlNodeValue(xmlImageNode);
                    }
                    else if (xmlImageNode.tagName == Consts.URL) {
                        imageUrl = GetImage(EBXML_CT2958529.GetXmlNodeValue(xmlImageNode), this.SkinUrl);
                    }
                }
                //image types
                if (imageType == Consts.TYPE_NORMAL) {
                    this.normalUrl = imageUrl;
                }
                else if (imageType == Consts.TYPE_HOVER) {
                    this.hoverUrl = imageUrl;
                }
                else if (imageType == Consts.TYPE_PRESSED) {
                    this.pressedUrl = imageUrl;
                }
                else if (imageType == Consts.TYPE_PLAYING) {
                    this.playingUrl = imageUrl;
                }
                else if (imageType == Consts.TYPE_BUFFERING) {
                    this.bufferingUrl = imageUrl;
                }
                else if (imageType == Consts.TYPE_ERROR) {
                    this.errorUrl = imageUrl;
                }
                else if (imageType == Consts.TYPE_STOPPED) {
                    this.stoppedUrl = imageUrl;
                }
            }
            else if (xmlNode.tagName == Consts.TEXT_COLOR) {
                this.textColor = EBXML_CT2958529.GetXmlNodeValue(xmlNode);
            }
            else if (xmlNode.tagName == Consts.TEXT_COLOR_HOVER) {
                this.textColorHover = EBXML_CT2958529.GetXmlNodeValue(xmlNode);
            }
            else if (xmlNode.tagName == Consts.BACKGROUND) {
                var xmlBackgroundNode = null;
                for (j = 0; j < xmlNode.childNodes.length; j++) {
                    xmlBackgroundNode = xmlNode.childNodes[j];
                    if (xmlBackgroundNode.tagName == Consts.WIDTH) {
                        this.width = EBXML_CT2958529.GetXmlNodeValue(xmlBackgroundNode);
                    }
                    else if (xmlBackgroundNode.tagName == Consts.HEIGHT) {
                        this.height = EBXML_CT2958529.GetXmlNodeValue(xmlBackgroundNode);
                    }
                    else if (xmlBackgroundNode.tagName == Consts.IMAGE) {
                        //we don't check the type of image, since it's a background image
                        for (k = 0; k < xmlBackgroundNode.childNodes.length; k++) {
                            xmlImageNode = xmlBackgroundNode.childNodes[k];
                            if (xmlImageNode.tagName == Consts.URL) {
                                this.normalUrl = GetImage(EBXML_CT2958529.GetXmlNodeValue(xmlImageNode), this.SkinUrl);
                            }
                        }
                    }
                }
            }
            else if (xmlNode.tagName == Consts.SLIDER_BUTTON) {
                var xmlSliderNode = null;
                this.sliderButton = new Object();
                var url = '';

                for (j = 0; j < xmlNode.childNodes.length; j++) {
                    xmlSliderNode = xmlNode.childNodes[j];
                    if (xmlSliderNode.tagName == Consts.WIDTH) {
                        this.sliderButton.width = EBXML_CT2958529.GetXmlNodeValue(xmlSliderNode);
                    }
                    else if (xmlSliderNode.tagName == Consts.IMAGE) {
                        for (k = 0; k < xmlSliderNode.childNodes.length; k++) {
                            xmlImageNode = xmlSliderNode.childNodes[k];
                            if (xmlImageNode.tagName == Consts.TYPE) {
                                type = EBXML_CT2958529.GetXmlNodeValue(xmlImageNode);
                            }
                            else if (xmlImageNode.tagName == Consts.URL) {
                                url = GetImage(EBXML_CT2958529.GetXmlNodeValue(xmlImageNode), this.SkinUrl);
                            }
                        }
                        if (type == Consts.TYPE_NORMAL) {
                            this.sliderButton.normalUrl = url;
                        }
                        else if (type == Consts.TYPE_HOVER) {
                            this.sliderButton.hoverUrl = url;
                        }
                        else if (type == Consts.TYPE_PRESSED) {
                            this.sliderButton.pressedUrl = url;
                        }
                    }
                }
            }
            else if (xmlNode.tagName == Consts.ITEM) {
                arrItem.push(new EBRadioSkinDefButton_CT2958529(xmlNode, this.SkinUrl))
            }
        } //for

        //in case of PLAY_PAUSE item, this object will include them
        if (arrItem.length > 0) {
            for (i = 0; i < arrItem.length; i++) {
                if (arrItem[i].itemType == Consts.TYPE_PLAY) {
                    this.Play = arrItem[i];
                    //must transfer width to the object, hense it presents only in PLAY_PAUSE item
                    this.Play.width = this.width;
                }
                else if (arrItem[i].itemType == Consts.TYPE_PAUSE) {
                    this.Pause = arrItem[i];
                    //must transfer width to the object, hense it presents only in PLAY_PAUSE item
                    this.Pause.width = this.width;
                }
            }
        }
    };  //init
    
    //check and init Item XML from Skin XML
    if(xmlItem.tagName == Consts.ITEM)
        this.Init();
    else
        return null;
};

// Radio Skin Object - represents XML SKIN node from RADIO node in localsettings.txt
function EBToolbarRadioSkin_CT2958529(xmlSkin)
{
    this.Url            = '';
    this.ImageUrl       = '';
    this.Name           = '';
    this.init           = true;
    
    if(!xmlSkin || (xmlSkin && xmlSkin.childNodes.length == 0))
    {
        this.init = false;
        return null;
    }
    
    var xmlNode = null;
    for(var i=0;i<xmlSkin.childNodes.length;i++)
    {
        xmlNode = xmlSkin.childNodes[i];
        
        if(xmlNode.tagName == 'URL')
            this.Url = EBXML_CT2958529.GetXmlNodeValue(xmlNode);
        else if(xmlNode.tagName == 'IMAGE_URL')
        {
            this.ImageUrl = EBXML_CT2958529.GetXmlNodeValue(xmlNode);
            this.ImageUrl = EBUrl_CT2958529.AddHTTPProtocol(this.ImageUrl);
        }
        else if(xmlNode.tagName == 'NAME')
            this.Name = EBXML_CT2958529.GetXmlNodeValue(xmlNode);
    }
    //not valid skin if no url presents
    if(!this.Url)
    {
        this.init = false;
        return null;
    }
    else
    {
        if(!EBUrl_CT2958529.IsValidURL(this.Url))
        {
            this.init = false;
            return null;
        }
        else
            this.Url = EBUrl_CT2958529.AddHTTPProtocol(this.Url);
    }
};
function EBAlertSettingComponent_CT2958529(item) {
    EBBaseToolbarComponent_CT2958529.call(this, item);
    
    this.ComponentItem = item;
    this.XULElement = null;
    this.XULChevronElement = null;
    this.XULToolbarItemContainer = null;
    this.buttonCommandCallback = null;

    this.Init = function() {
        var strHint = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_OPTIONS_DLG_NOTIFICATION_SETTINGS_BUTTON");
        var strLabel, strBackupImage, strImage = "";
        if (EBActionManager_CT2958529.IsAppView())
            strImage = this.ComponentItem.appInfo.imageUrl;
        else
            strImage = this.ComponentItem.DisplayIcon;

        //create the xul element
        var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
        this.buttonCommandCallback = function(event) {
            var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
            oWindow.EBAlertManager_CT2958529.OpenSettingsDialog(oWindow);
        };
        this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, "", strLabel, strImage, strHint, this.buttonCommandCallback, "", EBActionManager_CT2958529.IsAppView(), "");

        //create the tooltip element (for the shrink-unshrink tooltip)
        this.CreateTooltipShrink();
        return true;
    };

    this.AddToChevron = function(objXULContainer) {
        if (this.XULChevronElement) {
            this.XULChevronElement.removeEventListener("command", this.buttonCommandCallback, false);
            this.XULChevronElement = null;
        }

        var strLabel = this.XULElement.getAttribute('label');
        var strImage = this.XULElement.getAttribute('image');
        var strTooltip = this.XULElement.getAttribute('tooltiptext');

        this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuItem(strLabel, strImage, strTooltip, this.buttonCommandCallback, '', null);

        objXULContainer.appendChild(this.XULChevronElement);

        this.handleSetDetectionForChevron();
        
        return this.XULChevronElement;
    };

    this.CreateTooltipShrink = function() {
        EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID, this.XULElement);
    };
};

EBAlertSettingComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBAlertSettingComponent_CT2958529.constructor = EBAlertSettingComponent_CT2958529;

function EBAlInOneComponent_CT2958529(item) {
    EBBaseToolbarComponent_CT2958529.call(this, item);
    
    this.ComponentItem = item;
    this.XULElement = null;
    this.XULChevronElement = null;
    this.XULToolbarItemContainer = null;
    this.buttonCommandCallback = null;
    var that = this;
    var firstTime = true;
    var tryToOpen = false; isInError = false;
    var mostRecentWindow = null;
    var mAIOWindow = null;
    var mBGWindow = null;

    this.Init = function() {
        var strHint = this.ComponentItem.button.tooltip;
        var strLabel, strImage, strHint;
        if (EBActionManager_CT2958529.IsAppView())
            strImage = this.ComponentItem.appInfo.imageUrl;
        else {
            strLabel = this.ComponentItem.button.text;
            strImage = this.ComponentItem.button.image;
        }
        var that = this;
        //create the xul element
        var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
        this.buttonCommandCallback = function(e) {
            if (e.eventPhase != 2 || e.button == 2) return;
            if (!that.ComponentItem.isUntrusted &&
                EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID) &&
	                !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID)) {
                EBToolbarPreferenceManager_CT2958529.Clear(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID);
                EBPreferenceService_CT2958529.SaveAll();
            }
            if (that.ComponentItem.isUntrusted &&
	        !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID) &&
	        !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.approveUntrustedApps))
                that.unTrusttedCommandCallback();
            else {
                EBUsageAllInOne_CT2958529.OnAIOClick(that.ComponentItem.UniqueCompID, that.ComponentItem.CompType);
                setTimeout(function() { that.openAllInOneToolbar(); }, 50);
            }
        };

        this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, "", strLabel, strImage, strHint, null, "", true);
        //this.XULElement.setAttribute('type', 'checkbox');

        this.XULElement.addEventListener("mousedown", this.buttonCommandCallback, false);

        //create the tooltip element (for the shrink-unshrink tooltip)
        this.CreateTooltipShrink();
        return true;
    };

    this.appChangeToTrust = function() {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.appApproved + "." + this.ComponentItem.UniqueCompID, true);
        EBPreferenceService_CT2958529.SaveAll();
        if (isTOOpen) {
            var that = this;
            EBUsageAllInOne_CT2958529.OnAIOClick(this.ComponentItem.UniqueCompID, this.ComponentItem.CompType);
            setTimeout(function() { that.openAllInOneToolbar(); }, 50);
        }
    };

    this.AddToChevron = function(objXULContainer) {
        if (this.XULChevronElement) {
            this.XULChevronElement.removeEventListener("command", this.buttonCommandCallback, false);
            this.XULChevronElement = null;
        }
        var strImage;
        var strLabel = this.XULElement.getAttribute('label');
        var strTooltip = this.XULElement.getAttribute('tooltiptext');

        if (EBActionManager_CT2958529.IsAppView())
            strImage = this.ComponentItem.appInfo.imageUrl;
        else
            strImage = this.XULElement.getAttribute('image');


        this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuItem(strLabel, strImage, strTooltip, this.buttonCommandCallback, '', null);


        objXULContainer.appendChild(this.XULChevronElement);
        return this.XULChevronElement;
    };

    this.CreateTooltipShrink = function() {
        EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID, this.XULElement);
    };

    this.openAllInOneToolbar = function() {
        mostRecentWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        // for cancel before finish the first time
        
        if ((firstTime || isInError) && this.XULElement.checked) {
            this.rollBack();
            isInError = false;
            return;
        }
        // hide open window
        if (this.hideAIOWindows()) return;
        this.XULElement.checked = true;
        if (mostRecentWindow.EBChevronStaticManager_CT2958529.AIOWindows.Contains(this.ComponentItem.ctid)) {
            // show existing window
            this.showAIOWindow();
        }
        else {
            // open window for the first time
            this.createAIOBgWindow();
        }
    };

    this.createAIOBgWindow = function() {
        var BgName = "chevronToolbar_BG" + this.ComponentItem.ctid + EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true).gBrowser[EBGlobalConsts_CT2958529.WindowId];
        var dialog = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName("EBAIOBackgroundType_CT2958529", BgName);
        var coordinates = EBScreen_CT2958529.getCorrectedCoordinatesForFloatingWindow(this.XULToolbarItemContainer, this.XULToolbarItemContainer.boxObject.width, true);
        if (!dialog) {
            mostRecentWindow.EBChevronStaticManager_CT2958529.disableCloseAllWindows = true;
            var preParams = "chrome,dependent,resizable=no,titlebar=no,";
            var strParamsForBgWin = preParams + "width=50,height=49,left=" + coordinates.x + ",top=" + coordinates.y;
            mostRecentWindow.EBChevronStaticManager_CT2958529.disableCloseAllWindows = true;
            EBGlobalManager_CT2958529.OpenDialog("chrome://browsersearch/content/bgAIOWin.xul", BgName, strParamsForBgWin,
                [{ "ctid": this.ComponentItem.ctid, "parentComp": this}], false, function(win) { mBGWindow = win; });
        }
    };

    this.startMainAIOWindow = function(bgWin) {
        var name = "chevronToolbar_" + this.ComponentItem.ctid + EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true).gBrowser[EBGlobalConsts_CT2958529.WindowId];
        var coordinates = EBScreen_CT2958529.getCorrectedCoordinatesForFloatingWindow(this.XULToolbarItemContainer, 1270);
        var x, y = -1500;
        var preParams = "chrome,dependent,resizable=no,titlebar=no,";
        var strParamsForAIOManiWin = preParams + "width=0,height=0,left=" + x + ",top=" + y;
        EBGlobalManager_CT2958529.OpenDialog("chrome://browsersearch/content/AIOWindow.xul", name, strParamsForAIOManiWin,
            [{ "FirstIndex": 0, "ctid": this.ComponentItem.ctid, "url": this.ComponentItem.serviceUrl, "interval": 120, "parentComp": this, "bgWin": bgWin}],
            false, function(win) { mAIOWindow = win; });
        mostRecentWindow.EBChevronStaticManager_CT2958529.disableCloseAllWindows = true;
    };

    this.setWindow = function(win, bgWin) {
        if (!this.XULElement.checked) return;
        firstTime = false;
        this.XULElement.checked = true;
        bgWin.document.getElementById("loadingImage").style.display = "none";

        if (EBGlobalManager_CT2958529.IsMacintoshPlatform())
            bgWin.resizeTo(50, 8);

        var finalWidth = this.calulateWidth(win);

        if (!tryToOpen) {
            win.resizeTo(0, win.EBChevronConsts_CT2958529.floatingWindowHight);
            win.moveTo(bgWin.screenX + 10, bgWin.screenY + 8);
        }
        tryToOpen = true;
        win.focus();
        EBScreen_CT2958529.openFloatingWindow(win, finalWidth);
        
        mostRecentWindow.EBChevronStaticManager_CT2958529.disableCloseAllWindows = false;
        var source = EBChevronConsts_CT2958529.source.auto;
        win.EBToolbarManager_CT2958529.chevronManager.SetChevron(null, false, source);
    };

    this.showErrorMessage = function(win, bgWin) {
        if (!this.XULElement.checked) return;
        firstTime = false;
        this.XULElement.checked = true;
        var oldPivot = (bgWin.outerWidth + bgWin.screenX) / 2;
        bgWin.document.getElementById("loadingImage").style.display = "none";
        bgWin.document.getElementById("errMsg").style.display = "";
        bgWin.resizeBy(bgWin.document.getElementById("errMsg").boxObject.width - bgWin.outerWidth, 0);
        var newPivot = (bgWin.outerWidth + bgWin.screenX) / 2;
        bgWin.moveBy(oldPivot - newPivot, 0);
        isInError = true;
    };

    this.SetChevronComponentsCollapsed = function(componentsHash) {
        //set the toolbar components
        if (this.IndexFirstChevronComponent != -1) {
            var objToolbarComponent = null;
            for (var i = 0; i < componentsHash.Count(); i++) {
                objToolbarComponent = componentsHash.GetByIndex(i);
                objToolbarComponent.SetComponentCollapsed(false);
            }
        }
    };

    this.calulateWidth = function(win) {
        var width = 0;
        var componentsHash = win.EBToolbarManager_CT2958529.dataToolbarObject.ComponentsHash;
        this.SetChevronComponentsCollapsed(componentsHash);
        if (componentsHash.Count() != 0) {
            var gapForStart = win.EBGlobalManager_CT2958529.IsToolbarRTL() ? componentsHash.GetByIndex(0).XULElement.boxObject.width : 0;
            var gapForEnd = win.EBGlobalManager_CT2958529.IsToolbarRTL() ? 0 : componentsHash.GetByIndex(componentsHash.Count() - 1).GetToolbarItemContainer().boxObject.width;
            var startComponentLocation = componentsHash.GetByIndex(0).GetToolbarItemContainer().boxObject.x + gapForStart;
            var endComponentLocation = componentsHash.GetByIndex(componentsHash.Count() - 1).GetToolbarItemContainer().boxObject.x + gapForEnd;
            width = endComponentLocation - startComponentLocation;
            width = width + 10;
            if (win.EBGlobalManager_CT2958529.IsToolbarRTL()) width = width * -1;
            if (width > EBChevronConsts_CT2958529.floatingWindowMaxWidth) width = EBChevronConsts_CT2958529.floatingWindowMaxWidth;
        }
        return width;
    };

    this.rollBack = function() {
        this.XULElement.checked = false;
        var oDialogs = EBGlobalManager_CT2958529.GetXULWindowsByType("EBChevronToolbarType_CT2958529");
        for (var i = 0; i < oDialogs.length; i++) {
            oDialogs[i].arguments[0][0].bgWin.close();
            oDialogs[i].close();
            mostRecentWindow.EBChevronStaticManager_CT2958529.AIOWindows.Remove(this.ComponentItem.ctid);
        }
    };

    this.hideAIOWindows = function() {
        var isToExit = false;
        var oDialogs = EBGlobalManager_CT2958529.GetXULWindowsByType("EBChevronToolbarType_CT2958529");
        for (var i = 0; i < oDialogs.length; i++) {
            var oDialog = oDialogs[i];
            if (oDialog && oDialog.isAIOMode_CT2958529 && oDialog.arguments[0][0].parentComp.XULElement.checked) {
                oDialog.arguments[0][0].parentComp.XULElement.checked = false;
                mostRecentWindow.EBChevronStaticManager_CT2958529.disableCloseAllWindows = true;
                mostRecentWindow.EBChevronStaticManager_CT2958529.saveAIOWindowSize(oDialog, true);
                mostRecentWindow.EBChevronStaticManager_CT2958529.onchange(false);
                if (oDialog.arguments[0][0].ctid == this.ComponentItem.ctid)
                    isToExit = true;
            }
        }
        return isToExit;
    };


    this.showAIOWindow = function() {
        firstTime = false;
        mostRecentWindow.EBChevronStaticManager_CT2958529.disableCloseAllWindows = true;
        var winObj = mostRecentWindow.EBChevronStaticManager_CT2958529.AIOWindows.GetByID(this.ComponentItem.ctid);
        var coordinates = EBScreen_CT2958529.getCorrectedCoordinatesForFloatingWindow(this.XULToolbarItemContainer, this.XULToolbarItemContainer.boxObject.width);
        if (winObj && winObj.oWindow) {
            try {
                //window, linux
                if (!EBGlobalManager_CT2958529.IsMacintoshPlatform())
                    winObj.oWindow.resizeBy(-1270, 0);
                //Mac
                else
                    winObj.oWindow.resizeTo(0, 27)

                winObj.oWindow.moveTo(coordinates.x, coordinates.y + 8);
                winObj.oWindow.arguments[0][0].bgWin.moveTo(coordinates.x, coordinates.y);
                winObj.oWindow.arguments[0][0].parentComp = this;
                var width = this.calulateWidth(winObj.oWindow);
                EBScreen_CT2958529.openFloatingWindow(winObj.oWindow, width);

                winObj.oWindow.focus();

                mostRecentWindow.EBChevronStaticManager_CT2958529.floatingWindowsArray.push(winObj.oWindow);

                setTimeout(function() { mostRecentWindow.EBChevronStaticManager_CT2958529.disableCloseAllWindows = false; }, 10);
            }
            catch (e) {
                EBLog(e);
            }
        }
    };

    this.closeAIOWindow = function() {
        if (mBGWindow && mAIOWindow) {
            if (mostRecentWindow)
                mostRecentWindow.EBChevronStaticManager_CT2958529.AIOWindows.Remove(this.ComponentItem.ctid);

            mBGWindow.close();
            mAIOWindow.close();
            mBGWindow = null;
            mAIOWindow = null;
            firstTime = true;
            tryToOpen = false;
            this.XULElement.checked = false;
        }
    };

    this.UnloadComponent = function() {
        if (EBGlobalManager_CT2958529.IsMacintoshPlatform())
            this.closeAIOWindow();
    };
};
EBAlInOneComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBAlInOneComponent_CT2958529.constructor = EBAlInOneComponent_CT2958529; 

function EBBaseToolbarComponent_CT2958529(item) {
    if (!item) return;
    
    this.isTemporary = false;
    this.ComponentItem = item;
    this.XULElement = null;
    this.XULChevronElement = null;
    this.XULToolbarItemContainer = null;
    this.hashFunctions = null;
    this.contextMenuIdForChevronElement = null;
    this.hasMinimizedGadgets = false;
    this.unTrusttedCommandCallback = null;

    var UTAppUpdateDialogId = "UntrustedAppApprovalDialog";
    var UTApprovalDialogId = "UntrustedAppPendingDialog";


    this.Init = function() { return true; };

    this.AddToToolbar = function(objToolbarContainer, isFirst) {
        //set toolbar button class[before adding to toolbar - important!]:
        this.SetToolbarButtonClass();

        this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
        this.XULToolbarItemContainer.appendChild(this.XULElement);
        this.XULElement.hasMinimizedGadget = false;
        
        if (!isFirst || objToolbarContainer.childNodes.length == 0)
            objToolbarContainer.appendChild(this.XULToolbarItemContainer);
        else
            objToolbarContainer.insertBefore(this.XULToolbarItemContainer, objToolbarContainer.firstChild);

        this.OnLoadElement();
        this.SetChevronOnImageLoaded();

        //set the button global style[after adding to toolbar - important!]:
        EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement);
    };

    this.RemoveFromToolbar = function(objToolbarContainer) {
        try {
            if (this.XULToolbarItemContainer) {
                this.UnloadComponent();
                objToolbarContainer.removeChild(this.XULToolbarItemContainer);
                this.ComponentItem = null;
                this.XULChevronElement = null;
            }
        }
        catch (e) {
            EBLogging_CT2958529.LogToConsole(e, "cannot remove component");
        }
    };


    this._getImage = function() {
        if (!this.XULElement || !this.XULElement.getAttribute("image")) return null;
        return document.getAnonymousElementByAttribute(this.XULElement, "class", "toolbarbutton-icon");
    };

    this.SetChevronOnImageLoaded = function() {
        var oImage = this._getImage();
        if (!oImage) return;

        if (oImage.boxObject && oImage.boxObject.width) {
            EBChevronStaticManager_CT2958529.onchange(true);
        }
        else {
            oImage.onload = function() {
                EBChevronStaticManager_CT2958529.onchange(true);
            };
        }
    };

    this.OnLoadElement = function() { };
    this.UnloadComponent = function() { };
    this.OnOutOfChevron = function() { };
    this.SetComponentCollapsed = function(isCollapsed) {
        if (this.XULToolbarItemContainer)
            this.XULToolbarItemContainer.setAttribute('collapsed', isCollapsed);

        if (!isCollapsed)
            this.OnOutOfChevron();
    };

    this.IsCollapsed = function() {
        var xulElement = this.GetToolbarItemContainer();
        return xulElement.getAttribute("collapsed") == "true";
    };

    this.AddToChevron = function(objXULContainer) { };
    this.SetToolbarButtonClass = function() {
        if (!this.ComponentItem.button || this.ComponentItem.button.image)
            EBToolbarDesignManager_CT2958529.SetToolbarButtonClass(this.ComponentItem.UniqueCompID, this.XULElement);
    };
    
    this.CreateTooltipShrink = function() {
        EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID, this.XULElement);
    };

    this.UpdateUI = function(strLabel, strImage, strTooltipText, strTooltipID) {
        if (!this.XULElement) return;

        if (strLabel) {
            this.XULElement.setAttribute("label", strLabel);
            if (this.XULChevronElement) this.XULChevronElement.setAttribute("label", strLabel);
        }

        if (strImage) {
            this.XULElement.setAttribute("image", strImage);
            if (this.XULChevronElement) this.XULChevronElement.setAttribute("image", strImage);
        }

        if (strTooltipText)
            this.XULElement.setAttribute("tooltiptext", strTooltipText);

        if (strTooltipID) {
            this.XULElement.removeAttribute("tooltiptext");
            this.XULElement.setAttribute("tooltip", strTooltipID);
        }

        //recalculate chevron, maybe the size is changed
        EBChevronStaticManager_CT2958529.onchange(true);
    };

    this.OnBeforeRefresh = function() { };
    //returns true if other toolbar instances (other windows) should receive this event.
    this.RefreshComponent = function() {
        return false;
    };
    this.OnLanguagePackChange = function() { };
    this.GetToolbarItemContainer = function() {
        return this.XULToolbarItemContainer;
    };

    this.Onload = function(callback) {
        if (EBGlobalConsts_CT2958529.IsEngine) {
            //will fire on every image element on XBL
            this.XULElement.onload = function(e) {
                //TODO: move the whole thing to XBL sometime
                if (e.originalTarget.getAttribute("anonid") == "imgMain")
                    callback();
            }
        }
        else {
            var oImage = this._getImage();
            if (!oImage) callback();
            else {
                if (oImage.boxObject && oImage.boxObject.width)
                    callback();
                else {
                    var wrapper = function() {
                        callback();
                        oImage.removeEventListener("load", wrapper, false);
                    };
                    oImage.addEventListener("load", wrapper, false);
                }
            }
        }
    };

    this.WrappFunctions = function() {
        var arrFunctions = arguments;
        var wrapperFunction = function(event) {
            for (var i = 0; i < arrFunctions.length; i++) {
                if (arrFunctions[i])
                    arrFunctions[i](event);
            }
        };
        return wrapperFunction;
    };

    this.AddContextMenu = function(contextMenuId) {
        if (this.isTemporary) return;

        this.contextMenuIdForChevronElement = contextMenuId;
        if (!this.XULElement) return false;

        this.XULElement.setAttribute("eb-comp-id", this.ComponentItem.UniqueCompID);
        this.XULElement.setAttribute("context", contextMenuId);
        //For firefox prior to 3.6
        if (!EBGlobalManager_CT2958529.IsFirefox36()) {
            this.XULElement.addEventListener("contextmenu", function(event) {
                EBToolbarManager_CT2958529.contextMenuManager.contextMenuCompId = self.ComponentItem.UniqueCompID;
            }, false);
        }

        return true;
    };

    this.AddContextMenuToChevron = function() {
        if (!this.XULChevronElement) return false;
        //set this attribute in order to get the component related to the UI element
        var self = this;
        this.XULChevronElement.addEventListener("click", function(e) {
            if (e.button != 2) return;
            if (self.XULChevronElement.childNodes.length > 0) {
                for (var i = 0; i < self.XULChevronElement.childNodes.length; i++)
                    self.XULChevronElement.childNodes[i].hidePopup();
            }
            EBToolbarManager_CT2958529.contextMenuManager.contextMenuCompId = self.ComponentItem.UniqueCompID;
        }, false);

        this.XULChevronElement.setAttribute("context", this.contextMenuIdForChevronElement);
        return true;
    };

    this.OnDelete = function() { };

    this.SetDetected = function() {
        this.isTemporary = true;
        if (!this.XULToolbarItemContainer) return;

        this.XULToolbarItemContainer.style.opacity = "0.3";
        var self = this;
        this.XULToolbarItemContainer.onclick = function(e) {
            if (e.which == 1) {
                self.XULToolbarItemContainer.style.opacity = "1";
                self.isTemporary = false;
                oToolbarManager_CT2958529.saveDetectedComponent(self.ComponentItem);
                e.preventDefault();
                return false;
            }

        };

        //set detected tooltip
        this.XULElement.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey("CELP_STR_ID_ENGINE_DETECTION_COMPONENTS_TOOLTIP"));
    };

    var self = this;
    var onMouseOver = function(e) {
        EBGadgetsMinimizeManager_CT2958529.onMouseOverComponent(e, self.ComponentItem.UniqueCompID);
    };

    var onMouseOut = function(e) {
        EBGadgetsMinimizeManager_CT2958529.onMouseOutComponent(e, self.ComponentItem.UniqueCompID);
    };

    var onClick = function(e) {
        EBGadgetsMinimizeManager_CT2958529.onClick(e, self.ComponentItem.UniqueCompID);
    };

    this.InitMinimizedGadgets = function() {
        this.hasMinimizedGadgets = true;
        this.XULElement.hasMinimizedGadgets = true;
        this.XULElement.addEventListener("mouseover", onMouseOver, false);
        this.XULElement.addEventListener("mouseout", onMouseOut, false);
        this.XULElement.addEventListener("click", onClick, false);
        var position = (EBGlobalManager_CT2958529.IsToolbarRTL()) ? EBCanvas_CT2958529.positionFlags.topRight : EBCanvas_CT2958529.positionFlags.topLeft;
        var icon = (EBGlobalManager_CT2958529.IsToolbarRTL()) ? EBGadgetsMinimizeManager_CT2958529.buttonNotificationIconRTL : EBGadgetsMinimizeManager_CT2958529.buttonNotificationIcon;
        if (!EBActionManager_CT2958529.IsAppView())
            EBImageHandler_CT2958529.SetStar(this.XULElement, icon, position);
    };

    this.DisposeMinimizedGadgets = function() {
        this.hasMinimizedGadgets = false;
        this.XULElement.hasMinimizedGadgets = false;
        this.XULElement.removeEventListener("mouseover", onMouseOver, false);
        this.XULElement.removeEventListener("mouseout", onMouseOut, false);
        this.XULElement.removeEventListener("click", onClick, false);
        if (!EBActionManager_CT2958529.IsAppView())
            EBImageHandler_CT2958529.RemoveStar(this.XULElement);
    };

    this.handleSetDetectionForChevron = function() {
        if (this.isTemporary) {
            var self = this;
            this.XULChevronElement.style.opacity = "0.3";
            this.XULChevronElement.onclick = function(e) {
                if (e.which == 1) {
                    self.XULChevronElement.style.opacity = "1";
                    self.XULToolbarItemContainer.style.opacity = "1";
                    self.isTemporary = false;
                    oToolbarManager_CT2958529.saveDetectedComponent(self.ComponentItem);
                    e.preventDefault();
                    return false;
                }
            };
            //set detected tooltip
            this.XULChevronElement.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey("CELP_STR_ID_ENGINE_DETECTION_COMPONENTS_TOOLTIP"));
        }
    };

    this.appChangeToTrust = function(isToOpen) { };


    this.AddMinimizedGadget = function(elementId) { };
    this.RemoveMinimizedGadget = function(elementId) { };


    var that = this;
    var untrustedCommandFunc = function() {
        var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        var dialogName = EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID) ? UTApprovalDialogId : UTAppUpdateDialogId;
        var dialogData = oToolbarManager_CT2958529.dialogsManager.getDialogDataManager(dialogName);
        var strDialogOpenType = (EBGlobalConsts_CT2958529.IsAMO) ? "dependent," : "modal,";
        var strParams = stringFormat("{0}resizable=no,titlebar=yes,", strDialogOpenType);
        dialogData.showDialogWinBaseWithPosition(window, 0, 0, EBToolbarManager_CT2958529.chevronManager.isChevronShown(), oToolbarManager_CT2958529, strParams, that, win.EBChevronStaticManager_CT2958529);

        if (!EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID)) {
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID, false);
            EBPreferenceService_CT2958529.SaveAll();
        }
    };

    this.unTrusttedCommandCallback = this.WrappFunctions(untrustedCommandFunc);
    
};

function EBBaseBrowserComponent_CT2958529(browserItem) {
    if (!browserItem) return;
    EBBaseToolbarComponent_CT2958529.call(this, browserItem);
    
    this.ComponentItem = browserItem;
    var self = this;
    this.browserManager = null;
    this.isOnlineMode = true;
    this.XULBrowserElement = null;
    this.XULPreviewElement = null;
    this.timeoutFunc = null;
    this.focusManager = (EBGlobalManager_CT2958529.IsFirefox36()) ? Components.classes["@mozilla.org/focus-manager;1"].getService(Components.interfaces.nsIFocusManager) : null;
    var isFirstTime = true;
    this.Init = function() { };
    this.originalWidth = 0;
    
    this.networkStateObserver = new EBBrowserNetworkStateObserver_CT2958529(
	    function() { self.onConnectionStateOn(); },
	    function() { self.onConnectionStateChanged(); }
	);

    this.resizeCompWidth = function(strNewWidth) {
        if (strNewWidth > 0) {
            if (isFirstTime) {
                isFirstTime = false;
                this.originalWidth = this.XULToolbarItemContainer.boxObject.width;
            }
            this.XULElement.setAttribute('width', strNewWidth);
            this.XULToolbarItemContainer.setAttribute("width", strNewWidth);
        }
    };

    this.unResizeCompWidth = function() {
        if (this.ComponentItem && this.originalWidth > 0) {
            this.XULElement.setAttribute('width', this.originalWidth);
            this.XULToolbarItemContainer.setAttribute('width', this.originalWidth);

            return true;
        }
        return false;
    };

    this.blurCallback = function(event) {
        //event is called twice, for window and fro document, filter one of it
        if (!event.target.window) return;
        var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
        setTimeout(function() {
            //focused gone to contentWindow
            if (this.focusManager && this.focusManager.focusedWindow && this.focusManager.focusedWindow.name == self.XULBrowserElement.contentWindow.name) return;
            if (!ChevronStaticManager.focusFromBC) { ChevronStaticManager.CloseAllWindows(); }
            else { ChevronStaticManager.focusFromBC = false; }
        }, 10);
    };

	this.clickCallback = function(event) {
	    self.onBrowserCompClicked(event);
	};

	this.focusCallback = function(event) {
	    //event is called twice, for window and fro document, filter one of it
	    if (!event.target.window) return;
	    var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
	    if (ChevronStaticManager) {
	        ChevronStaticManager.SetFocusFromBC();
	    }
	};

	this.AddToToolbar = function(objToolbarContainer, isFirst) {
	    this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
	    this.XULToolbarItemContainer.appendChild(this.XULElement);

	    if (!isFirst || objToolbarContainer.childNodes.length == 0)
	        objToolbarContainer.appendChild(this.XULToolbarItemContainer);
	    else
	        objToolbarContainer.insertBefore(this.XULToolbarItemContainer, objToolbarContainer.firstChild);
	    
	    if (this.XULBrowserElement)
	        this.OnLoadElement();

	    this.SetChevronOnLoad();

	    if (!oToolbar_CT2958529.networkConnectivity.manager.isOnline) {
	        this.onConnectionStateOff();
	    }
	};

	this.OnLoadElement = function(dontSwap) {
	    //init the Internet connection observer
	    this.networkStateObserver.register();
	    if (dontSwap)
	        this.registerBrowserManager();
	    else {
	        if (isFloatingMode_CT2958529 && !isAIOMode_CT2958529 && EBGlobalManager_CT2958529.IsFirefox35())
	            this.swapDocShells(true);
	        else {
	            this.registerBrowserManager();
	        }
	    }
	    this.SetToolbarButtonClass();
	};

	this.swapDocShells = function(isOnLoad) {
	    var syncSize = function(source, destination) {
	        destination.browserManager.browserCompApi.width = source.browserManager.browserCompApi.width;
	        destination.browserManager.browserCompApi.height = source.browserManager.browserCompApi.height;
	        destination.XULBrowserElement.width = source.XULBrowserElement.width;
	        destination.XULBrowserElement.height = source.XULBrowserElement.height;
	        destination.XULBrowserElement.parentNode.width = source.XULBrowserElement.width;
	    };

	    var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
	    var oCompFromMain = win.EBComponentsManager_CT2958529.GetComponentByCompID(this.ComponentItem.UniqueCompID);

	    if (isOnLoad) {
	        this.timeoutFunc = setTimeout(function() {
	            try {
	                self.XULBrowserElement.swapDocShells(oCompFromMain.XULBrowserElement);
	            }
	            catch (e) {
	                EBLog(e, "swap doc shells");
	            }
	            self.registerBrowserManager();
	            syncSize(oCompFromMain, self);
	            self.loadBrowserCompleted();
	        }, 100);
	    }
	    else {
	        if (!this.browserManager) {
	            clearTimeout(this.timeoutFunc);
	            return;
	        }
	        
	        syncSize(this, oCompFromMain);
	        this.unregisterBrowserManager();
	        try {
	            self.XULBrowserElement.swapDocShells(oCompFromMain.XULBrowserElement);
	        }
	        catch (e) {
	            EBLog(e, "swap doc shells");
	        }
	        oCompFromMain.browserManager.attachBCAPI();
	    }
	};

	this.registerBrowserManager = function() {

	    if (!this.isOnlineMode) return;

	    this.browserManager = new EBBrowserCompProgressListener_CT2958529();
	    this.browserManager.init(this.XULBrowserElement,
                                this._isAllowUntrustedFunctions(),
                                this.ComponentItem.width,
                                this.ComponentItem.height,
                                this.ComponentItem.UniqueCompID,
                                this.ComponentItem.UniqueCompID,
                                this.ComponentItem.CompType,
                                this.ComponentItem.autoFit,
                                this.ComponentItem.visibleState);


	    if (isFloatingMode_CT2958529) {
	        this.XULBrowserElement.addEventListener("blur", function(e) { self.blurCallback(e); }, true);
	        this.XULBrowserElement.addEventListener("click", function(e) { self.clickCallback(e); }, true);
	        this.XULBrowserElement.addEventListener("focus", function(e) { self.focusCallback(e); }, true);
	    }
	    this.Onload(function() { self.loadBrowserCompleted(); });
	};

	this.loadBrowserCompleted = function() { };

    this.onBrowserCompClicked = function(event) {
    if (event.button == 2) return;
        if (event.target.tagName == "A") {
            
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            if (ChevronStaticManager)
                setTimeout(function() { ChevronStaticManager.CloseAllWindows(); }, 0);
        }
    };

    this.OnUnloadElement = function() {
        this.networkStateObserver.unregister();
        if (isFloatingMode_CT2958529) {
            if (EBGlobalManager_CT2958529.IsFirefox35() && this.stateIsOpened && !isAIOMode_CT2958529)
                this.swapDocShells(false);
            else
                this.unregisterBrowserManager();

            this.XULBrowserElement.removeEventListener("blur", function(e) { self.blurCallback(e); }, true);
            this.XULBrowserElement.removeEventListener("click", function(e) { self.clickCallback(e); }, true);
            this.XULBrowserElement.removeEventListener("focus", function(e) { self.focusCallback(e); }, true);
        }
        else {
            this.unregisterBrowserManager();
        }
    };

    this.unregisterBrowserManager = function() {
        if (this.browserManager) {
            this.browserManager.unload();
        }

        this.browserManager = null;
    };

    this.UnloadComponent = function() {
        this.OnUnloadElement();
    };

    this.SetToolbarButtonClass = function() {
        if (EBGlobalManager_CT2958529.IsMacintoshPlatform() && EBGlobalManager_CT2958529.IsFirefox35()) {
            this.XULElement.style.marginTop = "1px";
            this.XULElement.style.marginBottom = "1px";
        }
    };

    this.AddToChevron = function(objXULContainer) {
        this.XULChevronElement = null;
        var strLabel = this.ComponentItem.DisplayText;
        if (EBActionManager_CT2958529.IsAppView()) {
            var strImage = this.ComponentItem.appInfo.imageUrl;
            if(!strImage)
                strImage = this.ComponentItem.compThumbnailUrl;
        }
        else
            var strImage = this.ComponentItem.DisplayIcon;
            
        this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuItem(strLabel, strImage);
        objXULContainer.appendChild(this.XULChevronElement);

        if (this.isTemporary) {
            this.XULChevronElement.onclick = function(e) {
                if (e.which == 1) {
                    self.XULChevronElement.style.opacity = "1";
                    var xulBrowser = self.XULElement;
                    var docJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(xulBrowser.contentWindow);
                    docJS.document.body.style.opacity = "1";
                    self.isTemporary = false;
                    self.XULChevronElement.setAttribute('disabled', 'true');
                    oToolbarManager_CT2958529.saveDetectedComponent(self.ComponentItem);
                    e.preventDefault();
                    return false;
                }
            };

            //set detected tooltip
            this.XULChevronElement.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey("CELP_STR_ID_ENGINE_DETECTION_COMPONENTS_TOOLTIP"));
        }
        else
            this.XULChevronElement.setAttribute('disabled', 'true');

        return this.XULChevronElement;
    };

    this._isAllowUntrustedFunctions = function() {
        //if user component, always allow.
        if (this.ComponentItem.CompType == EBComponentsConsts_CT2958529.ComponentsType.UserAdded)
            return true;
        else
            return EBGlobalConsts_CT2958529.IsEngine ? oToolbarManager_CT2958529.data.settings.truste.allowNonPrivacyFunction : oToolbarManager_CT2958529.data.generalToolbarInfo.allowNonPrivacyFunctions;
    };

    this.Onload = function(callback) { };

    this.SetChevronOnLoad = function() {
        var callback = function() {
            EBChevronStaticManager_CT2958529.onchange(true);
        };

        if (this.browserManager)
            this.browserManager.addOnloadFireOnceCallback(callback);
        else
            callback();
    };

    this.openWithCache = function() {
        this.XULElement.webNavigation.loadURI(this.ComponentItem.url, Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
    };

    this.RefreshComponent = function() {
        var nsIWebNavigation = Components.interfaces.nsIWebNavigation;
        var strUrl = EBActionManager_CT2958529.ConvertAliasesUrl(this.ComponentItem.url);
        strUrl = EBUrl_CT2958529.Randomize(strUrl);
        this.XULElement.webNavigation.loadURI(strUrl, nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
        return true;
    };

    this.validateSize = function() {
        //auto-fit will take maximum toolbar height
        var toolbarHeight = EBUILogic_Toolbar_CT2958529.getHeight();
        if (this.ComponentItem.autoFit.height)
            this.ComponentItem.height = toolbarHeight;
        //prevent html component height bigger then toolbar.
        else if (this.ComponentItem.height > toolbarHeight)
            this.ComponentItem.height = toolbarHeight;
        else if (this.ComponentItem.height < 20)
            this.ComponentItem.height = 20;
    };

    this.onConnectionStateOff = function() {
        if (!this.isOnlineMode) return;

        this.isOnlineMode = false;
        this.unregisterBrowserManager();
        this.XULToolbarItemContainer.removeChild(this.XULElement);
        this.XULElement = this.XULPreviewElement;
        this.XULToolbarItemContainer.appendChild(this.XULElement);
    };

    this.onConnectionStateOn = function() {
        if (this.isOnlineMode) return;

        this.isOnlineMode = true;
        setTimeout(function() {
            self.XULToolbarItemContainer.removeChild(self.XULElement);
            self.XULElement = self.XULBrowserElement;
            self.XULToolbarItemContainer.appendChild(self.XULElement);
            self.registerBrowserManager();
            var nsIWebNavigation = Components.interfaces.nsIWebNavigation;
            var strUrl = EBActionManager_CT2958529.ConvertAliasesUrl(self.ComponentItem.url);
            self.XULBrowserElement.webNavigation.loadURI(strUrl, nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
        }, 10000);
    };

    this.onConnectionStateChanged = function() {
        if (this.isOnlineMode) return;

        this.onConnectionStateOn();
    };

    this.SetDetected = function() { };

    this.onToolbarHide = function() { };

    this.onToolbarShow = function() { };

    this.AddContextMenu = function(contextMenuId) {
        if (this.isTemporary) return;

        this.contextMenuIdForChevronElement = contextMenuId;
        if (!this.XULElement) return false;

        this.XULElement.setAttribute("eb-comp-id", this.ComponentItem.UniqueCompID);
        this.XULElement.setAttribute("context", contextMenuId);

        var self = this;
        if (!EBGlobalManager_CT2958529.IsFirefox36()) {
            this.XULElement.addEventListener("contextmenu", function(event) {
                EBToolbarManager_CT2958529.contextMenuManager.contextMenuCompId = self.ComponentItem.UniqueCompID;
                event.cancelBubble = true;
            }, false);
        }
        else {
            this.XULElement.addEventListener("click", function(e) {
                if (e.button != 2) return;
                EBToolbarManager_CT2958529.contextMenuManager.contextMenuCompId = self.ComponentItem.UniqueCompID;
            }, false);
        }

        return true;
    };
};

EBBaseBrowserComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBBaseBrowserComponent_CT2958529.constructor = EBBaseBrowserComponent_CT2958529;

function EBEngineBrowserComponent_CT2958529(browserItem) {
    EBBaseBrowserComponent_CT2958529.call(this, browserItem);

    this.XULButton = null;
    this.XULCloseButton = null;
    this.XULLoadingBox = null;
    this.XULBrowserBox = null;
    var self = this;
    var isFloatingModeOnOpen = false;
    var alwaysOpen = false;
    var mShowStateChanged = false;
    this.originalWidth = 0;
    var isFirstTime = true;
    var deltaOpenClose = 50;
    this.compCanBeShownPartial = false;

    this.Init = function() {
        //replace the aliases for the browser component
        this.ComponentItem.url = EBActionManager_CT2958529.ConvertAliasesUrl(this.ComponentItem.url);
        this.ComponentItem.previewImageUrl = EBActionManager_CT2958529.ConvertAliasesUrl(this.ComponentItem.previewImageUrl);
        this.validateSize();

        if (this.ComponentItem.visibleState == 'ALWAYS_OPEN') {
            this.stateIsOpened = true;
            alwaysOpen = true;
        }

        if (this.ComponentItem.visibleState == 'START_OPEN' && this.stateIsOpened == undefined)
            this.stateIsOpened = true;
        var isUntrusted = (EBGlobalConsts_CT2958529.IsEngine && this.ComponentItem.isUntrusted &&
	        !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.appApproved + "." + this.ComponentItem.UniqueCompID) &&
	        !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.approveUntrustedApps)) ? true : false;


        if (this.stateIsOpened && !isUntrusted) {
            this.loadBrowser(false, false, false);
        }
        else {
            var strLabel = "";
            var strImage = this.ComponentItem.appInfo.imageUrl;
            var strHint = this.ComponentItem.DisplayText;
            var strBackupImage = this.ComponentItem.compThumbnailUrl;

            var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
            var objCommand = function(event) {
                isUntrusted = (EBGlobalConsts_CT2958529.IsEngine && self.ComponentItem.isUntrusted &&
	        !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.appApproved + "." + self.ComponentItem.UniqueCompID) &&
	        !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.approveUntrustedApps)) ? true : false;
                if (isUntrusted) {
                    self.unTrusttedCommandCallback();
                }
                else {
                    self.loadBrowser(true, true, false);
                }
            };
            this.XULButton = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, "", strLabel, strImage, strHint, objCommand, "", EBActionManager_CT2958529.IsAppView(), strBackupImage);
            this.XULElement = this.XULButton;
        }

        return true;
    };

    this.appChangeToTrust = function(isToOpen) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.appApproved + "." + this.ComponentItem.UniqueCompID, true);
        EBPreferenceService_CT2958529.SaveAll();
        if (isToOpen) this.XULElement.click();

    };

    this.loadBrowser = function(openSlowly, removeButton, fromComponentInChevron) {
        if (isFloatingMode_CT2958529)
            isFloatingModeOnOpen = true;
        else
            isFloatingModeOnOpen = false;

        this.XULBrowserBox = EBXULFactory_CT2958529.CreateHBox("", "", "center");
        this.XULBrowserBox.setAttribute('width', 0);
        //close button
        var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
        if (!alwaysOpen) {
            var objCommand = function(event) { self.returnTo24pxButton(event); };
            var closeButtonImg = (EBGlobalManager_CT2958529.IsToolbarRTL()) ? "chrome://browsersearch/skin/appView/MinimizeButton_RTL.png" : "chrome://browsersearch/skin/appView/MinimizeButton.png";
            this.XULCloseButton = EBXULFactory_CT2958529.CreateImage(closeButtonImg, 10, 24, false);
            this.XULCloseButton.setAttribute('class', 'ebBrowserComponent24pxClose');
            this.XULCloseButton.onclick = objCommand;

        }

        //loading image
        this.XULLoadingBox = EBXULFactory_CT2958529.CreateHBox("", "", "center");
        this.XULLoadingBox.setAttribute('boxWidth', this.ComponentItem.width);
        this.XULLoadingBox.setAttribute('class', 'browserLoader24px');
        if (removeButton)
            this.XULToolbarItemContainer.removeChild(this.XULButton);


        if (EBGlobalManager_CT2958529.IsToolbarRTL())
            this.XULLoadingBox.setAttribute('style', 'margin-left: 0px;');
        this.XULBrowserBox.appendChild(this.XULLoadingBox);
        if (!alwaysOpen)
            this.XULBrowserBox.appendChild(this.XULCloseButton);
        if (this.XULToolbarItemContainer)
            this.XULToolbarItemContainer.appendChild(this.XULBrowserBox);

        var currentWidth, deltaSize;
        var openLoader = function(width) {
            currentWidth = self.XULLoadingBox.boxObject.width;
            //stop condition of this recursion
            if (width >= self.browserWidth) {
                deltaSize = self.browserWidth - width + 9;

                if (!fromComponentInChevron && self.XULToolbarItemContainer && !isFloatingMode_CT2958529)
                    EBToolbarManager_CT2958529.stripSizeManager.onForceResize(deltaSize);

                self.XULLoadingBox.setAttribute('width', self.browserWidth + "px");
                if (self.XULToolbarItemContainer) {
                    self.XULLoadingBox.displayLoadingImage();
                    EBChevronStaticManager_CT2958529.onchange(false);
                }

                self.initXULElement();
                self.stateIsOpened = true;
                return;
            }

            if (!isFloatingMode_CT2958529 && !fromComponentInChevron && self.XULToolbarItemContainer) {
                deltaSize = width - currentWidth;
                EBToolbarManager_CT2958529.stripSizeManager.onForceResize(deltaSize);
                EBGlobalPreferenceManager_CT2958529.SetPref("permanenceEngine", false);
            }

            self.XULLoadingBox.setAttribute('width', width + "px");
            setTimeout(function() { openLoader(width + deltaOpenClose); }, 10);
        };

        if (!openSlowly)
            openLoader(this.browserWidth);
        else {
            self.XULLoadingBox.setAttribute('width', "14px");
            openLoader(14);
            if (isFloatingMode_CT2958529)
                EBToolbarManager_CT2958529.stripSizeManager.onForceResize(this.browserWidth - 30);
        }

    };

    this.loadBrowserCompleted = function() {
        if (this.XULLoadingBox.parentNode == this.XULBrowserBox)
            this.XULBrowserBox.removeChild(this.XULLoadingBox);
        this.XULBrowserElement.style.visibility = '';
        this.XULBrowserElement.parentNode.width = this.browserWidth;
        this.XULBrowserBox.setAttribute('style', '-moz-margin-start: 3px;');
        if (alwaysOpen)
            this.XULBrowserBox.setAttribute('style', 'margin-right:11px;');
        EBChevronStaticManager_CT2958529.onchange(false);

    };

    this.initXULElement = function() {
        //create the XUL element
        var strUrl = (isFloatingMode_CT2958529 && !isAIOMode_CT2958529 && EBGlobalManager_CT2958529.IsFirefox35() && !isFloatingModeOnOpen) ? "" : this.ComponentItem.url;

        //don't load browsers when engine is hidden
        if (strUrl && !EBActionManager_CT2958529.IsToolbarShown()) strUrl = "";
        
        var strWidth = this.ComponentItem.width;
        var browserWrapper = EBXULFactory_CT2958529.CreateHBox('', 'height:28px');
        this.XULBrowserElement = EBXULFactory_CT2958529.CreateBrowser(this.ComponentItem.UniqueCompID,
															strUrl,
															strWidth,
															this.ComponentItem.height);



        this.XULPreviewElement = EBXULFactory_CT2958529.CreateHBox("", "", "center");
        this.XULPreviewElement.setAttribute('style', 'margin-left:2px; margin-right:2px; ');
        var previewImage = EBXULFactory_CT2958529.CreateImage(this.ComponentItem.previewImageUrl, null, null, true);
        this.XULPreviewElement.appendChild(previewImage);
        this.XULPreviewElement.setAttribute('tooltiptext', oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_BROWSER_COMPONENT_NAVIGATION_ERROR'));
        this.XULBrowserBox.setAttribute('style', 'height:28px');
        this.XULBrowserBox.removeChild(this.XULLoadingBox);
        if (!alwaysOpen)
            this.XULBrowserBox.removeChild(this.XULCloseButton);

        browserWrapper.appendChild(this.XULBrowserElement);

        this.XULBrowserBox.appendChild(browserWrapper);
        this.XULBrowserElement.style.visibility = 'hidden';

        this.XULBrowserBox.appendChild(this.XULLoadingBox);
        this.XULLoadingBox.setAttribute('style', 'margin-left: -' + this.ComponentItem.width + 'px ');

        if (!alwaysOpen)
            this.XULBrowserBox.appendChild(this.XULCloseButton);

        this.XULElement = this.XULBrowserBox;

        if (this.XULToolbarItemContainer) {
            this.XULLoadingBox.displayLoadingImage();
            if (isFloatingMode_CT2958529) {
                var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
                var oCompFromMain = win.EBComponentsManager_CT2958529.GetComponentByCompID(this.ComponentItem.UniqueCompID);
                oCompFromMain.loadBrowser(false, true, true);
            }

            this.OnLoadElement(isFloatingModeOnOpen);
        }
    };

    this.__defineGetter__("browserWidth", function() {
        return this.ComponentItem.width;
    });

    this.__defineSetter__("browserWidth", function(val) {
        this.ComponentItem.width =  val ;
    });

    this.__defineGetter__("stateIsOpened", function() {
        return EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.BrowserCompStateIsOpen + this.ComponentItem.UniqueCompID);
    });

    this.__defineSetter__("stateIsOpened", function(val) {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.BrowserCompStateIsOpen + this.ComponentItem.UniqueCompID, val);
    });

    this.returnTo24pxButton = function(event, fromComponentInChevron) {
        var currentWidth;
        var closeLoader = function(width, deltaSize) {
            //exit condition of this recursion
            if (width <= 32) {
                self.stateIsOpened = false;
                self.XULToolbarItemContainer.removeChild(self.XULLoadingBox);
                if (!self.XULButton)
                    self.Init();
                else
                    self.XULElement = self.XULButton;

                self.XULToolbarItemContainer.appendChild(self.XULElement);

                if (!fromComponentInChevron) {
                    if (isFloatingMode_CT2958529)
                        EBToolbarManager_CT2958529.stripSizeManager.onForceResize(30 - self.browserWidth);
                    else {
                        EBToolbarManager_CT2958529.stripSizeManager.onForceResize(17 - width);
                    }

                    //EBChevronStaticManager_CT2958529.onchange(false);
                }
                if (!fromComponentInChevron)
                    EBToolbarManager_CT2958529.stripSizeManager.resizeEngineToContent(true);
                
                return;
            }

            self.XULLoadingBox.setAttribute("width", width + "px");

            if (!isFloatingMode_CT2958529 && !fromComponentInChevron) {
                //var deltaSize = width - currentWidth;
                EBToolbarManager_CT2958529.stripSizeManager.onForceResize(deltaSize);
                EBGlobalPreferenceManager_CT2958529.SetPref("permanenceEngine", false);
            }

            currentWidth = self.XULLoadingBox.boxObject.width;
            setTimeout(function() { closeLoader(width - deltaOpenClose, -deltaOpenClose); }, 10);
        };

        if (!fromComponentInChevron)
            this.unregisterBrowserManager();

        this.XULLoadingBox.setAttribute("width", parseInt(this.browserWidth + 10) + "px");
        currentWidth = self.XULToolbarItemContainer.boxObject.width;
        this.XULToolbarItemContainer.removeChild(this.XULBrowserBox);
        this.XULLoadingBox.style.marginLeft = "0px";
        this.XULLoadingBox.style.marginRight = "12px";
        this.XULToolbarItemContainer.appendChild(this.XULLoadingBox);

        if (!fromComponentInChevron)
            EBChevronStaticManager_CT2958529.onchange(false);
        closeLoader(this.browserWidth + 10, self.XULToolbarItemContainer.boxObject.width - currentWidth);

        if (isFloatingMode_CT2958529 && !isAIOMode_CT2958529) {
            var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
            var oCompFromMain = win.EBComponentsManager_CT2958529.GetComponentByCompID(this.ComponentItem.UniqueCompID);
            oCompFromMain.returnTo24pxButton(event, true);
            mShowStateChanged = !mShowStateChanged;
        }
    };

    this.OnUnloadElement = function() {
        if (this.stateIsOpened) {
            this.networkStateObserver.unregister();
            if (isFloatingMode_CT2958529 && !isAIOMode_CT2958529) {
                if (EBGlobalManager_CT2958529.IsFirefox35())
                    this.swapDocShells(false);
                else
                    this.unregisterBrowserManager();
                
                this.XULBrowserElement.removeEventListener("blur", function(e) { self.blurCallback(e); }, true);
                this.XULBrowserElement.removeEventListener("click", function(e) { self.clickCallback(e); }, true);
                this.XULBrowserElement.removeEventListener("focus", function(e) { self.focusCallback(e); }, true);
                if (mShowStateChanged) {
                    var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
                    win.EBChevronStaticManager_CT2958529.onchange(false);
                }

            }
            else {
                this.unregisterBrowserManager();
            }
        }
    };

    this.Onload = function(callback) {
        if (this.browserManager)
            this.browserManager.addOnloadFireOnceCallback(callback);
        else {
            this.XULElement.onload = function(e) {
                //TODO: move the whole thing to XBL sometime
                if (e.originalTarget.getAttribute("anonid") == "imgMain") {
                    callback();
                    self.XULElement.onload = null;
                }
            }
        }
    };

    this.SetDetected = function() {
        this.isTemporary = true;
        if (!this.XULToolbarItemContainer) return;

        //opened
        if (this.browserManager) {
            var setDetectedStyle = function() {
                var xulBrowser = self.XULElement;
                var docJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(xulBrowser.contentWindow);
                docJS.document.body.style.opacity = "0.3";
            };

            this.Onload(setDetectedStyle);
        }
        else
            this.XULToolbarItemContainer.style.opacity = "0.3";

        this.XULToolbarItemContainer.onclick = function(e) {
            if (e.which == 1) {
                var xulBrowser = self.XULElement;
                if (self.browserManager) {
                    var docJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(xulBrowser.contentWindow);
                    if (docJS) {
                        docJS.document.body.style.opacity = "1";
                        self.isTemporary = false;
                    }
                }
                else
                    self.XULToolbarItemContainer.style.opacity = "1";
                
                oToolbarManager_CT2958529.saveDetectedComponent(self.ComponentItem);
                return false;
            }
        };
        //set detected tooltip
        this.XULElement.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey("CELP_STR_ID_ENGINE_DETECTION_COMPONENTS_TOOLTIP"));
    };

    this.resizeCompWidth = function(strNewWidth) {
        return;
//        if (!this.XULBrowserElement || this.XULBrowserElement && this.XULBrowserElement.width == strNewWidth && this.XULBrowserElement.parentNode.width == strNewWidth)
//            return;

//        if (strNewWidth > 0) {
//            if (isFirstTime) {
//                isFirstTime = false;
//                this.originalWidth = this.XULToolbarItemContainer.boxObject.width - 10; //10px for minimize button
//            }
//            if (this.originalWidth > 0 && strNewWidth > this.originalWidth) strNewWidth = this.originalWidth;
//            if (strNewWidth == this.originalWidth) {
//                this.unResizeCompWidth();
//                return;
//            }

//            this.XULBrowserElement.width = strNewWidth;
//            this.XULBrowserElement.parentNode.width = strNewWidth;
//            setTimeout(function() { EBChevronStaticManager_CT2958529.onchange(false); }, 10);
//        }
    };

    this.SetComponentCollapsed = function(isCollapsed) {
        if (this.XULToolbarItemContainer)
            this.XULToolbarItemContainer.setAttribute('collapsed', isCollapsed);

        if (!isCollapsed)
            this.OnOutOfChevron();
    };

    this.unResizeCompWidth = function() {
//        if (!this.XULBrowserElement) return false;
//        
//        if (this.ComponentItem && this.originalWidth > 0) {
//            this.XULBrowserElement.setAttribute('width', this.originalWidth);
//            this.XULBrowserElement.parentNode.setAttribute('width', this.originalWidth);
//            setTimeout(function() { EBChevronStaticManager_CT2958529.onchange(false); }, 10);
//            return true;
//        }
        return false;
    };
    
    this.onToolbarHide = function() {
        if (this.stateIsOpened)
            this.XULBrowserElement.webNavigation.loadURI("about:blank", nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
    };

    this.onToolbarShow = function() {
        return;
        if (this.stateIsOpened)
            this.XULBrowserElement.webNavigation.loadURI(this.ComponentItem.url, nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
    };
};

EBEngineBrowserComponent_CT2958529.prototype = new EBBaseBrowserComponent_CT2958529();
EBEngineBrowserComponent_CT2958529.constructor = EBEngineBrowserComponent_CT2958529;

function EBToolbarBrowserComponent_CT2958529(browserItem) {
    EBBaseBrowserComponent_CT2958529.call(this, browserItem);

    this.stateIsOpened = true;

    this.Init = function() {
        //replace the aliases for the browser component
        this.ComponentItem.url = EBActionManager_CT2958529.ConvertAliasesUrl(this.ComponentItem.url);
        this.ComponentItem.previewImageUrl = EBActionManager_CT2958529.ConvertAliasesUrl(this.ComponentItem.previewImageUrl);
        this.validateSize();
        this.initXULElement();

        return true;
    };

    this.initXULElement = function() {
        //create the XUL element
        var strUrl = (isFloatingMode_CT2958529 && !isAIOMode_CT2958529 && EBGlobalManager_CT2958529.IsFirefox35()) ? "" : this.ComponentItem.url;
        var strWidth = (isFloatingMode_CT2958529 && !isAIOMode_CT2958529 && EBGlobalManager_CT2958529.IsFirefox35()) ? 0 : this.ComponentItem.width;
        this.XULBrowserElement = EBXULFactory_CT2958529.CreateBrowser(this.ComponentItem.UniqueCompID, strUrl, strWidth, this.ComponentItem.height);
        this.XULPreviewElement = EBXULFactory_CT2958529.CreateHBox("", "", "center");
        this.XULPreviewElement.setAttribute('style', 'margin-left:2px; margin-right:2px;');
        var previewImage = EBXULFactory_CT2958529.CreateImage(this.ComponentItem.previewImageUrl, null, null, true);
        this.XULPreviewElement.appendChild(previewImage);
        this.XULPreviewElement.setAttribute('tooltiptext', oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_BROWSER_COMPONENT_NAVIGATION_ERROR'));
        this.XULElement = this.XULBrowserElement;
    };

    this.Onload = function(callback) {
        this.browserManager.addOnloadFireOnceCallback(callback);
    };

    this.SetDetected = function() {
        this.isTemporary = true;
        if (!this.XULToolbarItemContainer) return;

        var setDetectedStyle = function() {
            var xulBrowser = self.XULElement;
            var docJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(xulBrowser.contentWindow);
            docJS.document.body.style.opacity = "0.3";
        };

        this.Onload(setDetectedStyle);

        this.XULToolbarItemContainer.onclick = function(e) {
            if (e.which == 1) {
                var xulBrowser = self.XULElement;
                var docJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(xulBrowser.contentWindow);
                docJS.document.body.style.opacity = "1";
                self.isTemporary = false;
                oToolbarManager_CT2958529.saveDetectedComponent(self.ComponentItem);
                return false;
            }
        };

        //set detected tooltip
        this.XULElement.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey("CELP_STR_ID_ENGINE_DETECTION_COMPONENTS_TOOLTIP"));
    };

    this.onToolbarHide = function() {
        this.XULElement.webNavigation.loadURI("about:blank", nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
    };

    this.onToolbarShow = function() {
        this.XULElement.webNavigation.loadURI(this.ComponentItem.url, nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
    };
};

EBToolbarBrowserComponent_CT2958529.prototype = new EBBaseBrowserComponent_CT2958529();
EBToolbarBrowserComponent_CT2958529.constructor = EBToolbarBrowserComponent_CT2958529;
function EBButtonComponent_CT2958529(buttonItem)
{
    EBBaseToolbarComponent_CT2958529.call(this, buttonItem);
    
	this.ComponentItem				= buttonItem;
	this.XULElement					= null;
	this.XULChevronElement			= null;
	this.XULToolbarItemContainer = null;
	this.buttonCommandCallback = null;
	this.popHtmlData = null;





	this.Init = function() {
	    this.ComponentItem.button.image = EBDefaultsManager_CT2958529.getImageUrl(this.ComponentItem.button.image);

	    //create usage function
	    var that = this;
	    var usageFunc = function() {
	        EBUsageButton_CT2958529.OnButtonClick(that.ComponentItem.UniqueCompID, that.ComponentItem.CompType);
	    };
	    var commandFunc = null;

	    var isDeletable = (this.ComponentItem.CompType == EBComponentsConsts_CT2958529.ComponentsType.UserAdded);

	    switch (this.ComponentItem.button.type) {
	        case "LINK":
	            var strTarget = this.ComponentItem.button.data.target;
	            if (strTarget != "NEW" && strTarget != "TAB") strTarget = "SELF";

	            commandFunc = function(event) {
	                event.customData = {
	                    "compId": that.ComponentItem.UniqueCompID,
	                    "url": that.ComponentItem.button.data.link,
	                    "urlTarget": strTarget,
	                    "isUser": isDeletable,
	                    "parentId": that.ComponentItem.UniqueCompID,
	                    "strAncestorId": that.ComponentItem.UniqueCompID,
	                    "compType": that.ComponentItem.CompType,
	                    "source": EBUsageGadget_CT2958529.SourceButton
	                };

	                EBLinkManager_CT2958529.LoadLinkURL(event);
	            };

	            break;
	        case "COMMAND":
	            //check if this command is supported by Firefox :-)
	            if (!EBSpecialCommands_CT2958529.IsSupportedCommand(this.ComponentItem.button.data.command))
	                return false;

	            commandFunc = function(event) {
	                EBSpecialCommands_CT2958529.ActivateSpecialCommand(event, that.ComponentItem.button.data.command);
	            };

	            break;
	        case "POP_HTML":
	            var popHtmlData = this.ComponentItem.button.data;
	            popHtmlData.isUser = isDeletable;
	            popHtmlData.componentId = this.ComponentItem.UniqueCompID;
	            popHtmlData.elementId = this.ComponentItem.UniqueCompID;
	            popHtmlData.title = this.ComponentItem.button.text;
	            popHtmlData.compType = this.ComponentItem.CompType;
	            popHtmlData.source = EBUsageGadget_CT2958529.SourceButton;
	            popHtmlData.titleIconUrl = this.ComponentItem.button.image;

	            if (!that.ComponentItem.isUntrusted && EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID) &&
	                !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID)) {
	                EBToolbarPreferenceManager_CT2958529.Clear(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID);
	                EBPreferenceService_CT2958529.SaveAll();
	            }

	            commandFunc = function(event) {
	                if (EBGlobalConsts_CT2958529.IsEngine && that.ComponentItem.isUntrusted &&
	                        !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID) &&
	                        !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.approveUntrustedApps)) {
	                    popHtmlData.parentElement = event.target;
	                    that.popHtmlData = popHtmlData;
	                    that.unTrusttedCommandCallback();
	                }
	                else {
	                    popHtmlData.parentElement = event.target;
	                    EBGadgetManager_CT2958529.OpenGadget(popHtmlData);
	                }
	            };
	            //don't send usage of button click when opening gadget
	            usageFunc = null;
	            break;
	        case "APPLICATION":
	            var data = this.ComponentItem.button.data;
	            commandFunc = function(event) {
	                EBComponentsManager_CT2958529.ExecuteApplication(data.exeAlias, data.params, data.link, event);
	            };
	    }
	    var strHint = this.ComponentItem.button.tooltip;
	    var strLabel, strImage, strBackupImage;
	    if (EBActionManager_CT2958529.IsAppView()) {
	        strImage = this.ComponentItem.appInfo.imageUrl;
	        strBackupImage = this.ComponentItem.compThumbnailUrl;
	    }
	    else {
	        strLabel = this.ComponentItem.button.text;
	        strImage = this.ComponentItem.button.image;
	    }
	    var that = this;

	    this.buttonCommandCallback = this.WrappFunctions(commandFunc, usageFunc);

	    //create the xul element
	    var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
	    this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, "", strLabel, strImage, strHint, this.buttonCommandCallback, "", EBActionManager_CT2958529.IsAppView(), strBackupImage);

	    //create the tooltip element (for the shrink-unshrink tooltip)
	    this.CreateTooltipShrink();
	    return true;
	};

	this.appChangeToTrust = function(ifToOpen) {
	    EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.appApproved + "." + this.ComponentItem.UniqueCompID, true);
	    EBPreferenceService_CT2958529.SaveAll();
	    if (ifToOpen) this.XULElement.click();
	};


	this.openAppByDemand = function() {
	    this.XULElement.click();
	};

	this.AddToChevron = function(objXULContainer) {
	    if (this.XULChevronElement) {
	        this.XULChevronElement.removeEventListener("command", this.buttonCommandCallback, false);
	        this.XULChevronElement = null;
	    }
	    var strTooltip = this.ComponentItem.button.tooltip;
	    var strImage;
	    var strLabel = this.ComponentItem.button.text;
	    if (EBActionManager_CT2958529.IsAppView())
	        var strImage = this.XULElement.selectedImage;
	    else
	        strImage = this.ComponentItem.button.image;


	    this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuItem(strLabel, strImage, strTooltip, this.buttonCommandCallback, "", null);
	    objXULContainer.appendChild(this.XULChevronElement);

	    this.handleSetDetectionForChevron();

	    return this.XULChevronElement;
	};
	
	this.CreateTooltipShrink = function()
	{
		EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID,this.XULElement);
	};
};

EBButtonComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBButtonComponent_CT2958529.constructor = EBButtonComponent_CT2958529




//*********************** Chat Component ************************
function EBChatComponent_CT2958529(chatItem) {
    EBBaseToolbarComponent_CT2958529.call(this, chatItem);
    
    this.ComponentItem = chatItem;
    this.XULElement = null;
    this.XULChevronElement = null;
    this.XULToolbarItemContainer = null;
    this.totalParticipantsCount = 0;
    this.menuUIManager = new ChatMenuUIManager_CT2958529(this);
    var observer = null;
    this.isInChevron = false;

    //pointer to the chat manager XPCOM
    this.chatManager = oToolbar_CT2958529.chat.getChatManager(EBGlobalConsts_CT2958529.ToolbarCTID);

    this.Init = function() {
        return true;
    };

    this._initChatCore = function() {
        this.chatManager.init(EBGlobalConsts_CT2958529.ToolbarCTID,
                                EBActionManager_CT2958529.GetCTID(),
                                this.ComponentItem.serviceUrl,
                                this.ComponentItem.serviceIntervalMM);
    };

    this._initUI = function() {
        var strId = "EBChatButton_CT2958529" + this.ComponentItem.UniqueCompID;
        var strType = "menu-button";
        var strCaption = this.ComponentItem.button.text;
        var strImage = this.ComponentItem.button.image;
        var strTooltip = this.ComponentItem.button.tooltip;
        var strCommand = "";
        var iTotalCount = this.chatManager.getAllProvidersParticipantsCount();

        //ebchattoolbarbutton is an xbl element, which is like toolbarbutton, but adds participants count images
        this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strId, strType, strCaption, strImage, strTooltip, strCommand, "");
        this.XULElement.setAttribute("class", "ebChatMenuButton_CT2958529");
        this.XULElement.setAttribute("number", iTotalCount);

        //init button menu
        this.menuUIManager.init(this.chatManager, this.XULElement, this.ComponentItem.UniqueCompID, this.ComponentItem.CompType, this.ComponentItem.defaultRoom, this);
    };

    this._registerObserver = function() {
        observer = new EBChatObserver_CT2958529(this.onParticipantsChange, this);
        observer.register();
    };

    this.onToolbarRefresh = function(bInvalidateCache) {
        this.chatManager.onToolbarRefresh(bInvalidateCache);
    };

    this.reInit = function(bInvalidateCache) {
        this.chatManager.reInit(bInvalidateCache);
    };

    this.onParticipantsChange = function(aSubject) {
        var iTotalCount = this.chatManager.getAllProvidersParticipantsCount();
        if (!this.isInChevron)
            this.XULElement.number = iTotalCount.toString();
        else
            EBUILogic_Functions_CT2958529.setAcceltext(this.XULChevronElement, this.menuUIManager._getMenuItemParticipantsCaption(iTotalCount));
    };

    this.AddToToolbar = function(objToolbarContainer, isFirst) {
        this._initChatCore();
        this._initUI();
        
        //set toolbar button class[before adding to toolbar - important!]:
        this.SetToolbarButtonClass();

        this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
        this.XULToolbarItemContainer.appendChild(this.XULElement);
        
        if (!isFirst || objToolbarContainer.childNodes.length == 0)
            objToolbarContainer.appendChild(this.XULToolbarItemContainer);
        else
            objToolbarContainer.insertBefore(this.XULToolbarItemContainer, objToolbarContainer.firstChild);

        this.OnLoadElement();
        this.SetChevronOnImageLoaded();

        //set the button global style[after adding to toolbar - important!]:
        EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement);
    };
    
    this._shutdownChatCore = function() {
        if (this.chatManager)
            this.chatManager.shutdown(EBGlobalConsts_CT2958529.ToolbarCTID, EBActionManager_CT2958529.GetCTID());
    };

    this._unregisterObserver = function() {
        if (observer) observer.unregister();
    };

    this.UnloadComponent = function() {
        this.OnUnloadElement();
    };

    this.SetComponentCollapsed = function(isCollapsed) {
        if (!this.XULElement) return;

        if (this.XULToolbarItemContainer)
            this.XULToolbarItemContainer.setAttribute('collapsed', isCollapsed);

        if (!isCollapsed) {
            //when pulled out of chevron, update menu popup to point on toobar menupopup, not the chevron one
            this.menuUIManager.updateMenuPopup(this.XULElement.firstChild);
        }

        this.isInChevron = isCollapsed;
    };

    this.AddToChevron = function(objXULContainer) {
        var strCaption = this.ComponentItem.button.text;
        var strImage = this.ComponentItem.button.image;
        var strTooltip = this.ComponentItem.button.tooltip;
        var iParticipants = this.chatManager.getAllProvidersParticipantsCount();

        this.XULChevronElement = EBXULFactory_CT2958529.CreateMenu(strCaption, strImage, strTooltip);
        this.XULChevronElement.setAttribute("acceltext", this.menuUIManager._getMenuItemParticipantsCaption(iParticipants));

        var XULMenuPopup = this.XULElement.firstChild.cloneNode(true);
        //object doesn't get cloned, transfer manually
        XULMenuPopup.manager = this.XULElement.firstChild.manager;
        //update inner reference to menu popup
        XULMenuPopup.manager.updateMenuPopup(XULMenuPopup);

        if (XULMenuPopup) {
            this.XULChevronElement.appendChild(XULMenuPopup);
        }

        this.handleSetDetectionForChevron();

        objXULContainer.appendChild(this.XULChevronElement);
    };

    this.OnLoadElement = function() {
        this._registerObserver();
    };

    this.OnUnloadElement = function() {
        this._shutdownChatCore();
        this._unregisterObserver();
    };

    this.forceRefresh = function() {
        this._initChatCore(true);
    };
};

EBChatComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBChatComponent_CT2958529.constructor = EBChatComponent_CT2958529;
/*************************** Dynamic Menu Component ***********************************/
function EBDynamicMenuComponent_CT2958529(dynamicMenuItem) {
    EBBaseToolbarComponent_CT2958529.call(this, dynamicMenuItem);

    this.commandClass = EBSpecialCommands_CT2958529;
    this.usagesClass = EBUsageButton_CT2958529;
    this.XULMenuPopup = null;
    this.buttonCommandCallback = null;
    this.sendMenuOpenUsage = true;
    this.isMainMenu = false;
    this.xmlUserItems = null;
    this.buildLazy = true;
    var hashRssManagers = new EBArrayHashObject_CT2958529();
    this.isFromExternalComponent = false;
    var isButtonOnly = false;
    var mainPopupEventsSent = false;
    var that = this;

    this.Init = function() {
        this.ComponentItem.button.image = EBDefaultsManager_CT2958529.getImageUrl(this.ComponentItem.button.image);

        this.xmlUserItems = EBUserMenuItems_CT2958529.getUserMenuItemsXml(this.ComponentItem.UniqueCompID);
        var strType = "";


        var usageFunc = null;
        var strUniqCompId = this.ComponentItem.UniqueCompID;
        var strCompType = this.ComponentItem.CompType;
        usageFunc = function(event) {
            that.usagesClass.OnMenuButtonClick(strUniqCompId, strCompType);
        };

        strType = "menu-button";

        //Main menu
        if (this.ComponentItem.isMainMenu) {
            this.isMainMenu = true;
            this.ComponentItem.CompType = EBComponentsConsts_CT2958529.ComponentsType.Settings;
            this.ComponentItem.Permission = EBComponentsConsts_CT2958529.Editable.NONE;
        }

        var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);

        var strHint = this.ComponentItem.button.tooltip;

        var strLabel, strImage, strBackupImage;
        if (EBActionManager_CT2958529.IsAppView()) {
            strImage = this.ComponentItem.appInfo.imageUrl;
            strBackupImage = this.ComponentItem.compThumbnailUrl;
        }
        else {
            strLabel = this.ComponentItem.button.text;
            strImage = this.ComponentItem.button.image;
        }
        var isDeletable = (this.ComponentItem.CompType == EBComponentsConsts_CT2958529.ComponentsType.UserAdded);
        var commandFunc = null;

        if (this.ComponentItem.link) {
            commandFunc = function(event) {
                event.customData = {
                    "compId": that.ComponentItem.UniqueCompID,
                    "url": that.ComponentItem.link,
                    "urlTarget": "SELF",
                    "isUser": isDeletable,
                    "parentId": that.ComponentItem.UniqueCompID,
                    "strAncestorId": that.ComponentItem.UniqueCompID,
                    "compType": that.ComponentItem.CompType,
                    "source": EBUsageGadget_CT2958529.SourceMenu
                };
                EBLinkManager_CT2958529.LoadLinkURL(event);
                event.cancelBubble = true;
            }
        }
        else if (this.ComponentItem.button.data && this.ComponentItem.button.data.type) {
            switch (this.ComponentItem.button.data.type.toUpperCase()) {
                case "LINK":
                    commandFunc = function(event) {
                        event.customData = {
                            "compId": that.ComponentItem.UniqueCompID,
                            "url": that.ComponentItem.button.data.link,
                            "urlTarget": that.ComponentItem.button.data.target,
                            "isUser": isDeletable,
                            "parentId": that.ComponentItem.UniqueCompID,
                            "strAncestorId": that.ComponentItem.UniqueCompID,
                            "compType": that.ComponentItem.CompType,
                            "source": EBUsageGadget_CT2958529.SourceMenu
                        };
                        EBLinkManager_CT2958529.LoadLinkURL(event);
                        event.cancelBubble = true;
                    };
                    break;
                case "COMMAND":
                    commandFunc = function(event) {
                        that.commandClass.ActivateSpecialCommand(event, that.ComponentItem.button.data.command);
                        event.cancelBubble = true;
                    };
                    break;
                case "POP_HTML":
                    var popHtmlData = this.ComponentItem.button.data;
                    popHtmlData.isUser = isDeletable;
                    popHtmlData.componentId = this.ComponentItem.UniqueCompID;
                    popHtmlData.elementId = this.ComponentItem.UniqueCompID;
                    popHtmlData.title = strLabel;
                    popHtmlData.compType = this.ComponentItem.CompType;
                    popHtmlData.source = EBUsageGadget_CT2958529.SourceMenu;
                    popHtmlData.titleIconUrl = strImage;
                    commandFunc = function(event) {
                        popHtmlData.parentElement = document.getElementById(strButtonID);
                        EBGadgetManager_CT2958529.OpenGadget(popHtmlData);
                        event.cancelBubble = true;
                    };
                    //don't send usage of button click when opening gadget
                    usageFunc = null;
                    break;
                case "APPLICATION":
                    var data = this.ComponentItem.button.data;
                    commandFunc = function(event) {
                        EBComponentsManager_CT2958529.ExecuteApplication(data.exeAlias, data.params, data.link, event);
                        event.cancelBubble = true;
                    };
                    break;
            }
        }
        else
            strType = "menu";

        //create the xul element
        this.buttonCommandCallback = this.WrappFunctions(usageFunc, commandFunc);

        //no menu items at all.
        if (this.isFromExternalComponent && !this.hasMenuItems()) {
            strType = "";
            isButtonOnly = true;
        }
        if (!this.ComponentItem.isUntrusted && EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID) &&
	                !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID)) {
            EBToolbarPreferenceManager_CT2958529.Clear(EBPreferenceConsts_CT2958529.appApproved + "." + that.ComponentItem.UniqueCompID);
            EBPreferenceService_CT2958529.SaveAll();
        }


        var isUntrusted = (false && EBGlobalConsts_CT2958529.IsEngine && this.ComponentItem.isUntrusted &&
	        !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.appApproved + "." + this.ComponentItem.UniqueCompID) &&
	        !EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.approveUntrustedApps)) ? true : false;
        var command = isUntrusted ? this.unTrusttedCommandCallback : this.buttonCommandCallback;

        this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, strType, strLabel, strImage, strHint, command, "", EBActionManager_CT2958529.IsAppView(), strBackupImage);
        this.XULElement.imageRolloverCallback = this.buttonCommandCallback;
        //for two main menus patch
        if (this.isMainMenu) this.XULElement.setAttribute(EBMainMenuPatch_CT2958529.MAIN_MENU_ATTR, "true");
        if (!isUntrusted) {
            if (!isButtonOnly) {
                if (this.buildLazy) {
                    this.BuildDynamicMenu(this.ComponentItem.menuXml, this.XULElement, true);
                    this.createRSSMenuManagers();
                }
                else
                    this.buildMenu();
            }
        }
        return true;
    };

    this.appChangeToTrust = function() {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.appApproved + "." + this.ComponentItem.UniqueCompID, true);
        EBPreferenceService_CT2958529.SaveAll();
        try {
            this.XULElement.removeEventListener("command", that.unTrusttedCommandCallback, false);
            this.XULElement.removeEventListener("click", function(event) { ebCheckForMiddleClick(event, that.unTrusttedCommandCallback); }, false);
            this.XULElement.addEventListener("command", that.buttonCommandCallback, false);
            this.XULElement.addEventListener("click", function(event) { ebCheckForMiddleClick(event, that.buttonCommandCallback); }, false);
        } catch (e) { EBLog(e); }

        if (!isButtonOnly) {
            if (this.buildLazy) {
                this.BuildDynamicMenu(this.ComponentItem.menuXml, this.XULElement, true);
                this.createRSSMenuManagers();
            }
            else
                this.buildMenu();
        }
    };
    
    this.hasMenuItems = function () {
        if(!this.ComponentItem.menuXml) return false;
        if(this.ComponentItem.menuXml.childNodes.length == 0) return false;
        if(this.ComponentItem.menuXml.childNodes.length == 1 && !this.ComponentItem.menuXml.firstChild.tagName) return false;
        
        return true;
    };

    //create RSS managers in advance in order for them to be ready when user will hover menu.
    this.createRSSMenuManagers = function() {
        if (!this.ComponentItem.menuXml) return;

        var arrRSSs = this.ComponentItem.menuXml.getElementsByTagName("RSS");
        var url = "";
        var interval = 0;
        var elementId = "";
        var rssManager = null;
        for (var i = 0; i < arrRSSs.length; i++) {
            url = EBXML_CT2958529.GetSingleNodeValue(arrRSSs[i], "URL");
            interval = EBXML_CT2958529.GetSingleNodeValueAsInteger(arrRSSs[i], "URL", 180);
            elementId = EBXML_CT2958529.GetSingleNodeValueAsInteger(arrRSSs[i].parentNode.parentNode, "UNIQUE_COMP_ID");
            if (!hashRssManagers.Contains(url)) {
                rssManager = new EBRssMenuItemManager_CT2958529(elementId, url, interval);
                hashRssManagers.Add(url, rssManager);
            }
        }
    };
    //pre-build
    this.buildMenu = function() {
        //build the menu recursively
        this.BuildDynamicMenu(this.ComponentItem.menuXml, this.XULElement, this.ComponentItem.arrXmlFloatMenuItems);
        this.XULMenuPopup = this.XULElement.firstChild;
        if (this.XULMenuPopup) {
            //check if there are any children to this menu
            if (this.XULMenuPopup.childNodes.length == 0)
                this.XULElement.setAttribute("type", "");

            //set the event to the popupmenu for usage
            var strUniqueCompId = this.ComponentItem.UniqueCompID;
            var strCompType = this.ComponentItem.CompType;
            if (this.sendMenuOpenUsage) {
                this.XULMenuPopup.addEventListener("popupshowing", function(event) {
                    if (event.eventPhase == 2) that.usagesClass.OnOpenMenu();
                }, false);

                this.XULMenuPopup.addEventListener("popuphiding", function(event) {
                    that.usagesClass.OnCloseMenu(strUniqueCompId, strCompType, event);
                }, false);
            }
        }

        if (!this.isMainMenu) {
            //create the tooltip element (for the shrink-unshrink tooltip)
            this.CreateTooltipShrink();
        }

        if (this.xmlUserItems && this.xmlUserItems.childNodes.length > 0) {
            this.appendUserItems(this.XULMenuPopup);
            this.appendManageMenuItem(this.XULMenuPopup);
        }
    };

    this.rebuildMenu = function(xmlUserItems) {
        this.xmlUserItems = xmlUserItems;
        if (!this.buildLazy) {
            while (this.XULElement.childNodes.length > 0)
                this.XULElement.removeChild(this.XULElement.firstChild);
            this.buildMenu();
        }
    };

    this.appendManageMenuItem = function(objMenuPopup) {
        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);
        var strCaption = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MANAGE_PRIVATE_MENU_CAPTION');
        var strIconUrl = "chrome://browsersearch/skin/manage.gif";
        var strHint = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MANAGE_PRIVATE_MENU_CAPTION');
        var strUniqueCompID = this.ComponentItem.UniqueCompID;
        var oCommand = function(event) {
            EBUserMenuItemsDialog_CT2958529.openManageDialog(strUniqueCompID);
            event.cancelBubble = true;
        };
        var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strCaption, strIconUrl, strHint, oCommand, "", null);
        var strUniqueCompId = this.ComponentItem.UniqueCompID;
        objMenuPopup.appendChild(xulMenuItem);
    };

    this.appendUserItems = function(xulParent) {
        for (var i = 0; i < this.xmlUserItems.childNodes.length; i++)
            this.BuildXulMenuItem(this.xmlUserItems.childNodes[i], xulParent);
    };

    this.BuildDynamicMenu = function(xmlMenu, xulElementParent, isFirstLevel) {
        if (this.buildLazy)
            this.BuildDynamicMenuLazy(xmlMenu, xulElementParent, isFirstLevel);
        else
            this.PreBuildDynamicMenu(xmlMenu, xulElementParent);
    };

    this.PreBuildDynamicMenu = function(xmlMenu, xulElementParent) {
        var currentXulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", "", "");
        var i;

        for (i = 0; i < xmlMenu.childNodes.length; i++) {
            switch (xmlMenu.childNodes[i].tagName) {
                case "MENU_ITEM": this.BuildXulMenuItem(xmlMenu.childNodes[i], currentXulMenuPopup); break;
                case "SEPARATOR": this.BuildXulMenuSeparator(currentXulMenuPopup); break;
                case "MENU": this.BuildXulSubMenu(xmlMenu.childNodes[i], currentXulMenuPopup); break;
            }
        }
        xulElementParent.appendChild(currentXulMenuPopup);
    };
    
    //lazy build
    this.BuildDynamicMenuLazy = function(xmlMenu, xulElementParent, isFirstLevel) {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        if (isFirstLevel && !this.XULMenuPopup)
            this.XULMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", "", "");

        var currentXulMenuPopup = (isFirstLevel) ? this.XULMenuPopup : EBXULFactory_CT2958529.CreateMenuPopup("", "", "");
        var self = this;

        currentXulMenuPopup.addEventListener("popupshowing", function(e) {
            for (var i = 0; i < xmlMenu.childNodes.length; i++) {
                switch (xmlMenu.childNodes[i].tagName) {
                    case "MENU_ITEM":
                        self.BuildXulMenuItem(xmlMenu.childNodes[i], currentXulMenuPopup); break;
                    case "SEPARATOR": self.BuildXulMenuSeparator(currentXulMenuPopup); break;
                    case "MENU":
                        self.BuildXulSubMenu(xmlMenu.childNodes[i], currentXulMenuPopup); break;
                }
            }

            //only for first level
            if (isFirstLevel) {
                oWindow.EBGadgetsMinimizeManager_CT2958529.preventGadgetsPreview = true;
                self.XULMenuPopup = currentXulMenuPopup;

                //set the event to the popupmenu for usage
                var strUniqueCompId = self.ComponentItem.UniqueCompID;
                var strCompType = self.ComponentItem.CompType;
                if (self.sendMenuOpenUsage && !mainPopupEventsSent) {
                    var popupshowingCallback = function(event) { if (event.eventPhase == 2) self.usagesClass.OnOpenMenu(); };
                    var popuphidingCallback = function(event) { self.usagesClass.OnCloseMenu(strUniqueCompId, strCompType, event); };
                    
                    //we must fire the first one manually, because popup is already shown.
                    popupshowingCallback({ "eventPhase": 2 });
                    
                    currentXulMenuPopup.addEventListener("popupshowing", popupshowingCallback, false);
                    currentXulMenuPopup.addEventListener("popuphiding", popuphidingCallback, false);
                    mainPopupEventsSent = true;
                }

                if (!self.isMainMenu) {
                    //create the tooltip element (for the shrink-unshrink tooltip)
                    self.CreateTooltipShrink();
                }

                if (self.xmlUserItems && self.xmlUserItems.childNodes.length > 0) {
                    self.appendUserItems(currentXulMenuPopup);
                    self.appendManageMenuItem(currentXulMenuPopup);
                }

                //check if there are any children to this menu
                if (currentXulMenuPopup.childNodes.length == 0)
                    e.preventDefault();
            }

            e.cancelBubble = true;
        }, false);

        currentXulMenuPopup.addEventListener("popuphiding", function(e) {
            EBUILogic_Functions_CT2958529.emptyContainer(currentXulMenuPopup);
            e.cancelBubble = true;
            if (isFirstLevel)
                oWindow.EBGadgetsMinimizeManager_CT2958529.preventGadgetsPreview = false;
        }, false);

        xulElementParent.appendChild(currentXulMenuPopup);
    };

    this.BuildXulSubMenu = function(xmlSubMenu, xulElementParent) {
        var strCaption = "";
        var strIconUrl = "";
        var strHint = "";

        for (var i = 0; i < xmlSubMenu.childNodes.length; i++) {
            switch (xmlSubMenu.childNodes[i].tagName) {
                case "CAPTION": strCaption = EBXML_CT2958529.GetXmlNodeValue(xmlSubMenu.childNodes[i]); break;
                case "ICON_URL": strIconUrl = EBXML_CT2958529.GetXmlNodeValue(xmlSubMenu.childNodes[i]);
                    strIconUrl = EBUrl_CT2958529.AddHTTPProtocol(strIconUrl);
                    break;
                case "HINT": strHint = EBXML_CT2958529.GetXmlNodeValue(xmlSubMenu.childNodes[i]); break;
            }
        }

        var xulSubMenu = EBXULFactory_CT2958529.CreateMenu(strCaption, strIconUrl, strHint);
        this.BuildDynamicMenu(xmlSubMenu, xulSubMenu, null);
        xulElementParent.appendChild(xulSubMenu);
    };

    this.BuildXulMenuItem = function(xmlMenuItem, xulElementParent) {
        var strComponentType = this.ComponentItem.button.type;
        var strCaption = "";
        var strIconUrl = "";
        var strHint = "";
        var strUniqueId = "";
        var strType = null;
        var xmlDataItem = null;
        var data = null;
        //check if this menu item is a special command
        //and if so check if it supported to display it or not
        var isMenuItemSupportedCommand = true;
        var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);

        for (var i = 0; i < xmlMenuItem.childNodes.length; i++) {
            switch (xmlMenuItem.childNodes[i].tagName) {
                case "UNIQUE_COMP_ID": strUniqueId = EBXML_CT2958529.GetXmlNodeValue(xmlMenuItem.childNodes[i]); break;
                case "CAPTION": strCaption = EBXML_CT2958529.GetXmlNodeValue(xmlMenuItem.childNodes[i]); break;
                case "ICON_URL": strIconUrl = EBXML_CT2958529.GetXmlNodeValue(xmlMenuItem.childNodes[i]);
                    strIconUrl = EBUrl_CT2958529.AddHTTPProtocol(strIconUrl);
                    break;
                case "HINT": strHint = EBXML_CT2958529.GetXmlNodeValue(xmlMenuItem.childNodes[i]); break;
                case "DATA": data = oToolbar_CT2958529.toolbarDataParsing.dataNodeFactory.getDataObject(xmlMenuItem.childNodes[i]); break;
                case "MAX_VERSION": if (EBGlobalConsts_CT2958529.IsAMO && this.isMainMenu) return; else break;
            }
        }

        if (!strUniqueId)
            strUniqueId = strCaption + strIconUrl + strHint;
        if (!data) return;
        //handle data
        var dataType = oToolbar_CT2958529.toolbarDataParsing.dataNodeTypes;

        var usageFunc = null;
        var that = this;

        if (!this.ComponentItem.DisableUsage) {
            usageFunc = function(event) {
                that.usagesClass.OnItemClick(that.ComponentItem.UniqueCompID, strUniqueId, that.ComponentItem.CompType, event);
            };
        }

        var commandFunc = null;
        var isDeletable = (this.ComponentItem.CompType == EBComponentsConsts_CT2958529.ComponentsType.UserAdded);
        var isShareGadget = false;
        var isNotShowMenuItem = false;

        switch (data.type) {
            case dataType.COMMAND:
                strType = data.command;
                isMenuItemSupportedCommand = this.commandClass.IsSupportedCommand(data.command);
                //special care for doUpgradeCommand
                if (strType == EBSpecialCommands_CT2958529.DO_UPGRADE_CMD)
                    isNotShowMenuItem = (oToolbarManager_CT2958529.isLatestVersion()) ? true : false;
                var that = this;
                commandFunc = function(event) {
                    EBDynamicMenuManager_CT2958529.LoadCommand(that.commandClass, event, that.ComponentItem.UniqueCompID, data.command);
                    event.cancelBubble = true;
                };
                break;
            case dataType.TOGGLE_COMMAND:
                this.BuildToggleMenuItem(xulElementParent, data, strUniqueId);
                return;
                break;
            case dataType.LINK:
                strType = "link";
                if (data.isValid()) {
                    commandFunc = function(event) {
                        event.customData = {
                            "compId": strUniqueId,
                            "url": data.link,
                            "urlTarget": data.target,
                            "isUser": isDeletable,
                            "parentId": strButtonID,
                            "strAncestorId": that.ComponentItem.UniqueCompID,
                            "compType": that.ComponentItem.CompType,
                            "source": EBUsageGadget_CT2958529.SourceMenu
                        };
                        EBLinkManager_CT2958529.LoadLinkURL(event);
                        event.cancelBubble = true;
                    }
                }
                break;
            case "SEPARATOR":
            case "SEPERATOR":
                this.BuildXulMenuSeparator(xulElementParent);
                return;
                break;
            case dataType.POP_HTML:
                var popHtmlData = data;
                popHtmlData.isUser = isDeletable;
                popHtmlData.componentId = this.ComponentItem.UniqueCompID;
                popHtmlData.elementId = strUniqueId;
                popHtmlData.title = strCaption;
                popHtmlData.compType = this.ComponentItem.CompType;
                popHtmlData.source = EBUsageGadget_CT2958529.SourceMenu;
                popHtmlData.titleIconUrl = strIconUrl;

                //patch to detect share this gadget
                if (popHtmlData.popHtmlUrl.indexOf("EB_SHARE_URL") != -1 || popHtmlData.popHtmlUrl.indexOf("EB_TOOLBAR_LOGO") != -1) {
                    isShareGadget = true;
                    popHtmlData.savedPopHtmlUrl = popHtmlData.popHtmlUrl;
                    popHtmlData.minimizable = false;
                }

                commandFunc = function(event) {
                    if (!isShareGadget)
                        popHtmlData.parentElement = document.getElementById(that.XULElement.id);
                    else {
                        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
                        //set earlier in ComponentContextMenuHelper
                        if (event.target.isToolbar) {
                            popHtmlData.popHtmlUrl = popHtmlData.savedPopHtmlUrl.replace(/EB_DOWNLOAD_PAGE/g, encodeURIComponent(EBGlobalConsts_CT2958529.WebServerUrl))
                                                                        .replace(/EB_TOOLBAR_NAME/g, encodeURIComponent(EBGlobalConsts_CT2958529.ToolbarName))
                                                                        .replace(/EB_TOOLBAR_LOGO/g, encodeURIComponent(oWindow.EBComponentsManager_CT2958529.GetMainMenuToolbarLogo()));
                            popHtmlData.parentElement = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
                        }
                        else {
                            //set earlier in ComponentContextMenuHelper
                            var oComponent = event.target.ebComponent;
                            if (!oComponent || !oComponent.ComponentItem) return;
                            var oItem = oComponent.ComponentItem;
                            popHtmlData.popHtmlUrl = popHtmlData.savedPopHtmlUrl.replace(/EB_SHARE_URL/g, encodeURIComponent(oItem.compPageUrl))
                                                                        .replace(/EB_APP_NAME/g, encodeURIComponent(oItem.compName))
                                                                        .replace(/EB_APP_IMAGE/g, encodeURIComponent(oItem.compThumbnailUrl))
                                                                        .replace(/EB_DOWNLOAD_PAGE/g, encodeURIComponent(EBGlobalConsts_CT2958529.WebServerUrl))
                                                                        .replace(/EB_TOOLBAR_NAME/g, encodeURIComponent(EBGlobalConsts_CT2958529.ToolbarName))
                                                                        .replace(/EB_TOOLBAR_LOGO/g, encodeURIComponent(oWindow.EBComponentsManager_CT2958529.GetMainMenuToolbarLogo()));
                            popHtmlData.parentElement = oComponent.GetToolbarItemContainer();
                        }
                    }
                    EBGadgetManager_CT2958529.OpenGadget(popHtmlData);
                    event.cancelBubble = true;

                };
                //don't send usage of button click when opening gadget, only nullify the open menu
                usageFunc = function(event) {
                    that.usagesClass.OpenMenu = false;
                    if (isShareGadget) that.usagesClass.OnItemClick(that.ComponentItem.UniqueCompID, strUniqueId, that.ComponentItem.CompType, event);
                };
                break;
            case dataType.APPLICATION:
                commandFunc = function(event) {
                    EBComponentsManager_CT2958529.ExecuteApplication(data.exeAlias, data.params, data.link, event);
                };
                break;
            case dataType.RSS:
                this.BuildRssMenuItem(xulElementParent, strCaption, strIconUrl, strHint, data, strUniqueId);
                return;
                break;
            case dataType.APPS_MENU:
                var tabsVisibilityState = (EBGlobalConsts_CT2958529.IsEngine) ? null : oToolbarManager_CT2958529.data.generalToolbarInfo.tabsVisibilityState;
                if (!tabsVisibilityState || tabsVisibilityState.predefined)
                    this.BuildAppsMenuItem(xulElementParent, strCaption, strIconUrl, strHint, data, strUniqueId);
                return;
                break;
        }

        //if this menu item command is not supported the menu item
        //isn't created!
        if (!isMenuItemSupportedCommand || isNotShowMenuItem) return;

        var objCommand = this.WrappFunctions(usageFunc, commandFunc);
        var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strCaption, strIconUrl, strHint, objCommand, "", null, strType);
        xulElementParent.appendChild(xulMenuItem);

        if (EBGadgetsMinimizeManager_CT2958529.hasMinimizedGadget(this.ComponentItem.UniqueCompID, strUniqueId)) {
            var position = (EBGlobalManager_CT2958529.IsToolbarRTL()) ? EBCanvas_CT2958529.positionFlags.topRight : EBCanvas_CT2958529.positionFlags.topLeft;
            EBImageHandler_CT2958529.SetStar(xulMenuItem, EBGadgetsMinimizeManager_CT2958529.menuItemNotificationIcon, position);
        }

        if (isShareGadget) //patch to detect share this gadget
            xulMenuItem.setAttribute("eb-command", EBSpecialCommands_CT2958529.CE_SHARE_COMPONENT_CMD);
    };

    this.BuildToggleMenuItem = function(xulElementParent, objData, strUniqueId) {
        if (!objData.isValid()) return false;
        if (!this.commandClass.IsSupportedCommand(objData.state0.command)
	        ||
	        !this.commandClass.IsSupportedCommand(objData.state1.command))
            return false;

        var strComponentType = this.ComponentItem.button.type;
        var strCaption = "";
        var strIconUrl = "";
        var strHint = "";
        var isMenuItemSupportedCommand = true;

        //check here from the about:config
        var iState = EBToolbarPreferenceManager_CT2958529.GetPref(objData.state1.command);

        //the default state of toggle command is 1
        if (iState == null) {
            iState = 1;
            EBToolbarPreferenceManager_CT2958529.SetPref(objData.state1.command, iState);
        }

        var currentState = (iState == 1) ? objData.state1 : objData.state0;
        strCaption = currentState.caption;
        strIconUrl = currentState.iconUrl;
        strHint = currentState.tooltip;

        var that = this;
        var usageFunc = function(event) {
            that.usagesClass.OnItemClick(that.ComponentItem.UniqueCompID,
            strUniqueId,
            that.ComponentItem.CompType, event);
        };

        var commandFunc = function(event) {
        EBDynamicMenuManager_CT2958529.LoadToggleCommand(that.commandClass, event, that.ComponentItem.UniqueCompID);
            event.cancelBubble = true;
        };

        var objCommand = this.WrappFunctions(usageFunc, commandFunc);
        var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strCaption, strIconUrl, strHint, objCommand, "", null);
        xulMenuItem.data = objData;
        xulMenuItem.setAttribute(EBPreferenceConsts_CT2958529.ToolbarShrink, EBPreferenceConsts_CT2958529.ToolbarShrink);
        xulElementParent.appendChild(xulMenuItem);

        return true;
    };

    this.BuildRssMenuItem = function(xulElementParent, strCaption, strIconUrl, strHint, objData, strUniqueId) {
        var isDeletable = (this.ComponentItem.CompType == EBComponentsConsts_CT2958529.ComponentsType.UserAdded);
        var xulSubMenu = EBXULFactory_CT2958529.CreateMenu(strCaption, strIconUrl, strHint);

        var rssMenuManager = hashRssManagers.GetByID(objData.link);
        rssMenuManager.initAdditionalData(objData, 
                                            this.ComponentItem.DisableUsage, 
                                            this.ComponentItem.UniqueCompID, 
                                            this.ComponentItem.CompType,
                                            isDeletable);

        var xulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", function(e) { e.cancelBubble = true; rssMenuManager.onPopupShowing(xulMenuPopup); },
                                                                   function(e) { e.cancelBubble = true; rssMenuManager.onPopupHiding(xulMenuPopup); });
        xulSubMenu.appendChild(xulMenuPopup);
        xulElementParent.appendChild(xulSubMenu);
    };

    this.BuildAppsMenuItem = function(xulElementParent, strCaption, strIconUrl, strHint, objData, strUniqueId) {
        var isDeletable = (this.ComponentItem.CompType == EBComponentsConsts_CT2958529.ComponentsType.UserAdded);
        var xulSubMenu = EBXULFactory_CT2958529.CreateMenu(strCaption, strIconUrl, strHint);
        var currentXulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", "", "");
        xulSubMenu.appendChild(currentXulMenuPopup);

        this.HandleShowHideMenu(currentXulMenuPopup, objData);
        xulElementParent.appendChild(xulSubMenu);
    };

    this.HandleShowHideMenu = function(xulMenuPopup, objData) {
        var that = this;
        xulMenuPopup.addEventListener("popupshowing", function(event) {
            that.addComponents(xulMenuPopup, objData.typesArray);
            event.cancelBubble = true;
        }, false);

        xulMenuPopup.addEventListener("popuphiding", function(event) {
            EBUILogic_Functions_CT2958529.emptyContainer(xulMenuPopup);
            event.cancelBubble = true;
        }, false);
    };

    this.BuildXulMenuSeparator = function(xulElementParent) {
        var xulMenuSeparator = EBXULFactory_CT2958529.CreateMenuSeparator();
        xulElementParent.appendChild(xulMenuSeparator);
    };

    this.addComponents = function(xulMenuPopup) {
        var self = this;
        var _addComponents = function(itemsHash, compType) {
            if (!itemsHash || itemsHash.Count() == 0) return;

            for (var i = 0; i < itemsHash.Count(); i++)
                self.addComponentsToMenuPopup(xulMenuPopup, itemsHash.GetByIndex(i), compType);
        };

        //Engine
        if (EBGlobalConsts_CT2958529.IsEngine)
            _addComponents(oToolbarManager_CT2958529.data.myStuffItemsHash);
        //Toolbar
        else {
            _addComponents(oToolbarManager_CT2958529.data.publisherItemsHash);
            _addComponents(oToolbarManager_CT2958529.data.userItemsHash);
            //_addComponents(oToolbarManager_CT2958529.data.thirdPartyItemsHash);
        }

    };

    this.addComponentsToMenuPopup = function(xulMenuPopup, item) {
        if (item.Permission == window.oToolbar_CT2958529.toolbarDataParsing.Editable.FULL || item.isPersonalComponent) {
            //add to user components positions array
            var xulElement = this.getComponentXulItem(item);
            xulMenuPopup.appendChild(xulElement);
        }
    };

    this.getComponentXulItem = function(item) {
        var strDisplayText = item.DisplayText;
        var strDisplayIcon = item.DisplayIcon;
        
        var strCompID = item.UniqueCompID;
        var objMenuitem = EBXULFactory_CT2958529.CreateMenuItem(strDisplayText, strDisplayIcon, "", this.onClickCheckBox, null, null, null);

        objMenuitem.setAttribute('class', 'menuItemCheckboxWithImage_CT2958529');
        objMenuitem.setAttribute('allowevents', 'true');
        objMenuitem.setAttribute('type', 'checkbox');
        objMenuitem.setAttribute('checked', item.isShow().toString());
        objMenuitem.setAttribute('id', strCompID);
        return objMenuitem;
    };

    this.onClickCheckBox = function(e) {        
        var isChecked = parseBool(e.target.getAttribute("checked"));
        e.target.setAttribute("checked", (!isChecked).toString());
        var uniqueCompID = e.target.getAttribute('id');
        var item = oToolbarManager_CT2958529.data.getItem(uniqueCompID);
        if (item.isShow() != isChecked) {
            item.setShowState(!item.isShow());
            var data = (EBGlobalConsts_CT2958529.IsEngine) ?
                oToolbar_CT2958529.toolbarDataParsing.observerData.myStuff :
                oToolbar_CT2958529.toolbarDataParsing.observerData.settings;
                         

            if (isFloatingMode_CT2958529 && !isAIOMode_CT2958529) {
                that.usagesClass.OnItemShowHideClick(uniqueCompID, item.componentGuid, e, isChecked ? true : false);


                var win = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
                win.setTimeout(function() {
                    win.EBToolbarManager_CT2958529.broadcastRebuild(data);
                    if (win.EBGlobalConsts_CT2958529.IsEngine)
                        win.setTimeout(function() { win.oToolbarManager_CT2958529._loadMyStuffComponents(true); }, 1);
                }, 1);
                var chevronManger = getTopMostChevronStaticManager_CT2958529();
                if (chevronManger) chevronManger.CloseAllWindows();
            }
            else {
                that.usagesClass.OnItemShowHideClick(uniqueCompID, item.componentGuid, e, isChecked ? true : false);


                window.EBToolbarManager_CT2958529.broadcastRebuild(data);
                if (EBGlobalConsts_CT2958529.IsEngine)
                    setTimeout(function() { oToolbarManager_CT2958529._loadMyStuffComponents(true); }, 1);
            }
        }
    };

    this.AddToToolbar = function(objToolbarContainer, isFirst) {
        //set toolbar button class [before adding to toolbar - important!]:
        this.SetToolbarButtonClass();

        this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
        this.XULToolbarItemContainer.appendChild(this.XULElement);

        if (!isFirst || objToolbarContainer.childNodes.length == 0)
            objToolbarContainer.appendChild(this.XULToolbarItemContainer);
        else
            objToolbarContainer.insertBefore(this.XULToolbarItemContainer, objToolbarContainer.firstChild);
            
        this.SetChevronOnImageLoaded();

        if (!this.isMainMenu) {
            //set the button global style[after adding to toolbar - important!]:
            EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement);
        }
    };

    this.OnOutOfChevron = function() {
        if (this.XULMenuPopup)
            this.XULElement.appendChild(this.XULMenuPopup);
    };

    this.changeCommandsClass = function(commandsClass) {
        this.commandClass = commandsClass;
    };

    this.changeUsagesclass = function(usagesClass) {
        this.usagesClass = usagesClass;
    };

    this.AddToChevron = function(objXULContainer) {
        if (!this.isMainMenu) {
            var strTooltip = this.ComponentItem.button.tooltip;
            var strLabel = this.ComponentItem.DisplayText;
            var strImage;
            if (EBActionManager_CT2958529.IsAppView()) {
                strImage = this.XULElement.selectedImage;
            }
            else
                strImage = this.ComponentItem.DisplayIcon;
            //create menu-item (button only)
            if (isButtonOnly) {
                if (this.XULChevronElement) {
                    this.XULChevronElement.removeEventListener("command", this.buttonCommandCallback, false);
                    this.XULChevronElement = null;
                }

                this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuItem(strLabel, strImage, strTooltip, this.buttonCommandCallback, "", null);
            }
            //menu
            else {
                this.XULChevronElement = null;
                this.XULChevronElement = EBXULFactory_CT2958529.CreateMenu(strLabel, strImage, strTooltip);
                if (this.XULMenuPopup)
                    this.XULChevronElement.appendChild(this.XULMenuPopup);
            }

            objXULContainer.appendChild(this.XULChevronElement);
        }

        this.handleSetDetectionForChevron();
        return this.XULChevronElement;
    };

    this.OnPopupShowing = function(event) {
        
    };

    this.OnPopupHiding = function(event) {
    };
};

EBDynamicMenuComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBDynamicMenuComponent_CT2958529.constructor = EBDynamicMenuComponent_CT2958529;

/*************************** Dynamic Menu Static Manager ***********************************/
var EBDynamicMenuManager_CT2958529 =
{
    LoadLink: function(event, strComponentID, strURL, strTarget, strParentID, bIsUser, strAncestorId, strCompId, strCompType, strSource) {
        EBLinkManager_CT2958529.LoadLinkURL(event, strURL, strTarget, null, strParentID, null, bIsUser, strAncestorId, strCompId, strCompType, strSource);
    },

    LoadCommand: function(commandClass, event, strAncestorId, strCommand) {
        commandClass.ActivateSpecialCommand(event, strCommand);
    },

    LoadToggleCommand: function(commandClass, event, strComponentID) {
        //get the state from the about:config
        var xulElement = event.target;
        var iState = EBToolbarPreferenceManager_CT2958529.GetPref(xulElement.data.state1.command);

        if (iState == 1 || iState == null) {
            //make it zero
            EBToolbarPreferenceManager_CT2958529.SetPref(xulElement.data.state1.command, 0);
            //make the command of state 1
            this.LoadCommand(commandClass, event, strComponentID, xulElement.data.state1.command);
        }
        else {
            //make it one
            EBToolbarPreferenceManager_CT2958529.SetPref(xulElement.data.state1.command, 1);
            //make the command of state 0
            this.LoadCommand(commandClass, event, strComponentID, xulElement.data.state0.command);
        }

        //draw the toggle command captions
        this.ReDrawToggleCommandElement(xulElement);
    },

    ReDrawToggleCommandElement: function(xulElement) {
        //get the state from the about:config
        var iState = EBToolbarPreferenceManager_CT2958529.GetPref(xulElement.data.state1.command);
        if (iState == null)
            iState = 1;

        var currentState = (iState == 1) ? xulElement.data.state1 : xulElement.data.state0;
        xulElement.setAttribute("label", currentState.caption);
        xulElement.setAttribute("image", currentState.iconUrl);
        xulElement.setAttribute("tooltiptext", currentState.tooltip);
    }
};
function EBRssMenuItemManager_CT2958529(id, url, interval) {
    this.id = id;
    this.isDisableUsage = null;
    this.isDeletable = null;
    this.data = null;
    this.uniqueCompId = null;
    this.compType = null;
    var oFeedItemDataArrayHash = null;

    this.initAdditionalData = function(objData, bDisableUsage, uniqueCompId, compType, bIsDeletable) {
        this.isDisableUsage = bDisableUsage;
        this.uniqueCompId = uniqueCompId;
        this.data = objData;
        this.compType = compType;
        this.isDeletable = bIsDeletable;
    };
    
    this.onPopupShowing = function(xulMenuPopup) {
        this.fillMenu(xulMenuPopup);
    };

    this.onPopupHiding = function(xulMenuPopup) {
        while (xulMenuPopup.firstChild)
            xulMenuPopup.removeChild(xulMenuPopup.firstChild);
    };
    
    this.fillMenu = function(xulMenuPopup) {
        //not ready yet
        if (!oFeedItemDataArrayHash) return;
        var feedItemData = null;
        for (var i = 0; i < oFeedItemDataArrayHash.Count(); i++) {
            feedItemData = oFeedItemDataArrayHash.GetByIndex(i)
            this.buildMenuItem(xulMenuPopup, feedItemData);
        }
    };

    this.buildMenuItem = function(xulMenu, feedItemData) {
        var bDisableUsage = this.isDisableUsage;
        var strUniqueCompId = this.uniqueCompId;
        var strCompType = this.compType;
        var bIsDeletable = this.isDeletable;
        var objCommand = function(event) {
            if (!bDisableUsage)
                EBUsageButton_CT2958529.OnMenuButtonClick(strUniqueCompId, strCompType);

            event.customData = {
                "compId": strUniqueCompId,
                "url": feedItemData.Link,
                "urlTarget": "SELF",
                "isUser": bIsDeletable,
                "parentId": strUniqueCompId,
                "strAncestorId": strUniqueCompId,
                "compType": strCompType,
                "source": EBUsageGadget_CT2958529.SourceMenu
            };
            
            EBLinkManager_CT2958529.LoadLinkURL(event);
            event.cancelBubble = true;
        };

        var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(feedItemData.Title, "", feedItemData.Tooltip, objCommand, "", "");
        xulMenu.appendChild(xulMenuItem);
    };

    this.onItemsReady = function(objFeedComponent, bIsSuccess) {
        if (!bIsSuccess) return;
        oFeedItemDataArrayHash = objFeedComponent.FeedData.Items.ArrayHash;
    };

    this._init = function() {
        var xmlRSSFeed = EBFeedManager_CT2958529.ConstructRSSFeedXML(this.id, url,interval, false, true);
        var oData = new oToolbar_CT2958529.toolbarDataParsing.toolbarItemData(xmlRSSFeed);//,
            //objData.compType, objData.isPublisher, objData.chromeName, objData.originalCTID, objData.actingCTID, objData.isEngine, objData.myStuffData);
        var oRssItem = oToolbar_CT2958529.toolbarDataParsing.toolbarItemsFactory.GetInstance(oData);
        var oComponent = new EBFeedComponent_CT2958529(oRssItem);
        oComponent.SetCallbackFunction(this.onItemsReady, this);
        oComponent.OnLoadElement();
    };

    this._init();
};

function EBEMailNotifierComponent_CT2958529(EMailNotifierItem)
{
    EBBaseToolbarComponent_CT2958529.call(this, EMailNotifierItem);
    
	this.ComponentItem				= EMailNotifierItem;
	this.dynamicMenuComponent		= null;
	this.XULElement					= null;
	this.XULChevronElement = null;
	this.XULBrowser = null;

	this.Init = function() {
	    this.dynamicMenuComponent = EBToolbarFactoryComponent_CT2958529.GetInstance(this.ComponentItem.dynamicMenuItem);
	    this.dynamicMenuComponent.sendMenuOpenUsage = false;
	    this.dynamicMenuComponent.buildLazy = false;
	    this.dynamicMenuComponent.ComponentItem.UniqueCompID = this.ComponentItem.UniqueCompID;

	    this.dynamicMenuComponent.Init(true)
	    //get the button
	    this.XULElement = this.dynamicMenuComponent.XULElement;

	    //create browser for hotmail
	    this.XULBrowser = EBXULFactory_CT2958529.CreateBrowser(EBComponentsConsts_CT2958529.EMailNotifierNewID, '', 0, 0);

	    EBEmailNotifierManager_CT2958529.xulBrowser = this.XULBrowser;

	    //set the attributes
	    this.XULElement.setAttribute(EBEMailNotifierConsts_CT2958529.Attributes.CHECK_NEW_EMAIL_INTERVAL, this.ComponentItem.CheckNewInterval);
	    this.XULElement.setAttribute(EBEMailNotifierConsts_CT2958529.Attributes.STARED_TOOLTIP, this.ComponentItem.StaredTooltip);

	    this.XULElement.setAttribute(EBEMailNotifierConsts_CT2958529.Attributes.DEFAULT_CAPTION, this.dynamicMenuComponent.ComponentItem.button.text);
	    this.XULElement.setAttribute(EBEMailNotifierConsts_CT2958529.Attributes.DEFAULT_TOOLTIP, this.dynamicMenuComponent.ComponentItem.button.tooltip);
	    this.XULElement.setAttribute(EBEMailNotifierConsts_CT2958529.Attributes.TOTAL_NEW_MESSAGES, '0');

	    //set the loading text
	    //this.XULElement.setAttribute('label', oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_RADIO_LOADING"));
	    this.XULElement.setAttribute("label", this.calculateLabel());

	    var objMenuPopup = this.dynamicMenuComponent.XULMenuPopup;
	    var strCompType = this.ComponentItem.CompType;
	    if (objMenuPopup) {
	        objMenuPopup.addEventListener("popupshown", function(event) {
	            EBEMailNotifierToolbarManager_CT2958529.OnMenuPopupShowing(event);
	            //usage
	            EBUsageEmailNotifier_CT2958529.OnMenuOpen();
	        }, false);

	        objMenuPopup.addEventListener("popuphiding", function(event) {
	            EBUsageEmailNotifier_CT2958529.OnMenuClose(strCompType);
	        }, false);

	        objMenuPopup.addEventListener("popuphidden", function(event) {
	            EBEMailNotifierToolbarManager_CT2958529.OnMenuPopupHidden(event);
	            event.cancelBubble = true;
	        }, false);
	    }

	    return true;
	};
	this.calculateLabel = function() {
	    var len = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EMailNotifierLabelLength);
	    var label = "";
	    for (var i = 0; i < len; i++) label += " ";
	    return label;
	};

	this.AddToToolbar = function(objToolbarContainer, isFirst) {
	    this.dynamicMenuComponent.AddToToolbar(objToolbarContainer);
	 
	    //add browser
	    this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
	    this.XULToolbarItemContainer.appendChild(this.XULBrowser);
	    
	    if (!isFirst || objToolbarContainer.childNodes.length == 0)
	        objToolbarContainer.appendChild(this.XULToolbarItemContainer);
	    else
	        objToolbarContainer.insertBefore(this.XULToolbarItemContainer, objToolbarContainer.firstChild);

	    //nullify stared attribute
	    EBImageHandler_CT2958529.NullifyStaredAttribute(this.XULElement);

	    //call the onload element
	    this.OnLoadElement();
	};

	this.RemoveFromToolbar = function(objToolbarContainer) {
	    this.UnloadComponent();
	    this.dynamicMenuComponent.RemoveFromToolbar(objToolbarContainer);
	};
	
	this.UnloadComponent = function()
	{
	    this.OnUnloadElement();
	    try {
	        //remove this progress listener of this browser xul element
	        this.XULBrowser.removeProgressListener(EmailWebListener_CT2958529);
	    }
	    catch (ex) { }

	};

	this.SetToolbarButtonClass = function()
	{
		this.dynamicMenuComponent.SetToolbarButtonClass();
	};

	this.GetToolbarItemContainer = function() {
	    return this.dynamicMenuComponent.XULToolbarItemContainer;
	};
	
	this.SetComponentCollapsed = function(isCollapsed)
	{
		this.dynamicMenuComponent.SetComponentCollapsed(isCollapsed);
	};

	this.AddToChevron = function(objXULContainer) {
	    this.XULChevronElement = null;
	    this.XULChevronElement = this.dynamicMenuComponent.AddToChevron(objXULContainer);

	    if (this.XULChevronElement) {
	        //set the dynamic data of the email notifier component(lable and image)
	        var strLabel = this.XULElement.getAttribute('label');
	        var strImage = this.XULElement.getAttribute('image');

	        this.XULChevronElement.setAttribute('label', strLabel);
	        this.XULChevronElement.setAttribute('image', strImage);

	        //since the settings comes without icon i need to set the menupopup 
	        //icon class
	        var strButtonClassGet = this.XULElement.getAttribute('class');
	        var strChevronClassGet = this.XULChevronElement.getAttribute('class');
	        var strClassSet = 'menu-iconic';

	        if (strButtonClassGet)
	            strClassSet += ' ' + strButtonClassGet;

	        if (strChevronClassGet)
	            strClassSet += ' ' + strChevronClassGet;

	        this.XULChevronElement.setAttribute('class', strClassSet);

	        //star logic for chevron, this menuitem is star candidate
	        EBChevronStaticManager_CT2958529.TransferStarLogicSettings(this.XULElement, this.XULChevronElement);

	        this.handleSetDetectionForChevron();
	        
	    }

	    return this.XULChevronElement;
	};

	this.UpdateUI = function(strLabel, strImage, strTooltipText, strTooltipID) {
	    this.dynamicMenuComponent.UpdateUI(strLabel, strImage, strTooltipText, strTooltipID);
	};

	this.OnLoadElement = function(isThread) {
	    //set the onload process in a separated thread
	    //cause this process can take a long time (loading from the file,calling to server etc...)
	    if (isThread) {
	        var objThreadFunction = function() {
	            EBEMailNotifierToolbarManager_CT2958529.OnLoadToolbarEMailNotifier();
	        };

	        //bigger timeout should fix the "tab effects" effect on loading file
	        //when timeout is small, on some machines the email accounts file is loaded empty
	        setTimeout(objThreadFunction, 1800);
	    }
	    else
	        EBEMailNotifierToolbarManager_CT2958529.OnLoadToolbarEMailNotifier();
	};

	this.OnUnloadElement = function() {
	    EBEMailNotifierToolbarManager_CT2958529.OnUnloadToolbarEMailNotifier();
	};
};

EBEMailNotifierComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBEMailNotifierComponent_CT2958529.constructor = EBEMailNotifierComponent_CT2958529;
function EBExternalComponent_CT2958529(externalComponentItem)
{
    EBBaseToolbarComponent_CT2958529.call(this, externalComponentItem);
	
	this.ComponentItem			= externalComponentItem;
	this.XULElement				= null;
	this.XULChevronElement		= null;
	this.DynamicMenuComponent	= null;
	this.TimeoutID = null;
	this.onloadCallback = null;

	this.Init = function() {
	    this.XULElement = EBXULFactory_CT2958529.CreateToolbarItem();
	    this.XULElement.setAttribute(EBExternalComponentConsts_CT2958529.Attributes.ComponentURL, this.ComponentItem.link);
	    this.XULElement.setAttribute(EBExternalComponentConsts_CT2958529.Attributes.ComponentInterval, this.ComponentItem.interval);

	    EBExternalComponentManager_CT2958529.GetComponent(this, false);

	    return true;
	};

	this.AddToToolbar = function(objToolbarContainer, isFirst) {
	    this.SetToolbarButtonClass();
	    
	    if (!isFirst || objToolbarContainer.childNodes.length == 0)
	        objToolbarContainer.appendChild(this.XULElement);
	    else
	        objToolbarContainer.insertBefore(this.XULElement, objToolbarContainer.firstChild);

	    if (this.DynamicMenuComponent) {
	        EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.DynamicMenuComponent.XULElement);
	        this.DynamicMenuComponent.SetChevronOnImageLoaded(true);
	    }

	    this.OnLoadElement();
	};

	this.RemoveFromToolbar = function(objToolbarContainer) {
	    try {
	        if (this.XULElement) {
	            this.UnloadComponent();
	            objToolbarContainer.removeChild(this.XULElement);
	        }
	    }
	    catch (e) {
	        EBLogging_CT2958529.LogToConsole(e, "cannot remove component");
	    }
	};

	this.OnBeforeRefresh = function() {
	    EBExternalComponentManager_CT2958529.NullifyLastCheckTime(this);
	};
	
	this.SetDisplayIconText = function(oDynamicMenuComponent)
	{ 
		var strDisplayIcon	= oDynamicMenuComponent.ComponentItem.DisplayIcon;
		var strDisplayText	= oDynamicMenuComponent.ComponentItem.DisplayText;
		
		if(strDisplayText)
			this.ComponentItem.DisplayIcon = strDisplayIcon;
		
		if(strDisplayText)
			this.ComponentItem.DisplayText = strDisplayText;
	};
	
	this.OnLoadElement = function()
	{
		EBExternalComponentManager_CT2958529.Initialize(this);
	};
	
	this.OnUnloadElement = function()
	{
		EBExternalComponentManager_CT2958529.Terminate(this);
	};
	
	this.UnloadComponent = function()
	{
		this.OnUnloadElement();	
	};
	
	this.SetToolbarButtonClass = function()
	{
		if(this.DynamicMenuComponent)
			this.DynamicMenuComponent.SetToolbarButtonClass();
	};

	this.SetComponentCollapsed = function(isCollapsed) {
	    if (this.DynamicMenuComponent)
	        this.DynamicMenuComponent.SetComponentCollapsed(isCollapsed);
	};
	
	this.GetToolbarItemContainer = function() {
	    return this.XULElement;
	};

	this.AddToChevron = function(objXULContainer) {
	    if (!this.DynamicMenuComponent) return null;
	    
	    return this.DynamicMenuComponent.AddToChevron(objXULContainer);
	};

	this.Onload = function(callback) {
	    if (this.DynamicMenuComponent)
	        this.DynamicMenuComponent.Onload(callback);
	    else
	        this.onloadCallback = callback;
	};

	this.RefreshComponent = function() {
	    EBExternalComponentManager_CT2958529.GetComponent(this, true);
	    return false;
	};

	this.InitMinimizedGadgets = function() {
	    this.DynamicMenuComponent.InitMinimizedGadgets();
	};

	this.DisposeMinimizedGadgets = function() {
	    this.DynamicMenuComponent.DisposeMinimizedGadgets();
	};

	this.SetDetected = function() {
	    this.isTemporary = true;
	    if (!this.XULElement) return;

	    this.XULElement.style.opacity = "0.3";
	    var self = this;
	    this.XULElement.onclick = function(e) {
	        if (e.which == 1) {
	            self.XULElement.style.opacity = "1";
	            self.isTemporary = false;
	            oToolbarManager_CT2958529.saveDetectedComponent(self.ComponentItem);
	            e.preventDefault();
	            return false;
	        }

	    };

	    //set detected tooltip
	    this.XULElement.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey("CELP_STR_ID_ENGINE_DETECTION_COMPONENTS_TOOLTIP"));
	};

	this.AddContextMenu = function(contextMenuId) {
	    if (this.isTemporary) return;

	    this.contextMenuIdForChevronElement = contextMenuId;
	    if (!this.DynamicMenuComponent) return false;
	    this.DynamicMenuComponent.AddContextMenu(contextMenuId);
	    return true;
	};
};

EBExternalComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBExternalComponent_CT2958529.constructor = EBExternalComponent_CT2958529;
var EBExternalComponentConsts_CT2958529 =
{
    Attributes:
	{
	    ComponentURL: 'EB_EXTERNAL_COMPONENT_URL',
	    ComponentInterval: 'EB_EXTERNAL_COMPONENT_INTERVAL'
	},

    folder: "externalmenu",

    cacheMode:
    {
        noCache: "NO_TB_CACHE",
        cacheOnError: "TB_CACHE_ON_ERROR_ONLY",
        fullCache: "TB_CACHE"
    }
};

var EBExternalComponentManager_CT2958529 =
{
    Initialize: function(oToolbarComponent) {
        if (!oToolbarComponent.TimeoutID) {
            this.SetTimeoutCheck(oToolbarComponent);
        }
    },

    Terminate: function(oToolbarComponent) {
        if (oToolbarComponent.TimeoutID) {
            clearTimeout(oToolbarComponent.TimeoutID);
            oToolbarComponent.TimeoutID = null;
        }
    },

    GetCacheModePrefName: function(objToolbarComponent) {
        return EBPreferenceConsts_CT2958529.ExternalComponentCacheMode + objToolbarComponent.ComponentItem.UniqueCompID;
    },

    GetCacheMode: function(objToolbarComponent) {
        var prefName = this.GetCacheModePrefName(objToolbarComponent);
        var cacheMode = (EBToolbarPreferenceManager_CT2958529.HasUserValue(prefName, true)) ?
                            EBToolbarPreferenceManager_CT2958529.GetPref(prefName, true) : objToolbarComponent.ComponentItem.cacheMode;
        if (!cacheMode) cacheMode = EBExternalComponentConsts_CT2958529.cacheMode.fullCache;
        return cacheMode;
    },

    SaveCacheMode: function(objToolbarComponent, cacheMode) {
        if (!cacheMode) return;
        var prefName = this.GetCacheModePrefName(objToolbarComponent);
        EBToolbarPreferenceManager_CT2958529.SetPref(prefName, cacheMode, true);
    },

    GetComponent: function(objToolbarComponent, isForceCheck) {
        try {
            var cacheMode = this.GetCacheMode(objToolbarComponent);
            if (isForceCheck || this.IsElapsed(objToolbarComponent) ||
                !this.isFileExists(objToolbarComponent) ||
                cacheMode == EBExternalComponentConsts_CT2958529.cacheMode.noCache)
                this.CheckFromServer(objToolbarComponent, isForceCheck);
            else {
                this.getComponentFromFile(objToolbarComponent);
                if (cacheMode == EBExternalComponentConsts_CT2958529.cacheMode.cacheOnError)
                    this.CheckFromServer(objToolbarComponent);
            }
        }
        catch (ex) {
            EBLog(ex);
        }
        finally {
            this.SetTimeoutCheck(objToolbarComponent);
        }
    },

    SetTimeoutCheck: function(objToolbarComponent) {
        var iInterval = this.GetIntervalTime(objToolbarComponent);

        var objIntervalFunction = function() {
            EBExternalComponentManager_CT2958529.GetComponent(objToolbarComponent, false);
        };
        //set the timeout to call the next time
        objToolbarComponent.TimeoutID = setTimeout(objIntervalFunction, iInterval);
    },

    GetIntervalTime: function(objToolbarComponent) {
        var XULToolbarItem = objToolbarComponent.XULElement;
        var iIntervalInMinute = XULToolbarItem.getAttribute(EBExternalComponentConsts_CT2958529.Attributes.ComponentInterval);
        var iIntervalTime = 1000 * 60 * iIntervalInMinute;

        return iIntervalTime;
    },

    getUrlFromComponent: function(objToolbarComponent) {
        var XULToolbarItem = objToolbarComponent.XULElement;
        var strURL = XULToolbarItem.getAttribute(EBExternalComponentConsts_CT2958529.Attributes.ComponentURL);
        return strURL;
    },

    CheckFromServer: function(objToolbarComponent, bypassCache) {
        this.SetComponentPrefPollDate(objToolbarComponent);

        var strURL = this.getUrlFromComponent(objToolbarComponent);
        var cacheMode = this.GetCacheMode(objToolbarComponent);
        var oCallBackFunction = function(strXML, o) {
            var XMLDoc = EBXML_CT2958529.GetXmlDocument(strXML);
            if (cacheMode != EBExternalComponentConsts_CT2958529.cacheMode.noCache && EBXML_CT2958529.IsLegal(XMLDoc))
                EBExternalComponentManager_CT2958529.saveMenuXml(strXML, strURL);

            EBExternalComponentManager_CT2958529.BroadcastParseComponent(objToolbarComponent, XMLDoc);
        };

        strURL = EBActionManager_CT2958529.ConvertAliasesUrl(strURL);
        EBWeb_CT2958529.HTTPServerRequest(strURL, null, false, oCallBackFunction, bypassCache);
    },

    _getFullFilePath: function(strUrl) {
        var strFilename = EBGlobalManager_CT2958529.ToLegalFileName(strUrl);
        var strFullPath = EBExternalComponentConsts_CT2958529.folder + EBDirIO_CT2958529.sep + strFilename;
        return strFullPath;
    },

    isFileExists: function(objToolbarComponent) {
        var strUrl = this.getUrlFromComponent(objToolbarComponent);
        return EBIOManager_CT2958529.IsToolbarFileExists(this._getFullFilePath(strUrl));
    },

    getComponentFromFile: function(objToolbarComponent) {
        var strUrl = this.getUrlFromComponent(objToolbarComponent);
        var strFilename = this._getFullFilePath(strUrl);
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(strFilename);
        var strXml = EBFileIO_CT2958529.read(oFile, EBGlobalConsts_CT2958529.DefaultCharset);

        if (!strXml) return;

        var XMLDoc = EBXML_CT2958529.GetXmlDocument(strXml);
        EBExternalComponentManager_CT2958529.ParseComponent(objToolbarComponent, XMLDoc);
    },

    saveMenuXml: function(strXml, strUrl) {
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(this._getFullFilePath(strUrl));
        EBFileIO_CT2958529.write(oFile, strXml, "", EBGlobalConsts_CT2958529.DefaultCharset);
    },

    IsElapsed: function(objToolbarComponent) {
        var strPrefName = this.GetFullPrefName(objToolbarComponent);
        var strPrefDateValue = EBToolbarPreferenceManager_CT2958529.GetPref(strPrefName);

        if (!strPrefDateValue) return true;

        var objCurrentDate = new Date();
        var objPollDate = new Date(strPrefDateValue);

        var iCheckIntervalTime = this.GetIntervalTime(objToolbarComponent);

        var iDateDiff = objCurrentDate - objPollDate;

        return iDateDiff > iCheckIntervalTime;
    },

    SetComponentPrefPollDate: function(objToolbarComponent) {
        var strPrefName = this.GetFullPrefName(objToolbarComponent);
        var objCurrentDate = new Date();
        var strDateValue = objCurrentDate.toString();
        EBToolbarPreferenceManager_CT2958529.SetPref(strPrefName, strDateValue);
    },

    GetFullPrefName: function(objToolbarComponent) {
        var strPrefNamePrefix = EBPreferenceConsts_CT2958529.ExternalComponentPrefix;
        var strCompID = objToolbarComponent.ComponentItem.UniqueCompID;

        var strFullPrefName = strPrefNamePrefix + strCompID;

        return strFullPrefName;
    },

    BroadcastParseComponent: function(objToolbarComponent, XMLDoc) {
        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var oWindow = null;
        var compId = objToolbarComponent.ComponentItem.UniqueCompID;
        for (var i = 0; i < arrWindows.length; i++) {
            oWindow = arrWindows[i];
            if (oWindow.EBExternalComponentManager_CT2958529) {
                var objExtComponent = oWindow.EBComponentsManager_CT2958529.GetComponentByCompID(compId);
                oWindow.EBExternalComponentManager_CT2958529.ParseComponent(objExtComponent, XMLDoc);
            }
        }
    },

    ParseComponent: function(objToolbarComponent, XMLDoc) {
        if (!EBXML_CT2958529.IsLegal(XMLDoc)) return;

        var xmlDocumentElement = XMLDoc.documentElement;
        var cacheMode = EBXML_CT2958529.GetSingleNodeValue(xmlDocumentElement, "CACHE_MODE", "");

        //update cache mode from external xml
        if (cacheMode) this.SaveCacheMode(objToolbarComponent, cacheMode);

        var objItemData = objToolbarComponent.ComponentItem.objData.clone();
        objItemData.xmlNode = xmlDocumentElement;
        var objDynamicMenuItem = oToolbar_CT2958529.toolbarDataParsing.toolbarItemsFactory.GetInstance(objItemData);

        var objDynamicMenuComponent = EBToolbarFactoryComponent_CT2958529.GetInstance(objDynamicMenuItem);
        var XULToolbarItem = objToolbarComponent.XULElement;

        if (objDynamicMenuComponent == null) return;
        objDynamicMenuComponent.ComponentItem.UniqueCompID = objToolbarComponent.ComponentItem.UniqueCompID;

        //empty toolbar item
        while (XULToolbarItem.childNodes.length > 0) {
            XULToolbarItem.removeChild(XULToolbarItem.firstChild);
        }

        objDynamicMenuComponent.isFromExternalComponent = true;
        if (EBActionManager_CT2958529.IsAppView()) {
            if (!objDynamicMenuComponent.ComponentItem.appInfo.imageUrl)
                objDynamicMenuComponent.ComponentItem.appInfo.imageUrl = objToolbarComponent.ComponentItem.appInfo.imageUrl;
            objDynamicMenuComponent.ComponentItem.compThumbnailUrl = objToolbarComponent.ComponentItem.compThumbnailUrl;
        }

        if (!objDynamicMenuComponent.Init()) {
            objToolbarComponent.DynamicMenuComponent = null;
            return;
        }

        objDynamicMenuComponent.AddToToolbar(XULToolbarItem);
        if (objToolbarComponent.onloadCallback) {
            objDynamicMenuComponent.Onload(objToolbarComponent.onloadCallback);
            objToolbarComponent.onloadCallback = null;
        }

        //set the display Text & Icon
        objToolbarComponent.SetDisplayIconText(objDynamicMenuComponent);

        //set the component to the external class
        objToolbarComponent.DynamicMenuComponent = objDynamicMenuComponent;
        if (objToolbarComponent.contextMenuIdForChevronElement)
            objDynamicMenuComponent.AddContextMenu(objToolbarComponent.contextMenuIdForChevronElement);

        EBChevronStaticManager_CT2958529.onchange(false);
    },

    NullifyLastCheckTime: function(objToolbarComponent) {
        var strPrefName = this.GetFullPrefName(objToolbarComponent);
        EBToolbarPreferenceManager_CT2958529.SetPref(strPrefName, null);
    }
};

function EBFacebookComponent_CT2958529(FacebookItem) {
    EBBaseToolbarComponent_CT2958529.call(this, FacebookItem);

    this.dynamicMenuComponent = null;
    this.XULElement = null;
    this.dynamicMenuXULElement = null;
    this.XULLoginButton = null;
    this.observer = null;
    this.buttonCommandCallback = null;
    var isDynamicMenu = false;
    var xulMenuPopup = null;
    var isFirstTime = true;
    var dynMenuPopupShowingCallback = null;
    var dynMenuPopupHidingCallback = null;
    //pointer to the facebook manager XPCOM
    this.facebookManager = oToolbar_CT2958529.facebook.manager;
    this.languagePack = oToolbarManager_CT2958529.data.languagePack;
    var that = this;

    this.Init = function() {
        this.facebookManager.register(this.ComponentItem, this.languagePack, EBActionManager_CT2958529.GetToolbarName(), oToolbarManager_CT2958529.getLocale());

        dynMenuPopupShowingCallback = function(event) {
            that.OnMainPopupShowing(event);
            EBUsageFacebook_CT2958529.OnOpenMenu();
        };

        dynMenuPopupHidingCallback = function(event) {
            that.OnMainPopupHiding(event);
            EBUsageFacebook_CT2958529.OnCloseMenu(that.ComponentItem.UniqueCompID, that.ComponentItem.CompType);
        };

        return true;
    };

    this.AddToToolbar = function(objToolbarContainer, isFirst) {
        //add only container at the beginning
        this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
        
        if (!isFirst || objToolbarContainer.childNodes.length == 0)
            objToolbarContainer.appendChild(this.XULToolbarItemContainer);
        else
            objToolbarContainer.insertBefore(this.XULToolbarItemContainer, objToolbarContainer.firstChild);

        if (!this.dynamicMenuComponent)
            this.setDynamicMenu();

        if (this.dynamicMenuComponent)
            this.addComponentToToolbar();

        this.OnLoadElement();
    };

    this.addComponentToToolbar = function() {
        //get the button
        this.setLoginButton();
        this.XULElement = this.XULLoginButton;

        //set toolbar button class[before adding to toolbar - important!]:
        this.SetToolbarButtonClass();

        //clear container
        while (this.XULToolbarItemContainer.firstChild)
            this.XULToolbarItemContainer.removeChild(this.XULToolbarItemContainer.firstChild);

        this.XULToolbarItemContainer.appendChild(this.XULElement);

        this.SetChevronOnImageLoaded();

        //set the button global style[after adding to toolbar - important!]:
        EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement);

        if (this.facebookManager.isInit) {
            if (this.facebookManager.isLoggedIn)
                setTimeout(function() {
                    that.changeButton(oToolbar_CT2958529.facebook.consts.observer.loggedIn);
                }, 1);
            else
                setTimeout(function() {
                    that.changeButton(oToolbar_CT2958529.facebook.consts.observer.logout);
                }, 1);
        }
    };

    this.RemoveFromToolbar = function(objToolbarContainer) {
        if (isDynamicMenu && this.dynamicMenuComponent)
            this.dynamicMenuComponent.RemoveFromToolbar(objToolbarContainer);
        else {
            try {
                if (this.XULToolbarItemContainer) {
                    objToolbarContainer.removeChild(this.XULToolbarItemContainer);
                    this.ComponentItem = null;
                    this.XULChevronElement = null;
                }
            }
            catch (e) {
                EBLog(e, "cannot remove component");
            }
        }
        this.UnloadComponent();
    };

    this.UnloadComponent = function() {
        if (this.observer) {
            this.observer.unregister();
            this.observer = null;
        }
    };

    this.SetToolbarButtonClass = function() {
        if (isDynamicMenu && this.dynamicMenuComponent)
            this.dynamicMenuComponent.SetToolbarButtonClass();
        else if (!this.ComponentItem.button || this.ComponentItem.button.image)
            EBToolbarDesignManager_CT2958529.SetToolbarButtonClass(this.ComponentItem.UniqueCompID, this.XULElement);
    };

    this.GetToolbarItemContainer = function() {
        return this.XULToolbarItemContainer
    };

    this.AddToChevron = function(objXULContainer) {
        if (isDynamicMenu && this.dynamicMenuComponent)
            this.XULChevronElement = this.dynamicMenuComponent.AddToChevron(objXULContainer);
        else {
            try {
                if (this.XULChevronElement) {
                    this.XULChevronElement.removeEventListener("command", this.buttonCommandCallback, false);
                    this.XULChevronElement = null;
                }
            }
            catch (e) {
                EBLog(e);
            }

            if (this.XULElement) {
                var strLabel = this.XULElement.getAttribute('label');
                var strImage = this.XULElement.getAttribute('image');
                var strHint = this.XULElement.getAttribute('tooltiptext');

                this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuItem(strLabel, strImage, strHint, this.buttonCommandCallback, "", null);
                objXULContainer.appendChild(this.XULChevronElement);


                this.handleSetDetectionForChevron();
            }
        }

        if (this.XULChevronElement) {
            //since the settings comes without icon i need to set the menupopup 
            //icon class
            var strButtonClassGet = this.XULElement.getAttribute('class');
            var strChevronClassGet = this.XULChevronElement.getAttribute('class');
            var strClassSet = 'menu-iconic';

            if (strButtonClassGet)
                strClassSet += ' ' + strButtonClassGet;

            if (strChevronClassGet)
                strClassSet += ' ' + strChevronClassGet;

            this.XULChevronElement.setAttribute('class', strClassSet);

            //star logic for chevron, this menuitem is star candidate
            EBChevronStaticManager_CT2958529.TransferStarLogicSettings(this.XULElement, this.XULChevronElement);
        }

        return this.XULChevronElement;
    };

    this.OnOutOfChevron = function() {
        if (isDynamicMenu && this.dynamicMenuComponent)
            this.dynamicMenuComponent.OnOutOfChevron();
    };

    this.UpdateUI = function(strLabel, strImage, strTooltipText, strTooltipID) {
        if (this.dynamicMenuComponent)
            this.dynamicMenuComponent.UpdateUI(strLabel, strImage, strTooltipText, strTooltipID);
    };

    this.OnLoadElement = function(isThread) {
        if (!this.observer) {
            this.observer = new EBFacebookObserver_CT2958529(this, this.changeButton, this.setStarIcons, this.onDynamicMenuReady);
            this.observer.register();
        }
    };

    this.onDynamicMenuReady = function() {
        this.setDynamicMenu();
        this.addComponentToToolbar();
    };
    
    this.setStarIcons = function(status) {
        if (status == oToolbar_CT2958529.facebook.consts.observer.addStar)
            EBImageHandler_CT2958529.UpdateStar(this.XULElement, true);
        else if (status == oToolbar_CT2958529.facebook.consts.observer.removeStar)
            EBImageHandler_CT2958529.UpdateStar(this.XULElement, false);

        /*
        for (i = 0; i < xulMenuPopup.childNodes.length; i++) {
        item = xulMenuPopup.childNodes[i];
        if (item.tagName == 'menuitem') {
        var name = item.getAttribute("eb-command");
        var isStar = getIsStar(name);
        if (isStar)
        EBImageHandler_CT2958529.UpdateStar(item, true);
        else
        EBImageHandler_CT2958529.UpdateStar(item, false);
        }
        }
        */
    };

    this.OnMainPopupHiding = function(event) {
        this.facebookManager.isStarred = false;
    };

    this.OnMainPopupShowing = function(event) {
        if (event.eventPhase != 2) return;

        var item;
        var is2Separator = false;

        for (i = 0; i < xulMenuPopup.childNodes.length; i++) {
            item = xulMenuPopup.childNodes[i];
            if (item.tagName == 'menuseparator') {
                if (is2Separator)
                    item.style.display = "none";
                else {
                    item.style.display = "";
                    is2Separator = true;
                }
            }
            else {
                if (item.tagName == 'menuitem') {
                    var name = item.getAttribute("eb-command");
                    var number = parseInt(this.getNewFeedsNum(name));
                    var userName = this.facebookManager.userName;
                    if (!name || number != 0 || name == "FB_INBOX" || name == "FB_LOGOUT") {
                        if (isFirstTime && name == "link") item.addEventListener("command", function(e) {
                            that.setOnItemClickForLinks(e);
                        }, false);
                        if (number > 0 && name)
                            EBUILogic_Functions_CT2958529.setAcceltext(item, "[" + number + "]");
                        else
                            EBUILogic_Functions_CT2958529.setAcceltext(item, "");
                        if (name != "link" && number == -1 && name != "FB_INBOX")
                            item.style.display = "none";
                        else {
                            item.style.display = "";
                            is2Separator = false;
                        }


                        if (name == "FB_LOGOUT" && userName)
                            EBUILogic_Functions_CT2958529.setAcceltext(item, "[" + userName + "]");
                    }

                    else
                        item.style.display = "none";
                }
            }
        }
        isFirstTime = false;
    };

    this.setOnItemClickForLinks = function() {
        EBUsageFacebook_CT2958529.OnItemClick(this.ComponentItem.UniqueCompID, this.ComponentItem.UniqueCompID, this.ComponentItem.CompType);
    };

    this.getNewFeedsNum = function(command) {
        switch (command) {
            case "FB_INBOX":
                return this.facebookManager.inboxUnreadNum;
                break;
            case "FB_FRIENDS":
                return this.facebookManager.friendsRequestNum;
                break;
            case "FB_GROUPS":
                return this.facebookManager.groupsRequestNum;
                break;
            case "FB_EVENTS":
                return this.facebookManager.eventsRequestNum;
                break;
            default: return null;
        }
    };

    this.setLoginButton = function() {
        var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
        var strLabel = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_COMPONENT_LOGIN_TEXT');
        var strImage = this.dynamicMenuComponent.ComponentItem.button.image;
	    var key =  EBGlobalConsts_CT2958529.IsEngine ? 'CELP_STR_ID_FACEBOOK_COMPONENT_LOGGED_OUT_HINT' : 'CTLP_STR_ID_FACEBOOK_COMPONENT_LOGGED_OUT_HINT'
        var strHint = oToolbarManager_CT2958529.getLPKey(key);
        
        var commandFunc = function(event) {
            EBFacebookCommands_CT2958529.ActivateSpecialCommand(event, "FB_LOGIN");
            event.cancelBubble = true;
        };
        this.buttonCommandCallback = this.WrappFunctions(commandFunc);
        this.XULLoginButton = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, "button", strLabel, strImage, strHint, this.buttonCommandCallback, "");
    };

    this.setDynamicMenu = function() {
        var dynamicMenuItem = this.facebookManager.getDynamicMenuItem(oToolbarManager_CT2958529.getLocale(), this.ComponentItem);
        if (!dynamicMenuItem) return;
        this.dynamicMenuComponent = EBToolbarFactoryComponent_CT2958529.GetInstance(dynamicMenuItem);
        if (!this.dynamicMenuComponent) return false;
        
        //replace the default image with publisher
        if (this.ComponentItem.fbIconUrl)
            this.dynamicMenuComponent.ComponentItem.button.image = this.ComponentItem.fbIconUrl;
        this.dynamicMenuComponent.sendMenuOpenUsage = false;
        this.dynamicMenuComponent.ComponentItem.UniqueCompID = this.ComponentItem.UniqueCompID;
        this.dynamicMenuComponent.changeCommandsClass(EBFacebookCommands_CT2958529);
        if (!this.dynamicMenuComponent.Init(true)) return false;
        	var key =  EBGlobalConsts_CT2958529.IsEngine ? 'CELP_STR_ID_FACEBOOK_COMPONENT_LOGGED_IN_HINT' : 'CTLP_STR_ID_FACEBOOK_COMPONENT_LOGGED_IN_HINT'
        var strHint = oToolbarManager_CT2958529.getLPKey(key);
        this.dynamicMenuComponent.XULElement.setAttribute("tooltiptext", strHint);
        return true;
    };

    this.openFacebookGadgetWindow = function(strUrl, type, height, width) {
        var popHtmlData = new oToolbar_CT2958529.toolbarDataParsing.dataObjects.PopHtml();
        popHtmlData.popHtmlUrl = EBActionManager_CT2958529.ConvertAliasesUrl(strUrl);
        popHtmlData.parentElement = this.XULElement;
        popHtmlData.openPositionType = popHtmlData.openPositionTypes.alignment;
        popHtmlData.openPositionData.vertical = popHtmlData.openPositionTypes.verticalAlignmentBottom;
        popHtmlData.width = width;
        popHtmlData.height = height;
        popHtmlData.resizable = true;
        popHtmlData.isUser = false;
        popHtmlData.saveLocation = false;
        popHtmlData.saveSize = false;
        popHtmlData.componentId = this.ComponentItem.UniqueCompID;
        popHtmlData.elementId = this.ComponentItem.UniqueCompID;
        popHtmlData.compType = this.ComponentItem.compType;
        popHtmlData.gadgetType = EBGadgetManager_CT2958529.GADGET_TYPE_FACEBOOK;
        popHtmlData.facebookGagetType = type;
        popHtmlData.titleIconUrl = this.XULElement.getAttribute("image");
        popHtmlData.minimizable = false;

        var strButtonId = this.XULElement.getAttribute("id");
        popHtmlData.parentElement = document.getElementById(strButtonId);
        EBGadgetManager_CT2958529.OpenGadget(popHtmlData);
    };

    this.AddContextMenu = function(contextMenuId) {
        if (this.isTemporary) return;

        this.contextMenuIdForChevronElement = contextMenuId;
        return true;
    };

    this._addContextMenu = function() {
        if (!this.XULElement) return false;

        this.XULElement.setAttribute("eb-comp-id", this.ComponentItem.UniqueCompID);
        this.XULElement.setAttribute("context", this.contextMenuIdForChevronElement);

        //for Linux / Mac - set here event listener
        if (!EBGlobalManager_CT2958529.IsWindowsPlatform()) {
            this.XULElement.addEventListener("contextmenu", function(event) {
                EBToolbarManager_CT2958529.contextMenuManager.contextMenuCompId = self.ComponentItem.UniqueCompID;
            }, false);
        }

        return true;
    };

    this.changeButton = function(type) {
        if (type == oToolbar_CT2958529.facebook.consts.observer.loggedIn) {
            try {
                this.XULElement.removeEventListener("command", this.buttonCommandCallback, false);
            } catch (e) { EBLog(e); }
            this.XULToolbarItemContainer.removeChild(this.XULElement);
            this.setDynamicMenu();
            this.XULElement = this.dynamicMenuComponent.XULElement;
            isDynamicMenu = true;
            this.XULToolbarItemContainer.appendChild(this.XULElement);
            //override the popupshowing of the dynamic menu
            xulMenuPopup = this.dynamicMenuComponent.XULMenuPopup;

            if (xulMenuPopup) {
                xulMenuPopup.addEventListener("popupshowing", dynMenuPopupShowingCallback, false);
                xulMenuPopup.addEventListener("popuphiding", dynMenuPopupHidingCallback, false);
            }
        }
        else if (type == oToolbar_CT2958529.facebook.consts.observer.logout) {
            try {
                xulMenuPopup = this.dynamicMenuComponent.XULMenuPopup;

                if (xulMenuPopup) {
                    xulMenuPopup.removeEventListener("popupshowing", dynMenuPopupShowingCallback, false);
                    xulMenuPopup.removeEventListener("popuphiding", dynMenuPopupHidingCallback, false);
                }
            }
            catch (e) { EBLog(e); }

            this.XULToolbarItemContainer.removeChild(this.XULElement);
            this.XULElement = this.XULLoginButton;
            isDynamicMenu = false;
            this.XULToolbarItemContainer.appendChild(this.XULElement);
            this.XULElement.addEventListener("command", this.buttonCommandCallback, false);
        }

        if (this.facebookManager.isStarred && type == oToolbar_CT2958529.facebook.consts.observer.loggedIn)
            EBImageHandler_CT2958529.UpdateStar(this.XULElement, true);

        //recalculate chevron, cause text is removed or added
        EBChevronStaticManager_CT2958529.onchange(false);
        this.SetToolbarButtonClass();

        //set the button global style[after adding to toolbar - important!]:
        EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement);
        this._addContextMenu();
    };

    this.OnLanguagePackChange = function() {
        this.facebookManager.updateLanguagePackAndToolbarName(this.languagePack, EBActionManager_CT2958529.GetToolbarName());
    };

    this.callbackForGetDataForUpdateStatus = function(strJson, type) {
        try {
            var json = JSON.parse(strJson);
        } catch (exp) {
            EBLog('JSON.parse: ' + exp);
            return;
        }
        json = json[0];
        var message;
        var picture;
        var settingObj = oToolbar_CT2958529.facebook.manager.facebookSettings;
        var urlStr = oToolbar_CT2958529.facebook.manager.facebookSettings.gadget.facebookUpdateStatusUrl;
        urlStr += "?" + oToolbar_CT2958529.facebook.manager.facebookSettings.gadget.facebookUpdateStatusParams;

        message = json.status.message;
        picture = json.pic_square;
        urlStr = urlStr.replace(/EB_FB_CURRENT_STATUS/g, message);
        urlStr = urlStr.replace(/EB_FB_USER_NAME/g, json.name);
        if (picture)
            urlStr = urlStr.replace(/EB_FB_USER_IMAGE_URL/g, picture);
        else
            urlStr = urlStr.replace(/EB_FB_USER_IMAGE_URL/g, settingObj.images.facebookDefaultProfileImgUrl);

        urlStr = urlStr.replace(/EB_FB_STATUS_TXT/g, oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_STATUS_GADGET_STATUS_TXT'));
        urlStr = urlStr.replace(/EB_FB_INPUT_DEFAULT_TXT/g, oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_STATUS_GADGET_INPUT_TXT'));
        urlStr = urlStr.replace(/EB_FB_POST_TXT/g, oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_STATUS_GADGET_POST_TXT'));
        urlStr = urlStr.replace(/EB_FB_CANCEL_TXT/g, oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_STATUS_GADGET_CANCEL_TXT'));
        if (!message) {
            urlStr = urlStr.replace(/EB_FB_CLEAR_TXT/g, "");
            urlStr = urlStr.replace(/EB_FB_STATUS_TIME/g, "");
        }
        else {
            urlStr = urlStr.replace(/EB_FB_CLEAR_TXT/g, oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_FACEBOOK_STATUS_GADGET_CLEAR_TXT'));
            urlStr = urlStr.replace(/EB_FB_STATUS_TIME/g, "");
        }
        if (EBGlobalManager_CT2958529.IsToolbarRTL())
            urlStr = urlStr.replace(/EB_FB_ALIGNMENT/g, "rtl");
        else
            urlStr = urlStr.replace(/EB_FB_ALIGNMENT/g, "ltr");

        this.openFacebookGadgetWindow(urlStr, type, settingObj.gadget.facebookUpdateStatusHeight, settingObj.gadget.facebookUpdateStatusWidth);
    };

    this.getRelTimeWithinWeek = function(time, initialCap) {
        var currentTime = new Date;

        var updateTime = new Date;
        updateTime.setTime(time * 1000);

        var days = new Array("Sunday", "Monday", "Tuesday", "Wednesday",
                       "Thursday", "Friday", "Saturday");
        var day;

        // assumption that status messages are only shown if in the last 7 days
        if (updateTime.getDate() == currentTime.getDate())
            day = initialCap ? "Today" : "today";
        else if ((updateTime.getDay() + 1) % 7 == currentTime.getDay())
            day = initialCap ? "Yesterday" : "yesterday";
        else
            day = days[updateTime.getDay()];

        var hour = updateTime.getHours();
        if (hour > 11) timeOfDay = 'pm';
        else timeOfDay = 'am';
        if (hour >= 13) hour -= 12;
        if (hour == 0) hour = 12;

        var minute = updateTime.getMinutes();
        if (minute < 10) {
            minute = '0' + minute;
        }

        var tstr = day + ' at ' + hour + ':' + minute + ' ' + timeOfDay;
        return tstr;
    }
};

EBFacebookComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBFacebookComponent_CT2958529.constructor = EBFacebookComponent_CT2958529;
function EBFacebookObserver_CT2958529(that, callbackForChangeButton, callbackForChangeStar, callbackDynamicMenuReady) {
    this.Topic = oToolbar_CT2958529.facebook.consts.observer.topic;
    
    this.observe = function(aSubject, aTopic, aData) {
        try {
            switch (aData) {
                case oToolbar_CT2958529.facebook.consts.observer.loggedIn:
                case oToolbar_CT2958529.facebook.consts.observer.logout:
                    callbackForChangeButton.call(that, aData);
                    break;

                case oToolbar_CT2958529.facebook.consts.observer.addStar:
                case oToolbar_CT2958529.facebook.consts.observer.removeStar:
                    callbackForChangeStar.call(that, aData);
                    break;

                case oToolbar_CT2958529.facebook.consts.observer.dynamicMenuReady:
                    var locale = aSubject.wrappedJSObject.locale;
                    if (locale == oToolbarManager_CT2958529.getLocale())
                        callbackDynamicMenuReady.call(that);
                    break;
            }
        }
        catch (e) {
            EBLog(e, "EBFacebookObserver");
        }
    }
}

EBFacebookObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();
function EBFeedComponent_CT2958529(feedItem) {
    EBBaseToolbarComponent_CT2958529.call(this, feedItem);
    
    this.ComponentItem = feedItem;
    this.IsMultiFeed = false;

    //save the comp id of the multi feed in every multi feed child to 
    //retrieve it using its children!
    this.MultiFeedCompID = '';
    this.MultiFeedChildIndex = -1;
    this.IsLiveMode = false;
    this.XULElement = null;
    this.XULChevronElement = null;
    this.XULToolbarItemContainer = null;

    this.callbackFunc = null;
    this.callbackFuncThis = null;
    this.isCustom = false;

    /********** Component & Dialog Data **********/
    //timeout id for the thread running
    this.TimeoutID = null;
    //indicates whether this component in the middle of loading data from the server
    //to abort it after certain time(built in timeout to the server request)
    this.LoadingFromServer = false;
    //keep the data of the structured and history in the component
    this.FeedData = null;
    this.HistoryData = null;
    this.NumOfNew = 0;
    //the position of the div scroll in the dialog
    this.ContainerScrollTop = 0;
    this.observer = null;

    this.Init = function() {
        this.IsLiveMode = this.ComponentItem.LiveMode;
        this.ComponentItem.IconNormalURL = EBDefaultsManager_CT2958529.getImageUrl(this.ComponentItem.IconNormalURL);
        //create the xul element 
        //if this is part of multi feed this is a menu item 
        //if it's regular feed it's a button
        if (!this.IsMultiFeed) {
            var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
            var strImage, strLabel, strBackupImage;
            if (EBActionManager_CT2958529.IsAppView()) {
                strImage = this.ComponentItem.appInfo.imageUrl;
                strBackupImage = this.ComponentItem.compThumbnailUrl;
            }
            else {
                strImage = this.ComponentItem.IconNormalURL;
                strLabel = this.ComponentItem.Title;

                if (!this.IsLiveMode) {
                    var iFeedCount = EBFeedManager_CT2958529.GetFeedsCount(this.ComponentItem.UniqueCompID);
                    strLabel += ' [' + iFeedCount + ']'
                }
            }

            this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, 'menu', strLabel, strImage, "", "", "", EBActionManager_CT2958529.IsAppView(), strBackupImage);
            this.XULElement.setAttribute("context", "");
            if (!this.IsLiveMode && EBActionManager_CT2958529.IsAppView())
                this.XULElement.setAttribute("notificationNumber", iFeedCount);

            //create the menupopup
            var strOnPopupShowing = '';
            var strOnPopupHiding = '';

            strOnPopupShowing = 'return EBFeedUIManager_CT2958529.onFeedShowing(event,\'' + this.ComponentItem.UniqueCompID + '\',-1);';
            strOnPopupHiding = "";

            var oMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup('', strOnPopupShowing, strOnPopupHiding);
            oMenuPopup.setAttribute("class", "ebFeedDialogPopup_CT2958529");
            this.XULElement.appendChild(oMenuPopup);
        }

        //create the tooltip element (for the shrink-unshrink tooltip)
        if (!this.IsMultiFeed)
            this.CreateTooltipShrink();

        return true;
    };

    this.GetFeedTitle = function() {
        var strTitle = this.ComponentItem.Title;

        strTitle = EBGlobalManager_CT2958529.TrimToOne(strTitle);
        strTitle = EBXML_CT2958529.FromLegalXml(strTitle);

        return strTitle;
    };

    this.GetFeedCount = function(bIsMultifeed) {
        EBFeedManager_CT2958529.SetFeedsCount(this.ComponentItem.UniqueCompID, this.NumOfNew);
        return this.NumOfNew;
    };

    this.IsStared = function() {
        if (this.IsLiveMode) return false;
        
        var bIsStared = false;

        if (this.FeedData)
            bIsStared = this.FeedData.Data.Stared;

        return bIsStared;
    };

    this.GetFeedImage = function() {
        return this.ComponentItem.IconNormalURL;
    };

    this.AddToToolbar = function(objToolbarContainer, isFirst) {
        //set toolbar button class[before adding to toolbar - important!]:
        this.SetToolbarButtonClass();

        this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
        this.XULToolbarItemContainer.appendChild(this.XULElement);
        
        if (!isFirst || objToolbarContainer.childNodes.length == 0)
            objToolbarContainer.appendChild(this.XULToolbarItemContainer);
        else
            objToolbarContainer.insertBefore(this.XULToolbarItemContainer, objToolbarContainer.firstChild);

        this.SetChevronOnImageLoaded();

        //set the button global style[after adding to toolbar - important!]:
        if (!this.IsMultiFeed)
            EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement);

        //nullify stared attribute
        EBImageHandler_CT2958529.NullifyStaredAttribute(this.XULElement);

        //call the onload element
        this.OnLoadElement();
    };

    this.UnloadComponent = function() {
        this.OnUnloadElement();
    };

    this.SetToolbarButtonClass = function() {
        if (!this.IsMultiFeed)
            EBToolbarDesignManager_CT2958529.SetToolbarButtonClass(this.ComponentItem.UniqueCompID, this.XULElement);
    };

    this.SetComponentCollapsed = function(isCollapsed) {
        if (this.XULToolbarItemContainer)
            this.XULToolbarItemContainer.setAttribute('collapsed', isCollapsed);
    };

    this.AddToChevron = function(objXULContainer) {
        this.XULChevronElement = null;
        var strImage = this.XULElement.getAttribute("image");

        this.XULChevronElement = EBXULFactory_CT2958529.CreateMenu("", strImage, "");

        var objAttribute = null;
        for (var i = 0; i < this.XULElement.attributes.length; i++) {
            objAttribute = this.XULElement.attributes[i];
            if (objAttribute.name.toLowerCase() != 'class' &&
			    objAttribute.name.toLowerCase() != 'tooltip' &&
			    objAttribute.name.toLowerCase() != 'label' &&
			    objAttribute.name.toLowerCase() != 'image' &&
			    objAttribute.name != EBImageHandler_CT2958529.Consts.StarredAttribute) {
                this.XULChevronElement.setAttribute(objAttribute.name, objAttribute.value);
            }
        }

        //star logic for chevron, this menuitem is star candidate
        EBChevronStaticManager_CT2958529.TransferStarLogicSettings(this.XULElement, this.XULChevronElement);

        var txtClass = this.XULChevronElement.getAttribute('class');
        var strLabel = this.GetFeedTitle();
        this.XULChevronElement.setAttribute('class', txtClass);
        strLabel = EBXML_CT2958529.FromLegalXml(strLabel);
        this.XULChevronElement.setAttribute('label', strLabel);

        if (!this.IsLiveMode)
            this.XULChevronElement.setAttribute('acceltext', "[" + this.GetFeedCount() + "]");


        //set the tooltiptext - in case of shrink mode so there is special tooltip shrink
        //we need to return it to the original tooltip
        var strOriginalTooltip = this.XULElement.getAttribute(EBGlobalConsts_CT2958529.Attributes.XULTooltip);
        if (strOriginalTooltip)
            this.XULChevronElement.setAttribute('tooltiptext', strOriginalTooltip);

        var XULMenuPopup = this.XULElement.firstChild.cloneNode(true);

        if (XULMenuPopup)
            this.XULChevronElement.appendChild(XULMenuPopup);

        objXULContainer.appendChild(this.XULChevronElement);

        this.handleSetDetectionForChevron();
        
        return this.XULChevronElement;
    };

    this.OnLoadElement = function(timeOut) {
        if (!this.IsMultiFeed && !this.observer) {
            this.observer = new EBFeedObserver_CT2958529(this.ComponentItem.UniqueCompID, this, this.updateFeed);
            this.observer.register();
        }
        //set the onload process in a separated thread
        //cause this process can take a long time (loading from the file,calling to server etc...)
        if (!timeOut)
            timeOut = 100;

        var oComponent = this;

        var objThreadFunction = function() {
            EBFeedManager_CT2958529.OnLoadFeedItem(oComponent);
        };

        setTimeout(objThreadFunction, timeOut);
    };

    this.OnUnloadElement = function() {
        EBFeedManager_CT2958529.OnUnloadFeedItem(this);

        if (this.observer) {
            this.observer.unregister();
            this.observer = null;
        }
    };

    this.CreateTooltipShrink = function() {
        EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID, this.XULElement);
    };

    //Custom Component functions
    this.SetCallbackFunction = function(objCallback, objThis) {
        this.callbackFunc = objCallback;
        this.callbackFuncThis = objThis;
        this.isCustom = true;
    };

    this.Invoke = function(isSuccess) {
        this.callbackFunc.call(this.callbackFuncThis, this, isSuccess);
    };

    this.updateFeed = function(feedComponent) {
        //reload in this window, because if taken from another window, the functions inside using another window's
        //functions and consts failes.
        EBFeedManager_CT2958529.LoadComponentData(this);

        //set chevron if number is changed
        if (this.NumOfNew != feedComponent.NumOfNew)
            EBChevronStaticManager_CT2958529.onchange(true);

        this.NumOfNew = feedComponent.NumOfNew;
        this.ContainerScrollTop = feedComponent.ContainerScrollTop;

        /* -- enable this when feed will be in XPCOM
        this.FeedData = feedComponent.FeedData;
        this.HistoryData = feedComponent.HistoryData;
        */

        var strCount = this.GetFeedCount();
        var strLabel = this.GetFeedTitle();

        if (!this.IsLiveMode) strLabel += " [" + strCount + "]";

        if (EBActionManager_CT2958529.IsAppView()) {
            if (!this.IsLiveMode)
                this.XULElement.notificationNumber = strCount;
        }
        else {
            this.XULElement.setAttribute("label", strLabel);
            EBImageHandler_CT2958529.UpdateStar(this.XULElement, this.IsStared());
        }

        if (this.XULChevronElement && !this.IsLiveMode) {
            this._updateCountInChevron(this.XULChevronElement, strCount);
            EBImageHandler_CT2958529.UpdateStar(this.XULChevronElement, this.IsStared());
        }
    };

    this._updateCountInChevron = function(xulMenu, strCount) {
        EBUILogic_Functions_CT2958529.setAcceltext(xulMenu, strCount);
    };
};

EBFeedComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBFeedComponent_CT2958529.constructor = EBFeedComponent_CT2958529;
function EBFeedObserver_CT2958529(compId, that, callbackFeedReload) {
    this.Topic = EBFeedConsts_CT2958529.Observer.Topic_FeedObserver;

    this.observe = function(aSubject, aTopic, aData) {
        try {
            if (aSubject.wrappedJSObject.uniqueCompID != compId) return;
            switch (aData) {
                case EBFeedConsts_CT2958529.Observer.Data_FeedReload:
                    callbackFeedReload.call(that, aSubject.wrappedJSObject.feedComponent);
                    break;
                default: break;
            }
        } catch (e) {
            EBLogging_CT2958529.LogToConsole(e, "EBFeedObserver_CT2958529");
        }
    }
}

EBFeedObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();
function EBHighlighterComponent_CT2958529(highlighterItem)
{
    EBBaseToolbarComponent_CT2958529.call(this, highlighterItem);
	
	this.ComponentItem				= highlighterItem;
	this.strHighlighterId			= EBSearchBoxConsts_CT2958529.SearchHighlighterIDPrefix + EBGlobalConsts_CT2958529.ToolbarCTID;
	this.XULElement					= null;
	this.XULChevronElement			= null;
	this.XULToolbarItemContainer = null;

	this.Init = function() {
	    var strCommand = 'EBHighlighterManager_CT2958529.OnCommandHighlighter(event);';
	    var strImage = oToolbarSkin_CT2958529.highlighterInactiveImageUrl;
	    this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(this.strHighlighterId,
												'menu-button',
												'',
												strImage,
												this.ComponentItem.strTooltip,
												strCommand,
												"");

	    //use default icon if exists
	    EBDefaultsManager_CT2958529.checkIcon(this.XULElement);

	    this.XULElement.setAttribute('disabled', true);
	    this.XULElement.setAttribute('checked', false);

	    var xulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", "", "");
	    xulMenuPopup.setAttribute('onpopupshowing', 'this.manager.fillItems(event)');
	    xulMenuPopup.setAttribute('onpopuphiding', 'this.manager.clearMenu(event)');
	    this.XULElement.appendChild(xulMenuPopup);

	    return true;
	};

	this.AddToToolbar = function(objToolbarContainer) {
	    this.SetToolbarButtonClass();

	    this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
	    this.XULToolbarItemContainer.appendChild(this.XULElement);
	    objToolbarContainer.appendChild(this.XULToolbarItemContainer);
	    this.XULElement.firstChild.manager = this;

	    this.SetChevronOnImageLoaded();

	    if (EBToolbarManager_CT2958529.dataToolbarObject.IsHighlighting)
	        this.XULElement.setAttribute("checked", true);
	};

	this.AddToChevron = function(objXULContainer) {
	    this.XULChevronElement = null;

	    var strLabel = EBHighlighterConsts_CT2958529.DisplayText;
	    var strCommand = 'EBHighlighterManager_CT2958529.OnCommandHighlighter(event);';
	    var strImage = this.XULElement.getAttribute('image');
	    var strTooltip = this.XULElement.getAttribute('tooltiptext');

	    if (EBToolbarManager_CT2958529.dataToolbarObject.IsHighlighting) {
	        strImage = EBHighlighterConsts_CT2958529.Images.HighlighterChevron;
	    }

	    this.XULChevronElement = EBXULFactory_CT2958529.CreateMenu(strLabel, strImage, strTooltip);
	    var strIsDisabled = this.XULElement.getAttribute('disabled');
	    this.XULChevronElement.setAttribute('disabled', strIsDisabled);

	    var XULMenuPopup = this.XULElement.firstChild.cloneNode(true);
	    if (XULMenuPopup) {
	        this.XULChevronElement.appendChild(XULMenuPopup);
	        XULMenuPopup.manager = this;
	    }

	    objXULContainer.appendChild(this.XULChevronElement);

	    return this.XULChevronElement;
	};

	this._createMenuItem = function(term) {
	    var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(term, "", "", "this.parentNode.manager.onclickTerm(event); event.cancelBubble = true;", "", "");
	    return xulMenuItem;
	};
	
	this.fillItems = function(event) {
	    var list = EBHighlighterManager_CT2958529.GetTermsToHighlight();
	    for (var i = 0; i < list.length; i++) {
	        event.target.appendChild(this._createMenuItem(list[i]));
	    }
	};

	this.clearMenu = function(event) {
        while(event.target.firstChild)
            event.target.removeChild(event.target.firstChild);
	};

	this.onclickTerm = function(event) {
	    EBHighlighterManager_CT2958529.OnCommandSearchTerm(event);
	};
};

EBHighlighterComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBHighlighterComponent_CT2958529.constructor = EBHighlighterComponent_CT2958529;

function EBLabelComponent_CT2958529(labelItem)
{
    EBBaseToolbarComponent_CT2958529.call(this, labelItem);
	
	this.ComponentItem				= labelItem;
	this.XULElement					= null;
	this.XULChevronElement			= null;
	this.XULToolbarItemContainer	= null;

	this.Init = function() {
	    var strLabel = this.ComponentItem.button.text;
	    var strImage = this.ComponentItem.button.image;
	    var strHint = this.ComponentItem.button.tooltip;

	    //create the xul element
	    var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);

	    var xulLabel = EBXULFactory_CT2958529.CreateLabel(strLabel, "padding-top:2px;");
	    var xulImage = EBXULFactory_CT2958529.CreateImage(strImage, null, null);

	    this.XULElement = EBXULFactory_CT2958529.CreateHBox("", "", "center");
	    this.XULElement.setAttribute('id', strButtonID);
	    this.XULElement.setAttribute('tooltiptext', strHint);
	    this.XULElement.setAttribute('style', 'margin-left:2px; margin-right:2px;');

	    this.XULElement.appendChild(xulImage);
	    this.XULElement.appendChild(xulLabel);

	    //create the tooltip element (for the shrink-unshrink tooltip)
	    this.CreateTooltipShrink();

	    return true;
	};

	this.AddToToolbar = function(objToolbarContainer) {
	    this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
	    this.XULToolbarItemContainer.appendChild(this.XULElement);
	    objToolbarContainer.appendChild(this.XULToolbarItemContainer);

	    this.SetChevronOnImageLoaded();

	    //set the button global style[after adding to toolbar - important!]:
	    this.SetToolbarButtonClass();

	    //set the button global style[after adding to toolbar - important!]:
	    if (this.XULElement.childNodes[1])
	        EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement.childNodes[1]);
	};

	this.SetToolbarButtonClass = function() {
	    //TODO: check why this.XULElement.childNodes[1] is undefined in AIO + remove 'if' from addToToolbar
	    if (this.XULElement.childNodes[1])
	        this.XULElement.childNodes[1].style.display = EBActionManager_CT2958529.ToolbarShrink() ? 'none' : '-moz-box';
	};

	this.AddToChevron = function(objXULContainer) {
	    this.XULChevronElement = null;

	    var strLabel = this.ComponentItem.button.text;
	    var strImage = this.ComponentItem.button.image;
	    var strTooltip = this.ComponentItem.button.tooltip;
	    var strCommand = this.XULElement.getAttribute('oncommand');
	    this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuItem(strLabel,
																	strImage,
																	strTooltip,
																	'',
																	'',
																	null);
	    this.XULChevronElement.setAttribute("closemenu", "none")

	    objXULContainer.appendChild(this.XULChevronElement);

		this.handleSetDetectionForChevron();
		
		return this.XULChevronElement;
	};
	
	this.CreateTooltipShrink = function()
	{
		EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID,this.XULElement);
	};
};
EBLabelComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBLabelComponent_CT2958529.constructor = EBLabelComponent_CT2958529;



function EBLogoComponent_CT2958529(labelItem) {
    EBLabelComponent_CT2958529.call(this, labelItem);

    this.ComponentItem = labelItem;
    this.XULElement = null;
    this.XULChevronElement = null;
    this.XULToolbarItemContainer = null;
    var strHint = this.ComponentItem.tooltip;

    this.Init = function() {
        var strImage = this.ComponentItem.DisplayIcon;
        var strLink = this.ComponentItem.link;
        var strLabel = "";
        //var strHint = this.ComponentItem.button.tooltip;

        //create the xul element
        if (strLink) {
            this.ComponentItem.image = EBDefaultsManager_CT2958529.getImageUrl(this.ComponentItem.image);

            //create usage function
            var that = this;
            var usageFunc = function() {
                EBUsageButton_CT2958529.OnButtonClick(that.ComponentItem.UniqueCompID, that.ComponentItem.CompType);
            };
            var commandFunc = null;

            var isDeletable = false;

            var strTarget = "SELF";

            commandFunc = function(event) {
                event.customData = {
                    "compId": that.ComponentItem.UniqueCompID,
                    "url": that.ComponentItem.link,
                    "urlTarget": strTarget,
                    "isUser": isDeletable,
                    "parentId": that.ComponentItem.UniqueCompID,
                    "strAncestorId": that.ComponentItem.UniqueCompID,
                    "compType": that.ComponentItem.CompType,
                    "source": EBUsageGadget_CT2958529.SourceButton
                };

                EBLinkManager_CT2958529.LoadLinkURL(event);
            };

            var strLabel, strImage, strBackupImage;
            if (EBActionManager_CT2958529.IsAppView()) {
                strImage = this.ComponentItem.appInfo.imageUrl;
                strBackupImage = this.ComponentItem.compThumbnailUrl;
            }
            this.buttonCommandCallback = this.WrappFunctions(commandFunc, usageFunc);

            //create the xul element
            var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);

            this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, "", strLabel, strImage, strHint, this.buttonCommandCallback, "", EBActionManager_CT2958529.IsAppView(), strBackupImage);

        }
        else {
            var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);

            var xulImage = EBXULFactory_CT2958529.CreateImage(strImage, null, null);

            this.XULElement = EBXULFactory_CT2958529.CreateHBox("", "", "center");
            this.XULElement.setAttribute('id', strButtonID);
            // this.XULElement.setAttribute('tooltiptext', strHint);
            this.XULElement.setAttribute('style', 'margin-left:2px; margin-right:2px;');

            this.XULElement.appendChild(xulImage);
        }
        //create the tooltip element (for the shrink-unshrink tooltip)
        this.CreateTooltipShrink();

        return true;
    };

};
EBLogoComponent_CT2958529.prototype = new EBLabelComponent_CT2958529();
EBLogoComponent_CT2958529.constructor = EBLogoComponent_CT2958529;


function EBMultiCommunityComponent_CT2958529(labelItem)
{
    EBBaseToolbarComponent_CT2958529.call(this, labelItem);
	
	this.ComponentItem				= labelItem;
	this.XULElement					= null;
	this.XULChevronElement			= null;
	this.XULToolbarItemContainer	= null;

	this.Init = function() {
	    EBMCLanguagePack_CT2958529.OnLoad();

	    var strImage = oToolbarSkin_CT2958529.groupInactiveImageUrl;
	    var strHint = "";
	    var objCommand = function() { EBMCButtonManager_CT2958529.OnClickMainButton(); };
	    //create the xul element
	    var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
	    this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, "menu", "", strImage, "", objCommand, "");

	    //for two main menus patch
	    this.XULElement.setAttribute(EBMainMenuPatch_CT2958529.MULTICOMMUNITY_ATTR, "true");

	    EBMCMenu_CT2958529.xulMenuObj = this.XULElement;
	    //create the tooltip element (for the shrink-unshrink tooltip)
	    this.CreateTooltipShrink();

	    //star logic handler for multicommunities
	    var onPopupShowed = function(event) { EBImageHandler_CT2958529.OnPopupShowed(event); };
	    //Usage for no action opening the menu
	    var onPopupHiding = function(event) { EBUsageMyConduit_CT2958529.OnCloseDropDownMenu(EBMCManager_CT2958529.GetCount()); };

	    var currentXulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", onPopupShowed, onPopupHiding);
	    this.XULElement.appendChild(currentXulMenuPopup);
	    this.PopulateMenu(currentXulMenuPopup);

	    return true;
	};

	this.PopulateMenu = function(xulElementParent) {
	    var xulMenuItem = null;
	    var objCommand = null;

	    if (EBActionManager_CT2958529.IsToolbarMC()) {
	        //standard disabled comminty found
	        xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(
															EBMCMenu_CT2958529.MenuItemInitText,
															oToolbarSkin_CT2958529.groupInactiveImageUrl,
															EBMCMenu_CT2958529.MenuItemInitText,
															"",
															"",
															null);
	        xulMenuItem.setAttribute('disabled', 'true');
	        xulMenuItem.setAttribute('id', EBMCMenu_CT2958529.MenuItemDetectedPrefix);
	        xulMenuItem.setAttribute('name', EBMCMenu_CT2958529.MenuItemNewCommunityNameAtt);
	        xulElementParent.appendChild(xulMenuItem);

	        //separator
	        var xulMenuSeparator = EBXULFactory_CT2958529.CreateMenuSeparator();
	        xulMenuSeparator.setAttribute("name", EBMCMenu_CT2958529.MenuItemSeparatorNameAtt + "0");
	        xulElementParent.appendChild(xulMenuSeparator);

	        //Config
	        objCommand = function(event) { EBMCManager_CT2958529.OnClickOpenDialog(window); };
	        xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(
															EBMCMenu_CT2958529.OptionsText,
															this.ComponentItem.MenuItem3Icon,
															EBMCMenu_CT2958529.OptionsText,
															objCommand,
															"",
															null);
	        xulElementParent.appendChild(xulMenuItem);

	        //separator
	        xulMenuSeparator = EBXULFactory_CT2958529.CreateMenuSeparator();
	        xulElementParent.appendChild(xulMenuSeparator);
	    }

	    //Switch to original
	    var strCaption = EBGlobalConsts_CT2958529.ToolbarName;
	    var strHint = "Switch to original Community";
	    objCommand = function(event) {
	        EBMCManager_CT2958529.ChangeToOriginal(EBUsageMyConduit_CT2958529.SourceMenu);
	        EBMCMenu_CT2958529.OnCommunitySelect(EBMCMenu_CT2958529.MenuItemDetectedPrefix + strCaption);
	    };
	    xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strCaption, EBMCMenu_CT2958529.MenuItemCommunity, strHint, objCommand, "", null);
	    xulMenuItem.setAttribute("id", EBMCMenu_CT2958529.MenuItemDetectedPrefix + strCaption);
	    xulMenuItem.setAttribute("name", EBMCMenu_CT2958529.MenuItemCommunityNameAtt);
	    xulMenuItem.setAttribute("EB_CTID", EBGlobalConsts_CT2958529.ToolbarCTID);
	    xulMenuItem.setAttribute("EB_CHANGE_TO", true);

	    if (EBMCManager_CT2958529.IsSelectedOriginalCommunity())
	        EBMCMenu_CT2958529.SetMenuSelected(xulMenuItem);

	    xulElementParent.appendChild(xulMenuItem);
	};
	
	this.AddToToolbar = function(objToolbarContainer)
	{
		//set toolbar button class[before adding to toolbar - important!]:
		this.SetToolbarButtonClass();
	
		this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
		this.XULToolbarItemContainer.appendChild(this.XULElement);
		objToolbarContainer.appendChild(this.XULToolbarItemContainer);
		
		//set the button global style[after adding to toolbar - important!]:
		EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement);
		EBMCManager_CT2958529.OnLoad();
	};

	this.SetToolbarButtonClass = function() { };

	this.AddToChevron = function(objXULContainer) {
	    return null;
	};
	
	this.CreateTooltipShrink = function()
	{
		EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID,this.XULElement);
	};
};
EBMultiCommunityComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBMultiCommunityComponent_CT2958529.constructor = EBMultiCommunityComponent_CT2958529;





function EBMultiFeedComponent_CT2958529(objMultiFeedItem) {
    if (!objMultiFeedItem) return;
    EBBaseToolbarComponent_CT2958529.call(this, objMultiFeedItem);
    
    this.ComponentItem = objMultiFeedItem;
    this.XULElement = null;
    this.XULToolbarItemContainer = null;
    this.XULChevronElement = null;
    this.IsAllLive = true;
    this.FeedComponents = new Array();

    this.Init = function() {
        this.ComponentItem.DisplayIcon = EBDefaultsManager_CT2958529.getImageUrl(this.ComponentItem.DisplayIcon);
        if (this.ComponentItem.MultiFeedButton)
            this.ComponentItem.MultiFeedButton.IconNormalURL = EBDefaultsManager_CT2958529.getImageUrl(this.ComponentItem.MultiFeedButton.IconNormalURL);

        var objFeedItem = null;
        var i;
        for (i = 0; i < this.ComponentItem.FeedItems.length; i++) {
            objFeedItem = this.ComponentItem.FeedItems[i];
            //create the feed component with as a multi feed
            var oFeedComponent = new EBFeedComponent_CT2958529(objFeedItem);
            oFeedComponent.IsMultiFeed = true;
            oFeedComponent.MultiFeedCompID = this.ComponentItem.UniqueCompID;
            var iIndex = this.FeedComponents.length;
            oFeedComponent.MultiFeedChildIndex = iIndex;
            this.FeedComponents[iIndex] = oFeedComponent;
        }

        //check feed components init!
        var isFeedComponentsInit = false;
        var objFeedComponent = null;
        for (i = 0; i < this.FeedComponents.length; i++) {
            objFeedComponent = this.FeedComponents[i];
            isFeedComponentsInit = objFeedComponent.Init();
            if (!objFeedComponent.IsLiveMode)
                this.IsAllLive = false;
        }

        if (isFeedComponentsInit) {
            //create the main multi feed button
            var strType = 'menu';
            var strImage, strLabel, strBackupImage;
            var strTooltip = this.ComponentItem.MultiFeedButton.ButtonTooltip;
            if (EBActionManager_CT2958529.IsAppView()) {
                strImage = this.ComponentItem.appInfo.imageUrl;
                strBackupImage = this.ComponentItem.compThumbnailUrl;
            }
            else {
                strImage = this.ComponentItem.MultiFeedButton.IconNormalURL;
                strLabel = this.ComponentItem.MultiFeedButton.DeafultButtonText;

                if (!this.IsAllLive) {
                    var iFeedCount = EBFeedManager_CT2958529.GetFeedsCount(this.ComponentItem.UniqueCompID);
                    strLabel += ' [' + iFeedCount + ']';
                }
            }

            var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
            this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, strType, strLabel, strImage, strTooltip, "", "", EBActionManager_CT2958529.IsAppView(), strBackupImage);
            this.XULElement.setAttribute("context", "");

            if (!this.IsLiveMode && EBActionManager_CT2958529.IsAppView())
                this.XULElement.setAttribute("notificationNumber", iFeedCount);

            var xulMenuPopup = this._getMenuPopup();
            //add all to the main multi feed button:
            this.XULElement.appendChild(xulMenuPopup);

        }

        //create the tooltip element (for the shrink-unshrink tooltip)
        if (isFeedComponentsInit)
            this.CreateTooltipShrink();

        return isFeedComponentsInit;
    };

    this._getMenuPopup = function() {
        var strOnPopupShowing = "return EBFeedUIManager_CT2958529.onFeedsMenuShowing(event,'" + this.ComponentItem.UniqueCompID + "');";
        var strOnPopupHiding = "return EBFeedUIManager_CT2958529.onFeedMenuHiding(event,'" + this.ComponentItem.UniqueCompID + "',false);";
        var strOnPopupShown = "return EBFeedUIManager_CT2958529.onFeedsMenuShown(event,'" + this.ComponentItem.UniqueCompID + "');";
        var objXULMainMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", strOnPopupShowing, strOnPopupHiding);
        objXULMainMenuPopup.setAttribute("eb-main-feed-popup", true);
        objXULMainMenuPopup.setAttribute("onpopupshown", strOnPopupShown);
        return objXULMainMenuPopup;
    };

    this.createFeedsMenu = function(objXULMainMenuPopup) {
        var feedItem = null;
        var feedMenu = null;
        for (var i = 0; i < this.ComponentItem.FeedItems.length; i++) {
            feedItem = this.ComponentItem.FeedItems[i];
            feedMenu = this._addFeedMenu(objXULMainMenuPopup, feedItem, i);
        }
    };

    this._addFeedMenu = function(objXULMainMenuPopup, feedItem, i) {
        var strLabel = feedItem.Title;
        var strImage = feedItem.IconNormalURL;
        var xulMenu = EBXULFactory_CT2958529.CreateMenu(strLabel, strImage, "")

        if (!this.FeedComponents[i].IsLiveMode) {
            var strCount = "[" + this.FeedComponents[i].NumOfNew + " " + oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_GLOBAL_UNREAD") + "]";
            xulMenu.setAttribute("acceltext", strCount);
        }

        var strOnPopupShowing = "return EBFeedUIManager_CT2958529.onFeedShowing(event,'" + this.ComponentItem.UniqueCompID + "'," + i + ");";
        var strOnPopupHiding = "";
        var xulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup(Math.random(), strOnPopupShowing, strOnPopupHiding);
        xulMenuPopup.setAttribute("class", "ebFeedDialogPopup_CT2958529");

        xulMenu.appendChild(xulMenuPopup);
        objXULMainMenuPopup.appendChild(xulMenu);
    };

    //this is done on popup shown event, because if done earlier, the start are shown only on second menu open
    this.updateStarsOnFeedsMenu = function(xulMenuPopup) {
        var xulMenu = null;
        var bIsStarred;
        for (var i = 0; i < xulMenuPopup.childNodes.length; i++) {
            if (!this.FeedComponents[i].IsLiveMode) {
                bIsStarred = this.FeedComponents[i].IsStared();
                xulMenu = xulMenuPopup.childNodes[i];
                EBImageHandler_CT2958529.UpdateStar(xulMenu, bIsStarred);
            }
        }
    };

    this.removeStarOnMenu = function(xulMenu, xulMenuPopup) {
        EBImageHandler_CT2958529.UpdateStar(xulMenu, false);
    };

    this.emptyFeedsMenu = function(xulMenuPopup) {
        while (xulMenuPopup.childNodes.length > 0)
            xulMenuPopup.removeChild(xulMenuPopup.firstChild);
    };

    this.updateFeedCountInMenu = function(xulMenuPopup, iFeedIndex) {
        if (this.FeedComponents[iFeedIndex].IsLiveMode) return;
        var xulMenu = xulMenuPopup.childNodes[iFeedIndex];
        var strCount = "[" + this.FeedComponents[iFeedIndex].NumOfNew + " " + oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_GLOBAL_UNREAD") + "]";

        EBUILogic_Functions_CT2958529.setAcceltext(xulMenu, strCount);
    };

    this.GetMultiFeedTitle = function() {
        var strTitle = this.ComponentItem.MultiFeedButton.DeafultButtonText;
        return strTitle;
    };

    this.GetMultiFeedCount = function() {
        var iNumOfNew = 0;
        var oFeedComponent = null;
        for (var i = 0; i < this.FeedComponents.length; i++) {
            oFeedComponent = this.FeedComponents[i];
            iNumOfNew += oFeedComponent.NumOfNew;
        }

        EBFeedManager_CT2958529.SetFeedsCount(this.ComponentItem.UniqueCompID, iNumOfNew);

        return iNumOfNew;
    };

    this.IsStared = function() {
        if (this.IsAllLive) return false;
        var oFeedComponent = null;

        for (var i = 0; i < this.FeedComponents.length; i++) {
            oFeedComponent = this.FeedComponents[i];
            if (oFeedComponent.FeedData && !oFeedComponent.IsLiveMode && oFeedComponent.FeedData.Data.Stared)
                return true;
        }

        return false;
    };

    this.GetMultiFeedImage = function() {
        return this.ComponentItem.MultiFeedButton.IconNormalURL;
    };

    this.AddToToolbar = function(objToolbarContainer, isFirst) {
        //set toolbar button class[before adding to toolbar - important!]:
        this.SetToolbarButtonClass();

        this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
        this.XULToolbarItemContainer.appendChild(this.XULElement);
        
        if (!isFirst || objToolbarContainer.childNodes.length == 0)
            objToolbarContainer.appendChild(this.XULToolbarItemContainer);
        else
            objToolbarContainer.insertBefore(this.XULToolbarItemContainer, objToolbarContainer.firstChild);

        this.SetChevronOnImageLoaded();

        //set the button global style[after adding to toolbar - important!]:
        EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement);

        //nullify stared attribute
        EBImageHandler_CT2958529.NullifyStaredAttribute(this.XULElement);

        this.OnLoadElement();
    };

    this.UnloadComponent = function() {
        this.OnUnloadElement();
    };

    this.AddToChevron = function(objXULContainer) {
        this.XULChevronElement = null;
        var image = (EBActionManager_CT2958529.IsAppView()) ? this.XULElement.selectedImage : this.XULElement.getAttribute("image");
        this.XULChevronElement = EBXULFactory_CT2958529.CreateMenu("", image, "");

        var objAttribute = null;
        for (var i = 0; i < this.XULElement.attributes.length; i++) {
            objAttribute = this.XULElement.attributes[i];
            if (objAttribute.name.toLowerCase() != 'class' &&
			    objAttribute.name.toLowerCase() != 'tooltip' &&
			    objAttribute.name.toLowerCase() != 'label' &&
			    objAttribute.name != EBImageHandler_CT2958529.Consts.StarredAttribute
			  ) {
                this.XULChevronElement.setAttribute(objAttribute.name, objAttribute.value);
            }
        }

        //star logic for chevron, this menuitem is star candidate
        EBChevronStaticManager_CT2958529.TransferStarLogicSettings(this.XULElement, this.XULChevronElement);

        //set the class attribute separately
        var strChevronClassGet = this.XULChevronElement.getAttribute('class');
        var strClassSet = 'menu-iconic';
        var strLabel = this.GetMultiFeedTitle();

        if (strChevronClassGet)
            strClassSet += ' ' + strChevronClassGet;

        if (!this.IsAllLive)
            this.XULChevronElement.setAttribute('acceltext', '[' + this.GetMultiFeedCount() + ']');

        this.XULChevronElement.setAttribute('class', strClassSet);
        this.XULChevronElement.setAttribute('label', strLabel);

        if (EBActionManager_CT2958529.IsAppView())
            this.XULChevronElement.setAttribute('image', this.XULElement.selectedImage);

        //set the tooltiptext - in case of shrink mode so there is special tooltip shrink
        //we need to return it to the original tooltip
        var strOriginalTooltip = this.XULElement.getAttribute(EBGlobalConsts_CT2958529.Attributes.XULTooltip);
        if (strOriginalTooltip)
            this.XULChevronElement.setAttribute('tooltiptext', strOriginalTooltip);

        var oXULMainMenuPopup = this.XULElement.firstChild.cloneNode(true);
        this.XULChevronElement.appendChild(oXULMainMenuPopup);
        objXULContainer.appendChild(this.XULChevronElement);
        this.handleSetDetectionForChevron();

        return this.XULChevronElement;
    };

    this.OnLoadElement = function() {
        if (!this.observer) {
            this.observer = new EBFeedObserver_CT2958529(this.ComponentItem.UniqueCompID, this, this.updateFeed);
            this.observer.register();
        }

        var objFeedComponent = null;
        for (var i = 0; i < this.FeedComponents.length; i++) {
            objFeedComponent = this.FeedComponents[i];
            objFeedComponent.OnLoadElement(i * 100);
        }
    };

    this.OnUnloadElement = function() {
        var objFeedComponent = null;
        for (var i = 0; i < this.FeedComponents.length; i++) {
            objFeedComponent = this.FeedComponents[i];
            objFeedComponent.OnUnloadElement();
        }

        if (this.observer) {
            this.observer.unregister();
            this.observer = null;
        }
    };

    this.CreateTooltipShrink = function() {
        EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID, this.XULElement);
    };

    this.updateFeed = function(feedComponent) {
        var myFeedComponent = this.FeedComponents[feedComponent.MultiFeedChildIndex];
        EBFeedManager_CT2958529.LoadComponentData(myFeedComponent);

        //set chevron if number is changed
        if (myFeedComponent.NumOfNew != feedComponent.NumOfNew)
            EBChevronStaticManager_CT2958529.onchange(true);

        myFeedComponent.NumOfNew = feedComponent.NumOfNew;
        myFeedComponent.ContainerScrollTop = feedComponent.ContainerScrollTop;

        //this.FeedComponents[feedComponent.MultiFeedChildIndex] = feedComponent;

        var strCount = this.GetMultiFeedCount();
        var strLabel = this.GetMultiFeedTitle();
        if (!this.IsAllLive)
            strLabel += " [" + strCount + "]";

        if (EBActionManager_CT2958529.IsAppView()) {
            if (!this.IsLiveMode)
                this.XULElement.notificationNumber = strCount;
        }
        else {
            this.XULElement.setAttribute("label", strLabel);
            EBImageHandler_CT2958529.UpdateStar(this.XULElement, this.IsStared());
        }

        if (this.XULChevronElement && !this.IsAllLive) {
            this._updateCountInChevron(this.XULChevronElement, strCount);
            EBImageHandler_CT2958529.UpdateStar(this.XULChevronElement, this.IsStared());
        }

        EBFeedUIManager_CT2958529.updateMultifeedCountInMenu(this.ComponentItem.UniqueCompID, feedComponent.MultiFeedChildIndex);
    };

    this._updateCountInChevron = function(xulMenu, strCount) {
        EBUILogic_Functions_CT2958529.setAcceltext(xulMenu, strCount);
    };

    this.OnDelete = function() {
        for (var i = 0; i < this.FeedComponents.length; i++)
            this.FeedComponents[i].OnDelete();
    };
};

EBMultiFeedComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBMultiFeedComponent_CT2958529.constructor = EBMultiFeedComponent_CT2958529;

function EBMyStuffComponent_CT2958529(item) {
    EBBaseToolbarComponent_CT2958529.call(this, item);
    
    this.ComponentItem = item;
    this.XULElement = null;
    this.XULChevronElement = null;
    this.XULToolbarItemContainer = null;
    this.buttonCommandCallback = null;

    this.Init = function() {
        var strLabel = "";
        var strImage = oToolbarSkin_CT2958529.myStuffImageUrl;
	    var key = EBGlobalConsts_CT2958529.IsEngine ? "CELP_STR_ID_ENGINE_ADD_APPS_BUTTON_TOOLTIP" : "CTLP_STR_ID_MYSTUFF_ADD_STUFF_TOOLTIP";
        var strHint = oToolbarManager_CT2958529.getLPKey(key);

        //create the xul element
        var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
        this.buttonCommandCallback = function(event) { EBToolbarManager_CT2958529.myStuffManager.onclickAdd(event); };
        this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, "", strLabel, strImage, strHint, this.buttonCommandCallback, "");
        
        //create the tooltip element (for the shrink-unshrink tooltip)
        this.CreateTooltipShrink();
        return true;
    };

    this.AddToChevron = function(objXULContainer) {
        if (this.XULChevronElement) {
            this.XULChevronElement.removeEventListener("command", this.buttonCommandCallback, false);
            this.XULChevronElement = null;
        }

        var strLabel = this.XULElement.getAttribute('label');
        var strImage = this.XULElement.getAttribute('image');
        var strTooltip = this.XULElement.getAttribute('tooltiptext');

        this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuItem(strLabel, strImage, strTooltip, this.buttonCommandCallback, '', null);

        objXULContainer.appendChild(this.XULChevronElement);
        return this.XULChevronElement;
    };

    this.CreateTooltipShrink = function() {
        EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID, this.XULElement);
    };

    this.AddContextMenu = function(contextMenuId) { };
};

EBMyStuffComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBMyStuffComponent_CT2958529.constructor = EBMyStuffComponent_CT2958529;

function EBMyStuffWithOptionsComponent_CT2958529(item) {
    EBBaseToolbarComponent_CT2958529.call(this, item);
    
    this.ComponentItem = item;
    this.XULElement = null;
    this.XULChevronElement = null;
    this.XULToolbarItemContainer = null;
    this.buttonCommandCallback = null;

    this.Init = function() {
        var strImage = oToolbarSkin_CT2958529.myStuffImageUrl;
        var strHint = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_ADD_STUFF_TOOLTIP");

        var strOptionsIcon = this.ComponentItem.optionsIcon;
        var strOptionsLabel = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_MANAGE_CAPTION");
        var strOptionsHint = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_MANAGE_TOOLTIP");
        var objOptionsCommand = function(event) {
            EBToolbarManager_CT2958529.myStuffManager.onclickOptions(event);
            event.cancelBubble = true;
        };

        //create the xul element
        var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
        this.buttonCommandCallback = function(event) {
            EBToolbarManager_CT2958529.myStuffManager.onclickAdd(event);
        };
        this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, "menu-button", "", strImage, strHint, this.buttonCommandCallback, "");

        //create options menuitem
        var xulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", "", "");
        var xulOptionsMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strOptionsLabel, strOptionsIcon, strOptionsHint, objOptionsCommand, "", null);
        xulMenuPopup.appendChild(xulOptionsMenuItem);
        this.XULElement.appendChild(xulMenuPopup);

        this.CreateTooltipShrink();
        return true;
    };

    this.AddToChevron = function(objXULContainer) {
        return null;
    };

    this.CreateTooltipShrink = function() {
        EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID, this.XULElement);
    };
};

EBMyStuffWithOptionsComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBMyStuffWithOptionsComponent_CT2958529.constructor = EBMyStuffWithOptionsComponent_CT2958529;

function EBPrivacyComponent_CT2958529(privacyItem)
{
    EBBaseToolbarComponent_CT2958529.call(this, privacyItem);
	
	this.ComponentItem			= privacyItem;
	this.dynamicMenuComponent	= null;
	this.XULElement				= null;
	this.XULChevronElement		= null;

	this.Init = function() {
	    this.dynamicMenuComponent = EBToolbarFactoryComponent_CT2958529.GetInstance(this.ComponentItem.dynamicMenuItem);
	    if (this.dynamicMenuComponent)
	        this.dynamicMenuComponent.ComponentItem.UniqueCompID = this.ComponentItem.UniqueCompID;

	    var bIsInit = this.dynamicMenuComponent.Init(true);

	    if (bIsInit) {
	        this.XULElement = this.dynamicMenuComponent.XULElement;
	        this.XULElement.setAttribute("label", oToolbarManager_CT2958529.getLPKey("\@APPSERVER_MAIN_MENU_PRIVACY_APPSERVER\@"));
	    }

	    return bIsInit;
	};


	this.AddToToolbar = function(objToolbarContainer) {
	    this.dynamicMenuComponent.AddToToolbar(objToolbarContainer);
	};

	this.RemoveFromToolbar = function(objToolbarContainer) {
	    this.UnloadComponent();
	    this.dynamicMenuComponent.RemoveFromToolbar(objToolbarContainer);
	};

	this.SetToolbarButtonClass = function() {
	    this.dynamicMenuComponent.SetToolbarButtonClass();
	};
	
	//if this element should be in chevron return the toolbar item 
	//of this element
	this.GetToolbarItemContainer = function() {
	    return this.dynamicMenuComponent.XULToolbarItemContainer;
	};

	this.SetComponentCollapsed = function(isCollapsed) {
	    this.dynamicMenuComponent.SetComponentCollapsed(isCollapsed);
	};

	this.AddToChevron = function(objXULContainer) {
	    this.XULChevronElement = null;

	    this.XULChevronElement = this.dynamicMenuComponent.AddToChevron(objXULContainer);

	    if (this.XULChevronElement) {
	        //set the caption and label of the privacy button
	        var strLabel = this.XULElement.getAttribute("label");
	        var strImage = this.XULElement.getAttribute("image");

	        this.XULChevronElement.setAttribute('label', strLabel);
	        this.XULChevronElement.setAttribute('image', strImage);
	    }

	    this.handleSetDetectionForChevron();
	    return this.XULChevronElement;
	};

	this.OnLanguagePackChange = function() {
	    var strLabel = oToolbarManager_CT2958529.getLPKey("\@APPSERVER_MAIN_MENU_PRIVACY_APPSERVER\@");
	    this.XULElement.setAttribute("label", strLabel);
	    if (this.XULChevronElement)
	        this.XULChevronElement.setAttribute("label", strLabel);
	};
};

EBPrivacyComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBPrivacyComponent_CT2958529.constructor = EBPrivacyComponent_CT2958529;
//Radio Component
function EBRadioComponent_CT2958529(radioItem)
{
    EBBaseToolbarComponent_CT2958529.call(this, radioItem);
	
	this.ComponentItem				= radioItem;
	this.XULElement					= null;
	this.XULChevronElement			= null;
	this.XULToolbarItemContainer	= null;

	this.Init = function() {
	    if (!EBGlobalManager_CT2958529.IsWindowsPlatform()) return false;
	 
	    EBRadioLanguagePack_CT2958529.OnRadioLoad();

	    var XulElement_style = "-moz-box-align: center; max-height: 28px; padding-top: 3px;padding-bottom: 3px; direction:ltr;"
	    this.XULElement = EBXULFactory_CT2958529.CreateHBox("", XulElement_style, "");


	    //take server url from settings, override defaults
	    if (this.ComponentItem.RadioServerURL)
	        EBRadioConsts_CT2958529.ServerURL = this.ComponentItem.RadioServerURL;

	    this.initSkins();
	    return true;
	};

	this.initSkins = function() {
	    if (!this.ComponentItem.xmlSkins) return;

	    this.ComponentItem.Skins = new Array();
	    var xmlSkins = this.ComponentItem.xmlSkins;
	    var xmlSkin = null;
	    var oSkin = null;

	    for (var j = 0; j < xmlSkins.childNodes.length; j++) {
	        xmlSkin = xmlSkins.childNodes[j];
	        oSkin = new EBToolbarRadioSkin_CT2958529(xmlSkin);
	        if (oSkin.init)
	            this.ComponentItem.Skins.push(oSkin);
	    }
	};
	
	this.AddToToolbar = function(objToolbarContainer)
	{
		if(!EBGlobalManager_CT2958529.IsWindowsPlatform()) return;
		
		this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
		this.XULToolbarItemContainer.appendChild(this.XULElement);
		this.XULToolbarItemContainer.setAttribute('id',EBRadioConsts_CT2958529.RadioMainID);
		objToolbarContainer.appendChild(this.XULToolbarItemContainer);
		
		this.OnLoadElement();
		
	};

	this.OnLoadElement = function() {
	    //check if skin not load, apply default
	    setTimeout(function() { EBRadioManager_CT2958529.CheckIfSkinLoaded(); }, 2000);
	    setTimeout(function() { EBRadioManager_CT2958529.ApplySkin(); }, 100);
	};

	this.OnUnloadElement = function() {
	    EBRadioManager_CT2958529.UnloadToolbar(this.ComponentItem.isShow());
	};

	this.UnloadComponent = function() {
	    this.OnUnloadElement();
	};
	
	this.SetToolbarButtonClass = function() { };
	
	//if this element should be in chevron return the toolbar item 
	//of this element
	this.IsToChevron = function()
	{
		var XULToolbarItem	= null;
		var isLastShownComponent = EBComponentsManager_CT2958529.IsLastShownComponent(this);
		
		var isInChevron		=  EBChevronManager_CT2958529.IsInChevron(this.XULToolbarItemContainer,isLastShownComponent);
		if(isInChevron)  
			XULToolbarItem = this.XULToolbarItemContainer;
		
		if(!XULToolbarItem)
			EBRadioManager_CT2958529.SetOutChevron();
		
		return XULToolbarItem;
	};
	
	this.OnLanguagePackChange = function()
	{
		this.Init();
		var oContainer = document.getElementById(EBRadioConsts_CT2958529.RadioMainID);
		oContainer.removeChild(oContainer.firstChild);
		oContainer.appendChild(this.XULElement);
		this.OnLoadElement();
	};
	
	this.AddToChevron = function(objXULContainer)
	{
		if(!EBGlobalManager_CT2958529.IsWindowsPlatform()) return;
		
		this.XULChevronElement = null;

		var strLabel	=	this.ComponentItem.DisplayText;
		var strImage    =   EBRadioGUIManager_CT2958529.GetRadioChevronImage();
		
		var strHint		=	"Radio";
		this.XULChevronElement = EBXULFactory_CT2958529.CreateMenu(strLabel,strImage,strHint);
		var xulMenuContainer = EBXULFactory_CT2958529.CreateMenuPopup("","","");
		
		strLabel		= "Stations";
		var XULStationsMenu = EBXULFactory_CT2958529.CreateMenu(strLabel,"","");
		XULStationsMenu.setAttribute('id',EBRadioConsts_CT2958529.RadioMenuButtonChevronID);
		
		var XULPlayButton = EBXULFactory_CT2958529.CreateMenuItem("","","","","","")
		XULPlayButton.setAttribute('id',EBRadioConsts_CT2958529.RadioPlayButtonChevronID);
		XULPlayButton.setAttribute("class","menuitem-iconic");
		XULPlayButton.setAttribute("style",EBToolbarDesignConsts_CT2958529.ToolbarMaxImageHeightStyle);
		objXULContainer.appendChild(this.XULChevronElement);
		xulMenuContainer.appendChild(XULPlayButton);
		xulMenuContainer.appendChild(XULStationsMenu);
			
		this.XULChevronElement.appendChild(xulMenuContainer);
		EBRadioManager_CT2958529.SetInChevron(XULStationsMenu);
		
		if(EBRadioConsts_CT2958529.NowState.PlayState == "playing")
			EBRadioGUIManager_CT2958529.SetPlayChevron();
		else
			EBRadioGUIManager_CT2958529.SetPauseChevron();		
		
		this.handleSetDetectionForChevron();
		return this.XULChevronElement;
	};
};
EBRadioComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBRadioComponent_CT2958529.constructor = EBRadioComponent_CT2958529;
    
function EBSearchBoxComponent_CT2958529(searchItem) {
    EBBaseToolbarComponent_CT2958529.call(this, searchItem);

    this.ComponentItem = searchItem;
    this.searchSuggests = null;
    this.selectedSearchEngine = null;

    //the xul element for the search component:
    this.xulMenuList = null;
    this.xulMenuPopup = null;
    this.xulSplitter = null;
    this.xulGoButton = null;

    this.XULChevronElement = null;

    this.SuggestUrl = '';
    this.SearchTermToReplace = '';

    this.XULToolbarItemContainerSearchBox = null;

    //since we need the menulist and the toolbarbutton with his menu items
    //talked to each other we defined id to the menulist and the toolbarbutton
    //and plant it as an attribute in all of them
    this.searchButtonId = EBSearchBoxConsts_CT2958529.SearchButtonIDPrefix + EBGlobalConsts_CT2958529.ToolbarCTID;
    this.searchMenuListId = EBSearchBoxConsts_CT2958529.SearchMenuListIDPrefix + EBGlobalConsts_CT2958529.ToolbarCTID;
    this.searchGoButtonId = EBSearchBoxConsts_CT2958529.SearchGoButtonIDPrefix + EBGlobalConsts_CT2958529.ToolbarCTID;
    this.observer = null;

    this.Init = function() {

        if (isFloatingMode_CT2958529 && !isAIOMode_CT2958529) return false;
        //do not update search from address bar url
        /*
        if (this.ComponentItem.searchHookUrl)
        EBSearchFromAddressBar_CT2958529.updateFromSettings(this.ComponentItem.searchHookUrl);
        */

        var strSplitterStyle = " -moz-appearance: none; background-color: transparent;border: none !important;"
        var strResizeBefore = "closest";
        var strResizeAfter = "grow";

        //check if this toolbar is ltr or rtl to set the splitter behaviour correctly
        if (EBGlobalManager_CT2958529.GetToolbarDir() == "rtl") {
            strResizeBefore = "farthest";
            strResizeAfter = "closest";
        }

        var strSplitterImage = oToolbarSkin_CT2958529.splitterImageUrl;

        this.xulSplitter = EBXULFactory_CT2958529.CreateSplitter("open", "none", strResizeBefore, strResizeAfter,
	                                                            "Resize the Search Box", strSplitterStyle, strSplitterImage);

        this.xulSplitter.addEventListener("mouseup", function(event) { EBSearchBoxManager_CT2958529.OnMouseUpSplitter(event); }, false);
        this.xulSplitter.addEventListener("mousedown", function(event) { EBSearchBoxManager_CT2958529.OnMouseDownSplitter(event); }, false);

        var strTooltip = "";
        var strStyle = "";

        //create all the xul elements
        var strMenuListId = this.searchMenuListId;
        var objMenuListOnInput = function(event) { EBSearchBoxManager_CT2958529.OnInputSearchBox(this); };
        var objMenuListOnKeyPress = function(event) { EBSearchBoxManager_CT2958529.MenuListSearch(event); };
        var objMenuListOnClick = function(event) { EBSearchBoxManager_CT2958529.OnClickSearchBox(event, this); };
        var objMenuListOnMouseDown = function(event) { EBSearchBoxManager_CT2958529.OnMouseDownSearchBox(event, this); };
        var strMenuListWidth = this.GetSearchBoxWidth();
        var strMenuListMinWidth = (!this.ComponentItem.minSearchBoxWidth || this.ComponentItem.minSearchBoxWidth <= 0) ? EBSearchBoxConsts_CT2958529.SearchBoxMinWidth : this.ComponentItem.minSearchBoxWidth;

        this.xulMenuList = document.createElement("textbox");
        this.xulMenuList.setAttribute('id', strMenuListId);
        this.xulMenuList.addEventListener("keypress", objMenuListOnKeyPress, true);
        this.xulMenuList.addEventListener("input", objMenuListOnInput, false);
        this.xulMenuList.addEventListener("click", objMenuListOnClick, false);
        this.xulMenuList.addEventListener("mousedown", objMenuListOnMouseDown, false);
        this.xulMenuList.setAttribute("ontextentered", "EBSearchBoxManager_CT2958529.OnSelectSearchTermFromHistoryAsync({})");

        this.xulMenuList.setAttribute('width', strMenuListWidth);
        this.xulMenuList.setAttribute('min-width', strMenuListMinWidth);
        this.xulMenuList.style.minWidth = strMenuListMinWidth + "px";
        this.xulMenuList.setAttribute('type', 'autocomplete');
        this.xulMenuList.setAttribute('autocompletesearch', 'conduit-auto-complete-with-suggest4');
        this.xulMenuList.setAttribute('showcommentcolumn', 'false');
        this.xulMenuList.setAttribute('autocompletepopup', 'EBPopupAutoComplete_CT2958529');
        this.xulMenuList.setAttribute('enablehistory', !EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.EnableSearchHistory) || EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EnableSearchHistory));
        this.xulMenuList.setAttribute('ignoreblurwhilesearching', 'true');
        this.xulMenuList.setAttribute('completeselectedindex', 'true');
        this.xulMenuList.setAttribute('flex', '1');

        var strToolbarButtonId = this.searchButtonId;
        //++++++++++++++++++
        //Go button

        var strCaption = this.ComponentItem.DisplayText;
        var strImage = this.ComponentItem.DisplayIcon;
        var strGoButtonId = this.searchGoButtonId;
        var objCommand = function(event) { EBSearchBoxManager_CT2958529.ButtonSearch(event); };

        this.xulGoButton = EBXULFactory_CT2958529.CreateToolbarButton(strGoButtonId, "menu-button", strCaption, strImage, "", objCommand, "");

        //use default icon if exists
        EBDefaultsManager_CT2958529.checkIcon(this.xulGoButton);
        EBSearchBoxConsts_CT2958529.xulGoButton = this.xulGoButton;
        EBSearchBoxConsts_CT2958529.SerachTarget = this.ComponentItem.searchTarget; 
        
        if (oToolbarManager_CT2958529.myStuffEnabled())
            this.AddMyStuffSearchEngine();

        this.BuildSearchEngines(this.ComponentItem.searchEnginesXml, this.xulGoButton);

        if (this.ComponentItem.searchSuggestsXml != null)
            this.SetSearchSuggests(this.ComponentItem.searchSuggestsXml);

        this.InitializeDefaultSearch(this.xulGoButton);

        //create the tooltip element (for the shrink-unshrink tooltip)
        this.CreateTooltipShrink();
        return true;
    };

    this.setAutocompleteParams = function() {

        var autocompleteParams =
        { "suggestUrl": this.SuggestUrl,
            "searchTermToReplace": this.SearchTermToReplace,
            "txtSuggest": this.SuggestCaption ? this.SuggestCaption : oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_SEARCH_SUGGESTIONS"),
            "txtHistory": oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_SEARCH_HISTORY"),
            "isShowHistory": !EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.EnableSearchSuggest) || EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EnableSearchSuggest) ? true : false
        };
        this.xulMenuList.searchParam = JSON.stringify(autocompleteParams);
    };
    //add my stuff search engine's xml definition into all search engines xml
    this.AddMyStuffSearchEngine = function() {
        //create xml definition for mystuff search engine
        if (this.ComponentItem.mystuffEngineAdded) return;

        this.ComponentItem.mystuffEngineAdded = true;
        var xmlEngines = this.ComponentItem.searchEnginesXml;
        var xmlDoc = xmlEngines.ownerDocument;
        var strUrl = oToolbarManager_CT2958529.getMyStuffSearchUrl();
        var xmlNewEngine = xmlDoc.createElement("SEARCH_ENGINE");
        var xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "PREFIX", strUrl);
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "SEARCH_TERM_TO_REPLACE", "SEARCH_TERM");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "EMPTY_SEARCH_URL", strUrl.replace(/SEARCH_TERM/, ""));
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "INPUT_CHARSET", "UTF-8");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "ICON_URL", "chrome://browsersearch/skin/myStuff/plus-icon.png");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "CAPTION", oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_SEARCH_ENGINE_CAPTION"));
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "DEFAULT", "FALSE");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "ORIGIN", "EB");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "IMAGE_URL", "chrome://browsersearch/skin/myStuff/plus-icon.png");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "CAN_BE_DEFAULT", "FALSE");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "IMAGE_HOVER_URL", "chrome://browsersearch/skin/myStuff/plus-icon.png");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "SUGGEST_URL", "");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "SUGGEST_CAPTION", "");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "BG_TEXT", "");
        xmlNewEngine.appendChild(xmlChild);
        xmlChild = EBXML_CT2958529.CreateXmlTextNode(xmlDoc, "UNIQUE_COMP_ID", "300");
        xmlNewEngine.appendChild(xmlChild);

        var xmlEngine = null;
        var origin = "";
        var majorDefault = null;

        //find a right point to insert the engine
        try {
            var isFound = false;
            for (var i = 1; i < xmlEngines.childNodes.length; i++) {
                xmlEngine = xmlEngines.childNodes[i];
                if (xmlEngine && xmlEngine.tagName && xmlEngine.tagName == "SEARCH_ENGINE") {
                    origin = EBXML_CT2958529.GetSingleNodeValue(xmlEngine, "ORIGIN");
                    majorDefault = EBXML_CT2958529.GetSingleNodeValueAsBoolean(xmlEngine, "MAJOR_DEFAULT", false);
                    if (!majorDefault && origin == "EB") {
                        xmlEngines.insertBefore(xmlNewEngine, xmlEngine);
                        isFound = true;
                        break;
                    }
                }
            }

            if (!isFound)
                xmlEngines.appendChild(xmlNewEngine);
        }
        catch (ex) {
            EBLog(ex);
        }
    };

    this.InitializeDefaultSearch = function(objXULElement) {
        var menuItemElements = null;
        var defaultMenuItem = null;

        //check here the chosen engine from the global var
        var strPrefValue = (this.backToDefault()) ? this.selectedSearchEngine :
		                                  EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.SearchEngine, true);
        if (strPrefValue) {
            //the search engine is save of "name||url" so i get it to an array
            var arrNamePrefix = strPrefValue.split(EBGlobalConsts_CT2958529.Delimiter);

            var strName = decodeURIComponent(arrNamePrefix[0]);
            var strPrefix = arrNamePrefix[1];
            var checkIfFound = false;
            menuItemElements = objXULElement.getElementsByAttribute("EB_CAN_BE_DEFAULT", "TRUE");
            for (var i = 0; i < menuItemElements.length; i++) {
                defaultMenuItem = menuItemElements[i];
                if (strName == defaultMenuItem.getAttribute("label")
					&& strPrefix == defaultMenuItem.getAttribute("EB_PREFIX")) {
                    { checkIfFound = true; break; }
                }
            }
            if (!checkIfFound) defaultMenuItem = null;
        }

        //if not come from the global var i'll take the xml default
        if (!defaultMenuItem) {
            menuItemElements = objXULElement.getElementsByAttribute("EB_DEFAULT", "TRUE");

            if (menuItemElements.length == 0)
                defaultMenuItem = objXULElement.firstChild.childNodes[0];
            else
                defaultMenuItem = menuItemElements[0];
        }

        if (defaultMenuItem) {
            //set this menu item to checked
            defaultMenuItem.setAttribute("style", "font-weight:bold");
            defaultMenuItem.setAttribute("EBchecked", "true");

            //get this menu item image and label to set it to the main search button
            this.setImageAndTextToGoButton(defaultMenuItem);
            this.SuggestUrl = (defaultMenuItem.getAttribute("EB_SUGGEST_URL_INNER")) ?  defaultMenuItem.getAttribute("EB_SUGGEST_URL_INNER") :
                                                                                        defaultMenuItem.getAttribute("EB_SUGGEST_URL");
            this.SuggestCaption = defaultMenuItem.getAttribute("EB_SUGGEST_CAPTION");
            this.SearchTermToReplace = defaultMenuItem.getAttribute("EB_SEARCH_TERM_TO_REPLACE");
            var engineId = defaultMenuItem.getAttribute("EB_UNIQUE_ID");

            //set selected engineId (for usage)
            EBSearchBoxConsts_CT2958529.SelectedEngineId = engineId;
            EBSearchBoxManager_CT2958529.SetSearchEnginePreference(defaultMenuItem);
        }
    };

    this.BuildSearchEngines = function(xmlSearchEngines, xulElementParent, isInChevron) {
        var currentXulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", "", "");
        var strOnPopupShowed = 'EBUsageSearchBox_CT2958529.OnOpenEnginesMenu();';
        var strOnPopupHiding = 'EBUsageSearchBox_CT2958529.OnCloseEnginesMenu();';

        currentXulMenuPopup.setAttribute('onpopupshown', strOnPopupShowed);
        currentXulMenuPopup.setAttribute('onpopuphidden', strOnPopupHiding);

        for (var i = 0; i < xmlSearchEngines.childNodes.length; i++) {
            if (xmlSearchEngines.childNodes[i].tagName) {
                if (xmlSearchEngines.childNodes[i].tagName == "SEARCH_ENGINE")
                    this.BuildSearchMenuItem(xmlSearchEngines.childNodes[i], currentXulMenuPopup, isInChevron);
                else if (xmlSearchEngines.childNodes[i].tagName == "SEPARATOR")
                    this.BuildSearchSeparator(currentXulMenuPopup);
            }
        }

        xulElementParent.appendChild(currentXulMenuPopup);

    };

    this.BuildSearchMenuItem = function(xmlSearchMenuItem, xulElementParent, isInChevron, xulInsertBefore) {
        var strCaption = "";
        var strImageUrl = "";
        var strImageHoverUrl = "";
        var strHint = "";
        var strName = "";
        var strId = "";

        //unique search attributes
        var strPrefix = "";
        var strTermToReplace = "";
        var isDefault = "";
        var strDefault = "";
        var bCanBeDefault = false;
        var strInputCharset = "";
        var strType = "";
        var strPostParams = "";
        var strEmptySearchUrl = "";
        var strBGText = "";
        var strOrigin = "";
        var strSuggestUrl = "";
        var strSecondarySearchUrlPrefix = "";
        var strSecondarySearchTermToReplace = "";
        var iSecondarySearchTimeout = 30000;
        var strSuggestUrlInner = "";
        var strSuggestCaption = "";
        var strSuggestOriginatedSearchUrl = "";

        //hashtable to save another information to the search menu items
        var arrData = new Array();
        var xmlChildNode = null;
        for (var i = 0; i < xmlSearchMenuItem.childNodes.length; i++) {

            xmlChildNode = xmlSearchMenuItem.childNodes[i];

            switch (xmlChildNode.tagName) {
                case "CAPTION":
                    strCaption = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    break;
                case "IMAGE_URL":
                    strImageUrl = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_IMAGE_URL"] = strImageUrl;
                    break;
                case "IMAGE_HOVER_URL":
                    strImageHoverUrl = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_IMAGE_HOVER_URL"] = strImageHoverUrl;
                    break;
                case "TOOLTIP":
                    strHint = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_TOOLTIP"] = strHint;
                    break;
                case "PREFIX":
                    strPrefix = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_PREFIX"] = strPrefix;
                    break;
                case "SEARCH_TERM_TO_REPLACE":
                    strTermToReplace = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_SEARCH_TERM_TO_REPLACE"] = strTermToReplace;
                    break;
                case "MAJOR_DEFAULT":
                    isDefault = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["MAJOR_DEFAULT"] = isDefault;
                    break;
                case "DEFAULT":
                    strDefault = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_DEFAULT"] = strDefault;
                    break;
                case "TYPE":
                    strType = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_TYPE"] = strType;
                    break;
                case "POST_PARAMS":
                    strPostParams = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_POST_PARAMS"] = strPostParams;
                    break;
                case "INPUT_CHARSET":
                    strInputCharset = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_INPUT_CHARSET"] = strInputCharset;
                    break;
                case "CAN_BE_DEFAULT":
                    bCanBeDefault = EBXML_CT2958529.GetBooleanXmlNodeValue(xmlChildNode);

                    //if backToDefault is true, every engine in current session can be default
                    if (this.backToDefault())
                        bCanBeDefault = true;

                    if (bCanBeDefault) {
                        strName = "ebSearchMenuItem";
                        if (isInChevron)
                            strName += EBChevronConsts_CT2958529.ChevronSuffixText;
                    }
                    arrData["EB_CAN_BE_DEFAULT"] = bCanBeDefault.toString().toUpperCase();
                    break;
                case "EMPTY_SEARCH_URL":
                    strEmptySearchUrl = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_EMPTY_SEARCH_URL"] = strEmptySearchUrl;
                    break;
                case "BG_TEXT":
                    strBGText = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_BG_TEXT"] = strBGText;
                    break;
                case "ORIGIN":
                    strOrigin = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_ORIGIN"] = strOrigin;
                    break;
                case "SUGGEST_URL":
                    strSuggestUrl = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_SUGGEST_URL"] = strSuggestUrl;
                    break;
                case "UNIQUE_COMP_ID":
                    strId = EBXML_CT2958529.GetXmlNodeValue(xmlChildNode);
                    arrData["EB_UNIQUE_ID"] = strId;
                    break;
                case "SECONDARY_SEARCH_ENGINE":
                    iSecondarySearchTimeout = parseInt(EBXML_CT2958529.GetSingleNodeValue(xmlChildNode, "SEARCH_TIMEOUT_SEC"));
                    var xmlSearchEngine = EBXML_CT2958529.SelectSingleNode(xmlChildNode, "SEARCH_ENGINE");
                    if (xmlSearchEngine) {
                        strSecondarySearchUrlPrefix = EBXML_CT2958529.GetSingleNodeValue(xmlSearchEngine, "PREFIX");
                        strSecondarySearchTermToReplace = EBXML_CT2958529.GetSingleNodeValue(xmlSearchEngine, "SEARCH_TERM_TO_REPLACE");
                        if (strSecondarySearchUrlPrefix && strSecondarySearchTermToReplace && iSecondarySearchTimeout) {
                            arrData["EB_SECONDARY_SEARCH_TERM_TO_REPLACE"] = strSecondarySearchTermToReplace;
                            arrData["EB_SECONDARY_PREFIX"] = strSecondarySearchUrlPrefix;
                            arrData["EB_SEARCH_TIMEOUT_SEC"] = iSecondarySearchTimeout * 1000;
                        }
                    }
                    break;
                case "SUGGEST_INFO":
                    for (var j = 0; j < xmlChildNode.childNodes.length; j++) {
                        var suggestInfoXmlChild = xmlChildNode.childNodes[j];
                        switch (suggestInfoXmlChild.tagName) {
                            case "SUGGEST_URL":
                                strSuggestUrlInner = EBXML_CT2958529.GetXmlNodeValue(suggestInfoXmlChild);
                                arrData["EB_SUGGEST_URL_INNER"] = strSuggestUrlInner;
                                break;
                            case "SUGGEST_CAPTION":
                                strSuggestCaption = EBXML_CT2958529.GetXmlNodeValue(suggestInfoXmlChild);
                                arrData["EB_SUGGEST_CAPTION"] = strSuggestCaption;
                                break;
                            case "SUGGEST_ORIGINATED_SEARCH_URL":
                                strSuggestOriginatedSearchUrl = EBXML_CT2958529.GetXmlNodeValue(suggestInfoXmlChild);
                                arrData["EB_SUGGEST_ORIGINATED_SEARCH_URL"] = strSuggestOriginatedSearchUrl;
                                break;
                        } // case
                    } // for
                    break;
            } //switch
        } //for

        var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(strCaption, strImageUrl, strHint, "", strName, arrData);
        xulMenuItem.addEventListener("command", function(event) {
            EBSearchBoxManager_CT2958529.MenuItemSearch(event);
            event.cancelBubble = true;
        }, false);

        //use default icon if exists
        EBDefaultsManager_CT2958529.checkIcon(xulMenuItem);

        //set attribute for element in chevron
        if (isInChevron)
            xulMenuItem.setAttribute(EBSearchBoxConsts_CT2958529.Attributes.IsInChevron, isInChevron);

        if (!xulInsertBefore)
            xulElementParent.appendChild(xulMenuItem);
        else
            xulElementParent.insertBefore(xulMenuItem, xulInsertBefore)
    };

    this.BuildSearchSeparator = function(xulElementParent) {
        var xulMenuSeparator = EBXULFactory_CT2958529.CreateMenuSeparator();
        xulElementParent.appendChild(xulMenuSeparator);
    };

    this.SetSearchSuggests = function(xmlSearchSuggests) {
        this.searchSuggests = new Array();

        var strDomain = "";
        var strSearchParam = "";
        var strOutputCharset = "";

        for (var i = 0; i < xmlSearchSuggests.childNodes.length; i++) {
            if (xmlSearchSuggests.childNodes[i].tagName == "SUGGEST_SEARCH_ENGINE") {
                var XML_SEARCH_SUGGEST = xmlSearchSuggests.childNodes[i];

                for (var j = 0; j < XML_SEARCH_SUGGEST.childNodes.length; j++) {
                    if (XML_SEARCH_SUGGEST.childNodes[j].tagName == "DOMAIN")
                        strDomain = EBXML_CT2958529.GetXmlNodeValue(XML_SEARCH_SUGGEST.childNodes[j]);
                    else if (XML_SEARCH_SUGGEST.childNodes[j].tagName == "SEARCH_PARAM")
                        strSearchParam = EBXML_CT2958529.GetXmlNodeValue(XML_SEARCH_SUGGEST.childNodes[j]);
                    else if (XML_SEARCH_SUGGEST.childNodes[j].tagName == "OUTPUT_CHARSET")
                        strOutputCharset = EBXML_CT2958529.GetXmlNodeValue(XML_SEARCH_SUGGEST.childNodes[j]);
                }

                this.searchSuggests.push(new EBSuggestObject_CT2958529(strDomain, strSearchParam, strOutputCharset));
            }
        }
    };

    this.GetSearchBoxWidth = function() {
        var strMenuListWidth = (!this.ComponentItem.defaultSearchBoxWidth || this.ComponentItem.defaultSearchBoxWidth <= 0) ? EBSearchBoxConsts_CT2958529.SearchBoxWidth : this.ComponentItem.defaultSearchBoxWidth;

        //check if there is the width save in the about:config
        var strPrefWidth = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.SearchBoxWidth);
        if (strPrefWidth && isFinite(strPrefWidth))
            strMenuListWidth = strPrefWidth;
      
        return strMenuListWidth;
    };

    this.AddToToolbar = function(objToolbarContainer) {

        //set toolbar button class[before adding to toolbar - important!]:
        this.SetToolbarButtonClass();

        //set the width of the search box(for the shrink-unshring build toolbar call)
        this.xulMenuList.setAttribute('width', this.GetSearchBoxWidth());
        
        this.XULToolbarItemContainerSearchBox = EBXULFactory_CT2958529.CreateToolbarItem();
        this.XULToolbarItemContainerSearchBox.setAttribute("persist", "width");
        this.XULToolbarItemContainerSearchBox.appendChild(this.xulMenuList);
        this.XULToolbarItemContainerSearchBox.appendChild(this.xulGoButton);

        objToolbarContainer.appendChild(this.XULToolbarItemContainerSearchBox);
        objToolbarContainer.appendChild(this.xulSplitter);

        this.SetChevronOnImageLoaded();


        //set the button global style[after adding to toolbar - important!]:
        EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.xulGoButton);

        //set the searchbox bgcolor
        EBToolbarDesignManager_CT2958529.SetToolbarSearchBoxBGColor(this.xulMenuList, this.ComponentItem.strBgColor);

        //set the search term
        EBSearchBoxManager_CT2958529.SetSearchBoxBGText();

        //Enable / Disable autocomplete

            this.xulMenuList.setAttribute('disableautocomplete', 'false');


        this.xulMenuList.maxLength = 256;
        //   this.xulMenuList.style.maxHeight = "22px";
        //    this.xulMenuList.style.height = "22px";

        if (EBGlobalManager_CT2958529.IsLinuxPlatform()) {
            //this.xulMenuList.style.marginTop = "0px";
            //this.xulMenuList.style.marginBottom = "0px";
            this.xulMenuList.style.border = "0px";
        }

        //EBSearchBoxManager_CT2958529.SetSuggestUrl(this.xulMenuList, this.SuggestUrl, this.SearchTermToReplace);

        this.OnLoadComponent();
    };

    this.GetToolbarItemContainer = function() {
        return this.XULToolbarItemContainerSearchBox;
    };

    this.RemoveFromToolbar = function(objToolbarContainer) {
        try {
            this.UnloadComponent();

            if (this.XULToolbarItemContainerSearchBox)
                objToolbarContainer.removeChild(this.XULToolbarItemContainerSearchBox);

            if (this.xulSplitter)
                objToolbarContainer.removeChild(this.xulSplitter);
        }
        catch (e) {
            EBLog(e, "cannot remove component");
        }
    };

    this.SetChevronOnImageLoaded = function() {
        if (!this.xulGoButton.getAttribute("image")) return;

        var oImage = document.getAnonymousElementByAttribute(this.xulGoButton, "class", "toolbarbutton-icon");

        if (!oImage) return;
        oImage.onload = function() {
            EBChevronStaticManager_CT2958529.onchange(true);
        };
    };

    this.OnLoadComponent = function() {
        this.observer = new EBSearchBoxObserver_CT2958529(this);
        this.observer.register();

        if (EBGlobalManager_CT2958529.IsToolbarRTL() && this.xulGoButton.hasAttribute('image') && !EBGlobalManager_CT2958529.IsLinuxPlatform())
            this.xulGoButton.image = this.xulGoButton.getAttribute("image");

        this.setAutocompleteParams();
    };

    this.UnloadComponent = function() {
        this.observer.unregister();
    };

    this.SetToolbarButtonClass = function() {
        EBToolbarDesignManager_CT2958529.SetToolbarButtonClass(this.ComponentItem.UniqueCompID, this.xulGoButton);
    };

    this.SetComponentCollapsed = function(isCollapsed) { };

    this.AddToChevron = function(objXULContainer) {
        return null;
    };

    this.CreateTooltipShrink = function() {
        EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID, this.xulGoButton);
    };

    this.backToDefault = function() {
        if (EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.SearchBackToDefault))
            return EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.SearchBackToDefault);
        else
            return this.ComponentItem.backToDefault;
    };

    this.changeSuggestState = function(bIsEnabled) {
        this.xulMenuList.setAttribute("disableautocomplete", !bIsEnabled);
    };

    this.changeHistoryState = function(bIsEnabled, cleanOnly) {
        if (cleanOnly) {
            EBSearchBoxManager_CT2958529.ClearSearchHistory();
            return;
        }
        var suggestPopup = document.getElementById("EBPopupAutoComplete_CT2958529");
        suggestPopup.hideClearHistoryLink(!bIsEnabled);
        this.xulMenuList.setAttribute('enablehistory', bIsEnabled);
        if (!bIsEnabled) {
            EBSearchBoxManager_CT2958529.ClearSearchHistory();
        }
    };
    
    this.setSearchTerm = function(searchTerm) {
        if (this.xulMenuList.value != searchTerm) {
            this.xulMenuList.value = searchTerm;
            return true;
        }
        else
            return false;
    };

    this.getSearchTerm = function() {
        return this.xulMenuList.value;
    };

    this.setImageAndTextToGoButton = function(menuItem) {
        var strCaption, strImage;
        var that = this;
        if (EBSearchBoxManager_CT2958529.isMajorDefault(menuItem)) {
            strCaption = this.ComponentItem.DisplayText;
            strImage = this.ComponentItem.DisplayIcon;
            // in rtl case the image should be inverse
            if (this.ComponentItem.mirrorActivateIconOnRTL && EBGlobalManager_CT2958529.GetToolbarDir() == "rtl" && this.xulGoButton.hasAttribute('image'))
                setTimeout(function() { EBCanvas_CT2958529.getMirrorImage(strImage, function(image) { that.xulGoButton.image = image; }); }, 0);
        }
        else {
            strImage = menuItem.getAttribute("image");
            strCaption = menuItem.getAttribute("label");
        }

        EBSearchBoxManager_CT2958529.SetSearchButton(this.xulGoButton, strImage, strCaption);
    };

    this.OnLanguagePackChange = function() {
        this.setAutocompleteParams();
    };
};

EBSearchBoxComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBSearchBoxComponent_CT2958529.constructor = EBSearchBoxComponent_CT2958529;

var EBSearchBoxConsts_CT2958529 =
{
    MaxSearchHistoryItems: 20,
    MaxSearchSuggestItems: 100,
    SearchHistoryFileName: 'search_history.xml',

    SearchButtonIDPrefix: 'EBSearchButton',
    SearchMenuListIDPrefix: 'EBSearchMenuList',
    SearchHighlighterIDPrefix: 'EBSearchHighlighter',
    SearchGoButtonIDPrefix: 'EBSearchGoButton',

    SearchBoxWidth: '150',

    SearchBoxMinWidth: '100',

    NoSearchHistoryText: '(No Search History)',

    BackToDefault: true,

    IsUserInput: null,

    GoButtonText: 'Go',

    xulGoButton: null,

    lastKeyPressTimeStamp: null,

    lastEnterKeyPressed: false,

    SplitString: '!!',

    SuggestHistoryCaption: 'History',

    SuggestSuggestCaption: 'Suggestions',

    SelectedEngineId: '',

    IsSearchLoaded: false,

    SearchUrl: '',
    
    SerachTarget:'',

    LastClick: null,
    
    XML:
	{
	    SearchHistoryTagName: 'HISTORY',
	    SearchHistoryItemTagName: 'ITEM'
	},

    Attributes:
	{
	    SearchButtonID: 'EB_SEARCH_BUTTON_ID',
	    SearchMenuListID: 'EB_SEARCH_MENULIST_ID',
	    HighlighterImageEnabled: 'EB_HIGHLIGHTER_IMAGE_ENABLED',
	    HighlighterImageDisabled: 'EB_HIGHLIGHTER_IMAGE_DISABLED',
	    IsInChevron: 'EB_SEARCH_MENU_ITEM_IS_IN_CHEVRON'
	},

    Images:
	{
	    DefaultSearch: 'http://www.conduit.com/images/searchengines/search_icon.gif',
	    Splitter: 'chrome://browsersearch/skin/splitter.ico',
	    GoButton: 'chrome://browsersearch/skin/go_btn.gif',
	    GoButtonRTL: 'chrome://browsersearch/skin/go_btnRTL.gif'
	},

    observerTopic: "eb-search-box-changed",
    observerData:
	{
	    changeSearchSuggestState: "changeSearchSuggestState",
	    changeSearchHistoryState: "changeSearchHistoryState"
	    
	},

	SUGGEST_TERM_ALIAS: "UCM_SUGGEST_TERM"
};

var EBSearchBoxManager_CT2958529 =
{
    //var to determine if the bg_text of specific search was set 
    //from the code (allow to search the bgtext value if the user write
    //the same search term as the bg_text)
    IsSetSearchBGText: true,

    //the command of the search menulist
    MenuListSearch: function(event) {
        //not to be erased by clicking on nothing on the page when "select to search box" in on.
        EBSearchBoxConsts_CT2958529.IsUserInput = true;

        switch (event.keyCode) {
            case KeyEvent.DOM_VK_DOWN:
                var suggestPopup = document.getElementById("EBPopupAutoComplete_CT2958529");
                suggestPopup.skipToNext();
                break;
            case KeyEvent.DOM_VK_UP:
                var suggestPopup = document.getElementById("EBPopupAutoComplete_CT2958529");
                suggestPopup.skipToPrevious();
                break;
            case KeyEvent.DOM_VK_ENTER:
            case KeyEvent.DOM_VK_RETURN:    
                var strSearchTerm = event.target.value;
                //EBSearchBoxConsts_CT2958529.lastEnterKeyPressed = Date.parse(Date());

                EBSearchBoxConsts_CT2958529.lastEnterKeyPressed = true;
                setTimeout(function() { EBSearchBoxConsts_CT2958529.lastEnterKeyPressed = false; }, 1000);
                if (this.IsSearchToNavigate(strSearchTerm)) {
                    strSearchTerm = EBUrl_CT2958529.AddHTTPProtocol(strSearchTerm);
                    event.customData = { "url": strSearchTerm };
                    EBLinkManager_CT2958529.LoadLinkURL(event);

                    //usage
                    EBUsageSearchBox_CT2958529.OnSearchBoxNavigate();
                }
                else {
                    var searchButton = EBComponentsManager_CT2958529.GetSearchBoxComponent().xulGoButton;
                    var defaultMenuItem = this.GetCurrentSearchEngineMenuItem(searchButton);

                    if (defaultMenuItem != null)
                        this.SetSearch(event, defaultMenuItem, strSearchTerm, EBUsageSearchBox_CT2958529.SEARCH_SOURCE_VK_RETURN);
                }
                break;
        }
    },

    IsSearchToNavigate: function(strSearchTerm) {
        strSearchTerm = EBGlobalManager_CT2958529.Trim(strSearchTerm);

        //chekc if it's contains spaces in the middle
        if (/\s/.test(strSearchTerm))
            return false;

        //check if it's legal URL
        if (EBUrl_CT2958529.IsLegalURL(strSearchTerm))
            return true;

        var strDomain = '';

        //get the domain suffix 
        //(say from google.co.il gets 'il' - the one before the last dot(.))
        if (!strSearchTerm)
            return false;

        var arrMatches = strSearchTerm.match(/.*\.([^\/^\?^:]+)/i);
        if (arrMatches) {
            strDomain = arrMatches[1];
            if (strDomain && EBGlobalManager_CT2958529.IsDomainExists(strDomain))
                return true;
        }

        return false;

    },

    //the command of the search button
    ButtonSearch: function(event) {
        //get the menu list value
        var searchComp = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        var strSearchTerm = searchComp.getSearchTerm();
        var defaultMenuItem = this.GetCurrentSearchEngineMenuItem(searchComp.xulGoButton);

        if (defaultMenuItem)
            this.SetSearch(event, defaultMenuItem, strSearchTerm, EBUsageSearchBox_CT2958529.SEARCH_SOURCE_GO_BUTTON);
    },


    //the command of the search menuitem button
    MenuItemSearch: function(event) {
        var objXULMenuItem = event.target;
        var oSearchComponent = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        var searchButton = oSearchComponent.xulGoButton;
        var inputBox = oSearchComponent.xulMenuList;
        var strImage, strCaption;

        //check if it's can_be_default to set the main search button
        if (oSearchComponent.ComponentItem.canChangeDefault) {
            oSearchComponent.setImageAndTextToGoButton(objXULMenuItem);

            var strSuggestUrl = objXULMenuItem.getAttribute("EB_SUGGEST_URL");
            var strSuggestCaption = objXULMenuItem.getAttribute("EB_SUGGEST_CAPTION");
            var strSearchTermToReplace = objXULMenuItem.getAttribute("EB_SEARCH_TERM_TO_REPLACE");

            // -- disable setting search engine in the preference --
            if (this.IsSearchMenuItemCanBeDefault(objXULMenuItem))
                this.SetSearchEnginePreference(objXULMenuItem);


            this.SetSuggestUrl(inputBox, strSuggestUrl, strSearchTermToReplace);

            //check if it's chevron element to update the  menuitem
            //of the toolbar itself (update the radio selection)
            var iIndex = EBGlobalManager_CT2958529.GetDOMElementIndex(objXULMenuItem);
            if (iIndex != -1) {
                var objSearchBoxToolbarMenuItem = searchButton.firstChild.childNodes[iIndex];
                if (objSearchBoxToolbarMenuItem) {
                    //set this menuitem to check=true and the
                    //rest of the menuitems to check=false
                    //if not there is double selection(Firefox bug?!)
                    var objChildXULMenuItem = null;
                    for (var i = 0; i < searchButton.firstChild.childNodes.length; i++) {
                        objChildXULMenuItem = searchButton.firstChild.childNodes[i];
                        if (objChildXULMenuItem == objSearchBoxToolbarMenuItem) {
                            objChildXULMenuItem.setAttribute("style", "font-weight:bold");
                            objChildXULMenuItem.setAttribute("checked", "false");
                            objChildXULMenuItem.setAttribute("EBchecked", "true");
                        }
                        else {
                            objChildXULMenuItem.setAttribute("style", "font-weight:normal");
                            objChildXULMenuItem.setAttribute("EBchecked", "false");
                        }
                    }
                }
            }
        }

        //checked the selected menuitem after the page loads for search
        //if the mouse button is middle
        if (event.button == 1 && bIsCanBeDefault) {
            objXULMenuItem.setAttribute("style", "font-weight:bold");
            objXULMenuItem.setAttribute("EBchecked", "true");
        }

        //check to see if to set the bgtext
        if (this.IsSetSearchBGText)
            this.SetSearchBoxBGText();

        //get the menu list value
        var strSearchTerm = EBComponentsManager_CT2958529.GetSearchBoxComponent().getSearchTerm();
        var engineId = objXULMenuItem.getAttribute("EB_UNIQUE_ID");

        if (strSearchTerm)
            this.SetSearch(event, objXULMenuItem, strSearchTerm, EBUsageSearchBox_CT2958529.SEARCH_SOURCE_ENGINES_MENU);
        else {
            EBUsageSearchBox_CT2958529.OnChangeSearchEngine(EBSearchBoxConsts_CT2958529.SelectedEngineId, engineId);
            inputBox.focus();
        }

        EBSearchBoxConsts_CT2958529.SelectedEngineId = engineId;
    },

    SetSuggestUrl: function(oInputBox, strSuggestUrl, strSearchTermToReplace) {
        var oSearchComp = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        if (!oSearchComp) return;

        var fullSuggestUrl = (strSuggestUrl && strSearchTermToReplace) ?
            strSuggestUrl + EBSearchBoxConsts_CT2958529.SplitString + strSearchTermToReplace : "";
        oSearchComp.SuggestUrl = fullSuggestUrl;
        oSearchComp.setAutocompleteParams();
    },

    //search from the search history menu
    MenuItemHistorySearch: function(event) {
        var xulSearchButton = EBComponentsManager_CT2958529.GetSearchBoxComponent().xulGoButton;
        var defaultMenuItem = this.GetCurrentSearchEngineMenuItem(xulSearchButton);

        if (defaultMenuItem) {
            var oMenuItemHistory = event.target;

            //close the parent popup menu(it's stay open on middle click)
            oMenuItemHistory.parentNode.hidePopup();

            var strSearchTerm = oMenuItemHistory.getAttribute("label");
            this.SetSearch(event, defaultMenuItem, strSearchTerm, EBUsageSearchBox_CT2958529.SEARCH_SOURCE_HISTORY);

            var XULSearchBoxMenuList = EBComponentsManager_CT2958529.GetSearchBoxMenuList();
            if (XULSearchBoxMenuList) {
                XULSearchBoxMenuList.value = strSearchTerm;
            }

            EBActionManager_CT2958529.SearchTermChanged();

        }
    },

    //this function get the current active search(menu item)
    //parse it's element and according it does the search
    SetSearch: function(event, currentMenuItem, strSearchTerm, strSearchSource) {
        EBValidationManager_CT2958529.validate(EBPreferenceConsts_CT2958529.ValidationData_Search);
        //get the stored menu item data

        var bIsSearchFromSuggest = false;
        var strPrefix = "";

        //check the strSearchTerm
        var strSearchTermTrim = EBGlobalManager_CT2958529.TotalTrim(strSearchTerm);
        var isBlankSearch = strSearchTermTrim == '' ? true : false;
        //check the bgtext - if this is the auto bgtext(as oppose to the user
        //enter the same term as the bgtext) i consider it as a blank search!
        var strBGText = this.GetSearchBGText();
        if (this.IsSetSearchBGText && strSearchTerm == strBGText)
            isBlankSearch = true;

        var bIsHistoryItem = (isBlankSearch) ? false : this.AddTermToSuggestHistory(strSearchTerm);

        //set suggest usage
        if (strSearchSource == EBUsageSearchBox_CT2958529.SEARCH_SOURCE_HISTORY && !bIsHistoryItem) {
            bIsSearchFromSuggest = true;
            strSearchSource = EBUsageSearchBox_CT2958529.SEARCH_SOURCE_SUGGEST;
        }

        if (bIsSearchFromSuggest && currentMenuItem.getAttribute("EB_SUGGEST_ORIGINATED_SEARCH_URL")) {
            strPrefix = currentMenuItem.getAttribute("EB_SUGGEST_ORIGINATED_SEARCH_URL");
            var autoComplete = Components.classes["@mozilla.org/autocomplete/search;1?name=conduit-auto-complete-with-suggest4"].getService(Components.interfaces.nsIConduitAutoCompleteSearch);
            strPrefix = strPrefix.replace(EBSearchBoxConsts_CT2958529.SUGGEST_TERM_ALIAS, autoComplete.wrappedJSObject.searchString);
        }
        else
            strPrefix = currentMenuItem.getAttribute("EB_PREFIX");

        var strTermToReplace = currentMenuItem.getAttribute("EB_SEARCH_TERM_TO_REPLACE");
        var strEmptySearchUrl = currentMenuItem.getAttribute("EB_EMPTY_SEARCH_URL");
        var objSecondarySearch = this.getSecondarySearchData(currentMenuItem);

        var strSearchUrl = EBXML_CT2958529.FromLegalXml(strPrefix);

        var originalForABTesting = EBActionManager_CT2958529.GetTestingCTID();
        if (originalForABTesting) {
            strSearchUrl = strSearchUrl.replace(/EB_ORIGINAL_CTID/, originalForABTesting);
            strEmptySearchUrl = strEmptySearchUrl.replace(/EB_ORIGINAL_CTID/, originalForABTesting);
        }
        var target = EBSearchBoxConsts_CT2958529.SerachTarget ? EBSearchBoxConsts_CT2958529.SerachTarget : "SELF";
        if (target == "NEW") target = "BLANK";
        if (isBlankSearch) {
            //check if there is alternative url to navigate when the search is empty
            if (strEmptySearchUrl != "")
                strSearchUrl = EBActionManager_CT2958529.ConvertAliasesUrl(strEmptySearchUrl);
            else
                strSearchUrl = EBUrl_CT2958529.GetBaseUrl(strSearchUrl);
            //activate secondary search watch
            EBSecondarySearchManager_CT2958529.onSearchStarted(objSecondarySearch, event, null, "", strSearchUrl);
            event.customData = { "url": strSearchUrl, "urlTarget": target };
            EBLinkManager_CT2958529.LoadLinkURL(event);
        }
        else {
            //check to see if it's a post url
            var strType = currentMenuItem.getAttribute("EB_TYPE");

            var strInputCharset = currentMenuItem.getAttribute("EB_INPUT_CHARSET");

            if (strType.toUpperCase() != "POST") {
                //convert the search term according to the given xml charset
                //only in get method! - in the post method the conversion is in the 
                //form element via accept-charset

                strSearchTerm = EBFileIO_CT2958529.fromUnicode(strInputCharset, strSearchTerm);
                strSearchTerm = escape(strSearchTerm);
            }
            //strSearchTerm = strSearchTerm.replace(/\+/g,"%2B");

            //replace the spaces and %20 with "+" sign
            //understood by all search engines as space
            strSearchTerm = strSearchTerm.replace(/ /g, "+");
            strSearchTerm = strSearchTerm.replace(/%20/g, "+");

            //replace the const term with the actual search term
            strSearchUrl = strSearchUrl.replace(strTermToReplace, strSearchTerm);

            //replace the aliases
            strSearchUrl = EBActionManager_CT2958529.ConvertAliasesUrl(strSearchUrl);

            var strPostParams = null;

            if (strType.toUpperCase() == "POST") {
                strPostParams = currentMenuItem.getAttribute("EB_POST_PARAMS");
                strSearchTerm = EBFileIO_CT2958529.fromUnicode(strInputCharset, strSearchTerm);

                //replace the const term with the actual search term
                strPostParams = strPostParams.replace(strTermToReplace, strSearchTerm);
            }

            EBSecondarySearchManager_CT2958529.onSearchStarted(objSecondarySearch, event, strPostParams, strSearchTerm, strSearchUrl);
            event.customData = { "url": strSearchUrl, "postParams": strPostParams, "urlTarget": target };
            EBLinkManager_CT2958529.LoadLinkURL(event);
        }

        //usage call    
        var engineId = currentMenuItem.getAttribute('EB_UNIQUE_ID');

        if (isBlankSearch)
            strPrefix = '';

        EBUsageSearchBox_CT2958529.OnSearch(strPrefix, engineId, strSearchSource);
    },

    SetSearchButton: function(searchButton, strImage, strCaption) {
        var setGoButton = function(image, caption) {
            searchButton.setAttribute("image", image);
            searchButton.setAttribute("tooltiptext", caption);
            searchButton.setAttribute("label", caption);
            EBComponentsManager_CT2958529.GetSearchBoxComponent().SetToolbarButtonClass();
            EBChevronStaticManager_CT2958529.onchange(false);
        };

        //check for default
        if (!strImage)
        //get the default image for the search button
            strImage = EBSearchBoxConsts_CT2958529.Images.DefaultSearch;

        var oImage = new Image();
        oImage.onerror = function() { setGoButton(EBSearchBoxConsts_CT2958529.Images.GoButton, strCaption); oImage = null; }

        oImage.onload = function() {
            setGoButton(strImage, strCaption);
            oImage = null;
        };

        oImage.src = strImage;
    },

    OnInputSearchBox: function(menuListObj) {
        EBActionManager_CT2958529.SearchTermChanged();
    },

    IsInChevronMenuItemElement: function(objXULElement) {
        var strIsInChevron = objXULElement.getAttribute(EBSearchBoxConsts_CT2958529.Attributes.IsInChevron);
        return strIsInChevron == 'true' ? true : false;
    },

    OnMouseDownSplitter: function(event) {
        EBChevronStaticManager_CT2958529.startSearchSplitterMove(event);
    },

    OnMouseUpSplitter: function(event) {
        this.SetPrefMenuListWidth(false);
        EBChevronStaticManager_CT2958529.endSearchSplitterMove(event);
    },

    SetPrefMenuListWidth: function(disableUsage) {
        //save the toolbar menulist width
        var xulMenuList = EBComponentsManager_CT2958529.GetSearchBoxMenuList();

        if (xulMenuList) {
            var iOldWidth = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.SearchBoxWidth);
            var iNewWidth = xulMenuList.boxObject.width;

            //save it to the about:config
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.SearchBoxWidth, xulMenuList.boxObject.width);

            //usage
            if (disableUsage) return;

            if (!iOldWidth)
                iOldWidth = EBSearchBoxConsts_CT2958529.SearchBoxWidth;

            EBUsageSearchBox_CT2958529.OnSearchBoxResize(iOldWidth, iNewWidth);
        }

    },

    GetHighlighterButtonOnToolbar: function() {
        return document.getElementById(EBSearchBoxConsts_CT2958529.SearchHighlighterIDPrefix + EBGlobalConsts_CT2958529.ToolbarCTID);
    },

    GetCurrentSearchEngineMenuItem: function(searchButton) {
        var menuItemElements = searchButton.getElementsByAttribute("EBchecked", "true");
        if (menuItemElements.length == 0) {
            return searchButton.firstChild.childNodes[0];
        }
        else {
            return menuItemElements[0];
        }
        return null;
    },

    IsSearchMenuItemCanBeDefault: function(menuItem) {
        var strCanBeDefault = menuItem.getAttribute("EB_CAN_BE_DEFAULT");
        if (strCanBeDefault == "TRUE")
            return true;
        else
            return false;
    },

    //save the search engine in the about:config
    SetSearchEnginePreference: function(defaultMenuItem) {
        var strName = encodeURIComponent(defaultMenuItem.getAttribute("label"));
        var strPrefix = defaultMenuItem.getAttribute("EB_PREFIX");
        var strPrefName = EBPreferenceConsts_CT2958529.SearchEngine;
        var strPrefValue = strName + EBGlobalConsts_CT2958529.Delimiter + strPrefix;

        //if (.backToDefault())
        var oSearchComp = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        if (!oSearchComp) return;
        oSearchComp.selectedSearchEngine = strPrefValue;
        //else
        EBToolbarPreferenceManager_CT2958529.SetPref(strPrefName, strPrefValue, true);
    },

    AddTermToSuggestHistory: function(strSearchTerm) {
        var bIsFound = false;
        var bEnabled = (EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.EnableSearchHistory)) ?
                            EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.EnableSearchHistory) :
                            true;
        if (!bEnabled) return;

        //get the xml history file
        strSearchTerm = strSearchTerm.replace(/\+/g, " ");

        var fileSearchHistoryXML = EBSearchBoxManager_CT2958529.GetSuggestHistoryFile();
        //create domParser
        var strXMLSearch = EBFileIO_CT2958529.read(fileSearchHistoryXML, EBGlobalConsts_CT2958529.DefaultCharset);
        var xmlDocSearch = EBXML_CT2958529.GetXmlDocument(strXMLSearch);
        //get root nodes
        var xmlSearchRoot = xmlDocSearch.documentElement;
        var xmlSearchItems = xmlSearchRoot.getElementsByTagName(EBSearchBoxConsts_CT2958529.XML.SearchHistoryItemTagName);
        var xmlSearchItem = null;
        var strXMLValue = "";
        //check if this search term already in the history
        for (var i = 0; i < xmlSearchItems.length; i++) {
            xmlSearchItem = xmlSearchItems.item(i);
            strXMLValue = EBXML_CT2958529.GetXmlNodeValue(xmlSearchItem);
            if (strXMLValue == strSearchTerm) {
                xmlSearchRoot.removeChild(xmlSearchItem);
                bIsFound = true;
                break;
            }
        }

        var xmlSearchHistoryItem = EBXML_CT2958529.CreateXmlTextNode(xmlDocSearch, EBSearchBoxConsts_CT2958529.XML.SearchHistoryItemTagName, strSearchTerm);

        //insert the new value to the top of the list
        xmlSearchRoot.insertBefore(xmlSearchHistoryItem, xmlSearchRoot.firstChild);

        //check to remove the unnecessary items
        if (xmlSearchRoot.childNodes.length > EBSearchBoxConsts_CT2958529.MaxSearchSuggestItems) {
            xmlSearchRoot.removeChild(xmlSearchRoot.lastChild);
        }

        //save the changes to the file
        EBFileIO_CT2958529.write(fileSearchHistoryXML, EBXML_CT2958529.GetStringXml(xmlSearchRoot), "", EBGlobalConsts_CT2958529.DefaultCharset);

        return bIsFound;

    },

    ClearSearchHistory: function() {
        var xulMenuList = EBComponentsManager_CT2958529.GetSearchBoxMenuList();

        if (xulMenuList) {
            var xulMenuPopup = xulMenuList.firstChild;
            //empty all menu items
            while (xulMenuPopup.childNodes.length > 0) {
                xulMenuPopup.removeChild(xulMenuPopup.firstChild);
            }

            //place "no search history" menu item
            var xulMenuItem = EBXULFactory_CT2958529.CreateMenuItem(oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_NO_SEARCH_HISTORY_FOUND"),
															"",
															"",
															"",
															"",
															null);
            xulMenuItem.setAttribute("height", "18");
            xulMenuItem.setAttribute("disabled", "true");
            xulMenuPopup.appendChild(xulMenuItem);

            xulMenuList.value = "";
            EBActionManager_CT2958529.SearchTermChanged();
            //set the bgtext
            this.SetSearchBoxBGText();
        }
    },

    ClearSearchHistoryFile: function() {
        //nullify XML history file
        var fileSearchHistoryXML = this.GetSearchHistoryFile();
        EBFileIO_CT2958529.write(fileSearchHistoryXML, "", "", EBGlobalConsts_CT2958529.DefaultCharset);

        this.ClearSuggetFile();
    },

    ClearSuggetFile: function() {
        //nullify XML history suggest file
        var fileSearchHistoryXML = EBIOManager_CT2958529.CreateSuggestFile(EBSearchBoxConsts_CT2958529.SearchHistoryFileName);
        var strXML = "<" + EBSearchBoxConsts_CT2958529.XML.SearchHistoryTagName + "/>";
        EBFileIO_CT2958529.write(fileSearchHistoryXML, strXML, "", EBGlobalConsts_CT2958529.DefaultCharset);
    },

    OnMouseDownSearchBox: function(event, XULMenuList) {
        if (!XULMenuList.hasAttribute("focused")) {
            XULMenuList.inputField.setSelectionRange(0, 0);
        }
    },

    OnClickSearchBox: function(event, XULMenuList) {
        EBSearchBoxConsts_CT2958529.LastClick = Date.parse(Date());
    },

    OnOpenSuggestWindow: function() {
        var OnOpenSuggestWindowAsync = function() {
            if (EBSearchBoxConsts_CT2958529.LastClick &&
	            Date.parse(Date()) - EBSearchBoxConsts_CT2958529.LastClick == 0)
                EBUsageSearchBox_CT2958529.OnOpenSuggestWindow();
        };

        setTimeout(OnOpenSuggestWindowAsync, 50);
    },

    OnCloseSuggestWindow: function() {
        var OnCloseSuggestWindowAsync = function() {
            EBUsageSearchBox_CT2958529.OnCloseSuggestWindow();
        };

        setTimeout(OnCloseSuggestWindowAsync, 100);
    },

    GetSearchHistoryFile: function() {
        //get the search history file - if it doesn't exists - create it!
        var fileSearchHistoryXML = EBIOManager_CT2958529.CreateToolbarFile(EBSearchBoxConsts_CT2958529.SearchHistoryFileName);

        //check if what we created is an empty file
        //so we create the string of the xml
        if (!fileSearchHistoryXML.exists() || fileSearchHistoryXML.fileSize <= 0) {
            var strXML = this.GetDefaultSearchHistoryXMLString();
            EBFileIO_CT2958529.write(fileSearchHistoryXML, strXML, "", EBGlobalConsts_CT2958529.DefaultCharset);
        }

        return fileSearchHistoryXML;

    },

    GetSuggestHistoryFile: function() {
        //get the search history file - if it doesn't exists - create it!
        var fileSearchHistoryXML = EBIOManager_CT2958529.CreateSuggestFile(EBSearchBoxConsts_CT2958529.SearchHistoryFileName);

        //check if what we created is an empty file
        //so we create the string of the xml
        if (!fileSearchHistoryXML.exists() || fileSearchHistoryXML.fileSize <= 0) {
            var strXML = "<" + EBSearchBoxConsts_CT2958529.XML.SearchHistoryTagName + "/>";
            EBFileIO_CT2958529.write(fileSearchHistoryXML, strXML, "", EBGlobalConsts_CT2958529.DefaultCharset);
        }

        return fileSearchHistoryXML;

    },

    GetDefaultSearchHistoryXMLString: function() {
        var strXML = "";

        strXML += "<" + EBSearchBoxConsts_CT2958529.XML.SearchHistoryTagName + ">";

        for (var i = 0; i < EBSearchBoxConsts_CT2958529.MaxSearchHistoryItems; i++) {
            strXML += "<" + EBSearchBoxConsts_CT2958529.XML.SearchHistoryItemTagName + "/>";
        }

        strXML += "</" + EBSearchBoxConsts_CT2958529.XML.SearchHistoryTagName + ">";

        return strXML;
    },

    SetSearchBoxBGText: function() {
        var strBGText = this.GetSearchBGText();

        //get search box
        var XULSearchBoxMenuList = EBComponentsManager_CT2958529.GetSearchBoxMenuList();

        if (XULSearchBoxMenuList) {
            if (strBGText) {
                XULSearchBoxMenuList.value = strBGText;
                //set the var that sais that the bg text search is set
                this.IsSetSearchBGText = true;
            }
            else {
                XULSearchBoxMenuList.value = '';
            }
        }
    },

    GetSearchBGText: function() {
        var strBGText = '';

        var searchComp = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        var XULSearchButton = searchComp.xulGoButton;

        if (XULSearchButton) {
            var XULMenuItemCurrentSearchEngine = this.GetCurrentSearchEngineMenuItem(XULSearchButton);

            if (XULMenuItemCurrentSearchEngine)
                strBGText = XULMenuItemCurrentSearchEngine.getAttribute('EB_BG_TEXT');
        }

        return strBGText;
    },

    OnSearchBoxFocus: function(event) {
        var XULSearchBoxMenuList = event.target;

        var strBGText = this.GetSearchBGText();
        var strSearchBoxValue = XULSearchBoxMenuList.value;

        //check if set the bgtext automatically to nullify the search
        //term on focus
        if (this.IsSetSearchBGText && strSearchBoxValue == strBGText) {
            XULSearchBoxMenuList.value = '';
        }
        else if (strSearchBoxValue != '') //if the term is not empty select it on the focus event!
        {
            XULSearchBoxMenuList.select();
        }

    },

    OnSearchBoxBlur: function(event) {
        //event the occur when the search box looses the focus.
        //in this case we check to set the bgtext again
        var XULSearchBoxMenuList = event.target;
        var strSearchBoxValue = XULSearchBoxMenuList.value;
        if (strSearchBoxValue == '') {
            this.SetSearchBoxBGText();
        }
    },

    OnCommandSearchBox: function(event) { },

    OnSelectSearchTermFromHistoryAsync: function(e) {
        setTimeout(function() { EBSearchBoxManager_CT2958529.OnSelectSearchTermFromHistory(e); }, 10);
    },

    OnSelectSearchTermFromHistory: function(event) {
        EBSearchBoxConsts_CT2958529.IsUserInput = true;
        var searchButtonId = EBSearchBoxConsts_CT2958529.SearchButtonIDPrefix + EBGlobalConsts_CT2958529.ToolbarCTID;
        var xulButton = document.getElementById(searchButtonId);
        //get the search button via the string id
        var searchButton = EBComponentsManager_CT2958529.GetSearchBoxComponent().xulGoButton;
        var defaultMenuItem = this.GetCurrentSearchEngineMenuItem(searchButton);

        var strSearchTerm = EBComponentsManager_CT2958529.GetSearchBoxComponent().getSearchTerm();

        if (defaultMenuItem) {
            if (EBSearchBoxConsts_CT2958529.lastEnterKeyPressed == false)
                this.SetSearch(event, defaultMenuItem, strSearchTerm, EBUsageSearchBox_CT2958529.SEARCH_SOURCE_HISTORY);
        }
    },

    isMajorDefault: function(menuItem) {
        return EBGlobalManager_CT2958529.GetBooleanAttribute(menuItem, "MAJOR_DEFAULT", false)
    },

    getSecondarySearchData: function(xulButton) {
        var strPrefix = xulButton.getAttribute("EB_SECONDARY_PREFIX");
        if (!strPrefix) return null;

        var strSearchTermToReplace = xulButton.getAttribute("EB_SECONDARY_SEARCH_TERM_TO_REPLACE");
        var iInterval = parseInt(xulButton.getAttribute("EB_SEARCH_TIMEOUT_SEC"));
        var strEngineId = xulButton.getAttribute("EB_UNIQUE_ID");
        return { 'prefix': strPrefix, 'searchTermToReplace': strSearchTermToReplace, 'interval': iInterval, 'engineId': strEngineId };
    }
}





function EBSearchBoxObserver_CT2958529(searchComponent) {
    this.Topic = EBSearchBoxConsts_CT2958529.observerTopic;

    this.observe = function(aSubject, aTopic, aData) {
        aSubject = aSubject.wrappedJSObject;
        if (aSubject.originalCTID != EBGlobalConsts_CT2958529.ToolbarCTID) return;
        switch (aData) {
            case EBSearchBoxConsts_CT2958529.observerData.changeSearchSuggestState:
                searchComponent.changeSuggestState(aSubject.isEnabled);
                break;

            case EBSearchBoxConsts_CT2958529.observerData.changeSearchHistoryState:
                searchComponent.changeHistoryState(aSubject.isEnabled, aSubject.cleanOnly);
                break;
            default: break;
        }
    };
};

EBSearchBoxObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();
function EBSeparatorComponent_CT2958529(objSeparatorItem)
{

    EBBaseToolbarComponent_CT2958529.call(this, objSeparatorItem);
	
	this.ComponentItem				= objSeparatorItem;
	this.XULElement					= null;
	this.XULChevronElement			= null;
	this.XULToolbarItemContainer	= null;
	
	this.Init = function()
	{
	    if(oToolbarSkin_CT2958529.separatorImageUrl)
	        this.XULElement = EBXULFactory_CT2958529.CreateImage(oToolbarSkin_CT2958529.separatorImageUrl);
	    else
		    this.XULElement = EBXULFactory_CT2958529.CreateToolbarSeparator();
		
		return true;
	};
	
	this.AddToToolbar = function(objToolbarContainer)
	{
		this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
		this.XULToolbarItemContainer.appendChild(this.XULElement);
		objToolbarContainer.appendChild(this.XULToolbarItemContainer);

		this.handleSetDetectionForChevron();
	};
	
	this.UnloadComponent = function() { };
	
	this.SetToolbarButtonClass = function() { };
	
	this.SetComponentCollapsed = function(isCollapsed)
	{
		if(this.XULToolbarItemContainer)
		{
			this.XULToolbarItemContainer.setAttribute('collapsed',isCollapsed);
		}
	};
	
	this.AddToChevron = function(objXULContainer)
	{
		this.XULChevronElement = null;
		
		this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuSeparator();
	
		objXULContainer.appendChild(this.XULChevronElement);
		
		return this.XULChevronElement;
	};
};

EBSeparatorComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBSeparatorComponent_CT2958529.constructor = EBSeparatorComponent_CT2958529;
function EBToggleComponent_CT2958529(toggleItem)
{
    EBBaseToolbarComponent_CT2958529.call(this, toggleItem);
    
    this.ComponentItem = toggleItem;
	this.XULElement = null;
	this.XULChevronElement = null;
	this.ButtonId = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
	this.IsChecked = false;
	this.buttonCommandCallback = null;

	this.Init = function() {


	    var strUniqueCompId = this.ComponentItem.UniqueCompID;
	    var strCompType = this.ComponentItem.CompType;
	    this.buttonCommandCallback = function(event) {
	        EBToggleComponentManager_CT2958529.OnClick(event, strUniqueCompId, strCompType);
	    };
	    if (!EBToggleComponentManager_CT2958529.HasIsPressedStateFromPreferences(strUniqueCompId) && this.ComponentItem.defaultMode)
	        EBToggleComponentManager_CT2958529.SetIsPressedStateFromPreferences(strUniqueCompId, this.ComponentItem.defaultMode);
	    this.ComponentItem.button = this.ComponentItem.buttonOff;
	    this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(this.ButtonId,
														"",
														this.ComponentItem.button.text,
														this.ComponentItem.button.image,
														this.ComponentItem.button.tooltip,
														this.buttonCommandCallback,
														"");
	
	    this.XULElement.setAttribute('checked', false);
	    
	    

	    //create the tooltip element (for the shrink-unshrink tooltip)
	    this.CreateTooltipShrink();

	    return true;
	};

	this.AddToToolbar = function(objToolbarContainer, isFirst) {
	    //nullify chevron element in order to know if this component is in chevron or in toolbar.
	    this.XULChevronElement = null;

	    //set toolbar button class[before adding to toolbar - important!]:
	    this.SetToolbarButtonClass();

	    this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
	    this.XULToolbarItemContainer.appendChild(this.XULElement);
	    
	    if (!isFirst || objToolbarContainer.childNodes.length == 0)
	        objToolbarContainer.appendChild(this.XULToolbarItemContainer);
	    else
	        objToolbarContainer.insertBefore(this.XULToolbarItemContainer, objToolbarContainer.firstChild);
	    
	    this.SetChevronOnImageLoaded();

	    //set the button global style[after adding to toolbar - important!]:
	    EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement);

	    this.OnloadComponent();
	};

	this.OnloadComponent = function() {
	    EBToggleComponentManager_CT2958529.InitComponent(this);
	    if (EBActionManager_CT2958529.IsAppView()) {
	        this.XULElement.style.marginLeft = "3px";
	        this.XULElement.style.marginRight = "11px";
	    }
	};

	this.ToggleOn = function() {
	    this.ComponentItem.button = this.ComponentItem.buttonOn;
	    this.UpdateToggleState();
	    this.XULElement.checked = true;
	    this.IsChecked = true;
	};

	this.ToggleOff = function() {
	    this.ComponentItem.button = this.ComponentItem.buttonOff;
	    this.UpdateToggleState();
	    this.XULElement.checked = false;
	    this.IsChecked = false;
	};

	this.UpdateToggleState = function() {
	    this.XULElement.label = this.ComponentItem.button.text;
	    this.XULElement.image = this.ComponentItem.button.image;
	    this.XULElement.setAttribute('tooltiptext', this.ComponentItem.button.tooltip);
	};

	this.AddToChevron = function(objXULContainer) {
	    if (this.XULChevronElement) {
	        this.XULChevronElement.removeEventListener("command", this.buttonCommandCallback, false);
	        this.XULChevronElement = null;
	    }

	    var strLabel = this.ComponentItem.button.text;
	    var strImage = this.ComponentItem.button.image;
	    var strTooltip = this.ComponentItem.button.tooltip;

	    this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuItem(strLabel, strImage, strTooltip, this.buttonCommandCallback, "", null);
	    this.XULChevronElement.setAttribute('checked', this.IsChecked);
	    objXULContainer.appendChild(this.XULChevronElement);

	    this.handleSetDetectionForChevron();

	    return this.XULChevronElement;
	};

	this.CreateTooltipShrink = function() {
	    EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID, this.XULElement);
	};
};

EBToggleComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBToggleComponent_CT2958529.constructor = EBToggleComponent_CT2958529;

function EBTwitterComponent_CT2958529(objTwitterItem) {
    EBMultiFeedComponent_CT2958529.call(this, objTwitterItem);
    
    var CHEVRON_ICON = "chrome://browsersearch/skin/twitter/twitter_chevron.gif";
    var DEFAULT_IMAGE = "chrome://browsersearch/skin/twitter/twitter_no_img.png";
    
    this.ComponentItem = objTwitterItem;
    this.XULElement = null;
    this.XULToolbarItemContainer = null;
    this.XULChevronElement = null;
    this.FeedComponents = new Array();
    this.TwitterUsers = null;

    this.Init = function() {
        oToolbar_CT2958529.twitter.usersManager.registerComponent(objTwitterItem.arrFollowedUsers, objTwitterItem.generalUserInfo);
        this.TwitterUsers = oToolbar_CT2958529.twitter.usersManager.getUsersInfo(objTwitterItem.arrFollowedUsers);

        var oUser = null;
        var oTwitterRssComp = null;
        for (var i = 0; i < this.TwitterUsers.length; i++) {
            oUser = this.TwitterUsers[i];
            oTwitterRssComp = new EBTwitterRssComponent_CT2958529(oUser, this.ComponentItem.UniqueCompID, i)
            oTwitterRssComp.Init();
            if (this.TwitterUsers.length == 1)
                oTwitterRssComp.IsSingle = true;

            this.FeedComponents.push(oTwitterRssComp);
        }

        var strType = "menu";
        var strLabel = this.ComponentItem.button.text;
        var strImage = this.ComponentItem.button.image;
        var strTooltip = this.ComponentItem.button.tooltip;
        var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
        this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID, strType, strLabel, strImage, strTooltip, "", "");
        this.XULElement.setAttribute("context", "");
        var xulMenuPopup = this._getMenuPopup();
        xulMenuPopup.setAttribute("class", "ebTwitterMenupopup_CT2958529");
        //add all to the main multi feed button:
        this.XULElement.appendChild(xulMenuPopup);

        return true;
    };

    this.createFeedsMenu = function(objXULMainMenuPopup) {
        var twitterUser = null;
        var feedMenu = null;
        for (var i = 0; i < this.TwitterUsers.length; i++) {
            twitterUser = this.TwitterUsers[i];
            feedMenu = this._addFeedMenu(objXULMainMenuPopup, twitterUser, i);
        }
    };

    this._addFeedMenu = function(objXULMainMenuPopup, twitterUser, i) {
        var xulMenu = EBXULFactory_CT2958529.CreateMenu("", "", "")
        var className = "ebTwitterMenuItem_CT2958529";
        xulMenu.setAttribute("class", className);
        var image = (twitterUser.profileImageUrl) ? twitterUser.profileImageUrl : DEFAULT_IMAGE;
        xulMenu.setAttribute("image", image);
        xulMenu.setAttribute("screenname", twitterUser.displayName);
        if (!twitterUser.personalPageUrl) EBLog("no personal page url for: " + twitterUser.displayName);
        xulMenu.setAttribute("homepageurl", twitterUser.personalPageUrl);
        xulMenu.setAttribute("url", twitterUser.url);
        xulMenu.setAttribute("description", twitterUser.description);
        xulMenu.setAttribute("lastitem", i == this.TwitterUsers.length - 1);
        //data for usage
        xulMenu.setAttribute("userId", twitterUser.userId);
        xulMenu.setAttribute("screenName", twitterUser.screenName);
        xulMenu.setAttribute("compId", this.ComponentItem.UniqueCompID);
        xulMenu.setAttribute("elementId", twitterUser.UniqueCompID);
        xulMenu.setAttribute("compType", this.ComponentItem.CompType);

        var strOnPopupShowing = "return EBFeedUIManager_CT2958529.onFeedShowing(event,'" + this.ComponentItem.UniqueCompID + "'," + i + ", true);";
        var strOnPopupHiding = "";
        var xulMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup(Math.random(), strOnPopupShowing, strOnPopupHiding);
        xulMenuPopup.setAttribute("class", "ebTwitterDialogPopup_CT2958529");

        xulMenu.appendChild(xulMenuPopup);
        objXULMainMenuPopup.appendChild(xulMenu);

        //if there is only one twitter user, open the twitter dialog
        if (this.TwitterUsers.length == 1 && EBGlobalManager_CT2958529.IsFirefox3())
            setTimeout(function() {
                xulMenu.openSubMenu();
            }, 1);
    };

    this._getMenuPopup = function() {
        var strOnPopupShowing = "return EBFeedUIManager_CT2958529.onFeedsMenuShowing(event,'" + this.ComponentItem.UniqueCompID + "', true);";
        var strOnPopupHiding = "return EBFeedUIManager_CT2958529.onFeedMenuHiding(event,'" + this.ComponentItem.UniqueCompID + "', true);";
        var strOnPopupShown = "return EBFeedUIManager_CT2958529.onFeedsMenuShown(event,'" + this.ComponentItem.UniqueCompID + "');";
        var objXULMainMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup("", strOnPopupShowing, strOnPopupHiding);
        objXULMainMenuPopup.setAttribute("eb-main-feed-popup", true);
        objXULMainMenuPopup.setAttribute("onpopupshown", strOnPopupShown);
        return objXULMainMenuPopup;
    };

    //this is done on popup shown event, because if done earlier, the stars are shown only on second menu open
    this.updateStarsOnFeedsMenu = function(xulMenuPopup) {
        var xulMenu = null;
        var bIsStarred;
        for (var i = 0; i < xulMenuPopup.childNodes.length; i++) {
            bIsStarred = this.FeedComponents[i].IsStared();
            xulMenu = xulMenuPopup.childNodes[i];
            var xulImage = document.getAnonymousElementByAttribute(xulMenu, "anonid", "logo");
            EBImageHandler_CT2958529.UpdateStar(xulImage, bIsStarred);
        }
    };

    this.removeStarOnMenu = function(xulMenu, xulMenuPopup) {
        var xulImage = document.getAnonymousElementByAttribute(xulMenu, "anonid", "logo");
        if (xulImage)
            EBImageHandler_CT2958529.UpdateStar(xulImage, false);
    };
    
    this.updateFeedCountInMenu = function() { };

    this.GetMultiFeedTitle = function() {
        return this.ComponentItem.button.text;
    };

    this.AddToChevron = function(objXULContainer) {
        this.XULChevronElement = null;
        this.XULChevronElement = EBXULFactory_CT2958529.CreateMenu("", "", "");

        var objAttribute = null;
        for (var i = 0; i < this.XULElement.attributes.length; i++) {
            objAttribute = this.XULElement.attributes[i];
            if (objAttribute.name.toLowerCase() != 'class' &&
			    objAttribute.name.toLowerCase() != 'tooltip' &&
			    objAttribute.name.toLowerCase() != 'label' &&
			    objAttribute.name != EBImageHandler_CT2958529.Consts.StarredAttribute
			  ) {
                this.XULChevronElement.setAttribute(objAttribute.name, objAttribute.value);
            }
        }

        //star logic for chevron, this menuitem is star candidate
        EBChevronStaticManager_CT2958529.TransferStarLogicSettings(this.XULElement, this.XULChevronElement);

        //set the class attribute separately
        var strChevronClassGet = this.XULChevronElement.getAttribute('class');
        var strClassSet = 'menu-iconic';
        var strLabel = this.GetMultiFeedTitle();

        if (strChevronClassGet)
            strClassSet += ' ' + strChevronClassGet;

        if (!this.IsAllLive)
            this.XULChevronElement.setAttribute('acceltext', this.GetMultiFeedCount());

        this.XULChevronElement.setAttribute('class', strClassSet);
        this.XULChevronElement.setAttribute('label', strLabel);
        //set image from resources in chevron, because publihser's image can be bigger then 18x18
        //and scratched big icon doesn't look good.
        this.XULChevronElement.setAttribute("image", CHEVRON_ICON);

        //set the tooltiptext - in case of shrink mode so there is special tooltip shrink
        //we need to return it to the original tooltip
        var strOriginalTooltip = this.XULElement.getAttribute(EBGlobalConsts_CT2958529.Attributes.XULTooltip);
        if (strOriginalTooltip)
            this.XULChevronElement.setAttribute('tooltiptext', strOriginalTooltip);

        var oXULMainMenuPopup = this.XULElement.firstChild.cloneNode(true);
        this.XULChevronElement.appendChild(oXULMainMenuPopup);
        objXULContainer.appendChild(this.XULChevronElement);


        this.handleSetDetectionForChevron();

        return this.XULChevronElement;
    };
};

EBTwitterComponent_CT2958529.prototype = new EBMultiFeedComponent_CT2958529();
EBTwitterComponent_CT2958529.constructor = EBTwitterComponent_CT2958529;
function EBTwitterRssComponent_CT2958529(objTwitterUser, uniqueCompID, index) {
    EBFeedComponent_CT2958529.call(this, objTwitterUser);
    
    this.MultiFeedChildIndex = index;
    this.IsLiveMode = false;
    this.IsMultiFeed = true;
    this.FeedData = null;
    this.MultiFeedCompID = uniqueCompID;
    this.IsSingle = false;

    this.Init = function() {
        return true;
    };

};

EBTwitterRssComponent_CT2958529.prototype = new EBFeedComponent_CT2958529();
EBTwitterRssComponent_CT2958529.constructor = EBTwitterRssComponent_CT2958529;
function EBWeatherComponent_CT2958529(oWeatherItem)
{
    EBBaseToolbarComponent_CT2958529.call(this, oWeatherItem);
	
	this.ComponentItem				= oWeatherItem;
	this.XULElement					= null;
	this.XULChevronElement			= null;
	this.XULToolbarItemContainer	= null;

	this.Init = function() {
	    var strLabel = this.ComponentItem.Button.text;
	    var strImage = "";

	    if (this.ComponentItem.Button.image) {
	        strImage = this.ComponentItem.Button.image;
	        EBWeatherGUIConsts_CT2958529.Image = strImage;
	    }
	    else
	        strImage = EBWeatherGUIConsts_CT2958529.Image;

	    if (!this.ComponentItem.DisplayIcon)
	        this.ComponentItem.DisplayIcon = strImage;

	    var strTooltip = this.ComponentItem.Button.tooltip;

	    var strCommand = 'EBWeatherManager_CT2958529.OnCommandWeatherToolbarButton(event);';

	    var strButtonID = EBComponentsManager_CT2958529.GetToolbarButtonID(this.ComponentItem.UniqueCompID);
	    this.XULElement = EBXULFactory_CT2958529.CreateToolbarButton(strButtonID,
																		'',
																		strLabel,
																		strImage,
																		strTooltip,
																		strCommand,
																		"");

	    //create the tooltip element (for the shrink-unshrink tooltip)
	    this.CreateTooltipShrink();

	    //take servers url from settings, override defaults
	    if (this.ComponentItem.ServerURL)
	        EBWeatherConsts_CT2958529.URL.DefaultServer = this.ComponentItem.ServerURL;

	    if (this.ComponentItem.WebSearchURL)
	        EBWeatherConsts_CT2958529.URL.DefaultServer = this.ComponentItem.DefaultWebSearch;

	    return true;
	};

	this.AddToToolbar = function(objToolbarContainer) {
	    this.SetToolbarButtonClass();

	    this.XULToolbarItemContainer = EBXULFactory_CT2958529.CreateToolbarItem();
	    this.XULToolbarItemContainer.appendChild(this.XULElement);
	    objToolbarContainer.appendChild(this.XULToolbarItemContainer);

	    this.SetChevronOnImageLoaded();

	    //set the button global style[after adding to toolbar - important!]:
	    EBToolbarDesignManager_CT2958529.SetToolbarButtonGlobalStyle(this.XULElement);

	    this.OnLoadElement();
	};
	
	this.OnLoadElement = function()
	{
		EBWeatherManager_CT2958529.Initialize();
	};
	
	this.UnloadComponent = function()
	{
		this.OnUnloadElement();
	};
	
	this.OnUnloadElement = function()
	{
		EBWeatherManager_CT2958529.Terminate();
	};
	
	this.AddToChevron = function(objXULContainer)
	{
		this.XULChevronElement = null;
		
		var strLabel		=	this.XULElement.getAttribute('label');
		var strImage		= 	this.XULElement.getAttribute('image');
		var strTooltip		=	this.XULElement.getAttribute('tooltiptext');
		var strCommand		=	this.XULElement.getAttribute('oncommand');
		
		
		//check if there is the special tooltip
		var strTooltipID	=	this.XULElement.getAttribute('tooltip');
		
		this.XULChevronElement = EBXULFactory_CT2958529.CreateMenuItem(strLabel,
																	strImage,
																	strTooltip,
																	strCommand,
																	'',
																	null);
	
		if(strTooltipID == EBWeatherGUIConsts_CT2958529.ForecastTooltipID)
		{
			this.XULChevronElement.removeAttribute('tooltiptext',strTooltipID);	
			this.XULChevronElement.setAttribute('tooltip',strTooltipID);	
		}
		
		objXULContainer.appendChild(this.XULChevronElement);
		this.handleSetDetectionForChevron();
		
		return this.XULChevronElement;
	};
	
	this.CreateTooltipShrink = function()
	{
		EBComponentsManager_CT2958529.AddTooltip(this.ComponentItem.UniqueCompID,this.XULElement);
	};
};

EBWeatherComponent_CT2958529.prototype = new EBBaseToolbarComponent_CT2958529();
EBWeatherComponent_CT2958529.constructor = EBWeatherComponent_CT2958529;
function EBTwitterDialogManager_CT2958529(xulMenuPopup, oFeedComponent) {
    var POSTED_LINK_ATTR = "posted";
    var INNER_LINK_ATTR = "innerLink"
    this.xulMenuPopup = xulMenuPopup;
    this.m_oFeedComponent = oFeedComponent;
    this.compType = ""; //lazy initiated
    this.contextLink = null;
    var TWITTER_NAME_REGEX = /[a-zA-Z0-9_]/g;

    this.initUsageObjects = function() {
        this.usgDeleteItem = EBUsageTwitter_CT2958529.DeleteItem;
        this.usgOpenItem = EBUsageTwitter_CT2958529.OpenItemLink;
        this.usgRefresh = EBUsageTwitter_CT2958529.Refresh;
        this.usgDeleteAll = EBUsageTwitter_CT2958529.DeleteAll;
        this.usgClose = EBUsageTwitter_CT2958529.OnRssClose;
        this.usgOpen = EBUsageTwitter_CT2958529.OnRssOpen;
    };

    this.cleanTwitterUserNameLink = function(strName) {
        if (!strName) return "";
        var match = strName.match(TWITTER_NAME_REGEX);
        if (!match) return strName;
        return match.join("");
    };
    
    this.sendInnerMenuItemClickUsage = function(strLink, iIndex, bIsNewWindow, bIsNewTab) {
        EBUsageTwitter_CT2958529.OpenItemInnerLink(
                    this.m_oFeedComponent.MultiFeedCompID,
                    this.m_oFeedComponent.ComponentItem.UniqueCompID,
                    this.m_oFeedComponent.ComponentItem.FeedURL,
                    strLink,
                    iIndex,
                    this.m_oFeedComponent.FeedData.Items.ArrayHash.Count(),
                    this.m_oFeedComponent.ComponentItem.userId,
                    this.m_oFeedComponent.ComponentItem.screenName,
                    this.compType,
                    bIsNewWindow,
                    bIsNewTab);

    };
    
    //create posted gray text
    this.createPostedHtmlText = function(strPostedText) {
        return EBHTMLFactory_CT2958529.CreateElement("span", strPostedText, [["class", "htmlPosted"], [POSTED_LINK_ATTR, POSTED_LINK_ATTR]], null);
    };

    //create inner link
    this.createInnerLink = function(strLink, strCaption) {
        var onclickFunction = function(event) {
            event.customData = { "url": strLink };
            EBLinkManager_CT2958529.LoadLinkURL(event);
            //catch this link attribute in later bubbling stage for usage
            event.itemLink = strLink;
            //we are blocking the execution of "href", it's used only for UI purposes.
            return false;
        };

        return EBHTMLFactory_CT2958529.CreateElement("a", " " + strCaption, [["href", strLink], ["class", "htmlLink"], [INNER_LINK_ATTR, INNER_LINK_ATTR]], onclickFunction);
    };

    this.checkAndGetLink = function(strToken) {
        if (strToken.indexOf(EBUrl_CT2958529.HTTP_PROTOCOL) == 0)
            return this.createInnerLink(strToken, strToken);
        else if (strToken.indexOf("@") == 0)
            return this.createInnerLink("http://twitter.com/" + this.cleanTwitterUserNameLink(strToken.replace(/@/, "")), strToken);
    };

    this.TokenizeTitleToElements = function(strTitle) {
        if (!strTitle) return "";
        var arrTitleTokens = strTitle.split(" ");
        if (arrTitleTokens.length == 0) return null;

        //first word is not needed, remove it from the tokens array
        arrTitleTokens.splice(0, 1);
        var strAccomulativeText = "";
        var arrXulLabels = new Array();
        var xulLabel = null;
        var textNode = null;

        for (var i = 0; i < arrTitleTokens.length; i++) {
            xulLabel = this.checkAndGetLink(arrTitleTokens[i]);
            if (!xulLabel)
                strAccomulativeText += " " + arrTitleTokens[i];
            else {
                //dump accomulated text
                if (strAccomulativeText) {
                    textNode = document.createTextNode(strAccomulativeText);
                    arrXulLabels.push(textNode);
                    strAccomulativeText = "";
                }
                //add the link
                arrXulLabels.push(xulLabel);
            }
        }

        if (strAccomulativeText) {
            textNode = document.createTextNode(strAccomulativeText);
            arrXulLabels.push(textNode);
        }

        return arrXulLabels;
    };

    //create the item link (including the inner links), in twitter rss dialog
    this.LoadFeedItemData = function(oFeedItemData, iIndex) {
        if (!this.compType) {
            var oMultiTwitterComponent = EBComponentsManager_CT2958529.GetComponentByCompID(this.m_oFeedComponent.MultiFeedCompID);
            this.compType = (oMultiTwitterComponent) ? oMultiTwitterComponent.ComponentItem.CompType : "";
        }

        var strTitle = EBGlobalManager_CT2958529.htmlDecode(oFeedItemData.Title);
        var arrXulLabels = this.TokenizeTitleToElements(strTitle);
        var strLink = oFeedItemData.Link;
        var strTooltip = oFeedItemData.Tooltip;
        var strStatus = oFeedItemData.Status;
        var bVisited = oFeedItemData.Visited;
        var xulPopup = this.xulMenuPopup;
        var manager = this;
        var compType = this.compType;
        
        var htmlClick = function(e) {
            //inner link
            if (e.itemLink) {
                //usage
                manager.sendInnerMenuItemClickUsage(e.itemLink, iIndex, false, false);
                //close feed popup / multifeed menupopup
                EBFeedUIManager_CT2958529.closeFeed(xulPopup);
            }
            else
                manager.OnClickBoxFeedItem(e, this);
        };

        //create the html:div element representing one twitter post
        var arrAttr = new Array();
        arrAttr.push(["class", "divTwitterItem"]);
        arrAttr.push([EBFeedDialogConsts_CT2958529.Attributes.Link, strLink]);
        arrAttr.push([EBFeedDialogConsts_CT2958529.Attributes.Index, iIndex]);
        if (EBGlobalManager_CT2958529.IsFirefox3())
            arrAttr.push(["tooltiptext", strTooltip]);
        var htmlDiv = EBHTMLFactory_CT2958529.CreateElement("div", null, arrAttr, htmlClick);

        if (arrXulLabels) {
            for (var i = 0; i < arrXulLabels.length; i++)
                htmlDiv.appendChild(arrXulLabels[i]);
        }

        //add posted date text
        htmlDiv.appendChild(EBHTMLFactory_CT2958529.CreateElement("br"));
        htmlDiv.appendChild(this.createPostedHtmlText(strTooltip, htmlClick));
        htmlDiv.onmouseover = function(e) { manager.OnMouseOverBoxFeedItem(e, this); };

        var oRow = document.createElement('hbox');
        //add the elements to the hbox
        var xulSpacer = document.createElement("spacer");
        xulSpacer.setAttribute("width", "33");
        oRow.appendChild(xulSpacer);
        oRow.appendChild(htmlDiv);

        //add to the main container
        var oRowsItems = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "rowsItems");
        oRowsItems.appendChild(oRow);
    };

    this.OnCommandShowInNewWindow = function(event, bIsTab) {
        //find the element associated with the popup menu:
        var oElement = this.contextItem;
        var oBoxLabel = null;
        var oRow = null;

        if (oElement.tagName == 'label')
            oBoxLabel = oElement.parentNode;
        else
            oBoxLabel = oElement;

        var strLink = oBoxLabel.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Link);
        var iIndex = oBoxLabel.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Index);
        var oFeedItemDataArrayHash = this.m_oFeedComponent.FeedData.Items.ArrayHash;
        var oFeedItemData = oFeedItemDataArrayHash.GetByID(strLink);

        //set not stared:
        this.setNotStarred();

        //update read status and number of unread
        if (oFeedItemData.Status == EBFeedXMLConsts_CT2958529.UNREAD) {
            //update the num of new
            if (!this.m_oFeedComponent.IsLiveMode)
                this.m_oFeedComponent.NumOfNew--;

            oFeedItemData.Status = EBFeedXMLConsts_CT2958529.READ;
        }

        oFeedItemData.Visited = true;

        this.SaveDataAndUpdate();

        //inner link
        if (this.contextLink) {
            strLink = EBXML_CT2958529.FromLegalXml(this.contextLink);
            //usage
            this.sendInnerMenuItemClickUsage(strLink, iIndex, !bIsTab, bIsTab);

        }
        //regular item link
        else {
            strLink = EBXML_CT2958529.FromLegalXml(strLink);
            //usage
            this.sendMenuItemClickUsage(strLink, iIndex, oBoxLabel, bIsTab, !bIsTab);
        }

        if (bIsTab)
            EBWeb_CT2958529.LoadURLInNewTab(strLink);
        else
            oWindow = EBWeb_CT2958529.LoadURLInNewWindow(strLink);

        EBFeedUIManager_CT2958529.closeFeed(this.xulMenuPopup);
    };

    //this function is used to "close" the context menu
    this.OnMouseOverBoxFeedItem = function(event, oElement) {
        if (this.contextItem &&
            this.contextItem.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Index) != oElement.getAttribute(EBFeedDialogConsts_CT2958529.Attributes.Index))
            this.xulContext.style.display = "none";
    };

    //somehow the right click doesn't work here on htmlDiv item, so I'm using on click of their container
    this.onRowsClick = function(event) {
        //right click
        if (event.button == 2)
            this.openContextBox(event);
    };

    this.LoadHeaderData = function() {
        var strFeedTitle = this.m_oFeedComponent.ComponentItem.displayName;
        strFeedTitle = EBXML_CT2958529.FromLegalXml(strFeedTitle);
        this.lblTitle.setAttribute('value', strFeedTitle);
    };

    this.openContextBox = function(event) {
        //set manually the item associated with the context
        if (event.target.getAttribute(POSTED_LINK_ATTR) == POSTED_LINK_ATTR) {
            this.contextItem = event.target.parentNode;
            this.contextLink = null;
        }
        else if (event.target.getAttribute(INNER_LINK_ATTR) == INNER_LINK_ATTR) {
            this.contextItem = event.target.parentNode;
            this.contextLink = event.target.getAttribute("href");
        }
        else {
            this.contextItem = event.target;
            this.contextLink = null;
        }

        this.xulContext.style.display = "";
        var xulOpenInNewTab = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextNewTab");
        var xulOpenInNewWindow = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextNewWindow");
        var xulDeleteItem = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextDelete");
        var manager = this;

        //FF 3+
        if (EBGlobalManager_CT2958529.IsFirefox3()) {
            var mouseX = event.screenX - this.xulMenuPopup.boxObject.screenX;
            var mouseY = event.screenY - this.xulMenuPopup.boxObject.screenY - 16;

            //lazy calculation of xulContext width
            if (!this.xulContextWidth) this.xulContextWidth = this.xulContext.boxObject.width;
            if (!this.xulContextHeight) this.xulContextHeight = this.xulContext.boxObject.height;

            if (mouseX + this.xulContextWidth > this.xulStack.boxObject.width)
                mouseX = this.xulStack.boxObject.width - this.xulContextWidth - 10;

            if (mouseY + this.xulContextHeight > this.xulStack.boxObject.height)
                mouseY = this.xulStack.boxObject.height - this.xulContextHeight;

            this.xulContext.setAttribute("top", mouseY);
            this.xulContext.setAttribute("left", mouseX);
        }
        //FF 2-
        else {
            var xulRows = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "rowsItems");
            xulRows.insertBefore(this.xulContext, this.contextItem.parentNode.nextSibling);
        }
    };

    this.OnClickDeleteAll = function(event) {
        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale);
        var strTitle = EBActionManager_CT2958529.GetToolbarName() + " Toolbar";
        var strText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_TWITTER_ARE_YOU_SURE_DELETE_ALL_TWEETS');
        var strCheckboxText = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_DONT_ASK_AGAIN');
        var checkboxValue = { "value": false };
        var isDelete = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.FeedDeleteDontAskAgain);
        var bClearFeed = true;

        if (!isDelete) {
            bClearFeed = false;
            EBFeedUIManager_CT2958529.closeFeed(this.xulMenuPopup);
            isDelete = EBGlobalManager_CT2958529.ConfirmCheck(window, strTitle, strText, strCheckboxText, checkboxValue);
        }

        if (isDelete) {
            this._DeleteAll(event, bClearFeed);
            if (checkboxValue.value)
                EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.FeedDeleteDontAskAgain, true);
        }

        //usage
        var strAncestorId = this.m_oFeedComponent.MultiFeedCompID;
        var strCompId = this.m_oFeedComponent.ComponentItem.UniqueCompID;
        this.usgDeleteAll(strAncestorId, strCompId, this.compType);
    };

    this.ApplyLanguagePack = function() {
        var xulOpenInNewTab = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextNewTab");
        var xulOpenInNewWindow = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextNewWindow");
        var xulDeleteItem = document.getAnonymousElementByAttribute(this.xulMenuPopup, "id", "contextDelete");

        var locale = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale);

        if (this.imgComments)
            this.imgComments.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_ADD_YOUR_COMMET_TO_BOX'));

        if (this.imgRefresh)
            this.imgRefresh.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_TWITTER_REFRESH_TWEETS_TOOLTIP'));

        if (this.imgDelete)
            this.imgDelete.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_TWITTER_DELETE_ALL_TWEETS_TOOLTIP'));

        if (this.imgRead)
            this.imgRead.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_MARK_ALL_AS_READ_TOOLTIP'));

        if (this.imgUnread)
            this.imgUnread.setAttribute("tooltiptext", oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_MARK_ALL_AS_UNREAD_TOOLTIP'));

        xulOpenInNewTab.value = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_OPEN_IN_NEW_TAB');
        xulOpenInNewWindow.value = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_OPEN_IN_NEW_WINDOW');
        xulDeleteItem.value = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_RSS_DELETE_MESSAGE');
    };

    if (this.xulMenuPopup && this.m_oFeedComponent)
        this.init();
};

EBTwitterDialogManager_CT2958529.prototype = new EBFeedDialogManager_CT2958529();
EBTwitterDialogManager_CT2958529.prototype.constructor = EBTwitterDialogManager_CT2958529;
function BaseDialogManager_CT2958529() {
    this.xulElements = {};
    this.mainWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

    this._onload = function(e) {
        //override
    };

    this._onunload = function(e) {
        //override
    };
    
    this.onload = function(e) {
        EBUILogic_Dialog_CT2958529.fillDialogMembers(this.xulElements, document);
        this._onload(e);
    };

    this.onunload = function(e) {
        this._onunload(e);
    };
};
var EBUILogic_Browser_CT2958529 =
{
    _isThreedface: function(color) {
        return color && (color == "rgb(212, 208, 200)" || color.toLowerCase() == "threedface");
    },

    _getBackgroundImageAndRepeat: function(xulElement) {
        var bgImage = xulElement.ownerDocument.defaultView.getComputedStyle(xulElement, null).getPropertyValue("background-image");
        var bgRepeat = xulElement.ownerDocument.defaultView.getComputedStyle(xulElement, null).getPropertyValue("background-repeat");
        if (!xulElement.parentNode || xulElement.tagName == "window" || bgImage != "none")
            return { "bgImage": bgImage, "bgRepeat": bgRepeat };
        else
            return this._getBackgroundImageAndRepeat(xulElement.parentNode);
    },

    _getBackgroundColor: function(xulElement) {
        var bgColor = xulElement.ownerDocument.defaultView.getComputedStyle(xulElement, null).getPropertyValue("background-color");
        if (!xulElement.parentNode || xulElement.tagName == "window" || bgColor || bgColor != "transparent")
            return bgColor;
        else
            this._getBackgroundColor(xulElement.parentNode);
    },

    _getThemeStyle: function(bIsClassicTheme, isVista) {
        var oToolbar = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
        var bgImageInfo = this._getBackgroundImageAndRepeat(oToolbar);
        bgImageInfo.bgColor = this._getBackgroundColor(oToolbar);
        return bgImageInfo;
    },

    _getStyleWin: function(bIsClassicTheme, isVista, isTicker, autoFit, height, maxHeight) {
        var objStyle = this._getThemeStyle();

        if (objStyle.bgColor == "transparent" && objStyle.bgImage == "none") {
            if (bIsClassicTheme || !isVista)
                objStyle.bgColor = "threedface";
            else
                objStyle.bgColor = "rgb(211,218,237)";
        }

        if (!autoFit.height) {
            if (isTicker) {
                objStyle.marginTop = "5px";
                objStyle.marginBottom = "3px";
            }
            else {
                var margin = (maxHeight - height) / 2;
                objStyle.marginTop = margin + "px";
                objStyle.marginBottom = margin + "px";
            }
        }

        return objStyle;
    },

    _getStyleMac: function(isTicker, autoFit, height, maxHeight) {
        var objStyle = this._getThemeStyle();
        if (objStyle.bgColor == "transparent" && objStyle.bgImage == "none")
            objStyle.bgColor = "rgb(158, 158, 158)";

        if (!autoFit.height) {
            if (isTicker) {
                if (EBGlobalManager_CT2958529.IsFirefox35()) {
                    objStyle.marginTop = "4px";
                    objStyle.marginBottom = "2px";
                }
                else {
                    objStyle.marginTop = "5px";
                    objStyle.marginBottom = "3px";
                }
            }
            else {
                var margin = (maxHeight - height) / 2;
                if (EBGlobalManager_CT2958529.IsFirefox35()) {
                    objStyle.marginTop = parseInt(margin - 1) + "px";
                    objStyle.marginBottom = parseInt(margin - 1) + "px";
                }
                else {
                    objStyle.marginTop = margin + "px";
                    objStyle.marginBottom = margin + "px";
                }
            }
        }

        return objStyle;
    },

    _getStyleLinux: function(isTicker, autoFit, height, maxHeight) {
        var objStyle = this._getThemeStyle();
        if (objStyle.bgColor == "transparent" && objStyle.bgImage == "none")
            objStyle.bgColor = "rgb(239, 235, 231)";

        if (!autoFit.height) {
            if (isTicker) {
                objStyle.marginTop = "5px";
                objStyle.marginBottom = "3px";
            }
            else {
                var margin = (maxHeight - height) / 2;
                objStyle.marginTop = margin + "px";
                objStyle.marginBottom = margin + "px";
            }
        }

        return objStyle;
    },

    _isToChangeBG: function(bgColor, bgImage) {
        if (bgColor && bgColor != "transparent" && !this._isThreedface(bgColor) && bgColor.toLowerCase() != "rgb(240, 240, 240)")
            return false;

        if (bgImage && bgImage != "none")
            return false;

        return true;
    },

    _isToChangeBGTicker: function(divBGColor) {
        return this._isThreedface(divBGColor);
    },

    _isLastToolbar: function() {
        var toolbarsContainer = document.getElementById("navigator-toolbox");
        var toolbars = toolbarsContainer.getElementsByTagName("toolbar");
        return toolbars[toolbars.length - 1].id == EBGlobalConsts_CT2958529.ToolbarId;
    },

    setBrowserStyle: function(xulBrowser, isTicker, autoFit, height) {
        try {
            var htmlBody = xulBrowser.contentWindow.document.getElementsByTagName("body")[0];
            var maxHeight = EBUILogic_Toolbar_CT2958529.getHeight();

            var objStyle = null;
            //windows
            if (EBGlobalManager_CT2958529.IsWindowsPlatform()) {
                var bIsClassicTheme = !EBWindows_CT2958529.IsThemed();
                var isVista = EBWindows_CT2958529.IsVistaOS() || EBWindows_CT2958529.IsWindows7();
                objStyle = this._getStyleWin(bIsClassicTheme, isVista, isTicker, autoFit, height, maxHeight);
            }
            //mac OSx
            else if (EBGlobalManager_CT2958529.IsMacintoshPlatform())
                objStyle = this._getStyleMac(isTicker, autoFit, height, maxHeight);
            //Linux
            else
                objStyle = this._getStyleLinux(isTicker, autoFit, height, maxHeight);

            //workaround to a strange bug that occurs when there is a dialog about set as default browser,
            //in such cases, the html component gets the url of an external component.
            try {
                var bgColor = xulBrowser.contentWindow.document.defaultView.getComputedStyle(htmlBody, null).getPropertyValue("background-color");
                var bgImage = xulBrowser.contentWindow.document.defaultView.getComputedStyle(htmlBody, null).getPropertyValue("background-image");
            }
            catch (ex) {
                // EBLog(ex);
                return;
            }
            //regular
            if (!isTicker) {
                if (this._isToChangeBG(bgColor, bgImage)) {
                    htmlBody.style.backgroundImage = objStyle.bgImage;
                    htmlBody.style.backgroundColor = objStyle.bgColor;
                    htmlBody.style.backgroundRepeat = objStyle.bgRepeat;
                }
                htmlBody.style.marginTop = objStyle.marginTop;
                htmlBody.style.marginBottom = objStyle.marginBottom;
            }
            //news ticker | ticker
            else {
                var mainDiv = htmlBody.getElementsByTagName("div")[0];
                if (!mainDiv) return;

                var divBGColor = xulBrowser.contentDocument.defaultView.getComputedStyle(mainDiv, null).getPropertyValue("background-color");

                if (this._isToChangeBGTicker(divBGColor)) {
                    htmlBody.style.backgroundImage = objStyle.bgImage;
                    htmlBody.style.backgroundColor = objStyle.bgColor;
                    htmlBody.style.backgroundRepeat = objStyle.bgRepeat;
                }
                else {
                    htmlBody.style.backgroundColor = divBGColor;
                }

                mainDiv.style.backgroundColor = "transparent";
                htmlBody.style.marginTop = objStyle.marginTop;
                htmlBody.style.marginBottom = objStyle.marginBottom;
            }
        }
        catch (ex) {
            // EBLogging_CT2958529.LogToConsole(ex, "html component background");
        }
    }
};

var EBCanvas_CT2958529 =
{
    canvas: null,
    hashImages: new EBArrayHashObject_CT2958529(),
    positionFlags:
    {
        topRight: "tr",
        bottomRight: "br",
        topLeft: "tl"
    },
    appSize: 24,
    leftoverSize: 2,

    //lazy creation of canvas element
    _getCanvas: function() {
        if (this.canvas) return this.canvas;
        this.canvas = EBHTMLFactory_CT2958529.CreateElement("canvas", null, null, null);
        return this.canvas;
    },

    getImageBase64DataFromWindow: function(win, top, left, width, height, scale) {
        var canvas = this._getCanvas();
        canvas.width = width;
        canvas.height = height;
        var ctx = canvas.getContext('2d');
        //ctx.clearRect(0, 0, width, height);
        var strBase64ImageData = "";
        try {
            ctx.drawWindow(win, top, left, width, height, "#FFFFFF");
            strBase64ImageData = canvas.toDataURL("image/png");
        }
        catch (ex) {
            EBLog(ex);
            strBase64ImageData = -1;
        }

        return strBase64ImageData;
    },

    getImageBase64DataFromBrowser: function(xulBrowser, scale) {
        if (!xulBrowser || xulBrowser.style.display == "none") return -1;
        var width = xulBrowser.boxObject.width;
        var height = xulBrowser.boxObject.height;
        return this.getImageBase64DataFromWindow(xulBrowser.contentWindow, 0, 0, width, height, scale);
    },

    getImageBase64DataFromGadget: function(win, callback) {
        var xulBrowser = win.EBGadgetDialog_CT2958529.xulBrowser;
        var gadgetDialog = win.EBGadgetDialog_CT2958529._oDialog;
        var strInnerBrowserImageData = this.getImageBase64DataFromBrowser(xulBrowser);
        var width = gadgetDialog.boxObject.width;
        var height = gadgetDialog.boxObject.height;
        var strGadgetImageData = this.getImageBase64DataFromWindow(win, 0, 0, width, height, 1);
        var isBrowserImageLoaded = false;
        var isGadgetImageLoaded = false;

        var drawBothImages = function(gadgetImage, browserImage) {
            var canvas = EBHTMLFactory_CT2958529.CreateElement("canvas", null, null, null);
            canvas.width = width;
            canvas.height = height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(gadgetImage, 0, 0);
            if (browserImage)
                ctx.drawImage(browserImage, xulBrowser.boxObject.x + 1, xulBrowser.boxObject.y + 1);
            callback(canvas.toDataURL("image/png"));
        };

        var browserImage = new Image();
        var gadgetImage = new Image();

        if (strInnerBrowserImageData != -1) {
            browserImage.onload = function() {
                isBrowserImageLoaded = true;
                if (isGadgetImageLoaded)
                    drawBothImages(gadgetImage, browserImage);

            };
            browserImage.src = strInnerBrowserImageData;
        }
        else {
            browserImage = null;
            isBrowserImageLoaded = true;
        }

        gadgetImage.onload = function() {
            isGadgetImageLoaded = true;
            if (isBrowserImageLoaded)
                drawBothImages(gadgetImage, browserImage);
        };
        gadgetImage.src = strGadgetImageData;
    },

    addOverlayImage: function(strBaseImageUrl, strOverlayImageUrl, positionFlags, callback) {
        var baseImage, overlayImage, isBaseImageReady, isOverlayImageReady;
        if (this.hashImages.Contains(strBaseImageUrl)) {
            baseImage = this.hashImages.GetByID(strBaseImageUrl);
            isBaseImageReady = true;
        }

        if (this.hashImages.Contains(strOverlayImageUrl)) {
            overlayImage = this.hashImages.GetByID(strOverlayImageUrl);
            isOverlayImageReady = true;
        }

        var drawOverlay = function() {
            var canvas = EBCanvas_CT2958529._getCanvas();
            canvas.width = baseImage.width;
            canvas.height = baseImage.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(baseImage, 0, 0);
            var deltaX = 0;
            var deltaY = 0;
            switch (positionFlags) {
                case EBCanvas_CT2958529.positionFlags.topRight:
                    deltaX = baseImage.width - overlayImage.width;
                    break;
                case EBCanvas_CT2958529.positionFlags.bottomRight:
                    deltaX = baseImage.width - overlayImage.width;
                    deltaY = baseImage.height - overlayImage.height;
                    break;
                default:
                    deltaX = baseImage.width - overlayImage.width;
                    break;
            }

            ctx.drawImage(overlayImage, deltaX, deltaY);
            callback(canvas.toDataURL("image/png"));
        };

        if (!baseImage) {
            baseImage = new Image();
            baseImage.onload = function() {
                isBaseImageReady = true;
                EBCanvas_CT2958529.hashImages.Add(strBaseImageUrl, baseImage);
                if (isOverlayImageReady)
                    drawOverlay();
            };
            baseImage.src = strBaseImageUrl;
        }

        if (!overlayImage) {
            overlayImage = new Image();
            overlayImage.onload = function() {
                isOverlayImageReady = true;
                EBCanvas_CT2958529.hashImages.Add(strOverlayImageUrl, overlayImage);
                if (isBaseImageReady)
                    drawOverlay();
            };
            overlayImage.src = strOverlayImageUrl;
        }

        if (isBaseImageReady && isOverlayImageReady)
            drawOverlay();
    },

    getBase64DataOfImageOverImage: function(strTemplateImageUrl, strImageUrl, callback) {
        var canvas = this._getCanvas();
        canvas.width = this.appSize;
        canvas.height = this.appSize;
        var ctx = canvas.getContext('2d');
        var that = this;

        //draw template
        var baseImage = new Image();
        baseImage.onload = function() {
            ctx.drawImage(baseImage, 0, 0); //(image, x, y)

            //draw cover image
            var topImage = new Image();
            topImage.onload = function() {
                var strImageSize = that.appSize - leftoverSize;
                if (topImage.width > strImageSize || topImage.height > strImageSize) {
                    var sliceFactor = (topImage.width >= topImage.height) ? (topImage.width / strImageSize) : (topImage.height / strImageSize);
                    topImage.height = topImage.height / sliceFactor;
                    topImage.width = topImage.width / sliceFactor;
                }
                var axisXstartPoint = Math.round(that.appSize / 2 - topImage.width / 2);
                var axisYstartPoint = Math.round(that.appSize / 2 - topImage.height / 2);

                ctx.drawImage(topImage, axisXstartPoint, axisYstartPoint);
                callback(canvas.toDataURL("image/png"));
            };
            topImage.src = strImageUrl;

        };
        baseImage.src = strTemplateImageUrl;
    },

    getDrawImage: function(strTemplateImageUrl, strNumber, callback) {
        var canvas = this._getCanvas();
        var baseImage = new Image();
        baseImage.onload = function() {
            canvas.width = baseImage.width;
            canvas.height = baseImage.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(baseImage, 7, 7); //(image, x, y)
            ctx.fillStyle = "Transparent";
            ctx.strokeStyle = "white";
            ctx.strokeText(strNumber, 12, 12);  //should be change the setting
            ctx.fill();
            ctx.stroke();
            callback(canvas.toDataURL("image/png"));
        };

        baseImage.src = strTemplateImageUrl;
    },

    create24pxImage: function(strImageUrl, callback) {
        if (!strImageUrl) return;

        var self = this;
        var canvas = this._getCanvas();
        var baseImage = new Image();
        baseImage.onload = function() {
            canvas.width = 24;
            canvas.height = 24;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(baseImage, 0, 0, 24, 24);
            callback(canvas.toDataURL("image/png"));
        };
        baseImage.src = strImageUrl;
    },

    getMirrorImage: function(strImageUrl, callback) {
        if (!strImageUrl) return;

        var self = this;
        var canvas = this._getCanvas();
        var baseImage = new Image();
        baseImage.onload = function() {
            canvas.width = baseImage.width;
            canvas.height = baseImage.height;
            var ctx = canvas.getContext('2d');
            var width = baseImage.width;
            var height = baseImage.height;
            for (var i = 0; i <= width; i++)
                ctx.drawImage(baseImage, width - i, 0, 1, height, i, 0, 1, height);

            callback(canvas.toDataURL("image/png"));
        };
        baseImage.src = strImageUrl;
    }
};
var EBToolbarCssFunctions_CT2958529 =
{
    _cssStyleSheet: null,
    _globalCssStyleSheet: null,
    _cssToolbarButtonStyleSheet: null,
    _cssToolbarButtonStyleSheetWin: null,
    _cssToolbarButtonStyleSheetLinux: null,
    _cssToolbarButtonStyleSheetMac: null,

    GLOBAL_STYLE_SHEET_URL: "chrome://global/skin/global.css",
    STYLE_SHEET_URL: "chrome://browsersearch/skin/ebtoolbarstyle.css",
    TOOLBAR_BUTTON_STYLE_SHEET_URL_WIN_XP: "chrome://browsersearch/skin/ebtoolbarbuttonstyleWinXP.css",
    TOOLBAR_BUTTON_STYLE_SHEET_URL_LINUX: "chrome://browsersearch/skin/ebtoolbarbuttonstyleLinux.css",
    TOOLBAR_BUTTON_STYLE_SHEET_URL_MAC: "chrome://browsersearch/skin/ebtoolbarbuttonstyleMac.css",
    TOOLBAR_BUTTON_CSS_ATTR: "ebToolbarButton_CT2958529",
    DROPDOWN_MENUBUTTON_SELECTOR_TEXT: "toolbarbutton[{0}=\"true\"] > .toolbarbutton-menubutton-dropmarker",
    DROPDOWN_MENU_SELECTOR_TEXT: "toolbarbutton[{0}=\"true\"] > .toolbarbutton-menu-dropmarker",
    DROPDOWN_MENUBUTTON_SELECTOR_TEXT_DISABLED: "toolbarbutton[{0}=\"true\"][disabled=\"true\"] > .toolbarbutton-menubutton-dropmarker",
    DROPDOWN_MENU_SELECTOR_TEXT_DISABLED: "toolbarbutton[{0}=\"true\"][disabled=\"true\"] > .toolbarbutton-menu-dropmarker",
    MAC_MENUBUTTON_HOVER_FONT_COLOR_CSS: "toolbarbutton[{0}=\"true\"]:hover > .toolbarbutton-menubutton-button {color: {1} !important;}",
    dropDownInitiated: false,
    toolbarHeightLinux: "35px",

    addCssClass: function(strStyleDeclaration, index, isToGlobal) {
        var styleSheet = (isToGlobal) ? this._globalCssStyleSheet : this._cssStyleSheet;
        if (!styleSheet) return;
        if (!index && index != 0) index = styleSheet.length;
        if (!index) index = 0;

        try {
            styleSheet.insertRule(strStyleDeclaration, index);
        }
        catch (ex) {
            EBLog(ex);
        }
    },

    removeCssClass: function(selectorText) {
        if (!this._cssStyleSheet) return;
        var cssRule = "";
        for (var i = 0; i < this._cssStyleSheet.cssRules.length; i++) {
            cssRule = this._cssStyleSheet.cssRules.item(i);
            if (cssRule.selectorText == selectorText) {
                this._cssStyleSheet.deleteRule(i);
                break;
            }
        }
    },

    fixMacFontHoverColor: function(color) {
        var strStyleDeclaration = stringFormat(this.MAC_MENUBUTTON_HOVER_FONT_COLOR_CSS, this.TOOLBAR_BUTTON_CSS_ATTR, color);
        this.addCssClass(strStyleDeclaration);
    },

    changeDropMarker: function(imageUrl) {
        if (this.dropDownInitiated) {
            this.removeCssClass(stringFormat(this.DROPDOWN_MENUBUTTON_SELECTOR_TEXT, this.TOOLBAR_BUTTON_CSS_ATTR));
            this.removeCssClass(stringFormat(this.DROPDOWN_MENU_SELECTOR_TEXT, this.TOOLBAR_BUTTON_CSS_ATTR));
            this.removeCssClass(stringFormat(this.DROPDOWN_MENUBUTTON_SELECTOR_TEXT_DISABLED, this.TOOLBAR_BUTTON_CSS_ATTR));
            this.removeCssClass(stringFormat(this.DROPDOWN_MENU_SELECTOR_TEXT_DISABLED, this.TOOLBAR_BUTTON_CSS_ATTR));

            this.dropDownInitiated = false;
        }

        if (!imageUrl) return;

        this.dropDownInitiated = true;
        var strStyleDeclaration = stringFormat(this.DROPDOWN_MENUBUTTON_SELECTOR_TEXT, this.TOOLBAR_BUTTON_CSS_ATTR);

        strStyleDeclaration += "{ -moz-appearance: none !important; padding: 3px; border: none !important;";
        if (EBGlobalManager_CT2958529.IsLinuxPlatform())
            strStyleDeclaration += stringFormat(" background: url('{0}') no-repeat center; list-style-image: none; -moz-margin-end: 3px; -moz-margin-start: 2px;}", imageUrl);
        else if (EBGlobalManager_CT2958529.IsMacintoshPlatform())
            strStyleDeclaration += stringFormat(" list-style-image: url('{0}'); -moz-padding-start:0px !important; -moz-padding-end:0px !important;}", imageUrl);
        else
            strStyleDeclaration += stringFormat(" list-style-image: url('{0}');}", imageUrl);
        //for toolbarbutton type="menu-button"
        this.addCssClass(strStyleDeclaration);

        strStyleDeclaration = stringFormat(this.DROPDOWN_MENU_SELECTOR_TEXT, this.TOOLBAR_BUTTON_CSS_ATTR);
        strStyleDeclaration += "{ -moz-appearance: none !important; border: none !important;";
        strStyleDeclaration += " background-color: transparent !important;padding: 0px;width: auto;";
        strStyleDeclaration += stringFormat(" list-style-image: url('{0}'); -moz-margin-start: 2px; }", imageUrl);
        //for toolbarbutton type="menu"
        this.addCssClass(strStyleDeclaration);

        strStyleDeclaration = stringFormat(this.DROPDOWN_MENUBUTTON_SELECTOR_TEXT_DISABLED, this.TOOLBAR_BUTTON_CSS_ATTR);
        strStyleDeclaration += "{ -moz-appearance: none !important; border: none !important;";
        strStyleDeclaration += " background-color: transparent !important;padding: 3px;width: auto;";
        if (EBGlobalManager_CT2958529.IsLinuxPlatform())
            strStyleDeclaration += stringFormat(" background: url('{0}') no-repeat center; list-style-image: none; -moz-margin-end: 3px; -moz-margin-start: 2px;}", imageUrl);
        else
            strStyleDeclaration += stringFormat(" list-style-image: url('{0}')!important; -moz-margin-start: 0px; }", imageUrl);
        //for toolbarbutton type="menu-button" disabled
        this.addCssClass(strStyleDeclaration);


        strStyleDeclaration = stringFormat(this.DROPDOWN_MENU_SELECTOR_TEXT_DISABLED, this.TOOLBAR_BUTTON_CSS_ATTR);
        strStyleDeclaration += "{ -moz-appearance: none !important; border: none !important;";
        strStyleDeclaration += " background-color: transparent !important;padding: 3px;width: auto;";
        strStyleDeclaration += stringFormat(" list-style-image: url('{0}'); -moz-margin-start: 0px; }", imageUrl);
        //for toolbarbutton type="menu" disabled
        this.addCssClass(strStyleDeclaration);
    },

    checkToLoadWindowsXPThemeCSSStyleSheet: function(oSkin) {
        if (!this._cssToolbarButtonStyleSheet) return;

        //no need to en
        if (!oSkin.backgroundColor && !oSkin.backgroundImageUrl) {
            this._cssToolbarButtonStyleSheet.disabled = true;
            return;
        }

        //enable for linux or WinXP themed
        if (EBGlobalManager_CT2958529.IsMacintoshPlatform() ||
            EBGlobalManager_CT2958529.IsLinuxPlatform() ||
            EBGlobalManager_CT2958529.IsWindowsPlatform() && EBWindows_CT2958529.IsXP() && EBWindows_CT2958529.IsThemed())
            this._cssToolbarButtonStyleSheet.disabled = false;
        //unload
        else
            this._cssToolbarButtonStyleSheet.disabled = true;
    },

    init: function() {
        try {
            //set 35px height for toolbar under linux
            if (EBGlobalManager_CT2958529.IsLinuxPlatform()) {
                var xulToolbar = document.getElementById(EBGlobalConsts_CT2958529.ToolbarId);
                xulToolbar.setAttribute("height", this.toolbarHeightLinux);
            }

            var cssSheets = document.styleSheets;
            if (!cssSheets || cssSheets.length == 0) return;

            for (var i = 0; i < cssSheets.length; i++) {
                if (cssSheets[i].href == this.STYLE_SHEET_URL)
                    this._cssStyleSheet = cssSheets[i];
                else if (cssSheets[i].href == this.GLOBAL_STYLE_SHEET_URL)
                    this._globalCssStyleSheet = cssSheets[i];
                else if (cssSheets[i].href == this.TOOLBAR_BUTTON_STYLE_SHEET_URL_WIN_XP)
                    this._cssToolbarButtonStyleSheetWin = cssSheets[i];
                else if (cssSheets[i].href == this.TOOLBAR_BUTTON_STYLE_SHEET_URL_LINUX)
                    this._cssToolbarButtonStyleSheetLinux = cssSheets[i];
                else if (cssSheets[i].href == this.TOOLBAR_BUTTON_STYLE_SHEET_URL_MAC)
                    this._cssToolbarButtonStyleSheetMac = cssSheets[i];
            }

            if (EBGlobalConsts_CT2958529.IsEngine) {
                //engine
                if (!isFloatingMode_CT2958529)
                    return;
                //engine chevron
                /*
                else if (!isAIOMode_CT2958529) {
                    this._cssToolbarButtonStyleSheetWin.disabled = true;
                    this._cssToolbarButtonStyleSheetMac.disabled = true;
                    this._cssToolbarButtonStyleSheetLinux.disabled = true;
                    return;
                }*/
            }

            //Linux
            if (EBGlobalManager_CT2958529.IsLinuxPlatform()) {
                this._cssToolbarButtonStyleSheetWin.disabled = true;
                this._cssToolbarButtonStyleSheetMac.disabled = true;
                this._cssToolbarButtonStyleSheet = this._cssToolbarButtonStyleSheetLinux;
            }
            //Mac
            else if (EBGlobalManager_CT2958529.IsMacintoshPlatform()) {
                this._cssToolbarButtonStyleSheetLinux.disabled = true;
                this._cssToolbarButtonStyleSheetWin.disabled = true;
                this._cssToolbarButtonStyleSheet = this._cssToolbarButtonStyleSheetMac;
            }
            //Windows
            else {
                this._cssToolbarButtonStyleSheetLinux.disabled = true;
                this._cssToolbarButtonStyleSheetMac.disabled = true;
                this._cssToolbarButtonStyleSheet = this._cssToolbarButtonStyleSheetWin;
            }
        }
        catch (ex) {
            EBLog(ex);
        }
    }
};

var EBUILogic_Dialog_CT2958529 =
{
    fadeOutSteps: 10,
    fadeInSteps: 0,
    fadeOutRef: null,
    xulWindow: null,

    setWindowDirection: function(strDirection, strDialogId) {
        if (EBGlobalManager_CT2958529.IsFirefox3())
            window.document.dir = strDirection;
        else {
            document.getElementById(strDialogId).style.display = 'none';
            document.getElementById(strDialogId).style.direction = strDirection;
        }
    },

    fadeOut: function(strDialogId) {
        this.xulWindow = document.getElementById(strDialogId);
        this.fadeOutRef = setInterval(function() { EBUILogic_Dialog_CT2958529._fadeOut(); }, 30);
    },

    fadeIn: function(strDialogId) {
        this.xulWindow = document.getElementById(strDialogId);
        this._setFFVersion();
        this.fadeOutRef = setInterval(function() { EBUILogic_Dialog_CT2958529._fadeIn(); }, 15);
    },

    _fadeOut: function() {
        this.xulWindow.style.opacity = this.fadeOutSteps * 0.1;
        this.fadeOutSteps--;

        if (this.fadeOutSteps == 0) {
            clearInterval(this.fadeOutRef);
            window.close();
        }
    },

    _fadeIn: function() {
        this.xulWindow.style.opacity = this.fadeInSteps * 0.1;
        this.fadeInSteps++;

        if (this.fadeInSteps == 10) {
            clearInterval(this.fadeOutRef);
            this.xulWindow.style.opacity = 1;
        }
    },

    _setFFVersion: function() {
        this.xulWindow.setAttribute("FF2", !EBGlobalManager_CT2958529.IsFirefox3());
    },

    fillDialogMembers: function(objMembers, doc) {
        var objElement = null;
        for (var i in objMembers) {
            objElement = doc.getElementById(i);
            if (objElement)
                objMembers[i] = objElement;
        }
    }
};
var EngineNotificationsHandlerConsts_CT2958529 =
{
    parametersTypes:
    {
        image: "image",
        text: "text"
    },

    width: 26,
    height: 26
};
function DrawOverlayObjects_CT2958529(callback, width, height, BGColor, arrOfImageData, textData)
{
    var mArrOfImages = new Array();
    var mCanvas = EBHTMLFactory_CT2958529.CreateElement("canvas", null, null, null);
    mCanvas.width = width;
    mCanvas.height = height;
    var mCtx = mCanvas.getContext('2d');

    var mCount = 0;
    var createImage = function(index, url) {
        var image = new Image();
        image.onload = function() {
            mArrOfImages[index] = image;
            mCount++;
            if (mCount == arrOfImageData.length)
                drawObjects();
        };
        image.src = url;
    };

    var drawOverlayObjects = function() {
        var objImageData = null;
        var image = null;
        for (var i = 0; i < arrOfImageData.length; i++) {
            objImageData = arrOfImageData[i];
            createImage(i, objImageData.url);
        }
    };

    var drawObjects = function() {
        for (var i = 0; i < mArrOfImages.length; i++)
            appendImage(mArrOfImages[i], arrOfImageData[i]);
        
        appendText(textData);
        callback(mCanvas.toDataURL("image/png"));
    };

    var appendImage = function(image, data) {
        var width = (data.width) ? data.width : image.width;
        var height = (data.height) ? data.height : image.height;

        mCtx.drawImage(image, data.x, data.y, width, height);
    };

    var appendText = function(data) {
        //TODO:
    };

    drawOverlayObjects();
};



function EBImageData_CT2958529(url, x, y, width, hight) {
    this.url = url;
    this.x = x;
    this.y = y;
    this.width = width;
    this.hight = hight;
};
function EBTextData_CT2958529(text, x, y, color, font) {
    this.text = text;
    this.x = x;
    this.y = y;
    this.textColor = color;
    this.textFont = font;
};
var EBUILogic_Functions_CT2958529 =
{
    setAcceltext: function(xulMenuItem, strText) {
        //FF 3+
        var xulAcceltext = document.getAnonymousElementByAttribute(xulMenuItem, "class", "menu-accel-container")

        //FF 2
        if (!xulAcceltext || !xulAcceltext.firstChild)
            xulAcceltext = document.getAnonymousElementByAttribute(xulMenuItem, "anonid", "accel")

        if (xulAcceltext)
            xulAcceltext.firstChild.value = strText;
        else
            xulMenuItem.setAttribute("acceltext", strText);
    },

    isAboveElement: function(e, xulElement) {
        var x = e.screenX;
        var y = e.screenY;
        var bo = xulElement.boxObject;
        var elementX = bo.screenX;
        var elementY = bo.screenY;

        return (x >= elementX && x <= elementX + bo.width && y >= elementY && y <= elementY + bo.height);
    },

    getClearMenuPopupFunc: function() {
        return function(event) {
            setTimeout(function() {
                var xulMenuPopup = event.target;
                while (xulMenuPopup.firstChild)
                    xulMenuPopup.removeChild(xulMenuPopup.firstChild);
            }, 10);
            event.cancelBubble = true;
        };
    },

    emptyContainer: function(xulElement) {
        if (!xulElement) return;
        while (xulElement.firstChild)
            xulElement.removeChild(xulElement.firstChild);
    },

    fadeIn: function(xulElement, opacityStep, timeoutMs) {
        var fadeIn = function(opacity) {
            xulElement.style.opacity = opacity;
            if (opacity == 1) return;

            setTimeout(function() { fadeIn(opacity += opacityStep); }, timeoutMs);
        }
        xulElement.style.display = "";
        fadeIn(0);
    },

    fadeOut: function(xulElement, opacityStep, timeoutMs) {
        var fadeOut = function(opacity) {
            xulElement.style.opacity = opacity;
            if (opacity == 0) {
                xulElement.style.opacity = opacity;
                xulElement.style.display = "none";
                return;
            }
            setTimeout(function() { fadeOut(opacity -= opacityStep); }, timeoutMs);
        }

        fadeOut(1);
    },

    validateWidth: function(xulElement, width, setMaxSize) {
        var widthCorrection = width - xulElement.boxObject.width;
        if (widthCorrection > 0) {
            xulElement.setAttribute("width", width + widthCorrection);
            if (setMaxSize)
                xulElement.style.maxWidth = parseInt(width + widthCorrection) + "px";
        }
    },

    increaseWidth: function(xulElement, deltaWidth, setMaxSize) {
        var oldWidth = xulElement.boxObject.width;
        var newWidth = oldWidth + deltaWidth;
        xulElement.setAttribute("width", newWidth);

        if (!setMaxSize) {
            var currentMaxWidth = parseInt(document.defaultView.getComputedStyle(xulElement, null).getPropertyValue("max-width"));
            if (currentMaxWidth < newWidth) setMaxSize = true;
        }

        if (setMaxSize)
            xulElement.style.maxWidth = newWidth + "px";

        this.validateWidth(xulElement, newWidth, setMaxSize);
    },

    sizeToContent: function(xulElement, setMaxSize) {
        if (!xulElement || !xulElement.firstChild) return;

        var firstElementBO = xulElement.firstChild.boxObject;
        var lastElementBO = xulElement.childNodes[xulElement.childNodes.length - 1].boxObject;
        var newWidth = lastElementBO.screenX + lastElementBO.width - firstElementBO.screenX;
        xulElement.setAttribute("width", newWidth);
        if (setMaxSize)
            xulElement.style.maxWidth = newWidth + "px";

        this.validateWidth(xulElement, newWidth, setMaxSize);
    }
};

var EBUILogic_ImageButtons_CT2958529 = {
    setManager: function(obj) {
        obj.manager = new EBImageButtonManager_CT2958529(obj);
    }
};

function EBImageButtonManager_CT2958529(obj)
{
    this.mainClass = "";
    this.regularClass = "";
    this.hoverClass = "";
    this.downClass = "";
    this.disabledClass = "";
    this.isDisabled = false;

    this.disable = function() {
        this.isDisabled = true;
        obj.className = this.mainClass + " " + this.disabledClass;
    };

    this.enable = function() {
        this.isDisabled = false;
        obj.className = this.mainClass + " " + this.regularClass;
    };

    this.onmouseDownPaging = function() {
        if (!this.isDisabled)
            obj.className = this.mainClass + " " + this.downClass;
    };

    this.onmouseUpPaging = function() {
        if (!this.isDisabled)
            obj.className = this.mainClass + " " + this.hoverClass;
    };

    this.onmouseOverPaging = function() {
        if (!this.isDisabled)
            obj.className = this.mainClass + " " + this.hoverClass;
    };

    this.onmouseOutPaging = function() {
        if (!this.isDisabled)
            obj.className = this.mainClass + " " + this.regularClass;
    };

    this._init = function() {
        obj.onmousedown = function(evnt) { evnt.target.manager.onmouseDownPaging(); };
        obj.onmouseup = function(evnt) { evnt.target.manager.onmouseUpPaging(); };
        obj.onmouseover = function(evnt) { evnt.target.manager.onmouseOverPaging(); };
        obj.onmouseout = function(evnt) { evnt.target.manager.onmouseOutPaging(); };

        var strClasses = obj.getAttribute("ebClasses");
        var arrClasses = strClasses.split(";");
        if (arrClasses.length < 5) return;

        this.mainClass = arrClasses[0];
        this.regularClass = arrClasses[1]
        this.hoverClass = arrClasses[2];
        this.downClass = arrClasses[3];
        this.disabledClass = arrClasses[4];

        obj.className = this.mainClass + " " + this.regularClass;
    };

    this._init();
};
//image handler functions
//This class enables to dynamically set star icons on images
var EBImageHandler_CT2958529 =
{
    // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Private methods and members
    Consts:
    {
        StarredAttribute: 'EB_IS_STARRED',
        IsToStarAttribute: 'EB_IS_TO_STAR',
        StarCandidate: 'EB_STAR_CANDIDATE',
        OriginalImageUrl: "eb-original-image-url",
        StarIcon: 'chrome://browsersearch/skin/star.png'
    },

    // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Public Methods
    SetStar: function(xulButton, strStarUrl, positionFlags) {
        if (!xulButton) return;
        var strImageUrl = (xulButton.hasAttribute("src")) ? xulButton.getAttribute("src") : xulButton.getAttribute("image");
        if (!strStarUrl) strStarUrl = this.Consts.StarIcon;
        var onMixedImageReady = function(strImageData) {
            xulButton.setAttribute("src", strImageData);
            xulButton.setAttribute("image", strImageData);
            //save the original image
            if (!xulButton.hasAttribute(EBImageHandler_CT2958529.Consts.OriginalImageUrl))
                xulButton.setAttribute(EBImageHandler_CT2958529.Consts.OriginalImageUrl, strImageUrl);
            xulButton.setAttribute(EBImageHandler_CT2958529.Consts.StarredAttribute, true);
        };

        EBCanvas_CT2958529.addOverlayImage(strImageUrl, strStarUrl, positionFlags, onMixedImageReady);
    },

    RemoveStar: function(xulButton) {
        var strOriginalImageUrl = xulButton.getAttribute(this.Consts.OriginalImageUrl);
        xulButton.removeAttribute(EBImageHandler_CT2958529.Consts.OriginalImageUrl);
        if (!strOriginalImageUrl) return;

        xulButton.setAttribute("src", strOriginalImageUrl);
        xulButton.setAttribute("image", strOriginalImageUrl);
        xulButton.setAttribute(EBImageHandler_CT2958529.Consts.StarredAttribute, false);

    },

    UpdateStar: function(xulButton, bIsStar, strStarUrl, positionFlags) {
        if (bIsStar)
            this.SetStar(xulButton, strStarUrl);
        else
            this.RemoveStar(xulButton, strStarUrl);
    },

    SetNewImage: function(xulButton, strNewImagePath) {
        xulButton.setAttribute("src", strNewImagePath);
        xulButton.setAttribute("image", strNewImagePath);
        this.SetStar();
    },

    GetImageUrl: function(xulButton) {
        var bAttributeValue = EBGlobalManager_CT2958529.GetBooleanAttribute(xulButton, EBImageHandler_CT2958529.Consts.StarredAttribute, false)

        if (bAttributeValue)
            return xulButton.getAttribute(EBImageHandler_CT2958529.Consts.OriginalImageUrl);
        else
            return (xulButton.hasAttribute("image")) ? xulButton.getAttribute("image") : xulButton.getAttribute("src");

        return strImageName;
    },

    OnPopupShowed: function(event) {
        var xulMenuPopup = event.target;
        var bIsStared = false;
        var xulMenuItem = null;
        for (var i = 0; i < xulMenuPopup.childNodes.length; i++) {
            xulMenuItem = xulMenuPopup.childNodes[i];
            bIsStared = EBGlobalManager_CT2958529.GetBooleanAttribute(xulMenuItem, EBImageHandler_CT2958529.Consts.IsToStarAttribute, false);
            if (bIsStared) {
                EBImageHandler_CT2958529.UpdateStar(xulMenuItem, bIsStared);
            }
        }
    },

    NullifyStaredAttribute: function(xulElement) {
        xulElement.setAttribute(this.Consts.StarredAttribute, false);
    },

    IsStarred: function(xulElement) {
        return EBGlobalManager_CT2958529.GetBooleanAttribute(xulElement, EBImageHandler_CT2958529.Consts.StarredAttribute, false);
    }
};
        
        

function EBUILogic_Popup_CT2958529(xulPopup)
{
    this.fadeOutSteps = 10;
    this.fadeInSteps =  0;
    this.fadeOutRef = null;
    this.xulWindow = xulPopup;
    var _mouseover, _mouseout;
    var mInProcess = false;

    this.setPopupDirection = function(strDirection) {
        this.xulWindow.style.direction = strDirection;
    };

    this.fadeOut = function() {
        if(mInProcess) return;
        mInProcess = true;
        this.fadeOutSteps = 10;
        this.xulWindow.style.opacity = 1;
        var that = this;
        this.fadeOutRef = setInterval(function() { that._fadeOut(); }, 30);
    };

    this.fadeIn = function() {
        if (mInProcess) return;
        mInProcess = true;
        this.fadeInSteps = 0;
        this.xulWindow.style.opacity = 0;
        this._setFFVersion();
        var that = this;
        this.fadeOutRef = setInterval(function() { that._fadeIn(); }, 15);
    };

    this._fadeOut = function() {
        this.xulWindow.style.opacity = this.fadeOutSteps * 0.1;
        this.fadeOutSteps--;

        if (this.fadeOutSteps == 0) {
            clearInterval(this.fadeOutRef);
            this.xulWindow.hidePopup();
            mInProcess = false;
        }
    };

    this._fadeIn = function() {
        this.xulWindow.style.opacity = this.fadeInSteps * 0.1;
        this.fadeInSteps++;

        if (this.fadeInSteps == 10) {
            clearInterval(this.fadeOutRef);
            this.xulWindow.style.opacity = 1;
            mInProcess = false;
        }
    };

    this._setFFVersion = function() {
        this.xulWindow.setAttribute("FF2", !EBGlobalManager_CT2958529.IsFirefox3());
    };

    this.showPopup = function(anchor, position, x, y, isContextMenu, popupTypeFF2, popupAnchorFF2, popupAlignFF2) {
        if (EBGlobalManager_CT2958529.IsFirefox3()) {
            this.xulWindow.openPopup(anchor, position, x, y, isContextMenu, null);
        }
        else {
            this.xulWindow.showPopup(anchor, x, y, popupTypeFF2, popupAnchorFF2, popupAlignFF2);
        }
    };

    this.hidePopup = function() {
        this.xulWindow.hidePopup();
    };

    this.addMouseOverAndOutEvents = function(onmouseover, onmouseout) {
        var timer = null;
        var mouseInside = false;

        _mouseover = function(e) {
            if (e.eventPhase != 2) return;
            clearTimeout(timer);
            if (!mouseInside) {
                mouseInside = true;
                onmouseover(e);
            }
        };

        _mouseout = function(e) {
            var iTimeout = (EBGlobalManager_CT2958529.IsMacintoshPlatform()) ? 300 : 100;
            if (e.eventPhase == 2)
                timer = setTimeout(function() { onmouseout(e); mouseInside = false; }, iTimeout);
        };

        xulPopup.addEventListener("mouseover", _mouseover, false);
        xulPopup.addEventListener("mouseout", _mouseout, false);
    };

    this.removeMouseOverAndOutEvents = function() {
        if (_mouseout && _mouseover) {
            xulPopup.removeEventListener("mouseover", _mouseover, false);
            xulPopup.removeEventListener("mouseout", _mouseout, false);
        }
    };
};
var EBScreen_CT2958529 =
{
    screenManager: Components.classes["@mozilla.org/gfx/screenmanager;1"].getService(Components.interfaces.nsIScreenManager),

    getCorrectedCoordinatesForWindow: function(x, y, width, height, parentElement) {
        var showingScreen = null;
        //try to open the gadget on parent's element screen
        if (parentElement && parentElement.boxObject) {
            showingScreen = this.screenManager.screenForRect(parentElement.boxObject.screenX,
                                                            parentElement.boxObject.screenY,
                                                            parentElement.boxObject.width,
                                                            parentElement.boxObject.height);
        }
        else
            showingScreen = this.screenManager.screenForRect(x, y, width, height);

        var screenX = {};
        var screenY = {};
        var screenWidth = {};
        var screenHeight = {};
        showingScreen.GetAvailRect(screenX, screenY, screenWidth, screenHeight);

        if (x + width > screenX.value + screenWidth.value)
            x = screenX.value + screenWidth.value - width;

        if (y + height > screenY.value + screenHeight.value)
            y = screenY.value + screenHeight.value - height;

        if (x < screenX.value)
            x = screenX.value;

        if (y < screenY.value)
            y = screenY.value;

        var bResizedWidth = false;
        if (width > screenWidth.value) {
            width = screenWidth.value;
            bResizedWidth = true;
        }

        var bResizedHeight = false;
        if (height > screenHeight.value) {
            height = screenHeight.value;
            bResizedHeight = true;
        }

        return { "x": x, "y": y, "width": width, "height": height, "resizedWidth": bResizedWidth, "resizedHeight": bResizedHeight };
    },

    getCorrectedCoordinatesForFloatingWindow: function(parentXulElement, width, isOpenInTheMiddle, panelWidth) {
        var clacWidth = width + 5;
        var clacHeight = EBChevronConsts_CT2958529.floatingWindowHight + 5;
        var difference = isOpenInTheMiddle ? parentXulElement.boxObject.width : clacWidth;
        var x = (parentXulElement.boxObject.screenX + parentXulElement.boxObject.width - difference);
        if (panelWidth && isOpenInTheMiddle)
            x = parentXulElement.boxObject.screenX - (panelWidth / 2 - parentXulElement.boxObject.width / 2);
        var y = parentXulElement.boxObject.screenY + EBChevronConsts_CT2958529.floatingWindowHight;

        if (EBGlobalManager_CT2958529.IsWindowsPlatform())
            y -= 2;
        else if (EBGlobalManager_CT2958529.IsMacintoshPlatform())
            y += 8;
        else if (EBGlobalManager_CT2958529.IsLinuxPlatform())
            y += 6;

        if (EBGlobalManager_CT2958529.IsToolbarRTL()) {
            x = parentXulElement.boxObject.screenX;
            if (x + clacWidth > screen.availWidth)
                x = x - (x + clacWidth - screen.availWidth) - 5;
        }

        if (x < EBChevronConsts_CT2958529.floatingWindowGap) x = EBChevronConsts_CT2958529.floatingWindowGap;
        var objCoordinates = EBScreen_CT2958529.getCorrectedCoordinatesForWindow(x, y, clacWidth, EBChevronConsts_CT2958529.floatingWindowHight, parentXulElement);
        var computeX = (objCoordinates.x == 0) ? 1 : objCoordinates.x;
        if (computeX != x && computeX < EBChevronConsts_CT2958529.floatingWindowGap + screen.availWidth) computeX = 5 + screen.availWidth;
        return { "x": computeX, "y": y, "width": clacWidth, "height": clacHeight };
    },

    openFloatingWindow: function(win, width) {
        var showingScreen = this.screenManager.screenForRect(win.screenX, win.screenY, 1, 1);
        var screenX = {};
        var screenY = {};
        var screenWidth = {};
        var screenHeight = {};
        showingScreen.GetAvailRect(screenX, screenY, screenWidth, screenHeight);
        if (win.isInOpeningProcess) return;
        win.isInOpeningProcess = true;
        var growthInterval = setInterval(function() {
            try {
                if (win && width > win.innerWidth) {
                    var gap = width - win.innerWidth < 80 ? width - win.innerWidth : 80;
                    if (EBChevronConsts_CT2958529.floatingWindowGap + screenX.value < win.screenX) {

                        if (win.screenX - gap > EBChevronConsts_CT2958529.floatingWindowGap + screenX.value)
                            win.moveBy(-gap / 2, 0)
                        else
                            win.moveBy(-(win.screenX - (EBChevronConsts_CT2958529.floatingWindowGap + screenX.value)), 0);
                        if (screenX.value + screenWidth.value > win.screenX + win.outerWidth + gap)
                            win.resizeBy(gap, 0)
                        else
                            win.resizeBy(screenX.value + screenWidth.value - (win.screenX + win.outerWidth) - EBChevronConsts_CT2958529.floatingWindowGap, 0);
                    }
                    else {
                        if (screenX.value + screenWidth.value > win.screenX + win.outerWidth + gap) {
                            win.resizeBy(gap, 0);
                        }
                        else {
                            win.resizeBy(screenX.value + screenWidth.value - (win.screenX + win.outerWidth) - EBChevronConsts_CT2958529.floatingWindowGap, 0);
                        }
                    }
                }
                else {
                    clearInterval(growthInterval);
                    win.isInOpeningProcess = false;
                }
            }
            catch (e) {
                clearInterval(growthInterval);
                win.isInOpeningProcess = false;
            }
        }, 1);
    }
};

var EBUILogic_Toolbar_CT2958529 =
{
    Consts: {
        RTL: "rtl",
        LTR: "ltr",
        SYSTEM: "system",
        REVERSE: "reverse",
        NORMAL: "normal"
    },

    setToolbarSkin: function(skin) {
        var xulToolbar = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
        xulToolbar.style.backgroundImage = (skin.backgroundImageUrl) ? "url('" + skin.backgroundImageUrl + "')" : null;
        xulToolbar.style.backgroundColor = (skin.backgroundColor) ? skin.backgroundColor : null;

        if (!isFloatingMode_CT2958529) {
            var myStuffSplitter = EBToolbarManager_CT2958529.dataToolbarObject.MyStuffSplitter.firstChild;
            myStuffSplitter.style.backgroundImage = "url('" + skin.splitterImageUrl + "')";

            var optionsButton = EBToolbarManager_CT2958529.dataToolbarObject.OptionsButton;
            optionsButton.setAttribute("image", skin.optionsImageUrl);
            //myStuffSplitter.style.backgroundColor = (skin.backgroundColor) ? skin.backgroundColor : null;
        }

        EBToolbarCssFunctions_CT2958529.changeDropMarker(skin.dropDownArrowImageUrl);

        if (skin.fontColor && EBGlobalManager_CT2958529.IsMacintoshPlatform())
            EBToolbarCssFunctions_CT2958529.fixMacFontHoverColor(skin.fontColor);
    },

    setMyStuffDirection: function(direction) {
        //set resizebefore / resizeafter for mysuff splitter
        var xulSplitter = document.getElementById(EBGlobalConsts_CT2958529.MyStuffSplitterId);
        var oPublisherContainer = EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer;
        if (direction == this.Consts.RTL) {
            if (!isFloatingMode_CT2958529) {
                xulSplitter.setAttribute("resizebefore", "closest");
                xulSplitter.setAttribute("resizeafter", "farthest");
            }
            oPublisherContainer.style.overflow = "visible";
        }
        else {
            if (!isFloatingMode_CT2958529) {
                xulSplitter.setAttribute("resizebefore", "farthest");
                xulSplitter.setAttribute("resizeafter", "closest");

            }
            oPublisherContainer.style.overflow = "hidden";
        }
    },

    setDirection: function(direction) {
        if (EBGlobalManager_CT2958529.IsMacintoshPlatform() && EBGlobalManager_CT2958529.IsFirefox3()) return;

        EBGlobalConsts_CT2958529.IsToolbarReversed = direction;
        var oToolbar = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
        oToolbar.style.direction = direction;

        if (!EBGlobalManager_CT2958529.IsFirefox3()) {
            if (oToolbar.dir != this.Consts.REVERSE) oToolbar.dir = this.Consts.REVERSE;
            else oToolbar.dir = this.Consts.NORMAL;
        }

        if (!EBGlobalConsts_CT2958529.IsEngine) this.setMyStuffDirection(direction);
    },


    checkDirection: function() {
        if (EBGlobalManager_CT2958529.IsMacintoshPlatform() && EBGlobalManager_CT2958529.IsFirefox3()) return;

        var oWindow = EBGlobalManager_CT2958529._GetMostRecentBrowserWindow(true);
        var strToolbarDefinedDir = "";

        if (isFloatingMode_CT2958529 && EBGlobalConsts_CT2958529.IsEngine && oWindow.DualPackageFunctions_CT2958529.isEngineOnToolbar())
            strToolbarDefinedDir = oWindow.document.defaultView.getComputedStyle(oWindow.EBToolbarManager_CT2958529.dataToolbarObject.ComponentsContainer, null).getPropertyValue("direction").toLowerCase();
        else
            strToolbarDefinedDir = EBGlobalConsts_CT2958529.IsEngine ? this.Consts.SYSTEM : oToolbarManager_CT2958529.data.generalToolbarInfo.toolbarAlignMode;

        var strSystemDir = EBGlobalManager_CT2958529.GetUserAgentDirection().toLowerCase();

        if (EBGlobalConsts_CT2958529.IsEngine && !isFloatingMode_CT2958529) {
            this.setDirection(strSystemDir);
            return;
        }

        var strToolbarDir = document.defaultView.getComputedStyle(EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance, null).getPropertyValue("direction").toLowerCase();

        if (!strToolbarDefinedDir) return;

        switch (strToolbarDefinedDir.toLowerCase()) {
            case this.Consts.SYSTEM:
                if (strSystemDir != strToolbarDir) this.setDirection(strSystemDir);
                else this.setMyStuffDirection(strSystemDir);
                break;
            case this.Consts.RTL:
                if (strToolbarDir != this.Consts.RTL) this.setDirection(this.Consts.RTL);
                else this.setMyStuffDirection(this.Consts.RTL);
                break;
            case this.Consts.LTR:
                if (strToolbarDir != this.Consts.LTR) this.setDirection(this.Consts.LTR);
                else this.setMyStuffDirection(this.Consts.LTR);
                break;
            default: break;
        }
    },

    getHeight: function() {
        if (EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.isEngineOnToolbar()) {
            var defaultHeight = 28;
            var ownerDataToolbarObject = EBToolbarManager_CT2958529.ownerDataToolbarObject();
            if (!ownerDataToolbarObject)
                return defaultHeight;


            if (!ownerDataToolbarObject.ToolbarInstance || !ownerDataToolbarObject.ToolbarInstance.boxObject)
                return defaultHeight;

            return ownerDataToolbarObject.ToolbarInstance.boxObject.height;
        }

        return parseInt(document.defaultView.getComputedStyle(EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance, null).getPropertyValue("height"));
    }
};

var EBChevronConsts_CT2958529 =
{
    PrefixID: 'EBToolbarChevron_',
    EBToolbarChevronBoxId : 'EBToolbarChevronBox_CT2958529',
    Image: 'chrome://browsersearch/skin/chevron.png',
    ImageRTL: 'chrome://browsersearch/skin/chevron_rtl.png',
    Width: 20,
    SplitterWidth: 9,
    GapFromSearchBox: 0,
    floatingWindowHight: 28,
    floatingWindowMaxWidth: screen.availWidth - 10,
    floatingWindowGap: 5,
    MyStuffButtonWidth: 32,
    ChevronSuffixText: '_chevron',
    ChevronElementDefaultBorderStyle: 'border:1px solid transparent;',
    ChevronElementHoverStyle: 'background-color:transparent;border:1px solid #316AC5;',
    ChevronElementOutStyle: 'background-color:transparent;',
    ChevronFeedRTLClass: 'eb-chevron-feed-rtl_CT2958529',
    source:
    {
        auto: 0,
        windowResize: 1,
        splitter: 2,
        searchSplitter: 3,
        api: 4
    },

    ChevronSkinTopic: 'eb-toolbar-skin-changes',
    ChevronSkinData:
    {
        toolbarSkinLoaded: 'toolbarSkinLoaded',
        toolbarSkinUnLoaded: 'toolbarSkinUnLoaded'
    }
}; 
var EBChevronStaticManager_CT2958529 =
{
    splitterDown: false,
    searchSplitterDown: false,
    floatingWindowsArray: new Array(), //if length !=0 then the chevron is alive
    AIOWindows: new EBArrayHashObject3_CT2958529(),
    disableCloseAllWindows: false,
    timeOutForOpenAIOWindow: null,
    focusFromBC: false,

    getEngineChevronManager: function() {
        var engineManager = window["EBToolbarManager_" + EBGlobalConsts_CT2958529.EngineCTID];
        if (!engineManager) return null;

        return engineManager.chevronManager;
    },

    getEngineStripSizeManager: function() {
        var engineManager = window["EBToolbarManager_" + EBGlobalConsts_CT2958529.EngineCTID];
        if (!engineManager) return null;

        return engineManager.stripSizeManager;
    },

    getToolbarChevronStaticManager: function() {
        return toolbarChevronStaticManager = window["EBChevronStaticManager_" + DualPackageFunctions_CT2958529.engineOwnerCTID()];
    },

    getToolbarChevronManager: function() {
        var toolbarManager = window["EBToolbarManager_" + DualPackageFunctions_CT2958529.engineOwnerCTID()];
        if (!toolbarManager) return null;

        return toolbarManager.chevronManager;
    },

    SetFocusFromBC: function() {
        this.focusFromBC = true;
        var that = this;
        setTimeout(function() { that.focusFromBC = false; }, 15);
    },

    IsChevronAlive: function() {
        if (this.floatingWindowsArray.length > 0)
            return true;
        else return false;
    },

    CloseAllWindows: function() {
        var that = this;
        if (!this.disableCloseAllWindows && !this.isVolumeDialogOpen) {
            this.uncheckChevronButton();
            for (var i = 0; i < this.floatingWindowsArray.length; i++) {
                var win = this.floatingWindowsArray[i];
                win.isAIOMode_CT2958529 ? this.saveAIOWindowSize(win, false) : win.close();
            }

            this.floatingWindowsArray = new Array();

            this.isTocloseAll = true;
            this.onchange(false);

        }
        else
            setTimeout(function() { that.disableCloseAllWindows = false; that.isVolumeDialogOpen = false; }, 5);

        EBAlertManager_CT2958529.onChevronClose();
    },

    CloseAllAIOWindows: function() {
        var that = this;
        for (var i = 0; i < this.floatingWindowsArray.length; i++) {
            var win = this.floatingWindowsArray[i];
            if (win.isAIOMode_CT2958529) this.saveAIOWindowSize(win, false);
        }
        this.floatingWindowsArray.splice(i, 1);
        this.onchange(false);
    },

    saveAIOWindowSize: function(win, removeFromArray) {
        if (EBGlobalManager_CT2958529.IsLinuxPlatform()) {
            win.AIOParentComponent.closeAIOWindow();
            return;
        }
        if (EBGlobalManager_CT2958529.IsMacintoshPlatform() && win.isInOpeningProcess) return;
        var param = win.arguments[0][0];
        if (this.AIOWindows.Contains(param.ctid)) {
            var oWin = this.AIOWindows.GetByID(param.ctid);
            oWin.width = win.innerWidth;
            oWin.height = win.innerHeight;
            win.moveTo(20000, 20000);
            win.isInOpeningProcess = false;
            param.parentComp.XULElement.checked = false;
            param.bgWin.moveTo(20000, 20000);
            if (removeFromArray) {
                for (var i = this.floatingWindowsArray.length - 1; i >= 0; i--) {
                    if ((!win) || win.name == this.floatingWindowsArray[i].name) break;
                    this.floatingWindowsArray.splice(i, 1);
                }
            }
        }
    },

    CloseCorrectWindows: function(FocusedWindow) {
        if (!FocusedWindow) {
            for (var i = 0; i < this.floatingWindowsArray.length; i++) {
                if (this.floatingWindowsArray[i].isFocused) {
                    FocusedWindow = this.floatingWindowsArray[i];
                    break;
                }
            }
        }
        if (!FocusedWindow) return;
        for (var i = this.floatingWindowsArray.length - 1; i >= 0; i--) {
            if ((!FocusedWindow) || FocusedWindow.name == this.floatingWindowsArray[i].name) break;
            var win = this.floatingWindowsArray[i];
            win.isAIOMode_CT2958529 ? this.saveAIOWindowSize(win, false) : win.close();
            this.floatingWindowsArray.splice(i, 1);
            this.onchange(false);
        }
    },

    uncheckChevronButton: function() {
        EBGlobalManager_CT2958529.DispatchEvent(window, "uncheckChevronbutton", null); //toolbarContainerChangeSize
        this.isChevronButtonChecked = false;
    },

    checkAndCloseForMenuChevron: function(event) {
        if (event.eventPhase != 2) return;
        for (var i = 0; i < this.floatingWindowsArray.length; i++) {
            var win = this.floatingWindowsArray[i];
            if (!win.isMouseIsOnMe) {
                this.uncheckChevronButton();
                win.isAIOMode_CT2958529 ? this.saveAIOWindowSize(win, false) : win.close();
                this.floatingWindowsArray.splice(i, 1);
            }
        }
    },

    TransferStarLogicSettings: function(xulElement, xulChevronElement) {
        xulChevronElement.setAttribute(EBImageHandler_CT2958529.Consts.StarCandidate, 'true');
        var bIsStared = EBGlobalManager_CT2958529.GetBooleanAttribute(xulElement, EBImageHandler_CT2958529.Consts.StarredAttribute, false);
        xulChevronElement.setAttribute(EBImageHandler_CT2958529.Consts.IsToStarAttribute, bIsStared);
    },

    startSplitterMove: function(event) {
        this.splitterDown = true;
        var splitter = EBToolbarManager_CT2958529.dataToolbarObject.MyStuffSplitter;
        splitter.addEventListener("mousemove", EBChevronStaticManager_CT2958529.draggingSplitter, false);
        //usage
        var width = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.PublisherContainerWidth);
        if (!width) width = 0;
        EBUsageMyStuff_CT2958529.OnResizerStart(width);
        EBToolbarManager_CT2958529.stripSizeManager.SetWidthRestrictionsBeforeMoveSpliter();
    },

    endSplitterMove: function(event) {
        if (!this.splitterDown) return;

        this.splitterDown = false;
        var splitter = EBToolbarManager_CT2958529.dataToolbarObject.MyStuffSplitter;
        splitter.removeEventListener("mousemove", EBChevronStaticManager_CT2958529.draggingSplitter, false);

        var source = EBChevronConsts_CT2958529.source.splitter;
        EBToolbarManager_CT2958529.chevronManager.SetChevronWithOutTimeOut(event, false, source);

        //usage
        EBToolbarManager_CT2958529.chevronManager.ReportUsageOnResize();

        var engineChevronManager = EBChevronStaticManager_CT2958529.getEngineChevronManager();
        var engineStripSizeManager = EBChevronStaticManager_CT2958529.getEngineStripSizeManager();

        if (engineChevronManager) {
            EBGlobalPreferenceManager_CT2958529.SetPref("permanenceEngine", true);
            engineChevronManager.SetChevronWithOutTimeOut(event, false, source);
            engineStripSizeManager.SetWidthRestrictionsAfterMoveSpliter();
        }
    },

    draggingSplitter: function(event) {
        var source = EBChevronConsts_CT2958529.source.splitter;
        EBToolbarManager_CT2958529.chevronManager.SetChevronWithOutTimeOut(event, false, source);
        var engineChevronManager = EBChevronStaticManager_CT2958529.getEngineChevronManager();
        if (engineChevronManager)
            engineChevronManager.SetChevronWithOutTimeOut(event, false, source);
    },

    startSearchSplitterMove: function(event) {
        this.searchSplitterDown = true;
        var searchComponent = EBComponentsManager_CT2958529.GetSearchBoxComponent();

        if (searchComponent) {
            var splitter = searchComponent.xulSplitter;
            splitter.addEventListener("mousemove", EBChevronStaticManager_CT2958529.draggingSearchSplitter, false);
        }
        EBToolbarManager_CT2958529.stripSizeManager.SetWidthRestrictionsBeforeMoveSearchSpliter();
    },

    endSearchSplitterMove: function(event) {
        if (!this.searchSplitterDown) return;
        this.searchSplitterDown = false;
        var searchComponent = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        if (searchComponent) {
            var splitter = searchComponent.xulSplitter;
            splitter.removeEventListener("mousemove", EBChevronStaticManager_CT2958529.draggingSearchSplitter, false);
        }
        var source = EBChevronConsts_CT2958529.source.searchSplitter;

        EBToolbarManager_CT2958529.chevronManager.SetChevronWithOutTimeOut(event, false, source);
        EBToolbarManager_CT2958529.stripSizeManager.SetWidthRestrictionsBeforeMoveSpliter();
    },

    draggingSearchSplitter: function(event) {
        if (EBGlobalManager_CT2958529.IsToolbarRTL()) return;

        var source = EBChevronConsts_CT2958529.source.searchSplitter;
        EBToolbarManager_CT2958529.chevronManager.SetChevron(event, false, source);
        var engineChevronManager = EBChevronStaticManager_CT2958529.getEngineChevronManager();
        if (engineChevronManager)
            engineChevronManager.SetChevron(event, false, source);
    },

    onWindowResize: function(event) {
        var source = EBChevronConsts_CT2958529.source.windowResize;
        EBToolbarManager_CT2958529.stripSizeManager.SetWidthRestrictionsOnBeforeWindowResize();
        EBToolbarManager_CT2958529.chevronManager.SetChevron(event, false, source);
    },

    onchange: function(isComponentsChanged) {
        if (isAIOMode_CT2958529)
            this.openAIOWindow();
        else {
            if (!EBActionManager_CT2958529.IsToolbarShown()) return;
            var source = EBChevronConsts_CT2958529.source.auto;
            EBToolbarManager_CT2958529.stripSizeManager.onChange();
            if (EBToolbarManager_CT2958529.chevronManager)
                EBToolbarManager_CT2958529.chevronManager.SetChevron(null, isComponentsChanged, source);
        }
    },

    forceChange: function() {
        var source = EBChevronConsts_CT2958529.source.splitter;
        EBToolbarManager_CT2958529.chevronManager.SetChevronWithOutTimeOut(null, false, source);


        var engineChevronManager = EBChevronStaticManager_CT2958529.getEngineChevronManager();
        var engineStripSizeManager = EBChevronStaticManager_CT2958529.getEngineStripSizeManager();

        if (engineChevronManager) {
            engineChevronManager.SetChevronWithOutTimeOut(null, false, source);
            engineStripSizeManager.SetWidthRestrictionsAfterMoveSpliter();
        }
    },

    openAIOWindow: function() {
        var that = this;
        if (this.timeOutForOpenAIOWindow) {
            clearTimeout(this.timeOutForOpenAIOWindow); this.timeOutForOpenAIOWindow = null;
        }
        this.timeOutForOpenAIOWindow = setTimeout(function() {
            var param = window.arguments[0][0];
            var ChevronStaticManager = getTopMostChevronStaticManager_CT2958529();
            if (ChevronStaticManager.AIOWindows.Contains(param.ctid)) {
                var WinObj = ChevronStaticManager.AIOWindows.GetByID(param.ctid);
                param.parentComp.setWindow(window, param.bgWin);
            }
            this.timeOutForOpenAIOWindow = null;
        }, 50);
    },

    resizeEngineToContent: function(ensureFirstAppIsVisible) {
        EBToolbarManager_CT2958529.stripSizeManager.resizeEngineToContent(true, ensureFirstAppIsVisible);
        var toolbarStaticChevronManager = this.getToolbarChevronStaticManager();
        if (!toolbarStaticChevronManager) return;

        toolbarStaticChevronManager.onchange(true);
    },

    onFirstChevronMouseDown: function(event) {

        if (event.which == 1) {
            EBToolbarManager_CT2958529.chevronManager.OnMenuPopupChevronShowing(event);
            event.cancelBubble = true;
        }

        EBAlertManager_CT2958529.onChevronClose();

    }
};

function EBChevronToolbarManager_CT2958529() {
    var arrComponentsInChevron = null;
    var mainWindow = null;
    var iWindowTop = 0;
    var chevronManger = null;
    var xulToolbar = null;

    this._fillMembers = function() {
        chevronManger = window.arguments[0];
        iWindowTop = window.arguments[1];
        mainWindow = window.opener;
        xulToolbar = document.getElementById("ebChevronToolbar");
    };

    this._applySkin = function() {
        //TODO:
    };

    this._addComponentsToToolbar = function() {
        var oComponent;
        if (chevronManger.IndexFirstChevronComponent == -1) return;
        for (var i = chevronManger.IndexFirstChevronComponent; i < chevronManger.componentsHash.Count(); i++) {
            oComponent = chevronManger.componentsHash.GetByIndex(i);
            oComponent.AddToToolbarChevron(xulToolbar);
        }
    };

    this.onload = function(event) {
        this._fillMembers();
        this._applySkin();
        this._addComponentsToToolbar();
    };

    this.onunload = function(event) {
        //TODO:
    };
};
function EBBaseStripeSizeManager_CT2958529(toolbarContainer, componentsHash) {
    this.SetWidthRestrictionsBeforeMoveSpliter = function(source) { };
    this.SetWidthRestrictionsOnWindowResize = function() { };
    this.SetWidthRestrictionsBeforeMoveSearchSpliter = function() { };
    this.SetWidthRestrictionsAfterMoveSpliter = function() { };
    this.SetWidthRestrictionsOnBeforeWindowResize = function() { };
    
    this.SetMinWidth = function(width) { };
    this.SetMaxWidth = function(width) { };
    this.onResize = function(width) { };
    this.onForceResize = function(width) { };
    this.postLoad = function() { };
    this.OnUnload = function() { };
    this.onChange = function() { };
    this.resizeEngineToContent = function() { };

    this.setFirstTimeWidth = function() {
        var iWidth = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.PublisherContainerWidth);
        if (!iWidth) {
            var totalWidth = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance.boxObject.width;
            iWidth = totalWidth - EBChevronConsts_CT2958529.SplitterWidth - EBChevronConsts_CT2958529.MyStuffButtonWidth;
        }
        var w = iWidth - EBChevronConsts_CT2958529.Width
        if (w < 0) return;

        toolbarContainer.setAttribute("width", w);
        var source = EBChevronConsts_CT2958529.source.windowResize;
        EBToolbarManager_CT2958529.chevronManager.SetChevron(null, true, source);
    };
};
function EBDualPackageStripeSizeManager_CT2958529(appsContainer, componentsHash) {
    EBBaseStripeSizeManager_CT2958529.call(this, appsContainer, componentsHash);

    this.init = function() {
    };

    this.OnUnload = function() {
        var engineContainer = EBToolbarManager_CT2958529.dataToolbarObject.EngineContainer;
        if (EBGlobalConsts_CT2958529.IsEngine) {
            appsContainer.style.maxWidth = (screen.availWidth) + "px";
            appsContainer.style.width = (screen.availWidth - EBChevronConsts_CT2958529.MyStuffButtonWidth) + "px";
            engineContainer.style.maxWidth = (screen.availWidth) + "px";
            engineContainer.style.width = (screen.availWidth) + "px";
        }
    };

    this.onResize = function(event) {
        var source = EBChevronConsts_CT2958529.source.windowResize;
        EBToolbarManager_CT2958529.chevronManager.SetChevron(event, true, source);
    };

    this.SetMinWidth = function(width) {
        appsContainer.style.minWidth = width + "px";
    };

    this.saveWidth = function(newWidth) {
        if (!EBGlobalConsts_CT2958529.IsEngine) return;
        var engineContainer = EBToolbarManager_CT2958529.dataToolbarObject.EngineContainer;
        if (typeof newWidth == "undefined")
            newWidth = parseInt(document.defaultView.getComputedStyle(engineContainer, null).getPropertyValue("width"));
        else
            appsContainer.setAttribute("width", newWidth);
        
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.PublisherContainerWidth, newWidth - EBChevronConsts_CT2958529.MyStuffButtonWidth + 2);
    };

    this.SetMaxWidth = function(width) {
        var objSearchBoxComponent = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        if (!objSearchBoxComponent) return 0;
        var goButton = objSearchBoxComponent.xulGoButton;
        var objSearchBox = objSearchBoxComponent.xulMenuList;
        var toolbar = document.getElementById(EBGlobalConsts_CT2958529.EngineContainerId);
        var start1 = EBGlobalManager_CT2958529.IsToolbarRTL() ? screen.width - objSearchBox.boxObject.x - objSearchBox.boxObject.width -40: objSearchBox.boxObject.x;
        width -= (start1 + goButton.boxObject.width + EBChevronConsts_CT2958529.Width + 40 + toolbar.boxObject.width);
        objSearchBox.style.maxWidth = width + "px";
    };

    this.GetSearchBoxX = function() {
        var objSearchBoxComponent = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        if (!objSearchBoxComponent) return 0;

        var objSearchBox = objSearchBoxComponent.xulGoButton;
        var s = EBGlobalManager_CT2958529.IsToolbarRTL() ? window.outerWidth - objSearchBox.boxObject.x : objSearchBox.boxObject.x + objSearchBox.boxObject.width;
        return s;
    };

    this.SetWidthRestrictionsBeforeMoveSpliter = function(preventDispatchEvent) {
        if (EBGlobalConsts_CT2958529.IsEngine) return;
        var gapFromSearchBox = EBChevronConsts_CT2958529.Width + 8;
        if (!EBGlobalManager_CT2958529.IsToolbarRTL()) {
            this.SetMinWidth(this.GetSearchBoxX() + gapFromSearchBox);
        }
        else {
            this.SetMinWidth(this.GetSearchBoxX() + gapFromSearchBox -50);
        }
        
        if (!preventDispatchEvent)
            EBGlobalManager_CT2958529.DispatchEvent(window, "appsContainerChangeSize", null);
    };

    this.SetWidthRestrictionsBeforeMoveSearchSpliter = function() {
        this.SetMaxWidth(screen.width);
        EBGlobalManager_CT2958529.DispatchEvent(window, "appsContainerChangeSize", null);
    };

    this.SetWidthRestrictionsAfterMoveSpliter = function() {
        if (!EBGlobalConsts_CT2958529.IsEngine) return;
        var engineContainer = EBToolbarManager_CT2958529.dataToolbarObject.EngineContainer;
        if (engineContainer.style.maxWidth == document.defaultView.getComputedStyle(engineContainer, null).getPropertyValue("width")) {
            EBGlobalPreferenceManager_CT2958529.SetPref("permanenceEngine", false);
        }
        EBGlobalManager_CT2958529.DispatchEvent(window, "appsContainerChangeSize", null);
    };

    this.postLoad = function() {
        this.resizeEngineToContent(true);
    };

    this.onChange = function() {
        this.resizeEngineToContent(true);
    };

    this.isComponentVisible = function(component, container) {
        var xulElement = component.GetToolbarItemContainer();
        if (!xulElement) return false;

        var componentBO = xulElement.boxObject;
        var containerBO = container.boxObject;
        return containerBO.width > componentBO.width;
    };

    this.resizeEngineToContent = function(isChangeWidth, ensureFirstAppIsVisible) {
        if (EBGlobalConsts_CT2958529.IsEngine) {
            var firstComponent = componentsHash.GetByIndex(0);
            var lastComponent = componentsHash.GetByIndex(componentsHash.Count() - 1);
            EBToolbarManager_CT2958529.chevronManager.SetChevronComponentsCollapsed(false);

            var newWidth = 0;
            var gapForMac = EBGlobalManager_CT2958529.IsMacintoshPlatform() ? 10 : 0;
            gapForMac = !EBGlobalManager_CT2958529.IsFirefox35() ? 5 : 0;
            if (firstComponent && lastComponent) {
                var gapForStart = EBGlobalManager_CT2958529.IsToolbarRTL() ? firstComponent.GetToolbarItemContainer().boxObject.width : 0;
                var gapForEnd = EBGlobalManager_CT2958529.IsToolbarRTL() ? 0 : lastComponent.GetToolbarItemContainer().boxObject.width;

                var firstCompX = firstComponent.GetToolbarItemContainer().boxObject.screenX + gapForStart;
                var lastCompX = lastComponent.GetToolbarItemContainer().boxObject.screenX + gapForEnd;
                newWidth = Math.abs(lastCompX - firstCompX) + 6;
            }

            var engineContainer = EBToolbarManager_CT2958529.dataToolbarObject.EngineContainer;
            appsContainer.style.maxWidth = newWidth + "px";

            var engineContainerWidth = EBChevronConsts_CT2958529.MyStuffButtonWidth + newWidth + gapForMac;
            engineContainer.style.maxWidth = engineContainerWidth + "px";

            if (isChangeWidth) {
                if (!EBGlobalPreferenceManager_CT2958529.GetPref("permanenceEngine")) {
                    var engineContainerWidth = newWidth + EBChevronConsts_CT2958529.MyStuffButtonWidth + EBChevronConsts_CT2958529.Width + gapForMac;
                    engineContainer.setAttribute("width", engineContainerWidth);
                    appsContainer.setAttribute("width", newWidth);
                    EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.PublisherContainerWidth, newWidth);
                }
                else if (ensureFirstAppIsVisible) {
                    var firstComponent = componentsHash.GetByIndex(0);
                    //show the first app if in chevron
                    if (!this.isComponentVisible(firstComponent, appsContainer)) {
                        var xulElement = firstComponent.GetToolbarItemContainer();
                        if (xulElement) {
                            var componentBO = xulElement.boxObject;
                            var newWidth = componentBO.width + 6;
                            appsContainer.setAttribute("width", newWidth);
                            engineContainer.setAttribute("width", newWidth + EBChevronConsts_CT2958529.MyStuffButtonWidth + EBChevronConsts_CT2958529.Width + gapForMac);
                            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.PublisherContainerWidth, newWidth);
                        }
                    }
                }
            }

            EBToolbarManager_CT2958529.chevronManager.SetChevronWithOutTimeOut(null, true, null);
        }
        else
            EBToolbarManager_CT2958529.chevronManager.SetChevron(null, true, null);

        EBGlobalManager_CT2958529.DispatchEvent(window, "appsContainerChangeSize", null);
    };


    this.onForceResize = function(deltaWidth) {
        var engineContainer = EBToolbarManager_CT2958529.dataToolbarObject.EngineContainer;

        EBUILogic_Functions_CT2958529.increaseWidth(appsContainer, deltaWidth, false);
        EBUILogic_Functions_CT2958529.increaseWidth(engineContainer, deltaWidth, false);

        //EBToolbarManager_CT2958529.chevronManager.SetChevronWithOutTimeOut(null, true, null);
        EBGlobalManager_CT2958529.DispatchEvent(window, "appsContainerChangeSize", null);
    };

    this.SetWidthRestrictionsOnBeforeWindowResize = function() {
        this.SetWidthRestrictionsBeforeMoveSpliter(true);
    };

    this.init();
};

EBDualPackageStripeSizeManager_CT2958529.prototype = new EBBaseStripeSizeManager_CT2958529();
EBDualPackageStripeSizeManager_CT2958529.constructor = EBDualPackageStripeSizeManager_CT2958529;

function EBBaseChevronManager_CT2958529(toolbarContainer, componentsHash, index, isEngine) {
    if (!toolbarContainer) return;

    this.toolbarContainer = toolbarContainer;
    this.componentsHash = componentsHash;
    this.isMyStuff = EBGlobalConsts_CT2958529.IsEngine;
    this.xulSearchBox = null;
    this.IndexFirstChevronComponent = -1;

    this.isOpen = false;
    this.visibleComponentsWidth = 0;
    this.hasVisibleComponents = false;
    this.currentIndex = index; 
    this.rtlDeltaWidth = 0;
    this.widthForToolbar = 0;
    this.dataObj = null;
    var timeOutForSetChevron = null;
    var chevronElementBox = document.getElementById(EBChevronConsts_CT2958529.EBToolbarChevronBoxId);

    this.ChevronXULElement = null;
    this.compPartialDisplayed = null;
    this.possibleCompPartialWidth = 0;
    this.compPartialIndex = -1;
    this.preverntSetChevronTmp = false;

    this.__defineGetter__("isChevronVisible", function() {
        return chevronElementBox.getAttribute("collapsed") != "true";
    });

    this.GetContainerWidth = function() {
        return toolbarContainer.boxObject.width;
    };

    this.GetToolbarWidth = function() {
        var toolbar = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance;
        var iWidth = parseInt(document.defaultView.getComputedStyle(toolbar, null).getPropertyValue("width"));
        return iWidth;
    };


    this.GetToolbarChveronID = function() {
        return EBChevronConsts_CT2958529.PrefixID + EBGlobalConsts_CT2958529.ToolbarCTID;
    };

    this.SetComponentsInfo = function() {
        this.visibleComponentsWidth = 0;
        var oComponent = null;
        var xulElement = null;
        this.hasVisibleComponents = false;
        for (var i = 0; i < this.componentsHash.Count(); i++) {
            oComponent = this.componentsHash.GetByIndex(i);
            if (oComponent.ComponentItem.isShow()) {
                xulElement = oComponent.GetToolbarItemContainer();
                if (xulElement) {
                    this.visibleComponentsWidth += xulElement.boxObject.width + 1;
                    this.hasVisibleComponents = true;
                }
            }
        }

        // this.SetWidthRestrictionsBeforeMoveSpliter();
    };

    this.OnComponentsRebuild = function() { };

    //function that checks if this element should be in chevron
    this.IsInChevron = function(XULToolbarItem, isLastShownComponent) {
        if (XULToolbarItem && XULToolbarItem.boxObject) {
            var iToolbarWidth = this.GetContainerWidth();
            var iToolbarX = this.toolbarContainer.boxObject.x;
            var iElementX = XULToolbarItem.boxObject.x;
            var iElementWidth = XULToolbarItem.boxObject.width;
            var iChevronWidth = EBChevronConsts_CT2958529.Width;
            //check if it's the last component so i don't calculate the 
            //width of the chevron element itself:
            if (isLastShownComponent) iChevronWidth = 0;
            //right to left calculation
            if (EBGlobalManager_CT2958529.IsToolbarRTL()) {
                var gapToTheEnd = iElementX - iToolbarX - iChevronWidth;
                if (gapToTheEnd <= this.rtlDeltaWidth + 2) {
                    return true;
                }
            }
            else //left to right calculation
            {
                if ((iElementX + iElementWidth - iToolbarX) > (iToolbarWidth - iChevronWidth - 2)) {
                    return true;
                }
            }
        }
        return false;
    };

    this.IsLastShownComponent = function(objToolbarComponentToCheck) {
        var objToolbarComponent = null;

        for (var i = this.componentsHash.Count() - 1; i >= 0; i--) {
            objToolbarComponent = this.componentsHash.GetByIndex(i);
            if (objToolbarComponent.ComponentItem.isShow())
                return (objToolbarComponent == objToolbarComponentToCheck);
        }

        return false;
    };

    this.IsToChevron = function(component) {
        if (!component.ComponentItem.ShowInChevron) return null;

        var iLastShownComponent = this.IsLastShownComponent(component);
        var xulToolbarItemComponent = component.GetToolbarItemContainer();
        if (xulToolbarItemComponent && (this.IsInChevron(xulToolbarItemComponent, iLastShownComponent) || (component == this.compPartialDisplayed))) {
            return xulToolbarItemComponent;
        }
        else {
            return null;
        }
    };

    this.toChange = function() {
        this.ChevronXULElement.isOpen = this.ChevronXULElement.isOpen ? false : true;
    };

    this.CreateChevronElement = function() { };

    this.changeChevronButtonState = function(state) {
        if (this.ChevronXULElement.checked != state)
            this.ChevronXULElement.checked = state;
    };

    this.isChevronButtonChecked = function() {
        return this.ChevronXULElement.firstChild.checked;
    };
    this.OnUnload = function() { };

    this.OnMenuPopupChevronShowing = function(event) { };



    this.OnPopupShowed = function(event) {
        //fill if needed
    };

    this.IsAddToolbarComponentToChevron = function(objToolbarComponent) {
        return objToolbarComponent.ComponentItem.ShowInChevron && objToolbarComponent.ComponentItem.isShow();
    };

    this.SetChevronElementStyle = function(XULChevronElement) {
        if (XULChevronElement.tagName != 'menuseparator') {
            //check to see if this element is disabled to not set it's color (from disabled grey to element black)
            var isSetColor = XULChevronElement.getAttribute('disabled') == 'true' ? false : true;

            XULChevronElement.setAttribute('style', EBChevronConsts_CT2958529.ChevronElementDefaultBorderStyle);
            //set the style events
            XULChevronElement.setAttribute('onmouseover', 'this.parentNode.chevronManager.OnMouseOverChevronMenuElement(event,' + isSetColor + ');');
            XULChevronElement.setAttribute('onmouseout', 'this.parentNode.chevronManager.OnMouseOutChevronMenuElement(event,' + isSetColor + ');');
        }
    };

    this.OnMouseOverChevronMenuElement = function(event, isSetColor) {
        //isSetColor for the browser component element where we don't
        //want to set their color to black beacuse they are disabled
        //prevent bubbeling the style to this chevron element's child
        if (event.eventPhase != 2) return;

        var XULElement = event.target;
        var strColorStyle = '';
        if (isSetColor) strColorStyle = 'color:black;';

        var strStyleSet = strColorStyle + EBChevronConsts_CT2958529.ChevronElementHoverStyle;
        XULElement.setAttribute('style', strStyleSet);
    };

    this.OnMouseOutChevronMenuElement = function(event, isSetColor) {
        //prevent bubbeling the style to this chevron element's child
        if (event.eventPhase != 2) return;
        var XULElement = event.target;

        var strColorStyle = '';
        if (isSetColor) {
            strColorStyle = 'color:black;';
        }
        var strStyleSet = strColorStyle + EBChevronConsts_CT2958529.ChevronElementDefaultBorderStyle + EBChevronConsts_CT2958529.ChevronElementOutStyle;
        XULElement.setAttribute('style', strStyleSet);
        if (XULElement.isTemporary) XULElement.style.opacity = "0.3";
    };

    this.SetFirstChevronComponentIndex = function() {
        //nullify the indexes
        this.IndexFirstChevronComponent = -1;

        //check for the toolbar components (get the first element index)

        this.IndexFirstChevronComponent = this.GetFirstChevronComponentIndex();

    };

    this.GetFirstChevronComponentIndex = function() {
        //in case the window has been shrink / unshrink and the comp changed
        if (this.compPartialDisplayed && this.compPartialDisplayed != objToolbarComponent) {
            this.compPartialDisplayed.unResizeCompWidth();
            this.compPartialDisplayed = null;
            this.possibleCompPartialWidth = 0;
        }

        var index = -1;
        var objToolbarComponent = null;
        for (var i = 0; i < this.componentsHash.Count(); i++) {
            objToolbarComponent = this.componentsHash.GetByIndex(i);
            if (objToolbarComponent.ComponentItem.isShow() && this.IsToChevron(objToolbarComponent)) {
                index = i;
                break;
            }
        }

        this.calulateWidth(index);

        //resize
        if (objToolbarComponent && index > -1 && this.canLastCompOnToolbarBePartialDisplayed(objToolbarComponent) && this.possibleCompPartialWidth > 0) {
            objToolbarComponent.resizeCompWidth(this.possibleCompPartialWidth);
            if (this.possibleCompPartialWidth == this.compPartialDisplayed.ComponentItem.originalWidth) {
                this.compPartialDisplayed = null;
                this.possibleCompPartialWidth = 0;
            }
            this.compPartialIndex = index;
            index++;
        }
        //unresize
        else {
            if (objToolbarComponent && this.compPartialIndex > -1) {
                var objToolbarComponentPartial = this.componentsHash.GetByIndex(this.compPartialIndex);
                if (this.canLastCompOnToolbarBePartialDisplayed(objToolbarComponentPartial)) {
                    objToolbarComponentPartial.resizeCompWidth(this.possibleCompPartialWidth);
                    if (this.possibleCompPartialWidth == this.compPartialDisplayed.ComponentItem.originalWidth) {
                        this.possibleCompPartialWidth = 0;
                        this.compPartialDisplayed = null;
                    }
                }
            }
        }
        if (index < 0)
            index = -1;
        return index;
    };

    this.canLastCompOnToolbarBePartialDisplayed = function(component) {
        if (EBGlobalConsts_CT2958529.IsEngine) return false;
        if (!component || !component.ComponentItem.compCanBeShownPartial || (component.ComponentItem.compCanBeShownPartial && component.ComponentItem.MinWidthForDisplay == 0))
            return false;

        var XULToolbarItem = component.GetToolbarItemContainer();
        if (XULToolbarItem && XULToolbarItem.boxObject) {
            var iToolbarWidth = this.GetContainerWidth();
            var iToolbarX = this.toolbarContainer.boxObject.x;
            var iElementX = XULToolbarItem.boxObject.x;
            var iElementNewWidth = XULToolbarItem.boxObject.width - component.ComponentItem.MinWidthForDisplay;
            var iChevronWidth = EBChevronConsts_CT2958529.Width;

            //check if it's the last component so i don't calculate the 
            //width of the chevron element itself:
            //if (this.IsLastShownComponent(component)) iChevronWidth = 0;

            //right to left calculation
            if (EBGlobalManager_CT2958529.IsToolbarRTL()) {
                var gapToTheEnd = iElementX - iToolbarX - iChevronWidth;
                if ((gapToTheEnd - this.rtlDeltaWidth + 2) - component.ComponentItem.MinWidthForDisplay >= 0) {
                    this.possibleCompPartialWidth = gapToTheEnd - this.rtlDeltaWidth + 2;
                    this.compPartialDisplayed = component;
                    if (this.possibleCompPartialWidth > component.ComponentItem.width) this.possibleCompPartialWidth = component.ComponentItem.width;
                    return true;
                }
            }
            else //left to right calculation
            {
                if (((iToolbarWidth - iChevronWidth - 2) - (iElementX - iToolbarX)) >= component.ComponentItem.MinWidthForDisplay) {
                    this.possibleCompPartialWidth = (iToolbarWidth - iChevronWidth - 2) - (iElementX - iToolbarX);
                    this.compPartialDisplayed = component; //the problem is that this one changes to be the last comp
                    if (this.possibleCompPartialWidth > component.ComponentItem.width) {
                        this.possibleCompPartialWidth = component.ComponentItem.width;
                    }
                    return true;
                }
            }
        }
        return false;
    };

    this.calulateWidth = function(index) {
        var width = 0;

        if (index > 0 && this.compPartialDisplayed && this.compPartialDisplayed.ComponentItem && this.compPartialDisplayed.ComponentItem.UniqueCompID == this.componentsHash.GetByIndex(index - 1).ComponentItem.UniqueCompID) {
            index--;
        }

        if (index > -1 && index < this.componentsHash.Count()) {
            var gapForStart = EBGlobalManager_CT2958529.IsToolbarRTL() ? this.componentsHash.GetByIndex(index).GetToolbarItemContainer().boxObject.width : 0;
            var gapForEnd = EBGlobalManager_CT2958529.IsToolbarRTL() ? 0 : this.componentsHash.GetByIndex(this.componentsHash.Count() - 1).GetToolbarItemContainer().boxObject.width;
            var startIndex = index > 1 ? index - 1 : 0;
            if (!this.componentsHash.GetByIndex(startIndex).XULElement) startIndex++;
            var startComponentLocation = this.componentsHash.GetByIndex(index).GetToolbarItemContainer().boxObject.x + gapForStart;
            var endComponentLocation = this.componentsHash.GetByIndex(this.componentsHash.Count() - 1).GetToolbarItemContainer().boxObject.x + gapForEnd;

            this.widthForToolbar = Math.abs(endComponentLocation - startComponentLocation);
            var gap = 13 + EBGlobalConsts_CT2958529.IsEngine ? 10 : 0;
            if (this.componentsHash.GetByIndex(this.componentsHash.Count() - 1).ComponentItem instanceof oToolbar_CT2958529.toolbarDataParsing.toolbarItems.separator
                    && !oToolbarSkin_CT2958529.separatorImageUrl)
                gap += 9;
            this.widthForToolbar = this.widthForToolbar + gap;
            if (this.widthForToolbar > EBChevronConsts_CT2958529.floatingWindowMaxWidth) this.widthForToolbar = EBChevronConsts_CT2958529.floatingWindowMaxWidth;
        }
    };

    this.SetChevronComponentsCollapsed = function(isCollapsed) {
        //set the toolbar components
        if (this.IndexFirstChevronComponent != -1) {
            var objToolbarComponent = null;
            for (var i = this.IndexFirstChevronComponent; i < this.componentsHash.Count(); i++) {
                objToolbarComponent = this.componentsHash.GetByIndex(i);
                if (objToolbarComponent) {
                    objToolbarComponent.SetComponentCollapsed(isCollapsed);
                    objToolbarComponent.ComponentItem.isInChevron = isCollapsed;
                }
            }
        }
        else {
            if ( !isFloatingMode_CT2958529) {
                for (var i = 0; i < this.componentsHash.Count(); i++) {
                    objToolbarComponent = this.componentsHash.GetByIndex(i);
                    if (objToolbarComponent) {
                        objToolbarComponent.ComponentItem.isInChevron = false;
                    }
                }
            }
        }
    };

    this.SetChevronElementCollapsed = function(isCollapsed) {
        //if there is visible chevron element on the toolbar 
        //the last element on the toolbar (toolbaritem) should be hidden
        //for the sizing effect to be smoothly
        if (this.ChevronXULElement) {
            //i collapsed each element in the chevron due to a bug in fx 1.0.*
            chevronElementBox.setAttribute('collapsed', isCollapsed);
        }
    };

    this.isChevronShown = function() {
        return !parseBool(chevronElementBox.getAttribute('collapsed'));
    };

    //function that checks what chevron is legal start chevron element
    //from the start index - it's eliminates the components that doesn't supposed
    //to be in the chevron (the ShowInChevrom member from the settings is false)
    this.GetLegalStartChevronComponent = function() {
        var objToolbarComponent = null;
        for (var i = this.IndexFirstChevronComponent; i < this.componentsHash.Count(); i++) {
            objToolbarComponent = this.componentsHash.GetByIndex(i);
            if (objToolbarComponent && this.IsAddToolbarComponentToChevron(objToolbarComponent))
                return objToolbarComponent;
        }
        if (this.componentsHash.Count() == 1 && this.compPartialDisplayed)
            return this.compPartialDisplayed;
        if (this.componentsHash.Count() == this.IndexFirstChevronComponent && this.compPartialDisplayed)
            return this.compPartialDisplayed;

        return null;
    };

    this.SetChevronElement = function() {
        if (!this.ChevronXULElement)
            this.CreateChevronElement();

        //indicates if the chevron is added
        //(after all the checks - if this component is legal,in chevron etc...)
        var isChevron = false;
        //set the chevron into the toolbar
        //start the check from the toolbar components
        if (this.IndexFirstChevronComponent != -1) {
            var objStartChevronComponent = this.GetLegalStartChevronComponent();
            if (objStartChevronComponent) {
                var objToolbarItem = this.IsToChevron(objStartChevronComponent);
                if (objToolbarItem) {
                    isChevron = true;
                    //add the chevron to the toolbar
                    this.locateChevronElement();
                    this.SetChevronElementCollapsed(false);
                }
            }
        }
    };

    this.calulateWidthFromStartToComponent = function(compIndex) {
        var width = 0;
        if (compIndex >= this.componentsHash.Count()) compIndex = this.componentsHash.Count() - 1;
        var gapForStart = EBGlobalManager_CT2958529.IsToolbarRTL() ? this.componentsHash.GetByIndex(0).GetToolbarItemContainer().boxObject.width : 0;
        var gapForEnd = EBGlobalManager_CT2958529.IsToolbarRTL() ? 0 : this.componentsHash.GetByIndex(compIndex).GetToolbarItemContainer().boxObject.width;
        var startComponentLocation = this.componentsHash.GetByIndex(0).GetToolbarItemContainer().boxObject.x + gapForStart;
        var endComponentLocation = this.componentsHash.GetByIndex(compIndex).GetToolbarItemContainer().boxObject.x + gapForEnd;
        width = Math.abs(endComponentLocation - startComponentLocation);
        var gap = EBGlobalConsts_CT2958529.IsEngine ? 13 : 10;
        width += gap;
        if (width > EBChevronConsts_CT2958529.floatingWindowMaxWidth) width = EBChevronConsts_CT2958529.floatingWindowMaxWidth;
        return width;
    };

    this.CheckLegalChevron = function(event, isFirstTime) {
        //only if it comes from the onmouseup event of the splitter
        if ((event && event.type == 'mouseup') || isFirstTime) {
            var objSplitter = null;
            var objSearchBox = null;
            var objSearchBoxComponent = EBComponentsManager_CT2958529.GetSearchBoxComponent();

            if (objSearchBoxComponent) {
                objSplitter = objSearchBoxComponent.xulSplitter;
                objSearchBox = objSearchBoxComponent.xulMenuList;
            }

            if (objSearchBox && objSplitter && objSplitter.boxObject) {
                var iToolbarWidth = this.GetContainerWidth();
                var iScreenWidth = window.screen.width;
                var iChevronWidth = EBChevronConsts_CT2958529.Width;
                var iTargetX;

                //if it's first time the check is compare to the all screen
                //and if not the check is compare the toolbar width

                var iCheckWidth = isFirstTime ? iScreenWidth : iToolbarWidth;
                var strWidthSet = 0;
                //no mystuff
                //if (!oToolbarManager_CT2958529.myStuffEnabled()) {
                iTargetX = objSplitter.boxObject.x + objSplitter.boxObject.width;
                var iSearchBoxGap = (iTargetX) - (iCheckWidth - iChevronWidth);

                if (iSearchBoxGap > 0)
                    strWidthSet = objSearchBox.parentNode.getAttribute('width') - iSearchBoxGap;

                if (strWidthSet <= 0) return;

                //if it's first time check i set the width to default
                if (isFirstTime)
                    strWidthSet = EBSearchBoxConsts_CT2958529.SearchBoxWidth;

                //set the width in timeout cause there is an event happening
                //that sets the width according to the splitter mouse up event

                var manager = this;
                var objTimeoutFunction = function() {
                    objSearchBox.parentNode.setAttribute('width', strWidthSet);
                    EBSearchBoxManager_CT2958529.SetPrefMenuListWidth(true);
                    EBToolbarManager_CT2958529.stripSizeManager.SetWidthRestrictionsBeforeMoveSpliter();
                    EBChevronStaticManager_CT2958529.onchange(false);
                }

                setTimeout(objTimeoutFunction, 100);
            }
        }
    };
    this.onLanguagePackChange = function() { };

    this.SetChevron = function(event, isComponentsRebuild, source) {
        if (EBGlobalManager_CT2958529.IsToolbarRTL()) {
            this._setChevron(event, isComponentsRebuild, source);
            return;
        }

        var that = this;
        if (timeOutForSetChevron)
            clearTimeout(timeOutForSetChevron); timeOutForSetChevron = null;

        timeOutForSetChevron = setTimeout(function() { that._setChevron(event, isComponentsRebuild, source); timeOutForSetChevron = null; }, 200);
    };


    this.SetChevronWithOutTimeOut = function(event, isComponentsRebuild, source) {
        this._setChevron(event, isComponentsRebuild, source);
    };

    this._setChevron = function(event, isComponentsRebuild, source) {
        if (this.preverntSetChevronTmp) {
            this.SetChevronComponentsCollapsed(true);
            var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(false);
            oWindow.EBToolbarManager_CT2958529.chevronManager.compPartialDisplayed.resizeCompWidth();
            return;
        }
        try {
//            if (EBGlobalConsts_CT2958529.IsEngine) {
//                for (var i = 0; i < EBChevronStaticManager_CT2958529.floatingWindowsArray.length; i++)
//                    if (EBChevronStaticManager_CT2958529.floatingWindowsArray[i].isFloatingMode_CT2958529 && EBChevronStaticManager_CT2958529.floatingWindowsArray.length == 1) {
//                    return;
//                }
//            }


            if (!this.componentsHash) return;
            //first hide the chevron element to calculate right
            //the elements on the toolbar
            this.SetChevronElementCollapsed(true);

            var currWidth = this.GetContainerWidth();
            //show all components(collased = false)
            this.SetChevronComponentsCollapsed(false);

            //on RTL toolbar growth to the right, exceeding the borders of the screen when all components are visible if there is
            //not enough space.
            var newWidth = 0; //this.GetContainerWidth();
            if (EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.isEngineInDualPackage()) {
                for (var i = 0; i < this.componentsHash.Count(); i++) {
                    newWidth += parseInt(this.componentsHash.GetByIndex(i).GetToolbarItemContainer().boxObject.width);
                }
            }
            else
                newWidth = this.GetContainerWidth();
            this.rtlDeltaWidth = newWidth - currWidth;
            this.SetComponentsInfo();

            if (isComponentsRebuild)
                this.OnComponentsRebuild();
            //set the first index of the component that will be in the chevron
            this.SetFirstChevronComponentIndex();
            //add the chevron to the toolbar before the first chevron element
            this.SetChevronElement();

            //hide all the elements that supposed to be in the chevron
            this.SetChevronComponentsCollapsed(true);

            //check if to set the toolbar width if it's exceed the window width
            if (!EBGlobalManager_CT2958529.IsToolbarRTL())
                this.CheckLegalChevron(event, isComponentsRebuild);

            if (isFloatingMode_CT2958529) EBToolbarManager_CT2958529.stripSizeManager.onResize();
        }
        catch (err) {
            EBLogging_CT2958529.LogToConsole(err, "CHEVRON ERROR");
        }
    };

    this.setCehvronContextMenu = function() {
        if (EBGlobalConsts_CT2958529.IsEngine)
            return;

        var strHostContextMenuId = oToolbarManager_CT2958529.metaDataConsts.EBToolbarContextMenuId + EBGlobalConsts_CT2958529.ToolbarCTID;
        this.ChevronXULElement.setAttribute("context", strHostContextMenuId);
    };

    this.locateChevronElement = function() {
        chevronElementBox.setAttribute('collapsed', false);
    };

    this.setEngineChevronSkinInDUP = function() {
        if (!(EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.isEngineInDualPackage() && (DualPackageFunctions_CT2958529.isEngineOnToolbar() || isFloatingMode_CT2958529)))
            return "";

        this.ChevronXULElement.setAttribute('ebToolbarButton_' + DualPackageFunctions_CT2958529.engineOwnerCTID(), true);
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        var toolbarSkin = oWindow['oToolbarSkin_' + DualPackageFunctions_CT2958529.engineOwnerCTID()];

        if (!toolbarSkin) return "";

        //check if chevron is default image (no special skinned chevron)
        var strChevronImage = toolbarSkin.chevronImageUrl;
        if (strChevronImage.indexOf("chrome://") == 0)
            strChevronImage = "";
        else
            this.ChevronXULElement.setAttribute("image", strChevronImage);

        return strChevronImage;
    };

    this.setEngineChevronSkinToDefualt = function() {
        if (!EBGlobalConsts_CT2958529.IsEngine && !DualPackageFunctions_CT2958529.isEngineInDualPackage())
            return;

        var strImage = oToolbarSkin_CT2958529.chevronImageUrl;
        if (EBGlobalManager_CT2958529.IsToolbarRTL())
            strImage = EBChevronConsts_CT2958529.ImageRTL;

        this.ChevronXULElement.setAttribute("image", strImage);
        this.ChevronXULElement.setAttribute("width", EBChevronConsts_CT2958529.Width);
    };
};

function EBFirstChevronManager_CT2958529(toolbarContainer, componentsHash, index) {
    EBBaseChevronManager_CT2958529.call(this, toolbarContainer, componentsHash, index);
    
    this.CreateChevronElement = function() {
        var strID = this.GetToolbarChveronID();
        var strImage = oToolbarSkin_CT2958529.chevronImageUrl;
        //check if chevron is default image (no special skinned chevron)
        if (strImage.indexOf("chrome://") == 0 && EBGlobalManager_CT2958529.IsToolbarRTL())
            strImage = EBChevronConsts_CT2958529.ImageRTL;

        this.ChevronXULElement = document.getElementById(strID);
        this.ChevronXULElement.setAttribute("image", strImage);

        if (EBGlobalConsts_CT2958529.IsEngine) {
            var toolbarChevronImage = this.setEngineChevronSkinInDUP();
            if (toolbarChevronImage) strImage = toolbarChevronImage;
        }

        var self = this;
        var img = new Image();
        img.onload = function() {
            EBChevronConsts_CT2958529.Width = img.width + 11;
            img = null;
            self.ChevronXULElement.setAttribute("width", EBChevronConsts_CT2958529.Width);
            self.ChevronXULElement.parentNode.setAttribute("width", EBChevronConsts_CT2958529.Width);
            self.ChevronXULElement.parentNode.style.maxWidth = EBChevronConsts_CT2958529.Width + "px";
        };
        img.src = strImage;

        this.setCehvronContextMenu();
        document.addEventListener("uncheckChevronbutton", function() { self.changeChevronButtonState(false); }, false);
        //notify the engine that toolbar skin as be loaded
        if (!EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.isToolbarInDualPackage() && DualPackageFunctions_CT2958529.isEngineOnToolbar())
            EBObserversManager_CT2958529.NotifyCustomObserver(null, EBChevronConsts_CT2958529.ChevronSkinTopic, EBChevronConsts_CT2958529.ChevronSkinData.toolbarSkinLoaded);

    };

    this.OnUnload = function() {
        if (this.compPartialDisplayed)
            this.compPartialDisplayed.SetComponentCollapsed(false);

        if (!EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.isToolbarInDualPackage() && !DualPackageFunctions_CT2958529.isEngineOnToolbar())
            EBObserversManager_CT2958529.NotifyCustomObserver(null, EBChevronConsts_CT2958529.ChevronSkinTopic, EBChevronConsts_CT2958529.ChevronSkinData.toolbarSkinUnLoaded);

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
    };

    this.OnMenuPopupChevronShowing = function(event) {
        var that = this;
        var name = "chevronToolbar";
        var oDialog = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName("EBChevronToolbarType_CT2958529", name);
        if (oDialog) {
            oDialog.close();
            EBChevronStaticManager_CT2958529.uncheckChevronButton();
            EBChevronStaticManager_CT2958529.onchange(false); return;
        }
        else {
            setTimeout(function() { that._onMenuPopupChevronShowing(); }, 10);
        }
    };


    this._onMenuPopupChevronShowing = function(event) {
        if (this.compPartialDisplayed) {
            this.preverntSetChevronTmp = true;
            this.compPartialDisplayed.unResizeCompWidth();
            this.possibleCompPartialWidth = 0;
            this.compPartialIndex = -1;
            this.compPartialDisplayed.SetComponentCollapsed(true);
            this.IndexFirstChevronComponent--;
        }

        var name = "chevronToolbar";
        this.dataObj = new oToolbar_CT2958529.toolbarDataParsing.dataObjects.ChevronToolbar();
        this.dataObj.isMyStuff = this.isMyStuff;
        this.dataObj.detectedItem = EBToolbarManager_CT2958529.detectedItem;
        if (this.currentIndex == 0 && !this.isMyStuff && !EBGlobalConsts_CT2958529.IsEngine) this.currentIndex--;

        this.dataObj.FirstIndex = this.IndexFirstChevronComponent + this.currentIndex;
        var coordinates = EBScreen_CT2958529.getCorrectedCoordinatesForFloatingWindow(this.ChevronXULElement, this.widthForToolbar);
        var strParams = "chrome,dependent,resizable=no,titlebar=no,width=" + coordinates.width + ",height=" + coordinates.height + ",left=" + coordinates.x + ",top=" + coordinates.y;
        //there is a bug in Firefox3, if window background color is set to transparent, all xul:browser controls are transparent.
        //so the only difference between chevronDialogFF3.xul and the regular is it's BG color.
        var chevronDialogUrl = (EBGlobalManager_CT2958529.IsFirefox35()) ? "chrome://browsersearch/content/chevronDialog.xul" : "chrome://browsersearch/content/chevronDialogFF3.xul";
        EBGlobalManager_CT2958529.OpenDialog(chevronDialogUrl, name, strParams, [this.dataObj]);

        //send usage
        this.changeChevronButtonState(true);
        EBChevronStaticManager_CT2958529.isChevronButtonChecked = true;
        var strCompType = (this.isMyStuff) ? oToolbar_CT2958529.toolbarDataParsing.ComponentType.MyStuff : oToolbar_CT2958529.toolbarDataParsing.ComponentType.Settings;
        EBUsageChevron_CT2958529.Open(this.isMyStuff, strCompType);

    };
    this.ReportUsageOnResize = function() {
        var width = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.PublisherContainerWidth);
        if (!width) width = 0;
        EBUsageMyStuff_CT2958529.OnResizerEnd(width);
    };
};

EBFirstChevronManager_CT2958529.prototype = new EBBaseChevronManager_CT2958529();
EBFirstChevronManager_CT2958529.constructor = EBFirstChevronManager_CT2958529;

function EBSecondChevronManager_CT2958529(toolbarContainer, componentsHash, index) {
    EBBaseChevronManager_CT2958529.call(this, toolbarContainer, componentsHash, index);

    this.CreateChevronElement = function() {
        var strID = this.GetToolbarChveronID();
        var strImage = oToolbarSkin_CT2958529.chevronImageUrl;
        if (EBGlobalManager_CT2958529.IsToolbarRTL())
            strImage = EBChevronConsts_CT2958529.ImageRTL;

        this.ChevronXULElement = document.getElementById(strID);
        this.ChevronXULElement.setAttribute("image", strImage);

        if (EBGlobalConsts_CT2958529.IsEngine) {
            var toolbarChevronImage = this.setEngineChevronSkinInDUP();
            if (toolbarChevronImage) strImage = toolbarChevronImage;
        }
        
        var img = new Image();
        var self = this;
        img.onload = function() {
            EBChevronConsts_CT2958529.Width = img.width + 11;
            img = null;
            self.ChevronXULElement.setAttribute("width", EBChevronConsts_CT2958529.Width);
            self.ChevronXULElement.parentNode.setAttribute("width", EBChevronConsts_CT2958529.Width);
            self.ChevronXULElement.parentNode.style.maxWidth = EBChevronConsts_CT2958529.Width + "px";
        };
        img.src = strImage;

        var strOnPopupShowing = "this.chevronManager.OnMenuPopupChevronShowing(event);";
        var strOnPopupShown = "this.chevronManager.OnPopupShowed(event);";
        var XULMenuPopup = EBXULFactory_CT2958529.CreateMenuPopup('', strOnPopupShowing, '');
        XULMenuPopup.setAttribute("onpopupshown", strOnPopupShown);
        XULMenuPopup.setAttribute("onpopuphidden", 'getTopMostChevronStaticManager_CT2958529().checkAndCloseForMenuChevron(event);');
        this.ChevronXULElement.appendChild(XULMenuPopup);

        //  this.ChevronXULElement.setAttribute("flex", "1");
        //  this.ChevronXULElement.setAttribute("pack", "end");
        this.setCehvronContextMenu();
        //set manager to menupopup
        XULMenuPopup.chevronManager = this;
    };

    this.OnUnload = function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
        oWindow.EBToolbarManager_CT2958529.chevronManager.preverntSetChevronTmp = false;

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        if (objWindow)
            objWindow.EBToolbarManager_CT2958529.chevronManager.SetChevron(null, false, null);
        if (isFloatingMode_CT2958529) {
            if (objWindow && objWindow.EBRadioManager_CT2958529.isShrink) {

                if (objWindow.EBRadioGUIManager_CT2958529.SetShrink) {
                    try {
                        objWindow.EBRadioGUIManager_CT2958529.SetShrink();
                    }
                    catch (ex) { }
                }
                EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().EBRadioManager_CT2958529.isShrink = false;
            }
            if (objWindow && objWindow.EBRadioManager_CT2958529.isUnshrink) {
                if (objWindow.EBRadioGUIManager_CT2958529.SetExpand) {
                    try {
                        objWindow.EBRadioGUIManager_CT2958529.SetExpand();
                    }
                    catch (ex) { }
                }
                objWindow.EBRadioManager_CT2958529.isUnshrink = false;
            }
        }
    };

    this.OnMenuPopupChevronShowing = function(event) {
        //chevron behave like menu

        //check to see that this popupshowing event is coming from the main
        //menupopup - (this event somehow propagating to all the menupopup childs)
        if (event.eventPhase != 2) return;
        var XULMenuPopup = event.target;

        //nullify the menupopup
        while (XULMenuPopup.childNodes.length > 0)
            XULMenuPopup.removeChild(XULMenuPopup.firstChild);

        if (this.IndexFirstChevronComponent != -1) {
            var objToolbarComponent = null;
            for (var i = this.IndexFirstChevronComponent; i < this.componentsHash.Count(); i++) {
                objToolbarComponent = this.componentsHash.GetByIndex(i);

                if (objToolbarComponent && this.IsAddToolbarComponentToChevron(objToolbarComponent)) {
                    var XULChevronElement = objToolbarComponent.AddToChevron(XULMenuPopup);
                    if (!isAIOMode_CT2958529)
                        objToolbarComponent.AddContextMenuToChevron();
                    if (XULChevronElement) {
                        this.SetChevronElementStyle(XULChevronElement);
                        if (objToolbarComponent.isTemporary)
                            XULChevronElement.style.opacity = "0.3";
                        XULChevronElement.isTemporary = objToolbarComponent.isTemporary;
                    }
                }
            }
        }
    };
};

EBSecondChevronManager_CT2958529.prototype = new EBBaseChevronManager_CT2958529();
EBSecondChevronManager_CT2958529.constructor = EBSecondChevronManager_CT2958529;

function EBSecondStripeSizeManager_CT2958529(toolbarContainer, componentsHash) {
    EBBaseStripeSizeManager_CT2958529.call(this, toolbarContainer, componentsHash);

    var timeOutForonResize = null;
    var wasChange = false;

    this.init = function() {
        var that = this;
      //  toolbarContainer.addEventListener("resize", function(event) { that.onResize(event); }, false);
    };

    this.OnUnload = function() {
      //  toolbarContainer.removeEventListener("resize", function(event) { that.onResize(event); }, false);
    };


    this.onResize = function() {
        var that = this;
        if (timeOutForonResize) {
            clearTimeout(timeOutForonResize); timeOutForonResize = null;
        }
        timeOutForonResize = setTimeout(function() { that._onResize(); timeOutForonResize = null; }, 200);
    };


    this._onResize = function() {
        if (!isAIOMode_CT2958529) {

            EBToolbarManager_CT2958529.chevronManager.SetChevronComponentsCollapsed(false);
            EBToolbarManager_CT2958529.chevronManager.SetFirstChevronComponentIndex();
            var lastWidth = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance.boxObject.width + 5;
            var lastLeft = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance.boxObject.screenX;
            var width = EBToolbarManager_CT2958529.chevronManager.calulateWidthFromStartToComponent(EBToolbarManager_CT2958529.chevronManager.IndexFirstChevronComponent + 1); //this.calulateWidthFromStartToComponent(this.IndexFirstChevronComponent + 1) + 10;
            var left = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance.boxObject.screenX - (width - lastWidth) - 4;
            if (EBGlobalManager_CT2958529.IsToolbarRTL()) left = window.screenX;
            if (width > EBChevronConsts_CT2958529.floatingWindowMaxWidth) width = EBChevronConsts_CT2958529.floatingWindowMaxWidth;
            if (left < EBChevronConsts_CT2958529.floatingWindowGap) left = EBChevronConsts_CT2958529.floatingWindowGap;
            if (lastLeft > screen.availWidth && left < screen.availWidth) left = EBChevronConsts_CT2958529.floatingWindowGap + screen.availWidth;
            if (lastWidth < width) {
                //var newY = (wasChange || EBWindows_CT2958529.IsWindows7()) ? window.screenY : window.screenY + 3;
                window.moveTo(left, window.screenY);
                wasChange = true;
                window.resizeTo(width, EBChevronConsts_CT2958529.floatingWindowHight);
            }
            EBToolbarManager_CT2958529.chevronManager.SetChevronComponentsCollapsed(true);
            //EBScreen_CT2958529.openFloatingWindow(window, width);
        }
    };


    this.onForceResize = function(delta) {
        var lastWidth = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance.boxObject.width;
        var lastLeft = EBToolbarManager_CT2958529.dataToolbarObject.ToolbarInstance.boxObject.screenX;
        var width = lastWidth;
        var left = lastLeft;
        if (EBGlobalManager_CT2958529.IsToolbarRTL()) left = window.screenX;
        if (width > EBChevronConsts_CT2958529.floatingWindowMaxWidth) width = EBChevronConsts_CT2958529.floatingWindowMaxWidth;
        if (left < EBChevronConsts_CT2958529.floatingWindowGap) left = EBChevronConsts_CT2958529.floatingWindowGap;
        if (lastLeft > screen.availWidth && left < screen.availWidth) left = EBChevronConsts_CT2958529.floatingWindowGap + screen.availWidth;
        if (!wasChange) delta += 2;
        if (!EBGlobalManager_CT2958529.IsToolbarRTL()) window.moveTo(left - delta, window.screenY);
        window.resizeTo(width + delta + 1, EBChevronConsts_CT2958529.floatingWindowHight);
        wasChange = true;
        return;

    };
    this.init();
};

EBSecondStripeSizeManager_CT2958529.prototype = new EBBaseStripeSizeManager_CT2958529();
EBSecondStripeSizeManager_CT2958529.constructor = EBSecondStripeSizeManager_CT2958529;

var EBStripeSizeManagersFactory_CT2958529 =
{
    getManager: function(componentsContainer, componentsHash, isDualPackage) {
        if (isFloatingMode_CT2958529)
            return new EBSecondStripeSizeManager_CT2958529(componentsContainer, componentsHash);
        else {
            //dual package, for engine and toolbar same manager
            if (isDualPackage)
                return new EBDualPackageStripeSizeManager_CT2958529(componentsContainer, componentsHash);
            //stand alone
            else
                return new EBToolbarStripeSizeManager_CT2958529(componentsContainer, componentsHash);
        }
    }
};
function EBToolbarStripeSizeManager_CT2958529(toolbarContainer, componentsHash) {
    EBBaseStripeSizeManager_CT2958529.call(this, toolbarContainer, componentsHash);
    
    
    this.SetWidthRestrictionsOnWindowResize = function() { };
    this.SetMinWidth = function(width) {
        toolbarContainer.style.minWidth = width + "px";
    };

    this.saveWidth = function(newWidth) {
        if (typeof newWidth == "undefined")
            newWidth = parseInt(document.defaultView.getComputedStyle(toolbarContainer, null).getPropertyValue("width"));
        else
            toolbarContainer.setAttribute("width", newWidth);

        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.PublisherContainerWidth, newWidth);
    };

    this.SetMaxWidth = function(width) {
        var objSearchBoxComponent = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        if (!objSearchBoxComponent) return 0;
        var goButton = objSearchBoxComponent.xulGoButton;
        var objSearchBox = objSearchBoxComponent.xulMenuList;
        width -= (objSearchBox.boxObject.x + goButton.boxObject.width + EBChevronConsts_CT2958529.Width + 40);
        objSearchBox.style.maxWidth = screen.availWidth + "px";
    };

    this.GetSearchBoxX = function() {
        var objSearchBoxComponent = EBComponentsManager_CT2958529.GetSearchBoxComponent();
        if (!objSearchBoxComponent) return EBChevronConsts_CT2958529.MyStuffButtonWidth;

        var objSearchBox = objSearchBoxComponent.xulGoButton;
        return objSearchBox.boxObject.x + objSearchBox.boxObject.width;
    };

    this.SetWidthRestrictionsBeforeMoveSearchSpliter = function() {
        var gapFromSearchBox = EBChevronConsts_CT2958529.Width + 10;
        if (EBGlobalManager_CT2958529.IsToolbarRTL()) {
            this.SetMaxWidth(screen.width);
        }
        else {
            this.SetMaxWidth(screen.width);
            if (!EBGlobalConsts_CT2958529.IsEngine) this.SetMinWidth(screen.width - this.GetSearchBoxX() + gapFromSearchBox);
        }
    };

    this.SetWidthRestrictionsBeforeMoveSpliter = function(source) {
        var gapFromSearchBox = EBChevronConsts_CT2958529.Width + 10; //oToolbarManager_CT2958529.myStuffPublihserMinWidth();
        if (!EBGlobalManager_CT2958529.IsToolbarRTL()) {
            if (!EBGlobalConsts_CT2958529.IsEngine) this.SetMinWidth(this.GetSearchBoxX() + gapFromSearchBox);
        }
        else {
            if (!EBGlobalConsts_CT2958529.IsEngine) this.SetMinWidth(screen.width - this.GetSearchBoxX() + gapFromSearchBox);
        }

    };

    this.SetWidthRestrictionsOnBeforeWindowResize = function() {
        this.SetWidthRestrictionsBeforeMoveSpliter();
    };

    this.postLoad = function() {
        this.SetWidthRestrictionsBeforeMoveSearchSpliter();
    };

};

EBToolbarStripeSizeManager_CT2958529.prototype = new EBBaseStripeSizeManager_CT2958529();
EBToolbarStripeSizeManager_CT2958529.constructor = EBToolbarStripeSizeManager_CT2958529;
function EBToolbarChevronSkinObserver_CT2958529(callbackToolbarSkinLoaded, callbacktoolbarSkinUnLoaded) {
    this.Topic = EBChevronConsts_CT2958529.ChevronSkinTopic;

    this.observe = function(aSubject, aTopic, aData) {
        switch (aData) {
            case EBChevronConsts_CT2958529.ChevronSkinData.toolbarSkinLoaded:
                callbackToolbarSkinLoaded();
                break;
            case EBChevronConsts_CT2958529.ChevronSkinData.toolbarSkinUnLoaded:
                callbacktoolbarSkinUnLoaded();
                break;
            default: break;
        }
    };
};

EBToolbarChevronSkinObserver_CT2958529.prototype = new EBBaseObserver_CT2958529();

var EBHTMLFactory_CT2958529 =
{
    SetAttributes: function(objElement, arrAttributes) {
        if (!arrAttributes || arrAttributes.length == 0) return;

        var attrPair = null;
        for (var i = 0; i < arrAttributes.length; i++) {
            attrPair = arrAttributes[i];
            objElement.setAttribute(attrPair[0], attrPair[1]);
        }
    },

    CreateElement: function(tagName, innerHTML, arrAttributesList, onclickCallback) {
        var htmlElement = document.createElementNS("http://www.w3.org/1999/xhtml", "html:" + tagName);
        if (innerHTML)
            htmlElement.appendChild(document.createTextNode(innerHTML));

        if (onclickCallback)
            htmlElement.onclick = onclickCallback;

        this.SetAttributes(htmlElement, arrAttributesList);
        return htmlElement;
    }
};
/*********************************** Dynamic Xul Elements *******************************/
var EBXULFactory_CT2958529 =
{
    menu: "menu",
    menuButton: "menu-button",

    CreateToolbarButton: function(strId, strType, strLabel, strImage, strTooltip, command, strCSSClassName, isAppViewButton, strBackupImage) {
        var xulToolbarButton = document.createElement("toolbarbutton");

        var strOriginalTooltip = '';

        if (strId)
            xulToolbarButton.setAttribute("id", strId);

        if (strType)
            xulToolbarButton.setAttribute("type", strType);

        if (strLabel) {
            strLabel = EBXML_CT2958529.FromLegalXml(strLabel);
            xulToolbarButton.setAttribute("label", strLabel);
        }

        if (strImage) {
            /*
            oToolbar_CT2958529.cachedIcons.manager.getCachedImagePath(strImage, function(strLocalPath) {
            xulToolbarButton.setAttribute("image", strLocalPath);
            });*/
            xulToolbarButton.setAttribute("image", strImage);
        }

        if (strTooltip) {
            xulToolbarButton.setAttribute("tooltiptext", strTooltip);
            strOriginalTooltip = strTooltip;
        }

        if (command) {
            if (typeof command == "string") {
                xulToolbarButton.setAttribute("oncommand", command);
                xulToolbarButton.setAttribute("onclick", "checkForMiddleClick(this, event);");
            }
            else {
                xulToolbarButton.addEventListener("command", command, false);
                xulToolbarButton.addEventListener("click", function(event) { ebCheckForMiddleClick(event, command); }, false);
            }
        }

        if (strCSSClassName)
            xulToolbarButton.setAttribute("class", strCSSClassName);

        if (strBackupImage)
            xulToolbarButton.setAttribute("BackupImage", strBackupImage);


        //set the global function checkForMiddleClick of Firefox browser
        //to check if the user press this button with middle mouse button
        //set the original tooltip attribute
        xulToolbarButton.setAttribute(EBGlobalConsts_CT2958529.Attributes.XULTooltip, strOriginalTooltip);
        if (!isAppViewButton)
            xulToolbarButton.setAttribute(EBToolbarCssFunctions_CT2958529.TOOLBAR_BUTTON_CSS_ATTR, "true");
        //is APP or Component via (Engine vs Toolbar), there is special XBL for engine toolbarbuttons
        xulToolbarButton.setAttribute(EBToolbarDesignConsts_CT2958529.TOOLBAR_BUTTON_APP_VIEW, isAppViewButton);
        xulToolbarButton.setAttribute(EBToolbarDesignConsts_CT2958529.TOOLBAR_IS_RTL, EBGlobalManager_CT2958529.IsToolbarRTL());
        return xulToolbarButton;
    },

    CreateMenuPopup: function(strId, onPopupShowing, onPopupHiding) {
        var xulMenuPopup = document.createElement("menupopup");

        if (strId)
            xulMenuPopup.setAttribute("id", strId);

        if (onPopupShowing) {
            if (typeof onPopupShowing == "string")
                xulMenuPopup.setAttribute("onpopupshowing", onPopupShowing);
            else
                xulMenuPopup.addEventListener("popupshowing", onPopupShowing, false);
        }

        if (onPopupHiding) {
            if (typeof onPopupShowing == "string")
                xulMenuPopup.setAttribute("onpopuphiding", onPopupHiding);
            else
                xulMenuPopup.addEventListener("popuphiding", onPopupHiding, false);
        }

        return xulMenuPopup;
    },

    CreateMenuSeparator: function() {
        return document.createElement("menuseparator");
    },

    CreateMenuItem: function(strLabel, strImage, strTooltip, command, strName, arrData, commandString) {
        var xulMenuItem = document.createElement("menuitem");

        if (strLabel) {
            strLabel = EBXML_CT2958529.FromLegalXml(strLabel);
            xulMenuItem.setAttribute("label", strLabel);
        }

        if (strImage) {
            /*
            oToolbar_CT2958529.cachedIcons.manager.getCachedImagePath(strImage, function(strLocalPath) {
            xulMenuItem.setAttribute("image", strLocalPath);
            });*/
            xulMenuItem.setAttribute("image", strImage);
            xulMenuItem.setAttribute("class", "menuitem-iconic");
            xulMenuItem.setAttribute("style", EBToolbarDesignConsts_CT2958529.ToolbarMaxImageHeightStyle);
            xulMenuItem.setAttribute("ebcss", "true");
            xulMenuItem.setAttribute("context", "");
        }

        if (strTooltip == undefined) strTooltip = "";
        xulMenuItem.setAttribute("tooltiptext", strTooltip);

        if (command) {
            if (typeof command == "string") {
                xulMenuItem.setAttribute("oncommand", command);
                xulMenuItem.setAttribute("onclick", "checkForMiddleClick(this, event);");
            }
            else {
                xulMenuItem.addEventListener("command", command, false);
                xulMenuItem.addEventListener("click", function(event) { ebCheckForMiddleClick(event, command); }, false);
            }
        }
        if (strName) {
            xulMenuItem.setAttribute("name", strName);
            //In Firefox 3, when setting menuitem to type "radio", the icons are not appear.
            //xulMenuItem.setAttribute("type","radio");
        }

        //additional information stored in a hashtable to add per xul item
        if (arrData) {
            for (var strData in arrData) {
                xulMenuItem.setAttribute(strData, arrData[strData]);
            }
        }

        if (commandString)
            xulMenuItem.setAttribute("eb-command", commandString);

        return xulMenuItem;
    },

    CreateMenu: function(strLabel, strImage, strTooltip) {
        var xulMenu = document.createElement('menu');

        var strClass = '';

        if (strLabel) {
            strLabel = EBXML_CT2958529.FromLegalXml(strLabel);
            xulMenu.setAttribute('label', strLabel);
        }

        if (strImage) {
            /*
            oToolbar_CT2958529.cachedIcons.manager.getCachedImagePath(strImage, function(strLocalPath) {
            xulMenu.setAttribute("image", strLocalPath);
            });*/
            xulMenu.setAttribute("image", strImage);

            strClass = 'menu-iconic';
            xulMenu.setAttribute('style', EBToolbarDesignConsts_CT2958529.ToolbarMaxImageHeightStyle);
            xulMenu.setAttribute("ebcss", "true");
        }

        xulMenu.setAttribute('tooltiptext', strTooltip);

        //check toolbar rtl for the arrow
        if (EBGlobalConsts_CT2958529.IsToolbarReversed) {
            if (EBGlobalManager_CT2958529.IsToolbarRTL()) {
                var strSubMenuRTLClass = (EBGlobalManager_CT2958529.IsFirefox3()) ? EBToolbarDesignConsts_CT2958529.SubMenuRTLClassFF3 : EBToolbarDesignConsts_CT2958529.SubMenuRTLClass;

                if (strClass)
                    strClass += ' ' + strSubMenuRTLClass;
                else
                    strClass = strSubMenuRTLClass;
            }
            else //ltr reversed toolbar
            {
                var strSubMenuLTRClass = (EBGlobalManager_CT2958529.IsFirefox3()) ? EBToolbarDesignConsts_CT2958529.SubMenuLTRClassFF3 : EBToolbarDesignConsts_CT2958529.SubMenuLTRClass;
                if (strClass)
                    strClass += ' ' + strSubMenuLTRClass;
                else
                    strClass = strSubMenuLTRClass;
            }
        }

        if (strClass)
            xulMenu.setAttribute("class", strClass);

        return xulMenu;
    },

    CreateMenuList: function(strId, strOnInput, strOnKeyPress, strOnClick, strOnMouseDown, strWidth, strMinWidth, strStyle) {
        var xulMenuList = document.createElement("menulist");

        if (strId) {
            xulMenuList.setAttribute("id", strId);
        }
        if (strOnInput) {
            xulMenuList.setAttribute("oninput", strOnInput);
        }
        if (strOnKeyPress) {
            xulMenuList.setAttribute("onkeypress", strOnKeyPress);
        }
        if (strOnClick) {
            xulMenuList.setAttribute("onclick", strOnClick);
        }
        if (strOnMouseDown) {
            xulMenuList.setAttribute("onmousedown", strOnMouseDown);
        }
        if (strWidth) {
            xulMenuList.setAttribute("width", strWidth);
        }
        if (strMinWidth) {
            xulMenuList.setAttribute("minwidth", strMinWidth);
        }
        if (strStyle) {
            xulMenuList.setAttribute("style", strStyle);
        }

        //fixed menu list attributes
        xulMenuList.setAttribute("editable", "true");
        xulMenuList.setAttribute("flex", "1");

        return xulMenuList;
    },

    CreateBrowser: function(strId, strSrc, strWidth, strHeight) {
        var XULBrowser = document.createElement("browser");

        XULBrowser.setAttribute("id", strId);
        XULBrowser.setAttribute("autoscroll", false);
        XULBrowser.setAttribute("src", strSrc);
        XULBrowser.setAttribute("width", strWidth);
        XULBrowser.setAttribute("height", strHeight);
        XULBrowser.setAttribute('type', 'content');
        //disable the scroll with style
        XULBrowser.setAttribute("style", "overflow:hidden;");

        return XULBrowser;
    },

    CreateSplitter: function(strState, strCollapse, strResizeBefore, strResizeAfter, strTooltip, strStyle, strImage) {
        var xulSplitter = document.createElement("splitter");

        if (strState) {
            xulSplitter.setAttribute("state", strState);
        }
        if (strCollapse) {
            xulSplitter.setAttribute("collapse", strCollapse);
        }
        if (strResizeBefore) {
            xulSplitter.setAttribute("resizebefore", strResizeBefore);
        }
        if (strResizeAfter) {
            xulSplitter.setAttribute("resizeafter", strResizeAfter);
        }
        if (strTooltip) {
            xulSplitter.setAttribute("tooltiptext", strTooltip);
        }
        if (strStyle) {
            xulSplitter.setAttribute("style", strStyle);
        }
        //TODO: attach to cachedImages
        if (strImage) {
            var strStyleImage = "min-height:18px;min-width:9px;background-image:url(\"" + strImage + "\");";
            var xulVBox = this.CreateVBox('', strStyleImage, '');
            xulSplitter.appendChild(xulVBox);
        }
        return xulSplitter;
    },

    CreateVBox: function(strFlex, strStyle, strAlign) {
        var xulVBox = document.createElement("vbox");
        if (strFlex) {
            xulVBox.setAttribute("flex", strFlex);
        }
        if (strStyle) {
            xulVBox.setAttribute("style", strStyle);
        }
        if (strAlign) {
            xulVBox.setAttribute("align", strAlign);
        }
        return xulVBox;
    },

    CreateHBox: function(strFlex, strStyle, strAlign) {
        var xulHBox = document.createElement("hbox");
        if (strFlex) {
            xulHBox.setAttribute("flex", strFlex);
        }
        if (strStyle) {
            xulHBox.setAttribute("style", strStyle);
        }
        if (strAlign) {
            xulHBox.setAttribute("align", strAlign);
        }
        return xulHBox;
    },

    CreateSpacer: function(strStyle) {
        var xulSpacer = document.createElement("spacer");
        if (strStyle) {
            xulSpacer.setAttribute("style", strStyle);
        }
        return xulSpacer;
    },

    CreateImage: function(strSrc, strWidth, strHeight, bFireRecalculateChecvronOnLoad) {
        var xulImage = document.createElement("image");
        if (bFireRecalculateChecvronOnLoad) {
            xulImage.onload = function() {
                EBChevronStaticManager_CT2958529.onchange(true);
            };
        }

        if (strSrc) {
            oToolbar_CT2958529.cachedIcons.manager.getCachedImagePath(strSrc, function(strLocalPath) {
                xulImage.setAttribute("src", strLocalPath);
            });
        }

        if (strWidth)
            xulImage.setAttribute("width", strWidth);

        if (strHeight)
            xulImage.setAttribute("height", strHeight);
        xulImage.setAttribute(EBToolbarDesignConsts_CT2958529.TOOLBAR_IS_RTL, EBGlobalManager_CT2958529.IsToolbarRTL());

        return xulImage;
    },

    CreateLabel: function(strValue, strStyle) {
        var xulLabel = document.createElement("label");
        if (strValue) {
            xulLabel.setAttribute("value", strValue);
        }
        if (strStyle) {
            xulLabel.setAttribute("style", strStyle);
        }
        return xulLabel;
    },

    CreateToolbarItem: function() {
        var XULToolbarItem = document.createElement("toolbaritem");
        return XULToolbarItem;
    },

    CreateToolbarSeparator: function() {
        var xulToolbarSeparator = document.createElement("toolbarseparator");
        return xulToolbarSeparator;
    },

    CreateToolbarSpring: function() {
        var xulToolbarSpring = document.createElement("toolbarspring");
        return xulToolbarSpring;
    },

    CreateSeparator: function(strClass) {
        var xulSeparator = document.createElement("separator");

        if (strClass) {
            xulSeparator.setAttribute("class", strClass);
        }
        return xulSeparator;
    },

    CreateTooltip: function(strID, strOrient, strOnPopupShowing) {
        var XULTooltip = document.createElement("tooltip");

        if (strID) {
            XULTooltip.setAttribute("id", strID);
        }

        if (strOrient) {
            XULTooltip.setAttribute("orient", strOrient);
        }

        if (strOnPopupShowing) {
            XULTooltip.setAttribute('onpopupshowing', strOnPopupShowing);
        }

        return XULTooltip;
    },

    SetAttributes: function(objElement, arrAttributes) {
        if (!arrAttributes || arrAttributes.length == 0) return;

        var attrPair = null;
        for (var i = 0; i < arrAttributes.length; i++) {
            attrPair = arrAttributes[i];
            objElement.setAttribute(attrPair[0], attrPair[1]);
        }
    },

    CreateElement: function(tagName, innerHTML, arrAttributesList, onclickCallback) {
        var xulElement = document.createElement(tagName);
        if (innerHTML)
            xulElement.appendChild(document.createTextNode(innerHTML));

        if (onclickCallback)
            xulElement.addEventListener("click", onclickCallback, false);

        this.SetAttributes(xulElement, arrAttributesList);
        return xulElement;
    }
};

function ExtensionsDialogManager_CT2958529(addOnsDialog) {
    var _uninstallEngineDialogPath = "chrome://browsersearch/content/uninstallEngine.xul";
    var _uninstallEngineDialogName = "EBUninstallDialog";
    var _uninstallToolbarDialogPath = "chrome://browsersearch/content/uninstallToolbar.xul";
    var _uninstallToolbarDialogName = "EBUninstallDialogToolbar";
    var firstTime = false;

    this.onload = function(e) {
        if (firstTime) return;
        firstTime = true;

        UninstallFunctions_CT2958529.setAllConduitExtentions(function(strList) {
            var originalUninstall = gExtensionsViewController.commands.cmd_uninstall;
            var uninstallWarpper = function(e) {
                if (e.id.indexOf(EBGlobalConsts_CT2958529.EngineGUID) != -1) {
                    var options = "modal,centerscreen,resizable=no";
                    window.openDialog(_uninstallEngineDialogPath, _uninstallEngineDialogName, options, addOnsDialog, strList);
                    return false;
                }
                else
                    originalUninstall(e);
            };

            gExtensionsViewController.commands.cmd_uninstall = uninstallWarpper;
        });
    };
};
function UninstallEngineDialog_CT2958529() {
    this.xulElements = {
        "itemsContainer": null,
        "radKeep": null,
        "radUninstall": null,
        "lblTitle": null,
        "btnCancel": null,
        "btnAccept": null,
        "noAppsTextContainer": null
    };

    var mListToolbarsGuids = null;
    var mAppsCounter;
    var mCheckedBoxCounter = 0;
    var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow(true);
    var strToolbarImageDefault = "chrome://browsersearch/skin/uninstall/uninstall_Toolbar.png";

    this.uninstall = function(arrToolbarsToUninstall, checkedAppsCounter) {
        //uninstall engine and all existing toolbars
        if (!arrToolbarsToUninstall) {
            EBGlobalManager_CT2958529.UninstallExtension(EBGlobalConsts_CT2958529.EngineGUID);
            DualPackageFunctions_CT2958529.setEngineOwner("", "", "");
            for (var j = 0; j < mListToolbarsGuids.length; j++)
                EBGlobalManager_CT2958529.UninstallExtension(mListToolbarsGuids[j]);
        }
        else {   //uninstall some toolbars
            UninstallFunctions_CT2958529.getNumberOfConduitExtentions(function(strList) {
                EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.KeepEngineInstalled, strList == 1 ? false : true);
                for (var i = 0; i < arrToolbarsToUninstall.length; i++)
                    EBGlobalManager_CT2958529.UninstallExtension(arrToolbarsToUninstall[i]);
            });
        }
    };

    this.acceptChanges = function() {
        var checkBox = null;
        var item = null;

        var itemsHash = oWindow.DualPackageFunctions_CT2958529.isEngineInDualPackage() ? this.mainWindow.oToolbar_CT2958529.toolbar.getEngineManager().data.myStuffItemsHash :
                                            this.mainWindow.oToolbarManager_CT2958529.data.myStuffItemsHash;
        var isChanged = false;
        var positionsHash = new EBArrayHashObject_CT2958529();
        var arrToolbarsToUninstall = new Array();
        var checkedAppsCounter = 0;

        try {
            for (var i = 0; i < this.xulElements.itemsContainer.childNodes.length - 1; i++) {
                checkBox = this.xulElements.itemsContainer.getItemAtIndex(i).firstChild;

                item = itemsHash.GetByID(checkBox.getAttribute("compId"));
                if (item) {
                    //if item is unchecked, then it remains
                    if (!parseBool(checkBox.getAttribute("checked"))) {
                        positionsHash.Add(item.UniqueCompID, item.UniqueCompID);
                    }
                    else {
                        isChanged = true;
                        checkedAppsCounter++;
                    }
                }
                else {
                    checkBox = this.xulElements.itemsContainer.getItemAtIndex(i).firstChild;
                    if (parseBool(checkBox.getAttribute("checked"))) {
                        var strToolbarGuid = checkBox.getAttribute("compId");
                        arrToolbarsToUninstall.push(strToolbarGuid);
                    }
                }
            }
        }
        catch (e) {
            EBLog(e);
        }

        if (isChanged) {
            oWindow.oToolbar_CT2958529.toolbar.getEngineManager().updateMyStuffComponents(positionsHash);
            if (oWindow)
                oWindow.setTimeout(function() {oWindow.oToolbar_CT2958529.toolbar.getEngineManager()._loadMyStuffComponents(true); }, 1);
        }

        if (arrToolbarsToUninstall.length > 0) {
            this.uninstall(arrToolbarsToUninstall, checkedAppsCounter);
            var addOnsDialog = window.arguments[0];
            if (!EBGlobalManager_CT2958529.IsFirefox4())
                addOnsDialog.enableRestartButton();
        }
         if (EBGlobalManager_CT2958529.IsFirefox4())
            this.cancelUninstall();
    };

    this.getComponentBox = function(compId, imageUrl, label, isChecked, isEngine) {
        var self = this;
        var objListItem = EBXULFactory_CT2958529.CreateElement("listitem", null, [["allowevents", "true"], ["style", "height:26px; width:56px;"]], null);
        var objCheckBox = EBXULFactory_CT2958529.CreateElement("listcell", null,
                [["type", "checkbox"], ["checked", isChecked], ["compId", compId], ["style", "-moz-padding-start:15px;"]],
                function(e) {
                    var isChecked = EBGlobalManager_CT2958529.GetBooleanAttribute(this, "checked");
                    this.setAttribute("checked", !isChecked);
                });
        objCheckBox.addEventListener("click", function(event) { self.changeRemoveButton(objCheckBox.getAttribute("checked")); }, false);
        var objTextImage = EBXULFactory_CT2958529.CreateElement("listcell", null,
                                                                [["image", imageUrl], ["disable", "true"], ["label", label], ["class", "listcell-iconic eb-listcell-iconic_CT2958529"]], null);

        objListItem.appendChild(objCheckBox);
        objListItem.appendChild(objTextImage);
        return objListItem;
    };

    this.changeRemoveButton = function(isChecked) {
        if (isChecked == "true")
            mCheckedBoxCounter++;
        else mCheckedBoxCounter--;

        if (mCheckedBoxCounter > 0)
            this.xulElements.btnAccept.setAttribute("disabled", "false");
        else this.xulElements.btnAccept.setAttribute("disabled", "true");
    };
 
    this.onRadioChange = function(id) {
        this.enableDisableRemoveApps(id == "radKeep");
    };

    this.enableDisableRemoveApps = function(enable) {
        if (enable) {
            this.xulElements.btnAccept.setAttribute("disabled", "true");
            this.xulElements.itemsContainer.disabled = false;
            for (var i = 0; i < this.xulElements.itemsContainer.childNodes.length; i++) {
                this.xulElements.itemsContainer.childNodes[i].firstChild.setAttribute("disabled", false);
                this.xulElements.itemsContainer.childNodes[i].setAttribute("allowevents", true);
                this.xulElements.itemsContainer.childNodes[i].childNodes[1].style.opacity = "1";
            }

        }
        else {
            this.xulElements.btnAccept.setAttribute("disabled", "false");
            this.xulElements.itemsContainer.disabled = true;
            for (var i = 0; i < this.xulElements.itemsContainer.childNodes.length; i++) {
                this.xulElements.itemsContainer.childNodes[i].firstChild.setAttribute("disabled", true);
                this.xulElements.itemsContainer.childNodes[i].setAttribute("allowevents", false);
                this.xulElements.itemsContainer.childNodes[i].childNodes[1].style.opacity = "0.5";
            }
        }
    };

    this.handleCheckAllCheckbox = function() {
        var hasUnCheckedCheckboxes = false;
        var checkedState = null;
        for (var i = 1; i < this.xulElements.itemsContainer.childNodes.length; i++) {
            if (this.xulElements.itemsContainer.getItemAtIndex(i)) {
                checkedState = EBGlobalManager_CT2958529.GetBooleanAttribute(this.xulElements.itemsContainer.getItemAtIndex(i).firstChild, "checked");
                if (!checkedState) {
                    hasUnCheckedCheckboxes = true;
                    break;
                }
            }
        }

        if (hasUnCheckedCheckboxes)
            this.xulElements.itemsContainer.getItemAtIndex(0).firstChild.setAttribute("checked", "false");
        else
            this.xulElements.itemsContainer.getItemAtIndex(0).firstChild.setAttribute("checked", "true");
    };

    var addRandomToName = function(strName) {
        return strName + Math.random().toString();
    };

    this.fillComponents = function() {
        var strToolbarNameAndGuid = window.arguments[1];
        var arrCTIDs;
        if (strToolbarNameAndGuid)
            arrCTIDs = strToolbarNameAndGuid.split(",");

        var manager = oWindow.oToolbar_CT2958529.toolbar.engineManager;
        var itemsHash = manager.data.myStuffItemsHash;
        var xulItemBox = null;
        var compItem = null;
        var bHaveComponents = false;

        var appsHash = new EBSortHash_CT2958529();
        var nameLessAppsArray = new Array();

        //handle toolbars
        if (arrCTIDs) {
            for (var j = 0; j < arrCTIDs.length; j++) {
                var arrSingleToolbar = arrCTIDs[j].split(":");
                var strToolbarGUID = arrSingleToolbar[0].substring(1, arrSingleToolbar[0].length - 1);
                var strToolbarName = arrSingleToolbar[1].substring(1, arrSingleToolbar[1].length - 1);
                mListToolbarsGuids.push(strToolbarGUID);

                xulItemBox = this.getComponentBox(strToolbarGUID, strToolbarImageDefault, strToolbarName, false, false);
                appsHash.Add(strToolbarName, xulItemBox);
                bHaveComponents = true;
            }
        }
        //handle engine
        if (itemsHash) {
            var imageUrl = "";
            for (var i = 0; i < itemsHash.Count(); i++) {
                compItem = itemsHash.GetByIndex(i);
                if (compItem.Permission == this.mainWindow.oToolbar_CT2958529.toolbarDataParsing.Editable.FULL) {
                    imageUrl = (compItem.appInfo.imageUrl) ? compItem.appInfo.imageUrl : compItem.compThumbnailUrl;
                    var strDisplayText = compItem.DisplayText ? compItem.DisplayText : compItem.compName;
                    xulItemBox = this.getComponentBox(compItem.UniqueCompID, imageUrl, strDisplayText, false, true);
                    if (!strDisplayText)
                        nameLessAppsArray.push(xulItemBox);
                    else
                        appsHash.Add(addRandomToName(strDisplayText), xulItemBox);

                    bHaveComponents = true;
                    mAppsCounter++;
                }
            }
        }
        //for nameless apps
        for (var a = 0; a < nameLessAppsArray.length; a++)
            this.xulElements.itemsContainer.appendChild(nameLessAppsArray[a]);

        var sortedValsArr = appsHash.getSortedValuesArray();
        for (var c = 0; c < sortedValsArr.length; c++)
            this.xulElements.itemsContainer.appendChild(sortedValsArr[c]);

        if (bHaveComponents) {
            this.xulElements.itemsContainer.style.display = "";
            this.xulElements.noAppsTextContainer.style.display = "none";
        }
        else {
            this.xulElements.radUninstall.click();
            this.xulElements.radKeep.disabled = true;

            //add no apps text
            this.xulElements.itemsContainer.style.display = "none"
            this.xulElements.noAppsTextContainer.style.display = "";
            this.xulElements.noAppsTextContainer.innerHTML = oWindow.oToolbarManager_CT2958529.getLPKey("CELP_STR_ID_ENGINE_UNINSTALL_NO_APPS_TEXT");
        }
    };

    this._onload = function(e) {
        mAppsCounter = 0;
        mListToolbarsGuids = new Array();
        this.fillComponents();
        this.applyLP();
    };

    this._onunload = function(e) { };

    this.onaccept = function(e) {
        try {
            if (this.xulElements.radUninstall.selected) {
                this.uninstall(null);
                if (!EBGlobalManager_CT2958529.IsFirefox4()) {
                    var addOnsDialog = window.arguments[0];
                    addOnsDialog.enableRestartButton();
                }
                else {
                    var mainWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
                    mainWindow.EBUninstallManager_CT2958529.PostUninstallToolbar();
                }
            }
            else {
                this.acceptChanges();
            }
        } catch (ex) { EBLog(ex); }

        window.close();
    };
    
    this.cancelUninstall = function() {
        if (EBGlobalManager_CT2958529.IsFirefox4()) {
            var self = this;
            Components.utils.import("resource://gre/modules/AddonManager.jsm");
            AddonManager.getAddonByID(EBGlobalConsts_CT2958529.EngineGUID, function(addon) {
                oWindow.addOnlistener_CT2958529.onOperationCancelled(addon);
                });
        } 
    };
    
    this.applyLP = function() {
        var toolbarManager = oWindow.oToolbarManager_CT2958529 ? oWindow.oToolbarManager_CT2958529 : window["oToolbarManager_" + EBGlobalConsts_CT2958529.EngineCTID];
        this.xulElements.lblTitle.value = toolbarManager.getLPKey("CELP_STR_ID_ENGINE_UNINSTALLER_HEADER");
        this.xulElements.radKeep.setAttribute("label", toolbarManager.getLPKey("CELP_STR_ID_ENGINE_UNINSTALL_REMOVE_COMPONENT"));
        this.xulElements.radUninstall.setAttribute("label", toolbarManager.getLPKey("CELP_STR_ID_ENGINE_UNINSTALL_REMOVE_ALL_MY_COMPONENT"));
        this.xulElements.btnAccept.setAttribute("label", toolbarManager.getLPKey("CELP_STR_ID_ENGINE_UNINSTALL_OK_BUTTON"));
        this.xulElements.btnCancel.setAttribute("label", toolbarManager.getLPKey("CELP_STR_ID_ENGINE_UNINSTALL_CANCEL_BUTTON"));
    };
};

UninstallEngineDialog_CT2958529.prototype = new BaseDialogManager_CT2958529();
UninstallEngineDialog_CT2958529.constructor = UninstallEngineDialog_CT2958529();

var UninstallFunctions_CT2958529 =
{
    mStrConduitExtentions: "",
    
    setAllConduitExtentions: function(callback) { 
        //ff 4
        if (EBGlobalManager_CT2958529.IsFirefox4()) {
            Components.utils.import("resource://gre/modules/AddonManager.jsm");
            AddonManager.getAllAddons(function(arrAddons) {
                var strToolbarListRes = "";
                for(var i = 0; i<arrAddons.length; i++) {
                    if (arrAddons[i].creator!=null) {
                        var isConduitLtd = arrAddons[i].creator.toString().indexOf("Conduit") != -1 ? true: false;
                        var id = arrAddons[i].id;
                        var name = arrAddons[i].name;
                        var engineDependOnToolbarkey = EBPreferenceConsts_CT2958529.EngineDependOnToolbar+"."+id.substring(1,id.length-1);
                        if ((isConduitLtd) && (name!="Conduit Engine") && (EBGlobalPreferenceManager_CT2958529.HasUserValue(engineDependOnToolbarkey))) {
                            if (strToolbarListRes!="")
                                strToolbarListRes += ",";
                            strToolbarListRes += id + ":" + name;
                        }
                    }
                }
                callback(strToolbarListRes);
                });                
        }
        //ff 3-3.6
        else {
            var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]  
                                .getService(Components.interfaces.nsIExtensionManager);
            var itemList = gExtensionManager.getItemList(Components.interfaces.nsIUpdateItem.TYPE_EXTENSION, {});
            var arrID = new Array();
            var arrName = new Array();
            for (var [key, value] in Iterator(itemList)) {
                var arrExt = value.objectSource.substring(2,value.objectSource.length-2).split(",");
                var id= "";
                var name= "";
                var isConduitLtd = value.objectSource.indexOf("conduit") != -1 ? true: false;
               
                if(isConduitLtd){          
                    for(var i = 0; i< arrExt.length; i++){
                        var strAtt = arrExt[i].split(":");
                        if(strAtt[0].indexOf("id")!=-1 && strAtt[1].indexOf("{")!=-1 && strAtt[1].indexOf("}")!=-1)
                            id = strAtt[1]; 
                        if(strAtt[0].indexOf("name")!=-1 &&  strAtt[1].indexOf("Toolbar")!=-1)
                            name = strAtt[1]; 
                            
                        var engineDependOnToolbarkey = EBPreferenceConsts_CT2958529.EngineDependOnToolbar+"."+id.substring(1,id.length-1);
                        if((i== arrExt.length-1) && id && name && EBGlobalPreferenceManager_CT2958529.HasUserValue(engineDependOnToolbarkey)){
                          arrID.push(id);
                          arrName.push(name);
                        }
                     }
                 }
            }
                    
          
            var strToolbarsList3="";
            for(var j=0;j<arrID.length;j++){
                strToolbarsList3 += arrID[j]+":"+arrName[j];
                if(j != arrID.length-1)
                   strToolbarsList3 += ",";
            }
        
            this.mStrConduitExtentions = strToolbarsList3;  
            callback(strToolbarsList3);
        }
    },
    
    getNumberOfConduitExtentions: function(callback) {
        if(!this.mStrConduitExtentions){
            this.setAllConduitExtentions(function(strToolbarsList) {
                if(!strToolbarsList) {
                    callback(0);
                    return;
                } 
            });
        }
        callback(this.mStrConduitExtentions.split(",").length);
    }
};
var addOnlistener_CT2958529 = 
{
  
    
    onUninstalling: function(addon) {
        var _uninstallEngineDialogPath = "chrome://browsersearch/content/uninstallEngine.xul";
        var _uninstallEngineDialogName = "EBUninstallDialog";
        var _uninstallToolbarDialogPath = "chrome://browsersearch/content/uninstallToolbar.xul";
        var _uninstallToolbarDialogName = "EBUninstallDialogToolbar";
        //toolbar
        if(!EBGlobalConsts_CT2958529.IsEngine && addon.id == EBGlobalConsts_CT2958529.GUID) {
                EBLogging_CT2958529.LogToConsole("Initiate uninstall sequence: CT2958529");
                EBUninstallManager_CT2958529.PostUninstallToolbar();
        }
        //engine
        else 
            if(EBGlobalConsts_CT2958529.IsEngine && addon.id == EBGlobalConsts_CT2958529.EngineGUID){
                UninstallFunctions_CT2958529.setAllConduitExtentions(function(strList) {
                    if (window.removeEngineWithNoDialog) {
                        window.removeEngineWithNoDialog = false;
                        EBUninstallManager_CT2958529.PostUninstallToolbar();
                        return false;
                    }
                    else {
                        var options = "centerscreen,resizable=no";
                        var addOnsDialog = null;
                        setTimeout(function(){ 
                            window.openDialog(_uninstallEngineDialogPath, _uninstallEngineDialogName, options, addOnsDialog, strList);
                        },1);
                        return false;
                    }
                });
            }
    },
  
    onOperationCancelled: function(addon) {
        addon.cancelUninstall();
        EBLogging_CT2958529.LogToConsole("Uninstall sequence canceled");
        EBUninstallManager_CT2958529.CancelUninstall();
    }
};

var UninstallListenerFF4_CT2958529 =
{
    register: function() {
        Components.utils.import("resource://gre/modules/AddonManager.jsm");
        AddonManager.addAddonListener();
        try {
          Components.utils.import("resource://gre/modules/AddonManager.jsm");
          AddonManager.addAddonListener(addOnlistener_CT2958529);
        } catch (ex) {} 
    },
    
    unregister: function() {
        Components.utils.import("resource://gre/modules/AddonManager.jsm");
        AddonManager.addAddonListener();
        try {
          Components.utils.import("resource://gre/modules/AddonManager.jsm");
          AddonManager.removeAddonListener(addOnlistener_CT2958529);
        } catch (ex) {} 
    }   
};
var EBUninstallManager_CT2958529 =
{
    keepAndHideEngine: false,
    keepEngineInstalled: false,
    
    IsShowUninstallPage: function() {
        var bValue;

        if (EBToolbarPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.IsOpenUninstallPage))
            bValue = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.IsOpenUninstallPage)
        else
            bValue = EBGlobalConsts_CT2958529.ShowUninstallPage;

        return bValue;
    },

    GetUninstallURL: function() {
        var strAdditional = 'Uninstall/?version=' + EBGlobalConsts_CT2958529.Version + '&platform=firefox';

        var strUninstallURL = EBGlobalConsts_CT2958529.IsEngine ? oToolbarManager_CT2958529.data.settings.enginePages.uninstall : EBActionManager_CT2958529.GetWebServerURL(strAdditional);
        return strUninstallURL;

    },

    //set this pref key when uninstall the toolbar in order to clear all
    //the toolbar data when the window is closing!
    SetUninstallPreference: function() {
        EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.Uninstall, true);
    },

    RemoveUninstallPreference: function() {
        if (EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Uninstall)) {
            EBToolbarPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.Uninstall, false);
        }
    },

    //check if it is uninstall mode with the pref uninstall key:
    IsUninstall: function() {
        var strUninstallPrefName = EBPreferenceConsts_CT2958529.Uninstall;
        return EBToolbarPreferenceManager_CT2958529.HasUserValue(strUninstallPrefName) && EBToolbarPreferenceManager_CT2958529.GetPref(strUninstallPrefName);
    },
    
    CleanDupData: function () {
        if (!EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.engineOwnerCTID() == EBGlobalConsts_CT2958529.ToolbarCTID) {
            DualPackageFunctions_CT2958529.setEngineOwner("", "", "");
            if (this.keepEngineInstalled) {
                DualPackageFunctions_CT2958529.setEngineOwner(EBGlobalConsts_CT2958529.EngineCTID, EBGlobalConsts_CT2958529.ConduitEngineName, EBGlobalConsts_CT2958529.EngineGUID);
            }
        }
        if (EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.KeepEngineInstalled))
            EBGlobalPreferenceManager_CT2958529.SetPref(EBPreferenceConsts_CT2958529.KeepEngineInstalled, false);    
    },

    ClearToolbarData: function() {
        this.CleanDupData();
        
        if (EBGlobalConsts_CT2958529.IsAMO)
            this.ResetToDefaults();

        //clear all preferences:
        EBToolbarPreferenceManager_CT2958529.ClearAll();

        //remove toolbar main directory
        EBIOManager_CT2958529.DeleteToolbarDirectory();

        //remove suggest file with it's directory
        EBIOManager_CT2958529.DeleteSuggestDirectory();

        //update installed toolbars count
        this.RemoveMeFromInstalledToolbarsList(EBPreferenceConsts_CT2958529.ToolbarsList);
    },

    PostUninstallToolbar: function() {

        var isSingleMystuffToolbar = function() {
            var strCTIDs = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.ToolbarsList);
            var arrCTIDs = strCTIDs.split(",");
            var numOfMystuffToolbars = 0;
            for (var i = 0; i < arrCTIDs.length; i++) {
                if (arrCTIDs[i] != EBGlobalConsts_CT2958529.EngineCTID) {
                    var strKeyToCheck = arrCTIDs[i] + ".myStuffEnabled";
                    if (EBPreferenceService_CT2958529.GetPref(strKeyToCheck)) {
                        if (oToolbar_CT2958529.dualPackageFuncs.isToolbarMyStuffEnable(arrCTIDs[i])) {
                            numOfMystuffToolbars++;
                        }
                    }
                }
            }
            return numOfMystuffToolbars == 1 ? true : false;
        };

        if (EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.KeepEngineInstalled)) {
            var self = this;
            UninstallFunctions_CT2958529.getNumberOfConduitExtentions(function(strList) {
                this.keepEngineInstalled = EBGlobalPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.KeepEngineInstalled) ? true : false;
                if (! this.keepEngineInstalled && strList == 1) {
                     this.keepEngineInstalled = !EBGlobalConsts_CT2958529.ForceUninstallEngineOnToolbarUninstall;
                }
                self.PostUninstallToolbarInner( this.keepEngineInstalled);
            });
        }
        //comes from toolbar uninstall dialog
        else if (!EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.engineOwnerCTID() == EBGlobalConsts_CT2958529.ToolbarCTID) {
             this.keepEngineInstalled = isSingleMystuffToolbar() ? false : true;
            this.PostUninstallToolbarInner( this.keepEngineInstalled);
        }
        else {
            this.PostUninstallToolbarInner( this.keepEngineInstalled);
        }
    },

    PostUninstallToolbarInner: function(keepEngineInstalled) {
        var additionalUninstallChecks = function(keepEngineInstalled) {


            //toolbar hidden
            if (!oToolbarManager_CT2958529) {
                EBToolbarManager_CT2958529.onload();
            }
            if (!EBGlobalConsts_CT2958529.IsEngine) {
                EBUninstallManager_CT2958529.sendUninstallLog();
            }
            else {
                oToolbarManager_CT2958529.usage.sendUninstallUsage();
                if (EBGlobalPreferenceManager_CT2958529.HasUserValue(EBPreferenceConsts_CT2958529.OriginalEngineOwner))
                    DualPackageFunctions_CT2958529.setOriginalEngineOwner("", "", "");
            }

            //set the uninstall preference
            EBUninstallManager_CT2958529.SetUninstallPreference();

            if (EBUninstallManager_CT2958529.IsShowUninstallPage()) {
                //load uninstall page
                var strUninstallURL = EBUninstallManager_CT2958529.GetUninstallURL();
                var event = { "customData": { "url": strUninstallURL, "urlTarget": "TAB", "isStayInCurrantPage": EBGlobalManager_CT2958529.IsFirefox4()} };
                setTimeout(function() { EBLinkManager_CT2958529.LoadLinkURL(event); }, 1);
            }
        };
        //if engine is kept and has no apps - hide the engine
        if (keepEngineInstalled && !EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.isToolbarInDualPackage() && DualPackageFunctions_CT2958529.isEngineInDualPackage()) {
            var engineManager = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow().oToolbar_CT2958529.toolbar.getEngineManager(null, true);
            if (engineManager && engineManager.data.myStuffDataHash.Count() == 0){
                DualPackageFunctions_CT2958529.hideShowEngineAfterRestart(true);
                }
        }
        this.RemoveMeFromInstalledToolbarsList(EBPreferenceConsts_CT2958529.CantToolbarBeEngineOwner);
        
        //uninstall engine if forced from toolbar
        if (!keepEngineInstalled && !EBGlobalConsts_CT2958529.IsEngine && DualPackageFunctions_CT2958529.isToolbarInDualPackage()) {
            //ff 4
            if (EBGlobalManager_CT2958529.IsFirefox4()) {
                Components.utils.import("resource://gre/modules/AddonManager.jsm");
                AddonManager.getAddonByID(EBGlobalConsts_CT2958529.EngineGUID, function(addon) {
                    if (addon) {
                        window.removeEngineWithNoDialog = true;
                        addon.uninstall();
                    }
                    additionalUninstallChecks(keepEngineInstalled);                    
                });
            }
            else { //ff 3-3.6
                var objExtManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
                if (objExtManager.getItemForID(EBGlobalConsts_CT2958529.EngineGUID))
                    objExtManager.uninstallItem(EBGlobalConsts_CT2958529.EngineGUID);
                additionalUninstallChecks(keepEngineInstalled);
            }
        }
        else {
            additionalUninstallChecks(keepEngineInstalled);
        }


    },

    CancelUninstall: function() {
        var originalEngineOwnerObj = DualPackageFunctions_CT2958529.originalEngineOwner();
        if (originalEngineOwnerObj.CTID == EBGlobalConsts_CT2958529.ToolbarCTID)
            DualPackageFunctions_CT2958529.setEngineOwner(originalEngineOwnerObj.CTID, originalEngineOwnerObj.ToolbarId, originalEngineOwnerObj.Guid);

        this.RemoveUninstallPreference();
    },

    sendUninstallLog: function() {
        var objData = new oToolbar_CT2958529.uninstallLog.uninstallLogDS(
                    EBGlobalConsts_CT2958529.Version,
                    EBGlobalConsts_CT2958529.ToolbarCTID,
                    EBActionManager_CT2958529.GetCTID(),
                    EBGlobalManager_CT2958529.GetOS(),
                    EBGlobalManager_CT2958529.GetBrowserNameAndVersion(),
                    EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.UserID)
                    );
        oToolbar_CT2958529.uninstallLog.manager.send(objData);
    },

    IsToClearToolbarData: function() {
        return this.IsUninstall() && EBGlobalManager_CT2958529.IsLastWindowInstance();
    },

    IsLastToolbar: function(strPrefName) {
        var strToolbarList = EBGlobalPreferenceManager_CT2958529.GetPref(strPrefName);
        return (strToolbarList) ? false : true;
    },

    RemoveMeFromInstalledToolbarsList: function(strPrefName) {
        var strToolbarList = EBGlobalPreferenceManager_CT2958529.GetPref(strPrefName);

        if (!strToolbarList) return;

        var arrToolbars = strToolbarList.split(',');

        for (var i = 0; i < arrToolbars.length; i++)
            if (arrToolbars[i] == EBGlobalConsts_CT2958529.ToolbarCTID)
            arrToolbars.splice(i, 1);

        strToolbarList = (arrToolbars.length == 0) ? '' : arrToolbars.join(',');

        EBGlobalPreferenceManager_CT2958529.SetPref(strPrefName, strToolbarList);
    },

    ClearCommonData: function() {
        EBGlobalPreferenceManager_CT2958529.ClearAll();
        oToolbarManager_CT2958529.onUninstallLast();
    },

    //after clearing the toolbar private data when the last browser closed we assure
    //that the toolbar is completley removed by closing all the remain Firefox windows:
    //like the extensions manager window
    CloseAllWindows: function() {
        var objWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var objEnumerator = objWindowsManager.getEnumerator(null);
        while (objEnumerator.hasMoreElements()) {
            var objWindow = objEnumerator.getNext();
            objWindow.close();
        }
    },

    ResetToDefaults: function() {
        //remove search engine
        try {
            var strDestPath = EBInitParams_CT2958529.getProfileSearchPluginsFolder();

            var oFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            oFile.initWithPath(strDestPath);
            oFile.appendRelativePath('conduit.xml');
            EBFileIO_CT2958529.unlink(oFile);
        }
        catch (ex) {
            EBLog(ex, "Unable to remove the search xml file");
        }

        //reset homepage
        EBInitParams_CT2958529.ResetHomepage();
    }
};


var EBUsageAllInOne_CT2958529 =
{
    OnAIOClick: function(elementId, strCompType) {
        var strActionType = 'AIO_CLICK';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    }
};

var EBUsageBrowserComponent_CT2958529 =
{
    OnClick: function(strCompId, event, strCompType, strSessonLength) {
        var strAncestorId = strCompId;
        var strElementId = '';
        if (event && event.target && event.target.id)
            strElementId = event.target.id;

        var strActionType = 'BROWSER_COMPONENT_SESSION_CLICK';
        var jsonUsageDataArray = [["sessionLengthInSeconds", strSessonLength]];
        if (strElementId)
            jsonUsageDataArray.push(["elementID", EBXML_CT2958529.ToLegalXML(strElementId)]);
        
        oToolbarManager_CT2958529.usage.sendComponentUsage(strCompId, strActionType, jsonUsageDataArray);
    }
};
var EBUsageButton_CT2958529 =
{
    OpenMenu: false,

    OnButtonClick: function(elementId, strCompType) {
        var compId = elementId;
        var strActionType = 'BUTTON_CLICK';
        
        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnOpenMenu: function() {
        this.OpenMenu = true;
    },

    OnCloseMenu: function(elementId, strCompType) {
        if (!this.OpenMenu) return;

        this.OpenMenu = false;
        var strActionType = 'BUTTON_MENU_OPEN_MENU';
        var compId = elementId;
        
        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnMenuButtonClick: function(elementId, strCompType) {
        var compId = elementId;
        var strActionType = 'BUTTON_MENU_BTN_CLICK';
        
        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnItemClick: function(compId, elementId, strCompType) {
        this.OpenMenu = false;
        var strActionType = 'BUTTON_MENU_ITEM_CLICK';

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    }
};
var EBUsageChat_CT2958529 =
{
    SourceButton: 'Button',
    SourceMenu: 'Menu',
    OpenMenu: false,

    OnClickInside: function(compId, elementId, event, strUrl, ourRoomId, strCompType) {
        var strElementId = '';
        if (event && event.target && event.target.id)
            strElementId = event.target.id;

        var strActionType = 'CHAT_ROOM_FIRST_CLICK';

        var jsonUsageDataArray = new Array();

        jsonUsageDataArray.push(["chatRoomUrl", strUrl]);
        if (ourRoomId)
            jsonUsageDataArray.push(["roomId", ourRoomId]);
        if (strElementId)
            jsonUsageDataArray.push(["elementId", strElementId]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, compId);
    },

    OnOpen: function(compId, elementId, strUrl, strSource, ourRoomId, strCompType) {
        this.OpenMenu = false;
        var strActionType = 'CHAT_ROOM_OPEN';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["sourceCompType", strSource]);
        if (ourRoomId)
            jsonUsageDataArray.push(["roomId", ourRoomId]);
        if (strUrl)
            jsonUsageDataArray.push(["chatRoomUrl", strUrl]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    Close: function(compId, elementId, strUrl, ourRoomId, iDuration, strCompType) {
        var strActionType = 'CHAT_ROOM_CLOSE';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["chatRoomUrl", strUrl]);
        jsonUsageDataArray.push(["durationSec", iDuration]);
        if (ourRoomId)
            jsonUsageDataArray.push(["roomId", ourRoomId]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    OnOpenMenu: function() {
        this.OpenMenu = true;
    },

    OnCloseMenu: function(compId, elementId, strCompType) {
        if (!this.OpenMenu) return;
        this.OpenMenu = false;

        var strActionType = 'CHAT_OPEN_MENU';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    }
};

var EBUsageChevron_CT2958529 =
{
    Open: function(isMyStuff, strCompType) {
        oToolbarManager_CT2958529.usage.sendContainerUsage("CHEVRON_OPEN_MENU");
    }
};
var EBUsageComponentContextMenu_CT2958529 =
{
    OpenMenu: false,

    OnOpenMenu: function() {
        this.OpenMenu = true;
    },

    OnCloseMenu: function(elementId, strCompType, event) {
        if (!this.OpenMenu)
            return;

        this.OpenMenu = false;
        var strActionType = EBGlobalConsts_CT2958529.IsEngine ? 'ENGINE_CONTEXT_MENU_OPEN' : 'PUBLISHER_CONTEXT_MENU_OPEN';
        var compId = elementId;
        oToolbarManager_CT2958529.usage.sendContainerUsage(strActionType, event.target.contextComponentId, null);
    },

    OnItemClick: function(compId, elementId, strCompType, event) {
        this.OpenMenu = false;
        var strActionType = EBGlobalConsts_CT2958529.IsEngine ? 'ENGINE_CONTEXT_MENU_ITEM_CLICK' : 'PUBLISHER_CONTEXT_MENU_ITEM_CLICK';
        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["elementId", elementId]);
        oToolbarManager_CT2958529.usage.sendContainerUsage(strActionType, event.target.contextComponentId, jsonUsageDataArray);
    },

    OnMenuButtonClick: function(elementId, strCompType) { },

    OnItemShowHideClick: function(strClickedComponentId, strClickedAppGUID, event, isShow) {
        this.OpenMenu = false;
        var strActionType = EBGlobalConsts_CT2958529.IsEngine ? 'ENGINE_CONTEXT_MENU_ITEM_CLICK' : 'PUBLISHER_CONTEXT_MENU_ITEM_CLICK';
        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["clickedComponentId", strClickedComponentId]);

        if (EBGlobalConsts_CT2958529.IsEngine && strClickedAppGUID)
            jsonUsageDataArray.push(["clickedAppGUID", strClickedAppGUID]);

        jsonUsageDataArray.push(["show", isShow]);

        if (EBGlobalConsts_CT2958529.IsEngine)
            oToolbarManager_CT2958529.usage.sendContainerUsage(strActionType, event.target.contextComponentId, jsonUsageDataArray);
        else oToolbarManager_CT2958529.usage.sendContainerUsage(strActionType, jsonUsageDataArray);
    }
}
    
var EBUsageEmailNotifier_CT2958529 =
{
    OpenMenu: false,

    OnMenuOpen: function() {
        this.OpenMenu = true;
    },

    OnMenuClose: function(strCompType) {
        strCompType = "";
        //if other action was performed, do not send usage.
        if (!this.OpenMenu)
            return;

        this.OpenMenu = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var strActionType = 'EMAILNOTIFY_OPEN_MENU';

        var jsonUsageDataArray = [["numberOfAccounts", EBEMailNotifierToolbarManager_CT2958529.MailAccountsCollection.Arr.length]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, jsonUsageDataArray);
    },

    OnAccountOpen: function(strCompType) {
        this.OpenMenu = false;
        strCompType = "";

        var compId = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var strActionType = 'EMAILNOTIFY_OPEN_ACCOUNT';
        var source = "MENU";

        var jsonUsageDataArray = [["numberOfAccounts", EBEMailNotifierToolbarManager_CT2958529.MailAccountsCollection.Arr.length], ["source", source]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, jsonUsageDataArray);
    },

    OnCheckForNewEmails: function(strCompType) {
        this.OpenMenu = false;
        strCompType = "";

        var compId = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var strActionType = 'EMAILNOTIFY_CHECK';

        var jsonUsageDataArray = [["numberOfAccounts", EBEMailNotifierToolbarManager_CT2958529.MailAccountsCollection.Arr.length]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, jsonUsageDataArray);
    },

    OnClickToolbarOptions: function(strCompType) {
        this.OpenMenu = false;
        strCompType = "";

        var compId = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var strActionType = 'EMAILNOTIFY_TB_OPTIONS';

        var jsonUsageDataArray = [["numberOfAccounts", EBEMailNotifierToolbarManager_CT2958529.MailAccountsCollection.Arr.length]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, jsonUsageDataArray);
    },

    OnClickFeedback: function(strCompType) {
        this.OpenMenu = false;
        strCompType = "";

        var compId = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.EMailNotifier;
        var strActionType = 'EMAILNOTIFY_FEEDBACK';

        var jsonUsageDataArray = [["numberOfAccounts", EBEMailNotifierToolbarManager_CT2958529.MailAccountsCollection.Arr.length]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, jsonUsageDataArray);
    }
};
var EBUsageEngineContextMenu_CT2958529 =
{
    OpenMenu: false,

    OnOpenMenu: function() {
        this.OpenMenu = true;
    },

    OnCloseMenu: function(elementId, strCompType) {
        if (!this.OpenMenu)
            return;

        this.OpenMenu = false;
        var strActionType = 'ENGINE_OPEN_MENU';
        var compId = elementId;

        oToolbarManager_CT2958529.usage.sendContainerUsage(strActionType, null, null);
    },

    OnItemClick: function(compId, elementId, strCompType) {
        this.OpenMenu = false;
        var strActionType = 'ENGINE_MENU_ITEM_CLICK';
        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["elementId", elementId]);
        oToolbarManager_CT2958529.usage.sendContainerUsage(strActionType, null, jsonUsageDataArray);
    },

    OnMenuButtonClick: function(elementId, strCompType) { },

    OnItemShowHideClick: function(strClickedComponentId, strClickedAppGUID, event, isShow) {
        this.OpenMenu = false;
        var strActionType = EBGlobalConsts_CT2958529.IsEngine ? 'ENGINE_CONTEXT_MENU_ITEM_CLICK' : 'PUBLISHER_CONTEXT_MENU_ITEM_CLICK';
        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["clickedComponentId", strClickedComponentId]);
        jsonUsageDataArray.push(["clickedAppGUID", strClickedAppGUID]);
        jsonUsageDataArray.push(["show", isShow]);
        oToolbarManager_CT2958529.usage.sendContainerUsage(strActionType, null, jsonUsageDataArray);
    }
};
var EBUsageFacebook_CT2958529 =
{
    OpenMenu: false,

    OnButtonClick: function(elementId, strCompType) {
        var compId = elementId;
        var strActionType = 'BUTTON_CLICK';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnOpenMenu: function() {
        this.OpenMenu = true;
    },

    OnCloseMenu: function(elementId, strCompType) {
        if (!this.OpenMenu)
            return;

        this.OpenMenu = false;
        var strActionType = 'BUTTON_MENU_OPEN_MENU';
        var compId = elementId;

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnMenuButtonClick: function(elementId, strCompType) {
        var compId = elementId;
        var strActionType = 'BUTTON_MENU_BTN_CLICK';
        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnItemClick: function(compId, elementId, strCompType) {
        this.OpenMenu = false;
        var strActionType = 'BUTTON_MENU_ITEM_CLICK';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnLoginGadgetOpen: function(compId, elementId, strCompType) {
        var strActionType = 'FB_GADGET_LOGIN_OPEN';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnLoginGadgetClose: function(compId, elementId, strCompType, status) {
        var strActionType = 'FB_GADGET_LOGIN_CLOSE';
        var jsonUsageDataArray = [["status", status]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    OnSetStatusPermGadgetOpen: function(compId, elementId, strCompType) {
        var strActionType = 'FB_GADGET_STATUS_PERM_OPEN';

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnSetStatusPermGadgetClose: function(compId, elementId, strCompType, status) {
        var strActionType = 'FB_GADGET_STATUS_PERM_CLOSE';
        var jsonUsageDataArray = [["status", status]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    OnSetStatusGadgetShow: function(compId, elementId, strCompType) {
        var strActionType = 'FB_GADGET_SET_STATUS_SHOW';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnSetStatusGadgetOpen: function(compId, elementId, strCompType) {
        var strActionType = 'FB_GADGET_SET_STATUS_OPEN';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },
    OnSetStatusGadgetClear: function(compId, elementId, strCompType) {
        var strActionType = 'FB_GADGET_SET_STATUS_CLEAR';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnSetStatusGadgetClose: function(compId, elementId, strCompType, status) {
        var strActionType = 'FB_GADGET_SET_STATUS_CLOSE';
        var jsonUsageDataArray = [["status", status]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    OnShareGadgetOpen: function(compId, elementId, strCompType) {
        var strActionType = 'FB_GADGET_SHARE_OPEN';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnShareGadgetClose: function(compId, elementId, strCompType) {
        var strActionType = 'FB_GADGET_SHARE_CLOSE';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnReadMailboxPermGadgetOpen: function(compId, elementId, strCompType) {
        var strActionType = 'FB_GADGET_INBOX_PERM_SHOW';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnReadMailboxPermGadgetClose: function(compId, elementId, strCompType, status) {
        var strActionType = 'FB_GADGET_INBOX_PERM_CLOSE';
        var jsonUsageDataArray = [["status", status]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    }
};
var EBUsageGadget_CT2958529 =
{
    SourceApi: 'Api',
    SourceButton: 'Button',
    SourceMenu: 'Menu',
    SourceBC: 'BC',
    SourceTooltip: 'Tooltip',
    Other: 'Other',

    GadgetTypes:
    {
        Gadget: 'GADGET',
        MiniUpage: 'MINI_UPAGE',
        MiniUpageGadget: 'MINI_UPAGE_GADGET',
        Chat: 'Chat'
    },

    OnClickInside: function(compId, elementId, event, strSource, strGadgetType, strUrl, strCompType) {
        var strElementId = '';
        if (event && event.target && event.target.id)
            strElementId = event.target.id;

        var strActionType = 'GADGET_FIRST_CLICK';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["sourceCompType", strSource]);
        jsonUsageDataArray.push(["gadgetType", strGadgetType]);
        jsonUsageDataArray.push(["gadgetUrl", strUrl]);
        if (strElementId)
            jsonUsageDataArray.push(["elementId", strElementId]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    OnOpen: function(compId, elementId, strUrl, strSource, strGadgetType, strCompType) {
        var strActionType = 'GADGET_OPEN';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["sourceCompType", strSource]);
        jsonUsageDataArray.push(["gadgetType", strGadgetType]);
        jsonUsageDataArray.push(["gadgetUrl", strUrl]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    Close: function(compId, elementId, strUrl, strSource, strGadgetType, iDuration, strCompType) {
        var strActionType = 'GADGET_CLOSE';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["sourceCompType", strSource]);
        jsonUsageDataArray.push(["gadgetType", strGadgetType]);
        jsonUsageDataArray.push(["gadgetUrl", strUrl]);
        jsonUsageDataArray.push(["durationSec", iDuration]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    Edit: function(compId, elementId, strSource, strGadgetType, strCompType) {
        var strActionType = 'GADGET_EDIT';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["sourceCompType", strSource]);
        jsonUsageDataArray.push(["gadgetType", strGadgetType]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    }
};
var EBUsageHighlighter_CT2958529 =
{
    OnClick: function(bIsHighLighting, strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Highlighter;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Highlighter;
        var strActionType;

        if (bIsHighLighting)
            strActionType = 'HIGHLIGHTER_CLICK';
        else
            strActionType = 'HIGHLIGHTER_UNHIGHLIGHT';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnClickWord: function(strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Highlighter;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Highlighter;
        var strActionType = 'HIGHLIGHTER_FIND_WORD';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    }
};
var EBUsageMyConduit_CT2958529 =
{
    DetectStartTimeStamp: null,
    PopupDialogTimeStamp: null,
    OpenDropDownMenu: false,

    SourceMenu: 'Menu',
    SourceTooltip: 'Tooltip',
    SourceMessageBox: 'MessageBox',
    SourceApi: 'Api',

    ExitCodeCancel: 'Cancel',
    ExitCodeOK: 'OK',

    ToolbarDetected: function() {
        this.DetectStartTimeStamp = Date.parse(Date());
    },

    PopupShown: function() {
        this.PopupDialogTimeStamp = Date.parse(Date());
    },

    OnOpenDropDownMenu: function() {
        this.OpenDropDownMenu = true;
    },

    OnCloseDropDownMenu: function(iNumberOfToolbarsInMenu, strCompType) {
        strCompType = "";
        //if other action was performed, do not send usage.
        if (!this.OpenDropDownMenu)
            return;

        this.OpenDropDownMenu = false;
        var strCompId = oToolbarManager_CT2958529.data.componentsIds.MultiCommunity;
        var strActionType = 'MYCONDUIT_OPEN_MENU';

        oToolbarManager_CT2958529.usage.sendComponentUsage(strCompId, strActionType, [["NUMBER_OF_TOOLBARS", iNumberOfToolbarsInMenu]]);
    },

    AddNewCommunity: function(iNumberOfToolbarsInMenu, strCTIDfrom, strCTIDto, strActionSource, strCompType) {
        this.OpenDropDownMenu = false;
        strCompType = "";

        var strCompId = oToolbarManager_CT2958529.getToolbarData().componentsIds.MultiCommunity;
        var strActionType = 'MYCONDUIT_ADD_COMMUNITY';
        var iElepsedTimeMsec;

        if (strActionSource == this.SourceMessageBox)
            iElepsedTimeMsec = Date.parse(Date()) - this.PopupDialogTimeStamp;
        else
            iElepsedTimeMsec = Date.parse(Date()) - this.DetectStartTimeStamp;

        oToolbarManager_CT2958529.usage.sendComponentUsage(strCompId, strActionType, [["NUMBER_OF_TOOLBARS", iNumberOfToolbarsInMenu],
                                                                                ["CTID_FROM", strCTIDfrom],
                                                                                ["CTID_TO", strCTIDto],
                                                                                ["ELAPSED_TIME_MSEC", iElepsedTimeMsec],
                                                                                ["SOURCE", strActionSource]
                                                                                ]);
    },

    SwitchCommunity: function(iNumberOfToolbarsInMenu, strCTIDfrom, strCTIDto, strActionSource, strCompType) {
        this.OpenDropDownMenu = false;
        strCompType = "";

        var strCompId = oToolbarManager_CT2958529.data.componentsIds.MultiCommunity;
        var strActionType = 'MYCONDUIT_SWITCH_COMMUNITY';

        oToolbarManager_CT2958529.usage.sendComponentUsage(strCompId, strActionType, [["NUMBER_OF_TOOLBARS", iNumberOfToolbarsInMenu],
                                                                                ["CTID_FROM", strCTIDfrom],
                                                                                ["CTID_TO", strCTIDto],
                                                                                ["SOURCE", strActionSource]
                                                                                ]);
    },

    OpenEditdialog: function(iNumberOfToolbarsInMenu, exitCode, arrListOfRemovedCTIDs, arrListOfHiddenCTIDs, arrListOfShownCTIDs, strCompType) {
        this.OpenDropDownMenu = false;
        strCompType = "";

        var ArrayToCTIDXMLList = function(arrCTIDList) {
            if (!arrCTIDList)
                return '';

            var strXML = '';

            for (var i = 0; i < arrCTIDList.length; i++)
                strXML += '<CTID>' + arrCTIDList[i] + '</CTID>';

            return strXML;
        };

        var strCompId = oToolbarManager_CT2958529.data.componentsIds.MultiCommunity;
        var strActionType = 'MYCONDUIT_OPEN_EDIT';
        oToolbarManager_CT2958529.usage.sendComponentUsage(strCompId, strActionType, [["NUMBER_OF_TOOLBARS", iNumberOfToolbarsInMenu],
                                                                                ["EXIT_CODE", exitCode],
                                                                                ["REMOVED", ArrayToCTIDXMLList(arrListOfRemovedCTIDs)],
                                                                                ["HIDDEN", ArrayToCTIDXMLList(arrListOfHiddenCTIDs)],
                                                                                ["SHOWN", ArrayToCTIDXMLList(arrListOfShownCTIDs)]
                                                                                ]);
    }
};
var EBUsageMyStuff_CT2958529 =
{
    AddStuffEngineClick: function() {
        oToolbarManager_CT2958529.usage.sendContainerUsage("ENGINE_PLUS_BUTTON_CLICK");
    },
    
    AddStuffToolbarClick: function() {
        oToolbarManager_CT2958529.usage.sendContainerUsage("TOOLBAR_PLUS_BUTTON_CLICK");
    },

    OptionsClick: function() { },
    OnResizerStart: function() { },
    OnResizerEnd: function() { }
};
var EBUsageRadio_CT2958529 =
{
    SourceRecent: 'Recent stations',
    SourceUserDefined: 'User defined',
    SourceLocalFiles: 'User local',
    SourceLocalStations: 'Local stations',
    SourcePublisher: 'Publisher stations',
    SourceMore: 'More stations',

    ClickSourcePlayBtn: 'RADIO_CLICK_SOURCE_BUTTON',
    ClickSourceMediaList: 'RADIO_CLICK_SOURCE_MEDIA_LIST',

    SettingsActionSearch: 'SETTINGS_ACTION_SEARCH',
    SettingsActionDefine: 'SETTINGS_ACTION_DEFINE',
    SettingsActionAddFiles: 'SETTINGS_ACTION_FILES',

    ExitCodeOK: 'OK',
    ExitCodeCancel: 'Cancel',

    OpenMenu: false,
    PlayTimestamp: null,

    OnOpenMenu: function() {
        this.OpenMenu = true;
    },

    OnCloseMenu: function(strCompType) {
        strCompType = "";
        if (!this.OpenMenu) return;

        this.OpenMenu = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var strActionType = 'RADIO_OPEN_MENU';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnPlay: function(strMediaSource, strClickSource, strStationId, strStationUrl, strStationName, strCompType) {
        strCompType = "";
        if (strMediaSource == this.SourceLocalFiles)
            strStationUrl = '';

        this.OpenMenu = false;
        this.PlayTimestamp = Date.parse(Date());

        if (strStationUrl.indexOf('~!!~') != -1) {
            strStationUrl = "Local";
            strStationId = "";
            strMediaSource = this.SourceUserDefined;
        }

        var compId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var strActionType = 'RADIO_PLAY';
        var iVolume = EBRadioIOManager_CT2958529.GetVolumeFromRegistry();
        if (!iVolume) iVolume = 50;

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["mediaSource", strMediaSource]);
        jsonUsageDataArray.push(["clickSource", strClickSource]);
        jsonUsageDataArray.push(["stationId", strStationId]);
        jsonUsageDataArray.push(["stationUrl", strStationUrl]);
        jsonUsageDataArray.push(["stationName", strStationName]);
        jsonUsageDataArray.push(["valume", iVolume]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, jsonUsageDataArray);
    },

    OnStop: function(strCompType) {
        this.OpenMenu = false;
        strCompType = "";

        var iPlayDuration = 0;

        if (this.PlayTimestamp)
            iPlayDuration = Date.parse(Date()) - this.PlayTimestamp;

        this.PlayTimestamp = null;

        var compId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var strActionType = 'RADIO_STOP';

        var jsonUsageDataArray = [["duration", iPlayDuration]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, jsonUsageDataArray);
    },

    OnClickVolume: function(strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var strActionType = 'RADIO_VOLUME';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnShrink: function(strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var strActionType = 'RADIO_SHRINK';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnUnShrink: function(strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var strActionType = 'RADIO_UNSHRINK';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnOpenSettingsDialog: function(strCompType) {
        strCompType = "";
        this.OpenMenu = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var strActionType = 'RADIO_OPEN_SETTINGS_DIALOG';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnSettingsAction: function(strAction, strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var strActionType = 'RADIO_SETTINGS_DIALOG_ACTION';

        var jsonUsageDataArray = [["action", strAction]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, jsonUsageDataArray);
    },

    OnCloseSettings: function(strExitCode, strCompType) {
        strCompType = "";
        this.OpenMenu = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Radio;
        var strActionType = 'RADIO_CLOSE_SETTINGS_DIALOG';

        var jsonUsageDataArray = [["exitCode", strExitCode]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, jsonUsageDataArray);
    }
};
var EBUsageRss_CT2958529 =
{
    OpenRss: false,
    OpenMultiRss: false,

    OnOpenMultiRss: function() {
        EBUsageRss_CT2958529.OpenMultiRss = true;
    },

    OnCloseMultiRss: function(elementId, strCompType) {
        if (!EBUsageRss_CT2958529.OpenMultiRss) return;

        EBUsageRss_CT2958529.OpenMultiRss = false;

        var compId = elementId;
        var strActionType = 'MULTIRSS_OPEN_MENU';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnRssOpen: function() {
        EBUsageRss_CT2958529.OpenRss = true;
        EBUsageRss_CT2958529.OpenMultiRss = false;
    },

    OnRssClose: function(compId, elementId, strFeedUrl, strCompType) {
        if (!EBUsageRss_CT2958529.OpenRss) return;

        EBUsageRss_CT2958529.OpenRss = false;
        EBUsageRss_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = elementId;

        var strActionType = 'RSS_OPEN_MENU';
        var jsonUsageDataArray = [["feedUrl", strFeedUrl]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    OpenItemLink: function(compId, elementId, strFeedUrl, strItemUrl, bIsNewWindow, bIsNewTab, iIndex, iCount, strCompType) {
        EBUsageRss_CT2958529.OpenRss = false;
        EBUsageRss_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = elementId;

        var strActionType = 'RSS_OPEN_ITEM';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["feedUrl", strFeedUrl]);
        jsonUsageDataArray.push(["itemUrl", strItemUrl]);
        jsonUsageDataArray.push(["newWindow", bIsNewWindow.toString().toUpperCase()]);
        jsonUsageDataArray.push(["newTag", bIsNewTab.toString().toUpperCase()]);
        jsonUsageDataArray.push(["index", iIndex]);
        jsonUsageDataArray.push(["count", iCount]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    MarkAllRead: function(compId, elementId, strCompType) {
        EBUsageRss_CT2958529.OpenRss = false;
        EBUsageRss_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = elementId;

        var strActionType = 'RSS_MARK_READ';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    MarkAllUnRead: function(compId, elementId, strCompType) {
        EBUsageRss_CT2958529.OpenRss = false;
        EBUsageRss_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = elementId;

        var strActionType = 'RSS_MARK_UNREAD';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    DeleteAll: function(compId, elementId, strCompType) {
        EBUsageRss_CT2958529.OpenRss = false;
        EBUsageRss_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = elementId;

        var strActionType = 'RSS_DELETE_ALL';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    Refresh: function(compId, elementId, strCompType) {
        EBUsageRss_CT2958529.OpenRss = false;
        EBUsageRss_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = elementId;

        var strActionType = 'RSS_REFRESH';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    DeleteItem: function(compId, elementId, strCompType) {
        EBUsageRss_CT2958529.OpenRss = false;
        EBUsageRss_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = elementId;

        var strActionType = 'RSS_DELETE_ITEM';
        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    }
};
var EBUsageSearchBox_CT2958529 =
{
    SEARCH_SOURCE_GO_BUTTON: 'SEARCH_SOURCE_GO_BUTTON',
    SEARCH_SOURCE_VK_RETURN: 'SEARCH_SOURCE_VK_RETURN',
    SEARCH_SOURCE_ENGINES_MENU: 'SEARCH_SOURCE_ENGINES_MENU',
    SEARCH_SOURCE_HISTORY: 'SEARCH_SOURCE_HISTORY',
    SEARCH_SOURCE_SUGGEST: 'SEARCH_SOURCE_SUGGEST',

    OpenEnginesMenu: false,
    OpenSuggestWindow: false,

    OnOpenEnginesMenu: function() {
        this.OpenEnginesMenu = true;
    },

    OnOpenSuggestWindow: function() {
        this.OpenSuggestWindow = true;
    },

    OnSearch: function(strSearchUrl, strSearchEngineId, strSource, strCompType) {
        strCompType = "";
        if (strSource == this.SEARCH_SOURCE_ENGINES_MENU)
            this.OpenEnginesMenu = false;

        this.OpenSuggestWindow = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var elementId = strSearchEngineId;
        var strActionType = 'SEARCHBOX_SEARCH';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["searchUrl", strSearchUrl]);
        jsonUsageDataArray.push(["source", strSource]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    OnCloseEnginesMenu: function(strCompType) {
        strCompType = "";
        //if other action was performed, do not send usage.
        if (!this.OpenEnginesMenu)
            return;

        this.OpenEnginesMenu = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var strActionType = 'SEARCHBOX_OPEN_ENGINES_MENU';

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnChangeSearchEngine: function(strEngineIdFrom, strEngineIdTo, strCompType) {
        strCompType = "";
        this.OpenEnginesMenu = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var elementId = compId;
        var strActionType = 'SEARCHBOX_CHANGE_ENGINE';

        var jsonUsageDataArray = [["engineElementIdFrom", strEngineIdFrom], ["engineIdTo", strEngineIdTo]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    OnSearchBoxResize: function(iOldWith, iNewWidth, strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var strActionType = 'SEARCHBOX_RESIZE_BOX';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["widthOld", iOldWith]);
        jsonUsageDataArray.push(["widthNew", iNewWidth]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    OnCloseSuggestWindow: function(strCompType) {
        strCompType = "";

        if (!this.OpenSuggestWindow) return;

        this.OpenSuggestWindow = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var strActionType = 'SEARCHBOX_OPEN_SUGGEST';

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnSuggestWindowResize: function(iOldWidth, iOldHeight, iNewWidth, iNewHeight, strCompType) {
        strCompType = "";
        this.OpenSuggestWindow = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var strActionType = 'SEARCHBOX_RESIZE_SUGGEST';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["widthOld", iOldWidth]);
        jsonUsageDataArray.push(["widthNew", iNewWidth]);
        jsonUsageDataArray.push(["heighOld", iOldHeight]);
        jsonUsageDataArray.push(["heighNew", iNewHeight]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, elementId);
    },

    OnSuggestScroll: function(strCompType) {
        strCompType = "";
        this.OpenSuggestWindow = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var strActionType = 'SEARCHBOX_SCROLL_SUGGEST';

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    },

    OnSearchBoxNavigate: function(strCompType) {
        strCompType = "";
        this.OpenSuggestWindow = false;

        var compId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.SearchBox;
        var strActionType = 'SEARCHBOX_NAVIGATE';

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, elementId);
    }
};
var EBUsageToggleComponent_CT2958529 =
{
    OnClickOn: function(elementId, strCompType) {
        var compId = elementId;
        var strActionType = 'TOGGLE_BUTTON_CLICK_IN';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnClickOff: function(elementId, strCompType) {
        var compId = elementId;
        var strActionType = 'TOGGLE_BUTTON_CLICK_OUT';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    }
};
var EBUsageToolbarContextMenu_CT2958529 =
{
    OpenMenu: false,

    OnOpenMenu: function() {
        this.OpenMenu = true;
    },

    OnCloseMenu: function(elementId, strCompType) {
        if (!this.OpenMenu)
            return;

        this.OpenMenu = false;
        var strActionType = 'PUBLISHER_CONTEXT_MENU_OPEN';
        var compId = elementId;

        oToolbarManager_CT2958529.usage.sendContainerUsage(strActionType, null);
    },

    OnItemClick: function(compId, elementId, strCompType) {
        this.OpenMenu = false;
        var strActionType = 'PUBLISHER_CONTEXT_MENU_ITEM_CLICK';
        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["elementId", elementId]);
        oToolbarManager_CT2958529.usage.sendContainerUsage(strActionType, jsonUsageDataArray);
    },

    OnMenuButtonClick: function(elementId, strCompType) { },

    OnItemShowHideClick: function(strClickedComponentId, strClickedAppGUID, event, isShow) {
        this.OpenMenu = false;
        var strActionType = EBGlobalConsts_CT2958529.IsEngine ? 'ENGINE_CONTEXT_MENU_ITEM_CLICK' : 'PUBLISHER_CONTEXT_MENU_ITEM_CLICK';
        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["clickedComponentId", strClickedComponentId]);
        jsonUsageDataArray.push(["show", isShow]);
        oToolbarManager_CT2958529.usage.sendContainerUsage(strActionType, jsonUsageDataArray);
    }
};
var EBUsageTwitter_CT2958529 =
{
    OpenRss: false,
    OpenMultiRss: false,

    OnOpenMultiRss: function() {
        EBUsageTwitter_CT2958529.OpenMultiRss = true;
    },

    OnMultiMenuItemClick: function(compId, strCompId, strCompType, url, twitterUserId, userScreenName) {
        EBUsageTwitter_CT2958529.OpenMultiRss = false;
        EBUsageTwitter_CT2958529.OpenRss = false;
        var strActionType = 'TWITTER_OPEN_MAIN_MENU_ITEM';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["url", url]);
        jsonUsageDataArray.push(["twitterUserId", twitterUserId]);
        jsonUsageDataArray.push(["twitterUserScreenName", userScreenName]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, strCompId);
    },

    OnCloseMultiRss: function(strCompId, strCompType) {
        if (!EBUsageTwitter_CT2958529.OpenMultiRss) return;

        EBUsageTwitter_CT2958529.OpenMultiRss = false;
        var compId = strCompId;
        var strActionType = 'TWITTER_OPEN_MAIN_MENU';

        oToolbarManager_CT2958529.usage.sendComponentUsage(strCompId, strActionType, null);
    },

    OnRssOpen: function() {
        EBUsageTwitter_CT2958529.OpenRss = true;
        EBUsageTwitter_CT2958529.OpenMultiRss = false;
    },

    OnRssClose: function(compId, strCompId, strFeedUrl, strCompType) {
        if (!EBUsageTwitter_CT2958529.OpenRss) return;

        EBUsageTwitter_CT2958529.OpenRss = false;
        EBUsageTwitter_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = strCompId;

        var strActionType = 'TWITTER_OPEN_MENU';

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, strCompId);
    },

    OpenItemLink: function(compId, strCompId, strFeedUrl, strItemUrl, bIsNewWindow, bIsNewTab, iIndex, iCount, strCompType, twitterUserId, userScreenName) {
        EBUsageTwitter_CT2958529.OpenRss = false;
        EBUsageTwitter_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = strCompId;

        var strActionType = 'TWITTER_OPEN_ITEM';

        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["feedUrl", strFeedUrl]);
        jsonUsageDataArray.push(["itemUrl", strItemUrl]);
        jsonUsageDataArray.push(["newWindow", bIsNewWindow.toString().toUpperCase()]);
        jsonUsageDataArray.push(["newTag", bIsNewTab.toString().toUpperCase()]);
        jsonUsageDataArray.push(["index", iIndex]);
        jsonUsageDataArray.push(["count", iCount]);
        jsonUsageDataArray.push(["twitterUserId", twitterUserId]);
        jsonUsageDataArray.push(["twitterUserScreenName", userScreenName]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, strCompId);
    },

    OpenItemInnerLink: function(compId, strCompId, strFeedUrl, strItemUrl, iIndex, iCount, twitterUserId, userScreenName, strCompType, bIsNewWindow, bIsNewTab) {
        EBUsageTwitter_CT2958529.OpenRss = false;
        EBUsageTwitter_CT2958529.OpenMultiRss = false;

        var strActionType = 'TWITTER_OPEN_INNER_ITEM';
        var jsonUsageDataArray = new Array();
        jsonUsageDataArray.push(["feedUrl", strFeedUrl]);
        jsonUsageDataArray.push(["itemUrl", strItemUrl]);
        jsonUsageDataArray.push(["newWindow", bIsNewWindow.toString().toUpperCase()]);
        jsonUsageDataArray.push(["newTag", bIsNewTab.toString().toUpperCase()]);
        jsonUsageDataArray.push(["index", iIndex]);
        jsonUsageDataArray.push(["count", iCount]);
        jsonUsageDataArray.push(["twitterUserId", twitterUserId]);
        jsonUsageDataArray.push(["twitterUserScreenName", userScreenName]);

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, jsonUsageDataArray, strCompId);
    },

    DeleteAll: function(compId, strCompId, strCompType) {
        EBUsageTwitter_CT2958529.OpenRss = false;
        EBUsageTwitter_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = strCompId;

        var strActionType = 'TWITTER_DELETE_ALL';

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, strCompId);
    },

    Refresh: function(compId, strCompId, strCompType) {
        EBUsageTwitter_CT2958529.OpenRss = false;
        EBUsageTwitter_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = strCompId;

        var strActionType = 'TWITTER_REFRESH';

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, strCompId);
    },

    DeleteItem: function(compId, strCompId, strCompType) {
        EBUsageTwitter_CT2958529.OpenRss = false;
        EBUsageTwitter_CT2958529.OpenMultiRss = false;

        if (!compId)
            compId = strCompId;

        var strActionType = 'TWITTER_DELETE_ITEM';

        oToolbarManager_CT2958529.usage.sendComponentUsage(compId, strActionType, null, strCompId);
    }
};
var EBUsageWeather_CT2958529 =
{
    OnOpenWindow: function(strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var strActionType = 'WEATHER_OPEN_WINDOW';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnChangeCF: function(strChangeTo, strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var strActionType = 'WEATHER_CHANGE_TO';

        var jsonUsageDataArray = [["changeTo", strChangeTo]];

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, jsonUsageDataArray);
    },

    OnChangeLocation: function(strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var strActionType = 'WEATHER_CHANGE_LOCATION';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnExtendedForcast: function(strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var strActionType = 'WEATHER_EXTENDED_FORECAST';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnWeatherSearch: function(strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var strActionType = 'WEATHER_SEARCH';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnWeatherFeedback: function(strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var strActionType = 'WEATHER_FEEDBACK';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    },

    OnSelect: function(strCompType) {
        strCompType = "";
        var compId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var elementId = oToolbarManager_CT2958529.data.componentsIds.Weather;
        var strActionType = 'WEATHER_SELECT_BUTTON';

        oToolbarManager_CT2958529.usage.sendComponentUsage(elementId, strActionType, null);
    }
};
var EBUserMenuItems_CT2958529 =
{
    rootTag: "MENU",
    folder: "MenuItems",

    merge: function(xmlMergeTo, strComponentId) {
        var xmlUserMenuItems = this.getUserMenuItemsXml(strComponentId);
        if (xmlUserMenuItems) {
            var xmlItem = null;
            while (xmlUserMenuItems.childNodes.length > 0) {
                xmlMergeTo.appendChild(xmlUserMenuItems.firstChild);
            }

            return true;
        }

        return false;
    },

    getUserMenuItemsXml: function(strComponentId) {
        var strFilename = this.getFilename(strComponentId);
        if (!EBIOManager_CT2958529.IsToolbarFileExists(strFilename))
            return null;

        var oFile = EBIOManager_CT2958529.CreateToolbarFile(strFilename);
        var strXml = EBFileIO_CT2958529.read(oFile, EBGlobalConsts_CT2958529.DefaultCharset);
        var xmlDoc = EBXML_CT2958529.GetXmlDocument(strXml);
        return xmlDoc.documentElement;
    },

    getFilename: function(strComponentId) {
        var prefix = EBGlobalConsts_CT2958529.IsEngine ? this.folder + EBDirIO_CT2958529.sep : "";
        return prefix + strComponentId + ".xml";
    },

    addUserMenuItem: function(strXml, strComponentId) {
        var xmlMenuItem = EBXML_CT2958529.GetXmlDocument(strXml);
        if (xmlMenuItem.parseError)
            throw EBGlobalConsts_CT2958529.IsEngine ? WebApiManager_CT2958529.errorCodes.menuItemParseError : EBWebPageApiConsts_CT2958529.Errors.PRIVATE_MENU_PARSE_ERROR;
        xmlMenuItem = xmlMenuItem.documentElement;

        var xmlMenuItems = this.getUserMenuItemsXml(strComponentId);

        if (xmlMenuItems == null)
            this.addFirstMenuItem(strXml, strComponentId);
        else {
            if (this.isExists(xmlMenuItems, xmlMenuItem))
                throw EBGlobalConsts_CT2958529.IsEngine ? WebApiManager_CT2958529.errorCodes.menuItemsExists : EBWebPageApiConsts_CT2958529.Errors.MENU_ITEM_ALREADY_EXISTS;

            xmlMenuItems.appendChild(xmlMenuItem);
            this.saveMenuItems(xmlMenuItems, strComponentId);
        }
    },

    isExists: function(xmlMenuItems, xmlMenuItem) {
        var xmlExistingMenuItem = null;
        for (var i = 0; i < xmlMenuItems.childNodes.length; i++) {
            xmlExistingMenuItem = xmlMenuItems.childNodes[i];
            if (EBXML_CT2958529.GetSingleNodeValue(xmlExistingMenuItem, "HASH_CODE") ==
                EBXML_CT2958529.GetSingleNodeValue(xmlMenuItem, "HASH_CODE"))
                return true;
        }

        return false;
    },

    addFirstMenuItem: function(strXml, strComponentId) {
        var strMenuItemsXml = "<" + this.rootTag + ">" + strXml + "</" + this.rootTag + ">";
        this.saveMenuItems(strMenuItemsXml, strComponentId);
    },

    saveMenuItems: function(xmlMenuItems, strComponentId) {
        var strMenuItems = (typeof xmlMenuItems != 'string') ? EBXML_CT2958529.GetStringXml(xmlMenuItems) : xmlMenuItems;
        var oFile = EBIOManager_CT2958529.CreateToolbarFile(this.getFilename(strComponentId));
        EBFileIO_CT2958529.write(oFile, strMenuItems, null, EBGlobalConsts_CT2958529.DefaultCharset);
    },

    addFromApi: function(strXml, strComponentId) {
        var strTitle = oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MANAGE_PRIVATE_MENU_ADD_APPROVAL_TITLE');
        var strMsg;
        var objComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strComponentId);

        if (!objComponent)
            throw EBGlobalConsts_CT2958529.IsEngine ? WebApiManager_CT2958529.errorCodes.componentNotExists : EBWebPageApiConsts_CT2958529.Errors.MENU_ITEM_COMP_ID_NOT_VALID;
        var key = null;
        if (objComponent.ComponentItem.button.text) {
            key = EBGlobalConsts_CT2958529.IsEngine ? 'CELP_STR_ID_MANAGE_PRIVATE_MENU_ADD_APPROVAL' : 'CTLP_STR_ID_MANAGE_PRIVATE_MENU_ADD_APPROVAL';
            strMsg = oToolbarManager_CT2958529.getLPKey(key);
        }
        else {
            key = EBGlobalConsts_CT2958529.IsEngine ? 'CELP_STR_ID_MANAGE_PRIVATE_MENU_ADD_APPROVAL2' : 'CTLP_STR_ID_MANAGE_PRIVATE_MENU_ADD_APPROVAL2';
            strMsg = oToolbarManager_CT2958529.getLPKey(key);
        }

        strMsg = strMsg.replace(/\[COMPONENT NAME\]/, objComponent.ComponentItem.button.text);
        strMsg = strMsg.replace(/\[TOOLBAR NAME\]/, EBActionManager_CT2958529.GetToolbarName());
        //confrirm the action
        if (!EBGlobalManager_CT2958529.Confirm(window, strTitle, strMsg))
            throw EBGlobalConsts_CT2958529.IsEngine ? WebApiManager_CT2958529.errorCodes.operationAborted : EBWebPageApiConsts_CT2958529.Errors.OPERATION_ABORTED;

        //save new user menu item
        this.addUserMenuItem(strXml, strComponentId);
        //refresh the menu
        var xmlUserMenuItems = this.getUserMenuItemsXml(strComponentId);
        objComponent.rebuildMenu(xmlUserMenuItems);
    }
}

var EBUserMenuItemsDialog_CT2958529 =
{
    manageDialogFileName: 'chrome://browsersearch/content/manageMenu.xul',
    manageDialogName: 'manageMenu',
    xmlMenuItems: null,
    componentId: '',
    oMenuComponent: null,

    openManageDialog: function(strComponentId) {

        this.oMenuComponent = EBComponentsManager_CT2958529.GetComponentByCompID(strComponentId);
        EBGlobalManager_CT2958529.OpenDialog(this.manageDialogFileName,
								this.manageDialogName,
								'chrome,modal,centerscreen,resizable=no', [strComponentId]);
    },

    OnLoad: function(event) {
        this.componentId = window.arguments[0][0];
        this.xmlMenuItems = EBUserMenuItems_CT2958529.getUserMenuItemsXml(this.componentId);
        if (this.xmlMenuItems)
            this.fillMenuItemsUI();

        this.ApplyLP();
        var lst = document.getElementById("listMenuItems")
        lst.getItemAtIndex(0).click();
    },

    OnAccept: function(event) {
        EBUserMenuItems_CT2958529.saveMenuItems(this.xmlMenuItems, this.componentId);
        var oWin = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWin.EBUserMenuItemsDialog_CT2958529.oMenuComponent.rebuildMenu(this.xmlMenuItems);
    },

    fillMenuItemsUI: function() {
        var xulList = document.getElementById('listMenuItems');
        var xulItem = null;

        for (var i = 0; i < this.xmlMenuItems.childNodes.length; i++) {
            xulItem = this.createItem(this.xmlMenuItems.childNodes[i]);
            if (xulItem != null)
                xulList.appendChild(xulItem);
        }
    },

    createItem: function(xmlMenuItem) {
        if (!xmlMenuItem) return null;

        var strCaption = EBXML_CT2958529.GetSingleNodeValue(xmlMenuItem, "CAPTION");
        var strIcon = EBXML_CT2958529.GetSingleNodeValue(xmlMenuItem, "ICON_URL");
        var objListItem = document.createElement("listitem");
        var objCell = document.createElement("listcell");

        objCell.setAttribute("label", strCaption);
        objCell.setAttribute("image", strIcon);
        objCell.setAttribute('class', 'listcell-iconic');
        objListItem.appendChild(objCell);

        return objListItem;
    },

    //UI events
    Listbox_OnSelect: function(event) {
        var lst = document.getElementById("listMenuItems")
        if (lst.selectedIndex == 0)
            this._DisableUpBtn();
        else
            this._EnableUpBtn();

        if (lst.selectedIndex == this.xmlMenuItems.childNodes.length - 1)
            this._DisableDownBtn();
        else
            this._EnableDownBtn();
    },

    Listbox_OnKeypress: function() {

    },

    OnDelete: function() {
        var lst = document.getElementById("listMenuItems")
        var iIndex = lst.selectedIndex;
        var oSelected = lst.selectedItem;
        lst.removeItemAt(iIndex);
        if (lst.getRowCount() == 0) {
            this._DisableDeleteBtn();
            this._DisableDownBtn();
            this._DisableUpBtn();
        }
        else if (iIndex >= lst.getRowCount())
            lst.getItemAtIndex(iIndex - 1).click();
        else
            lst.getItemAtIndex(iIndex).click();

        //remove from xml
        this.xmlMenuItems.removeChild(this.xmlMenuItems.childNodes[iIndex]);
    },

    MoveUp: function(event) {
        //handle UI
        var lst = document.getElementById("listMenuItems")
        var oSelected = lst.selectedItem;
        var iIndex = lst.selectedIndex;
        var oUpper = lst.childNodes[iIndex];
        lst.insertBefore(oSelected, oUpper);
        oSelected.click();

        //handle XML
        var xmlSelected = this.xmlMenuItems.childNodes[iIndex];
        var xmlUpper = this.xmlMenuItems.childNodes[iIndex - 1];
        this.xmlMenuItems.insertBefore(xmlSelected, xmlUpper);

        this.Listbox_OnSelect();
    },

    MoveDown: function(event) {
        //handle UI
        var lst = document.getElementById("listMenuItems")
        var oSelected = lst.selectedItem;
        var iIndex = lst.selectedIndex;
        var oDowner = lst.childNodes[iIndex + 2];
        lst.insertBefore(oDowner, oSelected);
        oSelected.click();

        //handle XML
        var xmlSelected = this.xmlMenuItems.childNodes[iIndex];
        var xmlDowner = this.xmlMenuItems.childNodes[iIndex + 1];
        this.xmlMenuItems.insertBefore(xmlDowner, xmlSelected);

        this.Listbox_OnSelect();
    },

    _DisableUpBtn: function() {
        var oUp = document.getElementById("btnUp");
        oUp.disabled = true;
        oUp.image = "chrome://global/skin/arrow/arrow-up-dis.gif"

    },

    _EnableUpBtn: function() {
        var oUp = document.getElementById("btnUp");
        oUp.disabled = false;
        oUp.image = "chrome://global/skin/arrow/arrow-up-sharp.gif"

    },

    _DisableDownBtn: function() {
        var oDown = document.getElementById("btnDown");
        oDown.disabled = true;
        oDown.image = "chrome://global/skin/arrow/arrow-dn-dis.gif"
    },

    _EnableDownBtn: function() {
        var oDown = document.getElementById("btnDown");
        oDown.disabled = false;
        oDown.image = "chrome://global/skin/arrow/arrow-dn-sharp.gif"
    },

    _DisableDeleteBtn: function() {
        var oDelete = document.getElementById('btnDelete');
        oDelete.disabled = true;
    },

    ApplyLP: function() {
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var locale = oWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);
        var dialogsDirection = oWindow.EBGlobalManager_CT2958529.IsReverseDialogs();
        var oDialog = document.getElementById('ebManageMenuID');

        if (dialogsDirection)
            EBUILogic_Dialog_CT2958529.setWindowDirection(dialogsDirection, "ebManageMenuID");

        var acceptButton = oDialog.getButton('accept');
        var cancelButton = oDialog.getButton('cancel');
        var lblTitle = document.getElementById("lblTitle");
        var dscTitle = document.getElementById("dscTitle");
        var btnDelete = document.getElementById("btnDelete");

        oDialog.title = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MANAGE_PRIVATE_MENU_DLG_CAPTION');
        acceptButton.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_OK'));
        cancelButton.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_CANCEL'));
        btnDelete.setAttribute('label', oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MANAGE_PRIVATE_MENU_DLG_DELETE_ITEM'));
        lblTitle.value = oWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_MANAGE_PRIVATE_MENU_DLG_SUB_TITLE')
	var key = EBGlobalConsts_CT2958529.IsEngine ? 'CELP_STR_ID_MANAGE_PRIVATE_MENU_DLG_EXPLAIN': 'CTLP_STR_ID_MANAGE_PRIVATE_MENU_DLG_EXPLAIN';
        dscTitle.firstChild.nodeValue = oWindow.oToolbarManager_CT2958529.getLPKey(key);
    }
}
//the xml tag names of the weather data
var EBWeatherXMLConsts_CT2958529 = 
{
	//Server XML
	SEARCH					: 'SEARCH',
	SUGGESTIONS				: 'SUGGESTIONS',
	SUGGESTION				: 'SUGGESTION',
	CITY					: 'CITY',
	COUNTRY					: 'COUNTRY',
	LOCATION_ID				: 'LOCATION_ID',
	FORECAST				: 'FORECAST',
	DAYS					: 'DAYS',
	DAY						: 'DAY',
	DATE					: 'DATE',
	F_MIN					: 'F_MIN',
	F_MAX					: 'F_MAX',
	C_MIN					: 'C_MIN',
	C_MAX					: 'C_MAX',
	CONDITION_DESCRIPTION	: 'CONDITION_DESCRIPTION',
	CONDITION_ICON			: 'CONDITION_ICON',
	CURRENT_CONDITION		: 'CURRENT_CONDITION',
	TEMP_F					: 'TEMP_F',
	TEMP_C					: 'TEMP_C',
	WEATHER_TEXT			: 'WEATHER_TEXT',
	SKY						: 'SKY',
	FEELS_LIKE_F			: 'FEELS_LIKE_F',
	FEELS_LIKE_C			: 'FEELS_LIKE_C',
	ICON					: 'ICON',
	BUTTON_ICON				: 'BUTTON_ICON',
	TOOLTIP_ICON			: 'TOOLTIP_ICON',
	
	NORESULTS				: 'NORESULTS'
	
}

var EBWeatherUnits_CT2958529 = 
{
	TEMPERATURE_F : 'F',
	TEMPERATURE_C : 'C'
}


//The data structure of the weather data.
//this is the same structure hierarchy as the xml have from the server
//every data class define the XMLSerialize function which makes the object
//to string xml data

/***** Search Data structure *******/
function EBWeatherSuggestion_CT2958529(strCity,strCountry,strLocationID)
{
	this.City		= strCity;
	this.Country	= strCountry;
	this.LocationID	= strLocationID;
	
	this.XMLSerialize = function()
	{
		var strXMLSuggestion	= EBWeatherXMLConsts_CT2958529.SUGGESTION;
		var strXMLCity			= EBWeatherXMLConsts_CT2958529.CITY;
		var strXMLCountry		= EBWeatherXMLConsts_CT2958529.COUNTRY;
		var strXMLLocationID	= EBWeatherXMLConsts_CT2958529.LOCATION_ID;
		
		var strXML = '';
		strXML +=	 '<' + strXMLSuggestion + '>';
		strXML +=		'<' + strXMLCity+ '>' + this.City + '</' + strXMLCity+ '>';
		strXML +=		'<' + strXMLCountry+ '>' + this.Country + '</' + strXMLCountry+ '>';
		strXML +=		'<' + strXMLLocationID+ '>' + this.LocationID + '</' + strXMLLocationID+ '>';
		strXML +=	'</' + strXMLSuggestion + '>';
		
		return strXML;
		
	};
}

function EBWeatherSuggestionCollection_CT2958529()
{
	this.Collection = new EBArrayCollection_CT2958529();
	
	this.XMLSerialize = function()
	{
		var strXMLSuggestions	= EBWeatherXMLConsts_CT2958529.SUGGESTIONS;
		var strXML = '';
		strXML += '<' + strXMLSuggestions + '>';
		
		var oWeatherSuggestion = null;
		for(var i=0;i<this.Collection.Arr.length;i++)
		{
			oWeatherSuggestion = this.Collection.GetItem(i);
			strXML += oWeatherSuggestion.XMLSerialize();
		}
		
		strXML += '</' + strXMLSuggestions + '>';
		
		return strXML;
	};
}

function EBWeatherSearch_CT2958529(oSuggestionCollection)
{
	this.SuggestionCollection = oSuggestionCollection;
	
	this.XMLSerialize = function()
	{
		var strXMLSearch	= EBWeatherXMLConsts_CT2958529.SEARCH;
		var strXML = '';
		
		strXML += '<' + strXMLSearch + '>';
		strXML +=	this.SuggestionCollection.XMLSerialize();
		strXML += '</' + strXMLSearch + '>';
		
		return strXML;
	};
}

/***** Forecast Data structure *******/
function EBWeatherCurrentCondition_CT2958529(strTempF,
												strTempC,
												strWeatherText,
												strSky,
												strFeelsLikeF,
												strFeelsLikeC,
												strIcon,
												strButtonIcon,
												strTooltipIcon)
{
	this.TempF			= strTempF;
	this.TempC			= strTempC;
	this.WeatherText	= strWeatherText;
	this.Sky			= strSky;
	this.FeelsLikeF		= strFeelsLikeF;
	this.FeelsLikeC		= strFeelsLikeC;
	this.Icon			= strIcon;
	this.ButtonIcon		= strButtonIcon;
	this.TooltipIcon	= strTooltipIcon;
	
	this.XMLSerialize = function()
	{
		var strXMLCurrentCondition	= EBWeatherXMLConsts_CT2958529.CURRENT_CONDITION;
		var strXMLTempF				= EBWeatherXMLConsts_CT2958529.TEMP_F;
		var strXMLTempC				= EBWeatherXMLConsts_CT2958529.TEMP_C;
		var strXMLWeatherText		= EBWeatherXMLConsts_CT2958529.WEATHER_TEXT;
		var strXMLSky				= EBWeatherXMLConsts_CT2958529.SKY;
		var strXMLFeelsLikeF		= EBWeatherXMLConsts_CT2958529.FEELS_LIKE_F;
		var strXMLFeelsLikeC		= EBWeatherXMLConsts_CT2958529.FEELS_LIKE_C;
		var strXMLIcon				= EBWeatherXMLConsts_CT2958529.ICON;
		var strXMLButtonIcon		= EBWeatherXMLConsts_CT2958529.BUTTON_ICON;
		var strXMLTooltipIcon		= EBWeatherXMLConsts_CT2958529.TOOLTIP_ICON;
	
		var strXML = '';
		strXML +=	 '<' + strXMLCurrentCondition + '>';
		strXML +=		'<' + strXMLTempF+ '>' + this.TempF + '</' + strXMLTempF+ '>';
		strXML +=		'<' + strXMLTempC+ '>' + this.TempC + '</' + strXMLTempC+ '>';
		strXML +=		'<' + strXMLWeatherText+ '>' + this.WeatherText + '</' + strXMLWeatherText+ '>';
		strXML +=		'<' + strXMLSky+ '>' + this.Sky + '</' + strXMLSky+ '>';
		strXML +=		'<' + strXMLFeelsLikeF+ '>' + this.FeelsLikeF + '</' + strXMLFeelsLikeF+ '>';
		strXML +=		'<' + strXMLFeelsLikeC+ '>' + this.FeelsLikeC + '</' + strXMLFeelsLikeC+ '>';
		strXML +=		'<' + strXMLIcon+ '>' + this.Icon + '</' + strXMLIcon+ '>';
		strXML +=		'<' + strXMLButtonIcon+ '>' + this.ButtonIcon + '</' + strXMLButtonIcon+ '>';
		strXML +=		'<' + strXMLTooltipIcon+ '>' + this.TooltipIcon + '</' + strXMLTooltipIcon+ '>';
		strXML +=	'</' + strXMLCurrentCondition + '>';
		
		return strXML;
	};
}


function EBWeatherDay_CT2958529(iDayIndex,
									strDate,
									strDay,
									strFMin,
									strFMax,
									strCMin,
									strCMax,
									strConditionDescription,
									strConditionIcon)
{
	
	this.DayIndex				= iDayIndex;
	this.Date					= strDate;
	this.Day					= strDay;
	this.FMin					= strFMin;
	this.FMax					= strFMax;
	this.CMin					= strCMin;
	this.CMax					= strCMax;
	this.ConditionDescription	= strConditionDescription;
	this.ConditionIcon			= strConditionIcon;
	
	this.XMLSerialize = function()
	{
		var strXMLMainDayFullTagName	= EBWeatherXMLConsts_CT2958529.DAY + this.DayIndex;
		var strXMLDate					= EBWeatherXMLConsts_CT2958529.DATE;
		var strXMLDay					= EBWeatherXMLConsts_CT2958529.DAY;
		var strXMLFMin					= EBWeatherXMLConsts_CT2958529.F_MIN;
		var strXMLFMax					= EBWeatherXMLConsts_CT2958529.F_MAX;
		var strXMLCMin					= EBWeatherXMLConsts_CT2958529.C_MIN;
		var strXMLCMax					= EBWeatherXMLConsts_CT2958529.C_MAX;
		var strXMLConditionDescription	= EBWeatherXMLConsts_CT2958529.CONDITION_DESCRIPTION;
		var strXMLConditionIcon			= EBWeatherXMLConsts_CT2958529.CONDITION_ICON;
	
		var strXML = '';
		strXML +=	 '<' + strXMLMainDayFullTagName + '>';
		strXML +=		'<' + strXMLDate+ '>' + this.Date + '</' + strXMLDate+ '>';
		strXML +=		'<' + strXMLDay+ '>' + this.Day + '</' + strXMLDay+ '>';
		strXML +=		'<' + strXMLFMin+ '>' + this.FMin + '</' + strXMLFMin+ '>';
		strXML +=		'<' + strXMLFMax+ '>' + this.FMax + '</' + strXMLFMax+ '>';
		strXML +=		'<' + strXMLCMin+ '>' + this.CMin + '</' + strXMLCMin+ '>';
		strXML +=		'<' + strXMLCMax+ '>' + this.CMax + '</' + strXMLCMax+ '>';
		strXML +=		'<' + strXMLConditionDescription+ '>' + this.ConditionDescription + '</' + strXMLConditionDescription+ '>';
		strXML +=		'<' + strXMLConditionIcon+ '>' + this.ConditionIcon + '</' + strXMLConditionIcon+ '>';
		strXML +=	'</' + strXMLMainDayFullTagName + '>';
		
		return strXML;
	};
}


function EBWeatherDayCollection_CT2958529()
{
	this.Collection = new EBArrayCollection_CT2958529();
	
	this.XMLSerialize = function()
	{
		var strXMLDays	= EBWeatherXMLConsts_CT2958529.DAYS;
		var strXML = '';
		strXML += '<' + strXMLDays + '>';
		
		var oWeatherDay = null;
		for(var i=0;i<this.Collection.Arr.length;i++)
		{
			oWeatherDay = this.Collection.GetItem(i);
			strXML += oWeatherDay.XMLSerialize();
		}
		
		strXML += '</' + strXMLDays + '>';
		
		return strXML;
	};
}


function EBWeatherForecast_CT2958529(strLocationID,oWeatherDayCollection,oWeatherCurrentCondition)
{
	this.LocationID			= strLocationID;
	this.DayCollection		= oWeatherDayCollection;
	this.CurrentCondition	= oWeatherCurrentCondition;
	
	this.XMLSerialize = function()
	{	
		var strXMLForecast		= EBWeatherXMLConsts_CT2958529.FORECAST;
		var strXMLLocationID	= EBWeatherXMLConsts_CT2958529.LOCATION_ID;
		var strXML = '';
		strXML += '<' + strXMLForecast + '>';
		strXML +=		'<' + strXMLLocationID+ '>' + this.LocationID + '</' + strXMLLocationID+ '>';
		strXML +=		this.DayCollection.XMLSerialize();
		strXML +=		this.CurrentCondition.XMLSerialize();
		strXML += '</' + strXMLForecast + '>';
		
		return strXML;
	};	
}

//manager class that responsible to convert string xml to the 
//weather data object correspondingly
var EBWeatherDataFactory_CT2958529 = 
{
	XMLToWeatherSearch : function(XMLDoc)
	{
		var oWeatherSearch			= null;
		var oSuggestionCollection	= null;
		var strXMLSearch			= EBWeatherXMLConsts_CT2958529.SEARCH;
		var strXMLSuggestions		= EBWeatherXMLConsts_CT2958529.SUGGESTIONS;
		
		
		var XMLRoot			= XMLDoc.documentElement;
		var XMLChildNode	= null;
		if(XMLRoot.tagName == strXMLSearch)
		{
			for(var i=0;i<XMLRoot.childNodes.length;i++)
			{
				XMLChildNode = XMLRoot.childNodes[i];
				if(XMLChildNode.tagName == strXMLSuggestions)
				{
					oSuggestionCollection = this.XMLToWeatherSuggestionCollection(XMLChildNode);
				}
			}
			
			if(oSuggestionCollection)
			{
				oWeatherSearch = new EBWeatherSearch_CT2958529(oSuggestionCollection)
			}
		}
		
		return oWeatherSearch;
	},	
	
	XMLToWeatherSuggestionCollection : function(XMLNode)
	{
		var oWeatherSuggestionCollection	= null;
		var oWeatherSuggestion				= null;
		
		var strXMLSuggestions				= EBWeatherXMLConsts_CT2958529.SUGGESTIONS;
		
		//get the correct root node (depends in this is the xml document or a regular dom node)
		var XMLRoot			= XMLNode.ownerDocument ? XMLNode : XMLNode.documentElement;
		var XMLChildNode	= null;
		if(XMLRoot.tagName == strXMLSuggestions)
		{
			oWeatherSuggestionCollection = new EBWeatherSuggestionCollection_CT2958529();
			for(var i=0;i<XMLRoot.childNodes.length;i++)
			{
				XMLChildNode = XMLRoot.childNodes[i];
				oWeatherSuggestion = this.XMLToWeatherSuggestion(XMLChildNode);
				if(oWeatherSuggestion)
				{
					oWeatherSuggestionCollection.Collection.AppendElement(oWeatherSuggestion);
				}
			}
		}
		
		return oWeatherSuggestionCollection;
	},
	
	XMLToWeatherSuggestion : function(XMLNode)
	{
		var oWeatherSuggestion	= null;
		var strCity				= '';
		var strCountry			= '';
		var strLocationID		= '';
		
		var strXMLSuggestion	= EBWeatherXMLConsts_CT2958529.SUGGESTION;
		var strXMLCity			= EBWeatherXMLConsts_CT2958529.CITY;
		var strXMLCountry		= EBWeatherXMLConsts_CT2958529.COUNTRY;
		var strXMLLocationID	= EBWeatherXMLConsts_CT2958529.LOCATION_ID;
		
		//get the correct root node (depends in this is the xml document or a regular dom node)
		var XMLRoot			= XMLNode.ownerDocument ? XMLNode : XMLNode.documentElement;
		var XMLChildNode	= null;
		if(XMLRoot.tagName == strXMLSuggestion)
		{
			for(var i=0;i<XMLRoot.childNodes.length;i++)
			{
				XMLChildNode = XMLRoot.childNodes[i];
				if(XMLChildNode.tagName == strXMLCity)
				{
					strCity = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLCountry)
				{
					strCountry = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLLocationID)
				{
					strLocationID = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
			}
			
			oWeatherSuggestion = new EBWeatherSuggestion_CT2958529(strCity,strCountry,strLocationID);
		}
		
		return oWeatherSuggestion;
	},
	
	XMLToWeatherForecast : function(XMLDoc)
	{
		var oWeatherForecast		= null;
		
		var strLocationID				= '';
		var oWeatherDayCollection		= null;
		var oWeatherCurrentCondition	= null;
		
		var strXMLForecast				= EBWeatherXMLConsts_CT2958529.FORECAST;
		var strXMLLocationID			= EBWeatherXMLConsts_CT2958529.LOCATION_ID;
		var strXMLDays					= EBWeatherXMLConsts_CT2958529.DAYS;
		var strXMLCurrentCondition		= EBWeatherXMLConsts_CT2958529.CURRENT_CONDITION;
		
		
		var XMLRoot			= XMLDoc.documentElement;
		var XMLChildNode	= null;
		if(XMLRoot.tagName == strXMLForecast)
		{
			for(var i=0;i<XMLRoot.childNodes.length;i++)
			{
				XMLChildNode = XMLRoot.childNodes[i];
				if(XMLChildNode.tagName == strXMLLocationID)
				{
					strLocationID = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLDays)
				{
					oWeatherDayCollection = this.XMLToWeatherDayCollection(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLCurrentCondition)
				{
					oWeatherCurrentCondition = this.XMLToWeatherCurrentCondition(XMLChildNode);
				}
			}
			
			if(strLocationID && oWeatherDayCollection && oWeatherCurrentCondition)
			{
				oWeatherForecast = new EBWeatherForecast_CT2958529(strLocationID,
															oWeatherDayCollection,
															oWeatherCurrentCondition)
			}
		}
		
		return oWeatherForecast;
		
	},
	
	XMLToWeatherDayCollection : function(XMLNode)
	{
		var oWeatherDayCollection		= null;
		var oWeatherDay					= null;
		var strXMLDays					= EBWeatherXMLConsts_CT2958529.DAYS;
		
		var XMLRoot			= XMLNode.ownerDocument ? XMLNode : XMLNode.documentElement;
		var XMLChildNode	= null;
		
		if(XMLRoot.tagName == strXMLDays)
		{
			oWeatherDayCollection = new EBWeatherDayCollection_CT2958529();
			for(var i=0;i<XMLRoot.childNodes.length;i++)
			{
				XMLChildNode = XMLRoot.childNodes[i];
				oWeatherDay = this.XMLToWeatherDay(XMLChildNode);
				if(oWeatherDay)
				{
					oWeatherDayCollection.Collection.AppendElement(oWeatherDay);
				}
			}
		}
		
		return oWeatherDayCollection;
	},
	
	XMLToWeatherDay : function(XMLNode)
	{
		var oWeatherDay = null;
		
		var iDayIndex				= 0;
		var strDate					= '';
		var strDay					= '';
		var strFMin					= '';
		var strFMax					= '';
		var strCMin					= '';
		var strCMax					= '';
		var strConditionDescription = '';
		var strConditionIcon		= '';
		
		var strXMLDate					= EBWeatherXMLConsts_CT2958529.DATE;
		var strXMLDay					= EBWeatherXMLConsts_CT2958529.DAY;
		var strXMLFMin					= EBWeatherXMLConsts_CT2958529.F_MIN;
		var strXMLFMax					= EBWeatherXMLConsts_CT2958529.F_MAX;
		var strXMLCMin					= EBWeatherXMLConsts_CT2958529.C_MIN;
		var strXMLCMax					= EBWeatherXMLConsts_CT2958529.C_MAX;
		var strXMLConditionDescription	= EBWeatherXMLConsts_CT2958529.CONDITION_DESCRIPTION;
		var strXMLConditionIcon			= EBWeatherXMLConsts_CT2958529.CONDITION_ICON;

		var XMLRoot			= XMLNode.ownerDocument ? XMLNode : XMLNode.documentElement;
		var XMLChildNode	= null;
		
		var strXMLRootTagName = XMLRoot.tagName;
		if(EBGlobalManager_CT2958529.BeginsWith(strXMLRootTagName,strXMLDay))
		{
			//extricate the number from the DAY[number] pattern
			iDayIndex = strXMLRootTagName.substring(strXMLDay.length);
			for(var i=0;i<XMLRoot.childNodes.length;i++)
			{
				XMLChildNode = XMLRoot.childNodes[i];
				if(XMLChildNode.tagName == strXMLDate)
				{
					strDate = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLDay)
				{
					strDay = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLFMin)
				{
					strFMin = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLFMax)
				{
					strFMax = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLCMin)
				{
					strCMin = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLCMax)
				{
					strCMax = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLConditionDescription)
				{
					strConditionDescription = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLConditionIcon)
				{
					strConditionIcon = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
			}
			
			
			oWeatherDay = new EBWeatherDay_CT2958529(iDayIndex,
												strDate,
												strDay,
												strFMin,
												strFMax,
												strCMin,
												strCMax,
												strConditionDescription,
												strConditionIcon)
		}
		
		return oWeatherDay;
		
	},
	
	XMLToWeatherCurrentCondition : function(XMLNode)
	{
		var oWeatherCurrentCondition = null;
		
		var strTempF		= '';
		var strTempC		= '';
		var strWeatherText	= '';
		var strSky			= '';
		var strFeelsLikeF	= '';
		var strFeelsLikeC	= '';
		var strIcon			= '';
		var strButtonIcon	= '';
		var strTooltipIcon	= '';
	
	
		var strXMLCurrentCondition	= EBWeatherXMLConsts_CT2958529.CURRENT_CONDITION;
		var strXMLTempF				= EBWeatherXMLConsts_CT2958529.TEMP_F;
		var strXMLTempC				= EBWeatherXMLConsts_CT2958529.TEMP_C;
		var strXMLWeatherText		= EBWeatherXMLConsts_CT2958529.WEATHER_TEXT;
		var strXMLSky				= EBWeatherXMLConsts_CT2958529.SKY;
		var strXMLFeelsLikeF		= EBWeatherXMLConsts_CT2958529.FEELS_LIKE_F;
		var strXMLFeelsLikeC		= EBWeatherXMLConsts_CT2958529.FEELS_LIKE_C;
		var strXMLIcon				= EBWeatherXMLConsts_CT2958529.ICON;
		var strXMLButtonIcon		= EBWeatherXMLConsts_CT2958529.BUTTON_ICON;
		var strXMLTooltipIcon		= EBWeatherXMLConsts_CT2958529.TOOLTIP_ICON;
	
		var XMLRoot			= XMLNode.ownerDocument ? XMLNode : XMLNode.documentElement;
		var XMLChildNode	= null;
		if(XMLRoot.tagName == strXMLCurrentCondition)
		{
			for(var i=0;i<XMLRoot.childNodes.length;i++)
			{
				XMLChildNode = XMLRoot.childNodes[i];
				if(XMLChildNode.tagName == strXMLTempF)
				{
					strTempF = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLTempC)
				{
					strTempC = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLWeatherText)
				{
					strWeatherText = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLSky)
				{
					strSky = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLFeelsLikeF)
				{
					strFeelsLikeF = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLFeelsLikeC)
				{
					strFeelsLikeC = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLIcon)
				{
					strIcon = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLButtonIcon)
				{
					strButtonIcon = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
				else if(XMLChildNode.tagName == strXMLTooltipIcon)
				{
					strTooltipIcon = EBXML_CT2958529.GetXmlNodeValue(XMLChildNode);
				}
			}
			
			
			oWeatherCurrentCondition = new EBWeatherCurrentCondition_CT2958529(strTempF,
												strTempC,
												strWeatherText,
												strSky,
												strFeelsLikeF,
												strFeelsLikeC,
												strIcon,
												strButtonIcon,
												strTooltipIcon);
		}
		
		return oWeatherCurrentCondition;
		
	}
	
	
	
}



var EBWeatherDialogConsts_CT2958529 =
{
    XULFileName: 'weather.xul',
    XULFileNameRTL: 'weatherRTL.xul',
    XULOldAPIFileName: 'oldapi/weather_oldapi.xul',
    DialogName: 'weatherDialogName_CT2958529',
    DialogType: 'EBWeatherDialog_CT2958529',
    DefaultSearchBoxValue: 'Search for a country or city name',
    SearchCaption: 'Search',
    SelectCaption: 'Select',
    ChangeToCaption: 'Change to',
    DialogWidth: 458,
    DialogHeight: 279,

    Attributes:
	{
	    LocationID: 'EB_WEATHER_LOCATION_ID'
	},

    Panels:
	{
	    SearchSelectPanel: 1,
	    SelectPanel: 2,
	    ForecastPanel: 3,
	    ErrorPanel: 4
	}
};

var EBWeatherDialogManager_CT2958529 =
{
    //instance to save the weather search after a search has been made
    CurrentWeatherSearch: null,

    //instance to save the weather forecast
    CurrentWeatherForecast: null,

    //instance to save the weather current city
    CurrentWeatherSuggestion: null,

    //instance of the http request object to abort it on close 
    //of the dialog
    XMLHTTPRequest: null,

    Open: function(iX, iY) {
        var strChromePath = '';

        if (EBGlobalManager_CT2958529.IsNewestBrowserAPI()) {
            var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
            var direction = objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.DialogsAlignMode, true);

            if (!direction) direction = "ltr";

            if (direction.toLowerCase() == 'rtl')
                strChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + EBWeatherDialogConsts_CT2958529.XULFileNameRTL;
            else
                strChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + EBWeatherDialogConsts_CT2958529.XULFileName;
        }
        else {
            strChromePath = EBGlobalConsts_CT2958529.ChromeContentPath + EBWeatherDialogConsts_CT2958529.XULOldAPIFileName;
        }

        EBGlobalManager_CT2958529.OpenDialog(strChromePath,
							EBWeatherDialogConsts_CT2958529.DialogName,
							'chrome,dependent,resizable=no,titlebar=yes,screenX=' + iX + ',screenY=' + iY);

    },

    OnLoadDialog: function() {
        //usage
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        objWindow.EBUsageWeather_CT2958529.OnOpenWindow();

        //Apply language pack on dialog
        EBWeatherLanguagePack_CT2958529.Apply();

        this.SetDefaultElements();
        //check which panel to load - forecast or search-select
        var oWeatherForecast = EBWeatherManager_CT2958529.LoadWeatherForecast();
        var oWeatherSuggestionCurrent = EBWeatherManager_CT2958529.LoadWeatherCurrentCity();

        if (oWeatherForecast && oWeatherSuggestionCurrent && !EBWeatherManager_CT2958529.IsTimeElapsed())
            this.LoadForecastPanel(oWeatherForecast, oWeatherSuggestionCurrent);
        else
            this.LoadSearchSelectPanel();

    },

    SetDefaultElements: function() {
        this.HideSearchSelectErrorMsg();
        this.SetSearchSelectLoadingMode(false);
        this.SetSelectLoadingMode(false);
    },

    OnUnLoadDialog: function() {
        this.KillHTTPRequest();
    },

    KillHTTPRequest: function() {
        if (this.XMLHTTPRequest) {
            this.XMLHTTPRequest.abort();
        }
    },

    OnBlurDialog: function(event) {
        if (event.eventPhase == 2) {
            window.close()
            //firefox bug is when you close one xul window, the others are moved
            //to back in z-order, so we focus() on the last focused PopHtmlWindow
            //and it gets all such window to front. (only on window platform)
            if (EBGlobalManager_CT2958529.IsWindowsPlatform()) {
                var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
                oWindow.setTimeout(function() { oWindow.EBGadgetManager_CT2958529.BringToFront(); }, 1);
            }
        }
    },

    LoadSearchSelectPanel: function() {
        //set the default text to the search box
        var strSearchMsg = EBWeatherDialogConsts_CT2958529.DefaultSearchBoxValue;
        var oSearchBox = document.getElementById('txtSearchBox');
        oSearchBox.value = strSearchMsg;

        //load the search history and set all the radio elements according it
        this.LoadSearchData();

        //check if to enable the back button (if there is forecast to show)
        var oButtonBack1 = document.getElementById('btnBack1');
        oButtonBack1.disabled = this.CurrentWeatherForecast ? false : true;

        //switch to the first panel
        this.SwitchToPanel(EBWeatherDialogConsts_CT2958529.Panels.SearchSelectPanel);
        try {
            MoveHistoryLocationsBlock();
        }
        catch (ex) {
            //EBLogging_CT2958529.LogToConsole(ex);
        }
    },

    LoadSearchData: function() {
        var oRadioGroupSearchResults = document.getElementById('radioGroupSearchResults');
        var oRadioHistoryCity3 = document.getElementById('radHistoryCity3');
        var oRadioHistoryCity2 = document.getElementById('radHistoryCity2');
        var oRadioHistoryCity1 = document.getElementById('radHistoryCity1');
        var oRadioCurrentCity = document.getElementById('radCurrentCity');
        var oRadioSearchBox = document.getElementById('radSearchBox');

        //hide first all cities radio boxes
        this.ShowHideXULObject(oRadioCurrentCity, false);
        this.ShowHideXULObject(oRadioHistoryCity1, false);
        this.ShowHideXULObject(oRadioHistoryCity2, false);
        this.ShowHideXULObject(oRadioHistoryCity3, false);

        var oWeatherSearchHistory = EBWeatherManager_CT2958529.LoadWeatherHistory();

        var bIsHistoryItems = false;

        if (oWeatherSearchHistory) {
            var oWeatherSuggestionCollection = oWeatherSearchHistory.SuggestionCollection;
            var oWeatherSuggestionCurrent = oWeatherSuggestionCollection.Collection.GetItem(0);

            if (oWeatherSuggestionCurrent) {
                bIsHistoryItems = true;
                this.ShowHideXULObject(oRadioCurrentCity, true);
                this.SetXULWeatherSuggestionAttributes(oRadioCurrentCity, oWeatherSuggestionCurrent);

                this.LoadSearchHistoryData(oWeatherSuggestionCollection);

                oRadioGroupSearchResults.selectedItem = oRadioCurrentCity;
            }
        }

        //if there isn't any history items the mode is search 
        if (!bIsHistoryItems) {
            oRadioGroupSearchResults.selectedItem = oRadioSearchBox;
        }
    },

    //set to the xul the caption and the special attribute location id
    //this will made to the choises radio boxes and the search results combo items
    //cause their both have the same attributes
    SetXULWeatherSuggestionAttributes: function(oXULElement, oWeatherSuggestion) {
        var strCaption = this.GetCityCountryCaption(oWeatherSuggestion);
        var strLocationID = oWeatherSuggestion.LocationID;
        //set the full label caption
        oXULElement.setAttribute('label', strCaption);
        //set the special location id attribute
        oXULElement.setAttribute(EBWeatherDialogConsts_CT2958529.Attributes.LocationID, strLocationID);
    },

    LoadSearchHistoryData: function(oWeatherSuggestionCollection) {
        var oWeatherSuggestionHistory1 = oWeatherSuggestionCollection.Collection.GetItem(1);
        var oWeatherSuggestionHistory2 = oWeatherSuggestionCollection.Collection.GetItem(2);
        var oWeatherSuggestionHistory3 = oWeatherSuggestionCollection.Collection.GetItem(3);

        //set the radio of the history city data 1-2-3
        //show each radio only if the previous is shown
        if (this.SetRadioHistoryCity(1, oWeatherSuggestionHistory1)) {
            if (this.SetRadioHistoryCity(2, oWeatherSuggestionHistory2)) {
                this.SetRadioHistoryCity(3, oWeatherSuggestionHistory3);
            }
        }
    },

    SetRadioHistoryCity: function(iHistoryIndex, oWeatherSuggestion) {
        var bVisible = false;
        var oRadioHistoryCity = document.getElementById('radHistoryCity' + iHistoryIndex);

        if (oWeatherSuggestion) {
            bVisible = true;
            this.SetXULWeatherSuggestionAttributes(oRadioHistoryCity, oWeatherSuggestion);
        }

        this.ShowHideXULObject(oRadioHistoryCity, bVisible);
        return bVisible;
    },

    ShowHideXULObject: function(oXUL, bShow) {
        var strVisibilityStyle = bShow ? 'visible' : 'hidden';
        oXUL.style.visibility = strVisibilityStyle;
    },

    GetCityCountryCaption: function(oWeatherSuggestion) {
        var strCaption = oWeatherSuggestion.City + ', ' + oWeatherSuggestion.Country;
        return strCaption;
    },

    OnSelectRadioGroupSearchResults: function() {
        //change the label of the search/select button according to the radio selection
        var oRadioGroupSearchResults = document.getElementById('radioGroupSearchResults');
        var oRadioSearchBox = document.getElementById('radSearchBox');

        var oButtonSelectSearch = document.getElementById('btnSelect1');

        var strCaption = '';

        if (oRadioGroupSearchResults.selectedItem == oRadioSearchBox) {
            strCaption = EBWeatherDialogConsts_CT2958529.SearchCaption;
        }
        else {
            strCaption = EBWeatherDialogConsts_CT2958529.SelectCaption;
            //hide the errors messages
            this.HideSearchSelectErrorMsg();
        }

        oButtonSelectSearch.setAttribute('label', strCaption);
        oButtonSelectSearch.accessKey = strCaption.charAt(0);
    },

    OnFocusSearchBox: function(event) {

        var oSearchBox = event.target;
        //check if it's readonly(meaning in the middle of search process)
        if (oSearchBox.getAttribute('readonly') == 'true') {
            return;
        }

        var strSearchMsg = EBWeatherDialogConsts_CT2958529.DefaultSearchBoxValue;
        if (oSearchBox.value == strSearchMsg) {
            oSearchBox.value = '';
        }

        //select the radio search
        var oRadioGroupSearchResults = document.getElementById('radioGroupSearchResults');
        var oRadioSearchBox = document.getElementById('radSearchBox');
        oRadioGroupSearchResults.selectedItem = oRadioSearchBox;

        //hide the errors messages
        this.HideSearchSelectErrorMsg();
    },

    OnBlurSearchBox: function(event) {
        if (event.eventPhase == 2) {
            var oSearchBox = event.target;
            //check if it's readonly(meaning in the middle of search process)
            if (oSearchBox.getAttribute('readonly') == 'true') {
                return;
            }
            if (document.commandDispatcher.focusedElement) {
                window.close();
            }
            else {
                var strSearchMsg = EBWeatherDialogConsts_CT2958529.DefaultSearchBoxValue;
                if (oSearchBox.value == '') {
                    oSearchBox.value = strSearchMsg;
                }

                //hide the errors messages
                this.HideSearchSelectErrorMsg();
            }
        }
    },

    OnKeyPressSearchBox: function(event) {
        if (event.which == 13) {
            this.OnCommandButtonSelectSearch();
        }
    },

    OnKeyPressSearchResultsCombo: function(event) {
        if (event.which == 13) {
            this.OnCommandButtonSelect();
        }
    },

    OnHelp: function() {
        //usage
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBUsageWeather_CT2958529.OnWeatherFeedback();

        var weatherComp = oWindow.EBComponentsManager_CT2958529.GetWeatherComponent();
        if (weatherComp && weatherComp.ComponentItem.helpUrl)
            oWindow.EBWeb_CT2958529.LoadURL(weatherComp.ComponentItem.helpUrl);
    },

    OnCommandButtonSelectSearch: function() {
        var oRadioGroupSearchResults = document.getElementById('radioGroupSearchResults');
        var oRadioSearchBox = document.getElementById('radSearchBox');
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();

        if (oRadioGroupSearchResults.selectedItem == oRadioSearchBox) {
            //usage
            oWindow.EBUsageWeather_CT2958529.OnWeatherSearch();
            this.SearchCityFromTextBox();
        }
        else {
            //usage
            oWindow.EBUsageWeather_CT2958529.OnSelect();
            this.SearchCityFromRadioBox();
        }
    },

    SearchCityFromRadioBox: function() {
        var oRadioGroupSearchResults = document.getElementById('radioGroupSearchResults');
        var oRadioHistoryCity3 = document.getElementById('radHistoryCity3');
        var oRadioHistoryCity2 = document.getElementById('radHistoryCity2');
        var oRadioHistoryCity1 = document.getElementById('radHistoryCity1');
        var oRadioCurrentCity = document.getElementById('radCurrentCity');

        var oXULSelectedRadio = oRadioGroupSearchResults.selectedItem;
        var oWeatherSuggestion = null;

        var oWeatherSearchHistory = EBWeatherManager_CT2958529.LoadWeatherHistory();

        var oWeatherForecast = null;

        if (oWeatherSearchHistory) {
            var oWeatherSuggestionCollection = oWeatherSearchHistory.SuggestionCollection;

            if (oXULSelectedRadio == oRadioCurrentCity) {
                oWeatherSuggestion = oWeatherSuggestionCollection.Collection.GetItem(0);
            }
            else if (oXULSelectedRadio == oRadioHistoryCity1) {
                oWeatherSuggestion = oWeatherSuggestionCollection.Collection.GetItem(1);
            }
            else if (oXULSelectedRadio == oRadioHistoryCity2) {
                oWeatherSuggestion = oWeatherSuggestionCollection.Collection.GetItem(2);
            }
            else if (oXULSelectedRadio == oRadioHistoryCity3) {
                oWeatherSuggestion = oWeatherSuggestionCollection.Collection.GetItem(3);
            }
        }


        if (oWeatherSuggestion) {
            if (oXULSelectedRadio == oRadioCurrentCity) {
                oWeatherForecast = EBWeatherManager_CT2958529.LoadWeatherForecast();
                if (oWeatherForecast) {
                    this.LoadForecastPanel(oWeatherForecast, oWeatherSuggestion);
                }
                else {
                    this.LoadErrorPanel();
                }
            }
            else//only if select a different city then the current i save the new suggestion to the file(re-arrange them) and load the forecast from the server
            {
                //load the forecast from the server
                var strLocationID = oXULSelectedRadio.getAttribute(EBWeatherDialogConsts_CT2958529.Attributes.LocationID);

                var oCallBackFunction = function(XMLDoc, o) {
                    try {
                        if (o.value == EBGlobalConsts_CT2958529.NetworkError) {
                            EBWeatherDialogManager_CT2958529.ShowHideServerUnavailableMsg(true);
                        }
                        else {
                            var oWeatherForecast = null;
                            if (EBWeatherManager_CT2958529.IsValidWeatherXMLDoc(XMLDoc)) {
                                oWeatherForecast = EBWeatherDataFactory_CT2958529.XMLToWeatherForecast(XMLDoc);
                            }

                            if (oWeatherForecast) {
                                //only if success coming from the server - save all to files(history & forecast)
                                EBWeatherDialogManager_CT2958529.SaveWeatherForecastAndWeatherHistory(oWeatherForecast, oWeatherSuggestion);
                                EBWeatherDialogManager_CT2958529.LoadForecastPanel(oWeatherForecast, oWeatherSuggestion);
                            }
                            else {
                                EBWeatherDialogManager_CT2958529.LoadErrorPanel();
                            }
                        }

                        //in any case when coming back from the server 
                        //go back to regular mode
                        EBWeatherDialogManager_CT2958529.SetSearchSelectLoadingMode(false);
                        //nullify the member request object
                        EBWeatherDialogManager_CT2958529.XMLHTTPRequest = null;
                    }
                    catch (ex) { }
                };
                this.SetSearchSelectLoadingMode(true);
                this.ServerRequestForecast(strLocationID, oCallBackFunction);
            }
        }
        else {
            this.LoadErrorPanel();
        }
    },

    SearchCityFromTextBox: function() {
        var oSearchBox = document.getElementById('txtSearchBox');
        var strValue = oSearchBox.value;
        var strDefaultValue = EBWeatherDialogConsts_CT2958529.DefaultSearchBoxValue;

        if (EBGlobalManager_CT2958529.TotalTrim(strValue) && strValue != strDefaultValue) {
            //make the dialog in loading mode
            this.SetSearchSelectLoadingMode(true);

            //make the server request and send an object to check if there was exception
            this.ServerRequestCitySearch(strValue);
        }
        else {
            this.ShowHideCityNotFoundMsg(true);
        }
    },

    //set the mode of the dialog to be loading 
    //(true - disable/hide all and show progressmeter)
    //(false - enable/show all and hide progressmeter)
    SetSearchSelectLoadingMode: function(bValue) {
        var oRadioGroupSearchResults = document.getElementById('radioGroupSearchResults');
        var oRadioHistoryCity3 = document.getElementById('radHistoryCity3');
        var oRadioHistoryCity2 = document.getElementById('radHistoryCity2');
        var oRadioHistoryCity1 = document.getElementById('radHistoryCity1');
        var oRadioCurrentCity = document.getElementById('radCurrentCity');
        var oRadioSearchBox = document.getElementById('radSearchBox');
        var oTextSearchBox = document.getElementById('txtSearchBox');

        var oButtonBack1 = document.getElementById('btnBack1');
        var oButtonSelectSearch = document.getElementById('btnSelect1');

        //disable the radio and the text box
        oRadioGroupSearchResults.disabled = bValue;
        oRadioHistoryCity3.disabled = bValue;
        oRadioHistoryCity2.disabled = bValue;
        oRadioHistoryCity1.disabled = bValue;
        oRadioCurrentCity.disabled = bValue;
        oRadioSearchBox.disabled = bValue;


        //set the readonly and not the disabled cause it's causes a bug
        //with the textbox when enable it the cursor disappeared
        if (bValue) {
            oTextSearchBox.setAttribute('readonly', 'true');
        }
        else {
            oTextSearchBox.removeAttribute('readonly');
        }


        //hide the buttons
        this.ShowHideXULObject(oButtonBack1, !bValue);
        this.ShowHideXULObject(oButtonSelectSearch, !bValue);

        //handle the progressmeter
        //get the box of the progressmeter
        var oProgressMeterBox = document.getElementById('progBox1');
        //empty it (if there is progressmeter in it)
        if (oProgressMeterBox.firstChild) {
            oProgressMeterBox.removeChild(oProgressMeterBox.firstChild);
        }
        var oProgressMeter = null;
        if (bValue) {
            oProgressMeter = this.CreateProgressMeter();
            oProgressMeterBox.appendChild(oProgressMeter);
        }
    },

    SetSelectLoadingMode: function(bValue) {
        var oSearchResultsCombo = document.getElementById('ebWeatherSearchResultsCombo');

        var oButtonBack2 = document.getElementById('btnBack2');
        var oButtonSelect = document.getElementById('btnSelect2');

        //disable combo
        oSearchResultsCombo.disabled = bValue;

        //hide the buttons
        this.ShowHideXULObject(oButtonBack2, !bValue);
        this.ShowHideXULObject(oButtonSelect, !bValue);

        //handle the progressmeter
        //get the box of the progressmeter
        var oProgressMeterBox = document.getElementById('progBox2');
        //empty it (if there is progressmeter in it)
        if (oProgressMeterBox.firstChild) {
            oProgressMeterBox.removeChild(oProgressMeterBox.firstChild);
        }
        var oProgressMeter = null;
        if (bValue) {
            oProgressMeter = this.CreateProgressMeter();
            oProgressMeterBox.appendChild(oProgressMeter);
        }

    },

    CreateProgressMeter: function() {
        var oProgressMeter = document.createElement('progressmeter');
        oProgressMeter.setAttribute('mode', 'undetermined');
        return oProgressMeter;
    },

    ServerRequestCitySearch: function(strSearchTerm) {
        var oWeatherSearch = null;

        var strServerURL = EBWeatherManager_CT2958529.GetWeatherServerURL();
        //assembley the full url

        var strFullServerURL = strServerURL + EBWeatherManager_CT2958529.ReplaceAliases(EBWeatherConsts_CT2958529.URL.QS_SEARCH) + strSearchTerm;

        var oCallBackFunction = EBWeatherDialogManager_CT2958529.ServerResponseCitySearch;

        //get the source from the server and save the http request to this class to
        //retrieve it when closing the dialog for abortion
        this.XMLHTTPRequest = EBWeatherManager_CT2958529.ServerRequest(strFullServerURL, oCallBackFunction);
    },

    //since this call is coming from the server all the calls
    //to this class functions is using the full name of the class
    //and not just this.
    ServerResponseCitySearch: function(XMLDoc, o) {
        try {
            //check if there was server error(no internet etc...)
            if (o.value == EBGlobalConsts_CT2958529.NetworkError) {
                EBWeatherDialogManager_CT2958529.ShowHideServerUnavailableMsg(true);
            }
            else {
                var oWeatherSearch = null;
                if (EBWeatherManager_CT2958529.IsValidWeatherXMLDoc(XMLDoc)) {
                    //get the object via the xml(if failed null is been returned
                    oWeatherSearch = EBWeatherDataFactory_CT2958529.XMLToWeatherSearch(XMLDoc);
                }

                if (oWeatherSearch) {
                    EBWeatherDialogManager_CT2958529.LoadSelectPanel(oWeatherSearch);
                }
                else {
                    //show the not found msg if it's illegal term
                    EBWeatherDialogManager_CT2958529.ShowHideCityNotFoundMsg(true);
                }
            }

            //in any case remove the loading mode of the dialog at the end of the response
            EBWeatherDialogManager_CT2958529.SetSearchSelectLoadingMode(false);
            //nullify the request object
            EBWeatherDialogManager_CT2958529.XMLHTTPRequest = null;
        }
        catch (ex) { }
    },

    ServerRequestForecast: function(strLocationID, oCallBackFunction) {
        var oWeatherForecast = null;

        var strServerURL = EBWeatherManager_CT2958529.GetWeatherServerURL();
        //assembley the full url
        var strFullServerURL = strServerURL + EBWeatherManager_CT2958529.ReplaceAliases(EBWeatherConsts_CT2958529.URL.QS_FORECAST) + strLocationID;

        //get the source from the server and save the http request to this class to
        //retrieve it when closing the dialog for abortion
        this.XMLHTTPRequest = EBWeatherManager_CT2958529.ServerRequest(strFullServerURL, oCallBackFunction);
    },

    HideSearchSelectErrorMsg: function() {
        this.ShowHideCityNotFoundMsg(false);
        this.ShowHideServerUnavailableMsg(false);
    },

    ShowHideCityNotFoundMsg: function(bShow) {
        var oLabelCityNotFound = document.getElementById('lblCityNotFound');
        this.ShowHideXULObject(oLabelCityNotFound, bShow);
    },

    ShowHideServerUnavailableMsg: function(bShow) {
        var oLabelUnavailableMsg = document.getElementById('lblServiceUnavailable');
        this.ShowHideXULObject(oLabelUnavailableMsg, bShow);
    },

    NullifyAllAccessKey: function() {
        var oButtonBack1 = document.getElementById('btnBack1');
        var oButtonSelect1 = document.getElementById('btnSelect1');

        var oButtonBack2 = document.getElementById('btnBack2');
        var oButtonSelect2 = document.getElementById('btnSelect2');

        var oButtonBack4 = document.getElementById('btnBack4');
        var oButtonSelect4 = document.getElementById('btnSelect4');

        oButtonBack1.removeAttribute('accesskey');
        oButtonSelect1.removeAttribute('accesskey');

        oButtonBack2.removeAttribute('accesskey');
        oButtonSelect2.removeAttribute('accesskey');

        oButtonBack4.removeAttribute('accesskey');
        oButtonSelect4.removeAttribute('accesskey');
    },

    SwitchToPanel: function(iPanelIndex) {
        var oWeatherMain = document.getElementById('weatherMain');
        var oWeatherSelectedPanel = document.getElementById('weatherPanel' + iPanelIndex);

        //when switching to panel we set the access key to the back-select buttons
        //we can't set the access key in the xul since it's in the same window and in the same letters('S' and 'B')
        //so the last definition override the rest
        this.NullifyAllAccessKey();
        //set the access key to the chosen panel
        var oButtonBack = document.getElementById('btnBack' + iPanelIndex);
        var oButtonSelect = document.getElementById('btnSelect' + iPanelIndex);
        if (oButtonBack && oButtonSelect) {
            oButtonBack.setAttribute('accesskey', oButtonBack.label.charAt(3));
            oButtonSelect.setAttribute('accesskey', oButtonSelect.label.charAt(0));
        }

        oWeatherMain.selectedPanel = oWeatherSelectedPanel;

    },

    LoadSelectPanel: function(oWeatherSearch) {
        var oButtonSelect = document.getElementById('btnSelect2');
        oButtonSelect.focus();

        //switch the deck to panel 2
        this.SwitchToPanel(EBWeatherDialogConsts_CT2958529.Panels.SelectPanel);

        //save the weather search data object to retrieve it in the selection
        this.CurrentWeatherSearch = oWeatherSearch;

        //populate the combo with the search results
        var oComboSearchResults = document.getElementById('ebWeatherSearchResultsCombo');
        var oMenuPopup = oComboSearchResults.firstChild;
        //empty the menu popup
        while (oMenuPopup.childNodes.length > 0) {
            oMenuPopup.removeChild(oMenuPopup.firstChild);
        }

        //get the collection from the search object	
        var oCollection = oWeatherSearch.SuggestionCollection.Collection;

        var oWeatherSuggestion = null;
        var oXULMenuItem = null;
        var strLabel = '';
        var strLocationID = '';

        for (var i = 0; i < oCollection.Arr.length; i++) {
            oWeatherSuggestion = oCollection.GetItem(i);

            oXULMenuItem = document.createElement('menuitem');
            this.SetXULWeatherSuggestionAttributes(oXULMenuItem, oWeatherSuggestion);

            oMenuPopup.appendChild(oXULMenuItem);
        }

        if (oMenuPopup.childNodes.length > 0) {
            oComboSearchResults.selectedIndex = 0;
        }


    },

    OnCommandButtonBack1: function() {
        //back to the forecast panel
        //this button is enabled in the first panel load only if there 
        //is a forecast to show(the this.CurrentWeatherForecast is set)
        this.SwitchToPanel(EBWeatherDialogConsts_CT2958529.Panels.ForecastPanel);
    },

    OnCommandButtonBack2: function() {
        //go back to the first dialog without loading it from the file
        //meaning back to the last situation the user left it.
        this.SwitchToPanel(EBWeatherDialogConsts_CT2958529.Panels.SearchSelectPanel);
    },

    OnCommandButtonBack3: function() {
        this.LoadSearchSelectPanel();
    },



    OnCommandButtonSelect: function() {
        var oComboSearchResults = document.getElementById('ebWeatherSearchResultsCombo');
        var oMenuItem = oComboSearchResults.selectedItem;
        var iSelectedIndex = oComboSearchResults.selectedIndex;

        //get the location id from the special attribute:
        var strLocationID = oMenuItem.getAttribute(EBWeatherDialogConsts_CT2958529.Attributes.LocationID);

        var oCallBackFunction = function(XMLDoc, o) {
            try {
                if (o.value == EBGlobalConsts_CT2958529.NetworkError) {
                    EBWeatherDialogManager_CT2958529.LoadErrorPanel();
                }
                else {
                    var oWeatherForecast = null;
                    if (EBWeatherManager_CT2958529.IsValidWeatherXMLDoc(XMLDoc)) {
                        oWeatherForecast = EBWeatherDataFactory_CT2958529.XMLToWeatherForecast(XMLDoc);
                    }
                    if (oWeatherForecast) {
                        //get the chosen search suggestion
                        var oWeatherSearch = EBWeatherDialogManager_CT2958529.CurrentWeatherSearch;
                        var oCollection = oWeatherSearch.SuggestionCollection.Collection;
                        var oWeatherSuggestion = oCollection.GetItem(iSelectedIndex);

                        if (oWeatherSuggestion) {
                            EBWeatherDialogManager_CT2958529.SaveWeatherForecastAndWeatherHistory(oWeatherForecast, oWeatherSuggestion);
                            //load the forecast panel
                            EBWeatherDialogManager_CT2958529.LoadForecastPanel(oWeatherForecast, oWeatherSuggestion);
                        }
                        else {
                            EBWeatherDialogManager_CT2958529.LoadErrorPanel();
                        }
                    }
                    else {
                        EBWeatherDialogManager_CT2958529.LoadErrorPanel();
                    }
                    //in any case when coming back from the server 
                    //go back to regular mode
                    EBWeatherDialogManager_CT2958529.SetSelectLoadingMode(false);
                    //nullify the member request object
                    EBWeatherDialogManager_CT2958529.XMLHTTPRequest = null;
                }
            }
            catch (ex) { }
        };
        this.SetSelectLoadingMode(true);
        this.ServerRequestForecast(strLocationID, oCallBackFunction);
    },

    //save the weather forecast and history from the dialog:
    //1.save the suggestions history (re-arrange them if needed)
    //2.save the forecast to the file
    //3.update the poll date
    //4.broadcast cahnges to browsers
    SaveWeatherForecastAndWeatherHistory: function(oWeatherForecast, oWeatherSuggestionCurrent) {
        //save the new suggestion
        EBWeatherManager_CT2958529.SaveSuggestionsHistory(oWeatherSuggestionCurrent);
        //save the forecast to the file
        EBWeatherManager_CT2958529.SaveWeatherForecast(oWeatherForecast);
        //update the polldate to now:
        EBWeatherPreferencesManager_CT2958529.SetWeatherPollDate();
        //broadcast changes to all browsers
        EBWeatherManager_CT2958529.Broadcast(EBWeatherStateConsts_CT2958529.FORECAST, oWeatherForecast, oWeatherSuggestionCurrent);

    },

    OnClickLabelChangeTo: function() {
        var strUnitValueToSet = '';
        var strPrefUnit = EBWeatherPreferencesManager_CT2958529.GetWeatherUnits();
        var strUnitTemperatureF = EBWeatherUnits_CT2958529.TEMPERATURE_F;
        var strUnitTemperatureC = EBWeatherUnits_CT2958529.TEMPERATURE_C;

        if (strPrefUnit == strUnitTemperatureC)
            strUnitValueToSet = strUnitTemperatureF;
        else
            strUnitValueToSet = strUnitTemperatureC;

        //usage
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBUsageWeather_CT2958529.OnChangeCF(strUnitValueToSet);

        EBWeatherPreferencesManager_CT2958529.SetWeatherUnit(strUnitValueToSet);

        this.SetTemperatureUnitElements();

        //broadcast changes to the button in all browsers
        EBWeatherManager_CT2958529.Broadcast(EBWeatherStateConsts_CT2958529.FORECAST, this.CurrentWeatherForecast, this.CurrentWeatherSuggestion);
    },

    OnClickLabelChangeLocation: function() {
        //usage
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBUsageWeather_CT2958529.OnChangeLocation();

        this.LoadSearchSelectPanel();
    },

    ExtendedForecast: function(event) {
        //usage
        var oWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        oWindow.EBUsageWeather_CT2958529.OnExtendedForcast();

        window.close();
        EBWeatherManager_CT2958529.LoadWeatherWebSearch(event, this.CurrentWeatherForecast, this.CurrentWeatherSuggestion);
    },

    LoadForecastPanel: function(oWeatherForecast, oWeatherSuggestion) {
        this.CurrentWeatherForecast = oWeatherForecast;
        this.CurrentWeatherSuggestion = oWeatherSuggestion;

        //set the caption of the city,country
        var oLabelCityCountryCaption = document.getElementById('lblCityCountryCaption');
        var strLabel = this.GetCityCountryCaption(oWeatherSuggestion);
        //validate if it's too long string we present only the city
        if (strLabel.length > 25) {
            strLabel = oWeatherSuggestion.City;
        }

        oLabelCityCountryCaption.setAttribute('value', strLabel);

        //set the current condition elements
        this.SetCurrentConditionElements(oWeatherForecast);
        //set the days elements
        this.SetDaysElements(oWeatherForecast);
        //set the units elements
        this.SetTemperatureUnitElements();

        this.SwitchToPanel(EBWeatherDialogConsts_CT2958529.Panels.ForecastPanel);

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var dialogsDirection = objWindow.EBGlobalManager_CT2958529.IsReverseDialogs();

        if (dialogsDirection == 'rtl')
            MoveLocationName();
    },

    SetCurrentConditionElements: function(oWeatherForecast) {
        var oLabelCCSky = document.getElementById('lblCurrentConditionSky');
        var oImageCCConditionIcon = document.getElementById('imgCurrentConditionIcon');

        var oWeatherCurrentCondition = oWeatherForecast.CurrentCondition;

        var strSky = oWeatherCurrentCondition.Sky;
        var strIcon = oWeatherCurrentCondition.Icon;

        oLabelCCSky.setAttribute('value', strSky);
        oImageCCConditionIcon.setAttribute('src', strIcon);

    },

    SetDaysElements: function(oWeatherForecast) {
        var oLabelDay1 = document.getElementById('lblDay1');
        var oImageDay1Icon = document.getElementById('imgDay1Icon');
        var oLabelDay1CD = document.getElementById('lblDay1ConditionDescription');

        var oLabelDay2 = document.getElementById('lblDay2');
        var oImageDay2Icon = document.getElementById('imgDay2Icon');
        var oLabelDay2CD = document.getElementById('lblDay2ConditionDescription');

        var oLabelDay3 = document.getElementById('lblDay3');
        var oImageDay3Icon = document.getElementById('imgDay3Icon');
        var oLabelDay3CD = document.getElementById('lblDay3ConditionDescription');

        var strDay1 = '';
        var strDay1Icon = '';
        var strDay1CD = '';

        var strDay2 = '';
        var strDay2Icon = '';
        var strDay2CD = '';

        var strDay3 = '';
        var strDay3Icon = '';
        var strDay3CD = '';

        var oWeatherDaysCollection = oWeatherForecast.DayCollection;

        var oWeatherDay1 = oWeatherDaysCollection.Collection.GetItem(0);
        var oWeatherDay2 = oWeatherDaysCollection.Collection.GetItem(1);
        var oWeatherDay3 = oWeatherDaysCollection.Collection.GetItem(2);

        if (oWeatherDay1) {
            strDay1 = oWeatherDay1.Day;
            strDay1Icon = oWeatherDay1.ConditionIcon;
            strDay1CD = oWeatherDay1.ConditionDescription;
        }

        if (oWeatherDay2) {
            strDay2 = oWeatherDay2.Day;
            strDay2Icon = oWeatherDay2.ConditionIcon;
            strDay2CD = oWeatherDay2.ConditionDescription;
        }

        if (oWeatherDay3) {
            strDay3 = oWeatherDay3.Day;
            strDay3Icon = oWeatherDay3.ConditionIcon;
            strDay3CD = oWeatherDay3.ConditionDescription;
        }

        oLabelDay1.setAttribute('value', strDay1);
        oImageDay1Icon.setAttribute('src', strDay1Icon);
        oLabelDay1CD.setAttribute('value', strDay1CD);

        oLabelDay2.setAttribute('value', strDay2);
        oImageDay2Icon.setAttribute('src', strDay2Icon);
        oLabelDay2CD.setAttribute('value', strDay2CD);

        oLabelDay3.setAttribute('value', strDay3);
        oImageDay3Icon.setAttribute('src', strDay3Icon);
        oLabelDay3CD.setAttribute('value', strDay3CD);

    },

    SetTemperatureUnitElements: function() {
        var oWeatherForecast = this.CurrentWeatherForecast;

        var strDegreeSymbol = EBGlobalConsts_CT2958529.DegreeSymbol;

        var strPrefUnit = EBWeatherPreferencesManager_CT2958529.GetWeatherUnits();
        var strUnitTemperatureF = EBWeatherUnits_CT2958529.TEMPERATURE_F;
        var strUnitTemperatureC = EBWeatherUnits_CT2958529.TEMPERATURE_C;

        var strCahngeTo = '';
        var strCCFeelsLike = '';
        var strCCTemperature = '';
        var strCCTemperatureText = '';

        var strDay1TempMax = '';
        var strDay1TempMin = '';

        var strDay2TempMax = '';
        var strDay2TempMin = '';

        var strDay3TempMax = '';
        var strDay3TempMin = '';


        var oLabelChangeTo = document.getElementById('lblChangeTo');
        var oLabelCCFeelsLike = document.getElementById('lblCurrentConditionFeelsLike');
        var oLabelCCTemperature = document.getElementById('lblCurrentConditionTemperature');
        var oLabelCCTemperatureText = document.getElementById('lblCurrentConditionTemperatureText');

        var oLabelDay1TempMax = document.getElementById('lblDay1TemperatureMax');
        var oLabelDay1TempMin = document.getElementById('lblDay1TemperatureMin');

        var oLabelDay2TempMax = document.getElementById('lblDay2TemperatureMax');
        var oLabelDay2TempMin = document.getElementById('lblDay2TemperatureMin');

        var oLabelDay3TempMax = document.getElementById('lblDay3TemperatureMax');
        var oLabelDay3TempMin = document.getElementById('lblDay3TemperatureMin');

        var oWeatherCurrentCondition = oWeatherForecast.CurrentCondition;

        var oWeatherDaysCollection = oWeatherForecast.DayCollection;

        var oWeatherDay1 = oWeatherDaysCollection.Collection.GetItem(0);
        var oWeatherDay2 = oWeatherDaysCollection.Collection.GetItem(1);
        var oWeatherDay3 = oWeatherDaysCollection.Collection.GetItem(2);

        if (strPrefUnit == strUnitTemperatureC) {
            strCahngeTo = EBWeatherDialogConsts_CT2958529.ChangeToCaption + ' ' + strUnitTemperatureF + strDegreeSymbol;

            strCCFeelsLike = oWeatherCurrentCondition.FeelsLikeC + strDegreeSymbol;
            strCCTemperature = oWeatherCurrentCondition.TempC + strDegreeSymbol;
            strCCTemperatureText = strUnitTemperatureC.toUpperCase();

            if (oWeatherDay1) {
                strDay1TempMax = oWeatherDay1.CMax + strDegreeSymbol;
                strDay1TempMin = oWeatherDay1.CMin + strDegreeSymbol;
            }

            if (oWeatherDay2) {
                strDay2TempMax = oWeatherDay2.CMax + strDegreeSymbol;
                strDay2TempMin = oWeatherDay2.CMin + strDegreeSymbol;
            }

            if (oWeatherDay3) {
                strDay3TempMax = oWeatherDay3.CMax + strDegreeSymbol;
                strDay3TempMin = oWeatherDay3.CMin + strDegreeSymbol;
            }
        }
        else {
            strCahngeTo = EBWeatherDialogConsts_CT2958529.ChangeToCaption + ' ' + strUnitTemperatureC + strDegreeSymbol;

            strCCFeelsLike = oWeatherCurrentCondition.FeelsLikeF + strDegreeSymbol;
            strCCTemperature = oWeatherCurrentCondition.TempF + strDegreeSymbol;
            strCCTemperatureText = strUnitTemperatureF.toUpperCase();

            if (oWeatherDay1) {
                strDay1TempMax = oWeatherDay1.FMax + strDegreeSymbol;
                strDay1TempMin = oWeatherDay1.FMin + strDegreeSymbol;
            }

            if (oWeatherDay2) {
                strDay2TempMax = oWeatherDay2.FMax + strDegreeSymbol;
                strDay2TempMin = oWeatherDay2.FMin + strDegreeSymbol;
            }

            if (oWeatherDay3) {
                strDay3TempMax = oWeatherDay3.FMax + strDegreeSymbol;
                strDay3TempMin = oWeatherDay3.FMin + strDegreeSymbol;
            }
        }

        oLabelChangeTo.setAttribute('value', strCahngeTo);
        oLabelCCFeelsLike.setAttribute('value', strCCFeelsLike);
        oLabelCCTemperature.setAttribute('value', strCCTemperature);
        oLabelCCTemperatureText.setAttribute('value', strCCTemperatureText);
        oLabelDay1TempMax.setAttribute('value', strDay1TempMax);
        oLabelDay1TempMin.setAttribute('value', strDay1TempMin);

        oLabelDay2TempMax.setAttribute('value', strDay2TempMax);
        oLabelDay2TempMin.setAttribute('value', strDay2TempMin);

        oLabelDay3TempMax.setAttribute('value', strDay3TempMax);
        oLabelDay3TempMin.setAttribute('value', strDay3TempMin);


    },

    LoadErrorPanel: function() {
        //set the focus on the back
        var oButtonBack4 = document.getElementById('btnBack4');
        oButtonBack4.focus();

        this.SwitchToPanel(EBWeatherDialogConsts_CT2958529.Panels.ErrorPanel);
    },

    GetDialog: function() {
        var strWeatherDialogType = EBWeatherDialogConsts_CT2958529.DialogType;
        var strWeatherDialogName = EBWeatherDialogConsts_CT2958529.DialogName;

        var oWeatherDialog = EBGlobalManager_CT2958529.GetXULWindowByTypeAndName(strWeatherDialogType, strWeatherDialogName);

        return oWeatherDialog;
    },

    Close: function() {
        var oWeatherDialog = this.GetDialog();
        if (oWeatherDialog) {
            oWeatherDialog.close();
        }
    }

}

var EBWeatherConsts_CT2958529 = 
{
	DefaultInterval : 20,
	
	URL	: 
	{
	    DefaultServer: 'http://weather.services.conduit.com/weatherrequest.ctp',
		QS_SEARCH			: '?type=search&platform=fx&source=1&ctid=CT2958529&octid=ORIGINAL_CT_ID&locale=LOCALE&cityname=',
		QS_FORECAST			: '?type=forecast&imagetype=DEFAULT&locale=LOCALE&locationid=',
		DefaultWebSearch	: 'http://search.conduit.com/'
	},
	
	Tooltip :
	{
	    Caption     : 'The weather in',
	    FeelsLike   : 'Feels like:',
	    Sky         : 'Sky:'
	}
}

var EBWeatherStateConsts_CT2958529 = 
{
	UNAVAILABLE : -1,
	START		: 0,
	FORECAST	: 1
}

var EBWeatherIFeelLuckyConsts_CT2958529 = 
{
	ErrorInterval			: 24,  // 24 hours
	CityNotFoundInterval	: 24*7, // one week
	IFeelLuckyText			: 'ebifeellucky'
}

var EBWeatherGUIConsts_CT2958529 = 
{
	Caption					: 'Weather',
	ForecastTooltipID		: 'EBWeatherForecastTooltip_CT2958529',
	Image					: 'chrome://browsersearch/skin/weather.png',
	DefaultImage            : 'chrome://browsersearch/skin/weather.png',
	ImageNA					: 'chrome://browsersearch/skin/weather_na.png',
	CaptionNA				: 'No Data',
	ScaleXmlTag             : 'TEMPERATURE_SCALE',
	ScaleF: 'Fahrenheit',
	ScaleC: 'Celsius'
}

//manager of the weather data.
//each load function is load the data from a file and return it object data
//each save function is the opposite - from an object back to the file
var EBWeatherManager_CT2958529 =
{
    TimeoutID: null,

    //timeout interval set to one minute
    TimeoutInterval: 60000,

    ActivateTimeoutInterval: 1000,

    Initialize: function() {
        this.Start();
    },

    Terminate: function() {
        this.ClearTimeoutID();
    },

    ClearTimeoutID: function() {
        if (this.TimeoutID) {
            clearTimeout(this.TimeoutID);
            this.TimeoutID = null;
        }
    },

    //when the toolbar loads there is a check if there is 
    //current city suggestion - this is the indication that the toolbar
    //made search and need to activated the check mechanism
    //if not - the toolbarbutton displays regular weather button
    Start: function() {
        var oWeatherSuggestionCurrent = this.LoadWeatherCurrentCity();
        if (oWeatherSuggestionCurrent) {
            var oWeatherForecast = this.LoadWeatherForecast();
            if (oWeatherForecast && !this.IsTimeElapsed()) {
                this.SetToolbarButtonForecast(oWeatherForecast, oWeatherSuggestionCurrent);
            }
            else {
                if (!oWeatherForecast)
                    this.TimeoutCheck(true);

                this.SetToolbarButtonStart();
            }

            this.ActivateTimeoutCheck();

        }
        else {
            this.SetToolbarButtonStart();
            this.IFeelLucky();

        }
    },

    IsTimeToCheckIFeelLucky: function() {
        var WeatherNextIFeelLuckyCheck = EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.WeatherNextIFeelLuckyCheck);
        var now = Date();
        if (WeatherNextIFeelLuckyCheck == null) {
            WeatherNextIFeelLuckyCheck = now;
        }
        var milliDif = Date.parse(now) - Date.parse(WeatherNextIFeelLuckyCheck);
        if (milliDif >= 0) {
            return true;
        }
        else {
            return false;
        }
    },

    SetUnitsType: function(xmlHistory) {
        var strWeatherUnit;
        var strScale = EBXML_CT2958529.GetSingleNodeValue(xmlHistory, EBWeatherGUIConsts_CT2958529.ScaleXmlTag);

        if (!strScale)
            strWeatherUnit = EBWeatherUnits_CT2958529.TEMPERATURE_C;
        else {
            if (strScale == EBWeatherGUIConsts_CT2958529.ScaleF)
                strWeatherUnit = EBWeatherUnits_CT2958529.TEMPERATURE_F;
            else
                strWeatherUnit = EBWeatherUnits_CT2958529.TEMPERATURE_C;
        }

        EBWeatherPreferencesManager_CT2958529.SetWeatherUnit(strWeatherUnit);
    },

    IFeelLucky: function() {
        //need to activate i feel lucky
        if (this.IsTimeToCheckIFeelLucky()) {
            var oCallBackFunction = function(XMLDoc, o) {
                try {
                    if (o.value == EBGlobalConsts_CT2958529.NetworkError) {
                        EBWeatherManager_CT2958529.SetNextIFeelLuckyCheck(EBWeatherIFeelLuckyConsts_CT2958529.ErrorInterval);
                        EBWeatherManager_CT2958529.SetToolbarButtonStart();
                    }
                    else {
                        if (EBWeatherManager_CT2958529.IsValidWeatherXMLDoc(XMLDoc)) {
                            var strXMLSearch = EBXML_CT2958529.GetStringXml(XMLDoc);
                            EBWeatherIOManager_CT2958529.WriteHistory(strXMLSearch);
                            var oWeatherSuggestionCurrent = EBWeatherManager_CT2958529.LoadWeatherCurrentCity();

                            //set weather units by location ID
                            EBWeatherManager_CT2958529.SetUnitsType(XMLDoc);

                            if (oWeatherSuggestionCurrent) {
                                EBWeatherManager_CT2958529.CheckFromServer(oWeatherSuggestionCurrent);
                            }
                            EBWeatherManager_CT2958529.ActivateTimeoutCheck();
                        }
                        else {
                            EBWeatherManager_CT2958529.SetNextIFeelLuckyCheck(EBWeatherIFeelLuckyConsts_CT2958529.CityNotFoundInterval);
                        }
                    }
                }
                catch (ex) { }
            };

            var strServerURL = EBWeatherManager_CT2958529.GetWeatherServerURL();
            //assembley the full url
            var strFullServerURL = strServerURL + this.ReplaceAliases(EBWeatherConsts_CT2958529.URL.QS_SEARCH) + EBWeatherIFeelLuckyConsts_CT2958529.IFeelLuckyText;
            this.ServerRequest(strFullServerURL, oCallBackFunction);
        }
    },

    ReplaceAliases: function(strUrl) {
        strUrl = strUrl.replace(/ORIGINAL_CT_ID/, EBActionManager_CT2958529.GetCTIDForServices())
        strUrl = strUrl.replace(/LOCALE/, EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true))

        return strUrl;
    },

    SetNextIFeelLuckyCheck: function(hoursInterval) {
        var now = Date();
    },

    ActivateTimeoutCheck: function() {
        setTimeout(function() { EBWeatherManager_CT2958529.TimeoutCheck(); }, EBWeatherManager_CT2958529.ActivateTimeoutInterval);
    },

    //check every minute if need to go to the server
    TimeoutCheck: function(bIsForceCheck) {
        if (this.IsTimeElapsed() || this.IsWeatherNetworkError() || bIsForceCheck) {
            var oWeatherSuggestionCurrent = this.LoadWeatherCurrentCity();
            if (oWeatherSuggestionCurrent) {
                this.CheckFromServer(oWeatherSuggestionCurrent);
            }
        }

        this.TimeoutID = setTimeout(function() { EBWeatherManager_CT2958529.TimeoutCheck(); }, EBWeatherManager_CT2958529.TimeoutInterval);
    },

    IsTimeElapsed: function() {
        var bRetVal = true;
        var strPrefWeatherPollDate = EBWeatherPreferencesManager_CT2958529.GetWeatherPollDate();
        if (strPrefWeatherPollDate) {
            var iIntervalMinutes = this.GetWeatherInterval();

            var oDateCurrent = new Date();
            var oDatePollDate = new Date(strPrefWeatherPollDate);

            var iCheckIntervalTime = 1000 * 60 * iIntervalMinutes;

            var iDateDiff = oDateCurrent - oDatePollDate;

            bRetVal = iDateDiff > iCheckIntervalTime;
        }

        return bRetVal;

    },

    CheckFromServer: function(oWeatherSuggestionCurrent) {
        //update the poll date to now
        EBWeatherPreferencesManager_CT2958529.SetWeatherPollDate();

        var strLocationID = oWeatherSuggestionCurrent.LocationID;

        var strServerURL = this.GetWeatherServerURL();
        var strFullServerURL = strServerURL + this.ReplaceAliases(EBWeatherConsts_CT2958529.URL.QS_FORECAST) + strLocationID;

        var oCallBackFunction = function(XMLDoc, o) {
            EBWeatherManager_CT2958529.ServerResponse(XMLDoc, o, oWeatherSuggestionCurrent);
        };
        this.ServerRequest(strFullServerURL, oCallBackFunction);
    },


    //when the server callback activate we check if there was network error
    //to mark it in the prefs or the xml is not valid - UNAVAILABLE state
    //if the xmldoc is valid the state is FORECAST
    //after the check broadcast changes to all browsers
    ServerResponse: function(XMLDoc, o, oWeatherSuggestionCurrent) {
        var oWeatherForecast = null;
        var iState = null;
        if (o.value == EBGlobalConsts_CT2958529.NetworkError) {
            //mark server error in prefs:
            EBWeatherPreferencesManager_CT2958529.SetWeatherNetwork(EBGlobalConsts_CT2958529.NetworkError);
            iState = EBWeatherStateConsts_CT2958529.UNAVAILABLE;
        }
        else {
            //mark no server error
            EBWeatherPreferencesManager_CT2958529.SetWeatherNetwork('');

            //check if it's legal forecast xml from the server
            if (this.IsValidWeatherXMLDoc(XMLDoc)) {
                oWeatherForecast = EBWeatherDataFactory_CT2958529.XMLToWeatherForecast(XMLDoc);
            }
            if (oWeatherForecast) {
                iState = EBWeatherStateConsts_CT2958529.FORECAST;
                //save it to file
                this.SaveWeatherForecast(oWeatherForecast);
            }
            else {
                iState = EBWeatherStateConsts_CT2958529.UNAVAILABLE;
            }
        }

        if (iState == EBWeatherStateConsts_CT2958529.UNAVAILABLE) {
            //nullify the file
            this.NullifyWeatherForecast();
        }


        //put here the broadcast call
        this.Broadcast(iState, oWeatherForecast, oWeatherSuggestionCurrent);

    },

    OnCommandWeatherToolbarButton: function(event) {
        //get the x position from the element
        var oXULElement = event.target;
        var iDialogWidth = EBWeatherDialogConsts_CT2958529.DialogWidth;

        var oCoordinates = EBActionManager_CT2958529.GetToolbarDialogOpeningCoordinates(oXULElement, iDialogWidth);

        EBWeatherDialogManager_CT2958529.Open(oCoordinates.X, oCoordinates.Y);
    },

    LoadWeatherWebSearch: function(event, oWeatherForecast, oWeatherSuggestionCurrent) {
        var strWebSearchURL = this.GetWeatherWebSearchURL();

        //get the data for the url
        var strCityName = oWeatherSuggestionCurrent.City;
        var strCountry = oWeatherSuggestionCurrent.Country;
        var strCityCountry = strCityName + ',' + strCountry;
        var strLocationID = oWeatherForecast.LocationID;
        var strCTID = EBActionManager_CT2958529.GetCTID();
        var strOCTID = EBGlobalConsts_CT2958529.ToolbarCTID;

        var strWeatherUnit = '';
        var strPrefUnit = EBWeatherPreferencesManager_CT2958529.GetWeatherUnits();
        if (strPrefUnit == EBWeatherUnits_CT2958529.TEMPERATURE_C) {
            strWeatherUnit = EBWeatherUnits_CT2958529.TEMPERATURE_C;
        }
        else {
            strWeatherUnit = EBWeatherUnits_CT2958529.TEMPERATURE_F;
        }
        strWeatherUnit = strWeatherUnit.toLowerCase();

        //assembly the url
        var strFullWebSearchURL = strWebSearchURL +
								'Results.aspx' +
								'?q=' + strCityName +
								'&SearchType=SearchWeather' +
								'&wbl=1' +
								'&WeatherLocationId=' + strLocationID +
								'&WeatherCityLocation=' + strCityCountry +
								'&ctid=' + strCTID +
								'&wunits=' + strWeatherUnit +
								'&octid=' + strOCTID;

        //since the search called from dialog i bring the last browser window
        var oBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        event.customData = { "url": strFullWebSearchURL };
        oBrowserWindow.EBLinkManager_CT2958529.LoadLinkURL(event);

    },


    //the weather history is a search objects that hold in the 
    //suggestion collection the current and the 1-2-3 history cities
    LoadWeatherHistory: function() {
        var oWeatherSearch = null;

        var strXML = EBWeatherIOManager_CT2958529.ReadHistory();

        if (strXML) {
            var XMLDoc = EBXML_CT2958529.GetXmlDocument(strXML);
            oWeatherSearch = EBWeatherDataFactory_CT2958529.XMLToWeatherSearch(XMLDoc);
        }

        return oWeatherSearch;
    },

    SaveWeatherHistory: function(oWeatherSearch) {
        var strXML = oWeatherSearch.XMLSerialize();
        EBWeatherIOManager_CT2958529.WriteHistory(strXML);
    },

    LoadWeatherCurrentCity: function() {
        var oWeatherSuggestion = null;
        var oWeatherSearch = this.LoadWeatherHistory();
        if (oWeatherSearch) {
            oWeatherSuggestion = oWeatherSearch.SuggestionCollection.Collection.GetItem(0);
        }

        return oWeatherSuggestion;
    },

    LoadWeatherForecast: function() {
        var oWeatherForecast = null;

        var strXML = EBWeatherIOManager_CT2958529.ReadForecast();

        if (strXML) {
            var XMLDoc = EBXML_CT2958529.GetXmlDocument(strXML);
            oWeatherForecast = EBWeatherDataFactory_CT2958529.XMLToWeatherForecast(XMLDoc);
        }

        return oWeatherForecast;
    },

    SaveWeatherForecast: function(oWeatherForecast) {
        var strXML = oWeatherForecast.XMLSerialize();
        EBWeatherIOManager_CT2958529.WriteForecast(strXML);
    },

    //save the suggestion whether it a new one (from the combo selection)
    //of if it's change from the history. 
    SaveSuggestionsHistory: function(oNewWeatherSuggestionCurrent) {
        var oWeatherSearchHistory = this.LoadWeatherHistory();

        var oWeatherSuggestionCollection = null;


        var oNewWeatherSuggestionHistory1ToSet = null;
        var oNewWeatherSuggestionHistory2ToSet = null;
        var oNewWeatherSuggestionHistory3ToSet = null;

        if (oWeatherSearchHistory) {
            oWeatherSuggestionCollection = oWeatherSearchHistory.SuggestionCollection;

            //load all the suggestions history
            var oWeatherSuggestionCurrent = oWeatherSuggestionCollection.Collection.GetItem(0);
            var oWeatherSuggestionHistory1 = oWeatherSuggestionCollection.Collection.GetItem(1);
            var oWeatherSuggestionHistory2 = oWeatherSuggestionCollection.Collection.GetItem(2);
            var oWeatherSuggestionHistory3 = oWeatherSuggestionCollection.Collection.GetItem(3);

            var strNewLocationID = '';
            var strCurrentLocationID = '';
            var strHistory1LocationID = '';
            var strHistory2LocationID = '';

            var bIsSaveHistory1 = false;
            var bIsSaveHistory2 = false;

            //get all the locations id of the suggestions
            strNewLocationID = oNewWeatherSuggestionCurrent.LocationID;
            if (oWeatherSuggestionCurrent) {
                strCurrentLocationID = oWeatherSuggestionCurrent.LocationID;
            }
            if (oWeatherSuggestionHistory1) {
                strHistory1LocationID = oWeatherSuggestionHistory1.LocationID;
            }
            if (oWeatherSuggestionHistory2) {
                strHistory2LocationID = oWeatherSuggestionHistory2.LocationID;
            }

            //check if to save the current city to history1 (if it's exists and if it's not like the new current)
            if (oWeatherSuggestionCurrent && strCurrentLocationID != strNewLocationID) {
                bIsSaveHistory1 = true;
                oNewWeatherSuggestionHistory1ToSet = oWeatherSuggestionCurrent;
            }
            else {
                oNewWeatherSuggestionHistory1ToSet = oWeatherSuggestionHistory1;
            }

            //check the rest of the saves history items.
            //only if saves the previous object and it's not like the new current i save the previous object 
            //to the next spot (history1 to history2)
            if (bIsSaveHistory1 && oWeatherSuggestionHistory1 && strHistory1LocationID != strNewLocationID) {
                bIsSaveHistory2 = true;
                oNewWeatherSuggestionHistory2ToSet = oWeatherSuggestionHistory1;
            }
            else {
                oNewWeatherSuggestionHistory2ToSet = oWeatherSuggestionHistory2;
            }

            //check to save history2 to history3
            if (bIsSaveHistory2 && oWeatherSuggestionHistory2 && strHistory2LocationID != strNewLocationID) {
                oNewWeatherSuggestionHistory3ToSet = oWeatherSuggestionHistory2;
            }
            else {
                oNewWeatherSuggestionHistory3ToSet = oWeatherSuggestionHistory3;
            }

        }


        //make the search object and save it to file
        oWeatherSuggestionCollection = new EBWeatherSuggestionCollection_CT2958529();
        //add the elements to the suggestion:
        oWeatherSuggestionCollection.Collection.AppendElement(oNewWeatherSuggestionCurrent);
        if (oNewWeatherSuggestionHistory1ToSet) {
            oWeatherSuggestionCollection.Collection.AppendElement(oNewWeatherSuggestionHistory1ToSet);
        }
        if (oNewWeatherSuggestionHistory2ToSet) {
            oWeatherSuggestionCollection.Collection.AppendElement(oNewWeatherSuggestionHistory2ToSet);
        }
        if (oNewWeatherSuggestionHistory3ToSet) {
            oWeatherSuggestionCollection.Collection.AppendElement(oNewWeatherSuggestionHistory3ToSet);
        }

        oWeatherSearchHistory = new EBWeatherSearch_CT2958529(oWeatherSuggestionCollection);

        //save it to file
        this.SaveWeatherHistory(oWeatherSearchHistory);
    },


    NullifyWeatherForecast: function() {
        EBWeatherIOManager_CT2958529.WriteForecast('');
    },

    IsNoResultsResponse: function(XMLDoc) {
        var XMLRoot = XMLDoc.documentElement;
        var strNodeValue = EBXML_CT2958529.GetXmlNodeValue(XMLRoot);

        return strNodeValue == EBWeatherXMLConsts_CT2958529.NORESULTS ? true : false;
    },

    //the server call which try to retrieve XML
    ServerRequest: function(strURL, oCallBackFunction) {
        //return the object
        return EBWeb_CT2958529.HTTPServerRequest(strURL, null, true, oCallBackFunction);
    },

    IsValidWeatherXMLDoc: function(XMLDoc) {
        if (XMLDoc && !this.IsNoResultsResponse(XMLDoc)) {
            return true;
        }
        else {
            return false;
        }
    },

    //check if there was network problem that mark in the prefs
    IsWeatherNetworkError: function() {
        var strWeatherNetwork = EBWeatherPreferencesManager_CT2958529.GetWeatherNetwork();

        return strWeatherNetwork == EBGlobalConsts_CT2958529.NetworkError ? true : false;
    },

    //all the date from the component calling using the GetMostRecentBrowserWindow
    //function cause this function calling from the dialog as well which
    //the data(toolbar components) not define there but only in the browsers window
    GetWeatherServerURL: function() {
        var oBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var strServerURL = '';
        var oWeatherComponent = oBrowserWindow.EBComponentsManager_CT2958529.GetWeatherComponent();
        if (oWeatherComponent) {
            strServerURL = oWeatherComponent.ComponentItem.ServerURL;
        }

        if (!strServerURL) {
            strServerURL = EBWeatherConsts_CT2958529.URL.DefaultServer;
        }

        return strServerURL;
    },

    GetWeatherWebSearchURL: function() {
        var oBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var strWebSearchURL = '';
        var oWeatherComponent = oBrowserWindow.EBComponentsManager_CT2958529.GetWeatherComponent();
        if (oWeatherComponent) {
            strWebSearchURL = oWeatherComponent.ComponentItem.WebSearchURL;
        }

        if (!strWebSearchURL) {
            strWebSearchURL = EBWeatherConsts_CT2958529.URL.DefaultWebSearch;
        }

        return strWebSearchURL;
    },

    GetWeatherInterval: function() {
        var oBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var iInterval = null;
        var oWeatherComponent = oBrowserWindow.EBComponentsManager_CT2958529.GetWeatherComponent();
        if (oWeatherComponent) {
            iInterval = oWeatherComponent.ComponentItem.Interval;
        }

        if (!iInterval) {
            iInterval = EBWeatherConsts_CT2958529.DefaultInterval;
        }

        return iInterval;
    },

    GetWeatherDefaultCation: function() {
        var oBrowserWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var strCaption = '';
        var oWeatherComponent = oBrowserWindow.EBComponentsManager_CT2958529.GetWeatherComponent();

        if (oWeatherComponent)
            strCaption = oWeatherComponent.ComponentItem.Button.text;

        return strCaption;
    },

    //this function is not calling using the last browser opened
    //cause it's calling from the broadcast per browser
    GetWeatherToolbarButton: function() {
        var oXULToolbarButton = null;
        var oWeatherComponent = EBComponentsManager_CT2958529.GetWeatherComponent();
        if (oWeatherComponent) {
            oXULToolbarButton = oWeatherComponent.XULElement;
        }

        return oXULToolbarButton;
    },

    SetToolbarButtonCaptionImage: function(strLabel, strImage) {
        var oWeatherComponent = EBComponentsManager_CT2958529.GetWeatherComponent();
        if (oWeatherComponent)
            oWeatherComponent.UpdateUI(strLabel, strImage);
    },

    SetToolbarButtonForecastTooltip: function() {
        var oWeatherComponent = EBComponentsManager_CT2958529.GetWeatherComponent();
        if (oWeatherComponent) {
            var strForecastTooltipID = EBWeatherGUIConsts_CT2958529.ForecastTooltipID;
            oWeatherComponent.UpdateUI(null, null, null, strForecastTooltipID);
        }
    },

    SetToolbarButtonDefaultTooltip: function() {
        var oXULToolbarButton = this.GetWeatherToolbarButton();
        if (oXULToolbarButton) {
            oXULToolbarButton.removeAttribute('tooltip');
            var strWeatherCompID = oToolbarManager_CT2958529.data.componentsIds.Weather;
            //set the tooltip according to the state of the toolbar
            if (EBActionManager_CT2958529.ToolbarShrink()) {
                EBToolbarDesignManager_CT2958529.SetTooltipShrink(strWeatherCompID, oXULToolbarButton);
            }
            else {
                EBToolbarDesignManager_CT2958529.SetTooltipUnShrink(oXULToolbarButton);
            }
        }
    },

    SetToolbarButtonUnavailable: function() {
        var strLabel = EBWeatherGUIConsts_CT2958529.CaptionNA;
        var strImage = EBWeatherGUIConsts_CT2958529.ImageNA;
        this.SetToolbarButtonCaptionImage(strLabel, strImage);
        this.SetToolbarButtonDefaultTooltip();
    },

    SetToolbarButtonStart: function() {
        var strLabel = this.GetWeatherDefaultCation();
        var strImage = EBWeatherGUIConsts_CT2958529.Image;
        this.SetToolbarButtonCaptionImage(strLabel, strImage);
        this.SetToolbarButtonDefaultTooltip();
    },

    SetToolbarButtonForecast: function(oWeatherForecast, oWeatherSuggestionCurrent) {
        var oCurrentCondition = oWeatherForecast.CurrentCondition;
        var strImage = oCurrentCondition.ButtonIcon;
        //if there is icon in the settings, we take it.
        if (EBWeatherGUIConsts_CT2958529.Image != EBWeatherGUIConsts_CT2958529.DefaultImage)
            strImage = EBWeatherGUIConsts_CT2958529.Image;

        var strTemperature = null;
        var strFeelsLike = null;
        var strWeatherUnit = '';
        var strPrefUnit = EBWeatherPreferencesManager_CT2958529.GetWeatherUnits();
        if (strPrefUnit == EBWeatherUnits_CT2958529.TEMPERATURE_C) {
            strWeatherUnit = EBWeatherUnits_CT2958529.TEMPERATURE_C;
            strTemperature = oCurrentCondition.TempC;
            strFeelsLike = oCurrentCondition.FeelsLikeC;
        }
        else {
            strWeatherUnit = EBWeatherUnits_CT2958529.TEMPERATURE_F;
            strTemperature = oCurrentCondition.TempF;
            strFeelsLike = oCurrentCondition.FeelsLikeF;
        }

        var strLabel = strTemperature + EBGlobalConsts_CT2958529.DegreeSymbol + strWeatherUnit;
        this.SetToolbarButtonCaptionImage(strLabel, strImage);

        var strCityCountryCaption = EBWeatherDialogManager_CT2958529.GetCityCountryCaption(oWeatherSuggestionCurrent);
        var strSky = oCurrentCondition.Sky;
        var strTooltipIcon = oCurrentCondition.TooltipIcon;

        //set the tooltip elements
        var oLabelTooltipCaption = document.getElementById('lblWeatherTooltipCaption_CT2958529');
        var oImageTooltipIcon = document.getElementById('imgWeatherTooltipIcon_CT2958529');
        var oLabelTooltipFeelsLike = document.getElementById('lblWeatherTooltipFeelsLike_CT2958529');
        var oLabelTooltipSky = document.getElementById('lblWeatherTooltipSky_CT2958529');

        var strTooltipCaption = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_WEATHER_TOOLTIP_CAPTION") + ' ' + strCityCountryCaption;
        var strTooltipFeelsLike = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_WEATHER_DIALOG_FEELS_LIKE") + ' ' + strFeelsLike + EBGlobalConsts_CT2958529.DegreeSymbol + strWeatherUnit;
        var strTooltipSky = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_WEATHER_TOOLTIP_SKY") + ' ' + strSky;

        oLabelTooltipCaption.setAttribute('value', strTooltipCaption);
        oImageTooltipIcon.setAttribute('src', strTooltipIcon);
        oLabelTooltipFeelsLike.setAttribute('value', strTooltipFeelsLike);
        oLabelTooltipSky.setAttribute('value', strTooltipSky);

        this.SetToolbarButtonForecastTooltip();


    },

    SetToolbarWeather: function(iState, oWeatherForecast, oWeatherSuggestionCurrent) {
        if (iState == EBWeatherStateConsts_CT2958529.UNAVAILABLE) {
            this.SetToolbarButtonUnavailable();
        }
        else if (iState == EBWeatherStateConsts_CT2958529.FORECAST && oWeatherForecast && oWeatherSuggestionCurrent) {
            this.SetToolbarButtonForecast(oWeatherForecast, oWeatherSuggestionCurrent);
        }
        else {
            this.SetToolbarButtonStart();
        }


        //since the broadcast can come from the dialog as well 
        //i check if this browser activated the thread check and if not activate it
        if (!this.TimeoutID) {
            this.ActivateTimeoutCheck();
        }

    },

    Broadcast: function(iState, oWeatherForecast, oWeatherSuggestionCurrent) {

        var oWindowsManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);

        var oEnumerator = oWindowsManager.getEnumerator('navigator:browser');
        while (oEnumerator.hasMoreElements()) {
            var oWindow = oEnumerator.getNext();
            if (oWindow.EBWeatherManager_CT2958529.SetToolbarWeather) {
                try {
                    oWindow.EBWeatherManager_CT2958529.SetToolbarWeather(iState, oWeatherForecast, oWeatherSuggestionCurrent);
                }
                catch (ex) { }
            }
        }
    }

}
var EBWeatherIOConsts_CT2958529 =
{
    FolderName: 'weather',
    HistoryFileName: 'history.xml',
    ForecastFileName: 'forecast.xml'
};

var EBWeatherIOManager_CT2958529 =
{
    GetWeatherFullPath: function(strFileName) {
        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
        var locale = objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale, true);
        var strWeatherFolderName = EBWeatherIOConsts_CT2958529.FolderName;

        if (strFileName == EBWeatherIOConsts_CT2958529.ForecastFileName)
            strFileName = strFileName.replace(/\./, '_' + locale + '.');

        return strWeatherFolderName + EBDirIO_CT2958529.sep + strFileName;
    },

    GetWeatherFile: function(strFileName) {
        var strWeatherFullPath = this.GetWeatherFullPath(strFileName);
        return EBIOManager_CT2958529.CreateToolbarFile(strWeatherFullPath);
    },

    WriteWeatherFile: function(strFileName, strContent) {
        var bSuccess = false;
        var oFile = this.GetWeatherFile(strFileName);
        if (oFile)
            bSuccess = EBFileIO_CT2958529.write(oFile, strContent, "", EBGlobalConsts_CT2958529.DefaultCharset);

        return bSuccess;
    },

    ReadWeatherFile: function(strFileName) {
        var strContent = '';
        var oFile = this.GetWeatherFile(strFileName);
        if (oFile)
            strContent = EBFileIO_CT2958529.read(oFile, EBGlobalConsts_CT2958529.DefaultCharset);

        return strContent;
    },


    GetHistoryFileName: function() {
        return EBWeatherIOConsts_CT2958529.HistoryFileName;
    },

    ReadHistory: function() {
        var strFileName = this.GetHistoryFileName();
        return this.ReadWeatherFile(strFileName);
    },

    WriteHistory: function(strContent) {
        var strFileName = this.GetHistoryFileName();
        this.WriteWeatherFile(strFileName, strContent);
    },


    GetForecastFileName: function() {
        return EBWeatherIOConsts_CT2958529.ForecastFileName;
    },


    ReadForecast: function() {
        var strFileName = this.GetForecastFileName();
        return this.ReadWeatherFile(strFileName);
    },

    WriteForecast: function(strContent) {
        var strFileName = this.GetForecastFileName();
        this.WriteWeatherFile(strFileName, strContent);
    }
};

var EBWeatherPreferencesManager_CT2958529 =
{
    GetWeatherUnitPrefName: function() {
        return EBPreferenceConsts_CT2958529.WeatherUnit;
    },

    GetWeatherPollDatePrefName: function() {
        return EBPreferenceConsts_CT2958529.WeatherPollDate;
    },

    GetWeatherNetworkPrefName: function() {
        return EBPreferenceConsts_CT2958529.WeatherNetwork;
    },

    GetWeatherUnits: function() {
        var strWeatherUnitPrefName = this.GetWeatherUnitPrefName();
        var strWeatherUnit = EBToolbarPreferenceManager_CT2958529.GetPref(strWeatherUnitPrefName);

        if (!strWeatherUnit) {
            //save default value
            strWeatherUnit = EBWeatherUnits_CT2958529.TEMPERATURE_C;
            this.SetWeatherUnit(strWeatherUnit);
        }

        return strWeatherUnit;

    },

    SetWeatherUnit: function(strWeatherUnit) {
        var strWeatherUnitPrefName = this.GetWeatherUnitPrefName();
        EBToolbarPreferenceManager_CT2958529.SetPref(strWeatherUnitPrefName, strWeatherUnit);
    },

    GetWeatherPollDate: function() {
        var strWeatherPollDatePrefName = this.GetWeatherPollDatePrefName();
        return EBToolbarPreferenceManager_CT2958529.GetPref(strWeatherPollDatePrefName);
    },

    SetWeatherPollDate: function() {
        var oDate = new Date();
        var strWeatherPollDateValue = oDate.toString();
        var strWeatherPollDatePrefName = this.GetWeatherPollDatePrefName();
        EBToolbarPreferenceManager_CT2958529.SetPref(strWeatherPollDatePrefName, strWeatherPollDateValue);
    },

    GetWeatherNetwork: function() {
        var strWeatherNetworkPrefName = this.GetWeatherNetworkPrefName();
        return EBToolbarPreferenceManager_CT2958529.GetPref(strWeatherNetworkPrefName);
    },

    SetWeatherNetwork: function(strWeatherNetwork) {
        var strWeatherNetworkPrefName = this.GetWeatherNetworkPrefName();
        EBToolbarPreferenceManager_CT2958529.SetPref(strWeatherNetworkPrefName, strWeatherNetwork);
    }
};




var EBWeatherLanguagePack_CT2958529 = 
{
    Apply : function()
    {
        var lblWeather1             = document.getElementById('lblWeather1');
        var lblSelectLocation1      = document.getElementById('lblSelectLocation1');
        var lblCityNotFound         = document.getElementById('lblCityNotFound');
        var lblServiceUnavailable   = document.getElementById('lblServiceUnavailable');
        var btnBack1                = document.getElementById('btnBack1');
        var btnSelect1              = document.getElementById('btnSelect1');
        var aFeedBack1              = document.getElementById('aFeedBack1');
	var aHelp1 = document.getElementById('aHelp1');
        
        var lblWeather2             = document.getElementById('lblWeather2');
        var lblSelectLocation2      = document.getElementById('lblSelectLocation2');
        var lblSelectCity           = document.getElementById('lblSelectCity');
        var btnBack2                = document.getElementById('btnBack2');
        var btnSelect2              = document.getElementById('btnSelect2');
        var aFeedBack2              = document.getElementById('aFeedBack2');
	var aHelp2 = document.getElementById('aHelp2');
        
        var lblWeatherFor           = document.getElementById('lblWeatherFor');
        var lblChangeLocation       = document.getElementById('lblChangeLocation');
        var lblExtendedForecast     = document.getElementById('lblExtendedForecast');
        var lblRightNow             = document.getElementById('lblRightNow');
        var lblFeelsLike            = document.getElementById('lblFeelsLike');
        var aFeedBack3              = document.getElementById('aFeedBack3');
	var aHelp3 = document.getElementById('aHelp3');
        
        var lblWeather4             = document.getElementById('lblWeather4');
        var lblSelectLocation4      = document.getElementById('lblSelectLocation4');
        var dscWeatherUnavailable   = document.getElementById('dscWeatherUnavailable');
        var btnBack4                = document.getElementById('btnBack4');
        var btnSelect4              = document.getElementById('btnSelect4');
        var aFeedBack4              = document.getElementById('aFeedBack4');
	var aHelp4 = document.getElementById('aHelp4');

        var objWindow = EBGlobalManager_CT2958529.GetMostRecentBrowserWindow();
		var locale = objWindow.EBToolbarPreferenceManager_CT2958529.GetPref(EBPreferenceConsts_CT2958529.Locale,true);
		
        lblWeather1.value               = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_TITLE');
        lblSelectLocation1.value        = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_SELECT_LOCATION_TITLE');
        lblCityNotFound.value           = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_CITY_NOT_FOUND');
        lblServiceUnavailable.innerHTML = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_SERVICE_UNAVAILABLE');
        btnBack1.setAttribute           ('label','<< ' + objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_BTN_BACK'));
        btnSelect1.setAttribute         ('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_BTN_SELECT'));
        if(aFeedBack1) aFeedBack1.innerHTML            = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_FEEDBACK_LINK_CAPTION');
	if(aHelp1) aHelp1.innerHTML = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_HELP');
	
        lblWeather2.value               = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_TITLE');
        lblSelectLocation2.value        = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_SELECT_LOCATION_TITLE');
        lblSelectCity.value             = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_SELECT_CITY');
        btnBack2.setAttribute           ('label','<< ' + objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_BTN_BACK'));
        //btnBack2.setAttribute('accesskey',btnBack2.getAttribute('label').charAt(0));
        btnSelect2.setAttribute         ('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_BTN_SELECT'));
        //btnSelect2.setAttribute('accesskey',btnSelect2.getAttribute('label').charAt(0));
        if(aFeedBack2) aFeedBack2.innerHTML            = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_FEEDBACK_LINK_CAPTION');
	if(aHelp2) aHelp2.innerHTML = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_HELP');
	
        lblWeatherFor.value             = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_WEATHER_FOR');
        lblChangeLocation.value         = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_CHANGE_LOCATION');
        lblExtendedForecast.value       = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_EXTENDED_FORCAST');
        lblRightNow.value               = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_RIGHT_NOW');
        lblFeelsLike.value              = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_FEELS_LIKE');
        if(aFeedBack3) aFeedBack3.innerHTML            = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_FEEDBACK_LINK_CAPTION');
        if(aHelp3) aHelp3.innerHTML = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_HELP');
	
        lblWeather4.value               = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_TITLE');
        lblSelectLocation4.value        = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_SELECT_LOCATION_TITLE');
        dscWeatherUnavailable.innerHTML = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_WEATHER_UNAVAILABLE');
        btnBack4.setAttribute           ('label','<< ' + objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_BTN_BACK'));
        //btnBack4.setAttribute('accesskey',btnBack4.getAttribute('label').charAt(0));
        btnSelect4.setAttribute         ('label',objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_BTN_SELECT'));
        //btnSelect4.setAttribute('accesskey',btnSelect4.getAttribute('label').charAt(0));
        if(aFeedBack4) aFeedBack4.innerHTML            = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_FEEDBACK_LINK_CAPTION');
	if(aHelp4) aHelp4.innerHTML = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_GLOBAL_HELP');
        
        EBWeatherDialogConsts_CT2958529.ChangeToCaption       = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_WEATHER_CHANGE_TO');
        EBWeatherDialogConsts_CT2958529.SearchCaption         = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_BTN_SEARCH');
        EBWeatherDialogConsts_CT2958529.SelectCaption         = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_BTN_SELECT');
        EBWeatherDialogConsts_CT2958529.DefaultSearchBoxValue = objWindow.oToolbarManager_CT2958529.getLPKey('CTLP_STR_ID_WEATHER_DIALOG_EDITBOX_SEARCH_CITY');
    }
}
        
        
        
        

var WebApiManager_CT2958529 =
{
    errorCodes:
    {
        ok: 1,
        operationAborted: 17,
        componentExists: 5,
        componentNotExists: 13,
        menuItemsExists: 12,
        menuItemParseError: 15,
        detectionDisabled: 22,
        unknownError: 23
    },

    engineApi: new WebEngineAPI_CT2958529(),

    registerApi: function(win) {
        var docJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(win);
        if (docJS._CE_RegisterEngine && !docJS.conduitEngineAttached) {
            docJS.conduitEngineAttached = true;
            docJS._CE_RegisterEngine(this.engineApi);
        }
    }
};
function WebEngineAPI_CT2958529() {
    var engineStates = { "hidden": "hidden", "visible": "visible" };
    
    function getResult (returnValue, errorCode) {
        var obj = { "returnValue": returnValue, "errorCode": errorCode };
        
        return JSON.stringify(obj);
    };

    this.addSingleComponent = function(compGuid, compName, sourceId) {
        var bResult = oToolbarManager_CT2958529.addMyStuffComponent(compGuid, compName, sourceId, EBUrl_CT2958529.GetPageUrl(), window);
        return getResult(bResult, (bResult) ? WebApiManager_CT2958529.errorCodes.ok : WebApiManager_CT2958529.errorCodes.operationAborted);
    };

    this.displayDetectedComponent = function(compGuid, sourceId) {
        if (!oToolbarManager_CT2958529.isDetectionEnabled)
            return getResult(false, WebApiManager_CT2958529.errorCodes.detectionDisabled);

        var item = oToolbarManager_CT2958529.data.getItemByGuid(compGuid);
        //exits and visible
        if (item)
            return getResult(false, WebApiManager_CT2958529.errorCodes.componentExists);

        var docJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(window.gBrowser.contentWindow);
        oToolbarManager_CT2958529.displayDetectedComponent(compGuid, sourceId, window, docJS);
        return getResult(true, WebApiManager_CT2958529.errorCodes.ok);
    };

    this.getState = function() {
        return (EBActionManager_CT2958529.IsToolbarShown()) ? engineStates.visible : engineStates.hidden;
    };

    this.getInfo = function() {
        var returnObj = { "returnValue": true, "errorCode": WebApiManager_CT2958529.errorCodes.ok,
            "version": EBGlobalConsts_CT2958529.Version, "name": EBActionManager_CT2958529.GetToolbarName()
        };
        return JSON.stringify(returnObj);
    };
    
    this.isSupportedFunction = function(functionName) {
        var isSupported = (this[functionName]) ? true : false;
        return getResult(isSupported, WebApiManager_CT2958529.errorCodes.ok);
    };

    this.getMenus = function() {
        var arrMenuComponents = EBComponentsManager_CT2958529.GetAllDynamicMenuComponents();
        var arrMenusInfo = new Array();
        var menuItem = null;
        for (var i = 0; i < arrMenuComponents.length; i++) {
            menuItem = arrMenuComponents[i].ComponentItem;
            arrMenusInfo.push({ "caption": menuItem.button.text, "iconUrl": menuItem.button.image, "compId": menuItem.UniqueCompID });
        }

        var returnObj = { "returnValue": true, "errorCode": WebApiManager_CT2958529.errorCodes.ok, "menus": arrMenusInfo };
        return JSON.stringify(returnObj);
    };

    this.addMenuItem = function(menuCompId, strXmlMenuItem) {
        try {
            EBUserMenuItems_CT2958529.addFromApi(strXmlMenuItem, menuCompId);
            return getResult(true, WebApiManager_CT2958529.errorCodes.ok);
        }
        catch (errorCode) {
            return getResult(false, errorCode);
        }
    };

    this.isAppInstalled = function(strAppGuid) {
        if (!strAppGuid) return getResult(false, WebApiManager_CT2958529.errorCodes.ok);

        var item = oToolbarManager_CT2958529.data.getItemByGuid(strAppGuid);
        return getResult(!item ? false : true, WebApiManager_CT2958529.errorCodes.ok);
    };

    this.sendMessage = function(nickname, strValue) {
        if (!nickname || !strValue) return;

        //broadcast message
        var aSubject = EBObserversManager_CT2958529.GetSubject(gBrowser[EBGlobalConsts_CT2958529.WindowId]);
        aSubject.nickname = nickname;
        aSubject.value = strValue;

        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
            EBObserversManager_CT2958529.ToolbarEventsTopic,
            EBObserversManager_CT2958529.ToolbarEventsData.EBMessageReceived);

        return getResult(true, WebApiManager_CT2958529.errorCodes.ok);
    };
};

function EBWebPage_CT2958529()
{

    var isTrustedDomain = function () {
        var strDomain = getBrowser().contentWindow.location.href;
        var strTopLevelDomain = EBUrl_CT2958529.GetTopLevelDomainName(strDomain, true);
        strTopLevelDomain = strTopLevelDomain.toLowerCase();
        return (strTopLevelDomain == "conduit.com" || strTopLevelDomain == "eb.com" || strTopLevelDomain == "qasite.com");
    };
    
    this.ctid = EBActionManager_CT2958529.GetCTID();

    this.ExecuteApiFunction = function(args) { 
        var strFuncName = args[0];
        var bCheckIsSupportedOnly = (strFuncName == "IsSupportedFunction");
        var bIsSupported;
        var errorCode;

        //check is supported manager function
        
        if (bCheckIsSupportedOnly) {
            //manager function, one toolbar answer is enough, this toolbar should be the latest version
            bIsSupported = this._ExecuteApiFunction(args[1], null, true);
            errorCode = EBWebPageApiConsts_CT2958529.Errors.SUCCESS;
            return this.GetResultXmlString(bIsSupported, errorCode);
        }
        else
            return this._ExecuteApiFunction(strFuncName, args, false);
    };

    this._ExecuteApiFunction = function(strFuncName, arrArguments, bCheckIsSupportedOnly) {
        switch (strFuncName) {
            case "IsSupportedFunction": if (bCheckIsSupportedOnly) return true;
                break;
            case "RefreshToolbarByCTID": if (bCheckIsSupportedOnly) return true;
                return this.RefreshToolbar();
                break;
            case "ForceRefreshToolbar": if (bCheckIsSupportedOnly) return true;
                return this.ForceRefreshToolbar();
                break;
            case "ForceRefreshServices": if (bCheckIsSupportedOnly) return true;
                return this.ForceRefreshServices(arrArguments[1]);
                break;
            case "IsLatestApi": if (bCheckIsSupportedOnly) return true;
                return this.IsLatestApi();
                break;
            case "GetToolbarInfo": if (bCheckIsSupportedOnly) return true;
                return this.GetToolbarInfo();
                break;
            case "GetInfo": if (bCheckIsSupportedOnly) return true;
                return this.GetToolbarInfo();
                break;
            case "GetAllToolbarsInfo": if (bCheckIsSupportedOnly) return true;
                return this.GetToolbarInfo();
                break;
            case "AddComponentByXML": if (bCheckIsSupportedOnly) return true;
                return this.AddComponentByXML(arrArguments[1]);
                break;
            case "IsToolbarVisible": if (bCheckIsSupportedOnly) return true;
                return this.IsVisible();
                break;
            case "AddRadioStation": if (bCheckIsSupportedOnly) return true;
                return this.AddRadioStation(arrArguments[1]);
                break;
            case "AddAlert": if (bCheckIsSupportedOnly) return true;
                return this.AddAlert(arrArguments[1]);
                break;
            case "AddMyStuffAlert": if (bCheckIsSupportedOnly) return true;
                return this.AddMyStuffAlert(arrArguments[1], arrArguments[2]);
                break;
            case "RefreshMyGadgets": if (bCheckIsSupportedOnly) return true;
                return this.RefreshMyGadgets(arrArguments[1]);
                break;
            case "SwitchToCommunity": if (bCheckIsSupportedOnly) return true;
                return this.SwitchToCommunity(arrArguments[1]);
                break;
            case "AddUserLinkMenuItem": if (bCheckIsSupportedOnly) return true;
                return this.AddUserLinkMenuItem(arrArguments[1], arrArguments[2]);
                break;
            case "GetSupportedUserAddMenu": if (bCheckIsSupportedOnly) return true;
                return this.GetSupportedUserAddMenu();
                break;
            case "AddMyStuffComponent": if (bCheckIsSupportedOnly) return true;
                return this.AddMyStuffComponent(arrArguments[1], arrArguments[2], arrArguments[3]);
                break;
            case "SendMessage": if (bCheckIsSupportedOnly) return true;
                return this.SendMessage(arrArguments[1], arrArguments[2]);
                break;
            case "IsAppInstalled": if (bCheckIsSupportedOnly) return true;
                return this.IsAppInstalled(arrArguments[1]);
                break;
            default: if (bCheckIsSupportedOnly) return false;
                return this.UnsupportedFunction();
                break;
        }
    };

    this.RefreshToolbar = function() {
        var errorCode = EBWebPageApiConsts_CT2958529.Errors.NO_TOOLBAR;
        EBSpecialCommands_CT2958529.REFRESH_TOOLBAR_VIEW(false);
        return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS);
    };

    this.ForceRefreshToolbar = function() {
        //check if trusted domain
        if (!isTrustedDomain())
            return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.UN_TRUSTED_DOMAIN);

        EBSpecialCommands_CT2958529.REFRESH_TOOLBAR_VIEW(true);
        return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS);
    };

    this.ForceRefreshServices = function(flags) {
        if(!isTrustedDomain())
            return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.UN_TRUSTED_DOMAIN);

        if(EBSpecialCommands_CT2958529.ForceRefreshWithFlags) 
        {
            EBSpecialCommands_CT2958529.ForceRefreshWithFlags(flags);
            return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS);
        }
        else
            return this.UnsupportedFunction();
    };


    this.IsLatestApi = function() {
        return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS);
    };

    this.GetToolbarInfo = function() {
        var strDataXml = "<DATA><TOOLBAR_INFO>";
        strDataXml += "<VERSION>" + EBGlobalConsts_CT2958529.Version + "</VERSION>";
        strDataXml += "<NAME>" + EBActionManager_CT2958529.GetToolbarName() + "</NAME>";
        strDataXml += "<ORIGINAL_CTID>" + EBActionManager_CT2958529.GetOriginalCTIDForServices() + "</ORIGINAL_CTID>";
        strDataXml += "<CURRENT_CTID>" + EBActionManager_CT2958529.GetCTIDForServices() + "</CURRENT_CTID>";
        strDataXml += "<IS_MULTICOMMUNITY>" + EBActionManager_CT2958529.IsToolbarMC().toString() + "</IS_MULTICOMMUNITY>";
        strDataXml += "<IS_GROUPING>" + EBActionManager_CT2958529.IsToolbarGrouping().toString() + "</IS_GROUPING>";
        var iStatus = (EBGlobalConsts_CT2958529.IsEngine || oToolbarManager_CT2958529.myStuffEnabled()) ? "1" : "0";
        strDataXml += "<MY_STUFF_STATUS>" + iStatus + "</MY_STUFF_STATUS>";
        strDataXml += "</TOOLBAR_INFO></DATA>";

        return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS, strDataXml);
    };


    this.AddComponentByXML = function(strXML) {
        if (!EBGlobalManager_CT2958529.Confirm(window, EBActionManager_CT2958529.GetToolbarName(), oToolbarManager_CT2958529.getLPKey("CTLP_ADD_USER_COMPONENT_WARNING_DESCRIPTION")))
            return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.OPERATION_ABORTED);

        //var arrCTID = EBActionManager_CT2958529.GetEBToolbarsCTID();
        ///how do i know that the one who is passed is the original?
        var iError = this.AddComponentByXMLFunctionNew(strXML);
        var bRetValue = false;
        if (iError != null)
            bRetValue = (iError == EBWebPageApiConsts_CT2958529.Errors.SUCCESS) ? true : false;
        else
            iError = 0;
        return this.GetResultXmlString(bRetValue, iError);
    };

    this.AddComponentByXMLFunctionNew = function(strXML) {
        var xmlComponent = EBXML_CT2958529.GetXmlDocument(strXML);
        if (!xmlComponent || (xmlComponent && xmlComponent.getElementsByTagName("parsererror").length > 0)) {
            return EBWebPageApiConsts_CT2958529.Errors.ERROR_PARSE_XML;
        }
        
        //toggle component is not allowed from user
        if (xmlComponent.documentElement.tagName == "TOGGLE_COMPONENT")
            return EBWebPageApiConsts_CT2958529.Errors.COMPONENT_BLOCKED;

        var bValue = EBUserComponentsManager_CT2958529.AddComponentToFile(xmlComponent.documentElement);
        var errorCode = (bValue) ? EBWebPageApiConsts_CT2958529.Errors.SUCCESS : EBWebPageApiConsts_CT2958529.Errors.COMPONENT_EXISTS;
        return errorCode;
    };

    this.IsVisible = function() {
        var bRetValue = false;
        var errorCode = EBWebPageApiConsts_CT2958529.Errors.NO_TOOLBAR;
        if (EBActionManager_CT2958529.IsToolbarShown()) {
            bRetValue = EBActionManager_CT2958529.IsToolbarShown();
            errorCode = EBWebPageApiConsts_CT2958529.Errors.SUCCESS;
        }

        return this.GetResultXmlString(bRetValue, errorCode);
    };

    this.AddRadioStation = function(strXML) {
        var bValue = false;
        var errorCode = EBWebPageApiConsts_CT2958529.Errors.NO_TOOLBAR;
        
        if (EBRadioManager_CT2958529.AddRadioStation)
            errorCode = EBRadioManager_CT2958529.AddRadioStation(strXML);
        
        if (errorCode != null)
            bValue = (errorCode == EBWebPageApiConsts_CT2958529.Errors.SUCCESS) ? true : false;
        else {
            errorCode = EBWebPageApiConsts_CT2958529.Errors.NO_TOOLBAR;
            return this.UnsupportedFunction();
        }
         return this.GetResultXmlString(bValue, errorCode);
    };

    this.AddAlert = function(strAlertId) {
        if (!EBGlobalManager_CT2958529.Confirm(window, EBActionManager_CT2958529.GetToolbarName(), oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_ADD_NOTIFICATION_DESCRIPTION")))
            return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.OPERATION_ABORTED);

        var bValue = false;
        var errorCode = EBWebPageApiConsts_CT2958529.Errors.NO_TOOLBAR;
        if (strAlertId) {
            try {
                errorCode = EBAlertManager_CT2958529.AddExternalAlert(strAlertId)
                bValue = (errorCode == EBWebPageApiConsts_CT2958529.Errors.SUCCESS) ? true : false;
            }
            catch (ex) {
                return this.UnsupportedFunction();
            }
        }
        return this.GetResultXmlString(bValue, errorCode);
    };

    this.SwitchToCommunity = function(strSwitchToCTID) {
        //check first if the desired toolbar supports multicommunity or grouping
        var strXml = this.GetToolbarInfo();
        var oXml = EBXML_CT2958529.GetXmlDocument(strXml);
        var bIsMC = EBXML_CT2958529.GetSingleNodeValueAsBoolean(oXml, "IS_MULTICOMMUNITY", false);
        var bIsGrouping = EBXML_CT2958529.GetSingleNodeValueAsBoolean(oXml, "IS_GROUPING", false);
        if (!bIsGrouping && !bIsMC)
            return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.NO_MC_AND_GROUPING);

        if (!EBMCManager_CT2958529.GetCommunityFromExistingCommunitiesByCTID(strSwitchToCTID))
            return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.COMMUNITY_NOT_FOUND);

        EBMCManager_CT2958529.ChangeToCommunityFromApi(strSwitchToCTID);
        
        return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS);
    };

    //user menu item functions
    this.AddUserLinkMenuItem= function(strXml, strComponentId) {
        try {
            if (EBUserMenuItems_CT2958529.addFromApi) {
                EBUserMenuItems_CT2958529.addFromApi(strXml, strComponentId);
                return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS, strXml);
            }
            else
                return false;
        }
        catch (e) {
            if (typeof e == 'number')
                return this.GetResultXmlString(false, e);
            else
                return this.UnsupportedFunction();
        }
    };

    this.GetSupportedUserAddMenu= function() {
        try {
            var arrComponents = null;
            if (EBComponentsManager_CT2958529.GetAllDynamicMenuComponents)
                arrComponents = EBComponentsManager_CT2958529.GetAllDynamicMenuComponents();
            var strDataXml ="<DATA><MENUS_INFO>";
            if (arrComponents) {
                for (var i = 0; i < arrComponents.length; i++) {
                    strDataXml += EBXML_CT2958529.CreateXmlNodeStartString("MENU_INFO");
                    strDataXml += EBXML_CT2958529.CreateXmlNodeString("COMP_ID", arrComponents[i].ComponentItem.UniqueCompID);
                    strDataXml += EBXML_CT2958529.CreateXmlNodeString("CAPTION", arrComponents[i].ComponentItem.button.text);
                    strDataXml += EBXML_CT2958529.CreateXmlNodeString("ICON_URL", arrComponents[i].ComponentItem.button.image);
                    strDataXml += EBXML_CT2958529.CreateXmlNodeEndString("MENU_INFO");
                }
            }
            strDataXml += "</MENUS_INFO></DATA>";
        
            var strXmlResult = this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS, strDataXml);
            return strXmlResult;
        }
        catch (e) {
            return this.UnsupportedFunction();
        }
    };

    this.AddMyStuffComponent = function(compGuid, compInstanceGuid, componentName) {
        //my stuff disabled
        if (!EBGlobalConsts_CT2958529.IsEngine && !oToolbarManager_CT2958529.myStuffEnabled()) {
            return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.MY_STUFF_DISABLED);
        }
        var bIsExists = oToolbarManager_CT2958529.isExistsMyStuffComponent(compGuid);
        var title = "";
        var text = "";

        if (bIsExists) {
            title = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_API_ADD_COMPONENT_CONFIRM_TITLE_EXISTS");
            text = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_API_ADD_COMPONENT_CONFIRM_TEXT_EXISTS")
        }
        else {
            title = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_API_ADD_COMPONENT_CONFIRM_TITLE");
            text = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_API_ADD_COMPONENT_CONFIRM_TEXT");
        }

        if (componentName)
            text = text.replace(/\[COMPONENT NAME\]/g, componentName);

        var isTrustedDomain = oToolbar_CT2958529.toolbar.trustedDomains.isTrustedDomain(EBUrl_CT2958529.GetPageUrl(), EBGlobalConsts_CT2958529.ToolbarCTID);

        if ((isTrustedDomain && !bIsExists) || EBGlobalManager_CT2958529.Confirm(window, title, text)) {
            oToolbarManager_CT2958529.addMyStuffComponent(compGuid, compInstanceGuid, null);
            return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS);
        }
        else {
            return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.OPERATION_ABORTED);
        }
    };
      
    this.AddMyStuffAlert= function(strAlertId, strAlertProviderName) {
        var bIsEnabled = EBAlertManager_CT2958529.AlertEnabled();
        var strText = (bIsEnabled) ? oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_API_ADD_ALERT_CONFIRM_TEXT") :
                                        oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_API_ADD_NOTIFICATION_CONFIRM_NOTIFICATION_DISABLED_TEXT");
        strText = strText.replace(/\[ALERTS NAME\]/g, strAlertProviderName);
        var strTitle = oToolbarManager_CT2958529.getLPKey("CTLP_STR_ID_MYSTUFF_API_ADD_NOTIFICATION_CONFIRM_TITLE");
        var isTrustedDomain = oToolbar_CT2958529.toolbar.trustedDomains.isTrustedDomain(EBUrl_CT2958529.GetPageUrl(), EBGlobalConsts_CT2958529.ToolbarCTID);
        if ((isTrustedDomain && bIsEnabled) || EBGlobalManager_CT2958529.Confirm(window, strTitle, strText)) {
            var bValue = false;
            var errorCode = EBWebPageApiConsts_CT2958529.Errors.NO_TOOLBAR;

            if (strAlertId) {
                try {
                    if (!bIsEnabled) EBAlertManager_CT2958529.AlertEnabled(true);
                    errorCode = EBAlertManager_CT2958529.AddMyStuffAlert(strAlertId, strAlertProviderName);
                    bValue = (errorCode == EBWebPageApiConsts_CT2958529.Errors.SUCCESS) ? true : false;
                    return this.GetResultXmlString(bValue, errorCode);
                }
                catch (ex) {
                    return this.UnsupportedFunction();
                }
            }
        }
        else
            return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.OPERATION_ABORTED);
    };

    this.SendMessage = function(nickname, strValue) {
        if (!nickname || !strValue) return;

        //broadcast message
        var aSubject = EBObserversManager_CT2958529.GetSubject(gBrowser[EBGlobalConsts_CT2958529.WindowId]);
        aSubject.nickname = nickname;
        aSubject.value = strValue;

        EBObserversManager_CT2958529.NotifyCustomObserver(aSubject,
            EBObserversManager_CT2958529.ToolbarEventsTopic,
            EBObserversManager_CT2958529.ToolbarEventsData.EBMessageReceived);

        return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS);
    };

    this.IsAppInstalled = function(strGuid) {
        if (!strGuid) this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.OPERATION_ABORTED);

        var itemsHash = oToolbarManager_CT2958529.data.publisherItemsHash;
        for (var i = 0; i < itemsHash.Count(); i++) {
            testItem = itemsHash.GetByIndex(i);
            if (testItem.componentGuid && testItem.componentGuid == strGuid) {
                return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS);
            }
        }
      
        var engineManager = oToolbar_CT2958529.toolbar.getEngineManager();
        if (engineManager && engineManager.data && DualPackageFunctions_CT2958529.isToolbarInDualPackage()) {
            if (engineManager.data.getItemByGuid(strGuid))
                return this.GetResultXmlString(true, EBWebPageApiConsts_CT2958529.Errors.SUCCESS);
        }


        return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.SUCCESS);
    }; 
    
    this.AddComponentXMLFunction = function (strXML) {///send how?
        var xmlComponent = EBXML_CT2958529.GetXmlDocument(strXML);
        if (!xmlComponent)
            return false;
        
         return EBUserComponentsManager_CT2958529.AddComponentToFile(xmlComponent.documentElement);
       
    };

    this.UnsupportedFunction= function() {
        return this.GetResultXmlString(false, EBWebPageApiConsts_CT2958529.Errors.UNSUPPORTED);
     };
   
    this.GetResultXmlString= function(bResult, iErrorCode, strDataXml) {
        if (typeof strDataXml == "undefined") {
            strDataXml = "";
        }

        var strResult = "<RETURN_OBJECT>";
        strResult += "<RETURN_VALUE>" + bResult.toString() + "</RETURN_VALUE>";
        strResult += "<ERROR_CODE>" + iErrorCode + "</ERROR_CODE>";
        strResult += strDataXml;
        strResult += "</RETURN_OBJECT>";
        return strResult;
    };
};

var EBWebPageApiConsts_CT2958529 =
{
    Errors:
	{
	    NO_TOOLBAR: 0,
	    SUCCESS: 1,
	    COMPONENT_EXISTS: 5,
	    ERROR_PARSE_XML: 4,
	    UNSUPPORTED: 2,
	    NO_RADIO_COMPONENT: 21,
	    RADIO_MEDIA_EXISTS: 7,
	    ALERT_ERROR: 8,
	    COMPONENT_BLOCKED: 9,
	    UN_TRUSTED_DOMAIN: 10,
	    MY_STUFF_DISABLED: 11,
	    MENU_ITEM_ALREADY_EXISTS: 12,
	    MENU_ITEM_COMP_ID_NOT_VALID: 13,
	    PRIVATE_MENU_LOAD_ERROR: 14,
	    PRIVATE_MENU_PARSE_ERROR: 15,
	    PRIVATE_MENU_INTERNAL_ERROR: 16,
	    OPERATION_ABORTED: 17,
	    COMMUNITY_NOT_FOUND: 18,
	    NO_MC_AND_GROUPING: 19,
	    ACCESS_DENIED: 20
	},

    IsAddComponentAlertString: 'You are about to add a component to your toolbar. Click OK to allow this component.',
    IsAddAlertAlertString: 'You are about to add an alert, click ok to add this alert.\n\nAlerts are special messages that are sent to you because you installed a community toolbar.\nThe alerts usually include important news or special offers, and are sent only to members of the community.'
};

var EBWebPageApiManager_CT2958529 =
{

    //this is a document's JS object in case of toolbar API exists on document.
    webPageApi: new EBWebPage_CT2958529(),

    registerApi: function(win) {
        var objJavascript = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(win);
        if (objJavascript._TPIRegisterToolbarFF)
            objJavascript._TPIRegisterToolbarFF(this.webPageApi);
    },

    unregisterApi: function() {
        var unregisterApi = function(contentWindow) {
            var winJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(contentWindow);
            if (!winJS) return;

            if (winJS._TPIUnregisterToolbar)
                winJS._TPIUnregisterToolbar(EBActionManager_CT2958529.GetCTID());

            var doc = null;
            try {
                doc = winJS.document;
            }
            catch (ex) {
                //EBLog(ex, "unregister API from frame");
                return;
            }
            var arrFrames = EBGlobalManager_CT2958529.GetAllFrames(doc);

            if (!arrFrames || arrFrames.length == 0) return;
            for (var i = 0; i < arrFrames.length; i++)
                unregisterApi(arrFrames[i].contentWindow);
        };

        var arrWindows = EBGlobalManager_CT2958529.GetAllWindows();
        var win = null;
        var arrTabs = null;
        var tabContentWindow = null;

        for (var i = 0; i < arrWindows.length; i++) {
            win = arrWindows[i];
            if (win.EBGlobalManager_CT2958529) {
                arrTabs = win.EBGlobalManager_CT2958529.GetAllTabs();

                for (var j = 0; j < arrTabs.length; j++)
                    unregisterApi(arrTabs[j].contentWindow);
            }
        }
    },

    reregisterApi: function() {
        this.webPageApi = new EBWebPage_CT2958529();

        var self = this;
        var registerApi = function(contentWindow) {
            var winJS = EBGlobalManager_CT2958529.GetWebPageJavascriptObject(contentWindow);
            if (!winJS) return;
            
            if (winJS._TPIRegisterToolbarFF)
                winJS._TPIRegisterToolbarFF(self.webPageApi);

            var doc = null;
            try { doc = winJS.document; }
            catch (e) { return; }

            var arrFrames = EBGlobalManager_CT2958529.GetAllFrames(doc);
            if (!arrFrames || arrFrames.length == 0) return;
            for (var i = 0; i < arrFrames.length; i++)
                registerApi(arrFrames[i].contentWindow)
        };

        var arrTabs = EBGlobalManager_CT2958529.GetAllTabs();
        for (var j = 0; j < arrTabs.length; j++)
            registerApi(arrTabs[j].contentWindow);
    }
};

//for old toolbars to call
var EBToolbarApiManager_CT2958529 =
{
    GetToolbarInfo: function() {
        return "<!-- remark -->";
    }
};
